#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_bsques.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex bsques_literal_vector[];
const char *bsques_literal_string[];
setup_type const  bsques_g_setup[];
#define LITERAL bsques_literal_vector




Sex CC_Wnoargchk(void)
{
    Sex a;
#define LL_Hnoargchk LITERAL[0]
    a = value(LL_Hnoargchk);
    return a;
}

Sex CC_Wargchk(void)
{
    Sex a;
    a = value(LL_Hnoargchk);
    {
        return  Lnull(a);
    }
}

Sex CC_Wsttrace(void)
{
    Sex a, q;
#define LL_sttrac LITERAL[1]
    q = LL_sttrac;
#define LL_Htracmode LITERAL[2]
    a = value(LL_Htracmode);
    {
        return  Leq(a, q);
    }
}

Sex CC_Wuntrace(void)
{
    Sex a, q;
#define LL_untrac LITERAL[3]
    q = LL_untrac;
    a = value(LL_Htracmode);
    {
        return  Leq(a, q);
    }
}

Sex CC_Wstcomp(void)
{
    Sex a, q;
#define LL_stcomp LITERAL[4]
    q = LL_stcomp;
#define LL_Hcompmode LITERAL[5]
    a = value(LL_Hcompmode);
    {
        return  Leq(a, q);
    }
}

Sex CC_Wuncomp(void)
{
    Sex a, q;
#define LL_uncomp LITERAL[6]
    q = LL_uncomp;
    a = value(LL_Hcompmode);
    {
        return  Leq(a, q);
    }
}

Sex CC_Wmodulo(void)
{
    Sex a;
#define LL_Hmod LITERAL[7]
    a = value(LL_Hmod);
    return a;
}

Sex CC_Wtype(Sex a)
{
    if(!is_symbol(a)) goto    G0016;
    {
        return  CC_Widtype(a);
    }
   G0016:
    {
        return  CC_Wexprtype(a);
    }
}

Sex CC_Widtype(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_symbol(a)) goto    G0022;
#define LL_Bgid LITERAL[8]
    q = LL_Bgid;
    a = Lget(a, q);
    if(a != nil) goto    G0021;
   G0022:
    a = LITERAL[9];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0021:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
#define LL_Htemporal LITERAL[10]
    value(LL_Htemporal) = a;
    q = a;
#define LL_num LITERAL[11]
    a = LL_num;
    a = Lmemq(a, q);
    if(a == nil) goto    G0023;
#define LL_Anum LITERAL[12]
    a = LL_Anum;
    goto    G0029;
   G0023:
    q = value(LL_Htemporal);
#define LL_var LITERAL[13]
    a = LL_var;
    a = Lmemq(a, q);
    if(a == nil) goto    G0026;
#define LL_Avar LITERAL[14]
    a = LL_Avar;
    goto    G0029;
   G0026:
    q = value(LL_Htemporal);
#define LL_func LITERAL[15]
    a = LL_func;
    a = Lmemq(a, q);
    if(a == nil) goto    G0027;
#define LL_Afunc LITERAL[16]
    a = LL_Afunc;
    goto    G0029;
   G0027:
    q = value(LL_Htemporal);
#define LL_symbol LITERAL[17]
    a = LL_symbol;
    a = Lmemq(a, q);
    if(a == nil) goto    G0028;
#define LL_Asymbol LITERAL[18]
    a = LL_Asymbol;
    goto    G0029;
   G0028:
#define LL_Acons LITERAL[19]
    a = LL_Acons;
   G0029:
    popv(1);
    return a;
}

Sex CC_Wexprtype(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0033;
    if(!is_number(a)) goto    G0035;
#define LL_Abnum LITERAL[20]
    a = LL_Abnum;
    goto    G0057;
   G0035:
    if(!is_string(a)) goto    G0036;
#define LL_Astring LITERAL[21]
    a = LL_Astring;
    goto    G0057;
   G0033:
    a = car(a);
    if(!is_integer(a)) goto    G0045;
#define LL_CmaxcanoC LITERAL[22]
    if(a >= value(LL_CmaxcanoC)) goto    G0047;
#define LL_Acano LITERAL[23]
    a = LL_Acano;
    goto    G0057;
   G0047:
#define LL_Aform LITERAL[24]
    a = LL_Aform;
    goto    G0057;
   G0045:
    if(!is_vector(a)) goto    G0049;
#define LL_Aarray LITERAL[25]
    a = LL_Aarray;
    goto    G0057;
   G0049:
    if(!is_symbol(a)) goto    G0050;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G0050;
#define LL_BctypeB LITERAL[26]
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
    value(LL_Htemporal) = a;
#define LL_rat LITERAL[27]
    if(a != LL_rat) goto    G0053;
#define LL_Apref LITERAL[28]
    a = LL_Apref;
    goto    G0057;
   G0053:
#define LL_set LITERAL[29]
    if(a != LL_set) goto    G0054;
   G0059:
#define LL_Asetexpr LITERAL[30]
    a = LL_Asetexpr;
    goto    G0057;
   G0054:
#define LL_rel LITERAL[31]
    if(a != LL_rel) goto    G0055;
   G0060:
#define LL_Arelexpr LITERAL[32]
    a = LL_Arelexpr;
    goto    G0057;
   G0036:
    if(!is_symbol(a)) goto    G0050;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G0050;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    value(LL_Htemporal) = a;
    if(a == LL_set) goto    G0059;
    if(a == LL_rel) goto    G0060;
#define LL_log LITERAL[33]
    if(a != LL_log) goto    G0050;
   G0055:
#define LL_Alogexpr LITERAL[34]
    a = LL_Alogexpr;
    goto    G0057;
   G0050:
    a = LITERAL[35];
    a = CC_argerror(a);
   G0057:
    popv(1);
    return a;
}

Sex CC_Wbnumtype(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_number(a)) goto    G0066;
    a = LITERAL[36];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0066:
    if(!is_integer(a)) goto    G0067;
#define LL_Aint LITERAL[37]
    a = LL_Aint;
    goto    G0073;
   G0067:
    if(!is_rational(a)) goto    G0068;
#define LL_Aratn LITERAL[38]
    a = LL_Aratn;
    goto    G0073;
   G0068:
    if(!is_float(a)) goto    G0069;
#define LL_Afloat LITERAL[39]
    a = LL_Afloat;
    goto    G0073;
   G0069:
    if(!is_complex(a)) goto    G0070;
#define LL_Acompl LITERAL[40]
    a = LL_Acompl;
    goto    G0073;
   G0070:
    if(!is_efloat(a)) goto    G0071;
#define LL_Aefloat LITERAL[41]
    a = LL_Aefloat;
    goto    G0073;
   G0071:
    a = Lecomplexp(a);
    if(a == nil) goto    G0072;
#define LL_Aecompl LITERAL[42]
    a = LL_Aecompl;
    goto    G0073;
   G0072:
    q = w1;
    a = LITERAL[43];
    a = CC_errormsg(a, q);
   G0073:
    popv(1);
    return a;
}

Sex CC_Wcanotype(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0090;
    a = car(a);
    if(!is_integer(a)) goto    G0090;
#define LL_CpolyC LITERAL[44]
    if(a != value(LL_CpolyC)) goto    G0079;
    a = car(cdr(w1));
    if(!is_cons(a)) goto    G0083;
    a = car(a);
   G0083:
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
#define LL_tran LITERAL[45]
    a = LL_tran;
    a = Leq(a, q);
    if(a == nil) goto    G0081;
#define LL_Atran LITERAL[46]
    a = LL_Atran;
    goto    G0091;
   G0081:
#define LL_Apoly LITERAL[47]
    a = LL_Apoly;
    goto    G0091;
   G0079:
#define LL_CalgnC LITERAL[48]
    if(a != value(LL_CalgnC)) goto    G0088;
#define LL_Aalgn LITERAL[49]
    a = LL_Aalgn;
    goto    G0091;
   G0088:
#define LL_CratfC LITERAL[50]
    if(a != value(LL_CratfC)) goto    G0089;
#define LL_Aratf LITERAL[51]
    a = LL_Aratf;
    goto    G0091;
   G0089:
#define LL_CalgfC LITERAL[52]
    if(a != value(LL_CalgfC)) goto    G0090;
#define LL_Aalgf LITERAL[53]
    a = LL_Aalgf;
    goto    G0091;
   G0090:
    a = LITERAL[54];
    a = CC_argerror(a);
   G0091:
    popv(1);
    return a;
}

Sex CC_Wcoeftype(Sex a)
{
    Sex q;
    q = car(a);
    a = cdr(a);
    a = CC_coftypTbpol(a, q);
    if(is_symbol(a)) goto    G0098;
    if(a != value(LL_CalgnC)) goto    G0097;
    a = LL_Aalgn;
    goto    G0098;
   G0097:
    a = LL_Apoly;
   G0098:
    return a;
}

Sex CC_Wncoeftype(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = mkfxat(1);
#define LL_Hchkcoef LITERAL[55]
    value(LL_Hchkcoef) = a;
    q = cdr(w1);
    CC_ncoftypTbpol(a, q);
    q = mkfxat(1);
    a = value(LL_Hchkcoef);
    a = Leqn(a, q);
    if(a == nil) goto    G0103;
#define LL_AZ LITERAL[56]
    a = LL_AZ;
    goto    G0107;
   G0103:
    q = mkfxat(2);
    a = value(LL_Hchkcoef);
    a = Leqn(a, q);
    if(a == nil) goto    G0104;
#define LL_AQ LITERAL[57]
    a = LL_AQ;
    goto    G0107;
   G0104:
    q = mkfxat(3);
    a = value(LL_Hchkcoef);
    a = Leqn(a, q);
    if(a == nil) goto    G0105;
#define LL_AA LITERAL[58]
    a = LL_AA;
    goto    G0107;
   G0105:
    q = mkfxat(4);
    a = value(LL_Hchkcoef);
    a = Leqn(a, q);
    if(a == nil) goto    G0106;
#define LL_AF LITERAL[59]
    a = LL_AF;
    goto    G0107;
   G0106:
#define LL_AC LITERAL[60]
    a = LL_AC;
   G0107:
    popv(1);
    return a;
}

Sex CC_Wreal(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Latom(a);
    if(a == nil) goto    G0110;
    a = w1;
    a = Lcomplexp(a);
    a = Lnull(a);
   G0110:
    popv(1);
    return a;
}

Sex CC_WoverZ(Sex a)
{
    Sex q;
    a = CC_Wncoeftype(a);
    q = LL_AZ;
    {
        return  Leq(a, q);
    }
}

Sex CC_WoverQ(Sex a)
{
    Sex q;
    a = CC_Wncoeftype(a);
    q = LL_AQ;
    {
        return  Leq(a, q);
    }
}

Sex CC_WoverA(Sex a)
{
    Sex q;
    a = CC_Wncoeftype(a);
    q = LL_AA;
    {
        return  Leq(a, q);
    }
}

Sex CC_WoverR(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = CC_Wncoeftype(a);
    q = LL_AA;
    a = Lneq(a, q);
    if(a == nil) goto    G0123;
    a = w1;
    a = CC_Wncoeftype(a);
    q = LL_AC;
    a = Lneq(a, q);
   G0123:
    popv(1);
    return a;
}

Sex CC_WoverF(Sex a)
{
    Sex q;
    a = CC_Wncoeftype(a);
    q = LL_AF;
    {
        return  Leq(a, q);
    }
}

Sex CC_WoverC(Sex a)
{
    Sex q;
    a = CC_Wncoeftype(a);
    q = LL_AC;
    {
        return  Leq(a, q);
    }
}

Sex CC_Wexactcoef(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = true;
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_chknumTexact LITERAL[61]
    a = LL_chknumTexact;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    popv(1);
    return a;
}

Sex CC_Wapproxcoef(Sex a)
{
    a = CC_Wexactcoef(a);
    {
        return  Lnull(a);
    }
}

Sex CC_chknumTexact(Sex a)
{
    a = CC_Wexactnum(a);
    if(a == nil) goto    G0140;
    a = true;
    goto    G0141;
   G0140:
    value(LL_Hchkcoef) = nil;
#define LL_stop LITERAL[62]
    a = LL_stop;
   G0141:
    return a;
}

Sex CC_chknumTapprox(Sex a)
{
    a = CC_Wapproxnum(a);
    if(a == nil) goto    G0145;
    a = true;
    goto    G0146;
   G0145:
    value(LL_Hchkcoef) = nil;
    a = LL_stop;
   G0146:
    return a;
}

Sex CC_coftypTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = LL_Abnum;
    w3 = a;
    w2 = q;
   G0150:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0152;
    a = w3;
    goto    G0149;
   G0152:
    a = cdr(car(a));
    w4 = a;
    if(is_number(a)) goto    G0150;
    a = car(a);
    if(!is_integer(a)) goto    G0154;
    w4 = a;
    goto    G0155;
   G0154:
    q = w2;
    a = w4;
    a = CC_coftypTbpol(a, q);
    w4 = a;
    if(is_symbol(a)) goto    G0150;
   G0155:
    a = w2;
    if(a == value(LL_CpolyC)) goto    G0159;
    a = w4;
    if(a == value(LL_CpolyC)) goto    G0149;
    a = value(LL_CalgnC);
    w3 = a;
    goto    G0150;
   G0159:
    a = w4;
   G0149:
    popv(4);
    return a;
}

Sex CC_ncoftypTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = q;
    w3 = a;
    w2 = q;
   G0163:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0165;
    a = w1;
    goto    G0184;
   G0165:
    a = cdr(car(a));
    w4 = a;
    if(!is_number(a)) goto    G0167;
    if(is_integer(a)) goto    G0163;
    if(!is_rational(a)) goto    G0170;
    q = w1;
    a = mkfxat(2);
    goto    G0182;
   G0170:
    if(is_float(a)) goto    G0172;
    if(!is_efloat(a)) goto    G0171;
   G0172:
    q = w1;
    a = mkfxat(4);
   G0182:
    a = Lmax2(a, q);
    goto    G0186;
   G0171:
    a = mkfxat(5);
    goto    G0184;
   G0167:
    a = car(a);
    if(is_integer(a)) goto    G0175;
    q = w4;
    a = w1;
    a = CC_ncoftypTbpol(a, q);
    goto    G0186;
   G0175:
    if(a != value(LL_CalgnC)) goto    G0176;
    q = w1;
    a = mkfxat(3);
    a = Lmax2(a, q);
    goto    G0186;
   G0176:
    q = cdr(w4);
    a = w1;
    a = CC_ncoftypTbpol(a, q);
   G0186:
    w1 = a;
    q = mkfxat(5);
    a = w1;
    a = Llessp(a, q);
    if(a != nil) goto    G0163;
    a = mkfxat(5);
   G0184:
    value(LL_Hchkcoef) = a;
    popv(4);
    return a;
}

Sex CC_Wsinglevar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G0189;
    a = car(w1);
    a = Lfixp(a);
    if(a == nil) goto    G0189;
    q = value(LL_CratfC);
    a = car(w1);
    a = Lilessp(a, q);
    if(a == nil) goto    G0189;
    a = cdr(w1);
    a = CC_WsvarTbpol(a);
   G0189:
    popv(1);
    return a;
}

Sex CC_Wsinglepow(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0194;
    a = car(a);
    if(is_integer(a)) goto    G0193;
   G0194:
    a = nil;
    goto    G0196;
   G0193:
    if(a >= value(LL_CratfC)) goto    G0195;
    a = cdr(w1);
    goto    G0201;
   G0195:
    q = value(LL_CratfC);
    a = Leq(a, q);
    if(a == nil) goto    G0196;
    a = cdr(cdr(w1));
    a = Lnull(a);
    if(a == nil) goto    G0196;
    a = car(cdr(w1));
    w1 = a;
    a = cdr(a);
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G0196;
    a = car(w1);
    a = Lpairp(a);
    if(a == nil) goto    G0196;
    a = cdr(car(w1));
   G0201:
    a = CC_WspowTbpol(a);
   G0196:
    popv(1);
    return a;
}

Sex CC_Wunivar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = nil;
    w2 = nil;
    w3 = nil;
    if(car(a) >= value(LL_CratfC)) goto    G0205;
    w1 = a;
    a = cdr(a);
    w2 = a;
   G0207:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0237;
    a = cdr(car(a));
    w3 = a;
    if(is_number(a)) goto    G0207;
    a = car(a);
    if(is_integer(a)) goto    G0207;
    a = nil;
    goto    G0213;
   G0205:
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    a = car(car(a));
    w5 = a;
    if(is_number(a)) goto    G0219;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0213;
    a = car(cdr(w5));
    w2 = a;
   G0219:
    a = cdr(car(w3));
    w5 = a;
    if(is_number(a)) goto    G0227;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0213;
    a = w2;
    if(a != nil) goto    G0224;
    a = car(cdr(w5));
    w2 = a;
    goto    G0227;
   G0224:
    q = car(cdr(w5));
    a = Lequal(a, q);
    if(a == nil) goto    G0213;
   G0227:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0229;
   G0237:
    a = true;
    goto    G0213;
   G0229:
    a = car(car(a));
    w5 = a;
    if(is_number(a)) goto    G0231;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0213;
    q = car(cdr(w5));
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G0213;
   G0231:
    a = cdr(car(w3));
    w5 = a;
    if(is_number(a)) goto    G0227;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0213;
    q = car(cdr(w5));
    a = w2;
    a = Lequal(a, q);
    if(a != nil) goto    G0227;
   G0213:
    popv(5);
    return a;
}

Sex CC_Wlinearpol(Sex a)
{
    a = cdr(a);
    {
        return  CC_WlinpolTbpol(a);
    }
}

Sex CC_WlinpolTbpol(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
   G0244:
    a = cdr(w1);
    w1 = a;
    a = car(a);
    w2 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G0243;
    a = cdr(w2);
    a = CC_Wbnum(a);
    if(a == nil) goto    G0243;
    a = cdr(w1);
    if(a != nil) goto    G0250;
    a = mkfxat(0);
    goto    G0243;
   G0250:
    a = cdr(car(a));
    w1 = a;
    a = w1;
    a = CC_Wlist(a);
    if(a == nil) goto    G0252;
    a = car(w1);
    a = CC_Wtag(a);
    if(a == nil) goto    G0244;
   G0252:
    a = w1;
   G0243:
    popv(2);
    return a;
}

Sex CC_Wcommute(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = q;
    if(a == nil) goto    G0257;
    a = LITERAL[63];
    goto    G0268;
   G0257:
    a = w1;
    if(is_cons(a)) goto    G0258;
    if(!is_symbol(a)) goto    G0270;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
#define LL_uncom LITERAL[64]
    a = LL_uncom;
    a = Lmemq(a, q);
    {
        popv(1);
        return  Lnull(a);
    }
   G0258:
    a = car(a);
    if(is_integer(a)) goto    G0270;
#define LL_cL LITERAL[65]
    if(a != LL_cL) goto    G0266;
    a = w1;
    {
        popv(1);
        return  CC_WcommTcL(a);
    }
   G0266:
#define LL_cH LITERAL[66]
    if(a != LL_cH) goto    G0267;
   G0270:
    a = true;
    goto    G0268;
   G0267:
    a = nil;
   G0268:
    popv(1);
    return a;
}

Sex CC_Wconst(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G0274;
    {
        popv(2);
        return  Lnumberp(a);
    }
   G0274:
    a = car(a);
    if(!is_integer(a)) goto    G0275;
    if(a >= value(LL_CmaxcanoC)) goto    G0277;
    a = w1;
    {
        popv(2);
        return  CC_WconstTcano(a);
    }
   G0277:
    q = LITERAL[67];
    a = LITERAL[68];
    CC_optionmsg(a, q);
    goto    G0299;
   G0275:
    if(a != LL_cH) goto    G0279;
    a = w1;
    {
        popv(2);
        return  CC_WconstTcH(a);
    }
   G0279:
#define LL_ncH LITERAL[69]
    if(a == LL_ncH) goto    G0299;
    if(a != LL_cL) goto    G0281;
    w2 = nil;
    a = cdr(w1);
    w1 = a;
    a = car(a);
    w2 = a;
    if(is_number(a)) goto    G0298;
    a = car(a);
    if(!is_integer(a)) goto    G0286;
    a = w2;
    a = CC_WconstTcano(a);
    if(a == nil) goto    G0295;
   G0298:
    a = cdr(w1);
    w1 = a;
   G0286:
    a = car(car(car(w1)));
    if(a == LL_ncH) goto    G0299;
   G0291:
    a = car(car(w1));
    a = CC_WconstTcH(a);
    if(a == nil) goto    G0295;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0291;
    a = true;
    goto    G0295;
   G0281:
    q = LITERAL[67];
    a = LITERAL[70];
    CC_optionmsg(a, q);
   G0299:
    a = nil;
   G0295:
    popv(2);
    return a;
}

Sex CC_Wdependvar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0303;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G0315;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    if(a == nil) goto    G0315;
    goto    G0312;
   G0303:
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G0309;
    a = car(cdr(w1));
    if(!is_symbol(a)) goto    G0317;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    if(a == nil) goto    G0317;
   G0312:
    a = true;
    goto    G0315;
   G0309:
    q = LITERAL[71];
    a = LITERAL[72];
    CC_optionmsg(a, q);
   G0317:
    a = nil;
   G0315:
    popv(1);
    return a;
}

Sex CC_Wequal(Sex a, Sex q)
{
    Sex m;
    m = nil;
    {
        return  CC_Wequal1(a, q, m);
    }
}

Sex CC_Wpartequal(Sex a, Sex q)
{
    Sex m;
    m = nil;
    {
        return  CC_Wequal1(a, q, m);
    }
}

Sex CC_Wequal1(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    if(is_cons(a)) goto    G0325;
    if(is_number(a)) goto    G0344;
    if(!is_symbol(q)) goto    G0345;
    if(a != q) goto    G0329;
    a = true;
    goto    G0343;
   G0329:
    q = m;
    a = Lassoc(a, q);
    w1 = a;
    if(a == nil) goto    G0343;
    q = w2;
    a = cdr(a);
   G0344:
    {
        popv(3);
        return  Lequal(a, q);
    }
   G0325:
    a = car(a);
    if(!is_symbol(a)) goto    G0332;
    a = car(q);
    if(is_symbol(a)) goto    G0334;
   G0345:
    a = nil;
    goto    G0343;
   G0334:
    if(a != car(w1)) goto    G0335;
    a = car(w1);
    a = CC_Wpfunc(a);
    if(a == nil) goto    G0342;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_WequalTpfunc(a, q, m);
    }
   G0335:
    a = m;
    if(a == nil) goto    G0343;
    q = car(q);
    a = car(w1);
    a = CC_Wequal1(a, q, m);
    if(a != nil) goto    G0342;
    goto    G0343;
   G0332:
    q = car(q);
    a = CC_Wequal1(a, q, m);
    if(a == nil) goto    G0343;
   G0342:
    m = w3;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_Wequal1(a, q, m);
   G0343:
    popv(3);
    return a;
}

Sex CC_Wfree(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    a = CC_Aexpr2varfunc(a);
    w2 = a;
#define LL_Ainvalid LITERAL[73]
    if(a != LL_Ainvalid) goto    G0351;
    q = LITERAL[74];
    a = LITERAL[75];
    goto    G0370;
   G0351:
    a = w1;
    if(is_cons(a)) goto    G0352;
    if(a != w2) goto    G0354;
    a = nil;
    goto    G0367;
   G0354:
    a = true;
    goto    G0367;
   G0352:
    a = car(a);
    if(!is_integer(a)) goto    G0356;
    if(a >= value(LL_CmaxcanoC)) goto    G0358;
    m = nil;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_WfreeTcano(a, q, m);
    }
   G0358:
#define LL_CmaxformC LITERAL[76]
    if(a >= value(LL_CmaxformC)) goto    G0359;
    m = nil;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_WfreeTform(a, q, m);
    }
   G0359:
    q = LITERAL[74];
    a = mkfxat(1);
    goto    G0370;
   G0356:
    if(!is_symbol(a)) goto    G0361;
    q = LITERAL[77];
    a = Lmemq(a, q);
    if(a == nil) goto    G0363;
    m = nil;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_WfreeTc2H(a, q, m);
    }
   G0363:
    a = car(w1);
    if(a != LL_cL) goto    G0364;
    m = nil;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_WfreeTcL(a, q, m);
    }
   G0364:
    q = LITERAL[74];
    a = LITERAL[78];
    goto    G0370;
   G0361:
    a = w1;
    a = CC_Warray(a);
    if(a == nil) goto    G0366;
    a = LITERAL[74];
    {
        popv(2);
        return  CC_argerror(a);
    }
   G0366:
    q = LITERAL[74];
    a = mkfxat(1);
   G0370:
    a = CC_errormsg(a, q);
   G0367:
    popv(2);
    return a;
}

Sex CC_Wtotalfree(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    a = CC_Aexpr2varfunc(a);
    w2 = a;
    if(a != LL_Ainvalid) goto    G0374;
    q = LITERAL[79];
    a = LITERAL[75];
    goto    G0393;
   G0374:
    a = w1;
    if(is_cons(a)) goto    G0375;
    if(!is_symbol(a)) goto    G0377;
    m = true;
    q = w2;
    {
        popv(2);
        return  CC_WfreeTid(a, q, m);
    }
   G0377:
    a = true;
    goto    G0390;
   G0375:
    a = car(a);
    if(!is_integer(a)) goto    G0379;
    if(a >= value(LL_CmaxcanoC)) goto    G0381;
    m = true;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_WfreeTcano(a, q, m);
    }
   G0381:
    if(a >= value(LL_CmaxformC)) goto    G0382;
    m = true;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_WfreeTform(a, q, m);
    }
   G0382:
    q = LITERAL[79];
    a = mkfxat(1);
    goto    G0393;
   G0379:
    if(!is_symbol(a)) goto    G0384;
    q = LITERAL[77];
    a = Lmemq(a, q);
    if(a == nil) goto    G0386;
    m = true;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_WfreeTc2H(a, q, m);
    }
   G0386:
    a = car(w1);
    if(a != LL_cL) goto    G0387;
    m = true;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_WfreeTcL(a, q, m);
    }
   G0387:
    q = LITERAL[79];
    a = LITERAL[78];
    goto    G0393;
   G0384:
    a = w1;
    a = CC_Warray(a);
    if(a == nil) goto    G0389;
    a = LITERAL[79];
    {
        popv(2);
        return  CC_argerror(a);
    }
   G0389:
    q = LITERAL[79];
    a = mkfxat(1);
   G0393:
    a = CC_errormsg(a, q);
   G0390:
    popv(2);
    return a;
}

Sex CC_WfreeH(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0397;
    if(!is_symbol(a)) goto    G0399;
    {
        popv(1);
        return  CC_WfreeTid(a, q, m);
    }
   G0399:
    a = true;
    goto    G0408;
   G0397:
    a = car(a);
    if(!is_integer(a)) goto    G0401;
    if(a >= value(LL_CmaxcanoC)) goto    G0403;
    a = w1;
    {
        popv(1);
        return  CC_WfreeTcano(a, q, m);
    }
   G0403:
    a = w1;
    {
        popv(1);
        return  CC_WfreeTform(a, q, m);
    }
   G0401:
    if(a != LL_cL) goto    G0405;
    a = w1;
    {
        popv(1);
        return  CC_WfreeTcL(a, q, m);
    }
   G0405:
    if(a == LL_cH) goto    G0409;
    if(a != LL_ncH) goto    G0407;
   G0409:
    a = w1;
    {
        popv(1);
        return  CC_WfreeTc2H(a, q, m);
    }
   G0407:
    a = w1;
    a = CC_WfreeTfunc(a, q, m);
   G0408:
    popv(1);
    return a;
}

Sex CC_Wmonomial(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0413;
    {
        popv(1);
        return  Lnumberp(a);
    }
   G0413:
    a = car(a);
    if(!is_integer(a)) goto    G0414;
    if(a >= value(LL_CratfC)) goto    G0416;
    a = cdr(w1);
    goto    G0428;
   G0416:
    if(a != value(LL_CratfC)) goto    G0417;
    a = cdr(cdr(w1));
    a = Lnull(a);
    if(a == nil) goto    G0423;
    a = car(cdr(w1));
    w1 = a;
    if(a == nil) goto    G0423;
    a = cdr(car(a));
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0423;
    a = cdr(w1);
    a = Lnumberp(a);
    if(a != nil) goto    G0423;
    a = cdr(cdr(w1));
   G0428:
    {
        popv(1);
        return  CC_WmonoTbpol(a);
    }
   G0417:
    a = LITERAL[80];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0414:
    q = LITERAL[77];
    a = Lmemq(a, q);
    if(a == nil) goto    G0421;
    a = cdr(w1);
    {
        popv(1);
        return  CC_WmonoTbcH(a);
    }
   G0421:
    q = LL_cL;
    a = car(w1);
    a = Lneq(a, q);
    if(a == nil) goto    G0422;
    a = nil;
    goto    G0423;
   G0422:
    a = cdr(cdr(w1));
    a = Lnull(a);
    if(a == nil) goto    G0423;
    a = w1;
    a = Lcdaadr(a);
    a = CC_WmonoTbcH(a);
    if(a == nil) goto    G0423;
    a = cdr(car(cdr(w1)));
    w1 = a;
    a = Lnumberp(a);
    if(a != nil) goto    G0423;
    a = w1;
    a = CC_Wmonomial(a);
   G0423:
    popv(1);
    return a;
}

Sex CC_Wmonopol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G0431;
    a = car(w1);
    a = Lfixp(a);
    if(a == nil) goto    G0431;
    q = value(LL_CratfC);
    a = car(w1);
    a = Lilessp(a, q);
    if(a == nil) goto    G0431;
    a = cdr(w1);
    a = CC_WmonoTbpol(a);
   G0431:
    popv(1);
    return a;
}

Sex CC_Wsametype(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0435;
    if(is_symbol(a)) goto    G0457;
    a = Lnumberp(a);
    if(a == nil) goto    G0455;
    a = w2;
    {
        popv(3);
        return  Lnumberp(a);
    }
   G0435:
    if(is_cons(q)) goto    G0440;
    if(!is_symbol(q)) goto    G0459;
    q = a;
    a = w2;
   G0457:
    {
        popv(3);
        return  CC_WsametypeTidany(a, q);
    }
   G0440:
    a = car(a);
    if(!is_integer(a)) goto    G0444;
    a = car(q);
    if(!is_integer(a)) goto    G0459;
    if(car(w1) >= value(LL_CmaxcanoC)) goto    G0447;
    q = value(LL_CmaxcanoC);
    {
        popv(3);
        return  Lilessp(a, q);
    }
   G0447:
    a = w1;
    {
        popv(3);
        return  CC_WsametypeTform(a, q);
    }
   G0444:
    if(!is_symbol(a)) goto    G0449;
    a = car(q);
    if(is_symbol(a)) goto    G0451;
   G0459:
    a = nil;
    goto    G0455;
   G0451:
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
    w3 = a;
    q = LL_BctypeB;
    a = car(w2);
    a = Lget(a, q);
    q = a;
    a = w3;
    {
        popv(3);
        return  Leq(a, q);
    }
   G0449:
    a = Lvectorp(a);
    if(a == nil) goto    G0455;
    a = car(w2);
    a = Lvectorp(a);
    if(a == nil) goto    G0455;
    q = cdr(w2);
    a = cdr(w1);
    a = Lequal(a, q);
   G0455:
    popv(3);
    return a;
}

Sex CC_Wsingleid(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G0463;
    if(!is_symbol(a)) goto    G0485;
    goto    G0467;
   G0463:
    w2 = nil;
    a = car(a);
    if(!is_integer(a)) goto    G0470;
    q = value(LL_CpolyC);
    a = Leqn(a, q);
    if(a == nil) goto    G0485;
    a = cdr(cdr(cdr(w1)));
    if(a != nil) goto    G0485;
    a = car(cdr(w1));
    if(is_cons(a)) goto    G0485;
    a = car(cdr(cdr(w1)));
    w2 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G0485;
    a = cdr(w2);
    a = Lonep(a);
    if(a == nil) goto    G0485;
    a = car(cdr(w1));
    goto    G0467;
   G0470:
    q = LITERAL[77];
    a = Lmemq(a, q);
    if(a == nil) goto    G0467;
    a = cdr(cdr(cdr(w1)));
    if(a != nil) goto    G0485;
    a = car(cdr(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G0485;
    a = car(cdr(w1));
    w2 = a;
    if(is_cons(a)) goto    G0481;
    if(!is_symbol(a)) goto    G0485;
    goto    G0467;
   G0481:
    a = cdr(a);
    if(a != nil) goto    G0485;
    a = car(w2);
    goto    G0467;
   G0485:
    a = nil;
   G0467:
    popv(2);
    return a;
}

Sex CC_Wsinglefunc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G0495;
    q = LITERAL[77];
    a = car(w1);
    a = Lmemq(a, q);
    if(a == nil) goto    G0495;
    a = cdr(cdr(cdr(w1)));
    a = Lnull(a);
    if(a == nil) goto    G0495;
    a = car(cdr(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G0495;
    a = car(cdr(w1));
    a = Lpairp(a);
    if(a == nil) goto    G0495;
    a = car(car(cdr(w1)));
    a = CC_Wfunc(a);
   G0495:
    popv(1);
    return a;
}

Sex CC_Wsingleterm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0499;
    {
        popv(1);
        return  Lnumberp(a);
    }
   G0499:
    a = car(a);
    if(!is_integer(a)) goto    G0500;
    if(a < value(LL_CratfC)) goto    G0511;
    if(a != value(LL_CratfC)) goto    G0503;
    a = cdr(cdr(w1));
    a = Lnull(a);
    if(a == nil) goto    G0510;
    a = cdr(car(cdr(w1)));
    w1 = a;
    a = Lnumberp(a);
    if(a != nil) goto    G0510;
   G0511:
    a = cdr(w1);
    {
        popv(1);
        return  CC_WstermTbpol(a);
    }
   G0503:
    a = LITERAL[81];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0500:
    if(a != LL_cL) goto    G0508;
    a = cdr(cdr(w1));
    {
        popv(1);
        return  Lnull(a);
    }
   G0508:
    q = LITERAL[77];
    a = Lmemq(a, q);
    if(a == nil) goto    G0510;
    a = true;
   G0510:
    popv(1);
    return a;
}

Sex CC_Wformtype(Sex a)
{
    if(!is_cons(a)) goto    G0519;
    a = car(a);
    if(!is_integer(a)) goto    G0519;
#define LL_CmatxC LITERAL[82]
    if(a != value(LL_CmatxC)) goto    G0517;
#define LL_Amatx LITERAL[83]
    a = LL_Amatx;
    goto    G0520;
   G0517:
#define LL_CvectC LITERAL[84]
    if(a != value(LL_CvectC)) goto    G0518;
#define LL_Avect LITERAL[85]
    a = LL_Avect;
    goto    G0520;
   G0518:
#define LL_CtensC LITERAL[86]
    if(a != value(LL_CtensC)) goto    G0519;
#define LL_Atens LITERAL[87]
    a = LL_Atens;
    goto    G0520;
   G0519:
    a = LITERAL[88];
    a = CC_argerror(a);
   G0520:
    return a;
}

Sex CC_Welmttype(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0531;
    a = car(a);
    if(!is_integer(a)) goto    G0526;
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G0531;
    a = w1;
    {
        popv(1);
        return  CC_eltypeTform(a);
    }
   G0526:
    q = LITERAL[89];
    a = Lmemq(a, q);
    if(a == nil) goto    G0531;
    a = w1;
    {
        popv(1);
        return  CC_eltypeTset(a);
    }
   G0531:
    a = LITERAL[90];
    {
        popv(1);
        return  CC_argerror(a);
    }
}

Sex CC_eltypeTform(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w1 = a;
    a = LL_Abnum;
    w2 = a;
    a = true;
    w6 = a;
    a = car(cdr(cdr(w1)));
    w3 = a;
    a = car(cdr(w1));
    w1 = a;
    a = mkfxat(1);
    w4 = a;
   G0538:
    q = w4;
    a = w1;
    a = Lgetv(a, q);
    w5 = a;
    if(is_cons(a)) goto    G0541;
    a = CC_Wexactnum(a);
    if(a != nil) goto    G0546;
    w6 = nil;
    goto    G0546;
   G0541:
    a = car(a);
    if(is_integer(a)) goto    G0550;
    a = LL_Apref;
    goto    G0537;
   G0550:
    a = LL_Acano;
    w2 = a;
   G0546:
    a = w4;
    a = (Sex)((long)a + 0x10);
    w4 = a;
    if(w3 >= a) goto    G0538;
    a = w6;
    value(LL_Htemporal) = a;
    a = w2;
   G0537:
    popv(6);
    return a;
}

Sex CC_Wsize(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0556;
    a = car(a);
    if(!is_vector(a)) goto    G0555;
    a = w1;
    {
        popv(1);
        return  CC_Warraysize(a);
    }
   G0555:
    if(!is_integer(a)) goto    G0556;
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G0556;
    a = w1;
    {
        popv(1);
        return  CC_Wformsize(a);
    }
   G0556:
    a = LITERAL[91];
    {
        popv(1);
        return  CC_argerror(a);
    }
}

Sex CC_Wtotalsize(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0566;
    a = car(a);
    if(!is_vector(a)) goto    G0565;
    a = car(cdr(w1));
    goto    G0569;
   G0565:
    if(!is_integer(a)) goto    G0566;
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G0566;
    a = car(cdr(cdr(w1)));
    goto    G0569;
   G0566:
    a = LITERAL[92];
    a = CC_argerror(a);
   G0569:
    popv(1);
    return a;
}

Sex CC_Warraysize(Sex a)
{
    Sex q;
    q = cdr(cdr(a));
#define LL_Boset LITERAL[93]
    a = LL_Boset;
    {
        return  cons(a, q);
    }
}

Sex CC_Wformsize(Sex a)
{
    Sex q;
    q = cdr(cdr(cdr(a)));
    a = LL_Boset;
    {
        return  cons(a, q);
    }
}

Sex CC_WequalTpfunc(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = Llength(a);
    w4 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w4;
    a = Lequal(a, q);
    if(a == nil) goto    G0583;
    a = cdr(w1);
    if(a == nil) goto    G0614;
#define LL_Bargtype LITERAL[94]
    q = LL_Bargtype;
    a = car(w1);
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(is_cons(a)) goto    G0582;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(9);
        return  CC_Wequal1(a, q, m);
    }
   G0582:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = car(a);
    w8 = a;
    a = cdr(cdr(w1));
    w4 = a;
    a = cdr(cdr(w2));
    w5 = a;
    a = w8;
#define LL_argxy1 LITERAL[95]
    if(a != LL_argxy1) goto    G0589;
    a = cdr(w4);
    w4 = a;
    a = cdr(w5);
    w5 = a;
   G0589:
    a = car(w4);
    w6 = a;
    if(!is_cons(a)) goto    G0591;
    q = LITERAL[96];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0591;
    a = car(cdr(w6));
    w6 = a;
   G0591:
    a = car(w5);
    w7 = a;
    if(!is_cons(a)) goto    G0594;
    q = LITERAL[96];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0594;
    a = car(cdr(w7));
    w7 = a;
   G0594:
    q = w7;
    a = w6;
    a = cons(a, q);
    q = w3;
    a = cons(a, q);
    w3 = a;
    a = w4;
    if(a == nil) goto    G0598;
    q = LITERAL[97];
    a = w8;
    a = Lmemq(a, q);
    if(a == nil) goto    G0598;
    a = cdr(w4);
    w4 = a;
    a = cdr(w5);
    w5 = a;
   G0598:
    a = w4;
    if(a != nil) goto    G0589;
    m = w3;
    q = car(cdr(w2));
    a = car(cdr(w1));
    a = CC_Wequal1(a, q, m);
    if(a == nil) goto    G0583;
    a = cdr(cdr(w1));
    w4 = a;
    a = cdr(cdr(w5));
    w5 = a;
   G0587:
    a = w4;
    if(a == nil) goto    G0614;
    a = car(a);
    w6 = a;
    if(!is_cons(a)) goto    G0607;
    q = LITERAL[96];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0607;
    a = car(cdr(cdr(w6)));
    w6 = a;
   G0607:
    a = car(w5);
    w7 = a;
    if(!is_cons(a)) goto    G0610;
    q = LITERAL[96];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0610;
    a = car(cdr(cdr(w7)));
    w7 = a;
   G0610:
    m = w3;
    q = w7;
    a = w6;
    a = CC_Wequal1(a, q, m);
    if(a == nil) goto    G0583;
    a = cdr(w4);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    goto    G0587;
   G0614:
    a = true;
   G0583:
    popv(9);
    return a;
}

Sex CC_WcommTcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    a = cdr(a);
    w1 = a;
    a = car(a);
    if(is_number(a)) goto    G0619;
    a = car(car(w1));
    if(!is_integer(a)) goto    G0618;
   G0619:
    q = LL_cH;
    a = car(car(car(cdr(w1))));
    goto    G0622;
   G0618:
    q = LL_cH;
    a = car(a);
   G0622:
    {
        popv(1);
        return  Leq(a, q);
    }
}

Sex CC_WconstTcano(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(car(a) >= value(LL_CratfC)) goto    G0626;
    w1 = a;
    a = car(a);
    if(a == value(LL_CalgnC)) goto    G0640;
    a = car(cdr(w1));
    a = CC_Wtran(a);
    if(a == nil) goto    G0631;
    goto    G0640;
   G0626:
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = cdr(a);
    w1 = a;
   G0633:
    a = car(w1);
    w2 = a;
    a = car(a);
    w3 = a;
    if(is_number(a)) goto    G0637;
    a = CC_WconstTcano(a);
    if(a == nil) goto    G0631;
   G0637:
    a = cdr(w2);
    w3 = a;
    if(is_number(a)) goto    G0638;
    a = CC_WconstTcano(a);
    if(a == nil) goto    G0631;
   G0638:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0633;
   G0640:
    a = true;
   G0631:
    popv(3);
    return a;
}

Sex CC_WconstTcH(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    a = cdr(a);
    w1 = a;
   G0648:
    a = car(w1);
    w2 = a;
    if(is_number(a)) goto    G0657;
    a = car(a);
    if(is_integer(a)) goto    G0661;
    if(a != LL_cL) goto    G0655;
    a = w2;
    a = CC_Wconst(a);
    if(a != nil) goto    G0657;
   G0655:
    a = nil;
    goto    G0647;
   G0661:
    a = w2;
    a = CC_WconstTcano(a);
    if(a == nil) goto    G0647;
   G0657:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0648;
    a = true;
   G0647:
    popv(2);
    return a;
}

Sex CC_WmonoTbpol(Sex a)
{
    Sex q, m;
    m = a;
    a = cdr(cdr(a));
    if(a == nil) goto    G0665;
    a = nil;
    goto    G0668;
   G0665:
    a = cdr(car(cdr(m)));
    m = a;
    if(is_number(a)) goto    G0667;
    a = car(a);
    if(!is_integer(a)) goto    G0666;
   G0667:
    a = true;
    goto    G0668;
   G0666:
    a = m;
    a = CC_WmonoTbpol(a);
   G0668:
    return a;
}

Sex CC_WmonoTbcH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a != nil) goto    G0672;
    a = true;
    goto    G0678;
   G0672:
    w1 = a;
    a = car(a);
    if(!is_cons(a)) goto    G0682;
    a = car(a);
    value(LL_Htemporal) = a;
    if(!is_integer(a)) goto    G0674;
    a = car(w1);
    a = CC_Wmonomial(a);
    if(a == nil) goto    G0678;
    goto    G0682;
   G0674:
    if(a != LL_ncH) goto    G0676;
    a = cdr(car(w1));
    a = CC_WmonoTbcH(a);
    if(a == nil) goto    G0678;
    goto    G0682;
   G0676:
    q = LL_cL;
    a = Lneq(a, q);
    if(a == nil) goto    G0678;
   G0682:
    a = cdr(cdr(w1));
    a = CC_WmonoTbcH(a);
   G0678:
    popv(1);
    return a;
}

Sex CC_WsvarTbpol(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(cdr(a));
    a = Lnull(a);
    if(a == nil) goto    G0685;
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G0685;
    a = cdr(w1);
    a = Lonep(a);
   G0685:
    popv(1);
    return a;
}

Sex CC_WspowTbpol(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(cdr(a));
    a = Lnull(a);
    if(a == nil) goto    G0690;
    a = cdr(car(cdr(w1)));
    a = Lonep(a);
   G0690:
    popv(1);
    return a;
}

Sex CC_WstermTbpol(Sex a)
{
    Sex q, m;
    m = a;
    a = cdr(cdr(a));
    if(a == nil) goto    G0694;
    a = nil;
    goto    G0697;
   G0694:
    a = cdr(car(cdr(m)));
    m = a;
    if(is_number(a)) goto    G0696;
    a = car(a);
    if(!is_integer(a)) goto    G0695;
   G0696:
    a = true;
    goto    G0697;
   G0695:
    a = m;
    a = CC_WstermTbpol(a);
   G0697:
    return a;
}

Sex CC_WfreeTid(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a != q) goto    G0701;
    a = nil;
    goto    G0705;
   G0701:
    w1 = a;
    a = m;
    if(a == nil) goto    G0707;
    w2 = q;
    w3 = m;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    if(a != nil) goto    G0703;
   G0707:
    a = true;
    goto    G0705;
   G0703:
    a = CC_convTsexpr2gexpr(a);
    m = w3;
    q = w2;
    a = CC_WfreeH(a, q, m);
   G0705:
    popv(3);
    return a;
}

Sex CC_WfreeTfunc(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = Lequal(a, q);
    if(a != nil) goto    G0748;
    a = car(w1);
    if(a == w2) goto    G0748;
    a = w2;
    if(!is_cons(a)) goto    G0713;
    a = car(w1);
    if(a != car(w2)) goto    G0713;
    a = cdr(w2);
    if(a == nil) goto    G0748;
    a = cdr(w1);
    if(a == nil) goto    G0713;
    a = cdr(w2);
    if(a == nil) goto    G0713;
    a = cdr(a);
    if(a != nil) goto    G0713;
    q = car(cdr(w2));
    a = car(cdr(w1));
    a = Lequal(a, q);
    if(a != nil) goto    G0748;
   G0713:
    a = car(w1);
    a = CC_Wpfunc(a);
    if(a == nil) goto    G0717;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_WfreeTpfunc(a, q, m);
    }
   G0717:
    w4 = nil;
    w5 = nil;
    a = cdr(w1);
    w4 = a;
    if(a == nil) goto    G0728;
    a = car(a);
    w5 = a;
    if(!is_cons(a)) goto    G0732;
#define LL_Bindex LITERAL[98]
    q = LL_Bindex;
    a = car(a);
    a = Lneq(a, q);
    if(a != nil) goto    G0732;
    m = w3;
    q = w2;
    a = w5;
    a = CC_WfreeTfunc(a, q, m);
    if(a == nil) goto    G0718;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0732;
   G0728:
    a = car(w1);
    a = CC_getTfncvars(a);
    w4 = a;
    if(a == nil) goto    G0718;
    q = a;
    a = w2;
    a = Lmember(a, q);
    if(a == nil) goto    G0731;
   G0748:
    a = nil;
    goto    G0718;
   G0731:
    a = w3;
    if(a == nil) goto    G0746;
   G0732:
    a = car(w4);
    w5 = a;
    if(is_cons(a)) goto    G0734;
    if(!is_symbol(a)) goto    G0736;
    m = w3;
    q = w2;
    a = CC_WfreeTid(a, q, m);
    goto    G0743;
   G0736:
    a = true;
    goto    G0743;
   G0734:
    a = car(a);
    if(!is_integer(a)) goto    G0738;
    m = w3;
    q = w2;
    a = w5;
    a = CC_WfreeTcano(a, q, m);
    goto    G0743;
   G0738:
    q = LL_BctypeB;
    a = Lget(a, q);
    w5 = a;
    m = w3;
    q = w2;
    if(a != LL_rat) goto    G0739;
    a = car(w4);
    a = CC_WfreeTpref(a, q, m);
    goto    G0743;
   G0739:
    if(a != LL_rel) goto    G0740;
    a = car(cdr(car(w4)));
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0743;
    a = w4;
    a = Lcaddar(a);
    m = w3;
    q = w2;
    a = CC_WfreeH(a, q, m);
    goto    G0743;
   G0740:
    a = car(w4);
    a = CC_WfreeTfunc(a, q, m);
   G0743:
    w5 = a;
    if(a == nil) goto    G0718;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0732;
   G0746:
    a = true;
   G0718:
    popv(5);
    return a;
}

Sex CC_WfreeTpfunc(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = cdr(a);
    w5 = a;
    w2 = q;
    w3 = m;
    q = LL_Bargtype;
    a = car(w1);
    a = Lget(a, q);
    w4 = a;
    if(is_cons(a)) goto    G0759;
    q = LITERAL[99];
    a = Lmemq(a, q);
    if(a == nil) goto    G0754;
   G0753:
    m = w3;
    q = w2;
    a = car(w5);
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0752;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G0814;
    goto    G0753;
   G0754:
    m = w3;
    q = w2;
    a = car(w5);
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0752;
    q = LL_argxy1;
    a = w4;
    a = Lneq(a, q);
    if(a != nil) goto    G0771;
    a = cdr(w5);
    w5 = a;
    m = w3;
    q = w2;
    a = car(a);
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0752;
   G0771:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G0814;
    a = car(a);
    w6 = a;
    if(!is_cons(a)) goto    G0774;
    a = car(a);
#define LL_rM LITERAL[100]
    if(a != LL_rM) goto    G0774;
    m = w3;
    q = w2;
    a = car(cdr(cdr(w6)));
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0752;
    a = car(cdr(w6));
    w6 = a;
   G0774:
    a = w6;
    if(is_cons(a)) goto    G0780;
    if(a != w2) goto    G0784;
    goto    G0812;
   G0780:
    m = w3;
    q = w2;
    a = CC_WfreeTfunc(a, q, m);
    if(a == nil) goto    G0752;
   G0784:
    q = LITERAL[97];
    a = w4;
    a = Lmemq(a, q);
    if(a == nil) goto    G0771;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0787;
   G0814:
    a = true;
    goto    G0752;
   G0787:
    m = w3;
    q = w2;
    a = car(a);
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0752;
    goto    G0771;
   G0759:
    a = car(w4);
    w4 = a;
    a = true;
    w7 = a;
    m = w3;
    q = w2;
    a = car(w5);
    a = CC_WfreeH(a, q, m);
    if(a != nil) goto    G0791;
    w7 = nil;
   G0791:
    q = LL_argxy1;
    a = w4;
    a = Lneq(a, q);
    if(a != nil) goto    G0795;
    a = cdr(w5);
    w5 = a;
    m = w3;
    q = w2;
    a = car(a);
    a = CC_WfreeH(a, q, m);
    if(a != nil) goto    G0795;
    w7 = nil;
   G0795:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G0816;
    a = car(a);
    w6 = a;
    if(!is_cons(a)) goto    G0799;
    q = LL_rM;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0798;
   G0799:
    q = w6;
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G0803;
    a = true;
    w7 = a;
    goto    G0803;
   G0798:
    q = car(cdr(w6));
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G0805;
    a = true;
    w7 = a;
   G0805:
    m = w3;
    q = w2;
    a = car(cdr(cdr(w6)));
    a = CC_WfreeH(a, q, m);
    if(a != nil) goto    G0803;
    w7 = nil;
   G0803:
    q = LITERAL[97];
    a = w4;
    a = Lmemq(a, q);
    if(a == nil) goto    G0795;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0810;
   G0816:
    a = w7;
    goto    G0752;
   G0810:
    m = w3;
    q = w2;
    a = car(a);
    a = CC_WfreeH(a, q, m);
    if(a != nil) goto    G0795;
    w7 = nil;
   G0812:
    a = nil;
   G0752:
    popv(7);
    return a;
}

Sex CC_WfreeTcano(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(car(a) >= value(LL_CratfC)) goto    G0820;
    a = cdr(a);
    {
        popv(4);
        return  CC_WfreeTbpol(a, q, m);
    }
   G0820:
    w4 = nil;
    w1 = a;
    a = cdr(a);
    w1 = a;
    w2 = q;
    w3 = m;
   G0823:
    a = car(w1);
    w4 = a;
    a = car(a);
    if(!is_cons(a)) goto    G0825;
    m = w3;
    q = w2;
    a = cdr(car(w4));
    a = CC_WfreeTbpol(a, q, m);
    if(a == nil) goto    G0821;
   G0825:
    a = cdr(w4);
    if(!is_cons(a)) goto    G0828;
    m = w3;
    q = w2;
    a = cdr(a);
    a = CC_WfreeTbpol(a, q, m);
    if(a == nil) goto    G0821;
   G0828:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0823;
    a = true;
   G0821:
    popv(4);
    return a;
}

Sex CC_WfreeTpref(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G0834;
    a = w1;
    {
        popv(1);
        return  CC_WfreeTcL(a, q, m);
    }
   G0834:
    a = w1;
    {
        popv(1);
        return  CC_WfreeTc2H(a, q, m);
    }
}

Sex CC_WfreeTform(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = cdr(cdr(a));
    a = CC_arrysizeT(a);
    w4 = a;
    a = car(cdr(w1));
    w1 = a;
    a = w5;
    Lzerop(a);
   G0839:
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    m = w3;
    q = w2;
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0838;
    if(w5 < w4) goto    G0839;
    a = true;
   G0838:
    popv(5);
    return a;
}

Sex CC_WfreeTc2H(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    a = cdr(a);
    w1 = a;
    w2 = q;
    w3 = m;
   G0848:
    a = car(w1);
    w4 = a;
    if(is_cons(a)) goto    G0850;
    if(!is_symbol(a)) goto    G0852;
    m = w3;
    q = w2;
    a = CC_WfreeTid(a, q, m);
    goto    G0857;
   G0852:
    a = true;
    goto    G0857;
   G0850:
    a = car(a);
    m = w3;
    q = w2;
    if(!is_integer(a)) goto    G0854;
    a = w4;
    a = CC_WfreeTcano(a, q, m);
    goto    G0857;
   G0854:
    if(a != LL_cL) goto    G0855;
    a = w4;
    a = CC_WfreeTcL(a, q, m);
    goto    G0857;
   G0855:
    if(a != LL_ncH) goto    G0856;
    a = w4;
    a = CC_WfreeTc2H(a, q, m);
    goto    G0857;
   G0856:
    a = w4;
    a = CC_WfreeTfunc(a, q, m);
   G0857:
    w5 = a;
    if(a == nil) goto    G0847;
    a = car(cdr(w1));
    w5 = a;
    if(!is_cons(a)) goto    G0860;
    m = w3;
    q = w2;
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0847;
   G0860:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G0848;
    a = true;
   G0847:
    popv(5);
    return a;
}

Sex CC_WfreeTcL(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = q;
    w3 = m;
    a = cdr(a);
    w1 = a;
    a = car(a);
    if(is_number(a)) goto    G0879;
    a = car(car(w1));
    if(!is_integer(a)) goto    G0870;
    m = w3;
    q = w2;
    a = car(w1);
    a = CC_WfreeTcano(a, q, m);
    if(a == nil) goto    G0865;
   G0879:
    a = cdr(w1);
    w1 = a;
   G0870:
    m = w3;
    q = w2;
    a = car(car(w1));
    a = CC_WfreeTc2H(a, q, m);
    if(a == nil) goto    G0865;
    a = cdr(car(w1));
    if(!is_cons(a)) goto    G0876;
    m = w3;
    q = w2;
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G0865;
   G0876:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0870;
    a = true;
   G0865:
    popv(3);
    return a;
}

Sex CC_WfreeTbpol(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = car(a);
    w4 = a;
    w2 = q;
    w3 = m;
    a = Lequal(a, q);
    if(a == nil) goto    G0885;
    a = nil;
    goto    G0882;
   G0885:
    a = w4;
    if(!is_symbol(a)) goto    G0886;
    a = w3;
    if(a == nil) goto    G0891;
    m = a;
    q = w2;
    a = w4;
    a = CC_WfreeTid(a, q, m);
    goto    G0901;
   G0886:
    m = w3;
    q = w2;
    a = CC_WfreeTfunc(a, q, m);
    if(a == nil) goto    G0882;
   G0891:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0893;
    a = true;
    goto    G0882;
   G0893:
    a = cdr(car(a));
    w4 = a;
    if(is_number(a)) goto    G0891;
    a = car(a);
    if(!is_integer(a)) goto    G0897;
    a = cdr(w4);
    goto    G0898;
   G0897:
    a = w4;
   G0898:
    m = w3;
    q = w2;
    a = CC_WfreeTbpol(a, q, m);
   G0901:
    if(a != nil) goto    G0891;
   G0882:
    popv(4);
    return a;
}

Sex CC_WsametypeTid(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    w1 = a;
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = w1;
    {
        popv(2);
        return  Leq(a, q);
    }
}

Sex CC_WsametypeTidany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0913;
    if(!is_symbol(q)) goto    G0929;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    w3 = a;
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    goto    G0930;
   G0913:
    a = car(q);
    if(is_symbol(a)) goto    G0923;
   G0929:
    a = nil;
    goto    G0924;
   G0923:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    w3 = a;
    q = LL_BctypeB;
    a = car(w2);
    a = Lget(a, q);
   G0930:
    q = a;
    a = w3;
    a = Leq(a, q);
   G0924:
    popv(3);
    return a;
}

Sex CC_WsametypeTform(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Leq(a, q);
    if(a == nil) goto    G0933;
    q = cdr(cdr(w2));
    a = cdr(cdr(w1));
    a = Lequal(a, q);
   G0933:
    popv(2);
    return a;
}



/* initialization procedure */
int init_bsques(void)
{
   long i;

   create_symbols(bsques_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; bsques_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(bsques_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4;
        a = LITERAL[101];
        CC_Aenter(a);
        arg4 = nil;
        m = nil;
#define LL_Wnum LITERAL[102]
        q = LL_Wnum;
        a = LL_Wnum;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wvar LITERAL[103]
        q = LL_Wvar;
        a = LL_Wvar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wfunc LITERAL[104]
        q = LL_Wfunc;
        a = LL_Wfunc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsymbol LITERAL[105]
        q = LL_Wsymbol;
        a = LL_Wsymbol;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Warray LITERAL[106]
        q = LL_Warray;
        a = LL_Warray;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wnil LITERAL[107]
        q = LL_Wnil;
        a = LL_Wnil;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wuncom LITERAL[108]
        q = LL_Wuncom;
        a = LL_Wuncom;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Windxed LITERAL[109]
        q = LL_Windxed;
        a = LL_Windxed;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wdummy LITERAL[110]
        q = LL_Wdummy;
        a = LL_Wdummy;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wcvar LITERAL[111]
        q = LL_Wcvar;
        a = LL_Wcvar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wncvar LITERAL[112]
        q = LL_Wncvar;
        a = LL_Wncvar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wncfunc LITERAL[113]
        q = LL_Wncfunc;
        a = LL_Wncfunc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wpfunc LITERAL[114]
        q = LL_Wpfunc;
        a = LL_Wpfunc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wtfunc LITERAL[115]
        q = LL_Wtfunc;
        a = LL_Wtfunc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Woper LITERAL[116]
        q = LL_Woper;
        a = LL_Woper;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wbnum LITERAL[117]
        q = LL_Wbnum;
        a = LL_Wbnum;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wcano LITERAL[118]
        q = LL_Wcano;
        a = LL_Wcano;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wpref LITERAL[119]
        q = LL_Wpref;
        a = LL_Wpref;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wform LITERAL[120]
        q = LL_Wform;
        a = LL_Wform;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wratexpr LITERAL[121]
        q = LL_Wratexpr;
        a = LL_Wratexpr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsetexpr LITERAL[122]
        q = LL_Wsetexpr;
        a = LL_Wsetexpr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wrelexpr LITERAL[123]
        q = LL_Wrelexpr;
        a = LL_Wrelexpr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wlogexpr LITERAL[124]
        q = LL_Wlogexpr;
        a = LL_Wlogexpr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Walgn LITERAL[125]
        q = LL_Walgn;
        a = LL_Walgn;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Walgn;
#define LL_Walgnum LITERAL[126]
        a = LL_Walgnum;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wtran LITERAL[127]
        q = LL_Wtran;
        a = LL_Wtran;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wtran;
#define LL_Wtranum LITERAL[128]
        a = LL_Wtranum;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wpoly LITERAL[129]
        q = LL_Wpoly;
        a = LL_Wpoly;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Walgf LITERAL[130]
        q = LL_Walgf;
        a = LL_Walgf;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Walgf;
#define LL_Walgfun LITERAL[131]
        a = LL_Walgfun;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wratf LITERAL[132]
        q = LL_Wratf;
        a = LL_Wratf;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wratf;
#define LL_Wratfun LITERAL[133]
        a = LL_Wratfun;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wvect LITERAL[134]
        q = LL_Wvect;
        a = LL_Wvect;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wvect;
#define LL_Wvector LITERAL[135]
        a = LL_Wvector;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wmatx LITERAL[136]
        q = LL_Wmatx;
        a = LL_Wmatx;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wmatx;
#define LL_Wmatrix LITERAL[137]
        a = LL_Wmatrix;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wtens LITERAL[138]
        q = LL_Wtens;
        a = LL_Wtens;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wtens;
#define LL_Wtensor LITERAL[139]
        a = LL_Wtensor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wset LITERAL[140]
        q = LL_Wset;
        a = LL_Wset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Woset LITERAL[141]
        q = LL_Woset;
        a = LL_Woset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Woset;
#define LL_Wordset LITERAL[142]
        a = LL_Wordset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_killargchk LITERAL[143]
        q = LL_killargchk;
        a = LL_killargchk;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_recovargchk LITERAL[144]
        q = LL_recovargchk;
        a = LL_recovargchk;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_killtrace LITERAL[145]
        q = LL_killtrace;
        a = LL_killtrace;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_recovtrace LITERAL[146]
        q = LL_recovtrace;
        a = LL_recovtrace;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_savemod LITERAL[147]
        q = LL_savemod;
        a = LL_savemod;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_setmod LITERAL[148]
        q = LL_setmod;
        a = LL_setmod;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_recovmod LITERAL[149]
        q = LL_recovmod;
        a = LL_recovmod;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_saveprec LITERAL[150]
        q = LL_saveprec;
        a = LL_saveprec;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_setprec LITERAL[151]
        q = LL_setprec;
        a = LL_setprec;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_recovprec LITERAL[152]
        q = LL_recovprec;
        a = LL_recovprec;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wargchk LITERAL[153]
        q = LL_Wargchk;
        a = LL_Wargchk;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wnoargchk LITERAL[154]
        q = LL_Wnoargchk;
        a = LL_Wnoargchk;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wstcomp LITERAL[155]
        q = LL_Wstcomp;
        a = LL_Wstcomp;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wuncomp LITERAL[156]
        q = LL_Wuncomp;
        a = LL_Wuncomp;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsttrace LITERAL[157]
        q = LL_Wsttrace;
        a = LL_Wsttrace;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wuntrace LITERAL[158]
        q = LL_Wuntrace;
        a = LL_Wuntrace;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wmodulo LITERAL[159]
        q = LL_Wmodulo;
        a = LL_Wmodulo;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wappcomp LITERAL[160]
        q = LL_Wappcomp;
        a = LL_Wappcomp;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wtype LITERAL[161]
        q = LL_Wtype;
        a = LL_Wtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wtype;
#define LL_type LITERAL[162]
        a = LL_type;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Widtype LITERAL[163]
        q = LL_Widtype;
        a = LL_Widtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Widtype;
#define LL_idtype LITERAL[164]
        a = LL_idtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wexprtype LITERAL[165]
        q = LL_Wexprtype;
        a = LL_Wexprtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wexprtype;
#define LL_exprtype LITERAL[166]
        a = LL_exprtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wbnumtype LITERAL[167]
        q = LL_Wbnumtype;
#define LL_Wnumtype LITERAL[168]
        a = LL_Wnumtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wbnumtype;
#define LL_numtype LITERAL[169]
        a = LL_numtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wbnumtype;
        a = LL_Wbnumtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wbnumtype;
#define LL_bnumtype LITERAL[170]
        a = LL_bnumtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wcanotype LITERAL[171]
        q = LL_Wcanotype;
        a = LL_Wcanotype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wcanotype;
#define LL_canotype LITERAL[172]
        a = LL_canotype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wreal LITERAL[173]
        q = LL_Wreal;
        a = LL_Wreal;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wcoeftype LITERAL[174]
        q = LL_Wcoeftype;
        a = LL_Wcoeftype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wcoeftype;
#define LL_coeftype LITERAL[175]
        a = LL_coeftype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wcoeftype;
#define LL_Wcoefftype LITERAL[176]
        a = LL_Wcoefftype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wcoeftype;
#define LL_coefftype LITERAL[177]
        a = LL_coefftype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wncoeftype LITERAL[178]
        q = LL_Wncoeftype;
        a = LL_Wncoeftype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wncoeftype;
#define LL_ncoeftype LITERAL[179]
        a = LL_ncoeftype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wncoeftype;
#define LL_Wncoefftype LITERAL[180]
        a = LL_Wncoefftype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wncoeftype;
#define LL_ncoefftype LITERAL[181]
        a = LL_ncoefftype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_WoverZ LITERAL[182]
        q = LL_WoverZ;
        a = LL_WoverZ;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_WoverQ LITERAL[183]
        q = LL_WoverQ;
        a = LL_WoverQ;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_WoverA LITERAL[184]
        q = LL_WoverA;
        a = LL_WoverA;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_WoverR LITERAL[185]
        q = LL_WoverR;
        a = LL_WoverR;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_WoverF LITERAL[186]
        q = LL_WoverF;
        a = LL_WoverF;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_WoverC LITERAL[187]
        q = LL_WoverC;
        a = LL_WoverC;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wexactcoef LITERAL[188]
        q = LL_Wexactcoef;
        a = LL_Wexactcoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wapproxcoef LITERAL[189]
        q = LL_Wapproxcoef;
        a = LL_Wapproxcoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsinglevar LITERAL[190]
        q = LL_Wsinglevar;
#define LL_Wsingvar LITERAL[191]
        a = LL_Wsingvar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wsinglevar;
        a = LL_Wsinglevar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsinglepow LITERAL[192]
        q = LL_Wsinglepow;
#define LL_Wsingpow LITERAL[193]
        a = LL_Wsingpow;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wsinglepow;
        a = LL_Wsinglepow;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wunivar LITERAL[194]
        q = LL_Wunivar;
        a = LL_Wunivar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wunivar;
#define LL_Wunivariate LITERAL[195]
        a = LL_Wunivariate;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wlinearpol LITERAL[196]
        q = LL_Wlinearpol;
#define LL_Wlinpol LITERAL[197]
        a = LL_Wlinpol;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wlinearpol;
        a = LL_Wlinearpol;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
#define LL_argchk LITERAL[198]
        m = LL_argchk;
#define LL_Wcommute LITERAL[199]
        q = LL_Wcommute;
#define LL_Wcomm LITERAL[200]
        a = LL_Wcomm;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
        q = LL_Wcommute;
        a = LL_Wcommute;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wconst LITERAL[201]
        q = LL_Wconst;
        a = LL_Wconst;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wconst;
#define LL_Wconstant LITERAL[202]
        a = LL_Wconstant;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wequal LITERAL[203]
        q = LL_Wequal;
        a = LL_Wequal;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wfree LITERAL[204]
        q = LL_Wfree;
        a = LL_Wfree;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wtotalfree LITERAL[205]
        q = LL_Wtotalfree;
        a = LL_Wtotalfree;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wmonomial LITERAL[206]
        q = LL_Wmonomial;
#define LL_Wmono LITERAL[207]
        a = LL_Wmono;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wmonomial;
        a = LL_Wmonomial;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wmonomial;
#define LL_Wpowprod LITERAL[208]
        a = LL_Wpowprod;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wmonomial;
#define LL_Wpowerprod LITERAL[209]
        a = LL_Wpowerprod;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsametype LITERAL[210]
        q = LL_Wsametype;
        a = LL_Wsametype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsingleid LITERAL[211]
        q = LL_Wsingleid;
#define LL_Wsingid LITERAL[212]
        a = LL_Wsingid;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wsingleid;
        a = LL_Wsingleid;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsinglefunc LITERAL[213]
        q = LL_Wsinglefunc;
#define LL_Wsingfunc LITERAL[214]
        a = LL_Wsingfunc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wsinglefunc;
        a = LL_Wsinglefunc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsingleterm LITERAL[215]
        q = LL_Wsingleterm;
#define LL_Wsingterm LITERAL[216]
        a = LL_Wsingterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wsingleterm;
        a = LL_Wsingleterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wformtype LITERAL[217]
        q = LL_Wformtype;
        a = LL_Wformtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wformtype;
#define LL_formtype LITERAL[218]
        a = LL_formtype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Welmttype LITERAL[219]
        q = LL_Welmttype;
        a = LL_Welmttype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Welmttype;
#define LL_elmttype LITERAL[220]
        a = LL_elmttype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Welmttype;
#define LL_Weltype LITERAL[221]
        a = LL_Weltype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Welmttype;
#define LL_eltype LITERAL[222]
        a = LL_eltype;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wsize LITERAL[223]
        q = LL_Wsize;
        a = LL_Wsize;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wsize;
#define LL_size LITERAL[224]
        a = LL_size;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wtotalsize LITERAL[225]
        q = LL_Wtotalsize;
        a = LL_Wtotalsize;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wtotalsize;
#define LL_totalsize LITERAL[226]
        a = LL_totalsize;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Warraysize LITERAL[227]
        q = LL_Warraysize;
        a = LL_Warraysize;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Warraysize;
#define LL_arraysize LITERAL[228]
        a = LL_arraysize;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Wformsize LITERAL[229]
        q = LL_Wformsize;
        a = LL_Wformsize;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Wformsize;
#define LL_formsize LITERAL[230]
        a = LL_formsize;
        a = CC_defcommand(a, q, m, arg4);
        return 1;
    }
}
Sex LITERAL[232];

const  char *bsques_literal_string[232] =
{
/* 0 */
"!*noargchk",
/* 1 */
"sttrac",
/* 2 */
"!*tracmode",
/* 3 */
"untrac",
/* 4 */
"stcomp",
/* 5 */
"!*compmode",
/* 6 */
"uncomp",
/* 7 */
"!*mod",
/* 8 */
"!!gid",
/* 9 */
"\"IDTYPE\"",
/* 10 */
"!*temporal",
/* 11 */
"num",
/* 12 */
"! num",
/* 13 */
"var",
/* 14 */
"! var",
/* 15 */
"func",
/* 16 */
"! func",
/* 17 */
"symbol",
/* 18 */
"! symbol",
/* 19 */
"! cons",
/* 20 */
"! bnum",
/* 21 */
"! string",
/* 22 */
"!#maxcano!#",
/* 23 */
"! cano",
/* 24 */
"! form",
/* 25 */
"! array",
/* 26 */
"!!ctype!!",
/* 27 */
"rat",
/* 28 */
"! pref",
/* 29 */
"set",
/* 30 */
"! setexpr",
/* 31 */
"rel",
/* 32 */
"! relexpr",
/* 33 */
"log",
/* 34 */
"! logexpr",
/* 35 */
"\"EXPRTYPE\"",
/* 36 */
"\"BNUMTYPE\"",
/* 37 */
"! int",
/* 38 */
"! ratn",
/* 39 */
"! float",
/* 40 */
"! compl",
/* 41 */
"! efloat",
/* 42 */
"! ecompl",
/* 43 */
"\"UNDEFINED NUMERIC TYPE\"",
/* 44 */
"!#poly!#",
/* 45 */
"tran",
/* 46 */
"! tran",
/* 47 */
"! poly",
/* 48 */
"!#algn!#",
/* 49 */
"! algn",
/* 50 */
"!#ratf!#",
/* 51 */
"! ratf",
/* 52 */
"!#algf!#",
/* 53 */
"! algf",
/* 54 */
"\"CANOTYPE\"",
/* 55 */
"!*chkcoef",
/* 56 */
"! Z",
/* 57 */
"! Q",
/* 58 */
"! A",
/* 59 */
"! F",
/* 60 */
"! C",
/* 61 */
"chknum!:exact",
/* 62 */
"stop",
/* 63 */
"\"NOT YET !!!!\"",
/* 64 */
"uncom",
/* 65 */
"c!+",
/* 66 */
"c!*",
/* 67 */
"\"?CONST\"",
/* 68 */
"\"<FORM> IS INVALID FOR\"",
/* 69 */
"nc!*",
/* 70 */
"\"INVALID ARGUMENT FOR\"",
/* 71 */
"\"?DEPENDVAR\"",
/* 72 */
"\"ARGUMENT IS NOT <GAL-ID>\"",
/* 73 */
"! invalid",
/* 74 */
"\"?FREE\"",
/* 75 */
"\"SECOND ARG. MUST BE <VAR/FUNC>\"",
/* 76 */
"!#maxform!#",
/* 77 */
"(c!* nc!*)",
/* 78 */
"\"FIRST ARG. MUST BE <RAT-EXPR>\"",
/* 79 */
"\"?TOTALFREE\"",
/* 80 */
"\"?MONOMIAL\"",
/* 81 */
"\"?SINGLETERM\"",
/* 82 */
"!#matx!#",
/* 83 */
"! matx",
/* 84 */
"!#vect!#",
/* 85 */
"! vect",
/* 86 */
"!#tens!#",
/* 87 */
"! tens",
/* 88 */
"\"FORMTYPE\"",
/* 89 */
"(!!set !!oset)",
/* 90 */
"\"ELMTTYPE\"",
/* 91 */
"\"SIZE\"",
/* 92 */
"\"TOTALSIZE\"",
/* 93 */
"!!oset",
/* 94 */
"!!argtype",
/* 95 */
"argxy1",
/* 96 */
"(r!= r!-!>)",
/* 97 */
"(argx2 argx2n)",
/* 98 */
"!!index",
/* 99 */
"(arg1 arg2 argn)",
/* 100 */
"r!=",
/* 101 */
"(lisp)",
/* 102 */
"!?num",
/* 103 */
"!?var",
/* 104 */
"!?func",
/* 105 */
"!?symbol",
/* 106 */
"!?array",
/* 107 */
"!?nil",
/* 108 */
"!?uncom",
/* 109 */
"!?indxed",
/* 110 */
"!?dummy",
/* 111 */
"!?cvar",
/* 112 */
"!?ncvar",
/* 113 */
"!?ncfunc",
/* 114 */
"!?pfunc",
/* 115 */
"!?tfunc",
/* 116 */
"!?oper",
/* 117 */
"!?bnum",
/* 118 */
"!?cano",
/* 119 */
"!?pref",
/* 120 */
"!?form",
/* 121 */
"!?ratexpr",
/* 122 */
"!?setexpr",
/* 123 */
"!?relexpr",
/* 124 */
"!?logexpr",
/* 125 */
"!?algn",
/* 126 */
"!?algnum",
/* 127 */
"!?tran",
/* 128 */
"!?tranum",
/* 129 */
"!?poly",
/* 130 */
"!?algf",
/* 131 */
"!?algfun",
/* 132 */
"!?ratf",
/* 133 */
"!?ratfun",
/* 134 */
"!?vect",
/* 135 */
"!?vector",
/* 136 */
"!?matx",
/* 137 */
"!?matrix",
/* 138 */
"!?tens",
/* 139 */
"!?tensor",
/* 140 */
"!?set",
/* 141 */
"!?oset",
/* 142 */
"!?ordset",
/* 143 */
"killargchk",
/* 144 */
"recovargchk",
/* 145 */
"killtrace",
/* 146 */
"recovtrace",
/* 147 */
"savemod",
/* 148 */
"setmod",
/* 149 */
"recovmod",
/* 150 */
"saveprec",
/* 151 */
"setprec",
/* 152 */
"recovprec",
/* 153 */
"!?argchk",
/* 154 */
"!?noargchk",
/* 155 */
"!?stcomp",
/* 156 */
"!?uncomp",
/* 157 */
"!?sttrace",
/* 158 */
"!?untrace",
/* 159 */
"!?modulo",
/* 160 */
"!?appcomp",
/* 161 */
"!?type",
/* 162 */
"type",
/* 163 */
"!?idtype",
/* 164 */
"idtype",
/* 165 */
"!?exprtype",
/* 166 */
"exprtype",
/* 167 */
"!?bnumtype",
/* 168 */
"!?numtype",
/* 169 */
"numtype",
/* 170 */
"bnumtype",
/* 171 */
"!?canotype",
/* 172 */
"canotype",
/* 173 */
"!?real",
/* 174 */
"!?coeftype",
/* 175 */
"coeftype",
/* 176 */
"!?coefftype",
/* 177 */
"coefftype",
/* 178 */
"!?ncoeftype",
/* 179 */
"ncoeftype",
/* 180 */
"!?ncoefftype",
/* 181 */
"ncoefftype",
/* 182 */
"!?overZ",
/* 183 */
"!?overQ",
/* 184 */
"!?overA",
/* 185 */
"!?overR",
/* 186 */
"!?overF",
/* 187 */
"!?overC",
/* 188 */
"!?exactcoef",
/* 189 */
"!?approxcoef",
/* 190 */
"!?singlevar",
/* 191 */
"!?singvar",
/* 192 */
"!?singlepow",
/* 193 */
"!?singpow",
/* 194 */
"!?univar",
/* 195 */
"!?univariate",
/* 196 */
"!?linearpol",
/* 197 */
"!?linpol",
/* 198 */
"argchk",
/* 199 */
"!?commute",
/* 200 */
"!?comm",
/* 201 */
"!?const",
/* 202 */
"!?constant",
/* 203 */
"!?equal",
/* 204 */
"!?free",
/* 205 */
"!?totalfree",
/* 206 */
"!?monomial",
/* 207 */
"!?mono",
/* 208 */
"!?powprod",
/* 209 */
"!?powerprod",
/* 210 */
"!?sametype",
/* 211 */
"!?singleid",
/* 212 */
"!?singid",
/* 213 */
"!?singlefunc",
/* 214 */
"!?singfunc",
/* 215 */
"!?singleterm",
/* 216 */
"!?singterm",
/* 217 */
"!?formtype",
/* 218 */
"formtype",
/* 219 */
"!?elmttype",
/* 220 */
"elmttype",
/* 221 */
"!?eltype",
/* 222 */
"eltype",
/* 223 */
"!?size",
/* 224 */
"size",
/* 225 */
"!?totalsize",
/* 226 */
"totalsize",
/* 227 */
"!?arraysize",
/* 228 */
"arraysize",
/* 229 */
"!?formsize",
/* 230 */
"formsize",
/* 231 */ NULL
};
setup_type const bsques_g_setup[] =
{
    {"?sametype:form", (lisp_proc *)CC_WsametypeTform, 2},
    {"?sametype:idany", (lisp_proc *)CC_WsametypeTidany, 2},
    {"?sametype:id", (lisp_proc *)CC_WsametypeTid, 2},
    {"?free:bpol", (lisp_proc *)CC_WfreeTbpol, 3},
    {"?free:c+", (lisp_proc *)CC_WfreeTcL, 3},
    {"?free:c2*", (lisp_proc *)CC_WfreeTc2H, 3},
    {"?free:form", (lisp_proc *)CC_WfreeTform, 3},
    {"?free:pref", (lisp_proc *)CC_WfreeTpref, 3},
    {"?free:cano", (lisp_proc *)CC_WfreeTcano, 3},
    {"?free:pfunc", (lisp_proc *)CC_WfreeTpfunc, 3},
    {"?free:func", (lisp_proc *)CC_WfreeTfunc, 3},
    {"?free:id", (lisp_proc *)CC_WfreeTid, 3},
    {"?sterm:bpol", (lisp_proc *)CC_WstermTbpol, 1},
    {"?spow:bpol", (lisp_proc *)CC_WspowTbpol, 1},
    {"?svar:bpol", (lisp_proc *)CC_WsvarTbpol, 1},
    {"?mono:bc*", (lisp_proc *)CC_WmonoTbcH, 1},
    {"?mono:bpol", (lisp_proc *)CC_WmonoTbpol, 1},
    {"?const:c*", (lisp_proc *)CC_WconstTcH, 1},
    {"?const:cano", (lisp_proc *)CC_WconstTcano, 1},
    {"?comm:c+", (lisp_proc *)CC_WcommTcL, 1},
    {"?equal:pfunc", (lisp_proc *)CC_WequalTpfunc, 3},
    {"?formsize", (lisp_proc *)CC_Wformsize, 1},
    {"?arraysize", (lisp_proc *)CC_Warraysize, 1},
    {"?totalsize", (lisp_proc *)CC_Wtotalsize, 1},
    {"?size", (lisp_proc *)CC_Wsize, 1},
    {"eltype:form", (lisp_proc *)CC_eltypeTform, 1},
    {"?elmttype", (lisp_proc *)CC_Welmttype, 1},
    {"?formtype", (lisp_proc *)CC_Wformtype, 1},
    {"?singleterm", (lisp_proc *)CC_Wsingleterm, 1},
    {"?singlefunc", (lisp_proc *)CC_Wsinglefunc, 1},
    {"?singleid", (lisp_proc *)CC_Wsingleid, 1},
    {"?sametype", (lisp_proc *)CC_Wsametype, 2},
    {"?monopol3", (lisp_proc *)CC_Wmonopol3, 1},
    {"?monomial", (lisp_proc *)CC_Wmonomial, 1},
    {"?free*", (lisp_proc *)CC_WfreeH, 3},
    {"?totalfree", (lisp_proc *)CC_Wtotalfree, 2},
    {"?free", (lisp_proc *)CC_Wfree, 2},
    {"?equal1", (lisp_proc *)CC_Wequal1, 3},
    {"?partequal", (lisp_proc *)CC_Wpartequal, 2},
    {"?equal", (lisp_proc *)CC_Wequal, 2},
    {"?dependvar", (lisp_proc *)CC_Wdependvar, 1},
    {"?const", (lisp_proc *)CC_Wconst, 1},
    {"?commute", (lisp_proc *)CC_Wcommute, 2},
    {"?linpol:bpol", (lisp_proc *)CC_WlinpolTbpol, 1},
    {"?linearpol", (lisp_proc *)CC_Wlinearpol, 1},
    {"?univar", (lisp_proc *)CC_Wunivar, 1},
    {"?singlepow", (lisp_proc *)CC_Wsinglepow, 1},
    {"?singlevar", (lisp_proc *)CC_Wsinglevar, 1},
    {"ncoftyp:bpol", (lisp_proc *)CC_ncoftypTbpol, 2},
    {"coftyp:bpol", (lisp_proc *)CC_coftypTbpol, 2},
    {"chknum:approx", (lisp_proc *)CC_chknumTapprox, 1},
    {"chknum:exact", (lisp_proc *)CC_chknumTexact, 1},
    {"?approxcoef", (lisp_proc *)CC_Wapproxcoef, 1},
    {"?exactcoef", (lisp_proc *)CC_Wexactcoef, 1},
    {"?overC", (lisp_proc *)CC_WoverC, 1},
    {"?overF", (lisp_proc *)CC_WoverF, 1},
    {"?overR", (lisp_proc *)CC_WoverR, 1},
    {"?overA", (lisp_proc *)CC_WoverA, 1},
    {"?overQ", (lisp_proc *)CC_WoverQ, 1},
    {"?overZ", (lisp_proc *)CC_WoverZ, 1},
    {"?real", (lisp_proc *)CC_Wreal, 1},
    {"?ncoeftype", (lisp_proc *)CC_Wncoeftype, 1},
    {"?coeftype", (lisp_proc *)CC_Wcoeftype, 1},
    {"?canotype", (lisp_proc *)CC_Wcanotype, 1},
    {"?bnumtype", (lisp_proc *)CC_Wbnumtype, 1},
    {"?exprtype", (lisp_proc *)CC_Wexprtype, 1},
    {"?idtype", (lisp_proc *)CC_Widtype, 1},
    {"?type", (lisp_proc *)CC_Wtype, 1},
    {"?modulo", (lisp_proc *)CC_Wmodulo, 0},
    {"?uncomp", (lisp_proc *)CC_Wuncomp, 0},
    {"?stcomp", (lisp_proc *)CC_Wstcomp, 0},
    {"?untrace", (lisp_proc *)CC_Wuntrace, 0},
    {"?sttrace", (lisp_proc *)CC_Wsttrace, 0},
    {"?argchk", (lisp_proc *)CC_Wargchk, 0},
    {"?noargchk", (lisp_proc *)CC_Wnoargchk, 0},
    {NULL, NULL, 0 }
};

