#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_bswrit.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex bswrit_literal_vector[];
const char *bswrit_literal_string[];
setup_type const  bswrit_g_setup[];
#define LITERAL bswrit_literal_vector




Sex CC_gggprintH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    a = CC_convTsexpr2gexpr(a);
    q = w1;
    CC_galprintH(a, q);
    {
        popv(1);
        return  Lterpri();
    }
}

Sex CC_gprintH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Hprinmode LITERAL[0]
    a = value(LL_Hprinmode);
#define LL_nat LITERAL[1]
    if(a != LL_nat) goto    G0005;
    a = w1;
    {
        popv(1);
        return  CC_natprintH(a, q);
    }
   G0005:
#define LL_flat LITERAL[2]
    if(a != LL_flat) goto    G0006;
    a = w1;
    {
        popv(1);
        return  CC_flatprintH(a, q);
    }
   G0006:
#define LL_pret LITERAL[3]
    if(a != LL_pret) goto    G0007;
    a = w1;
    {
        popv(1);
        return  CC_pretprintH(a, q);
    }
   G0007:
    a = w1;
    {
        popv(1);
        return  CC_listprintH(a, q);
    }
}

Sex CC_natprintH(Sex a, Sex q)
{
    {
        return  CC_flatprintH(a, q);
    }
}

Sex CC_flatprintH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w3 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    a = q;
    if(a == nil) goto    G0023;
   G0017:
    a = car(w2);
    w3 = a;
    if(!is_symbol(a)) goto    G0019;
    Lprinc(a);
    goto    G0021;
   G0019:
    a = car(a);
    a = CC_Widtype(a);
#define LL_Avar LITERAL[4]
    if(a != LL_Avar) goto    G0020;
    a = w3;
    CC_fprinTxvar(a);
    goto    G0021;
   G0020:
    a = w3;
    CC_fprinTfunc(a);
   G0021:
    a = LITERAL[5];
    Lprinc(a);
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0017;
   G0023:
    a = w1;
    if(is_cons(a)) goto    G0025;
    a = CC_Warray(a);
    if(a == nil) goto    G0027;
#define LL_Bgid LITERAL[6]
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w4 = a;
    if(a == nil) goto    G0027;
    a = CC_convTsexpr2gexpr(a);
    q = w1;
    goto    G0045;
   G0027:
    a = w1;
    Lprinc(a);
    goto    G0044;
   G0025:
    a = car(a);
    if(!is_vector(a)) goto    G0036;
    a = LITERAL[7];
    Lprinc(a);
    Lterpri();
    Lterpri();
    q = w3;
    a = w1;
   G0045:
    CC_fprinTarray(a, q);
    goto    G0044;
   G0036:
    if(!is_symbol(a)) goto    G0037;
#define LL_BctypeB LITERAL[8]
    q = LL_BctypeB;
    a = Lget(a, q);
    w4 = a;
#define LL_rat LITERAL[9]
    if(a != LL_rat) goto    G0039;
    a = w1;
    CC_fprinTrat(a);
    goto    G0044;
   G0039:
#define LL_rel LITERAL[10]
    if(a != LL_rel) goto    G0040;
    a = w1;
    CC_fprinTrel(a);
    goto    G0044;
   G0040:
#define LL_set LITERAL[11]
    if(a != LL_set) goto    G0041;
    q = nil;
    a = w1;
    CC_fprinTset(a, q);
    goto    G0044;
   G0041:
    a = w1;
    CC_fprinTlog(a);
    goto    G0044;
   G0037:
#define LL_CmaxcanoC LITERAL[12]
    if(a >= value(LL_CmaxcanoC)) goto    G0043;
    q = true;
    a = w1;
    CC_fprinTcano(a, q);
    goto    G0044;
   G0043:
    q = w3;
    a = w1;
    CC_fprinTform(a, q);
   G0044:
    Lterpri();
    a = nil;
    popv(4);
    return a;
}

Sex CC_listprintH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w3 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    a = q;
    if(a == nil) goto    G0057;
   G0052:
    a = car(w2);
    w3 = a;
    if(!is_symbol(a)) goto    G0054;
    Lprinc(a);
    goto    G0055;
   G0054:
    CC_fprinTfunc(a);
   G0055:
    a = LITERAL[5];
    Lprinc(a);
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0052;
   G0057:
    a = w1;
    if(is_cons(a)) goto    G0059;
    a = CC_Warray(a);
    if(a == nil) goto    G0061;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w4 = a;
    if(a == nil) goto    G0061;
    a = CC_convTsexpr2gexpr(a);
    q = w1;
    goto    G0079;
   G0061:
    a = w1;
    Lprinc(a);
    goto    G0078;
   G0059:
    a = car(a);
    if(!is_vector(a)) goto    G0070;
    a = LITERAL[7];
    Lprinc(a);
    Lterpri();
    Lterpri();
    q = w3;
    a = w1;
   G0079:
    CC_fprinTarray(a, q);
    goto    G0078;
   G0070:
    if(!is_symbol(a)) goto    G0071;
    q = LL_BctypeB;
    a = Lget(a, q);
    w4 = a;
    if(a != LL_rat) goto    G0073;
    a = w1;
    CC_lprinTrat(a);
    goto    G0078;
   G0073:
    if(a != LL_rel) goto    G0074;
    a = w1;
    CC_lprinTrel(a);
    goto    G0078;
   G0074:
    if(a != LL_set) goto    G0075;
    q = nil;
    a = w1;
    CC_lprinTset(a, q);
    goto    G0078;
   G0075:
    a = w1;
    CC_fprinTlog(a);
    goto    G0078;
   G0071:
    if(a >= value(LL_CmaxcanoC)) goto    G0077;
    q = true;
    a = w1;
    CC_lprinTcano(a, q);
    goto    G0078;
   G0077:
    q = w3;
    a = w1;
    CC_fprinTform(a, q);
   G0078:
    Lterpri();
    Lterpri();
    a = nil;
    popv(4);
    return a;
}

Sex CC_fprinH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0083;
    {
        popv(2);
        return  Lprinc(a);
    }
   G0083:
    a = car(a);
    if(!is_integer(a)) goto    G0088;
    q = true;
    a = w1;
    {
        popv(2);
        return  CC_fprinTcano(a, q);
    }
   G0088:
    q = LL_BctypeB;
    a = Lget(a, q);
#define LL_Htemporal LITERAL[13]
    value(LL_Htemporal) = a;
    if(a != LL_rat) goto    G0089;
    a = w1;
    {
        popv(2);
        return  CC_fprinTrat(a);
    }
   G0089:
    if(a != LL_rel) goto    G0090;
    a = w1;
    {
        popv(2);
        return  CC_fprinTrel(a);
    }
   G0090:
    if(a != LL_set) goto    G0091;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_fprinTset(a, q);
    }
   G0091:
#define LL_log LITERAL[14]
    if(a != LL_log) goto    G0092;
    a = w1;
    {
        popv(2);
        return  CC_fprinTlog(a);
    }
   G0092:
    a = car(w1);
    a = CC_Widtype(a);
    if(a != LL_Avar) goto    G0093;
    a = w1;
    {
        popv(2);
        return  CC_fprinTxvar(a);
    }
   G0093:
    a = w1;
    {
        popv(2);
        return  CC_fprinTfunc(a);
    }
}

Sex CC_lprinH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0098;
    {
        popv(2);
        return  Lprinc(a);
    }
   G0098:
    a = car(a);
    if(!is_integer(a)) goto    G0103;
    q = true;
    a = w1;
    {
        popv(2);
        return  CC_lprinTcano(a, q);
    }
   G0103:
    q = LL_BctypeB;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a != LL_rat) goto    G0104;
    a = w1;
    {
        popv(2);
        return  CC_lprinTrat(a);
    }
   G0104:
    if(a != LL_rel) goto    G0105;
    a = w1;
    {
        popv(2);
        return  CC_lprinTrel(a);
    }
   G0105:
    if(a != LL_set) goto    G0106;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_lprinTset(a, q);
    }
   G0106:
    if(a != LL_log) goto    G0107;
    a = w1;
    {
        popv(2);
        return  CC_fprinTlog(a);
    }
   G0107:
    a = car(w1);
    a = CC_Widtype(a);
    if(a != LL_Avar) goto    G0108;
    a = w1;
    {
        popv(2);
        return  CC_fprinTxvar(a);
    }
   G0108:
    a = w1;
    {
        popv(2);
        return  CC_fprinTfunc(a);
    }
}

Sex CC_msgTpoly(Sex a)
{
    Sex q, m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(!is_number(a)) goto    G0113;
    Lprin(a);
    goto    G0118;
   G0113:
    a = CC_Cterms(a);
    value(LL_Htemporal) = a;
    q = mkfxat(10);
    a = Llessp(a, q);
    if(a == nil) goto    G0114;
    m = nil;
    q = nil;
    a = cdr(w1);
    CC_fprinTbpol(a, q, m);
   G0118:
    {
        popv(2);
        return  Lterpri();
    }
   G0114:
    w2 = nil;
    q = mkfxat(-5);
    a = value(LL_Htemporal);
    a = plus2(a, q);
    w2 = a;
    a = mkfxat(0);
#define LL_Hchkcoef LITERAL[15]
    value(LL_Hchkcoef) = a;
    arg4 = mkfxat(5);
    m = nil;
    q = nil;
    a = cdr(w1);
    CC_cutprinTbpol(a, q, m, arg4);
    a = LITERAL[16];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = LITERAL[17];
    Lprinc(a);
    Lterpri();
    a = nil;
    popv(2);
    return a;
}

Sex CC_fprinTlog(Sex a)
{
    {
        return  Lprint(a);
    }
}

Sex CC_fprinTrel(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = true;
    a = car(cdr(a));
    CC_fprinH(a, q);
    a = LITERAL[18];
    Lprinc(a);
    a = car(w1);
    CC_fprinTcons(a);
    a = LITERAL[18];
    Lprinc(a);
    q = true;
    a = car(cdr(cdr(w1)));
    CC_fprinH(a, q);
    a = nil;
    popv(1);
    return a;
}

Sex CC_fprinTcons(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = Lexplode(a);
    w3 = a;
    w2 = a;
    w4 = nil;
   G0129:
    a = w3;
    if(a == nil) goto    G0128;
    q = CHAR_OF(33);
    a = car(cdr(a));
    a = Lneq(a, q);
    if(a == nil) goto    G0133;
    a = cdr(w3);
    w3 = a;
    goto    G0134;
   G0133:
    q = cdr(cdr(w3));
    a = w3;
    cdr(a) = q;
   G0134:
    w4 = a;
    goto    G0129;
   G0128:
    w4 = nil;
    a = cdr(w2);
    goto    G0136;
   G0135:
    w5 = a;
    a = car(a);
    a = Lprinc(a);
    q = w4;
    a = cons(a, q);
    w4 = a;
    a = cdr(w5);
   G0136:
    if(a != nil) goto    G0135;
    a = w4;
    a = Lnreverse(a);
    a = nil;
    popv(5);
    return a;
}

Sex CC_fprinTset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G0142;
    a = LITERAL[19];
    {
        popv(3);
        return  Lprinc(a);
    }
   G0142:
    w3 = nil;
    a = car(w1);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    w2 = q;
    a = w3;
#define LL_Bset LITERAL[20]
    if(a != LL_Bset) goto    G0147;
#define LL_RlbraceS LITERAL[21]
    a = value(LL_RlbraceS);
    goto    G0148;
   G0147:
#define LL_RlbracketS LITERAL[22]
    a = value(LL_RlbracketS);
   G0148:
    Lprinc(a);
#define LL_RblankS LITERAL[23]
    a = value(LL_RblankS);
    Lprinc(a);
   G0145:
    q = true;
    a = car(w1);
    CC_fprinH(a, q);
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0151;
    a = LITERAL[24];
    Lprinc(a);
    goto    G0145;
   G0151:
    a = value(LL_RblankS);
    Lprinc(a);
    a = w3;
    if(a != LL_Bset) goto    G0153;
#define LL_RrbraceS LITERAL[25]
    a = value(LL_RrbraceS);
    goto    G0154;
   G0153:
#define LL_RrbracketS LITERAL[26]
    a = value(LL_RrbracketS);
   G0154:
    Lprinc(a);
    a = w2;
    if(a != nil) goto    G0157;
    Lterpri();
   G0157:
    a = nil;
    popv(3);
    return a;
}

Sex CC_fprinTarray(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    a = q;
    if(a != nil) goto    G0167;
    a = CHAR_OF(37);
    w2 = a;
   G0167:
    a = car(w1);
    w3 = a;
    a = cdr(cdr(w1));
    w5 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w6 = a;
    w4 = a;
    a = w5;
    w7 = a;
   G0163:
    a = car(w7);
    a = Lplusp(a);
    if(a == nil) goto    G0169;
    a = mkfxat(1);
    goto    G0197;
   G0169:
    a = mkfxat(-1);
   G0197:
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G0163;
    a = cdr(w4);
    w4 = a;
    q = mkfxat(0);
    a = w3;
    a = Lgetv(a, q);
    a = CC_convTsexpr2gexpr(a);
    w6 = a;
    if(a == nil) goto    G0181;
#define LL_Anil LITERAL[27]
    if(a == LL_Anil) goto    G0181;
    a = w2;
    Lprinc(a);
    a = LITERAL[28];
    Lprinc(a);
    q = true;
    a = w6;
    CC_fprinH(a, q);
    Lterpri();
    Lterpri();
    a = true;
    w9 = a;
   G0181:
    a = car(w5);
    a = Lzerop(a);
    if(a != nil) goto    G0196;
    a = mkfxat(0);
    w8 = a;
   G0184:
    a = w8;
    a = (Sex)((long)a + 0x10);
    w8 = a;
    q = a;
    a = w3;
    a = Lgetv(a, q);
    a = CC_convTsexpr2gexpr(a);
    w6 = a;
    if(a == nil) goto    G0165;
    if(a == LL_Anil) goto    G0165;
    a = w2;
    Lprinc(a);
    a = LITERAL[29];
    Lprinc(a);
    a = car(w4);
    Lprin(a);
    a = true;
    w9 = a;
    a = w4;
    w7 = a;
    w10 = nil;
   G0191:
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G0190;
    a = LITERAL[30];
    Lprinc(a);
    a = car(w7);
    a = Lprin(a);
    w10 = a;
    goto    G0191;
   G0190:
    a = LITERAL[31];
    Lprinc(a);
    q = true;
    a = w6;
    CC_fprinH(a, q);
    Lterpri();
    Lterpri();
   G0165:
    q = w5;
    a = w4;
    a = CC_idxsTadd1(a, q);
    if(a != nil) goto    G0184;
    a = w9;
    if(a != nil) goto    G0196;
    a = LITERAL[32];
    Lprint(a);
   G0196:
    a = nil;
    popv(10);
    return a;
}

Sex CC_fprinTform(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    a = q;
    if(a != nil) goto    G0208;
    a = CHAR_OF(37);
    w2 = a;
   G0208:
    a = car(cdr(w1));
    w3 = a;
    a = cdr(cdr(cdr(w1)));
    w5 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w6 = a;
    w4 = a;
    a = w5;
    w7 = a;
   G0204:
    a = car(w7);
    a = Lplusp(a);
    if(a == nil) goto    G0210;
    a = mkfxat(1);
    goto    G0236;
   G0210:
    a = mkfxat(-1);
   G0236:
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G0204;
    a = cdr(w4);
    w4 = a;
    q = mkfxat(0);
    a = w3;
    a = Lgetv(a, q);
    w6 = a;
    if(a == nil) goto    G0221;
    a = Lzerop(a);
    if(a != nil) goto    G0221;
    a = w2;
    Lprinc(a);
    a = LITERAL[28];
    Lprinc(a);
    q = true;
    a = w6;
    CC_fprinH(a, q);
    Lterpri();
    Lterpri();
    a = true;
    w9 = a;
   G0221:
    a = car(w5);
    a = Lzerop(a);
    if(a != nil) goto    G0235;
    a = mkfxat(0);
    w8 = a;
   G0224:
    a = w8;
    a = (Sex)((long)a + 0x10);
    w8 = a;
    q = a;
    a = w3;
    a = Lgetv(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0206;
    a = w6;
    if(a == LL_Anil) goto    G0206;
    a = w2;
    Lprinc(a);
    a = LITERAL[29];
    Lprinc(a);
    a = car(w4);
    Lprin(a);
    a = true;
    w9 = a;
    a = w4;
    w7 = a;
    w10 = nil;
   G0230:
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G0229;
    a = LITERAL[30];
    Lprinc(a);
    a = car(w7);
    a = Lprin(a);
    w10 = a;
    goto    G0230;
   G0229:
    a = LITERAL[31];
    Lprinc(a);
    q = true;
    a = w6;
    CC_fprinH(a, q);
    Lterpri();
    Lterpri();
   G0206:
    q = w5;
    a = w4;
    a = CC_idxsTadd1(a, q);
    if(a != nil) goto    G0224;
    a = w9;
    if(a != nil) goto    G0235;
    a = LITERAL[33];
    Lprint(a);
   G0235:
    a = nil;
    popv(10);
    return a;
}

Sex CC_fprinTrat(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0241;
    {
        popv(1);
        return  Lprin(a);
    }
   G0241:
    a = car(a);
    if(!is_integer(a)) goto    G0242;
    q = true;
    a = w1;
    {
        popv(1);
        return  CC_fprinTcano(a, q);
    }
   G0242:
#define LL_cL LITERAL[34]
    if(a != LL_cL) goto    G0243;
    a = w1;
    {
        popv(1);
        return  CC_fprinTcL(a);
    }
   G0243:
    a = w1;
    {
        popv(1);
        return  CC_fprinTnccH(a);
    }
}

Sex CC_fprinTcano(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0248;
    {
        popv(6);
        return  Lprin(a);
    }
   G0248:
#define LL_CratfC LITERAL[35]
    if(car(a) >= value(LL_CratfC)) goto    G0249;
    m = nil;
    q = nil;
    a = cdr(a);
    {
        popv(6);
        return  CC_fprinTbpol(a, q, m);
    }
   G0249:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = cdr(a);
    w3 = a;
    a = car(a);
    w4 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G0264;
    a = cdr(w4);
    w5 = a;
    if(!is_number(a)) goto    G0257;
    a = Lminusp(a);
    if(a != nil) goto    G0259;
    a = w5;
    goto    G0285;
   G0259:
    a = LITERAL[36];
    Lprinc(a);
    a = w5;
    a = Lminus(a);
   G0285:
    Lprin(a);
    goto    G0262;
   G0257:
    m = nil;
    q = nil;
    a = cdr(a);
    CC_fprinTbpol(a, q, m);
   G0262:
    a = cdr(w3);
    w3 = a;
    a = true;
    w6 = a;
    goto    G0282;
   G0264:
    a = car(w3);
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(!is_number(a)) goto    G0266;
    a = Lminusp(a);
    if(a == nil) goto    G0269;
    a = w6;
    if(a == nil) goto    G0271;
    a = LITERAL[37];
    Lprinc(a);
    a = w5;
    a = Lminus(a);
    goto    G0287;
   G0271:
    a = LITERAL[36];
    Lprinc(a);
    a = w5;
    a = Lminus(a);
    goto    G0288;
   G0269:
    a = w6;
    if(a == nil) goto    G0275;
    a = LITERAL[38];
    Lprinc(a);
    a = w5;
   G0287:
    Lprin(a);
    goto    G0277;
   G0275:
    a = w5;
   G0288:
    Lprin(a);
    a = true;
    w6 = a;
    goto    G0277;
   G0266:
    a = w6;
    if(a == nil) goto    G0279;
    a = LITERAL[38];
    Lprinc(a);
    goto    G0280;
   G0279:
    a = true;
    w6 = a;
   G0280:
    a = LITERAL[29];
    Lprinc(a);
    m = nil;
    q = nil;
    a = cdr(w5);
    CC_fprinTbpol(a, q, m);
    a = LITERAL[39];
    Lprinc(a);
   G0277:
    a = LITERAL[40];
    Lprinc(a);
    m = nil;
    q = nil;
    a = cdr(car(w4));
    CC_fprinTbpol(a, q, m);
    a = LITERAL[39];
    Lprinc(a);
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0250;
   G0282:
    a = w2;
    if(a == nil) goto    G0264;
    Lterpri();
    Lterpri();
    goto    G0264;
   G0250:
    popv(6);
    return a;
}

Sex CC_fprinTnccH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
   G0292:
    a = w5;
    if(a == nil) goto    G0294;
    a = LITERAL[41];
    Lprinc(a);
    goto    G0295;
   G0294:
    a = true;
    w5 = a;
   G0295:
    a = car(w2);
    w3 = a;
    if(is_cons(a)) goto    G0297;
    if(!is_number(a)) goto    G0319;
    a = Lminusp(a);
    if(a == nil) goto    G0300;
    a = LITERAL[42];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[39];
    goto    G0319;
   G0300:
    a = LITERAL[18];
    Lprinc(a);
    a = w3;
    Lprin(a);
    goto    G0305;
   G0297:
    a = car(a);
    if(!is_integer(a)) goto    G0302;
    a = LITERAL[29];
    Lprinc(a);
    q = nil;
    a = w3;
    CC_fprinTcano(a, q);
    a = LITERAL[39];
    goto    G0319;
   G0302:
#define LL_ncH LITERAL[43]
    if(a != LL_ncH) goto    G0303;
    a = w3;
    CC_fprinTnccH(a);
    goto    G0305;
   G0303:
    if(a != LL_cL) goto    G0304;
    a = LITERAL[29];
    Lprinc(a);
    a = w3;
    CC_fprinTcL(a);
    a = LITERAL[39];
   G0319:
    Lprinc(a);
    goto    G0305;
   G0304:
    a = w3;
    CC_fprinTfunc(a);
   G0305:
    a = car(cdr(w2));
    w4 = a;
    if(!is_number(a)) goto    G0307;
    a = Lminusp(a);
    if(a != nil) goto    G0310;
    a = w4;
    if(!is_rational(a)) goto    G0309;
   G0310:
    a = LITERAL[44];
    Lprinc(a);
    a = w4;
    Lprin(a);
    goto    G0320;
   G0309:
    a = Lonep(a);
    if(a != nil) goto    G0313;
    a = LITERAL[45];
    Lprinc(a);
    a = w4;
    Lprin(a);
    goto    G0313;
   G0307:
    a = LITERAL[44];
    Lprinc(a);
    a = w4;
    CC_fprinTrat(a);
   G0320:
    a = LITERAL[39];
    Lprinc(a);
   G0313:
    a = cdr(cdr(w2));
    w2 = a;
    if(a != nil) goto    G0292;
    popv(5);
    return a;
}

Sex CC_fprinTcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
    a = car(a);
    w3 = a;
    if(!is_number(a)) goto    G0327;
    a = Lminusp(a);
    if(a == nil) goto    G0330;
    a = LITERAL[36];
    Lprinc(a);
    a = w3;
    a = Lminus(a);
    goto    G0360;
   G0330:
    a = w3;
   G0360:
    Lprin(a);
    a = true;
    w5 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    w3 = a;
   G0327:
    a = car(a);
    if(!is_integer(a)) goto    G0324;
    a = w5;
    if(a == nil) goto    G0336;
    a = LITERAL[38];
    Lprinc(a);
    goto    G0337;
   G0336:
    a = true;
    w5 = a;
   G0337:
    a = LITERAL[29];
    Lprinc(a);
    q = nil;
    a = w3;
    CC_fprinTcano(a, q);
    a = LITERAL[39];
    Lprinc(a);
    a = cdr(w2);
    w2 = a;
   G0324:
    a = car(car(w2));
    w3 = a;
    a = cdr(car(w2));
    w4 = a;
    if(!is_cons(a)) goto    G0339;
    a = w5;
    if(a == nil) goto    G0341;
    a = LITERAL[38];
    Lprinc(a);
    goto    G0342;
   G0341:
    a = true;
    w5 = a;
   G0342:
    a = w3;
    CC_fprinTnccH(a);
    a = LITERAL[46];
    Lprinc(a);
    q = true;
    a = w4;
    CC_fprinH(a, q);
    a = LITERAL[39];
    Lprinc(a);
    goto    G0325;
   G0339:
    a = Lminusp(a);
    if(a == nil) goto    G0343;
    a = w4;
    a = Lminus(a);
    w4 = a;
    a = Lonep(a);
    if(a == nil) goto    G0345;
    a = w5;
    if(a == nil) goto    G0348;
    a = LITERAL[37];
    goto    G0364;
   G0348:
    a = LITERAL[36];
    Lprinc(a);
    goto    G0365;
   G0345:
    a = w5;
    if(a == nil) goto    G0350;
    a = LITERAL[37];
    Lprinc(a);
    a = w4;
    Lprin(a);
    goto    G0357;
   G0350:
    a = LITERAL[36];
    Lprinc(a);
    a = w4;
    Lprin(a);
    goto    G0365;
   G0343:
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G0352;
    a = w5;
    if(a == nil) goto    G0365;
    a = LITERAL[38];
    goto    G0364;
   G0352:
    a = w5;
    if(a == nil) goto    G0356;
    a = LITERAL[38];
    Lprinc(a);
    a = w4;
    Lprin(a);
    a = LITERAL[41];
   G0364:
    Lprinc(a);
    goto    G0357;
   G0356:
    a = w4;
    Lprin(a);
   G0365:
    a = true;
    w5 = a;
   G0357:
    a = w3;
    CC_fprinTnccH(a);
   G0325:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0324;
    popv(5);
    return a;
}

Sex CC_fprinTfunc(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    Lprinc(a);
    a = LITERAL[29];
    Lprinc(a);
    a = cdr(w1);
    {
        popv(1);
        return  CC_fprinTargs(a);
    }
}

Sex CC_fprinTargs(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(a == nil) goto    G0389;
   G0374:
    a = car(w1);
    if(is_cons(a)) goto    G0376;
    Lprinc(a);
    goto    G0387;
   G0376:
    a = car(a);
    w2 = a;
    if(!is_integer(a)) goto    G0377;
    q = nil;
    a = car(w1);
    CC_fprinTcano(a, q);
    goto    G0387;
   G0377:
    q = LL_BctypeB;
    a = Lget(a, q);
    w2 = a;
#define LL_gal LITERAL[47]
    if(a != LL_gal) goto    G0378;
    a = cdr(car(w1));
    CC_fprinTargs(a);
    a = LITERAL[29];
    Lprinc(a);
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0389;
    goto    G0374;
   G0378:
    if(a != LL_rat) goto    G0381;
    a = car(car(w1));
    if(a != LL_cL) goto    G0383;
    a = car(w1);
    CC_fprinTcL(a);
    goto    G0387;
   G0383:
    a = car(w1);
    CC_fprinTnccH(a);
    goto    G0387;
   G0381:
    if(a != LL_rel) goto    G0385;
    a = car(w1);
    CC_fprinTrel(a);
    goto    G0387;
   G0385:
    if(a != LL_set) goto    G0386;
    q = true;
    a = car(w1);
    CC_fprinTset(a, q);
    goto    G0387;
   G0386:
    a = car(w1);
    CC_fprinTlog(a);
   G0387:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0389;
    a = LITERAL[30];
    Lprinc(a);
    goto    G0374;
   G0389:
    a = LITERAL[39];
    Lprinc(a);
    a = nil;
    popv(2);
    return a;
}

Sex CC_fprinTcanset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    a = cdr(a);
    w1 = a;
    if(a != nil) goto    G0395;
    a = LITERAL[48];
    goto    G0401;
   G0395:
    a = LITERAL[49];
    Lprinc(a);
    w2 = nil;
   G0398:
    a = cdr(w1);
    if(a == nil) goto    G0402;
    q = true;
    a = car(w1);
    CC_fprinH(a, q);
    a = LITERAL[24];
    Lprinc(a);
    a = cdr(w1);
    w1 = a;
    w2 = a;
    goto    G0398;
   G0402:
    a = w2;
    q = true;
    a = car(w1);
    CC_fprinH(a, q);
    a = LITERAL[50];
   G0401:
    {
        popv(2);
        return  Lprinc(a);
    }
}

Sex CC_fprinTcanordset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    a = cdr(a);
    w1 = a;
    if(a != nil) goto    G0408;
    a = LITERAL[51];
    goto    G0414;
   G0408:
    a = LITERAL[52];
    Lprinc(a);
    w2 = nil;
   G0411:
    a = cdr(w1);
    if(a == nil) goto    G0415;
    q = true;
    a = car(w1);
    CC_fprinH(a, q);
    a = LITERAL[24];
    Lprinc(a);
    a = cdr(w1);
    w1 = a;
    w2 = a;
    goto    G0411;
   G0415:
    a = w2;
    q = true;
    a = car(w1);
    CC_fprinH(a, q);
    a = LITERAL[53];
   G0414:
    {
        popv(2);
        return  Lprinc(a);
    }
}

Sex CC_lprinTset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    a = car(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    w2 = q;
    a = w3;
    if(a != LL_Bset) goto    G0421;
    a = value(LL_RlbraceS);
    goto    G0422;
   G0421:
    a = value(LL_RlbracketS);
   G0422:
    Lprinc(a);
    a = value(LL_RblankS);
    Lprinc(a);
   G0419:
    q = true;
    a = car(w1);
    CC_fprinH(a, q);
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0425;
    a = LITERAL[54];
    Lprinc(a);
    Lterpri();
    a = LITERAL[55];
    Lprinc(a);
    goto    G0419;
   G0425:
    a = value(LL_RblankS);
    Lprinc(a);
    a = w3;
    if(a != LL_Bset) goto    G0427;
    a = value(LL_RrbraceS);
    goto    G0428;
   G0427:
    a = value(LL_RrbracketS);
   G0428:
    Lprinc(a);
    a = w2;
    if(a != nil) goto    G0431;
    Lterpri();
   G0431:
    a = nil;
    popv(3);
    return a;
}

Sex CC_lprinTcano(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(car(a) >= value(LL_CratfC)) goto    G0435;
    m = nil;
    q = nil;
    a = cdr(a);
    {
        popv(6);
        return  CC_lprinTbpol(a, q, m);
    }
   G0435:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
    a = car(a);
    w4 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G0450;
    a = cdr(w4);
    w5 = a;
    if(!is_number(a)) goto    G0443;
    a = Lminusp(a);
    if(a != nil) goto    G0445;
    a = w5;
    goto    G0471;
   G0445:
    a = LITERAL[36];
    Lprinc(a);
    a = w5;
    a = Lminus(a);
   G0471:
    Lprin(a);
    goto    G0448;
   G0443:
    m = nil;
    q = nil;
    a = cdr(a);
    CC_lprinTbpol(a, q, m);
   G0448:
    a = cdr(w3);
    w3 = a;
    a = true;
    w6 = a;
    goto    G0468;
   G0450:
    a = car(w3);
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(!is_number(a)) goto    G0452;
    a = Lminusp(a);
    if(a == nil) goto    G0455;
    a = w6;
    if(a == nil) goto    G0457;
    a = LITERAL[37];
    Lprinc(a);
    a = w5;
    a = Lminus(a);
    goto    G0473;
   G0457:
    a = LITERAL[36];
    Lprinc(a);
    a = w5;
    a = Lminus(a);
    goto    G0474;
   G0455:
    a = w6;
    if(a == nil) goto    G0461;
    a = LITERAL[38];
    Lprinc(a);
    a = w5;
   G0473:
    Lprin(a);
    goto    G0463;
   G0461:
    a = w5;
   G0474:
    Lprin(a);
    a = true;
    w6 = a;
    goto    G0463;
   G0452:
    a = w6;
    if(a == nil) goto    G0465;
    a = LITERAL[38];
    Lprinc(a);
    goto    G0466;
   G0465:
    a = true;
    w6 = a;
   G0466:
    a = LITERAL[29];
    Lprinc(a);
    m = nil;
    q = nil;
    a = cdr(w5);
    CC_lprinTbpol(a, q, m);
    a = LITERAL[39];
    Lprinc(a);
   G0463:
    a = LITERAL[40];
    Lprinc(a);
    m = nil;
    q = nil;
    a = cdr(car(w4));
    CC_lprinTbpol(a, q, m);
    a = LITERAL[39];
    Lprinc(a);
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0436;
   G0468:
    a = w2;
    if(a == nil) goto    G0450;
    Lterpri();
    Lterpri();
    goto    G0450;
   G0436:
    popv(6);
    return a;
}

Sex CC_lprinTbpol(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w1 = a;
    a = car(a);
    w5 = a;
    a = cdr(w1);
    w4 = a;
    w2 = q;
    w3 = m;
#define LL_Hpowser LITERAL[56]
    a = value(LL_Hpowser);
    if(a == nil) goto    G0481;
    q = a;
    a = w5;
    a = Lassoc(a, q);
    if(a == nil) goto    G0481;
    a = w4;
    a = Lreverse(a);
    w4 = a;
   G0481:
    a = car(car(w4));
    w6 = a;
    a = cdr(car(w4));
    w7 = a;
    if(is_number(a)) goto    G0493;
    a = car(a);
    if(!is_integer(a)) goto    G0485;
    a = w3;
    if(a == nil) goto    G0487;
    a = LITERAL[38];
    Lprinc(a);
   G0487:
    a = LITERAL[29];
    Lprinc(a);
    m = nil;
    q = nil;
    a = cdr(w7);
    CC_fprinTbpol(a, q, m);
    a = LITERAL[39];
    Lprinc(a);
    a = w6;
    a = Lzerop(a);
    if(a != nil) goto    G0489;
    q = w2;
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    goto    G0522;
   G0485:
    a = w6;
    a = Lzerop(a);
    if(a == nil) goto    G0495;
    m = w3;
    q = w2;
    goto    G0525;
   G0495:
    q = w2;
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    m = w3;
    q = a;
   G0525:
    a = w7;
    CC_lprinTbpol(a, q, m);
    goto    G0479;
   G0493:
    a = w7;
    a = Lminusp(a);
    if(a == nil) goto    G0500;
    a = w7;
    a = Lminus(a);
    w7 = a;
    a = w3;
    if(a == nil) goto    G0502;
    a = LITERAL[37];
    goto    G0527;
   G0502:
    a = LITERAL[36];
    goto    G0527;
   G0500:
    a = w3;
    if(a == nil) goto    G0504;
    a = LITERAL[38];
   G0527:
    Lprinc(a);
   G0504:
    a = w7;
    a = Lonep(a);
    if(a == nil) goto    G0506;
    a = w6;
    a = Lzerop(a);
    if(a != nil) goto    G0508;
    q = w2;
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    goto    G0529;
   G0508:
    a = w2;
    if(a != nil) goto    G0529;
    a = mkfxat(1);
    Lprin(a);
    goto    G0513;
   G0506:
    a = w7;
    Lprin(a);
    a = w6;
    a = Lzerop(a);
    if(a != nil) goto    G0515;
    q = w2;
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    goto    G0530;
   G0515:
    a = w2;
    if(a == nil) goto    G0517;
   G0530:
    w7 = a;
    goto    G0518;
   G0489:
    a = w2;
    if(a == nil) goto    G0517;
   G0522:
    w7 = a;
    a = LITERAL[41];
    Lprinc(a);
    a = w7;
    CC_fprinTcnterm(a);
   G0517:
    Lterpri();
    goto    G0479;
    a = w7;
   G0518:
   G0529:
    CC_fprinTcnterm(a);
   G0513:
    Lterpri();
   G0479:
    a = true;
    w3 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0481;
    popv(7);
    return a;
}

Sex CC_idxsTadd1(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = cdr(a);
    w2 = q;
    if(a != nil) goto    G0534;
    a = car(w1);
    a = Lplusp(a);
    if(a == nil) goto    G0536;
    a = car(w1);
    a = (Sex)((long)a + 0x10);
    value(LL_Htemporal) = a;
    if(car(w2) >= a) goto    G0550;
    q = mkfxat(1);
    goto    G0557;
   G0536:
    a = car(w1);
    a = (Sex)((long)a - 0x10);
    value(LL_Htemporal) = a;
    if(a >= car(w2)) goto    G0550;
    q = mkfxat(-1);
    goto    G0557;
   G0534:
    q = cdr(q);
    a = CC_idxsTadd1(a, q);
    if(a == nil) goto    G0544;
    a = w1;
    goto    G0552;
   G0544:
    a = car(w1);
    a = Lplusp(a);
    if(a == nil) goto    G0545;
    a = car(w1);
    a = (Sex)((long)a + 0x10);
    value(LL_Htemporal) = a;
    if(car(w2) >= a) goto    G0550;
    q = mkfxat(1);
    goto    G0557;
   G0545:
    a = car(w1);
    a = (Sex)((long)a - 0x10);
    value(LL_Htemporal) = a;
    if(a >= car(w2)) goto    G0550;
    q = mkfxat(-1);
   G0557:
    a = w1;
    car(a) = q;
    a = nil;
    goto    G0552;
   G0550:
    q = a;
    a = w1;
    car(a) = q;
   G0552:
    popv(2);
    return a;
}

Sex CC_fprinTbpol(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w1 = a;
    a = car(a);
    w5 = a;
    a = cdr(w1);
    w4 = a;
    w2 = q;
    w3 = m;
    a = value(LL_Hpowser);
    if(a == nil) goto    G0565;
    q = a;
    a = w5;
    a = Lassoc(a, q);
    if(a == nil) goto    G0565;
    a = w4;
    a = Lreverse(a);
    w4 = a;
   G0565:
    a = car(car(w4));
    w6 = a;
    a = cdr(car(w4));
    w7 = a;
    if(is_number(a)) goto    G0577;
    a = car(a);
    if(!is_integer(a)) goto    G0569;
    a = w3;
    if(a == nil) goto    G0571;
    a = LITERAL[38];
    Lprinc(a);
   G0571:
    a = LITERAL[29];
    Lprinc(a);
    m = nil;
    q = nil;
    a = cdr(w7);
    CC_fprinTbpol(a, q, m);
    a = LITERAL[39];
    Lprinc(a);
    a = w6;
    a = Lzerop(a);
    if(a != nil) goto    G0573;
    q = w2;
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    goto    G0606;
   G0573:
    a = w2;
    if(a == nil) goto    G0597;
   G0606:
    w7 = a;
    a = LITERAL[41];
    Lprinc(a);
    a = w7;
    goto    G0611;
   G0569:
    a = w6;
    a = Lzerop(a);
    if(a == nil) goto    G0579;
    m = w3;
    q = w2;
    goto    G0608;
   G0579:
    q = w2;
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    m = w3;
    q = a;
   G0608:
    a = w7;
    CC_fprinTbpol(a, q, m);
    goto    G0597;
   G0577:
    a = w7;
    a = Lminusp(a);
    if(a == nil) goto    G0584;
    a = w3;
    if(a == nil) goto    G0586;
    a = LITERAL[37];
    goto    G0609;
   G0586:
    a = LITERAL[36];
   G0609:
    Lprinc(a);
    a = w7;
    a = Lminus(a);
    w7 = a;
    goto    G0588;
   G0584:
    a = w3;
    if(a == nil) goto    G0588;
    a = LITERAL[38];
    Lprinc(a);
   G0588:
    a = w7;
    a = Lonep(a);
    if(a == nil) goto    G0590;
    a = w6;
    a = Lzerop(a);
    if(a != nil) goto    G0592;
    q = w2;
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    goto    G0611;
   G0592:
    a = w2;
    if(a != nil) goto    G0611;
    a = mkfxat(1);
    Lprin(a);
    goto    G0597;
   G0590:
    a = w7;
    Lprin(a);
    a = w6;
    a = Lzerop(a);
    if(a != nil) goto    G0599;
    q = w2;
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    goto    G0612;
   G0599:
    a = w2;
    if(a == nil) goto    G0597;
   G0612:
    w7 = a;
    a = w7;
   G0611:
    CC_fprinTcnterm(a);
   G0597:
    a = true;
    w3 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0565;
    popv(7);
    return a;
}

Sex CC_cutprinTbpol(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w1 = a;
    a = car(a);
    w6 = a;
    a = cdr(w1);
    w5 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = value(LL_Hpowser);
    if(a == nil) goto    G0619;
    q = a;
    a = w6;
    a = Lassoc(a, q);
    if(a == nil) goto    G0619;
    a = w5;
    a = Lreverse(a);
    w5 = a;
   G0619:
    a = car(car(w5));
    w7 = a;
    a = cdr(car(w5));
    w8 = a;
    if(is_number(a)) goto    G0631;
    a = car(a);
    if(!is_integer(a)) goto    G0623;
    a = w3;
    if(a == nil) goto    G0625;
    a = LITERAL[38];
    Lprinc(a);
   G0625:
    a = LITERAL[29];
    Lprinc(a);
    m = nil;
    q = nil;
    a = cdr(w8);
    CC_fprinTbpol(a, q, m);
    a = LITERAL[39];
    Lprinc(a);
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G0627;
    q = w2;
    a = w7;
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    goto    G0662;
   G0627:
    a = w2;
    if(a == nil) goto    G0651;
   G0662:
    w8 = a;
    a = LITERAL[41];
    Lprinc(a);
    a = w8;
    CC_fprinTcnterm(a);
    a = value(LL_Hchkcoef);
    a = Ladd1(a);
    value(LL_Hchkcoef) = a;
    goto    G0651;
   G0623:
    a = w7;
    a = Lzerop(a);
    if(a == nil) goto    G0633;
    arg4 = w4;
    m = w3;
    q = w2;
    goto    G0663;
   G0633:
    q = w2;
    a = w7;
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    arg4 = w4;
    m = w3;
    q = a;
   G0663:
    a = w8;
    CC_cutprinTbpol(a, q, m, arg4);
    goto    G0651;
   G0631:
    a = value(LL_Hchkcoef);
    a = Ladd1(a);
    value(LL_Hchkcoef) = a;
    a = w8;
    a = Lminusp(a);
    if(a == nil) goto    G0638;
    a = w3;
    if(a == nil) goto    G0640;
    a = LITERAL[37];
    goto    G0664;
   G0640:
    a = LITERAL[36];
   G0664:
    Lprinc(a);
    a = w8;
    a = Lminus(a);
    w8 = a;
    goto    G0642;
   G0638:
    a = w3;
    if(a == nil) goto    G0642;
    a = LITERAL[38];
    Lprinc(a);
   G0642:
    a = w8;
    a = Lonep(a);
    if(a == nil) goto    G0644;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G0646;
    q = w2;
    a = w7;
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    goto    G0666;
   G0646:
    a = w2;
    if(a != nil) goto    G0666;
    a = mkfxat(1);
    Lprin(a);
    goto    G0651;
   G0644:
    a = w8;
    Lprin(a);
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G0653;
    q = w2;
    a = w7;
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    goto    G0667;
   G0653:
    a = w2;
    if(a == nil) goto    G0651;
   G0667:
    w8 = a;
    a = w8;
   G0666:
    CC_fprinTcnterm(a);
   G0651:
    a = true;
    w3 = a;
    q = w4;
    a = value(LL_Hchkcoef);
    a = Lgeq(a, q);
    if(a == nil) goto    G0658;
    a = nil;
    goto    G0615;
   G0658:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0619;
   G0615:
    popv(8);
    return a;
}

Sex CC_fprinTcnterm(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(cdr(a));
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0671;
    CC_fprinTcnterm(a);
    a = car(w1);
    if(is_cons(a)) goto    G0673;
    Lprinc(a);
    goto    G0674;
   G0673:
    CC_fprinTxvar(a);
   G0674:
    a = car(cdr(w1));
    value(LL_Htemporal) = a;
    a = Lonep(a);
    if(a != nil) goto    G0689;
    a = value(LL_Htemporal);
    if(!is_integer(a)) goto    G0687;
    goto    G0690;
   G0671:
    a = car(w1);
    if(is_cons(a)) goto    G0682;
    Lprinc(a);
    goto    G0683;
   G0682:
    CC_fprinTxvar(a);
   G0683:
    a = car(cdr(w1));
    value(LL_Htemporal) = a;
    a = Lonep(a);
    if(a == nil) goto    G0685;
   G0689:
    a = nil;
    goto    G0680;
   G0685:
    a = value(LL_Htemporal);
    if(!is_integer(a)) goto    G0687;
   G0690:
    a = LITERAL[45];
    Lprinc(a);
    a = value(LL_Htemporal);
    {
        popv(1);
        return  Lprin(a);
    }
   G0687:
    a = LITERAL[45];
    Lprinc(a);
    a = LITERAL[29];
    Lprinc(a);
    a = value(LL_Htemporal);
    Lprin(a);
    a = LITERAL[39];
    a = Lprinc(a);
   G0680:
    popv(1);
    return a;
}

Sex CC_fprinTxvar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    Lprinc(a);
    a = value(LL_RlbracketS);
    Lprinc(a);
    a = cdr(w1);
    w1 = a;
   G0695:
    a = car(w1);
    if(is_cons(a)) goto    G0698;
    Lprin(a);
    goto    G0699;
   G0698:
    q = nil;
    CC_fprinTcano(a, q);
   G0699:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0696;
    a = LITERAL[30];
    Lprinc(a);
    goto    G0695;
   G0696:
    a = value(LL_RrbracketS);
    Lprinc(a);
    a = nil;
    popv(1);
    return a;
}



/* initialization procedure */
int init_bswrit(void)
{
   long i;

   create_symbols(bswrit_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; bswrit_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(bswrit_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a;
        a = LITERAL[57];
        a = CC_Aenter(a);
        return 1;
    }
}
Sex LITERAL[59];

const  char *bswrit_literal_string[59] =
{
/* 0 */
"!*prinmode",
/* 1 */
"nat",
/* 2 */
"flat",
/* 3 */
"pret",
/* 4 */
"! var",
/* 5 */
"\" := \"",
/* 6 */
"!!gid",
/* 7 */
"\"ARRAY AS FOLLOWS\"",
/* 8 */
"!!ctype!!",
/* 9 */
"rat",
/* 10 */
"rel",
/* 11 */
"set",
/* 12 */
"!#maxcano!#",
/* 13 */
"!*temporal",
/* 14 */
"log",
/* 15 */
"!*chkcoef",
/* 16 */
"\" + (\"",
/* 17 */
"\" terms)\"",
/* 18 */
"\" \"",
/* 19 */
"\" NIL\"",
/* 20 */
"!!set",
/* 21 */
"!<lbrace!>",
/* 22 */
"!<lbracket!>",
/* 23 */
"!<blank!>",
/* 24 */
"\" , \"",
/* 25 */
"!<rbrace!>",
/* 26 */
"!<rbracket!>",
/* 27 */
"! nil",
/* 28 */
"\"(0) := \"",
/* 29 */
"\"(\"",
/* 30 */
"\",\"",
/* 31 */
"\") := \"",
/* 32 */
"\"NULL ARRAY\"",
/* 33 */
"\"ZERO VECT/MATX/TENS\"",
/* 34 */
"c!+",
/* 35 */
"!#ratf!#",
/* 36 */
"\"- \"",
/* 37 */
"\" - \"",
/* 38 */
"\" + \"",
/* 39 */
"\")\"",
/* 40 */
"\"/(\"",
/* 41 */
"\"*\"",
/* 42 */
"\" (\"",
/* 43 */
"nc!*",
/* 44 */
"\"^(\"",
/* 45 */
"\"^\"",
/* 46 */
"\"*(\"",
/* 47 */
"gal",
/* 48 */
"\"{ }\"",
/* 49 */
"\"{ \"",
/* 50 */
"\" }\"",
/* 51 */
"\"[ ]\"",
/* 52 */
"\"[ \"",
/* 53 */
"\" ]\"",
/* 54 */
"\" ,\"",
/* 55 */
"\"  \"",
/* 56 */
"!*powser",
/* 57 */
"(lisp)",
/* 58 */ NULL
};
setup_type const bswrit_g_setup[] =
{
    {"fprin:xvar", (lisp_proc *)CC_fprinTxvar, 1},
    {"fprin:cnterm", (lisp_proc *)CC_fprinTcnterm, 1},
    {"cutprin:bpol", (lisp_proc *)CC_cutprinTbpol, 4},
    {"fprin:bpol", (lisp_proc *)CC_fprinTbpol, 3},
    {"idxs:add1", (lisp_proc *)CC_idxsTadd1, 2},
    {"lprin:bpol", (lisp_proc *)CC_lprinTbpol, 3},
    {"lprin:cano", (lisp_proc *)CC_lprinTcano, 2},
    {"lprin:set", (lisp_proc *)CC_lprinTset, 2},
    {"fprin:canordset", (lisp_proc *)CC_fprinTcanordset, 1},
    {"fprin:canset", (lisp_proc *)CC_fprinTcanset, 1},
    {"fprin:args", (lisp_proc *)CC_fprinTargs, 1},
    {"fprin:func", (lisp_proc *)CC_fprinTfunc, 1},
    {"fprin:c+", (lisp_proc *)CC_fprinTcL, 1},
    {"fprin:ncc*", (lisp_proc *)CC_fprinTnccH, 1},
    {"fprin:cano", (lisp_proc *)CC_fprinTcano, 2},
    {"fprin:rat", (lisp_proc *)CC_fprinTrat, 1},
    {"fprin:form", (lisp_proc *)CC_fprinTform, 2},
    {"fprin:array", (lisp_proc *)CC_fprinTarray, 2},
    {"fprin:set", (lisp_proc *)CC_fprinTset, 2},
    {"fprin:cons", (lisp_proc *)CC_fprinTcons, 1},
    {"fprin:rel", (lisp_proc *)CC_fprinTrel, 1},
    {"fprin:log", (lisp_proc *)CC_fprinTlog, 1},
    {"msg:poly", (lisp_proc *)CC_msgTpoly, 1},
    {"lprin*", (lisp_proc *)CC_lprinH, 2},
    {"fprin*", (lisp_proc *)CC_fprinH, 2},
    {"listprint*", (lisp_proc *)CC_listprintH, 2},
    {"flatprint*", (lisp_proc *)CC_flatprintH, 2},
    {"natprint*", (lisp_proc *)CC_natprintH, 2},
    {"gprint*", (lisp_proc *)CC_gprintH, 2},
    {"gggprint*", (lisp_proc *)CC_gggprintH, 2},
    {NULL, NULL, 0 }
};

