#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_cfap.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex cfap_literal_vector[];
const char *cfap_literal_string[];
setup_type const  cfap_g_setup[];
#define LITERAL cfap_literal_vector




Sex CC_printf(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G0002;
    q = nil;
    a = cdr(a);
    a = Lequal(a, q);
    if(a == nil) goto    G0004;
    q = car(cdr(w1));
#define LL_printf0 LITERAL[0]
    a = LL_printf0;
    {
        popv(1);
        return  Llist2(a, q);
    }
   G0004:
    q = nil;
    a = cdr(cdr(cdr(w1)));
    a = Lequal(a, q);
    if(a == nil) goto    G0005;
    m = car(cdr(cdr(w1)));
    q = car(cdr(w1));
#define LL_printf1 LITERAL[1]
    a = LL_printf1;
    goto    G0010;
   G0005:
    a = cdr(cdr(w1));
    if(a == nil) goto    G0008;
#define LL_list LITERAL[2]
    q = LL_list;
    a = Lxcons(a, q);
   G0008:
    m = a;
    q = car(cdr(w1));
#define LL_vprintf LITERAL[3]
    a = LL_vprintf;
   G0010:
    a = Llist3(a, q, m);
   G0002:
    popv(1);
    return a;
}

Sex CC_sprintf(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G0014;
    q = nil;
    a = cdr(a);
    a = Lequal(a, q);
    if(a == nil) goto    G0016;
    q = car(cdr(w1));
#define LL_sprintf0 LITERAL[4]
    a = LL_sprintf0;
    {
        popv(1);
        return  Llist2(a, q);
    }
   G0016:
    q = nil;
    a = cdr(cdr(cdr(w1)));
    a = Lequal(a, q);
    if(a == nil) goto    G0017;
    m = car(cdr(cdr(w1)));
    q = car(cdr(w1));
#define LL_sprintf1 LITERAL[5]
    a = LL_sprintf1;
    goto    G0022;
   G0017:
    a = cdr(cdr(w1));
    if(a == nil) goto    G0020;
    q = LL_list;
    a = Lxcons(a, q);
   G0020:
    m = a;
    q = car(cdr(w1));
#define LL_vsprintf LITERAL[6]
    a = LL_vsprintf;
   G0022:
    a = Llist3(a, q, m);
   G0014:
    popv(1);
    return a;
}

Sex CC_ccompile1(Sex a)
{
    Sex q, m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0063;
    a = car(a);
#define LL_de LITERAL[7]
    if(a != LL_de) goto    G0027;
    a = w1;
    a = Lcadddr(a);
    m = a;
    q = car(cdr(cdr(w1)));
#define LL_lambda LITERAL[8]
    a = LL_lambda;
    a = Llist3(a, q, m);
    m = a;
#define LL_expr LITERAL[9]
    q = LL_expr;
    goto    G0064;
   G0027:
#define LL_df LITERAL[10]
    if(a != LL_df) goto    G0030;
    a = w1;
    a = Lcadddr(a);
    m = a;
    q = car(cdr(cdr(w1)));
    a = LL_lambda;
    a = Llist3(a, q, m);
    m = a;
#define LL_fexpr LITERAL[11]
    q = LL_fexpr;
   G0064:
    a = car(cdr(w1));
    goto    G0065;
   G0030:
#define LL_dm LITERAL[12]
    if(a != LL_dm) goto    G0033;
    a = w1;
    a = Lcadddr(a);
    m = a;
    q = car(cdr(cdr(w1)));
    a = LL_lambda;
    a = Llist3(a, q, m);
    m = a;
#define LL_macro LITERAL[13]
    q = LL_macro;
    a = car(cdr(w1));
    CC_ccompile2(a, q, m);
    a = car(cdr(w1));
    a = Lmkquote(a);
    w2 = a;
    a = LL_macro;
    goto    G0066;
   G0033:
#define LL_ds LITERAL[14]
    if(a != LL_ds) goto    G0040;
    a = w1;
    a = Lcadddr(a);
    m = a;
    q = car(cdr(cdr(w1)));
    a = LL_lambda;
    a = Llist3(a, q, m);
    m = a;
#define LL_smacro LITERAL[15]
    q = LL_smacro;
    a = car(cdr(w1));
    CC_ccompile2(a, q, m);
    a = car(cdr(w1));
    a = Lmkquote(a);
    w2 = a;
    a = LL_smacro;
   G0066:
    a = Lmkquote(a);
    w3 = a;
    a = cdr(cdr(w1));
    a = Lmkquote(a);
    arg4 = a;
    m = w3;
    q = w2;
#define LL_put LITERAL[16]
    a = LL_put;
    a = Llist4(a, q, m, arg4);
#define LL_initials LITERAL[17]
    q = value(LL_initials);
    a = cons(a, q);
    value(LL_initials) = a;
    goto    G0062;
   G0040:
#define LL_putd LITERAL[18]
    if(a != LL_putd) goto    G0047;
    a = car(car(cdr(w1)));
#define LL_quote LITERAL[19]
    if(a != LL_quote) goto    G0047;
    a = car(car(cdr(cdr(w1))));
    if(a != LL_quote) goto    G0047;
    a = w1;
    a = Lcadddr(a);
    a = car(a);
    if(a != LL_quote) goto    G0047;
#define LL_compile LITERAL[20]
    q = LL_compile;
    a = car(cdr(car(cdr(cdr(w1)))));
    a = Lflagp(a, q);
    if(a == nil) goto    G0047;
    a = w1;
    a = Lcadadr(a);
    w2 = a;
    a = w1;
    a = Lcadddr(a);
    a = cdr(a);
    a = car(a);
    m = a;
    q = car(cdr(car(cdr(cdr(w1)))));
    a = w2;
   G0065:
    {
        popv(3);
        return  CC_ccompile2(a, q, m);
    }
   G0047:
    a = car(w1);
#define LL_evalKwhen LITERAL[21]
    if(a != LL_evalKwhen) goto    G0054;
    a = car(car(cdr(w1)));
    if(a != LL_compile) goto    G0054;
    m = nil;
    q = nil;
    a = car(cdr(cdr(w1)));
    {
        popv(3);
        return  Lerrorset(a, q, m);
    }
   G0054:
    a = car(w1);
#define LL_progn LITERAL[22]
    if(a != LL_progn) goto    G0056;
    w2 = nil;
    a = cdr(w1);
    w2 = a;
   G0058:
    if(a == nil) goto    G0062;
    a = car(a);
    CC_ccompile1(a);
    a = cdr(w2);
    w2 = a;
    goto    G0058;
   G0056:
#define LL_letfn LITERAL[23]
    if(a != LL_letfn) goto    G0061;
    a = w1;
    {
        popv(3);
        return eval(a, nil);
    }
   G0061:
    a = w1;
   G0063:
    a = CC_ccompiles(a);
   G0062:
    popv(3);
    return a;
}

Sex CC_ccompile2(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Hmodule LITERAL[24]
    a = value(LL_Hmodule);
    if(a == nil) goto    G0070;
    a = w1;
    {
        popv(1);
#define LL_modcmp LITERAL[25]
        return  apply3(LL_modcmp, a, q, m);
    }
   G0070:
    a = w1;
    {
        popv(1);
        return  CC_ccompile3(a, q, m);
    }
}

Sex CC_ccompile3(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = LL_compile;
    a = w2;
    a = Lflagp(a, q);
    if(a != nil) goto    G0076;
    arg4 = w2;
    m = LITERAL[26];
    q = w1;
    a = LITERAL[27];
    a = Llist4(a, q, m, arg4);
    goto    G0094;
   G0076:
#define LL_lose LITERAL[28]
    q = LL_lose;
    a = w1;
    a = Lflagp(a, q);
    if(a == nil) goto    G0078;
    q = LITERAL[29];
    a = w1;
    a = Llist2(a, q);
   G0094:
    Llprim(a);
    goto    G0080;
   G0078:
    q = LITERAL[30];
    a = w2;
    a = Lmemq(a, q);
    if(a == nil) goto    G0082;
    a = w1;
    a = Lgetd(a);
    a = car(a);
    if(a == w2) goto    G0082;
    a = w2;
    a = Lncons(a);
    m = a;
#define LL_cfntype LITERAL[31]
    q = LL_cfntype;
    a = w1;
    Lput(a, q, m);
   G0082:
    a = car(cdr(w3));
    w4 = a;
    q = LITERAL[30];
    a = w2;
    a = Lmemq(a, q);
    if(a == nil) goto    G0087;
    a = w1;
   G0087:
    q = a;
    a = w3;
    a = CC_Gcomproc(a, q);
    w3 = a;
    a = w4;
    a = Llength(a);
    arg4 = a;
    m = w2;
    q = w1;
#define LL_Hentry LITERAL[32]
    a = LL_Hentry;
    a = Llist4(a, q, m, arg4);
    q = w3;
    a = cons(a, q);
    a = Lmkquote(a);
    q = a;
#define LL_lap LITERAL[33]
    a = LL_lap;
    a = Llist2(a, q);
    CC_ccompiles(a);
   G0080:
    a = nil;
    popv(4);
    return a;
}

Sex CC_ccompile4(Sex a)
{
    Sex q, m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = car(cdr(a));
    w2 = a;
#define LL_sugar_initialization_procedure LITERAL[34]
    q = LL_sugar_initialization_procedure;
    a = w1;
    a = CC_Gcomproc(a, q);
    w1 = a;
    arg4 = mkfxat(0);
    m = LL_expr;
    q = LL_sugar_initialization_procedure;
#define LL_Hinit_entry LITERAL[35]
    a = LL_Hinit_entry;
    a = Llist4(a, q, m, arg4);
    q = w1;
    a = cons(a, q);
    a = Lmkquote(a);
    q = a;
    a = LL_lap;
    a = Llist2(a, q);
    CC_ccompiles(a);
    a = nil;
    popv(2);
    return a;
}

Sex CC_AGal_ccompilef(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    Lterpri();
#define LL_ccompile LITERAL[36]
    a = LL_ccompile;
#define LL_currentfn LITERAL[37]
    value(LL_currentfn) = a;
#define LL_entrynames LITERAL[38]
    value(LL_entrynames) = nil;
    value(LL_initials) = nil;
#define LL_literals LITERAL[39]
    value(LL_literals) = nil;
#define LL_ccompile1 LITERAL[40]
    a = LL_ccompile1;
#define LL_dfprintH LITERAL[41]
    value(LL_dfprintH) = a;
    a = true;
#define LL_Qnomessage LITERAL[42]
    value(LL_Qnomessage) = a;
#define LL_dfdebugH LITERAL[43]
    value(LL_dfdebugH) = nil;
    a = w2;
#define LL_filename LITERAL[44]
    value(LL_filename) = a;
    a = w1;
#define LL_pathname LITERAL[45]
    value(LL_pathname) = a;
#define LL_Hinitialization_procedure LITERAL[46]
    value(LL_Hinitialization_procedure) = nil;
    q = w2;
    if(a == nil) goto    G0106;
    a = Llist2(a, q);
    q = a;
    a = LITERAL[47];
    a = Lvsprintf(a, q);
    goto    G0113;
   G0106:
    a = LITERAL[48];
    a = Lsprintf1(a, q);
   G0113:
    w5 = a;
    a = w5;
#define LL_Qoutfile LITERAL[49]
    value(LL_Qoutfile) = a;
#define LL_output LITERAL[50]
    q = LL_output;
    a = Lopen(a, q);
    a = Lwrs(a);
    w5 = a;
    a = LITERAL[51];
    Lprintf0(a);
    a = LITERAL[52];
    Lprintf0(a);
    a = LITERAL[53];
    Lprintf0(a);
    a = LITERAL[54];
    Lprintf0(a);
    a = LITERAL[55];
    Lprintf0(a);
    a = LITERAL[56];
    Lprintf0(a);
    a = LITERAL[57];
    Lprintf0(a);
    a = LITERAL[58];
    Lprintf0(a);
    a = LITERAL[59];
    Lprintf0(a);
    a = LITERAL[60];
    Lprintf0(a);
    a = LITERAL[61];
    Lprintf0(a);
#define LL_Qstayslow LITERAL[62]
    a = value(LL_Qstayslow);
    if(a != nil) goto    G0112;
    a = LITERAL[63];
    Lprintf0(a);
   G0112:
    q = w2;
    a = LITERAL[64];
    Lprintf1(a, q);
    a = LITERAL[65];
    Lprintf0(a);
    a = LITERAL[66];
    Lprintf0(a);
    a = LITERAL[67];
    Lprintf0(a);
    q = w2;
    a = LITERAL[68];
    Lprintf1(a, q);
    q = w2;
    a = LITERAL[69];
    Lprintf1(a, q);
    q = w2;
    a = LITERAL[70];
    Lprintf1(a, q);
    q = w2;
    a = LITERAL[71];
    Lprintf1(a, q);
    a = LITERAL[72];
    Lprintf0(a);
    a = true;
#define LL_Hdefn LITERAL[73]
    value(LL_Hdefn) = a;
    a = nil;
    popv(5);
    return a;
}

Sex CC_Accompileendf(void)
{
    Sex a, q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w2 = nil;
    w1 = nil;
    w3 = nil;
    w4 = nil;
    Lterpri();
    a = value(LL_initials);
    a = Lnreverse(a);
    q = LL_progn;
    a = Lxcons(a, q);
    m = a;
    q = nil;
    a = LL_lambda;
    a = Llist3(a, q, m);
    w5 = a;
    Lterpri();
    a = LITERAL[74];
    Lprintf0(a);
    q = value(LL_filename);
    a = LITERAL[75];
    Lprintf1(a, q);
    a = LITERAL[76];
    Lprintf0(a);
    a = LITERAL[77];
    Lprintf0(a);
    a = LITERAL[65];
    Lprintf0(a);
    q = value(LL_filename);
    a = LITERAL[78];
    Lprintf1(a, q);
    a = LITERAL[79];
    Lprintf0(a);
    a = LITERAL[80];
    Lprintf0(a);
    q = value(LL_filename);
    a = LITERAL[81];
    Lprintf1(a, q);
    a = LITERAL[82];
    Lprintf0(a);
    q = value(LL_filename);
    a = LITERAL[83];
    Lprintf1(a, q);
    a = LITERAL[84];
    Lprintf0(a);
    a = true;
    value(LL_Hinitialization_procedure) = a;
    q = mkfxat(4);
#define LL_block_level LITERAL[85]
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    a = w5;
    CC_ccompile4(a);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    a = value(LL_literals);
    a = Llength(a);
    w6 = a;
    a = Ladd1(a);
    q = a;
    a = LITERAL[86];
    Lprintf1(a, q);
    a = w6;
    a = Ladd1(a);
    q = a;
    a = value(LL_filename);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[87];
    Lvprintf(a, q);
    a = LITERAL[76];
    Lprintf0(a);
    a = mkfxat(0);
    w2 = a;
    a = value(LL_literals);
    w5 = a;
    w7 = nil;
   G0132:
    if(a == nil) goto    G0131;
    q = car(a);
    a = w2;
    a = Llist2(a, q);
    q = a;
    a = LITERAL[88];
    Lvprintf(a, q);
    a = w2;
    a = Ladd1(a);
    w2 = a;
    a = cdr(w5);
    w5 = a;
    w7 = a;
    goto    G0132;
   G0131:
    q = w2;
    a = LITERAL[89];
    Lprintf1(a, q);
    q = value(LL_filename);
    a = LITERAL[90];
    Lprintf1(a, q);
    a = LITERAL[76];
    Lprintf0(a);
    a = value(LL_entrynames);
    w5 = a;
    w7 = nil;
   G0137:
    if(a == nil) goto    G0136;
#define LL_entry LITERAL[91]
    q = LL_entry;
    a = car(a);
    a = Lget(a, q);
    w4 = a;
    a = car(w5);
    a = CC_c_entryname(a);
    q = a;
    a = car(w5);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[92];
    Lvprintf(a, q);
    a = w4;
    if(a == nil) goto    G0143;
    a = car(a);
    if(a != LL_expr) goto    G0145;
    q = car(cdr(w4));
    goto    G0183;
   G0145:
    if(a != LL_fexpr) goto    G0146;
    a = LITERAL[93];
    goto    G0184;
   G0146:
    if(a != LL_macro) goto    G0147;
    a = LITERAL[94];
   G0184:
    Lprintf0(a);
    goto    G0143;
   G0147:
    if(a != LL_smacro) goto    G0143;
    q = car(cdr(w4));
    a = mkfxat(-3);
    a = diff2(a, q);
    q = a;
   G0183:
    a = LITERAL[95];
    Lprintf1(a, q);
   G0143:
    a = cdr(w5);
    w5 = a;
    w7 = a;
    goto    G0137;
   G0136:
    a = LITERAL[96];
    Lprintf0(a);
    a = LITERAL[97];
    Lprintf0(a);
    Lterpri();
    a = value(LL_pathname);
    q = value(LL_filename);
    if(a == nil) goto    G0151;
    a = Llist2(a, q);
    q = a;
    a = LITERAL[98];
    a = Lvsprintf(a, q);
    goto    G0185;
   G0151:
    a = LITERAL[99];
    a = Lsprintf1(a, q);
   G0185:
    value(LL_Qoutfile) = a;
    q = LL_output;
    a = value(LL_Qoutfile);
    a = Lopen(a, q);
    Lwrs(a);
    q = value(LL_filename);
    a = LITERAL[100];
    Lprintf1(a, q);
    q = value(LL_filename);
    a = LITERAL[101];
    Lprintf1(a, q);
    a = value(LL_entrynames);
    w5 = a;
    w7 = nil;
   G0156:
    if(a == nil) goto    G0155;
    q = LL_entry;
    a = car(a);
    a = Lget(a, q);
    w4 = a;
    if(a == nil) goto    G0160;
    a = value(LL_Qstayslow);
    if(a != nil) goto    G0163;
#define LL_stayslow LITERAL[102]
    q = LL_stayslow;
    a = car(w5);
    a = Lflagp(a, q);
    if(a == nil) goto    G0162;
   G0163:
    a = car(w5);
    a = CC_c_entryname(a);
    q = a;
    a = LITERAL[103];
    goto    G0186;
   G0162:
    a = car(w5);
    a = CC_c_entryname(a);
    q = a;
    a = LITERAL[104];
   G0186:
    Lprintf1(a, q);
    a = mkfxat(0);
    w2 = a;
    w8 = nil;
   G0168:
    q = car(cdr(w4));
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0188;
    a = w2;
    a = Ladd1(a);
    w2 = a;
    a = Lonep(a);
    if(a == nil) goto    G0172;
    a = LITERAL[105];
    goto    G0187;
   G0172:
    a = LITERAL[106];
   G0187:
    Lprintf0(a);
    q = mkfxat(7);
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G0175;
    a = LITERAL[65];
    a = Lprintf0(a);
   G0175:
    w8 = a;
    goto    G0168;
   G0188:
    a = w8;
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G0177;
    a = LITERAL[107];
    Lprintf0(a);
   G0177:
    a = LITERAL[108];
    Lprintf0(a);
   G0160:
    a = cdr(w5);
    w5 = a;
    w7 = a;
    goto    G0156;
   G0155:
    Lterpri();
    a = LITERAL[109];
    Lprintf0(a);
    a = nil;
    value(LL_Qoutfile) = a;
    Lwrs(a);
    a = value(LL_entrynames);
    w5 = a;
    w7 = nil;
   G0180:
    if(a == nil) goto    G0179;
    q = LL_entry;
    a = car(a);
    Lremprop(a, q);
    a = cdr(w5);
    w5 = a;
    w7 = a;
    goto    G0180;
   G0179:
    value(LL_entrynames) = nil;
    value(LL_literals) = nil;
    value(LL_dfprintH) = nil;
    Lterpri();
    value(LL_Hdefn) = nil;
    a = nil;
    popv(8);
    return a;
}

Sex CC_ccompend(void)
{
    Sex a, q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    a = value(LL_entrynames);
    w1 = a;
    w2 = nil;
   G0195:
    if(a == nil) goto    G0194;
    q = LL_entry;
    a = car(a);
    Lremprop(a, q);
    a = cdr(w1);
    w1 = a;
    w2 = a;
    goto    G0195;
   G0194:
    value(LL_entrynames) = nil;
    value(LL_literals) = nil;
    a = nil;
    Lrds(a);
    value(LL_dfprintH) = nil;
    Lterpri();
    value(LL_Hdefn) = nil;
    a = nil;
    popv(2);
    return a;
}

Sex CC_ccompiles1(Sex a)
{
    Sex q;
    if(a != nil) goto    G0201;
    a = true;
    goto    G0204;
   G0201:
    if(is_cons(a)) goto    G0202;
    q = a;
    a = LITERAL[110];
    a = Llist2(a, q);
    {
        return  Lprin2t(a);
    }
   G0202:
    a = CC_ccompify(a);
   G0204:
    return a;
}

Sex CC_ccompiles(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    {
        Sex *_w = bstack, *_v;
        bstackcheck();
#define LL_winp LITERAL[111]
        pushbv(0, LL_winp, nil);
        bstack = _w + 2;
    }
    w1 = a;
#define LL_ccompiles LITERAL[112]
    a = LL_ccompiles;
    value(LL_currentfn) = a;
    a = w1;
    a = Lmkquote(a);
    q = a;
#define LL_ccompiles1 LITERAL[113]
    a = LL_ccompiles1;
    a = Llist2(a, q);
#define LL_Hbakgag LITERAL[114]
    m = value(LL_Hbakgag);
    q = true;
    a = Lerrorset(a, q, m);
    value(LL_winp) = a;
    if(is_cons(a)) goto    G0211;
    Lterpri();
    q = value(LL_currentfn);
    a = LITERAL[115];
    a = Llist2(a, q);
    Lprin2t(a);
    a = Lterpri();
    goto    G0213;
   G0211:
    a = true;
   G0213:
    value(LL_winp) = a;
    {
        Sex *_w = bstack;
        popbv(0);
        bstack = _w - 2;
    }
    popv(2);
    return a;
}

Sex CC_ccompify(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
#define LL_ccompify LITERAL[116]
    a = LL_ccompify;
    value(LL_currentfn) = a;
    a = w1;
    if(!is_cons(a)) goto    G0224;
    a = car(a);
    if(a != LL_lap) goto    G0219;
    a = car(cdr(car(cdr(w1))));
    w2 = a;
    a = car(cdr(car(a)));
    value(LL_currentfn) = a;
    a = w2;
    CC_fap(a);
    goto    G0224;
   G0219:
    a = w1;
    a = CC_mungeable(a);
    if(a == nil) goto    G0221;
    a = car(w1);
#define LL_setq LITERAL[117]
    if(a != LL_setq) goto    G0223;
    a = car(cdr(w1));
    value(LL_currentfn) = a;
   G0223:
    q = value(LL_initials);
    a = w1;
    a = cons(a, q);
    value(LL_initials) = a;
    goto    G0224;
   G0221:
    q = LITERAL[118];
    a = car(w1);
    a = Lmemq(a, q);
    if(a != nil) goto    G0224;
    q = w1;
    a = LITERAL[110];
    a = Llist2(a, q);
    Lprin2t(a);
   G0224:
    a = nil;
    popv(2);
    return a;
}

Sex CC_mungeable(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = LITERAL[118];
    a = car(a);
    a = Lmemq(a, q);
    if(a != nil) goto    G0229;
#define LL_eval LITERAL[119]
    q = LL_eval;
    a = car(w1);
    a = Leq(a, q);
    if(a == nil) goto    G0229;
    a = car(cdr(w1));
    a = Latom(a);
    a = Lnull(a);
    if(a == nil) goto    G0229;
    q = LL_quote;
    a = car(car(cdr(w1)));
    a = Leq(a, q);
   G0229:
    {
        popv(1);
        return  Lnull(a);
    }
}

Sex CC_lap(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_HtargetKcpuH LITERAL[120]
    a = value(LL_HtargetKcpuH);
    if(a != CHAR_OF(99)) goto    G0235;
    a = w1;
    {
        popv(1);
        return  CC_lapKc(a);
    }
   G0235:
    q = nil;
    a = w1;
    {
        popv(1);
        return  CC_lapKbytecode(a, q);
    }
}

Sex CC_fap(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != CHAR_OF(99)) goto    G0240;
    a = w1;
    {
        popv(1);
        return  CC_fapKc(a);
    }
   G0240:
    q = nil;
    a = w1;
    {
        popv(1);
        return  CC_fapKbytecode(a, q);
    }
}

Sex CC_lapKc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w2 = nil;
    w3 = nil;
    w5 = nil;
    w1 = a;
    a = car(car(a));
    if(a != LL_Hentry) goto    G0248;
    a = cdr(cdr(car(w1)));
    w3 = a;
   G0248:
    a = cdr(w1);
    w4 = a;
   G0245:
    if(a == nil) goto    G0246;
#define LL_mc LITERAL[121]
    q = LL_mc;
    a = car(car(a));
    a = Lflagp(a, q);
    if(a == nil) goto    G0251;
    q = cdr(car(w4));
    a = car(car(w4));
    Lapply(a, q);
   G0251:
    a = cdr(w4);
    w4 = a;
    goto    G0245;
   G0246:
    a = car(w3);
    if(a != LL_expr) goto    G0253;
#define LL_subr LITERAL[122]
    a = LL_subr;
    goto    G0259;
   G0253:
    if(a != LL_fexpr) goto    G0254;
#define LL_fsubr LITERAL[123]
    a = LL_fsubr;
    goto    G0259;
   G0254:
    q = LL_compile;
    a = Lflagp(a, q);
    if(a == nil) goto    G0255;
    a = w3;
   G0259:
    w4 = a;
    goto    G0256;
   G0255:
    q = LITERAL[124];
    a = car(w3);
    a = Llist2(a, q);
    Llprie(a);
   G0256:
    a = nil;
    popv(5);
    return a;
}

Sex CC_fapKc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    Lterpri();
    q = LL_entry;
    a = value(LL_currentfn);
    a = Lget(a, q);
    if(a == nil) goto    G0270;
    a = LITERAL[125];
    Lprinc(a);
    q = value(LL_currentfn);
    a = LITERAL[126];
    a = Llist2(a, q);
    Lprinc(a);
    a = LITERAL[127];
    Lprin2t(a);
   G0270:
#define LL_Hplap LITERAL[128]
    a = value(LL_Hplap);
    if(a == nil) goto    G0273;
    a = w1;
    w5 = a;
    w6 = nil;
   G0275:
    if(a == nil) goto    G0273;
    a = car(a);
    Lprint(a);
    a = cdr(w5);
    w5 = a;
    w6 = a;
    goto    G0275;
   G0273:
    a = car(car(w1));
    if(a != LL_Hentry) goto    G0279;
    a = car(cdr(car(w1)));
#define LL_HlnameH LITERAL[129]
    value(LL_HlnameH) = a;
   G0279:
    a = w1;
    w4 = a;
#define LL_HrecursiveH LITERAL[130]
    value(LL_HrecursiveH) = nil;
    a = mkfxat(0);
#define LL_registers LITERAL[131]
    value(LL_registers) = a;
    w2 = nil;
    a = true;
    w3 = a;
    a = w4;
   G0265:
    if(a == nil) goto    G0266;
    a = car(a);
    w5 = a;
    a = w3;
    if(a == nil) goto    G0283;
    a = car(w5);
#define LL_Hstore LITERAL[132]
    if(a != LL_Hstore) goto    G0283;
    a = car(cdr(cdr(w5)));
    if(!is_number(a)) goto    G0283;
    q = w2;
    a = cons(a, q);
    w2 = a;
   G0283:
    a = car(w5);
#define LL_Hload LITERAL[133]
    if(a != LL_Hload) goto    G0286;
    q = value(LL_registers);
    a = car(cdr(w5));
    a = Lmax2(a, q);
    value(LL_registers) = a;
   G0286:
#define LL_mcKjump LITERAL[134]
    q = LL_mcKjump;
    a = car(w5);
    a = Lflagp(a, q);
    if(a == nil) goto    G0288;
    w3 = nil;
   G0288:
    a = car(w5);
#define LL_Hlinke LITERAL[135]
    if(a != LL_Hlinke) goto    G0290;
    a = car(cdr(w5));
    if(a != value(LL_HlnameH)) goto    G0290;
    a = true;
    value(LL_HrecursiveH) = a;
   G0290:
    a = cdr(w4);
    w4 = a;
    goto    G0265;
   G0266:
    q = w2;
    a = value(LL_registers);
    a = cons(a, q);
    value(LL_registers) = a;
    a = w1;
    w4 = a;
   G0267:
    if(a == nil) goto    G0268;
    a = car(a);
    w5 = a;
    q = LL_mc;
    a = car(a);
    a = Lflagp(a, q);
    if(a == nil) goto    G0295;
    q = cdr(w5);
    a = car(w5);
    Lapply(a, q);
    goto    G0296;
   G0295:
    q = w5;
    a = LITERAL[136];
    Lprintf1(a, q);
   G0296:
    a = cdr(w4);
    w4 = a;
    goto    G0267;
   G0268:
    a = value(LL_block_level);
    a = Lzerop(a);
    if(a != nil) goto    G0298;
    a = LITERAL[137];
    Lprintf0(a);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
   G0298:
    a = nil;
    popv(6);
    return a;
}

Sex CC_Gnumeq(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lequal(a, q);
    if(a == nil) goto    G0305;
    a = w1;
    if(is_number(a)) goto    G0303;
    a = true;
    goto    G0305;
   G0303:
    if(!is_float(a)) goto    G0304;
    a = w2;
    {
        popv(2);
        return  Lfloatp(a);
    }
   G0304:
    a = w2;
    a = Lfloatp(a);
    a = Lnull(a);
   G0305:
    popv(2);
    return a;
}

Sex CC_Gmkfunc(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
#define LL_Hsubr LITERAL[138]
    q = LL_Hsubr;
    a = Lget(a, q);
    w2 = a;
#define LL_Hholddef LITERAL[139]
    a = value(LL_Hholddef);
    if(a == nil) goto    G0311;
    a = w2;
    if(a == nil) goto    G0311;
    m = cdr(a);
    q = car(a);
    a = w1;
    Lputd(a, q, m);
    q = LL_Hsubr;
    a = w1;
    Lremprop(a, q);
   G0311:
    a = w1;
    {
        popv(2);
        return  Lmkquote(a);
    }
}

Sex CC_Hcomment(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
#define LL_bytecode LITERAL[140]
    if(a != LL_bytecode) goto    G0317;
    a = w1;
    {
        popv(2);
        return  CC_bTcomment(a, q);
    }
   G0317:
    a = w1;
#define LL_exitstackH LITERAL[141]
    value(LL_exitstackH) = a;
    w2 = q;
    q = mkfxat(0);
    a = Lleq(a, q);
    if(a == nil) goto    G0320;
    a = w2;
#define LL_exitlabH LITERAL[142]
    value(LL_exitlabH) = a;
    goto    G0321;
   G0320:
    value(LL_exitlabH) = nil;
   G0321:
    a = nil;
    popv(2);
    return a;
}

Sex CC_Hnoop(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = LL_bytecode;
    a = value(LL_HtargetKcpuH);
    a = Leq(a, q);
    if(a == nil) goto    G0324;
    a = w1;
    a = CC_bTnoop(a);
   G0324:
    popv(1);
    return a;
}

Sex CC_Hentry(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0333;
    a = w1;
    {
        popv(5);
        return  CC_bTentry(a, q, m);
    }
   G0333:
    a = mkfxat(0);
    value(LL_block_level) = a;
    q = m;
    a = w2;
    a = Llist2(a, q);
    m = a;
    q = LL_entry;
    a = w1;
    Lput(a, q, m);
    q = value(LL_entrynames);
    a = w1;
    a = cons(a, q);
    value(LL_entrynames) = a;
    a = value(LL_Qstayslow);
    if(a != nil) goto    G0338;
    q = LL_stayslow;
    a = w1;
    a = Lflagp(a, q);
    if(a == nil) goto    G0337;
   G0338:
    a = w1;
    a = CC_c_entryname(a);
    q = a;
    a = LITERAL[103];
    goto    G0361;
   G0337:
    a = w1;
    a = CC_c_entryname(a);
    q = a;
    a = LITERAL[143];
   G0361:
    Lprintf1(a, q);
    a = mkfxat(0);
    w4 = a;
    w5 = nil;
   G0343:
    q = w3;
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0342;
    a = w4;
    a = Ladd1(a);
    w4 = a;
    a = Lonep(a);
    if(a == nil) goto    G0347;
    a = LITERAL[144];
    a = Lprintf0(a);
    goto    G0348;
   G0347:
    a = w4;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[145];
    a = Lprintf1(a, q);
   G0348:
    w5 = a;
    goto    G0343;
   G0342:
    a = w4;
    a = Lzerop(a);
    if(a == nil) goto    G0351;
    a = LITERAL[107];
    Lprintf0(a);
   G0351:
    a = LITERAL[146];
    Lprintf0(a);
    a = mkfxat(4);
    value(LL_block_level) = a;
    q = car(value(LL_registers));
    a = w3;
    a = Lgeq(a, q);
    if(a != nil) goto    G0362;
    a = w3;
    a = Ladd1(a);
    w4 = a;
    a = CC_HHarg(a);
    q = a;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[147];
    Lvprintf(a, q);
    a = w4;
    a = Ladd1(a);
    w4 = a;
    w5 = nil;
   G0357:
    q = car(value(LL_registers));
    a = w4;
    a = Lleq(a, q);
    if(a == nil) goto    G0356;
    a = w4;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[148];
    Lprintf1(a, q);
    a = w4;
    a = Ladd1(a);
    w4 = a;
    w5 = a;
    goto    G0357;
   G0356:
    a = LITERAL[149];
    Lprintf0(a);
   G0362:
    a = nil;
    popv(5);
    return a;
}

Sex CC_Hinit_entry(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = value(LL_HtargetKcpuH);
    if(a == LL_bytecode) goto    G0380;
    a = mkfxat(4);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[150];
    Lprintf1(a, q);
    a = mkfxat(8);
    value(LL_block_level) = a;
    q = car(value(LL_registers));
    a = mkfxat(0);
    a = Lgeq(a, q);
    if(a != nil) goto    G0380;
    a = mkfxat(1);
    w4 = a;
    a = CC_HHarg(a);
    q = a;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[147];
    Lvprintf(a, q);
    a = w4;
    a = Ladd1(a);
    w4 = a;
    w5 = nil;
   G0375:
    q = car(value(LL_registers));
    a = w4;
    a = Lleq(a, q);
    if(a == nil) goto    G0374;
    a = w4;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[148];
    Lprintf1(a, q);
    a = w4;
    a = Ladd1(a);
    w4 = a;
    w5 = a;
    goto    G0375;
   G0374:
    a = LITERAL[149];
    Lprintf0(a);
   G0380:
    a = nil;
    popv(5);
    return a;
}

Sex CC_Halloc_old(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = Lgensym();
#define LL_Hentry_nameH LITERAL[151]
    value(LL_Hentry_nameH) = a;
    q = mkfxat(4);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0387;
    q = w1;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[152];
    Lvprintf(a, q);
    q = value(LL_block_level);
    a = LITERAL[153];
    Lprintf1(a, q);
    q = value(LL_block_level);
    a = LITERAL[154];
    Lprintf1(a, q);
    q = value(LL_block_level);
    a = LITERAL[155];
    Lprintf1(a, q);
    q = w1;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[156];
    Lvprintf(a, q);
    q = w1;
    goto    G0400;
   G0387:
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0391;
    q = value(LL_block_level);
    a = LITERAL[157];
    Lprintf1(a, q);
    q = value(LL_block_level);
    a = LITERAL[155];
    Lprintf1(a, q);
    a = w1;
    w2 = a;
    w3 = nil;
   G0393:
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0392;
    q = w1;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[158];
    Lvprintf(a, q);
    q = mkfxat(-1);
    a = w1;
    a = plus2(a, q);
    w1 = a;
    w3 = a;
    goto    G0393;
   G0392:
    q = w2;
   G0400:
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[159];
    Lvprintf(a, q);
   G0391:
    a = value(LL_HrecursiveH);
    if(a == nil) goto    G0399;
    q = value(LL_Hentry_nameH);
    a = LITERAL[160];
    Lprintf1(a, q);
   G0399:
    a = nil;
    popv(3);
    return a;
}

Sex CC_Halloc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0407;
    a = w1;
    {
        popv(2);
        return  CC_bTalloc(a);
    }
   G0407:
    a = Lgensym();
    value(LL_Hentry_nameH) = a;
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0410;
    q = value(LL_block_level);
    a = LITERAL[157];
    Lprintf1(a, q);
    q = value(LL_block_level);
    a = LITERAL[155];
    Lprintf1(a, q);
    q = w1;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[159];
    Lvprintf(a, q);
    w2 = nil;
   G0413:
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0410;
    q = w1;
    a = mkfxat(1);
    a = diff2(a, q);
    q = value(LL_registers);
    a = Lmemq(a, q);
    if(a != nil) goto    G0417;
    q = w1;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[161];
    Lvprintf(a, q);
   G0417:
    q = mkfxat(-1);
    a = w1;
    a = plus2(a, q);
    w1 = a;
    w2 = a;
    goto    G0413;
   G0410:
    a = value(LL_HrecursiveH);
    if(a == nil) goto    G0421;
    q = value(LL_Hentry_nameH);
    a = LITERAL[160];
    Lprintf1(a, q);
   G0421:
    a = nil;
    popv(2);
    return a;
}

Sex CC_Hdealloc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0425;
    a = w1;
    {
        popv(1);
        return  CC_bTdealloc(a);
    }
   G0425:
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0426;
    q = w1;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[162];
    a = Lvprintf(a, q);
   G0426:
    popv(1);
    return a;
}

Sex CC_Hexit(void)
{
    Sex a, q;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0431;
    {
        return  CC_bTexit();
    }
   G0431:
    a = value(LL_Hinitialization_procedure);
    if(a == nil) goto    G0432;
    q = value(LL_block_level);
    a = LITERAL[163];
    Lprintf1(a, q);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[164];
    {
        return  Lprintf1(a, q);
    }
   G0432:
    q = value(LL_block_level);
    a = LITERAL[165];
    Lprintf1(a, q);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    return a;
}

Sex CC_HHarg(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0442;
    a = Lonep(a);
    if(a == nil) goto    G0438;
    a = CHAR_OF(97);
    goto    G0442;
   G0438:
    q = mkfxat(2);
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G0439;
    a = CHAR_OF(113);
    goto    G0442;
   G0439:
    q = mkfxat(3);
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G0440;
    a = CHAR_OF(109);
    goto    G0442;
   G0440:
    q = mkfxat(3);
    a = w1;
    a = Lgreaterp(a, q);
    q = w1;
    if(a == nil) goto    G0441;
    a = LITERAL[166];
    goto    G0444;
   G0441:
    a = mkfxat(1);
    a = diff2(a, q);
    q = a;
    a = LITERAL[167];
   G0444:
    a = Lsprintf1(a, q);
   G0442:
    popv(1);
    return a;
}

Sex CC_Hjump(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0448;
    a = w1;
    {
        popv(1);
        return  CC_bTjump(a);
    }
   G0448:
    a = w1;
    if(a != value(LL_exitlabH)) goto    G0449;
    a = value(LL_exitstackH);
    {
        popv(1);
        return  CC_Hdealext(a);
    }
   G0449:
    q = a;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[168];
    {
        popv(1);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpc(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0456;
    a = w1;
    {
        popv(4);
        return  CC_bTjumpc(a, q, m);
    }
   G0456:
    a = m;
#define LL_null LITERAL[169]
    if(a != LL_null) goto    G0459;
    a = LITERAL[170];
    goto    G0511;
   G0459:
#define LL_atom LITERAL[171]
    if(a != LL_atom) goto    G0460;
    a = LITERAL[172];
    goto    G0511;
   G0460:
#define LL_pairp LITERAL[173]
    if(a != LL_pairp) goto    G0461;
    a = LITERAL[174];
    goto    G0511;
   G0461:
#define LL_idp LITERAL[175]
    if(a != LL_idp) goto    G0462;
    a = LITERAL[176];
    goto    G0511;
   G0462:
#define LL_stringp LITERAL[177]
    if(a != LL_stringp) goto    G0463;
    a = LITERAL[178];
    goto    G0511;
   G0463:
#define LL_vectorp LITERAL[179]
    if(a != LL_vectorp) goto    G0464;
    a = LITERAL[180];
    goto    G0511;
   G0464:
#define LL_numberp LITERAL[181]
    if(a != LL_numberp) goto    G0465;
    a = LITERAL[182];
    goto    G0511;
   G0465:
#define LL_becomplexp LITERAL[183]
    if(a != LL_becomplexp) goto    G0466;
    a = LITERAL[184];
    goto    G0511;
   G0466:
#define LL_befloatp LITERAL[185]
    if(a != LL_befloatp) goto    G0467;
    a = LITERAL[186];
    goto    G0511;
   G0467:
#define LL_bigp LITERAL[187]
    if(a != LL_bigp) goto    G0468;
    a = LITERAL[188];
    goto    G0511;
   G0468:
#define LL_bintervalp LITERAL[189]
    if(a != LL_bintervalp) goto    G0469;
    a = LITERAL[190];
    goto    G0511;
   G0469:
#define LL_complexp LITERAL[191]
    if(a != LL_complexp) goto    G0470;
    a = LITERAL[192];
    goto    G0511;
   G0470:
#define LL_complp LITERAL[193]
    if(a != LL_complp) goto    G0471;
    a = LITERAL[192];
    goto    G0511;
   G0471:
#define LL_ecomplexp LITERAL[194]
    if(a != LL_ecomplexp) goto    G0472;
    a = LITERAL[195];
    goto    G0511;
   G0472:
#define LL_efloatp LITERAL[196]
    if(a != LL_efloatp) goto    G0473;
    a = LITERAL[197];
    goto    G0511;
   G0473:
#define LL_fixp LITERAL[198]
    if(a != LL_fixp) goto    G0474;
    a = LITERAL[199];
    goto    G0511;
   G0474:
#define LL_floatp LITERAL[200]
    if(a != LL_floatp) goto    G0475;
    a = LITERAL[201];
    goto    G0511;
   G0475:
#define LL_bfloatp LITERAL[202]
    if(a != LL_bfloatp) goto    G0476;
    a = LITERAL[203];
    goto    G0511;
   G0476:
#define LL_intervalp LITERAL[204]
    if(a != LL_intervalp) goto    G0477;
    a = LITERAL[205];
    goto    G0511;
   G0477:
#define LL_intp LITERAL[206]
    if(a != LL_intp) goto    G0478;
    a = LITERAL[199];
    goto    G0511;
   G0478:
#define LL_intvalp LITERAL[207]
    if(a != LL_intvalp) goto    G0479;
    a = LITERAL[205];
    goto    G0511;
   G0479:
#define LL_logicalp LITERAL[208]
    if(a != LL_logicalp) goto    G0480;
    a = LITERAL[209];
    goto    G0511;
   G0480:
#define LL_logp LITERAL[210]
    if(a != LL_logp) goto    G0481;
    a = LITERAL[209];
    goto    G0511;
   G0481:
#define LL_rationalp LITERAL[211]
    if(a != LL_rationalp) goto    G0482;
    a = LITERAL[212];
    goto    G0511;
   G0482:
#define LL_ratnp LITERAL[213]
    if(a != LL_ratnp) goto    G0483;
    a = LITERAL[212];
    goto    G0511;
   G0483:
    a = LITERAL[214];
   G0511:
    w4 = a;
    a = q;
    a = CC_Haddress(a);
    m = w1;
    q = a;
    a = value(LL_block_level);
    a = Llist3(a, q, m);
    q = a;
    a = w4;
    Lvprintf(a, q);
    a = nil;
    popv(4);
    return a;
}

Sex CC_Hjumpnc(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0516;
    a = w1;
    {
        popv(4);
        return  CC_bTjumpnc(a, q, m);
    }
   G0516:
    a = m;
    if(a != LL_null) goto    G0519;
    a = LITERAL[215];
    goto    G0571;
   G0519:
    if(a != LL_atom) goto    G0520;
    a = LITERAL[174];
    goto    G0571;
   G0520:
    if(a != LL_pairp) goto    G0521;
    a = LITERAL[172];
    goto    G0571;
   G0521:
    if(a != LL_idp) goto    G0522;
    a = LITERAL[216];
    goto    G0571;
   G0522:
    if(a != LL_stringp) goto    G0523;
    a = LITERAL[217];
    goto    G0571;
   G0523:
    if(a != LL_vectorp) goto    G0524;
    a = LITERAL[218];
    goto    G0571;
   G0524:
    if(a != LL_numberp) goto    G0525;
    a = LITERAL[219];
    goto    G0571;
   G0525:
    if(a != LL_becomplexp) goto    G0526;
    a = LITERAL[220];
    goto    G0571;
   G0526:
    if(a != LL_befloatp) goto    G0527;
    a = LITERAL[221];
    goto    G0571;
   G0527:
    if(a != LL_bigp) goto    G0528;
    a = LITERAL[222];
    goto    G0571;
   G0528:
    if(a != LL_bintervalp) goto    G0529;
    a = LITERAL[223];
    goto    G0571;
   G0529:
    if(a != LL_complexp) goto    G0530;
    a = LITERAL[224];
    goto    G0571;
   G0530:
    if(a != LL_complp) goto    G0531;
    a = LITERAL[224];
    goto    G0571;
   G0531:
    if(a != LL_ecomplexp) goto    G0532;
    a = LITERAL[225];
    goto    G0571;
   G0532:
    if(a != LL_efloatp) goto    G0533;
    a = LITERAL[226];
    goto    G0571;
   G0533:
    if(a != LL_fixp) goto    G0534;
    a = LITERAL[227];
    goto    G0571;
   G0534:
    if(a != LL_floatp) goto    G0535;
    a = LITERAL[228];
    goto    G0571;
   G0535:
    if(a != LL_bfloatp) goto    G0536;
    a = LITERAL[229];
    goto    G0571;
   G0536:
    if(a != LL_intervalp) goto    G0537;
    a = LITERAL[230];
    goto    G0571;
   G0537:
    if(a != LL_intp) goto    G0538;
    a = LITERAL[227];
    goto    G0571;
   G0538:
    if(a != LL_intvalp) goto    G0539;
    a = LITERAL[230];
    goto    G0571;
   G0539:
    if(a != LL_logicalp) goto    G0540;
    a = LITERAL[231];
    goto    G0571;
   G0540:
    if(a != LL_logp) goto    G0541;
    a = LITERAL[231];
    goto    G0571;
   G0541:
    if(a != LL_rationalp) goto    G0542;
    a = LITERAL[232];
    goto    G0571;
   G0542:
    if(a != LL_ratnp) goto    G0543;
    a = LITERAL[232];
    goto    G0571;
   G0543:
    a = LITERAL[214];
   G0571:
    w4 = a;
    a = q;
    a = CC_Haddress(a);
    m = w1;
    q = a;
    a = value(LL_block_level);
    a = Llist3(a, q, m);
    q = a;
    a = w4;
    Lvprintf(a, q);
    a = nil;
    popv(4);
    return a;
}

Sex CC_Hjumpt(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0575;
    a = w1;
    {
        popv(1);
        return  CC_bTjumpt(a, q);
    }
   G0575:
    a = q;
    a = CC_Haddress(a);
    m = w1;
    q = a;
    a = value(LL_block_level);
    a = Llist3(a, q, m);
    q = a;
    a = LITERAL[215];
    {
        popv(1);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpnil(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0582;
    a = w1;
    {
        popv(1);
        return  CC_bTjumpnil(a, q);
    }
   G0582:
    a = q;
    a = CC_Haddress(a);
    m = w1;
    q = a;
    a = value(LL_block_level);
    a = Llist3(a, q, m);
    q = a;
    a = LITERAL[170];
    {
        popv(1);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpe(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0589;
    a = w1;
    {
        popv(3);
        return  CC_bTjumpeq(a, q, m);
    }
   G0589:
    w3 = m;
    a = q;
    a = CC_Haddress(a);
    w2 = a;
    a = w3;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[233];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpn(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0597;
    a = w1;
    {
        popv(3);
        return  CC_bTjumpne(a, q, m);
    }
   G0597:
    w3 = m;
    a = q;
    a = CC_Haddress(a);
    w2 = a;
    a = w3;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[234];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpge(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0605;
    a = w1;
    {
        popv(3);
        return  CC_bTjumpge(a, q, m);
    }
   G0605:
    w2 = q;
    a = m;
    a = CC_Haddress(a);
    w3 = a;
    a = w2;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w3;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[235];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpgt(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0613;
    a = w1;
    {
        popv(3);
        return  CC_bTjumpgt(a, q, m);
    }
   G0613:
    w2 = q;
    a = m;
    a = CC_Haddress(a);
    w3 = a;
    a = w2;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w3;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[236];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumple(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0621;
    a = w1;
    {
        popv(3);
        return  CC_bTjumple(a, q, m);
    }
   G0621:
    w3 = m;
    a = q;
    a = CC_Haddress(a);
    w2 = a;
    a = w3;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[236];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumplt(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0629;
    a = w1;
    {
        popv(3);
        return  CC_bTjumplt(a, q, m);
    }
   G0629:
    w3 = m;
    a = q;
    a = CC_Haddress(a);
    w2 = a;
    a = w3;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[235];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpige(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0637;
    a = w1;
    {
        popv(3);
        return  CC_bTjumpge(a, q, m);
    }
   G0637:
    w3 = m;
    a = q;
    a = CC_Haddress(a);
    w2 = a;
    a = w3;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[237];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpigt(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0645;
    a = w1;
    {
        popv(3);
        return  CC_bTjumpgt(a, q, m);
    }
   G0645:
    w3 = m;
    a = q;
    a = CC_Haddress(a);
    w2 = a;
    a = w3;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[238];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpile(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0653;
    a = w1;
    {
        popv(3);
        return  CC_bTjumple(a, q, m);
    }
   G0653:
    w3 = m;
    a = q;
    a = CC_Haddress(a);
    w2 = a;
    a = w3;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[239];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hjumpilt(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0661;
    a = w1;
    {
        popv(3);
        return  CC_bTjumplt(a, q, m);
    }
   G0661:
    w3 = m;
    a = q;
    a = CC_Haddress(a);
    w2 = a;
    a = w3;
    a = CC_Haddress(a);
    arg4 = w1;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[240];
    {
        popv(3);
        return  Lvprintf(a, q);
    }
}

Sex CC_Hlbl(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0669;
    a = w1;
    {
        popv(1);
        return  CC_bTlbl(a);
    }
   G0669:
    q = w1;
    a = LITERAL[160];
    {
        popv(1);
        return  Lprintf1(a, q);
    }
}

Sex CC_Hlambind(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0677;
    a = w1;
    {
        popv(5);
        return  CC_bTlambind(a, q);
    }
   G0677:
    a = mkfxat(0);
    w3 = a;
    q = value(LL_block_level);
    a = LITERAL[150];
    Lprintf1(a, q);
    q = mkfxat(4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[241];
    Lprintf1(a, q);
    q = value(LL_block_level);
    a = LITERAL[242];
    Lprintf1(a, q);
    a = w2;
   G0674:
    if(a == nil) goto    G0675;
    a = car(a);
    a = Lfluidp(a);
    if(a != nil) goto    G0681;
    q = LITERAL[243];
    a = car(w2);
    a = Llist2(a, q);
    Llprie(a);
   G0681:
    a = car(w2);
    a = CC_literalindex(a);
    w4 = a;
    a = car(w1);
    a = CC_Haddress(a);
    w5 = a;
    arg4 = a;
    m = w4;
    q = w3;
    a = value(LL_block_level);
    a = Llist4(a, q, m, arg4);
    q = a;
    a = LITERAL[244];
    Lvprintf(a, q);
    q = mkfxat(2);
    a = w3;
    a = plus2(a, q);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    goto    G0674;
   G0675:
    q = w3;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[245];
    Lvprintf(a, q);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[164];
    Lprintf1(a, q);
    a = nil;
    popv(5);
    return a;
}

Sex CC_Hprogbind(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0691;
    a = w1;
    {
        popv(3);
        return  CC_bTprogbind(a);
    }
   G0691:
    a = mkfxat(0);
    w2 = a;
    q = value(LL_block_level);
    a = LITERAL[150];
    Lprintf1(a, q);
    q = mkfxat(4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[241];
    Lprintf1(a, q);
    q = value(LL_block_level);
    a = LITERAL[242];
    Lprintf1(a, q);
    a = w1;
   G0688:
    if(a == nil) goto    G0689;
    a = car(a);
    a = Lfluidp(a);
    if(a != nil) goto    G0695;
    q = LITERAL[243];
    a = car(w1);
    a = Llist2(a, q);
    Llprie(a);
   G0695:
    a = car(w1);
    a = CC_literalindex(a);
    w3 = a;
    m = a;
    q = w2;
    a = value(LL_block_level);
    a = Llist3(a, q, m);
    q = a;
    a = LITERAL[246];
    Lvprintf(a, q);
    q = mkfxat(2);
    a = w2;
    a = plus2(a, q);
    w2 = a;
    a = cdr(w1);
    w1 = a;
    goto    G0688;
   G0689:
    q = w2;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[245];
    Lvprintf(a, q);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[164];
    Lprintf1(a, q);
    a = nil;
    popv(3);
    return a;
}

Sex CC_Hfreerstr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0705;
    a = w1;
    {
        popv(2);
        return  CC_bTfreerstr(a);
    }
   G0705:
    a = mkfxat(0);
    w2 = a;
    q = value(LL_block_level);
    a = LITERAL[150];
    Lprintf1(a, q);
    q = mkfxat(4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[247];
    Lprintf1(a, q);
    a = w1;
   G0702:
    if(a == nil) goto    G0703;
    a = car(a);
    a = Lfluidp(a);
    if(a != nil) goto    G0709;
    q = LITERAL[243];
    a = car(w1);
    a = Llist2(a, q);
    Llprie(a);
   G0709:
    q = w2;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[248];
    Lvprintf(a, q);
    q = mkfxat(-2);
    a = w2;
    a = plus2(a, q);
    w2 = a;
    a = cdr(w1);
    w1 = a;
    goto    G0702;
   G0703:
    a = w2;
    a = Lminus(a);
    q = a;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[249];
    Lvprintf(a, q);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[164];
    Lprintf1(a, q);
    a = nil;
    popv(2);
    return a;
}

Sex CC_Hload(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0717;
    a = w1;
    {
        popv(2);
        return  CC_bTload(a, q);
    }
   G0717:
    w2 = q;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_Hmove(a, q);
    }
}

Sex CC_Hstore(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0722;
    a = w1;
    {
        popv(1);
        return  CC_bTstore(a, q);
    }
   G0722:
    a = w1;
    {
        popv(1);
        return  CC_Hmove(a, q);
    }
}

Sex CC_Hmove(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    a = CC_Haddress(a);
    w1 = a;
    a = w2;
    a = CC_Haddress(a);
    w2 = a;
    m = w1;
    q = a;
    a = value(LL_block_level);
    a = Llist3(a, q, m);
    q = a;
    a = LITERAL[250];
    Lvprintf(a, q);
    a = nil;
    popv(2);
    return a;
}

Sex CC_Haddress(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a == nil) goto    G0747;
    w1 = a;
    q = LITERAL[251];
    a = Lequal(a, q);
    if(a == nil) goto    G0732;
    a = nil;
    goto    G0747;
   G0732:
    q = LITERAL[252];
    a = w1;
    a = Lequal(a, q);
    if(a != nil) goto    G0749;
    a = w1;
    if(a != true) goto    G0734;
   G0749:
#define LL_true LITERAL[253]
    a = LL_true;
    goto    G0747;
   G0734:
    if(!is_number(a)) goto    G0735;
    {
        popv(1);
        return  CC_HHarg(a);
    }
   G0735:
    if(!is_cons(a)) goto    G0747;
    a = car(a);
    if(a != LL_quote) goto    G0737;
    a = car(cdr(w1));
    {
        popv(1);
        return  CC_literalindex(a);
    }
   G0737:
    q = LITERAL[254];
    a = Lmemq(a, q);
    if(a == nil) goto    G0741;
    a = car(cdr(w1));
    a = CC_literalindex(a);
    q = a;
    a = LITERAL[255];
    goto    G0752;
   G0741:
    a = car(w1);
#define LL_car LITERAL[256]
    if(a != LL_car) goto    G0743;
    a = car(cdr(w1));
    a = CC_Haddress(a);
    q = a;
    a = LITERAL[257];
    goto    G0752;
   G0743:
#define LL_cdr LITERAL[258]
    if(a != LL_cdr) goto    G0745;
    a = car(cdr(w1));
    a = CC_Haddress(a);
    q = a;
    a = LITERAL[259];
   G0752:
    {
        popv(1);
        return  Lsprintf1(a, q);
    }
   G0745:
    q = a;
    a = LITERAL[260];
    a = Llist2(a, q);
    a = Llprie(a);
   G0747:
    popv(1);
    return a;
}

Sex CC_literalindex(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    {
        Sex *_w = bstack, *_v;
        bstackcheck();
#define LL_lname LITERAL[261]
        pushbv(0, LL_lname, nil);
        bstack = _w + 2;
    }
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = Lis_char(a);
    if(a == nil) goto    G0760;
    a = w1;
    a = Lchar_code(a);
    q = a;
    a = LITERAL[262];
    goto    G0784;
   G0760:
    a = w1;
    if(!is_integer(a)) goto    G0764;
    q = mkfxat(-134217728);
    a = Lgeq(a, q);
    if(a == nil) goto    G0764;
    q = mkfxat(134217727);
    a = w1;
    a = Lleq(a, q);
    if(a == nil) goto    G0764;
    q = w1;
    a = LITERAL[263];
    goto    G0784;
   G0764:
    a = mkfxat(0);
    w3 = a;
    a = value(LL_literals);
    w2 = a;
   G0756:
    if(a == nil) goto    G0757;
    q = car(a);
    a = w1;
    a = CC_Gnumeq(a, q);
    if(a != nil) goto    G0775;
    a = w3;
    a = Ladd1(a);
    w3 = a;
    a = cdr(w2);
    w2 = a;
    goto    G0756;
   G0757:
    a = w1;
    a = Lncons(a);
    q = a;
    a = value(LL_literals);
    a = Lnconc(a, q);
    value(LL_literals) = a;
    a = w1;
    if(!is_symbol(a)) goto    G0773;
    a = CC_c_literalname(a);
    value(LL_lname) = a;
    q = w3;
    a = Llist2(a, q);
    q = a;
    a = LITERAL[264];
    Lvprintf(a, q);
    a = value(LL_lname);
    goto    G0755;
   G0773:
    q = w3;
    a = LITERAL[265];
    goto    G0784;
   G0775:
    a = w1;
    if(!is_symbol(a)) goto    G0778;
    a = CC_c_literalname(a);
    goto    G0755;
   G0778:
    q = w3;
    a = LITERAL[265];
   G0784:
    a = Lsprintf1(a, q);
    goto    G0755;
    a = nil;
   G0755:
    {
        Sex *_w = bstack;
        popbv(0);
        bstack = _w - 2;
    }
    popv(4);
    return a;
}

Sex CC_Hlink(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0793;
    a = w1;
    {
        popv(7);
        return  CC_bTlink(a, q, m, arg4);
    }
   G0793:
    a = w1;
    if(a != LL_car) goto    G0796;
    q = value(LL_block_level);
    a = LITERAL[266];
    goto    G0835;
   G0796:
    if(a != LL_cdr) goto    G0797;
    q = value(LL_block_level);
    a = LITERAL[267];
    goto    G0835;
   G0797:
#define LL_rplaca LITERAL[268]
    if(a != LL_rplaca) goto    G0798;
    q = value(LL_block_level);
    a = LITERAL[269];
    goto    G0835;
   G0798:
#define LL_rplacd LITERAL[270]
    if(a != LL_rplacd) goto    G0799;
    q = value(LL_block_level);
    a = LITERAL[271];
    goto    G0835;
   G0799:
#define LL_iplus2 LITERAL[272]
    if(a != LL_iplus2) goto    G0800;
    q = value(LL_block_level);
    a = LITERAL[273];
    goto    G0835;
   G0800:
#define LL_idifference LITERAL[274]
    if(a != LL_idifference) goto    G0801;
    q = value(LL_block_level);
    a = LITERAL[275];
    goto    G0835;
   G0801:
#define LL_iadd1 LITERAL[276]
    if(a != LL_iadd1) goto    G0802;
    q = value(LL_block_level);
    a = LITERAL[277];
    goto    G0835;
   G0802:
#define LL_isub1 LITERAL[278]
    if(a != LL_isub1) goto    G0803;
    q = value(LL_block_level);
    a = LITERAL[279];
   G0835:
    Lprintf1(a, q);
    goto    G0815;
   G0803:
    a = value(LL_Qstayslow);
    if(a != nil) goto    G0805;
    q = LL_stayslow;
    a = w1;
    a = Lflagp(a, q);
    if(a == nil) goto    G0804;
   G0805:
    a = w1;
    a = CC_literalindex(a);
    w6 = a;
    a = mkfxat(1);
    w5 = a;
    a = w4;
    q = value(LL_block_level);
    if(a == nil) goto    G0807;
    a = LITERAL[280];
    goto    G0836;
   G0807:
    a = LITERAL[281];
   G0836:
    Lprintf1(a, q);
    q = w6;
    a = w3;
    a = Llist2(a, q);
    q = a;
    a = LITERAL[282];
    Lvprintf(a, q);
    w7 = nil;
   G0811:
    q = w3;
    a = w5;
    a = Lleq(a, q);
    if(a == nil) goto    G0820;
    a = w5;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[148];
    Lprintf1(a, q);
    a = w5;
    a = Ladd1(a);
    w5 = a;
    w7 = a;
    goto    G0811;
   G0804:
    a = mkfxat(1);
    w5 = a;
    a = w4;
    q = value(LL_block_level);
    if(a == nil) goto    G0817;
    a = LITERAL[280];
    goto    G0838;
   G0817:
    a = LITERAL[281];
   G0838:
    Lprintf1(a, q);
    a = w1;
    a = CC_c_entryname(a);
    q = a;
    a = LITERAL[283];
    Lprintf1(a, q);
    w7 = nil;
   G0821:
    q = w3;
    a = w5;
    a = Lleq(a, q);
    if(a == nil) goto    G0820;
    a = w5;
    a = Lonep(a);
    if(a == nil) goto    G0825;
    a = w5;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[284];
    goto    G0839;
   G0825:
    a = w5;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[148];
   G0839:
    Lprintf1(a, q);
    a = w5;
    a = Ladd1(a);
    w5 = a;
    w7 = a;
    goto    G0821;
   G0820:
    a = LITERAL[108];
    Lprintf0(a);
   G0815:
    a = nil;
    popv(7);
    return a;
}

Sex CC_Hlinke(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0847;
    a = w1;
    {
        popv(6);
        return  CC_bTlinke(a, q, m, arg4, arg5);
    }
   G0847:
    a = value(LL_Hinitialization_procedure);
    if(a == nil) goto    G0848;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = mkfxat(0);
    a = arg5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0850;
    q = w5;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[162];
    Lvprintf(a, q);
   G0850:
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    CC_Hlink(a, q, m, arg4);
    q = value(LL_block_level);
    a = LITERAL[163];
    Lprintf1(a, q);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[164];
    {
        popv(6);
        return  Lprintf1(a, q);
    }
   G0848:
    a = w1;
    if(a != value(LL_HlnameH)) goto    G0852;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    m = a;
    q = value(LL_Hentry_nameH);
    a = value(LL_block_level);
    a = Llist3(a, q, m);
    q = a;
    a = LITERAL[285];
    {
        popv(6);
        return  Lvprintf(a, q);
    }
   G0852:
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = value(LL_block_level);
    a = LITERAL[150];
    Lprintf1(a, q);
    q = mkfxat(4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = mkfxat(0);
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0857;
    q = w5;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[162];
    Lvprintf(a, q);
   G0857:
    a = mkfxat(1);
    w5 = a;
    a = w1;
    if(a != LL_car) goto    G0860;
    q = value(LL_block_level);
    a = LITERAL[286];
    goto    G0897;
   G0860:
    if(a != LL_cdr) goto    G0861;
    q = value(LL_block_level);
    a = LITERAL[287];
    goto    G0897;
   G0861:
    if(a != LL_rplaca) goto    G0862;
    q = value(LL_block_level);
    a = LITERAL[288];
    goto    G0897;
   G0862:
    if(a != LL_rplacd) goto    G0863;
    q = value(LL_block_level);
    a = LITERAL[289];
    goto    G0897;
   G0863:
    if(a != LL_iplus2) goto    G0864;
    q = value(LL_block_level);
    a = LITERAL[290];
    goto    G0897;
   G0864:
    if(a != LL_idifference) goto    G0865;
    q = value(LL_block_level);
    a = LITERAL[291];
    goto    G0897;
   G0865:
    if(a != LL_iadd1) goto    G0866;
    q = value(LL_block_level);
    a = LITERAL[292];
    goto    G0897;
   G0866:
    if(a != LL_isub1) goto    G0867;
    q = value(LL_block_level);
    a = LITERAL[293];
    goto    G0897;
   G0867:
    if(a != LL_eval) goto    G0868;
    q = value(LL_block_level);
    a = LITERAL[294];
   G0897:
    Lprintf1(a, q);
    goto    G0878;
   G0868:
    a = value(LL_Qstayslow);
    if(a != nil) goto    G0870;
    q = LL_stayslow;
    a = w1;
    a = Lflagp(a, q);
    if(a == nil) goto    G0869;
   G0870:
    a = w1;
    a = CC_literalindex(a);
    m = a;
    q = w3;
    a = value(LL_block_level);
    a = Llist3(a, q, m);
    q = a;
    a = LITERAL[295];
    Lvprintf(a, q);
    w6 = nil;
   G0874:
    q = w3;
    a = w5;
    a = Lleq(a, q);
    if(a == nil) goto    G0881;
    a = w5;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[148];
    Lprintf1(a, q);
    a = w5;
    a = Ladd1(a);
    w5 = a;
    w6 = a;
    goto    G0874;
   G0869:
    a = w1;
    a = CC_c_entryname(a);
    q = a;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[296];
    Lvprintf(a, q);
    w6 = nil;
   G0882:
    q = w3;
    a = w5;
    a = Lleq(a, q);
    if(a == nil) goto    G0881;
    a = w5;
    a = Lonep(a);
    if(a == nil) goto    G0886;
    a = w5;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[284];
    goto    G0899;
   G0886:
    a = w5;
    a = CC_HHarg(a);
    q = a;
    a = LITERAL[148];
   G0899:
    Lprintf1(a, q);
    a = w5;
    a = Ladd1(a);
    w5 = a;
    w6 = a;
    goto    G0882;
   G0881:
    a = LITERAL[108];
    Lprintf0(a);
   G0878:
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    q = a;
    a = LITERAL[164];
    Lprintf1(a, q);
    a = nil;
    popv(6);
    return a;
}

Sex CC_Hdealext(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_HtargetKcpuH);
    if(a != LL_bytecode) goto    G0904;
    a = w1;
    {
        popv(1);
        return  CC_bTdealext(a);
    }
   G0904:
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0907;
    q = w1;
    a = value(LL_block_level);
    a = Llist2(a, q);
    q = a;
    a = LITERAL[162];
    Lvprintf(a, q);
   G0907:
    a = value(LL_Hinitialization_procedure);
    q = value(LL_block_level);
    if(a == nil) goto    G0910;
    a = LITERAL[163];
    goto    G0912;
   G0910:
    a = LITERAL[165];
   G0912:
    Lprintf1(a, q);
    q = mkfxat(-4);
    a = value(LL_block_level);
    a = plus2(a, q);
    value(LL_block_level) = a;
    a = LITERAL[137];
    Lprintf0(a);
    a = nil;
    popv(1);
    return a;
}

Sex CC_c_entryname(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w5 = nil;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w6 = nil;
    w1 = a;
#define LL_centryname LITERAL[297]
    q = LL_centryname;
    a = Lget(a, q);
    w5 = a;
    if(a != nil) goto    G0917;
    a = LITERAL[298];
    w3 = a;
    a = w1;
    a = Lexplodec(a);
    w6 = a;
    w7 = nil;
   G0921:
    a = w6;
    if(a == nil) goto    G0920;
    a = car(a);
    w2 = a;
    a = cdr(w6);
    w6 = a;
    a = w2;
    if(a != CHAR_OF(95)) goto    G0925;
    q = w3;
    a = CHAR_OF(95);
    goto    G0934;
   G0925:
    a = Lliter(a);
    if(a != nil) goto    G0927;
    a = w2;
    a = Ldigitp(a);
    if(a == nil) goto    G0926;
   G0927:
    q = w3;
    a = w2;
    goto    G0934;
   G0926:
#define LL_conv_table LITERAL[299]
    q = value(LL_conv_table);
    a = w2;
    a = Latsoc(a, q);
    w4 = a;
    q = w3;
    if(a == nil) goto    G0928;
    a = cdr(a);
    goto    G0934;
   G0928:
    a = CHAR_OF(90);
   G0934:
    a = cons(a, q);
    w3 = a;
    w7 = a;
    goto    G0921;
   G0920:
    q = w3;
    a = CHAR_OF(34);
    a = cons(a, q);
    w3 = a;
    a = Lreverse(a);
    a = Lcompress(a);
   G0917:
    popv(7);
    return a;
}

Sex CC_c_literalname(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w2 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = LITERAL[300];
    w3 = a;
    a = w1;
    a = Lexplodec(a);
    w6 = a;
    w7 = nil;
   G0941:
    a = w6;
    if(a == nil) goto    G0940;
    a = car(a);
    w2 = a;
    a = cdr(w6);
    w6 = a;
    a = w2;
    if(a != CHAR_OF(95)) goto    G0945;
    q = w3;
    a = CHAR_OF(95);
    goto    G0954;
   G0945:
    a = Lliter(a);
    if(a != nil) goto    G0947;
    a = w2;
    a = Ldigitp(a);
    if(a == nil) goto    G0946;
   G0947:
    q = w3;
    a = w2;
    goto    G0954;
   G0946:
    q = value(LL_conv_table);
    a = w2;
    a = Latsoc(a, q);
    w4 = a;
    q = w3;
    if(a == nil) goto    G0948;
    a = cdr(a);
    goto    G0954;
   G0948:
    a = CHAR_OF(90);
   G0954:
    a = cons(a, q);
    w3 = a;
    w7 = a;
    goto    G0941;
   G0940:
    q = w3;
    a = CHAR_OF(34);
    a = cons(a, q);
    w3 = a;
    a = Lreverse(a);
    {
        popv(7);
        return  Lcompress(a);
    }
}



/* initialization procedure */
int init_cfap(void)
{
   long i;

   create_symbols(cfap_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; cfap_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(cfap_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m;
        a = LITERAL[301];
        CC_Aenter(a);
        q = LL_compile;
        a = LITERAL[302];
        Lflag(a, q);
        a = LITERAL[303];
        Lfluid(a);
        a = LITERAL[304];
        Lglobal(a);
        m = LITERAL[305];
        q = LL_macro;
#define LL_printf LITERAL[306]
        a = LL_printf;
        Lput(a, q, m);
        m = LITERAL[307];
        q = LL_macro;
#define LL_sprintf LITERAL[308]
        a = LL_sprintf;
        Lput(a, q, m);
#define LL_ignore LITERAL[309]
        q = LL_ignore;
        a = LITERAL[310];
        Lflag(a, q);
        a = LITERAL[311];
        Lglobal(a);
        q = LL_mc;
        a = LITERAL[312];
        Lflag(a, q);
        q = LL_mcKjump;
        a = LITERAL[313];
        Lflag(a, q);
        a = mkfxat(0);
        value(LL_block_level) = a;
#define LL_comtst LITERAL[314]
        q = LL_comtst;
        a = LITERAL[315];
        Ldeflist(a, q);
        q = LL_mc;
        a = LITERAL[316];
        Lflag(a, q);
#define LL_anyreg LITERAL[317]
        q = LL_anyreg;
        a = LITERAL[318];
        Ldeflist(a, q);
        a = LITERAL[319];
        value(LL_conv_table) = a;
        q = LL_centryname;
        a = LITERAL[320];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[321];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[322];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[323];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[324];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[325];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[326];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[327];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[328];
        Ldeflist(a, q);
        q = LL_centryname;
        a = LITERAL[329];
        a = Ldeflist(a, q);
        return 1;
    }
}
Sex LITERAL[331];

const  char *cfap_literal_string[331] =
{
/* 0 */
"printf0",
/* 1 */
"printf1",
/* 2 */
"list",
/* 3 */
"vprintf",
/* 4 */
"sprintf0",
/* 5 */
"sprintf1",
/* 6 */
"vsprintf",
/* 7 */
"de",
/* 8 */
"lambda",
/* 9 */
"expr",
/* 10 */
"df",
/* 11 */
"fexpr",
/* 12 */
"dm",
/* 13 */
"macro",
/* 14 */
"ds",
/* 15 */
"smacro",
/* 16 */
"put",
/* 17 */
"initials",
/* 18 */
"putd",
/* 19 */
"quote",
/* 20 */
"compile",
/* 21 */
"eval!-when",
/* 22 */
"progn",
/* 23 */
"letfn",
/* 24 */
"!*module",
/* 25 */
"modcmp",
/* 26 */
"\"OF TYPE\"",
/* 27 */
"\"UNCOMPILABLE FUNCTION\"",
/* 28 */
"lose",
/* 29 */
"\" not defined (LOSE flag)\"",
/* 30 */
"(expr fexpr)",
/* 31 */
"cfntype",
/* 32 */
"!*entry",
/* 33 */
"lap",
/* 34 */
"sugar!_initialization!_procedure",
/* 35 */
"!*init!_entry",
/* 36 */
"ccompile",
/* 37 */
"currentfn",
/* 38 */
"entrynames",
/* 39 */
"literals",
/* 40 */
"ccompile1",
/* 41 */
"dfprint!*",
/* 42 */
"!.nomessage",
/* 43 */
"dfdebug!*",
/* 44 */
"filename",
/* 45 */
"pathname",
/* 46 */
"!*initialization!_procedure",
/* 47 */
"\"%p/g_%p.c\"",
/* 48 */
"\"g_%p.c\"",
/* 49 */
"!.outfile",
/* 50 */
"output",
/* 51 */
"\"#include <stdlib.h>%n\"",
/* 52 */
"\"#include <stdarg.h>%n\"",
/* 53 */
"\"#include <string.h>%n\"",
/* 54 */
"\"#include <ctype.h>%n\"",
/* 55 */
"\"#include \"\"config.h\"\"%n\"",
/* 56 */
"\"#include \"\"tags.h\"\"%n\"",
/* 57 */
"\"#include \"\"errors.h\"\"%n\"",
/* 58 */
"\"#include \"\"externs.h\"\"%n\"",
/* 59 */
"\"#include \"\"arith.h\"\"%n\"",
/* 60 */
"\"#include \"\"macros.h\"\"%n\"",
/* 61 */
"\"#include \"\"entries.h\"\"%n\"",
/* 62 */
"!.stayslow",
/* 63 */
"\"#include \"\"gprotos.h\"\"%n\"",
/* 64 */
"\"#include \"\"g_%p.h\"\"%n\"",
/* 65 */
"\"%n\"",
/* 66 */
"\"extern Sex *literal_vectors[];%n\"",
/* 67 */
"\"extern int number_of_literal_vectors;%n\"",
/* 68 */
"\"Sex %p_literal_vector[];%n\"",
/* 69 */
"\"const char *%p_literal_string[];%n\"",
/* 70 */
"\"setup_type const  %p_g_setup[];%n\"",
/* 71 */
"\"#define LITERAL %p_literal_vector%n\"",
/* 72 */
"\"%n%n%n\"",
/* 73 */
"!*defn",
/* 74 */
"\"/* initialization procedure */%n\"",
/* 75 */
"\"int init_%p(void)%n\"",
/* 76 */
"\"{%n\"",
/* 77 */
"\"   long i;%n\"",
/* 78 */
"\"   create_symbols(%p_g_setup);%n\"",
/* 79 */
"\"   literal_vectors[number_of_literal_vectors++] =%n\"",
/* 80 */
"\"               LITERAL;%n\"",
/* 81 */
"\"   for(i = 0; %p_literal_string[i] != NULL; i++)%n\"",
/* 82 */
"\"           LITERAL[i]%n\"",
/* 83 */
"\"               = make_literal(%p_literal_string[i]);%n\"",
/* 84 */
"\"   LITERAL[i] = (Sex)NULL;%n\"",
/* 85 */
"block!_level",
/* 86 */
"\"Sex LITERAL[%p];%n\"",
/* 87 */
"\"%nconst  char *%p_literal_string[%p] =%n\"",
/* 88 */
"\"/* %p */%n\"\"%a\"\",%n\"",
/* 89 */
"\"/* %p */ NULL%n};%n\"",
/* 90 */
"\"setup_type const %p_g_setup[] =%n\"",
/* 91 */
"entry",
/* 92 */
"\"    {\"\"%p\"\", (lisp_proc *)%p, \"",
/* 93 */
"\"-1},%n\"",
/* 94 */
"\"-2},%n\"",
/* 95 */
"\"%p},%n\"",
/* 96 */
"\"    {NULL, NULL, 0 }%n\"",
/* 97 */
"\"};%n\"",
/* 98 */
"\"%p/g_%p.h\"",
/* 99 */
"\"g_%p.h\"",
/* 100 */
"\"#ifndef _G_%U_H_%n\"",
/* 101 */
"\"#define _G_%U_H_%n\"",
/* 102 */
"stayslow",
/* 103 */
"\"static Sex %p(\"",
/* 104 */
"\"extern Sex %p(\"",
/* 105 */
"\"Sex \"",
/* 106 */
"\", Sex\"",
/* 107 */
"\"void\"",
/* 108 */
"\");%n\"",
/* 109 */
"\"#endif%n\"",
/* 110 */
"\"UnCCOMP'd:\"",
/* 111 */
"winp",
/* 112 */
"ccompiles",
/* 113 */
"ccompiles1",
/* 114 */
"!*bakgag",
/* 115 */
"\"CCOMP aborted, in\"",
/* 116 */
"ccompify",
/* 117 */
"setq",
/* 118 */
"(comment quote)",
/* 119 */
"eval",
/* 120 */
"!*target!-cpu!*",
/* 121 */
"mc",
/* 122 */
"subr",
/* 123 */
"fsubr",
/* 124 */
"\"UNCOMPILABLE TYPE\"",
/* 125 */
"\"/*\"",
/* 126 */
"\"Duplicate entryname:\"",
/* 127 */
"\"*/\"",
/* 128 */
"!*plap",
/* 129 */
"!*lname!*",
/* 130 */
"!*recursive!*",
/* 131 */
"registers",
/* 132 */
"!*store",
/* 133 */
"!*load",
/* 134 */
"mc!-jump",
/* 135 */
"!*linke",
/* 136 */
"\"non macro call : %p%n\"",
/* 137 */
"\"}%n\"",
/* 138 */
"!*subr",
/* 139 */
"!*holddef",
/* 140 */
"bytecode",
/* 141 */
"exitstack!*",
/* 142 */
"exitlab!*",
/* 143 */
"\"Sex %p(\"",
/* 144 */
"\"Sex a\"",
/* 145 */
"\", Sex %p\"",
/* 146 */
"\")%n{%n\"",
/* 147 */
"\"%TSex %p\"",
/* 148 */
"\", %p\"",
/* 149 */
"\";%n\"",
/* 150 */
"\"%T{%n\"",
/* 151 */
"!*entry!_name!*",
/* 152 */
"\"%TSex *sp = stack+%p;%n\"",
/* 153 */
"\"%Tlong i;%n\"",
/* 154 */
"\"%TSex _nil = nil;%n\"",
/* 155 */
"\"%Tstackcheck();%n\"",
/* 156 */
"\"%Tfor(i = 0; i < %p; i++) *sp-- = _nil;%n\"",
/* 157 */
"\"%TSex *sp = stack;%n\"",
/* 158 */
"\"%Tsp[%p] = nil;%n\"",
/* 159 */
"\"%Tstack = sp + %p;%n\"",
/* 160 */
"\"%p:%n\"",
/* 161 */
"\"%Tw%p = nil;%n\"",
/* 162 */
"\"%Tpopv(%p);%n\"",
/* 163 */
"\"%Treturn 1;%n\"",
/* 164 */
"\"%T}%n\"",
/* 165 */
"\"%Treturn a;%n}%n\"",
/* 166 */
"\"arg%p\"",
/* 167 */
"\"w%p\"",
/* 168 */
"\"%Tgoto %p;%n\"",
/* 169 */
"null",
/* 170 */
"\"%Tif(%p == nil) goto %p;%n\"",
/* 171 */
"atom",
/* 172 */
"\"%Tif(!is_cons(%p)) goto %p;%n\"",
/* 173 */
"pairp",
/* 174 */
"\"%Tif(is_cons(%p)) goto %p;%n\"",
/* 175 */
"idp",
/* 176 */
"\"%Tif(is_symbol(%p)) goto %p;%n\"",
/* 177 */
"stringp",
/* 178 */
"\"%Tif(is_string(%p)) goto %p;%n\"",
/* 179 */
"vectorp",
/* 180 */
"\"%Tif(is_vector(%p)) goto %p;%n\"",
/* 181 */
"numberp",
/* 182 */
"\"%Tif(is_number(%p)) goto %p;%n\"",
/* 183 */
"becomplexp",
/* 184 */
"\"%Tif(is_becomplex(%p)) goto %p;%n\"",
/* 185 */
"befloatp",
/* 186 */
"\"%Tif(is_befloat(%p)) goto %p;%n\"",
/* 187 */
"bigp",
/* 188 */
"\"%Tif(is_bigint(%p)) goto %p;%n\"",
/* 189 */
"bintervalp",
/* 190 */
"\"%Tif(is_binterval(%p)) goto %p;%n\"",
/* 191 */
"complexp",
/* 192 */
"\"%Tif(is_complex(%p)) goto %p;%n\"",
/* 193 */
"complp",
/* 194 */
"ecomplexp",
/* 195 */
"\"%Tif(is_ecomplx(%p)) goto %p;%n\"",
/* 196 */
"efloatp",
/* 197 */
"\"%Tif(is_efloat(%p)) goto %p;%n\"",
/* 198 */
"fixp",
/* 199 */
"\"%Tif(is_integer(%p)) goto %p;%n\"",
/* 200 */
"floatp",
/* 201 */
"\"%Tif(is_float(%p)) goto %p;%n\"",
/* 202 */
"bfloatp",
/* 203 */
"\"%Tif(is_bfloat(%p)) goto %p;%n\"",
/* 204 */
"intervalp",
/* 205 */
"\"%Tif(is_interval(%p)) goto %p;%n\"",
/* 206 */
"intp",
/* 207 */
"intvalp",
/* 208 */
"logicalp",
/* 209 */
"\"%Tif(is_logical(%p)) goto %p;%n\"",
/* 210 */
"logp",
/* 211 */
"rationalp",
/* 212 */
"\"%Tif(is_rational(%p)) goto %p;%n\"",
/* 213 */
"ratnp",
/* 214 */
"\"%Terror(\"\"bad test type(%p)\"\"); goto %p;%n\"",
/* 215 */
"\"%Tif(%p != nil) goto %p;%n\"",
/* 216 */
"\"%Tif(!is_symbol(%p)) goto %p;%n\"",
/* 217 */
"\"%Tif(!is_string(%p)) goto %p;%n\"",
/* 218 */
"\"%Tif(!is_vector(%p)) goto %p;%n\"",
/* 219 */
"\"%Tif(!is_number(%p)) goto %p;%n\"",
/* 220 */
"\"%Tif(!is_becomplex(%p)) goto %p;%n\"",
/* 221 */
"\"%Tif(!is_befloat(%p)) goto %p;%n\"",
/* 222 */
"\"%Tif(!is_bigint(%p)) goto %p;%n\"",
/* 223 */
"\"%Tif(!is_binterval(%p)) goto %p;%n\"",
/* 224 */
"\"%Tif(!is_complex(%p)) goto %p;%n\"",
/* 225 */
"\"%Tif(!is_ecomplx(%p)) goto %p;%n\"",
/* 226 */
"\"%Tif(!is_efloat(%p)) goto %p;%n\"",
/* 227 */
"\"%Tif(!is_integer(%p)) goto %p;%n\"",
/* 228 */
"\"%Tif(!is_float(%p)) goto %p;%n\"",
/* 229 */
"\"%Tif(!is_bfloat(%p)) goto %p;%n\"",
/* 230 */
"\"%Tif(!is_interval(%p)) goto %p;%n\"",
/* 231 */
"\"%Tif(!is_logical(%p)) goto %p;%n\"",
/* 232 */
"\"%Tif(!is_rational(%p)) goto %p;%n\"",
/* 233 */
"\"%Tif(%p == %p) goto %p;%n\"",
/* 234 */
"\"%Tif(%p != %p) goto %p;%n\"",
/* 235 */
"\"%Tif(lessp(%p , %p)) goto %p;%n\"",
/* 236 */
"\"%Tif(lesseq(%p , %p)) goto %p;%n\"",
/* 237 */
"\"%Tif(%p >= %p) goto %p;%n\"",
/* 238 */
"\"%Tif(%p > %p) goto %p;%n\"",
/* 239 */
"\"%Tif(%p <= %p) goto %p;%n\"",
/* 240 */
"\"%Tif(%p < %p) goto %p;%n\"",
/* 241 */
"\"%TSex *_w = bstack, *_v;%n\"",
/* 242 */
"\"%Tbstackcheck();%n\"",
/* 243 */
"\"not fluid\"",
/* 244 */
"\"%Tpushbv(%p, %p, %p);%n\"",
/* 245 */
"\"%Tbstack = _w + %p;%n\"",
/* 246 */
"\"%Tpushbv(%p, %p, nil);%n\"",
/* 247 */
"\"%TSex *_w = bstack;%n\"",
/* 248 */
"\"%Tpopbv(%p);%n\"",
/* 249 */
"\"%Tbstack = _w - %p;%n\"",
/* 250 */
"\"%T%p = %p;%n\"",
/* 251 */
"'nil",
/* 252 */
"'t",
/* 253 */
"true",
/* 254 */
"(fluid global)",
/* 255 */
"\"value(%p)\"",
/* 256 */
"car",
/* 257 */
"\"car(%p)\"",
/* 258 */
"cdr",
/* 259 */
"\"cdr(%p)\"",
/* 260 */
"\"incomplete macro definition for\"",
/* 261 */
"lname",
/* 262 */
"\"CHAR_OF(%p)\"",
/* 263 */
"\"mkfxat(%p)\"",
/* 264 */
"\"#define %p LITERAL[%p]%n\"",
/* 265 */
"\"LITERAL[%p]\"",
/* 266 */
"\"%Ta = car(a);%n\"",
/* 267 */
"\"%Ta = cdr(a);%n\"",
/* 268 */
"rplaca",
/* 269 */
"\"%Tcar(a) = q;%n\"",
/* 270 */
"rplacd",
/* 271 */
"\"%Tcdr(a) = q;%n\"",
/* 272 */
"iplus2",
/* 273 */
"\"%Ta = (Sex)((long)a + (long)q - TAG_FIXNUM);%n\"",
/* 274 */
"idifference",
/* 275 */
"\"%Ta = (Sex)((long)a - (long)q + TAG_FIXNUM);%n\"",
/* 276 */
"iadd1",
/* 277 */
"\"%Ta = (Sex)((long)a + 0x10);%n\"",
/* 278 */
"isub1",
/* 279 */
"\"%Ta = (Sex)((long)a - 0x10);%n\"",
/* 280 */
"\"%Ta = \"",
/* 281 */
"\"%T\"",
/* 282 */
"\"apply%p(%p\"",
/* 283 */
"\"%p(\"",
/* 284 */
"\"%p\"",
/* 285 */
"\"%Tgoto %p;  /* recursive call to %p */%n\"",
/* 286 */
"\"%Treturn car(a);%n\"",
/* 287 */
"\"%Treturn cdr(a);%n\"",
/* 288 */
"\"%Tcar(a) = q;%n return a;%n\"",
/* 289 */
"\"%Tcdr(a) = q;%n return a;%n\"",
/* 290 */
"\"%Treturn (Sex)((long)a + (long)q - TAG_FIXNUM);%n\"",
/* 291 */
"\"%Treturn (Sex)((long)a - (long)q + TAG_FIXNUM);%n\"",
/* 292 */
"\"%Treturn (Sex)((long)a + 0x10);%n\"",
/* 293 */
"\"%Treturn (Sex)((long)a - 0x10);%n\"",
/* 294 */
"\"%Treturn eval(a, nil);%n\"",
/* 295 */
"\"%Treturn  apply%p(%p\"",
/* 296 */
"\"%Treturn  %p(\"",
/* 297 */
"centryname",
/* 298 */
"(!_ C C !\")",
/* 299 */
"conv!_table",
/* 300 */
"(!_ L L !\")",
/* 301 */
"(lisp)",
/* 302 */
"(smacro)",
/* 303 */
"(!*defn filename pathname exitlab!* exitstack!* registers conv!_table)",
/* 304 */
"(!*bakgag dfprint!* dfdebug!* !.nomessage !*lname!* !*entry!_name!* !*recursive!* block!_level !*initialization!_procedure currentfn entrynames literals initials !*module !*plap !*holddef !.stayslow)",
/* 305 */
"((!,u) (cond ((cdr !,u) (cond ((equal (cddr !,u) nil) (list 'printf0 (cadr !,u))) ((equal (cdddr !,u) nil) (list 'printf1 (cadr !,u) (caddr !,u))) (t (list 'vprintf (cadr !,u) (cond ((cddr !,u) (cons 'list (cddr !,u))))))))))",
/* 306 */
"printf",
/* 307 */
"((!,u) (cond ((cdr !,u) (cond ((equal (cddr !,u) nil) (list 'sprintf0 (cadr !,u))) ((equal (cdddr !,u) nil) (list 'sprintf1 (cadr !,u) (caddr !,u))) (t (list 'vsprintf (cadr !,u) (cond ((cddr !,u) (cons 'list (cddr !,u))))))))))",
/* 308 */
"sprintf",
/* 309 */
"ignore",
/* 310 */
"(ccompend)",
/* 311 */
"(!*holddef)",
/* 312 */
"(!*alloc !*dealloc !*entry !*exit !*store !*jump !*jumpc !*jumpnc !*jumpt !*jumpnil !*jumpe !*jumpn !*jumpge !*jumpgt !*jumple !*jumplt !*jumpige !*jumpigt !*jumpile !*jumpilt !*lbl !*lambind !*progbind !*freerstr !*comment !*init!_entry !*move !*load !*link !*linke !*code)",
/* 313 */
"(!*jump !*jumpc !*jumpnc !*jumpt !*jumpnil !*jumpe !*jumpn !*jumpge !*jumpgt !*jumple !*jumplt !*jumpige !*jumpigt !*jumpile !*jumpilt !*link !*linke)",
/* 314 */
"comtst",
/* 315 */
"((atom !&testfn) (null !&testfn) (idp !&testfn) (numberp !&testfn) (logp !&testfn) (floatp !&testfn) (bigp !&testfn) (stringp !&testfn) (pairp !&testfn) (fixp !&testfn) (vectorp !&testfn) (rationalp !&testfn) (ratnp !&testfn) (intp !&testfn) (logicalp !&testfn) (floatp !&testfn) (bfloatp !&testfn) (complexp !&testfn) (complp !&testfn) (ecomplexp !&testfn) (becomplexp !&testfn) (efloatp !&testfn) (befloatp !&testfn) (intervalp !&testfn) (intvalp !&testfn) (bintervalp !&testfn))",
/* 316 */
"(!*dealext !*noop)",
/* 317 */
"anyreg",
/* 318 */
"((car (lambda (x y) ((move (y a6) x) (move (x) x)))) (cdr (lambda (x y) ((move (y a6) x) (move (4 x) x)))))",
/* 319 */
"((!  . A) (!! . B) (!# . C) (!$ . D) (!% . E) (!^ . F) (!& . G) (!* . H) (!( . I) (!) . J) (!- . K) (!+ . L) (!= . M) (!\\ . N) (!| . O) (!, . P) (!. . Q) (!< . R) (!> . S) (!: . T) (!; . U) (!/ . V) (!? . W) (!~ . X) (!` . Y))",
/* 320 */
"((frexp Lfrexp) (ceiling Lceiling) (floor Lfloor) (lcm Llcm) (round Lround) (fix Ltruncate) (gcdn gcd) (gcd gcd) (denominator Ldenominator) (numerator Lnumerator) (ash Lash) (ash1 Lash1) (divide Ldivide) (evenp Levenp) (float Lfloat) (inorm Linorm) (logand2 logand2) (logeqv2 logeqv2) (lognot lognot) (logxor2 logxor2) (logor2 logor2) (lsd Llsd) (srandom Lsrandom) (random Lrandom) (next!-random!-number Lnext!_random) (max2 Lmax2) (min2 Lmin2) (minus Lminus) (minusp Lminusp) (mod modulus) (msd Lmsd) (oddp Loddp) (onep Lonep) (plus2 plus2) (plusp Lplusp) (rational Lrational) (times2 times2) (zerop Lzerop) (add1 Ladd1) (difference diff2) (eqn Leqn) (geq Lgeq) (greaterp Lgreaterp) (leq Lleq) (lessp Llessp) (ratio ratio2) (quotient quot2) (remainder remaind2) (sub1 Lsub1) (mkrational Lmkrational) (mkcomplex Lmkcomplex) (mkefloat Lmkefloat) (mkbfloat Lbfloat) (mkbefloat Lmkbefloat) (char!-code Lchar!_code) (char!-downcase Lchar!_downcase) (code!-char Lcode!_char1) (code!-char2 Lcode!_char2) (special!-char Lspecial!_char) (digit Ldigitp) (liter Lliter) (is!-char Lis!_char) (is!-wchar Lis!_wchar) (seprp Lseprp) (apply Lapply) (apply0 Lapply0) (apply1 Lapply1) (apply2 Lapply2) (apply3 Lapply3) (evlis Levlis) (funcall Lfuncall) (funcall0 Lfuncall0) (funcall1 Lfuncall1) (funcall2 Lfuncall2) (funcall3 Lfuncall3) (verbos Lverbos))",
/* 321 */
"((errorset1 Lerrorset1) (errorset2 Lerrorset2) (errorset Lerrorset) (reclaim Lgc) (gc Lgc) (acons Lacons) (atom Latom) (boundp Lboundp) (car Lcar) (cdr Lcdr) (caar Lcaar) (cadr Lcadr) (cdar Lcdar) (cddr Lcddr) (caaar Lcaaar) (caadr Lcaadr) (cadar Lcadar) (caddr Lcaddr) (cdaar Lcdaar) (cdadr Lcdadr) (cddar Lcddar) (cdddr Lcdddr) (caaaar Lcaaaar) (caaadr Lcaaadr) (caadar Lcaadar) (caaddr Lcaaddr) (cadaar Lcadaar) (cadadr Lcadadr) (caddar Lcaddar) (cadddr Lcadddr) (cdaaar Lcdaaar) (cdaadr Lcdaadr) (cdadar Lcdadar) (cdaddr Lcdaddr) (cddaar Lcddaar) (cddadr Lcddadr) (cdddar Lcdddar) (cddddr Lcddddr) (codep Lcodep) (bytecodep Lbytecodep) (constantp Lconstantp) (date Ldate) (error Lerror) (error1 Lerror1) (fixp Lfixp) (bigp Lbigp) (logicalp Llogicalp) (floatp Lfloatp) (bfloatp Lbfloatp) (rationalp Lrationalp) (complexp Lcomplexp) (complp Lcomplexp) (ecomplexp Lecomplexp) (becomplexp Lbecomplexp) (efloatp Lefloatp) (befloatp Lbefloatp) (intervalp Lintervalp) (intvalp Lintervalp) (bintervalp Lbintervalp) (fluidp Lfluidp) (gctime Lgctime) (get Lget) (globalp Lglobalp) (list2 Llist2) (list3 Llist3) (list4 Llist4) (list5 Llist5) (global Lglobal) (fluid Lfluid) (mkquote Lmkquote) (cons cons) (xcons Lxcons) (ncons Lncons))",
/* 322 */
"((numberp Lnumberp) (pair Lpair) (put Lput) (remprop Lremprop) (rplaca Lrplaca) (rplacd Lrplacd) (special!-formp Lspecial!_form!_p) (stop Lstop) (time Ltime) (union Lunion) (unionq Lunionq) (intersection Lintersection) (intersectionq Lintersectionq) (unglobal Lunglobal) (unfluid Lunfluid) (flag Lflag) (flagp Lflagp) (flagpcar Lflagpcar) (flagp!*!* Lflagp) (get!* Lget) (idp Lidp) (pairp Lpairp) (remflag Lremflag) (set Lset) (stringp Lstringp) (vectorp Lvectorp) (append Lappend) (eq Leq) (eqcar Leqcar) (eql Leql) (equal Lequal) (endp Lendp) (getd Lgetd) (length Llength) (putd Lputd) (remd Lremd) (trace Ltrace) (untrace Luntrace) (symbol!-name Lsymbol!_name) (plist Lplist) (putv Lputv) (upbv Lupbv) (memq Lmemq) (nconc Lnconc) (aconc Laconc) (map Lmap) (mapc Lmapc) (mapcar Lmapcar) (maplist Lmaplist) (mapcan Lmapcan) (mapcon Lmapcon) (neq Lneq) (not Lnull) (null Lnull) (reverse Lreverse) (smemq Lsmemq) (subla Lsubla) (sublis Lsublis) (delete Ldelete) (deleq Ldeleq) (assoc Lassoc) (atsoc Latsoc) (assq Latsoc) (getv Lgetv) (member Lmember) (mkvect Lmkvect) (reversip Lnreverse) (subst Lsubst) (quit Lquit) (bye Lbye) (deflist Ldeflist) (expand Lexpand) (copy Lcopy) (xn Lxn) (last Llast) (num Lnum) (den Lden) (printprompt Lprintprompt) (printaddr Lprintaddr) (traceall Ltraceall))",
/* 323 */
"((modular!-difference Lmodular!_difference) (modular!-minus Lmodular!_minus) (modular!-number Lmodular!_number) (modular!-plus Lmodular!_plus) (modular!-quotient Lmodular!_quotient) (modular!-reciprocal Lmodular!_reciprocal) (modular!-times Lmodular!_times) (modular!-expt Lmodular!_expt) (set!-small!-modulus Lset!_small!_modulus) (iadd1 Liadd1) (idifference Lidifference) (igeq Ligeq) (igreaterp Ligreaterp) (ileq Lileq) (ilessp Lilessp) (ilogand2 Lilogand2) (ilogor2 Lilogor2) (ilogxor2 Lilogxor2) (imax2 Limax2) (imin2 Limin2) (iminus Liminus) (iminusp Liminusp) (iplus2 Liplus2) (iquotient Liquotient) (iremainder Liremainder) (irightshift Lirightshift) (isub1 Lisub1) (itimes Litimes2) (itimes2 Litimes2) (ionep Lionep) (izerop Lizerop) (eject Leject) (filep Lfilep) (filedate Lfiledate) (flush Lflush) (lengthc Llengthc) (linelength Llinelength) (lposn Llposn) (open Lopen) (pagelength Lpagelength) (posn Lposn) (spaces Lxtab) (terpri Lterpri) (mkstemp Lmkstemp) (ttab Lttab) (wrs Lwrs) (xtab Lxtab) (close Lclose) (explode Lexplode) (explodew Lexplodew) (explodec Lexplodec) (explode2 Lexplodec) (exploden Lexploden) (explodecn Lexplodecn) (explode2n Lexplodecn) (prin Lprin) (prin1 Lprin) (princ Lprinc) (prin2 Lprinc) (prin2a Lprin2a) (print Lprint) (printc Lprintc) (fflush Lfflush) (feject Lfeject) (fterpri Lfterpri))",
/* 324 */
"((fprin Lfprin) (fprin1 Lfprin) (fprinc Lfprinc) (fprin2 Lfprinc) (fprin2a Lfprin2a) (fprint Lfprint) (fprintc Lfprintc) (vprintf Lvprintf) (vsprintf Lvsprintf) (vfprintf Lvfprintf) (printf0 Lprintf0) (sprintf0 Lsprintf0) (fprintf0 Lfprintf0) (printf1 Lprintf1) (sprintf1 Lsprintf1) (fprintf1 Lfprintf1) (set!-print!-precision Lprint!_precision) (tyo Ltyo) (batchp Lbatchp) (compress Lcompress) (mk!.id Lmake!_id) (rseek Lrseek) (rtell Lrtell) (gensym Lgensym) (gensym1 Lgensym1) (getenv Lgetenv) (intern Lintern) (orderp Lorderp) (rds Lrds) (read Lread) (read!_from!_string Lread!_from!_string) (setpchar Lsetpchar) (spool Lspool) (system Lsystem) (tyi Ltyi) (remob Lremob) (load Lload) (readch Lreadch) (abs Labs) (acos Lacos) (acosh Lacosh) (asec Lasec) (asech Lasech) (asin Lasin) (asinh Lasinh) (atan2 Latan2) (atanh Latanh) (cbrt Lcbrt) (cos Lcos) (cosh Lcosh) (exp Lexp) (expt Lexpt) (hypot Lhypot) (ln Llog) (log Llog) (log10 Llog10) (sec Lsec) (sech Lsech) (sin Lsin) (sinh Lsinh) (sqrt Lsqrt) (tan Ltan) (tanh Ltanh))",
/* 325 */
"((logb Llog!_2) (atan Latan) (eval Leval) (itvalp Lintervalp) (ecomplp Lecomplexp) (precision Lprecision) (isxdigit Lxdigitp) (strcat Lstrcat) (prin2t Lprin2t) (lprim Llprim) (lprie Llprie) (!#itvlow Linterval!_lower) (!#itvupp Linterval!_upper) (!#itvmid Linterval!_mid) (!#itvwid Linterval!_width) (!#itv Lmkinterval) (!#c Lmkcomplex) (!#cc Lcomplex!_conjugate) (!#ef Lmkefloat) (!#ec Lmkecomplex) (!#epart Lefloat!_error) (!#bef Lmkbefloat) (!#vpart Lefloat!_value) (!#cepart Lecomplex!_error) (!#rvpart Lecomplex!_real) (!#ivpart Lecomplex!_imag) (!#rpart Lcomplex!_real) (!#ipart Lcomplex!_imag) (dm Ldm!_fn) (df Ldf!_fn) (ds Lds!_fn) (de Lde!_fn))",
/* 326 */
"((file!-line Lfile!_line) (gen!-prime Lgen!_prime) (listp Llistp) (nth Lnth))",
/* 327 */
"((!#bepart Lbefloat!_error) (!#bvpart Lbefloat!_value) (!#cvpart Lecomplex!_value) (!#bef Lmkbefloat))",
/* 328 */
"((setarray1 Lsetarray1) (setarray2 Lsetarray2) (setarray3 Lsetarray3) (getarray1 Lgetarray1) (getarray2 Lgetarray2) (getarray3 Lgetarray3) (mkarray1 Lmkarray1) (mkarray2 Lmkarray2) (mkarray3 Lmkarray3))",
/* 329 */
"((!&bporg Lanpbporg) (!&bpend Lanpbpend) (bpsleft Lbpsleft) (bpsmove Lbpsmove) (!&relink Lrelink) (!&fastlink Lfastlink) (!&logx Llogx) (bufid Lbufid) (buft Lbuft) (buf1 Lbuf1) (buf2 Lbuf2) (buf4 Lbuf4) (buf4a Lbuf4a) (chrbg Lchrbg) (chr1 Lchr1) (chr2 Lchr2) (chr4 Lchr4) (chrt Lchrt) (plant Lplant) (planta Lplanta) (phex Lphex) (logical Llogical) (leftshift Lleftshift) (fslwopen Lfslwopen) (fslropen Lfslropen) (fslwclose Lfslwclose) (fslrclose Lfslrclose) (get!_number!_of!_args Lget!_number!_of!_args) (is!_macro Lis!_macro) (is!_special Lis!_special))",
/* 330 */ NULL
};
setup_type const cfap_g_setup[] =
{
    {"c_literalname", (lisp_proc *)CC_c_literalname, 1},
    {"c_entryname", (lisp_proc *)CC_c_entryname, 1},
    {"*dealext", (lisp_proc *)CC_Hdealext, 1},
    {"*linke", (lisp_proc *)CC_Hlinke, 5},
    {"*link", (lisp_proc *)CC_Hlink, 4},
    {"literalindex", (lisp_proc *)CC_literalindex, 1},
    {"*address", (lisp_proc *)CC_Haddress, 1},
    {"*move", (lisp_proc *)CC_Hmove, 2},
    {"*store", (lisp_proc *)CC_Hstore, 2},
    {"*load", (lisp_proc *)CC_Hload, 2},
    {"*freerstr", (lisp_proc *)CC_Hfreerstr, 1},
    {"*progbind", (lisp_proc *)CC_Hprogbind, 1},
    {"*lambind", (lisp_proc *)CC_Hlambind, 2},
    {"*lbl", (lisp_proc *)CC_Hlbl, 1},
    {"*jumpilt", (lisp_proc *)CC_Hjumpilt, 3},
    {"*jumpile", (lisp_proc *)CC_Hjumpile, 3},
    {"*jumpigt", (lisp_proc *)CC_Hjumpigt, 3},
    {"*jumpige", (lisp_proc *)CC_Hjumpige, 3},
    {"*jumplt", (lisp_proc *)CC_Hjumplt, 3},
    {"*jumple", (lisp_proc *)CC_Hjumple, 3},
    {"*jumpgt", (lisp_proc *)CC_Hjumpgt, 3},
    {"*jumpge", (lisp_proc *)CC_Hjumpge, 3},
    {"*jumpn", (lisp_proc *)CC_Hjumpn, 3},
    {"*jumpe", (lisp_proc *)CC_Hjumpe, 3},
    {"*jumpnil", (lisp_proc *)CC_Hjumpnil, 2},
    {"*jumpt", (lisp_proc *)CC_Hjumpt, 2},
    {"*jumpnc", (lisp_proc *)CC_Hjumpnc, 3},
    {"*jumpc", (lisp_proc *)CC_Hjumpc, 3},
    {"*jump", (lisp_proc *)CC_Hjump, 1},
    {"**arg", (lisp_proc *)CC_HHarg, 1},
    {"*exit", (lisp_proc *)CC_Hexit, 0},
    {"*dealloc", (lisp_proc *)CC_Hdealloc, 1},
    {"*alloc", (lisp_proc *)CC_Halloc, 1},
    {"*alloc_old", (lisp_proc *)CC_Halloc_old, 1},
    {"*init_entry", (lisp_proc *)CC_Hinit_entry, 3},
    {"*entry", (lisp_proc *)CC_Hentry, 3},
    {"*noop", (lisp_proc *)CC_Hnoop, 1},
    {"*comment", (lisp_proc *)CC_Hcomment, 2},
    {"&mkfunc", (lisp_proc *)CC_Gmkfunc, 1},
    {"&numeq", (lisp_proc *)CC_Gnumeq, 2},
    {"fap-c", (lisp_proc *)CC_fapKc, 1},
    {"lap-c", (lisp_proc *)CC_lapKc, 1},
    {"fap", (lisp_proc *)CC_fap, 1},
    {"lap", (lisp_proc *)CC_lap, 1},
    {"mungeable", (lisp_proc *)CC_mungeable, 1},
    {"ccompify", (lisp_proc *)CC_ccompify, 1},
    {"ccompiles", (lisp_proc *)CC_ccompiles, 1},
    {"ccompiles1", (lisp_proc *)CC_ccompiles1, 1},
    {"ccompend", (lisp_proc *)CC_ccompend, 0},
    {" ccompileendf", (lisp_proc *)CC_Accompileendf, 0},
    {" Gal_ccompilef", (lisp_proc *)CC_AGal_ccompilef, 2},
    {"ccompile4", (lisp_proc *)CC_ccompile4, 1},
    {"ccompile3", (lisp_proc *)CC_ccompile3, 3},
    {"ccompile2", (lisp_proc *)CC_ccompile2, 3},
    {"ccompile1", (lisp_proc *)CC_ccompile1, 1},
    {"sprintf", (lisp_proc *)CC_sprintf, -2},
    {"printf", (lisp_proc *)CC_printf, -2},
    {NULL, NULL, 0 }
};

