#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_comcomp.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex comcomp_literal_vector[];
const char *comcomp_literal_string[];
setup_type const  comcomp_g_setup[];
#define LITERAL comcomp_literal_vector




Sex CC_Atellmod(void)
{
    Sex a;
#define LL_Hmod LITERAL[0]
    a = value(LL_Hmod);
    return a;
}

Sex CC_Atellprec(void)
{
    Sex a;
#define LL_Hfloat LITERAL[1]
    a = value(LL_Hfloat);
    if(a == nil) goto    G0004;
    a = car(a);
    goto    G0005;
   G0004:
#define LL_Hmachineps LITERAL[2]
    a = value(LL_Hmachineps);
   G0005:
    return a;
}

Sex CC_Atellpowser(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    a = CC_Aexpr2varfunc(a);
    w1 = a;
    a = CC_Wid(a);
    if(a == nil) goto    G0012;
#define LL_Hpowser LITERAL[3]
    q = value(LL_Hpowser);
    a = w1;
    a = Latsoc(a, q);
    if(a == nil) goto    G0012;
    a = cdr(a);
   G0012:
    popv(1);
    return a;
}

Sex CC_setmod(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_integer(a)) goto    G0016;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0016;
    a = w1;
    goto    G0021;
   G0016:
    a = w1;
    if(a == nil) goto    G0019;
#define LL_Anil LITERAL[4]
    if(a != LL_Anil) goto    G0018;
   G0019:
    a = nil;
   G0021:
    value(LL_Hmod) = a;
#define LL_HHmod LITERAL[5]
    value(LL_HHmod) = a;
    goto    G0020;
   G0018:
    q = LITERAL[6];
    a = LITERAL[7];
    a = CC_errormsg(a, q);
   G0020:
    popv(1);
    return a;
}

Sex CC_setprec(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = a;
    a = mkfxat(100);
    a = times2(a, q);
#define LL_Hfcut LITERAL[8]
    value(LL_Hfcut) = a;
    q = w1;
    a = mkfxat(100);
    a = times2(a, q);
    q = w1;
    a = Lxcons(a, q);
    value(LL_Hfloat) = a;
#define LL_HHflo LITERAL[9]
    value(LL_HHflo) = a;
    popv(1);
    return a;
}

Sex CC_setpowser(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
#define LL_gM LITERAL[10]
    a = LL_gM;
    a = Llist3(a, q, m);
    q = a;
#define LL_powser LITERAL[11]
    a = LL_powser;
    a = Llist2(a, q);
    {
        return  CC_dclTpowser(a);
    }
}

Sex CC_Aassocset(void)
{
    Sex a;
#define LL_mlis LITERAL[12]
    a = LL_mlis;
    a = Lncons(a);
#define LL_Hmultalis LITERAL[13]
    value(LL_Hmultalis) = a;
    a = nil;
    return a;
}

Sex CC_Aassocend(void)
{
    Sex a;
    value(LL_Hmultalis) = nil;
    a = nil;
    return a;
}

Sex CC_Aassocget(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = CC_Watom(a);
    if(a != nil) goto    G0037;
    a = cdr(w1);
    if(a != nil) goto    G0036;
   G0037:
    a = LITERAL[14];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0036:
    q = a;
    a = value(LL_Hmultalis);
    {
        popv(1);
        return  CC_assocgetH(a, q);
    }
}

Sex CC_Aassocput(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = CC_Watom(a);
    if(a != nil) goto    G0043;
    a = cdr(w1);
    if(a != nil) goto    G0042;
   G0043:
    a = LITERAL[15];
    {
        popv(2);
        return  CC_argerror(a);
    }
   G0042:
    m = w2;
    q = a;
    a = value(LL_Hmultalis);
    {
        popv(2);
        return  CC_assocputH(a, q, m);
    }
}

Sex CC_Aassocdel(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = CC_Watom(a);
    if(a == nil) goto    G0048;
    q = LITERAL[16];
    a = w1;
    a = Lmemq(a, q);
    if(a == nil) goto    G0052;
    q = w1;
    goto    G0054;
   G0048:
    a = cdr(w1);
    if(a == nil) goto    G0052;
    q = a;
   G0054:
    a = value(LL_Hmultalis);
    {
        popv(1);
        return  CC_assocdelH(a, q);
    }
   G0052:
    a = LITERAL[17];
    {
        popv(1);
        return  CC_argerror(a);
    }
}

Sex CC_Aassoccomp(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G0059;
    q = car(w1);
    a = LITERAL[18];
    {
        popv(6);
        return  CC_errormsg(a, q);
    }
   G0059:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w3 = a;
    a = CC_Wintlist(a);
    w4 = a;
    if(a != nil) goto    G0063;
    q = w3;
#define LL_galeval LITERAL[19]
    a = LL_galeval;
    CC_fmapelm(a, q);
    a = w3;
    a = CC_Wintlist(a);
    w4 = a;
   G0063:
    q = w3;
    a = value(LL_Hmultalis);
    a = CC_assocgetH(a, q);
    w2 = a;
    q = LL_Anil;
    a = Lneq(a, q);
    if(a != nil) goto    G0071;
    a = w4;
    if(a != nil) goto    G0066;
    w5 = nil;
    a = w3;
    goto    G0068;
   G0067:
    w6 = a;
    a = LITERAL[20];
    q = w5;
    a = cons(a, q);
    w5 = a;
    a = cdr(w6);
   G0068:
    if(a != nil) goto    G0067;
    a = w5;
    a = Lnreverse(a);
   G0066:
    q = w3;
    a = car(w1);
    a = Lapply(a, q);
    w2 = a;
    m = a;
    q = w3;
    a = value(LL_Hmultalis);
    CC_assocputH(a, q, m);
   G0071:
    a = w2;
    popv(6);
    return a;
}

Sex CC_Aassocdump(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Watom(a);
    if(a == nil) goto    G0075;
    q = LITERAL[16];
    a = w1;
    a = Lmemq(a, q);
    if(a == nil) goto    G0079;
    arg4 = w3;
    m = w2;
    q = w1;
    goto    G0081;
   G0075:
    a = cdr(w1);
    if(a == nil) goto    G0079;
    arg4 = w3;
    m = w2;
    q = a;
   G0081:
    a = value(LL_Hmultalis);
    {
        popv(3);
        return  CC_assocdumpH(a, q, m, arg4);
    }
   G0079:
    a = LITERAL[21];
    {
        popv(3);
        return  CC_argerror(a);
    }
}

Sex CC_assocgetH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
   G0086:
    a = w3;
    if(a == nil) goto    G0110;
    a = car(w2);
    w5 = a;
   G0092:
    a = car(car(w3));
    w4 = a;
    if(a == nil) goto    G0102;
    q = a;
    a = w5;
    a = Lequal(a, q);
    if(a != nil) goto    G0105;
    a = w5;
    a = CC_Wint(a);
    if(a == nil) goto    G0096;
    a = w4;
    a = CC_Wint(a);
    if(a == nil) goto    G0096;
    q = w4;
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0110;
    goto    G0102;
   G0096:
    q = w4;
    a = w5;
    a = CC_Worder(a, q);
    if(a == nil) goto    G0110;
   G0102:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0110;
    goto    G0092;
   G0105:
    a = cdr(car(w3));
    w3 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0086;
    a = w3;
    if(a == nil) goto    G0110;
    a = car(car(a));
    if(a == nil) goto    G0109;
   G0110:
    a = LL_Anil;
    goto    G0085;
   G0109:
    a = cdr(car(w3));
   G0085:
    popv(5);
    return a;
}

Sex CC_assocputH(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w4 = a;
    w1 = a;
    w2 = q;
    w3 = m;
    a = cdr(a);
    w5 = a;
   G0120:
    a = w5;
    if(a == nil) goto    G0125;
    a = car(w2);
    w7 = a;
   G0129:
    a = car(car(w5));
    w6 = a;
    if(a == nil) goto    G0139;
    q = a;
    a = w7;
    a = Lequal(a, q);
    if(a != nil) goto    G0142;
    a = w7;
    a = CC_Wint(a);
    if(a == nil) goto    G0133;
    a = w6;
    a = CC_Wint(a);
    if(a == nil) goto    G0133;
    q = w6;
    a = w7;
    a = Lgreaterp(a, q);
    goto    G0157;
   G0133:
    q = w6;
    a = w7;
    a = CC_Worder(a, q);
   G0157:
    if(a == nil) goto    G0125;
   G0139:
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(a == nil) goto    G0125;
    goto    G0129;
   G0142:
    a = car(w5);
    w4 = a;
    a = cdr(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0120;
    a = w5;
    if(a == nil) goto    G0147;
    a = car(car(a));
    if(a == nil) goto    G0146;
   G0147:
    a = nil;
    a = Lncons(a);
    q = w5;
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
   G0146:
    a = car(cdr(w4));
    w5 = a;
    q = w3;
    goto    G0158;
   G0125:
    a = car(w2);
    a = Lncons(a);
    q = w5;
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = car(cdr(w4));
    w4 = a;
    a = cdr(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0125;
    q = w3;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
   G0158:
    cdr(a) = q;
    a = w3;
    popv(8);
    return a;
}

Sex CC_assocdelH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_Watom(a);
    if(a == nil) goto    G0162;
    q = nil;
    a = w1;
    cdr(a) = q;
    goto    G0192;
   G0162:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = w1;
    w3 = a;
   G0165:
    a = cdr(w3);
    if(a == nil) goto    G0185;
    a = car(w2);
    w5 = a;
   G0173:
    a = car(car(cdr(w3)));
    w4 = a;
    if(a == nil) goto    G0183;
    q = a;
    a = w5;
    a = Lequal(a, q);
    if(a != nil) goto    G0169;
    a = w5;
    a = CC_Wint(a);
    if(a == nil) goto    G0177;
    a = w4;
    a = CC_Wint(a);
    if(a == nil) goto    G0177;
    q = w4;
    a = w5;
    a = Lgreaterp(a, q);
    goto    G0194;
   G0177:
    q = w4;
    a = w5;
    a = CC_Worder(a, q);
   G0194:
    if(a == nil) goto    G0185;
   G0183:
    a = cdr(w3);
    w3 = a;
    a = cdr(a);
    if(a != nil) goto    G0173;
   G0185:
    a = LITERAL[22];
    goto    G0163;
   G0169:
    q = w6;
    a = w3;
    a = cons(a, q);
    w6 = a;
    a = car(cdr(w3));
    w3 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0165;
    q = nil;
    a = w3;
    cdr(a) = q;
   G0170:
    a = car(w6);
    w3 = a;
    a = cdr(car(cdr(a)));
    if(a != nil) goto    G0190;
    q = cdr(cdr(w3));
    a = w3;
    cdr(a) = q;
   G0190:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0170;
   G0192:
    a = LITERAL[23];
   G0163:
    popv(6);
    return a;
}

Sex CC_assocdumpH(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    a = cdr(a);
    w6 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = m;
    a = CC_Wlist(a);
    if(a != nil) goto    G0213;
    a = w3;
    a = CC_Wid(a);
    if(a != nil) goto    G0212;
   G0213:
    q = w3;
    a = LITERAL[24];
    CC_errormsg(a, q);
    goto    G0214;
   G0212:
    a = w3;
    if(a == nil) goto    G0215;
    if(a != LL_Anil) goto    G0214;
   G0215:
#define LL_AE LITERAL[25]
    a = LL_AE;
    w3 = a;
   G0214:
    a = w4;
    if(a == nil) goto    G0218;
    if(a != LL_Anil) goto    G0217;
   G0218:
    w4 = nil;
    goto    G0219;
   G0217:
    a = CC_Wint(a);
    if(a != nil) goto    G0219;
    q = w4;
    a = LITERAL[26];
    CC_errormsg(a, q);
   G0219:
    a = w2;
    a = CC_Watom(a);
    if(a != nil) goto    G0239;
   G0221:
    a = w6;
    if(a == nil) goto    G0236;
    a = car(w2);
    w7 = a;
    q = w8;
    a = w7;
    a = cons(a, q);
    w8 = a;
   G0199:
    a = car(car(w6));
    w9 = a;
    if(a == nil) goto    G0234;
    q = a;
    a = w7;
    a = Lequal(a, q);
    if(a != nil) goto    G0202;
    a = w7;
    a = CC_Wint(a);
    if(a == nil) goto    G0228;
    a = w9;
    a = CC_Wint(a);
    if(a == nil) goto    G0228;
    q = w9;
    a = w7;
    a = Lgreaterp(a, q);
    goto    G0256;
   G0228:
    q = w9;
    a = w7;
    a = CC_Worder(a, q);
   G0256:
    if(a == nil) goto    G0236;
   G0234:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0199;
   G0236:
    q = w3;
    a = LITERAL[27];
    CC_printmsg(a, q);
    a = nil;
    goto    G0197;
   G0202:
    a = cdr(car(w6));
    w6 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0221;
    a = w6;
    if(a == nil) goto    G0236;
   G0239:
    q = w5;
    a = w6;
    a = cons(a, q);
    w5 = a;
   G0204:
    a = car(car(w6));
    if(a == nil) goto    G0205;
    a = cdr(car(w6));
    w6 = a;
    if(a == nil) goto    G0210;
    q = w5;
    a = cons(a, q);
    w5 = a;
    goto    G0204;
   G0205:
    a = w4;
    if(a == nil) goto    G0245;
    a = Ladd1(a);
    w4 = a;
    Lterpri();
    a = w3;
    Lprinc(a);
    a = w4;
    Lprinc(a);
    goto    G0209;
   G0245:
    w2 = nil;
    a = w5;
    w9 = a;
   G0206:
    a = cdr(w9);
    w9 = a;
    if(a == nil) goto    G0247;
    q = w2;
    a = car(car(car(a)));
    a = cons(a, q);
    w2 = a;
    goto    G0206;
   G0247:
    a = w8;
    if(a == nil) goto    G0251;
    w9 = a;
   G0207:
    q = w2;
    a = car(w9);
    a = cons(a, q);
    w2 = a;
    a = cdr(w9);
    w9 = a;
    if(a != nil) goto    G0207;
   G0251:
    Lterpri();
    q = w2;
    a = w3;
    a = cons(a, q);
    CC_fprinTfunc(a);
   G0209:
    a = LITERAL[28];
    Lprinc(a);
    q = nil;
    a = cdr(car(car(w5)));
    CC_fprinH(a, q);
   G0210:
    a = cdr(car(w5));
    w9 = a;
    if(a == nil) goto    G0254;
    q = a;
    a = w5;
    car(a) = q;
    a = w9;
    w6 = a;
    goto    G0204;
   G0254:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0210;
    a = w4;
   G0197:
    popv(9);
    return a;
}

Sex CC_mlisThindex(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G0262;
    a = car(car(a));
    if(a == nil) goto    G0262;
    a = car(cdr(w1));
    a = CC_mlisThindex(a);
    q = car(car(cdr(w1)));
    a = Lxcons(a, q);
   G0262:
    popv(1);
    return a;
}

Sex CC_mlisThlist(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G0268;
    a = car(a);
#define LL_Htemporal LITERAL[29]
    value(LL_Htemporal) = a;
    q = cdr(cdr(w1));
    a = w1;
    cdr(a) = q;
    q = value(LL_Htemporal);
    a = LL_mlis;
    a = Llist2(a, q);
   G0268:
    popv(1);
    return a;
}

Sex CC_mlisThterm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G0273;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = w1;
    w2 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
   G0275:
    q = w6;
    a = w2;
    a = cons(a, q);
    w6 = a;
   G0276:
    a = cdr(w2);
    if(a == nil) goto    G0277;
    a = car(car(a));
    w3 = a;
    if(a == nil) goto    G0278;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = car(cdr(w2));
    w2 = a;
    goto    G0275;
   G0277:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G0273;
    a = car(a);
    w2 = a;
    q = cdr(cdr(a));
    cdr(a) = q;
    a = w4;
    a = CC_tail2(a);
    w5 = a;
    q = nil;
    cdr(a) = q;
    goto    G0276;
   G0278:
    q = cdr(car(cdr(w2)));
    a = w4;
    car(a) = q;
   G0279:
    q = cdr(cdr(w2));
    a = w2;
    cdr(a) = q;
    a = cdr(w2);
    if(a != nil) goto    G0289;
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G0289;
    a = car(a);
    w2 = a;
    goto    G0279;
   G0289:
    a = w4;
   G0273:
    popv(6);
    return a;
}



/* initialization procedure */
int init_comcomp(void)
{
   long i;

   create_symbols(comcomp_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; comcomp_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(comcomp_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4;
        a = LITERAL[30];
        CC_Aenter(a);
        arg4 = nil;
        m = nil;
#define LL_Atellmod LITERAL[31]
        q = LL_Atellmod;
#define LL_tellmod LITERAL[32]
        a = LL_tellmod;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Atellprec LITERAL[33]
        q = LL_Atellprec;
#define LL_tellprec LITERAL[34]
        a = LL_tellprec;
        CC_defcommand(a, q, m, arg4);
        a = LITERAL[35];
        Lglobal(a);
        arg4 = nil;
#define LL_uneval LITERAL[36]
        m = LL_uneval;
#define LL_Aassoccomp LITERAL[37]
        q = LL_Aassoccomp;
#define LL_assoccomp LITERAL[38]
        a = LL_assoccomp;
        a = CC_defcommand(a, q, m, arg4);
        return 1;
    }
}
Sex LITERAL[40];

const  char *comcomp_literal_string[40] =
{
/* 0 */
"!*mod",
/* 1 */
"!*float",
/* 2 */
"!*machineps",
/* 3 */
"!*powser",
/* 4 */
"! nil",
/* 5 */
"!*!*mod",
/* 6 */
"\"SETMOD\"",
/* 7 */
"\"ARG IS NOT POSITIVE INT\"",
/* 8 */
"!*fcut",
/* 9 */
"!*!*flo",
/* 10 */
"g!=",
/* 11 */
"powser",
/* 12 */
"mlis",
/* 13 */
"!*multalis",
/* 14 */
"\"ASSOCGET\"",
/* 15 */
"\"ASSOCPUT\"",
/* 16 */
"(! nil ! all)",
/* 17 */
"\"ASSOCDEL\"",
/* 18 */
"\"NO INDEX TO ASSOCCOMP COMMAND\"",
/* 19 */
"galeval",
/* 20 */
"(car ! ! ! G0070)",
/* 21 */
"\"ASSOCDUMP\"",
/* 22 */
"\"NOTHING TO DELETE\"",
/* 23 */
"\"DELETED\"",
/* 24 */
"\"INVALID ARGUMENT, NOT NAME\"",
/* 25 */
"! !%",
/* 26 */
"\"INVALID ARGUMENT, NOT INTEGER\"",
/* 27 */
"\"NOTHING TO DUMP\"",
/* 28 */
"\" = \"",
/* 29 */
"!*temporal",
/* 30 */
"(lisp)",
/* 31 */
"! tellmod",
/* 32 */
"tellmod",
/* 33 */
"! tellprec",
/* 34 */
"tellprec",
/* 35 */
"(!*multalis)",
/* 36 */
"uneval",
/* 37 */
"! assoccomp",
/* 38 */
"assoccomp",
/* 39 */ NULL
};
setup_type const comcomp_g_setup[] =
{
    {"mlis:hterm", (lisp_proc *)CC_mlisThterm, 1},
    {"mlis:hlist", (lisp_proc *)CC_mlisThlist, 1},
    {"mlis:hindex", (lisp_proc *)CC_mlisThindex, 1},
    {"assocdump*", (lisp_proc *)CC_assocdumpH, 4},
    {"assocdel*", (lisp_proc *)CC_assocdelH, 2},
    {"assocput*", (lisp_proc *)CC_assocputH, 3},
    {"assocget*", (lisp_proc *)CC_assocgetH, 2},
    {" assocdump", (lisp_proc *)CC_Aassocdump, 3},
    {" assoccomp", (lisp_proc *)CC_Aassoccomp, 1},
    {" assocdel", (lisp_proc *)CC_Aassocdel, 1},
    {" assocput", (lisp_proc *)CC_Aassocput, 2},
    {" assocget", (lisp_proc *)CC_Aassocget, 1},
    {" assocend", (lisp_proc *)CC_Aassocend, 0},
    {" assocset", (lisp_proc *)CC_Aassocset, 0},
    {"setpowser", (lisp_proc *)CC_setpowser, 2},
    {"setprec", (lisp_proc *)CC_setprec, 1},
    {"setmod", (lisp_proc *)CC_setmod, 1},
    {" tellpowser", (lisp_proc *)CC_Atellpowser, 1},
    {" tellprec", (lisp_proc *)CC_Atellprec, 0},
    {" tellmod", (lisp_proc *)CC_Atellmod, 0},
    {NULL, NULL, 0 }
};

