#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_comconv.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex comconv_literal_vector[];
const char *comconv_literal_string[];
setup_type const  comconv_g_setup[];
#define LITERAL comconv_literal_vector




Sex CC_modratn2int(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lden(a);
    q = a;
    a = w2;
    a = CC_cofactTintint(a, q);
    w3 = a;
    if(a == nil) goto    G0004;
    q = cdr(a);
    a = car(w1);
    a = times2(a, q);
    q = w2;
    a = remaind2(a, q);
    w3 = a;
    goto    G0006;
   G0004:
    q = w1;
    a = LITERAL[0];
    CC_errormsg(a, q);
    a = w3;
   G0006:
    a = Lplusp(a);
    if(a == nil) goto    G0008;
    a = w3;
    goto    G0001;
   G0008:
    a = w2;
    a = Lplusp(a);
    if(a == nil) goto    G0009;
    q = w2;
    a = w3;
    {
        popv(3);
        return  plus2(a, q);
    }
   G0009:
    q = w2;
    a = w3;
    a = diff2(a, q);
   G0001:
    popv(3);
    return a;
}

Sex CC_modint2ratn(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = Lfloat(a);
    q = mkfxat(2);
    a = quot2(a, q);
    a = Lsqrt(a);
    a = Ltruncate(a);
    m = a;
    q = w2;
    a = w1;
    a = CC_modint2numden(a, q, m);
    if(a == nil) goto    G0019;
    q = cdr(a);
    a = car(a);
    {
        popv(2);
        return  Lmkrational(a, q);
    }
   G0019:
    a = w1;
    popv(2);
    return a;
}

Sex CC_bnum2int(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(!is_integer(a)) goto    G0024;
#define LL_Hmod LITERAL[1]
    a = value(LL_Hmod);
    if(a == nil) goto    G0026;
    q = a;
    a = w1;
    {
        popv(2);
        return  modulus(a, q);
    }
   G0026:
    a = w1;
    goto    G0044;
   G0024:
    if(!is_rational(a)) goto    G0028;
    a = value(LL_Hmod);
    if(a == nil) goto    G0030;
    q = a;
    a = w1;
    {
        popv(2);
        return  CC_modratn2int(a, q);
    }
   G0030:
    a = w1;
    a = Lnum(a);
    w2 = a;
    a = w1;
    a = Lden(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  quot2(a, q);
    }
   G0028:
    if(is_float(a)) goto    G0051;
    if(!is_complex(a)) goto    G0035;
    a = Lcomplex_real(a);
    a = CC_bnum2int(a);
    w2 = a;
    a = w1;
    a = Lcomplex_imag(a);
    goto    G0050;
   G0035:
    if(!is_efloat(a)) goto    G0040;
    a = Lefloat_value(a);
    goto    G0051;
   G0040:
    if(!is_interval(a)) goto    G0042;
    a = Linterval_mid(a);
   G0051:
    {
        popv(2);
        return  Ltruncate(a);
    }
   G0042:
    a = Lecomplex_real(a);
    a = CC_bnum2int(a);
    w2 = a;
    a = w1;
    a = Lecomplex_imag(a);
   G0050:
    a = CC_bnum2int(a);
    q = a;
    a = w2;
    a = Lmkcomplex(a, q);
   G0044:
    popv(2);
    return a;
}

Sex CC_bnum2float(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0083;
    if(is_rational(a)) goto    G0083;
    if(!is_float(a)) goto    G0057;
#define LL_Hfcut LITERAL[2]
    a = value(LL_Hfcut);
    if(a == nil) goto    G0059;
    a = w1;
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0059;
    a = LITERAL[3];
    goto    G0075;
   G0059:
    a = w1;
    goto    G0075;
   G0057:
    if(!is_efloat(a)) goto    G0063;
    a = Lefloat_value(a);
    goto    G0083;
   G0063:
    if(is_bfloat(a)) goto    G0083;
    if(!is_befloat(a)) goto    G0066;
    a = Lbefloat_value(a);
    goto    G0083;
   G0066:
    if(!is_complex(a)) goto    G0068;
    a = Lcomplex_real(a);
    a = Lfloat(a);
    w2 = a;
    a = w1;
    a = Lcomplex_imag(a);
    goto    G0084;
   G0068:
    if(!is_interval(a)) goto    G0073;
    a = Linterval_mid(a);
   G0083:
    {
        popv(2);
        return  Lfloat(a);
    }
   G0073:
    a = Lecomplex_real(a);
    a = Lfloat(a);
    w2 = a;
    a = w1;
    a = Lecomplex_imag(a);
   G0084:
    a = Lfloat(a);
    q = a;
    a = w2;
    a = Lmkcomplex(a, q);
   G0075:
    popv(2);
    return a;
}

Sex CC_bnum2bfloat(Sex a)
{
    Sex q;
    if(is_integer(a)) goto    G0089;
    if(is_rational(a)) goto    G0089;
    if(!is_float(a)) goto    G0088;
   G0089:
    {
        return  Lbfloat(a);
    }
   G0088:
    q = LITERAL[4];
    a = LITERAL[5];
    {
        return  CC_errormsg(a, q);
    }
}

Sex CC_bnum2compl(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0095;
    if(!is_rational(a)) goto    G0094;
   G0095:
    q = mkfxat(0);
    goto    G0108;
   G0094:
    if(!is_float(a)) goto    G0096;
    q = LITERAL[3];
    goto    G0108;
   G0096:
    if(is_complex(a)) goto    G0102;
    if(!is_efloat(a)) goto    G0098;
    a = Lefloat_value(a);
    q = LITERAL[3];
    goto    G0108;
   G0098:
    if(!is_interval(a)) goto    G0100;
    a = Linterval_mid(a);
    q = LITERAL[3];
    goto    G0108;
   G0100:
    a = Lecomplex_real(a);
    w2 = a;
    a = w1;
    a = Lecomplex_imag(a);
    q = a;
    a = w2;
   G0108:
    a = Lmkcomplex(a, q);
   G0102:
    popv(2);
    return a;
}

Sex CC_bnum2efloat(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0113;
    if(!is_rational(a)) goto    G0112;
   G0113:
    a = Lfloat(a);
    w1 = a;
#define LL_Hmachineps LITERAL[6]
    q = value(LL_Hmachineps);
    a = times2(a, q);
    q = a;
    a = w1;
    goto    G0152;
   G0112:
    if(!is_float(a)) goto    G0115;
    a = Lzerop(a);
    if(a != nil) goto    G0119;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0117;
    a = w1;
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0117;
   G0119:
    q = LITERAL[3];
    a = LITERAL[3];
    goto    G0152;
   G0117:
    q = value(LL_Hmachineps);
    a = w1;
    a = times2(a, q);
    q = a;
    a = w1;
    goto    G0152;
   G0115:
    if(!is_complex(a)) goto    G0123;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G0128;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0138;
    a = w1;
    a = Lcomplex_imag(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0138;
   G0128:
    a = w1;
    a = Lcomplex_real(a);
    a = Lfloat(a);
    w1 = a;
    q = value(LL_Hmachineps);
    a = times2(a, q);
    q = a;
    a = w1;
    goto    G0152;
   G0123:
    if(is_efloat(a)) goto    G0146;
    if(!is_interval(a)) goto    G0135;
    a = Linterval_mid(a);
    w2 = a;
    a = w1;
    a = Linterval_width(a);
    q = a;
    a = w2;
    goto    G0152;
   G0135:
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G0141;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0138;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0138;
   G0141:
    a = w1;
    a = Lecomplex_real(a);
    a = Lfloat(a);
    w1 = a;
    q = value(LL_Hmachineps);
    a = times2(a, q);
    q = a;
    a = w1;
   G0152:
    {
        popv(2);
        return  Lmkefloat(a, q);
    }
   G0138:
    q = w1;
    a = LITERAL[7];
    a = CC_errormsg(a, q);
   G0146:
    popv(2);
    return a;
}

Sex CC_bnum2efloa1(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0157;
    if(!is_rational(a)) goto    G0156;
   G0157:
    a = Lfloat(a);
    w1 = a;
    q = value(LL_Hmachineps);
    goto    G0192;
   G0156:
    if(!is_float(a)) goto    G0158;
    a = Lzerop(a);
    if(a != nil) goto    G0162;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0160;
    a = w1;
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0160;
   G0162:
    q = LITERAL[3];
    a = LITERAL[3];
    goto    G0192;
   G0160:
    q = value(LL_Hmachineps);
    a = w1;
    goto    G0192;
   G0158:
    if(!is_complex(a)) goto    G0165;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G0170;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0179;
    a = w1;
    a = Lcomplex_imag(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0179;
   G0170:
    a = w1;
    a = Lcomplex_real(a);
    a = Lfloat(a);
    w1 = a;
    q = value(LL_Hmachineps);
    goto    G0192;
   G0165:
    if(is_efloat(a)) goto    G0186;
    if(!is_interval(a)) goto    G0176;
    a = Linterval_mid(a);
    w2 = a;
    a = w1;
    a = Linterval_width(a);
    q = a;
    a = w2;
    goto    G0192;
   G0176:
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G0182;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0179;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0179;
   G0182:
    a = w1;
    a = Lecomplex_real(a);
    a = Lfloat(a);
    w1 = a;
    q = value(LL_Hmachineps);
   G0192:
    {
        popv(2);
        return  Lmkefloat(a, q);
    }
   G0179:
    q = w1;
    a = LITERAL[7];
    a = CC_errormsg(a, q);
   G0186:
    popv(2);
    return a;
}

Sex CC_bnum2befloat(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0215;
    if(is_rational(a)) goto    G0215;
    if(!is_float(a)) goto    G0200;
   G0215:
    a = Lbfloat(a);
    w2 = a;
    q = value(LL_Hmachineps);
    a = w1;
    a = times2(a, q);
    goto    G0216;
   G0200:
    if(!is_efloat(a)) goto    G0203;
    a = Lefloat_value(a);
    a = Lbfloat(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
   G0216:
    q = a;
    a = w2;
    goto    G0218;
   G0203:
    if(!is_bfloat(a)) goto    G0207;
    a = Lfloat(a);
    q = value(LL_Hmachineps);
    a = times2(a, q);
    q = a;
    a = w1;
    goto    G0218;
   G0207:
    if(!is_befloat(a)) goto    G0210;
    a = Lbefloat_value(a);
    a = Lbfloat(a);
    w2 = a;
    a = w1;
    a = Lbefloat_error(a);
    q = a;
    a = w2;
   G0218:
    {
        popv(2);
        return  Lmkbefloat(a, q);
    }
   G0210:
    q = a;
    a = LITERAL[8];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
}

Sex CC_bnum2ecompl(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0223;
    if(!is_rational(a)) goto    G0222;
   G0223:
    a = Lfloat(a);
    w1 = a;
    goto    G0240;
   G0222:
    if(!is_float(a)) goto    G0225;
   G0240:
    q = value(LL_Hmachineps);
    a = times2(a, q);
    m = a;
    q = LITERAL[3];
    a = w1;
    goto    G0243;
   G0225:
    if(!is_complex(a)) goto    G0227;
    a = Labs(a);
    q = value(LL_Hmachineps);
    a = times2(a, q);
#define LL_Htemporal LITERAL[9]
    value(LL_Htemporal) = a;
    a = w1;
    a = Lcomplex_real(a);
    a = Lfloat(a);
    w2 = a;
    a = w1;
    a = Lcomplex_imag(a);
    a = Lfloat(a);
    m = value(LL_Htemporal);
    q = a;
    a = w2;
    goto    G0243;
   G0227:
    if(!is_efloat(a)) goto    G0233;
    a = Lefloat_value(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
    m = a;
    q = LITERAL[3];
    a = w2;
    goto    G0243;
   G0233:
    if(!is_interval(a)) goto    G0239;
    a = Linterval_mid(a);
    w2 = a;
    a = w1;
    a = Linterval_width(a);
    m = a;
    q = LITERAL[3];
    a = w2;
   G0243:
    a = Lmkecomplex(a, q, m);
   G0239:
    popv(2);
    return a;
}

Sex CC_bnum2intval(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
   G0284:
    w1 = a;
    if(is_integer(a)) goto    G0248;
    if(is_rational(a)) goto    G0248;
    if(!is_float(a)) goto    G0247;
   G0248:
    a = Lfloat(a);
    w1 = a;
    q = value(LL_Hmachineps);
    a = times2(a, q);
    value(LL_Htemporal) = a;
    q = a;
    a = w1;
    a = diff2(a, q);
    w2 = a;
    q = value(LL_Htemporal);
    a = w1;
    goto    G0283;
   G0247:
    if(!is_complex(a)) goto    G0251;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G0256;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0270;
    a = w1;
    a = Lcomplex_imag(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0270;
   G0256:
    a = w1;
    a = Lcomplex_real(a);
    goto    G0284;  /* recursive call to bnum2intval */
   G0251:
    if(!is_efloat(a)) goto    G0261;
    a = Lefloat_value(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
    q = a;
    a = w2;
    a = diff2(a, q);
    w2 = a;
    a = w1;
    a = Lefloat_value(a);
    w3 = a;
    a = w1;
    a = Lefloat_error(a);
    q = a;
    a = w3;
    goto    G0283;
   G0261:
    if(is_interval(a)) goto    G0274;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a == nil) goto    G0270;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0270;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Lgeq(a, q);
    if(a == nil) goto    G0269;
   G0270:
    q = w1;
    a = LITERAL[10];
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
   G0269:
    a = w1;
    a = Lecomplex_real(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    a = diff2(a, q);
    w2 = a;
    a = w1;
    a = Lecomplex_real(a);
    w3 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w3;
   G0283:
    a = plus2(a, q);
    q = a;
    a = w2;
    a = Lmkinterval(a, q);
   G0274:
    popv(3);
    return a;
}

Sex CC_bnum2round(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0336;
    if(is_rational(a)) goto    G0336;
    if(is_float(a)) goto    G0336;
    if(!is_complex(a)) goto    G0290;
    a = Lcomplex_imag(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lcomplex_real(a);
    a = Labs(a);
#define LL_Hmeps100 LITERAL[11]
    q = value(LL_Hmeps100);
    a = times2(a, q);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0292;
    a = w1;
    {
        popv(2);
        return  Lcomplex_real(a);
    }
   G0292:
    a = w1;
    a = Lcomplex_imag(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lcomplex_real(a);
    a = Labs(a);
    q = value(LL_Hmeps100);
    a = times2(a, q);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0328;
    a = w1;
    {
        popv(2);
        return  Lcomplex_imag(a);
    }
   G0290:
    if(!is_efloat(a)) goto    G0305;
    a = Lefloat_value(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0328;
    goto    G0313;
   G0305:
    a = Lecomplex_real(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0312;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0312;
   G0313:
    a = LITERAL[3];
    goto    G0336;
   G0312:
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    q = value(LL_Hmeps100);
    a = times2(a, q);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0320;
    a = w1;
    a = Lecomplex_real(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  Lmkefloat(a, q);
    }
   G0320:
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = value(LL_Hmeps100);
    a = times2(a, q);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0328;
    a = w1;
    a = Lecomplex_imag(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    m = a;
    q = w2;
    a = LITERAL[3];
    {
        popv(2);
        return  Lmkecomplex(a, q, m);
    }
   G0328:
    a = w1;
   G0336:
    popv(2);
    return a;
}

Sex CC_bnum2real(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0350;
    if(is_rational(a)) goto    G0350;
    if(is_float(a)) goto    G0350;
    if(!is_complex(a)) goto    G0345;
    {
        popv(2);
        return  Lcomplex_real(a);
    }
   G0345:
    if(is_efloat(a)) goto    G0350;
    a = Lecomplex_real(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0347;
    a = LITERAL[3];
    goto    G0350;
   G0347:
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = value(LL_Htemporal);
    a = Lmkefloat(a, q);
   G0350:
    popv(2);
    return a;
}

Sex CC_bnum2imag(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0356;
    if(!is_rational(a)) goto    G0355;
   G0356:
    a = mkfxat(0);
    goto    G0363;
   G0355:
    if(is_float(a)) goto    G0366;
    if(!is_complex(a)) goto    G0358;
    {
        popv(2);
        return  Lcomplex_imag(a);
    }
   G0358:
    if(is_efloat(a)) goto    G0366;
    a = Lecomplex_imag(a);
    value(LL_Htemporal) = a;
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0360;
   G0366:
    a = LITERAL[3];
    goto    G0363;
   G0360:
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = value(LL_Htemporal);
    a = Lmkefloat(a, q);
   G0363:
    popv(2);
    return a;
}

Sex CC_bnum2cc(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0374;
    if(is_rational(a)) goto    G0374;
    if(is_float(a)) goto    G0374;
    if(!is_complex(a)) goto    G0372;
    {
        popv(3);
        return  Lcomplex_conjugate(a);
    }
   G0372:
    if(is_efloat(a)) goto    G0374;
    a = Lecomplex_real(a);
    w2 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Lminus(a);
    w3 = a;
    a = w1;
    a = Lecomplex_error(a);
    m = a;
    q = w3;
    a = w2;
    a = Lmkecomplex(a, q, m);
   G0374:
    popv(3);
    return a;
}

Sex CC_Arealpart(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2real LITERAL[12]
    a = LL_bnum2real;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Aimagpart(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2imag LITERAL[13]
    a = LL_bnum2imag;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acompconj(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2cc LITERAL[14]
    a = LL_bnum2cc;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2abs(Sex a)
{
    Sex q;
    q = a;
#define LL_abs LITERAL[15]
    a = LL_abs;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2int(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2int LITERAL[16]
    a = LL_bnum2int;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2ratn(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2ratn LITERAL[17]
    a = LL_bnum2ratn;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2float(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2float LITERAL[18]
    a = LL_bnum2float;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2compl(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2compl LITERAL[19]
    a = LL_bnum2compl;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2bfloat(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2bfloat LITERAL[20]
    a = LL_bnum2bfloat;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2efloat(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2efloat LITERAL[21]
    a = LL_bnum2efloat;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2efloa1(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2efloa1 LITERAL[22]
    a = LL_bnum2efloa1;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2ecompl(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2ecompl LITERAL[23]
    a = LL_bnum2ecompl;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2intval(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2intval LITERAL[24]
    a = LL_bnum2intval;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Acoef2befloat(Sex a)
{
    Sex q;
    q = a;
#define LL_bnum2befloat LITERAL[25]
    a = LL_bnum2befloat;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_Asimpcompl(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = value(LL_Hmeps100);
    w3 = a;
    a = q;
    value(LL_Hmeps100) = a;
    w2 = q;
    q = w1;
#define LL_simpcompl LITERAL[26]
    a = LL_simpcompl;
    a = CC_mapTconvcoef(a, q);
    w4 = a;
    a = w3;
    value(LL_Hmeps100) = a;
    a = w4;
    popv(4);
    return a;
}

Sex CC_Amodulo(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(q)) goto    G0413;
    a = q;
    a = Lplusp(a);
    if(a == nil) goto    G0413;
    w3 = nil;
    a = value(LL_Hmod);
#define LL_HHmod LITERAL[27]
    value(LL_HHmod) = a;
    a = w2;
    value(LL_Hmod) = a;
    q = w1;
#define LL_modTintratn LITERAL[28]
    a = LL_modTintratn;
    a = CC_mapTconvcoef(a, q);
    w3 = a;
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = w3;
    goto    G0416;
   G0413:
    q = w2;
    a = LITERAL[29];
    a = CC_errormsg(a, q);
   G0416:
    popv(3);
    return a;
}

Sex CC_Amodulo2(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(q)) goto    G0420;
    a = q;
    a = Lplusp(a);
    if(a == nil) goto    G0420;
    w3 = nil;
    a = value(LL_Hmod);
    value(LL_HHmod) = a;
    a = w2;
    value(LL_Hmod) = a;
    q = w1;
#define LL_mod2Tintratn LITERAL[30]
    a = LL_mod2Tintratn;
    a = CC_mapTconvcoef(a, q);
    w3 = a;
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = w3;
    goto    G0423;
   G0420:
    q = w2;
    a = LITERAL[29];
    a = CC_errormsg(a, q);
   G0423:
    popv(3);
    return a;
}

Sex CC_modTintratn(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_integer(a)) goto    G0427;
    q = value(LL_Hmod);
    a = remaind2(a, q);
    w1 = a;
    a = Lminusp(a);
    if(a != nil) goto    G0429;
    a = w1;
    goto    G0433;
   G0429:
    q = value(LL_Hmod);
    a = w1;
    {
        popv(1);
        return  plus2(a, q);
    }
   G0427:
    if(!is_rational(a)) goto    G0432;
    q = value(LL_Hmod);
    {
        popv(1);
        return  CC_modratn2int(a, q);
    }
   G0432:
    q = a;
    a = LITERAL[0];
    a = CC_errormsg(a, q);
   G0433:
    popv(1);
    return a;
}

Sex CC_mod2Tintratn(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(!is_integer(a)) goto    G0437;
    q = value(LL_Hmod);
    {
        popv(2);
        return  CC_mod2(a, q);
    }
   G0437:
    if(is_rational(a)) goto    G0438;
    q = a;
    a = LITERAL[0];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0438:
    w2 = nil;
    a = Lden(a);
    q = a;
    a = value(LL_Hmod);
    a = CC_cofactTintint(a, q);
    w2 = a;
    if(a == nil) goto    G0443;
    q = cdr(a);
    a = car(w1);
    a = times2(a, q);
    w2 = a;
    goto    G0444;
   G0443:
    q = w1;
    a = LITERAL[0];
    CC_errormsg(a, q);
   G0444:
    q = value(LL_Hmod);
    a = w2;
    a = remaind2(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0455;
    a = w1;
    a = Lminusp(a);
    q = value(LL_Hmod);
    if(a != nil) goto    G0462;
    a = w1;
    a = diff2(a, q);
    w2 = a;
    q = a;
    a = w1;
    a = plus2(a, q);
    a = Lplusp(a);
    if(a == nil) goto    G0455;
   G0461:
    a = w2;
    goto    G0439;
   G0462:
    a = w1;
    a = plus2(a, q);
    w2 = a;
    q = a;
    a = w1;
    a = plus2(a, q);
    a = Lplusp(a);
    if(a == nil) goto    G0461;
   G0455:
    a = w1;
   G0439:
    popv(2);
    return a;
}

Sex CC_Acutcoef(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0466;
    a = q;
    a = Lplusp(a);
    if(a == nil) goto    G0466;
    w3 = nil;
    w4 = nil;
    a = value(LL_Hfcut);
    w3 = a;
    a = w2;
    value(LL_Hfcut) = a;
    q = w1;
#define LL_cutTbnum LITERAL[31]
    a = LL_cutTbnum;
    a = CC_mapTconvcoef(a, q);
    w4 = a;
    a = w3;
    value(LL_Hfcut) = a;
    a = w4;
    goto    G0469;
   G0466:
    q = w2;
    a = LITERAL[32];
    a = CC_errormsg(a, q);
   G0469:
    popv(4);
    return a;
}

Sex CC_Acutefcoef(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0473;
    a = q;
    a = Lplusp(a);
    if(a == nil) goto    G0473;
    w3 = nil;
    w4 = nil;
    a = value(LL_Hfcut);
    w3 = a;
    a = w2;
    value(LL_Hfcut) = a;
    q = w1;
#define LL_cutTefloat LITERAL[33]
    a = LL_cutTefloat;
    a = CC_mapTconvcoef(a, q);
    w4 = a;
    a = w3;
    value(LL_Hfcut) = a;
    a = w4;
    goto    G0476;
   G0473:
    q = w2;
    a = LITERAL[32];
    a = CC_errormsg(a, q);
   G0476:
    popv(4);
    return a;
}

Sex CC_Acutitvcoef(Sex a)
{
    Sex q;
    q = a;
#define LL_cutTintvl LITERAL[34]
    a = LL_cutTintvl;
    {
        return  CC_mapTconvcoef(a, q);
    }
}

Sex CC_cutTbnum(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_float(a)) goto    G0483;
    if(is_integer(a)) goto    G0483;
    if(!is_rational(a)) goto    G0482;
   G0483:
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0524;
    goto    G0538;
   G0482:
    if(!is_complex(a)) goto    G0488;
    a = Lcomplex_imag(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0524;
    a = w1;
    a = Lcomplex_real(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a != nil) goto    G0538;
    a = w1;
    {
        popv(2);
        return  Lcomplex_real(a);
    }
   G0488:
    if(!is_efloat(a)) goto    G0497;
    a = Lefloat_value(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
    q = a;
    a = value(LL_Hfcut);
    a = Lmax2(a, q);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0524;
    goto    G0538;
   G0497:
    a = Lecomplexp(a);
    if(a == nil) goto    G0505;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = value(LL_Hfcut);
    a = Lmax2(a, q);
    value(LL_Htemporal) = a;
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G0524;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    q = value(LL_Htemporal);
    a = Llessp(a, q);
    if(a != nil) goto    G0538;
    a = w1;
    a = Lecomplex_real(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_CE(a, q);
    }
   G0505:
    a = w1;
    a = Linterval_upper(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0518;
    a = w1;
    a = Linterval_lower(a);
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a != nil) goto    G0538;
   G0518:
    a = w1;
    a = Linterval_mid(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Linterval_width(a);
    q = a;
    a = LITERAL[35];
    a = times2(a, q);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0524;
   G0538:
    a = mkfxat(0);
    goto    G0529;
   G0524:
    a = w1;
   G0529:
    popv(2);
    return a;
}

Sex CC_cutTefloat(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G0542;
    a = Lefloat_value(a);
    q = a;
    a = value(LL_Hfcut);
    a = times2(a, q);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0551;
    goto    G0552;
   G0542:
    a = Lecomplexp(a);
    if(a == nil) goto    G0551;
    a = w1;
    a = Lecomplex_real(a);
    q = a;
    a = value(LL_Hfcut);
    a = times2(a, q);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0551;
    a = w1;
    a = Lecomplex_imag(a);
    q = a;
    a = value(LL_Hfcut);
    a = times2(a, q);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0551;
   G0552:
    a = mkfxat(0);
    goto    G0561;
   G0551:
    a = w1;
   G0561:
    popv(2);
    return a;
}

Sex CC_cutTintvl(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_interval(a)) goto    G0573;
    a = Linterval_lower(a);
    a = Lminusp(a);
    if(a == nil) goto    G0569;
    a = w1;
    a = Linterval_upper(a);
    a = Lplusp(a);
    if(a == nil) goto    G0569;
    a = mkfxat(0);
    goto    G0573;
   G0569:
    a = w1;
   G0573:
    popv(1);
    return a;
}

Sex CC_Aset2oset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0578;
#define LL_Bset LITERAL[36]
    q = LL_Bset;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0577;
   G0578:
    a = LITERAL[37];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0577:
    q = cdr(w1);
#define LL_Boset LITERAL[38]
    a = LL_Boset;
    {
        popv(1);
        return  cons(a, q);
    }
}

Sex CC_Aoset2set(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0584;
    q = LL_Boset;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0583;
   G0584:
    a = LITERAL[39];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0583:
#define LL_Worder LITERAL[40]
    q = LL_Worder;
    a = cdr(w1);
    a = CC_sortany(a, q);
    q = LL_Boset;
    {
        popv(1);
        return  Lxcons(a, q);
    }
}

Sex CC_Aarray2oset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0591;
    a = car(a);
    if(is_vector(a)) goto    G0590;
   G0591:
    a = LITERAL[41];
    {
        popv(5);
        return  CC_argerror(a);
    }
   G0590:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = LL_Boset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = car(cdr(w1));
    w4 = a;
    a = car(w1);
    w1 = a;
    a = mkfxat(0);
    w5 = a;
   G0594:
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    a = CC_convTsexpr2gexpr(a);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = w5;
    if(a != w4) goto    G0594;
    a = w2;
    popv(5);
    return a;
}

Sex CC_Aarray02oset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0606;
    a = car(a);
    if(is_vector(a)) goto    G0605;
   G0606:
    a = LITERAL[42];
    {
        popv(5);
        return  CC_argerror(a);
    }
   G0605:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = LL_Boset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = car(cdr(w1));
    w4 = a;
    a = car(w1);
    w1 = a;
    a = mkfxat(0);
    w5 = a;
   G0609:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    a = CC_convTsexpr2gexpr(a);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = w5;
    if(a == w4) goto    G0616;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    goto    G0609;
   G0616:
    a = w2;
    popv(5);
    return a;
}

Sex CC_Aoset2array(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0621;
    q = LL_Boset;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0620;
   G0621:
    a = LITERAL[43];
    {
        popv(6);
        return  CC_argerror(a);
    }
   G0620:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = cdr(w1);
    w2 = a;
    a = Llength(a);
    w5 = a;
    a = Lmkvect(a);
    w3 = a;
#define LL_CsimpenvC LITERAL[44]
    q = value(LL_CsimpenvC);
#define LL_CordenvC LITERAL[45]
    a = value(LL_CordenvC);
    a = cons(a, q);
#define LL_CevalenvC LITERAL[46]
    q = value(LL_CevalenvC);
    a = Lxcons(a, q);
    w4 = a;
#define LL_Anil LITERAL[47]
    m = LL_Anil;
    q = mkfxat(0);
    a = w3;
    Lputv(a, q, m);
    a = mkfxat(1);
    w6 = a;
   G0624:
    m = w4;
    q = nil;
    a = car(w2);
    a = CC_convTgexpr2sexpr(a, q, m);
    m = a;
    q = w6;
    a = w3;
    Lputv(a, q, m);
    a = w6;
    a = (Sex)((long)a + 0x10);
    w6 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0624;
    q = w5;
    a = q;
    a = Llist2(a, q);
    q = w3;
    {
        popv(6);
        return  Lxcons(a, q);
    }
}

Sex CC_Aoset2array0(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0636;
    q = LL_Boset;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0635;
   G0636:
    a = LITERAL[43];
    {
        popv(6);
        return  CC_argerror(a);
    }
   G0635:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = cdr(w1);
    w2 = a;
    a = Llength(a);
    q = mkfxat(-1);
    a = plus2(a, q);
    w5 = a;
    a = Lmkvect(a);
    w3 = a;
    a = mkfxat(0);
    w6 = a;
    q = value(LL_CsimpenvC);
    a = value(LL_CordenvC);
    a = cons(a, q);
    q = value(LL_CevalenvC);
    a = Lxcons(a, q);
    w4 = a;
   G0639:
    m = w4;
    q = nil;
    a = car(w2);
    a = CC_convTgexpr2sexpr(a, q, m);
    m = a;
    q = w6;
    a = w3;
    Lputv(a, q, m);
    a = w6;
    a = (Sex)((long)a + 0x10);
    w6 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0639;
    q = w5;
    a = q;
    a = Llist2(a, q);
    q = w3;
    {
        popv(6);
        return  Lxcons(a, q);
    }
}

Sex CC_Aarray2form(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0652;
    a = car(a);
    if(is_vector(a)) goto    G0651;
   G0652:
    a = LITERAL[48];
    {
        popv(7);
        return  CC_argerror(a);
    }
   G0651:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = cdr(w1);
    w4 = a;
    a = car(a);
    w5 = a;
    a = car(w1);
    w3 = a;
    a = w5;
    a = Lmkvect(a);
    w2 = a;
    a = mkfxat(0);
    w7 = a;
   G0655:
    q = w7;
    a = w3;
    a = Lgetv(a, q);
    w6 = a;
    if(a != LL_Anil) goto    G0657;
    a = mkfxat(0);
    goto    G0658;
   G0657:
    a = CC_convTsexpr2gexpr(a);
   G0658:
    m = a;
    q = w7;
    a = w2;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w5 >= a) goto    G0655;
    a = cdr(cdr(w4));
    if(a != nil) goto    G0664;
#define LL_CvectC LITERAL[49]
    a = value(LL_CvectC);
    goto    G0667;
   G0664:
    a = cdr(a);
    if(a != nil) goto    G0665;
    a = car(cdr(w4));
    a = Lplusp(a);
    if(a == nil) goto    G0665;
    a = car(cdr(cdr(w4)));
    a = Lminusp(a);
    if(a == nil) goto    G0665;
#define LL_CmatxC LITERAL[50]
    a = value(LL_CmatxC);
    goto    G0667;
   G0665:
#define LL_CtensC LITERAL[51]
    a = value(LL_CtensC);
   G0667:
    w6 = a;
    q = w4;
    a = w2;
    a = cons(a, q);
    q = w6;
    {
        popv(7);
        return  Lxcons(a, q);
    }
}

Sex CC_Aform2array(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0674;
    a = car(a);
    if(!is_integer(a)) goto    G0674;
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    if(a == nil) goto    G0673;
   G0674:
    a = LITERAL[52];
    {
        popv(8);
        return  CC_argerror(a);
    }
   G0673:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = cdr(cdr(w1));
    w5 = a;
    a = car(a);
    w6 = a;
    a = car(cdr(w1));
    w3 = a;
    a = w6;
    a = Lmkvect(a);
    w2 = a;
    a = mkfxat(0);
    w8 = a;
    q = value(LL_CsimpenvC);
    a = value(LL_CordenvC);
    a = cons(a, q);
    q = value(LL_CevalenvC);
    a = Lxcons(a, q);
    w4 = a;
   G0678:
    q = w8;
    a = w3;
    a = Lgetv(a, q);
    w7 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0681;
    a = LL_Anil;
    goto    G0683;
   G0681:
    m = w4;
    q = nil;
    a = w7;
    a = CC_convTgexpr2sexpr(a, q, m);
   G0683:
    m = a;
    q = w8;
    a = w2;
    Lputv(a, q, m);
    a = w8;
    a = (Sex)((long)a + 0x10);
    w8 = a;
    if(w6 >= a) goto    G0678;
    q = w5;
    a = w2;
    {
        popv(8);
        return  cons(a, q);
    }
}

Sex CC_Aoset2vect(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0693;
    q = LL_Boset;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0692;
   G0693:
    a = LITERAL[53];
    {
        popv(5);
        return  CC_argerror(a);
    }
   G0692:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(w1);
    w3 = a;
    q = a;
#define LL_Wratexpr LITERAL[54]
    a = LL_Wratexpr;
    a = CC_Wchklist(a, q);
    if(a != nil) goto    G0698;
    q = LITERAL[53];
    a = LITERAL[55];
    CC_errormsg(a, q);
   G0698:
    a = w3;
    a = Llength(a);
    w4 = a;
    a = Lmkvect(a);
    w2 = a;
    m = mkfxat(0);
    q = mkfxat(0);
    Lputv(a, q, m);
    a = mkfxat(0);
    w5 = a;
   G0696:
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    m = car(w3);
    q = a;
    a = w2;
    Lputv(a, q, m);
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0696;
    a = w4;
    a = Lminus(a);
    q = a;
    a = w4;
    a = Llist2(a, q);
    q = w2;
    a = Lxcons(a, q);
    q = value(LL_CvectC);
    {
        popv(5);
        return  Lxcons(a, q);
    }
}

Sex CC_Avect2oset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0710;
    q = value(LL_CvectC);
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0709;
   G0710:
    a = LITERAL[56];
    {
        popv(5);
        return  CC_argerror(a);
    }
   G0709:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = LL_Boset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = car(cdr(cdr(w1)));
    w4 = a;
    a = car(cdr(w1));
    w1 = a;
    a = mkfxat(0);
    w5 = a;
   G0713:
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = w5;
    if(a != w4) goto    G0713;
    a = w2;
    popv(5);
    return a;
}

Sex CC_Aoset2vect0(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0724;
    q = LL_Boset;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0723;
   G0724:
    a = LITERAL[53];
    {
        popv(5);
        return  CC_argerror(a);
    }
   G0723:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(w1);
    w3 = a;
    q = a;
    a = LL_Wratexpr;
    a = CC_Wchklist(a, q);
    if(a != nil) goto    G0729;
    q = LITERAL[57];
    a = LITERAL[55];
    CC_errormsg(a, q);
   G0729:
    a = w3;
    a = Llength(a);
    q = mkfxat(-1);
    a = plus2(a, q);
    w4 = a;
    a = Lmkvect(a);
    w2 = a;
    a = mkfxat(0);
    w5 = a;
   G0727:
    m = car(w3);
    q = w5;
    a = w2;
    Lputv(a, q, m);
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0727;
    a = w4;
    a = Lminus(a);
    q = a;
    a = w4;
    a = Llist2(a, q);
    q = w2;
    a = Lxcons(a, q);
    q = value(LL_CvectC);
    {
        popv(5);
        return  Lxcons(a, q);
    }
}

Sex CC_Avect02oset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0741;
    q = value(LL_CvectC);
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0740;
   G0741:
    a = LITERAL[58];
    {
        popv(5);
        return  CC_argerror(a);
    }
   G0740:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = LL_Boset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = car(cdr(cdr(w1)));
    w4 = a;
    a = car(cdr(w1));
    w1 = a;
    a = mkfxat(0);
    w5 = a;
   G0744:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = w5;
    if(a == w4) goto    G0750;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    goto    G0744;
   G0750:
    a = w2;
    popv(5);
    return a;
}



/* initialization procedure */
int init_comconv(void)
{
   long i;

   create_symbols(comconv_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; comconv_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(comconv_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4;
        a = LITERAL[59];
        CC_Aenter(a);
        arg4 = nil;
        m = nil;
#define LL_Amkexpr LITERAL[60]
        q = LL_Amkexpr;
#define LL_mkexpr LITERAL[61]
        a = LL_mkexpr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Avar2expr LITERAL[62]
        q = LL_Avar2expr;
#define LL_var2expr LITERAL[63]
        a = LL_var2expr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Afunc2expr LITERAL[64]
        q = LL_Afunc2expr;
#define LL_func2expr LITERAL[65]
        a = LL_func2expr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aexpr2varfunc LITERAL[66]
        q = LL_Aexpr2varfunc;
#define LL_expr2varfunc LITERAL[67]
        a = LL_expr2varfunc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Arealpart LITERAL[68]
        q = LL_Arealpart;
#define LL_realpart LITERAL[69]
        a = LL_realpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aimagpart LITERAL[70]
        q = LL_Aimagpart;
#define LL_imagpart LITERAL[71]
        a = LL_imagpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2abs LITERAL[72]
        q = LL_Acoef2abs;
#define LL_coef2abs LITERAL[73]
        a = LL_coef2abs;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2int LITERAL[74]
        q = LL_Acoef2int;
#define LL_coef2int LITERAL[75]
        a = LL_coef2int;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2ratn LITERAL[76]
        q = LL_Acoef2ratn;
#define LL_coef2ratn LITERAL[77]
        a = LL_coef2ratn;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Acoef2ratn;
#define LL_coef2ratnum LITERAL[78]
        a = LL_coef2ratnum;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2float LITERAL[79]
        q = LL_Acoef2float;
#define LL_coef2float LITERAL[80]
        a = LL_coef2float;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2compl LITERAL[81]
        q = LL_Acoef2compl;
#define LL_coef2compl LITERAL[82]
        a = LL_coef2compl;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Acoef2compl;
#define LL_coef2comple LITERAL[83]
        a = LL_coef2comple;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Acoef2compl;
#define LL_coef2complex LITERAL[84]
        a = LL_coef2complex;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2bfloat LITERAL[85]
        q = LL_Acoef2bfloat;
#define LL_coef2bfloat LITERAL[86]
        a = LL_coef2bfloat;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2efloat LITERAL[87]
        q = LL_Acoef2efloat;
#define LL_coef2efloat LITERAL[88]
        a = LL_coef2efloat;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2efloa1 LITERAL[89]
        q = LL_Acoef2efloa1;
#define LL_coef2efloat1 LITERAL[90]
        a = LL_coef2efloat1;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2ecompl LITERAL[91]
        q = LL_Acoef2ecompl;
#define LL_coef2ecompl LITERAL[92]
        a = LL_coef2ecompl;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Acoef2ecompl;
#define LL_coef2ecomplex LITERAL[93]
        a = LL_coef2ecomplex;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2intval LITERAL[94]
        q = LL_Acoef2intval;
#define LL_coef2intval LITERAL[95]
        a = LL_coef2intval;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Acoef2intval;
#define LL_coef2interval LITERAL[96]
        a = LL_coef2interval;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoef2befloat LITERAL[97]
        q = LL_Acoef2befloat;
#define LL_coef2befloat LITERAL[98]
        a = LL_coef2befloat;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Amodulo LITERAL[99]
        q = LL_Amodulo;
#define LL_modulo LITERAL[100]
        a = LL_modulo;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Amodulo;
#define LL_modulo1 LITERAL[101]
        a = LL_modulo1;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Amodulo2 LITERAL[102]
        q = LL_Amodulo2;
#define LL_modulo2 LITERAL[103]
        a = LL_modulo2;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acutcoef LITERAL[104]
        q = LL_Acutcoef;
#define LL_cutcoef LITERAL[105]
        a = LL_cutcoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acutefcoef LITERAL[106]
        q = LL_Acutefcoef;
#define LL_cutefcoef LITERAL[107]
        a = LL_cutefcoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acutitvcoef LITERAL[108]
        q = LL_Acutitvcoef;
#define LL_cutitvcoef LITERAL[109]
        a = LL_cutitvcoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Asimpcompl LITERAL[110]
        q = LL_Asimpcompl;
        a = LL_simpcompl;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aset2oset LITERAL[111]
        q = LL_Aset2oset;
#define LL_set2oset LITERAL[112]
        a = LL_set2oset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aset2oset;
#define LL_set2ordset LITERAL[113]
        a = LL_set2ordset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aoset2set LITERAL[114]
        q = LL_Aoset2set;
#define LL_oset2set LITERAL[115]
        a = LL_oset2set;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aoset2set;
#define LL_ordset2set LITERAL[116]
        a = LL_ordset2set;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aarray2oset LITERAL[117]
        q = LL_Aarray2oset;
#define LL_array2oset LITERAL[118]
        a = LL_array2oset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aarray2oset;
#define LL_array2ordset LITERAL[119]
        a = LL_array2ordset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aarray02oset LITERAL[120]
        q = LL_Aarray02oset;
#define LL_array02oset LITERAL[121]
        a = LL_array02oset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aarray02oset;
#define LL_array02ordset LITERAL[122]
        a = LL_array02ordset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aoset2array LITERAL[123]
        q = LL_Aoset2array;
#define LL_oset2array LITERAL[124]
        a = LL_oset2array;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aoset2array;
#define LL_ordset2array LITERAL[125]
        a = LL_ordset2array;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aoset2array0 LITERAL[126]
        q = LL_Aoset2array0;
#define LL_oset2array0 LITERAL[127]
        a = LL_oset2array0;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aoset2array0;
#define LL_ordset2array0 LITERAL[128]
        a = LL_ordset2array0;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aarray2form LITERAL[129]
        q = LL_Aarray2form;
#define LL_array2form LITERAL[130]
        a = LL_array2form;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aform2array LITERAL[131]
        q = LL_Aform2array;
#define LL_form2array LITERAL[132]
        a = LL_form2array;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aoset2vect LITERAL[133]
        q = LL_Aoset2vect;
#define LL_oset2vect LITERAL[134]
        a = LL_oset2vect;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aoset2vect;
#define LL_ordset2vect LITERAL[135]
        a = LL_ordset2vect;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Avect2oset LITERAL[136]
        q = LL_Avect2oset;
#define LL_vect2oset LITERAL[137]
        a = LL_vect2oset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Avect2oset;
#define LL_vect2ordset LITERAL[138]
        a = LL_vect2ordset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aoset2vect0 LITERAL[139]
        q = LL_Aoset2vect0;
#define LL_oset2vect0 LITERAL[140]
        a = LL_oset2vect0;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aoset2vect0;
#define LL_ordset2vect0 LITERAL[141]
        a = LL_ordset2vect0;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Avect02oset LITERAL[142]
        q = LL_Avect02oset;
#define LL_vect02oset LITERAL[143]
        a = LL_vect02oset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Avect02oset;
#define LL_vect02ordset LITERAL[144]
        a = LL_vect02ordset;
        a = CC_defcommand(a, q, m, arg4);
        return 1;
    }
}
Sex LITERAL[146];

const  char *comconv_literal_string[146] =
{
/* 0 */
"\"UNCONVERTIBLE TO <INT>\"",
/* 1 */
"!*mod",
/* 2 */
"!*fcut",
/* 3 */
"0.000000000000000",
/* 4 */
"\"bnum2bfloat\"",
/* 5 */
"\"PROGRAMMING NOT YET\"",
/* 6 */
"!*machineps",
/* 7 */
"\"UNCONVERTIBLE TO <EFLOAT>\"",
/* 8 */
"\"PROGRAMMING .. NOT YET\"",
/* 9 */
"!*temporal",
/* 10 */
"\"UNCONVERTIBLE TO <INTVAL>\"",
/* 11 */
"!*meps100",
/* 12 */
"bnum2real",
/* 13 */
"bnum2imag",
/* 14 */
"bnum2cc",
/* 15 */
"abs",
/* 16 */
"bnum2int",
/* 17 */
"bnum2ratn",
/* 18 */
"bnum2float",
/* 19 */
"bnum2compl",
/* 20 */
"bnum2bfloat",
/* 21 */
"bnum2efloat",
/* 22 */
"bnum2efloa1",
/* 23 */
"bnum2ecompl",
/* 24 */
"bnum2intval",
/* 25 */
"bnum2befloat",
/* 26 */
"simpcompl",
/* 27 */
"!*!*mod",
/* 28 */
"mod!:intratn",
/* 29 */
"\"INVALID ARGUMENT FOR MODULO\"",
/* 30 */
"mod2!:intratn",
/* 31 */
"cut!:bnum",
/* 32 */
"\"CUTOFF-NUMBER MUST BE POSITIVE\"",
/* 33 */
"cut!:efloat",
/* 34 */
"cut!:intvl",
/* 35 */
"0.5000000000000000",
/* 36 */
"!!set",
/* 37 */
"\"set2oset\"",
/* 38 */
"!!oset",
/* 39 */
"\"oset2set\"",
/* 40 */
"!?order",
/* 41 */
"\"array2oset\"",
/* 42 */
"\"array02oset\"",
/* 43 */
"\"oset2array\"",
/* 44 */
"!#simpenv!#",
/* 45 */
"!#ordenv!#",
/* 46 */
"!#evalenv!#",
/* 47 */
"! nil",
/* 48 */
"\"ARRAY2FORM\"",
/* 49 */
"!#vect!#",
/* 50 */
"!#matx!#",
/* 51 */
"!#tens!#",
/* 52 */
"\"FORM2ARRAY\"",
/* 53 */
"\"OSET2VECT\"",
/* 54 */
"!?ratexpr",
/* 55 */
"\"ELEMENT IS NOT <RATEXPR>\"",
/* 56 */
"\"VECT2OSET\"",
/* 57 */
"\"OSET2VECT0\"",
/* 58 */
"\"VECT02OSET\"",
/* 59 */
"(lisp)",
/* 60 */
"! mkexpr",
/* 61 */
"mkexpr",
/* 62 */
"! var2expr",
/* 63 */
"var2expr",
/* 64 */
"! func2expr",
/* 65 */
"func2expr",
/* 66 */
"! expr2varfunc",
/* 67 */
"expr2varfunc",
/* 68 */
"! realpart",
/* 69 */
"realpart",
/* 70 */
"! imagpart",
/* 71 */
"imagpart",
/* 72 */
"! coef2abs",
/* 73 */
"coef2abs",
/* 74 */
"! coef2int",
/* 75 */
"coef2int",
/* 76 */
"! coef2ratn",
/* 77 */
"coef2ratn",
/* 78 */
"coef2ratnum",
/* 79 */
"! coef2float",
/* 80 */
"coef2float",
/* 81 */
"! coef2compl",
/* 82 */
"coef2compl",
/* 83 */
"coef2comple",
/* 84 */
"coef2complex",
/* 85 */
"! coef2bfloat",
/* 86 */
"coef2bfloat",
/* 87 */
"! coef2efloat",
/* 88 */
"coef2efloat",
/* 89 */
"! coef2efloa1",
/* 90 */
"coef2efloat1",
/* 91 */
"! coef2ecompl",
/* 92 */
"coef2ecompl",
/* 93 */
"coef2ecomplex",
/* 94 */
"! coef2intval",
/* 95 */
"coef2intval",
/* 96 */
"coef2interval",
/* 97 */
"! coef2befloat",
/* 98 */
"coef2befloat",
/* 99 */
"! modulo",
/* 100 */
"modulo",
/* 101 */
"modulo1",
/* 102 */
"! modulo2",
/* 103 */
"modulo2",
/* 104 */
"! cutcoef",
/* 105 */
"cutcoef",
/* 106 */
"! cutefcoef",
/* 107 */
"cutefcoef",
/* 108 */
"! cutitvcoef",
/* 109 */
"cutitvcoef",
/* 110 */
"! simpcompl",
/* 111 */
"! set2oset",
/* 112 */
"set2oset",
/* 113 */
"set2ordset",
/* 114 */
"! oset2set",
/* 115 */
"oset2set",
/* 116 */
"ordset2set",
/* 117 */
"! array2oset",
/* 118 */
"array2oset",
/* 119 */
"array2ordset",
/* 120 */
"! array02oset",
/* 121 */
"array02oset",
/* 122 */
"array02ordset",
/* 123 */
"! oset2array",
/* 124 */
"oset2array",
/* 125 */
"ordset2array",
/* 126 */
"! oset2array0",
/* 127 */
"oset2array0",
/* 128 */
"ordset2array0",
/* 129 */
"! array2form",
/* 130 */
"array2form",
/* 131 */
"! form2array",
/* 132 */
"form2array",
/* 133 */
"! oset2vect",
/* 134 */
"oset2vect",
/* 135 */
"ordset2vect",
/* 136 */
"! vect2oset",
/* 137 */
"vect2oset",
/* 138 */
"vect2ordset",
/* 139 */
"! oset2vect0",
/* 140 */
"oset2vect0",
/* 141 */
"ordset2vect0",
/* 142 */
"! vect02oset",
/* 143 */
"vect02oset",
/* 144 */
"vect02ordset",
/* 145 */ NULL
};
setup_type const comconv_g_setup[] =
{
    {" vect02oset", (lisp_proc *)CC_Avect02oset, 1},
    {" oset2vect0", (lisp_proc *)CC_Aoset2vect0, 1},
    {" vect2oset", (lisp_proc *)CC_Avect2oset, 1},
    {" oset2vect", (lisp_proc *)CC_Aoset2vect, 1},
    {" form2array", (lisp_proc *)CC_Aform2array, 1},
    {" array2form", (lisp_proc *)CC_Aarray2form, 1},
    {" oset2array0", (lisp_proc *)CC_Aoset2array0, 1},
    {" oset2array", (lisp_proc *)CC_Aoset2array, 1},
    {" array02oset", (lisp_proc *)CC_Aarray02oset, 1},
    {" array2oset", (lisp_proc *)CC_Aarray2oset, 1},
    {" oset2set", (lisp_proc *)CC_Aoset2set, 1},
    {" set2oset", (lisp_proc *)CC_Aset2oset, 1},
    {"cut:intvl", (lisp_proc *)CC_cutTintvl, 1},
    {"cut:efloat", (lisp_proc *)CC_cutTefloat, 1},
    {"cut:bnum", (lisp_proc *)CC_cutTbnum, 1},
    {" cutitvcoef", (lisp_proc *)CC_Acutitvcoef, 1},
    {" cutefcoef", (lisp_proc *)CC_Acutefcoef, 2},
    {" cutcoef", (lisp_proc *)CC_Acutcoef, 2},
    {"mod2:intratn", (lisp_proc *)CC_mod2Tintratn, 1},
    {"mod:intratn", (lisp_proc *)CC_modTintratn, 1},
    {" modulo2", (lisp_proc *)CC_Amodulo2, 2},
    {" modulo", (lisp_proc *)CC_Amodulo, 2},
    {" simpcompl", (lisp_proc *)CC_Asimpcompl, 2},
    {" coef2befloat", (lisp_proc *)CC_Acoef2befloat, 1},
    {" coef2intval", (lisp_proc *)CC_Acoef2intval, 1},
    {" coef2ecompl", (lisp_proc *)CC_Acoef2ecompl, 1},
    {" coef2efloa1", (lisp_proc *)CC_Acoef2efloa1, 1},
    {" coef2efloat", (lisp_proc *)CC_Acoef2efloat, 1},
    {" coef2bfloat", (lisp_proc *)CC_Acoef2bfloat, 1},
    {" coef2compl", (lisp_proc *)CC_Acoef2compl, 1},
    {" coef2float", (lisp_proc *)CC_Acoef2float, 1},
    {" coef2ratn", (lisp_proc *)CC_Acoef2ratn, 1},
    {" coef2int", (lisp_proc *)CC_Acoef2int, 1},
    {" coef2abs", (lisp_proc *)CC_Acoef2abs, 1},
    {" compconj", (lisp_proc *)CC_Acompconj, 1},
    {" imagpart", (lisp_proc *)CC_Aimagpart, 1},
    {" realpart", (lisp_proc *)CC_Arealpart, 1},
    {"bnum2cc", (lisp_proc *)CC_bnum2cc, 1},
    {"bnum2imag", (lisp_proc *)CC_bnum2imag, 1},
    {"bnum2real", (lisp_proc *)CC_bnum2real, 1},
    {"bnum2round", (lisp_proc *)CC_bnum2round, 1},
    {"bnum2intval", (lisp_proc *)CC_bnum2intval, 1},
    {"bnum2ecompl", (lisp_proc *)CC_bnum2ecompl, 1},
    {"bnum2befloat", (lisp_proc *)CC_bnum2befloat, 1},
    {"bnum2efloa1", (lisp_proc *)CC_bnum2efloa1, 1},
    {"bnum2efloat", (lisp_proc *)CC_bnum2efloat, 1},
    {"bnum2compl", (lisp_proc *)CC_bnum2compl, 1},
    {"bnum2bfloat", (lisp_proc *)CC_bnum2bfloat, 1},
    {"bnum2float", (lisp_proc *)CC_bnum2float, 1},
    {"bnum2int", (lisp_proc *)CC_bnum2int, 1},
    {"modint2ratn", (lisp_proc *)CC_modint2ratn, 2},
    {"modratn2int", (lisp_proc *)CC_modratn2int, 2},
    {NULL, NULL, 0 }
};

