#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_comform.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex comform_literal_vector[];
const char *comform_literal_string[];
setup_type const  comform_g_setup[];
#define LITERAL comform_literal_vector




Sex CC_Wsparse(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Wmatx(a);
    if(a != nil) goto    G0005;
    a = LITERAL[0];
    CC_argerror(a);
   G0005:
    a = car(cdr(w1));
    w2 = a;
    a = car(cdr(cdr(w1)));
    w3 = a;
    a = mkfxat(0);
    w4 = a;
    w5 = a;
    w6 = nil;
   G0007:
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w3;
    a = Lleq(a, q);
    if(a == nil) goto    G0006;
    q = w5;
    a = w2;
    a = Lgetv(a, q);
    a = Lzerop(a);
    if(a == nil) goto    G0012;
    a = w4;
    a = Ladd1(a);
    w4 = a;
   G0012:
    w6 = a;
    goto    G0007;
   G0006:
    a = w4;
    a = Lfloat(a);
    q = w3;
    a = quot2(a, q);
    q = LITERAL[1];
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0003;
    a = true;
   G0003:
    popv(6);
    return a;
}

Sex CC_Avects2matx(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w2 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w3 = a;
    w1 = a;
    a = CC_Wsetexpr(a);
    if(a != nil) goto    G0043;
    q = LITERAL[2];
    a = mkfxat(3);
    CC_errormsg(a, q);
   G0043:
    w9 = nil;
   G0045:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0044;
    a = car(a);
    a = CC_Wvect(a);
    if(a != nil) goto    G0049;
    q = LITERAL[3];
    a = mkfxat(3);
    a = CC_errormsg(a, q);
    goto    G0048;
   G0049:
    a = nil;
   G0048:
    w9 = a;
    goto    G0045;
   G0044:
    a = cdr(w1);
    w1 = a;
    a = CC_listcdr(a);
    w3 = a;
    a = car(cdr(cdr(car(a))));
    w5 = a;
    a = w1;
    a = Llength(a);
    w9 = a;
    a = w5;
    a = Labs(a);
    q = a;
    a = w9;
    a = Lneq(a, q);
    if(a == nil) goto    G0051;
    q = LITERAL[4];
    a = mkfxat(3);
    CC_errormsg(a, q);
   G0051:
    q = w5;
    a = q;
    a = times2(a, q);
    a = Lmkvect(a);
    w2 = a;
    a = w5;
    a = Lminusp(a);
    if(a != nil) goto    G0084;
    a = mkfxat(1);
    goto    G0083;
   G0084:
    a = mkfxat(0);
    w6 = a;
    a = w5;
    a = Lminus(a);
    w5 = a;
   G0057:
    a = car(car(w3));
    w4 = a;
    a = mkfxat(1);
    w9 = a;
    a = w5;
    w10 = a;
    a = mkfxat(1);
    w11 = a;
    m = a;
    q = w10;
    a = w9;
    CC_Wchkfor(a, q, m);
   G0059:
    q = w5;
    a = w6;
    a = times2(a, q);
    q = w9;
    a = plus2(a, q);
    w13 = a;
    q = w9;
    a = w4;
    a = Lgetv(a, q);
    m = a;
    q = w13;
    a = w2;
    a = Lputv(a, q, m);
    w12 = a;
    q = w11;
    a = w9;
    a = plus2(a, q);
    w9 = a;
    m = w11;
    q = w10;
    a = CC_Wendfor(a, q, m);
    if(a == nil) goto    G0059;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0078;
    a = w6;
    a = Ladd1(a);
    w6 = a;
    goto    G0057;
   G0038:
    a = car(car(w3));
    w4 = a;
    a = mkfxat(1);
    w9 = a;
    a = w5;
    w10 = a;
    a = mkfxat(1);
    w11 = a;
    m = a;
    q = w10;
    a = w9;
    CC_Wchkfor(a, q, m);
   G0069:
    q = mkfxat(-1);
    a = w9;
    a = plus2(a, q);
    q = w5;
    a = times2(a, q);
    q = w7;
    a = plus2(a, q);
    w13 = a;
    q = w9;
    a = w4;
    a = Lgetv(a, q);
    m = a;
    q = w13;
    a = w2;
    a = Lputv(a, q, m);
    w12 = a;
    q = w11;
    a = w9;
    a = plus2(a, q);
    w9 = a;
    m = w11;
    q = w10;
    a = CC_Wendfor(a, q, m);
    if(a == nil) goto    G0069;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0078;
    a = w7;
    a = Ladd1(a);
   G0083:
    w7 = a;
    goto    G0038;
   G0078:
    q = w5;
    a = q;
    a = times2(a, q);
    w9 = a;
    a = w5;
    a = Lminus(a);
    m = a;
    q = w5;
    a = w9;
    a = Llist3(a, q, m);
    w5 = a;
    q = w2;
    a = Lxcons(a, q);
#define LL_CmatxC LITERAL[5]
    q = value(LL_CmatxC);
    {
        popv(13);
        return  Lxcons(a, q);
    }
}

Sex CC_Aunitmatrix(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_integer(a)) goto    G0089;
    a = Lplusp(a);
    if(a != nil) goto    G0088;
   G0089:
    a = LITERAL[6];
    {
        popv(4);
        return  CC_argerror(a);
    }
   G0088:
    w2 = nil;
    w3 = nil;
    q = w1;
    a = q;
    a = times2(a, q);
    w4 = a;
    a = w1;
    a = Lminus(a);
    m = a;
    q = w1;
    a = w4;
    a = Llist3(a, q, m);
    w3 = a;
    a = w1;
    a = CC_unitmatxH(a);
    w2 = a;
    q = w3;
    a = cons(a, q);
    q = value(LL_CmatxC);
    {
        popv(4);
        return  Lxcons(a, q);
    }
}

Sex CC_Aexchrow(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    arg4 = m;
    m = q;
    q = cdr(cdr(a));
    a = car(cdr(a));
    CC_exchrowH(a, q, m, arg4);
    a = w1;
    popv(1);
    return a;
}

Sex CC_Aexchcol(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    arg4 = m;
    m = q;
    q = cdr(cdr(a));
    a = car(cdr(a));
    CC_exchcolH(a, q, m, arg4);
    a = w1;
    popv(1);
    return a;
}

Sex CC_unitmatxH(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    q = a;
    a = times2(a, q);
    a = Lmkvect(a);
    w2 = a;
    a = mkfxat(0);
    w4 = a;
   G0103:
    q = w1;
    a = w4;
    a = times2(a, q);
    w3 = a;
    a = mkfxat(0);
    w5 = a;
   G0104:
    a = w3;
    a = Ladd1(a);
    w3 = a;
    a = w4;
    if(a != w5) goto    G0108;
    a = mkfxat(1);
    goto    G0109;
   G0108:
    a = mkfxat(0);
   G0109:
    m = a;
    q = w3;
    a = w2;
    Lputv(a, q, m);
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w1;
    a = Llessp(a, q);
    if(a != nil) goto    G0104;
    a = w4;
    a = Ladd1(a);
    w4 = a;
    q = w1;
    a = Llessp(a, q);
    if(a != nil) goto    G0103;
    a = w2;
    popv(5);
    return a;
}

Sex CC_copyvect(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lmkvect(a);
    w3 = a;
    a = mkfxat(1);
    w4 = a;
   G0120:
    q = w4;
    a = w1;
    a = Lgetv(a, q);
    m = a;
    q = w4;
    a = w3;
    Lputv(a, q, m);
    q = w2;
    a = w4;
    a = Lequal(a, q);
    if(a != nil) goto    G0124;
    a = w4;
    a = Ladd1(a);
    w4 = a;
    goto    G0120;
   G0124:
    a = w3;
    popv(4);
    return a;
}

Sex CC_exchrowH(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w6 = nil;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = car(cdr(q));
    a = Labs(a);
    w5 = a;
    a = car(cdr(cdr(w2)));
    a = Labs(a);
    w6 = a;
    q = w4;
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0130;
    a = w3;
    w10 = a;
    a = w4;
    w3 = a;
    a = w10;
    w4 = a;
   G0130:
    q = w4;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G0132;
    q = w5;
    a = w3;
    a = Lleq(a, q);
    if(a != nil) goto    G0143;
    q = w3;
    a = LITERAL[7];
    CC_errormsg(a, q);
   G0132:
    q = w5;
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0137;
    q = w4;
    a = LITERAL[7];
    CC_errormsg(a, q);
   G0137:
    a = w3;
    a = Lsub1(a);
    q = w6;
    a = times2(a, q);
    w7 = a;
    a = w4;
    a = Lsub1(a);
    q = w6;
    a = times2(a, q);
    w8 = a;
    a = mkfxat(1);
    w9 = a;
   G0128:
    a = w7;
    a = Ladd1(a);
    w7 = a;
    a = w8;
    a = Ladd1(a);
    w8 = a;
    q = w7;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w8;
    a = w1;
    a = Lgetv(a, q);
    m = a;
    q = w7;
    a = w1;
    Lputv(a, q, m);
    m = w10;
    q = w8;
    a = w1;
    Lputv(a, q, m);
    q = w6;
    a = w9;
    a = Lequal(a, q);
    if(a != nil) goto    G0143;
    a = w9;
    a = Ladd1(a);
    w9 = a;
    goto    G0128;
   G0143:
    a = w1;
    popv(10);
    return a;
}

Sex CC_exchcolH(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = arg4;
    a = m;
    a = Lequal(a, q);
    if(a != nil) goto    G0164;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = mkfxat(1);
    w7 = a;
    a = car(cdr(w2));
    a = Labs(a);
    w5 = a;
    a = car(cdr(cdr(w2)));
    a = Labs(a);
    w6 = a;
    q = w4;
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0152;
    a = w3;
    w8 = a;
    a = w4;
    w3 = a;
    a = w8;
    w4 = a;
   G0152:
    q = w4;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G0154;
    q = w6;
    a = w3;
    a = Lleq(a, q);
    if(a != nil) goto    G0164;
    q = w3;
    a = LITERAL[8];
    CC_errormsg(a, q);
   G0154:
    q = w6;
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0159;
    q = w4;
    a = LITERAL[8];
    CC_errormsg(a, q);
   G0159:
    q = w3;
    a = w1;
    a = Lgetv(a, q);
    w8 = a;
    q = w4;
    a = w1;
    a = Lgetv(a, q);
    m = a;
    q = w3;
    a = w1;
    Lputv(a, q, m);
    m = w8;
    q = w4;
    a = w1;
    Lputv(a, q, m);
    q = w5;
    a = w7;
    a = Lequal(a, q);
    if(a != nil) goto    G0164;
    a = w7;
    a = Ladd1(a);
    w7 = a;
    q = w6;
    a = w3;
    a = plus2(a, q);
    w3 = a;
    q = w6;
    a = w4;
    a = plus2(a, q);
    w4 = a;
    goto    G0159;
   G0164:
    a = w1;
    popv(8);
    return a;
}

Sex CC_multTcanobnum(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
    a = m;
    {
        return  CC_multTbnumcano(a, q);
    }
}

Sex CC_multTprefbnum(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
    a = m;
    {
        return  CC_multTbnumpref(a, q);
    }
}

Sex CC_multTprefcano(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
    a = m;
    {
        return  CC_multTcanopref(a, q);
    }
}

Sex CC_unmultTprefcano(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
    a = m;
    {
        return  CC_unmultTcanopref(a, q);
    }
}

Sex CC_plusTformform(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = cdr(cdr(a));
    w6 = a;
    q = cdr(cdr(q));
    a = Lequal(a, q);
    if(a != nil) goto    G0179;
    q = LITERAL[9];
    a = LITERAL[10];
    CC_errormsg(a, q);
   G0179:
    a = car(cdr(w1));
    w4 = a;
    a = car(cdr(w2));
    w5 = a;
    a = car(w6);
    w6 = a;
    a = Lmkvect(a);
    w3 = a;
    m = mkfxat(0);
    q = mkfxat(0);
    Lputv(a, q, m);
    a = mkfxat(1);
    w7 = a;
#define LL_Hcolmode LITERAL[11]
    a = value(LL_Hcolmode);
#define LL_uncol LITERAL[12]
    if(a == LL_uncol) goto    G0177;
   G0182:
    q = w7;
    a = w4;
    a = Lgetv(a, q);
    w8 = a;
    q = w7;
    a = w5;
    a = Lgetv(a, q);
    q = a;
    a = w8;
    a = CC_addH(a, q);
    m = a;
    q = w7;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w6 >= a) goto    G0182;
    q = cdr(cdr(w1));
    a = w3;
    a = cons(a, q);
    q = car(w1);
    goto    G0199;
   G0177:
    q = w7;
    a = w4;
    a = Lgetv(a, q);
    w8 = a;
    q = w7;
    a = w5;
    a = Lgetv(a, q);
    q = a;
    a = w8;
    a = CC_unaddH(a, q);
    m = a;
    q = w7;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w6 >= a) goto    G0177;
    q = cdr(cdr(w2));
    a = w3;
    a = cons(a, q);
    q = car(w2);
   G0199:
    {
        popv(8);
        return  Lxcons(a, q);
    }
}

Sex CC_negTform(Sex a)
{
    Sex q, m, arg4;
    arg4 = a;
#define LL_negTpref LITERAL[13]
    m = LL_negTpref;
#define LL_negTcano LITERAL[14]
    q = LL_negTcano;
#define LL_negTbnum LITERAL[15]
    a = LL_negTbnum;
    {
        return  CC_map3Tform(a, q, m, arg4);
    }
}

Sex CC_timesTbnumform(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    arg5 = q;
    arg4 = a;
#define LL_multTbnumpref LITERAL[16]
    m = LL_multTbnumpref;
#define LL_multTbnumcano LITERAL[17]
    q = LL_multTbnumcano;
#define LL_multTbnumbnum LITERAL[18]
    a = LL_multTbnumbnum;
    {
        return  CC_map3Txxform(a, q, m, arg4, arg5);
    }
}

Sex CC_timesTcanoform(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Hexpmode LITERAL[19]
    a = value(LL_Hexpmode);
    arg5 = q;
    arg4 = w1;
#define LL_unexp LITERAL[20]
    if(a != LL_unexp) goto    G0207;
#define LL_unmultTcanopref LITERAL[21]
    m = LL_unmultTcanopref;
#define LL_unmultTcanocano LITERAL[22]
    q = LL_unmultTcanocano;
    goto    G0209;
   G0207:
#define LL_multTcanopref LITERAL[23]
    m = LL_multTcanopref;
#define LL_multTcanocano LITERAL[24]
    q = LL_multTcanocano;
   G0209:
#define LL_multTcanobnum LITERAL[25]
    a = LL_multTcanobnum;
    {
        popv(1);
        return  CC_map3Txxform(a, q, m, arg4, arg5);
    }
}

Sex CC_timesTprefform(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_Hexpmode);
    arg5 = q;
    arg4 = w1;
    if(a != LL_unexp) goto    G0213;
#define LL_unmultTprefpref LITERAL[26]
    m = LL_unmultTprefpref;
#define LL_unmultTprefcano LITERAL[27]
    q = LL_unmultTprefcano;
    goto    G0215;
   G0213:
#define LL_multTprefpref LITERAL[28]
    m = LL_multTprefpref;
#define LL_multTprefcano LITERAL[29]
    q = LL_multTprefcano;
   G0215:
#define LL_multTprefbnum LITERAL[30]
    a = LL_multTprefbnum;
    {
        popv(1);
        return  CC_map3Txxform(a, q, m, arg4, arg5);
    }
}

Sex CC_timesTformpref(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_Hexpmode);
    arg5 = q;
    arg4 = w1;
    if(a != LL_unexp) goto    G0219;
    m = LL_unmultTprefpref;
    q = LL_unmultTcanopref;
    goto    G0221;
   G0219:
    m = LL_multTprefpref;
    q = LL_multTcanopref;
   G0221:
    a = LL_multTbnumpref;
    {
        popv(1);
        return  CC_map3Tformxx(a, q, m, arg4, arg5);
    }
}

Sex CC_timesTformform(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w3 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    a = cdr(cdr(cdr(a)));
    a = Llast(a);
    w3 = a;
    a = Lplusp(a);
    if(a == nil) goto    G0226;
    q = LITERAL[31];
    a = LITERAL[32];
    goto    G0248;
   G0226:
    a = car(cdr(cdr(cdr(w2))));
    w4 = a;
    a = Lminusp(a);
    if(a == nil) goto    G0228;
    q = LITERAL[31];
    a = LITERAL[33];
    goto    G0248;
   G0228:
    q = w4;
    a = w3;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    a = Lzerop(a);
    if(a != nil) goto    G0230;
    q = LITERAL[31];
    a = LITERAL[10];
   G0248:
    CC_errormsg(a, q);
   G0230:
    a = car(w1);
    w3 = a;
    if(a != value(LL_CmatxC)) goto    G0233;
    a = car(w2);
    w4 = a;
    if(a != value(LL_CmatxC)) goto    G0235;
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTmatmat(a, q);
    }
   G0235:
#define LL_CvectC LITERAL[34]
    if(a != value(LL_CvectC)) goto    G0236;
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTmatvec(a, q);
    }
   G0236:
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTmatten(a, q);
    }
   G0233:
    if(a != value(LL_CvectC)) goto    G0238;
    a = car(w2);
    w4 = a;
    if(a != value(LL_CvectC)) goto    G0240;
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTvecvec(a, q);
    }
   G0240:
    if(a != value(LL_CmatxC)) goto    G0241;
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTvecmat(a, q);
    }
   G0241:
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTvecten(a, q);
    }
   G0238:
    a = car(w2);
    w4 = a;
    if(a != value(LL_CvectC)) goto    G0243;
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTtenvec(a, q);
    }
   G0243:
    if(a != value(LL_CmatxC)) goto    G0244;
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTtenmat(a, q);
    }
   G0244:
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_timesTtenten(a, q);
    }
}

Sex CC_timesTvecvec(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w1 = a;
    a = mkfxat(0);
    w3 = a;
    a = car(cdr(cdr(w1)));
    w4 = a;
    a = car(cdr(w1));
    w1 = a;
    a = car(cdr(q));
    w2 = a;
    a = mkfxat(1);
    w5 = a;
    a = value(LL_Hcolmode);
    if(a != LL_uncol) goto    G0257;
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G0253;
   G0262:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w6 = a;
    q = w5;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w6;
    a = CC_unmultH(a, q);
    q = a;
    a = w3;
    a = CC_unaddH(a, q);
    w3 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w4 < a) goto    G0285;
    goto    G0262;
   G0253:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w6 = a;
    q = w5;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w6;
    a = CC_multH(a, q);
    q = a;
    a = w3;
    a = CC_unaddH(a, q);
    w3 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w4 < a) goto    G0285;
    goto    G0253;
   G0257:
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G0255;
   G0254:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w6 = a;
    q = w5;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w6;
    a = CC_unmultH(a, q);
    q = a;
    a = w3;
    a = CC_addH(a, q);
    w3 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w4 < a) goto    G0285;
    goto    G0254;
   G0255:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w6 = a;
    q = w5;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w6;
    a = CC_multH(a, q);
    q = a;
    a = w3;
    a = CC_addH(a, q);
    w3 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w4 >= a) goto    G0255;
   G0285:
    a = w3;
    popv(6);
    return a;
}

Sex CC_timesTvecmat(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w8 = nil;
    w7 = nil;
    w3 = nil;
    w5 = nil;
    w9 = nil;
    w1 = a;
    a = cdr(cdr(cdr(q)));
    w4 = a;
    a = car(a);
    w6 = a;
    w2 = q;
    a = car(cdr(w4));
    a = Labs(a);
    w8 = a;
    a = Lmkvect(a);
    w3 = a;
    a = car(cdr(w1));
    w1 = a;
    a = car(cdr(w2));
    w2 = a;
    m = mkfxat(0);
    q = mkfxat(0);
    a = w3;
    Lputv(a, q, m);
    a = mkfxat(1);
    w7 = a;
    a = value(LL_Hcolmode);
    if(a != LL_uncol) goto    G0303;
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G0295;
   G0308:
    a = mkfxat(0);
    w4 = a;
    a = mkfxat(1);
    w5 = a;
    a = w7;
    w9 = a;
   G0294:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w9;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w10;
    a = CC_unmultH(a, q);
    q = a;
    a = w4;
    a = CC_unaddH(a, q);
    w4 = a;
    q = w6;
    a = w9;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    w9 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w6 >= a) goto    G0294;
    m = w4;
    q = w7;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 < a) goto    G0343;
    goto    G0308;
   G0295:
    a = mkfxat(0);
    w4 = a;
    a = mkfxat(1);
    w5 = a;
    a = w7;
    w9 = a;
   G0296:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w9;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w10;
    a = CC_multH(a, q);
    q = a;
    a = w4;
    a = CC_unaddH(a, q);
    w4 = a;
    q = w6;
    a = w9;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    w9 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w6 >= a) goto    G0296;
    m = w4;
    q = w7;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 < a) goto    G0343;
    goto    G0295;
   G0303:
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G0299;
   G0297:
    a = mkfxat(0);
    w4 = a;
    a = mkfxat(1);
    w5 = a;
    a = w7;
    w9 = a;
   G0298:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w9;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w10;
    a = CC_unmultH(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
    w4 = a;
    q = w6;
    a = w9;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    w9 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w6 >= a) goto    G0298;
    m = w4;
    q = w7;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 < a) goto    G0343;
    goto    G0297;
   G0299:
    a = mkfxat(0);
    w4 = a;
    a = mkfxat(1);
    w5 = a;
    a = w7;
    w9 = a;
   G0300:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w9;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w10;
    a = CC_multH(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
    w4 = a;
    q = w6;
    a = w9;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    w9 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w6 >= a) goto    G0300;
    m = w4;
    q = w7;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 >= a) goto    G0299;
   G0343:
    a = w8;
    a = Lminus(a);
    q = a;
    a = w8;
    a = Llist2(a, q);
    q = w3;
    a = Lxcons(a, q);
    q = value(LL_CvectC);
    {
        popv(10);
        return  Lxcons(a, q);
    }
}

Sex CC_timesTmatvec(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w5 = nil;
    w3 = nil;
    w7 = nil;
    w1 = a;
    a = cdr(cdr(cdr(a)));
    w4 = a;
    a = car(a);
    w6 = a;
    w2 = q;
    a = car(cdr(w4));
    a = Labs(a);
    w8 = a;
    a = w6;
    a = Lmkvect(a);
    w3 = a;
    a = car(cdr(w1));
    w1 = a;
    a = car(cdr(w2));
    w2 = a;
    m = mkfxat(0);
    q = mkfxat(0);
    a = w3;
    Lputv(a, q, m);
    a = mkfxat(1);
    w5 = a;
    a = mkfxat(0);
    w9 = a;
    a = value(LL_Hcolmode);
    if(a != LL_uncol) goto    G0362;
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G0354;
   G0367:
    a = mkfxat(0);
    w4 = a;
    a = mkfxat(1);
    w7 = a;
   G0353:
    a = w9;
    a = (Sex)((long)a + 0x10);
    w9 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w7;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w10;
    a = CC_unmultH(a, q);
    q = a;
    a = w4;
    a = CC_unaddH(a, q);
    w4 = a;
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 >= a) goto    G0353;
    m = w4;
    q = w5;
    a = w3;
    Lputv(a, q, m);
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w6 < a) goto    G0406;
    goto    G0367;
   G0354:
    a = mkfxat(0);
    w4 = a;
    a = mkfxat(1);
    w7 = a;
   G0355:
    a = w9;
    a = (Sex)((long)a + 0x10);
    w9 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w7;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w10;
    a = CC_multH(a, q);
    q = a;
    a = w4;
    a = CC_unaddH(a, q);
    w4 = a;
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 >= a) goto    G0355;
    m = w4;
    q = w5;
    a = w3;
    Lputv(a, q, m);
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w6 < a) goto    G0406;
    goto    G0354;
   G0362:
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G0358;
   G0356:
    a = mkfxat(0);
    w4 = a;
    a = mkfxat(1);
    w7 = a;
   G0357:
    a = w9;
    a = (Sex)((long)a + 0x10);
    w9 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w7;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w10;
    a = CC_unmultH(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
    w4 = a;
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 >= a) goto    G0357;
    m = w4;
    q = w5;
    a = w3;
    Lputv(a, q, m);
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w6 < a) goto    G0406;
    goto    G0356;
   G0358:
    a = mkfxat(0);
    w4 = a;
    a = mkfxat(1);
    w7 = a;
   G0359:
    a = w9;
    a = (Sex)((long)a + 0x10);
    w9 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    w10 = a;
    q = w7;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w10;
    a = CC_multH(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
    w4 = a;
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 >= a) goto    G0359;
    m = w4;
    q = w5;
    a = w3;
    Lputv(a, q, m);
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w6 >= a) goto    G0358;
   G0406:
    q = w6;
    a = q;
    a = Llist2(a, q);
    q = w3;
    a = Lxcons(a, q);
    q = value(LL_CvectC);
    {
        popv(10);
        return  Lxcons(a, q);
    }
}

Sex CC_timesTmatmat(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w1 = a;
    a = cdr(cdr(cdr(a)));
    a = car(a);
    w8 = a;
    a = car(cdr(w1));
    w1 = a;
    a = cdr(cdr(cdr(q)));
    w4 = a;
    w2 = q;
    a = car(cdr(a));
    a = Lminus(a);
    w10 = a;
    a = car(cdr(w2));
    w2 = a;
    a = car(w4);
    w12 = a;
    q = w10;
    a = w8;
    a = times2(a, q);
    a = Lmkvect(a);
    w3 = a;
    m = mkfxat(0);
    q = mkfxat(0);
    Lputv(a, q, m);
    a = mkfxat(1);
    w9 = a;
   G0414:
    a = CHAR_OF(104);
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = mkfxat(1);
    w11 = a;
    a = w9;
    w7 = a;
   G0415:
    q = w7;
    a = w2;
    a = Lgetv(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = w11;
    if(a == w12) goto    G0416;
    a = (Sex)((long)a + 0x10);
    w11 = a;
    q = w10;
    a = w7;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    w7 = a;
    goto    G0415;
   G0416:
    a = mkfxat(1);
    w7 = a;
    a = mkfxat(0);
    w11 = a;
    a = cdr(w5);
    w5 = a;
    a = value(LL_Hcolmode);
    if(a != LL_uncol) goto    G0433;
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G0419;
   G0438:
    a = mkfxat(0);
    w4 = a;
    a = w5;
    w6 = a;
   G0418:
    a = w11;
    a = (Sex)((long)a + 0x10);
    w11 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    q = car(w6);
    a = CC_unmultH(a, q);
    q = a;
    a = w4;
    a = CC_unaddH(a, q);
    w4 = a;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0418;
    a = w7;
    a = (Sex)((long)a - 0x10);
    q = w10;
    a = Litimes2(a, q);
    q = w9;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    m = w4;
    q = a;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 < a) goto    G0481;
    goto    G0438;
   G0419:
    a = mkfxat(0);
    w4 = a;
    a = w5;
    w6 = a;
   G0420:
    a = w11;
    a = (Sex)((long)a + 0x10);
    w11 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    q = car(w6);
    a = CC_multH(a, q);
    q = a;
    a = w4;
    a = CC_unaddH(a, q);
    w4 = a;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0420;
    a = w7;
    a = (Sex)((long)a - 0x10);
    q = w10;
    a = Litimes2(a, q);
    q = w9;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    m = w4;
    q = a;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 < a) goto    G0481;
    goto    G0419;
   G0433:
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G0423;
   G0421:
    a = mkfxat(0);
    w4 = a;
    a = w5;
    w6 = a;
   G0422:
    a = w11;
    a = (Sex)((long)a + 0x10);
    w11 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    q = car(w6);
    a = CC_unmultH(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
    w4 = a;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0422;
    a = w7;
    a = (Sex)((long)a - 0x10);
    q = w10;
    a = Litimes2(a, q);
    q = w9;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    m = w4;
    q = a;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 < a) goto    G0481;
    goto    G0421;
   G0423:
    a = mkfxat(0);
    w4 = a;
    a = w5;
    w6 = a;
   G0424:
    a = w11;
    a = (Sex)((long)a + 0x10);
    w11 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    q = car(w6);
    a = CC_multH(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
    w4 = a;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0424;
    a = w7;
    a = (Sex)((long)a - 0x10);
    q = w10;
    a = Litimes2(a, q);
    q = w9;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    m = w4;
    q = a;
    a = w3;
    Lputv(a, q, m);
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    if(w8 >= a) goto    G0423;
   G0481:
    a = w9;
    a = (Sex)((long)a + 0x10);
    w9 = a;
    if(w10 >= a) goto    G0414;
    q = w10;
    a = w8;
    a = times2(a, q);
    w13 = a;
    a = w10;
    a = Lminus(a);
    m = a;
    q = w8;
    a = w13;
    a = Llist3(a, q, m);
    q = w3;
    a = Lxcons(a, q);
    q = value(LL_CmatxC);
    {
        popv(13);
        return  Lxcons(a, q);
    }
}

Sex CC_exptTform(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a == value(LL_CmatxC)) goto    G0494;
    q = nil;
    a = LITERAL[35];
    goto    G0503;
   G0494:
    w2 = q;
    a = cdr(cdr(cdr(w1)));
    a = CC_sumelms(a);
    a = Lzerop(a);
    if(a != nil) goto    G0495;
    q = nil;
    a = LITERAL[36];
    goto    G0503;
   G0495:
    a = w2;
    if(is_integer(a)) goto    G0497;
    q = LITERAL[37];
    a = LITERAL[38];
   G0503:
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
   G0497:
    a = Lminusp(a);
    if(a == nil) goto    G0498;
    a = w1;
    a = CC_recipTmatx(a);
    w3 = a;
    a = w2;
    a = Lminus(a);
    q = a;
    a = w3;
    goto    G0504;
   G0498:
    q = w2;
    a = w1;
   G0504:
    {
        popv(3);
        return  CC_exptTmatxpint(a, q);
    }
}

Sex CC_exptTmatxpint(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
   G0518:
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G0508;
    a = w1;
    goto    G0514;
   G0508:
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G0509;
    a = w1;
    a = Lcadddr(a);
    {
        popv(3);
        return  CC_Aunitmatrix(a);
    }
   G0509:
    a = w2;
    a = Levenp(a);
    if(a == nil) goto    G0511;
    q = w1;
    a = q;
    a = CC_timesTmatmat(a, q);
    w3 = a;
    q = mkfxat(2);
    a = w2;
    a = quot2(a, q);
    q = a;
    a = w3;
    goto    G0518;  /* recursive call to expt:matxpint */
   G0511:
    q = w1;
    a = q;
    a = CC_timesTmatmat(a, q);
    w3 = a;
    q = mkfxat(2);
    a = w2;
    a = quot2(a, q);
    q = a;
    a = w3;
    a = CC_exptTmatxpint(a, q);
    q = a;
    a = w1;
    a = CC_timesTmatmat(a, q);
   G0514:
    popv(3);
    return a;
}

Sex CC_Areverse(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G0521;
    a = LITERAL[39];
    {
        popv(6);
        return  CC_argerror(a);
    }
   G0521:
    a = car(a);
#define LL_Boset LITERAL[40]
    if(a != LL_Boset) goto    G0522;
    a = cdr(w1);
    a = Lreverse(a);
    q = LL_Boset;
    {
        popv(6);
        return  Lxcons(a, q);
    }
   G0522:
    if(is_vector(a)) goto    G0524;
    q = LITERAL[39];
    a = LITERAL[41];
    goto    G0536;
   G0524:
    a = cdr(cdr(cdr(w1)));
    if(a == nil) goto    G0525;
    q = LITERAL[39];
    a = LITERAL[42];
   G0536:
    {
        popv(6);
        return  CC_errormsg(a, q);
    }
   G0525:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = car(cdr(w1));
    w5 = a;
    a = car(w1);
    w3 = a;
    a = w5;
    a = Lmkvect(a);
    w2 = a;
    q = mkfxat(0);
    a = w3;
    a = Lgetv(a, q);
    m = a;
    q = mkfxat(0);
    a = w2;
    Lputv(a, q, m);
    a = mkfxat(0);
    w4 = a;
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
   G0528:
    a = w4;
    a = (Sex)((long)a + 0x10);
    w4 = a;
    w6 = a;
    a = w5;
    a = (Sex)((long)a - 0x10);
    w5 = a;
    q = a;
    a = w3;
    a = Lgetv(a, q);
    m = a;
    q = w6;
    a = w2;
    Lputv(a, q, m);
    a = w5;
    if(a != mkfxat(1)) goto    G0528;
    q = cdr(w1);
    a = w2;
    {
        popv(6);
        return  cons(a, q);
    }
}

Sex CC_Areverse0(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G0540;
    a = LITERAL[43];
    {
        popv(5);
        return  CC_argerror(a);
    }
   G0540:
    a = car(a);
    if(a != LL_Boset) goto    G0541;
    a = cdr(w1);
    a = Lreverse(a);
    q = LL_Boset;
    {
        popv(5);
        return  Lxcons(a, q);
    }
   G0541:
    if(is_vector(a)) goto    G0543;
    q = LITERAL[43];
    a = LITERAL[41];
    goto    G0553;
   G0543:
    a = cdr(cdr(cdr(w1)));
    if(a == nil) goto    G0544;
    q = LITERAL[43];
    a = LITERAL[42];
   G0553:
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G0544:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = car(cdr(w1));
    w5 = a;
    a = car(w1);
    w3 = a;
    a = w5;
    a = Lmkvect(a);
    w2 = a;
    a = w5;
    a = Ladd1(a);
    w5 = a;
    a = mkfxat(0);
    w4 = a;
   G0547:
    a = w5;
    a = (Sex)((long)a - 0x10);
    w5 = a;
    q = a;
    a = w3;
    a = Lgetv(a, q);
    m = a;
    q = w4;
    a = w2;
    Lputv(a, q, m);
    a = w4;
    a = (Sex)((long)a + 0x10);
    w4 = a;
    a = w5;
    if(a != mkfxat(0)) goto    G0547;
    q = cdr(w1);
    a = w2;
    {
        popv(5);
        return  cons(a, q);
    }
}

Sex CC_Asort(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G0557;
    a = LITERAL[44];
    {
        popv(7);
        return  CC_argerror(a);
    }
   G0557:
    a = car(a);
    if(a != LL_Boset) goto    G0558;
#define LL_Worder LITERAL[45]
    q = LL_Worder;
    a = cdr(w1);
    a = CC_sortany(a, q);
    q = LL_Boset;
    {
        popv(7);
        return  Lxcons(a, q);
    }
   G0558:
    if(is_vector(a)) goto    G0560;
    q = LITERAL[44];
    a = LITERAL[41];
    goto    G0582;
   G0560:
    a = cdr(cdr(cdr(w1)));
    if(a == nil) goto    G0561;
    q = LITERAL[44];
    a = LITERAL[42];
   G0582:
    {
        popv(7);
        return  CC_errormsg(a, q);
    }
   G0561:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = car(w1);
    w2 = a;
    a = car(cdr(w1));
    w3 = a;
    a = CHAR_OF(72);
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = mkfxat(1);
    w4 = a;
   G0564:
    q = w4;
    a = w2;
    a = Lgetv(a, q);
    w7 = a;
    if(!is_cons(a)) goto    G0568;
    q = cdr(cdr(a));
    a = Lxcons(a, q);
   G0568:
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = w4;
    a = (Sex)((long)a + 0x10);
    w4 = a;
    q = w3;
    a = Lleq(a, q);
    if(a != nil) goto    G0564;
    q = LL_Worder;
    a = cdr(w5);
    a = CC_sortany(a, q);
    w5 = a;
    a = w3;
    a = Lmkvect(a);
    w2 = a;
#define LL_Anil LITERAL[46]
    m = LL_Anil;
    q = mkfxat(0);
    Lputv(a, q, m);
    a = mkfxat(1);
    w4 = a;
   G0565:
    a = car(w5);
    w7 = a;
    if(!is_cons(a)) goto    G0577;
    a = cdr(a);
   G0577:
    m = a;
    q = w4;
    a = w2;
    Lputv(a, q, m);
    a = w4;
    a = (Sex)((long)a + 0x10);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0565;
    q = cdr(w1);
    a = w2;
    {
        popv(7);
        return  cons(a, q);
    }
}

Sex CC_Asort0(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G0586;
    a = LITERAL[47];
    {
        popv(7);
        return  CC_argerror(a);
    }
   G0586:
    a = car(a);
    if(a != LL_Boset) goto    G0587;
    q = LL_Worder;
    a = cdr(w1);
    a = CC_sortany(a, q);
    q = LL_Boset;
    {
        popv(7);
        return  Lxcons(a, q);
    }
   G0587:
    if(is_vector(a)) goto    G0589;
    q = LITERAL[47];
    a = LITERAL[41];
    goto    G0611;
   G0589:
    a = cdr(cdr(cdr(w1)));
    if(a == nil) goto    G0590;
    q = LITERAL[47];
    a = LITERAL[42];
   G0611:
    {
        popv(7);
        return  CC_errormsg(a, q);
    }
   G0590:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = car(w1);
    w2 = a;
    a = car(cdr(w1));
    w3 = a;
    a = CHAR_OF(72);
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = mkfxat(0);
    w4 = a;
   G0593:
    q = w4;
    a = w2;
    a = Lgetv(a, q);
    w7 = a;
    if(!is_cons(a)) goto    G0597;
    q = cdr(cdr(a));
    a = Lxcons(a, q);
   G0597:
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = w4;
    a = (Sex)((long)a + 0x10);
    w4 = a;
    q = w3;
    a = Lleq(a, q);
    if(a != nil) goto    G0593;
    q = LL_Worder;
    a = cdr(w5);
    a = CC_sortany(a, q);
    w5 = a;
    a = w3;
    a = Lmkvect(a);
    w2 = a;
    a = mkfxat(0);
    w4 = a;
   G0594:
    a = car(w5);
    w7 = a;
    if(!is_cons(a)) goto    G0606;
    a = cdr(a);
   G0606:
    m = a;
    q = w4;
    a = w2;
    Lputv(a, q, m);
    a = w4;
    a = (Sex)((long)a + 0x10);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0594;
    q = cdr(w1);
    a = w2;
    {
        popv(7);
        return  cons(a, q);
    }
}

Sex CC_Aflatten(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0615;
    a = LITERAL[48];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0615:
    a = car(a);
    if(!is_vector(a)) goto    G0616;
    q = car(cdr(w1));
    a = q;
    a = Llist2(a, q);
    q = car(w1);
    goto    G0625;
   G0616:
    if(a != value(LL_CvectC)) goto    G0618;
    a = w1;
    goto    G0624;
   G0618:
    if(a == value(LL_CmatxC)) goto    G0620;
#define LL_CtensC LITERAL[49]
    if(a != value(LL_CtensC)) goto    G0619;
   G0620:
    a = car(cdr(cdr(w1)));
    a = Lminus(a);
    q = a;
    a = car(cdr(cdr(w1)));
    a = Llist2(a, q);
    q = car(cdr(w1));
    a = Lxcons(a, q);
    q = value(LL_CvectC);
   G0625:
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G0619:
    q = LITERAL[48];
    a = LITERAL[50];
    a = CC_errormsg(a, q);
   G0624:
    popv(1);
    return a;
}

Sex CC_Atranspose(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_cons(a)) goto    G0630;
    a = car(a);
    if(is_integer(a)) goto    G0629;
   G0630:
    a = LITERAL[51];
    {
        popv(9);
        return  CC_argerror(a);
    }
   G0629:
    if(a != value(LL_CvectC)) goto    G0631;
    w2 = nil;
    a = cdr(cdr(w1));
    w2 = a;
    a = car(cdr(a));
    a = Lminus(a);
    q = a;
    a = car(w2);
    a = Llist2(a, q);
    w2 = a;
    q = car(cdr(w1));
    a = Lxcons(a, q);
    q = value(LL_CvectC);
    goto    G0656;
   G0631:
    if(a != value(LL_CmatxC)) goto    G0636;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = cdr(cdr(w1));
    w4 = a;
    a = car(cdr(a));
    w5 = a;
    a = car(cdr(cdr(w4)));
    a = Lminus(a);
    w6 = a;
    a = car(w4);
    w4 = a;
    a = car(cdr(w1));
    w3 = a;
    a = w4;
    a = Lmkvect(a);
    w2 = a;
    q = mkfxat(0);
    a = w3;
    a = Lgetv(a, q);
    m = a;
    q = mkfxat(0);
    a = w2;
    Lputv(a, q, m);
    a = mkfxat(0);
    w7 = a;
    a = mkfxat(1);
    w9 = a;
   G0638:
    a = w9;
    w8 = a;
   G0639:
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    q = a;
    a = w3;
    a = Lgetv(a, q);
    m = a;
    q = w8;
    a = w2;
    Lputv(a, q, m);
    q = w5;
    a = w8;
    a = (Sex)((long)a + (long)q - TAG_FIXNUM);
    w8 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G0639;
    a = w9;
    a = (Sex)((long)a + 0x10);
    w9 = a;
    q = w6;
    a = Lleq(a, q);
    if(a != nil) goto    G0638;
    a = w5;
    a = Lminus(a);
    m = a;
    q = w6;
    a = w4;
    a = Llist3(a, q, m);
    q = w2;
    a = Lxcons(a, q);
    q = value(LL_CmatxC);
   G0656:
    {
        popv(9);
        return  Lxcons(a, q);
    }
   G0636:
    q = nil;
    if(a != value(LL_CtensC)) goto    G0654;
    a = LITERAL[52];
    goto    G0657;
   G0654:
    a = LITERAL[53];
   G0657:
    {
        popv(9);
        return  CC_errormsg(a, q);
    }
}

Sex CC_detTprirow(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = a;
    w1 = a;
    a = LITERAL[54];
    Lprinc(a);
    w3 = nil;
   G0664:
    a = w2;
    if(a == nil) goto    G0663;
    q = nil;
    a = car(a);
    CC_fprinTcano(a, q);
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0668;
    a = LITERAL[55];
    a = Lprinc(a);
   G0668:
    w3 = a;
    goto    G0664;
   G0663:
    a = LITERAL[56];
    Lprinc(a);
    a = nil;
    popv(3);
    return a;
}

Sex CC_detTprimatx(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = a;
    w1 = a;
    Lterpri();
    a = LITERAL[54];
    Lprinc(a);
   G0672:
    a = car(w2);
    CC_detTprirow(a);
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0675;
    a = LITERAL[57];
    Lprinc(a);
    Lterpri();
    a = LITERAL[58];
    Lprinc(a);
    goto    G0672;
   G0675:
    a = LITERAL[56];
    Lprinc(a);
    Lterpri();
    a = nil;
    popv(3);
    return a;
}

Sex CC_Adet(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Wmatx(a);
    if(a != nil) goto    G0679;
    q = LITERAL[59];
    a = LITERAL[60];
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G0679:
    a = w1;
    a = CC_Wtotalsize(a);
    a = Lonep(a);
    if(a == nil) goto    G0680;
    q = mkfxat(1);
    a = car(cdr(w1));
    {
        popv(5);
        return  Lgetv(a, q);
    }
   G0680:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = w1;
    a = CC_convTmatx2elis(a);
    w2 = a;
    a = w1;
    a = CC_Welmttype(a);
    w3 = a;
    a = car(cdr(cdr(cdr(w1))));
    a = Labs(a);
    w5 = a;
#define LL_Abnum LITERAL[61]
    q = LL_Abnum;
    a = w3;
    a = Lneq(a, q);
    if(a != nil) goto    G0685;
#define LL_Htemporal LITERAL[62]
    a = value(LL_Htemporal);
    w4 = a;
    if(a == nil) goto    G0689;
    a = w2;
    {
        popv(5);
        return  CC_detTxctGauss(a);
    }
   G0689:
    a = w2;
    {
        popv(5);
        return  CC_detTfloGauss(a);
    }
   G0685:
    a = w1;
    a = CC_Wsparse(a);
    q = w5;
    a = w2;
    {
        popv(5);
        return  CC_detTminor(a, q);
    }
}

Sex CC_detTfloGauss(Sex a)
{
    {
        return  CC_detTxctGauss(a);
    }
}

Sex CC_detTxctGauss(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w9 = nil;
    w3 = nil;
    w1 = nil;
    w2 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    a = Lcopy(a);
    w1 = a;
    a = mkfxat(1);
    w9 = a;
    q = w1;
    a = LITERAL[63];
    CC_argprint(a, q);
   G0713:
    a = car(w1);
    w3 = a;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G0723;
    a = cdr(w1);
    w1 = a;
    w2 = a;
    goto    G0714;
   G0723:
    a = cdr(w1);
    w2 = a;
    a = mkfxat(1);
    w11 = a;
    w13 = nil;
   G0725:
    a = w2;
    if(a == nil) goto    G0724;
    a = car(car(a));
    a = Lzerop(a);
    if(a == nil) goto    G0724;
    a = cdr(w2);
    w2 = a;
    a = w11;
    a = Ladd1(a);
    w11 = a;
    w13 = a;
    goto    G0725;
   G0724:
    a = w2;
    if(a != nil) goto    G0730;
    a = mkfxat(0);
    goto    G0712;
   G0730:
    a = w11;
    a = Loddp(a);
    if(a == nil) goto    G0732;
    a = w9;
    a = Lminus(a);
    w9 = a;
   G0732:
    a = car(w2);
    w3 = a;
    a = w1;
    w2 = a;
    w13 = nil;
   G0734:
    q = car(cdr(w2));
    a = w3;
    a = Lneq(a, q);
    if(a == nil) goto    G0733;
    a = cdr(w2);
    w2 = a;
    w13 = a;
    goto    G0734;
   G0733:
    q = cdr(cdr(w2));
    a = w2;
    cdr(a) = q;
    a = w1;
    w2 = a;
   G0714:
    a = w3;
    w4 = a;
    a = car(a);
    w5 = a;
    a = car(w2);
    w6 = a;
    a = car(a);
    w7 = a;
    w13 = nil;
   G0738:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0737;
    a = cdr(w6);
    w6 = a;
    q = car(a);
    a = w5;
    a = times2(a, q);
    w14 = a;
    q = car(w4);
    a = w7;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = w14;
    a = plus2(a, q);
    w12 = a;
    q = a;
    a = w6;
    car(a) = q;
    w13 = a;
    goto    G0738;
   G0737:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0714;
    a = w1;
    a = CC_listcdr(a);
    w1 = a;
    a = w8;
    if(a == nil) goto    G0765;
    a = Lonep(a);
    if(a != nil) goto    G0765;
    a = w1;
    w2 = a;
    a = w8;
    a = CC_Wint(a);
    if(a == nil) goto    G0750;
    a = w8;
    w10 = a;
   G0751:
    a = car(w2);
    w3 = a;
    w13 = nil;
   G0753:
    if(a == nil) goto    G0752;
    q = w10;
    a = car(a);
    a = quot2(a, q);
    q = a;
    a = w3;
    car(a) = q;
    a = cdr(w3);
    w3 = a;
    w13 = a;
    goto    G0753;
   G0752:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0765;
    goto    G0751;
   G0750:
    q = w8;
    a = mkfxat(1);
    a = CC_mathdiv(a, q);
    w10 = a;
   G0719:
    a = car(w2);
    w3 = a;
    w13 = nil;
   G0760:
    if(a == nil) goto    G0759;
    q = car(a);
    a = w10;
    a = times2(a, q);
    q = a;
    a = w3;
    car(a) = q;
    a = cdr(w3);
    w3 = a;
    w13 = a;
    goto    G0760;
   G0759:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0719;
   G0765:
    a = cdr(w1);
    if(a == nil) goto    G0767;
    a = w5;
    w8 = a;
    goto    G0713;
   G0767:
    q = car(car(w1));
    a = w9;
    a = times2(a, q);
   G0712:
    popv(14);
    return a;
}

Sex CC_Adetsparse(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = CC_Wmatx(a);
    if(a != nil) goto    G0772;
    q = LITERAL[59];
    a = LITERAL[60];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0772:
    a = w1;
    a = CC_Wtotalsize(a);
    a = Lonep(a);
    if(a == nil) goto    G0773;
    q = mkfxat(1);
    a = car(cdr(w1));
    {
        popv(2);
        return  Lgetv(a, q);
    }
   G0773:
    a = w1;
    a = CC_convTmatx2elis(a);
    w2 = a;
    a = car(cdr(cdr(cdr(w1))));
    a = Labs(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_detTminor(a, q);
    }
}

Sex CC_detTminor(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = mkfxat(2);
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G0785;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = car(w1);
    w3 = a;
    a = car(cdr(w1));
    w4 = a;
    q = car(cdr(a));
    a = car(w3);
    a = CC_multH(a, q);
    w5 = a;
    q = car(cdr(w3));
    a = car(w4);
    a = CC_multH(a, q);
    w6 = a;
    a = CC_negH(a);
    q = a;
    a = w5;
    {
        popv(14);
        return  CC_addH(a, q);
    }
   G0785:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    a = w1;
    w4 = a;
    a = w2;
    a = Ladd1(a);
    w9 = a;
    a = mkfxat(1);
    w11 = a;
   G0791:
    a = car(w4);
    w5 = a;
    a = mkfxat(0);
    w13 = a;
    w14 = nil;
    a = w5;
   G0798:
    if(a == nil) goto    G0797;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G0802;
    a = w13;
    a = Ladd1(a);
    w13 = a;
   G0802:
    a = cdr(w5);
    w5 = a;
    w14 = a;
    goto    G0798;
   G0797:
    a = w13;
    a = Lzerop(a);
    if(a == nil) goto    G0804;
    a = mkfxat(0);
    goto    G0789;
   G0804:
    q = w9;
    a = w13;
    a = Llessp(a, q);
    if(a == nil) goto    G0806;
    a = w13;
    w9 = a;
    a = w11;
    w10 = a;
   G0806:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0808;
    a = w11;
    a = Ladd1(a);
    w11 = a;
    goto    G0791;
   G0808:
    q = w10;
    a = w1;
    a = Lnth(a, q);
    w5 = a;
    a = w10;
    a = Lonep(a);
    if(a == nil) goto    G0810;
    a = cdr(w1);
    w1 = a;
    goto    G0793;
   G0810:
    a = w1;
    w4 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w12 = a;
    w1 = a;
    w14 = nil;
   G0812:
    q = car(w4);
    a = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G0811;
    a = car(w4);
    a = Lncons(a);
    q = a;
    a = w12;
    cdr(a) = q;
    a = cdr(a);
    w12 = a;
    a = cdr(w4);
    w4 = a;
    w14 = a;
    goto    G0812;
   G0811:
    q = cdr(w4);
    a = w12;
    cdr(a) = q;
    a = cdr(w1);
    w1 = a;
   G0793:
    a = w10;
    a = Loddp(a);
    if(a == nil) goto    G0818;
    a = mkfxat(1);
    goto    G0819;
   G0818:
    a = mkfxat(-1);
   G0819:
    w6 = a;
    a = mkfxat(0);
    w3 = a;
    a = mkfxat(1);
    w11 = a;
   G0794:
    a = car(w5);
    a = Lzerop(a);
    if(a != nil) goto    G0795;
    a = w11;
    a = Loddp(a);
    if(a == nil) goto    G0823;
    a = w6;
    goto    G0824;
   G0823:
    a = w6;
    a = Lminus(a);
   G0824:
    w7 = a;
    q = w11;
    a = w1;
    a = CC_detTmkminor1(a, q);
    w4 = a;
    a = car(w5);
    w8 = a;
    a = w7;
    a = Lminusp(a);
    if(a == nil) goto    G0826;
    a = w8;
    a = CC_negH(a);
    w8 = a;
   G0826:
    q = mkfxat(-1);
    a = w2;
    a = plus2(a, q);
    q = a;
    a = w4;
    a = CC_detTminor(a, q);
    w13 = a;
    q = a;
    a = w8;
    a = CC_multH(a, q);
    q = w3;
    a = CC_addH(a, q);
    w3 = a;
   G0795:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G0830;
    a = w11;
    a = Ladd1(a);
    w11 = a;
    goto    G0794;
   G0830:
    a = w3;
   G0789:
    popv(14);
    return a;
}

Sex CC_detTmkminor1(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(72);
    a = Lncons(a);
    w6 = a;
    w3 = a;
   G0836:
    a = car(w1);
    w4 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w7 = a;
    w5 = a;
    a = mkfxat(0);
    w8 = a;
    w9 = nil;
   G0839:
    a = w8;
    a = Ladd1(a);
    w8 = a;
    q = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0838;
    a = car(w4);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = cdr(w4);
    w4 = a;
    w9 = a;
    goto    G0839;
   G0838:
    q = cdr(w4);
    a = w7;
    cdr(a) = q;
    a = cdr(w5);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0836;
    a = cdr(w3);
    popv(9);
    return a;
}

Sex CC_Adetgauss(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = CC_Wmatx(a);
    if(a != nil) goto    G0852;
    q = LITERAL[59];
    a = LITERAL[60];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0852:
    a = w1;
    a = CC_Wtotalsize(a);
    q = mkfxat(9);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0853;
    a = w1;
    a = CC_convTmatx2elis(a);
    {
        popv(2);
        return  CC_detgaussT(a);
    }
   G0853:
    a = w1;
    a = CC_Wtotalsize(a);
    a = Lonep(a);
    if(a == nil) goto    G0856;
    q = mkfxat(1);
    a = car(cdr(w1));
    {
        popv(2);
        return  Lgetv(a, q);
    }
   G0856:
    a = w1;
    a = CC_convTmatx2elis(a);
    w2 = a;
    a = car(cdr(cdr(cdr(w1))));
    a = Labs(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_detTminor(a, q);
    }
}

Sex CC_Adeteffgauss(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = CC_Wmatx(a);
    if(a != nil) goto    G0864;
    q = LITERAL[59];
    a = LITERAL[60];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0864:
    a = w1;
    a = CC_Wtotalsize(a);
    q = mkfxat(9);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0865;
    a = w1;
    a = CC_convTmatx2elis(a);
    {
        popv(2);
        return  CC_deteffgaussT(a);
    }
   G0865:
    a = w1;
    a = CC_Wtotalsize(a);
    a = Lonep(a);
    if(a == nil) goto    G0868;
    q = mkfxat(1);
    a = car(cdr(w1));
    {
        popv(2);
        return  Lgetv(a, q);
    }
   G0868:
    a = w1;
    a = CC_convTmatx2elis(a);
    w2 = a;
    a = car(cdr(cdr(cdr(w1))));
    a = Labs(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_detTminor(a, q);
    }
}

Sex CC_convTmatx2elis(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(cdr(a));
    w6 = a;
    a = cdr(cdr(w1));
    w8 = a;
    a = car(a);
    w7 = a;
    a = car(cdr(w8));
    a = Labs(a);
    w8 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = mkfxat(0);
    w9 = a;
   G0876:
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = mkfxat(1);
    w10 = a;
   G0877:
    q = w10;
    a = w9;
    a = plus2(a, q);
    q = a;
    a = w6;
    a = Lgetv(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w8;
    a = Lleq(a, q);
    if(a != nil) goto    G0877;
    a = cdr(w4);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    q = w8;
    a = w9;
    a = plus2(a, q);
    w9 = a;
    q = w7;
    a = Llessp(a, q);
    if(a != nil) goto    G0876;
    a = cdr(w2);
    popv(10);
    return a;
}

Sex CC_substTform(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5, arg6;
    arg6 = m;
    arg5 = q;
    arg4 = a;
#define LL_substTpref LITERAL[64]
    m = LL_substTpref;
#define LL_substTcano LITERAL[65]
    q = LL_substTcano;
    a = nil;
    {
        return  CC_map3Tformxxyy(a, q, m, arg4, arg5, arg6);
    }
}

Sex CC_dfTform(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5, arg6;
    arg6 = m;
    arg5 = q;
    arg4 = a;
#define LL_dfTpref LITERAL[66]
    m = LL_dfTpref;
#define LL_dfTcano LITERAL[67]
    q = LL_dfTcano;
#define LL_dfTbnum LITERAL[68]
    a = LL_dfTbnum;
    {
        return  CC_map3Tformxxyy(a, q, m, arg4, arg5, arg6);
    }
}



/* initialization procedure */
int init_comform(void)
{
   long i;

   create_symbols(comform_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; comform_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(comform_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4;
        a = LITERAL[69];
        CC_Aenter(a);
        arg4 = nil;
        m = nil;
#define LL_Aunitmatrix LITERAL[70]
        q = LL_Aunitmatrix;
#define LL_unitmat LITERAL[71]
        a = LL_unitmat;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aexchrow LITERAL[72]
        q = LL_Aexchrow;
#define LL_exchrow LITERAL[73]
        a = LL_exchrow;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aexchrow;
#define LL_exchangrow LITERAL[74]
        a = LL_exchangrow;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aexchcol LITERAL[75]
        q = LL_Aexchcol;
#define LL_exchcol LITERAL[76]
        a = LL_exchcol;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aexchcol;
#define LL_exchangcol LITERAL[77]
        a = LL_exchangcol;
        CC_defcommand(a, q, m, arg4);
#define LL_arg1 LITERAL[78]
        arg4 = LL_arg1;
#define LL_command LITERAL[79]
        m = LL_command;
#define LL_Avects2matx LITERAL[80]
        q = LL_Avects2matx;
#define LL_vects2matx LITERAL[81]
        a = LL_vects2matx;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Areverse LITERAL[82]
        q = LL_Areverse;
#define LL_reverse LITERAL[83]
        a = LL_reverse;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Areverse0 LITERAL[84]
        q = LL_Areverse0;
#define LL_reverse0 LITERAL[85]
        a = LL_reverse0;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Asort LITERAL[86]
        q = LL_Asort;
#define LL_sort LITERAL[87]
        a = LL_sort;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Asort0 LITERAL[88]
        q = LL_Asort0;
#define LL_sort0 LITERAL[89]
        a = LL_sort0;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aflatten LITERAL[90]
        q = LL_Aflatten;
#define LL_flatten LITERAL[91]
        a = LL_flatten;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Atranspose LITERAL[92]
        q = LL_Atranspose;
#define LL_transpose LITERAL[93]
        a = LL_transpose;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Adet LITERAL[94]
        q = LL_Adet;
#define LL_det LITERAL[95]
        a = LL_det;
        a = CC_defcommand(a, q, m, arg4);
        return 1;
    }
}
Sex LITERAL[97];

const  char *comform_literal_string[97] =
{
/* 0 */
"\"?sparse\"",
/* 1 */
"0.5000000000000000",
/* 2 */
"\"must be vects2matx([...])\"",
/* 3 */
"\"ARG must be [Vec1,...])\"",
/* 4 */
"\"SIZE-mismatch in vects2matx\"",
/* 5 */
"!#matx!#",
/* 6 */
"\"UNITMATRIX\"",
/* 7 */
"\"TOO LARGE INDEX for EXCHROW\"",
/* 8 */
"\"TOO LARGE INDEX for EXCHCOL\"",
/* 9 */
"\"FORM + FORM\"",
/* 10 */
"\"SIZE MISMATCH IN\"",
/* 11 */
"!*colmode",
/* 12 */
"uncol",
/* 13 */
"neg!:pref",
/* 14 */
"neg!:cano",
/* 15 */
"neg!:bnum",
/* 16 */
"mult!:bnumpref",
/* 17 */
"mult!:bnumcano",
/* 18 */
"mult!:bnumbnum",
/* 19 */
"!*expmode",
/* 20 */
"unexp",
/* 21 */
"unmult!:canopref",
/* 22 */
"unmult!:canocano",
/* 23 */
"mult!:canopref",
/* 24 */
"mult!:canocano",
/* 25 */
"mult!:canobnum",
/* 26 */
"unmult!:prefpref",
/* 27 */
"unmult!:prefcano",
/* 28 */
"mult!:prefpref",
/* 29 */
"mult!:prefcano",
/* 30 */
"mult!:prefbnum",
/* 31 */
"\"FORM*FORM\"",
/* 32 */
"\"FIRST ARG IS NOT ROW-TYPE\"",
/* 33 */
"\"SECOND AEG IS NOT COLUMN-TYPE\"",
/* 34 */
"!#vect!#",
/* 35 */
"\"(VECTOR or TENSOR)**e IS DETECTED\"",
/* 36 */
"\"EXPONENTIATION OF NON-SQUARE MATRIX\"",
/* 37 */
"\"MATRIX**e\"",
/* 38 */
"\"EXPONENT IS NOT AN INTEGER\"",
/* 39 */
"\"REVERSE\"",
/* 40 */
"!!oset",
/* 41 */
"\"ARGUMENT IS NOT <ARRAY/OSET>\"",
/* 42 */
"\"ARGUMENT IS NOT <LinearARRAY>\"",
/* 43 */
"\"REVERSE0\"",
/* 44 */
"\"SORT\"",
/* 45 */
"!?order",
/* 46 */
"! nil",
/* 47 */
"\"SORT0\"",
/* 48 */
"\"FLATTEN\"",
/* 49 */
"!#tens!#",
/* 50 */
"\"ARGUMENT IS NOT <ARRAY/FORM>\"",
/* 51 */
"\"TRANSPOSE\"",
/* 52 */
"\"PROGRAMMING NOT YET @@@@\"",
/* 53 */
"\"ARGUMENT IS NOT <VECT/MATX/TENS>\"",
/* 54 */
"\"( \"",
/* 55 */
"\" , \"",
/* 56 */
"\" )\"",
/* 57 */
"\" ,\"",
/* 58 */
"\"  \"",
/* 59 */
"\"DET\"",
/* 60 */
"\"ARGUMENT IS NOT <MATRIX>\"",
/* 61 */
"! bnum",
/* 62 */
"!*temporal",
/* 63 */
"\"ELIS in xctGauss\"",
/* 64 */
"subst!:pref",
/* 65 */
"subst!:cano",
/* 66 */
"df!:pref",
/* 67 */
"df!:cano",
/* 68 */
"df!:bnum",
/* 69 */
"(lisp)",
/* 70 */
"! unitmatrix",
/* 71 */
"unitmat",
/* 72 */
"! exchrow",
/* 73 */
"exchrow",
/* 74 */
"exchangrow",
/* 75 */
"! exchcol",
/* 76 */
"exchcol",
/* 77 */
"exchangcol",
/* 78 */
"arg1",
/* 79 */
"command",
/* 80 */
"! vects2matx",
/* 81 */
"vects2matx",
/* 82 */
"! reverse",
/* 83 */
"reverse",
/* 84 */
"! reverse0",
/* 85 */
"reverse0",
/* 86 */
"! sort",
/* 87 */
"sort",
/* 88 */
"! sort0",
/* 89 */
"sort0",
/* 90 */
"! flatten",
/* 91 */
"flatten",
/* 92 */
"! transpose",
/* 93 */
"transpose",
/* 94 */
"! det",
/* 95 */
"det",
/* 96 */ NULL
};
setup_type const comform_g_setup[] =
{
    {"df:form", (lisp_proc *)CC_dfTform, 3},
    {"subst:form", (lisp_proc *)CC_substTform, 3},
    {"conv:matx2elis", (lisp_proc *)CC_convTmatx2elis, 1},
    {" deteffgauss", (lisp_proc *)CC_Adeteffgauss, 1},
    {" detgauss", (lisp_proc *)CC_Adetgauss, 1},
    {"det:mkminor1", (lisp_proc *)CC_detTmkminor1, 2},
    {"det:minor", (lisp_proc *)CC_detTminor, 2},
    {" detsparse", (lisp_proc *)CC_Adetsparse, 1},
    {"det:xctGauss", (lisp_proc *)CC_detTxctGauss, 1},
    {"det:floGauss", (lisp_proc *)CC_detTfloGauss, 1},
    {" det", (lisp_proc *)CC_Adet, 1},
    {"det:primatx", (lisp_proc *)CC_detTprimatx, 1},
    {"det:prirow", (lisp_proc *)CC_detTprirow, 1},
    {" transpose", (lisp_proc *)CC_Atranspose, 1},
    {" flatten", (lisp_proc *)CC_Aflatten, 1},
    {" sort0", (lisp_proc *)CC_Asort0, 1},
    {" sort", (lisp_proc *)CC_Asort, 1},
    {" reverse0", (lisp_proc *)CC_Areverse0, 1},
    {" reverse", (lisp_proc *)CC_Areverse, 1},
    {"expt:matxpint", (lisp_proc *)CC_exptTmatxpint, 2},
    {"expt:form", (lisp_proc *)CC_exptTform, 2},
    {"times:matmat", (lisp_proc *)CC_timesTmatmat, 2},
    {"times:matvec", (lisp_proc *)CC_timesTmatvec, 2},
    {"times:vecmat", (lisp_proc *)CC_timesTvecmat, 2},
    {"times:vecvec", (lisp_proc *)CC_timesTvecvec, 2},
    {"times:formform", (lisp_proc *)CC_timesTformform, 2},
    {"times:formpref", (lisp_proc *)CC_timesTformpref, 2},
    {"times:prefform", (lisp_proc *)CC_timesTprefform, 2},
    {"times:canoform", (lisp_proc *)CC_timesTcanoform, 2},
    {"times:bnumform", (lisp_proc *)CC_timesTbnumform, 2},
    {"neg:form", (lisp_proc *)CC_negTform, 1},
    {"plus:formform", (lisp_proc *)CC_plusTformform, 2},
    {"unmult:prefcano", (lisp_proc *)CC_unmultTprefcano, 2},
    {"mult:prefcano", (lisp_proc *)CC_multTprefcano, 2},
    {"mult:prefbnum", (lisp_proc *)CC_multTprefbnum, 2},
    {"mult:canobnum", (lisp_proc *)CC_multTcanobnum, 2},
    {"exchcol*", (lisp_proc *)CC_exchcolH, 4},
    {"exchrow*", (lisp_proc *)CC_exchrowH, 4},
    {"copyvect", (lisp_proc *)CC_copyvect, 2},
    {"unitmatx*", (lisp_proc *)CC_unitmatxH, 1},
    {" exchcol", (lisp_proc *)CC_Aexchcol, 3},
    {" exchrow", (lisp_proc *)CC_Aexchrow, 3},
    {" unitmatrix", (lisp_proc *)CC_Aunitmatrix, 1},
    {" vects2matx", (lisp_proc *)CC_Avects2matx, 1},
    {"?sparse", (lisp_proc *)CC_Wsparse, 1},
    {NULL, NULL, 0 }
};

