#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_comrset.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex comrset_literal_vector[];
const char *comrset_literal_string[];
setup_type const  comrset_g_setup[];
#define LITERAL comrset_literal_vector




Sex CC_WM(Sex a, Sex q)
{
    {
        return  Lequal(a, q);
    }
}

Sex CC_WVM(Sex a, Sex q)
{
    a = Lequal(a, q);
    {
        return  Lnull(a);
    }
}

Sex CC_WR(Sex a, Sex q)
{
    {
        return  Llessp(a, q);
    }
}

Sex CC_WS(Sex a, Sex q)
{
    {
        return  Lgreaterp(a, q);
    }
}

Sex CC_WRM(Sex a, Sex q)
{
    a = Lgreaterp(a, q);
    {
        return  Lnull(a);
    }
}

Sex CC_WSM(Sex a, Sex q)
{
    a = Llessp(a, q);
    {
        return  Lnull(a);
    }
}

Sex CC_gKS(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
#define LL_rKS LITERAL[0]
    a = LL_rKS;
    {
        return  Llist3(a, q, m);
    }
}

Sex CC_gM(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0019;
    if(is_cons(q)) goto    G0021;
    if(!is_number(a)) goto    G0023;
    if(!is_number(q)) goto    G0023;
    m = q;
    q = a;
    goto    G0080;
   G0023:
    if(!is_symbol(a)) goto    G0058;
    if(!is_symbol(q)) goto    G0058;
    a = CC_WsametypeTid(a, q);
    if(a == nil) goto    G0058;
    m = w2;
    q = w1;
    goto    G0080;
   G0021:
    a = car(q);
    if(!is_integer(a)) goto    G0028;
    a = w1;
    if(!is_number(a)) goto    G0058;
#define LL_CmaxcanoC LITERAL[1]
    if(car(q) >= value(LL_CmaxcanoC)) goto    G0058;
    m = q;
    q = a;
    goto    G0080;
   G0028:
    a = w1;
    if(!is_symbol(a)) goto    G0058;
    a = CC_WsametypeTidany(a, q);
    if(a == nil) goto    G0058;
    m = w2;
    q = w1;
    goto    G0080;
   G0019:
    if(is_cons(q)) goto    G0036;
    a = car(a);
    if(!is_integer(a)) goto    G0038;
    if(!is_number(q)) goto    G0058;
    if(a >= value(LL_CmaxcanoC)) goto    G0058;
    m = q;
    q = w1;
    goto    G0080;
   G0038:
    if(!is_symbol(q)) goto    G0058;
    q = w1;
    a = w2;
    a = CC_WsametypeTidany(a, q);
    if(a == nil) goto    G0058;
    m = w2;
    q = w1;
    goto    G0080;
   G0036:
    a = car(a);
    if(!is_integer(a)) goto    G0046;
    if(a >= value(LL_CmaxcanoC)) goto    G0048;
    a = q;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0048;
    m = w2;
    q = w1;
    goto    G0080;
   G0048:
    a = car(w2);
    if(!is_integer(a)) goto    G0058;
    q = w2;
    a = w1;
    a = CC_WsametypeTform(a, q);
    if(a == nil) goto    G0058;
    m = w2;
    q = w1;
    goto    G0080;
   G0046:
    a = car(q);
    if(!is_integer(a)) goto    G0053;
    if(a >= value(LL_CmaxcanoC)) goto    G0058;
    a = w1;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0058;
    m = w2;
    q = w1;
    goto    G0080;
   G0053:
    a = car(w1);
    if(!is_symbol(a)) goto    G0058;
    a = car(q);
    if(!is_symbol(a)) goto    G0058;
#define LL_BctypeB LITERAL[2]
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
    w3 = a;
    q = LL_BctypeB;
    a = car(w2);
    a = Lget(a, q);
    if(a != w3) goto    G0058;
    m = w2;
    q = w1;
   G0080:
#define LL_rM LITERAL[3]
    a = LL_rM;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
   G0058:
    q = LITERAL[4];
    a = mkfxat(5);
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
}

Sex CC_gVM(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0086;
    if(is_cons(q)) goto    G0088;
    if(!is_number(a)) goto    G0090;
    if(!is_number(q)) goto    G0090;
    m = q;
    q = a;
    goto    G0147;
   G0090:
    if(!is_symbol(a)) goto    G0125;
    if(!is_symbol(q)) goto    G0125;
    a = CC_WsametypeTid(a, q);
    if(a == nil) goto    G0125;
    m = w2;
    q = w1;
    goto    G0147;
   G0088:
    a = car(q);
    if(!is_integer(a)) goto    G0095;
    a = w1;
    if(!is_number(a)) goto    G0125;
    if(car(q) >= value(LL_CmaxcanoC)) goto    G0125;
    m = q;
    q = a;
    goto    G0147;
   G0095:
    a = w1;
    if(!is_symbol(a)) goto    G0125;
    a = CC_WsametypeTidany(a, q);
    if(a == nil) goto    G0125;
    m = w2;
    q = w1;
    goto    G0147;
   G0086:
    if(is_cons(q)) goto    G0103;
    a = car(a);
    if(!is_integer(a)) goto    G0105;
    if(!is_number(q)) goto    G0125;
    if(a >= value(LL_CmaxcanoC)) goto    G0125;
    m = q;
    q = w1;
    goto    G0147;
   G0105:
    if(!is_symbol(q)) goto    G0125;
    q = w1;
    a = w2;
    a = CC_WsametypeTidany(a, q);
    if(a == nil) goto    G0125;
    m = w2;
    q = w1;
    goto    G0147;
   G0103:
    a = car(a);
    if(!is_integer(a)) goto    G0113;
    if(a >= value(LL_CmaxcanoC)) goto    G0115;
    a = q;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0115;
    m = w2;
    q = w1;
    goto    G0147;
   G0115:
    a = car(w2);
    if(!is_integer(a)) goto    G0125;
    q = w2;
    a = w1;
    a = CC_WsametypeTform(a, q);
    if(a == nil) goto    G0125;
    m = w2;
    q = w1;
    goto    G0147;
   G0113:
    a = car(q);
    if(!is_integer(a)) goto    G0120;
    if(a >= value(LL_CmaxcanoC)) goto    G0125;
    a = w1;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0125;
    m = w2;
    q = w1;
    goto    G0147;
   G0120:
    a = car(w1);
    if(!is_symbol(a)) goto    G0125;
    a = car(q);
    if(!is_symbol(a)) goto    G0125;
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
    w3 = a;
    q = LL_BctypeB;
    a = car(w2);
    a = Lget(a, q);
    if(a != w3) goto    G0125;
    m = w2;
    q = w1;
   G0147:
#define LL_rVM LITERAL[5]
    a = LL_rVM;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
   G0125:
    q = LITERAL[6];
    a = mkfxat(5);
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
}

Sex CC_gR(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0153;
    a = w2;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0153;
    m = w2;
    q = w1;
#define LL_rR LITERAL[7]
    a = LL_rR;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
   G0153:
    a = LITERAL[8];
    {
        popv(2);
        return  CC_argerror(a);
    }
}

Sex CC_gS(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0159;
    a = w2;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0159;
    m = w2;
    q = w1;
#define LL_rS LITERAL[9]
    a = LL_rS;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
   G0159:
    a = LITERAL[10];
    {
        popv(2);
        return  CC_argerror(a);
    }
}

Sex CC_gRM(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0165;
    a = w2;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0165;
    m = w2;
    q = w1;
#define LL_rRM LITERAL[11]
    a = LL_rRM;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
   G0165:
    a = LITERAL[12];
    {
        popv(2);
        return  CC_argerror(a);
    }
}

Sex CC_gSM(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0171;
    a = w2;
    a = CC_Wratexpr(a);
    if(a == nil) goto    G0171;
    m = w2;
    q = w1;
#define LL_rSM LITERAL[13]
    a = LL_rSM;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
   G0171:
    a = LITERAL[14];
    {
        popv(2);
        return  CC_argerror(a);
    }
}

Sex CC_gminusTsetset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0177;
#define LL_Anil LITERAL[15]
    q = LL_Anil;
    a = Lneq(a, q);
    if(a != nil) goto    G0193;
    a = w2;
    if(a == LL_Anil) goto    G0186;
    q = LITERAL[16];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0193;
    goto    G0216;
   G0177:
    if(is_cons(q)) goto    G0183;
    q = LITERAL[16];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0193;
    a = w2;
    if(a != LL_Anil) goto    G0193;
   G0186:
    a = w1;
    goto    G0213;
   G0183:
    a = car(a);
#define LL_Bset LITERAL[17]
    if(a != LL_Bset) goto    G0188;
    a = car(q);
    if(a != LL_Bset) goto    G0188;
    q = cdr(w1);
    a = cdr(w2);
    a = CC_multidelete(a, q);
    w1 = a;
    if(a == nil) goto    G0219;
    q = LL_Bset;
    {
        popv(5);
        return  Lxcons(a, q);
    }
   G0188:
    a = car(w1);
#define LL_Boset LITERAL[18]
    if(a != LL_Boset) goto    G0193;
    a = car(q);
    if(a != LL_Boset) goto    G0193;
    a = w1;
    a = Llength(a);
    w3 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w3;
    a = Llessp(a, q);
    if(a == nil) goto    G0196;
   G0216:
    q = nil;
    a = LITERAL[19];
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G0196:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(w1);
    a = Lreverse(a);
    w4 = a;
    a = cdr(w2);
    a = Lreverse(a);
    w5 = a;
   G0201:
    q = car(w5);
    a = car(w4);
    a = Lequal(a, q);
    if(a == nil) goto    G0220;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G0207;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0201;
   G0220:
    q = nil;
    a = LITERAL[19];
    CC_errormsg(a, q);
   G0207:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0209;
   G0219:
    a = LL_Anil;
    goto    G0213;
   G0209:
    q = w3;
    a = car(w4);
    a = cons(a, q);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0209;
    q = w3;
    a = LL_Boset;
    {
        popv(5);
        return  cons(a, q);
    }
   G0193:
    a = LITERAL[20];
    a = CC_argerror(a);
   G0213:
    popv(5);
    return a;
}

Sex CC_gplusTsetset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0224;
    if(is_cons(q)) goto    G0226;
    if(a != LL_Anil) goto    G0242;
    a = q;
    if(a != LL_Anil) goto    G0242;
    goto    G0249;
   G0226:
    if(a != LL_Anil) goto    G0242;
    q = LITERAL[16];
    a = car(w2);
    a = Lmemq(a, q);
    if(a == nil) goto    G0242;
    a = w2;
    goto    G0245;
   G0224:
    if(is_cons(q)) goto    G0234;
    a = q;
    if(a != LL_Anil) goto    G0242;
    q = LITERAL[16];
    a = car(w1);
    a = Lmemq(a, q);
    if(a == nil) goto    G0242;
    goto    G0249;
   G0234:
    a = car(a);
    if(a != LL_Bset) goto    G0239;
    a = car(q);
    if(a != LL_Bset) goto    G0239;
    q = cdr(q);
    a = cdr(w1);
    a = CC_ordunion(a, q);
    q = LL_Bset;
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G0239:
    a = car(w1);
    if(a != LL_Boset) goto    G0242;
    a = car(q);
    if(a != LL_Boset) goto    G0242;
    a = w1;
    a = CC_topcopy(a);
    w1 = a;
    a = CC_tail(a);
    q = cdr(w2);
    cdr(a) = q;
   G0249:
    a = w1;
    goto    G0245;
   G0242:
    a = LITERAL[21];
    a = CC_argerror(a);
   G0245:
    popv(2);
    return a;
}

Sex CC_gtimesTsetset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0254;
    if(is_cons(q)) goto    G0256;
    if(a != LL_Anil) goto    G0272;
    a = q;
    if(a != LL_Anil) goto    G0272;
    goto    G0279;
   G0256:
    if(a != LL_Anil) goto    G0272;
    goto    G0279;
   G0254:
    if(is_cons(q)) goto    G0263;
    a = q;
    if(a != LL_Anil) goto    G0272;
    goto    G0279;
   G0263:
    a = car(a);
    if(a != LL_Bset) goto    G0267;
    a = car(q);
    if(a != LL_Bset) goto    G0267;
    q = cdr(q);
    a = cdr(w1);
    a = Lintersection(a, q);
    w1 = a;
    if(a != nil) goto    G0270;
   G0279:
    a = LL_Anil;
    goto    G0274;
   G0270:
    q = LL_Bset;
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G0267:
    a = car(w1);
    if(a != LL_Boset) goto    G0272;
    a = car(q);
    if(a != LL_Boset) goto    G0272;
    q = nil;
    a = LITERAL[22];
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
   G0272:
    a = LITERAL[23];
    a = CC_argerror(a);
   G0274:
    popv(1);
    return a;
}

Sex CC_ordunion(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a != nil) goto    G0284;
    a = q;
    goto    G0290;
   G0284:
    w1 = a;
    a = q;
    if(a != nil) goto    G0285;
    a = w1;
    goto    G0290;
   G0285:
    w2 = q;
    q = car(a);
    a = car(w1);
    a = CC_orderRMS(a, q);
#define LL_Htemporal LITERAL[24]
    value(LL_Htemporal) = a;
    if(a != CHAR_OF(62)) goto    G0286;
    q = w2;
    a = cdr(w1);
    a = CC_ordunion(a, q);
    q = car(w1);
    goto    G0293;
   G0286:
    q = cdr(w2);
    if(a != CHAR_OF(60)) goto    G0288;
    a = w1;
    a = CC_ordunion(a, q);
    q = car(w2);
    goto    G0293;
   G0288:
    a = cdr(w1);
    a = CC_ordunion(a, q);
    q = car(w1);
   G0293:
    a = Lxcons(a, q);
   G0290:
    popv(2);
    return a;
}



/* initialization procedure */
int init_comrset(void)
{
   long i;

   create_symbols(comrset_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; comrset_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(comrset_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4, arg5;
        a = LITERAL[25];
        CC_Aenter(a);
        arg4 = nil;
        m = nil;
#define LL_Aunion LITERAL[26]
        q = LL_Aunion;
#define LL_union LITERAL[27]
        a = LL_union;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_gM LITERAL[28]
        q = LL_gM;
        a = LL_gM;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_gVM LITERAL[29]
        q = LL_gVM;
        a = LL_gVM;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_gR LITERAL[30]
        q = LL_gR;
        a = LL_gR;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_gS LITERAL[31]
        q = LL_gS;
        a = LL_gS;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_gRM LITERAL[32]
        q = LL_gRM;
        a = LL_gRM;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_gSM LITERAL[33]
        q = LL_gSM;
        a = LL_gSM;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_gKS LITERAL[34]
        q = LL_gKS;
        a = LL_gKS;
        CC_defcommand(a, q, m, arg4);
        arg5 = nil;
#define LL_gexp LITERAL[35]
        arg4 = LL_gexp;
#define LL_argn LITERAL[36]
        m = LL_argn;
#define LL_gplus LITERAL[37]
        q = LL_gplus;
#define LL_gDL LITERAL[38]
        a = LL_gDL;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_gexp;
        m = LL_argn;
#define LL_gtimes LITERAL[39]
        q = LL_gtimes;
#define LL_gDH LITERAL[40]
        a = LL_gDH;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_gexp;
#define LL_arg2 LITERAL[41]
        m = LL_arg2;
#define LL_gminus LITERAL[42]
        q = LL_gminus;
#define LL_gDK LITERAL[43]
        a = LL_gDK;
        a = CC_genprogram(a, q, m, arg4, arg5);
        return 1;
    }
}
Sex LITERAL[45];

const  char *comrset_literal_string[45] =
{
/* 0 */
"r!-!>",
/* 1 */
"!#maxcano!#",
/* 2 */
"!!ctype!!",
/* 3 */
"r!=",
/* 4 */
"\"=\"",
/* 5 */
"r!/!=",
/* 6 */
"\"/=\"",
/* 7 */
"r!<",
/* 8 */
"\"<\"",
/* 9 */
"r!>",
/* 10 */
"\">\"",
/* 11 */
"r!<!=",
/* 12 */
"\"<=\"",
/* 13 */
"r!>!=",
/* 14 */
"\">=\"",
/* 15 */
"! nil",
/* 16 */
"(!!set !!oset)",
/* 17 */
"!!set",
/* 18 */
"!!oset",
/* 19 */
"\"CAN NOT BE SUBTRACTED\"",
/* 20 */
"\"SetDIFFERENCE\"",
/* 21 */
"\"UNION\"",
/* 22 */
"\"SetINTERSEC DOES NOT APPLY TO ORD-SET\"",
/* 23 */
"\"SetINTERSECTION\"",
/* 24 */
"!*temporal",
/* 25 */
"(lisp)",
/* 26 */
"! union",
/* 27 */
"union",
/* 28 */
"g!=",
/* 29 */
"g!/!=",
/* 30 */
"g!<",
/* 31 */
"g!>",
/* 32 */
"g!<!=",
/* 33 */
"g!>!=",
/* 34 */
"g!-!>",
/* 35 */
"gexp",
/* 36 */
"argn",
/* 37 */
"gplus",
/* 38 */
"g!$!+",
/* 39 */
"gtimes",
/* 40 */
"g!$!*",
/* 41 */
"arg2",
/* 42 */
"gminus",
/* 43 */
"g!$!-",
/* 44 */ NULL
};
setup_type const comrset_g_setup[] =
{
    {"ordunion", (lisp_proc *)CC_ordunion, 2},
    {"gtimes:setset", (lisp_proc *)CC_gtimesTsetset, 2},
    {"gplus:setset", (lisp_proc *)CC_gplusTsetset, 2},
    {"gminus:setset", (lisp_proc *)CC_gminusTsetset, 2},
    {"g>=", (lisp_proc *)CC_gSM, 2},
    {"g<=", (lisp_proc *)CC_gRM, 2},
    {"g>", (lisp_proc *)CC_gS, 2},
    {"g<", (lisp_proc *)CC_gR, 2},
    {"g/=", (lisp_proc *)CC_gVM, 2},
    {"g=", (lisp_proc *)CC_gM, 2},
    {"g->", (lisp_proc *)CC_gKS, 2},
    {"?>=", (lisp_proc *)CC_WSM, 2},
    {"?<=", (lisp_proc *)CC_WRM, 2},
    {"?>", (lisp_proc *)CC_WS, 2},
    {"?<", (lisp_proc *)CC_WR, 2},
    {"?/=", (lisp_proc *)CC_WVM, 2},
    {"?=", (lisp_proc *)CC_WM, 2},
    {NULL, NULL, 0 }
};

