/*
 * bfloat.h             (C); Copyright 2011 by Fujio Kako, Nara Women's University.
 *  Basic functions.
 * $Header: /Users/kako/asuka/src/RCS/bfloat.h,v 2.4 2014/01/25 10:05:11 kako Exp $
 */


/***************************************************************************
 *
 *
 ***************************************************************************/

#ifdef USE_MPFR

#include <mpfr.h>

extern __mpfr_struct bfloat2mpfr(Sex a);
extern Sex      mpfr2bfloat(__mpfr_struct * a);
// #define MPFR_RNDN GMP_RNDN
Sex             plus2ddR(Sex a, Sex b, mpfr_rnd_t R);

#endif


Sex             bfloatitc(Sex a);
Sex             bfloatitz(Sex a);
Sex             bfloatitZ(Sex a);
void            print_int_with_exp(unsigned long u, long dexp,
				   putchar_fn * fn);
void            print_bignum_with_exp(Sex u, long dexp, putchar_fn * fn);
Sex             rightshifti(Sex a, long s);
Sex             leftshiftd(Sex a, long n);
Sex             rightshiftb(Sex a, long s);
Sex             leftshiftb(Sex a, long s);
Sex             extend_bignum(Sex a, long n);
bool            numeq2dd_bad(Sex a, Sex b);
double          power_of_tenth(long n);
Sex             power_of_big_tenth(long n);

#ifdef USE_MPFR
void            print_mpfr(mpfr_t a);
#endif
