/*
 * config.h      (C) Copyright 1998-2007 by Fujio Kako, Nara Women's University.
 *      $Header: /Users/kako/asuka/src/RCS/config.h,v 2.28 2016/02/03 01:08:44 kako Exp $
 */

/*
 * #define ASUKA
 */

#ifndef VERSION
#define VERSION     "1.21"
#endif

#if 0
#define ASUKA
#define Android
#endif

#if 0
#define USE_SYMBOL_AS_POLYNOMIAL
#endif

#ifdef VisualC
#define _Noreturn		/* */
#endif

#ifdef REDUCE

#define REDUCE_VERSION	"3.8"
#define REDUCE_MAJOR_VERSION	3
#define REDUCE_MINOR_VERSION	8

#if !defined(Android) && !defined(VisualC)
#define INCLUDE_BYTECODE_PACKAGES
#define USE_ZLIB
#endif

#endif

#ifdef GAL
#define GAL_VERSION	"1.31"
#endif


#ifdef ASUKA
#define ASUKA_VERSION	"0.82"
#endif

#include <assert.h>
#define ASSERT(x)	assert(x)


#ifndef Android
#if defined(__i386__) || defined(__x86_64__)
#define USE_GMP			/* So use gmp library instead */
#define HAVE_GMP
#define GMPVERSION 513		/* use mpir library insted of gmp */
#define USE_MPFR		/* use mpfr library for big float */
#define MPFRVERSION 312
#endif


// #define USE_LONG_LONG

#ifdef VisualC
#undef USE_MPFR

#define MPFR_RNDN     GMP_RNDN
#define MPFR_RNDU     GMP_RNDU
#define MPFR_RNDD     GMP_RNDD
#endif


#ifndef VisualC

// #define USE_READLINE

#ifndef USE_ASMCODE
#if defined(__i386__) || defined(__x86_64__)
#ifndef Android
#define USE_ASMCODE
#endif
#endif
#endif

#endif
#endif




#define BEFLOAT_ERROR_IS_DOUBLE
#define TOWARD_LOWER_PRECISION	1
#define CONVERT_FROM_COMPLEX	1

// #define DBL_EPSILON 2.2204460492503131e-16
#define EFLOAT_ERROR	2.2204460492503131e-16


#define DIPOLY_COEFF	0
#define TERM_ORDER_LEX		0
#define TERM_ORDER_REVLEX	1
#define TERM_ORDER_TLEX		2
#define TERM_ORDER_TREVLEX	3
#define TERM_ORDER_GRADINGS	-1
#define TERM_ORDER_GRADINGS1	-1
#define TERM_ORDER_GRADINGS2	-2
#define TERM_ORDER_GRADINGS3	-3
#define TERM_ORDER_GRADINGS4	-4
#define TERM_ORDER_GRADINGS5	-5
#define TERM_ORDER_GRADINGS6	-6


#define SAVE_SPACE
#define TEST_KARATSUBA
		/*
		 * Fixed the bugs in karatsuba routine. F.K. 2014.8.8 
		 */
// #define USE_KARATSUBA /* There's bugs in karatsuba routine */

#define KARATSUBA	16

#ifdef Android
#define CORE_SIZE		0x1000000
#define STACK_SIZE		0x100000
#define BIND_SIZE		0x100000
#else
#define CORE_SIZE		0x10000000
#define STACK_SIZE		0x200000
#define BIND_SIZE		0x200000
#endif
#define SPARE			0x100
#define OBVEC_SIZE		0x10000
#define GOBVEC_SIZE		0x4000
#define BUFFER_SIZE		40960
#define INIT_HASH_SIZE		1024

#define MAX_NARGS		15

/*
 * #define SAVE_WORK_SPACE 
 */


/*
 * GCC TYPE
 */

#define GNU_WIN32		2
#define GCC_DJGPP		1
#define GCC_UNIX		3
#define NO_GCC			4

/*
 * WINDOWS 
 */



#ifdef VisualC

#ifdef WINDOWS_NT
#define IMPNAME               "Windows"
#define OPSYS                 "WindowsNT"
#else
#define IMPNAME		      "Windows"
#define OPSYS                 "Windows95"
#endif

#ifndef HZ
#define HZ	60
#endif
#define Kanji
#define Shift_JIS
#define poll_for_attn()
#define GCCTYPE			NO_GCC

extern long     win32s;
extern void     addchars(char *c, long n);
extern long     chInput(void);
#endif




#ifdef Darwin
#define IMPNAME               "Darwin"
#define OPSYS                 "unix"
#define Kanji
#define EUC
#ifndef SEEK_SET
#define SEEK_SET           0
#endif
#define CLK_TCK		      CLOCKS_PER_SEC
#define SYS_TIMES             CLK_TCK
#define HZ             	      CLK_TCK
#define UNIX                  1
#define NO_BINARY_FOPEN       1	/* 
				 * * * * * probably not needed     
				 */
#define poll_for_attn()
#undef USE_READLINE
#undef  nil
#define nil	NIL
#endif

#ifdef SunOS
#define IMPNAME               "SunOS"
#define OPSYS                 "unix"
#define Kanji
#define EUC
#ifndef SEEK_SET
#define SEEK_SET           0
#endif
#include <sys/param.h>
#define SYS_TIMES             HZ
#define UNIX                  1
#define NO_BINARY_FOPEN       1	/* 
				 * * * * * probably not needed     
				 */
#define poll_for_attn()
#undef USE_READLINE
#endif

#ifdef FreeBSD
#define IMPNAME               "FreeBSD"
#define OPSYS                 "unix"
#define Kanji
#define EUC
#ifndef SEEK_SET
#define SEEK_SET           0
#endif
#include <sys/param.h>
#ifndef HZ
#define HZ             CLK_TCK
#endif
#define UNIX                  1
#define NO_BINARY_FOPEN       1	/* 
				 * * * * * probably not needed     
				 */
#define poll_for_attn()
#endif

#ifdef Linux
#define IMPNAME               "Linux"
#define OPSYS                 "unix"
#define Kanji
#define EUC
#ifndef SEEK_SET
#define SEEK_SET           0
#endif
#include <sys/param.h>
#ifndef HZ
#define HZ             100
#endif
#define UNIX                  1
#define NO_BINARY_FOPEN       1	/* 
				 * * * * * probably not needed     
				 */
#define poll_for_attn()
#endif


#ifdef Android

#define OPVER "4.4"
#define VARIABLE_MEMORY_MODEL
#define NO_SIGNAL_HANDLER

#define IMPNAME               "Android"
#define OPSYS                 "unix"
#define Kanji
#define EUC
#ifndef SEEK_SET
#define SEEK_SET           0
#endif
#include <sys/param.h>
#ifndef HZ
#define HZ             100
#endif
#define UNIX                  1
#define NO_BINARY_FOPEN       1	/* 
				 * * * * * probably not needed     
				 */
#define poll_for_attn()
#endif


#ifndef GCCTYPE
#define GCCTYPE		GCC_UNIX	/* 
					 * * * * for  unix    
					 */
#endif

#include <stdio.h>
#include <setjmp.h>
#include <signal.h>

#include <time.h>
#ifdef UNIX
#include <sys/time.h>
#endif

#ifdef ppc
#define ieee_exponent(u)	(((u.i[0]>>20)&0x7ff) - 0x3ff)
#define ieee_hiword(u)		((u.i[0]& 0xfffff) | 0x100000)
#define ieee_loword(u)		(u.i[1])
#define ieee_signum(u)		(u.i[0])
#else
#if defined(sparc) || defined(__sparc)
#define ieee_exponent(u)	(((u.i[0]>>20)&0x7ff) - 0x3ff)
#define ieee_hiword(u)		((u.i[0]& 0xfffff) | 0x100000)
#define ieee_loword(u)		(u.i[1])
#define ieee_signum(u)		(u.i[0])
#else
#define ieee_exponent(u)	(((u.i[1]>>20)&0x7ff) - 0x3ff)
#define ieee_hiword(u)		((u.i[1]& 0xfffff) | 0x100000)
#define ieee_loword(u)		(u.i[0])
#define ieee_signum(u)		(u.i[1])
#endif
#endif

#ifdef _LP64
#define ieee_word(u)		((u.l & 0xfffffffffffff) | 0x10000000000000)
#endif

#ifndef FILENAME_MAX
#define FILENAME_MAX	256
#endif

/*
 * array offset 
 */

#ifdef ASUKA
#define A_OFF	0
#else
#ifdef GAL
#define A_OFF	1
#else
#define A_OFF	0
#endif
#endif

#ifdef REDUCE
#define MKARRAY_INIT_VALUE      nil
#define MKMATRIX_INIT_VALUE     nil
#define MKVECTOR_INIT_VALUE     nil
#else
#define MKARRAY_INIT_VALUE      mkfxat(0)
#define MKMATRIX_INIT_VALUE     mkfxat(0)
#define MKVECTOR_INIT_VALUE     mkfxat(0)
#endif


/*
 * array offset 
 */

#ifdef _LP64
#define LPSIZE  64
#define LP_LOG2 6
#define N_SHIFT	32
#define L_HALF	0x00000000ffffffffL
#define U_HALF  0xffffffff00000000L
#define BYTES_PER_LONG	8
#else
#define LPSIZE  32
#define LP_LOG2 5
#define N_SHIFT	16
#define L_HALF	0x0000ffffL
#define U_HALF  0xffff0000L
#define BYTES_PER_LONG	4
#endif


#ifndef _LP64

#define MEMORY_UNDEF	-2
#define MEMORY_LOW      -1
#define MEMORY_HIGH     1
#define MEMORY_MIXED    0
#define MEMORY_VARIABLE 2

#ifdef VARIABLE_MEMORY_MODEL
#define MEMORY_MODEL MEMORY_VARIABLE
#else
#ifdef MIXED_MEMORY_MODEL
#define MEMORY_MODEL  MEMORY_MIXED
#else
#ifdef HIGH_MEMORY_MODEL
#define MEMORY_MODEL MEMORY_HIGH
#else
#ifdef LOW_MEMORY_MODEL
#define MEMORY_MODEL MEMORY_LOW
#else
#define MEMORY_MODEL MEMORY_LOW
#endif
#endif
#endif
#endif

#endif
