/*
 * entries.h            (C) Copyright 1998-2000, 2007 by Fujio Kako, Nara Women's University.
 * $Header: /Users/kako/asuka/src/RCS/entries.h,v 2.13 2016/05/23 01:26:26 kako Exp $
 */


/*
 * apply function
 */

extern Sex      apply0(Sex);
extern Sex      apply1(Sex, Sex);
extern Sex      apply2(Sex, Sex, Sex);
extern Sex      apply3(Sex, Sex, Sex, Sex);

extern Sex      carcdr_error(Sex a);
extern Sex      Linterp0(Sex fn);
extern Sex      Linterp1(Sex fn, Sex a1);
extern Sex      Linterp2(Sex fn, Sex a1, Sex a2);
extern Sex      Linterp3(Sex fn, Sex a1, Sex a2, Sex a3);
extern Sex      Linterpreter(Sex fn, Sex args);

/*
 * things with no args...
 */

extern Sex      Lerror0(void);
extern Sex      Lgctime(void);
extern Sex      Lgensym(void);
extern Sex      Lreset_gensym(Sex);
extern Sex      Llist_modules(void);
extern Sex      Llposn(void);
extern Sex      Lrandom_int1(void);
extern Sex      Lrandom_int2(void);
extern Sex      Lrandom_real1(void);
extern Sex      Lrandom_real2(void);
extern Sex      Lrandom_real3(void);
extern Sex      Lposn(void);
extern Sex      Lread(void);
extern Sex      Lreadch(void);
extern Sex      Lrtell(void);
extern Sex      Lterpri(void);
extern Sex      Ltime(void);
extern Sex      Ltyi(void);
extern Sex      Lgc(void);
extern Sex      Lgetpid(void);

/*
 * things with one arg...
 */

extern Sex      Lget_number_of_args(Sex a);
extern Sex      CC_get_number_of_args(Sex a);
extern Sex      Lis_macro(Sex a);
extern Sex      Lis_special(Sex a);

extern Sex      Labsval(Sex a);
extern Sex      Lsub1(Sex a);
extern Sex      Leval(Sex a);
extern Sex      Levlis(Sex a);
extern Sex      Lexplode(Sex a);
extern Sex      Lexplode2lc(Sex a);
extern Sex      Lexplodec(Sex a);
extern Sex      Lexploden(Sex a);
extern Sex      Lexplode2n(Sex a);
extern Sex      Lexplodecn(Sex a);
extern Sex      Ldefine_in_module(Sex a);
extern Sex      Lstart_module(Sex a);
extern Sex      Lmodule_exists(Sex a);
extern Sex      Lwrite_module(Sex a);
extern Sex      Lselect_module_file(Sex a);
extern Sex      Lsrandom(Sex a);
extern Sex      Ltruncate(Sex a);
extern Sex      Lfixp(Sex a);
extern Sex      Lfloat(Sex a);
extern Sex      Lfloatp(Sex a);
extern Sex      Lfluidp(Sex a);
extern Sex      Lgensym1(Sex a);
extern Sex      Lgetenv(Sex a);
extern Sex      Lglobalp(Sex a);
extern Sex      Liadd1(Sex a);
extern Sex      Lidp(Sex a);
extern Sex      Liminus(Sex a);
extern Sex      Liminusp(Sex a);
extern Sex      Lindirect(Sex a);
extern Sex      Lintegerp(Sex a);
extern Sex      Lintern(Sex a);
extern Sex      Lisub1(Sex a);
extern Sex      Llength(Sex a);
extern Sex      Llengthc(Sex a);
extern Sex      Llinelength(Sex a);
extern Sex      Lliter(Sex a);
/*
 * extern Sex Lcopy_module(Sex a);               
 */
/*
 * extern Sex Ldelete_module(Sex a);             
 */
/*
 * extern Sex Lload_module(Sex a);               
 */
extern Sex      Llog(Sex a);
extern Sex      Llognot(Sex a);
extern Sex      Llsd(Sex a);
extern Sex      Lmsd(Sex a);
extern Sex      Lmacro_function(Sex a);
extern Sex      Lglobal(Sex a);
extern Sex      Lsmkvect(Sex a);
extern Sex      Lfluid(Sex a);
extern Sex      Lmkquote(Sex a);
extern Sex      Lmkvect(Sex a);
extern Sex      Lmodular_minus(Sex a);
extern Sex      Lmodular_number(Sex a);
extern Sex      Lmodular_reciprocal(Sex a);
extern Sex      Lncons(Sex a);
extern Sex      Lnull(Sex a);
extern Sex      Lnull(Sex a);
extern Sex      Lnumberp(Sex a);
extern Sex      Loddp(Sex a);
extern Sex      Lonep(Sex a);
extern Sex      Lpagelength(Sex a);
extern Sex      Lpairp(Sex a);
extern Sex      Lplist(Sex a);
extern Sex      Lplusp(Sex a);
extern Sex      Lprin(Sex a);
extern Sex      Lprin(Sex a);
extern Sex      Lprinc(Sex a);
extern Sex      Lprinc(Sex a);
extern Sex      Lprint(Sex a);
extern Sex      Aprint(Sex a);
extern Sex      Lprintc(Sex a);
extern Sex      Lcaar(Sex a);
extern Sex      Lcadr(Sex a);
extern Sex      Lcar(Sex a);
extern Sex      Lcdar(Sex a);
extern Sex      Lcddr(Sex a);
extern Sex      Lcdr(Sex a);
extern Sex      Lrational(Sex a);
extern Sex      Lrdf(Sex a);
extern Sex      Lrds(Sex a);
extern Sex      Lgetd(Sex a);
extern Sex      Lremd(Sex a);
extern Sex      Lremob(Sex a);
extern Sex      Lreverse(Sex a);
extern Sex      Lnreverse(Sex a);
extern Sex      Lseprp(Sex a);
extern Sex      Lset_small_modulus(Sex a);
extern Sex      Lsetpchar(Sex a);
extern Sex      Lxtab(Sex a);
extern Sex      Lspecial_char(Sex a);
extern Sex      Lspecial_form_p(Sex a);
extern Sex      Lspool(Sex a);
extern Sex      Lstop(Sex a);
extern Sex      Lstringp(Sex a);
extern Sex      Lsymbol_env(Sex a);
extern Sex      Lsymbol_function(Sex a);
extern Sex      Lsymbol_name(Sex a);
extern Sex      Lsymbol_value(Sex a);
#ifdef UNIX
extern Sex      Lsystem(Sex a);
#endif
extern Sex      Ltrace(Sex a);
/*
 * extern Sex      Lttab(Sex a);
 */
extern Sex      Ltyo(Sex a);
extern Sex      Lunglobal(Sex a);
extern Sex      Lunfluid(Sex a);
extern Sex      Lupbv(Sex a);
extern Sex      Luntrace(Sex a);
extern Sex      Lvectorp(Sex a);
extern Sex      Lverbos(Sex a);
extern Sex      Lwrs(Sex a);
extern Sex      Lxtab(Sex a);
extern Sex      Lzerop(Sex a);

extern Sex      make_sov(Sex a);

extern Sex      getuniq(Sex a);
/*
 * things with two args ...
 */

extern Sex      apply1(Sex a, Sex b);
extern Sex      Lapply1(Sex a, Sex b);
extern Sex      Latan2d(Sex a, Sex b);
extern Sex      Lcons(Sex a, Sex b);
extern Sex      Ldelete(Sex a, Sex b);
extern Sex      expti(Sex a, long n);
extern Sex      Lexpt(Sex a, Sex b);
extern Sex      Lflag(Sex a, Sex b);
extern Sex      Lflagp(Sex a, Sex b);
extern Sex      Lflagp(Sex a, Sex b);
extern Sex      Lflagpcar(Sex a, Sex b);
extern Sex      Lgcd(Sex a, Sex b);
extern Sex      Lgeq(Sex a, Sex b);
extern Sex      Lget(Sex a, Sex b);
extern Sex      Lgetv(Sex a, Sex b);
extern Sex      Lgreaterp(Sex a, Sex b);
extern Sex      Lidifference(Sex a, Sex b);
extern Sex      Ligreaterp(Sex a, Sex b);
extern Sex      Lilessp(Sex a, Sex b);
extern Sex      Limax2(Sex a, Sex b);
extern Sex      Limin2(Sex a, Sex b);
extern Sex      Liplus2(Sex a, Sex b);
extern Sex      Liquotient(Sex a, Sex b);
extern Sex      Liremainder(Sex a, Sex b);
extern Sex      Lirightshift(Sex a, Sex b);
extern Sex      Litimes2(Sex a, Sex b);
extern Sex      Llcm(Sex a, Sex b);
extern Sex      Lleq(Sex a, Sex b);
extern Sex      Llessp(Sex a, Sex b);
extern Sex      Llist2(Sex a, Sex b);
extern Sex      Lmember(Sex a, Sex b);
extern Sex      Llogand2(Sex a, Sex b);
extern Sex      Llogeqv2(Sex a, Sex b);
extern Sex      Llogxor2(Sex a, Sex b);
extern Sex      Llogor2(Sex a, Sex b);
extern Sex      Lmax2(Sex a, Sex b);
extern Sex      Lmin2(Sex a, Sex b);
extern Sex      Lmod(Sex a, Sex b);
extern Sex      Lmodular_difference(Sex a, Sex b);
extern Sex      Lmodular_expt(Sex a, Sex b);
extern Sex      Lmodular_plus(Sex a, Sex b);
extern Sex      Lmodular_quotient(Sex a, Sex b);
extern Sex      Lmodular_times(Sex a, Sex b);
extern Sex      Lneq(Sex a, Sex b);
extern Sex      Lorderp(Sex a, Sex b);
extern Sex      Lplus2(Sex a, Sex b);
extern Sex      Lquotient(Sex a, Sex b);
extern Sex      Lrem(Sex a, Sex b);
extern Sex      Lremflag(Sex a, Sex b);
extern Sex      Lremprop(Sex a, Sex b);
extern Sex      Lrplaca(Sex a, Sex b);
extern Sex      Lrplacd(Sex a, Sex b);
extern Sex      Lrseek(Sex a);
extern Sex      Lsgetv(Sex a, Sex b);
extern Sex      Lset(Sex a, Sex b);
extern Sex      Lsmemq(Sex a, Sex b);
extern Sex      subla(Sex a, Sex b, Sex c);
extern Sex      Lsubla(Sex a, Sex b);
extern Sex      sublis(Sex a, Sex b, Sex c);
extern Sex      Lsublis(Sex a, Sex b);
extern Sex      Lsymbol_set_definition(Sex a, Sex b);
extern Sex      Lsymbol_set_env(Sex a, Sex b);
extern Sex      Ltimes2(Sex a, Sex b);
extern Sex      Lxcons(Sex a, Sex b);

extern Sex      Lgensym2(Sex a, Sex b);

extern Sex      Lilogor2(Sex a, Sex b);
extern Sex      Lilogand2(Sex a, Sex b);
extern Sex      Lilogxor2(Sex a, Sex b);
/*
 * Things with three args...
 */
extern Sex      Llist2star(Sex a, Sex b, Sex c);
extern Sex      Llist3(Sex a, Sex b, Sex c);
extern Sex      Lput(Sex a, Sex b, Sex c);
extern Sex      Lputv(Sex a, Sex b, Sex c);
extern Sex      Lsputv(Sex a, Sex b, Sex c);
extern Sex      Lsubst(Sex a, Sex b, Sex c);

/*
 * Things with four or more args
 */

extern Sex      Lapply3(Sex a, Sex b, Sex c, Sex d);
#ifdef ASUKA
extern Sex      Llist4(Sex a, Sex b, Sex c, Sex d);
extern Sex      Llist5(Sex a, Sex b, Sex c, Sex d, Sex e);
extern Sex      Llist6(Sex a, Sex b, Sex c, Sex d, Sex e, Sex f);
extern Sex      Llist7(Sex a, Sex b, Sex c, Sex d, Sex e, Sex f, Sex g);

#endif

/*
 * Algebraic functions
 */

extern Sex      Aexpt(Sex a, Sex b);


/*
 * end of entries.h 
 */

void            trace_arg_print(long n);
void            trace_val_print(void);



/*************************************************************/

/*
 * buitin 
 */

extern Sex      Lgc(void);

extern Sex      Lfslrclose(void);
extern Sex      Lfslwclose(void);

extern Sex      Lbpsleft(void);
extern Sex      Lanpbporg(void);
extern Sex      Lanpbpend(void);
extern Sex      Lchr1(void);
extern Sex      Lchr2(void);
extern Sex      Lchr4(void);
extern Sex      Lchrt(void);
extern Sex      Ldate(void);
extern Sex      Ldatestamp(void);
extern Sex      Lerror1(void);
extern Sex      Lgctime(void);
extern Sex      Ltime(void);
extern Sex      Lfloat_time(void);
extern Sex      Lquit(void);
extern Sex      Lbye(void);
extern Sex      Leject(void);
extern Sex      Lflush(void);
extern Sex      Llposn(void);
extern Sex      Lposn(void);
extern Sex      Lterpri(void);
extern Sex      Ltmpnam(void);
extern Sex      Lterpri(void);
extern Sex      Lbatchp(void);
extern Sex      Lrtell(void);
extern Sex      Lgensym(void);
extern Sex      Lread(void);
extern Sex      Lreadch(void);

extern Sex      Lfrexp(Sex a);
extern Sex      Lceiling(Sex a);
extern Sex      Lfloor(Sex a);
extern Sex      Lround(Sex a);
extern Sex      Ltruncate(Sex a);
extern Sex      Ldenominator(Sex a);
extern Sex      Lnumerator(Sex a);
extern Sex      Levenp(Sex a);
extern Sex      lognot(Sex a);
extern Sex      Llsd(Sex a);
extern Sex      Lsrandom(Sex a);
extern Sex      Lrandom(Sex a);
extern Sex      Lminusp(Sex a);
extern Sex      Lmsd(Sex a);
extern Sex      Loddp(Sex a);
extern Sex      Lonep(Sex a);
extern Sex      Lplusp(Sex a);
extern Sex      Lzerop(Sex a);
extern Sex      Ladd1(Sex a);
extern Sex      reciprocal(Sex a);
extern Sex      reciprocal2(Sex a, Sex b);
extern Sex      Lsub1(Sex a);
extern Sex      Lprecision(Sex a);
extern Sex      Lfix(Sex a);
extern Sex      Llogical(Sex a);
extern Sex      Llogical(Sex a);
extern Sex      Lrational(Sex a);
extern Sex      Lfloat(Sex a);
extern Sex      Lfloat(Sex a);
extern Sex      Lefloat(Sex a);
extern Sex      Lmkefloat1(Sex a);
extern Sex      Linterval(Sex a);
extern Sex      Lcomplex(Sex a);
extern Sex      Lecomplex(Sex a);
extern Sex      Lbfloat(Sex a);
extern Sex      Lbefloat(Sex a);
extern Sex      Lbinterval(Sex a);
extern Sex      Lbecomplex(Sex a);
extern Sex      Lcomplex_conjugate(Sex a);
extern Sex      Lmkmodular(Sex a);
extern Sex      Lunmodular(Sex a);
extern Sex      Lmodular(Sex a, Sex b);
extern Sex      Lmodular2(Sex a, long b);
extern Sex      Linterval_lower(Sex a);
extern Sex      Linterval_upper(Sex a);
extern Sex      Linterval_mid(Sex a);
extern Sex      Linterval_width(Sex a);
extern Sex      Lefloat_error(Sex a);
extern Sex      Lefloat_value(Sex a);
extern Sex      Lecomplex_value(Sex a);
extern Sex      Lecomplex_error(Sex a);
extern Sex      Lecomplex_real(Sex a);
extern Sex      Lecomplex_imag(Sex a);
extern Sex      Lcomplex_real(Sex a);
extern Sex      Lcomplex_imag(Sex a);
extern Sex      Lbefloat_error(Sex a);
extern Sex      Lbefloat_value(Sex a);
extern Sex      Lnext_prime(Sex a);
extern Sex      Lprime_before(Sex a);
extern Sex      Lprimep(Sex a);
extern Sex      Lbmodular_minus(Sex a);
extern Sex      Lbmodular_number(Sex a);
extern Sex      Lbmodular_reciprocal(Sex a);
extern Sex      Lset_modulus(Sex a);
extern Sex      Lset_big_modulus(Sex a);
extern Sex      Lchar_code(Sex a);
extern Sex      Lcode_char(Sex a);
extern Sex      Lspecial_char(Sex a);
extern Sex      Ldigitp(Sex a);
extern Sex      Lliter(Sex a);
extern Sex      Lis_char(Sex a);
extern Sex      Lis_wchar(Sex a);
extern Sex      Lseprp(Sex a);
extern Sex      Ldigitp(Sex a);
extern Sex      Lxdigitp(Sex a);
extern Sex      Lliter(Sex a);
extern Sex      Lseprp(Sex a);
extern Sex      Lapply0(Sex a);
extern Sex      Levlis(Sex a);
extern Sex      Lfuncall0(Sex a);
extern Sex      Lverbos(Sex a);
extern Sex      Lerrorset1(Sex a);
extern Sex      Lfslropen(Sex a);
extern Sex      Lfslwopen(Sex a);
extern Sex      Lbpsmove(Sex a);
extern Sex      Lchrbg(Sex a);
extern Sex      Latom(Sex a);
extern Sex      Lboundp(Sex a);
extern Sex      Lcar(Sex a);
extern Sex      Lcdr(Sex a);
extern Sex      Lcaar(Sex a);
extern Sex      Lcadr(Sex a);
extern Sex      Lcdar(Sex a);
extern Sex      Lcddr(Sex a);
extern Sex      Lcaaar(Sex a);
extern Sex      Lcaadr(Sex a);
extern Sex      Lcadar(Sex a);
extern Sex      Lcaddr(Sex a);
extern Sex      Lcdaar(Sex a);
extern Sex      Lcdadr(Sex a);
extern Sex      Lcddar(Sex a);
extern Sex      Lcdddr(Sex a);
extern Sex      Lcaaaar(Sex a);
extern Sex      Lcaaadr(Sex a);
extern Sex      Lcaadar(Sex a);
extern Sex      Lcaaddr(Sex a);
extern Sex      Lcadaar(Sex a);
extern Sex      Lcadadr(Sex a);
extern Sex      Lcaddar(Sex a);
extern Sex      Lcadddr(Sex a);
extern Sex      Lcdaaar(Sex a);
extern Sex      Lcdaadr(Sex a);
extern Sex      Lcdadar(Sex a);
extern Sex      Lcdaddr(Sex a);
extern Sex      Lcddaar(Sex a);
extern Sex      Lcddadr(Sex a);
extern Sex      Lcdddar(Sex a);
extern Sex      Lcddddr(Sex a);
extern Sex      Lcodep(Sex a);
extern Sex      Lbytecodep(Sex a);
extern Sex      Lconstantp(Sex a);
extern Sex      Lerror2(Sex a);
extern Sex      Lfixp(Sex a);
extern Sex      Lbigp(Sex a);
extern Sex      Llogicalp(Sex a);
extern Sex      Lfloatp(Sex a);
extern Sex      Lbfloatp(Sex a);
extern Sex      Lrationalp(Sex a);
extern Sex      Lcomplexp(Sex a);
extern Sex      Lcomplexp(Sex a);
extern Sex      Lecomplexp(Sex a);
extern Sex      Lbecomplexp(Sex a);
extern Sex      Lefloatp(Sex a);
extern Sex      Lbefloatp(Sex a);
extern Sex      Lintervalp(Sex a);
extern Sex      Lbintervalp(Sex a);
extern Sex      Lfluidp(Sex a);
extern Sex      Lglobalp(Sex a);
extern Sex      Lglobal(Sex a);
extern Sex      Lfluid(Sex a);
extern Sex      Lmkquote(Sex a);
extern Sex      Lncons(Sex a);
extern Sex      Lnumberp(Sex a);
extern Sex      Lstop(Sex a);
extern Sex      Lunglobal(Sex a);
extern Sex      Lunfluid(Sex a);
extern Sex      Lidp(Sex a);
extern Sex      Lpairp(Sex a);
extern Sex      Llistp(Sex a);
extern Sex      Lstringp(Sex a);
extern Sex      Lvectorp(Sex a);
extern Sex      Lendp(Sex a);
extern Sex      Lgetd(Sex a);
extern Sex      Llength(Sex a);
extern Sex      Lremd(Sex a);
extern Sex      Ltrace(Sex a);
extern Sex      Luntrace(Sex a);
extern Sex      Lupbv(Sex a);
extern Sex      Lnull(Sex a);
extern Sex      Lnull(Sex a);
extern Sex      Lreverse(Sex a);
extern Sex      Lmkvect(Sex a);
extern Sex      Larraydim(Sex a);
extern Sex      Lmkarray1(Sex a);
extern Sex      Lmkiarray1(Sex a);
extern Sex      Lmkiarray1(Sex a);
extern Sex      Lmkfarray1(Sex a);
extern Sex      Lmkdarray1(Sex a);
extern Sex      Lnreverse(Sex a);
extern Sex      Lmaphcons(Sex a);
extern Sex      Lmodular_minus(Sex a);
extern Sex      Lmodular_number(Sex a);
extern Sex      Lmodular_reciprocal(Sex a);
extern Sex      Lset_small_modulus(Sex a);
extern Sex      Liadd1(Sex a);
extern Sex      Liminus(Sex a);
extern Sex      Liminusp(Sex a);
extern Sex      Lisub1(Sex a);
extern Sex      Lionep(Sex a);
extern Sex      Lizerop(Sex a);
extern Sex      Lfilep(Sex a);
extern Sex      Llengthc(Sex a);
extern Sex      Llinelength(Sex a);
extern Sex      Lpagelength(Sex a);
extern Sex      Lxtab(Sex a);
extern Sex      Lttab(Sex a);
extern Sex      Lwrs(Sex a);
extern Sex      Lxtab(Sex a);
extern Sex      Lclose(Sex a);
extern Sex      Lstrlen(Sex a);
extern Sex      Lexplode(Sex a);
extern Sex      Lexplodew(Sex a);
extern Sex      Lexplodec(Sex a);
extern Sex      Lexplodec(Sex a);
extern Sex      Lexploden(Sex a);
extern Sex      Lexplodecn(Sex a);
extern Sex      Lexplodecn(Sex a);
extern Sex      Lexplodelc(Sex a);
extern Sex      Lexplodeuc(Sex a);
extern Sex      Lprin(Sex a);
extern Sex      Lprin(Sex a);
extern Sex      Lprinc(Sex a);
extern Sex      Lprinc(Sex a);
extern Sex      Lprin2t(Sex a);
extern Sex      Lprin2a(Sex a);
extern Sex      Lprint(Sex a);
extern Sex      Lprintc(Sex a);
extern Sex      Lfflush(Sex a);
extern Sex      Lfeject(Sex a);
extern Sex      Lfterpri(Sex a);
extern Sex      Lputch(Sex a);
extern Sex      Llprim(Sex a);
extern Sex      Llprie(Sex a);
extern Sex      Lprin(Sex a);
extern Sex      Lprintf0(Sex a);
extern Sex      Lsprintf0(Sex a);
extern Sex      Lcompress(Sex a);
extern Sex      Lmake_id(Sex a);
extern Sex      Lmake_uid(Sex a);
extern Sex      Lrseek(Sex a);
extern Sex      Lgensym1(Sex a);
extern Sex      Lgetenv(Sex a);
extern Sex      Lintern(Sex a);
extern Sex      Lrds(Sex a);
extern Sex      Lsetpchar(Sex a);
extern Sex      Lspool(Sex a);
extern Sex      Lremob(Sex a);
extern Sex      Lshowtime(Sex a);
extern Sex      Labs(Sex a);
extern Sex      Lacos(Sex a);
extern Sex      Lacosh(Sex a);
extern Sex      Lasec(Sex a);
extern Sex      Lasech(Sex a);
extern Sex      Lasin(Sex a);
extern Sex      Lasinh(Sex a);
extern Sex      Latanh(Sex a);
extern Sex      Lcbrt(Sex a);
extern Sex      Lcos(Sex a);
extern Sex      Lcosh(Sex a);
extern Sex      Lexp(Sex a);
extern Sex      Llog(Sex a);
extern Sex      Llog(Sex a);
extern Sex      Llog10(Sex a);
extern Sex      Lsec(Sex a);
extern Sex      Lsech(Sex a);
extern Sex      Lsin(Sex a);
extern Sex      Lsinh(Sex a);
extern Sex      Lsqrt(Sex a);
extern Sex      Ltan(Sex a);
extern Sex      Ltanh(Sex a);
extern Sex      Latan(Sex a);
extern Sex      Lcsc(Sex a);
extern Sex      Lcsch(Sex a);
extern Sex      Lcot(Sex a);
extern Sex      Lcoth(Sex a);
extern Sex      Lacsc(Sex a);
extern Sex      Lacsch(Sex a);
extern Sex      Lacot(Sex a);
extern Sex      Lacoth(Sex a);
extern Sex      Lfactorial(Sex a);


extern Sex      Llcm(Sex a, Sex q);
extern Sex      gcd(Sex a, Sex q);
extern Sex      gcd(Sex a, Sex q);
extern Sex      Lash(Sex a, Sex q);
extern Sex      Lash1(Sex a, Sex q);
extern Sex      Ldivide(Sex a, Sex q);
extern Sex      logand2(Sex a, Sex q);
extern Sex      logeqv2(Sex a, Sex q);
extern Sex      logxor2(Sex a, Sex q);
extern Sex      logor2(Sex a, Sex q);
extern Sex      Lmax2(Sex a, Sex q);
extern Sex      Lmin2(Sex a, Sex q);
extern Sex      modulus(Sex a, Sex q);
extern Sex      plus2(Sex a, Sex q);
extern Sex      times2(Sex a, Sex q);
extern Sex      diff2(Sex a, Sex q);
extern Sex      Leqn(Sex a, Sex q);
extern Sex      Lappeq(Sex a, Sex q);
extern Sex      Lgeq(Sex a, Sex q);
extern Sex      Lgreaterp(Sex a, Sex q);
extern Sex      Lleq(Sex a, Sex q);
extern Sex      Lleq(Sex a, Sex q);
extern Sex      Lgeq(Sex a, Sex q);
extern Sex      Llessp(Sex a, Sex q);
extern Sex      Lcgeq(Sex a, Sex q);
extern Sex      Lcgreaterp(Sex a, Sex q);
extern Sex      Lcleq(Sex a, Sex q);
extern Sex      Lcleq(Sex a, Sex q);
extern Sex      Lcgeq(Sex a, Sex q);
extern Sex      Lclessp(Sex a, Sex q);
extern Sex      ratio2(Sex a, Sex q);
extern Sex      quot2(Sex a, Sex q);
extern Sex      remaind2(Sex a, Sex q);
extern Sex      Lmkrational(Sex a, Sex q);
extern Sex      Lmkefloat(Sex a, Sex q);
extern Sex      Lmkinterval(Sex a, Sex q);
extern Sex      Lmkcomplex(Sex a, Sex q);
extern Sex      Lmkbefloat(Sex a, Sex q);
extern Sex      Lmkbinterval(Sex a, Sex q);
extern Sex      Lmkcomplex(Sex a, Sex q);
extern Sex      Lmkefloat(Sex a, Sex q);
extern Sex      Lmkbefloat(Sex a, Sex q);
extern Sex      Lmkinterval(Sex a, Sex q);
extern Sex      Lleftshift(Sex a, Sex q);
extern Sex      Lgen_prime(Sex a, Sex q);
extern Sex      Lsafe_fp_plus(Sex a, Sex q);
extern Sex      Lsafe_fp_times(Sex a, Sex q);
extern Sex      Lsafe_fp_quot(Sex a, Sex q);
extern Sex      Lbmodular_difference(Sex a, Sex q);
extern Sex      Lbmodular_plus(Sex a, Sex q);
extern Sex      Lbmodular_quotient(Sex a, Sex q);
extern Sex      Lbmodular_times(Sex a, Sex q);
extern Sex      Lbmodular_expt(Sex a, Sex q);
extern Sex      Lapply(Sex a, Sex q);
extern Sex      Lapply1(Sex a, Sex q);
extern Sex      Lfuncall(Sex a, Sex q);
extern Sex      Lfuncall1(Sex a, Sex q);

extern Sex      Lerror(Sex a, Sex q);
extern Sex      Lget(Sex a, Sex q);
extern Sex      Llist2(Sex a, Sex q);
extern Sex      cons(Sex a, Sex q);
extern Sex      Lxcons(Sex a, Sex q);
extern Sex      Lpair(Sex a, Sex q);
extern Sex      Lremprop(Sex a, Sex q);
extern Sex      Lrplaca(Sex a, Sex q);
extern Sex      Lrplacd(Sex a, Sex q);
extern Sex      Lunion(Sex a, Sex q);
extern Sex      Lunionq(Sex a, Sex q);
extern Sex      Lintersection(Sex a, Sex q);
extern Sex      Lintersectionq(Sex a, Sex q);
extern Sex      Lflag(Sex a, Sex q);
extern Sex      Lflagp(Sex a, Sex q);
extern Sex      Lflagpcar(Sex a, Sex q);
extern Sex      Lflagp(Sex a, Sex q);
extern Sex      Lget(Sex a, Sex q);
extern Sex      Lremflag(Sex a, Sex q);
extern Sex      Lset(Sex a, Sex q);
extern Sex      Lappend(Sex a, Sex q);
extern Sex      Leq(Sex a, Sex q);
extern Sex      Leqcar(Sex a, Sex q);
extern Sex      Leql(Sex a, Sex q);
extern Sex      Lequal(Sex a, Sex q);
extern Sex      Lmemq(Sex a, Sex q);
extern Sex      Lnconc(Sex a, Sex q);
extern Sex      Laconc(Sex a, Sex q);
extern Sex      Lmap(Sex a, Sex q);
extern Sex      Lmapc(Sex a, Sex q);
extern Sex      Lmapcar(Sex a, Sex q);
extern Sex      Lmaplist(Sex a, Sex q);
extern Sex      Lmapcan(Sex a, Sex q);
extern Sex      Lmapcon(Sex a, Sex q);
extern Sex      Lmapv(Sex a, Sex q);
extern Sex      Lneq(Sex a, Sex q);
extern Sex      Lsmemq(Sex a, Sex q);
extern Sex      Lsubla(Sex a, Sex q);
extern Sex      Lsublis(Sex a, Sex q);
extern Sex      Ldelete(Sex a, Sex q);
extern Sex      Ldeleq(Sex a, Sex q);
extern Sex      Lrassoc(Sex a, Sex q);
extern Sex      Lassoc(Sex a, Sex q);
extern Sex      Lassoc(Sex a, Sex q);
extern Sex      Latsoc(Sex a, Sex q);
extern Sex      Latsoc(Sex a, Sex q);
extern Sex      Lgetv(Sex a, Sex q);
extern Sex      Laref(Sex a, Sex q);
extern Sex      Lmember(Sex a, Sex q);
extern Sex      Lmember(Sex a, Sex q);
extern Sex      Lmkarray2(Sex a, Sex q);
extern Sex      Lmkiarray2(Sex a, Sex q);
extern Sex      Lmkfarray2(Sex a, Sex q);
extern Sex      Lmkdarray2(Sex a, Sex q);
extern Sex      Lgetarray1(Sex a, Sex q);
extern Sex      Lnth(Sex a, Sex q);
extern Sex      Lpnth(Sex a, Sex q);
extern Sex      Lgethash(Sex a, Sex q);
extern Sex      Lremhash(Sex a, Sex q);
extern Sex      Lmaphash(Sex a, Sex q);
extern Sex      Lhcons(Sex a, Sex q);
extern Sex      Lhmapcar(Sex a, Sex q);
extern Sex      Lhappend(Sex a, Sex q);
extern Sex      Lmodular_difference(Sex a, Sex q);
extern Sex      Lmodular_plus(Sex a, Sex q);
extern Sex      Lmodular_quotient(Sex a, Sex q);
extern Sex      Lmodular_times(Sex a, Sex q);
extern Sex      Lmodular_expt(Sex a, Sex q);
extern Sex      Lidifference(Sex a, Sex q);
extern Sex      Ligeq(Sex a, Sex q);
extern Sex      Ligreaterp(Sex a, Sex q);
extern Sex      Lileq(Sex a, Sex q);
extern Sex      Lilessp(Sex a, Sex q);
extern Sex      Lilogand2(Sex a, Sex q);
extern Sex      Lilogor2(Sex a, Sex q);
extern Sex      Lilogxor2(Sex a, Sex q);
extern Sex      Limax2(Sex a, Sex q);
extern Sex      Limin2(Sex a, Sex q);
extern Sex      Liplus2(Sex a, Sex q);
extern Sex      Liquotient(Sex a, Sex q);
extern Sex      Liremainder(Sex a, Sex q);
extern Sex      Lirightshift(Sex a, Sex q);
extern Sex      Litimes2(Sex a, Sex q);
extern Sex      Litimes2(Sex a, Sex q);
extern Sex      Lopen(Sex a, Sex q);
extern Sex      Lfprin(Sex a, Sex q);
extern Sex      Lfprin(Sex a, Sex q);
extern Sex      Lfprinc(Sex a, Sex q);
extern Sex      Lfprinc(Sex a, Sex q);
extern Sex      Lfprin2a(Sex a, Sex q);
extern Sex      Lfprint(Sex a, Sex q);
extern Sex      Lfprintc(Sex a, Sex q);
extern Sex      Lvprintf(Sex a, Sex q);
extern Sex      Lvsprintf(Sex a, Sex q);
extern Sex      Lfprintf0(Sex a, Sex q);
extern Sex      Lprintf1(Sex a, Sex q);
extern Sex      Lsprintf1(Sex a, Sex q);
extern Sex      Lbldmsg1(Sex a, Sex q);
extern Sex      Lstrcat(Sex a, Sex q);
extern Sex      Latan2(Sex a, Sex q);
extern Sex      Lhypot(Sex a, Sex q);
extern Sex      Llog_2(Sex a, Sex q);
extern Sex      Lpfactorial(Sex a, Sex q);
extern Sex      Lbinomial(Sex a, Sex q);


extern Sex      Lmkecomplex(Sex a, Sex q, Sex m);
extern Sex      Lmkbecomplex(Sex a, Sex q, Sex m);
extern Sex      Lmkecomplex(Sex a, Sex q, Sex m);
extern Sex      Lapply2(Sex a, Sex q, Sex m);
extern Sex      Lfuncall2(Sex a, Sex q, Sex m);
extern Sex      Lerrorset(Sex a, Sex q, Sex m);
extern Sex      Llist3(Sex a, Sex q, Sex m);
extern Sex      Lput(Sex a, Sex q, Sex m);
extern Sex      Lputd(Sex a, Sex q, Sex m);
extern Sex      Lputv(Sex a, Sex q, Sex m);
extern Sex      Lmap2(Sex a, Sex q, Sex m);
extern Sex      Lmapc2(Sex a, Sex q, Sex m);
extern Sex      Lmapcar2(Sex a, Sex q, Sex m);
extern Sex      Lmaplist2(Sex a, Sex q, Sex m);
extern Sex      Lmapcan2(Sex a, Sex q, Sex m);
extern Sex      Lmapcon2(Sex a, Sex q, Sex m);
extern Sex      Lmapv2(Sex a, Sex q, Sex m);
extern Sex      Lmkarray3(Sex a, Sex q, Sex m);
extern Sex      Lmkiarray3(Sex a, Sex q, Sex m);
extern Sex      Lmkfarray3(Sex a, Sex q, Sex m);
extern Sex      Lmkdarray3(Sex a, Sex q, Sex m);
extern Sex      Lgetarray2(Sex a, Sex q, Sex m);
extern Sex      Lsetarray1(Sex a, Sex q, Sex m);
extern Sex      Lsubst(Sex a, Sex q, Sex m);
extern Sex      Lsethash(Sex a, Sex q, Sex m);
extern Sex      Lvfprintf(Sex a, Sex q, Sex m);
extern Sex      Lfprintf1(Sex a, Sex q, Sex m);
extern Sex      Lacons(Sex a, Sex q, Sex m);

/*************************************************************/

extern Sex      Lmake_fluid(Sex a);
extern Sex      Lmake_global(Sex a);
extern Sex      Lmake_special(Sex a);
extern Sex      Lmake_unfluid(Sex a);
extern Sex      Lmake_unglobal(Sex a);
extern Sex      Lmake_unspecial(Sex a);

/*************************************************************/
extern Sex      Lillegal_bignum_zero(Sex a);
/*************************************************************/
