/*
 * errors.h             (C) Copyright 1998-2000, 2007 by Fujio Kako, Nara Women's University.
 * Error codes and functions.
 * $Header: /Users/kako/asuka/src/RCS/errors.h,v 2.4 2016/02/02 23:54:45 kako Exp $
 * 
 */


extern Sex      interrupted(Sex p);
extern Sex      error(char *s);
extern Sex      error1(char *s, Sex a);
extern Sex      error2(char *s, Sex a, Sex b);

extern Sex      aerror(char *s);	/* 
					 * Called from C not Lisp 
					 */
extern Sex      aerror0(char *s);
extern Sex      aerror1(char *s, Sex a);
extern Sex      aerror2(char *s, Sex a, Sex b);
extern Sex      aerror3(char *s, Sex a, Sex b, Sex c);

extern Sex      warnings(char *s, Sex a, Sex b);
extern Sex      messages(char *s, Sex a, Sex b);

extern void     fatal_error(char *s);

#define GC_MSG_BITS   0x07
#define BACKTRACE_FLAG 0x08
#define MESSAGES_FLAG 0x10
#define LOAD_MESSAGES_FLAG 0x20
#define LOAD_ECHO_FLAG 0x40

#define verbos_flag (miscflags & GC_MSG_BITS)

#ifdef Android
extern void     asuka_error(char *fmt, char *msg);
extern void     asuka_error2(char *fmt, char *msg, char *s);
extern void     asuka_warning(char *fmt);
extern void     asuka_warning0(char *fmt);
extern void     asuka_warning1(char *fmt, char *s);
extern void     asuka_warning2(char *fmt, char *s, char *t);
extern void     asuka_message(char *fmt, char *s);
#endif
