/*
 * externs.h      (C) Copyright 1998-2001, 2007 by Fujio Kako, Nara Women's University.
 *      $Header: /Users/kako/asuka/src/RCS/externs.h,v 2.50 2018/01/05 02:35:21 kako Exp $
 */






extern Sex     *stackbase;
extern Sex     *stack;
extern Sex     *bindbase;
extern Sex     *bstack;
extern Sex     *stacklimit;
extern Sex     *bindlimit;
extern long     stack_size;
extern long     bind_size;

extern Sex      bytecode_regs[];
extern long     bytecode_nreg;

#define push(x)         *++stack = (x);

#define push2(a,b)      { Sex *_w = stack;         \
                          _w[1] = (a); _w[2] = (b); stack = _w+2;         \
                        }
#define push3(a,b,c)    { Sex *_w = stack;         \
                          _w[1] = (a); _w[2] = (b); _w[3] = (c);          \
                          stack = _w+3; }
#define push4(a,b,c,d)  { Sex *_w = stack;         \
                          _w[1] = (a); _w[2] = (b); _w[3] = (c);          \
                          _w[4] = (d); stack = _w+4; }
#define push5(a,b,c,d,e){ Sex *_w = stack;         \
                          _w[1] = (a); _w[2] = (b); _w[3] = (c);          \
                          _w[4] = (d); _w[5] = (e); stack = _w+5;         \
                        }
#define pop(x)          (x) = *stack--;
#define pop2(a,b)       { Sex *_w = stack-2;     \
                          (a) = _w[2]; (b) = _w[1]; stack = _w;           \
                        }
#define pop3(a,b,c)     { Sex *_w = stack-3;     \
                          (a) = _w[3]; (b) = _w[2]; (c) = _w[1];          \
                          stack = _w; }
#define pop4(a,b,c,d)   { Sex *_w = stack-4;     \
                          (a) = _w[4]; (b) = _w[3]; (c) = _w[2];          \
                          (d) = _w[1]; stack = _w; }
#define pop5(a,b,c,d,e) { Sex *_w = stack-5;     \
                          (a) = _w[5]; (b) = _w[4]; (c) = _w[3];          \
                          (d) = _w[2]; (e) = _w[1]; stack = _w; }
#define popv(n)         stack -= (n);
#define pushv(n)	{int _i; Sex *_w = stack; \
			 for(_i  = 0; _i < (n); _i++) \
			 *++_w = nil; \
			 stack = _w;}

#define pushb(v)	{Sex *_w = bstack;                                \
		         _w[2] = (v);_w[1] = value(v);bstack = _w+2;}
#define popb()		{Sex *_w = bstack - 2; Sex _v;             \
                         _v = _w[2]; value(_v) = _w[1]; bstack = _w;}

#define pushbv(n, u, v)	{ _v = &value(u); _w[n+2] = (u); \
			 _w[n+1] = *_v; *_v = v;}
#define popbv(n)	{ value(_w[n]) = _w[n-1];}

#define GC_USER      0
#define GC_CONS      1
#define GC_FWD       2


extern void     STACKCHECK(void);

#define stackcheck()                                      \
    if (stack >= stacklimit) {   stack_over(); }
#define bstackcheck()                                     \
    if (bstack >= bindlimit) {   bind_over(); }


extern Sex      nil;
extern Sex      env;



extern long     core_size;

extern Cons_Cell *cellpointer;
extern Cons_Cell *celllimit;
extern Cons_Cell *cellbase;
extern long     cell_size;


extern Sex     *fwdlimit;
extern Sex     *fwdpointer;
extern Sex     *fwdbase;
extern long     fwd_size;

extern int      gensym_cnt;
extern int      gensym1_cnt;
extern int      print_precision;
extern int      print_bfloat_precision;
extern int      read_precision;
extern unsigned long miscflags;
extern long     current_modulus;
extern long     current_d_precision;
extern long     current_w_precision;
extern long     current_b_precision;
extern double   current_precision;
extern long     exit_reason;

extern Sex      true;
extern Sex      lambda;
extern Sex      funarg;
extern Sex      undefined_var;

extern Sex      asuka_mode;
extern Sex      plot_device;
extern Sex      plot_devices;
extern Sex      evalhook;
extern Sex      applyhook;
extern Sex      catch_tags;
extern Sex      exit_tag;
extern Sex      exit_val;
extern Sex      current_package;
extern Sex      current_charvec;

extern Sex      sugar_charvec;
extern Sex      asuka_charvec;
extern Sex      current_sugar_package;
extern Sex      current_asuka_package;

extern Sex      uniq_cons_table;
extern Sex      uniq_string_table;
extern long     uniq_cons_size,
                uniq_cons_count;
extern Sex      fake_cons_cell;
extern Sex      gensym_base;
extern char    *boffo;
extern Sex      io_workspace;
extern Sex      io_workspace2;
#ifdef SAVE_WORK_SPACE
extern Sex      work_space;
#endif
extern Sex      supervisor;
extern Sex      standard_input;
extern Sex      lisp_input;
extern Sex      file_input;
extern Sex      standard_output;
extern Sex      lisp_output;
extern Sex      file_output;
extern Sex      standard_errout;
extern Sex      lisp_errout;
extern Sex      fsl_input;
extern Sex      fsl_output;
extern Sex      prompt_message;
extern Sex      lisp_prompt_message;
extern Sex      emsg_star;
extern Sex      current_big_modulus;
extern Sex      star_modulus;
extern Sex      star_bmodulus;
extern Sex      star_var_order;
extern Sex      pi_value;
extern Sex      e_value;
extern Sex      log2_value;
extern Sex      log10_value;
extern Sex      sqrt2_value;
extern Sex      sqrt5_value;
extern Sex      prime_list;

extern Sex      kernel_order;
extern Sex      dipoly_kernel_order;

extern Sex      true_symbol;
extern Sex      false_symbol;
extern Sex      time_out_symbol;
#ifdef ASUKA
extern Sex      asuka_true_symbol;
extern Sex      asuka_false_symbol;
extern Sex      asuka_nil_symbol;
extern Sex      catch_symbol;
extern Sex      throw_symbol;
extern Sex      any_symbol;
extern Sex      switch_symbol;
extern Sex      case_symbol;
#endif

extern Sex      append_symbol;
extern Sex      input_symbol;
extern Sex      output_symbol;
extern Sex      aref_symbol;
extern Sex      bappend_symbol;
extern Sex      binput_symbol;
extern Sex      boutput_symbol;
extern Sex      car_symbol;
extern Sex      cdr_symbol;
extern Sex      caar_symbol;
extern Sex      cadr_symbol;
extern Sex      cdar_symbol;
extern Sex      cddr_symbol;
extern Sex      comma_at_symbol;
extern Sex      comma_symbol;
extern Sex      echo_symbol;
extern Sex      eecho_symbol;
extern Sex      alist_symbol;
extern Sex      eval_symbol;
extern Sex      subr_symbol;
extern Sex      fsubr_symbol;
extern Sex      expr_symbol;
extern Sex      fexpr_symbol;
extern Sex      macro_symbol;
extern Sex      smacro_symbol;
extern Sex      cmacro_symbol;
extern Sex      csmacro_symbol;
extern Sex      code_symbol;
extern Sex      fcode_symbol;
extern Sex      mcode_symbol;
extern Sex      scode_symbol;
extern Sex      nomess_symbol;

extern Sex      function_symbol;
extern Sex      progn_symbol;
extern Sex      prog2_symbol;
extern Sex      quote_symbol;
extern Sex      cons_symbol;
extern Sex      nconc_symbol;
extern Sex      bye_symbol;

extern Sex      raise_symbol;
extern Sex      lower_symbol;
extern Sex      hankaku_symbol;


#ifdef ASUKA
extern Sex      expreope_symbol;
extern Sex      name_symbol;
extern Sex      for_symbol;
extern Sex      foreach_symbol;
extern Sex      if_symbol;
extern Sex      setq_symbol;

extern Sex      itrsyth_symbol;
extern Sex      noncomu_symbol;
extern Sex      omit_symbol;
extern Sex      lesser_equal_symbol;
extern Sex      greater_equal_symbol;
extern Sex      not_equal_symbol;
extern Sex      colon_equal_symbol;
extern Sex      semicolon_semicolon_symbol;
extern Sex      arrowope_symbol;
extern Sex      onbeepre_symbol;

extern Sex      twbeepre_symbol;
extern Sex      thbeepre_symbol;
extern Sex      lambda_symbol;
extern Sex      equal_symbol;
extern Sex      minus_symbol;
extern Sex      list_symbol;
extern Sex      set_symbol;
extern Sex      prog_symbol;
extern Sex      go_symbol;
extern Sex      return_symbol;
extern Sex      reversip_symbol;
extern Sex      defproc_symbol;
extern Sex      not_symbol;
extern Sex      set_diff_symbol;
extern Sex      ge_symbol;
extern Sex      le_symbol;
extern Sex      gt_symbol;
extern Sex      lt_symbol;
extern Sex      add_symbol;
extern Sex      sub_symbol;
extern Sex      times_symbol;

extern Sex      error_symbol;
extern Sex      debug_symbol;
extern Sex      debugn_symbol;
extern Sex      write_symbol;
extern Sex      writen_symbol;
extern Sex      printf_symbol;
extern Sex      read_symbol;
extern Sex      import_symbol;
extern Sex      save_symbol;
extern Sex      load_symbol;
extern Sex      clear_symbol;
extern Sex      algebraic_symbol;

extern Sex      sin_symbol;
extern Sex      cos_symbol;
extern Sex      tan_symbol;
extern Sex      asin_symbol;
extern Sex      acos_symbol;
extern Sex      atan_symbol;
extern Sex      sinh_symbol;
extern Sex      cosh_symbol;
extern Sex      tanh_symbol;
extern Sex      asinh_symbol;
extern Sex      acosh_symbol;
extern Sex      atanh_symbol;
extern Sex      exp_symbol;
extern Sex      log_symbol;
extern Sex      log2_symbol;
extern Sex      log10_symbol;
extern Sex      sqrt_symbol;
extern Sex      cbrt_symbol;

extern Sex      array_symbol;
extern Sex      mkarray1_symbol;
extern Sex      mkarray2_symbol;
extern Sex      mkarray3_symbol;
extern Sex      getarray1_symbol;
extern Sex      getarray2_symbol;
extern Sex      getarray3_symbol;
extern Sex      setarray1_symbol;
extern Sex      setarray2_symbol;
extern Sex      setarray3_symbol;
extern Sex      matrix_symbol;
extern Sex      mkmatrix_symbol;
extern Sex      vector_symbol;
extern Sex      mkvector_symbol;
#endif



extern Sex      proc_frame;
extern Sex      proc_vars;
extern Sex      proc_gvars;
extern Sex      loop_frame;

#define MAX_INPUT_FILES         40	/* 
					 * * * * * * * * limit on *
					 * command-line  * * * * length *
					 *    
					 */
#define MAX_SYMBOLS_TO_DEFINE   40

extern char    *files_to_read[MAX_INPUT_FILES];


extern long     number_of_input_files;


#define Bool_to_Sex(p) ((p) ? true : nil)


extern long     curchar;
extern long     tty_count;
extern long     column;
extern long     line_length;
extern FILE    *spool_file;
extern FILE    *debug_file;


extern long     ttyget(void);

extern void     flush_tty(void);

extern double   get_time(void);
extern double   base_time;
extern double   io_time;
extern double   gc_time;
extern double   trap_time;
extern bool     already_in_gc;
extern bool     interrupt_pending;
extern jmp_buf *errorset_buffer;
extern void     unwind_bind(Sex *);
extern long     print_flag;
extern void     onintr(int code);
extern void     oninti(int code);


extern long     list_length(Sex a);
extern Sex      undefined_proc(Sex a);
extern Sex      ash(Sex a, Sex b);
extern bool     complex_stringp(Sex a);
extern Sex      cons(Sex a, Sex b);
extern Sex      rcons(Sex a, Sex b);
extern Sex      remaind2(Sex a, Sex b);
extern bool     eql(Sex a, Sex b);
extern Sex      equal(Sex a, Sex b);
extern Sex      eval(Sex u, Sex env);
extern Sex      evlis(Sex a, Sex env);
extern Sex      apply(Sex u, Sex args, Sex env);
extern Sex      apply_n(Sex fn, long nargs, Sex env);
extern Sex      apply_lambda(Sex fn, Sex def, long nargs, Sex env);
extern Sex      gcd(Sex a, Sex b);
extern Sex      get(Sex a, Sex b);
extern Sex      getvector(long tag, long type, long length);
extern Sex      getvector_init(long n, Sex v);
extern unsigned long hash_string(char *s, long n);
extern void     init_heap_segments(void);
extern bool     geq2(Sex a, Sex b);
extern bool     greaterp2(Sex a, Sex b);
extern bool     lessp2(Sex a, Sex b);
extern Sex      lognot(Sex a);
extern Sex      mkbigat1(long n);
extern Sex      make_string2(char *b, long n);
extern Sex      make_string(char *b);
extern Sex      make_symbol(char *s);
extern Sex      make_asuka_symbol(char *s);
extern Sex      make_asuka_fluid_symbol(char *s, Sex v);
extern Sex      make_proc_symbol(char *s, zero_args * f1, long nargs);
extern Sex      make_fluid_symbol(char *s, Sex value);
extern void     lisp_printf(char *fmt, ...);
extern Sex      ndelete(Sex a, Sex b);
extern Sex      negate(Sex a);
extern FILE    *open_file(char *filename, char *original_name,
			  size_t n, char *dirn, FILE * old_file);
extern Sex      plus2(Sex a, Sex b);
extern void     preserve(void);
extern Sex      prin(Sex u);
extern void     prin_to_stdout(Sex u);
extern void     prin_to_stderr(Sex u);
extern void     loop_print(Sex o);
typedef void    putchar_fn(long);
typedef int     compare_fn(const void *, const void *);
extern void     print_sex(Sex u, putchar_fn * fn);
extern void     hprint_sex(Sex u, putchar_fn * fn, long level);
extern Sex      princ(Sex u);
extern Sex      print(Sex u);
extern Sex      printc(Sex u);

extern Sex      Lprint_precision(Sex a);

extern void     print_bignum(Sex u, putchar_fn * f);
extern void     print_bighex(Sex u, putchar_fn * f);
extern void     print_efloat(Sex u, putchar_fn * f);
extern void     print_ecomplex(Sex u, putchar_fn * f);
extern void     print_interval(Sex u, putchar_fn * f);
extern void     print_bfloat(Sex u, putchar_fn * f);
extern void     print_befloat(Sex u, putchar_fn * f);
extern void     print_becomplex(Sex u, putchar_fn * f);
extern void     print_binterval(Sex u, putchar_fn * f);
extern void     print_fmodular(Sex u, putchar_fn * f);
extern void     print_uint(unsigned long u, putchar_fn * f);
extern void     print_int(long u, putchar_fn * f);
extern void     print_float(double u, putchar_fn * f);
extern void     print_modular(Sex u, putchar_fn * f);
extern void     print_bmodular(Sex u, putchar_fn * f);
extern void     print_polynomial(Sex u, putchar_fn * f);

typedef struct var_list {
    Sex            *var;
    Sex            *pow;
    struct var_list *next;
} var_list;

extern void     print_poly_aux(Sex u, var_list * v, putchar_fn * fn,
			       long f);
#ifdef ASUKA
extern void     print_const(Sex u, putchar_fn * f);
extern void     print_algnum(Sex u, putchar_fn * f);
extern void     print_variable(Sex u, putchar_fn * f);
extern void     print_dipoly(Sex u, putchar_fn * f);
extern void     print_rpoly(Sex u, putchar_fn * f);
extern void     print_vector(Sex u, putchar_fn * f);
extern void     print_matrix(Sex u, putchar_fn * f);
extern void     print_prefix(Sex u, putchar_fn * f);
#endif
extern void     print_expt10(long n, putchar_fn * f);

extern Sex      quot2(Sex a, Sex b);
extern Sex      rational(Sex a);
extern void     read_eval_print(void);
extern Sex      reclaim(Sex value_to_return, long stg_class, long size);
extern void     set_fn(Sex sym, long nargs, void *fn);
extern void     setup(void);
extern Sex      simplify_string(Sex s);
extern bool     stringp(Sex a);
extern Sex      terpri(void);
extern Sex      times2(Sex a, Sex b);
extern long     thirty_two_bits(Sex a);

/*
 *  setup type
 */


extern zero_args *zero_arg_functions[];
extern one_args *one_arg_functions[];
extern two_args *two_arg_functions[];
extern three_args *three_arg_functions[];

typedef struct setup_type {
    char const     *const name;
    // Sex(*fn) ();
    zero_args      *fn;
    int             nargs;
} setup_type;

extern setup_type const arith_setup[];
extern setup_type const trig_setup[];
extern setup_type const modular_setup[];
extern setup_type const char_setup[];
extern setup_type const eval_setup[];
extern setup_type const fns_setup[];
extern setup_type const fap_setup[];
#ifdef ASUKA
extern setup_type const list_setup[];
#endif
extern setup_type const print_setup[];
extern setup_type const read_setup[];
extern setup_type const hash_setup[];
extern setup_type const plot_setup[];
extern setup_type const mfunc_setup[];
extern setup_type const gfunc_setup[];
extern setup_type const triangular_setup[];
extern setup_type const polynomial_setup[];
extern setup_type const algnum_setup[];
extern setup_type const misc_setup[];
extern setup_type const groebner_setup[];
extern setup_type const gcd_setup[];
extern setup_type const factor_setup[];
extern setup_type const matrix_setup[];


extern void     create_symbols(setup_type const s[]);

/*
 *
 */


extern Sex      Lapply(Sex fn, Sex args);
extern Sex      Lerrorset1(Sex form);
extern Sex      Lerrorset(Sex form, Sex ffg1, Sex ffg2);
extern Sex      Lfuncall0(Sex fn);
extern Sex      Lfuncall1(Sex fn, Sex a1);
extern Sex      Lfuncall2(Sex fn, Sex a1, Sex a2);
extern Sex      Lfuncall3(Sex fn, Sex a1, Sex a2, Sex a3);
extern Sex      Lfuncall4(Sex fn, Sex a1, Sex a2, Sex a3, Sex a4);
extern Sex      Lfuncall5(Sex fn, Sex a1, Sex a2, Sex a3, Sex a4, Sex a5);
extern Sex      Lfuncall(Sex fn, Sex args);
extern Sex      declare_fn(Sex args, Sex env);
extern Sex      function_fn(Sex args, Sex env);
extern Sex      prog_fn_1(Sex bvl, Sex body, Sex env);
extern Sex      progn_fn(Sex args, Sex env);
extern Sex      prog2_fn(Sex args, Sex env);
extern Sex      quote_fn(Sex args, Sex env);
extern Sex      tagbody_fn(Sex args, Sex env);
extern Sex      Lerror0(void);
extern _Noreturn Sex Lerror1(void);
extern _Noreturn Sex Lerror2(Sex msg);
extern _Noreturn Sex Lerror(Sex msg, Sex a);


extern Sex      Lmap(Sex x, Sex fn);
extern Sex      Lmapc(Sex x, Sex fn);
extern Sex      Lmapcar(Sex x, Sex fn);
extern Sex      Lmaplist(Sex x, Sex fn);
extern Sex      Lmapcan(Sex x, Sex fn);
extern Sex      Lmapcon(Sex x, Sex fn);
extern Sex      Lmapv(Sex x, Sex fn);

extern Sex      Lmap2(Sex x, Sex y, Sex fn);
extern Sex      Lmapc2(Sex x, Sex y, Sex fn);
extern Sex      Lmapcar2(Sex x, Sex y, Sex fn);
extern Sex      Lmaplist2(Sex x, Sex y, Sex fn);
extern Sex      Lmapcan2(Sex x, Sex y, Sex fn);
extern Sex      Lmapcon2(Sex x, Sex y, Sex fn);
extern Sex      Lmapv2(Sex x, Sex y, Sex fn);



extern FILE    *open_file(char *filename, char *old, size_t n,
			  char *mode, FILE * old_file);


extern bool     file_exists(char *filename, char *old, size_t n, char *tt);


extern int      batchp(void);


#ifdef MS_DOS
extern long     kbhit(void);
#endif


#ifdef WINDOWS31
extern long     win32s;
#endif

#ifdef WINDOWS_NT
extern long     win32s;
#endif


#ifdef MS_DOS
/*
 * MSDOS specific low-level graphics primitive
 */
extern Sex      Lint10h(Sex, Sex, Sex, Sex);
extern Sex      Lint10hr(Sex, Sex, Sex, Sex);
#endif

extern long     need_trace;
extern long     trace_count;
extern long     trace_flag;
extern long     trace_level;
extern long     compile_flag;


/*
 *    more of function prototypes
 */

extern void     stack_over(void);
extern void     bind_over(void);
extern void     buffer_over(void);


extern Sex      Lputd(Sex a, Sex b, Sex c);
extern Sex      Lfactorial(Sex a);
extern Sex      Momit(Sex a);
extern Sex      Msort1(Sex a);
extern Sex      Msetffn(Sex a, Sex b);
extern Sex      Lstrcat(Sex a, Sex b);

extern Sex      Lputv(Sex v, Sex n, Sex a);
extern Sex      Lgetv(Sex v, Sex n);
extern Sex      Lmkvect(Sex a);
extern Sex      Llistp(Sex a);
extern Sex      Lbye(void);


extern Sex      load_module(Sex a);



extern Sex      gnegatea(Sex a);
extern Sex      recipa(Sex a);

extern Sex      Llink(Sex, long);
extern Sex      interpreter(long, long, Sex);

extern Sex      poly_subst(Sex, Sex, Sex);
extern Sex      dipoly_subst(Sex, Sex, Sex);
extern Sex      rpoly_subst(Sex, Sex, Sex);

extern Sex      Asub(Sex a, Sex x, Sex b);
extern Sex      Areval(Sex a);
extern Sex      Lgen_sharp_symbol(Sex a);
extern Sex      Adiff(Sex a, Sex x);


extern unsigned long umul(unsigned long *, unsigned long, unsigned long);
extern unsigned long udiv(unsigned long *,
			  unsigned long, unsigned long, unsigned long);
extern unsigned long umuladd(unsigned long *,
			     unsigned long, unsigned long, unsigned long);
extern unsigned long umulrem(unsigned long, unsigned long, unsigned long);

extern Sex      gensym2(char *);


extern long     my_main(long argc, char *argv[]);
extern long     orderp(Sex a, Sex b);
extern long     compare_term(Sex a, Sex b);
extern long     compare_dipoly(Sex a, Sex b);
extern long     compare_var(Sex a, Sex b);

extern Sex      Aspoly(Sex a, Sex b);
extern Sex      Apoly_spoly(Sex a, Sex b);
extern Sex      Adipoly_spoly(Sex a, Sex b);
extern Sex      Areduce(Sex a, Sex g);
extern Sex      Amonic(Sex a);
extern Sex      Amonic1(Sex a);
extern Sex      Afull_reduce(Sex a, Sex g);
extern Sex      Areduce1(Sex a, Sex g);
extern Sex      Afull_reduce1(Sex a, Sex g);
extern Sex      Apoly_reduce(Sex a, Sex g);
extern Sex      Apoly_reduce1(Sex a, Sex g);
extern Sex      Adipoly_reduce(Sex a, Sex g);
extern Sex      Adipoly_reduce1(Sex a, Sex g);
extern Sex      Afull_reduce(Sex a, Sex g);
extern Sex      Afull_reduce1(Sex a, Sex g);
extern Sex      Apoly_full_reduce(Sex a, Sex g);
extern Sex      Apoly_full_reduce1(Sex a, Sex g);
extern Sex      Adipoly_full_reduce(Sex a, Sex g);
extern Sex      Adipoly_remainder(Sex a, Sex g);
extern Sex      Adipoly_quotient(Sex a, Sex g);

extern Sex      Alt_reducible(Sex a, Sex g);
extern Sex      Apoly_lt_reducible(Sex a, Sex g);
extern Sex      Adipoly_lt_reducible(Sex a, Sex g);
extern Sex      Alt_divisible(Sex a, Sex g);
extern Sex      Apoly_lt_divisible(Sex a, Sex g);
extern Sex      Adipoly_lt_divisible(Sex a, Sex g);
extern bool     dipoly_is_number(Sex g);

extern Sex      ALT_gcd(Sex a, Sex g);
extern Sex      ALT_lcm(Sex a, Sex g);
extern Sex      Adipoly_LT_gcd(Sex a, Sex g);
extern Sex      Adipoly_LT_lcm(Sex a, Sex g);
extern Sex      Apoly_LT_gcd(Sex a, Sex g);
extern Sex      Apoly_LT_lcm(Sex a, Sex g);

extern Sex      Ahave_nontrivial_gcd(Sex a, Sex g);
extern Sex      Alt_lcm_ordervec(Sex a, Sex g);
extern Sex      Alt_lcm_expvec(Sex a, Sex g);
extern Sex      Apoly_have_nontrivial_gcd(Sex a, Sex g);
extern Sex      Adipoly_have_nontrivial_gcd(Sex a, Sex g);
extern Sex      Adipoly_lt_lcm_ordervec(Sex a, Sex g);
extern Sex      Adipoly_lt_lcm_expvec(Sex a, Sex g);

extern Sex      Areduce_set(Sex a);
extern Sex      Apoly_reduce_set(Sex a);
extern Sex      Adipoly_reduce_set(Sex a);

extern Sex      Aexpvec_lcm(Sex a, Sex b);
extern Sex      Aexpvec_gcd(Sex a, Sex b);
extern Sex      Aexpvec_div(Sex a, Sex b);

extern Sex      Ahomogenize(Sex a, Sex x);

extern Sex      Aexpvec(Sex a);
extern Sex      Aexpvec2(Sex a, Sex v);

extern Sex      Lbmodular(Sex a, Sex b);

extern Sex      all_variables(Sex a);

extern Sex      new_prefix(void);
extern Sex      simplify_prefix(Sex a);

extern long     my_random(long p);
