
debug:=false;
f5c_r:={};
f5c_Rule:={};

proc F5(F);
begin local Gp, Gc, B;
	local i, j, m, f;
	global f5c_r, f5c_Rule;

	if check_dipoly_list(F) = false then
        	write "not dipoly list", F;
        	return false;
	fi;

write "f5a: f=", F;
	F:=sort_by_tdeg_and_order(F);
write "f5b: f=", F;
	m:=length(F);

	f5c_Rule := {{}};

	f:=car(F);
	f := f/HC(f);
	F:=rest(F);
	f:={1, 1, f};
	f5c_r:=append(f5c_r, {f});
	Gp:={1};
	B:={f};

	for i:=2 to m do
		f:=car(F);
		f:=f/HC(f);
		F:=cdr(F);
		f:={1, i, f};
		f5c_r:=append(f5c_r, {f});
		Gc := F5_incremental(i, B, Gp);
		Gp := Gc;
		B:={};
		foreach j in Gp do
			f:=Poly(j);
			if f = 1 then return {1};
			fi;
			B:=append(B, {f});
		od;
	od;
	return B;
end;

proc Poly(i);
begin  local f;
	global f5c_r;
	if f5c_r = nil then return nil;
	fi;
	f:=nth(f5c_r, i);
	return third(f);
end;
	

proc F5_incremental(i, B, Gp);
begin local id, d;
	local P, Pd, S, R, Gc;
	local k, d1, H, p, f, j;
	global f5c_r, f5c_Rule;

	id:=length(f5c_r);
	Gc := append(Gp, {id});
	f5c_Rule := append(f5c_Rule, {{}});
	P:={};
	foreach j in Gp do
		f:=Critical_Pair(id, j, i, Gp);
		if f <> nil then
			P:=append(P, {f});
		fi;
	od;

write "F5_inc: P=", P;

	while P <> {} do
		p:=car(P);
		d:=tdeg(first(p));
		H:=cdr(P);
		foreach p in H do
			d1:=tdeg(first(p));
			if d1 < d then d:=d1; fi;
		od;

		Pd:={};
		foreach p in P do
			d1:=tdeg(first(p));
			if d1 = d then
				Pd:=append(Pd, {p});
			fi;
		od;
		P :=setdiff(P, Pd);
		S:=Compute_Spols(Pd);
		R:=Reduction(S, B, Gp, Gc);
		foreach k in R do
			foreach j in Gc do
				j:=Critical_Pair(k, j, i, Gp);
				if j <> nil then
					P:=append(P, {j});
				fi;
			od;
			Gc:=append(Gc, {k});
		od;
	od;
	return Gc;
end;

proc Critical_Pair(k, l, i, Gp);
begin local tk, tl, t, u1, u2;
	local rk, rl;
	local f, n1, n2, t1, t2;
	global f5c_r;

	rk:=nth(f5c_r, k);
	rl:=nth(f5c_r, l);
	tk:=HM(third(rk));
	tl:=HM(third(rl));
	t:=lcm(tk, tl);
	u1:=t/tk;
	u2:=t/tl;
	t1:=car(rk);
	t2:=car(rl);
	n1:=cadr(rk);
	n2:=cadr(rl);
	if n1 = i and top_reducible(u1*t1, Gp) then return {};
	fi;
	if n2 = i and top_reducible(u2*t2, Gp) then return {};
	fi;
	if n1 < n2 or (n1 = n2 and orderp(u1*t1 , u2*t2)) then
		f:={t, l, u2, k, u1};
	else
		f:={t, k, u1, l, u2};
	fi;
	return f;
end;

proc Compute_Spols(P);
begin
	local S, p;
	local u, v, k, l, t;
	local i, s;
	global f5c_r;

	P:=sort_by_degree(P);
	S:={};
	foreach p in P do
		t:=car(p); p:=cdr(p);
		k:=car(p); p:=cdr(p);
		u:=car(p); p:=cdr(p);
		l:=car(p); p:=cdr(p);
		v:=car(p); 
		if not Is_Rewritable(u, k) and not Is_Rewritable(v, l) then
			s:=Spol(Poly(k), Poly(l));
		   if not(s=0) then
			t:=nth(f5c_r, k);
			p:={u*car(t), cadr(t), s};
			f5c_r:=append(f5c_r, {p});
			i:=length(f5c_r);
			Add_Rule(u*car(t), cadr(t), i);
			S:=append(S, {i});
		   fi;
		fi;
	od;
	S:=sort_by_signature(S);
	return S;
end;


proc Spol(ri, rj);
begin
	local s, v, ti, tj;
	ti:=HT(ri);
	tj:=HT(rj);
	v := lcm(ti, tj);
	ti:=v/ti;
	tj:=v/tj;
	s:=ri*ti - rj*tj;
	return s;
end;
	

proc Reduction(S, B, Gp, Gc);
begin
	local to_do, completed;
	local rk, h, k;
	global f5c_r;

	to_do:=sort_by_signature(S);
	completed:={};
	while to_do <> {} do
		k:=car(to_do);
		to_do:=rest(to_do);
		h:=Normal_Form(Poly(k), B);
		rk:=nth(f5c_r, k);
		rk:={car(rk), cadr(rk), h};
		h:=Top_Reduction(k, Gp, union(Gc, completed));
		completed := union(completed, car(h));
		h:=sort_by_signature(cadr(h));
		to_do := merge_by_signature(to_do, h);
	od;
	return completed;
end;

proc Normal_Form(f, F);
begin 
	local g, r;
write "NF: ", f, " with ", F;
	/*g:=foreach r in F collect third(r);*/
	return reduce(f, F);
end;


proc Top_Reduction(k, Gp, Gc);
begin
	local i, j, c, u, q;
	local rk, J, p;
	global f5c_r;

	p:=Poly(k);
	if p=0 then
		write "Reduction to zero!";
		return {{}, {}};
	fi;
	J:=Find_Reductor(k, Gp, Gc);
	if J = {} then
		rk := nth(f5c_r, k);
		rk:= {car(rk), cadr(rk), p/HC(p)};
		return {{k}, {}};
	fi;

	j:=car(J);
	q:=Poly(j);
	u:=HM(p)/HM(q);
	c:=HC(p) /HC(q);
	p:=p-c*u*q;
	if p <> 0 then
		p:=p/HC(p);
	fi;
	if compare_signature2(u, j, k) then
		rk:=nth(f5c_r, k);
		rk:={car(rk), cadr(rk), p};
		return {{}, {p}};
	else
		rk:=nth(f5c_r, j);
		rk:={u*car(rk), cadr(rk), p};
		f5c_r:=append(f5c_r, {rk});
		i:=length(f5c_r);
		Add_Rule(u*car(rk), cadr(rk), i);
		return {{}, {k, i}};
	fi;
end;

proc compare_signature2(u, j, k);
begin
	local rj, rk;
	local ij, ik, uj, uk;
	global f5c_r;

	rj:=nth(f5c_r, j);
	rk:=nth(f5c_r, k);
	ij:=cadr(rj); ik:=cadr(rk);
	uj:=u*car(rj); uk:=cadr(rk);
	if ij < ik then return true;
	elif ij = ik and orderp(uj, uk) then return true;
	else return false;
	fi;
end;

proc Find_Reductor(k, Gp, Gc);
begin
	local t, u;
	local nj, tj, rj;
	local nk, tk, rk;
	local tp, j;
	global f5c_r;

	t:=HM(Poly(k));
	rk:=nth(f5c_r, k);
	tk:=car(rk);
	nk:=cadr(rk);
	foreach j in Gc do
		tp:=HM(Poly(j));
		if term_div(tp, t) then
			u:=t/tp;
			rj:=nth(f5c_r, j);
			tj:=car(rj);
			nj:=cadr(rj);
			if nj <> nk or tk <> u*tj  and
				not Is_Rewritable(u,j)  and
				not top_reducible(u*tj, Gp) then
				return {j};
			fi;
		fi;
	od;
	return {};
end;

proc term_div(f, g);
begin local a;
	a:=f/g;
	if is_number(a) or is_poly(a) then return dipoly(a);
	elif is_dipoly(a) then return a;
	else return false;
	fi;
end;


proc Add_Rule(t, n, k);
begin
	local rk;
	global f5c_Rule;

	rk:=nth(f5c_Rule, n);
	rk:=append(rk, {{t, k}});
	replace(f5c_Rule, rk, n);
end;

proc Is_Rewritable(u, k);
begin
	local j;

	j:=Find_Rewriting(u,k);
	if j=k then return false;
	else return true;
	fi;
end;


proc Find_Rewriting(u, k);
begin
	local j, n, p, ctr;
	local nj, tj, nk, tk, rk;
	global f5c_r, f5c_Rule;

	rk:=nth(f5c_r, k);
	tk:=car(rk);
	nk:=cadr(rk);
	ctr:=length(nth(f5c_Rule, nk));
	while ctr > 0 do
		p:=nth(f5c_Rule,nk);
		p:=nth(p, ctr);
		tj:=car(p);
		nj:=cadr(p);
		if term_div(tj, u*tk) then
			return j;
		fi;
		ctr:=ctr-1;
	od;
	return k;
end;

f:={y*z^3-x^2*t^2, x*z^2-y^2*t, x^2*y-z^2*t};
setorder revlex x,y,z,t;
g:=dipoly(f);



proc check_dipoly_list(F);
begin
        local o, f, l;
	global debug;

        if not is_list(F) then
                if debug then error("not list", F);fi;
                return false;
        fi;
        f:=car(F);
        l:=cdr(F);
        if not is_dipoly(f) then
                if debug then error("not dipoly", f);fi;
                return false;
        fi;
        o:=dipoly_order(f);
        if o <> getdipolyorder() then
                if debug then error("order mismatch", o);fi;
                return false;
        fi;
        foreach f in l do
                if not is_dipoly(f) then
                        if debug then error("not dipoly", f);fi;
                        return false;
                fi;
                if o <> dipoly_order(f) then
                        if debug then error("order mismatch", f);fi;
                        return false;
                fi;
        od;
        return true;
end;

proc merge_by_degree(u, v);
begin
	local P;
	movd('merge_sort_compare_function', 'compare_by_degree');
	P:=merge_sort(u, v);
	return P;
end;

proc merge_by_signature(u, v);
begin
	local P;
	movd('merge_sort_compare_function', 'compare_by_signature');
	P:=merge_sort(u, v);
	return P;
end;

proc merge_sort(u, v);
begin local a, b, w;
	w := {};
	while u <> {} and v <> {} do
		a := first(u);
		b := first(v);
		if merge_sort_compare_function(a, b) then
			w:=cons(a, w);
			u:=rest(u);
			continue;
		else
			w:=cons(b, w);
			v:=rest(v);
			continue;
		fi;
	od;
	w:=reversip(w);
	w:=append(w, u);
	w:=append(w, v);
	return w;
end;
		
proc sort_by_signature(u);
begin
	local a, i, n, s;
write "sort by sig: u=", u;
	movd('quick_sort_compare_function', 'compare_by_signature');
	n := length(u);
	if n <= 1 then return u; fi;
	array a[n];
	list2array(a, u);
	quick_sort(a, 0, n-1);
	s:=nil;
	for i:=n-1 downto 0 do
		s:=cons(a[i], s);
	od;
write "sort by sig: s=", s;
	return s;
end;

proc sort_by_tdeg_and_order(u);
begin
	local a, i, n, s;
	movd('quick_sort_compare_function', 'compare_by_tdeg_and_order');
	n := length(u);
	if n <= 1 then return u;
	fi;
	array a[n];
	list2array(a, u);
	quick_sort(a, 0, n-1);
	s:=nil;
	for i:=n-1 downto 0 do
		s:=cons(a[i], s);
	od;
	return s;
end;

proc sort_by_degree(u);
begin
	local a, i, n, s;
	movd('quick_sort_compare_function', 'compare_by_degree');
	n := length(u);
	if n <= 1 then return u;
	fi;
	array a[n];
	list2array(a, u);
	quick_sort(a, 0, n-1);
	s:=nil;
	for i:=n-1 downto 0 do
		s:=cons(a[i], s);
	od;
	return s;
end;

/*
proc quick_sort(a, l, r);
begin local ls, rs; 
	local pivot;
	local ll;


	rs:=r;
	ls:=l;
	pivot := a[l];

	while l < r do
		while quick_sort_compare_function(pivot, a[r]) and l < r do
			r := r - 1;
		od;
		if r <>  l then
			a[l] := a[r];
			l := l + 1;
		fi;
		while quick_sort_compare_function(a[l], pivot) and l < r do
			l := l + 1;
		od;
		if l <> r then
			a[r] := a[l];
			r := r - 1;
		fi;
	od;
	a[l] := pivot;
	ll:=l;
	l := ls;
	r:=rs;
	if l < ll then
		quick_sort(a, l, ll-1);
	fi;
	if r > ll then
		quick_sort(a, ll+1, r);
	fi;
	return a;
end;
*/

proc quick_sort(a, l, s);
begin local i, j, pivot, t;
	local m;
	i := l;
	j := s;
	m:=quotient(i+j, 2);
	pivot:=a[m];
	while i <= j do
		while quick_sort_compare_function(a[i], pivot) do
			i:=i+1;
		od;
		while quick_sort_compare_function(pivot, a[j]) do
			j:=j-1;
		od;
		if i <= j then
			t:=a[i];
			a[i]:=a[j];
			a[j]:=t;
			i:=i+1;
			j:=j-1;
		fi;
	od;
	if l < j then
		quick_sort(a, l, j);
	fi;
	if i < s then
		quick_sort(a, i, s);
	fi;
	return a;
end;


proc compare_by_tdeg_and_order(u, v);
begin
	local s;
	s := compare_by_tdeg_and_order2(u, v);
	write u, " <  ", v, " --> ", s;
	return s;
end;

proc compare_by_tdeg_and_order2(u, v);
begin 
/*write "compare ", u, " and ", v;*/
	if tdeg(u) < tdeg(v) then
		return true;
	elif tdeg(u) = tdeg(v) then
		return not orderp(u, v);
	fi;
	return nil;
end;

proc compare_by_degree(u, v);
begin 
/*write "compare ", u, " and ", v;*/
	if tdeg(car(u)) < tdeg(car(v)) then
		return true;
	fi;
	return nil;
end;

proc compare_by_signature(u, v);
begin 
	local ui, vi;
	global f5c_r;
	u:=nth(f5c_r, u);
	v:=nth(f5c_r, v);
	ui:=second(u); vi:=second(v);
	if ui > vi then return true;
	elif ui < vi then return false;
	fi;
	if compare(first(u), first(v)) < 0 then
		return true;
	fi;
	return false;
end;

proc compare_signature(u, v);
	/* 1: u > v 
          -1: u < v
           0: u = v
         */
begin
	local ut, vt, ui, vi;
	ut:=first(u); ui:=second(u);
	vt:=first(v); vi := second(v);
	if ui < vi then return 1;
	elif ui > vi then return -1;
	else return compare(ut, vt);
	fi;
end;

proc minimal_by_signature(u);
begin local v, w;
/*write "minimal_by_signature: u=", u;*/
	if u = {} then return u;
	fi;
	v:=first(u);
	u:=rest(u);
	foreach w in u do
		if compare_signature(v, w) = 1 then v:=w;
		fi;
	od;
/*write "minimal_by_signature: return ", v;*/
	return v;
end;

proc HM(f);
begin
        return mlterm(f);
end;

proc HT(f);
begin
        return mpower(f);
end;

proc HC(f);
begin
        return mlcoeff(f);
end;

proc top_reducible(t, G);
begin local g, f, s;
        s := false;
        foreach g in G  do
		g := Poly(g);
		if g <> nil then
                	f:=ht_div(t, g);
                	if f <> false then s:=true; break;
                	fi;
		fi;
        od;
        return s;
end;

proc ht_div(f, g);
begin
        local h;
        h := mlterm(f)/mlterm(g);
        if is_number(h) or is_poly(h) then
                return dipoly(h);
        elif is_dipoly(h) then
                return h;
        fi;
        return false;
end;

