/*
 *    $Header: /Users/kako/asuka/src/RCS/fap.c,v 2.17 2016/03/10 02:40:55 kako Exp $
 *
 *    $Log: fap.c,v $
 *    Revision 2.17  2016/03/10 02:40:55  kako
 *    *** empty log message ***
 *
 *    Revision 2.16  2016/03/09 03:44:28  kako
 *    *** empty log message ***
 *
 *    Revision 2.14  2015/04/23 04:04:47  kako
 *    *** empty log message ***
 *
 *    Revision 2.13  2015/03/02 08:19:04  kako
 *    *** empty log message ***
 *
 *    Revision 2.12  2015/02/05 02:58:19  kako
 *    *** empty log message ***
 *
 *    Revision 2.12  2015/02/04 15:29:11  kako
 *    *** empty log message ***
 *
 *    Revision 2.11  2014/12/25 10:51:37  kako
 *    *** empty log message ***
 *
 *    Revision 2.11  2014/12/24 07:18:10  kako
 *    *** empty log message ***
 *
 *    Revision 2.10  2014/10/29 05:42:38  kako
 *    *** empty log message ***
 *
 *    Revision 2.9  2014/10/27 02:28:08  kako
 *    *** empty log message ***
 *
 *    Revision 2.11  2014/10/25 11:43:59  kako
 *    *** empty log message ***
 *
 *    Revision 2.10  2014/10/25 11:21:19  kako
 *    *** empty log message ***
 *
 *    Revision 2.9  2014/10/25 11:13:45  kako
 *    *** empty log message ***
 *
 *    Revision 2.8  2014/10/14 04:29:30  kako
 *    *** empty log message ***
 *
 *    Revision 2.7  2014/10/09 09:39:51  kako
 *    *** empty log message ***
 *
 *    Revision 2.5  2014/10/08 00:16:33  kako
 *    *** empty log message ***
 *
 *    Revision 2.4  2014/09/08 09:35:02  kako
 *    *** empty log message ***
 *
 *    Revision 2.3  2013/04/23 13:41:00  kako
 *    *** empty log message ***
 *
 *    Revision 2.2  2013/04/04 23:48:49  kako
 *    *** empty log message ***
 *
 *    Revision 2.1  2012/10/21 13:32:48  kako
 *    *** empty log message ***
 *
 *    Revision 1.14  2011/12/08 11:52:51  kako
 *    *** empty log message ***
 *
 *    Revision 1.13  2011/12/05 00:34:14  kako
 *    *** empty log message ***
 *
 */


static char const rcsid[] =
    "$Id: fap.c,v 2.17 2016/03/10 02:40:55 kako Exp $";


#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "mathop.h"
#include "code.h"
#include "read.h"
#include "fap.h"
#include "fns.h"
#include "entries.h"
#ifdef USE_ZLIB
#include <zlib.h>
#endif



/******************************************************************/
/******************************************************************/
/******************************************************************/

SFILE           fslnull = { NULL, NULL, 0, 0, 0 };
SFILE           fslfdi = { NULL, NULL, 0, 0, 0 };
// myFILE fslfdi = {NULL, NULL, NULL, 0};
// FILE *fslfdi = NULL;
FILE           *fslfdo = NULL;

long            fsl_getc(void);
void            fsl_putc(long c);


/*******************************************************************
 *	&bporg and &bpend
 *				85-8-19
 *******************************************************************/
Sex
Lanpbporg(void)
{
    return mkfxat(bpsorg);
}

Sex
Lanpbpend(void)
{
    return mkfxat(bpsend);
}

Sex
Lbpsleft(void)
{
    return mkfxat(bpsend - bpsorg);
}

Sex
Lbpsmove(Sex a)
{
    long            n;
    Code           *p;

    if (!is_fixnum(a))
	error1("bpsmove -- bad arg", a);

    n = bpsend + mkint(a);
    p = (Code *) realloc(bytecode, sizeof(Code) * n);

    if (p == NULL)
	fatal_error("no more free space for bytecode");
    bytecode = p;
    return mkfxat(n);
}



Sex
Llogx(Sex a)
{
    return mklogical((long) a);
}

/*******************************************************************
 *	uncall		make fastcall to slowlink
 *******************************************************************/

Sex
Lrelink(Sex a, Sex b)
{
    return nil;
}

Sex
Lfastlink(void)
{
    return nil;
}

/*******************************************************************
 *******************************************************************
 *	fap and fisl support routines
 *			85-8-8		fujio kako
 *******************************************************************
 *******************************************************************
 *	file open & close for fap
 *	fslropen(file_name)		subr
 *	fslwopen(file_name)
 *******************************************************************/

#if defined(REDUCE) && defined(INCLUDE_BYTECODE_PACKAGES)

#ifdef _LP64
#define USE_FAPLIB64
#include "faplib.h"
#else
#define USE_FAPLIB32
#include "faplib.h"
#endif

bcode_package  *
search_bcode_package(Sex name)
{
    bcode_package  *p = b_pack;
    char           *fname;
    long            len;

    if (is_symbol(name)) {
	fname = pname(name);
	len = symbol_length(name);
    } else if (is_string(name)) {
	fname = &string_value(name, 0);
	len = string_length(name);
    } else
	return NULL;
    while (p->pkg_name != NULL) {
	if (strncmp(p->pkg_name, fname, len) == 0) {
	    return p;
	}
	p++;
    }
    return NULL;
}

Sex
Lfslropen_string(Sex file)
{
    bcode_package  *b;
    Sex             a;
    SFILE           f;
    long            n;
#ifdef USE_ZLIB
    unsigned long   len;
    unsigned char  *buf;
    int             r;
#endif

    if (file == nil)
	return nil;
    b = search_bcode_package(file);
#ifdef USE_ZLIB
    if (b == NULL || b->src_size <= 0) {
	// lisp_printf("fslropen_string: search failed %p\n", file);
	return nil;
    }
    // lisp_printf("fslropen_string file %p\n", file);
    len = b->src_size;
    buf = (unsigned char *) malloc(len);
    r = uncompress(buf, &len, b->data, b->dst_size);
    switch (r) {
    case Z_OK:
	break;
    case Z_MEM_ERROR:
	error("uncompress: there was not enough memory");
	break;
    case Z_BUF_ERROR:
	error("uncompress: there was not enough space");
	break;
    case Z_DATA_ERROR:
	error("uncompress: input data was corrupted or incomplete");
	break;
    }
    a = make_string_handle(buf, len, 1);
#else
    if (b == NULL || b->size <= 0)
	return nil;
    // lisp_printf("fslropen_string file %p\n", file);
    a = make_string_handle(b->data, b->size, 0);
#endif

    f = fslfdi;
    fslfdi.fp = NULL;
    fslfdi.type = 1;
    fslfdi.data = b->data;
#ifdef USE_ZLIB
    fslfdi.size = b->src_size;
#else
    fslfdi.size = b->size;
#endif
    fslfdi.pos = 0;
    n = chr4();
    if (n != 0x4641534c) {
	Lclose(a);
	fslfdi = f;
	return nil;
    }
    if (fsl_input != nil) {
	file_SFILE(car(fsl_input)) = f;
    }
    fsl_input = cons(a, fsl_input);
    return car(fsl_input);

    // lisp_printf(" returns %p\n", nil);
}

#else

Sex
Lfslropen_string(Sex file)
{
    return nil;
}

#endif

Sex
Lfslropen(Sex file)
{
    Sex             a;
    long            n;
    // myFILE f;
    SFILE           f;
    // lisp_printf("fslropen file %p\n", file);

    if (file == nil)
	return nil;
    a = Lopen_file(file, input_symbol);
    if (a == nil)
	return nil;
    f = fslfdi;
    fslfdi = fslnull;
    fslfdi.type = 2;
    fslfdi.fp = file_FILE(a);
    n = chr4();
    if (n != 0x4641534c) {
	Lclose(a);
	fslfdi = f;
	return nil;
    }
    if (fsl_input != nil) {
	file_SFILE(car(fsl_input)) = f;
    }
    fsl_input = cons(a, fsl_input);
    return car(fsl_input);
}

Sex
Lfslrclose(void)
{
    Sex             a;
    SFILE          *sf;

    if (fsl_input != nil) {
	Lclose(car(fsl_input));
	fsl_input = cdr(fsl_input);
    }
    if (fsl_input != nil) {
	a = car(fsl_input);
	fslfdi = file_SFILE(a);
    } else {
	fslfdi = fslnull;
    }
    return nil;
}



Sex
Lfslwopen(Sex file)
{
    Sex             a;
    if (fsl_output != nil) {
	Lclose(fsl_output);
	fsl_output = nil;
    }
    if (file == nil)
	return nil;
    a = Lopen_file(file, output_symbol);
    if (a == nil)
	return nil;
    fsl_output = a;
    fslfdo = file_FILE(a);
    return a;
}

Sex
Lfslwclose(void)
{
    if (fsl_output != nil) {
	Lclose(fsl_output);
	fsl_output = nil;
    }
    fslfdo = NULL;
    return nil;
}


/*******************************************************************
 *	fap/fisl input and output routines
 *	buft(tg,st)
 *	buf1(n)
 *	buf2(n)
 *	buf4(n)
 *	chrt()		read tg and st
 *	chr1()		1 byte
 *	chr2()
 *	chr4()
 *	chrbg(st)	read atom
 *******************************************************************/
Sex
Lbuft(Sex tg, Sex st)
{
    long            n;
    n = (mkint(tg) << 4 | mkint(st));
    fsl_putc(n);
    return nil;
}

Sex
Lbuf1(Sex a)
{
    long            n = mkint(a);
    fsl_putc(n);
    return nil;
}

Sex
Lbuf2(Sex a)
{
    long            n;
    n = mkint(a);
    fsl_putc(n >> 8);
    fsl_putc(n);
    return nil;
}

Sex
Lbuf4(Sex a)
{
    long            n;
    if (is_fixnum(a))
	n = mkint(a);
    else if (is_bigint(a))
	n = bignum_value(a)[0];
    else if (is_logical(a))
	n = logical_value(a)[0];
    else
	n = 0;
    fsl_putc(n >> 24);
    fsl_putc(n >> 16);
    fsl_putc(n >> 8);
    fsl_putc(n);
    return nil;
}

Sex
Lbuf4a(Sex a)
{
    return Lbuf4(a);
}

/*
 */

void
buft(long tg, long st)
{
    fsl_putc(tg << 4 | st);
}

void
buf1(long n)
{
    fsl_putc(n);
}

void
buf2(long n)
{
    fsl_putc(n >> 8);
    fsl_putc(n);
}


void
buf4(long n)
{
    fsl_putc(n >> 24);
    fsl_putc(n >> 16);
    fsl_putc(n >> 8);
    fsl_putc(n);
}

/*
 * put out id or big number 
 */

Sex
Lbufid(Sex a)
{
    long            size;
    char           *p;
    long            i,
                    k;

    if (is_symbol(a)) {
	size = symbol_length(a);
	p = (char *) &pname(a);
    } else if (is_fixnum(a)) {
	k = mkint(a);
	p = (char *) &k;
	size = sizeof(i);
    } else if (is_logical(a)) {
	size = logical_length(a) - HDR;
	p = (char *) &logical_value(a);
    } else if (is_bigint(a)) {
	size = bignum_length(a) - HDR;
	p = (char *) &bignum_value(a);
    } else if (is_float(a)) {
	size = 8;
	p = (char *) &float_val(a);
    } else if (is_string(a)) {
	size = string_length(a);
	p = (char *) &string_value(a, 0);
    }
    if (size > 0 && size <= 255)
	fsl_putc(size);
    else {
	fsl_putc(0);
	fsl_putc(size >> 8);
	fsl_putc(size);
    }
    for (i = 0; i < size; i++)
	fsl_putc(*p++);
    return nil;
}

/*******************************************************************/
/*******************************************************************/
Sex
Lchrt(void)
{
    long            n;
    Sex             s;

    n = fsl_getc();
    // lisp_printf("chrt: tg = %02x\n", n);
    return cons(mkfxat(n >> 4), mkfxat(n & 15));
}

Sex
Lchr1(void)
{
    return mkfxat(fsl_getc());
}

Sex
Lchr2(void)
{
    long            n;
    n = fsl_getc() << 8 | fsl_getc();
    return mkfxat(n);
}

Sex
Lchr4(void)
{
    long            n;
    n = fsl_getc();
    n = (n << 8) | fsl_getc();
    n = (n << 8) | fsl_getc();
    n = (n << 8) | fsl_getc();
    if (n >= fix_min && n <= fix_max)
	return mkfxat(n);
    return mkbigat1s(1, n);
}


/*******************************************************************/
Sex
chrt(void)
{
    long            n;
    Sex             s;

    n = fsl_getc();
    s = cons(mkfxat(n << 4), mkfxat(n & 15));
    return s;
}

/*******************************************************************
 *	chrbg(mode)		subr
 *		read atom
 *	mode = 0	id
 *		1	fix num
 *		2	logical num.
 *		3	float num.
 *		4	positive big. num.
 *		5	negative big. num.
 *		6	string
 *******************************************************************/

Sex
chrid(long mode)
{				/* atom */
    long            size;
    switch (mode) {
    case 0:			/* id */
    case 1:			/* fixnum */
    case 2:			/* string */
	break;
    }
    return nil;
}

Sex
Lchrbg(Sex a)
{				/* read number */
    long            size;
    Sex             s;
    char           *p;
    long            i,
                    k;
    int             k1,
                    k2;
    long            mode;

    mode = mkint(a);
    // if (mode == 1)
    // return Lchr4();

    size = fsl_getc();
    if (size == 0)
	size = (fsl_getc() << 8) | fsl_getc();

    switch (mode) {
    case 0:			/* symbol */
	s = getvector(TAG_BINARY, T_STRING, HDR + size);
	p = (char *) &string_value(s, 0);
	for (i = 0; i < size; i++)
	    *p++ = fsl_getc();
	return Lintern(s);
    case 1:
#ifdef _LP64
	if (size == 8) {
	    p = (char *) &k;
	    for (i = 0; i < size; i++)
		*p++ = fsl_getc();
	    return mkfxat(k);
	} else if (size == 4) {
	    p = (char *) &k2;
	    for (i = 0; i < size; i++)
		*p++ = fsl_getc();
	    k = k2;
	    return mkfxat(k);
	} else {
	    error1("chrbg: invalid fix size", mkfxat(size));
	    return mkfxat(0);
	}
#else
	if (size == 4) {
	    p = (char *) &k;
	    for (i = 0; i < size; i++)
		*p++ = fsl_getc();
	    return mkfxat(k);
	} else if (size == 8) {
	    p = (char *) &k;
	    for (i = 0; i < 4; i++)
		*p++ = fsl_getc();
	    p = (char *) &k2;
	    for (i = 0; i < 4; i++)
		*p++ = fsl_getc();
	    if (k2 < 0) {
		k2 = ~k2;
		k = ~k;
		k1 = k + 1;
		if (k < 0 && k1 > 0)
		    k2 = k2 + 1;
		if (k2 == 0) {
		    if (k1 <= fix_max + 1)
			return mkfxat(-k1);
		    s = getvector(TAG_NUMBERS, T_BIGNEG, bnum_len(1));
		    bignum_value(s)[0] = k1;
		    return s;

		}
		s = getvector(TAG_NUMBERS, T_BIGNEG, bnum_len(2));
		bignum_value(s)[0] = k1;
		bignum_value(s)[1] = k2;
		return s;
	    } else {
		if (k2 == 0) {
		    k1 = k;
		    if (k1 <= fix_max)
			return mkfxat(k1);
		    s = getvector(TAG_NUMBERS, T_BIGNUM, bnum_len(1));
		    bignum_value(s)[0] = k1;
		    return s;
		}
		s = getvector(TAG_NUMBERS, T_BIGNUM, bnum_len(2));
		bignum_value(s)[0] = k;
		bignum_value(s)[1] = k2;
		return s;
	    }
	} else {
	    error1("chrbg: invalid fix size", mkfxat(size));
	    return mkfxat(0);
	}
#endif
    case 2:			/* logical */
	s = getvector(TAG_NUMBERS, T_LOGICAL, size + HDR);
	p = (char *) &logical_value(s);
	break;
    case 3:			/* float */
	s = new_float();
	p = (char *) &float_val(s);
	size = 8;
	for (i = 0; i < size; i++)
	    *p++ = fsl_getc();
	return s;
    case 4:			/* bignum */
	s = getvector(TAG_NUMBERS, T_BIGNUM, size + HDR);
	p = (char *) &bignum_value(s);
	break;
    case 5:			/* bignegative */
	s = getvector(TAG_NUMBERS, T_BIGNEG, size + HDR);
	p = (char *) &bignum_value(s);
	break;
    case 6:			/* string */
	s = getvector(TAG_BINARY, T_STRING, HDR + size);
	p = (char *) &string_value(s, 0);
	for (i = 0; i < size; i++)
	    *p++ = fsl_getc();
	return s;
    default:
	error1("chrbg: number type not implemented", mkfxat(mode));
	break;
    }
#ifdef _LP64
    if (size % 4 != 0) {
	error1("chrbg: invalid size", mkfxat(size));
    } else if (size % 8 != 0) {
	bignum_value(s)[size / 8] = 0;
	for (i = 0; i < size; i++)
	    *p++ = fsl_getc();
    } else {
	for (i = 0; i < size; i++)
	    *p++ = fsl_getc();
    }
#else
    if (size % 4 != 0) {
	error1("chrbg: invalid size", mkfxat(size));
    } else if (size % 8 != 0) {
	for (i = 0; i < size; i++)
	    *p++ = fsl_getc();
    } else {
	for (i = 0; i < size; i++)
	    *p++ = fsl_getc();
	if (bignum_value(s)[size / 4 - 1] == 0)
	    bignum_length(s) = bignum_length(s) - 4;
    }
#endif
    return s;
}

Sex
chrgal(long mode)
{

    long            type;
    long            size;

    switch (mode) {
    case N_VAR:
	type = T_VAR;
	break;
    case N_ALGNUM:
	type = T_ALGNUM;
	break;
    case N_TRNNUM:
	type = T_TRNNUM;
	break;
    case N_POLY:
	type = T_POLY;
	break;
    case N_DIPOLY:
	type = T_DIPOLY;
	break;
    case N_ALGFUN:
	type = T_ALGFUN;
	break;
    case N_RPOLY:
	type = T_RPOLY;
	break;
    case N_VECT:
	type = T_VECT;
	break;
    case N_MATRIX:
	type = T_MATRIX;
	break;
    case N_TENSOR:
	type = T_TENSOR;
	break;
    case N_PREF:
	type = T_PREFIX;
	break;
    case N_RELEXP:
	type = T_RELEXP;
	break;
    case N_SETEXP:
	type = T_SETEXP;
	break;
    case N_LOGEXP:
	type = T_LOGEXP;
	break;
    }
    error("chrgal: number type not implemented");
    return nil;
}


Sex
chr1(void)
{
    long            n;
    n = fsl_getc();
    return n;
}

long
chr2(void)
{
    char            c1,
                    c2;
    long            n;

    c1 = fsl_getc();
    c2 = fsl_getc();
    n = (c1 << 8) + c2;
    return n;
}

int
chr4(void)
{
    int             n;

    n = fsl_getc();
    n = (n << 8) + fsl_getc();
    n = (n << 8) + fsl_getc();
    n = (n << 8) + fsl_getc();
    return n;
}
/*******************************************************************/

long
fsl_getc(void)
{
    long            n;

    switch (fslfdi.type) {
    case 1:
	if (fslfdi.size > fslfdi.pos) {
	    n = fslfdi.data[fslfdi.pos++];
	    n &= 0xff;
	    // lisp_printf("fsl_getc: 0x%02x\n", n);
	    return n;
	}
	return 0;
    case 2:
	n = fgetc(fslfdi.fp) & 0xff;
	// lisp_printf("fsl_getc: 0x%02x\n", n);
	return n;
    default:
	return 0;
    }
}

void
fsl_putc(long c)
{
    if (fslfdo == NULL)
	return;
    fputc(c, fslfdo);
}

/*******************************************************************/

long            ai = 0;
long            aimax = 0;
Sex             AItable;

Sex
Lallocait(Sex size)
{
    long            n;
    if (!is_fixnum(size) || (n = mkint(size)) >= 2000)
	error1("allocait: size too large", size);
    AItable = Lmkarray1(size);
    ai = 0;
    aimax = n;
    return true;
}

Sex
Lresetait(void)
{
    AItable = nil;
    aimax = 0;
    ai = 0;
    return true;
}

Sex
Lchrai(void)
{
    long            n;
    Sex             a;

    n = (fsl_getc() << 8) | fsl_getc();
    if (n < 0 || n >= aimax)
	return nil;
    a = Lgetarray1(AItable, mkfxat(n));
    return a;
}

Sex
Lputai(Sex a)
{
    if (ai >= aimax)
	error("ai table overflow");
    ai++;
    Lsetarray1(AItable, mkfxat(ai), a);
    return nil;
}

/*******************************************************************/
Sex
Lplant(Sex u, Sex a)
{
    union {
	long            n;
	short           s[2];
    } n;

    long            m;
    Code           *p;

    if (bpsorg >= bpsend) {
	m = bpsend + 100000;
	p = (Code *) realloc(bytecode, sizeof(Code) * m);
	if (p == NULL)
	    fatal_error("plant: bps full");
	bytecode = p;
	bpsend = m;
    }
    if (is_fixnum(u))
	n.n = mkint(u);
    else if (is_logical(u))
	n.n = logical_value(u)[0];
    else if (is_bigint(u))
	n.n = bignum_value(u)[0];
    else
	error("plant: not number");

    switch (a) {
    case mkfxat(2):
	bytecode[bpsorg++] = n.n;
	break;
    case mkfxat(4):
	*(int *) (&bytecode[bpsorg]) = n.n;
	bpsorg += 2;
	break;
    case mkfxat(6):
	bytecode[bpsorg++] = n.s[0];
	bytecode[bpsorg++] = n.s[1];
	break;
    default:
	error1("plant: invalid argument", a);
    }

    return nil;
}


Sex
Lplanta(Sex u)
{
    long            m;
    void           *p;

    if (bpsorg >= bpsend) {
	m = bpsend + 100000;
	p = realloc(bytecode, sizeof(Code) * m);
	if (p == NULL)
	    fatal_error("planta: atomindex full");
	bytecode = (Code *) p;
	bpsend = m;
    }
    if (atomorg >= atomend) {
	m = atomend + NATOM;
	if (m > 0xffff) {
	    error("planta: atomidnex exceed max");
	}
	p = realloc(atoms, sizeof(Sex) * m);
	if (p == NULL)
	    fatal_error("planta: atomindex full");
	atoms = (Sex *) p;
	atomend = m;
    }

    bytecode[bpsorg++] = atomorg;
    atoms[atomorg++] = u;
    return nil;
}


/*******************************************************************/


setup_type const fap_setup[] = {
    {"plant", (lisp_proc *) Lplant, 2},
    {"planta", (lisp_proc *) Lplanta, 1},
    {"fslropen", (lisp_proc *) Lfslropen, 1},
    {"fslropen_string", (lisp_proc *) Lfslropen_string, 1},
    {"fslwopen", (lisp_proc *) Lfslwopen, 1},
    {"fslrclose", (lisp_proc *) Lfslrclose, 0},
    {"fslwclose", (lisp_proc *) Lfslwclose, 0},
    {"bpsleft", (lisp_proc *) Lbpsleft, 0},
    {"bpsmove", (lisp_proc *) Lbpsmove, 1},
    {"&bporg", (lisp_proc *) Lanpbporg, 0},
    {"&bpend", (lisp_proc *) Lanpbpend, 0},
    {"&logx", (lisp_proc *) Llogx, 1},
    {"chr1", (lisp_proc *) Lchr1, 0},
    {"chr2", (lisp_proc *) Lchr2, 0},
    {"chr4", (lisp_proc *) Lchr4, 0},
    {"chrt", (lisp_proc *) Lchrt, 0},
    {"chrbg", (lisp_proc *) Lchrbg, 1},
    {NULL, 0, 0}
};
