/*
 * fns.h                (C); Copyright 1998-2000, 2007 by Fujio Kako, Nara Women's University.
 *  Basic functions.
 * $Header: /Users/kako/asuka/src/RCS/fns.h,v 2.10 2016/09/05 02:51:29 kako Exp $
 */


/***************************************************************************
 *
 * Some basic functions                                                 
 *
 ***************************************************************************/

Sex             Lcar(Sex A);
Sex             Lcdr(Sex A);
Sex             Lrplaca(Sex A, Sex Q);
Sex             Lrplacd(Sex A, Sex Q);
Sex             Latom(Sex p);
Sex             Leq(Sex a, Sex b);
Sex             Lpnth(Sex u, Sex n);
Sex             Lnth(Sex u, Sex n);
Sex             Llistp(Sex p);
Sex             Lnumberp(Sex p);
Sex             Lfloatp(Sex p);
Sex             Lget(Sex a, Sex b);
Sex             Lput(Sex a, Sex b, Sex c);
Sex             Lremprop(Sex a, Sex b);

/*****************************************************************************/
/*
 * Storage allocation.                                                  
 */
/*****************************************************************************/

Sex             cons(Sex a, Sex b);
Sex             rcons(Sex a, Sex b);
Sex             Lxcons(Sex b, Sex a);
Sex             Lncons(Sex a);
Sex             Llist2(Sex a, Sex b);
Sex             Llist2star(Sex a, Sex b, Sex c);
Sex             Lacons(Sex a, Sex b, Sex c);
Sex             Llist3(Sex a, Sex b, Sex c);
Sex             Llist4(Sex a, Sex b, Sex c, Sex d);
Sex             Llist5(Sex a, Sex b, Sex c, Sex d, Sex e);

#ifdef ASUKA
Sex             Llist6(Sex a, Sex b, Sex c, Sex d, Sex e, Sex f);
Sex             Llist7(Sex a, Sex b, Sex c, Sex d, Sex e, Sex f, Sex g);
#endif

Sex             Lcaar(Sex a);
Sex             Lcadr(Sex a);
Sex             Lcdar(Sex a);
Sex             Lcddr(Sex a);
Sex             Lcaaar(Sex a);
Sex             Lcaadr(Sex a);
Sex             Lcadar(Sex a);
Sex             Lcaddr(Sex a);
Sex             Lcdaar(Sex a);
Sex             Lcdadr(Sex a);
Sex             Lcddar(Sex a);
Sex             Lcdddr(Sex a);
Sex             Lcaaaar(Sex a);
Sex             Lcaaadr(Sex a);
Sex             Lcaadar(Sex a);
Sex             Lcaaddr(Sex a);
Sex             Lcadaar(Sex a);
Sex             Lcadadr(Sex a);
Sex             Lcaddar(Sex a);
Sex             Lcadddr(Sex a);
Sex             Lcdaaar(Sex a);
Sex             Lcdaadr(Sex a);
Sex             Lcdadar(Sex a);
Sex             Lcdaddr(Sex a);
Sex             Lcddaar(Sex a);
Sex             Lcddadr(Sex a);
Sex             Lcdddar(Sex a);
Sex             Lcddddr(Sex a);
Sex             Lidp(Sex a);

Sex             Lpairp(Sex a);
Sex             Lconstantp(Sex a);

Sex             Lnumtype(Sex p);
Sex             Lgnumtype(Sex p);
Sex             Lbigp(Sex p);
Sex             Lfixnump(Sex p);
Sex             Lfixp(Sex p);
Sex             Llogicalp(Sex p);

Sex             Lrationalp(Sex p);
Sex             Lbfloatp(Sex p);

Sex             Lefloatp(Sex p);
Sex             Lbefloatp(Sex p);
Sex             Lcomplexp(Sex p);
Sex             Lecomplexp(Sex p);

Sex             Lbecomplexp(Sex p);
Sex             Lintervalp(Sex p);
Sex             Lbintervalp(Sex p);

bool            stringp(Sex a);
Sex             Lstringp(Sex a);

Sex             Lvectorp(Sex a);
Sex             Larrayp(Sex a);
Sex             make_sov(Sex els);

static Sex      Lpackagep(Sex a);
static Sex      Lpackage_cnt(Sex a);
static Sex      Lhashp(Sex a);

Sex             Lflagp(Sex a, Sex b);
Sex             Lflagpcar(Sex a, Sex b);
Sex             Lflag(Sex a, Sex b);
Sex             Lremflag(Sex a, Sex b);

Sex             Lmkquote(Sex a);
Sex             Lpair(Sex a, Sex b);
static long     memqcount(Sex a, Sex b);
static long     membercount(Sex a, Sex b);
Sex             Lintersection(Sex a, Sex b);
Sex             Lintersectionq(Sex a, Sex b);
Sex             Lunion(Sex a, Sex b);
Sex             Lunionq(Sex a, Sex b);
_Noreturn Sex   Lerror(Sex msg, Sex a);
Sex             Lerror0(void);
_Noreturn Sex   Lerror1(void);
_Noreturn Sex   Lerror2(Sex msg);
Sex             Lstop(Sex code);
Sex             Lfluid(Sex a);
Sex             Lglobal(Sex a);
Sex             Lunfluid(Sex a);
Sex             Lmake_fluid(Sex a);
Sex             Lmake_global(Sex a);
Sex             Lmake_special(Sex a);
Sex             Lmake_unfluid(Sex a);
Sex             Lmake_unglobal(Sex a);
Sex             Lmake_unspecial(Sex a);
Sex             Lunglobal(Sex a);
Sex             Lis_special_var(Sex a);
Sex             Lfluidp(Sex a);
Sex             Lglobalp(Sex a);
Sex             Lboundp(Sex a);
Sex             Lsymbol_value(Sex a);

Sex             Lset(Sex a, Sex b);

Sex             Lcodep(Sex a);

Sex             Lbytecodep(Sex a);
Sex             getvector(long tag, long type, long size);
Sex             getvector_init(long n, Sex k);
Sex             Lfloat_time(void);

Sex             Ltime(void);
Sex             Lgctime(void);
Sex             Lgccalled(void);
Sex             Ldate(void);
Sex             Ldate_and_time(void);
Sex             Ldatestamp(void);

Sex             deleqip(Sex a, Sex l);

Sex             Lputd(Sex a, Sex b, Sex c);

Sex             Lgetd(Sex a);
Sex             Lmovd(Sex a, Sex b);
Sex             Lget_number_of_args(Sex a);
Sex             Lput_proc(Sex a, Sex b, Sex c);
Sex             Lget_proc(Sex a, Sex b);
Sex             Lremd(Sex a);
Sex             Ltraceall(Sex a);
Sex             Ltrace(Sex a);
Sex             Luntrace(Sex a);
Sex             Lmacro_function(Sex a);
Sex             Lsymbol_length(Sex a);
Sex             Lsymbol_name(Sex a);
Sex             Lplist(Sex a);
Sex             Latom_tag(Sex a);
Sex             Lnumber_tag(Sex a);
Sex             Lnumber_length(Sex a);
Sex             Lmkvect(Sex n);

Sex             Larraydim(Sex a);
long            checkarray1(Sex n1);
long            checkarray2(Sex n1, Sex n2);

long            checkarray3(Sex n1, Sex n2, Sex n3);
Sex             mkarray(long n);
Sex             Lmkarray1(Sex n1);
Sex             Lmkarray2(Sex n1, Sex n2);
Sex             Lmkarray3(Sex n1, Sex n2, Sex n3);
Sex             mkarray_fn(Sex args, Sex env);

Sex             Lmkiarray1(Sex n1);
Sex             Lmkiarray2(Sex n1, Sex n2);
Sex             Lmkiarray3(Sex n1, Sex n2, Sex n3);
Sex             Lmklarray1(Sex n1);
Sex             Lmklarray2(Sex n1, Sex n2);
Sex             Lmklarray3(Sex n1, Sex n2, Sex n3);
Sex             Lmkfarray1(Sex n1);
Sex             Lmkfarray2(Sex n1, Sex n2);
Sex             Lmkfarray3(Sex n1, Sex n2, Sex n3);
Sex             Lmkdarray1(Sex n1);
Sex             Lmkdarray2(Sex n1, Sex n2);
Sex             Lmkdarray3(Sex n1, Sex n2, Sex n3);

static Sex      list_getarray1(Sex v, long d);
static Sex      list_getarray2(Sex v, long d1, long d2);
static Sex      list_getarray3(Sex v, long d1, long d2, long d3);
static Sex      list_setarray1(Sex v, Sex x, long d);
static Sex      list_setarray2(Sex v, Sex x, long d1, long d2);
static Sex      list_setarray3(Sex v, Sex x, long d1, long d2, long d3);
Sex             Lgetarray1(Sex v, Sex n1);
Sex             Lgetarray2(Sex v, Sex n1, Sex n2);
Sex             Lgetarray3(Sex v, Sex n1, Sex n2, Sex n3);
Sex             getarray_fn(Sex arg, Sex env);
Sex             Lsetarray1(Sex v, Sex x, Sex n1);

Sex             Lsetarray2(Sex v, Sex x, Sex n1, Sex n2);
Sex             Lsetarray3(Sex v, Sex x, Sex n1, Sex n2, Sex n3);

Sex             setarray_fn(Sex arg, Sex env);

Sex             Lmkmatrix(Sex a, Sex b);
Sex             Lmkvector(Sex a);

Sex             Lputv(Sex v, Sex n, Sex x);
Sex             Laref(Sex v, Sex n);
Sex             Lgetv(Sex v, Sex n);
Sex             Lupbv(Sex v);
bool            eql(Sex a, Sex b);
static Sex      numequal(Sex a, Sex b);
static Sex      strequal(Sex a, Sex b);
static Sex      vecequal(Sex a, Sex b);

Sex             equal(Sex a, Sex b);

Sex             Leql(Sex a, Sex b);
Sex             Leqcar(Sex a, Sex b);
Sex             Lequal(Sex a, Sex b);
Sex             Lneq(Sex a, Sex b);
Sex             Lnull(Sex a);
Sex             Lendp(Sex a);

Sex             Lreverse(Sex a);

Sex             Lassoc(Sex a, Sex b);
Sex             Lrassoc(Sex a, Sex b);
Sex             Latsoc(Sex a, Sex b);
Sex             Lmember(Sex a, Sex b);
Sex             Lmemq(Sex a, Sex b);
static bool     smemq(Sex a, Sex b);
Sex             Lsmemq(Sex a, Sex b);
Sex             Lsetdiff(Sex a, Sex b);
Sex             Lsetdiffq(Sex a, Sex b);
Sex             Lsetadd(Sex a, Sex b);
Sex             Lsetaddq(Sex a, Sex b);

long            list_length(Sex a);

Sex             Llength(Sex a);
Sex             Lappend(Sex a, Sex b);

Sex             Ldelete(Sex a, Sex b);

Sex             Ldeleq(Sex a, Sex b);
Sex             Laconc(Sex a, Sex b);

Sex             Lnconc(Sex a, Sex b);

static Sex      Lsubstq(Sex a, Sex b, Sex c);
Sex             Lsubst(Sex a, Sex b, Sex c);

Sex             Lsublis(Sex al, Sex x);
Sex             Lsubla(Sex al, Sex x);
Sex             Lquit(void);
Sex             Lbye(void);

#ifdef INCLUDE_FEND
/*****************************************************************************/
/*
 * Standard lisp functions.
 */
/*****************************************************************************/

Sex             Ldeflist(Sex u, Sex ind);

Sex             Lexpand(Sex l, Sex fn);
static Sex      logxor_fn(Sex args, Sex env);
static Sex      logand_fn(Sex args, Sex env);
static Sex      logor_fn(Sex args, Sex env);
static Sex      ilogxor_fn(Sex args, Sex env);
static Sex      ilogand_fn(Sex args, Sex env);
static Sex      ilogor_fn(Sex args, Sex env);
static Sex      max_fn(Sex args, Sex env);
static Sex      min_fn(Sex args, Sex env);

static Sex      imax_fn(Sex args, Sex env);
static Sex      imin_fn(Sex args, Sex env);
/*
 * Code for copy 
 */
Sex             Lcopy(Sex u);
/*
 * toplevel list or array copy 
 */
Sex             Lclone(Sex u);
Sex             array_copy(Sex u);

/*
 * Code for xn 
 */

Sex             Lxn(Sex v, Sex u);
Sex             Llast(Sex u);
Sex             Lnum(Sex n);
Sex             Lden(Sex n);
Sex             Lprintprompt(Sex u);
#endif
Sex             Lprintaddr(Sex x);
#ifdef ASUKA
Sex             Lmode_lisp(void);
Sex             Lmode_asuka(void);
#endif
Sex             array_copy(Sex);
