/*
 * list.h               (C); Copyright 2011 by Fujio Kako, Nara Women's University.
 *  Basic functions.
 * $Header: /Users/kako/asuka/src/RCS/list.h,v 2.11 2016/09/06 05:50:02 kako Exp $
 */



/*****************************************************************************/
/*
 * Some basic functions                                                 
 */
/****************************************************************************
 */

static Sex      Acar(Sex A);
static Sex      Acdr(Sex A);
static Sex      Arplaca(Sex A, Sex Q);
static Sex      Arplacd(Sex A, Sex Q);

static Sex      Aatom(Sex p);
static Sex      Aeq(Sex a, Sex b);
static Sex      Anthcdr(Sex u, Sex n);
static Sex      Areplace(Sex u, Sex f, Sex n);
static Sex      Apnth(Sex u, Sex n);
static Sex      Anth(Sex u, Sex n);
static Sex      Alistp(Sex p);
static Sex      Anumberp(Sex p);

static Sex      Afloatp(Sex p);

static Sex      Aget(Sex a, Sex b);
static Sex      Aput(Sex a, Sex b, Sex c);
static Sex      Aremprop(Sex a, Sex b);

/*****************************************************************************/
/*
 * Storage allocation.                                                  
 */
/*****************************************************************************/

static Sex      Acons(Sex a, Sex b);
static Sex      Arcons(Sex a, Sex b);
static Sex      Axcons(Sex b, Sex a);
static Sex      Ancons(Sex a);
static Sex      Alist2(Sex a, Sex b);
static Sex      Alist2star(Sex a, Sex b, Sex c);
static Sex      Aacons(Sex a, Sex b, Sex c);
static Sex      Alist3(Sex a, Sex b, Sex c);

static Sex      Alist4(Sex a, Sex b, Sex c, Sex d);
static Sex      Alist5(Sex a, Sex b, Sex c, Sex d, Sex e);

#ifdef ASUKA
static Sex      Alist6(Sex a, Sex b, Sex c, Sex d, Sex e, Sex f);
static Sex      Alist7(Sex a, Sex b, Sex c, Sex d, Sex e, Sex f, Sex g);
#endif
static Sex      Acaar(Sex a);
static Sex      Acadr(Sex a);
static Sex      Acdar(Sex a);
static Sex      Acddr(Sex a);
static Sex      Acaaar(Sex a);
static Sex      Acaadr(Sex a);
static Sex      Acadar(Sex a);
static Sex      Acaddr(Sex a);
static Sex      Acdaar(Sex a);
static Sex      Acdadr(Sex a);
static Sex      Acddar(Sex a);
static Sex      Acdddr(Sex a);
static Sex      Acaaaar(Sex a);
static Sex      Acaaadr(Sex a);
static Sex      Acaadar(Sex a);
static Sex      Acaaddr(Sex a);
static Sex      Acadaar(Sex a);
static Sex      Acadadr(Sex a);
static Sex      Acaddar(Sex a);
static Sex      Acadddr(Sex a);
static Sex      Acdaaar(Sex a);
static Sex      Acdaadr(Sex a);
static Sex      Acdadar(Sex a);
static Sex      Acdaddr(Sex a);
static Sex      Acddaar(Sex a);
static Sex      Acddadr(Sex a);
static Sex      Acdddar(Sex a);

static Sex      Acddddr(Sex a);

static Sex      Aidp(Sex a);

static Sex      Apairp(Sex a);
static Sex      Aconstantp(Sex a);

static Sex      Abigp(Sex p);
static Sex      Afixp(Sex p);
static Sex      Alogicalp(Sex p);

static Sex      Arationalp(Sex p);
static Sex      Abfloatp(Sex p);

static Sex      Aefloatp(Sex p);

static Sex      Abefloatp(Sex p);
static Sex      Acomplexp(Sex p);
static Sex      Aecomplexp(Sex p);

static Sex      Abecomplexp(Sex p);
static Sex      Aintervalp(Sex p);
static Sex      Abintervalp(Sex p);

bool            AAstringp(Sex a);
static Sex      Astringp(Sex a);

static Sex      Avectorp(Sex a);

static Sex      Apackagep(Sex a);
static Sex      Apackage_cnt(Sex a);
static Sex      Ahashp(Sex a);

static Sex      Aflagp(Sex a, Sex b);
static Sex      Aflagpcar(Sex a, Sex b);
static Sex      Aflag(Sex a, Sex b);
static Sex      Aremflag(Sex a, Sex b);

static Sex      Amkquote(Sex a);
static Sex      Apair(Sex a, Sex b);
static long     memqcount(Sex a, Sex b);
static long     membercount(Sex a, Sex b);
static Sex      Aintersection(Sex a, Sex b);
static Sex      Aintersectionq(Sex a, Sex b);
Sex             Amerge(Sex a, Sex b);
static Sex      Asort(Sex a);
static void     quick_sort(Sex * a, long l, long r);
static Sex      Aunion(Sex a, Sex b);
static Sex      Aunionq(Sex a, Sex b);
Sex             Asetdiff(Sex a, Sex b);
static Sex      Asetdiffq(Sex a, Sex b);

Sex             Aerror(Sex msg, Sex a);
static Sex      Aerror0(void);
static Sex      Aerror1(void);
static Sex      Aerror2(Sex msg);
static Sex      Astop(Sex code);
static Sex      Afluid(Sex a);
static Sex      Aglobal(Sex a);
static Sex      Aunfluid(Sex a);
static Sex      Aunglobal(Sex a);
static Sex      Afluidp(Sex a);
static Sex      Aglobalp(Sex a);
static Sex      Aboundp(Sex a);
static Sex      Asymbol_value(Sex a);

static Sex      Aset(Sex a, Sex b);


static Sex      Acodep(Sex a);
static Sex      Agetvector(long tag, long type, long size);
static Sex      Agetvector_init(long n, Sex k);

static Sex      Afloat_time(void);

static Sex      Atime(void);
static Sex      Agctime(void);
static Sex      Agccalled(void);
static Sex      Adate(void);

static Sex      deleqip(Sex a, Sex l);

static Sex      Aputd(Sex a, Sex b, Sex c);

static Sex      Agetd(Sex a);
static Sex      Amovd(Sex a, Sex b);
static Sex      Aremd(Sex a);

static Sex      Atraceall(Sex a);
static Sex      Atrace(Sex a);
static Sex      Auntrace(Sex a);
static Sex      Amacro_function(Sex a);


static Sex      Asymbol_length(Sex a);
static Sex      Asymbol_name(Sex a);
static Sex      Aplist(Sex a);

static Sex      Aatom_tag(Sex a);
static Sex      Anumber_tag(Sex a);
static Sex      Anumber_length(Sex a);
static Sex      Amkvect(Sex n);
long            Acheckarray1(Sex n1);
long            Acheckarray2(Sex n1, Sex n2);

long            Acheckarray3(Sex n1, Sex n2, Sex n3);
static Sex      Amkarray1(Sex n1);
static Sex      Amkarray2(Sex n1, Sex n2);
static Sex      Amkarray3(Sex n1, Sex n2, Sex n3);
static Sex      mkarray_fn(Sex args, Sex env);

static Sex      Amkiarray1(Sex n1);
static Sex      Amkiarray2(Sex n1, Sex n2);
static Sex      Amkiarray3(Sex n1, Sex n2, Sex n3);
static Sex      Amklarray1(Sex n1);
static Sex      Amklarray2(Sex n1, Sex n2);
static Sex      Amklarray3(Sex n1, Sex n2, Sex n3);
static Sex      Amkfarray1(Sex n1);
static Sex      Amkfarray2(Sex n1, Sex n2);
static Sex      Amkfarray3(Sex n1, Sex n2, Sex n3);
static Sex      Amkdarray1(Sex n1);
static Sex      Amkdarray2(Sex n1, Sex n2);
static Sex      Amkdarray3(Sex n1, Sex n2, Sex n3);
static Sex      Agetarray1(Sex v, Sex n1);
static Sex      Agetarray2(Sex v, Sex n1, Sex n2);
static Sex      Agetarray3(Sex v, Sex n1, Sex n2, Sex n3);
static Sex      getarray_fn(Sex arg, Sex env);
static Sex      Asetarray1(Sex v, Sex x, Sex n1);
static Sex      Asetarray2(Sex v, Sex x, Sex n1, Sex n2);

static Sex      Asetarray3(Sex v, Sex x, Sex n1, Sex n2, Sex n3);
Sex             Alist2array(Sex a, Sex v);
static Sex      Alist2array1(Sex a, Sex v);
static Sex      Alist2array2(Sex a, Sex v);
static Sex      Alist2array3(Sex a, Sex v);
static Sex      Aarray2list(Sex a);
static Sex      Aarray2list1(Sex a, Sex v);
static Sex      Aarray2list2(Sex a, Sex v);
static Sex      Aarray2list3(Sex a, Sex v);

static Sex      setarray_fn(Sex arg, Sex env);
static Sex      Aputv(Sex v, Sex n, Sex x);
static Sex      Aaref(Sex v, Sex n);
static Sex      Agetv(Sex v, Sex n);

static Sex      Aupbv(Sex v);

bool            AAeql(Sex a, Sex b);
static Sex      numequal(Sex a, Sex b);
static Sex      strequal(Sex a, Sex b);
static Sex      vecequal(Sex a, Sex b);
static Sex      AAequal(Sex a, Sex b);

static Sex      Aeql(Sex a, Sex b);
static Sex      Aeqcar(Sex a, Sex b);
static Sex      Aequal(Sex a, Sex b);
static Sex      Aneq(Sex a, Sex b);
static Sex      Anull(Sex a);
static Sex      Aendp(Sex a);

static Sex      Areverse(Sex a);

static Sex      Aassoc(Sex a, Sex b);
static Sex      Arassoc(Sex a, Sex b);
static Sex      Aatsoc(Sex a, Sex b);
static Sex      Amember(Sex a, Sex b);

static Sex      Amemq(Sex a, Sex b);
static bool     smemq(Sex a, Sex b);
static Sex      Asmemq(Sex a, Sex b);

long            AAlist_length(Sex a);

static Sex      Alength(Sex a);

static Sex      Aappend(Sex a, Sex b);
static Sex      Aappende(Sex a, Sex b);

static Sex      Adelete(Sex a, Sex b);

static Sex      Adeleq(Sex a, Sex b);
static Sex      Aaconc(Sex a, Sex b);
static Sex      Anconc(Sex a, Sex b);
static Sex      Asubstq(Sex a, Sex b, Sex c);
static Sex      Asubst(Sex a, Sex b, Sex c);

static Sex      Asublis(Sex al, Sex x);
static Sex      Asubla(Sex al, Sex x);
static Sex      Aquit(void);
static Sex      Abye(void);


#ifdef INCLUDE_FEND

/*****************************************************************************/
/*
 * Standard lisp functions.
 */
/*****************************************************************************/


/*
 * Code for deflist 
 */
static Sex      Adeflist(Sex u, Sex ind);

static Sex      Aexpand(Sex l, Sex fn);

static Sex      logxor_fn(Sex args, Sex env);
static Sex      logand_fn(Sex args, Sex env);
static Sex      logor_fn(Sex args, Sex env);
static Sex      ilogxor_fn(Sex args, Sex env);
static Sex      ilogand_fn(Sex args, Sex env);
static Sex      ilogor_fn(Sex args, Sex env);

static Sex      max_fn(Sex args, Sex env);
static Sex      min_fn(Sex args, Sex env);
static Sex      imax_fn(Sex args, Sex env);
static Sex      imin_fn(Sex args, Sex env);


/*
 * Code for copy 
 */
static Sex      Acopy(Sex u);
/*
 * toplevel list or array copy 
 */
static Sex      Aclone(Sex u);
static Sex      Aarray_copy(Sex u);

/*
 * Code for xn 
 */
static Sex      Axn(Sex v, Sex u);


static Sex      Alast(Sex u);


static Sex      Anum(Sex n);
static Sex      Aden(Sex n);


static Sex      Aprintprompt(Sex u);
#endif
static Sex      Aprintaddr(Sex x);
#ifdef ASUKA
static Sex      Amode_lisp(void);
static Sex      Amode_asuka(void);
#endif
Sex             Lgetarray1(Sex v, Sex n1);
Sex             Lgetarray2(Sex v, Sex n1, Sex n2);
Sex             Lgetarray3(Sex v, Sex n1, Sex n2, Sex n3);
Sex             Lsetarray1(Sex v, Sex x, Sex n1);
Sex             Lsetarray2(Sex v, Sex x, Sex n1, Sex n2);
Sex             Lsetarray3(Sex v, Sex x, Sex n1, Sex n2, Sex n3);
Sex             Ldeflist(Sex u, Sex ind);
Sex             Lexpand(Sex l, Sex fn);
Sex             Lcopy(Sex u);
Sex             Lxn(Sex v, Sex u);


// static Sex Alist2matrix(Sex a, Sex v);
static Sex      Alist2vector(Sex a);
static Sex      Avector2list(Sex a);
static Sex      Asetvector(Sex a, Sex v);
static Sex      Asetmatrix(Sex a, Sex v);

extern Sex      new_vector(long n);
extern Sex      new_matrix(long a, long b);

extern Sex      Ais_modular(Sex a);
extern Sex      new_prefix(void);
