
#include <stdio.h>
#include <stdlib.h>
#include <zlib.h>

char *PATH = "../reduce32/faplib/";

char* package[] = {
"acfsf",
"alg",
"algint",
"applysym",
"arith",
"arnum",
"assert",
"assist",
"atensor",
"avector",
"bfap",
"bibasis",
"boolean",
"breduce",
"cali",
"camal",
"cantens",
"ccomp",
"cdiff",
"cedit",
"cfap",
"cgb",
"changevr",
"cl",
"clprl",
"cmacro",
"compact",
"compiler",
"complr",
"conlaw",
"crack",
"cvit",
"dcfsf",
"defint",
"desir",
"dfpart",
"dipoly",
"dummy",
"dvfsf",
"eds",
"entry",
"excalc",
"ezgcd",
"factor",
"fap",
"fide",
"fide1",
"fisl",
"fmprint",
"fps",
"ftr",
"gcref",
"gentran",
"geometry",
"geoprover",
"gnuplot",
"groebfac",
"groebner",
"groebnr2",
"groext",
"guardian",
"hephys",
"ibalp",
"ideals",
"ineq",
"int",
"invbase",
"lalr",
"lap",
"laplace",
"libreduce",
"lie",
"liepde",
"limits",
"linalg",
"linineq",
"listvecops",
"lpdo",
"mathml",
"mathmlom",
"mathpr",
"matrix",
"misc",
"mma",
"modsr",
"mri",
"mri_ofsf",
"mri_pasf",
"mrvlimit",
"ncpoly",
"noncom2",
"normform",
"numeric",
"odesolve",
"ofsf",
"orthovec",
"otrgsimp",
"pasf",
"pf",
"pgauss",
"physop",
"plot",
"pm",
"poly",
"polydiv",
"pretty",
"profile",
"prolog",
"qepcad",
"qerrc",
"qhull",
"qqe",
"qqe_ofsf",
"qsum",
"randpoly",
"ranum",
"rataprx",
"ratint",
"rcref",
"reacteqn",
"redfront",
"redlog",
"reduce4",
"rend",
"reset",
"residue",
"rl",
"rlfi",
"rlisp",
"rlisp88",
"rltools",
"roots",
"roots2",
"rprint",
"rsolve",
"rtrace",
"rubi_red",
"scope",
"sets",
"sfgamma",
"smt",
"solve",
"sparse",
"spde",
"specbess",
"specfaux",
"specfn",
"specfn2",
"sum",
"support",
"susy2",
"symaux",
"symmetry",
"tables",
"talp",
"taylor",
"tmprint",
"tplp",
"tps",
"tri",
"trigd",
"trigint",
"trigsimp",
"turtle",
"utf8",
"v3tools",
"wu",
"xcolor",
"xideal",
"zeilberg",
"ztrans",
};

void gencode(char *p);
void zgencode(char *p);

long slen;
long dlen;

int
main(int argc, char *argv[])
{
	int i, j;
	int n;
	int d[200], s[200];

	n = sizeof(package)/sizeof(char *);
	printf("#ifdef USE_ZLIB\n");
	for(i = 0; i < n; i++) {
		zgencode(package[i]);
		s[i] = slen;
		d[i] = dlen;
	}
	printf("\nbcode_package b_pack[] = {\n");
	for(i = 0; i < n; i++) {
		printf("{\"%s\", bcode_z_%s, %d, %d},\n",
			package[i], package[i], s[i], d[i]);
	}
	printf("{NULL, NULL, -1, -1}};\n");
	printf("#else\n");
	for(i = 0; i < n; i++) {
		gencode(package[i]);
		s[i] = slen;
	}
	printf("\nbcode_package b_pack[] = {\n");
	for(i = 0; i < n; i++) {
		printf("{\"%s\", bcode_%s, %d},\n",
			package[i], package[i], s[i]);
	}
	printf("{NULL, NULL, -1}};\n");
	printf("#endif\n");


}

void
gencode(char *p)
{
	FILE *fp;
	int c;
	int n;
	char fname[128];

	sprintf(fname, "%s%s", PATH, p);
	fp = fopen(fname, "r");
	if(fp == NULL) {
		fprintf(stderr, "can't open %s\n", fname);
		return;
	}

	printf("unsigned char bcode_%s[] = {\n", p);
	n = 0;
	while((c = fgetc(fp)) != EOF) {
		c &=0xff;
		if(n % 20 == 0) printf("\n");
		printf("%d,", c);
		n++;
	}
	printf("};\n");
	fclose(fp);
	slen = n;
}

unsigned char ibuffer[512000];
unsigned char obuffer[512000];

void
zgencode(char *p)
{
	FILE *fp;
	int c;
	long n;
	char fname[128];
	unsigned long len;

	sprintf(fname, "%s%s", PATH, p);
	fp = fopen(fname, "r");
	if(fp == NULL) {
		fprintf(stderr, "can't open %s\n", fname);
		return;
	}

	printf("unsigned char bcode_z_%s[] = {\n", p);
	n = 0;
	while((c = fgetc(fp)) != EOF)
		ibuffer[n++] = c;
	len = 512000;
	compress(obuffer, &len, ibuffer, n);
	slen = n;
	dlen = len;

	for(n = 0; n < len; n++) {
		c = obuffer[n];
		c &=0xff;
		if(n % 20 == 0) printf("\n");
		printf("%d,", c);
	}
	printf("};\n");
	fclose(fp);
}
