/*
 * mathop.h             (C) Copyright 1998-2000, 2007 by Fujio Kako, Nara Women's University.
 *  Header for arithmetic routines
 * $Header: /Users/kako/asuka/src/RCS/mathop.h,v 2.9 2016/04/03 23:43:37 kako Exp $
 */

extern Sex      math_er(Sex a, Sex b);
extern Sex      mkzero2(Sex a, Sex b);

/*
 * addition
 */


extern Sex      plus2cx(Sex a, Sex b);
extern Sex      plus2ex(Sex a, Sex b);
extern Sex      plus2zx(Sex a, Sex b);
extern Sex      plus2xE(Sex a, Sex b);
extern Sex      plus2xc(Sex a, Sex b);
extern Sex      plus2xe(Sex a, Sex b);
extern Sex      plus2xv(Sex a, Sex b);
extern Sex      plus2xz(Sex a, Sex b);
extern Sex      plus2xZ(Sex a, Sex b);
extern Sex      plus2xV(Sex a, Sex b);

extern Sex      plus2ii(Sex a, Sex b);
#define plus2il plus2ib
extern Sex      plus2ib(Sex a, Sex b);
extern Sex      plus2im(Sex a, Sex b);
extern Sex      plus2ir(Sex a, Sex b);
extern Sex      plus2if(Sex a, Sex b);
extern Sex      plus2ie(Sex a, Sex b);
#define plus2ic plus2xc
extern Sex      plus2iv(Sex a, Sex b);
extern Sex      plus2id(Sex a, Sex b);
extern Sex      plus2iz(Sex a, Sex b);
extern Sex      plus2iE(Sex a, Sex b);
#define plus2iZ plus2xZ
#define plus2iV plus2xV
extern Sex      plus2iM(Sex a, Sex b);

#define plus2ll plus2bb
#define plus2lb plus2bb
#define plus2lm plus2bm
#define plus2lr plus2br
#define plus2lf plus2bf
#define plus2le plus2be
#define plus2lc plus2bc
#define plus2lv plus2bv
#define plus2ld plus2bd
#define plus2lz plus2bz
#define plus2lE plus2bE
#define plus2lZ plus2bZ
#define plus2lV plus2bV
#define plus2lM	plus2bM

extern Sex      plus2bb(Sex a, Sex b);
extern Sex      plus2bm(Sex a, Sex b);
#define plus2br plus2ir
#define plus2bf plus2if
#define plus2be plus2xe
#define plus2bc plus2xc
#define plus2bv plus2xv
extern Sex      plus2bd(Sex a, Sex b);
#define plus2bz plus2xz
extern Sex      plus2bE(Sex a, Sex b);
#define plus2bZ plus2xZ
#define plus2bV plus2xV
extern Sex      plus2bM(Sex a, Sex b);

extern Sex      plus2mm(Sex a, Sex b);
extern Sex      plus2mr(Sex a, Sex b);
#define plus2mf math_er
#define plus2me math_er
extern Sex      plus2mc(Sex a, Sex b);
#define plus2mv math_er
#define plus2md math_er
#define plus2mz math_er
#define plus2mE math_er
#define plus2mZ math_er
#define plus2mV math_er

extern Sex      plus2rr(Sex a, Sex b);
#define plus2rf plus2if
#define plus2re plus2xe
#define plus2rc plus2xc
#define plus2rv plus2xv
extern Sex      plus2rd(Sex a, Sex b);
#define plus2rz plus2xz
extern Sex      plus2rE(Sex a, Sex b);
#define plus2rZ plus2xZ
#define plus2rV plus2xV
extern Sex      plus2rM(Sex a, Sex b);

extern Sex      plus2ff(Sex a, Sex b);
extern Sex      plus2fe(Sex a, Sex b);
#define plus2fc plus2xc
extern Sex      plus2fv(Sex a, Sex b);
extern Sex      plus2fd(Sex a, Sex b);
extern Sex      plus2fz(Sex a, Sex b);
extern Sex      plus2fE(Sex a, Sex b);
extern Sex      plus2fZ(Sex a, Sex b);
extern Sex      plus2fV(Sex a, Sex b);

extern Sex      plus2ee(Sex a, Sex b);
extern Sex      plus2ec(Sex a, Sex b);
extern Sex      plus2ev(Sex a, Sex b);
#define plus2ed plus2ex
extern Sex      plus2ez(Sex a, Sex b);
extern Sex      plus2eE(Sex a, Sex b);
extern Sex      plus2eZ(Sex a, Sex b);
extern Sex      plus2eV(Sex a, Sex b);

extern Sex      plus2cc(Sex a, Sex b);
#define plus2cv plus2cx
#define plus2cd plus2cx
extern Sex      plus2cz(Sex a, Sex b);
extern Sex      plus2cE(Sex a, Sex b);
// #define plus2cE plus2cx
extern Sex      plus2cZ(Sex a, Sex b);
// extern Sex plus2cV(Sex a, Sex b);
#define plus2cV	plus2cx
extern Sex      plus2cM(Sex a, Sex b);

extern Sex      plus2vv(Sex a, Sex b);
extern Sex      plus2vd(Sex a, Sex b);
extern Sex      plus2vz(Sex a, Sex b);
extern Sex      plus2vE(Sex a, Sex b);
extern Sex      plus2vZ(Sex a, Sex b);
extern Sex      plus2vV(Sex a, Sex b);

extern Sex      plus2dd(Sex a, Sex b);
#define plus2dz plus2xz
extern Sex      plus2dE(Sex a, Sex b);
#define plus2dZ plus2xZ
#define plus2dV plus2xV

extern Sex      plus2zz(Sex a, Sex b);
extern Sex      plus2zE(Sex a, Sex b);
extern Sex      plus2zZ(Sex a, Sex b);
extern Sex      plus2zV(Sex a, Sex b);

extern Sex      plus2EE(Sex a, Sex b);
extern Sex      plus2EZ(Sex a, Sex b);
extern Sex      plus2EV(Sex a, Sex b);

extern Sex      plus2ZZ(Sex a, Sex b);
extern Sex      plus2ZV(Sex a, Sex b);

extern Sex      plus2VV(Sex a, Sex b);

extern Sex      plus2Mi(Sex a, Sex b);
#define plus2Ml	plus2Mb
extern Sex      plus2Mb(Sex a, Sex b);
extern Sex      plus2Mr(Sex a, Sex b);
extern Sex      plus2Mc(Sex a, Sex b);
extern Sex      plus2MM(Sex a, Sex b);

/*
 * differece
 */

extern Sex      diff2cx(Sex a, Sex b);
extern Sex      diff2ex(Sex a, Sex b);
extern Sex      diff2vx(Sex a, Sex b);
extern Sex      diff2zx(Sex a, Sex b);
extern Sex      diff2Ex(Sex a, Sex b);
extern Sex      diff2Zx(Sex a, Sex b);
extern Sex      diff2Vx(Sex a, Sex b);
extern Sex      diff2xc(Sex a, Sex b);
extern Sex      diff2xv(Sex a, Sex b);
extern Sex      diff2xe(Sex a, Sex b);
extern Sex      diff2xz(Sex a, Sex b);
extern Sex      diff2xE(Sex a, Sex b);
extern Sex      diff2xZ(Sex a, Sex b);
extern Sex      diff2xV(Sex a, Sex b);


extern Sex      diff2ii(Sex a, Sex b);
#define diff2il diff2ib
extern Sex      diff2ib(Sex a, Sex b);
extern Sex      diff2im(Sex a, Sex b);
extern Sex      diff2ir(Sex a, Sex b);
extern Sex      diff2if(Sex a, Sex b);
extern Sex      diff2ie(Sex a, Sex b);
#define diff2ic diff2xc
extern Sex      diff2iv(Sex a, Sex b);
extern Sex      diff2id(Sex a, Sex b);
extern Sex      diff2iz(Sex a, Sex b);
#define diff2iE diff2xE
#define diff2iZ diff2xZ
#define diff2iV diff2xV
extern Sex      diff2iM(Sex a, Sex b);


#define diff2li diff2bi
extern Sex      diff2bi(Sex a, Sex b);
extern Sex      diff2mi(Sex a, Sex b);
extern Sex      diff2ri(Sex a, Sex b);
extern Sex      diff2fi(Sex a, Sex b);
extern Sex      diff2ei(Sex a, Sex b);
#define diff2ci diff2cx
extern Sex      diff2vi(Sex a, Sex b);
extern Sex      diff2di(Sex a, Sex b);
extern Sex      diff2zi(Sex a, Sex b);
#define diff2Ei diff2Ex
#define diff2Zi diff2Zx
#define diff2Vi diff2Vx
extern Sex      diff2Mi(Sex a, Sex b);

#define diff2ll diff2bb
#define diff2lb diff2bb
#define diff2lm diff2bm
#define diff2lr diff2br
#define diff2lf diff2bf
#define diff2le diff2be
#define diff2lc diff2bc
#define diff2lv diff2bv
#define diff2ld diff2bd
#define diff2lz diff2bz
#define diff2lE diff2bE
#define diff2lZ diff2bZ
#define diff2lV diff2bV
#define diff2lM	diff2bM

#define diff2bl diff2bb
extern Sex      diff2bb(Sex a, Sex b);
extern Sex      diff2bm(Sex a, Sex b);
#define diff2br diff2ir
#define diff2bf diff2if
#define diff2be diff2xe
#define diff2bc diff2xc
#define diff2bv diff2xv
extern Sex      diff2bd(Sex a, Sex b);
#define diff2bz diff2xz
#define diff2bE diff2xE
#define diff2bZ diff2xZ
#define diff2bV diff2xV
extern Sex      diff2bM(Sex a, Sex b);

#define diff2ml diff2mb
extern Sex      diff2mb(Sex a, Sex b);
extern Sex      diff2mm(Sex a, Sex b);
extern Sex      diff2mr(Sex a, Sex b);
#define diff2mf math_er
#define diff2me math_er
extern Sex      diff2mc(Sex a, Sex b);
#define diff2mv math_er
#define diff2md math_er
#define diff2mz math_er
#define diff2mE math_er
#define diff2mZ math_er
#define diff2mV math_er

#define diff2rl diff2rb
#define diff2rb diff2ri
extern Sex      diff2rm(Sex a, Sex b);
extern Sex      diff2rr(Sex a, Sex b);
#define diff2rf diff2if
#define diff2re diff2xe
#define diff2rc diff2xc
#define diff2rv diff2xv
extern Sex      diff2rd(Sex a, Sex b);
#define diff2rz diff2xz
#define diff2rE diff2xE
#define diff2rZ diff2xZ
#define diff2rV diff2xV
extern Sex      diff2rM(Sex a, Sex b);

#define diff2fl diff2fi
#define diff2fb diff2fi
#define diff2fm math_er
#define diff2fr diff2fi
extern Sex      diff2ff(Sex a, Sex b);
extern Sex      diff2fe(Sex a, Sex b);
#define diff2fc diff2xc
extern Sex      diff2fv(Sex a, Sex b);
extern Sex      diff2fd(Sex a, Sex b);
extern Sex      diff2fz(Sex a, Sex b);
extern Sex      diff2fE(Sex a, Sex b);
extern Sex      diff2fZ(Sex a, Sex b);
extern Sex      diff2fV(Sex a, Sex b);

#define diff2el diff2eb
#define diff2eb diff2ex
#define diff2em math_er
#define diff2er diff2ex
extern Sex      diff2ef(Sex a, Sex b);
extern Sex      diff2ee(Sex a, Sex b);
extern Sex      diff2ec(Sex a, Sex b);
extern Sex      diff2ev(Sex a, Sex b);
#define diff2ed diff2ex
extern Sex      diff2ez(Sex a, Sex b);
extern Sex      diff2eE(Sex a, Sex b);
extern Sex      diff2eZ(Sex a, Sex b);
extern Sex      diff2eV(Sex a, Sex b);

#define diff2cl diff2cx
#define diff2cb diff2cx
extern Sex      diff2cm(Sex a, Sex b);
#define diff2cr diff2cx
#define diff2cf diff2cx
extern Sex      diff2ce(Sex a, Sex b);
extern Sex      diff2cc(Sex a, Sex b);
#define diff2cv diff2cx
#define diff2cd diff2cx
extern Sex      diff2cz(Sex a, Sex b);
extern Sex      diff2cE(Sex a, Sex b);
// #define diff2cE diff2cx
extern Sex      diff2cZ(Sex a, Sex b);
// extern Sex diff2cV(Sex a, Sex b);
#define diff2cV	diff2cx
extern Sex      diff2cM(Sex a, Sex b);

#define diff2vl diff2vb
#define diff2vb diff2vx
#define diff2vm math_er
#define diff2vr diff2vx
extern Sex      diff2vf(Sex a, Sex b);
extern Sex      diff2ve(Sex a, Sex b);
#define diff2vc diff2xc
extern Sex      diff2vv(Sex a, Sex b);
#define diff2vd diff2vx
extern Sex      diff2vz(Sex a, Sex b);
extern Sex      diff2vE(Sex a, Sex b);
extern Sex      diff2vZ(Sex a, Sex b);
extern Sex      diff2vV(Sex a, Sex b);

#define diff2dl diff2db
extern Sex      diff2db(Sex a, Sex b);
#define diff2dm math_er
extern Sex      diff2dr(Sex a, Sex b);
extern Sex      diff2df(Sex a, Sex b);
#define diff2de diff2xe
#define diff2dc diff2xc
#define diff2dv diff2xv
extern Sex      diff2dd(Sex a, Sex b);
#define diff2dz diff2xz
#define diff2dE diff2xE
#define diff2dZ diff2xZ
#define diff2dV diff2xV

#define diff2zl diff2zb
#define diff2zb diff2zx
#define diff2zm math_er
#define diff2zr diff2zx
extern Sex      diff2zf(Sex a, Sex b);
extern Sex      diff2ze(Sex a, Sex b);
extern Sex      diff2zc(Sex a, Sex b);
extern Sex      diff2zv(Sex a, Sex b);
#define diff2zd diff2zx
extern Sex      diff2zz(Sex a, Sex b);
extern Sex      diff2zE(Sex a, Sex b);
extern Sex      diff2zZ(Sex a, Sex b);
extern Sex      diff2zV(Sex a, Sex b);

#define diff2El diff2Ex
#define diff2Eb diff2Ex
#define diff2Em math_er
#define diff2Er diff2Ex
extern Sex      diff2Ef(Sex a, Sex b);
extern Sex      diff2Ee(Sex a, Sex b);
extern Sex      diff2Ec(Sex a, Sex b);
// #define diff2Ec diff2xc
extern Sex      diff2Ev(Sex a, Sex b);
#define diff2Ed diff2Ex
extern Sex      diff2Ez(Sex a, Sex b);
extern Sex      diff2EE(Sex a, Sex b);
extern Sex      diff2EZ(Sex a, Sex b);
extern Sex      diff2EV(Sex a, Sex b);

#define diff2Zl diff2Zx
#define diff2Zb diff2Zx
#define diff2Zm math_er
#define diff2Zr diff2Zx
extern Sex      diff2Zf(Sex a, Sex b);
extern Sex      diff2Ze(Sex a, Sex b);
extern Sex      diff2Zc(Sex a, Sex b);
extern Sex      diff2Zv(Sex a, Sex b);
#define diff2Zd diff2Zx
extern Sex      diff2Zz(Sex a, Sex b);
extern Sex      diff2ZE(Sex a, Sex b);
extern Sex      diff2ZZ(Sex a, Sex b);
extern Sex      diff2ZV(Sex a, Sex b);

#define diff2Vl diff2Vx
#define diff2Vb diff2Vx
#define diff2Vm math_er
#define diff2Vr diff2Vx
extern Sex      diff2Vf(Sex a, Sex b);
extern Sex      diff2Ve(Sex a, Sex b);
// extern Sex diff2Vc(Sex a, Sex b);
#define diff2Vc	diff2xc
extern Sex      diff2Vv(Sex a, Sex b);
#define diff2Vd diff2Vx
extern Sex      diff2Vz(Sex a, Sex b);
extern Sex      diff2VE(Sex a, Sex b);
extern Sex      diff2VZ(Sex a, Sex b);
extern Sex      diff2VV(Sex a, Sex b);

#define diff2Ml diff2Mb
extern Sex      diff2Mb(Sex a, Sex b);
extern Sex      diff2Mr(Sex a, Sex b);
extern Sex      diff2Mc(Sex a, Sex b);
extern Sex      diff2MM(Sex a, Sex b);

/*
 * multiplications
 */

extern Sex      times2xc(Sex a, Sex b);
extern Sex      times2xe(Sex a, Sex b);
extern Sex      times2xv(Sex a, Sex b);
extern Sex      times2xz(Sex a, Sex b);
extern Sex      times2xE(Sex a, Sex b);
extern Sex      times2xZ(Sex a, Sex b);
extern Sex      times2xV(Sex a, Sex b);
extern Sex      times2cx(Sex a, Sex b);
extern Sex      times2ex(Sex a, Sex b);
extern Sex      times2zx(Sex a, Sex b);

extern Sex      times2ii(Sex a, Sex b);
#define times2il times2ib
extern Sex      times2ib(Sex a, Sex b);
extern Sex      times2im(Sex a, Sex b);
extern Sex      times2ir(Sex a, Sex b);
extern Sex      times2if(Sex a, Sex b);
extern Sex      times2ie(Sex a, Sex b);
#define times2ic times2xc
extern Sex      times2iv(Sex a, Sex b);
extern Sex      times2id(Sex a, Sex b);
#define times2iz times2xz
#define times2iE times2xE
#define times2iZ times2xZ
#define times2iV times2xV
extern Sex      times2iM(Sex a, Sex b);

#define times2ll times2bb
#define times2lb times2bb
#define times2lm times2bm
#define times2lr times2br
#define times2lf times2bf
#define times2le times2be
#define times2lc times2bc
#define times2lv times2bv
#define times2ld times2bd
#define times2lz times2bz
#define times2lE times2bE
#define times2lZ times2bZ
#define times2lV times2bV
#define times2lM times2bM

extern Sex      times2bb(Sex a, Sex b);
extern Sex      times2bm(Sex a, Sex b);
#define times2br times2ir
#define times2bf times2if
#define times2be times2xe
#define times2bc times2xc
#define times2bv times2xv
extern Sex      times2bd(Sex a, Sex b);
#define times2bz times2xz
#define times2bE times2xE
#define times2bZ times2xZ
#define times2bV times2xV
extern Sex      times2bM(Sex a, Sex b);

extern Sex      times2mm(Sex a, Sex b);
extern Sex      times2mr(Sex a, Sex b);
#define times2mf math_er
#define times2me math_er
extern Sex      times2mc(Sex a, Sex b);
#define times2mv math_er
#define times2md math_er
#define times2mz math_er
#define times2mE math_er
#define times2mZ math_er
#define times2mV math_er

extern Sex      times2rr(Sex a, Sex b);
extern Sex      times2rf(Sex a, Sex b);
#define times2re times2xe
#define times2rc times2xc
#define times2rv times2xv
extern Sex      times2rd(Sex a, Sex b);
#define times2rz times2xz
#define times2rE times2xE
#define times2rZ times2xZ
#define times2rV times2xV
extern Sex      times2rM(Sex a, Sex b);

extern Sex      times2ff(Sex a, Sex b);
extern Sex      times2fe(Sex a, Sex b);
#define times2fc times2xc
extern Sex      times2fv(Sex a, Sex b);
extern Sex      times2fd(Sex a, Sex b);
extern Sex      times2fz(Sex a, Sex b);
extern Sex      times2fE(Sex a, Sex b);
extern Sex      times2fZ(Sex a, Sex b);
extern Sex      times2fV(Sex a, Sex b);

extern Sex      times2ee(Sex a, Sex b);
extern Sex      times2ec(Sex a, Sex b);
extern Sex      times2ev(Sex a, Sex b);
#define times2ed times2ex
extern Sex      times2ez(Sex a, Sex b);
extern Sex      times2eE(Sex a, Sex b);
extern Sex      times2eZ(Sex a, Sex b);
extern Sex      times2eV(Sex a, Sex b);

extern Sex      times2cc(Sex a, Sex b);
#define times2cv times2cx
#define times2cd times2cx
extern Sex      times2cz(Sex a, Sex b);
extern Sex      times2cE(Sex a, Sex b);
// #define times2cE times2cx
extern Sex      times2cZ(Sex a, Sex b);
// extern Sex times2cV(Sex a, Sex b);
#define times2cV	times2cx
#define	times2cM	times2cx

extern Sex      times2vv(Sex a, Sex b);
extern Sex      times2vd(Sex a, Sex b);
extern Sex      times2vz(Sex a, Sex b);
extern Sex      times2vE(Sex a, Sex b);
extern Sex      times2vZ(Sex a, Sex b);
extern Sex      times2vV(Sex a, Sex b);

extern Sex      times2dd(Sex a, Sex b);
#define times2dz times2xz
#define times2dE times2xE
#define times2dZ times2xZ
#define times2dV times2xV

extern Sex      times2zz(Sex a, Sex b);
extern Sex      times2zE(Sex a, Sex b);
extern Sex      times2zZ(Sex a, Sex b);
extern Sex      times2zV(Sex a, Sex b);

extern Sex      times2EE(Sex a, Sex b);
extern Sex      times2EZ(Sex a, Sex b);
extern Sex      times2EV(Sex a, Sex b);

extern Sex      times2ZZ(Sex a, Sex b);
extern Sex      times2ZV(Sex a, Sex b);

extern Sex      times2VV(Sex a, Sex b);

#define times2Ml times2Mb
extern Sex      times2Mb(Sex a, Sex b);
extern Sex      times2Mr(Sex a, Sex b);
#define times2Mc	times2xc
extern Sex      times2MM(Sex a, Sex b);
/*
 * quotient
 */

extern Sex      quot2xc(Sex a, Sex b);
extern Sex      quot2xe(Sex a, Sex b);
extern Sex      quot2xv(Sex a, Sex b);
extern Sex      quot2xz(Sex a, Sex b);
extern Sex      quot2xE(Sex a, Sex b);
extern Sex      quot2xZ(Sex a, Sex b);
extern Sex      quot2xV(Sex a, Sex b);
extern Sex      quot2cx(Sex a, Sex b);
extern Sex      quot2ex(Sex a, Sex b);
extern Sex      quot2vx(Sex a, Sex b);
extern Sex      quot2zx(Sex a, Sex b);
extern Sex      quot2Ex(Sex a, Sex b);
extern Sex      quot2Zx(Sex a, Sex b);
extern Sex      quot2Vx(Sex a, Sex b);

extern Sex      quot2ii(Sex a, Sex b);
#define quot2il quot2ib
extern Sex      quot2ib(Sex a, Sex b);
extern Sex      quot2im(Sex a, Sex b);
extern Sex      quot2ir(Sex a, Sex b);
extern Sex      quot2if(Sex a, Sex b);
extern Sex      quot2ie(Sex a, Sex b);
#define quot2ic quot2xc
extern Sex      quot2iv(Sex a, Sex b);
extern Sex      quot2id(Sex a, Sex b);
#define quot2iz quot2xz
#define quot2iE quot2xE
#define quot2iZ quot2xZ
#define quot2iV quot2xV
extern Sex      quot2iM(Sex a, Sex b);

#define quot2li quot2bi
extern Sex      quot2bi(Sex a, Sex b);
extern Sex      quot2mi(Sex a, Sex b);
extern Sex      quot2ri(Sex a, Sex b);
extern Sex      quot2fi(Sex a, Sex b);
extern Sex      quot2ei(Sex a, Sex b);
#define quot2ci quot2cx
extern Sex      quot2vi(Sex a, Sex b);
extern Sex      quot2di(Sex a, Sex b);
#define quot2zi quot2zx
#define quot2Ei quot2Ex
#define quot2Zi quot2Zx
#define quot2Vi quot2Vx
extern Sex      quot2Mi(Sex a, Sex b);

#define quot2ll quot2bb
#define quot2lb quot2bb
#define quot2lm quot2bm
#define quot2lr quot2br
#define quot2lf quot2bf
#define quot2le quot2be
#define quot2lc quot2bc
#define quot2lv quot2bv
#define quot2ld quot2bd
#define quot2lz quot2bz
#define quot2lE quot2bE
#define quot2lZ quot2bZ
#define quot2lV quot2bV
#define quot2lM quot2bM

#define quot2bl quot2bb
extern Sex      quot2bb(Sex a, Sex b);
extern Sex      quot2bm(Sex a, Sex b);
extern Sex      quot2br(Sex a, Sex b);
#define quot2bf quot2if
#define quot2be quot2xe
#define quot2bc quot2xc
#define quot2bv quot2xv
extern Sex      quot2bd(Sex a, Sex b);
#define quot2bz quot2xz
#define quot2bE quot2xE
#define quot2bZ quot2xZ
#define quot2bV quot2xV
extern Sex      quot2bM(Sex a, Sex b);

#define quot2ml quot2mb
extern Sex      quot2mb(Sex a, Sex b);
extern Sex      quot2mm(Sex a, Sex b);
extern Sex      quot2mr(Sex a, Sex b);
#define quot2mf math_er
#define quot2me math_er
#define quot2mc quot2xc
#define quot2mv math_er
#define quot2md math_er
#define quot2mz math_er
#define quot2mE math_er
#define quot2mZ math_er
#define quot2mV math_er

#define quot2rl quot2rb
extern Sex      quot2rb(Sex a, Sex b);
extern Sex      quot2rm(Sex a, Sex b);
extern Sex      quot2rr(Sex a, Sex b);
#define quot2rf quot2if
#define quot2re quot2xe
#define quot2rc quot2xc
#define quot2rv quot2xv
extern Sex      quot2rd(Sex a, Sex b);
#define quot2rz quot2xz
#define quot2rE quot2xE
#define quot2rZ quot2xZ
#define quot2rV quot2xV
extern Sex      quot2rM(Sex a, Sex b);

#define quot2fl quot2fi
#define quot2fb quot2fi
#define quot2fm math_er
#define quot2fr quot2fi
extern Sex      quot2ff(Sex a, Sex b);
extern Sex      quot2fe(Sex a, Sex b);
#define quot2fc quot2xc
extern Sex      quot2fv(Sex a, Sex b);
extern Sex      quot2fd(Sex a, Sex b);
extern Sex      quot2fz(Sex a, Sex b);
extern Sex      quot2fE(Sex a, Sex b);
extern Sex      quot2fZ(Sex a, Sex b);
extern Sex      quot2fV(Sex a, Sex b);

#define quot2el quot2eb
#define quot2eb quot2ex
#define quot2em math_er
#define quot2er quot2ex
extern Sex      quot2ef(Sex a, Sex b);
extern Sex      quot2ee(Sex a, Sex b);
extern Sex      quot2ec(Sex a, Sex b);
extern Sex      quot2ev(Sex a, Sex b);
#define quot2ed quot2ex
extern Sex      quot2ez(Sex a, Sex b);
extern Sex      quot2eE(Sex a, Sex b);
extern Sex      quot2eZ(Sex a, Sex b);
extern Sex      quot2eV(Sex a, Sex b);

#define quot2cl quot2cx
#define quot2cb quot2cx
#define quot2cm quot2cx
#define quot2cr quot2cx
#define quot2cf quot2cx
extern Sex      quot2ce(Sex a, Sex b);
extern Sex      quot2cc(Sex a, Sex b);
extern Sex      quot2cv(Sex a, Sex b);
#define quot2cd quot2cx
extern Sex      quot2cz(Sex a, Sex b);
extern Sex      quot2cE(Sex a, Sex b);
// #define quot2cE quot2cx
extern Sex      quot2cZ(Sex a, Sex b);
// extern Sex quot2cV(Sex a, Sex b);
#define quot2cV	quot2cx
#define quot2cM	quot2cx

#define quot2vl quot2vb
#define quot2vb quot2vx
#define quot2vm math_er
#define quot2vr quot2vx
extern Sex      quot2vf(Sex a, Sex b);
extern Sex      quot2ve(Sex a, Sex b);
extern Sex      quot2vc(Sex a, Sex b);
extern Sex      quot2vv(Sex a, Sex b);
#define quot2vd quot2vx
extern Sex      quot2vz(Sex a, Sex b);
extern Sex      quot2vE(Sex a, Sex b);
extern Sex      quot2vZ(Sex a, Sex b);
extern Sex      quot2vV(Sex a, Sex b);

#define quot2dl quot2db
extern Sex      quot2db(Sex a, Sex b);
#define quot2dm math_er
extern Sex      quot2dr(Sex a, Sex b);
extern Sex      quot2df(Sex a, Sex b);
#define quot2de quot2xe
#define quot2dc quot2xc
#define quot2dv quot2xv
extern Sex      quot2dd(Sex a, Sex b);
#define quot2dz quot2xz
#define quot2dE quot2xE
#define quot2dZ quot2xZ
#define quot2dV quot2xV

#define quot2zl quot2zb
#define quot2zb quot2zx
#define quot2zm math_er
#define quot2zr quot2zx
extern Sex      quot2zf(Sex a, Sex b);
extern Sex      quot2ze(Sex a, Sex b);
extern Sex      quot2zc(Sex a, Sex b);
extern Sex      quot2zv(Sex a, Sex b);
#define quot2zd quot2zx
extern Sex      quot2zz(Sex a, Sex b);
extern Sex      quot2zE(Sex a, Sex b);
extern Sex      quot2zZ(Sex a, Sex b);
extern Sex      quot2zV(Sex a, Sex b);

#define quot2El quot2Ex
#define quot2Eb quot2Ex
#define quot2Em math_er
#define quot2Er quot2Ex
extern Sex      quot2Ef(Sex a, Sex b);
extern Sex      quot2Ee(Sex a, Sex b);
extern Sex      quot2Ec(Sex a, Sex b);
// #define quot2Ec quot2xc
extern Sex      quot2Ev(Sex a, Sex b);
#define quot2Ed quot2Ex
extern Sex      quot2Ez(Sex a, Sex b);
extern Sex      quot2EE(Sex a, Sex b);
extern Sex      quot2EZ(Sex a, Sex b);
extern Sex      quot2EV(Sex a, Sex b);

#define quot2Zl quot2Zx
#define quot2Zb quot2Zx
#define quot2Zm math_er
#define quot2Zr quot2Zx
extern Sex      quot2Zf(Sex a, Sex b);
extern Sex      quot2Ze(Sex a, Sex b);
extern Sex      quot2Zc(Sex a, Sex b);
extern Sex      quot2Zv(Sex a, Sex b);
#define quot2Zd quot2Zx
extern Sex      quot2Zz(Sex a, Sex b);
extern Sex      quot2ZE(Sex a, Sex b);
extern Sex      quot2ZZ(Sex a, Sex b);
extern Sex      quot2ZV(Sex a, Sex b);

#define quot2Vl quot2Vx
#define quot2Vb quot2Vx
#define quot2Vm math_er
#define quot2Vr quot2Vx
extern Sex      quot2Vf(Sex a, Sex b);
extern Sex      quot2Ve(Sex a, Sex b);
// extern Sex quot2Vc(Sex a, Sex b);
#define quot2Vc	quot2xc
extern Sex      quot2Vv(Sex a, Sex b);
#define quot2Vd quot2Vx
extern Sex      quot2Vz(Sex a, Sex b);
extern Sex      quot2VE(Sex a, Sex b);
extern Sex      quot2VZ(Sex a, Sex b);
extern Sex      quot2VV(Sex a, Sex b);

#define quot2Ml	quot2Mb
extern Sex      quot2Mb(Sex a, Sex b);
extern Sex      quot2Mr(Sex a, Sex b);
#define quot2Mc	quot2xc
extern Sex      quot2MM(Sex a, Sex b);
/*
 * 
 * 28a29 > #define quot2br quot2ir 32a34 > #define quot2ce quot2cx 37a40 > 
 * #define quot2cv quot2cx 47a51 > #define quot2ec quot2xc 91a96 > #define 
 * quot2rb quot2ri 98a104 > #define quot2vc quot2xc % 
 * 
 * 
 */

extern Sex      ratio2xz(Sex a, Sex b);
extern Sex      ratio2zx(Sex a, Sex b);

extern Sex      ratio2ii(Sex a, Sex b);
#define ratio2il ratio2ii
#define ratio2ib ratio2ii
#define ratio2li ratio2ii
#define ratio2ll ratio2ii
#define ratio2lb ratio2ii
#define ratio2bi ratio2ii
#define ratio2bl ratio2ii
#define ratio2bb ratio2ii

/*
 * remainder
 */

extern Sex      rem2cx(Sex a, Sex b);
extern Sex      rem2xc(Sex a, Sex b);
extern Sex      rem2xz(Sex a, Sex b);
extern Sex      rem2zx(Sex a, Sex b);

extern Sex      rem2ii(Sex a, Sex b);
#define rem2il rem2ib
extern Sex      rem2ib(Sex a, Sex b);
#define rem2im mkzero2
#define rem2ir mkzero2
#define rem2if mkzero2
#define rem2ie mkzero2
#define rem2ic rem2xc
#define rem2iv mkzero2
#define rem2id mkzero2
#define rem2iz mkzero2
#define rem2iE mkzero2
#define rem2iZ mkzero2
#define rem2iV mkzero2
#define rem2iM mkzero2

#define rem2li rem2bi
extern Sex      rem2bi(Sex a, Sex b);
#define rem2mi mkzero2
#define rem2ri mkzero2
#define rem2fi mkzero2
#define rem2ei mkzero2
#define rem2ci rem2cx
#define rem2vi mkzero2
#define rem2di mkzero2
#define rem2zi mkzero2
#define rem2Ei mkzero2
#define rem2Zi mkzero2
#define rem2Vi mkzero2
#define rem2Mi mkzero2

#define rem2ll rem2bb
#define rem2lb rem2bb
#define rem2lm rem2bm
#define rem2lr rem2br
#define rem2lf rem2bf
#define rem2le rem2be
#define rem2lc rem2xc
#define rem2lv rem2bv
#define rem2ld rem2bd
#define rem2lz rem2bz
#define rem2lE rem2bE
#define rem2lZ rem2bZ
#define rem2lV rem2bV
#define rem2lM rem2bM

#define rem2bl rem2bb
extern Sex      rem2bb(Sex a, Sex b);
#define rem2bm mkzero2
#define rem2br mkzero2
#define rem2bf mkzero2
#define rem2be mkzero2
#define rem2bc rem2xc
#define rem2bv mkzero2
#define rem2bd mkzero2
#define rem2bz mkzero2
#define rem2bE mkzero2
#define rem2bZ mkzero2
#define rem2bV mkzero2
#define rem2bM mkzero2

#define rem2ml mkzero2
#define rem2mb mkzero2
#define rem2mm mkzero2
#define rem2mr mkzero2
#define rem2mf math_er
#define rem2me math_er
#define rem2mc rem2xc
#define rem2mv math_er
#define rem2md math_er
#define rem2mz math_er
#define rem2mE math_er
#define rem2mZ math_er
#define rem2mV math_er
#define rem2mM math_er

#define rem2rl mkzero2
#define rem2rb mkzero2
#define rem2rm mkzero2
#define rem2rr mkzero2
#define rem2rf mkzero2
#define rem2re mkzero2
#define rem2rc rem2xc
#define rem2rv mkzero2
#define rem2rd mkzero2
#define rem2rz mkzero2
#define rem2rE mkzero2
#define rem2rZ mkzero2
#define rem2rV mkzero2
#define rem2rM mkzero2

#define rem2fl mkzero2
#define rem2fb mkzero2
#define rem2fm math_er
#define rem2fr mkzero2
#define rem2ff mkzero2
#define rem2fe mkzero2
#define rem2fc mkzero2
#define rem2fv mkzero2
#define rem2fd mkzero2
#define rem2fz mkzero2
#define rem2fE mkzero2
#define rem2fZ mkzero2
#define rem2fV mkzero2
#define rem2fM math_er

#define rem2el mkzero2
#define rem2eb mkzero2
#define rem2em math_er
#define rem2er mkzero2
#define rem2ef mkzero2
#define rem2ee mkzero2
#define rem2ec mkzero2
#define rem2ev mkzero2
#define rem2ed mkzero2
#define rem2ez mkzero2
#define rem2eE mkzero2
#define rem2eZ mkzero2
#define rem2eV mkzero2
#define rem2eM math_er

#define rem2cl rem2cb
#define rem2cb rem2cx
#define rem2cm rem2cx
#define rem2cr rem2cx
#define rem2cf mkzero2
#define rem2ce mkzero2
extern Sex      rem2cc(Sex a, Sex b);
#define rem2cv mkzero2
#define rem2cd mkzero2
#define rem2cz mkzero2
#define rem2cE mkzero2
#define rem2cZ mkzero2
#define rem2cV mkzero2
#define rem2cM rem2cx

#define rem2vl mkzero2
#define rem2vb mkzero2
#define rem2vm math_er
#define rem2vr mkzero2
#define rem2vf mkzero2
#define rem2ve mkzero2
#define rem2vc mkzero2
#define rem2vv mkzero2
#define rem2vd mkzero2
#define rem2vz mkzero2
#define rem2vE mkzero2
#define rem2vZ mkzero2
#define rem2vV mkzero2
#define rem2vM math_er

#define rem2dl mkzero2
#define rem2db mkzero2
#define rem2dm math_er
#define rem2dr mkzero2
#define rem2df mkzero2
#define rem2de mkzero2
#define rem2dc mkzero2
#define rem2dv mkzero2
#define rem2dd mkzero2
#define rem2dz mkzero2
#define rem2dE mkzero2
#define rem2dZ mkzero2
#define rem2dV mkzero2
#define rem2dM math_er

#define rem2zl mkzero2
#define rem2zb mkzero2
#define rem2zm math_er
#define rem2zr mkzero2
#define rem2zf mkzero2
#define rem2ze mkzero2
#define rem2zc mkzero2
#define rem2zv mkzero2
#define rem2zd mkzero2
#define rem2zz mkzero2
#define rem2zE mkzero2
#define rem2zZ mkzero2
#define rem2zV mkzero2
#define rem2zM math_er

#define rem2El mkzero2
#define rem2Eb mkzero2
#define rem2Em math_er
#define rem2Er mkzero2
#define rem2Ef mkzero2
#define rem2Ee mkzero2
#define rem2Ec mkzero2
#define rem2Ev mkzero2
#define rem2Ed mkzero2
#define rem2Ez mkzero2
#define rem2EE mkzero2
#define rem2EZ mkzero2
#define rem2EV mkzero2
#define rem2EM math_er

#define rem2Zl mkzero2
#define rem2Zb mkzero2
#define rem2Zm math_er
#define rem2Zr mkzero2
#define rem2Zf mkzero2
#define rem2Ze mkzero2
// #define rem2Zc rem2xc
#define rem2Zc mkzero2
#define rem2Zv mkzero2
#define rem2Zd mkzero2
#define rem2Zz mkzero2
#define rem2ZE mkzero2
#define rem2ZZ mkzero2
#define rem2ZV mkzero2
#define rem2ZM math_er

#define rem2Vl mkzero2
#define rem2Vb mkzero2
#define rem2Vm math_er
#define rem2Vr mkzero2
#define rem2Vf mkzero2
#define rem2Ve mkzero2
#define rem2Vc mkzero2
#define rem2Vv mkzero2
#define rem2Vd mkzero2
#define rem2Vz mkzero2
#define rem2VE mkzero2
#define rem2VZ mkzero2
#define rem2VV mkzero2
#define rem2VM math_er


#define rem2Ml mkzero2
#define rem2Mb mkzero2
#define rem2Mm math_er
#define rem2Mr mkzero2
#define rem2Mf math_er
#define rem2Me math_er
#define rem2Mc rem2xc
#define rem2Mv math_er
#define rem2Md math_er
#define rem2Mz math_er
#define rem2ME math_er
#define rem2MZ math_er
#define rem2MV math_er
#define rem2MM mkzero2

/*
 * modulus
 */

extern Sex      mod2xx(Sex a, Sex b);

extern Sex      mod2ii(Sex a, Sex b);
extern Sex      mod2il(Sex a, Sex b);
extern Sex      mod2ib(Sex a, Sex b);
extern Sex      mod2im(Sex a, Sex b);
extern Sex      mod2ir(Sex a, Sex b);
extern Sex      mod2if(Sex a, Sex b);
extern Sex      mod2ie(Sex a, Sex b);
extern Sex      mod2ic(Sex a, Sex b);
extern Sex      mod2iv(Sex a, Sex b);
extern Sex      mod2id(Sex a, Sex b);
extern Sex      mod2iz(Sex a, Sex b);
extern Sex      mod2iE(Sex a, Sex b);
extern Sex      mod2iZ(Sex a, Sex b);
extern Sex      mod2iV(Sex a, Sex b);
extern Sex      mod2iM(Sex a, Sex b);

extern Sex      mod2li(Sex a, Sex b);
extern Sex      mod2bi(Sex a, Sex b);
extern Sex      mod2mi(Sex a, Sex b);
extern Sex      mod2ri(Sex a, Sex b);
extern Sex      mod2fi(Sex a, Sex b);
extern Sex      mod2ei(Sex a, Sex b);
extern Sex      mod2ci(Sex a, Sex b);
extern Sex      mod2vi(Sex a, Sex b);
extern Sex      mod2di(Sex a, Sex b);
extern Sex      mod2zi(Sex a, Sex b);
extern Sex      mod2Ei(Sex a, Sex b);
extern Sex      mod2Zi(Sex a, Sex b);
extern Sex      mod2Vi(Sex a, Sex b);
extern Sex      mod2Mi(Sex a, Sex b);

extern Sex      mod2ll(Sex a, Sex b);
extern Sex      mod2lb(Sex a, Sex b);
extern Sex      mod2lm(Sex a, Sex b);
extern Sex      mod2lr(Sex a, Sex b);
extern Sex      mod2lf(Sex a, Sex b);
extern Sex      mod2le(Sex a, Sex b);
extern Sex      mod2lc(Sex a, Sex b);
extern Sex      mod2lv(Sex a, Sex b);
extern Sex      mod2ld(Sex a, Sex b);
extern Sex      mod2lz(Sex a, Sex b);
extern Sex      mod2lE(Sex a, Sex b);
extern Sex      mod2lZ(Sex a, Sex b);
extern Sex      mod2lV(Sex a, Sex b);
extern Sex      mod2lM(Sex a, Sex b);

extern Sex      mod2bl(Sex a, Sex b);
extern Sex      mod2bb(Sex a, Sex b);
extern Sex      mod2bm(Sex a, Sex b);
extern Sex      mod2br(Sex a, Sex b);
extern Sex      mod2bf(Sex a, Sex b);
extern Sex      mod2be(Sex a, Sex b);
extern Sex      mod2bc(Sex a, Sex b);
extern Sex      mod2bv(Sex a, Sex b);
extern Sex      mod2bd(Sex a, Sex b);
extern Sex      mod2bz(Sex a, Sex b);
extern Sex      mod2bE(Sex a, Sex b);
extern Sex      mod2bZ(Sex a, Sex b);
extern Sex      mod2bV(Sex a, Sex b);
extern Sex      mod2bM(Sex a, Sex b);

extern Sex      mod2ml(Sex a, Sex b);
extern Sex      mod2mb(Sex a, Sex b);
extern Sex      mod2mm(Sex a, Sex b);
extern Sex      mod2mr(Sex a, Sex b);
extern Sex      mod2mf(Sex a, Sex b);
extern Sex      mod2me(Sex a, Sex b);
extern Sex      mod2mc(Sex a, Sex b);
extern Sex      mod2mv(Sex a, Sex b);
extern Sex      mod2md(Sex a, Sex b);
extern Sex      mod2mz(Sex a, Sex b);
extern Sex      mod2mE(Sex a, Sex b);
extern Sex      mod2mZ(Sex a, Sex b);
extern Sex      mod2mV(Sex a, Sex b);
extern Sex      mod2mM(Sex a, Sex b);

extern Sex      mod2rl(Sex a, Sex b);
extern Sex      mod2rb(Sex a, Sex b);
extern Sex      mod2rm(Sex a, Sex b);
extern Sex      mod2rr(Sex a, Sex b);
extern Sex      mod2rf(Sex a, Sex b);
extern Sex      mod2re(Sex a, Sex b);
extern Sex      mod2rc(Sex a, Sex b);
extern Sex      mod2rv(Sex a, Sex b);
extern Sex      mod2rd(Sex a, Sex b);
extern Sex      mod2rz(Sex a, Sex b);
extern Sex      mod2rE(Sex a, Sex b);
extern Sex      mod2rZ(Sex a, Sex b);
extern Sex      mod2rV(Sex a, Sex b);
extern Sex      mod2rM(Sex a, Sex b);

extern Sex      mod2fl(Sex a, Sex b);
extern Sex      mod2fb(Sex a, Sex b);
extern Sex      mod2fm(Sex a, Sex b);
extern Sex      mod2fr(Sex a, Sex b);
extern Sex      mod2ff(Sex a, Sex b);
extern Sex      mod2fe(Sex a, Sex b);
extern Sex      mod2fc(Sex a, Sex b);
extern Sex      mod2fv(Sex a, Sex b);
extern Sex      mod2fd(Sex a, Sex b);
extern Sex      mod2fz(Sex a, Sex b);
extern Sex      mod2fE(Sex a, Sex b);
extern Sex      mod2fZ(Sex a, Sex b);
extern Sex      mod2fV(Sex a, Sex b);
extern Sex      mod2fM(Sex a, Sex b);

extern Sex      mod2el(Sex a, Sex b);
extern Sex      mod2eb(Sex a, Sex b);
extern Sex      mod2em(Sex a, Sex b);
extern Sex      mod2er(Sex a, Sex b);
extern Sex      mod2ef(Sex a, Sex b);
extern Sex      mod2ee(Sex a, Sex b);
extern Sex      mod2ec(Sex a, Sex b);
extern Sex      mod2ev(Sex a, Sex b);
extern Sex      mod2ed(Sex a, Sex b);
extern Sex      mod2ez(Sex a, Sex b);
extern Sex      mod2eE(Sex a, Sex b);
extern Sex      mod2eZ(Sex a, Sex b);
extern Sex      mod2eV(Sex a, Sex b);
extern Sex      mod2eM(Sex a, Sex b);

extern Sex      mod2cl(Sex a, Sex b);
extern Sex      mod2cb(Sex a, Sex b);
extern Sex      mod2cm(Sex a, Sex b);
extern Sex      mod2cr(Sex a, Sex b);
extern Sex      mod2cf(Sex a, Sex b);
extern Sex      mod2ce(Sex a, Sex b);
extern Sex      mod2cc(Sex a, Sex b);
extern Sex      mod2cv(Sex a, Sex b);
extern Sex      mod2cd(Sex a, Sex b);
extern Sex      mod2cz(Sex a, Sex b);
extern Sex      mod2cE(Sex a, Sex b);
extern Sex      mod2cZ(Sex a, Sex b);
extern Sex      mod2cV(Sex a, Sex b);
extern Sex      mod2cM(Sex a, Sex b);

extern Sex      mod2vl(Sex a, Sex b);
extern Sex      mod2vb(Sex a, Sex b);
extern Sex      mod2vm(Sex a, Sex b);
extern Sex      mod2vr(Sex a, Sex b);
extern Sex      mod2vf(Sex a, Sex b);
extern Sex      mod2ve(Sex a, Sex b);
extern Sex      mod2vc(Sex a, Sex b);
extern Sex      mod2vv(Sex a, Sex b);
extern Sex      mod2vd(Sex a, Sex b);
extern Sex      mod2vz(Sex a, Sex b);
extern Sex      mod2vE(Sex a, Sex b);
extern Sex      mod2vZ(Sex a, Sex b);
extern Sex      mod2vV(Sex a, Sex b);
extern Sex      mod2vM(Sex a, Sex b);

extern Sex      mod2dl(Sex a, Sex b);
extern Sex      mod2db(Sex a, Sex b);
extern Sex      mod2dm(Sex a, Sex b);
extern Sex      mod2dr(Sex a, Sex b);
extern Sex      mod2df(Sex a, Sex b);
extern Sex      mod2de(Sex a, Sex b);
extern Sex      mod2dc(Sex a, Sex b);
extern Sex      mod2dv(Sex a, Sex b);
extern Sex      mod2dd(Sex a, Sex b);
extern Sex      mod2dz(Sex a, Sex b);
extern Sex      mod2dE(Sex a, Sex b);
extern Sex      mod2dZ(Sex a, Sex b);
extern Sex      mod2dV(Sex a, Sex b);
extern Sex      mod2dM(Sex a, Sex b);

extern Sex      mod2zl(Sex a, Sex b);
extern Sex      mod2zb(Sex a, Sex b);
extern Sex      mod2zm(Sex a, Sex b);
extern Sex      mod2zr(Sex a, Sex b);
extern Sex      mod2zf(Sex a, Sex b);
extern Sex      mod2ze(Sex a, Sex b);
extern Sex      mod2zc(Sex a, Sex b);
extern Sex      mod2zv(Sex a, Sex b);
extern Sex      mod2zd(Sex a, Sex b);
extern Sex      mod2zz(Sex a, Sex b);
extern Sex      mod2zE(Sex a, Sex b);
extern Sex      mod2zZ(Sex a, Sex b);
extern Sex      mod2zV(Sex a, Sex b);
extern Sex      mod2zM(Sex a, Sex b);

extern Sex      mod2El(Sex a, Sex b);
extern Sex      mod2Eb(Sex a, Sex b);
extern Sex      mod2Em(Sex a, Sex b);
extern Sex      mod2Er(Sex a, Sex b);
extern Sex      mod2Ef(Sex a, Sex b);
extern Sex      mod2Ee(Sex a, Sex b);
extern Sex      mod2Ec(Sex a, Sex b);
extern Sex      mod2Ev(Sex a, Sex b);
extern Sex      mod2Ed(Sex a, Sex b);
extern Sex      mod2Ez(Sex a, Sex b);
extern Sex      mod2EE(Sex a, Sex b);
extern Sex      mod2EZ(Sex a, Sex b);
extern Sex      mod2EV(Sex a, Sex b);
extern Sex      mod2EM(Sex a, Sex b);

extern Sex      mod2Zl(Sex a, Sex b);
extern Sex      mod2Zb(Sex a, Sex b);
extern Sex      mod2Zm(Sex a, Sex b);
extern Sex      mod2Zr(Sex a, Sex b);
extern Sex      mod2Zf(Sex a, Sex b);
extern Sex      mod2Ze(Sex a, Sex b);
extern Sex      mod2Zc(Sex a, Sex b);
extern Sex      mod2Zv(Sex a, Sex b);
extern Sex      mod2Zd(Sex a, Sex b);
extern Sex      mod2Zz(Sex a, Sex b);
extern Sex      mod2ZE(Sex a, Sex b);
extern Sex      mod2ZZ(Sex a, Sex b);
extern Sex      mod2ZV(Sex a, Sex b);
extern Sex      mod2ZM(Sex a, Sex b);

extern Sex      mod2Vl(Sex a, Sex b);
extern Sex      mod2Vb(Sex a, Sex b);
extern Sex      mod2Vm(Sex a, Sex b);
extern Sex      mod2Vr(Sex a, Sex b);
extern Sex      mod2Vf(Sex a, Sex b);
extern Sex      mod2Ve(Sex a, Sex b);
extern Sex      mod2Vc(Sex a, Sex b);
extern Sex      mod2Vv(Sex a, Sex b);
extern Sex      mod2Vd(Sex a, Sex b);
extern Sex      mod2Vz(Sex a, Sex b);
extern Sex      mod2VE(Sex a, Sex b);
extern Sex      mod2VZ(Sex a, Sex b);
extern Sex      mod2VV(Sex a, Sex b);
extern Sex      mod2VM(Sex a, Sex b);

extern Sex      mod2Ml(Sex a, Sex b);
extern Sex      mod2Mb(Sex a, Sex b);
extern Sex      mod2Mm(Sex a, Sex b);
extern Sex      mod2Mr(Sex a, Sex b);
extern Sex      mod2Mf(Sex a, Sex b);
extern Sex      mod2Me(Sex a, Sex b);
extern Sex      mod2Mc(Sex a, Sex b);
extern Sex      mod2Mv(Sex a, Sex b);
extern Sex      mod2Md(Sex a, Sex b);
extern Sex      mod2Mz(Sex a, Sex b);
extern Sex      mod2ME(Sex a, Sex b);
extern Sex      mod2MZ(Sex a, Sex b);
extern Sex      mod2MV(Sex a, Sex b);
extern Sex      mod2MM(Sex a, Sex b);

/*
 *
 */

#define mod2EE mod2xx
#define mod2EV mod2xx
#define mod2EZ mod2xx
#define mod2Eb mod2xx
#define mod2Ec mod2xx
#define mod2Ed mod2xx
#define mod2Ee mod2xx
#define mod2Ef mod2xx
#define mod2Ei mod2xx
#define mod2El mod2Eb
#define mod2Em math_er
#define mod2Er mod2xx
#define mod2Ev mod2xx
#define mod2Ez mod2xx
#define mod2VE mod2xx
#define mod2VV mod2xx
#define mod2VZ mod2xx
#define mod2Vb mod2xx
#define mod2Vc mod2xx
#define mod2Vd mod2xx
#define mod2Ve mod2xx
#define mod2Vf mod2xx
#define mod2Vi mod2xx
#define mod2Vl mod2Vb
#define mod2Vm math_er
#define mod2Vr mod2xx
#define mod2Vv mod2xx
#define mod2Vz mod2xx
#define mod2ZE mod2xx
#define mod2ZV mod2xx
#define mod2ZZ mod2xx
#define mod2Zb mod2xx
#define mod2Zc mod2xx
#define mod2Zd mod2xx
#define mod2Ze mod2xx
#define mod2Zf mod2xx
#define mod2Zi mod2xx
#define mod2Zl mod2Zb
#define mod2Zm math_er
#define mod2Zr mod2xx
#define mod2Zv mod2xx
#define mod2Zz mod2xx
#define mod2bE mod2xx
#define mod2bV mod2xx
#define mod2bZ mod2xx
#define mod2bc mod2xx
#define mod2bd mod2xx
#define mod2be mod2xx
#define mod2bf mod2xx
#define mod2bl mod2bb
#define mod2bm math_er
#define mod2br mod2xx
#define mod2bv mod2xx
#define mod2bz mod2xx
#define mod2cE mod2xx
#define mod2cV mod2xx
#define mod2cZ mod2xx
#define mod2cb mod2xx
#define mod2cc mod2xx
#define mod2cd mod2xx
#define mod2ce mod2xx
#define mod2cf mod2xx
#define mod2ci mod2xx
#define mod2cl mod2cb
#define mod2cm math_er
#define mod2cr mod2xx
#define mod2cv mod2xx
#define mod2cz mod2xx
#define mod2dE mod2xx
#define mod2dV mod2xx
#define mod2dZ mod2xx
#define mod2db mod2xx
#define mod2dc mod2xx
#define mod2dd mod2xx
#define mod2de mod2xx
#define mod2df mod2xx
#define mod2di mod2xx
#define mod2dl mod2db
#define mod2dm math_er
#define mod2dr mod2xx
#define mod2dv mod2xx
#define mod2dz mod2xx
#define mod2eE mod2xx
#define mod2eV mod2xx
#define mod2eZ mod2xx
#define mod2eb mod2xx
#define mod2ec mod2xx
#define mod2ed mod2xx
#define mod2ee mod2xx
#define mod2ef mod2xx
#define mod2ei mod2xx
#define mod2el	mod2eb
#define mod2em math_er
#define mod2er mod2xx
#define mod2ev mod2xx
#define mod2ez mod2xx
#define mod2fE mod2xx
#define mod2fV mod2xx
#define mod2fZ mod2xx
#define mod2fb mod2xx
#define mod2fc mod2xx
#define mod2fd mod2xx
#define mod2fe mod2xx
#define mod2ff mod2xx
#define mod2fi mod2xx
#define mod2fl mod2fb
#define mod2fm math_er
#define mod2fr mod2xx
#define mod2fv mod2xx
#define mod2fz mod2xx
#define mod2iE mod2xx
#define mod2iV mod2xx
#define mod2iZ mod2xx
#define mod2ic mod2xx
#define mod2id mod2xx
#define mod2ie mod2xx
#define mod2if mod2xx
#define mod2il	mod2ib
#define mod2im math_er
#define mod2ir mod2xx
#define mod2iv mod2xx
#define mod2iz mod2xx
#define mod2lE mod2xx
#define mod2lV mod2xx
#define mod2lZ mod2xx
#define mod2lb mod2bb
#define mod2lc mod2xx
#define mod2ld mod2xx
#define mod2le mod2xx
#define mod2lf mod2xx
#define mod2li mod2bi
#define mod2ll mod2bb
#define mod2lm mod2bm
#define mod2lr mod2xx
#define mod2lv mod2xx
#define mod2lz mod2xx
#define mod2mE math_er
#define mod2mV math_er
#define mod2mZ math_er
#define mod2mb math_er
#define mod2mc math_er
#define mod2md math_er
#define mod2me math_er
#define mod2mf math_er
#define mod2mi math_er
#define mod2ml mod2mb
#define mod2mm math_er
#define mod2mr math_er
#define mod2mv math_er
#define mod2mz math_er
#define mod2rE mod2xx
#define mod2rV mod2xx
#define mod2rZ mod2xx
// #define mod2rb mod2xx
#define mod2rc mod2xx
#define mod2rd mod2xx
#define mod2re mod2xx
#define mod2rf mod2xx
// #define mod2ri mod2xx
#define mod2rl mod2rb
#define mod2rm math_er
#define mod2rr mod2xx
#define mod2rv mod2xx
#define mod2rz mod2xx
#define mod2vE mod2xx
#define mod2vV mod2xx
#define mod2vZ mod2xx
#define mod2vb mod2xx
#define mod2vc mod2xx
#define mod2vd mod2xx
#define mod2ve mod2xx
#define mod2vf mod2xx
#define mod2vi mod2xx
#define mod2vl mod2vb
#define mod2vm math_er
#define mod2vr mod2xx
#define mod2vv mod2xx
#define mod2vz mod2xx
#define mod2zE mod2xx
#define mod2zV mod2xx
#define mod2zZ mod2xx
#define mod2zb mod2xx
#define mod2zc mod2xx
#define mod2zd mod2xx
#define mod2ze mod2xx
#define mod2zf mod2xx
#define mod2zi mod2xx
#define mod2zl mod2zb
#define mod2zm math_er
#define mod2zr mod2xx
#define mod2zv mod2xx
#define mod2zz mod2xx

#define mod2iM math_er
#define mod2lM math_er
#define mod2bM math_er
#define mod2rM math_er
#define mod2fM math_er
#define mod2mM math_er
#define mod2eM math_er
#define mod2dM math_er
#define mod2EM math_er
#define mod2VM math_er
#define mod2ZM math_er
#define mod2vM math_er
#define mod2cM math_er
#define mod2zM math_er

#define mod2Mi math_er
#define mod2Ml math_er
#define mod2Mb math_er
#define mod2Mr math_er
#define mod2Mf math_er
#define mod2Mm math_er
#define mod2Me math_er
#define mod2Md math_er
#define mod2Mv math_er
#define mod2Mz math_er
#define mod2Mc math_er
#define mod2ME math_er
#define mod2MV math_er
#define mod2MZ math_er
#define mod2MM math_er


/*
 * smodulus
 */

extern Sex      smod2xx(Sex a, Sex b);

extern Sex      smod2ii(Sex a, Sex b);
extern Sex      smod2il(Sex a, Sex b);
extern Sex      smod2ib(Sex a, Sex b);
extern Sex      smod2im(Sex a, Sex b);
extern Sex      smod2ir(Sex a, Sex b);
extern Sex      smod2if(Sex a, Sex b);
extern Sex      smod2ie(Sex a, Sex b);
extern Sex      smod2ic(Sex a, Sex b);
extern Sex      smod2iv(Sex a, Sex b);
extern Sex      smod2id(Sex a, Sex b);
extern Sex      smod2iz(Sex a, Sex b);
extern Sex      smod2iE(Sex a, Sex b);
extern Sex      smod2iZ(Sex a, Sex b);
extern Sex      smod2iV(Sex a, Sex b);
extern Sex      smod2iM(Sex a, Sex b);

extern Sex      smod2li(Sex a, Sex b);
extern Sex      smod2bi(Sex a, Sex b);
extern Sex      smod2mi(Sex a, Sex b);
extern Sex      smod2ri(Sex a, Sex b);
extern Sex      smod2fi(Sex a, Sex b);
extern Sex      smod2ei(Sex a, Sex b);
extern Sex      smod2ci(Sex a, Sex b);
extern Sex      smod2vi(Sex a, Sex b);
extern Sex      smod2di(Sex a, Sex b);
extern Sex      smod2zi(Sex a, Sex b);
extern Sex      smod2Ei(Sex a, Sex b);
extern Sex      smod2Zi(Sex a, Sex b);
extern Sex      smod2Vi(Sex a, Sex b);
extern Sex      smod2Mi(Sex a, Sex b);

extern Sex      smod2ll(Sex a, Sex b);
extern Sex      smod2lb(Sex a, Sex b);
extern Sex      smod2lm(Sex a, Sex b);
extern Sex      smod2lr(Sex a, Sex b);
extern Sex      smod2lf(Sex a, Sex b);
extern Sex      smod2le(Sex a, Sex b);
extern Sex      smod2lc(Sex a, Sex b);
extern Sex      smod2lv(Sex a, Sex b);
extern Sex      smod2ld(Sex a, Sex b);
extern Sex      smod2lz(Sex a, Sex b);
extern Sex      smod2lE(Sex a, Sex b);
extern Sex      smod2lZ(Sex a, Sex b);
extern Sex      smod2lV(Sex a, Sex b);
extern Sex      smod2lM(Sex a, Sex b);

extern Sex      smod2bl(Sex a, Sex b);
extern Sex      smod2bb(Sex a, Sex b);
extern Sex      smod2bm(Sex a, Sex b);
extern Sex      smod2br(Sex a, Sex b);
extern Sex      smod2bf(Sex a, Sex b);
extern Sex      smod2be(Sex a, Sex b);
extern Sex      smod2bc(Sex a, Sex b);
extern Sex      smod2bv(Sex a, Sex b);
extern Sex      smod2bd(Sex a, Sex b);
extern Sex      smod2bz(Sex a, Sex b);
extern Sex      smod2bE(Sex a, Sex b);
extern Sex      smod2bZ(Sex a, Sex b);
extern Sex      smod2bV(Sex a, Sex b);
extern Sex      smod2bM(Sex a, Sex b);

extern Sex      smod2ml(Sex a, Sex b);
extern Sex      smod2mb(Sex a, Sex b);
extern Sex      smod2mm(Sex a, Sex b);
extern Sex      smod2mr(Sex a, Sex b);
extern Sex      smod2mf(Sex a, Sex b);
extern Sex      smod2me(Sex a, Sex b);
extern Sex      smod2mc(Sex a, Sex b);
extern Sex      smod2mv(Sex a, Sex b);
extern Sex      smod2md(Sex a, Sex b);
extern Sex      smod2mz(Sex a, Sex b);
extern Sex      smod2mE(Sex a, Sex b);
extern Sex      smod2mZ(Sex a, Sex b);
extern Sex      smod2mV(Sex a, Sex b);
extern Sex      smod2mM(Sex a, Sex b);

extern Sex      smod2rl(Sex a, Sex b);
extern Sex      smod2rb(Sex a, Sex b);
extern Sex      smod2rm(Sex a, Sex b);
extern Sex      smod2rr(Sex a, Sex b);
extern Sex      smod2rf(Sex a, Sex b);
extern Sex      smod2re(Sex a, Sex b);
extern Sex      smod2rc(Sex a, Sex b);
extern Sex      smod2rv(Sex a, Sex b);
extern Sex      smod2rd(Sex a, Sex b);
extern Sex      smod2rz(Sex a, Sex b);
extern Sex      smod2rE(Sex a, Sex b);
extern Sex      smod2rZ(Sex a, Sex b);
extern Sex      smod2rV(Sex a, Sex b);
extern Sex      smod2rM(Sex a, Sex b);

extern Sex      smod2fl(Sex a, Sex b);
extern Sex      smod2fb(Sex a, Sex b);
extern Sex      smod2fm(Sex a, Sex b);
extern Sex      smod2fr(Sex a, Sex b);
extern Sex      smod2ff(Sex a, Sex b);
extern Sex      smod2fe(Sex a, Sex b);
extern Sex      smod2fc(Sex a, Sex b);
extern Sex      smod2fv(Sex a, Sex b);
extern Sex      smod2fd(Sex a, Sex b);
extern Sex      smod2fz(Sex a, Sex b);
extern Sex      smod2fE(Sex a, Sex b);
extern Sex      smod2fZ(Sex a, Sex b);
extern Sex      smod2fV(Sex a, Sex b);
extern Sex      smod2fM(Sex a, Sex b);

extern Sex      smod2el(Sex a, Sex b);
extern Sex      smod2eb(Sex a, Sex b);
extern Sex      smod2em(Sex a, Sex b);
extern Sex      smod2er(Sex a, Sex b);
extern Sex      smod2ef(Sex a, Sex b);
extern Sex      smod2ee(Sex a, Sex b);
extern Sex      smod2ec(Sex a, Sex b);
extern Sex      smod2ev(Sex a, Sex b);
extern Sex      smod2ed(Sex a, Sex b);
extern Sex      smod2ez(Sex a, Sex b);
extern Sex      smod2eE(Sex a, Sex b);
extern Sex      smod2eZ(Sex a, Sex b);
extern Sex      smod2eV(Sex a, Sex b);
extern Sex      smod2eM(Sex a, Sex b);

extern Sex      smod2cl(Sex a, Sex b);
extern Sex      smod2cb(Sex a, Sex b);
extern Sex      smod2cm(Sex a, Sex b);
extern Sex      smod2cr(Sex a, Sex b);
extern Sex      smod2cf(Sex a, Sex b);
extern Sex      smod2ce(Sex a, Sex b);
extern Sex      smod2cc(Sex a, Sex b);
extern Sex      smod2cv(Sex a, Sex b);
extern Sex      smod2cd(Sex a, Sex b);
extern Sex      smod2cz(Sex a, Sex b);
extern Sex      smod2cE(Sex a, Sex b);
extern Sex      smod2cZ(Sex a, Sex b);
extern Sex      smod2cV(Sex a, Sex b);
extern Sex      smod2cM(Sex a, Sex b);

extern Sex      smod2vl(Sex a, Sex b);
extern Sex      smod2vb(Sex a, Sex b);
extern Sex      smod2vm(Sex a, Sex b);
extern Sex      smod2vr(Sex a, Sex b);
extern Sex      smod2vf(Sex a, Sex b);
extern Sex      smod2ve(Sex a, Sex b);
extern Sex      smod2vc(Sex a, Sex b);
extern Sex      smod2vv(Sex a, Sex b);
extern Sex      smod2vd(Sex a, Sex b);
extern Sex      smod2vz(Sex a, Sex b);
extern Sex      smod2vE(Sex a, Sex b);
extern Sex      smod2vZ(Sex a, Sex b);
extern Sex      smod2vV(Sex a, Sex b);
extern Sex      smod2vM(Sex a, Sex b);

extern Sex      smod2dl(Sex a, Sex b);
extern Sex      smod2db(Sex a, Sex b);
extern Sex      smod2dm(Sex a, Sex b);
extern Sex      smod2dr(Sex a, Sex b);
extern Sex      smod2df(Sex a, Sex b);
extern Sex      smod2de(Sex a, Sex b);
extern Sex      smod2dc(Sex a, Sex b);
extern Sex      smod2dv(Sex a, Sex b);
extern Sex      smod2dd(Sex a, Sex b);
extern Sex      smod2dz(Sex a, Sex b);
extern Sex      smod2dE(Sex a, Sex b);
extern Sex      smod2dZ(Sex a, Sex b);
extern Sex      smod2dV(Sex a, Sex b);
extern Sex      smod2dM(Sex a, Sex b);

extern Sex      smod2zl(Sex a, Sex b);
extern Sex      smod2zb(Sex a, Sex b);
extern Sex      smod2zm(Sex a, Sex b);
extern Sex      smod2zr(Sex a, Sex b);
extern Sex      smod2zf(Sex a, Sex b);
extern Sex      smod2ze(Sex a, Sex b);
extern Sex      smod2zc(Sex a, Sex b);
extern Sex      smod2zv(Sex a, Sex b);
extern Sex      smod2zd(Sex a, Sex b);
extern Sex      smod2zz(Sex a, Sex b);
extern Sex      smod2zE(Sex a, Sex b);
extern Sex      smod2zZ(Sex a, Sex b);
extern Sex      smod2zV(Sex a, Sex b);
extern Sex      smod2zM(Sex a, Sex b);

extern Sex      smod2El(Sex a, Sex b);
extern Sex      smod2Eb(Sex a, Sex b);
extern Sex      smod2Em(Sex a, Sex b);
extern Sex      smod2Er(Sex a, Sex b);
extern Sex      smod2Ef(Sex a, Sex b);
extern Sex      smod2Ee(Sex a, Sex b);
extern Sex      smod2Ec(Sex a, Sex b);
extern Sex      smod2Ev(Sex a, Sex b);
extern Sex      smod2Ed(Sex a, Sex b);
extern Sex      smod2Ez(Sex a, Sex b);
extern Sex      smod2EE(Sex a, Sex b);
extern Sex      smod2EZ(Sex a, Sex b);
extern Sex      smod2EV(Sex a, Sex b);
extern Sex      smod2EM(Sex a, Sex b);

extern Sex      smod2Zl(Sex a, Sex b);
extern Sex      smod2Zb(Sex a, Sex b);
extern Sex      smod2Zm(Sex a, Sex b);
extern Sex      smod2Zr(Sex a, Sex b);
extern Sex      smod2Zf(Sex a, Sex b);
extern Sex      smod2Ze(Sex a, Sex b);
extern Sex      smod2Zc(Sex a, Sex b);
extern Sex      smod2Zv(Sex a, Sex b);
extern Sex      smod2Zd(Sex a, Sex b);
extern Sex      smod2Zz(Sex a, Sex b);
extern Sex      smod2ZE(Sex a, Sex b);
extern Sex      smod2ZZ(Sex a, Sex b);
extern Sex      smod2ZV(Sex a, Sex b);
extern Sex      smod2ZM(Sex a, Sex b);

extern Sex      smod2Vl(Sex a, Sex b);
extern Sex      smod2Vb(Sex a, Sex b);
extern Sex      smod2Vm(Sex a, Sex b);
extern Sex      smod2Vr(Sex a, Sex b);
extern Sex      smod2Vf(Sex a, Sex b);
extern Sex      smod2Ve(Sex a, Sex b);
extern Sex      smod2Vc(Sex a, Sex b);
extern Sex      smod2Vv(Sex a, Sex b);
extern Sex      smod2Vd(Sex a, Sex b);
extern Sex      smod2Vz(Sex a, Sex b);
extern Sex      smod2VE(Sex a, Sex b);
extern Sex      smod2VZ(Sex a, Sex b);
extern Sex      smod2VV(Sex a, Sex b);
extern Sex      smod2VM(Sex a, Sex b);

extern Sex      smod2Ml(Sex a, Sex b);
extern Sex      smod2Mb(Sex a, Sex b);
extern Sex      smod2Mm(Sex a, Sex b);
extern Sex      smod2Mr(Sex a, Sex b);
extern Sex      smod2Mf(Sex a, Sex b);
extern Sex      smod2Me(Sex a, Sex b);
extern Sex      smod2Mc(Sex a, Sex b);
extern Sex      smod2Mv(Sex a, Sex b);
extern Sex      smod2Md(Sex a, Sex b);
extern Sex      smod2Mz(Sex a, Sex b);
extern Sex      smod2ME(Sex a, Sex b);
extern Sex      smod2MZ(Sex a, Sex b);
extern Sex      smod2MV(Sex a, Sex b);
extern Sex      smod2MM(Sex a, Sex b);

/*
 *
 */

#define smod2EE smod2xx
#define smod2EV smod2xx
#define smod2EZ smod2xx
#define smod2Eb smod2xx
#define smod2Ec smod2xx
#define smod2Ed smod2xx
#define smod2Ee smod2xx
#define smod2Ef smod2xx
#define smod2Ei smod2xx
#define smod2El smod2Eb
#define smod2Em math_er
#define smod2Er smod2xx
#define smod2Ev smod2xx
#define smod2Ez smod2xx
#define smod2VE smod2xx
#define smod2VV smod2xx
#define smod2VZ smod2xx
#define smod2Vb smod2xx
#define smod2Vc smod2xx
#define smod2Vd smod2xx
#define smod2Ve smod2xx
#define smod2Vf smod2xx
#define smod2Vi smod2xx
#define smod2Vl smod2Vb
#define smod2Vm math_er
#define smod2Vr smod2xx
#define smod2Vv smod2xx
#define smod2Vz smod2xx
#define smod2ZE smod2xx
#define smod2ZV smod2xx
#define smod2ZZ smod2xx
#define smod2Zb smod2xx
#define smod2Zc smod2xx
#define smod2Zd smod2xx
#define smod2Ze smod2xx
#define smod2Zf smod2xx
#define smod2Zi smod2xx
#define smod2Zl smod2Zb
#define smod2Zm math_er
#define smod2Zr smod2xx
#define smod2Zv smod2xx
#define smod2Zz smod2xx
#define smod2bE smod2xx
#define smod2bV smod2xx
#define smod2bZ smod2xx
#define smod2bc smod2xx
#define smod2bd smod2xx
#define smod2be smod2xx
#define smod2bf smod2xx
#define smod2bl smod2bb
#define smod2bm math_er
#define smod2br smod2xx
#define smod2bv smod2xx
#define smod2bz smod2xx
#define smod2cE smod2xx
#define smod2cV smod2xx
#define smod2cZ smod2xx
#define smod2cb smod2xx
#define smod2cc smod2xx
#define smod2cd smod2xx
#define smod2ce smod2xx
#define smod2cf smod2xx
#define smod2ci smod2xx
#define smod2cl smod2cb
#define smod2cm math_er
#define smod2cr smod2xx
#define smod2cv smod2xx
#define smod2cz smod2xx
#define smod2dE smod2xx
#define smod2dV smod2xx
#define smod2dZ smod2xx
#define smod2db smod2xx
#define smod2dc smod2xx
#define smod2dd smod2xx
#define smod2de smod2xx
#define smod2df smod2xx
#define smod2di smod2xx
#define smod2dl smod2db
#define smod2dm math_er
#define smod2dr smod2xx
#define smod2dv smod2xx
#define smod2dz smod2xx
#define smod2eE smod2xx
#define smod2eV smod2xx
#define smod2eZ smod2xx
#define smod2eb smod2xx
#define smod2ec smod2xx
#define smod2ed smod2xx
#define smod2ee smod2xx
#define smod2ef smod2xx
#define smod2ei smod2xx
#define smod2el	smod2eb
#define smod2em math_er
#define smod2er smod2xx
#define smod2ev smod2xx
#define smod2ez smod2xx
#define smod2fE smod2xx
#define smod2fV smod2xx
#define smod2fZ smod2xx
#define smod2fb smod2xx
#define smod2fc smod2xx
#define smod2fd smod2xx
#define smod2fe smod2xx
#define smod2ff smod2xx
#define smod2fi smod2xx
#define smod2fl smod2fb
#define smod2fm math_er
#define smod2fr smod2xx
#define smod2fv smod2xx
#define smod2fz smod2xx
#define smod2iE smod2xx
#define smod2iV smod2xx
#define smod2iZ smod2xx
#define smod2ic smod2xx
#define smod2id smod2xx
#define smod2ie smod2xx
#define smod2if smod2xx
#define smod2il	smod2ib
#define smod2im math_er
#define smod2ir smod2xx
#define smod2iv smod2xx
#define smod2iz smod2xx
#define smod2lE smod2xx
#define smod2lV smod2xx
#define smod2lZ smod2xx
#define smod2lb smod2bb
#define smod2lc smod2xx
#define smod2ld smod2xx
#define smod2le smod2xx
#define smod2lf smod2xx
#define smod2li smod2bi
#define smod2ll smod2bb
#define smod2lm smod2bm
#define smod2lr smod2xx
#define smod2lv smod2xx
#define smod2lz smod2xx
#define smod2mE math_er
#define smod2mV math_er
#define smod2mZ math_er
#define smod2mb math_er
#define smod2mc math_er
#define smod2md math_er
#define smod2me math_er
#define smod2mf math_er
#define smod2mi math_er
#define smod2ml smod2mb
#define smod2mm math_er
#define smod2mr math_er
#define smod2mv math_er
#define smod2mz math_er
#define smod2rE smod2xx
#define smod2rV smod2xx
#define smod2rZ smod2xx
// #define smod2rb smod2xx
#define smod2rc smod2xx
#define smod2rd smod2xx
#define smod2re smod2xx
#define smod2rf smod2xx
// #define smod2ri smod2xx
#define smod2rl smod2rb
#define smod2rm math_er
#define smod2rr smod2xx
#define smod2rv smod2xx
#define smod2rz smod2xx
#define smod2vE smod2xx
#define smod2vV smod2xx
#define smod2vZ smod2xx
#define smod2vb smod2xx
#define smod2vc smod2xx
#define smod2vd smod2xx
#define smod2ve smod2xx
#define smod2vf smod2xx
#define smod2vi smod2xx
#define smod2vl smod2vb
#define smod2vm math_er
#define smod2vr smod2xx
#define smod2vv smod2xx
#define smod2vz smod2xx
#define smod2zE smod2xx
#define smod2zV smod2xx
#define smod2zZ smod2xx
#define smod2zb smod2xx
#define smod2zc smod2xx
#define smod2zd smod2xx
#define smod2ze smod2xx
#define smod2zf smod2xx
#define smod2zi smod2xx
#define smod2zl smod2zb
#define smod2zm math_er
#define smod2zr smod2xx
#define smod2zv smod2xx
#define smod2zz smod2xx

#define smod2iM math_er
#define smod2lM math_er
#define smod2bM math_er
#define smod2rM math_er
#define smod2fM math_er
#define smod2mM math_er
#define smod2eM math_er
#define smod2dM math_er
#define smod2EM math_er
#define smod2VM math_er
#define smod2ZM math_er
#define smod2vM math_er
#define smod2cM math_er
#define smod2zM math_er

#define smod2Mi math_er
#define smod2Ml math_er
#define smod2Mb math_er
#define smod2Mr math_er
#define smod2Mf math_er
#define smod2Mm math_er
#define smod2Me math_er
#define smod2Md math_er
#define smod2Mv math_er
#define smod2Mz math_er
#define smod2Mc math_er
#define smod2ME math_er
#define smod2MV math_er
#define smod2MZ math_er
#define smod2MM math_er

/*
 * greatest common divisor
 */


extern Sex      gcdbb(Sex a, Sex b);
extern Sex      gcdbi(Sex a, Sex b);
extern Sex      gcdii(Sex a, Sex b);



/*
 *  arithmetic between integers (short and/or big)
 */

extern Sex      plus2ij(Sex a, Sex b);
extern Sex      plus2ji(Sex a, Sex b);
extern Sex      plus2jj(Sex a, Sex b);


extern Sex      diff2ij(Sex a, Sex b);
extern Sex      diff2ji(Sex a, Sex b);
extern Sex      diff2jj(Sex a, Sex b);

extern Sex      times2ij(Sex a, Sex b);
extern Sex      times2ji(Sex a, Sex b);
extern Sex      times2jj(Sex a, Sex b);

extern Sex      quot2ij(Sex a, Sex b);
extern Sex      quot2ji(Sex a, Sex b);
extern Sex      quot2jj(Sex a, Sex b);

extern Sex      rem2ij(Sex a, Sex b);
extern Sex      rem2ji(Sex a, Sex b);
extern Sex      rem2jj(Sex a, Sex b);

extern Sex      mod2ij(Sex a, Sex b);
extern Sex      mod2ji(Sex a, Sex b);
extern Sex      mod2jj(Sex a, Sex b);

extern Sex      absi(Sex a);
extern Sex      absb(Sex a);
extern Sex      absj(Sex a);

extern Sex      plus2xp(Sex a, Sex b);
extern Sex      plus2pp(Sex a, Sex b);

extern Sex      diff2xp(Sex a, Sex b);
extern Sex      diff2px(Sex a, Sex b);
extern Sex      diff2pp(Sex a, Sex b);

extern Sex      times2xp(Sex a, Sex b);
extern Sex      times2pp(Sex a, Sex b);
extern Sex      times2tp(Sex a, Sex b);

extern Sex      quot2px(Sex a, Sex b);
extern Sex      quot2pp(Sex a, Sex b);


extern Sex      ratio2px(Sex a, Sex b);

extern Sex      negateM(Sex a);
extern Sex      negatem(Sex a);

extern Sex      negateY(Sex a);



extern Sex      plus2iq(Sex a, Sex b);
extern Sex      plus2lq(Sex a, Sex b);
extern Sex      plus2bq(Sex a, Sex b);
extern Sex      plus2rq(Sex a, Sex b);
extern Sex      plus2cq(Sex a, Sex b);
extern Sex      plus2Mq(Sex a, Sex b);
extern Sex      plus2ql(Sex a, Sex b);
extern Sex      plus2qb(Sex a, Sex b);
extern Sex      plus2qr(Sex a, Sex b);
extern Sex      plus2qc(Sex a, Sex b);
extern Sex      plus2qM(Sex a, Sex b);
extern Sex      plus2qq(Sex a, Sex b);
extern Sex      diff2iq(Sex a, Sex b);
extern Sex      diff2qi(Sex a, Sex b);
extern Sex      diff2lq(Sex a, Sex b);
extern Sex      diff2bq(Sex a, Sex b);
extern Sex      diff2rq(Sex a, Sex b);
extern Sex      diff2cq(Sex a, Sex b);
extern Sex      diff2Mq(Sex a, Sex b);
extern Sex      diff2ql(Sex a, Sex b);
extern Sex      diff2qb(Sex a, Sex b);
extern Sex      diff2qr(Sex a, Sex b);
extern Sex      diff2qc(Sex a, Sex b);
extern Sex      diff2qM(Sex a, Sex b);
extern Sex      diff2qq(Sex a, Sex b);
extern Sex      times2iq(Sex a, Sex b);
extern Sex      times2lq(Sex a, Sex b);
extern Sex      times2bq(Sex a, Sex b);
extern Sex      times2rq(Sex a, Sex b);
extern Sex      times2cq(Sex a, Sex b);
extern Sex      times2Mq(Sex a, Sex b);
extern Sex      times2ql(Sex a, Sex b);
extern Sex      times2qb(Sex a, Sex b);
extern Sex      times2qr(Sex a, Sex b);
extern Sex      times2qc(Sex a, Sex b);
extern Sex      times2qM(Sex a, Sex b);
extern Sex      times2qq(Sex a, Sex b);
extern Sex      quot2iq(Sex a, Sex b);
extern Sex      quot2qi(Sex a, Sex b);
extern Sex      quot2lq(Sex a, Sex b);
extern Sex      quot2bq(Sex a, Sex b);
extern Sex      quot2rq(Sex a, Sex b);
extern Sex      quot2cq(Sex a, Sex b);
extern Sex      quot2Mq(Sex a, Sex b);
extern Sex      quot2ql(Sex a, Sex b);
extern Sex      quot2qb(Sex a, Sex b);
extern Sex      quot2qr(Sex a, Sex b);
extern Sex      quot2qc(Sex a, Sex b);
extern Sex      quot2qM(Sex a, Sex b);
extern Sex      quot2qq(Sex a, Sex b);
extern Sex      rem2iq(Sex a, Sex b);
extern Sex      rem2qi(Sex a, Sex b);
extern Sex      rem2lq(Sex a, Sex b);
extern Sex      rem2bq(Sex a, Sex b);
extern Sex      rem2mq(Sex a, Sex b);
extern Sex      rem2rq(Sex a, Sex b);
extern Sex      rem2cq(Sex a, Sex b);
extern Sex      rem2Mq(Sex a, Sex b);
extern Sex      rem2ql(Sex a, Sex b);
extern Sex      rem2qb(Sex a, Sex b);
extern Sex      rem2qm(Sex a, Sex b);
extern Sex      rem2qr(Sex a, Sex b);
extern Sex      rem2qf(Sex a, Sex b);
extern Sex      rem2qe(Sex a, Sex b);
extern Sex      rem2qc(Sex a, Sex b);
extern Sex      rem2qv(Sex a, Sex b);
extern Sex      rem2qd(Sex a, Sex b);
extern Sex      rem2qz(Sex a, Sex b);
extern Sex      rem2qE(Sex a, Sex b);
extern Sex      rem2qZ(Sex a, Sex b);
extern Sex      rem2qV(Sex a, Sex b);
extern Sex      rem2qM(Sex a, Sex b);
extern Sex      rem2qq(Sex a, Sex b);
extern Sex      mod2iq(Sex a, Sex b);
extern Sex      mod2qi(Sex a, Sex b);
extern Sex      mod2lq(Sex a, Sex b);
extern Sex      mod2bq(Sex a, Sex b);
extern Sex      mod2mq(Sex a, Sex b);
extern Sex      mod2rq(Sex a, Sex b);
extern Sex      mod2cq(Sex a, Sex b);
extern Sex      mod2Mq(Sex a, Sex b);
extern Sex      mod2ql(Sex a, Sex b);
extern Sex      mod2qb(Sex a, Sex b);
extern Sex      mod2qm(Sex a, Sex b);
extern Sex      mod2qr(Sex a, Sex b);
extern Sex      mod2qc(Sex a, Sex b);
extern Sex      mod2qM(Sex a, Sex b);
extern Sex      mod2qq(Sex a, Sex b);

#define smod2iq math_er
#define smod2qi math_er
#define smod2lq math_er
#define smod2bq math_er
#define smod2mq math_er
#define smod2rq math_er
#define smod2cq math_er
#define smod2Mq math_er
#define smod2ql math_er
#define smod2qb math_er
#define smod2qm math_er
#define smod2qr math_er
#define smod2qc math_er
#define smod2qM math_er
#define smod2qq math_er


/*
 */
extern Sex      plus2iY(Sex a, Sex b);
extern Sex      plus2Yi(Sex a, Sex b);

#define plus2lY math_er
extern Sex      plus2bY(Sex a, Sex b);
#define plus2mY math_er
extern Sex      plus2rY(Sex a, Sex b);
#define plus2fY math_er
#define plus2eY math_er
#define plus2cY math_er
#define plus2vY math_er
#define plus2dY math_er
#define plus2zY math_er
#define plus2EY math_er
#define plus2ZY math_er
#define plus2VY math_er
#define plus2MY math_er
#define plus2qY math_er
#define plus2Yl math_er
extern Sex      plus2Yb(Sex a, Sex b);
extern Sex      plus2Yr(Sex a, Sex b);
#define plus2Yc math_er
#define plus2YM math_er
#define plus2Yq math_er
extern Sex      plus2YY(Sex a, Sex b);
/*
 */
extern Sex      diff2iY(Sex a, Sex b);
extern Sex      diff2Yi(Sex a, Sex b);

#define diff2lY math_er
extern Sex      diff2bY(Sex a, Sex b);
#define diff2mY math_er
extern Sex      diff2rY(Sex a, Sex b);
#define diff2fY math_er
#define diff2eY math_er
#define diff2cY math_er
#define diff2vY math_er
#define diff2dY math_er
#define diff2zY math_er
#define diff2EY math_er
#define diff2ZY math_er
#define diff2VY math_er
#define diff2MY math_er
#define diff2qY math_er
#define diff2Yl math_er
extern Sex      diff2Yb(Sex a, Sex b);
extern Sex      diff2Yr(Sex a, Sex b);
#define diff2YM math_er
#define diff2Yq math_er
extern Sex      diff2YY(Sex a, Sex b);
/*
 */
extern Sex      times2iY(Sex a, Sex b);
extern Sex      times2Yi(Sex a, Sex b);

#define times2lY math_er
extern Sex      times2bY(Sex a, Sex b);
#define times2mY math_er
extern Sex      times2rY(Sex a, Sex b);
#define times2fY math_er
#define times2eY math_er
#define times2cY math_er
#define times2vY math_er
#define times2dY math_er
#define times2zY math_er
#define times2EY math_er
#define times2ZY math_er
#define times2VY math_er
#define times2MY math_er
#define times2qY math_er
#define times2Yl math_er
extern Sex      times2Yb(Sex a, Sex b);
extern Sex      times2Yr(Sex a, Sex b);
#define times2Yc math_er
#define times2YM math_er
#define times2Yq math_er
extern Sex      times2YY(Sex a, Sex b);
/*
 */
extern Sex      quot2iY(Sex a, Sex b);
extern Sex      quot2Yi(Sex a, Sex b);

#define quot2lY math_er
extern Sex      quot2bY(Sex a, Sex b);
#define quot2mY math_er
extern Sex      quot2rY(Sex a, Sex b);
#define quot2fY math_er
#define quot2eY math_er
#define quot2cY math_er
#define quot2vY math_er
#define quot2dY math_er
#define quot2zY math_er
#define quot2EY math_er
#define quot2ZY math_er
#define quot2VY math_er
#define quot2MY math_er
#define quot2qY math_er
#define quot2Yl math_er
extern Sex      quot2Yb(Sex a, Sex b);
extern Sex      quot2Yr(Sex a, Sex b);
#define quot2Yc math_er
#define quot2YM math_er
#define quot2Yq math_er
extern Sex      quot2YY(Sex a, Sex b);
/*
 */
#define rem2iY mkzero2
#define rem2Yi mkzero2

#define rem2lY mkzero2
#define rem2bY mkzero2
#define rem2mY math_er
#define rem2rY mkzero2
#define rem2fY math_er
#define rem2eY math_er
#define rem2cY math_er
#define rem2vY math_er
#define rem2dY math_er
#define rem2zY math_er
#define rem2EY math_er
#define rem2ZY math_er
#define rem2VY math_er
#define rem2MY math_er
#define rem2qY math_er
#define rem2Yl math_er
#define rem2Yb mkzero2
#define rem2Yr mkzero2
#define rem2YM math_er
#define rem2Yq math_er
#define rem2YY mkzero2

#define rem2Ym math_er
#define rem2Yf math_er
#define rem2Ye math_er
#define rem2Yc math_er
#define rem2Yv math_er
#define rem2Yd math_er
#define rem2Yz math_er
#define rem2YE math_er
#define rem2YZ math_er
#define rem2YV math_er
/*
 */
#define mod2iY mkzero2
#define mod2Yi mkzero2

#define mod2lY math_er
#define mod2bY mkzero2
#define mod2mY math_er
#define mod2rY mkzero2
#define mod2fY math_er
#define mod2eY math_er
#define mod2cY math_er
#define mod2vY math_er
#define mod2dY math_er
#define mod2zY math_er
#define mod2EY math_er
#define mod2ZY math_er
#define mod2VY math_er
#define mod2MY math_er
#define mod2qY math_er
#define mod2Yl math_er
#define mod2Yb mkzero2
#define mod2Ym math_er
#define mod2Yc math_er
#define mod2Yr mkzero2
#define mod2YM math_er
#define mod2Yq math_er
#define mod2YY mkzero2
/*
 */
#define smod2iY mkzero2
#define smod2Yi mkzero2

#define smod2lY math_er
#define smod2bY mkzero2
#define smod2mY math_er
#define smod2rY mkzero2
#define smod2fY math_er
#define smod2eY math_er
#define smod2cY math_er
#define smod2vY math_er
#define smod2dY math_er
#define smod2zY math_er
#define smod2EY math_er
#define smod2ZY math_er
#define smod2VY math_er
#define smod2MY math_er
#define smod2qY math_er
#define smod2Yl math_er
#define smod2Yb mkzero2
#define smod2Yr mkzero2
#define smod2Ym math_er
#define smod2Yc math_er
#define smod2YM math_er
#define smod2Yq math_er
#define smod2YY mkzero2
