
/*
 * misc.h      (C); Copyright 2011 by Fujio Kako, Nara Women's University.
 * Transcendental Functions.
 *      $Header: /Users/kako/asuka/src/RCS/misc.h,v 2.9 2016/01/05 02:50:44 kako Exp $
 */


Sex             Awrite(Sex args);
Sex             Awriten(Sex args);
Sex             Aclear(Sex a);
Sex             Aload(Sex a);
Sex             Aimport(Sex a);
Sex             Asize(Sex a);
Sex             Amcoeff(Sex p);
Sex             Acoeff(Sex p, Sex x);
Sex             Acoeffn(Sex p, Sex x, Sex n);
Sex             Acoeffx(Sex p, Sex x);
Sex             Acoeffy(Sex p, Sex x);
Sex             Asupport(Sex p);
Sex             Asupport_ap(Sex p, Sex e);
Sex             Anew_symbol1(Sex x, Sex n1);
Sex             Anew_symbol2(Sex x, Sex n1, Sex n2);

extern Sex      Amerge(Sex p, Sex q);

Sex             Aunknowns(Sex a);
Sex             Amax_coeff(Sex a);
Sex             Anterms(Sex a);

Sex             Aprecision(Sex a);

/**************************************************************/
/********* Conversion between various typs ********************/
/**************************************************************/

Sex             converter(Sex a, one_args * cf);
Sex             polynomial_converter(Sex a, one_args * cf);
Sex             dipoly_converter(Sex a, one_args * cf);
Sex             rpoly_converter(Sex a, one_args * cf);
Sex             list_converter(Sex a, one_args * cf);
Sex             matrix_converter(Sex a, one_args * cf);
Sex             vector_converter(Sex a, one_args * cf);

Sex             converter2(Sex a, Sex b, two_args * cf);
Sex             polynomial_converter2(Sex a, Sex b, two_args * cf);
Sex             dipoly_converter2(Sex a, Sex b, two_args * cf);
Sex             rpoly_converter2(Sex a, Sex b, two_args * cf);
Sex             list_converter2(Sex a, Sex b, two_args * cf);
Sex             matrix_converter2(Sex a, Sex b, two_args * cf);
Sex             vector_converter2(Sex a, Sex b, two_args * cf);

Sex             Aunmodular(Sex a);
Sex             Aunmodular_pol(Sex a);
Sex             Aunmodular_dipoly(Sex a);
Sex             Aunmodular_vect(Sex a);
Sex             Aunmodular_mat(Sex a);

Sex             Amodular(Sex a);
Sex             Amkmodular(Sex a, Sex b);
Sex             Amkmodular_pol(Sex a, Sex b);
Sex             Amkmodular_dipoly(Sex a, Sex b);
Sex             Amkmodular_vect(Sex a, Sex b);
Sex             Amkmodular_mat(Sex a, Sex b);
Sex             Amodular_pol(Sex a);
Sex             Amodular_dipoly(Sex a);
Sex             Amodular_vect(Sex a);
Sex             Amodular_mat(Sex a);

Sex             Afmodular(Sex a);
extern Sex      Lfmodular(Sex a);
Sex             Afmodular_pol(Sex a);
Sex             Afmodular_dipoly(Sex a);
Sex             Afmodular_vect(Sex a);
Sex             Afmodular_mat(Sex a);

Sex             Afloat(Sex a);
Sex             Afloat_pol(Sex a);
Sex             Afloat_dipoly(Sex a);
Sex             Afloat_vect(Sex a);
Sex             Afloat_mat(Sex a);

Sex             Abfloat(Sex a);
Sex             Abfloat_pol(Sex a);
Sex             Abfloat_dipoly(Sex a);
Sex             Abfloat_vect(Sex a);
Sex             Abfloat_mat(Sex a);
Sex             Aefloat(Sex a);
Sex             Amkefloat(Sex a, Sex f);
Sex             Amkefloat_by_ratio(Sex a, Sex f);
Sex             Amkefloat_pol(Sex a, Sex f);
Sex             Amkefloat_dipoly(Sex a, Sex f);
Sex             Amkefloat_vect(Sex a, Sex f);
Sex             Amkefloat_mat(Sex a, Sex f);

Sex             Ainterval(Sex a, Sex f);

Sex             Abefloat(Sex a);
Sex             Amkbefloat(Sex a, Sex f);
Sex             Amkbefloat_by_ratio(Sex a, Sex f);
Sex             Amkbefloat_pol(Sex a, Sex f);
Sex             Amkbefloat_dipoly(Sex a, Sex f);
Sex             Amkbefloat_vect(Sex a, Sex f);
Sex             Amkbefloat_mat(Sex a, Sex f);

Sex             Aefloat_value(Sex a);
Sex             Aefloat_value_pol(Sex a);
Sex             Aefloat_value_dipoly(Sex a);
Sex             Aefloat_value_vect(Sex a);
Sex             Aefloat_value_mat(Sex a);
Sex             Aefloat_error(Sex a);
Sex             Aefloat_error_pol(Sex a);
Sex             Aefloat_error_dipoly(Sex a);
Sex             Aefloat_error_vect(Sex a);
Sex             Aefloat_error_mat(Sex a);

Sex             Adump_array(Sex a);

/**************************************************************/
/**************************************************************/

Sex             Ais_cons(Sex a);

Sex             Ais_fixnum(Sex a);
Sex             Ais_hdrs(Sex a);
Sex             Ais_reloc(Sex a);
Sex             Ais_symbol(Sex a);
Sex             Ais_numhdr(Sex a);
Sex             Ais_lisp_vector(Sex a);
Sex             Ais_binhdr(Sex a);
Sex             Ais_number(Sex a);
Sex             Ais_immed(Sex a);
Sex             Ais_logical(Sex a);
Sex             Ais_modular(Sex a);
Sex             Ais_bigint(Sex a);
Sex             Ais_float(Sex a);
Sex             Ais_rational(Sex a);
Sex             Ais_ratio(Sex a);
Sex             Ais_complex(Sex a);
Sex             Ais_bfloat(Sex a);
Sex             Ais_efloat(Sex a);
Sex             Ais_interval(Sex a);
Sex             Ais_ecomplex(Sex a);
Sex             Ais_befloat(Sex a);
Sex             Ais_binterval(Sex a);
Sex             Ais_becomplex(Sex a);
Sex             Ais_bmodular(Sex a);
Sex             Ais_qmodular(Sex a);
Sex             Ais_fmodular(Sex a);
Sex             Ais_poly(Sex a);
Sex             Ais_tropical(Sex a);
Sex             Ais_dipoly(Sex a);
Sex             Ais_rpoly(Sex a);
Sex             Ais_bigneg(Sex a);
Sex             Ais_integer(Sex a);
Sex             Ais_fix(Sex a);
Sex             Ais_neg(Sex a);
Sex             Ais_app(Sex a);
Sex             Ais_log(Sex a);
Sex             Ais_eff(Sex a);
Sex             Ais_cmp(Sex a);
Sex             Ais_big(Sex a);
Sex             Ais_vector(Sex a);
Sex             Ais_matrix(Sex a);
Sex             Ais_array(Sex a);
Sex             Ais_string(Sex a);
Sex             Ais_iarray(Sex a);
Sex             Ais_sarray(Sex a);
Sex             Ais_darray(Sex a);
Sex             Ais_iarray2(Sex a);
Sex             Ais_sarray2(Sex a);
Sex             Ais_darray2(Sex a);
Sex             Ais_iarray3(Sex a);
Sex             Ais_sarray3(Sex a);
Sex             Ais_darray3(Sex a);
Sex             Ais_package(Sex a);


Sex             Aws(Sex a);
/**************************************************************/
/**************************************************************/
Sex             Lpolynomial(Sex a);
Sex             Ldipoly(Sex a);
Sex             Ltropical(Sex a);
/**************************************************************/
/**************************************************************/
extern Sex      Lset_fmodulus(Sex a);
