/*
 * polynomial.h       (C) Copyright 2011 by Fujio Kako, Nara Women's Univeristy
 *      $Header: /Users/kako/asuka/src/RCS/polynomial.h,v 2.10 2015/12/09 03:44:28 kako Exp $
 */

bool            minuspP(Sex a);
void            print_poly_aux(Sex a, var_list * v, putchar_fn * fn,
			       long first);
void            print_polynomial(Sex a, putchar_fn * fn);
void            print_rpoly(Sex a, putchar_fn * fn);
Sex             make_poly(Sex x, Sex p);
Sex             make_polynomial(Sex a, Sex b, Sex c);
Sex             symbol_to_polynomial(Sex a);
Sex             make_rpoly(Sex a, Sex b);
/***************************************************************/
/***************************************************************/
/***************************************************************/
Sex             Lsimplify(Sex a);
Sex             simplify_poly(Sex a);
Sex             simplify_rpoly(Sex a);
Sex             simplify_dipoly(Sex a);
Sex             simplify_prefix(Sex a);
Sex             Lreorder(Sex a);
Sex             Lsetorder(Sex a);
Sex             Lsetkorder(Sex a);
Sex             Lgetorder(void);
Sex             Lgetdipolyorder(void);
long            compare_var(Sex a, Sex b);
Sex             plus2xp(Sex t, Sex b);
Sex             gplus2pn(Sex a, Sex b);
Sex             gplus2np(Sex a, Sex b);
Sex             plus2pp(Sex a, Sex b);
Sex             gplus2pp(Sex a, Sex b);
Sex             gplus2nr(Sex a, Sex b);
Sex             gplus2rn(Sex b, Sex a);
Sex             gplus2rr(Sex a, Sex b);
Sex             diff2xp(Sex t, Sex b);
Sex             diff2px(Sex a, Sex t);
Sex             gdiff2pn(Sex a, Sex b);
Sex             gdiff2np(Sex a, Sex b);
Sex             diff2pp(Sex a, Sex b);
Sex             gdiff2pp(Sex a, Sex b);
Sex             negatep(Sex a);
Sex             gnegate(Sex a);
Sex             gnegatep(Sex a);
Sex             gnegater(Sex a);
Sex             modulusp(Sex a, Sex b);
Sex             smodulusp(Sex a, Sex b);
Sex             gmodulus(Sex a, Sex b);
Sex             gmodulusp(Sex a, Sex b);
Sex             gmodulusr(Sex a, Sex b);
Sex             gdiff2nr(Sex a, Sex b);
Sex             gdiff2rn(Sex a, Sex b);
Sex             gdiff2rr(Sex a, Sex b);
Sex             times2xp(Sex t, Sex a);
Sex             gtimes2pn(Sex p, Sex t);
Sex             gtimes2np(Sex t, Sex p);
Sex             times2tt(Sex t1, Sex t2);
Sex             times2tp(Sex t, Sex p);
#ifndef NEW_POLYMUL
Sex             times2pp(Sex a, Sex b);
#endif
Sex             gtimes2pp(Sex a, Sex b);
Sex             exptip(Sex a, long n);
Sex             gexpt2pi(Sex a, Sex b);
Sex             gexpt2ri(Sex a, Sex b);
Sex             gtimes2rn(Sex a, Sex b);
Sex             gtimes2nr(Sex a, Sex b);
Sex             gtimes2rr(Sex a, Sex b);
Sex             quot2px(Sex a, Sex b);
Sex             gquot2pn(Sex a, Sex b);
Sex             gquot2np(Sex a, Sex b);
Sex             quot2pp(Sex a, Sex b);
Sex             gquot2pp(Sex a, Sex b);
Sex             gquot2nr(Sex a, Sex b);
Sex             gquot2rn(Sex a, Sex b);
Sex             gquot2rr(Sex a, Sex b);

Sex             gplus2rp(Sex a, Sex b);
Sex             gplus2pr(Sex a, Sex b);
Sex             gdiff2rp(Sex a, Sex b);
Sex             gdiff2pr(Sex a, Sex b);
Sex             gtimes2rp(Sex a, Sex b);
Sex             gtimes2pr(Sex a, Sex b);
Sex             gquot2rp(Sex a, Sex b);
Sex             gquot2pr(Sex a, Sex b);
Sex             ratio2px(Sex a, Sex b);
Sex             gratio2pn(Sex a, Sex b);
Sex             gratio2np(Sex a, Sex b);
Sex             gratio2pp(Sex a, Sex b);
Sex             mod2xP(Sex a, Sex b);
Sex             mod2Px(Sex a, Sex b);
Sex             mod2PP(Sex a, Sex b);
Sex             mod2xR(Sex a, Sex b);
Sex             mod2Rx(Sex a, Sex b);
Sex             mod2RP(Sex a, Sex b);
Sex             mod2PR(Sex a, Sex b);
Sex             mod2RR(Sex a, Sex b);
Sex             grem2np(Sex a, Sex b);
Sex             grem2pn(Sex a, Sex b);
Sex             grem2pp(Sex a, Sex b);
Sex             grem2nr(Sex a, Sex b);
Sex             grem2rn(Sex a, Sex b);
Sex             grem2rp(Sex a, Sex b);
Sex             grem2pr(Sex a, Sex b);
Sex             grem2rr(Sex a, Sex b);

/***************************************************************/
/***************************************************************/
/***************************************************************/
Sex             gpdivide2(Sex a, Sex b, Sex x);
Sex             gpquotient2(Sex a, Sex b, Sex x);
Sex             gpremaind2(Sex a, Sex b, Sex x);
Sex             grdivide2(Sex a, Sex b, Sex x);
Sex             grquotient2(Sex a, Sex b, Sex x);
Sex             grremaind2(Sex a, Sex b, Sex x);
bool            lessp2PP(Sex a, Sex b);
bool            lessp2RR(Sex a, Sex b);
bool            numeq2PP(Sex a, Sex b);
bool            numeq2RR(Sex a, Sex b);
bool            appeq2PP(Sex a, Sex b);
bool            appeq2RR(Sex a, Sex b);
Sex             fixitp(Sex a);
Sex             fixitP(Sex a);
Sex             floatitp(Sex a);
Sex             floatitP(Sex a);
Sex             bfloatitp(Sex a);
Sex             bfloatitP(Sex a);
Sex             efloatitp(Sex a);
Sex             efloatitP(Sex a);
Sex             ecomplexitp(Sex a);
Sex             ecomplexitP(Sex a);
Sex             intervalitp(Sex a);
Sex             intervalitP(Sex a);
Sex             befloatitp(Sex a);
Sex             befloatitP(Sex a);
Sex             becomplexitp(Sex a);
Sex             becomplexitP(Sex a);
Sex             bintervalitp(Sex a);
Sex             bintervalitP(Sex a);
Sex             wuremainder(Sex a, Sex b);
/***************************************************************/
/***************************************************************/
Sex             Areval(Sex a);
Sex             poly_reval(Sex a);
Sex             poly_reval_sub(Sex a);
Sex             dipoly_reval(Sex a);
Sex             rpoly_reval(Sex a);
/***************************************************************/
Sex             Asubst(Sex a, Sex v, Sex b);
Sex             Asub(Sex a, Sex v, Sex b);
Sex             poly_subst(Sex a, Sex v, Sex b);
Sex             poly_subst_sub(Sex a, Sex v, Sex b);
Sex             dipoly_subst(Sex a, Sex v, Sex b);
Sex             rpoly_subst(Sex a, Sex v, Sex b);

Sex             Apoly_spoly(Sex a, Sex b);
Sex             Apoly_reduce(Sex a, Sex g);
Sex             Apoly_reduce1(Sex a, Sex g);
Sex             Apoly_full_reduce(Sex a, Sex g);
Sex             Apoly_full_reduce1(Sex a, Sex g);
/***************************************************************/
/***************************************************************/
extern Sex      polynomial_to_distributed(Sex a, Sex b);
extern Sex      Lpolynomial(Sex a);
extern Sex      poly_to_dipoly(Sex a, Sex o);
/***************************************************************/
extern Sex      Lnreverse(Sex a);
