/*
 * print.h      (C); Copyright 2011 by Fujio Kako, Nara Women's University.
 *      $Header: /Users/kako/asuka/src/RCS/print.h,v 2.12 2016/09/06 05:48:29 kako Exp $
 */


/*****************************************************************************/
#define P_ESCAPED          1
#define P_CESCAPED         2
#define P_NOLINEBREAK      4
#define P_LADJUST               0x08
#define P_ZEROPAD               0x10
#define P_DOWNCASE              0x20
#define P_UPPERCASE             0x40
/*****************************************************************************/
#ifdef VisualC
#define va_copy(d, s)	(d = s)
#endif
/*****************************************************************************/

void            debug_printf(char *fmt0, ...);
void            lisp_printf(char *fmt0, ...);
static void     lisp_vprintf(putchar_fn * fn, char *fmt0, Sex, va_list a);
static Sex      scan_format(char *fmt, va_list a);
Sex             Lputch(Sex a);
Sex             make_file_handle(FILE * f, long a, putchar_fn * fn);
Sex             make_string_handle(unsigned char *f, int size, int flag);
void            char_to_count(long c);
void            wchar_to_count(long c);
void            char_to_stdout(long c);
void            char_to_stderr(long c);
void            char_to_debug(long c);
void            char_to_androidout(long c);
void            char_to_androiderr(long c);
void            init_androidout(void);
char           *get_androidout(void);
static void     char_to_file(long c);
static void     char_to_lispout(long c);
static Sex      Lfiledate(Sex name);
Sex             Lfilep(Sex name);
Sex             Ltmpnam(void);
Sex             Lmkstemp(void);
Sex             Lopen(Sex name, Sex dir);
Sex             Lopen_file(Sex name, Sex dir);
Sex             Lwrs(Sex a);
Sex             Lclose(Sex a);
/*****************************************************************************/
/*
 * Printing.                                                            
 */
/*****************************************************************************/
void            print_string(char *p, putchar_fn * fn);
Sex             Lprint_precision(Sex a);
void            print_barray_int(long n, long f, putchar_fn * fn);
void            print_barray_long(long n, long f, putchar_fn * fn);
void            print_barray_float(float d, long f, putchar_fn * fn);
void            print_barray_double(double d, long f, putchar_fn * fn);
void            print_barray(Sex u, long type, putchar_fn * fn);
void            print_barray2(Sex u, long type, putchar_fn * fn);
void            print_barray3(Sex u, long type, putchar_fn * fn);
void            print_sex(Sex u, putchar_fn * fn);
void            hprint_sex(Sex u, putchar_fn * fn, long lev);
Sex             prin(Sex u);
void            prin_to_stdout(Sex u);
void            prin_to_stderr(Sex u);
void            prin_to_debug(Sex u);
Sex             princ(Sex u);
Sex             print(Sex u);
Sex             printc(Sex u);
Sex             terpri(void);
static void     char_to_list(long c);
static void     wchar_to_list(long c);
static void     int_to_list(long c);
Sex             Lstrlen(Sex u);
Sex             string2list(Sex u);
static Sex      explode(Sex u);
static Sex      explodew(Sex u);
static void     code_to_list(long c);
static Sex      exploden(Sex u);
Sex             Llinelength(Sex a);
Sex             Lfprin(Sex f, Sex a);
Sex             Lprin(Sex a);
Sex             Lposn(void);
Sex             Llposn(void);
Sex             Lpagelength(Sex a);
Sex             Lfprinc(Sex f, Sex a);
Sex             Lprinc(Sex a);
Sex             Lprin2t(Sex a);
Sex             Lfprin2a(Sex f, Sex a);
Sex             Lprin2a(Sex a);
Sex             Llprim(Sex a);
Sex             Llprie(Sex a);
Sex             Llengthc(Sex a);
Sex             CC_debug_prin2(Sex a);
Sex             CC_debug_prin2t(Sex a);
Sex             Ldebug_prin2(Sex a);
Sex             Ldebug_prin2t(Sex a);
void            bldmsg1(Sex f, Sex u, putchar_fn * fn);
void            lisp_vfprintf(Sex f, Sex u, putchar_fn * fn);
void            char_to_boffo(long c);
Sex             Lbldmsg1(Sex f, Sex u);
Sex             Lvprintf(Sex f, Sex u);
Sex             printf_fn(Sex args, Sex env);
Sex             Lvsprintf(Sex f, Sex u);
Sex             Lvfprintf(Sex f, Sex fmt, Sex u);
Sex             Lprintf0(Sex f);
Sex             Lsprintf0(Sex f);
Sex             Lfprintf0(Sex f, Sex fmt);
Sex             Lprintf1(Sex f, Sex u);
Sex             Lsprintf1(Sex f, Sex u);
Sex             Lfprintf1(Sex f, Sex fmt, Sex u);
Sex             Lprintf2(Sex f, Sex u, Sex v);
Sex             Lfprint(Sex f, Sex a);
Sex             Lprint(Sex a);
Sex             Lfprintc(Sex f, Sex a);
Sex             Lprintc(Sex a);
Sex             Lphex(Sex a, Sex b);
Sex             Lfterpri(Sex f);
Sex             Lterpri(void);
Sex             Lfflush(Sex f);
Sex             Lflush(void);
Sex             Lttab(Sex a);
Sex             Lxtab(Sex a);
Sex             Lfeject(Sex f);
Sex             Leject(void);
Sex             Lsprin2(Sex a);
Sex             Lexplodew(Sex a);
Sex             Lexplode(Sex a);
Sex             Lexplodec(Sex a);
Sex             Lexplodelc(Sex a);
Sex             Lexplodeuc(Sex a);
Sex             Lexploden(Sex a);
Sex             Lexplodecn(Sex a);
void            print_phex(Sex u, long k, putchar_fn * fn);
