/*
 * qmodular.c      (C) Copyright 2012 by Fujio Kako, Nara Women's University.
 * short int and modular arithmetics
 *      $Header: /Users/kako/asuka/src/RCS/qmodular.c,v 2.1 2012/10/21 13:32:48 kako Exp $
 */

static char const rcsid[] =
    "$Id: qmodular.c,v 2.1 2012/10/21 13:32:48 kako Exp $";


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "entries.h"
#include "mathop.h"
#include "compare.h"

Sex
rem2Mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2bq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2cq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2Mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qE(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qM(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qV(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2lq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qZ(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qb(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qc(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qd(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qe(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qf(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qi(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2ql(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qm(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qr(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qv(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2rq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
rem2qz(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2bq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2cq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2qM(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2lq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2qb(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2qc(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qE(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2qi(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2ql(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qM(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2qq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2qr(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
quot2rq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qV(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qZ(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qb(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qc(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qd(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qe(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qf(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qi(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2ql(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qm(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qr(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qv(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
lessp2qz(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2Mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2bq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2cq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2qM(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2lq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2qb(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2qc(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2qi(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2ql(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2qm(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2qq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2qr(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
mod2rq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
appeq2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
appeq2qq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2Mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2bq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2cq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2qM(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2lq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2qb(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2qc(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2ql(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2qq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2qr(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
times2rq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2Mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2bq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2cq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2qM(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2lq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2qb(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2qc(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2ql(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2qq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2qr(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
plus2rq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2Mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2bq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2eq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2fq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2qM(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2lq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
numeq2qq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2Mq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2bq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2cq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2iq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2qM(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2lq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2qb(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2qc(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2qi(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2ql(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2qq(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2qr(Sex a, Sex b)
{
    return math_er(a, b);
}
Sex
diff2rq(Sex a, Sex b)
{
    return math_er(a, b);
}
