/*
 * rprotos.h            (C) Copyright 1998-2000 by Fujio Kako, Nara Women's University.
 *  prototypes for reduce3.7 routines
 * $Header: /Users/kako/asuka/src/RCS/rprotos.h,v 2.14 2017/11/27 00:45:12 kako Exp $
 */

#ifdef REDUCE
#if REDUCE_MINOR_VERSION == 6
#include "r_alg.h"
#include "r_algint.h"
#include "r_arithmetic.h"
#include "r_arnum.h"
#include "r_cedit.h"
#include "r_cfap.h"
#include "r_complr.h"
#include "r_dipoly.h"
#include "r_entry.h"
#include "r_ezgcd.h"
#include "r_factor.h"
#include "r_groebner.h"
#include "r_groebnr2.h"
#include "r_hephys.h"
#include "r_int.h"
#include "r_mathpr.h"
#include "r_matrix.h"
#include "r_misc.h"
#include "r_poly.h"
#include "r_pretty.h"
#include "r_prolog.h"
#include "r_rend.h"
#include "r_rlisp.h"
#include "r_roots.h"
#include "r_roots2.h"
#include "r_rprint.h"
#include "r_solve.h"
#include "r_specbess.h"
#include "r_taylor.h"
#include "r_tps.h"
#endif

#if REDUCE_MINOR_VERSION == 7
#include "r_alg.h"
#include "r_algint.h"
#include "r_applysym.h"
#include "r_arithmetic.h"
#include "r_arnum.h"
#include "r_cedit.h"
#include "r_cfap.h"
#include "r_complr.h"
#include "r_crack.h"
#include "r_dipoly.h"
#include "r_entry.h"
#include "r_ezgcd.h"
#include "r_factor.h"

#include "r_groebner.h"
#include "r_groebnr2.h"
#include "r_hephys.h"
#include "r_ideals.h"
#include "r_ineq.h"
#include "r_int.h"
#include "r_mathpr.h"
#include "r_matrix.h"
#include "r_misc.h"
#include "r_modsr.h"
#include "r_poly.h"
//#include "r_polydiv.h"
#include "r_pretty.h"
#include "r_prolog.h"
#include "r_rend.h"
#include "r_rlisp.h"
#include "r_rlisp88.h"
#include "r_roots.h"
#include "r_roots2.h"
#include "r_rprint.h"
#include "r_sfgamma.h"
#include "r_solve.h"
#include "r_specfn.h"
#include "r_sum.h"
#include "r_taylor.h"
#include "r_tps.h"
#endif

#if REDUCE_MINOR_VERSION == 8

#include "r_alg.h"
#include "r_arith.h"
#include "r_complr.h"
#include "r_cfap.h"
#include "r_mathpr.h"
#include "r_matrix.h"
/*
 * #include "r_module.h" #include "patches.h" 
 */
#include "r_poly.h"
#include "r_pretty.h"
#include "r_prolog.h"
#include "r_rend.h"
#include "r_rlisp.h"
#include "r_solve.h"
#include "r_int.h"
#include "r_defint.h"
#include "r_ezgcd.h"
#include "r_factor.h"
/*
 * #include "r_taylor.h" 
 */
#include "r_reduce4.h"
#include "r_linalg.h"
#include "r_fmprint.h"

#include "r_entry.h"
#include "r_cmacro.h"
#include "r_lap.h"
#include "r_fap.h"
#include "r_fisl.h"



#include "r_algint.h"
#include "r_arnum.h"
#include "r_dipoly.h"
#include "r_groebner.h"

#include "r_groebnr2.h"
#include "r_hephys.h"
#include "r_ideals.h"
#include "r_ineq.h"
#include "r_limits.h"
#include "r_numeric.h"
//#include "r_polydiv.h"
#include "r_odesolve.h"
#include "r_rlisp88.h"
#include "r_roots.h"
#include "r_roots2.h"
#include "r_rprint.h"
#include "r_rsolve.h"
#include "r_sfgamma.h"
#include "r_specbess.h"
#include "r_specfn.h"
#include "r_specfaux.h"
#include "r_specfn2.h"
#include "r_sum.h"
#include "r_taylor.h"
#include "r_tps.h"
#include "r_wu.h"
// #include "r_cl.h"

#include "r_ztrans.h"
#include "r_excalc.h"
#include "r_xideal.h"
#include "stub.h"

extern int      init_alg(void);
extern int      init_arith(void);
extern int      init_mathpr(void);
extern int      init_poly(void);
extern int      init_hephys(void);
extern int      init_rlisp(void);
extern int      init_rend(void);
extern int      init_entry(void);
extern int      init_prolog(void);
extern int      init_matrix(void);
extern int      init_solve(void);
extern int      init_ezgcd(void);
extern int      init_factor(void);
extern int      init_int(void);
extern int      init_algint(void);
extern int      init_roots(void);
extern int      init_roots2(void);
extern int      init_dipoly(void);
extern int      init_groebner(void);
extern int      init_groebnr2(void);
extern int      init_ideals(void);
extern int      init_sum(void);
//extern int      init_polydiv(void);
extern int      init_arnum(void);
extern int      init_cfap(void);
extern int      init_complr(void);
extern int      init_pretty(void);
extern int      init_rprint(void);
extern int      init_tps(void);
extern int      init_wu(void);
extern int      init_taylor(void);
extern int      init_ineq(void);
extern int      init_rlisp88(void);
extern int      init_trigsimp(void);
extern int      init_limits(void);
extern int      init_numeric(void);
extern int      init_odesolve(void);
extern int      init_rsolve(void);
extern int      init_specfn(void);
extern int      init_specfn2(void);
extern int      init_specfaux(void);
extern int      init_specbess(void);
extern int      init_sfgamma(void);
extern int      init_fmprint(void);
extern int      init_linalg(void);
extern int      init_reduce4(void);
extern int      init_listvecops(void);

extern int      init_fap(void);
extern int      init_lap(void);
extern int      init_fisl(void);
extern int      init_cmacro(void);
extern int      init_ccomp(void);

extern Sex	list_to_vector(Sex u);
extern Sex	CC_listKtoKvector(Sex u);
extern Sex	CC_gethash(Sex u, Sex v);
extern Sex	CC_puthash(Sex u, Sex v, Sex w);
extern Sex	CC_mkhash(Sex u, Sex v, Sex w);
//extern Sex	CC_makeKstringKunique(Sex u, Sex v, Sex w);

#endif

#include "protos.h"
#include "stubs.h"
#endif

#ifdef ASUKA

#ifndef Android
#include "r_sfap.h"
#include "r_complr.h"
#endif
#include "r_pretty.h"
#include "protos.h"

#ifndef Android
extern int      init_complr(void);
extern int      init_sfap(void);
#endif
extern int      init_pretty(void);
extern Sex      Lasuka_parse(void);
#define CC_asuka_parse	Lasuka_parse
#endif
