% MODULE CFAP --- generate C Code files


eval!-when(compile, flag('(modcmp), 'stayslow));

comment this section links lisp compiler to c code generator;

symbolic;

%flag('(smacro), 'compile);

deflist('((lsh leftshift)),'newnam);

deflist('((leftshift 6)),'infix);

fluid '(!*defn pathname filename registers exitlab!* exitstack!* conv!_table);

global '(!*compiler!-target!*);

!*compiler!-target!* := 'a;

global '(btime!* !*bakgag dfprint!* dfdebug!* !.nomessage !*showlap);

global '(!*lname!* !*entry!_name!* !*recursive!*);

global '(block!_level !*initialization!_procedure !.outfile !.infile);


%switch showlap;


global '(currentfn entrynames literals initials winp);

global '(ftypes!* !*module !*stayslow);

macro procedure printf (u) ;
%% Formatted printing. This function is used in entry.rl;
   if cdr u then
      if cddr u = nil then list('printf0, cadr u)
      else if cdddr u = nil then list('printf1, cadr u, caddr u)
      else list('vprintf,cadr u, if cddr u then 'list . cddr u);


procedure spaces(n);
   while n > 0 do <<
	fprin2(f, '! );
	n := n - 1;
   >>;

macro procedure fprintf (u) ;
%% Formatted printing. This function is used in entry.rl;
   if cddr u then
      if cdddr u = nil then list('fprintf0, cadr u, caddr u)
      else if cddddr u = nil then list('fprintf1, cadr u, caddr u, cadddr u)
      else list('vfprintf,cadr u, caddr u, 'list . cdddr u);



macro procedure sprintf (u) ;
   if cdr u then
      if cddr u = nil then list('sprintf0, cadr u)
      else if cdddr u = nil then list('sprintf1, cadr u, caddr u)
      else list('vsprintf,cadr u, if cddr u then 'list . cddr u);


procedure ccompile1 (x) ;
  if atom x then ccompiles x
   else if eq(car x ,'de)
    then ccompile2(cadr x,'expr,list('lambda,caddr x,cadddr x))
   else if eq(car x ,'df)
    then ccompile2(cadr x,'fexpr,list('lambda,caddr x,cadddr x))
   else if eq(car x ,'dm)
    then <<
	%ccompile2(cadr x, 'macro, list('lambda, caddr x, cadddr x));
	%initials := list('put, mkquote cadr x, mkquote 'macro, 
	%		mkquote cddr x) . initials;
	initials := list('putd, mkquote cadr x, mkquote 'macro, 
			mkquote list('lambda, caddr x, cadddr x)) . initials;
	>>
   else if eq(car x ,'ds)
    then <<
	%ccompile2(cadr x, 'smacro, list('lambda, caddr x, cadddr x));
	%initials := list('put, mkquote cadr x, mkquote 'smacro, 
	%		mkquote cddr x) . initials;
	initials := list('putd, mkquote cadr x, mkquote 'smacro, 
			mkquote list('lambda, caddr x, cadddr x)) . initials;
	>>
   else if eq(car x ,'putd)
	     and eqcar(cadr x,'quote)
	     and eqcar(caddr x,'quote)
	     and eqcar(cadddr x,'quote)
	     and flagp(cadr caddr x,'compile)
    then ccompile2(cadadr x,cadr caddr x,cadr cadddr x)
   else if eq(car x ,'putc)
	     and eqcar(cadr x,'quote)
	     and eqcar(caddr x,'quote)
	     and eqcar(cadddr x,'quote)
	     and flagp(cadr caddr x,'compile)
    then ccompile2(cadadr x,cadr caddr x,cadr cadddr x)
   else if eq(car x ,'eval!-when)
	     and (eqcar(cadr x,'compile) or memq('compile, cadr x))
    then errorset(caddr x, nil, nil)
   else if eq(car x ,'progn) then 
       begin scalar z;
	  z:=cdr x;
   loop:
	  if null z then return;
	  ccompile1 car z;
	  z := cdr z;
	  goto loop;
	end
   else if eq(car x ,'letfn) then eval x
   else ccompiles x;

procedure ccompile2(name,type,exp) ;
  if !*module then modcmp(name,type,exp)
   else ccompile3(name,type,exp);

procedure ccompile3(name,type,exp) ;
  begin scalar varlis, x;
     if not flagp(type,'compile)
       then error("ccompile3", list("UNCOMPILABLE FUNCTION",name,"OF TYPE",type));
     if memq(type ,'(expr fexpr)) and not eqcar(getd name,type)
       then put(name,'cfntype,list type);
     varlis := cadr exp;
     exp := !&comproc(exp,if memq(type ,'(expr fexpr)) then name);
     if !*showlap then <<
        printf("/* compile %p %n" , name);
	foreach x in exp do
		printf("%p%n", x);
        printf("*/%n");
     >>;
     ccompiles list('lap,
		  mkquote (list('!*entry,name,type,length varlis)
			     . exp));
  end;

procedure ccompile4(exp) ;
  begin scalar varlis;
     varlis := nil;
     exp:= list('lambda, nil, cons('progn, exp));
     exp := !&comproc(exp,'sugar!_initialization!_procedure);
     ccompiles list('lap, mkquote(list('!*init!_entry,'sugar!_initialization!_procedure,'expr, 0) . exp));
  end;

procedure print!-header(file);
  begin 
     printf("/*  compiler generated code for %p */%n", file);
     printf("#include <stdlib.h>%n");
     printf("#include <stdarg.h>%n");
     printf("#include <string.h>%n");
     printf("#include <ctype.h>%n");
     printf("#include ""config.h""%n");
     printf("#include ""tags.h""%n");
     printf("#include ""errors.h""%n");
     printf("#include ""externs.h""%n");
     printf("#include ""arith.h""%n");
     printf("#include ""macros.h""%n");
     printf("#include ""entries.h""%n");
     if not !*stayslow then 
         printf("#include ""%pprotos.h""%n", !*compiler!-target!*);
     printf("#include ""a_%p.h""%n", file);
     printf("%n");
     printf("extern Sex *literal_vectors[];%n");
     printf("extern int number_of_literal_vectors;%n");
     printf("Sex %p_literal_vector[];%n", file);
     printf("const char *%p_literal_string[];%n", file);
     printf("setup_type const  %p_%p_setup[];%n", file,
		!*compiler!-target!*);
%     printf("const char *%p_initialization_string[];%n", file);
     printf("#define LITERAL %p_literal_vector%n", file);
     printf("%n%n%n");
     return nil;
   end;

procedure ccompilefile (file) ;
  begin scalar x,ocrfil, wfl, rfl;
     btime!* := time();
     terpri();

     currentfn := 'ccompile;
     entrynames := nil;
     initials := nil;
     literals := nil;
     dfprint!* := 'ccompile1;
     !.nomessage := t;
     dfdebug!* := nil;
     filename := file;
     !*initialization!_procedure := nil;

      wfl := sprintf("a_%p.c", file); 
      wfl := wrs open(!.outfile := wfl, 'output);
      print!-header(file);

      rfl := sprintf("%p.m", file); 
      rfl := rds open(!.infile := rfl, 'input);
  b:
	x := asuka_parse();
	
	if x eq !$eof!$ then goto a;

	printf("/* compile1 %n");
        printf(" %p %n", x);
        printf(" */%n");
	ccompile1(x);
	goto b;
	
  a:
     ! ccompileendf();
     rds(nil);
     return nil;
  end;

     
procedure ! ccompileendf() ;
   begin scalar wfl, n, m, y, z, llen, x;
     terpri();
     z:= reversip initials;
   % z:= list('lambda, nil, cons('progn , z));
     terpri();
     printf("/* initialization procedure */%n");
   %  printf("static void _init()%n");
   %  printf("{ init_%p(void);}%n%n", filename);
     printf("int init_%p(void)%n", filename);
     printf("{%n");
     printf("   long i;%n");
     printf("%n");
     printf("   create_asuka_symbols(%p_%p_setup);%n",filename,
			!*compiler!-target!*);
     printf("   literal_vectors[number_of_literal_vectors++] = %n");
     printf("               LITERAL;%n");
     printf("   for(i = 0; %p_literal_string[i] != NULL ; i++)%n",filename);
     printf("           LITERAL[i] %n");
     printf("               = make_asuka_literal(%p_literal_string[i]);%n", filename);
     printf("   LITERAL[i] = (Sex)NULL;%n");
     !*initialization!_procedure := t;
     
	block!_level := block!_level + 4;
     ccompile4(z);
	block!_level := block!_level - 4;
     llen := length literals;


     %printf("}%n");

	
     printf("Sex LITERAL[%p];%n", llen+1);

     printf("%nconst  char *%p_literal_string[%p] = %n", filename, llen+1);
     printf("{%n");

     n := 0;
     z := literals;
     while z do <<
	printf("/* %p */%n""%a"",%n", n, car z);
	n := n+1;
	z := cdr z;
     >>;
     printf("/* %p */ NULL%n};%n", n);

     printf("setup_type const %p_%p_setup[] = %n", filename,
		!*compiler!-target!*);
     printf("{%n");
     z := entrynames;
     while z do <<
	x := car z;
	y := get(x, 'entry);
	printf("    {""%p"", (lisp_proc *)%p, ", x, c!_entryname(x) ) ;
        if y then <<
	    if car(y) eq 'expr then
	       printf("%p},%n", cadr y) 
	    else if car(y) eq 'fexpr then
	       printf("-1},%n")
	    else if car(y) eq 'macro then
	       printf("-2},%n")
	    else if car(y) eq 'smacro then
	       printf("%p},%n", -3 - cadr y) ;
	>>;
	z := cdr z;
     >>;
     printf("    {NULL, NULL, 0 }%n" );
     printf("};%n");
	
     terpri();
     
     wfl := sprintf("a_%p.h", filename);
    % ! output list wfl;
     if pathname then
         !.outfile := sprintf("%p/a_%p.h", pathname, filename)
     else
         !.outfile := sprintf("a_%p.h", filename);
     wrs open (!.outfile, 'output);
     printf("#ifndef _R_%U_H_%n", filename);
     printf("#define _R_%U_H_%n", filename);
     z := entrynames;
     while z do <<
	x := car z;
	y := get(x, 'entry);
        if y then <<
	    if !*stayslow or flagp(x, 'stayslow) or flagp(x, 'static) then
	        printf("static Sex %p(", c!_entryname(x))
	    else
	        printf("Sex %p(", c!_entryname(x));
            n := 0;
	    while n < cadr y do <<
	       n := n+1;
               if n = 1 then printf("Sex %p", !*!*arg n)
	        else printf(", Sex %p", !*!*arg n);
	       if n = 5 then terpri();
	    >>;
	    if n = 0 then printf("void");
	    printf(");%n");
	>>;
	z := cdr z;
     >>;
    %% wrs wfl;

     terpri();
     printf("#endif%n");
     wrs (!.outfile := nil);
	
     z := entrynames;
     while z do <<
	remprop(car z, 'entry);
	z := cdr z;
     >>;
     entrynames:= nil;
     literals := nil;
     dfprint!* := nil;
     terpri();
     !*defn := nil;
   end;



procedure ccompend ();
  begin scalar z;
     z := entrynames;
     while z do <<
	remprop(car z, 'entry);
	z := cdr z;
     >>;
     entrynames := nil;
     literals := nil;
     rds nil;
     dfprint!* := nil;
     terpri();
     !*defn := nil;
  end;

flag('(ccompend),'ignore);

put('ccompend,'stat,'endstat);

procedure ccompiles1 (x) ;
  if null x then t
   else if atom x then prin2t list("UnCCOMP'd:",x)
   else ccompify x;

procedure ccompiles (x) ;
  begin
     currentfn := 'ccompiles;
     winp := errorset(list('ccompiles1,mkquote x),t,!*bakgag);
     winp :=
      if atom winp
	then <<terpri();
	       prin2t list("CCOMP aborted, in",currentfn);
	       terpri()>>
       else t;
     return winp;
  end;


procedure ccompify (y) ;
  begin scalar code;
     currentfn := 'ccompify;
     if atom y then nil
      else if eq(car y ,'lap)
       then begin
	       code := cadr cadr y;
	       currentfn := cadar code;
	       fap(code);
	    end
      else if mungeable y
       then <<if eq(car y ,'setq) then currentfn := cadr y;
              initials := y . initials
	>>
      else if not memq(car y ,'(comment quote))
       then prin2t list("UnCCOMP'd:",y);
  end;

procedure mungeable (x) ;
   not (memq(car x ,'(comment quote))
	  or eq(car x ,'eval) and not atom cadr x and eq(caadr x ,'quote)) ;




%% MODULE LAP --- LISP assembly program for C code
%% Author: Fujio Kako			85-8-29;




%comment global and fluid variables used in this section:

%literals    association list for quote and fluid address constant locs
%!*holddef flag indicating that compiled definition should be 'held';

global '(!*holddef );


procedure lap(x);
  lap!-c(x);

procedure fap(x);
  fap!-c(x);

procedure lap!-c(x) ;
  begin scalar v,w,y,z;

     if eq(caar x ,'!*entry) then <<w := cddar x>>;
     y := cdr x;
   lp1:
     if null y then goto lp2
      else if flagp(caar y,'mc) %% expand macroes
       then apply(caar y,cdar y);
     y := cdr y;
     goto lp1;
   lp2:
     if eq(car w ,'expr) then y := 'subr
      else if eq(car w ,'fexpr) then y := 'fsubr
      else if flagp(car w,'compile) then y := w
      else lprie list(car w,"UNCOMPILABLE TYPE");
     return ;
  end;


procedure fap!-c(x) ;
  begin scalar v,w,y,z, n;

     terpri();
     if get(currentfn,'entry)
         then <<prin2 "/*"; 
		prin2 list("Duplicate entryname:",currentfn);
		prin2 "Ignore the current definition.";
		prin2t "*/";
		return>>;
	if !*plap then <<
	    z := x;
	    while z do <<
		print car z;
		z := cdr z;
	    >>;
	>>;
     if eq(caar x ,'!*entry) then !*lname!* := cadar x;
     y := x;
     !*recursive!* := nil;
     registers := 0;
     v := nil;
     w := t;
   lp3:
     if null y then goto lp4;
     z := car y;
     if w and eq(car z, '!*store) and numberp caddr z then
	v := caddr z . v;
     if eq(car z ,'!*load) then
	registers := max2(cadr z, registers);
     if flagp(car z, 'mc!-jump) then w:=nil;
     if (eq(car z , '!*link) or eq(car z, '!*linke)) then
        registers := max2(1, registers);
     if eq(car z , '!*linke) and eq (cadr z, !*lname!*) then
	!*recursive!* :=t ;
     y := cdr y;
     goto lp3;
   lp4:
     registers := registers . v;
	%foreach y in x do print y;
     y := x;
   lp1:
     if null y then goto lp2;
     z := car y;
     if flagp(car z,'mc) %% expand macroes
       then apply(car z,cdr z)
      else printf("non macro call : %p%n", z);
     y := cdr y;
     goto lp1;
   lp2:
     if not (block!_level = 0) then <<
	printf("}%n");
	block!_level := block!_level - 4;
     >>;
     return;
  end;




procedure !&numeq(u,v) ;
 %  % Distinguishs between equal fixed and floating numbers;
  if null (u=v) then nil
   else if null numberp u then t
   else if floatp u then floatp v
   else null floatp v;


%%********************************************************************
%% MODULE cmacro --- C code generator
%
%% Author: Fujio Kako			97-9-10
%
%%;

global '(maxnargs !*nolinke !*plap );


maxnargs := 13;			%% Maximum number of args.;




procedure !&mkfunc (fn) ;
   begin scalar x;
     x := get(fn, '!*subr);
     if !*holddef and x
       then <<putd(fn, car x, cdr x);
              remprop(fn, '!*subr) >>;
     return mkquote fn
   end;

flag('(!*alloc !*dealloc !*entry !*exit !*store !*jump !*jumpc
      !*jumpnc !*jumpt !*jumpnil !*jumpe !*jumpn 
      !*jumpge !*jumpgt !*jumple !*jumplt
      !*lbl !*lambind !*progbind !*freerstr
      !*comment  !*init!_entry
      !*move !*load !*link !*linke !*code),'mc);

flag('(!*jump !*jumpc
      !*jumpnc !*jumpt !*jumpnil !*jumpe !*jumpn 
      !*jumpge !*jumpgt !*jumple !*jumplt
      !*link !*linke ),'mc!-jump);

block!_level := 0;

procedure !*comment(stack,exitlab) ;
       <<exitstack!* := stack;
         if stack <= 0 then exitlab!* := exitlab
          else exitlab!* := nil;
         nil>>;

procedure !*noop (n) ; 
	nil;

procedure !*entry(name,type,args) ;
  begin scalar n;
   block!_level := 0;
   put(name, 'entry, list(type, args));
   entrynames := name . entrynames;
   if !*stayslow or flagp(name, 'stayslow) or flagp(name, 'static) then
       printf("static  Sex %p(", c!_entryname name)
   else
       printf("Sex %p(", c!_entryname name);
   n := 0;
   while n < args do <<
       n := n + 1 ;
       if n = 1 then printf("Sex a")
        else printf(", Sex %p", !*!*arg n);
       if n = 5 then terpri() >>;
   if n = 0 then printf("void");
   printf(")%n{%n");
   block!_level := 4;
   if args >= car registers then return nil;
   n := args + 1;
   spaces(block!_level);
   printf("Sex %p", !*!*arg n);
   n := n + 1;
   while n <= car registers do  <<
        printf(", %p", !*!*arg n);
	 n := n + 1>>;
   printf(";%n");

  end;

procedure !*init!_entry(name,type,args) ;
  begin scalar n;
   block!_level := 4;
   spaces(block!_level);
   printf("{%n");
   block!_level := 8;
   if 0 >= car registers then return nil;
   n := 1;
   spaces(block!_level);
   printf("Sex %p", !*!*arg n);
   n := n + 1;
   while n <= car registers do  <<
        printf(", %p", !*!*arg n);
	 n := n + 1>>;
   printf(";%n");
   %printf("}%n");

  end;

procedure !*alloc(n) ;
   begin 
      !*entry!_name!* := gensym();
      if n > 0 then <<
	spaces(block!_level);
	printf("Sex *sp = stack;%n");
	spaces(block!_level);
	printf("stackcheck();%n");
	spaces(block!_level);
	printf("stack = sp + %p;%n", n);
	while n > 0 do <<
	    if not memq(1-n, registers) then <<
	        spaces(block!_level);
	        printf("w%p = nil;%n", n);
	    >>;
	    n := n - 1;
	>>;
     >>;
     if !*recursive!* then
         printf("%p:%n", !*entry!_name!*);
   end;

procedure !*dealloc (n) ;
   if n>0 then
    <<spaces(block!_level);printf("popv(%p);%n", n);>>;

procedure !*exit ();
   if !*initialization!_procedure then
   << spaces(block!_level);
    printf("return 1;%n");
    block!_level := block!_level-4;
    spaces(block!_level);
    printf("}%n")
   >>
   else
   <<spaces(block!_level);
    printf("return a;%n");
    block!_level := block!_level-4;
    spaces(block!_level);
    printf("}%n")
    >>;


procedure !*!*arg (reg) ; 	%% get the address of reg/floc;
  if not numberp reg then reg
   else if reg=1 then 'a
   else if reg=2 then 'q
   else if reg=3 then 'm
   else if reg>3
    then sprintf("arg%p", reg)
   else sprintf("w%p",1-reg);

%%	Jump instructions;

procedure !*jump (adr) ;
      if eq(adr ,exitlab!*) then !*dealext (exitstack!*)
      else <<spaces(block!_level);
	     printf("goto %p;%n",adr);>>;


procedure !*jumpc(adr,reg,type) ;
   begin scalar form;
     if type = 'null then form := "%Tif(%p == nil) goto %p;%n"
     else if type = 'atom then form := "%Tif(!is_cons(%p)) goto %p;%n"
     else if type = 'pairp then form := "%Tif(is_cons(%p)) goto %p;%n"
     else if type = 'idp then form := "%Tif(is_symbol(%p)) goto %p;%n"
     else if type = 'stringp then form := "%Tif(is_string(%p)) goto %p;%n"
     else if type = 'vectorp then form := "%Tif(is_vector(%p)) goto %p;%n"
     else if type = 'logp then form := "%Tif(is_logical(%p)) goto %p;%n"
     else if type = 'bigp then form := "%Tif(is_bigint(%p)) goto %p;%n"
     else if type = 'floatp then form := "%Tif(is_float(%p)) goto %p;%n"
     else if type = 'numberp then form := "%Tif(is_number(%p)) goto %p;%n"
     else if type = 'intp then form := "%Tif(is_integer(%p)) goto %p;%n"
     else if type = 'fixp then form := "%Tif(is_integer(%p)) goto %p;%n"
     else if type = 'rationalp then form := "%Tif(is_rational(%p)) goto %p;%n"
     else if type = 'complexp then form := "%Tif(is_complex(%p)) goto %p;%n"
     else if type = 'fixnump then form := "%Tif(is_fixnum(%p)) goto %p;%n"
     else error("UNKNOWN JUMP ", type);
    printf(form , block!_level, !*address(reg), adr);
   end;

procedure !*jumpnc(adr,reg,type) ;
   begin scalar form;
     if type = 'null then form := "%Tif(%p != nil) goto %p;%n"
     else if type = 'atom then form := "%Tif(is_cons(%p)) goto %p;%n"
     else if type = 'pairp then form := "%Tif(!is_cons(%p)) goto %p;%n"
     else if type = 'idp then form := "%Tif(!is_symbol(%p)) goto %p;%n"
     else if type = 'stringp then form := "%Tif(!is_string(%p)) goto %p;%n"
     else if type = 'vectorp then form := "%Tif(!is_vector(%p)) goto %p;%n"
     else if type = 'logp then form := "%Tif(!is_logical(%p)) goto %p;%n"
     else if type = 'bigp then form := "%Tif(!is_bigint(%p)) goto %p;%n"
     else if type = 'floatp then form := "%Tif(!is_float(%p)) goto %p;%n"
     else if type = 'numberp then form := "%Tif(!is_number(%p)) goto %p;%n"
     else if type = 'intp then form := "%Tif(!is_integer(%p)) goto %p;%n"
     else if type = 'fixp then form := "%Tif(!is_integer(%p)) goto %p;%n"
     else if type = 'rationalp then form := "%Tif(!is_rational(%p)) goto %p;%n"
     else if type = 'complexp then form := "%Tif(!is_complex(%p)) goto %p;%n"
     else if type = 'fixnump then form := "%Tif(!is_fixnum(%p)) goto %p;%n"
     else error("UNKNOWN JUMP ", type);
    printf(form , block!_level, !*address(reg), adr);
   end;

procedure !*jumpt(adr,exp) ;
    printf("%Tif(%p != nil) goto %p;%n", 
		block!_level, !*address(exp), adr);

procedure !*jumpnil(adr,exp) ;
    printf("%Tif(%p == nil) goto %p;%n", 
		block!_level, !*address(exp), adr);

procedure !*jumpe(adr,exp1,exp2) ;
    printf("%Tif(%p == %p) goto %p;%n", 
		block!_level, !*address(exp1), !*address(exp2), adr);

procedure !*jumpn(adr,exp1,exp2) ;
    printf("%Tif(%p != %p) goto %p;%n", 
		block!_level, !*address(exp1), !*address(exp2), adr);

procedure !*jumpge(adr,exp1,exp2) ;
    printf("%Tif(%p >= %p) goto %p;%n", 
		block!_level, !*address(exp1), !*address(exp2), adr);

procedure !*jumpgt(adr,exp1,exp2) ;
    printf("%Tif(%p > %p) goto %p;%n", 
		block!_level, !*address(exp1), !*address(exp2), adr);

procedure !*jumple(adr,exp1,exp2) ;
    printf("%Tif(%p <= %p) goto %p;%n", 
		block!_level, !*address(exp1), !*address(exp2), adr);

procedure !*jumplt(adr,exp1,exp2) ;
        printf("%Tif(%p < %p) goto %p;%n", 
		block!_level, !*address(exp1), !*address(exp2), adr);

procedure !*lbl (adr) ; 
   		printf("%p:%n", adr);

%%	lambda binding and prog binding;

procedure !*lambind(regs,alst) ;
  begin scalar m, u, v;
     m := 0;
     spaces(block!_level);
     printf("{%n");
     block!_level := block!_level + 4;
     spaces(block!_level);
     printf("Sex *_w = bstack, *_v;%n");
     spaces(block!_level);
     printf("bstackcheck();%n");
     
 a:  
   %  if null alst then goto b
   %   else if not fluidp caar alst
   %    then lprie list(car alst,"not fluid");
   %  u := literalindex caar alst;
     if null alst then goto b
      else if not fluidp car alst
       then lprie list(car alst,"not fluid");
     u := literalindex car alst;
     v := !*address car regs;
     spaces(block!_level);
     printf("pushbv(%p, %p, %p);%n", m, u, v);
     m := m + 2;
     regs := cdr regs;
     alst := cdr alst;
     goto a;
  b:
     spaces(block!_level);
     printf("bstack = _w + %p;%n", m);
     block!_level := block!_level - 4;
     spaces(block!_level);
     printf("}%n");
  end;


procedure !*progbind(alst) ;
  begin scalar m, u;
     m := 0;
     spaces(block!_level);
     printf("{%n");
     block!_level := block!_level + 4;
     spaces(block!_level);
     printf("Sex *_w = bstack, *_v;%n");
     spaces(block!_level);
     printf("bstackcheck();%n");
     
 a:  
  %   if null alst then goto b
  %    else if not fluidp caar alst
  %     then lprie list(car alst,"not fluid");
  %   u := literalindex caar alst;
     if null alst then goto b
      else if not fluidp car alst
       then lprie list(car alst,"not fluid");
     u := literalindex car alst;
     spaces(block!_level);
     printf("pushbv(%p, %p, nil);%n", m, u);
     m := m + 2;
     alst := cdr alst;
     goto a;
  b:
     spaces(block!_level);
     printf("bstack = _w + %p;%n", m);
     block!_level := block!_level - 4;
     spaces(block!_level);
     printf("}%n");
  end;


procedure !*freerstr(alst) ;
  begin scalar m;
     m := 0;
     spaces(block!_level);
     printf("{%n");
     block!_level := block!_level + 4;
     spaces(block!_level);
     printf("Sex *_w = bstack;%n");
     
 a:  
   %  if null alst then goto b
   %   else if not fluidp caar alst
   %    then lprie list(car alst,"not fluid");
     if null alst then goto b
      else if not fluidp car alst
       then lprie list(car alst,"not fluid");
     spaces(block!_level);
     printf("popbv(%p);%n", m);
     m := m - 2;
     alst := cdr alst;
     goto a;
  b:
     spaces(block!_level);
     printf("bstack = _w - %p;%n", -m);
     block!_level := block!_level - 4;
     spaces(block!_level);
     printf("}%n");
  end;



procedure !*load(reg,exp) ; 
		!*move(exp, reg);

procedure !*store(reg,exp) ; 
		!*move(reg,exp);

procedure !*move(src,dst) ;
 begin 
  src := !*address src;
  dst := !*address dst;
  spaces(block!_level);
  printf("%p = %p;%n", dst, src);
 end;

procedure !*address(exp) ;
 if null exp then 'nil
 else if eq(exp ,'t) then 'true
 else if equal(exp, ''nil) then 'nil
 else if equal(exp, ''t) then 'true
 else if numberp exp then !*!*arg exp
 else if atom exp then exp
 else if eq(car exp ,'quote) then
	literalindex(cadr exp)
 else if memq(car exp ,'(fluid global)) then 
	sprintf("value(%p)", literalindex(cadr exp))
 else if eq(car exp ,'car) then 
	sprintf("car(%p)", !*address cadr exp)
 else if eq(car exp ,'cdr) then 
	sprintf("cdr(%p)", !*address cadr exp)
 else lprie list("incomplete macro definition for", car exp);

procedure literalindex(exp) ;
  begin scalar x,n, l;
  %  if fixp(exp) and exp >= -0x8000000 and exp <= 0x7ffffff then
  %	return sprintf("mkfxat(%p)", exp);
    if is!-char(exp) then
	return sprintf("CHAR_OF(%p)", char!-code(exp));
    if fixp(exp) and exp >= -134217728 and exp <= 134217727 then
  	return sprintf("mkfxat(%p)", exp);
    n := 0;
    x := literals;
 a: if null x then goto b;
	if eql(exp, car x) then goto c;
	n := n+1;
	x := cdr x;
    goto a;
  b:
   literals:= nconc(literals, list exp);
   if idp exp then <<
      l := c!_literalname exp;
      printf("#define %p LITERAL[%p]%n", l, n)
   >> else <<
      return sprintf("LITERAL[%p]", n)
   >>;
  c:
   if idp exp then 
      return c!_literalname exp
    else 
      return sprintf("LITERAL[%p]", n);
 end;
	




procedure !*link(fn,type,nargs, reg) ;
   begin scalar n, l;

	if eq(fn, 'car) then
		printf("%Ta = car(a);%n", block!_level)
	else if eq(fn , 'cdr) then
		printf("%Ta = cdr(a);%n", block!_level)
	else if eq(fn, 'rplaca) then
		printf("%Tcar(a) = q;%n", block!_level)
	else if eq(fn, 'rplacd) then
		printf("%Tcdr(a) = q;%n", block!_level)
	else if eq(fn, 'iplus2) then
		printf("%Ta = (Sex)((long) a + (long) q - TAG_FIXNUM);%n", 
			block!_level)
	else if eq(fn, 'idifference) then
		printf("%Ta = (Sex)((long) a - (long) q + TAG_FIXNUM);%n", 
			block!_level)
	else if eq(fn, 'iadd1) then
		printf("%Ta = (Sex)((long) a +0x10);%n", block!_level)
	else if eq(fn, 'isub1) then
		printf("%Ta = (Sex)((long) a -0x10);%n", block!_level)
     else <<
    
     n := 1;
     

     if !*stayslow or flagp(fn, 'stayslow) or flagp(fn, 'slowlink) then  <<
         l := literalindex fn;
         spaces(block!_level);
         if reg then printf("a = ");
         printf("apply%p(%p", nargs, l);
         while n <= nargs do  <<
	     printf(", %p", !*!*arg n);
	     n := n + 1>>;
     >> else  <<
         spaces(block!_level);
         if reg then printf("a = ");
         printf("%p(" , c!_entryname fn );
         while n <= nargs do <<
            if n = 1 then printf("%p", !*!*arg n)
	     else printf(", %p", !*!*arg n);
	    n := n + 1;
        >>;
     >>;
     printf(");%n");
    >>;
 end;

procedure !*linke(fn, type,nargs, reg, n) ;
  if !*initialization!_procedure then <<
     if n>0 then
        <<spaces(block!_level);printf("popv(%p);%n", n);>>;
     !*link(fn, type, nargs, reg);
     spaces(block!_level);
     printf("return 1;%n");
     block!_level := block!_level - 4;
     spaces(block!_level);
     printf("}%n");
  >> else if eq(fn, !*lname!*) then <<
	spaces(block!_level);
	printf("goto %p; /* recursive call to %p */%n", !*entry!_name!*, fn);
  >> else
   begin  scalar l;
     spaces(block!_level);
     printf("{%n");
     block!_level := block!_level +4;
     if n>0 then
        <<spaces(block!_level);printf("popv(%p);%n", n);>>;
     if eq(fn, 'car) then
		printf("%Treturn car(a);%n", block!_level)
	else if eq(fn , 'cdr) then
		printf("%Treturn cdr(a);%n", block!_level)
	else if eq(fn, 'rplaca) then
		printf("%Tcar(a) = q;%n%Treturn a;%n", 
			block!_level, block!_level)
	else if eq(fn, 'rplacd) then
		printf("%Tcdr(a) = q;%n%Treturn a;%n", 
			block!_level, block!_level)
	else if eq(fn, 'iplus2) then
		printf("%Treturn (Sex)((long) a + (long) q - TAG_FIXNUM);%n", 
			block!_level)
	else if eq(fn, 'idifference) then
		printf("%Treturn (Sex)((long) a - (long) q + TAG_FIXNUM);%n", 
			block!_level)
	else if eq(fn, 'iadd1) then
		printf("%Treturn (Sex)((long) a +0x10);%n", block!_level)
	else if eq(fn, 'isub1) then
		printf("%Treturn (Sex)((long) a -0x10);%n", block!_level)
     else if eq(fn, 'eval) then
	printf("%Treturn eval(a, nil);", block!_level)
     else <<
	 if !*stayslow or flagp(fn, 'stayslow) or flagp(fn, 'slowlink) then <<
	       l := literalindex fn;
               spaces(block!_level);
               printf("return  apply%p(%p", nargs, l);
               n := 1;
               while n <= nargs do <<
	           printf(", %p", !*!*arg n);
	          n := n + 1;
               >>;
         >> else <<
             spaces(block!_level);
             printf("return  %p(", c!_entryname fn);
               n := 1;
               while n <= nargs do <<
                  if n = 1 then printf("%p", !*!*arg n)
	           else printf(", %p", !*!*arg n);
	          n := n + 1;
               >>;
         >>;
         printf(");%n");
      >>;
%	spaces(block!_level+4);
%	printf("/* %a */%n", fn);
     block!_level:=block!_level-4;
     spaces(block!_level);
     printf("}%n");
 end;


%%	Optimization of type checks;

put('atom,'comtst,'!&testfn);

put('numberp,'comtst,'!&testfn);

put('logp,'comtst,'!&testfn);

put('floatp,'comtst,'!&testfn);

put('bigp,'comtst,'!&testfn);

put('stringp,'comtst,'!&testfn);

put('pairp,'comtst,'!&testfn);

put('null,'comtst,'!&testfn);

put('idp,'comtst,'!&testfn);

put('fixp,'comtst,'!&testfn);

put('fixnump,'comtst,'!&testfn);

put('vectorp,'comtst,'!&testfn);


put('intp, 'comtst, '!&testfn);


procedure !*dealext (n) ;
   begin 
     if n>0 then
        <<spaces(block!_level);printf("popv(%p);%n", n);>>;
      if !*initialization!_procedure then
      <<
          block!_level := block!_level-4;
          printf("return 1;}%n");
      >>
      else
      <<
          spaces(block!_level);
          printf("return a;%n}%n");
          block!_level := block!_level-4;
          printf("}%n");
      >>;
   end;



flag('(!*dealext !*noop),'mc);



deflist('((car    (lambda (x y) ((move (y a6) x) (move (x) x  ))))
	  (cdr    (lambda (x y) ((move (y a6) x) (move (4 x) x))))
      %    (rplaca (lambda (x y) ((move (y a6) x) (move (x) x  ))))
      %    (rplacd (lambda (x y) ((move (y a6) x) (move (x) x  ))))
		),
	'anyreg);


global '(c!_char!_mappings);

c!_char!_mappings := '(
  (!  . !A)  (!! . !B)  (!# . !C)  (!$ . !D)
  (!% . !E)  (!^ . !F)  (!& . !G)  (!* . !H)
  (!( . !I)  (!) . !J)  (!- . !K)  (!+ . !L)
  (!= . !M)  (!\ . !N)  (!| . !O)  (!, . !P)
  (!. . !Q)  (!< . !R)  (!> . !S)  (!: . !T)
  (!; . !U)  (!/ . !V)  (!? . !W)  (!~ . !X)
  (!` . !Y));

procedure c!_entryname(fn) ;
   begin scalar c, r,w, x,z;
      if (x := get(fn, 'centryname)) then return x;
      r := '(!_ !C !C !");
      z := explodec fn;
      while z do <<
	 c := car z;
	 z := cdr z;
         if c = '!_ then r:= '!_ . r
         else if liter c or digit c then r := c . r
         else if w:= atsoc(c, c!_char!_mappings) then r := cdr w . r
         else if c = '!{ then r := '!Z . ('!A  .  r)
         else if c = '!} then r := '!Z . ('!B  .  r)
         else r := '!Z  .  r;
     >>;
     r := '!" . r;
    return compress reverse r;
   end;

procedure c!_literalname(fn) ;
   begin scalar c, r,w, z;
      r := '(!_ !L !L !");
      z := explodec fn;
      while z do <<
	 c := car z;
	 z := cdr z;
         if c = '!_ then r:= '!_ . r
         else if liter c or digit c then r := c . r
         else if w:= atsoc(c, c!_char!_mappings) then r := cdr w . r
         else if c = '!{ then r := '!Z . ('!A  .  r)
         else if c = '!} then r := '!Z . ('!B  .  r)
         else r := '!Z  .  r;
     >>;
     r := '!" . r;
    return compress reverse r;
   end;
        

deflist('(
    (abs   !Labs) (acos   !Lacos) (acosh   !Lacosh) (asec   !Lasec) (asech   !Lasech)
    (asin   !Lasin) (asinh   !Lasinh) (atan2   !Latan2) (atanh   !Latanh) (cbrt   !Lcbrt)
    (cos   !Lcos) (cosh   !Lcosh) (exp   !Lexp) (expt   Aexpt) (hypot   !Lhypot)
    (ln   !Llog) (log   !Llog) (log10   !Llog10) (sec   !Lsec) (sech   !Lsech)
    (sin   !Lsin) (sinh   !Lsinh) (sqrt   !Lsqrt) (tan   !Ltan) (tanh   !Ltanh)
    (logb   !Llog_2)    (atan   !Latan) (csc   !Lcsc) (csch   !Lcsch) (cot   !Lcot)
    (coth   !Lcoth) (acsc   !Lacsc) (acsch   !Lacsch) (acot   !Lacot) (acoth   !Lacoth)
    (pi   !Lpi) (e   !Le) (e_x   !Le_x) (factorial   !Lfactorial) (pfactorial   !Lpfactorial)
    (binomial   !Lbinomial)
  ), 'centryname);

deflist('(
    (make_hash_table   !Lmake_hash_table  )
    (hash_table_p   !Lhash_table_p  )
    (gethash   !Lgethash  )
    (remhash   !Lremhash  )
    (maphash   !Lmaphash  )
    (clrhash   !Lclrhash  )
    (hash_table_count   !Lhash_table_count  )
    (hash_table_size   !Lhash_table_size  )
    (sxhash   !Lsxhash  )
    (hash_equal   !Lhash_equal  )
    (sethash   !Lsethash  3)
    (next_hash_table_entry   !Lnext_hash_table_entry  )
    (hcons   !Lhcons  )
    (maphcons   !Lmaphcons  )
    (hmapcar   !Lhmapcar  )
    (happend   !Lhappend  )
    (hlist   hlist_fn  )
  ), 'centryname);

deflist('(
    (mkalgnum   mkalgnum  ) 
    (algebraic   mk_algebraic  )  
    (is_algnum   Lis_algnum  ) 
  ), 'centryname);

deflist('(
    (setkorder   !Lsetkorder)
    (setorder   !Lsetorder)
    (set_order   !Lsetorder)
    (reorder   !Lreorder)
    (simplify   !Lsimplify)
    (simp   !Lsimplify)
    (symbol_to_polynomial   symbol_to_polynomial)
    (resultant   !Lresultant)
    (resultant_bezout1   !Lresultant_bezout1)
    (resultant_bezout2   !Lresultant_bezout2)
    (resultant_det   !Lresultant_det)
    (resultant_poly   !Lresultant_poly)
    (gquotient   gquot2)
    (gremainder   gremaind2)
    (wuremainder   wuremainder)
    (premainder   gpremaind2)
    (pquotient   gpquotient2)
    (pdivide   gpdivide2)
    (rremainder   grremaind2)
    (rquotient   grquotient2)
    (rdivide   grdivide2)
    (sub   !Asub)
    (reval   !Areval)

  ), 'centryname);

deflist('(
    (!:!=  !Msetf_fn)
    (setq  !Msetf_fn)
    (read  !Mread)
    (import  !Mimport)
    (save  !Msave)
    (for  !Mfor)
    (!!  !Mfactorial)
    (intersect  !Mintersect)
    (set_diff  !Mset_diff)
    (!$  !Mrange)
    (!.!.  !Momit)
    (!@!@  !Mitrsyth)
    (setm  !Mset)
    (listq  !Mlist)
    (!.  !Mconect)
    (!%  !Mlabel)
    (array  !Marray)

  ), 'centryname);

deflist('(
    (poly_pol  !Mpoly_pol)
    (mkterm  !Mmkterm)
    (mvar  !Mvar)
    (mdeg  !Mdeg)
    (mpower  !Mlpower)
    (mlpower  !Mlpower)
    (minit  !Minit)
    (mtail  !Mreduct)
    (mreduct  !Mreduct)
    (mlterm  !Mlterm)
    (mlcoeff  !Minit)
    (mquot  gquot2)
    (mrem  gremaind2)
    (deg  !Adeg)
    (tdeg  !Atdeg)
    (mcdeg  !Amtdeg_coeff)
    (tcdeg  !Atdeg_coeff)
    (poly2dist  !Apoly2dist)
    (expvec  !Aexpvec)
    (expvec2  !Aexpvec2)
    (init  !Ainit)
    (tail  !Areduct)
    (reduct  !Areduct)
    (lterm  !Alterm)
    (lpower  !Alpower)
    (lcoeff  !Ainit)
    (pquot  gpquotient2)
    (prem  gpremaind2)
    (times  !Mtimes)
    (pgcd  !Mpgcd)
    (Mgcd  !Mgcd)
    (sqfree  !Msqfree)
    (cont  !Mcont)
    (pp  !Mpp)
    (norm  !Norm)
    (lbibun  !Lbibun)
    (diff  !Adiff)
    (is_poly  !Lis_poly)
    (is_number  !Lis_number)
    (compare_var  !Mcompare_var)
    (orderp  !Lorderp)
    (orderpp  !Mcompare_var)

  ), 'centryname);
deflist('(

    (acons  !Lacons)
    (atom  !Latom)
    (boundp  !Lboundp)
    (car  !Lcar)
    (cdr  !Lcdr)
    (caar  !Lcaar)
    (cadr  !Lcadr)
    (cdar  !Lcdar)
    (cddr  !Lcddr)
    (caaar  !Lcaaar)
    (caadr  !Lcaadr)
    (cadar  !Lcadar)
    (caddr  !Lcaddr)
    (cdaar  !Lcdaar)
    (cdadr  !Lcdadr)
    (cddar  !Lcddar)
    (cdddr  !Lcdddr)
    (caaaar  !Lcaaaar)
    (caaadr  !Lcaaadr)
    (caadar  !Lcaadar)
    (caaddr  !Lcaaddr)
    (cadaar  !Lcadaar)
    (cadadr  !Lcadadr)
    (caddar  !Lcaddar)
    (cadddr  !Lcadddr)
    (cdaaar  !Lcdaaar)
    (cdaadr  !Lcdaadr)
    (cdadar  !Lcdadar)
    (cdaddr  !Lcdaddr)
    (cddaar  !Lcddaar)
    (cddadr  !Lcddadr)
    (cdddar  !Lcdddar)
    (cddddr  !Lcddddr)
    (first  !Lcar)
    (second  !Lcadr)
    (third  !Lcaddr)
    (rest  !Lcdr)

    (codep  !Acodep)
    (constantp  !Aconstantp)
    (date  !Adate)
    (error  !Aerror)
    (error1  !Aerror1)
    (error2  !Aerror2)
    (fixp  !Afixp)
    (bigp  !Abigp)
    (modularp  !Ais_modular)
    (logicalp  !Alogicalp)
    (floatp  !Afloatp)
    (bfloatp  !Abfloatp)
    (rationalp  !Arationalp)
    (complexp  !Acomplexp)
    (complp  !Acomplexp)
    (ecomplexp  !Aecomplexp)
    (becomplexp  !Abecomplexp)
    (efloatp  !Aefloatp)
    (befloatp  !Abefloatp)
    (intervalp  !Aintervalp)
    (bintervalp  !Abintervalp)
    (fluidp  !Lfluidp)
    (gctime  !Agctime)
    (gccalled  !Agccalled)
    (get  !Aget)
    (globalp  !Lglobalp)
    (list2  !Llist2)
    (list3  !Llist3)
    (list4  !Llist4 )
    (list5  !Llist5 )
    (global  !Lglobal)
    (fluid  !Lfluid)
    (mkquote  !Amkquote)
    (cons  cons)
    (xcons  !Lxcons)
    (ncons  !Lncons)
    (numberp  !Anumberp)
    (pair  !Apair)
    (put  !Lput)
    (remprop  !Aremprop)
    (rplaca  !Arplaca)
    (rplacd  !Arplacd)
    (stop  !Astop)
    (time  !Atime)
    (union  !Aunion)
    (merge  !Amerge)
    (sort  !Asort)
    (unionq  !Aunionq)
    (intersection  !Aintersection)
    (intersectionq  !Aintersectionq)
    (setdiff  !Asetdiff)
    (setdiffq  !Asetdiffq)
    (unglobal  !Aunglobal)
    (unfluid  !Aunfluid)
    (flag  !Lflag)
    (flagp  !Lflagp)
    (flagpcar  !Aflagpcar)
    (flagp**  !Aflagp)
    (get*  !Aget)
    (idp  !Aidp)
    (pairp  !Apairp)
    (listp  !Alistp)
    (is_list  !Alistp)
    (remflag  !Aremflag)
    (set  !Aset)
    (stringp  !Astringp)
    (vectorp  !Avectorp)
    (append  !Lappend)
    (appende  !Lappende)
    (eq  !Aeq)
    (eqcar  !Aeqcar)
    (eql  !Aeql)
    (equal  !Lequal)
    (endp  !Aendp)
    (getd  !Agetd)
    (movd  !Amovd)
    (length  !Llength)
    (putd  !Lputd)
    (remd  !Aremd)
    (trace  !Atrace)
    (untrace  !Auntrace)
    (plist  !Aplist)
    (putv  !Lputv)
    (upbv  !Aupbv)
    (memq  !Amemq)
    (nconc  !Anconc)
    (aconc  !Aaconc)
    (map  Lmap)
    (mapc  Lmapc)
    (mapcar  Lmapcar)
    (maplist  Lmaplist)
    (mapcan  Lmapcan)
    (mapcon  Lmapcon)
    (mapv  Lmapv)
    (map2  Lmap2)
    (mapc2  Lmapc2)
    (mapcar2  Lmapcar2)
    (maplist2  Lmaplist2)
    (mapcan2  Lmapcan2)
    (mapcon2  Lmapcon2)
    (mapv2  Lmapv2)
    (neq  !Aneq)
    (not  !Lnull)
    (null  !Lnull)
    (reverse  !Areverse)
    (smemq  !Asmemq)
    (subla  !Asubla)
    (sublis  !Asublis)
    (delete  !Adelete)
    (deleq  !Adeleq)
    (rassoc  !Arassoc)
    (assoc  !Aassoc)
    (atsoc  !Aatsoc)
    (assq  !Aatsoc)
    (getv  !Agetv)
    (aref  !Aaref)
    (member  !Lmember)
    (mkvect  !Lmkvect)
    (mkarray  mkarray_fn)
    (mkarray1  !Lmkarray1)
    (mkarray2  !Lmkarray2)
    (mkarray3  !Lmkarray3)
    (mkiarray  !Lmkiarray1)
    (mkivect  !Lmkiarray1)
    (mkiarray2  !Lmkiarray2)
    (mkiarray3  !Lmkiarray3)
    (mkfvect  !Lmkfarray1)
    (mkfarray2  !Lmkfarray2)
    (mkfarray3  !Lmkfarray3)
    (mkdvect  !Lmkdarray1)
    (mkdarray2  !Lmkdarray2)
    (mkdarray3  !Lmkdarray3)
    (getarray  getarray_fn)
    (getarray1  !Lgetarray1)
    (getarray2  !Lgetarray2)
    (getarray3  !Lgetarray3 )
    (set_array  setarray_fn)
    (setarray1  !Lsetarray1)
    (setarray2  !Lsetarray2 )
    (setarray3  !Lsetarray3 )
    (list2array  !Alist2array)
    (array2list  !Aarray2list)
    (list2vector  !Alist2vector)
    (vector2list  !Avector2list)
    (setarray  !Llist2array)
    (setmatrix  !Lsetmatrix)
    (setvector  !Lsetvector)
    (reversip  Lnreverse)
    (subst  !Asubst)
    (quit  !Aquit)
    (bye  !Abye)
    (logxor  logxor_fn)
    (logand  logand_fn)
    (logor  logor_fn)
    (ilogxor  ilogxor_fn)
    (ilogand  ilogand_fn)
    (ilogor  ilogor_fn)
    (max  max_fn)
    (min  min_fn)
    (imax  imax_fn)
    (imin  imin_fn)
    (deflist  !Ldeflist)
    (expand  !Aexpand)
    (copy  !Acopy)
    (clone  !Aclone)
    (xn  !Axn)
    (last  !Alast)
    (num  !Anum)
    (den  !Aden)
    (printprompt  !Aprintprompt)
    (printaddr  !Aprintaddr)
    (traceall  !Atraceall)
    (nth  !Anth)
    (pnth  !Apnth)
    (nthcdr  !Anthcdr)
    (replace  !Areplace)
    (package_cnt  !Apackage_cnt)
    (hashp  !Ahashp)
    (packagep  !Apackagep)
    (lisp  !Amode_lisp)
    (asuka  !Amode_asuka)
  ), 'centryname);
deflist('(

    (with_timeout  with_timeout)
    (dump_array  !Adump_array)
    (clone  !Lclone)
    (frexp  !Lfrexp)
    (ceiling  !Lceiling)
    (floor  !Lfloor)
    (round  !Lround)
    (truncate  !Ltruncate)
    (gcdn  gcd)
    (gcd  !Mgcd)
    (lcm  !Mlcm)
    (denominator  !Ldenominator)
    (numerator  !Lnumerator)
    (ash  !Lash)
    (ash1  !Lash1)
    (divide  !Ldivide)
    (evenp  !Levenp)
    (logand2  logand2)
    (logeqv2  logeqv2)
    (lognot  lognot)
    (logxor2  logxor2)
    (logor2  logor2)
    (lsd  !Llsd)
    (srandom  !Lsrandom)
    (random  !Lrandom)
    (random_int1  !Lrandom_int1)
    (random_int2  !Lrandom_int2)
    (random_real1  !Lrandom_real1)
    (random_real2  !Lrandom_real2)
    (random_real3  !Lrandom_real3)
    (max2  !Lmax2)
    (min2  !Lmin2)
    (minus  gnegate)
    (minusp  !Lminusp)
    (mod  modulus)
    (msd  !Lmsd)
    (oddp  !Loddp)
    (onep  !Lonep)
    (plus2  plus2)
    (plusp  !Lplusp)
    (times2  times2)
    (zerop  !Lgzerop)
    (add1  !Ladd1)
    (difference  diff2)
    (eqn  !Leqn)
    (appeqn  !Lappeq)
    (geq  !Lgeq)
    (greaterp  !Lgreaterp)
    (leq  !Lleq)
    (lep  !Lleq)
    (gep  !Lgeq)
    (lessp  !Llessp)
    (cgeq  !Lcgeq)
    (cgreaterp  !Lcgreaterp)
    (cleq  !Lcleq)
    (clep  !Lcleq)
    (cgep  !Lcgeq)
    (clessp  !Lclessp)
    (ratio  ratio2)
    (quotient  quot2)
    (remainder  remaind2)
    (reciprocal  reciprocal2)
    (sub1  !Lsub1)
    (precision  !Lprecision)
    (number_log2  !Lnumber_log2)
    (fix  !Lfix)
    (logical  !Llogical)
    (rational  !Lrational)
    (float  !Afloat)
    (efloat  !Aefloat)
    (mkefloat  !Amkefloat)
    (mkefloat_by_ratio  !Amkefloat_by_ratio)
    (interval  !Linterval)
    (interval_by_ratio  !Ainterval)
    (complex  !Lcomplex)
    (mkcomplex  !Lmkcomplex)
    (ecomplex  !Lecomplex)
    (mkecomplex  !Lmkecomplex)
    (bfloat  !Abfloat)
    (befloat  !Abefloat)
    (mkbefloat  !Amkbefloat)
    (mkbefloat_by_ratio  !Amkbefloat_by_ratio)
    (binterval  !Lbinterval)
    (mkbinterval  !Lmkbinterval)
    (becomplex  !Lbecomplex)
    (mkbecomplex  !Lmkbecomplex)
    (modular  !Amodular)
    (mkmodular  !Amkmodular)
    (unmodular  !Aunmodular)
    (setmodulus  !Lset_modulus)
    (fmodular  !Afmodular)
    (set_fmodulus  !Lset_fmodulus)
    (interval_lower  !Linterval_lower)
    (interval_upper  !Linterval_upper)
    (interval_mid  !Linterval_mid)
    (interval_width  !Linterval_width)
    (mkinterval  !Lmkinterval)
    (efloat_error  !Aefloat_error)
    (efloat_value  !Aefloat_value)
    (ecomplex_error  !Lecomplex_error)
    (ecomplex_real  !Lecomplex_real)
    (ecomplex_imag  !Lecomplex_imag)
    (complex_real  !Lcomplex_real)
    (complex_imag  !Lcomplex_imag)

    (polynomial  !Lpolynomial)
    (tropical  !Ltropical)
    (dipoly  !Ldipoly)
    (setorder_lex  !Lsetorder_lex)
    (setorder_tlex  !Lsetorder_tlex)
    (setorder_revlex  !Lsetorder_revlex)
    (setorder_trevlex  !Lsetorder_trevlex)
    (setorder_gradings  !Lsetorder_gradings)
    (unknowns  !Aunknowns)
    (max_coeff  !Amax_coeff)
    (nterms  !Anterms)
    (!+  gplus2)
    (!-  gdiff2)
    (!*  gtimes2)
    (!/  gratio2)
    (!/!/  gremaind2)
    (!^  gexpt)
    (cross  gcross)
    (!=  !Lgeqn)
    (!=!:!=  !Lappeq)
    (!<  !Llessp)
    (!>  !Lgreaterp)
    (!>!=  !Lgeq)
    (!<!=  !Lleq)
    (bfloat_man  !Lbfloat_man)
    (bfloat_exp  !Lbfloat_exp)
    (leftshift  !Lleftshift)
    (gen_prime  !Lgen_prime)
    (next_prime  !Lnext_prime)
    (prime_before  !Lprime_before)

    (primep  !Lprimep)

    (DEBUG  !Adebug)
    (debug_on  !Adebug_on)
    (debug_off  !Adebug_off)
    (debug_level  !Adebug_level)
    (debug_depth  !Adebug_depth)
    (debug  !Adebug)
    (debugn  !Adebugn)
    (write  !Awrite)
    (writen  !Awriten)
    (clear  !Aclear)
    (load  !Aload)
    (echo  !Aecho)
    (import  !Aimport)
    (size  !Asize)
    (mcoeff  !Amcoeff)
    (coeff  !Acoeff)
    (coeffx  !Acoeffx)
    (coeffy  !Acoeffy)
    (coeffn  !Acoeffn)
    (support  !Asupport)
    (support_ap  !Asupport_ap)
    (new_symbol1  !Anew_symbol1)
    (new_symbol2  !Anew_symbol2)
    (print_precision  !Lprint_precision)
    (Precision  !Aprecision)

    (setorder  !Lsetorder)
    (getorder  !Lgetorder)
    (getdipolyorder  !Lgetdipolyorder)

    (printf  !Lvprintf)
    (printf0  !Lprintf0)
    (printf1  !Lprintf1)
    (printf2  !Lprintf2)

    (is_cons  !Ais_cons)
    (is_fixnum  !Ais_fixnum)
    (is_hdrs  !Ais_hdrs)
    (is_reloc  !Ais_reloc)
    (is_symbol  !Ais_symbol)
    (is_numhdr  !Ais_numhdr)
    (is_vechdr  !Ais_lisp_vector)
    (is_binhdr  !Ais_binhdr)
    (is_number  !Ais_number)
    (is_immed  !Ais_immed)
    (is_logical  !Ais_logical)
    (is_bigint  !Ais_bigint)
    (is_modular  !Ais_modular)
    (is_float  !Ais_float)
    (is_rational  !Ais_rational)
    (is_ratio  !Ais_ratio)
    (is_complex  !Ais_complex)
    (is_bfloat  !Ais_bfloat)
    (is_efloat  !Ais_efloat)
    (is_interval  !Ais_interval)
    (is_ecomplex  !Ais_ecomplex)
    (is_befloat  !Ais_befloat)
    (is_binterval  !Ais_binterval)
    (is_becomplex  !Ais_becomplex)
    (is_bmodular  !Ais_bmodular)
    (is_qmodular  !Ais_qmodular)
    (is_fmodular  !Ais_fmodular)
    (is_poly  !Ais_poly)
    (is_tropical  !Ais_tropical)
    (is_dipoly  !Ais_dipoly)
    (is_rpoly  !Ais_rpoly)
    (is_bigneg  !Ais_bigneg)
    (is_integer  !Ais_integer)
    (is_fix  !Ais_fix)
    (is_neg  !Ais_neg)
    (is_app  !Ais_app)
    (is_log  !Ais_log)
    (is_eff  !Ais_eff)
    (is_cmp  !Ais_cmp)
    (is_big  !Ais_big)
    (is_vector  !Ais_vector)
    (is_matrix  !Ais_matrix)
    (is_array  !Ais_array)
    (is_string  !Ais_string)
    (is_iarray  !Ais_iarray)
    (is_sarray  !Ais_sarray)
    (is_darray  !Ais_darray)
    (is_iarray2  !Ais_iarray2)
    (is_sarray2  !Ais_sarray2)
    (is_darray2  !Ais_darray2)
    (is_iarray3  !Ais_iarray3)
    (is_sarray3  !Ais_sarray3)
    (is_darray3  !Ais_darray3)
    (is_package  !Ais_package)
    (recipi!M  recipi!M)
    (spoly  !Aspoly)
    (reduce  !Areduce)
    (monic  !Amonic)
    (reduce_set  !Areduce_set)
    (full_reduce  !Afull_reduce)
    (dipoly_remainder  !Adipoly_remainder)
    (dipoly_quotient  !Adipoly_quotient)
    (dipoly_order  !Adipoly_order)
    (dipoly_pol  !Adipoly_pol)
    (is_dipoly_list  !Ais_dipoly_list)
    (lt_reducible  !Alt_reducible)
    (lt_divisible  !Alt_divisible)
    (have_nontrivial_gcd  !Ahave_nontrivial_gcd)
    (has_nontrivial_gcd  !Ahave_nontrivial_gcd)
    (lt_lcm_expvec  !Alt_lcm_expvec)
    (lt_lcm_ordervec  !Alt_lcm_ordervec)
    (sortPairset  !Asort_pairset)
    (mergePairset  !Amerge_pairset)
    (ws  !Aws)

    (expvec_lcm  !Aexpvec_lcm)
    (expvec_gcd  !Aexpvec_gcd)
    (expvec_div  !Aexpvec_div)

    (lt_gcd  !ALT_gcd)
    (lt_lcm  !ALT_lcm)

    (homogenize  !Ahomogenize)
    (ordervec  !Aordervec)
    (sugar_strategy  !Asugar_strategy)
    (is_sugar_strategy  !Ais_sugar_strategy)
    (append_lcm  append_lcm)

    (pause  !Apause)
    (dump  !Adump)

    (makeid  !Amake_id)
    (makeuid  !Amake_uid)
    (system  !Asystem)
    (list2bnum  !Alist2bnum)
    (bnum2list  !Abnum2list)
    (compare  !Acompare)
  ), 'centryname);
deflist('(
    (groebner  !Agroebner )
    (groebner_algorithm  !Agroebner_algorithm )
    (gb  !Agroebner )
    (gb42  !Agroebner42 )
    (gb44  !Agroebner44 )
    (mgb  !Aminimalgb )
    (rgb  !Areducedgb )
    (isgb  !Ais_groebner )
    (katsura  !Akatsura )
    (cyclic  !Acyclic )
    (F4  !F4 )
    (F5  !F5 )
    (fgb  !FGb_int )
    (fgb_p  !FGb_mod )

  ), 'centryname);
deflist('(
    (factor  Afactor )
    (zfactor  Azfactor )
    (berlekamp  berlekamp )
    (squarefree  SquareFree )
    (FormMatrix  FormMatrix )
    (factorlist2prefix  factorlist2prefix )
    (isqrt  isqrt )
    (iroot  iroot )

  ), 'centryname);
deflist('(
    (ezgcd_debug  Lezgcd_debug )
    (gcd_mgcd  my_gcd_mgcd )
    (gcd_ezgcd  my_gcd_ezgcd )
    (gcd_ezgcd1  my_gcd_ezgcd1 )
    (gcd_ezgcd2  my_gcd_ezgcd2 )
    (gcd_ezgcd3  my_gcd_ezgcd3 )
    (gcd_ezgcd4  my_gcd_ezgcd4 )
    (gcd_sprs  my_gcd_sprs )
    (gcd_pprs  my_gcd_pprs )
    (gcd_rprs  my_gcd_rprs )
    (gcd_euclid  my_gcd_euclid )
    (gcd_heuristic  my_gcd_heuristic )
    (gcd_huristic  my_gcd_heuristic )
    (gcd_combine  my_gcd_combine2 )
    (cont_mgcd  cont_mgcd )
    (remainder_by_int2  remainder_by_int2 )
    (quotient_by_int  quotient_by_int )
    (remainder_by_int  remainder_by_int )
    (wrem  wrem )
    (wquo  wquo )

  ), 'centryname);

deflist('(
    (trace  Atrace )
    (determinant  Ldeterminant )
    (transpose  Ltranspose )
    (ident  Lident )
    (diag  Ldiag )
    (inverseMatrix  inverseMatrix )
    (newvector  Anewvector )
    (newmatrix  Anewmatrix )

    (addMatrix  addMatrix )
    (subMatrix  subMatrix )
    (scaleMatrix  scaleMatrix )
    (scaleaddMatrix  scaleaddMatrix )

    (addVector  addVector )
    (subVector  subVector )
    (scaleVector  scaleVector )
    (scaleaddVector  scaleaddVector )

    (rowvector  Arowvector )
    (colvector  Acolvector )
    (setrow  Asetrow )
    (setcol  Asetcol )
    (swap_row  Aswap_row )
    (swap_col  Aswap_col )
    (scale_row  Ascale_row )
    (scale_col  Ascale_col )
    (muladd_row  Amuladd_row )
    (muladd_col  Amuladd_col )
    (scale_muladd_row  Ascale_muladd_row )
    (scale_muladd_col  Ascale_muladd_col )
    (ins_row  Ains_row )
    (ins_col  Ains_col )
    (merge_row  Amerge_row )
    (merge_col  Amerge_col )
    (del_row  Adel_row )
    (del_col  Adel_col )
    (submatrix  Asubmatrix )
    (cofactor  Acofactor )
    (rank  Arank )

  ), 'centryname);

deflist('(
	(mkmatrix Lmkmatrix)
	(mkvector Lmkvector)
	
  ), 'centryname);
end;
