#/*
# * umath.s      (C) Copyright 2011 by Fujio Kako, Nara Women's University.
# * 
# *      $Header: /Users/kako/asuka/src/RCS/umath.s,v 2.2 2012/10/22 02:11:52 kako Exp $
# */

#static char const rcsid[] =
#"$Id: umath.s,v 2.2 2012/10/22 02:11:52 kako Exp $";

#if defined(__i386__) || defined(__x86_64__)

#define USE_ASMCODE

#ifdef USE_ASMCODE

	.text
	.align	3, 0x90
	.globl	_umul

	.globl	_umuldiv
	.globl	_umulquo
	.globl	_umulrem

	.globl	_udiv
	.globl	_uquo
	.globl	_urem

	.globl	_umuladd


#ifdef _LP64
#	h = umul(*l, a, b);	; a * b -> h . l
#	    umul(rdi, rsi, rdx)
_umul:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rax
	mulq	%rsi
	movq	%rax, (%rdi)
	movq	%rdx, %rax
	leave
	ret
#	q = umuldiv(*r, a, b, m);	; a * b / m  -> q . r
#	    umuldiv(rdi, rsi, rdx, rcx)
_umuldiv:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rax
	mulq	%rsi
	divq	%rcx
	movq	%rdx, (%rdi)
	leave
	ret
#	q = umulquo(a, b, m);	; a * b / m  -> q . r
#	    umulquo(rdi, rsi, rdx)
_umulquo:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdi, %rax
	movq	%rdx, %rcx
	mulq	%rsi
	divq	%rcx
	leave
	ret
#	r = umulrem(a, b, m);	; a * b / m  -> q . r
#	    umulrem(rdi, rsi, rdx)
_umulrem:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rcx
	movq	%rdi, %rax
	mulq	%rsi
	divq	%rcx
	movq	%rdx, %rax
	leave
	ret
#       q = udiv(*r, h, l, d);  h . l / d -> q .. r
#                udiv(%rdi, %rsi, %rdx, %rcx)
_udiv:
        pushq   %rbp
        movq    %rsp, %rbp
        movq    %rdx, %rax
        movq    %rsi, %rdx
        divq    %rcx
        movq    %rdx, (%rdi)
        leave
        ret
#	q = uquo(*r, h, l, d);	h . l / d -> q .. r
#		 udiv(%rdi, %rsi, %rdx)
_uquo:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rcx
	movq	%rdi, %rdx
	movq	%rsi, %rax
	divq	%rcx
	leave
	ret
#	q = urem(h, l, d);	h . l / d -> q .. r
#		 urem(%rdi, %rsi, %rdx)
_urem:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rcx
	movq	%rdi, %rdx
	movq	%rsi, %rax
	divq	%rcx
        movq    %rdx, %rax
	leave
	ret
#	h = umuladd(*l, a, b, c);	; a * b + c -> h . l
#	    (rdi, rsi, rdx, rcx)
_umuladd:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rax
	mulq	%rsi
	xorq	%r8, %r8
	addq	%rcx, %rax
	adcq	%r8, %rdx	
	movq	%rax, (%rdi)
	movq	%rdx, %rax
	leave
	ret
#else
#	h = umul(*l, a, b);	; a * b -> h . l
#	    umul(rdi, rsi, rdx)
_umul:
	movl	4(%esp), %ecx
	movl	8(%esp), %eax
	mull	12(%esp)
	movl	%eax, (%ecx)
	movl	%edx, %eax
	ret
#	q = umuldiv(*r, a, b, m);	; a * b / m  -> q . r
#	    umuldiv(rdi, rsi, rdx, rcx)
_umuldiv:
	movl	4(%esp), %ecx
	movl	8(%esp), %eax
	mull	12(%esp)
	divl	16(%esp)
	movl	%edx, (%ecx)
	ret
#	q = umulquo(a, b, m);	; a * b / m  -> q . r
#	    umulquo(rdi, rsi, rdx)
_umulquo:
	movl	4(%esp), %eax
	mull	8(%esp)
	divl	12(%esp)
	ret
#	r = umulrem(a, b, m);	; a * b / m  -> q . r
#	    umulrem(rdi, rsi, rdx)
_umulrem:
	movl	4(%esp), %eax
	mull	8(%esp)
	divl	12(%esp)
	movl	%edx, %eax
	ret
#	q = udiv(*r, h, l, d);	h . l / d -> q .. r
#		 udiv(%rdi, %rsi, %rdx, %rcx)
_udiv:
	movl	12(%esp), %eax
	movl	8(%esp), %edx
	divl	16(%esp)
	movl	4(%esp), %ecx
	movl	%edx, (%ecx)
	ret
#	q = uquo(h, l, d);	h . l / d -> q .. r
#		 uquo(%rdi, %rsi, %rdx)
_uquo:
	movl	8(%esp), %eax
	movl	4(%esp), %edx
	divl	12(%esp)
	ret
#	r = urem(h, l, d);	h . l / d -> q .. r
#		 urem(%rdi, %rsi, %rdx)
_urem:
	movl	8(%esp), %eax
	movl	4(%esp), %edx
	divl	12(%esp)
	movl	%edx, %eax
	ret
#	h = umuladd(*l, a, b, c);	; a * b + c -> h . l
#	    (rdi, rsi, rdx, rcx)
_umuladd:
	push	%ebx
	movl	8(%esp), %ecx
	movl	12(%esp), %eax
	mull	16(%esp)
	xorl	%ebx, %ebx
	addl	20(%esp), %eax
	movl	%eax, (%ecx)
	adcl	%ebx, %edx
	movl	%edx, %eax
	pop	%ebx
	ret
#endif
#endif

#if defined(__ppc__) || defined(__ppc64__)
	.text
	.align	3, 0x90
	.globl	_umul

	.globl	_umuldiv
	.globl	_umulquo
	.globl	_umulrem

	.globl	_udiv
	.globl	_uquo
	.globl	_urem

	.globl	_umuladd

#ifdef _LP64
_umul:
	mulld	r0, r4, r5
	mulhdu	r9, r4, r5
	std	r0, 0(r3)
	mr	r3, r9
	blr
#else

_umul:
	mullw	r0, r4, r5
	mulhwu	r9, r4, r5
	stw	r0, 0(r3)
	mr	r3, r9
	blr

#endif

#endif

#endif
