#/*
# * umath.s      (C) Copyright 2011 by Fujio Kako, Nara Women's University.
# * 
# *      $Header: /Users/kako/asuka/src/RCS/umath_linux64.s,v 2.2 2012/10/22 02:11:52 kako Exp $
# */

#static char const rcsid[] =
#"$Id: umath_linux64.s,v 2.2 2012/10/22 02:11:52 kako Exp $";

	.text
	.align	8, 0x90
	.globl	umul

	.globl	umuldiv
	.globl	umulquo
	.globl	umulrem

	.globl	udiv
	.globl	uquo
	.globl	urem

	.globl	umuladd


#	h = umul(*l, a, b);	; a * b -> h . l
#	    umul(rdi, rsi, rdx)
umul:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rax
	mulq	%rsi
	movq	%rax, (%rdi)
	movq	%rdx, %rax
	leave
	ret
#	q = umuldiv(*r, a, b, m);	; a * b / m  -> q . r
#	    umuldiv(rdi, rsi, rdx, rcx)
umuldiv:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rax
	mulq	%rsi
	divq	%rcx
	movq	%rdx, (%rdi)
	leave
	ret
#	q = umulquo(a, b, m);	; a * b / m  -> q . r
#	    umulquo(rdi, rsi, rdx)
umulquo:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdi, %rax
	movq	%rdx, %rcx
	mulq	%rsi
	divq	%rcx
	leave
	ret
#	r = umulrem(a, b, m);	; a * b / m  -> q . r
#	    umulrem(rdi, rsi, rdx)
umulrem:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rcx
	movq	%rdi, %rax
	mulq	%rsi
	divq	%rcx
	movq	%rdx, %rax
	leave
	ret
#       q = udiv(*r, h, l, d);  h . l / d -> q .. r
#                udiv(%rdi, %rsi, %rdx, %rcx)
udiv:
        pushq   %rbp
        movq    %rsp, %rbp
        movq    %rdx, %rax
        movq    %rsi, %rdx
        divq    %rcx
        movq    %rdx, (%rdi)
        leave
        ret
#	q = uquo(*r, h, l, d);	h . l / d -> q .. r
#		 udiv(%rdi, %rsi, %rdx)
uquo:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rcx
	movq	%rdi, %rdx
	movq	%rsi, %rax
	divq	%rcx
	leave
	ret
#	q = urem(h, l, d);	h . l / d -> q .. r
#		 urem(%rdi, %rsi, %rdx)
urem:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rcx
	movq	%rdi, %rdx
	movq	%rsi, %rax
	divq	%rcx
        movq    %rdx, %rax
	leave
	ret
#	h = umuladd(*l, a, b, c);	; a * b + c -> h . l
#	    (rdi, rsi, rdx, rcx)
umuladd:
	pushq	%rbp
	movq	%rsp, %rbp
	movq	%rdx, %rax
	mulq	%rsi
	xorq	%r8, %r8
	addq	%rcx, %rax
	adcq	%r8, %rdx	
	movq	%rax, (%rdi)
	movq	%rdx, %rax
	leave
	ret
