void done(int k);

extern void onintr(int signo);
extern void set_signals(void);
extern void usage(void);
extern void getargs(int argc, char *argv[]);
extern char * allocate(unsigned n);
extern void create_file_names(void);
extern void open_files(void);



extern void set_EFF(void);
extern void set_first_derives(void);
extern void closure(short *nucleus, int n);
extern void finalize_closure(void);

#ifdef  DEBUG
extern void print_closure(int n);
extern void print_EFF(void);
extern void print_first_derives(void)
#endif

extern void fatal(char *msg);
extern void no_space(void);
extern void open_error(char *filename);
extern void unexpected_EOF(void);
extern void print_pos(char *st_line, char *st_cptr);
extern void syntax_error(int st_lineno, char *st_line, char *st_cptr);
extern void unterminated_comment(int c_lineno, char *c_line, char *c_cptr);
extern void unterminated_string(int s_lineno, char *s_line, char *s_cptr);
extern void unterminated_text(int t_lineno, char *t_line, char *t_cptr);
extern void unterminated_union(int u_lineno, char *u_line, char *u_cptr);
extern void over_unionized(char *u_cptr);
extern void illegal_tag(int t_lineno, char *t_line, char *t_cptr);
extern void illegal_character(char *c_cptr);
extern void used_reserved(char *s);
extern void tokenized_start(char *s);
extern void retyped_warning(char *s);
extern void reprec_warning(char *s);
extern void revalued_warning(char *s);
extern void terminal_start(char *s);
extern void restarted_warning(void);
extern void no_grammar(void);
extern void terminal_lhs(int s_lineno);
extern void prec_redeclared(void);
extern void unterminated_action(int a_lineno, char *a_line, char *a_cptr);
extern void dollar_warning(int a_lineno, int i);
extern void dollar_error(int a_lineno, char *a_line, char *a_cptr);
extern void untyped_lhs(void);
extern void untyped_rhs(int i, char *s);
extern void unknown_rhs(int i);
extern void default_action_warning(void);
extern void undefined_goal(char *s);
extern void undefined_symbol_warning(char *s);



extern void lalr(void) ;
extern void set_state_table(void);
extern void set_accessing_symbol(void);
extern void set_shift_table(void);
extern void set_reduction_table(void);
extern void set_maxrhs(void);
extern void initialize_LA(void);
extern void set_goto_map(void);
extern int map_goto(int state, int symbol);
extern void initialize_F(void);
extern void build_relations(void);
extern void add_lookback_edge(int stateno, int ruleno, int gotono);
extern short ** transpose(short **R, int n);
extern void compute_FOLLOWS(void);
extern void compute_lookaheads(void);
extern void digraph(short **relation) ;
extern void traverse(int i);



extern void allocate_itemsets(void);
extern void allocate_storage(void);
extern void append_states(void);
extern void free_storage(void);
extern void generate_states(void);
extern int get_state(int symbol);
extern void initialize_states(void);
extern void new_itemsets(void);
extern core * new_state(int symbol);
extern void show_cores(void);
extern void show_ritems(void);
extern void show_rrhs(void);
extern void show_shifts(void);
extern void save_shifts(void);
extern void save_reductions(void);
extern void set_derives(void);
extern void free_derives(void);
#ifdef  DEBUG
extern void print_derives(void);
#endif
extern void set_nullable(void);
extern void free_nullable(void);
extern void lr0(void);



extern void make_parser(void);
extern action * parse_actions(int stateno);
extern action * get_shifts(int stateno);
extern action * add_reductions(int stateno, action *actions);
extern action * add_reduce(action *actions, int ruleno, int symbol);
extern void find_final_state(void);
extern void unused_rules(void);
extern void remove_conflicts(void);
extern void total_conflicts(void);
extern int sole_reduction(int stateno);
extern void defreds(void);
extern void free_action_row(action *p);
extern void free_parser(void);


extern void output(void);
extern void output_prefix(void);
extern void output_rule_data(void);
extern void output_yydefred(void);
extern void output_actions(void);
extern void token_actions(void);
extern void goto_actions(void);
extern int default_goto(int symbol);
extern void save_column(int symbol, int default_state);
extern void sort_actions(void);
extern void pack_table(void);
extern int matching_vector(int vector);
extern int pack_vector(int vector);
extern void output_base(void);
extern void output_table(void);
extern void output_check(void);
extern int is_C_identifier(char *name);
extern void output_defines(void);
extern void output_stored_text(void);
extern void output_debug(void);
extern void output_stype(void);
extern void output_trailing_text(void);
extern void output_semantic_actions(void);
extern void free_itemsets(void);
extern void free_shifts(void);
extern void free_reductions(void);


extern void cachec(int c);
extern void get_line(void);
extern char * dup_line(void);
extern void skip_comment(void);
extern int nextc(void);
extern int keyword(void);
extern void copy_ident(void);
extern void copy_text(void);
extern void copy_union(void);
extern int hexval(int c);
extern bucket * get_literal(void);
extern int is_reserved(char *name);
extern bucket * get_name(void);
extern int get_number(void);
extern char * get_tag(void);
extern void declare_tokens(int assoc);
extern void declare_types(void);
extern void declare_start(void);
extern void read_declarations(void);
extern void initialize_grammar(void);
extern void expand_items(void);
extern void expand_rules(void);
extern void advance_to_start(void);
extern void start_rule(bucket *bp, int s_lineno);
extern void end_rule(void);
extern void insert_empty_rule(void);
extern void add_symbol(void);
extern void copy_action(void);
extern int mark_symbol(void);
extern void read_grammar(void);
extern void free_tags(void);
extern void pack_names(void);
extern void check_symbols(void);
extern void pack_symbols(void);
extern void pack_grammar(void);
extern void print_grammar(void);
extern void reader(void);



extern void write_section(char *section[]);


extern int hash(char *name);
extern bucket * make_bucket(char *name);
extern bucket * lookup(char *name);
extern void create_symbol_table(void);
extern void free_symbol_table(void);
extern void free_symbols(void);


extern void verbose(void);
extern void log_unused(void);
extern void log_conflicts(void);
extern void print_state(int state);
extern void print_conflicts(int state);
extern void print_core(int state);
extern void print_nulls(int state);
extern void print_actions(int stateno);
extern void print_shifts(action *p);
extern void print_reductions(action *p, int defred);
extern void print_gotos(int stateno);



extern void transitive_closure(unsigned *R, int n);

extern void reflexive_transitive_closure(unsigned *R, int n);

