#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_bsatom.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex bsatom_literal_vector[];
const char *bsatom_literal_string[];
setup_type const  bsatom_g_setup[];
#define LITERAL bsatom_literal_vector




Sex CC_recovTgconst(void)
{
    Sex a;
#define LL_HHmod LITERAL[0]
    a = value(LL_HHmod);
#define LL_Hmod LITERAL[1]
    value(LL_Hmod) = a;
#define LL_HHflo LITERAL[2]
    a = value(LL_HHflo);
#define LL_Hfloat LITERAL[3]
    value(LL_Hfloat) = a;
    return a;
}

Sex CC_killargchk(void)
{
    Sex a, q;
#define LL_Hnoargchk LITERAL[4]
    q = value(LL_Hnoargchk);
    a = LL_Hnoargchk;
    a = cons(a, q);
#define LL_Qgstack LITERAL[5]
    q = value(LL_Qgstack);
    a = cons(a, q);
    value(LL_Qgstack) = a;
    a = true;
    value(LL_Hnoargchk) = a;
    return a;
}

Sex CC_recovargchk(void)
{
    Sex a, q;
    a = LL_Hnoargchk;
    if(a != car(car(value(LL_Qgstack)))) goto    G0007;
    a = cdr(car(value(LL_Qgstack)));
    value(LL_Hnoargchk) = a;
    a = cdr(value(LL_Qgstack));
    value(LL_Qgstack) = a;
    a = value(LL_Hnoargchk);
    goto    G0008;
   G0007:
    q = nil;
    a = LITERAL[6];
    a = CC_errormsg(a, q);
   G0008:
    return a;
}

Sex CC_killtrace(void)
{
    Sex a, q;
#define LL_Htracmode LITERAL[7]
    q = value(LL_Htracmode);
    a = LL_Htracmode;
    a = cons(a, q);
    q = value(LL_Qgstack);
    a = cons(a, q);
    value(LL_Qgstack) = a;
#define LL_untrac LITERAL[8]
    a = LL_untrac;
    value(LL_Htracmode) = a;
    return a;
}

Sex CC_recovtrace(void)
{
    Sex a, q;
    a = LL_Htracmode;
    if(a != car(car(value(LL_Qgstack)))) goto    G0015;
    a = cdr(car(value(LL_Qgstack)));
    value(LL_Htracmode) = a;
    a = cdr(value(LL_Qgstack));
    value(LL_Qgstack) = a;
    a = value(LL_Htracmode);
    goto    G0016;
   G0015:
    q = nil;
    a = LITERAL[9];
    a = CC_errormsg(a, q);
   G0016:
    return a;
}

Sex CC_savemod(void)
{
    Sex a, q;
    q = value(LL_Hmod);
    a = LL_Hmod;
    a = cons(a, q);
    q = value(LL_Qgstack);
    a = cons(a, q);
    value(LL_Qgstack) = a;
    a = LL_Hmod;
    return a;
}

Sex CC_recovmod(void)
{
    Sex a, q;
    a = LL_Hmod;
    if(a != car(car(value(LL_Qgstack)))) goto    G0023;
    a = cdr(car(value(LL_Qgstack)));
    value(LL_Hmod) = a;
    value(LL_HHmod) = a;
    a = cdr(value(LL_Qgstack));
    value(LL_Qgstack) = a;
    a = value(LL_Hmod);
    goto    G0024;
   G0023:
    q = nil;
    a = LITERAL[10];
    a = CC_errormsg(a, q);
   G0024:
    return a;
}

Sex CC_saveprec(void)
{
    Sex a, q;
    q = value(LL_Hfloat);
    a = LL_Hfloat;
    a = cons(a, q);
    q = value(LL_Qgstack);
    a = cons(a, q);
    value(LL_Qgstack) = a;
    a = LL_Hfloat;
    return a;
}

Sex CC_recovprec(void)
{
    Sex a, q;
    a = LL_Hfloat;
    if(a != car(car(value(LL_Qgstack)))) goto    G0031;
    a = cdr(car(value(LL_Qgstack)));
    value(LL_Hfloat) = a;
    value(LL_HHflo) = a;
    a = cdr(value(LL_Qgstack));
    value(LL_Qgstack) = a;
    a = value(LL_Hfloat);
    goto    G0032;
   G0031:
    q = nil;
    a = LITERAL[11];
    a = CC_errormsg(a, q);
   G0032:
    return a;
}

Sex CC_setcomp(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Hcompmode LITERAL[12]
    q = value(LL_Hcompmode);
    a = LL_Hcompmode;
    a = cons(a, q);
    q = value(LL_Qgstack);
    a = cons(a, q);
    value(LL_Qgstack) = a;
    a = w1;
    value(LL_Hcompmode) = a;
    popv(1);
    return a;
}

Sex CC_unsetcomp(void)
{
    Sex a, q;
    a = LL_Hcompmode;
    if(a != car(car(value(LL_Qgstack)))) goto    G0039;
    a = cdr(car(value(LL_Qgstack)));
    value(LL_Hcompmode) = a;
    a = cdr(value(LL_Qgstack));
    value(LL_Qgstack) = a;
    a = value(LL_Hcompmode);
    goto    G0040;
   G0039:
    q = nil;
    a = LITERAL[13];
    a = CC_errormsg(a, q);
   G0040:
    return a;
}

Sex CC_CC(Sex a, Sex q)
{
    {
        return  Lmkcomplex(a, q);
    }
}

Sex CC_CE(Sex a, Sex q)
{
    {
        return  Lmkefloat(a, q);
    }
}

Sex CC_CBE(Sex a, Sex q)
{
    {
        return  Lmkbefloat(a, q);
    }
}

Sex CC_CEC(Sex a, Sex q, Sex m)
{
    {
        return  Lmkecomplex(a, q, m);
    }
}

Sex CC_CI(Sex a, Sex q)
{
    {
        return  Lmkinterval(a, q);
    }
}

Sex CC_realpart(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = CC_Wcompl(a);
    if(a != nil) goto    G0054;
    a = w1;
    goto    G0056;
   G0054:
    a = w1;
    if(!is_complex(a)) goto    G0055;
    {
        popv(1);
        return  Lcomplex_real(a);
    }
   G0055:
    a = Lecomplex_real(a);
   G0056:
    popv(1);
    return a;
}

Sex CC_imagpart(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = CC_Wcompl(a);
    if(a != nil) goto    G0060;
    a = mkfxat(0);
    goto    G0062;
   G0060:
    a = w1;
    if(!is_complex(a)) goto    G0061;
    {
        popv(1);
        return  Lcomplex_imag(a);
    }
   G0061:
    a = Lecomplex_imag(a);
   G0062:
    popv(1);
    return a;
}

Sex CC_simpcompl(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Wint(a);
    if(a != nil) goto    G0084;
    a = w1;
    a = CC_Wratn(a);
    if(a != nil) goto    G0084;
    a = w1;
    a = CC_Wfloat(a);
    if(a != nil) goto    G0084;
    a = w1;
    if(is_efloat(a)) goto    G0076;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    if(!is_complex(a)) goto    G0069;
    a = CC_realpart(a);
    w2 = a;
    a = Labs(a);
    w3 = a;
    a = w1;
    a = CC_imagpart(a);
    a = Labs(a);
    w4 = a;
    q = w3;
#define LL_Hmeps100 LITERAL[14]
    a = value(LL_Hmeps100);
    a = times2(a, q);
    q = a;
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0084;
    a = w2;
    w1 = a;
    goto    G0084;
   G0069:
    w5 = nil;
    a = CC_realpart(a);
    w2 = a;
    a = Labs(a);
    w3 = a;
    a = w1;
    a = CC_imagpart(a);
    a = Labs(a);
    w4 = a;
    a = w1;
    a = Lecomplex_error(a);
    w5 = a;
    q = a;
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0081;
    q = w5;
    a = w3;
    a = Llessp(a, q);
    if(a == nil) goto    G0081;
    a = mkfxat(0);
    w1 = a;
   G0081:
    q = w3;
    a = value(LL_Hmeps100);
    a = times2(a, q);
    q = a;
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0084;
    q = w5;
    a = w2;
    a = Lmkefloat(a, q);
    w1 = a;
   G0084:
    a = w1;
   G0076:
    popv(5);
    return a;
}

Sex CC_Aarg(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_number(a)) goto    G0091;
    a = LITERAL[15];
    {
        popv(2);
        return  CC_argerror(a);
    }
   G0091:
    a = CC_Wcompl(a);
    if(a != nil) goto    G0092;
    a = LITERAL[16];
    goto    G0100;
   G0092:
    a = w1;
    a = CC_realpart(a);
    a = Lzerop(a);
    if(a == nil) goto    G0093;
    a = w1;
    a = CC_imagpart(a);
    a = Lplusp(a);
    if(a == nil) goto    G0096;
    q = mkfxat(4);
#define LL_CpiC LITERAL[17]
    a = value(LL_CpiC);
    {
        popv(2);
        return  quot2(a, q);
    }
   G0096:
    q = mkfxat(4);
    a = value(LL_CpiC);
    a = quot2(a, q);
    {
        popv(2);
        return  Lminus(a);
    }
   G0093:
    a = w1;
    a = CC_imagpart(a);
    w2 = a;
    a = w1;
    a = CC_realpart(a);
    q = a;
    a = w2;
    a = Latan2(a, q);
   G0100:
    popv(2);
    return a;
}

Sex CC_abs2(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Wcompl(a);
    if(a != nil) goto    G0106;
    q = w1;
    a = q;
    {
        popv(4);
        return  times2(a, q);
    }
   G0106:
    w2 = nil;
    w3 = nil;
    a = w1;
    a = CC_realpart(a);
    w2 = a;
    a = w1;
    a = CC_imagpart(a);
    w3 = a;
    q = w2;
    a = q;
    a = times2(a, q);
    w4 = a;
    q = w3;
    a = q;
    a = times2(a, q);
    q = a;
    a = w4;
    {
        popv(4);
        return  plus2(a, q);
    }
}

Sex CC_Watom(Sex a)
{
    {
        return  Latom(a);
    }
}

Sex CC_Wbfloat(Sex a)
{
    {
        return  Lbfloatp(a);
    }
}

Sex CC_Wbnum(Sex a)
{
    {
        return  Lnumberp(a);
    }
}

Sex CC_Wcompl(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lcomplexp(a);
    if(a != nil) goto    G0120;
    a = w1;
    a = Lecomplexp(a);
   G0120:
    popv(1);
    return a;
}

Sex CC_Wcomplx(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lcomplexp(a);
    if(a != nil) goto    G0123;
    a = w1;
    a = Lecomplexp(a);
   G0123:
    popv(1);
    return a;
}

Sex CC_Wefloat(Sex a)
{
    {
        return  Lefloatp(a);
    }
}

Sex CC_Weqn(Sex a, Sex q)
{
    {
        return  Leqn(a, q);
    }
}

Sex CC_Weven(Sex a)
{
    {
        return  Levenp(a);
    }
}

Sex CC_Wfloat(Sex a)
{
    {
        return  Lfloatp(a);
    }
}

Sex CC_Wid(Sex a)
{
    {
        return  Lidp(a);
    }
}

Sex CC_Wint(Sex a)
{
    {
        return  Lfixp(a);
    }
}

Sex CC_Wlist(Sex a)
{
    {
        return  Lpairp(a);
    }
}

Sex CC_Wminus(Sex a)
{
    {
        return  Lminusp(a);
    }
}

Sex CC_Wnull(Sex a)
{
    {
        return  Lnull(a);
    }
}

Sex CC_Wodd(Sex a)
{
    {
        return  Loddp(a);
    }
}

Sex CC_Wone(Sex a)
{
    {
        return  Lonep(a);
    }
}

Sex CC_Wplus(Sex a)
{
    {
        return  Lplusp(a);
    }
}

Sex CC_Wratn(Sex a)
{
    {
        return  Lrationalp(a);
    }
}

Sex CC_Wstring(Sex a)
{
    {
        return  Lstringp(a);
    }
}

Sex CC_Wtag(Sex a)
{
    {
        return  Lfixp(a);
    }
}

Sex CC_Wzero(Sex a)
{
    {
        return  Lzerop(a);
    }
}

Sex CC_Wgtgt(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = q;
    w1 = m;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0158;
    q = w1;
    a = w2;
    a = Lgreaterp(a, q);
   G0158:
    popv(2);
    return a;
}

Sex CC_Wgege(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = q;
    w1 = m;
    q = a;
    a = w2;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0161;
    q = w2;
    a = w1;
    a = Lgreaterp(a, q);
   G0161:
    {
        popv(2);
        return  Lnull(a);
    }
}

Sex CC_Wltlt(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = q;
    w1 = m;
    a = Llessp(a, q);
    if(a == nil) goto    G0165;
    q = w1;
    a = w2;
    a = Llessp(a, q);
   G0165:
    popv(2);
    return a;
}

Sex CC_Wlele(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = q;
    w1 = m;
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G0168;
    q = w2;
    a = w1;
    a = Llessp(a, q);
   G0168:
    {
        popv(2);
        return  Lnull(a);
    }
}

Sex CC_complgeqp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lequal(a, q);
    if(a != nil) goto    G0189;
    a = w1;
    if(is_complex(a)) goto    G0174;
    a = w2;
    if(is_complex(a)) goto    G0174;
    a = w1;
    a = Labs(a);
    w3 = a;
    a = w2;
    a = Labs(a);
    q = a;
    goto    G0190;
   G0174:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = w1;
    a = CC_realpart(a);
    w3 = a;
    a = w2;
    a = CC_realpart(a);
    w4 = a;
    a = w1;
    a = CC_imagpart(a);
    w5 = a;
    a = w2;
    a = CC_imagpart(a);
    w6 = a;
    q = w3;
    a = q;
    a = times2(a, q);
    w9 = a;
    q = w5;
    a = q;
    a = times2(a, q);
    q = a;
    a = w9;
    a = plus2(a, q);
    w7 = a;
    q = w4;
    a = q;
    a = times2(a, q);
    w9 = a;
    q = w6;
    a = q;
    a = times2(a, q);
    q = a;
    a = w9;
    a = plus2(a, q);
    w8 = a;
    q = a;
    a = w7;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0185;
   G0189:
    a = true;
    goto    G0178;
   G0185:
    q = w8;
    a = w7;
    a = Llessp(a, q);
    if(a == nil) goto    G0186;
    a = nil;
    goto    G0178;
   G0186:
    q = w4;
   G0190:
    a = w3;
    a = Lgeq(a, q);
   G0178:
    popv(9);
    return a;
}

Sex CC_rpartgeqp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    a = CC_realpart(a);
    w1 = a;
    a = w2;
    a = CC_realpart(a);
    q = a;
    a = w1;
    {
        popv(2);
        return  Lgeq(a, q);
    }
}

Sex CC_ipartgeqp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    a = CC_imagpart(a);
    w1 = a;
    a = w2;
    a = CC_imagpart(a);
    q = a;
    a = w1;
    {
        popv(2);
        return  Lgeq(a, q);
    }
}

Sex CC_Wexactnum(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_integer(a)) goto    G0203;
    if(!is_rational(a)) goto    G0202;
   G0203:
    a = true;
    goto    G0205;
   G0202:
    if(is_complex(a)) goto    G0204;
    a = nil;
    goto    G0205;
   G0204:
    a = Lcomplex_real(a);
    a = CC_Wexactnum(a);
    if(a == nil) goto    G0205;
    a = w1;
    a = Lcomplex_imag(a);
    a = CC_Wexactnum(a);
   G0205:
    popv(1);
    return a;
}

Sex CC_Wapproxnum(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_integer(a)) goto    G0213;
    if(!is_rational(a)) goto    G0212;
   G0213:
    a = nil;
    goto    G0215;
   G0212:
    if(is_complex(a)) goto    G0214;
    a = true;
    goto    G0215;
   G0214:
    a = Lcomplex_real(a);
    a = CC_Wapproxnum(a);
    if(a != nil) goto    G0215;
    a = w1;
    a = Lcomplex_imag(a);
    a = CC_Wapproxnum(a);
   G0215:
    popv(1);
    return a;
}

Sex CC_Wcdr(Sex a, Sex q)
{
    if(a != q) goto    G0222;
    a = true;
    goto    G0224;
   G0222:
    if(a == nil) goto    G0224;
    a = cdr(a);
    a = CC_Wcdr(a, q);
   G0224:
    return a;
}

Sex CC_Wchklist(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    if(a != nil) goto    G0228;
    a = true;
    goto    G0230;
   G0228:
    w2 = q;
    q = car(a);
    a = w1;
    a = Lfuncall1(a, q);
    if(a == nil) goto    G0230;
    q = cdr(w2);
    a = w1;
    a = CC_Wchklist(a, q);
   G0230:
    popv(2);
    return a;
}

Sex CC_Wchklist2(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = m;
    if(a != nil) goto    G0234;
    a = true;
    goto    G0236;
   G0234:
    w2 = q;
    w3 = m;
    m = car(a);
    a = w1;
    a = Lfuncall2(a, q, m);
    if(a == nil) goto    G0236;
    m = cdr(w3);
    q = w2;
    a = w1;
    a = CC_Wchklist2(a, q, m);
   G0236:
    popv(3);
    return a;
}

Sex CC_Widlist(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
   G0243:
    if(a != nil) goto    G0240;
    a = true;
    goto    G0242;
   G0240:
    w1 = a;
    a = car(a);
    if(!is_symbol(a)) goto    G0241;
    a = cdr(w1);
    goto    G0243;  /* recursive call to ?idlist */
   G0241:
    a = nil;
   G0242:
    popv(1);
    return a;
}

Sex CC_Wintlist(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
   G0249:
    if(a != nil) goto    G0246;
    a = true;
    goto    G0248;
   G0246:
    w1 = a;
    a = car(a);
    if(!is_integer(a)) goto    G0247;
    a = cdr(w1);
    goto    G0249;  /* recursive call to ?intlist */
   G0247:
    a = nil;
   G0248:
    popv(1);
    return a;
}

Sex CC_Wnumlist(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
   G0255:
    if(a != nil) goto    G0252;
    a = true;
    goto    G0254;
   G0252:
    w1 = a;
    a = car(a);
    if(!is_number(a)) goto    G0253;
    a = cdr(w1);
    goto    G0255;  /* recursive call to ?numlist */
   G0253:
    a = nil;
   G0254:
    popv(1);
    return a;
}

Sex CC_Wzerolist(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a != nil) goto    G0258;
    a = true;
    goto    G0260;
   G0258:
    w1 = a;
    a = car(a);
    a = Lzerop(a);
    if(a == nil) goto    G0260;
    a = cdr(w1);
    a = CC_Wzerolist(a);
   G0260:
    popv(1);
    return a;
}

Sex CC_Wsubset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a != nil) goto    G0264;
    a = true;
    goto    G0266;
   G0264:
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lmember(a, q);
    if(a == nil) goto    G0266;
    q = w2;
    a = cdr(w1);
    a = CC_Wsubset(a, q);
   G0266:
    popv(2);
    return a;
}

Sex CC_Wsubsetq(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a != nil) goto    G0270;
    a = true;
    goto    G0272;
   G0270:
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0272;
    q = w2;
    a = cdr(w1);
    a = CC_Wsubsetq(a, q);
   G0272:
    popv(2);
    return a;
}

Sex CC_Rlis(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
   G0285:
    w1 = a;
    w2 = q;
    if(a == nil) goto    G0277;
    a = q;
    if(a != nil) goto    G0276;
   G0277:
    a = q;
    goto    G0284;
   G0276:
    q = car(a);
    a = car(w1);
    a = Leqn(a, q);
    if(a == nil) goto    G0281;
    q = cdr(w2);
    a = cdr(w1);
    goto    G0285;  /* recursive call to <lis */
   G0281:
    q = car(w2);
    a = car(w1);
    a = Llessp(a, q);
   G0284:
    if(a == nil) goto    G0283;
    a = true;
   G0283:
    popv(2);
    return a;
}

Sex CC_Slis(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
   G0297:
    w1 = a;
    w2 = q;
    if(a == nil) goto    G0289;
    a = q;
    if(a != nil) goto    G0288;
   G0289:
    a = w1;
    goto    G0296;
   G0288:
    q = car(a);
    a = car(w1);
    a = Leqn(a, q);
    if(a == nil) goto    G0293;
    q = cdr(w2);
    a = cdr(w1);
    goto    G0297;  /* recursive call to >lis */
   G0293:
    q = car(w2);
    a = car(w1);
    a = Lgreaterp(a, q);
   G0296:
    if(a == nil) goto    G0295;
    a = true;
   G0295:
    popv(2);
    return a;
}

Sex CC_SMlis(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
   G0304:
    if(a != nil) goto    G0300;
    a = CHAR_OF(61);
    goto    G0303;
   G0300:
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Leqn(a, q);
    if(a == nil) goto    G0301;
    q = cdr(w2);
    a = cdr(w1);
    goto    G0304;  /* recursive call to >=lis */
   G0301:
    q = car(w2);
    a = car(w1);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0303;
    a = true;
   G0303:
    popv(2);
    return a;
}

Sex CC_maxabs(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0309;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G0308;
    a = car(w1);
    goto    G0309;
   G0308:
    w2 = nil;
    w3 = nil;
    a = car(w1);
    w2 = a;
    a = CC_abs2(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G0311:
    a = car(w1);
    a = CC_abs2(a);
    q = a;
    a = w3;
    a = Lgeq(a, q);
    if(a != nil) goto    G0316;
    a = car(w1);
    w2 = a;
    a = CC_abs2(a);
    w3 = a;
   G0316:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0311;
    a = w2;
   G0309:
    popv(3);
    return a;
}

Sex CC_minabs(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0325;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G0324;
    a = car(w1);
    goto    G0325;
   G0324:
    w2 = nil;
    w3 = nil;
    a = car(w1);
    w2 = a;
    a = CC_abs2(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G0327:
    a = car(w1);
    a = CC_abs2(a);
    q = a;
    a = w3;
    a = Lleq(a, q);
    if(a != nil) goto    G0332;
    a = car(w1);
    w2 = a;
    a = CC_abs2(a);
    w3 = a;
   G0332:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0327;
    a = w2;
   G0325:
    popv(3);
    return a;
}

Sex CC_prodelms(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a != nil) goto    G0339;
    a = mkfxat(1);
    goto    G0340;
   G0339:
    w1 = a;
    a = cdr(a);
    a = CC_prodelms(a);
    q = a;
    a = car(w1);
    a = times2(a, q);
   G0340:
    popv(1);
    return a;
}

Sex CC_sumelms(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a != nil) goto    G0345;
    a = mkfxat(0);
    goto    G0346;
   G0345:
    w1 = a;
    a = cdr(a);
    a = CC_sumelms(a);
    q = a;
    a = car(w1);
    a = plus2(a, q);
   G0346:
    popv(1);
    return a;
}

Sex CC_listcar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a == nil) goto    G0352;
    w1 = a;
    a = cdr(a);
    a = CC_listcar(a);
    q = car(car(w1));
    a = Lxcons(a, q);
   G0352:
    popv(1);
    return a;
}

Sex CC_revlistcar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
   G0357:
    if(a == nil) goto    G0359;
    q = w2;
    a = car(car(a));
    a = cons(a, q);
    w2 = a;
    a = cdr(w1);
    w1 = a;
    goto    G0357;
   G0359:
    a = w2;
    popv(2);
    return a;
}

Sex CC_listcdr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a == nil) goto    G0365;
    w1 = a;
    a = cdr(a);
    a = CC_listcdr(a);
    q = cdr(car(w1));
    a = Lxcons(a, q);
   G0365:
    popv(1);
    return a;
}

Sex CC_seTlistcdr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a == nil) goto    G0371;
    w1 = a;
    q = cdr(car(a));
    car(a) = q;
    a = cdr(w1);
    a = CC_seTlistcdr(a);
   G0371:
    popv(1);
    return a;
}

Sex CC_flattenlis(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    w2 = a;
   G0377:
    a = car(w1);
    w4 = a;
    w5 = nil;
   G0380:
    if(a == nil) goto    G0379;
    a = car(a);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    w5 = a;
    goto    G0380;
   G0379:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0377;
    a = cdr(w2);
    popv(5);
    return a;
}

Sex CC_listpair(Sex a, Sex q)
{
    {
        return  Lpair(a, q);
    }
}

Sex CC_listsome(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = mkfxat(0);
    a = w2;
    a = Lleq(a, q);
    if(a == nil) goto    G0392;
    a = nil;
    goto    G0393;
   G0392:
    a = w2;
    a = Lsub1(a);
    q = a;
    a = w1;
    a = CC_listsome(a, q);
    q = w1;
    a = Lxcons(a, q);
   G0393:
    popv(2);
    return a;
}

Sex CC_listzero(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = mkfxat(0);
    a = Lleq(a, q);
    if(a == nil) goto    G0399;
    a = nil;
    goto    G0400;
   G0399:
    a = w1;
    a = Lsub1(a);
    a = CC_listzero(a);
    q = mkfxat(0);
    a = Lxcons(a, q);
   G0400:
    popv(1);
    return a;
}

Sex CC_listmax(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0407;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lmax2(a, q);
    w3 = a;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_listmax(a, q);
    q = w3;
    a = Lxcons(a, q);
   G0407:
    popv(3);
    return a;
}

Sex CC_listmin(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0414;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lmin2(a, q);
    w3 = a;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_listmin(a, q);
    q = w3;
    a = Lxcons(a, q);
   G0414:
    popv(3);
    return a;
}

Sex CC_listmult(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = q;
    if(a == nil) goto    G0421;
    w2 = q;
    q = car(a);
    a = w1;
    a = times2(a, q);
    w3 = a;
    q = cdr(w2);
    a = w1;
    a = CC_listmult(a, q);
    q = w3;
    a = Lxcons(a, q);
   G0421:
    popv(3);
    return a;
}

Sex CC_listsum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0428;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = plus2(a, q);
    w3 = a;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_listsum(a, q);
    q = w3;
    a = Lxcons(a, q);
   G0428:
    popv(3);
    return a;
}

Sex CC_listdiff(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0435;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = diff2(a, q);
    w3 = a;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_listdiff(a, q);
    q = w3;
    a = Lxcons(a, q);
   G0435:
    popv(3);
    return a;
}

Sex CC_listneg(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0442;
    w1 = a;
    a = car(a);
    a = Lminus(a);
    w2 = a;
    a = cdr(w1);
    a = CC_listneg(a);
    q = w2;
    a = Lxcons(a, q);
   G0442:
    popv(2);
    return a;
}

Sex CC_seTlistneg(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = a;
    w1 = a;
   G0448:
    a = car(w2);
    a = Lminus(a);
    q = a;
    a = w2;
    car(a) = q;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0448;
    a = w1;
    popv(2);
    return a;
}

Sex CC_seTdelete(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a != nil) goto    G0455;
    a = q;
    goto    G0457;
   G0455:
    w2 = q;
    q = car(a);
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G0456;
    q = cdr(cdr(w2));
    a = w2;
    {
        popv(2);
        cdr(a) = q;
 return a;
    }
   G0456:
    q = cdr(w2);
    a = w1;
    a = CC_seTdelete(a, q);
   G0457:
    popv(2);
    return a;
}

Sex CC_deletebycar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    if(a == nil) goto    G0463;
    w2 = q;
    q = car(car(a));
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0462;
    a = cdr(w2);
    goto    G0463;
   G0462:
    q = cdr(w2);
    a = w1;
    a = CC_deletebycar(a, q);
    q = car(w2);
    a = Lxcons(a, q);
   G0463:
    popv(2);
    return a;
}

Sex CC_seTdeletebycar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a != nil) goto    G0468;
    a = q;
    goto    G0470;
   G0468:
    w2 = q;
    q = car(car(a));
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0469;
    q = cdr(cdr(w2));
    a = w2;
    {
        popv(2);
        cdr(a) = q;
 return a;
    }
   G0469:
    q = cdr(w2);
    a = w1;
    a = CC_seTdeletebycar(a, q);
   G0470:
    popv(2);
    return a;
}

Sex CC_deletebyindex(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = mkfxat(0);
    w3 = a;
   G0474:
    a = w3;
    a = Ladd1(a);
    w3 = a;
    q = w1;
    a = Llessp(a, q);
    if(a != nil) goto    G0484;
    q = cdr(w2);
    a = w5;
    cdr(a) = q;
    a = car(w2);
    w5 = a;
    goto    G0475;
   G0484:
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0474;
    w5 = nil;
    a = w5;
   G0475:
#define LL_Hsave LITERAL[18]
    value(LL_Hsave) = a;
    a = cdr(w4);
    popv(5);
    return a;
}

Sex CC_multirplaca(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    if(a != nil) goto    G0488;
    a = w1;
    goto    G0489;
   G0488:
    w2 = q;
    q = car(a);
    a = w1;
    car(a) = q;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_multirplaca(a, q);
   G0489:
    popv(2);
    return a;
}

Sex CC_multiassoc(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G0493:
    q = w2;
    a = car(w1);
    a = Lassoc(a, q);
    w5 = a;
    if(a == nil) goto    G0496;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0496:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0493;
    a = cdr(w3);
    popv(5);
    return a;
}

Sex CC_multidelete(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lcopy(a);
    q = CHAR_OF(104);
    a = Lxcons(a, q);
    w3 = a;
   G0504:
    q = w3;
    a = car(w1);
    CC_seTdelete(a, q);
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0504;
    a = cdr(w3);
    popv(3);
    return a;
}

Sex CC_multideletebyindex(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(104);
    a = Lncons(a);
    w6 = a;
    w4 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w7 = a;
    w5 = a;
    a = mkfxat(0);
    w3 = a;
   G0511:
    a = w3;
    a = Ladd1(a);
    w3 = a;
    q = car(w1);
    a = Llessp(a, q);
    if(a == nil) goto    G0514;
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    goto    G0518;
   G0514:
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = cdr(w1);
    w1 = a;
   G0518:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0512;
    a = w1;
    if(a != nil) goto    G0511;
    q = w2;
    a = w6;
    cdr(a) = q;
   G0512:
    a = cdr(w5);
    value(LL_Hsave) = a;
    a = cdr(w4);
    popv(7);
    return a;
}

Sex CC_insertbycar(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = w2;
   G0527:
    if(a != nil) goto    G0529;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    goto    G0537;
   G0529:
    a = car(car(a));
    w6 = a;
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0532;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = cdr(w2);
    goto    G0540;
   G0532:
    m = w6;
    q = car(w1);
    a = w3;
    a = Lfuncall2(a, q, m);
    if(a != nil) goto    G0541;
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    goto    G0527;
   G0541:
    q = w2;
    a = w1;
    a = cons(a, q);
    w6 = a;
    q = a;
    a = w5;
   G0540:
    cdr(a) = q;
   G0537:
    a = cdr(w4);
    popv(6);
    return a;
}

Sex CC_insertbycar2(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = w2;
   G0545:
    if(a != nil) goto    G0547;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    goto    G0555;
   G0547:
    a = car(car(a));
    w6 = a;
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a != nil) goto    G0554;
    m = w6;
    q = car(w1);
    a = w3;
    a = Lfuncall2(a, q, m);
    if(a != nil) goto    G0559;
   G0554:
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    goto    G0545;
   G0559:
    q = w2;
    a = w1;
    a = cons(a, q);
    w6 = a;
    q = a;
    a = w5;
    cdr(a) = q;
   G0555:
    a = cdr(w4);
    popv(6);
    return a;
}

Sex CC_seTinsert(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a != nil) goto    G0563;
    w2 = q;
    w3 = m;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    {
        popv(3);
        return cdr(a);
    }
   G0563:
    w2 = q;
    w3 = m;
    q = car(a);
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G0566;
    a = cdr(w2);
    goto    G0568;
   G0566:
    m = car(cdr(w2));
    q = w1;
    a = w3;
    a = Lfuncall2(a, q, m);
    if(a == nil) goto    G0567;
    q = cdr(w2);
    a = w1;
    a = cons(a, q);
    w1 = a;
    q = a;
    a = w2;
    cdr(a) = q;
    a = w1;
    goto    G0568;
   G0567:
    m = w3;
    q = cdr(w2);
    a = w1;
    a = CC_seTinsert(a, q, m);
   G0568:
    popv(3);
    return a;
}

Sex CC_seTinsertAlis(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = cdr(m);
    a = Lassoc(a, q);
#define LL_Htemporal LITERAL[19]
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0572;
    a = CC_tail(a);
    w5 = a;
    a = w2;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    {
        popv(5);
        return cdr(a);
    }
   G0572:
    q = w2;
    a = w1;
    a = Llist2(a, q);
    m = w4;
    q = w3;
    {
        popv(5);
        return  CC_seTinsertbycar(a, q, m);
    }
}

Sex CC_seTinsertbycar(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a != nil) goto    G0581;
    w2 = q;
    w3 = m;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    {
        popv(3);
        return cdr(a);
    }
   G0581:
    w2 = q;
    w3 = m;
    q = car(car(a));
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0584;
    q = w1;
    a = cdr(w2);
    {
        popv(3);
        car(a) = q;
 return a;
    }
   G0584:
    m = car(car(cdr(w2)));
    q = car(w1);
    a = w3;
    a = Lfuncall2(a, q, m);
    if(a == nil) goto    G0585;
    q = cdr(w2);
    a = w1;
    a = cons(a, q);
    w1 = a;
    q = a;
    a = w2;
    cdr(a) = q;
    a = w1;
    goto    G0586;
   G0585:
    m = w3;
    q = cdr(w2);
    a = w1;
    a = CC_seTinsertbycar(a, q, m);
   G0586:
    popv(3);
    return a;
}

Sex CC_seTinsertbycar2(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a != nil) goto    G0590;
    w2 = q;
    w3 = m;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    {
        popv(3);
        return cdr(a);
    }
   G0590:
    w2 = q;
    w3 = m;
    q = car(car(a));
    a = car(w1);
    a = Lequal(a, q);
    if(a != nil) goto    G0594;
    m = car(car(cdr(w2)));
    q = car(w1);
    a = w3;
    a = Lfuncall2(a, q, m);
    if(a == nil) goto    G0594;
    q = cdr(w2);
    a = w1;
    a = cons(a, q);
    w1 = a;
    q = a;
    a = w2;
    cdr(a) = q;
    a = w1;
    goto    G0595;
   G0594:
    m = w3;
    q = cdr(w2);
    a = w1;
    a = CC_seTinsertbycar2(a, q, m);
   G0595:
    popv(3);
    return a;
}

Sex CC_merglists(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    q = car(a);
    a = CHAR_OF(104);
    a = cons(a, q);
    w3 = a;
    goto    G0605;
   G0600:
    a = car(w1);
    w5 = a;
    a = w3;
    w4 = a;
   G0601:
    m = w2;
    q = w4;
    a = car(w5);
    a = CC_seTinsert(a, q, m);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0601;
   G0605:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0600;
    a = cdr(w3);
    popv(7);
    return a;
}

Sex CC_sortCs(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = CC_WorderCs(a, q);
    if(a == nil) goto    G0615;
    a = w1;
    goto    G0610;
   G0615:
    a = w1;
    a = CC_topcopy(a);
    q = CHAR_OF(104);
    a = Lxcons(a, q);
    w5 = a;
    w3 = a;
   G0611:
    a = w5;
    w7 = a;
    a = cdr(a);
    w6 = a;
    a = car(a);
    w4 = a;
   G0612:
    m = car(cdr(w6));
    q = w4;
    a = w2;
    a = Lfuncall2(a, q, m);
    if(a != nil) goto    G0618;
    a = w6;
    w7 = a;
    a = car(cdr(a));
    w4 = a;
   G0618:
    a = cdr(w6);
    w6 = a;
    a = cdr(a);
    if(a != nil) goto    G0612;
    a = w7;
    if(a != w5) goto    G0623;
    a = cdr(w5);
    w5 = a;
    goto    G0624;
   G0623:
    q = cdr(cdr(a));
    cdr(a) = q;
    a = cdr(w5);
    w6 = a;
    a = w4;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = w6;
    cdr(a) = q;
   G0624:
    a = cdr(cdr(w5));
    if(a != nil) goto    G0611;
    a = cdr(w3);
   G0610:
    popv(7);
    return a;
}

Sex CC_sortany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    a = CC_topcopy(a);
    q = w1;
    {
        popv(1);
        return  CC_seTsortany(a, q);
    }
}

Sex CC_seTsortany(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(a == nil) goto    G0636;
    a = cdr(a);
    if(a != nil) goto    G0635;
   G0636:
    a = w1;
    goto    G0637;
   G0635:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    q = w1;
    a = CHAR_OF(104);
    a = cons(a, q);
    w3 = a;
    a = w1;
    w4 = a;
    a = car(a);
    w7 = a;
    a = cdr(w1);
    w5 = a;
   G0639:
    a = car(w5);
    w8 = a;
    m = a;
    q = w7;
    a = w2;
    a = Lfuncall2(a, q, m);
    if(a == nil) goto    G0643;
    a = w8;
    w7 = a;
    a = w5;
    w4 = a;
    goto    G0641;
   G0643:
    a = w4;
    if(a != cdr(w3)) goto    G0645;
    q = car(w5);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    q = cdr(w5);
    a = w4;
    cdr(a) = q;
    goto    G0641;
   G0645:
    a = w3;
    w6 = a;
   G0640:
    m = car(cdr(w6));
    q = w8;
    a = w2;
    a = Lfuncall2(a, q, m);
    if(a != nil) goto    G0649;
    a = cdr(w6);
    if(a == w4) goto    G0649;
    w6 = a;
    goto    G0640;
   G0649:
    q = cdr(w6);
    a = w8;
    a = cons(a, q);
    q = a;
    a = w6;
    cdr(a) = q;
    q = cdr(w5);
    a = w4;
    cdr(a) = q;
   G0641:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0639;
    a = cdr(w3);
   G0637:
    popv(8);
    return a;
}

Sex CC_sortbycar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    a = CC_topcopy(a);
    q = w1;
    {
        popv(1);
        return  CC_seTsortbycar(a, q);
    }
}

Sex CC_seTsortbycar(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(a == nil) goto    G0661;
    a = cdr(a);
    if(a != nil) goto    G0660;
   G0661:
    a = w1;
    goto    G0662;
   G0660:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    q = w1;
    a = CHAR_OF(104);
    a = cons(a, q);
    w3 = a;
    a = w1;
    w4 = a;
    a = car(a);
    w7 = a;
    a = cdr(w1);
    w5 = a;
   G0664:
    a = car(w5);
    w8 = a;
    a = car(a);
    m = a;
    q = car(w7);
    a = w2;
    a = Lfuncall2(a, q, m);
    if(a == nil) goto    G0668;
    a = w8;
    w7 = a;
    a = w5;
    w4 = a;
    goto    G0666;
   G0668:
    a = w4;
    if(a != cdr(w3)) goto    G0671;
    q = car(w5);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    q = cdr(w5);
    a = w4;
    cdr(a) = q;
    goto    G0666;
   G0671:
    a = w3;
    w6 = a;
   G0665:
    m = car(car(cdr(w6)));
    q = car(w8);
    a = w2;
    a = Lfuncall2(a, q, m);
    if(a != nil) goto    G0675;
    a = cdr(w6);
    if(a == w4) goto    G0675;
    w6 = a;
    goto    G0665;
   G0675:
    q = cdr(w6);
    a = w8;
    a = cons(a, q);
    q = a;
    a = w6;
    cdr(a) = q;
    q = cdr(w5);
    a = w4;
    cdr(a) = q;
   G0666:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0664;
    a = cdr(w3);
   G0662:
    popv(8);
    return a;
}

Sex CC_seTsortset(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G0693;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w4 = a;
    w3 = a;
    w2 = a;
   G0686:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0693;
    q = car(a);
    a = car(w3);
    a = Lequal(a, q);
    if(a == nil) goto    G0689;
    q = cdr(w4);
    a = w3;
    cdr(a) = q;
    a = w3;
    w4 = a;
    goto    G0686;
   G0689:
    q = car(w4);
    a = car(w3);
    a = CC_Worder(a, q);
    if(a == nil) goto    G0690;
    a = w4;
    w3 = a;
    goto    G0686;
   G0690:
    a = w2;
    if(a == w3) goto    G0692;
    if(a == w1) goto    G0692;
    q = car(a);
    a = car(w4);
    a = CC_Worder(a, q);
    if(a == nil) goto    G0691;
   G0692:
    a = w1;
    w2 = a;
   G0691:
#define LL_Worder LITERAL[20]
    m = LL_Worder;
    q = w2;
    a = car(w4);
    a = CC_seTinsert(a, q, m);
    w2 = a;
    q = cdr(w4);
    a = w3;
    cdr(a) = q;
    goto    G0686;
   G0693:
    a = w1;
    popv(4);
    return a;
}

Sex CC_intersecq(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0700;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0698;
    q = w2;
    a = cdr(w1);
    a = CC_intersecq(a, q);
    q = car(w1);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G0698:
    q = w2;
    a = cdr(w1);
    a = CC_intersecq(a, q);
   G0700:
    popv(2);
    return a;
}

Sex CC_seTunionq(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a != nil) goto    G0704;
    a = q;
    goto    G0706;
   G0704:
    w1 = a;
    a = q;
    if(a == nil) goto    G0717;
    w3 = nil;
    w4 = nil;
    w2 = q;
   G0708:
    a = car(w2);
    w4 = a;
    a = w1;
    w3 = a;
   G0709:
    q = car(w3);
    a = w4;
    a = Lneq(a, q);
    if(a == nil) goto    G0711;
    a = cdr(w3);
    if(a == nil) goto    G0713;
    w3 = a;
    goto    G0709;
   G0713:
    a = w4;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
   G0711:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0708;
   G0717:
    a = w1;
   G0706:
    popv(4);
    return a;
}

Sex CC_seTunionids(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a != nil) goto    G0722;
    a = q;
    goto    G0724;
   G0722:
    w1 = a;
    a = q;
    if(a != nil) goto    G0723;
    a = w1;
    goto    G0724;
   G0723:
    w3 = nil;
    w4 = nil;
    w2 = q;
    q = CHAR_OF(104);
    a = Lxcons(a, q);
    w4 = a;
    w3 = a;
   G0726:
    a = car(w1);
    if(a != car(w2)) goto    G0728;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0739;
    goto    G0726;
   G0728:
    q = car(w2);
    a = CC_WorderTid(a, q);
    if(a == nil) goto    G0732;
    q = w2;
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0739;
    goto    G0726;
   G0732:
    a = w2;
    w4 = a;
    a = cdr(a);
    w2 = a;
    if(a != nil) goto    G0726;
    q = w1;
    a = w4;
    cdr(a) = q;
   G0739:
    a = cdr(w3);
   G0724:
    popv(4);
    return a;
}

Sex CC_seTunionvars(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a != nil) goto    G0745;
    a = q;
    goto    G0747;
   G0745:
    w1 = a;
    a = q;
    if(a != nil) goto    G0746;
    a = w1;
    goto    G0747;
   G0746:
    w3 = nil;
    w4 = nil;
    w2 = q;
#define LL_head LITERAL[21]
    q = LL_head;
    a = Lxcons(a, q);
    w4 = a;
    w3 = a;
   G0749:
    q = car(w2);
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0751;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0762;
    goto    G0749;
   G0751:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0755;
    q = w2;
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0762;
    goto    G0749;
   G0755:
    a = w2;
    w4 = a;
    a = cdr(a);
    w2 = a;
    if(a != nil) goto    G0749;
    q = w1;
    a = w4;
    cdr(a) = q;
   G0762:
    a = cdr(w3);
   G0747:
    popv(4);
    return a;
}

Sex CC_mod1(Sex a)
{
    Sex q;
    q = value(LL_Hmod);
    {
        return  remaind2(a, q);
    }
}

Sex CC_mod2(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    a = remaind2(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0781;
    a = w1;
    a = Lminusp(a);
    if(a != nil) goto    G0787;
    a = w2;
    a = Labs(a);
    q = a;
    a = w1;
    a = diff2(a, q);
    value(LL_Htemporal) = a;
    q = a;
    a = w1;
    a = plus2(a, q);
    a = Lplusp(a);
    if(a == nil) goto    G0781;
   G0786:
    a = value(LL_Htemporal);
    goto    G0778;
   G0787:
    a = w2;
    a = Labs(a);
    q = a;
    a = w1;
    a = plus2(a, q);
    value(LL_Htemporal) = a;
    q = a;
    a = w1;
    a = plus2(a, q);
    a = Lplusp(a);
    if(a == nil) goto    G0786;
   G0781:
    a = w1;
   G0778:
    popv(2);
    return a;
}

Sex CC_modadd(Sex a, Sex q)
{
    a = plus2(a, q);
    q = value(LL_Hmod);
    {
        return  remaind2(a, q);
    }
}

Sex CC_modmult(Sex a, Sex q)
{
    a = times2(a, q);
    q = value(LL_Hmod);
    {
        return  remaind2(a, q);
    }
}

Sex CC_moddiv(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = q;
    a = CC_modrecip(a);
    q = a;
    a = w1;
    a = times2(a, q);
    q = value(LL_Hmod);
    {
        popv(1);
        return  remaind2(a, q);
    }
}

Sex CC_modrecip(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0801;
    q = nil;
    a = mkfxat(6);
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
   G0801:
    q = w1;
    a = value(LL_Hmod);
    a = CC_cofactTintint(a, q);
    w1 = a;
    if(a == nil) goto    G0802;
    a = cdr(a);
    w1 = a;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0808;
    q = value(LL_Hmod);
    a = w1;
    {
        popv(1);
        return  plus2(a, q);
    }
   G0802:
    q = value(LL_Hmod);
    a = LITERAL[22];
    CC_optionmsg(a, q);
    q = nil;
    a = nil;
    a = Lerror(a, q);
   G0808:
    a = w1;
    popv(1);
    return a;
}

Sex CC_modplus2(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = m;
    a = plus2(a, q);
    q = w1;
    {
        popv(1);
        return  modulus(a, q);
    }
}

Sex CC_modtimes2(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = m;
    a = times2(a, q);
    q = w1;
    {
        popv(1);
        return  modulus(a, q);
    }
}

Sex CC_modinverse(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = a;
    a = w2;
    a = CC_cofactTintint(a, q);
    w3 = a;
    if(a != nil) goto    G0826;
    q = w2;
    a = LITERAL[22];
    CC_optionmsg(a, q);
    q = nil;
    a = nil;
    Lerror(a, q);
   G0826:
    a = cdr(a);
    w3 = a;
    a = Lminusp(a);
    if(a != nil) goto    G0822;
    a = w3;
    goto    G0817;
   G0822:
    a = w2;
    a = Labs(a);
    q = a;
    a = w3;
    a = plus2(a, q);
   G0817:
    popv(3);
    return a;
}

Sex CC_modquotient(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    a = CC_cofactTintint(a, q);
    w4 = a;
    if(a != nil) goto    G0839;
    q = w3;
    a = LITERAL[22];
    CC_optionmsg(a, q);
    q = nil;
    a = nil;
    Lerror(a, q);
   G0839:
    q = cdr(a);
    a = w1;
    a = times2(a, q);
    q = w3;
    a = remaind2(a, q);
    w4 = a;
    a = Lminusp(a);
    if(a != nil) goto    G0835;
    a = w4;
    goto    G0829;
   G0835:
    a = w3;
    a = Labs(a);
    q = a;
    a = w4;
    a = plus2(a, q);
   G0829:
    popv(4);
    return a;
}

Sex CC_modexpt(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    a = q;
    a = Lplusp(a);
    if(a == nil) goto    G0843;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_modexptTsub(a, q, m);
    }
   G0843:
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G0844;
    a = mkfxat(1);
    goto    G0845;
   G0844:
    a = mkfxat(0);
   G0845:
    popv(3);
    return a;
}

Sex CC_modexptTsub(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G0849;
    a = w1;
    goto    G0850;
   G0849:
    q = mkfxat(2);
    a = w2;
    a = quot2(a, q);
    m = w3;
    q = a;
    a = w1;
    a = CC_modexptTsub(a, q, m);
    value(LL_Htemporal) = a;
    q = a;
    a = times2(a, q);
    q = w3;
    a = modulus(a, q);
    value(LL_Htemporal) = a;
    a = w2;
    a = Levenp(a);
    if(a == nil) goto    G0854;
    a = value(LL_Htemporal);
    goto    G0850;
   G0854:
    q = w1;
    a = value(LL_Htemporal);
    a = times2(a, q);
    q = w3;
    a = modulus(a, q);
   G0850:
    popv(3);
    return a;
}

Sex CC_modint2numden(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
   G0894:
    w1 = a;
    w2 = q;
    w3 = m;
    a = Lminusp(a);
    if(a == nil) goto    G0860;
    a = w1;
    a = Lminus(a);
    m = w3;
    q = w2;
    a = CC_modint2numden(a, q, m);
    w1 = a;
    if(a == nil) goto    G0870;
    a = car(a);
    a = Lminus(a);
    q = cdr(w1);
    goto    G0892;
   G0860:
    q = w2;
    a = w1;
    a = Lgeq(a, q);
    if(a == nil) goto    G0866;
    q = w2;
    a = w1;
    a = remaind2(a, q);
    m = w3;
    q = w2;
    goto    G0894;  /* recursive call to modint2numden */
   G0866:
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G0868;
    q = mkfxat(1);
    a = mkfxat(0);
    goto    G0892;
   G0868:
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0869;
    q = mkfxat(1);
    a = mkfxat(1);
    goto    G0892;
   G0869:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = mkfxat(1);
    w6 = a;
    w5 = a;
    a = mkfxat(0);
    w7 = a;
    w4 = a;
   G0872:
    a = w1;
    a = Lzerop(a);
    if(a != nil) goto    G0893;
    q = w3;
    a = w1;
    a = Llessp(a, q);
    if(a == nil) goto    G0875;
    a = w6;
    a = Lminusp(a);
    if(a != nil) goto    G0877;
    q = w3;
    a = w6;
    a = Llessp(a, q);
    if(a == nil) goto    G0870;
    q = w6;
    a = w1;
    goto    G0892;
   G0877:
    a = w6;
    a = Lminus(a);
    w6 = a;
    q = w3;
    a = Llessp(a, q);
    if(a == nil) goto    G0870;
    a = w1;
    a = Lminus(a);
    q = w6;
   G0892:
    {
        popv(9);
        return  cons(a, q);
    }
   G0875:
    q = w1;
    a = w2;
    a = Ldivide(a, q);
    w9 = a;
    a = car(a);
    w8 = a;
    a = w1;
    w2 = a;
    a = cdr(w9);
    w1 = a;
    a = w4;
    w9 = a;
    q = a;
    a = w8;
    a = times2(a, q);
    q = a;
    a = w5;
    a = diff2(a, q);
    w4 = a;
    a = w9;
    w5 = a;
    a = w6;
    w9 = a;
    q = a;
    a = w8;
    a = times2(a, q);
    q = a;
    a = w7;
    a = diff2(a, q);
    w6 = a;
    a = w9;
    w7 = a;
    goto    G0872;
   G0893:
    a = nil;
   G0870:
    popv(9);
    return a;
}

Sex CC_cofactTintint(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lminusp(a);
    if(a == nil) goto    G0897;
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G0899;
    a = w1;
    a = Lminus(a);
    w3 = a;
    a = w2;
    a = Lminus(a);
    q = a;
    a = w3;
    a = CC_cofactTintint(a, q);
    w1 = a;
    if(a == nil) goto    G0917;
    a = car(a);
    a = Lminus(a);
    q = a;
    a = w1;
    car(a) = q;
    a = cdr(w1);
    goto    G0937;
   G0899:
    a = w1;
    a = Lminus(a);
    q = w2;
    a = CC_cofactTintint(a, q);
    w1 = a;
    if(a == nil) goto    G0917;
    a = car(a);
    a = Lminus(a);
    q = a;
    a = w1;
    {
        popv(8);
        car(a) = q;
 return a;
    }
   G0897:
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G0911;
    a = w2;
    a = Lminus(a);
    q = a;
    a = w1;
    a = CC_cofactTintint(a, q);
    w1 = a;
    if(a == nil) goto    G0917;
    a = cdr(a);
   G0937:
    a = Lminus(a);
    q = a;
    a = w1;
    {
        popv(8);
        cdr(a) = q;
 return a;
    }
   G0911:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    q = w1;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0921;
    a = mkfxat(1);
    w5 = a;
    w4 = a;
    a = mkfxat(0);
    goto    G0938;
   G0921:
    a = w1;
    w8 = a;
    a = w2;
    w1 = a;
    a = w8;
    w2 = a;
    a = mkfxat(0);
    w5 = a;
    w4 = a;
    a = mkfxat(1);
   G0938:
    w6 = a;
    w3 = a;
   G0922:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G0924;
    q = w5;
    a = w3;
    goto    G0940;
   G0924:
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G0926;
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0917;
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G0929;
    a = w6;
    a = Lzerop(a);
    if(a == nil) goto    G0929;
    q = mkfxat(0);
    a = mkfxat(1);
    goto    G0940;
   G0929:
    a = w3;
    a = Lonep(a);
    if(a == nil) goto    G0917;
    a = w5;
    a = Lzerop(a);
    if(a == nil) goto    G0917;
    q = mkfxat(1);
    a = mkfxat(0);
   G0940:
    {
        popv(8);
        return  cons(a, q);
    }
   G0926:
    q = w2;
    a = w1;
    a = Ldivide(a, q);
    w8 = a;
    a = car(a);
    w7 = a;
    a = w2;
    w1 = a;
    a = cdr(w8);
    w2 = a;
    a = w3;
    w8 = a;
    q = a;
    a = w7;
    a = times2(a, q);
    q = a;
    a = w4;
    a = diff2(a, q);
    w3 = a;
    a = w8;
    w4 = a;
    a = w5;
    w8 = a;
    q = a;
    a = w7;
    a = times2(a, q);
    q = a;
    a = w6;
    a = diff2(a, q);
    w5 = a;
    a = w8;
    w6 = a;
    goto    G0922;
   G0917:
    popv(8);
    return a;
}

Sex CC_WorderCs(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G0944;
    a = true;
    goto    G0946;
   G0944:
    w2 = q;
    m = car(a);
    q = car(w1);
    a = w2;
    a = Lfuncall2(a, q, m);
    if(a == nil) goto    G0946;
    q = w2;
    a = cdr(w1);
    a = CC_WorderCs(a, q);
   G0946:
    popv(2);
    return a;
}

Sex CC_qabs(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = CC_Wcompl(a);
    if(a != nil) goto    G0950;
    a = w1;
    {
        popv(2);
        return  Labs(a);
    }
   G0950:
    a = w1;
    a = Lcomplex_real(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lcomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  plus2(a, q);
    }
}

Sex CC_compllessp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_realpart(a);
    w3 = a;
    a = w2;
    a = CC_realpart(a);
    w4 = a;
    q = a;
    a = w3;
    a = Llessp(a, q);
    if(a == nil) goto    G0960;
    a = true;
    goto    G0958;
   G0960:
    q = w4;
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0961;
    a = nil;
    goto    G0958;
   G0961:
    a = w1;
    a = CC_imagpart(a);
    w5 = a;
    a = w2;
    a = CC_imagpart(a);
    q = a;
    a = w5;
    a = Llessp(a, q);
   G0958:
    popv(5);
    return a;
}

Sex CC_rpartlessp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    a = CC_realpart(a);
    w1 = a;
    a = w2;
    a = CC_realpart(a);
    q = a;
    a = w1;
    {
        popv(2);
        return  Llessp(a, q);
    }
}

Sex CC_ipartlessp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    a = CC_imagpart(a);
    w1 = a;
    a = w2;
    a = CC_imagpart(a);
    q = a;
    a = w1;
    {
        popv(2);
        return  Llessp(a, q);
    }
}

Sex CC_gcdTintint(Sex a, Sex q)
{
    {
        return  gcd(a, q);
    }
}

Sex CC_lcmTintint(Sex a, Sex q)
{
    {
        return  Llcm(a, q);
    }
}

Sex CC_addTbnumbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = value(LL_Hmod);
    if(a == nil) goto    G0981;
    a = w1;
    {
        popv(2);
        return  CC_modadd(a, q);
    }
   G0981:
    a = value(LL_Hfloat);
    if(a == nil) goto    G0988;
    a = cdr(a);
    if(a != nil) goto    G0983;
   G0988:
    a = w1;
    {
        popv(2);
        return  plus2(a, q);
    }
   G0983:
    w2 = q;
    a = w1;
    a = plus2(a, q);
    w2 = a;
    a = Labs(a);
    q = cdr(value(LL_Hfloat));
    a = Llessp(a, q);
    if(a == nil) goto    G0984;
    a = mkfxat(0);
    goto    G0987;
   G0984:
    a = w2;
   G0987:
    popv(2);
    return a;
}

Sex CC_negTbnum(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_Hmod);
    if(a != nil) goto    G0992;
    a = w1;
    {
        popv(1);
        return  Lminus(a);
    }
   G0992:
    a = w1;
    a = Lminus(a);
    w1 = a;
    a = Lminusp(a);
    if(a == nil) goto    G0993;
    q = value(LL_Hmod);
    a = w1;
    {
        popv(1);
        return  plus2(a, q);
    }
   G0993:
    a = w1;
    popv(1);
    return a;
}

Sex CC_multTbnumbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = value(LL_Hmod);
    if(a == nil) goto    G0999;
    a = w1;
    {
        popv(2);
        return  CC_modmult(a, q);
    }
   G0999:
    a = value(LL_Hfloat);
    if(a == nil) goto    G1006;
    a = cdr(a);
    if(a != nil) goto    G1001;
   G1006:
    a = w1;
    {
        popv(2);
        return  times2(a, q);
    }
   G1001:
    w2 = q;
    a = w1;
    a = times2(a, q);
    w2 = a;
    a = Labs(a);
    q = cdr(value(LL_Hfloat));
    a = Llessp(a, q);
    if(a == nil) goto    G1002;
    a = mkfxat(0);
    goto    G1005;
   G1002:
    a = w2;
   G1005:
    popv(2);
    return a;
}

Sex CC_recipTbnum(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(!is_integer(a)) goto    G1010;
    a = Lzerop(a);
    if(a != nil) goto    G1045;
    a = value(LL_Hmod);
    if(a == nil) goto    G1013;
    a = w1;
    {
        popv(2);
        return  CC_modrecip(a);
    }
   G1013:
    q = w1;
    a = mkfxat(1);
    goto    G1051;
   G1010:
    if(!is_rational(a)) goto    G1015;
    a = value(LL_Hmod);
    if(a == nil) goto    G1017;
    a = w1;
    a = Lden(a);
    w2 = a;
    a = w1;
    a = Lnum(a);
    a = CC_modrecip(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_modmult(a, q);
    }
   G1017:
    a = w1;
    a = Lden(a);
    w2 = a;
    a = w1;
    a = Lnum(a);
    q = a;
    a = w2;
   G1051:
    {
        popv(2);
        return  Lmkrational(a, q);
    }
   G1015:
    if(!is_float(a)) goto    G1024;
    a = Lzerop(a);
    if(a != nil) goto    G1045;
    q = w1;
    a = LITERAL[23];
    goto    G1058;
   G1024:
    if(!is_complex(a)) goto    G1028;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1030;
    a = w1;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1045;
   G1030:
    a = w1;
    a = Lcomplex_real(a);
    if(!is_float(a)) goto    G1034;
    q = LITERAL[16];
    a = LITERAL[23];
    a = Lmkcomplex(a, q);
    q = w1;
    goto    G1058;
   G1034:
    q = mkfxat(0);
    a = mkfxat(1);
    a = Lmkcomplex(a, q);
    q = w1;
    goto    G1058;
   G1028:
    if(!is_efloat(a)) goto    G1038;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a != nil) goto    G1045;
    q = LITERAL[16];
    a = LITERAL[23];
    a = Lmkefloat(a, q);
    q = w1;
    goto    G1058;
   G1038:
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1044;
    a = w1;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a == nil) goto    G1044;
   G1045:
    q = nil;
    a = mkfxat(6);
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G1044:
    m = LITERAL[16];
    q = LITERAL[16];
    a = LITERAL[23];
    a = Lmkecomplex(a, q, m);
    q = w1;
   G1058:
    {
        popv(2);
        return  quot2(a, q);
    }
}

Sex CC_powTbnumpint(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_integer(a)) goto    G1062;
    a = value(LL_Hmod);
    if(a == nil) goto    G1062;
    m = a;
    a = w1;
    {
        popv(1);
        return  CC_modexpt(a, q, m);
    }
   G1062:
    a = w1;
    {
        popv(1);
        return  Lexpt(a, q);
    }
}

Sex CC_powTbnumbnum(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(q)) goto    G1068;
    a = q;
    a = Lminusp(a);
    if(a == nil) goto    G1070;
    a = w1;
    a = CC_recipTbnum(a);
    w3 = a;
    a = w2;
    a = Lminus(a);
    q = a;
    a = w3;
    {
        popv(3);
        return  CC_powTbnumpint(a, q);
    }
   G1070:
    a = w2;
    a = Lzerop(a);
    if(a != nil) goto    G1082;
    a = w1;
    if(!is_integer(a)) goto    G1074;
    a = value(LL_Hmod);
    if(a == nil) goto    G1074;
    m = a;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_modexpt(a, q, m);
    }
   G1074:
    q = w2;
    a = w1;
    {
        popv(3);
        return  Lexpt(a, q);
    }
   G1068:
    a = Llog(a);
    q = a;
    a = w2;
    a = times2(a, q);
    a = Lexp(a);
    w1 = a;
#define LL_Hfcut LITERAL[24]
    a = value(LL_Hfcut);
    if(a == nil) goto    G1082;
    a = w1;
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G1082;
    a = mkfxat(0);
    goto    G1077;
   G1082:
    a = w1;
   G1077:
    popv(3);
    return a;
}

Sex CC_mathdiv(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(a)) goto    G1090;
    if(!is_integer(q)) goto    G1092;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1143;
    a = value(LL_Hmod);
    if(a == nil) goto    G1095;
    a = w2;
    a = CC_modrecip(a);
    goto    G1144;
   G1095:
    q = w2;
    a = w1;
    goto    G1150;
   G1092:
    if(!is_rational(q)) goto    G1110;
    a = value(LL_Hmod);
    if(a == nil) goto    G1100;
    a = q;
    a = Lden(a);
    w3 = a;
    a = w2;
    a = Lnum(a);
    a = CC_modrecip(a);
    q = a;
    a = w3;
    a = CC_modmult(a, q);
   G1144:
    q = a;
    a = w1;
    goto    G1149;
   G1100:
    a = q;
    a = Lden(a);
    q = a;
    a = w1;
    a = times2(a, q);
    w3 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w3;
    goto    G1150;
   G1090:
    if(!is_rational(a)) goto    G1110;
    if(!is_integer(q)) goto    G1112;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G1114;
   G1143:
    q = nil;
    a = mkfxat(6);
    {
        popv(4);
        return  CC_errormsg(a, q);
    }
   G1114:
    a = value(LL_Hmod);
    if(a == nil) goto    G1115;
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w1;
    a = Lden(a);
    q = w2;
    a = times2(a, q);
    a = CC_modrecip(a);
    q = a;
    a = w3;
    goto    G1149;
   G1115:
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w1;
    a = Lden(a);
    q = w2;
    a = times2(a, q);
    q = a;
    a = w3;
    goto    G1150;
   G1112:
    if(!is_rational(q)) goto    G1110;
    a = value(LL_Hmod);
    if(a == nil) goto    G1126;
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w2;
    a = Lden(a);
    q = a;
    a = w3;
    a = times2(a, q);
    w3 = a;
    a = w1;
    a = Lden(a);
    w4 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w4;
    a = times2(a, q);
    a = CC_modrecip(a);
    q = a;
    a = w3;
   G1149:
    {
        popv(4);
        return  CC_modmult(a, q);
    }
   G1126:
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w2;
    a = Lden(a);
    q = a;
    a = w3;
    a = times2(a, q);
    w3 = a;
    a = w1;
    a = Lden(a);
    w4 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w4;
    a = times2(a, q);
    q = a;
    a = w3;
   G1150:
    {
        popv(4);
        return  Lmkrational(a, q);
    }
   G1110:
    {
        popv(4);
        return  quot2(a, q);
    }
}

Sex CC_divTbnumbnum(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(a)) goto    G1155;
    if(!is_integer(q)) goto    G1157;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    q = w2;
    a = w1;
    goto    G1360;
   G1157:
    if(!is_rational(q)) goto    G1161;
    a = q;
    a = Lden(a);
    q = a;
    a = w1;
    a = times2(a, q);
    w3 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w3;
    goto    G1360;
   G1161:
    if(!is_float(q)) goto    G1165;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    a = w1;
    a = Lfloat(a);
    goto    G1367;
   G1165:
    if(!is_complex(q)) goto    G1170;
    a = q;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1172;
    a = w2;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
   G1172:
    a = w2;
    a = Lcomplex_real(a);
    if(!is_float(a)) goto    G1176;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    goto    G1367;
   G1176:
    q = mkfxat(0);
    a = w1;
    a = Lmkcomplex(a, q);
    goto    G1367;
   G1170:
    if(!is_efloat(q)) goto    G1181;
    a = q;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    goto    G1367;
   G1181:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1188;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
   G1188:
    a = w1;
    a = Lfloat(a);
    m = LITERAL[16];
    q = LITERAL[16];
    a = Lmkecomplex(a, q, m);
    goto    G1367;
   G1155:
    if(!is_rational(a)) goto    G1195;
    if(!is_integer(q)) goto    G1197;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w1;
    a = Lden(a);
    q = w2;
    a = times2(a, q);
    q = a;
    a = w3;
    goto    G1360;
   G1197:
    if(!is_rational(q)) goto    G1204;
    a = Lnum(a);
    w3 = a;
    a = w2;
    a = Lden(a);
    q = a;
    a = w3;
    a = times2(a, q);
    w3 = a;
    a = w1;
    a = Lden(a);
    w4 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w4;
    a = times2(a, q);
    q = a;
    a = w3;
   G1360:
    {
        popv(4);
        return  Lmkrational(a, q);
    }
   G1204:
    if(!is_float(q)) goto    G1211;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    a = w1;
    a = Lfloat(a);
    goto    G1367;
   G1211:
    if(!is_complex(q)) goto    G1216;
    a = q;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1218;
    a = w2;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
   G1218:
    a = w2;
    a = Lcomplex_real(a);
    if(!is_float(a)) goto    G1222;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    goto    G1367;
   G1222:
    q = mkfxat(0);
    a = w1;
    a = Lmkcomplex(a, q);
    goto    G1367;
   G1216:
    if(!is_efloat(q)) goto    G1227;
    a = q;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    goto    G1367;
   G1227:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1234;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
   G1234:
    a = w1;
    a = Lfloat(a);
    m = LITERAL[16];
    q = LITERAL[16];
    a = Lmkecomplex(a, q, m);
   G1367:
    q = w2;
    goto    G1342;
   G1195:
    if(!is_float(a)) goto    G1241;
    if(!is_integer(q)) goto    G1243;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    a = w2;
    a = Lfloat(a);
    q = a;
    a = w1;
    goto    G1342;
   G1243:
    if(!is_rational(q)) goto    G1248;
    a = q;
    a = Lfloat(a);
    q = a;
    a = w1;
    goto    G1342;
   G1248:
    if(is_float(q)) goto    G1342;
    if(!is_complex(q)) goto    G1251;
    a = q;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1253;
    a = w2;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
   G1253:
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    q = w2;
    goto    G1342;
   G1251:
    if(!is_efloat(q)) goto    G1260;
    a = q;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    q = w2;
    goto    G1342;
   G1260:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1267;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1289;
   G1267:
    m = LITERAL[16];
    q = LITERAL[16];
    a = w1;
    a = Lmkecomplex(a, q, m);
    q = w2;
    goto    G1342;
   G1241:
    if(!is_complex(a)) goto    G1273;
    if(!is_integer(q)) goto    G1275;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1289;
    a = w2;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    q = a;
    a = w1;
    goto    G1342;
   G1275:
    if(!is_rational(q)) goto    G1281;
    a = q;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    q = a;
    a = w1;
    goto    G1342;
   G1281:
    if(!is_float(q)) goto    G1284;
    q = LITERAL[16];
    a = w2;
    a = Lmkcomplex(a, q);
    q = a;
    a = w1;
    goto    G1342;
   G1284:
    if(!is_complex(q)) goto    G1286;
    a = q;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1288;
    a = w2;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a == nil) goto    G1288;
   G1289:
    q = nil;
    a = mkfxat(6);
    goto    G1396;
   G1288:
    q = w2;
    a = w1;
    goto    G1342;
   G1286:
    if(!is_efloat(q)) goto    G1293;
    q = nil;
    a = LITERAL[25];
    goto    G1396;
   G1293:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1294;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a == nil) goto    G1294;
    q = nil;
    a = mkfxat(6);
    goto    G1396;
   G1294:
    a = w1;
    a = Lcomplex_real(a);
    w3 = a;
    a = w1;
    a = Lcomplex_imag(a);
    m = LITERAL[16];
    q = a;
    a = w3;
    a = Lmkecomplex(a, q, m);
    q = w2;
    goto    G1342;
   G1273:
    if(!is_efloat(a)) goto    G1302;
    if(!is_integer(q)) goto    G1304;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G1306;
    q = nil;
    a = mkfxat(6);
    goto    G1396;
   G1306:
    a = w2;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    q = a;
    a = w1;
    goto    G1342;
   G1304:
    if(!is_rational(q)) goto    G1310;
    a = q;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    q = a;
    a = w1;
    goto    G1342;
   G1310:
    if(!is_float(q)) goto    G1313;
    q = LITERAL[16];
    a = w2;
    a = Lmkefloat(a, q);
    q = a;
    a = w1;
    goto    G1342;
   G1313:
    if(!is_complex(q)) goto    G1315;
    q = nil;
    a = LITERAL[25];
    goto    G1396;
   G1315:
    if(!is_efloat(q)) goto    G1316;
    a = q;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a == nil) goto    G1318;
    q = nil;
    a = mkfxat(6);
    goto    G1396;
   G1318:
    q = w2;
    a = w1;
    goto    G1342;
   G1316:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1321;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a == nil) goto    G1321;
    q = nil;
    a = mkfxat(6);
    goto    G1396;
   G1321:
    a = w1;
    a = Lefloat_value(a);
    w3 = a;
    a = w1;
    a = Lefloat_error(a);
    m = a;
    q = LITERAL[16];
    a = w3;
    a = Lmkecomplex(a, q, m);
    q = w2;
    goto    G1342;
   G1302:
    if(is_integer(q)) goto    G1330;
    if(!is_rational(q)) goto    G1329;
   G1330:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G1332;
    q = nil;
    a = mkfxat(6);
   G1396:
    {
        popv(4);
        return  CC_errormsg(a, q);
    }
   G1332:
    a = w2;
    a = Lfloat(a);
    m = LITERAL[16];
    q = LITERAL[16];
    a = Lmkecomplex(a, q, m);
    q = a;
    a = w1;
    goto    G1342;
   G1329:
    if(!is_float(q)) goto    G1336;
    m = LITERAL[16];
    q = LITERAL[16];
    a = w2;
    a = Lmkecomplex(a, q, m);
    q = a;
    a = w1;
    goto    G1342;
   G1336:
    if(!is_complex(q)) goto    G1338;
    a = q;
    a = Lcomplex_real(a);
    w3 = a;
    a = w2;
    a = Lcomplex_imag(a);
    m = LITERAL[16];
    q = a;
    a = w3;
    a = Lmkecomplex(a, q, m);
    q = a;
    a = w1;
    goto    G1342;
   G1338:
    if(!is_efloat(q)) goto    G1342;
    a = q;
    a = Lefloat_value(a);
    w3 = a;
    a = w2;
    a = Lefloat_error(a);
    m = a;
    q = LITERAL[16];
    a = w3;
    a = Lmkecomplex(a, q, m);
    q = a;
    a = w1;
   G1342:
    {
        popv(4);
        return  quot2(a, q);
    }
}

Sex CC_flgdivTbnumbnum(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(a)) goto    G1405;
    if(!is_integer(q)) goto    G1407;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = value(LL_Hmod);
    if(a == nil) goto    G1410;
    a = w2;
    a = CC_modrecip(a);
    goto    G1622;
   G1410:
    q = w2;
    a = w1;
    goto    G1637;
   G1407:
    if(!is_rational(q)) goto    G1413;
    a = value(LL_Hmod);
    if(a == nil) goto    G1415;
    a = q;
    a = Lden(a);
    w3 = a;
    a = w2;
    a = Lnum(a);
    a = CC_modrecip(a);
    q = a;
    a = w3;
    a = CC_modmult(a, q);
   G1622:
    q = a;
    a = w1;
    goto    G1636;
   G1415:
    a = q;
    a = Lden(a);
    q = a;
    a = w1;
    a = times2(a, q);
    w3 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w3;
    goto    G1637;
   G1413:
    if(!is_float(q)) goto    G1424;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = w1;
    a = Lfloat(a);
    goto    G1644;
   G1424:
    if(!is_complex(q)) goto    G1429;
    a = q;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1431;
    a = w2;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
   G1431:
    a = w2;
    a = Lcomplex_real(a);
    if(!is_float(a)) goto    G1435;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    goto    G1644;
   G1435:
    q = mkfxat(0);
    a = w1;
    a = Lmkcomplex(a, q);
    goto    G1644;
   G1429:
    if(!is_efloat(q)) goto    G1440;
    a = q;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    goto    G1644;
   G1440:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1447;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
   G1447:
    a = w1;
    a = Lfloat(a);
    m = LITERAL[16];
    q = LITERAL[16];
    a = Lmkecomplex(a, q, m);
    goto    G1644;
   G1405:
    if(!is_rational(a)) goto    G1454;
    if(!is_integer(q)) goto    G1456;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = value(LL_Hmod);
    if(a == nil) goto    G1459;
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w1;
    a = Lden(a);
    q = w2;
    a = times2(a, q);
    a = CC_modrecip(a);
    q = a;
    a = w3;
    goto    G1636;
   G1459:
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w1;
    a = Lden(a);
    q = w2;
    a = times2(a, q);
    q = a;
    a = w3;
    goto    G1637;
   G1456:
    if(!is_rational(q)) goto    G1468;
    a = value(LL_Hmod);
    if(a == nil) goto    G1470;
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w2;
    a = Lden(a);
    q = a;
    a = w3;
    a = times2(a, q);
    w3 = a;
    a = w1;
    a = Lden(a);
    w4 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w4;
    a = times2(a, q);
    a = CC_modrecip(a);
    q = a;
    a = w3;
   G1636:
    {
        popv(4);
        return  CC_modmult(a, q);
    }
   G1470:
    a = w1;
    a = Lnum(a);
    w3 = a;
    a = w2;
    a = Lden(a);
    q = a;
    a = w3;
    a = times2(a, q);
    w3 = a;
    a = w1;
    a = Lden(a);
    w4 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w4;
    a = times2(a, q);
    q = a;
    a = w3;
   G1637:
    {
        popv(4);
        return  Lmkrational(a, q);
    }
   G1468:
    if(!is_float(q)) goto    G1485;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = w1;
    a = Lfloat(a);
    goto    G1644;
   G1485:
    if(!is_complex(q)) goto    G1490;
    a = q;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1492;
    a = w2;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
   G1492:
    a = w2;
    a = Lcomplex_real(a);
    if(!is_float(a)) goto    G1496;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    goto    G1644;
   G1496:
    q = mkfxat(0);
    a = w1;
    a = Lmkcomplex(a, q);
    goto    G1644;
   G1490:
    if(!is_efloat(q)) goto    G1501;
    a = q;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    goto    G1644;
   G1501:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1508;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
   G1508:
    a = w1;
    a = Lfloat(a);
    m = LITERAL[16];
    q = LITERAL[16];
    a = Lmkecomplex(a, q, m);
   G1644:
    q = w2;
    goto    G1616;
   G1454:
    if(!is_float(a)) goto    G1515;
    if(!is_integer(q)) goto    G1517;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = w2;
    a = Lfloat(a);
    q = a;
    a = w1;
    goto    G1616;
   G1517:
    if(!is_rational(q)) goto    G1522;
    a = q;
    a = Lfloat(a);
    q = a;
    a = w1;
    goto    G1616;
   G1522:
    if(is_float(q)) goto    G1616;
    if(!is_complex(q)) goto    G1525;
    a = q;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1527;
    a = w2;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
   G1527:
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    q = w2;
    goto    G1616;
   G1525:
    if(!is_efloat(q)) goto    G1534;
    a = q;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = w1;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    q = w2;
    goto    G1616;
   G1534:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1541;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a != nil) goto    G1563;
   G1541:
    m = LITERAL[16];
    q = LITERAL[16];
    a = w1;
    a = Lmkecomplex(a, q, m);
    q = w2;
    goto    G1616;
   G1515:
    if(!is_complex(a)) goto    G1547;
    if(!is_integer(q)) goto    G1549;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    a = w2;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    q = a;
    a = w1;
    goto    G1616;
   G1549:
    if(!is_rational(q)) goto    G1555;
    a = q;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkcomplex(a, q);
    q = a;
    a = w1;
    goto    G1616;
   G1555:
    if(!is_float(q)) goto    G1558;
    q = LITERAL[16];
    a = w2;
    a = Lmkcomplex(a, q);
    q = a;
    a = w1;
    goto    G1616;
   G1558:
    if(!is_complex(q)) goto    G1560;
    a = q;
    a = Lcomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1562;
    a = w2;
    a = Lcomplex_imag(a);
    a = Lzerop(a);
    if(a == nil) goto    G1562;
   G1563:
    q = nil;
    a = mkfxat(6);
    goto    G1673;
   G1562:
    q = w2;
    a = w1;
    goto    G1616;
   G1560:
    if(!is_efloat(q)) goto    G1567;
    q = nil;
    a = LITERAL[25];
    goto    G1673;
   G1567:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1568;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a == nil) goto    G1568;
    q = nil;
    a = mkfxat(6);
    goto    G1673;
   G1568:
    a = w1;
    a = Lcomplex_real(a);
    w3 = a;
    a = w1;
    a = Lcomplex_imag(a);
    m = LITERAL[16];
    q = a;
    a = w3;
    a = Lmkecomplex(a, q, m);
    q = w2;
    goto    G1616;
   G1547:
    if(!is_efloat(a)) goto    G1576;
    if(!is_integer(q)) goto    G1578;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G1580;
    q = nil;
    a = mkfxat(6);
    goto    G1673;
   G1580:
    a = w2;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    q = a;
    a = w1;
    goto    G1616;
   G1578:
    if(!is_rational(q)) goto    G1584;
    a = q;
    a = Lfloat(a);
    q = LITERAL[16];
    a = Lmkefloat(a, q);
    q = a;
    a = w1;
    goto    G1616;
   G1584:
    if(!is_float(q)) goto    G1587;
    q = LITERAL[16];
    a = w2;
    a = Lmkefloat(a, q);
    q = a;
    a = w1;
    goto    G1616;
   G1587:
    if(!is_complex(q)) goto    G1589;
    q = nil;
    a = LITERAL[25];
    goto    G1673;
   G1589:
    if(!is_efloat(q)) goto    G1590;
    a = q;
    a = Lefloat_value(a);
    a = Lzerop(a);
    if(a == nil) goto    G1592;
    q = nil;
    a = mkfxat(6);
    goto    G1673;
   G1592:
    q = w2;
    a = w1;
    goto    G1616;
   G1590:
    a = q;
    a = Lecomplex_real(a);
    a = Lzerop(a);
    if(a == nil) goto    G1595;
    a = w2;
    a = Lecomplex_imag(a);
    a = Lzerop(a);
    if(a == nil) goto    G1595;
    q = nil;
    a = mkfxat(6);
    goto    G1673;
   G1595:
    a = w1;
    a = Lefloat_value(a);
    w3 = a;
    a = w1;
    a = Lefloat_error(a);
    m = a;
    q = LITERAL[16];
    a = w3;
    a = Lmkecomplex(a, q, m);
    q = w2;
    goto    G1616;
   G1576:
    if(is_integer(q)) goto    G1604;
    if(!is_rational(q)) goto    G1603;
   G1604:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G1606;
    q = nil;
    a = mkfxat(6);
   G1673:
    {
        popv(4);
        return  CC_errormsg(a, q);
    }
   G1606:
    a = w2;
    a = Lfloat(a);
    m = LITERAL[16];
    q = LITERAL[16];
    a = Lmkecomplex(a, q, m);
    q = a;
    a = w1;
    goto    G1616;
   G1603:
    if(!is_float(q)) goto    G1610;
    m = LITERAL[16];
    q = LITERAL[16];
    a = w2;
    a = Lmkecomplex(a, q, m);
    q = a;
    a = w1;
    goto    G1616;
   G1610:
    if(!is_complex(q)) goto    G1612;
    a = q;
    a = Lcomplex_real(a);
    w3 = a;
    a = w2;
    a = Lcomplex_imag(a);
    m = LITERAL[16];
    q = a;
    a = w3;
    a = Lmkecomplex(a, q, m);
    q = a;
    a = w1;
    goto    G1616;
   G1612:
    if(!is_efloat(q)) goto    G1616;
    a = q;
    a = Lefloat_value(a);
    w3 = a;
    a = w2;
    a = Lefloat_error(a);
    m = a;
    q = LITERAL[16];
    a = w3;
    a = Lmkecomplex(a, q, m);
    q = a;
    a = w1;
   G1616:
    {
        popv(4);
        return  quot2(a, q);
    }
}

Sex CC_signdiff(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lminusp(a);
    if(a != nil) goto    G1691;
    a = w2;
    a = Lminusp(a);
    if(a != nil) goto    G1688;
    q = w2;
    a = w1;
    a = Llessp(a, q);
    if(a == nil) goto    G1687;
   G1688:
    a = nil;
    goto    G1689;
   G1691:
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G1689;
    q = w2;
    a = w1;
    a = Lleq(a, q);
    if(a == nil) goto    G1689;
   G1687:
    q = w2;
    a = w1;
    a = diff2(a, q);
   G1689:
    popv(2);
    return a;
}

Sex CC_signmax2(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lminusp(a);
    if(a == nil) goto    G1695;
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G1701;
    q = w2;
    a = w1;
    {
        popv(2);
        return  Lmin2(a, q);
    }
   G1695:
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G1699;
   G1701:
    a = mkfxat(0);
    goto    G1700;
   G1699:
    q = w2;
    a = w1;
    a = Lmax2(a, q);
   G1700:
    popv(2);
    return a;
}

Sex CC_signmin2(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lminusp(a);
    if(a == nil) goto    G1705;
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G1711;
    q = w2;
    a = w1;
    {
        popv(2);
        return  Lmax2(a, q);
    }
   G1705:
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G1709;
   G1711:
    a = mkfxat(0);
    goto    G1710;
   G1709:
    q = w2;
    a = w1;
    a = Lmin2(a, q);
   G1710:
    popv(2);
    return a;
}

Sex CC_iqdiv(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Ldivide(a, q);
    value(LL_Htemporal) = a;
    a = car(a);
    if(!is_integer(a)) goto    G1715;
    a = value(LL_Htemporal);
    goto    G1717;
   G1715:
    a = car(value(LL_Htemporal));
    a = Ltruncate(a);
    value(LL_Htemporal) = a;
    q = w2;
    a = times2(a, q);
    q = a;
    a = w1;
    a = diff2(a, q);
    q = value(LL_Htemporal);
    a = Lxcons(a, q);
   G1717:
    popv(2);
    return a;
}

Sex CC_iqdiv2(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    a = Ldivide(a, q);
    w5 = a;
    a = car(a);
    if(!is_integer(a)) goto    G1724;
    a = car(w5);
    w3 = a;
    a = cdr(w5);
    goto    G1747;
   G1724:
    a = car(w5);
    a = Ltruncate(a);
    w3 = a;
    q = w2;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = w1;
    a = plus2(a, q);
   G1747:
    w4 = a;
    a = w1;
    a = Lplusp(a);
    if(a == nil) goto    G1730;
    a = w4;
    a = Labs(a);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    w6 = a;
    a = w2;
    a = Labs(a);
    q = a;
    a = w6;
    a = Llessp(a, q);
    if(a != nil) goto    G1744;
    a = w2;
    a = Lplusp(a);
    if(a == nil) goto    G1736;
    a = w3;
    a = Ladd1(a);
    w3 = a;
    a = w2;
    a = Lminus(a);
    q = a;
    goto    G1750;
   G1736:
    a = w3;
    a = Lsub1(a);
    w3 = a;
    q = w2;
    goto    G1750;
   G1730:
    a = w4;
    a = Labs(a);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    w6 = a;
    a = w2;
    a = Labs(a);
    q = a;
    a = w6;
    a = Llessp(a, q);
    if(a != nil) goto    G1744;
    a = w2;
    a = Lplusp(a);
    if(a == nil) goto    G1743;
    a = w3;
    a = Lsub1(a);
    w3 = a;
    q = w2;
    goto    G1750;
   G1743:
    a = w3;
    a = Ladd1(a);
    w3 = a;
    a = w2;
    a = Lminus(a);
    q = a;
   G1750:
    a = w4;
    a = plus2(a, q);
    w4 = a;
   G1744:
    q = w4;
    a = w3;
    {
        popv(6);
        return  cons(a, q);
    }
}

Sex CC_gcdTbnumbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(a)) goto    G1754;
    if(is_integer(q)) goto    G1776;
    if(!is_rational(q)) goto    G1778;
    a = q;
    a = Lnum(a);
    q = a;
    a = w1;
    goto    G1776;
   G1754:
    if(!is_rational(a)) goto    G1760;
    if(!is_integer(q)) goto    G1762;
    a = Lnum(a);
    q = w2;
   G1776:
    {
        popv(4);
        return  gcd(a, q);
    }
   G1762:
    if(!is_rational(q)) goto    G1778;
    a = Lnum(a);
    w3 = a;
    a = w2;
    a = Lnum(a);
    q = a;
    a = w3;
    a = gcd(a, q);
    w3 = a;
    a = w1;
    a = Lden(a);
    w4 = a;
    a = w2;
    a = Lden(a);
    q = a;
    a = w4;
    a = gcd(a, q);
    q = a;
    a = w3;
    {
        popv(4);
        return  Lmkrational(a, q);
    }
   G1760:
    if(is_integer(q)) goto    G1773;
    if(!is_rational(q)) goto    G1772;
   G1773:
    a = q;
   G1778:
    {
        popv(4);
        return  Labs(a);
    }
   G1772:
    a = mkfxat(1);
    popv(4);
    return a;
}

Sex CC_nthroot(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = mkfxat(1);
    a = Llessp(a, q);
    if(a == nil) goto    G1782;
    q = w1;
    a = LITERAL[23];
    a = quot2(a, q);
    q = w2;
    a = CC_nthroot(a, q);
    q = a;
    a = mkfxat(1);
    {
        popv(5);
        return  quot2(a, q);
    }
   G1782:
    q = mkfxat(0);
    a = w2;
    a = Lleq(a, q);
    if(a == nil) goto    G1785;
    q = LITERAL[26];
    a = LITERAL[27];
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G1785:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1786;
    a = w1;
    goto    G1788;
   G1786:
    q = mkfxat(2);
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G1787;
    a = w1;
    {
        popv(5);
        return  Lsqrt(a);
    }
   G1787:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = w2;
    if(!is_rational(a)) goto    G1791;
    a = Lden(a);
    q = a;
    a = w1;
    a = Lexpt(a, q);
    w1 = a;
    a = w2;
    a = Lnum(a);
    w2 = a;
   G1791:
    a = w1;
    a = Llog(a);
    q = w2;
    a = CC_divTbnumbnum(a, q);
    a = Lexp(a);
    w3 = a;
    a = Ltruncate(a);
    w4 = a;
    q = a;
    a = w3;
    a = diff2(a, q);
    w5 = a;
    q = LITERAL[28];
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1796;
    a = w4;
    a = Ladd1(a);
    goto    G1805;
   G1796:
    q = LITERAL[29];
    a = w5;
    a = Llessp(a, q);
    if(a == nil) goto    G1797;
    a = w4;
    a = Lsub1(a);
   G1805:
    w4 = a;
    goto    G1798;
   G1797:
    a = w5;
    a = Labs(a);
    q = LITERAL[30];
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1801;
   G1798:
    q = w2;
    a = w4;
    a = Lexpt(a, q);
    q = a;
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G1801;
    a = w4;
    goto    G1788;
   G1801:
    a = w3;
   G1788:
    popv(5);
    return a;
}

Sex CC_partpower(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(a)) goto    G1811;
    if(!is_integer(q)) goto    G1811;
    q = mkfxat(1);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1811;
    q = mkfxat(1);
    a = w2;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1810;
   G1811:
    q = LITERAL[31];
    a = LITERAL[32];
    {
        popv(6);
        return  CC_errormsg(a, q);
    }
   G1810:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = w2;
    w5 = a;
    a = mkfxat(0);
    w3 = a;
    a = mkfxat(1);
    w4 = a;
   G1814:
    q = w5;
    a = w1;
    a = Ldivide(a, q);
    w6 = a;
    a = cdr(a);
    a = Lzerop(a);
    if(a == nil) goto    G1819;
    a = car(w6);
    w1 = a;
    q = w4;
    a = w3;
    a = plus2(a, q);
    w3 = a;
    q = w4;
    a = q;
    a = plus2(a, q);
    w4 = a;
    q = w5;
    a = q;
    a = times2(a, q);
    w5 = a;
    q = a;
    a = w1;
    a = Lgeq(a, q);
    if(a != nil) goto    G1814;
   G1819:
    a = w3;
    a = Lzerop(a);
    if(a == nil) goto    G1822;
    a = mkfxat(0);
    goto    G1812;
   G1822:
    q = mkfxat(2);
    a = w1;
    a = Llessp(a, q);
    if(a == nil) goto    G1823;
    a = w3;
    goto    G1812;
   G1823:
    q = w2;
    a = w1;
    a = CC_partpower(a, q);
    q = a;
    a = w3;
    a = plus2(a, q);
   G1812:
    popv(6);
    return a;
}

Sex CC_partroot(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_integer(a)) goto    G1831;
    if(!is_integer(q)) goto    G1831;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1831;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1830;
   G1831:
    q = LITERAL[33];
    a = LITERAL[34];
    {
        popv(9);
        return  CC_errormsg(a, q);
    }
   G1830:
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G1832;
    a = mkfxat(1);
    goto    G1833;
   G1832:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = mkfxat(1);
    w3 = a;
    w5 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w7 = a;
    w6 = a;
   G1835:
    a = w5;
    a = Ladd1(a);
    w5 = a;
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = w6;
    w8 = a;
    goto    G1842;
   G1836:
    q = car(w8);
    a = w5;
    a = remaind2(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G1838;
   G1842:
    a = cdr(w8);
    w8 = a;
    if(a == nil) goto    G1846;
    q = car(a);
    a = q;
    a = times2(a, q);
    q = a;
    a = w5;
    a = Lgeq(a, q);
    if(a != nil) goto    G1836;
   G1846:
    q = w5;
    a = w1;
    a = CC_partpower(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1838;
    q = w9;
    a = w5;
    a = Lexpt(a, q);
    q = a;
    a = w1;
    a = quot2(a, q);
    w1 = a;
    q = w2;
    a = w9;
    a = quot2(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1838;
    q = w9;
    a = w5;
    a = Lexpt(a, q);
    q = a;
    a = w3;
    a = times2(a, q);
    w3 = a;
   G1838:
    a = w5;
    a = Ladd1(a);
    q = w2;
    a = Lexpt(a, q);
    q = w1;
    a = Lleq(a, q);
    if(a != nil) goto    G1835;
    a = w3;
   G1833:
    popv(9);
    return a;
}

Sex CC_Wgid(Sex a)
{
    Sex q;
#define LL_Bgid LITERAL[35]
    q = LL_Bgid;
    {
        return  Lget(a, q);
    }
}

Sex CC_Wgcons(Sex a)
{
    Sex q;
#define LL_BctypeB LITERAL[36]
    q = LL_BctypeB;
    {
        return  Lget(a, q);
    }
}

Sex CC_constypeT(Sex a)
{
    Sex q;
    q = LL_BctypeB;
    {
        return  Lget(a, q);
    }
}

Sex CC_tagTtype(Sex a)
{
    a = car(a);
    return a;
}

Sex CC_tagTform(Sex a)
{
    Sex q;
    q = mkfxat(240);
    a = car(a);
    {
        return  Lilogand2(a, q);
    }
}

Sex CC_tagTexpr(Sex a)
{
    Sex q;
    q = mkfxat(3840);
    a = car(a);
    {
        return  Lilogand2(a, q);
    }
}

Sex CC_Wcanotag(Sex a)
{
    Sex q;
#define LL_CmaxcanoC LITERAL[37]
    q = value(LL_CmaxcanoC);
    {
        return  Lilessp(a, q);
    }
}

Sex CC_Wcanfortag(Sex a)
{
    Sex q;
#define LL_CmaxformC LITERAL[38]
    q = value(LL_CmaxformC);
    {
        return  Lilessp(a, q);
    }
}

Sex CC_Wformtag(Sex a)
{
    Sex q;
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    {
        return  Lnull(a);
    }
}

Sex CC_Wexprtag(Sex a)
{
    Sex q;
    q = mkfxat(3840);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    {
        return  Lnull(a);
    }
}

Sex CC_getTgorder(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(0);
    {
        return  Lgetv(a, q);
    }
}

Sex CC_getTgtypes(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    {
        return  Lgetv(a, q);
    }
}

Sex CC_getTsexpr(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    {
        return  Lgetv(a, q);
    }
}

Sex CC_getTgeval(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(3);
    {
        return  Lgetv(a, q);
    }
}

Sex CC_getTgcomp(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(4);
    {
        return  Lgetv(a, q);
    }
}

Sex CC_getTgsimp(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(5);
    {
        return  Lgetv(a, q);
    }
}

Sex CC_getTgprint(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(6);
    {
        return  Lgetv(a, q);
    }
}

Sex CC_getTgtype1(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    {
        return car(a);
    }
}

Sex CC_getTcompfn(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(4);
    a = Lgetv(a, q);
    a = cdr(a);
    q = a;
    a = w1;
    a = Latsoc(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G1915;
    a = cdr(a);
   G1915:
    popv(1);
    return a;
}

Sex CC_getTfncvars(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(4);
    a = Lgetv(a, q);
    a = cdr(a);
    q = a;
#define LL_fncvars LITERAL[39]
    a = LL_fncvars;
    a = Latsoc(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G1923;
    a = cdr(a);
   G1923:
    return a;
}

Sex CC_getTsimprs(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(5);
    a = Lgetv(a, q);
    a = cdr(a);
    q = a;
    a = w1;
    a = Latsoc(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G1931;
    a = cdr(a);
   G1931:
    popv(1);
    return a;
}

Sex CC_putTgorder(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    m = w1;
    q = mkfxat(0);
    {
        popv(1);
        return  Lputv(a, q, m);
    }
}

Sex CC_putTgtypes(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    m = w1;
    q = mkfxat(1);
    {
        popv(1);
        return  Lputv(a, q, m);
    }
}

Sex CC_putTsexpr(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    m = w1;
    q = mkfxat(2);
    {
        popv(1);
        return  Lputv(a, q, m);
    }
}

Sex CC_putTgprint(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    m = w1;
    q = mkfxat(6);
    {
        popv(1);
        return  Lputv(a, q, m);
    }
}

Sex CC_putTsavval(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(3);
    a = Lgetv(a, q);
    q = w1;
    {
        popv(1);
        cdr(a) = q;
 return a;
    }
}

Sex CC_putTcompfn(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(4);
    a = Lgetv(a, q);
    w4 = a;
   G1951:
    a = cdr(w4);
    if(a != nil) goto    G1954;
    q = w3;
    a = w2;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    goto    G1959;
   G1954:
    a = car(car(a));
    if(a == w2) goto    G1960;
    a = cdr(w4);
    w4 = a;
    goto    G1951;
   G1960:
    q = w3;
    a = car(cdr(w4));
   G1959:
    cdr(a) = q;
    a = nil;
    popv(4);
    return a;
}

Sex CC_putTsimprs(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(5);
    a = Lgetv(a, q);
    w4 = a;
   G1964:
    a = cdr(w4);
    if(a != nil) goto    G1967;
    q = w3;
    a = w2;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    goto    G1972;
   G1967:
    a = car(car(a));
    if(a == w2) goto    G1973;
    a = cdr(w4);
    w4 = a;
    goto    G1964;
   G1973:
    q = w3;
    a = car(cdr(w4));
   G1972:
    cdr(a) = q;
    a = cdr(w4);
    popv(4);
    return a;
}

Sex CC_putTordenv(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    if(is_cons(a)) goto    G1977;
    a = nil;
    goto    G1979;
   G1977:
    q = w1;
    a = cdr(car(a));
    car(a) = q;
   G1979:
    popv(1);
    return a;
}

Sex CC_putTsimpenv(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    if(is_cons(a)) goto    G1983;
    a = nil;
    goto    G1985;
   G1983:
    q = w1;
    a = cdr(car(a));
    cdr(a) = q;
   G1985:
    popv(1);
    return a;
}

Sex CC_setqTgexpr(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    m = nil;
    q = nil;
    a = w2;
    a = CC_convTgexpr2sexpr(a, q, m);
    q = a;
    a = w1;
    CC_putTsexpr(a, q);
    q = nil;
    a = w1;
    CC_putTsavval(a, q);
    a = w2;
    popv(2);
    return a;
}

Sex CC_addTidtype(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w3 = a;
    a = car(a);
    w4 = a;
    q = w3;
    a = w2;
    a = Lmemq(a, q);
    if(a != nil) goto    G2015;
    a = w2;
#define LL_uncom LITERAL[40]
    if(a == LL_uncom) goto    G1992;
#define LL_indxed LITERAL[41]
    if(a != LL_indxed) goto    G1997;
    q = LITERAL[42];
    a = w4;
    a = Lmemq(a, q);
    if(a == nil) goto    G1992;
    a = LITERAL[43];
    goto    G2017;
   G1997:
#define LL_dummy LITERAL[44]
    if(a != LL_dummy) goto    G2001;
    q = w3;
#define LL_var LITERAL[45]
    a = LL_var;
    a = Lmemq(a, q);
    if(a == nil) goto    G2003;
    q = LITERAL[46];
    a = w4;
    a = Lmemq(a, q);
    if(a == nil) goto    G1992;
    a = LITERAL[47];
    goto    G2017;
   G2003:
    q = w3;
#define LL_func LITERAL[48]
    a = LL_func;
    a = Lmemq(a, q);
    if(a != nil) goto    G1992;
    q = w3;
#define LL_symbol LITERAL[49]
    a = LL_symbol;
    a = Lmemq(a, q);
    if(a != nil) goto    G1992;
    a = LITERAL[47];
   G2017:
    w4 = a;
    goto    G2010;
   G2001:
    a = LITERAL[50];
    w4 = a;
    a = w2;
    w1 = a;
   G2010:
#define LL_decl LITERAL[51]
    q = LL_decl;
#define LL_Hrdstat LITERAL[52]
    a = value(LL_Hrdstat);
    a = Lneq(a, q);
    if(a == nil) goto    G2012;
    q = w1;
    a = w4;
    CC_errormsg(a, q);
    goto    G2013;
   G2012:
    q = car(w3);
    a = w4;
    CC_printmsg(a, q);
   G2013:
#define LL_fail LITERAL[53]
    a = LL_fail;
    goto    G1991;
   G1992:
    q = cdr(w3);
    a = w2;
    a = cons(a, q);
    q = car(w3);
    a = Lxcons(a, q);
    w3 = a;
    q = a;
    a = w1;
    CC_putTgtypes(a, q);
   G2015:
    a = w3;
   G1991:
    popv(4);
    return a;
}

Sex CC_convTgexpr2sexpr(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    if(!is_cons(a)) goto    G2022;
    w4 = nil;
    a = car(a);
    w4 = a;
    if(!is_integer(a)) goto    G2025;
    if(a >= value(LL_CmaxcanoC)) goto    G2027;
    a = q;
    if(a != nil) goto    G2042;
    a = w1;
    a = CC_idlistTcano(a);
    goto    G2052;
   G2027:
    if(a >= value(LL_CmaxformC)) goto    G2041;
#define LL_form LITERAL[54]
    a = LL_form;
    goto    G2052;
   G2025:
    if(!is_symbol(a)) goto    G2033;
    q = LL_BctypeB;
    a = Lget(a, q);
    w4 = a;
#define LL_rat LITERAL[55]
    if(a != LL_rat) goto    G2035;
    a = w2;
    if(a != nil) goto    G2042;
    a = w1;
    a = CC_idlistTpref(a);
    goto    G2052;
   G2035:
    if(a == nil) goto    G2041;
    goto    G2052;
   G2033:
    if(!is_vector(a)) goto    G2041;
#define LL_array LITERAL[56]
    a = LL_array;
   G2052:
    w2 = a;
    goto    G2042;
   G2041:
    q = LITERAL[57];
    a = mkfxat(1);
    CC_errormsg(a, q);
   G2042:
    a = w3;
    if(a != nil) goto    G2044;
#define LL_CsimpenvC LITERAL[58]
    q = value(LL_CsimpenvC);
#define LL_CordenvC LITERAL[59]
    a = value(LL_CordenvC);
    a = cons(a, q);
#define LL_CevalenvC LITERAL[60]
    q = value(LL_CevalenvC);
    a = Lxcons(a, q);
    w3 = a;
   G2044:
    q = w1;
    a = w2;
    a = cons(a, q);
    q = w3;
    a = Lxcons(a, q);
   G2022:
    popv(4);
    return a;
}

Sex CC_convTsexpr2gexpr(Sex a)
{
    if(!is_cons(a)) goto    G2058;
    a = cdr(cdr(a));
   G2058:
    return a;
}

Sex CC_Wnum(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
#define LL_num LITERAL[61]
    a = LL_num;
    {
        return  Lmemq(a, q);
    }
}

Sex CC_Wvar(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
    a = LL_var;
    {
        return  Lmemq(a, q);
    }
}

Sex CC_Wfunc(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
    a = LL_func;
    {
        return  Lmemq(a, q);
    }
}

Sex CC_Wsymbol(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
    a = LL_symbol;
    {
        return  Lmemq(a, q);
    }
}

Sex CC_Wuncom(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
    a = LL_uncom;
    {
        return  Lmemq(a, q);
    }
}

Sex CC_Windexed(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
    a = LL_indxed;
    {
        return  Lmemq(a, q);
    }
}

Sex CC_Wdummy(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
    a = LL_dummy;
    {
        return  Lmemq(a, q);
    }
}

Sex CC_Wcvar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lidp(a);
    if(a != nil) goto    G2090;
    a = car(w1);
    w1 = a;
    a = Lidp(a);
   G2090:
    if(a == nil) goto    G2089;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G2089;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w1 = a;
    q = a;
    a = LL_var;
    a = Lmemq(a, q);
    if(a == nil) goto    G2089;
    q = w1;
    a = LL_uncom;
    a = Lmemq(a, q);
    a = Lnull(a);
   G2089:
    popv(1);
    return a;
}

Sex CC_Wncvar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lidp(a);
    if(a != nil) goto    G2098;
    a = car(w1);
    w1 = a;
    a = Lidp(a);
   G2098:
    if(a == nil) goto    G2097;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G2097;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w1 = a;
    q = a;
    a = LL_var;
    a = Lmemq(a, q);
    if(a == nil) goto    G2097;
    q = w1;
    a = LL_uncom;
    a = Lmemq(a, q);
   G2097:
    popv(1);
    return a;
}

Sex CC_Wcfunc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lidp(a);
    if(a != nil) goto    G2105;
    a = car(w1);
    w1 = a;
    a = Lidp(a);
   G2105:
    if(a == nil) goto    G2104;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G2104;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w1 = a;
    q = a;
    a = LL_func;
    a = Lmemq(a, q);
    if(a == nil) goto    G2104;
    q = w1;
    a = LL_uncom;
    a = Lmemq(a, q);
    a = Lnull(a);
   G2104:
    popv(1);
    return a;
}

Sex CC_Wncfunc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lidp(a);
    if(a != nil) goto    G2113;
    a = car(w1);
    w1 = a;
    a = Lidp(a);
   G2113:
    if(a == nil) goto    G2112;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G2112;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w1 = a;
    q = a;
    a = LL_func;
    a = Lmemq(a, q);
    if(a == nil) goto    G2112;
    q = w1;
    a = LL_uncom;
    a = Lmemq(a, q);
   G2112:
    popv(1);
    return a;
}

Sex CC_Wpfunc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lidp(a);
    if(a != nil) goto    G2120;
    a = car(w1);
    w1 = a;
    a = Lidp(a);
   G2120:
    if(a == nil) goto    G2119;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G2119;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
#define LL_pfunc LITERAL[62]
    a = LL_pfunc;
    a = Lmemq(a, q);
   G2119:
    popv(1);
    return a;
}

Sex CC_Wtfunc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = CC_Wid(a);
    if(a == nil) goto    G2126;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G2126;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
#define LL_tfunc LITERAL[63]
    a = LL_tfunc;
    a = Lmemq(a, q);
   G2126:
    popv(1);
    return a;
}

Sex CC_Wopvar(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lidp(a);
    if(a != nil) goto    G2132;
    a = car(w1);
    w1 = a;
    a = Lidp(a);
   G2132:
    if(a == nil) goto    G2131;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G2131;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
#define LL_oper LITERAL[64]
    a = LL_oper;
    a = Lmemq(a, q);
   G2131:
    popv(1);
    return a;
}

Sex CC_Wnil(Sex a)
{
    Sex q;
#define LL_Anil LITERAL[65]
    q = LL_Anil;
    {
        return  Leq(a, q);
    }
}

Sex CC_Wcano(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G2140;
    a = car(w1);
    a = Lfixp(a);
    if(a == nil) goto    G2140;
    q = value(LL_CmaxcanoC);
    a = car(w1);
    a = Lilessp(a, q);
   G2140:
    popv(1);
    return a;
}

Sex CC_Wpref(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G2143;
    q = LITERAL[66];
    a = car(w1);
    a = Lmemq(a, q);
   G2143:
    popv(1);
    return a;
}

Sex CC_Wform(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G2146;
    a = car(w1);
    a = Lfixp(a);
    if(a == nil) goto    G2146;
    q = mkfxat(240);
    a = car(w1);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    a = Lnull(a);
   G2146:
    popv(1);
    return a;
}

Sex CC_Warray(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2152;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2157;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = LL_array;
    {
        popv(1);
        return  Leq(a, q);
    }
   G2152:
    a = car(a);
    a = Lvectorp(a);
   G2157:
    popv(1);
    return a;
}

Sex CC_Wratexpr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2161;
    {
        popv(1);
        return  Lnumberp(a);
    }
   G2161:
    a = car(a);
    if(!is_integer(a)) goto    G2162;
    q = value(LL_CmaxcanoC);
    {
        popv(1);
        return  Lilessp(a, q);
    }
   G2162:
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2163;
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
    q = a;
    a = LL_rat;
    a = Leq(a, q);
   G2163:
    popv(1);
    return a;
}

Sex CC_Wrelexpr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2169;
    a = nil;
    goto    G2170;
   G2169:
    q = LL_Bgid;
    a = car(a);
    a = Lget(a, q);
    if(a == nil) goto    G2170;
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
    q = a;
#define LL_rel LITERAL[67]
    a = LL_rel;
    a = Leq(a, q);
   G2170:
    popv(1);
    return a;
}

Sex CC_Wsetexpr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = LL_Bgid;
    if(is_cons(a)) goto    G2176;
    a = Lget(a, q);
    if(a == nil) goto    G2181;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    goto    G2184;
   G2176:
    a = car(a);
    a = Lget(a, q);
    if(a == nil) goto    G2181;
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
   G2184:
    q = a;
#define LL_set LITERAL[68]
    a = LL_set;
    a = Leq(a, q);
   G2181:
    popv(1);
    return a;
}

Sex CC_Wlogexpr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = LL_Bgid;
    if(is_cons(a)) goto    G2188;
    a = Lget(a, q);
    if(a == nil) goto    G2193;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = LL_symbol;
    goto    G2196;
   G2188:
    a = car(a);
    a = Lget(a, q);
    if(a == nil) goto    G2193;
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
    q = a;
#define LL_log LITERAL[69]
    a = LL_log;
   G2196:
    a = Leq(a, q);
   G2193:
    popv(1);
    return a;
}

Sex CC_Wpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G2199;
    a = car(w1);
    a = Lfixp(a);
    if(a == nil) goto    G2199;
#define LL_CratfC LITERAL[70]
    q = value(LL_CratfC);
    a = car(w1);
    a = Lilessp(a, q);
   G2199:
    popv(1);
    return a;
}

Sex CC_Walgn(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2203;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2209;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
#define LL_algn LITERAL[71]
    a = LL_algn;
    goto    G2216;
   G2203:
    a = car(a);
    if(!is_integer(a)) goto    G2208;
#define LL_CalgnC LITERAL[72]
    q = value(LL_CalgnC);
    goto    G2216;
   G2208:
    w1 = a;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2209;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = LL_algn;
   G2216:
    a = Leq(a, q);
   G2209:
    popv(1);
    return a;
}

Sex CC_Wtran(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
   G2233:
    w1 = a;
    if(!is_cons(a)) goto    G2232;
    a = car(a);
    if(!is_integer(a)) goto    G2225;
    a = car(cdr(w1));
    goto    G2233;  /* recursive call to ?tran */
   G2225:
    w1 = a;
   G2232:
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2226;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
#define LL_tran LITERAL[73]
    a = LL_tran;
    a = Leq(a, q);
   G2226:
    popv(1);
    return a;
}

Sex CC_Wpoly(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2236;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2241;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = LITERAL[74];
    goto    G2246;
   G2236:
    a = car(a);
    if(!is_integer(a)) goto    G2240;
#define LL_CpolyC LITERAL[75]
    q = value(LL_CpolyC);
    {
        popv(1);
        return  Leq(a, q);
    }
   G2240:
    w1 = a;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2241;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = LITERAL[76];
   G2246:
    a = Lequal(a, q);
   G2241:
    popv(1);
    return a;
}

Sex CC_Walgf(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2250;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2256;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
#define LL_algf LITERAL[77]
    a = LL_algf;
    goto    G2263;
   G2250:
    a = car(a);
    if(!is_integer(a)) goto    G2255;
#define LL_CalgfC LITERAL[78]
    q = value(LL_CalgfC);
    goto    G2263;
   G2255:
    w1 = a;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2256;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = LL_algf;
   G2263:
    a = Leq(a, q);
   G2256:
    popv(1);
    return a;
}

Sex CC_Wratf(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G2266;
    q = value(LL_CratfC);
    a = car(w1);
    a = Lequal(a, q);
   G2266:
    popv(1);
    return a;
}

Sex CC_Wvect(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2270;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2276;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
#define LL_vect LITERAL[79]
    a = LL_vect;
    goto    G2283;
   G2270:
    a = car(a);
    if(!is_integer(a)) goto    G2275;
#define LL_CvectC LITERAL[80]
    q = value(LL_CvectC);
    goto    G2283;
   G2275:
    w1 = a;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2276;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = LL_vect;
   G2283:
    a = Leq(a, q);
   G2276:
    popv(1);
    return a;
}

Sex CC_Wmatx(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2287;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2293;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
#define LL_matx LITERAL[81]
    a = LL_matx;
    goto    G2300;
   G2287:
    a = car(a);
    if(!is_integer(a)) goto    G2292;
#define LL_CmatxC LITERAL[82]
    q = value(LL_CmatxC);
    goto    G2300;
   G2292:
    w1 = a;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2293;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = LL_matx;
   G2300:
    a = Leq(a, q);
   G2293:
    popv(1);
    return a;
}

Sex CC_Wtens(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2304;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2310;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
#define LL_tens LITERAL[83]
    a = LL_tens;
    goto    G2317;
   G2304:
    a = car(a);
    if(!is_integer(a)) goto    G2309;
#define LL_CtensC LITERAL[84]
    q = value(LL_CtensC);
    goto    G2317;
   G2309:
    w1 = a;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2310;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = LL_tens;
   G2317:
    a = Leq(a, q);
   G2310:
    popv(1);
    return a;
}

Sex CC_Woper(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G2321;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G2327;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = a;
    a = LL_oper;
    {
        popv(1);
        return  Leq(a, q);
    }
   G2321:
    a = car(a);
#define LL_opH LITERAL[85]
    if(a != LL_opH) goto    G2326;
    a = true;
    goto    G2327;
   G2326:
    a = CC_Woper(a);
   G2327:
    popv(1);
    return a;
}

Sex CC_Woset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G2330;
#define LL_Boset LITERAL[86]
    q = LL_Boset;
    a = car(w1);
    a = Leq(a, q);
   G2330:
    popv(1);
    return a;
}

Sex CC_Wset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G2333;
#define LL_Bset LITERAL[87]
    q = LL_Bset;
    a = car(w1);
    a = Leq(a, q);
   G2333:
    popv(1);
    return a;
}

Sex CC_Worder(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
   G2364:
    w1 = a;
    w2 = q;
    if(!is_cons(a)) goto    G2337;
    if(!is_cons(q)) goto    G2355;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G2340;
    q = cdr(w2);
    a = cdr(w1);
    goto    G2358;
   G2340:
    q = car(w2);
    a = car(w1);
   G2358:
    goto    G2364;  /* recursive call to ?order */
   G2337:
    if(!is_number(a)) goto    G2342;
    if(!is_number(q)) goto    G2344;
    {
        popv(2);
        return  CC_complgeqp(a, q);
    }
   G2344:
    a = q;
    if(a == nil) goto    G2355;
    goto    G2362;
   G2342:
    if(a == nil) goto    G2347;
    if(!is_symbol(q)) goto    G2349;
    a = q;
    if(a == nil) goto    G2355;
    a = w1;
    {
        popv(2);
        return  CC_WorderTid(a, q);
    }
   G2349:
    if(!is_cons(q)) goto    G2355;
    goto    G2362;
   G2347:
    a = q;
    if(a == nil) goto    G2355;
   G2362:
    a = nil;
    goto    G2356;
   G2355:
    a = true;
   G2356:
    popv(2);
    return a;
}

Sex CC_Wrevorder(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
    a = m;
    {
        return  CC_Worder(a, q);
    }
}

Sex CC_WorderTid(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(0);
    a = Lgetv(a, q);
    w1 = a;
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(0);
    a = Lgetv(a, q);
    q = a;
    a = w1;
    a = Lilessp(a, q);
    {
        popv(2);
        return  Lnull(a);
    }
}

Sex CC_WorderTvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a == q) goto    G2390;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G2377;
    if(!is_cons(q)) goto    G2389;
    q = a;
    a = car(w2);
    a = CC_WorderTid(a, q);
    if(a == nil) goto    G2390;
    a = nil;
    goto    G2387;
   G2377:
    if(is_cons(q)) goto    G2382;
    a = car(a);
    a = CC_WorderTid(a, q);
    if(a == nil) goto    G2387;
   G2390:
    a = true;
    goto    G2387;
   G2382:
    a = car(a);
    if(a != car(q)) goto    G2386;
    q = cdr(q);
    a = cdr(w1);
    {
        popv(2);
        return  CC_Worder(a, q);
    }
   G2386:
    q = car(q);
   G2389:
    a = CC_WorderTid(a, q);
   G2387:
    popv(2);
    return a;
}

Sex CC_orderRMS(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
   G2437:
    w1 = a;
    w2 = q;
    if(!is_cons(a)) goto    G2394;
    if(!is_cons(q)) goto    G2422;
    q = car(q);
    a = car(a);
    a = CC_orderRMS(a, q);
    value(LL_Htemporal) = a;
    if(a != CHAR_OF(61)) goto    G2425;
    q = cdr(w2);
    a = cdr(w1);
    goto    G2437;  /* recursive call to order<=> */
   G2394:
    if(!is_number(a)) goto    G2401;
    if(!is_number(q)) goto    G2403;
    a = Leqn(a, q);
    if(a != nil) goto    G2424;
    q = w2;
    a = w1;
    a = CC_complgeqp(a, q);
    if(a == nil) goto    G2436;
    goto    G2422;
   G2403:
    a = q;
    if(a == nil) goto    G2422;
    goto    G2436;
   G2401:
    if(a == nil) goto    G2410;
    if(!is_symbol(q)) goto    G2412;
    a = q;
    if(a == nil) goto    G2422;
    if(a == w1) goto    G2424;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(0);
    a = Lgetv(a, q);
    w3 = a;
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(0);
    a = Lgetv(a, q);
    q = a;
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2436;
    goto    G2422;
   G2412:
    if(is_cons(q)) goto    G2436;
   G2422:
    a = CHAR_OF(62);
    goto    G2425;
   G2410:
    a = q;
    if(a == nil) goto    G2424;
   G2436:
    a = CHAR_OF(60);
    goto    G2425;
   G2424:
    a = CHAR_OF(61);
   G2425:
    popv(3);
    return a;
}

Sex CC_internTid(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G2509;
    a = Lexplode(a);
    w6 = a;
    a = car(a);
    if(a != CHAR_OF(33)) goto    G2450;
    a = cdr(w6);
    w6 = a;
   G2450:
    a = w2;
    if(a != nil) goto    G2455;
    a = car(w6);
    if(a != CHAR_OF(35)) goto    G2454;
    a = LL_tran;
    goto    G2455;
   G2454:
#define LL_Hdfaultyp LITERAL[88]
    a = value(LL_Hdfaultyp);
   G2455:
#define LL_BgtypeB LITERAL[89]
    q = LL_BgtypeB;
    a = Lget(a, q);
    w2 = a;
    a = car(w6);
    if(a == CHAR_OF(64)) goto    G2442;
    if(a == CHAR_OF(35)) goto    G2441;
   G2459:
    q = w2;
    a = LL_var;
    a = Lmemq(a, q);
    if(a == nil) goto    G2461;
    q = LL_algf;
    a = car(w2);
    a = Lneq(a, q);
    if(a == nil) goto    G2463;
#define LL_CordKvar LITERAL[90]
    a = value(LL_CordKvar);
    a = Lsub1(a);
    value(LL_CordKvar) = a;
    goto    G2506;
   G2463:
    a = value(LL_Hrdstat);
    if(a != LL_decl) goto    G2473;
#define LL_CordLalf LITERAL[91]
    a = value(LL_CordLalf);
    a = Ladd1(a);
    value(LL_CordLalf) = a;
    goto    G2506;
   G2461:
    q = w2;
    a = LL_func;
    a = Lmemq(a, q);
    if(a == nil) goto    G2466;
    a = car(w2);
    if(a != LL_pfunc) goto    G2468;
#define LL_CordKpfn LITERAL[92]
    a = value(LL_CordKpfn);
    a = Lsub1(a);
    value(LL_CordKpfn) = a;
    goto    G2506;
   G2468:
#define LL_CordKfun LITERAL[93]
    a = value(LL_CordKfun);
    a = Lsub1(a);
    value(LL_CordKfun) = a;
    goto    G2506;
   G2466:
    q = w2;
    a = LL_num;
    a = Lmemq(a, q);
    if(a == nil) goto    G2470;
    a = car(w2);
    if(a != LL_tran) goto    G2472;
#define LL_CordKtrn LITERAL[94]
    a = value(LL_CordKtrn);
    a = Lsub1(a);
    value(LL_CordKtrn) = a;
    goto    G2506;
   G2472:
    a = value(LL_Hrdstat);
    if(a != LL_decl) goto    G2473;
#define LL_CordLaln LITERAL[95]
    a = value(LL_CordLaln);
    a = Ladd1(a);
    value(LL_CordLaln) = a;
    goto    G2506;
   G2473:
    q = LITERAL[96];
    a = mkfxat(1);
    goto    G2504;
   G2470:
    a = value(LL_CordKvar);
    a = Lsub1(a);
    value(LL_CordKvar) = a;
    goto    G2506;
   G2509:
    a = LL_dummy;
    a = Lmemq(a, q);
    if(a != nil) goto    G2442;
    q = w2;
    a = LL_num;
    a = Lmemq(a, q);
    if(a == nil) goto    G2459;
   G2441:
    q = w2;
    a = LL_tran;
    a = Lmemq(a, q);
    if(a == nil) goto    G2477;
    a = value(LL_CordKtrn);
    a = Lsub1(a);
    value(LL_CordKtrn) = a;
    goto    G2506;
   G2477:
    q = w2;
    a = LL_algn;
    a = Lmemq(a, q);
    if(a == nil) goto    G2478;
    a = value(LL_Hrdstat);
    if(a != LL_decl) goto    G2478;
    a = value(LL_CordLaln);
    a = Ladd1(a);
    value(LL_CordLaln) = a;
   G2506:
    w3 = a;
    goto    G2443;
   G2478:
    q = w1;
    a = LITERAL[97];
   G2504:
    CC_errormsg(a, q);
    goto    G2443;
   G2442:
    q = w2;
    a = LL_var;
    a = Lmemq(a, q);
    if(a == nil) goto    G2482;
    a = value(LL_CordKvar);
    a = Lsub1(a);
    value(LL_CordKvar) = a;
    goto    G2508;
   G2482:
    q = w2;
    a = LL_func;
    a = Lmemq(a, q);
    if(a == nil) goto    G2483;
    a = value(LL_CordKfun);
    a = Lsub1(a);
    value(LL_CordKfun) = a;
    goto    G2508;
   G2483:
    a = value(LL_CordKtrn);
    a = Lsub1(a);
    value(LL_CordKtrn) = a;
   G2508:
    w3 = a;
    q = cdr(w2);
    a = LL_dummy;
    a = cons(a, q);
    q = car(w2);
    a = Lxcons(a, q);
    w2 = a;
   G2443:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G2487;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(5);
    a = Lgetv(a, q);
    goto    G2489;
   G2487:
    a = Lncons(a);
   G2489:
    w6 = a;
#define LL_Blocgid LITERAL[98]
    q = LL_Blocgid;
    a = w1;
    a = Lget(a, q);
    if(a != nil) goto    G2491;
    a = w1;
    Lintern(a);
   G2491:
    a = mkfxat(6);
    a = Lmkvect(a);
    w4 = a;
    m = w3;
    q = mkfxat(0);
    Lputv(a, q, m);
    a = w2;
    a = Lcopy(a);
    m = a;
    q = mkfxat(1);
    a = w4;
    Lputv(a, q, m);
    m = nil;
    q = mkfxat(2);
    a = w4;
    Lputv(a, q, m);
    a = nil;
    a = Lncons(a);
    m = a;
    q = mkfxat(3);
    a = w4;
    Lputv(a, q, m);
    a = nil;
    a = Lncons(a);
    m = a;
    q = mkfxat(4);
    a = w4;
    Lputv(a, q, m);
    m = w6;
    q = mkfxat(5);
    a = w4;
    Lputv(a, q, m);
    q = true;
    a = w1;
    a = CC_delQprefs(a, q);
    w6 = a;
    a = Lcompress(a);
    w5 = a;
    a = w6;
    a = Llength(a);
    q = w5;
    a = Lxcons(a, q);
    m = a;
    q = mkfxat(6);
    a = w4;
    Lputv(a, q, m);
    m = w4;
    q = LL_Bgid;
    a = w1;
    Lput(a, q, m);
    a = w1;
    popv(6);
    return a;
}

Sex CC_internTnid(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    a = Lexplode(a);
#define LL_RblankS LITERAL[99]
    q = value(LL_RblankS);
    a = Lxcons(a, q);
    a = Lmake_id(a);
    w1 = a;
    q = w2;
    CC_internTid(a, q);
    a = w1;
    popv(2);
    return a;
}

Sex CC_internTcons(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    q = LITERAL[100];
    a = w2;
    a = Lmemq(a, q);
    if(a != nil) goto    G2517;
    q = w2;
    a = LITERAL[101];
    CC_errormsg(a, q);
   G2517:
    q = LL_BctypeB;
    a = w1;
    a = Lget(a, q);
    if(a != nil) goto    G2519;
    m = w2;
    q = LL_BctypeB;
    a = w1;
    Lput(a, q, m);
    goto    G2520;
   G2519:
    q = w1;
    a = LITERAL[102];
    CC_errormsg(a, q);
   G2520:
    a = w3;
    if(a == nil) goto    G2522;
    m = a;
#define LL_Bgproc LITERAL[103]
    q = LL_Bgproc;
    a = w1;
    Lput(a, q, m);
   G2522:
    a = w1;
    Lintern(a);
    a = mkfxat(1);
    a = Lmkvect(a);
    m = a;
    q = LL_Bgid;
    a = w1;
    Lput(a, q, m);
#define LL_CordKcns LITERAL[104]
    a = value(LL_CordKcns);
    a = Lsub1(a);
    value(LL_CordKcns) = a;
    q = a;
    a = w1;
    CC_putTgorder(a, q);
    q = LL_BgtypeB;
#define LL_cons LITERAL[105]
    a = LL_cons;
    a = Lget(a, q);
    q = a;
    a = w1;
    CC_putTgtypes(a, q);
    a = w1;
    popv(3);
    return a;
}



/* initialization procedure */
int init_bsatom(void)
{
   long i;

   create_symbols(bsatom_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; bsatom_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(bsatom_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4, arg5;
        a = LITERAL[106];
        CC_Aenter(a);
        a = LITERAL[107];
        Lglobal(a);
        a = LITERAL[108];
        Lglobal(a);
        a = LITERAL[109];
        Lglobal(a);
        a = LITERAL[110];
        Lglobal(a);
        a = LITERAL[111];
        Lglobal(a);
        a = LITERAL[112];
        Lglobal(a);
        a = LITERAL[113];
        Lglobal(a);
        a = LITERAL[114];
        Lglobal(a);
        a = LITERAL[115];
        Lglobal(a);
        a = LITERAL[116];
        Lglobal(a);
        a = LITERAL[117];
        Lglobal(a);
        a = LITERAL[118];
        Lglobal(a);
        a = LITERAL[119];
        Lglobal(a);
        a = LITERAL[120];
        Lglobal(a);
#define LL_Bordhistory LITERAL[121]
        value(LL_Bordhistory) = nil;
        a = mkfxat(0);
#define LL_CordenvLC LITERAL[122]
        value(LL_CordenvLC) = a;
        value(LL_CordenvC) = a;
        value(LL_CevalenvC) = a;
        value(LL_CsimpenvC) = a;
        value(LL_Hmod) = nil;
        value(LL_Hfloat) = nil;
#define LL_Hpowser LITERAL[123]
        value(LL_Hpowser) = nil;
        value(LL_HHmod) = nil;
        value(LL_HHflo) = nil;
#define LL_Hexctdiv LITERAL[124]
        value(LL_Hexctdiv) = nil;
        value(LL_Hfcut) = nil;
        a = LITERAL[125];
#define LL_Hmachineps LITERAL[126]
        value(LL_Hmachineps) = a;
        a = LITERAL[127];
        value(LL_Hmeps100) = a;
        a = mkfxat(374941);
#define LL_Hrandom LITERAL[128]
        value(LL_Hrandom) = a;
#define LL_Hrndmsave LITERAL[129]
        value(LL_Hrndmsave) = nil;
        value(LL_Hnoargchk) = nil;
        a = LL_var;
        value(LL_Hdfaultyp) = a;
        value(LL_Hrdstat) = nil;
#define LL_Hsubstype LITERAL[130]
        value(LL_Hsubstype) = nil;
#define LL_Hchkcoef LITERAL[131]
        value(LL_Hchkcoef) = nil;
#define LL_Hbyproduct LITERAL[132]
        value(LL_Hbyproduct) = nil;
#define LL_Hquotient LITERAL[133]
        value(LL_Hquotient) = nil;
#define LL_Hremainder LITERAL[134]
        value(LL_Hremainder) = nil;
#define LL_Hrules LITERAL[135]
        value(LL_Hrules) = nil;
#define LL_Bopnrules LITERAL[136]
        value(LL_Bopnrules) = nil;
        a = mkfxat(100);
#define LL_Crewrite LITERAL[137]
        value(LL_Crewrite) = a;
        value(LL_Hsave) = nil;
#define LL_eval LITERAL[138]
        a = LL_eval;
#define LL_Hevalmode LITERAL[139]
        value(LL_Hevalmode) = a;
#define LL_comp LITERAL[140]
        a = LL_comp;
        value(LL_Hcompmode) = a;
#define LL_simp LITERAL[141]
        a = LL_simp;
#define LL_Hsimpmode LITERAL[142]
        value(LL_Hsimpmode) = a;
#define LL_flat LITERAL[143]
        a = LL_flat;
#define LL_Hprinmode LITERAL[144]
        value(LL_Hprinmode) = a;
        a = LL_untrac;
        value(LL_Htracmode) = a;
#define LL_col LITERAL[145]
        a = LL_col;
#define LL_Hcolmode LITERAL[146]
        value(LL_Hcolmode) = a;
#define LL_exp LITERAL[147]
        a = LL_exp;
#define LL_Hexpmode LITERAL[148]
        value(LL_Hexpmode) = a;
#define LL_div LITERAL[149]
        a = LL_div;
#define LL_Hdivmode LITERAL[150]
        value(LL_Hdivmode) = a;
#define LL_Hnumcomp LITERAL[151]
        value(LL_Hnumcomp) = nil;
#define LL_Hfuncomp LITERAL[152]
        value(LL_Hfuncomp) = nil;
        a = true;
#define LL_Hintexp LITERAL[153]
        value(LL_Hintexp) = a;
#define LL_Hfracpow LITERAL[154]
        value(LL_Hfracpow) = nil;
#define LL_Hsimpratf LITERAL[155]
        value(LL_Hsimpratf) = nil;
#define LL_Hsindex LITERAL[156]
        value(LL_Hsindex) = a;
        a = LITERAL[157];
        value(LL_CpiC) = a;
        a = LITERAL[158];
#define LL_Hprimes LITERAL[159]
        value(LL_Hprimes) = a;
        q = mkfxat(168);
        a = CC_ncdr(a, q);
#define LL_Hmedprimes LITERAL[160]
        value(LL_Hmedprimes) = a;
        a = LITERAL[161];
#define LL_Hbigprimes LITERAL[162]
        value(LL_Hbigprimes) = a;
        m = LITERAL[163];
        q = mkfxat(4);
#define LL_arrayTmsg LITERAL[164]
        a = value(LL_arrayTmsg);
        Lputv(a, q, m);
        m = LITERAL[165];
        q = mkfxat(5);
        a = value(LL_arrayTmsg);
        Lputv(a, q, m);
        m = LITERAL[166];
        q = mkfxat(6);
        a = value(LL_arrayTmsg);
        Lputv(a, q, m);
        m = LITERAL[167];
        q = mkfxat(7);
        a = value(LL_arrayTmsg);
        Lputv(a, q, m);
        m = LITERAL[168];
        q = mkfxat(8);
        a = value(LL_arrayTmsg);
        Lputv(a, q, m);
        m = LITERAL[169];
        q = mkfxat(9);
        a = value(LL_arrayTmsg);
        Lputv(a, q, m);
        m = LITERAL[170];
        q = mkfxat(10);
        a = value(LL_arrayTmsg);
        Lputv(a, q, m);
        m = LITERAL[171];
#define LL_smacro LITERAL[172]
        q = LL_smacro;
#define LL_listpair LITERAL[173]
        a = LL_listpair;
        Lput(a, q, m);
        m = LITERAL[174];
        q = LL_smacro;
#define LL_mod1 LITERAL[175]
        a = LL_mod1;
        Lput(a, q, m);
        m = LITERAL[176];
        q = LL_smacro;
#define LL_gcdTintint LITERAL[177]
        a = LL_gcdTintint;
        Lput(a, q, m);
        m = LITERAL[178];
        q = LL_smacro;
#define LL_lcmTintint LITERAL[179]
        a = LL_lcmTintint;
        Lput(a, q, m);
        m = LITERAL[180];
        q = LL_smacro;
#define LL_Wgid LITERAL[181]
        a = LL_Wgid;
        Lput(a, q, m);
        m = LITERAL[182];
        q = LL_smacro;
#define LL_Wgcons LITERAL[183]
        a = LL_Wgcons;
        Lput(a, q, m);
        m = LITERAL[182];
        q = LL_smacro;
#define LL_constypeT LITERAL[184]
        a = LL_constypeT;
        Lput(a, q, m);
        a = LITERAL[185];
        Lglobal(a);
        a = mkfxat(1);
        value(LL_CalgnC) = a;
        a = mkfxat(2);
        value(LL_CpolyC) = a;
        a = mkfxat(3);
        value(LL_CalgfC) = a;
        a = mkfxat(4);
        value(LL_CratfC) = a;
        a = mkfxat(10);
        value(LL_CmaxcanoC) = a;
        q = mkfxat(16);
        a = mkfxat(1);
        a = times2(a, q);
        value(LL_CvectC) = a;
        q = mkfxat(16);
        a = mkfxat(2);
        a = times2(a, q);
        value(LL_CmatxC) = a;
        q = mkfxat(16);
        a = mkfxat(3);
        a = times2(a, q);
        value(LL_CtensC) = a;
        a = mkfxat(100);
        value(LL_CmaxformC) = a;
        q = mkfxat(256);
        a = mkfxat(1);
        a = times2(a, q);
#define LL_CrelexprC LITERAL[186]
        value(LL_CrelexprC) = a;
        q = mkfxat(256);
        a = mkfxat(2);
        a = times2(a, q);
#define LL_CsetexprC LITERAL[187]
        value(LL_CsetexprC) = a;
        q = mkfxat(256);
        a = mkfxat(3);
        a = times2(a, q);
#define LL_ClogexprC LITERAL[188]
        value(LL_ClogexprC) = a;
#define LL_constant LITERAL[189]
        q = LL_constant;
        a = LITERAL[185];
        Lflag(a, q);
        m = LITERAL[190];
        q = LL_smacro;
#define LL_tagTtype LITERAL[191]
        a = LL_tagTtype;
        Lput(a, q, m);
        m = LITERAL[192];
        q = LL_smacro;
#define LL_tagTform LITERAL[193]
        a = LL_tagTform;
        Lput(a, q, m);
        m = LITERAL[194];
        q = LL_smacro;
#define LL_tagTexpr LITERAL[195]
        a = LL_tagTexpr;
        Lput(a, q, m);
        m = LITERAL[196];
        q = LL_smacro;
#define LL_Wcanotag LITERAL[197]
        a = LL_Wcanotag;
        Lput(a, q, m);
        m = LITERAL[198];
        q = LL_smacro;
#define LL_Wcanfortag LITERAL[199]
        a = LL_Wcanfortag;
        Lput(a, q, m);
        m = LITERAL[200];
        q = LL_smacro;
#define LL_Wformtag LITERAL[201]
        a = LL_Wformtag;
        Lput(a, q, m);
        m = LITERAL[202];
        q = LL_smacro;
#define LL_Wexprtag LITERAL[203]
        a = LL_Wexprtag;
        Lput(a, q, m);
        m = LITERAL[204];
        q = LL_smacro;
#define LL_getTgorder LITERAL[205]
        a = LL_getTgorder;
        Lput(a, q, m);
        m = LITERAL[206];
        q = LL_smacro;
#define LL_getTgtypes LITERAL[207]
        a = LL_getTgtypes;
        Lput(a, q, m);
        m = LITERAL[208];
        q = LL_smacro;
#define LL_getTsexpr LITERAL[209]
        a = LL_getTsexpr;
        Lput(a, q, m);
        m = LITERAL[210];
        q = LL_smacro;
#define LL_getTgeval LITERAL[211]
        a = LL_getTgeval;
        Lput(a, q, m);
        m = LITERAL[212];
        q = LL_smacro;
#define LL_getTgcomp LITERAL[213]
        a = LL_getTgcomp;
        Lput(a, q, m);
        m = LITERAL[214];
        q = LL_smacro;
#define LL_getTgsimp LITERAL[215]
        a = LL_getTgsimp;
        Lput(a, q, m);
        m = LITERAL[216];
        q = LL_smacro;
#define LL_getTgprint LITERAL[217]
        a = LL_getTgprint;
        Lput(a, q, m);
        m = LITERAL[218];
        q = LL_smacro;
#define LL_getTgtype1 LITERAL[219]
        a = LL_getTgtype1;
        Lput(a, q, m);
        m = LL_uncom;
        q = LL_BgtypeB;
        a = LL_uncom;
        Lput(a, q, m);
        m = LL_uncom;
        q = LL_BgtypeB;
#define LL_uncomm LITERAL[220]
        a = LL_uncomm;
        Lput(a, q, m);
        m = LL_uncom;
        q = LL_BgtypeB;
#define LL_noncom LITERAL[221]
        a = LL_noncom;
        Lput(a, q, m);
        m = LL_uncom;
        q = LL_BgtypeB;
#define LL_noncomm LITERAL[222]
        a = LL_noncomm;
        Lput(a, q, m);
        m = LL_indxed;
        q = LL_BgtypeB;
        a = LL_indxed;
        Lput(a, q, m);
        m = LL_indxed;
        q = LL_BgtypeB;
#define LL_indexed LITERAL[223]
        a = LL_indexed;
        Lput(a, q, m);
        m = LL_dummy;
        q = LL_BgtypeB;
        a = LL_dummy;
        Lput(a, q, m);
        a = LL_cons;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
        a = LL_cons;
        Lput(a, q, m);
        a = LL_num;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
        a = LL_num;
        Lput(a, q, m);
        a = LL_num;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_numb LITERAL[224]
        a = LL_numb;
        Lput(a, q, m);
        a = LL_num;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_number LITERAL[225]
        a = LL_number;
        Lput(a, q, m);
        a = LL_var;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
        a = LL_var;
        Lput(a, q, m);
        a = LL_var;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_variable LITERAL[226]
        a = LL_variable;
        Lput(a, q, m);
        a = LL_func;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
        a = LL_func;
        Lput(a, q, m);
        a = LL_func;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_function LITERAL[227]
        a = LL_function;
        Lput(a, q, m);
        q = LL_func;
        a = LL_tfunc;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
        a = LL_tfunc;
        Lput(a, q, m);
        q = LL_func;
        a = LL_tfunc;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_tfunction LITERAL[228]
        a = LL_tfunction;
        Lput(a, q, m);
        a = LL_symbol;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_symb LITERAL[229]
        a = LL_symb;
        Lput(a, q, m);
        a = LL_symbol;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
        a = LL_symbol;
        Lput(a, q, m);
        a = LL_array;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
        a = LL_array;
        Lput(a, q, m);
        q = LL_num;
        a = LL_algn;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
        a = LL_algn;
        Lput(a, q, m);
        q = LL_num;
        a = LL_algn;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_algnum LITERAL[230]
        a = LL_algnum;
        Lput(a, q, m);
        q = LL_num;
        a = LL_tran;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
        a = LL_tran;
        Lput(a, q, m);
        q = LL_num;
        a = LL_tran;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_tranum LITERAL[231]
        a = LL_tranum;
        Lput(a, q, m);
        q = LL_num;
        a = LL_tran;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_trannum LITERAL[232]
        a = LL_trannum;
        Lput(a, q, m);
        a = LL_var;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_poly LITERAL[233]
        a = LL_poly;
        Lput(a, q, m);
        a = LL_var;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_polynom LITERAL[234]
        a = LL_polynom;
        Lput(a, q, m);
        q = LL_var;
        a = LL_algf;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
        a = LL_algf;
        Lput(a, q, m);
        q = LL_var;
        a = LL_algf;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_algfunc LITERAL[235]
        a = LL_algfunc;
        Lput(a, q, m);
        a = LL_var;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_ratf LITERAL[236]
        a = LL_ratf;
        Lput(a, q, m);
        a = LL_var;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_ratfunc LITERAL[237]
        a = LL_ratfunc;
        Lput(a, q, m);
        m = LL_var;
        q = LL_uncom;
        a = LL_vect;
        a = Llist3(a, q, m);
        m = a;
        q = LL_BgtypeB;
        a = LL_vect;
        Lput(a, q, m);
        m = LL_var;
        q = LL_uncom;
        a = LL_vect;
        a = Llist3(a, q, m);
        m = a;
        q = LL_BgtypeB;
#define LL_vector LITERAL[238]
        a = LL_vector;
        Lput(a, q, m);
        m = LL_var;
        q = LL_uncom;
        a = LL_matx;
        a = Llist3(a, q, m);
        m = a;
        q = LL_BgtypeB;
        a = LL_matx;
        Lput(a, q, m);
        m = LL_var;
        q = LL_uncom;
        a = LL_matx;
        a = Llist3(a, q, m);
        m = a;
        q = LL_BgtypeB;
#define LL_matrix LITERAL[239]
        a = LL_matrix;
        Lput(a, q, m);
        m = LL_var;
        q = LL_uncom;
        a = LL_tens;
        a = Llist3(a, q, m);
        m = a;
        q = LL_BgtypeB;
        a = LL_tens;
        Lput(a, q, m);
        m = LL_var;
        q = LL_uncom;
        a = LL_tens;
        a = Llist3(a, q, m);
        m = a;
        q = LL_BgtypeB;
#define LL_tensor LITERAL[240]
        a = LL_tensor;
        Lput(a, q, m);
        m = LL_var;
        q = LL_uncom;
        a = LL_oper;
        a = Llist3(a, q, m);
        m = a;
        q = LL_BgtypeB;
        a = LL_oper;
        Lput(a, q, m);
        m = LL_var;
        q = LL_uncom;
        a = LL_oper;
        a = Llist3(a, q, m);
        m = a;
        q = LL_BgtypeB;
#define LL_operator LITERAL[241]
        a = LL_operator;
        Lput(a, q, m);
        q = LL_func;
        a = LL_pfunc;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
        a = LL_pfunc;
        Lput(a, q, m);
        q = LL_func;
        a = LL_pfunc;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_pfunction LITERAL[242]
        a = LL_pfunction;
        Lput(a, q, m);
        q = LL_symbol;
        a = LL_set;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
        a = LL_set;
        Lput(a, q, m);
        q = LL_symbol;
#define LL_oset LITERAL[243]
        a = LL_oset;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
        a = LL_oset;
        Lput(a, q, m);
        q = LL_symbol;
        a = LL_oset;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_ordset LITERAL[244]
        a = LL_ordset;
        Lput(a, q, m);
        a = LL_var;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_cvar LITERAL[245]
        a = LL_cvar;
        Lput(a, q, m);
        a = LL_func;
        a = Lncons(a);
        m = a;
        q = LL_BgtypeB;
#define LL_cfunc LITERAL[246]
        a = LL_cfunc;
        Lput(a, q, m);
        q = LL_uncom;
        a = LL_var;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_ucvar LITERAL[247]
        a = LL_ucvar;
        Lput(a, q, m);
        q = LL_uncom;
        a = LL_var;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_ncvar LITERAL[248]
        a = LL_ncvar;
        Lput(a, q, m);
        q = LL_uncom;
        a = LL_func;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_ucfunc LITERAL[249]
        a = LL_ucfunc;
        Lput(a, q, m);
        q = LL_uncom;
        a = LL_func;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_ncfunc LITERAL[250]
        a = LL_ncfunc;
        Lput(a, q, m);
        q = LL_indxed;
        a = LL_var;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_indvar LITERAL[251]
        a = LL_indvar;
        Lput(a, q, m);
        q = LL_indxed;
        a = LL_var;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_indxvar LITERAL[252]
        a = LL_indxvar;
        Lput(a, q, m);
        q = LL_indxed;
        a = LL_func;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_indfunc LITERAL[253]
        a = LL_indfunc;
        Lput(a, q, m);
        q = LL_indxed;
        a = LL_func;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_indxfunc LITERAL[254]
        a = LL_indxfunc;
        Lput(a, q, m);
        q = LL_indxed;
        a = LL_symbol;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_indsymb LITERAL[255]
        a = LL_indsymb;
        Lput(a, q, m);
        q = LL_indxed;
        a = LL_symbol;
        a = Llist2(a, q);
        m = a;
        q = LL_BgtypeB;
#define LL_indxsymb LITERAL[256]
        a = LL_indxsymb;
        Lput(a, q, m);
        a = LITERAL[257];
        Lglobal(a);
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(8);
        a = times2(a, q);
        q = mkfxat(-1);
        a = plus2(a, q);
        value(LL_CordKcns) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(7);
        a = times2(a, q);
#define LL_CordLpfn LITERAL[258]
        value(LL_CordLpfn) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(7);
        a = times2(a, q);
        value(LL_CordKpfn) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(6);
        a = times2(a, q);
#define LL_CordLfun LITERAL[259]
        value(LL_CordLfun) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(6);
        a = times2(a, q);
        value(LL_CordKfun) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(4);
        a = times2(a, q);
        value(LL_CordLalf) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(3);
        a = times2(a, q);
#define LL_CordLvar LITERAL[260]
        value(LL_CordLvar) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(3);
        a = times2(a, q);
        value(LL_CordKvar) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(1);
        a = times2(a, q);
#define LL_CordLtrn LITERAL[261]
        value(LL_CordLtrn) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(1);
        a = times2(a, q);
        value(LL_CordKtrn) = a;
        q = mkfxat(21);
        a = mkfxat(2);
        a = Lexpt(a, q);
        q = a;
        a = mkfxat(0);
        a = times2(a, q);
        value(LL_CordLaln) = a;
        q = mkfxat(1);
        a = CHAR_OF(39);
        a = cons(a, q);
#define LL_prefix LITERAL[262]
        q = LL_prefix;
        a = Lxcons(a, q);
        a = Lncons(a);
#define LL_Qgaltoken LITERAL[263]
        value(LL_Qgaltoken) = a;
        q = car(a);
        a = nil;
        a = cons(a, q);
        q = a;
        a = CHAR_OF(39);
        a = Llist2(a, q);
        m = a;
#define LL_Bgtoken LITERAL[264]
        q = LL_Bgtoken;
#define LL_RprimeS LITERAL[265]
        a = value(LL_RprimeS);
        Lput(a, q, m);
        arg5 = CHAR_OF(39);
        arg4 = CHAR_OF(58);
#define LL_postfix LITERAL[266]
        m = LL_postfix;
        q = LITERAL[267];
#define LL_gal LITERAL[268]
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = CHAR_OF(58);
#define LL_RR LITERAL[269]
        arg4 = LL_RR;
        m = LL_prefix;
        q = LITERAL[270];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_RR;
#define LL_SS LITERAL[271]
        arg4 = LL_SS;
        m = LL_postfix;
        q = LITERAL[272];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_SS;
#define LL_gB LITERAL[273]
        arg4 = LL_gB;
        m = LL_postfix;
        q = LITERAL[274];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gB;
#define LL_gBB LITERAL[275]
        arg4 = LL_gBB;
        m = LL_postfix;
        q = LITERAL[276];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gBB;
#define LL_gHH LITERAL[277]
        arg4 = LL_gHH;
#define LL_binary LITERAL[278]
        m = LL_binary;
        q = LITERAL[279];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gHH;
        arg4 = LL_gHH;
        m = LL_binary;
        q = LITERAL[280];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gHH;
#define LL_gQ LITERAL[281]
        arg4 = LL_gQ;
        m = LL_binary;
        q = LITERAL[282];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gQ;
#define LL_gSR LITERAL[283]
        arg4 = LL_gSR;
        m = LL_binary;
        q = LITERAL[284];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gSR;
#define LL_gH LITERAL[285]
        arg4 = LL_gH;
#define LL_nary LITERAL[286]
        m = LL_nary;
        q = LITERAL[287];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gH;
#define LL_gV LITERAL[288]
        arg4 = LL_gV;
        m = LL_binary;
        q = LITERAL[289];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gV;
#define LL_gVV LITERAL[290]
        arg4 = LL_gVV;
        m = LL_binary;
        q = LITERAL[291];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gVV;
#define LL_gVL LITERAL[292]
        arg4 = LL_gVL;
        m = LL_binary;
        q = LITERAL[293];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gVL;
#define LL_gL LITERAL[294]
        arg4 = LL_gL;
        m = LL_nary;
        q = LITERAL[295];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gL;
#define LL_gK LITERAL[296]
        arg4 = LL_gK;
#define LL_change LITERAL[297]
        m = LL_change;
        q = LITERAL[298];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gK;
#define LL_gDH LITERAL[299]
        arg4 = LL_gDH;
        m = LL_nary;
        q = LITERAL[300];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gDH;
#define LL_gDV LITERAL[301]
        arg4 = LL_gDV;
        m = LL_binary;
        q = LITERAL[302];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gDV;
#define LL_gDL LITERAL[303]
        arg4 = LL_gDL;
        m = LL_nary;
        q = LITERAL[304];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gDL;
#define LL_gDK LITERAL[305]
        arg4 = LL_gDK;
        m = LL_binary;
        q = LITERAL[306];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gDK;
#define LL_gM LITERAL[307]
        arg4 = LL_gM;
        m = LL_binary;
        q = LITERAL[308];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gM;
#define LL_gVM LITERAL[309]
        arg4 = LL_gVM;
        m = LL_binary;
        q = LITERAL[310];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gVM;
#define LL_gR LITERAL[311]
        arg4 = LL_gR;
        m = LL_binary;
        q = LITERAL[312];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gR;
#define LL_gS LITERAL[313]
        arg4 = LL_gS;
        m = LL_binary;
        q = LITERAL[314];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gS;
#define LL_gRM LITERAL[315]
        arg4 = LL_gRM;
        m = LL_binary;
        q = LITERAL[316];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gRM;
#define LL_gSM LITERAL[317]
        arg4 = LL_gSM;
        m = LL_binary;
        q = LITERAL[318];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gSM;
#define LL_WM LITERAL[319]
        arg4 = LL_WM;
        m = LL_binary;
        q = LITERAL[320];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_WM;
#define LL_WVM LITERAL[321]
        arg4 = LL_WVM;
        m = LL_binary;
        q = LITERAL[322];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_WVM;
#define LL_WR LITERAL[323]
        arg4 = LL_WR;
        m = LL_binary;
        q = LITERAL[324];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_WR;
#define LL_WS LITERAL[325]
        arg4 = LL_WS;
        m = LL_binary;
        q = LITERAL[326];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_WS;
#define LL_WRM LITERAL[327]
        arg4 = LL_WRM;
        m = LL_binary;
        q = LITERAL[328];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_WRM;
#define LL_WSM LITERAL[329]
        arg4 = LL_WSM;
        m = LL_binary;
        q = LITERAL[330];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_WSM;
#define LL_not LITERAL[331]
        arg4 = LL_not;
        m = LL_prefix;
        q = LITERAL[332];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_not;
        arg4 = LL_not;
        m = LL_prefix;
        q = LITERAL[333];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_not;
#define LL_and LITERAL[334]
        arg4 = LL_and;
        m = LL_nary;
        q = LITERAL[335];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_and;
        arg4 = LL_and;
        m = LL_nary;
        q = LITERAL[336];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_and;
#define LL_or LITERAL[337]
        arg4 = LL_or;
        m = LL_nary;
        q = LITERAL[338];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_or;
        arg4 = LL_or;
        m = LL_nary;
        q = LITERAL[339];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_or;
#define LL_gRS LITERAL[340]
        arg4 = LL_gRS;
        m = LL_binary;
        q = LITERAL[341];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gRS;
#define LL_gKS LITERAL[342]
        arg4 = LL_gKS;
        m = LL_binary;
        q = LITERAL[343];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gKS;
        arg4 = LL_gKS;
        m = LL_binary;
        q = LITERAL[344];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gKS;
#define LL_Bwith LITERAL[345]
        arg4 = LL_Bwith;
        m = LL_binary;
        q = LITERAL[346];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_Bwith;
        arg4 = LL_Bwith;
        m = LL_binary;
        q = LITERAL[347];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_Bwith;
#define LL_gTM LITERAL[348]
        arg4 = LL_gTM;
        m = LL_binary;
        q = LITERAL[349];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        arg5 = LL_gTM;
#define LL_MM LITERAL[350]
        arg4 = LL_MM;
        m = LL_binary;
        q = LITERAL[351];
        a = LL_gal;
        CC_deftoken(a, q, m, arg4, arg5);
        m = LL_SS;
        q = LL_RR;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gBB;
        q = LL_gB;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gHH;
        q = LL_gHH;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gV;
        q = LL_gH;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gVV;
        q = LL_gH;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gVM;
        q = LL_gM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gR;
        q = LL_gM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gS;
        q = LL_gM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gRM;
        q = LL_gM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gSM;
        q = LL_gM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_WVM;
        q = LL_WM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_WR;
        q = LL_WM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_WS;
        q = LL_WM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_WRM;
        q = LL_WM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_WSM;
        q = LL_WM;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_not;
        q = LL_not;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_and;
        q = LL_and;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_or;
        q = LL_and;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_Bwith;
        q = LL_Bwith;
        a = LL_gal;
        CC_equalprec(a, q, m);
        m = LL_gKS;
        q = LL_gKS;
        a = LL_gal;
        CC_equalprec(a, q, m);
#define LL_gRAR LITERAL[352]
        m = LL_gRAR;
#define LL_Bpaired LITERAL[353]
        q = LL_Bpaired;
        a = LL_gR;
        Lput(a, q, m);
#define LL_gSAS LITERAL[354]
        m = LL_gSAS;
        q = LL_Bpaired;
        a = LL_gS;
        Lput(a, q, m);
#define LL_gRMR LITERAL[355]
        m = LL_gRMR;
        q = LL_Bpaired;
        a = LL_gRM;
        Lput(a, q, m);
#define LL_Wltlt LITERAL[356]
        m = LL_Wltlt;
        q = LL_Bpaired;
        a = LL_WR;
        Lput(a, q, m);
#define LL_Wgtgt LITERAL[357]
        m = LL_Wgtgt;
        q = LL_Bpaired;
        a = LL_WS;
        Lput(a, q, m);
#define LL_Wlele LITERAL[358]
        m = LL_Wlele;
        q = LL_Bpaired;
        a = LL_WRM;
        Lput(a, q, m);
#define LL_Wgege LITERAL[359]
        m = LL_Wgege;
        q = LL_Bpaired;
        a = LL_WSM;
        Lput(a, q, m);
        q = LL_gH;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
#define LL_gtokenQH LITERAL[360]
        value(LL_gtokenQH) = a;
        q = LL_Bgtoken;
        a = CHAR_OF(78);
        Lremprop(a, q);
        q = LL_Bgtoken;
        a = CHAR_OF(110);
        Lremprop(a, q);
        q = LL_Bgtoken;
        a = CHAR_OF(65);
        Lremprop(a, q);
        q = LL_Bgtoken;
        a = CHAR_OF(97);
        Lremprop(a, q);
        q = LL_Bgtoken;
        a = CHAR_OF(79);
        Lremprop(a, q);
        q = LL_Bgtoken;
        a = CHAR_OF(111);
        Lremprop(a, q);
        q = LL_Bgtoken;
        a = CHAR_OF(87);
        Lremprop(a, q);
        q = LL_Bgtoken;
        a = CHAR_OF(119);
        Lremprop(a, q);
        q = LL_not;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
        arg4 = nil;
        m = a;
#define LL_NOT LITERAL[361]
        q = LL_NOT;
        a = LL_gal;
        CC_defkeyword(a, q, m, arg4);
        q = LL_not;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
        arg4 = nil;
        m = a;
        q = LL_not;
        a = LL_gal;
        CC_defkeyword(a, q, m, arg4);
        q = LL_and;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
        arg4 = nil;
        m = a;
#define LL_AND LITERAL[362]
        q = LL_AND;
        a = LL_gal;
        CC_defkeyword(a, q, m, arg4);
        q = LL_and;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
        arg4 = nil;
        m = a;
        q = LL_and;
        a = LL_gal;
        CC_defkeyword(a, q, m, arg4);
        q = LL_or;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
        arg4 = nil;
        m = a;
#define LL_OR LITERAL[363]
        q = LL_OR;
        a = LL_gal;
        CC_defkeyword(a, q, m, arg4);
        q = LL_or;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
        arg4 = nil;
        m = a;
        q = LL_or;
        a = LL_gal;
        CC_defkeyword(a, q, m, arg4);
        q = LL_Bwith;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
        arg4 = nil;
        m = a;
#define LL_WITH LITERAL[364]
        q = LL_WITH;
        a = LL_gal;
        CC_defkeyword(a, q, m, arg4);
        q = LL_Bwith;
        a = value(LL_Qgaltoken);
        a = CC_getQtform(a, q);
        arg4 = nil;
        m = a;
#define LL_with LITERAL[365]
        q = LL_with;
        a = LL_gal;
        CC_defkeyword(a, q, m, arg4);
        m = nil;
        q = LL_gal;
#define LL_Bindex LITERAL[366]
        a = LL_Bindex;
        CC_internTcons(a, q, m);
        m = nil;
        q = LL_gal;
        a = LL_Bwith;
        CC_internTcons(a, q, m);
        m = nil;
        q = LL_log;
#define LL_Bany LITERAL[367]
        a = LL_Bany;
        CC_internTcons(a, q, m);
        m = nil;
        q = LL_set;
        a = LL_Bset;
        CC_internTcons(a, q, m);
        m = nil;
        q = LL_set;
        a = LL_Boset;
        CC_internTcons(a, q, m);
        m = LL_gKS;
        q = LL_rel;
#define LL_rKS LITERAL[368]
        a = LL_rKS;
        CC_internTcons(a, q, m);
        m = LL_gM;
        q = LL_rel;
#define LL_rM LITERAL[369]
        a = LL_rM;
        CC_internTcons(a, q, m);
        m = LL_gVM;
        q = LL_rel;
#define LL_rVM LITERAL[370]
        a = LL_rVM;
        CC_internTcons(a, q, m);
        m = LL_gS;
        q = LL_rel;
#define LL_rS LITERAL[371]
        a = LL_rS;
        CC_internTcons(a, q, m);
        m = LL_gR;
        q = LL_rel;
#define LL_rR LITERAL[372]
        a = LL_rR;
        CC_internTcons(a, q, m);
        m = LL_gSM;
        q = LL_rel;
#define LL_rSM LITERAL[373]
        a = LL_rSM;
        CC_internTcons(a, q, m);
        m = LL_gRM;
        q = LL_rel;
#define LL_rRM LITERAL[374]
        a = LL_rRM;
        CC_internTcons(a, q, m);
        m = nil;
        q = LL_rat;
#define LL_ncH LITERAL[375]
        a = LL_ncH;
        CC_internTcons(a, q, m);
        m = nil;
        q = LL_rat;
#define LL_cH LITERAL[376]
        a = LL_cH;
        CC_internTcons(a, q, m);
        m = nil;
        q = LL_rat;
#define LL_cL LITERAL[377]
        a = LL_cL;
        CC_internTcons(a, q, m);
        a = value(LL_CordKvar);
        value(LL_CordLaln) = a;
        a = mkfxat(1);
        value(LL_CordKvar) = a;
        a = LL_decl;
        value(LL_Hrdstat) = a;
        q = LL_var;
        a = CHAR_OF(64);
        CC_internTid(a, q);
        q = LL_var;
#define LL_ZxtraZ LITERAL[378]
        a = LL_ZxtraZ;
        CC_internTid(a, q);
        a = value(LL_CordLaln);
        value(LL_CordKvar) = a;
        a = mkfxat(0);
        value(LL_CordLaln) = a;
        value(LL_Hrdstat) = nil;
        q = LL_set;
        a = LL_Anil;
        CC_internTid(a, q);
        q = LL_Bgid;
        a = LL_Anil;
        a = Lget(a, q);
        q = mkfxat(3);
        a = Lgetv(a, q);
#define LL_uneval LITERAL[379]
        q = LL_uneval;
        car(a) = q;
        return 1;
    }
}
Sex LITERAL[381];

const  char *bsatom_literal_string[381] =
{
/* 0 */
"!*!*mod",
/* 1 */
"!*mod",
/* 2 */
"!*!*flo",
/* 3 */
"!*float",
/* 4 */
"!*noargchk",
/* 5 */
"!.gstack",
/* 6 */
"\"KILLARGCHK-RECOVARGCHK MISMATCH\"",
/* 7 */
"!*tracmode",
/* 8 */
"untrac",
/* 9 */
"\"KILLTRACE-RECOVTRACE MISMATCH\"",
/* 10 */
"\"SAVEMOD-RECOVMOD SETTING MISMATCH\"",
/* 11 */
"\"SAVEPREC-RECOVPREC SETTING MISMATCH\"",
/* 12 */
"!*compmode",
/* 13 */
"\"SETCOMP-UNSETCOMP MISMATCH\"",
/* 14 */
"!*meps100",
/* 15 */
"\"arg\"",
/* 16 */
"0.000000000000000",
/* 17 */
"!#pi!#",
/* 18 */
"!*save",
/* 19 */
"!*temporal",
/* 20 */
"!?order",
/* 21 */
"head",
/* 22 */
"\"INVERSE NOT EXISTS FOR MOD\"",
/* 23 */
"1.000000000000000",
/* 24 */
"!*fcut",
/* 25 */
"\"MIXING OF <#COMPL> AND <#EFLOAT>\"",
/* 26 */
"\"NTHROOT\"",
/* 27 */
"\"SECOND ARG MUST BE > 0\"",
/* 28 */
"0.9990000000000000",
/* 29 */
"-0.9990000000000000",
/* 30 */
"0.001000000000000000",
/* 31 */
"\"PARTPOWER\"",
/* 32 */
"\"ARGS MUST BE INTEGERS > 1\"",
/* 33 */
"\"PARTROOT\"",
/* 34 */
"\"ARGS MUST BE INTEGERS > 0\"",
/* 35 */
"!!gid",
/* 36 */
"!!ctype!!",
/* 37 */
"!#maxcano!#",
/* 38 */
"!#maxform!#",
/* 39 */
"fncvars",
/* 40 */
"uncom",
/* 41 */
"indxed",
/* 42 */
"(algn algf array vect matx tens)",
/* 43 */
"\"INDEXING IS NOT ALLOWED FOR\"",
/* 44 */
"dummy",
/* 45 */
"var",
/* 46 */
"(algf vect matx tens)",
/* 47 */
"\"DO NOT USE @ IN ID-NAME OF TYPE\"",
/* 48 */
"func",
/* 49 */
"symbol",
/* 50 */
"\"INVALID AS PROPERTY TYPE\"",
/* 51 */
"decl",
/* 52 */
"!*rdstat",
/* 53 */
"fail",
/* 54 */
"form",
/* 55 */
"rat",
/* 56 */
"array",
/* 57 */
"\"CONV!:GEXPR2SEXPR\"",
/* 58 */
"!#simpenv!#",
/* 59 */
"!#ordenv!#",
/* 60 */
"!#evalenv!#",
/* 61 */
"num",
/* 62 */
"pfunc",
/* 63 */
"tfunc",
/* 64 */
"oper",
/* 65 */
"! nil",
/* 66 */
"(c!+ c!* nc!*)",
/* 67 */
"rel",
/* 68 */
"set",
/* 69 */
"log",
/* 70 */
"!#ratf!#",
/* 71 */
"algn",
/* 72 */
"!#algn!#",
/* 73 */
"tran",
/* 74 */
"(var)",
/* 75 */
"!#poly!#",
/* 76 */
"(var indxed)",
/* 77 */
"algf",
/* 78 */
"!#algf!#",
/* 79 */
"vect",
/* 80 */
"!#vect!#",
/* 81 */
"matx",
/* 82 */
"!#matx!#",
/* 83 */
"tens",
/* 84 */
"!#tens!#",
/* 85 */
"op!*",
/* 86 */
"!!oset",
/* 87 */
"!!set",
/* 88 */
"!*dfaultyp",
/* 89 */
"!!gtype!!",
/* 90 */
"!#ord!-var",
/* 91 */
"!#ord!+alf",
/* 92 */
"!#ord!-pfn",
/* 93 */
"!#ord!-fun",
/* 94 */
"!#ord!-trn",
/* 95 */
"!#ord!+aln",
/* 96 */
"\"INTERN:ID\"",
/* 97 */
"\"# IS FOR TRAN/ALGN ONLY\"",
/* 98 */
"!!locgid",
/* 99 */
"!<blank!>",
/* 100 */
"(rat rel set log gal)",
/* 101 */
"\"INVALID CONSTYPE FOR INTERN:CONS\"",
/* 102 */
"\"ALREADY DEFINED AS CONSTRUCTOR\"",
/* 103 */
"!!gproc",
/* 104 */
"!#ord!-cns",
/* 105 */
"cons",
/* 106 */
"(lisp)",
/* 107 */
"(!#time !!ordhistory !#ordenv!+!#)",
/* 108 */
"(!#ordenv!# !#evalenv!# !#simpenv!#)",
/* 109 */
"(!*mod !*float !*powser !*!*mod !*!*flo)",
/* 110 */
"(!*exctdiv !*machineps !*meps100 !*fcut)",
/* 111 */
"(!*noargchk !*dfaultyp !*rdstat !*substype)",
/* 112 */
"(!*chkcoef !*quotient !*remainder !*byproduct)",
/* 113 */
"(!*rules !!opnrules !#rewrite !*save)",
/* 114 */
"(!#pi!# !#e!#)",
/* 115 */
"(!*primes !*medprimes !*bigprimes !*random)",
/* 116 */
"(!*random !*rndmsave)",
/* 117 */
"(!*evalmode !*compmode !*simpmode !*prinmode)",
/* 118 */
"(!*colmode !*expmode !*divmode !*tracmode)",
/* 119 */
"(!*numcomp !*funcomp !*intexp)",
/* 120 */
"(!*fracpow !*simpratf !*sindex)",
/* 121 */
"!!ordhistory",
/* 122 */
"!#ordenv!+!#",
/* 123 */
"!*powser",
/* 124 */
"!*exctdiv",
/* 125 */
"1.000000000000000e-15",
/* 126 */
"!*machineps",
/* 127 */
"1.000000000000000e-13",
/* 128 */
"!*random",
/* 129 */
"!*rndmsave",
/* 130 */
"!*substype",
/* 131 */
"!*chkcoef",
/* 132 */
"!*byproduct",
/* 133 */
"!*quotient",
/* 134 */
"!*remainder",
/* 135 */
"!*rules",
/* 136 */
"!!opnrules",
/* 137 */
"!#rewrite",
/* 138 */
"eval",
/* 139 */
"!*evalmode",
/* 140 */
"comp",
/* 141 */
"simp",
/* 142 */
"!*simpmode",
/* 143 */
"flat",
/* 144 */
"!*prinmode",
/* 145 */
"col",
/* 146 */
"!*colmode",
/* 147 */
"exp",
/* 148 */
"!*expmode",
/* 149 */
"div",
/* 150 */
"!*divmode",
/* 151 */
"!*numcomp",
/* 152 */
"!*funcomp",
/* 153 */
"!*intexp",
/* 154 */
"!*fracpow",
/* 155 */
"!*simpratf",
/* 156 */
"!*sindex",
/* 157 */
"3.141592953590000",
/* 158 */
"(2 3 5 7 11 13 17 19 23 29 31 37 41 43 47 53 59 61 67 71 73 79 83 89 97 101 103 107 109 113 127 131 137 139 149 151 157 163 167 173 179 181 191 193 197 199 211 223 227 229 233 239 241 251 257 263 269 271 277 281 283 293 307 311 313 317 331 337 347 349 353 359 367 373 379 383 389 397 401 409 419 421 431 433 439 443 449 457 461 463 467 479 487 491 499 503 509 521 523 541 547 557 563 569 571 577 587 593 599 601 607 613 617 619 631 641 643 647 653 659 661 673 677 683 691 701 709 719 727 733 739 743 751 757 761 769 773 787 797 809 811 821 823 827 829 839 853 857 859 863 877 881 883 887 907 911 919 929 937 941 947 953 967 971 977 983 991 997 1009 1013 1019 1021 1031 1033 1039 1049 1051 1061 1063 1069 1087 1091 1093 1097 1103 1109 1117 1123 1129 1151 1153 1163 1171 1181 1187 1193 1201 1213 1217 1223 1229 1231 1237 1249 1259 1277 1279 1283 1289 1291 1297 1301 1303 1307 1319 1321 1327 1361 1367 1373 1381 1399 1409 1423 1427 1429 1433 1439 1447 1451 1453 1459 1471 1481 1483 1487 1489 1493 1499 1511 1523 1531 1543 1549 1553 1559 1567 1571 1579 1583 1597 1601 1607 1609 1613 1619 1621 1627 1637 1657 1663 1667 1669 1693 1697 1699 1709 1721 1723 1733 1741 1747 1753 1759 1777 1783 1787 1789 1801 1811 1823 1831 1847 1861 1867 1871 1873 1877 1879 1889 1901 1907 1913 1931 1933 1949 1951 1973 1979 1987 1993 1997 1999)",
/* 159 */
"!*primes",
/* 160 */
"!*medprimes",
/* 161 */
"(1000003 1000033 1000037 1000039 1000081 1000099 1000117 1000121 1000133 1000151 1000159 1000171 1000183 1000187 1000193 1000199 1000211 1000213 1000231 1000249 1000253 1000273 1000289 1000291 1000303 1000313 1000333 1000357 1000367 1000381 1000393 1000397 1000403 1000409 1000423 1000427 1000429 1000453 1000457 1000507 1000537 1000541 1000547 1000577 1000579 1000589 1000609 1000619 1000621 1000639 1000651 1000667 1000669 1000679 1000691 1000697 1000721 1000723 1000763 1000777 1000793 1000829 1000847 1000849 1000859 1000861 1000889 1000907 1000919 1000921 1000931 1000969 1000973 1000981 1000999 1001003 1001017 1001023 1001027 1001041 1001069 1001081 1001087 1001089 1001093 1001107 1001123 1001153 1001159 1001173 1001177 1001191 1001197 1001219 1001237 1001267 1001279 1001291 1001303 1001311 1001321 1001323 1001327 1001347 1001353 1001369 1001381 1001387 1001389 1001401 1001411 1001431 1001447 1001459 1001467 1001491 1001501 1001527 1001531 1001549 1001551 1001563 1001569 1001587 1001593 1001621 1001629 1001639 1001659 1001669 1001683 1001687 1001713 1001723 1001743 1001783 1001797 1001801 1001807 1001809 1001821 1001831 1001839 1001911 1001933 1001941 1001947 1001953 1001977 1001981 1001983 1001989)",
/* 162 */
"!*bigprimes",
/* 163 */
"\"ID-TYPE CHANGED, RESET TO BE NEW ID\"",
/* 164 */
"array!:msg",
/* 165 */
"\"ARGUMENT-TYPE MISMATCH IN\"",
/* 166 */
"\"ZERO DIVISION OCCURED\"",
/* 167 */
"\"EXACT-DIVISION FAILED\"",
/* 168 */
"\"ARGUMENT MUST BE <ALGN/POLY/ALGF> IN\"",
/* 169 */
"\"<VECT/MATX/TENS> IS USED AS EXPONENT\"",
/* 170 */
"\"NON-INTEGER EXPONENT TO <VECT/MATX/TENS>\"",
/* 171 */
"((!,l1 !,l2) (pair !,l1 !,l2))",
/* 172 */
"smacro",
/* 173 */
"listpair",
/* 174 */
"((!,n) (remainder !,n !*mod))",
/* 175 */
"mod1",
/* 176 */
"((!,m !,n) (gcd !,m !,n))",
/* 177 */
"gcd!:intint",
/* 178 */
"((!,m !,n) (lcm !,m !,n))",
/* 179 */
"lcm!:intint",
/* 180 */
"((!,id) (get !,id '!!gid))",
/* 181 */
"!?gid",
/* 182 */
"((!,id) (get !,id '!!ctype!!))",
/* 183 */
"!?gcons",
/* 184 */
"constype!:",
/* 185 */
"(!#algn!# !#poly!# !#algf!# !#ratf!# !#maxcano!# !#vect!# !#matx!# !#tens!# !#maxform!# !#relexpr!# !#setexpr!# !#logexpr!#)",
/* 186 */
"!#relexpr!#",
/* 187 */
"!#setexpr!#",
/* 188 */
"!#logexpr!#",
/* 189 */
"constant",
/* 190 */
"((!,u) (car !,u))",
/* 191 */
"tag!:type",
/* 192 */
"((!,u) (ilogand2 (car !,u) 240))",
/* 193 */
"tag!:form",
/* 194 */
"((!,u) (ilogand2 (car !,u) 3840))",
/* 195 */
"tag!:expr",
/* 196 */
"((!,tag) (ilessp !,tag !#maxcano!#))",
/* 197 */
"!?canotag",
/* 198 */
"((!,tag) (ilessp !,tag !#maxform!#))",
/* 199 */
"!?canfortag",
/* 200 */
"((!,tag) (not (zerop (ilogand2 !,tag 240))))",
/* 201 */
"!?formtag",
/* 202 */
"((!,tag) (not (zerop (ilogand2 !,tag 3840))))",
/* 203 */
"!?exprtag",
/* 204 */
"((!,id) (getv (get !,id '!!gid) 0))",
/* 205 */
"get!:gorder",
/* 206 */
"((!,id) (getv (get !,id '!!gid) 1))",
/* 207 */
"get!:gtypes",
/* 208 */
"((!,id) (getv (get !,id '!!gid) 2))",
/* 209 */
"get!:sexpr",
/* 210 */
"((!,id) (getv (get !,id '!!gid) 3))",
/* 211 */
"get!:geval",
/* 212 */
"((!,id) (getv (get !,id '!!gid) 4))",
/* 213 */
"get!:gcomp",
/* 214 */
"((!,id) (getv (get !,id '!!gid) 5))",
/* 215 */
"get!:gsimp",
/* 216 */
"((!,id) (getv (get !,id '!!gid) 6))",
/* 217 */
"get!:gprint",
/* 218 */
"((!,id) (car (get!:gtypes !,id)))",
/* 219 */
"get!:gtype1",
/* 220 */
"uncomm",
/* 221 */
"noncom",
/* 222 */
"noncomm",
/* 223 */
"indexed",
/* 224 */
"numb",
/* 225 */
"number",
/* 226 */
"variable",
/* 227 */
"function",
/* 228 */
"tfunction",
/* 229 */
"symb",
/* 230 */
"algnum",
/* 231 */
"tranum",
/* 232 */
"trannum",
/* 233 */
"poly",
/* 234 */
"polynom",
/* 235 */
"algfunc",
/* 236 */
"ratf",
/* 237 */
"ratfunc",
/* 238 */
"vector",
/* 239 */
"matrix",
/* 240 */
"tensor",
/* 241 */
"operator",
/* 242 */
"pfunction",
/* 243 */
"oset",
/* 244 */
"ordset",
/* 245 */
"cvar",
/* 246 */
"cfunc",
/* 247 */
"ucvar",
/* 248 */
"ncvar",
/* 249 */
"ucfunc",
/* 250 */
"ncfunc",
/* 251 */
"indvar",
/* 252 */
"indxvar",
/* 253 */
"indfunc",
/* 254 */
"indxfunc",
/* 255 */
"indsymb",
/* 256 */
"indxsymb",
/* 257 */
"(!#ord!-cns !#ord!+alf !#ord!+aln !#ord!-pfn !#ord!-fun !#ord!-var !#ord!-trn !#ord!+pfn !#ord!+fun !#ord!+var !#ord!+trn)",
/* 258 */
"!#ord!+pfn",
/* 259 */
"!#ord!+fun",
/* 260 */
"!#ord!+var",
/* 261 */
"!#ord!+trn",
/* 262 */
"prefix",
/* 263 */
"!.galtoken",
/* 264 */
"!!gtoken",
/* 265 */
"!<prime!>",
/* 266 */
"postfix",
/* 267 */
"(!:)",
/* 268 */
"gal",
/* 269 */
"!<!<",
/* 270 */
"(!< !<)",
/* 271 */
"!>!>",
/* 272 */
"(!> !>)",
/* 273 */
"g!!",
/* 274 */
"(!!)",
/* 275 */
"g!!!!",
/* 276 */
"(!! !!)",
/* 277 */
"g!*!*",
/* 278 */
"binary",
/* 279 */
"(!* !*)",
/* 280 */
"(!^)",
/* 281 */
"g!.",
/* 282 */
"(!.)",
/* 283 */
"g!>!<",
/* 284 */
"(!> !<)",
/* 285 */
"g!*",
/* 286 */
"nary",
/* 287 */
"(!*)",
/* 288 */
"g!/",
/* 289 */
"(!/)",
/* 290 */
"g!/!/",
/* 291 */
"(!/ !/)",
/* 292 */
"g!/!+",
/* 293 */
"(!/ !+)",
/* 294 */
"g!+",
/* 295 */
"(!+)",
/* 296 */
"g!-",
/* 297 */
"change",
/* 298 */
"(!-)",
/* 299 */
"g!$!*",
/* 300 */
"(!$ !*)",
/* 301 */
"g!$!/",
/* 302 */
"(!$ !/)",
/* 303 */
"g!$!+",
/* 304 */
"(!$ !+)",
/* 305 */
"g!$!-",
/* 306 */
"(!$ !-)",
/* 307 */
"g!=",
/* 308 */
"(!=)",
/* 309 */
"g!/!=",
/* 310 */
"(!/ !=)",
/* 311 */
"g!<",
/* 312 */
"(!<)",
/* 313 */
"g!>",
/* 314 */
"(!>)",
/* 315 */
"g!<!=",
/* 316 */
"(!< !=)",
/* 317 */
"g!>!=",
/* 318 */
"(!> !=)",
/* 319 */
"!?!=",
/* 320 */
"(!? !=)",
/* 321 */
"!?!/!=",
/* 322 */
"(!? !/ !=)",
/* 323 */
"!?!<",
/* 324 */
"(!? !<)",
/* 325 */
"!?!>",
/* 326 */
"(!? !>)",
/* 327 */
"!?!<!=",
/* 328 */
"(!? !< !=)",
/* 329 */
"!?!>!=",
/* 330 */
"(!? !> !=)",
/* 331 */
"not",
/* 332 */
"(N O T)",
/* 333 */
"(n o t)",
/* 334 */
"and",
/* 335 */
"(A N D)",
/* 336 */
"(a n d)",
/* 337 */
"or",
/* 338 */
"(O R)",
/* 339 */
"(o r)",
/* 340 */
"g!<!>",
/* 341 */
"(!< !>)",
/* 342 */
"g!-!>",
/* 343 */
"(!- !>)",
/* 344 */
"(!- !- !>)",
/* 345 */
"!!with",
/* 346 */
"(W I T H)",
/* 347 */
"(w i t h)",
/* 348 */
"g!:!=",
/* 349 */
"(!: !=)",
/* 350 */
"!=!=",
/* 351 */
"(!= !=)",
/* 352 */
"g!<! !<",
/* 353 */
"!!paired",
/* 354 */
"g!>! !>",
/* 355 */
"g!<!=!<",
/* 356 */
"!?ltlt",
/* 357 */
"!?gtgt",
/* 358 */
"!?lele",
/* 359 */
"!?gege",
/* 360 */
"gtoken!.!*",
/* 361 */
"NOT",
/* 362 */
"AND",
/* 363 */
"OR",
/* 364 */
"WITH",
/* 365 */
"with",
/* 366 */
"!!index",
/* 367 */
"!!any",
/* 368 */
"r!-!>",
/* 369 */
"r!=",
/* 370 */
"r!/!=",
/* 371 */
"r!>",
/* 372 */
"r!<",
/* 373 */
"r!>!=",
/* 374 */
"r!<!=",
/* 375 */
"nc!*",
/* 376 */
"c!*",
/* 377 */
"c!+",
/* 378 */
"!@xtra!@",
/* 379 */
"uneval",
/* 380 */ NULL
};
setup_type const bsatom_g_setup[] =
{
    {"intern:cons", (lisp_proc *)CC_internTcons, 3},
    {"intern:nid", (lisp_proc *)CC_internTnid, 2},
    {"intern:id", (lisp_proc *)CC_internTid, 2},
    {"order<=>", (lisp_proc *)CC_orderRMS, 2},
    {"?order:var", (lisp_proc *)CC_WorderTvar, 2},
    {"?order:id", (lisp_proc *)CC_WorderTid, 2},
    {"?revorder", (lisp_proc *)CC_Wrevorder, 2},
    {"?order", (lisp_proc *)CC_Worder, 2},
    {"?set", (lisp_proc *)CC_Wset, 1},
    {"?oset", (lisp_proc *)CC_Woset, 1},
    {"?oper", (lisp_proc *)CC_Woper, 1},
    {"?tens", (lisp_proc *)CC_Wtens, 1},
    {"?matx", (lisp_proc *)CC_Wmatx, 1},
    {"?vect", (lisp_proc *)CC_Wvect, 1},
    {"?ratf", (lisp_proc *)CC_Wratf, 1},
    {"?algf", (lisp_proc *)CC_Walgf, 1},
    {"?poly", (lisp_proc *)CC_Wpoly, 1},
    {"?tran", (lisp_proc *)CC_Wtran, 1},
    {"?algn", (lisp_proc *)CC_Walgn, 1},
    {"?pol3", (lisp_proc *)CC_Wpol3, 1},
    {"?logexpr", (lisp_proc *)CC_Wlogexpr, 1},
    {"?setexpr", (lisp_proc *)CC_Wsetexpr, 1},
    {"?relexpr", (lisp_proc *)CC_Wrelexpr, 1},
    {"?ratexpr", (lisp_proc *)CC_Wratexpr, 1},
    {"?array", (lisp_proc *)CC_Warray, 1},
    {"?form", (lisp_proc *)CC_Wform, 1},
    {"?pref", (lisp_proc *)CC_Wpref, 1},
    {"?cano", (lisp_proc *)CC_Wcano, 1},
    {"?nil", (lisp_proc *)CC_Wnil, 1},
    {"?opvar", (lisp_proc *)CC_Wopvar, 1},
    {"?tfunc", (lisp_proc *)CC_Wtfunc, 1},
    {"?pfunc", (lisp_proc *)CC_Wpfunc, 1},
    {"?ncfunc", (lisp_proc *)CC_Wncfunc, 1},
    {"?cfunc", (lisp_proc *)CC_Wcfunc, 1},
    {"?ncvar", (lisp_proc *)CC_Wncvar, 1},
    {"?cvar", (lisp_proc *)CC_Wcvar, 1},
    {"?dummy", (lisp_proc *)CC_Wdummy, 1},
    {"?indexed", (lisp_proc *)CC_Windexed, 1},
    {"?uncom", (lisp_proc *)CC_Wuncom, 1},
    {"?symbol", (lisp_proc *)CC_Wsymbol, 1},
    {"?func", (lisp_proc *)CC_Wfunc, 1},
    {"?var", (lisp_proc *)CC_Wvar, 1},
    {"?num", (lisp_proc *)CC_Wnum, 1},
    {"conv:sexpr2gexpr", (lisp_proc *)CC_convTsexpr2gexpr, 1},
    {"conv:gexpr2sexpr", (lisp_proc *)CC_convTgexpr2sexpr, 3},
    {"add:idtype", (lisp_proc *)CC_addTidtype, 2},
    {"setq:gexpr", (lisp_proc *)CC_setqTgexpr, 2},
    {"put:simpenv", (lisp_proc *)CC_putTsimpenv, 2},
    {"put:ordenv", (lisp_proc *)CC_putTordenv, 2},
    {"put:simprs", (lisp_proc *)CC_putTsimprs, 3},
    {"put:compfn", (lisp_proc *)CC_putTcompfn, 3},
    {"put:savval", (lisp_proc *)CC_putTsavval, 2},
    {"put:gprint", (lisp_proc *)CC_putTgprint, 2},
    {"put:sexpr", (lisp_proc *)CC_putTsexpr, 2},
    {"put:gtypes", (lisp_proc *)CC_putTgtypes, 2},
    {"put:gorder", (lisp_proc *)CC_putTgorder, 2},
    {"get:simprs", (lisp_proc *)CC_getTsimprs, 2},
    {"get:fncvars", (lisp_proc *)CC_getTfncvars, 1},
    {"get:compfn", (lisp_proc *)CC_getTcompfn, 2},
    {"get:gtype1", (lisp_proc *)CC_getTgtype1, -4},
    {"get:gprint", (lisp_proc *)CC_getTgprint, -4},
    {"get:gsimp", (lisp_proc *)CC_getTgsimp, -4},
    {"get:gcomp", (lisp_proc *)CC_getTgcomp, -4},
    {"get:geval", (lisp_proc *)CC_getTgeval, -4},
    {"get:sexpr", (lisp_proc *)CC_getTsexpr, -4},
    {"get:gtypes", (lisp_proc *)CC_getTgtypes, -4},
    {"get:gorder", (lisp_proc *)CC_getTgorder, -4},
    {"?exprtag", (lisp_proc *)CC_Wexprtag, -4},
    {"?formtag", (lisp_proc *)CC_Wformtag, -4},
    {"?canfortag", (lisp_proc *)CC_Wcanfortag, -4},
    {"?canotag", (lisp_proc *)CC_Wcanotag, -4},
    {"tag:expr", (lisp_proc *)CC_tagTexpr, -4},
    {"tag:form", (lisp_proc *)CC_tagTform, -4},
    {"tag:type", (lisp_proc *)CC_tagTtype, -4},
    {"constype:", (lisp_proc *)CC_constypeT, -4},
    {"?gcons", (lisp_proc *)CC_Wgcons, -4},
    {"?gid", (lisp_proc *)CC_Wgid, -4},
    {"partroot", (lisp_proc *)CC_partroot, 2},
    {"partpower", (lisp_proc *)CC_partpower, 2},
    {"nthroot", (lisp_proc *)CC_nthroot, 2},
    {"gcd:bnumbnum", (lisp_proc *)CC_gcdTbnumbnum, 2},
    {"iqdiv2", (lisp_proc *)CC_iqdiv2, 2},
    {"iqdiv", (lisp_proc *)CC_iqdiv, 2},
    {"signmin2", (lisp_proc *)CC_signmin2, 2},
    {"signmax2", (lisp_proc *)CC_signmax2, 2},
    {"signdiff", (lisp_proc *)CC_signdiff, 2},
    {"flgdiv:bnumbnum", (lisp_proc *)CC_flgdivTbnumbnum, 2},
    {"div:bnumbnum", (lisp_proc *)CC_divTbnumbnum, 2},
    {"mathdiv", (lisp_proc *)CC_mathdiv, 2},
    {"pow:bnumbnum", (lisp_proc *)CC_powTbnumbnum, 2},
    {"pow:bnumpint", (lisp_proc *)CC_powTbnumpint, 2},
    {"recip:bnum", (lisp_proc *)CC_recipTbnum, 1},
    {"mult:bnumbnum", (lisp_proc *)CC_multTbnumbnum, 2},
    {"neg:bnum", (lisp_proc *)CC_negTbnum, 1},
    {"add:bnumbnum", (lisp_proc *)CC_addTbnumbnum, 2},
    {"lcm:intint", (lisp_proc *)CC_lcmTintint, -5},
    {"gcd:intint", (lisp_proc *)CC_gcdTintint, -5},
    {"ipartlessp", (lisp_proc *)CC_ipartlessp, 2},
    {"rpartlessp", (lisp_proc *)CC_rpartlessp, 2},
    {"compllessp", (lisp_proc *)CC_compllessp, 2},
    {"qabs", (lisp_proc *)CC_qabs, 1},
    {"?order#s", (lisp_proc *)CC_WorderCs, 2},
    {"cofact:intint", (lisp_proc *)CC_cofactTintint, 2},
    {"modint2numden", (lisp_proc *)CC_modint2numden, 3},
    {"modexpt:sub", (lisp_proc *)CC_modexptTsub, 3},
    {"modexpt", (lisp_proc *)CC_modexpt, 3},
    {"modquotient", (lisp_proc *)CC_modquotient, 3},
    {"modinverse", (lisp_proc *)CC_modinverse, 2},
    {"modtimes2", (lisp_proc *)CC_modtimes2, 3},
    {"modplus2", (lisp_proc *)CC_modplus2, 3},
    {"modrecip", (lisp_proc *)CC_modrecip, 1},
    {"moddiv", (lisp_proc *)CC_moddiv, 2},
    {"modmult", (lisp_proc *)CC_modmult, 2},
    {"modadd", (lisp_proc *)CC_modadd, 2},
    {"mod2", (lisp_proc *)CC_mod2, 2},
    {"mod1", (lisp_proc *)CC_mod1, -4},
    {"se:unionvars", (lisp_proc *)CC_seTunionvars, 2},
    {"se:unionids", (lisp_proc *)CC_seTunionids, 2},
    {"se:unionq", (lisp_proc *)CC_seTunionq, 2},
    {"intersecq", (lisp_proc *)CC_intersecq, 2},
    {"se:sortset", (lisp_proc *)CC_seTsortset, 1},
    {"se:sortbycar", (lisp_proc *)CC_seTsortbycar, 2},
    {"sortbycar", (lisp_proc *)CC_sortbycar, 2},
    {"se:sortany", (lisp_proc *)CC_seTsortany, 2},
    {"sortany", (lisp_proc *)CC_sortany, 2},
    {"sort#s", (lisp_proc *)CC_sortCs, 2},
    {"merglists", (lisp_proc *)CC_merglists, 2},
    {"se:insertbycar2", (lisp_proc *)CC_seTinsertbycar2, 3},
    {"se:insertbycar", (lisp_proc *)CC_seTinsertbycar, 3},
    {"se:insertAlis", (lisp_proc *)CC_seTinsertAlis, 4},
    {"se:insert", (lisp_proc *)CC_seTinsert, 3},
    {"insertbycar2", (lisp_proc *)CC_insertbycar2, 3},
    {"insertbycar", (lisp_proc *)CC_insertbycar, 3},
    {"multideletebyindex", (lisp_proc *)CC_multideletebyindex, 2},
    {"multidelete", (lisp_proc *)CC_multidelete, 2},
    {"multiassoc", (lisp_proc *)CC_multiassoc, 2},
    {"multirplaca", (lisp_proc *)CC_multirplaca, 2},
    {"deletebyindex", (lisp_proc *)CC_deletebyindex, 2},
    {"se:deletebycar", (lisp_proc *)CC_seTdeletebycar, 2},
    {"deletebycar", (lisp_proc *)CC_deletebycar, 2},
    {"se:delete", (lisp_proc *)CC_seTdelete, 2},
    {"se:listneg", (lisp_proc *)CC_seTlistneg, 1},
    {"listneg", (lisp_proc *)CC_listneg, 1},
    {"listdiff", (lisp_proc *)CC_listdiff, 2},
    {"listsum", (lisp_proc *)CC_listsum, 2},
    {"listmult", (lisp_proc *)CC_listmult, 2},
    {"listmin", (lisp_proc *)CC_listmin, 2},
    {"listmax", (lisp_proc *)CC_listmax, 2},
    {"listzero", (lisp_proc *)CC_listzero, 1},
    {"listsome", (lisp_proc *)CC_listsome, 2},
    {"listpair", (lisp_proc *)CC_listpair, -5},
    {"flattenlis", (lisp_proc *)CC_flattenlis, 1},
    {"se:listcdr", (lisp_proc *)CC_seTlistcdr, 1},
    {"listcdr", (lisp_proc *)CC_listcdr, 1},
    {"revlistcar", (lisp_proc *)CC_revlistcar, 1},
    {"listcar", (lisp_proc *)CC_listcar, 1},
    {"sumelms", (lisp_proc *)CC_sumelms, 1},
    {"prodelms", (lisp_proc *)CC_prodelms, 1},
    {"minabs", (lisp_proc *)CC_minabs, 1},
    {"maxabs", (lisp_proc *)CC_maxabs, 1},
    {">=lis", (lisp_proc *)CC_SMlis, 2},
    {">lis", (lisp_proc *)CC_Slis, 2},
    {"<lis", (lisp_proc *)CC_Rlis, 2},
    {"?subsetq", (lisp_proc *)CC_Wsubsetq, 2},
    {"?subset", (lisp_proc *)CC_Wsubset, 2},
    {"?zerolist", (lisp_proc *)CC_Wzerolist, 1},
    {"?numlist", (lisp_proc *)CC_Wnumlist, 1},
    {"?intlist", (lisp_proc *)CC_Wintlist, 1},
    {"?idlist", (lisp_proc *)CC_Widlist, 1},
    {"?chklist2", (lisp_proc *)CC_Wchklist2, 3},
    {"?chklist", (lisp_proc *)CC_Wchklist, 2},
    {"?cdr", (lisp_proc *)CC_Wcdr, 2},
    {"?approxnum", (lisp_proc *)CC_Wapproxnum, 1},
    {"?exactnum", (lisp_proc *)CC_Wexactnum, 1},
    {"ipartgeqp", (lisp_proc *)CC_ipartgeqp, 2},
    {"rpartgeqp", (lisp_proc *)CC_rpartgeqp, 2},
    {"complgeqp", (lisp_proc *)CC_complgeqp, 2},
    {"?lele", (lisp_proc *)CC_Wlele, 3},
    {"?ltlt", (lisp_proc *)CC_Wltlt, 3},
    {"?gege", (lisp_proc *)CC_Wgege, 3},
    {"?gtgt", (lisp_proc *)CC_Wgtgt, 3},
    {"?zero", (lisp_proc *)CC_Wzero, 1},
    {"?tag", (lisp_proc *)CC_Wtag, 1},
    {"?string", (lisp_proc *)CC_Wstring, 1},
    {"?ratn", (lisp_proc *)CC_Wratn, 1},
    {"?plus", (lisp_proc *)CC_Wplus, 1},
    {"?one", (lisp_proc *)CC_Wone, 1},
    {"?odd", (lisp_proc *)CC_Wodd, 1},
    {"?null", (lisp_proc *)CC_Wnull, 1},
    {"?minus", (lisp_proc *)CC_Wminus, 1},
    {"?list", (lisp_proc *)CC_Wlist, 1},
    {"?int", (lisp_proc *)CC_Wint, 1},
    {"?id", (lisp_proc *)CC_Wid, 1},
    {"?float", (lisp_proc *)CC_Wfloat, 1},
    {"?even", (lisp_proc *)CC_Weven, 1},
    {"?eqn", (lisp_proc *)CC_Weqn, 2},
    {"?efloat", (lisp_proc *)CC_Wefloat, 1},
    {"?complx", (lisp_proc *)CC_Wcomplx, 1},
    {"?compl", (lisp_proc *)CC_Wcompl, 1},
    {"?bnum", (lisp_proc *)CC_Wbnum, 1},
    {"?bfloat", (lisp_proc *)CC_Wbfloat, 1},
    {"?atom", (lisp_proc *)CC_Watom, 1},
    {"abs2", (lisp_proc *)CC_abs2, 1},
    {" arg", (lisp_proc *)CC_Aarg, 1},
    {"simpcompl", (lisp_proc *)CC_simpcompl, 1},
    {"imagpart", (lisp_proc *)CC_imagpart, 1},
    {"realpart", (lisp_proc *)CC_realpart, 1},
    {"#I", (lisp_proc *)CC_CI, 2},
    {"#EC", (lisp_proc *)CC_CEC, 3},
    {"#BE", (lisp_proc *)CC_CBE, 2},
    {"#E", (lisp_proc *)CC_CE, 2},
    {"#C", (lisp_proc *)CC_CC, 2},
    {"unsetcomp", (lisp_proc *)CC_unsetcomp, 0},
    {"setcomp", (lisp_proc *)CC_setcomp, 1},
    {"recovprec", (lisp_proc *)CC_recovprec, 0},
    {"saveprec", (lisp_proc *)CC_saveprec, 0},
    {"recovmod", (lisp_proc *)CC_recovmod, 0},
    {"savemod", (lisp_proc *)CC_savemod, 0},
    {"recovtrace", (lisp_proc *)CC_recovtrace, 0},
    {"killtrace", (lisp_proc *)CC_killtrace, 0},
    {"recovargchk", (lisp_proc *)CC_recovargchk, 0},
    {"killargchk", (lisp_proc *)CC_killargchk, 0},
    {"recov:gconst", (lisp_proc *)CC_recovTgconst, 0},
    {NULL, NULL, 0 }
};

