#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_bseval.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex bseval_literal_vector[];
const char *bseval_literal_string[];
setup_type const  bseval_g_setup[];
#define LITERAL bseval_literal_vector




Sex CC_galeval(Sex a)
{
    if(is_number(a)) goto    G0003;
    a = CC_mkQgprog(a);
    a = Leval(a);
   G0003:
    return a;
}

Sex CC_mkQgprog(Sex a)
{
    Sex q, m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
   G0114:
    w1 = a;
    if(is_cons(a)) goto    G0008;
    if(a == nil) goto    G0094;
    if(!is_symbol(a)) goto    G0094;
    q = a;
#define LL_quote LITERAL[0]
    a = LL_quote;
    a = Llist2(a, q);
    q = a;
    goto    G0097;
   G0008:
    a = car(a);
    if(is_symbol(a)) goto    G0014;
    w2 = nil;
    w3 = nil;
    if(is_cons(a)) goto    G0017;
    q = a;
    goto    G0098;
   G0017:
    a = car(a);
    w3 = a;
#define LL_Bindex LITERAL[1]
    if(a != LL_Bindex) goto    G0018;
    a = car(cdr(car(w1)));
    w2 = a;
    if(!is_cons(a)) goto    G0022;
    q = LITERAL[2];
    a = car(a);
    a = Lmemq(a, q);
    if(a != nil) goto    G0022;
    q = w2;
    a = LITERAL[3];
    CC_errormsg(a, q);
   G0022:
    a = w2;
    a = CC_quoteTid(a);
    w2 = a;
    a = cdr(cdr(car(w1)));
    a = CC_mkQgargs(a);
    w4 = a;
    a = cdr(w1);
    a = CC_mkQgargs(a);
    arg4 = a;
    m = w4;
    q = w2;
#define LL_gevTxfunc LITERAL[4]
    a = LL_gevTxfunc;
    {
        popv(4);
        return  Llist4(a, q, m, arg4);
    }
   G0018:
#define LL_Bloc LITERAL[5]
    if(a != LL_Bloc) goto    G0026;
    q = car(cdr(car(w1)));
#define LL_callTname LITERAL[6]
    a = LL_callTname;
    a = Llist2(a, q);
    w4 = a;
    a = cdr(w1);
    a = CC_mkQgargs(a);
    m = a;
    q = w4;
    goto    G0101;
   G0026:
#define LL_Bdcl LITERAL[7]
    if(a != LL_Bdcl) goto    G0030;
    a = cdr(w1);
    a = CC_mkQgargs(a);
    m = a;
    q = car(cdr(car(w1)));
    goto    G0101;
   G0030:
#define LL_Bgex LITERAL[8]
    if(a != LL_Bgex) goto    G0033;
    a = car(cdr(car(w1)));
    a = CC_callTname(a);
    a = Lmkquote(a);
    w4 = a;
    a = cdr(w1);
    a = CC_mkQgargs(a);
    m = a;
    q = w4;
    goto    G0101;
   G0033:
#define LL_Bqid LITERAL[9]
    if(a != LL_Bqid) goto    G0038;
    a = car(cdr(car(w1)));
    if(!is_symbol(a)) goto    G0038;
    a = Lmkquote(a);
    w4 = a;
    a = cdr(w1);
    a = CC_mkQgargs(a);
    m = a;
    q = w4;
   G0101:
#define LL_gevTfunc LITERAL[10]
    a = LL_gevTfunc;
    goto    G0112;
   G0038:
    q = car(w1);
   G0098:
    a = LITERAL[11];
    CC_errormsg(a, q);
    a = nil;
    goto    G0094;
   G0014:
#define LL_BgevalB LITERAL[12]
    q = LL_BgevalB;
    a = Lget(a, q);
#define LL_Htemporal LITERAL[13]
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0044;
#define LL_lisp LITERAL[14]
    if(a == LL_lisp) goto    G0113;
#define LL_flag LITERAL[15]
    if(a != LL_flag) goto    G0047;
    a = car(w1);
    a = Lmkquote(a);
    w2 = a;
    a = car(cdr(w1));
    a = CC_mkQunevl(a);
    m = a;
    q = w2;
#define LL_flagcmndH LITERAL[16]
    a = LL_flagcmndH;
    goto    G0112;
   G0047:
#define LL_local LITERAL[17]
    if(a != LL_local) goto    G0050;
    a = car(w1);
    if(a != LL_Bloc) goto    G0052;
    a = car(cdr(w1));
    goto    G0094;
   G0052:
    if(a != LL_Bdcl) goto    G0053;
    q = car(cdr(w1));
   G0097:
#define LL_gevTid LITERAL[18]
    a = LL_gevTid;
    {
        popv(4);
        return  Llist2(a, q);
    }
   G0053:
    a = car(cdr(w1));
    w1 = a;
    if(!is_number(a)) goto    G0106;
    goto    G0094;
   G0050:
    a = car(w1);
#define LL_gTM LITERAL[19]
    if(a != LL_gTM) goto    G0056;
    q = nil;
    a = w1;
    {
        popv(4);
        return  CC_mkQgsetq(a, q);
    }
   G0056:
    if(a != LL_Bqid) goto    G0057;
    a = car(cdr(w1));
    w1 = a;
    if(is_symbol(a)) goto    G0106;
    q = a;
    a = LITERAL[20];
    goto    G0107;
   G0057:
    if(a != LL_Bindex) goto    G0061;
    w2 = nil;
    a = car(cdr(w1));
    w2 = a;
    if(!is_cons(a)) goto    G0066;
    q = LITERAL[2];
    a = car(a);
    a = Lmemq(a, q);
    if(a != nil) goto    G0066;
    q = w2;
    a = LITERAL[3];
    CC_errormsg(a, q);
   G0066:
    a = w2;
    a = CC_quoteTid(a);
    w2 = a;
    a = cdr(cdr(w1));
    a = CC_mkQgargs(a);
    m = a;
    q = w2;
#define LL_gevTxid LITERAL[21]
    a = LL_gevTxid;
    goto    G0112;
   G0061:
#define LL_Bquote LITERAL[22]
    if(a != LL_Bquote) goto    G0069;
    a = car(cdr(w1));
   G0106:
    {
        popv(4);
        return  Lmkquote(a);
    }
   G0069:
    q = LITERAL[23];
    a = mkfxat(1);
   G0107:
    {
        popv(4);
        return  CC_errormsg(a, q);
    }
   G0044:
#define LL_BgcmndB LITERAL[24]
    q = LL_BgcmndB;
    a = car(w1);
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0071;
    w2 = nil;
    w2 = a;
    if(!is_cons(a)) goto    G0074;
    q = car(a);
    a = w1;
    car(a) = q;
    a = cdr(w2);
    w2 = a;
   G0074:
    if(a != nil) goto    G0076;
    q = cdr(w1);
#define LL_mkQgprog LITERAL[25]
    a = LL_mkQgprog;
    CC_fmapelm(a, q);
    goto    G0113;
   G0076:
#define LL_Bpfunc LITERAL[26]
    if(a != LL_Bpfunc) goto    G0077;
    a = car(w1);
    a = Lmkquote(a);
    w3 = a;
    a = cdr(w1);
    a = CC_mkQgargs(a);
    m = a;
    q = w3;
#define LL_gevTpfunc LITERAL[27]
    a = LL_gevTpfunc;
    goto    G0112;
   G0077:
#define LL_Bnarg LITERAL[28]
    if(a != LL_Bnarg) goto    G0080;
    a = car(w1);
    a = Lmkquote(a);
    w3 = a;
    a = cdr(w1);
    a = CC_mkQgargs(a);
    m = a;
    q = w3;
#define LL_gevTnarg LITERAL[29]
    a = LL_gevTnarg;
    goto    G0112;
   G0080:
#define LL_Bunevl LITERAL[30]
    if(a != LL_Bunevl) goto    G0083;
    a = car(w1);
    a = Lmkquote(a);
    w3 = a;
    a = cdr(w1);
    a = CC_mkQunevl(a);
    m = a;
    q = w3;
    a = LL_gevTfunc;
    goto    G0112;
   G0083:
    a = cdr(w1);
    a = Llength(a);
    q = w2;
    a = Lgeq(a, q);
    if(a == nil) goto    G0086;
    q = cdr(w1);
    a = LL_mkQgprog;
    CC_fmapelm(a, q);
    goto    G0113;
   G0086:
    a = w1;
    a = CC_tail(a);
    w3 = a;
    a = nil;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    a = w1;
    goto    G0114;  /* recursive call to mk.gprog */
   G0071:
    a = car(w1);
    a = Lgetd(a);
    if(a == nil) goto    G0093;
    q = cdr(w1);
    a = LL_mkQgprog;
    CC_fmapelm(a, q);
   G0113:
    a = w1;
    goto    G0094;
   G0093:
    a = car(w1);
    a = Lmkquote(a);
    w2 = a;
    a = cdr(w1);
    a = CC_mkQgargs(a);
    m = a;
    q = w2;
    a = LL_gevTfunc;
   G0112:
    a = Llist3(a, q, m);
   G0094:
    popv(4);
    return a;
}

Sex CC_quoteTid(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0117;
    if(!is_symbol(a)) goto    G0119;
    if(a == nil) goto    G0119;
    q = a;
    a = LL_quote;
    goto    G0128;
   G0119:
    q = a;
    goto    G0127;
   G0117:
    a = car(a);
    if(a != LL_Bloc) goto    G0122;
    q = car(cdr(w1));
    a = LL_callTname;
    goto    G0128;
   G0122:
    if(a != LL_Bdcl) goto    G0123;
    a = car(cdr(w1));
    goto    G0125;
   G0123:
    if(a != LL_Bgex) goto    G0124;
    q = car(cdr(w1));
    a = LL_callTname;
   G0128:
    {
        popv(1);
        return  Llist2(a, q);
    }
   G0124:
    q = w1;
   G0127:
    a = LITERAL[31];
    a = CC_errormsg(a, q);
   G0125:
    popv(1);
    return a;
}

Sex CC_mkQgargs(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = a;
    a = LL_mkQgprog;
    CC_fmapelm(a, q);
    q = w1;
#define LL_list LITERAL[32]
    a = LL_list;
    {
        popv(1);
        return  cons(a, q);
    }
}

Sex CC_mkQgsimp(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0136;
    q = LITERAL[33];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0135;
    a = w1;
    goto    G0136;
   G0135:
    q = w1;
#define LL_gsimpH LITERAL[34]
    a = LL_gsimpH;
    a = Llist2(a, q);
   G0136:
    popv(1);
    return a;
}

Sex CC_mkQgsetq(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
   G0169:
    w1 = a;
    a = car(cdr(a));
    w3 = a;
    a = car(cdr(cdr(w1)));
    w4 = a;
    w2 = q;
    a = w3;
    if(is_cons(a)) goto    G0142;
    a = Lmkquote(a);
    goto    G0168;
   G0142:
    a = car(a);
    if(is_cons(a)) goto    G0143;
    if(a != LL_Bloc) goto    G0145;
    a = w4;
    a = CC_mkQgprog(a);
    m = a;
    q = car(cdr(w3));
#define LL_setq LITERAL[35]
    a = LL_setq;
    goto    G0165;
   G0145:
    if(a != LL_Bdcl) goto    G0148;
    a = car(cdr(w3));
    goto    G0168;
   G0148:
    q = cdr(w3);
    a = LL_mkQgprog;
    CC_fmapelm(a, q);
    a = car(w3);
    a = Lmkquote(a);
    q = cdr(w3);
    a = cons(a, q);
    q = LL_list;
    a = Lxcons(a, q);
    goto    G0168;
   G0143:
    a = car(a);
    if(a != LL_Bloc) goto    G0152;
    q = cdr(w3);
    a = LL_mkQgprog;
    CC_fmapelm(a, q);
    q = LL_callTname;
    a = car(w3);
    car(a) = q;
    q = w3;
    a = LL_list;
    a = cons(a, q);
    goto    G0168;
   G0152:
    if(a != LL_Bdcl) goto    G0140;
    q = cdr(w3);
    a = LL_mkQgprog;
    CC_fmapelm(a, q);
    q = car(cdr(car(w3)));
    a = w3;
    car(a) = q;
    q = w3;
    a = LL_list;
    a = cons(a, q);
   G0168:
    w3 = a;
    a = w4;
    if(!is_cons(a)) goto    G0156;
    a = car(a);
    if(a != LL_gTM) goto    G0156;
    q = w2;
    a = w3;
    a = cons(a, q);
    q = a;
    a = w4;
    goto    G0169;  /* recursive call to mk.gsetq */
   G0156:
    q = w2;
    a = w3;
    a = cons(a, q);
    q = LL_list;
    a = Lxcons(a, q);
    w5 = a;
    a = w4;
    a = CC_mkQgprog(a);
    m = a;
    q = w5;
    a = LL_gTM;
   G0165:
    {
        popv(5);
        return  Llist3(a, q, m);
    }
   G0140:
    q = w3;
    a = LITERAL[36];
    CC_errormsg(a, q);
    a = nil;
    popv(5);
    return a;
}

Sex CC_mkTerrsetprog(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w3 = nil;
    w2 = nil;
    w4 = nil;
    w1 = a;
    a = car(a);
    a = Lncons(a);
    w3 = a;
    w2 = a;
   G0172:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0183;
    a = car(a);
    if(is_cons(a)) goto    G0177;
    if(is_number(a)) goto    G0179;
    if(is_string(a)) goto    G0179;
   G0177:
    q = a;
    a = LL_quote;
    a = Llist2(a, q);
   G0179:
    w4 = a;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    goto    G0172;
   G0183:
    a = w2;
    popv(4);
    return a;
}

Sex CC_flagcmndH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
#define LL_Bonfflg LITERAL[37]
    q = LL_Bonfflg;
    a = Lget(a, q);
    w5 = a;
    a = car(a);
    w3 = a;
    a = car(cdr(w5));
    w4 = a;
    a = w3;
    a = Leval(a);
    q = w3;
    a = Lxcons(a, q);
#define LL_Qgstack LITERAL[38]
    q = value(LL_Qgstack);
    a = cons(a, q);
    value(LL_Qgstack) = a;
    q = w4;
    a = w3;
    Lset(a, q);
    a = w2;
    a = CC_galeval(a);
    w5 = a;
    q = cdr(car(value(LL_Qgstack)));
    a = w3;
    Lset(a, q);
    a = cdr(value(LL_Qgstack));
    value(LL_Qgstack) = a;
    a = w5;
    popv(5);
    return a;
}

Sex CC_callTname(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0191;
    if(!is_symbol(a)) goto    G0193;
    if(a != nil) goto    G0201;
   G0193:
    if(!is_number(a)) goto    G0197;
    a = LITERAL[39];
    goto    G0198;
   G0197:
    a = LITERAL[40];
   G0198:
    q = nil;
    CC_printmsg(a, q);
    q = w1;
    a = LITERAL[41];
    goto    G0207;
   G0191:
    a = CC_Wsingleid(a);
    w1 = a;
    if(a != nil) goto    G0201;
    a = CC_Warray(a);
    if(a != nil) goto    G0204;
    a = w1;
    a = CC_Wform(a);
    if(a == nil) goto    G0203;
   G0204:
    a = LITERAL[40];
    goto    G0205;
   G0203:
    a = LITERAL[39];
   G0205:
    q = nil;
    CC_printmsg(a, q);
    q = nil;
    a = LITERAL[42];
   G0207:
    a = CC_errormsg(a, q);
   G0201:
    popv(1);
    return a;
}

Sex CC_gevTid(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Bgid LITERAL[43]
    q = LL_Bgid;
    a = Lget(a, q);
    if(a != nil) goto    G0211;
    q = nil;
    a = w1;
    CC_internTid(a, q);
   G0211:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0213;
    a = w1;
    a = CC_evlmodeT(a);
#define LL_uneval LITERAL[44]
    q = LL_uneval;
    a = Lneq(a, q);
    if(a == nil) goto    G0213;
    q = value(LL_Htemporal);
    a = w1;
    {
        popv(1);
        return  CC_evlTsexpr(a, q);
    }
   G0213:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    value(LL_Htemporal) = a;
    q = a;
#define LL_indxed LITERAL[45]
    a = LL_indxed;
    a = Lmemq(a, q);
    if(a == nil) goto    G0217;
    q = w1;
    a = LITERAL[46];
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
   G0217:
    q = value(LL_Htemporal);
    a = w1;
    {
        popv(1);
        return  CC_convTid2expr(a, q);
    }
}

Sex CC_gevTxid(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a != nil) goto    G0224;
    q = nil;
    a = w1;
    CC_internTid(a, q);
    q = LL_indxed;
    a = w1;
    CC_addTidtype(a, q);
   G0224:
    a = w2;
    if(a != nil) goto    G0226;
    q = w1;
    a = LITERAL[47];
    goto    G0234;
   G0226:
    a = CC_Wchkindex(a);
    if(a != nil) goto    G0227;
    q = w1;
    a = LITERAL[48];
    goto    G0234;
   G0227:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    value(LL_Htemporal) = a;
    q = a;
    a = LL_indxed;
    a = Lmemq(a, q);
    if(a == nil) goto    G0228;
    q = w2;
    a = w1;
    a = cons(a, q);
    q = value(LL_Htemporal);
    {
        popv(2);
        return  CC_convTid2expr(a, q);
    }
   G0228:
    q = w1;
    a = LITERAL[49];
   G0234:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
}

Sex CC_gevTnarg(Sex a, Sex q)
{
    {
        return  Lfuncall1(a, q);
    }
}

Sex CC_gevTpfunc(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    if(a != nil) goto    G0241;
    q = w1;
    a = mkfxat(2);
    CC_errormsg(a, q);
   G0241:
    a = w1;
    a = CC_cmpmodeT(a);
#define LL_uncomp LITERAL[50]
    if(a != LL_uncomp) goto    G0243;
    q = w2;
    a = w1;
    a = CC_mkTpfunc(a, q);
    q = true;
    {
        popv(2);
        return  CC_convTfunc2expr(a, q);
    }
   G0243:
    q = w2;
#define LL_mkquote LITERAL[51]
    a = LL_mkquote;
    CC_fmapelm(a, q);
    q = w2;
    a = w1;
    a = cons(a, q);
    {
        popv(2);
        return eval(a, nil);
    }
}

Sex CC_gevTfunc(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lgetd(a);
    if(a == nil) goto    G0251;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G0253;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
#define LL_pfunc LITERAL[52]
    a = LL_pfunc;
    a = Lmemq(a, q);
    if(a == nil) goto    G0253;
    q = w2;
    a = w1;
    {
        popv(6);
        return  CC_gevTpfunc(a, q);
    }
   G0253:
    q = w2;
    a = w1;
    {
        popv(6);
        return  Lapply(a, q);
    }
   G0251:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a != nil) goto    G0266;
#define LL_func LITERAL[53]
    q = LL_func;
    a = w1;
    CC_internTid(a, q);
    goto    G0267;
   G0266:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w3 = a;
    if(a == nil) goto    G0267;
    q = LITERAL[54];
    a = car(cdr(a));
    a = Lmemq(a, q);
    if(a != nil) goto    G0277;
   G0267:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w4 = a;
    q = a;
    a = LL_func;
    a = Lmemq(a, q);
    if(a == nil) goto    G0271;
    q = w2;
    a = w1;
    a = CC_mkTfunc(a, q);
    q = w6;
    {
        popv(6);
        return  CC_convTfunc2expr(a, q);
    }
   G0271:
    q = LITERAL[55];
    a = car(w4);
    a = Lmemq(a, q);
    if(a != nil) goto    G0277;
    q = w1;
    a = LITERAL[56];
    CC_errormsg(a, q);
   G0277:
    a = w2;
    a = CC_Wintlist(a);
    if(a != nil) goto    G0280;
#define LL_Hsindex LITERAL[57]
    a = value(LL_Hsindex);
    if(a == nil) goto    G0280;
    a = w2;
    a = CC_Wchkindex(a);
    if(a != nil) goto    G0263;
   G0280:
    a = w1;
    a = CC_evlmodeT(a);
    w6 = a;
    if(a == LL_uneval) goto    G0263;
    a = w3;
    if(a == nil) goto    G0284;
    a = cdr(cdr(a));
    w4 = a;
    goto    G0285;
   G0284:
    q = w1;
    a = LITERAL[58];
    CC_errormsg(a, q);
   G0285:
    a = car(w4);
    if(is_vector(a)) goto    G0262;
    a = cdr(w4);
    w4 = a;
    q = cdr(w4);
    a = w2;
    a = CC_addressH(a, q);
    q = a;
    a = car(w4);
    a = Lgetv(a, q);
    w5 = a;
    q = car(w3);
    a = w6;
    a = cons(a, q);
    q = w5;
    {
        popv(6);
        return  CC_evlTgexpr(a, q);
    }
   G0262:
    q = cdr(w4);
    a = w2;
    a = CC_addressH(a, q);
    q = a;
    a = car(w4);
    a = Lgetv(a, q);
    w5 = a;
#define LL_Anil LITERAL[59]
    q = LL_Anil;
    a = Lneq(a, q);
    if(a == nil) goto    G0294;
    q = w5;
    a = w6;
    {
        popv(6);
        return  CC_evlTsexpr(a, q);
    }
   G0294:
    q = w1;
    a = LITERAL[60];
    CC_optionmsg(a, q);
    a = LL_Anil;
    goto    G0258;
   G0263:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
#define LL_uncom LITERAL[61]
    a = LL_uncom;
    a = Lmemq(a, q);
    if(a == nil) goto    G0297;
    q = w2;
    a = w1;
    a = cons(a, q);
#define LL_ncH LITERAL[62]
    q = LL_ncH;
    {
        popv(6);
        return  CC_convTvar2pref(a, q);
    }
   G0297:
    q = w2;
    a = w1;
    a = cons(a, q);
#define LL_CpolyC LITERAL[63]
    q = value(LL_CpolyC);
    {
        popv(6);
        return  CC_convTvar2cano(a, q);
    }
    q = w2;
    a = LITERAL[64];
    CC_errormsg(a, q);
    a = nil;
   G0258:
    popv(6);
    return a;
}

Sex CC_gevTxfunc(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_evlmodeT(a);
    q = LL_uneval;
    a = Lneq(a, q);
    if(a == nil) goto    G0308;
    a = true;
    w6 = a;
   G0308:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a != nil) goto    G0311;
    q = LL_func;
    a = w1;
    CC_internTid(a, q);
    q = LL_indxed;
    a = w1;
    CC_addTidtype(a, q);
   G0311:
    a = w2;
    a = CC_Wchkindex(a);
    if(a != nil) goto    G0313;
    q = w1;
    a = LITERAL[48];
    goto    G0322;
   G0313:
    a = w2;
    if(a != nil) goto    G0314;
    q = w1;
    a = LITERAL[47];
    goto    G0322;
   G0314:
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w4 = a;
    q = a;
    a = LL_func;
    a = Lmemq(a, q);
    if(a != nil) goto    G0315;
    q = w1;
    a = LITERAL[65];
   G0322:
    CC_errormsg(a, q);
   G0315:
    q = w2;
    a = LL_Bindex;
    a = cons(a, q);
    q = a;
    a = w1;
    a = Llist2(a, q);
    q = w3;
    a = CC_mkTfunc(a, q);
    w5 = a;
    q = w6;
    {
        popv(6);
        return  CC_convTfunc2expr(a, q);
    }
}

Sex CC_gevTset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    if(a != nil) goto    G0326;
    a = LL_Anil;
    goto    G0327;
   G0326:
    w2 = q;
#define LL_galeval LITERAL[66]
    a = LL_galeval;
    CC_fmapelm(a, q);
    a = w1;
#define LL_Boset LITERAL[67]
    if(a != LL_Boset) goto    G0329;
    q = w2;
    a = LL_Boset;
    {
        popv(2);
        return  cons(a, q);
    }
   G0329:
    q = w2;
#define LL_Bset LITERAL[68]
    a = LL_Bset;
    a = cons(a, q);
    a = CC_seTsortset(a);
   G0327:
    popv(2);
    return a;
}

Sex CC_gevTarform(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = q;
    a = CC_prodelms(a);
    a = Labs(a);
    w8 = a;
    a = Lmkvect(a);
    w4 = a;
    q = w2;
    a = w8;
    a = cons(a, q);
    w5 = a;
    m = nil;
    q = mkfxat(0);
    a = w4;
    Lputv(a, q, m);
    a = mkfxat(0);
    w7 = a;
    a = w1;
#define LL_array LITERAL[69]
    if(a == LL_array) goto    G0337;
   G0342:
    a = car(w3);
    a = CC_galeval(a);
    w8 = a;
    if(is_cons(a)) goto    G0344;
    if(!is_number(a)) goto    G0336;
    goto    G0353;
   G0344:
    a = car(a);
    if(!is_integer(a)) goto    G0348;
#define LL_CmaxcanoC LITERAL[70]
    if(a >= value(LL_CmaxcanoC)) goto    G0336;
    goto    G0353;
   G0348:
#define LL_BctypeB LITERAL[71]
    q = LL_BctypeB;
    a = Lget(a, q);
#define LL_rat LITERAL[72]
    if(a != LL_rat) goto    G0336;
   G0353:
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    m = w8;
    q = a;
    a = w4;
    Lputv(a, q, m);
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0361;
    goto    G0342;
   G0336:
    q = nil;
    a = LITERAL[73];
    CC_errormsg(a, q);
   G0337:
#define LL_CsimpenvC LITERAL[74]
    q = value(LL_CsimpenvC);
#define LL_CordenvC LITERAL[75]
    a = value(LL_CordenvC);
    a = cons(a, q);
#define LL_CevalenvC LITERAL[76]
    q = value(LL_CevalenvC);
    a = Lxcons(a, q);
    w6 = a;
   G0338:
    a = car(w3);
    a = CC_galeval(a);
    m = w6;
    q = nil;
    a = CC_convTgexpr2sexpr(a, q, m);
    w8 = a;
    a = w7;
    a = (Sex)((long)a + 0x10);
    w7 = a;
    m = w8;
    q = a;
    a = w4;
    Lputv(a, q, m);
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0338;
   G0361:
    a = w1;
#define LL_matx LITERAL[77]
    if(a != LL_matx) goto    G0363;
    a = car(cdr(cdr(w5)));
    w8 = a;
    a = Lplusp(a);
    if(a == nil) goto    G0363;
    a = w8;
    a = Lminus(a);
    q = a;
    a = cdr(cdr(w5));
    car(a) = q;
   G0363:
    q = w5;
    a = w4;
    a = cons(a, q);
    w4 = a;
    a = w1;
    if(a != LL_matx) goto    G0368;
    q = w4;
#define LL_CmatxC LITERAL[78]
    a = value(LL_CmatxC);
    goto    G0374;
   G0368:
#define LL_vect LITERAL[79]
    if(a != LL_vect) goto    G0369;
    q = w4;
#define LL_CvectC LITERAL[80]
    a = value(LL_CvectC);
    goto    G0374;
   G0369:
#define LL_tens LITERAL[81]
    if(a != LL_tens) goto    G0370;
    q = w4;
#define LL_CtensC LITERAL[82]
    a = value(LL_CtensC);
   G0374:
    {
        popv(8);
        return  cons(a, q);
    }
   G0370:
    a = w4;
    popv(8);
    return a;
}

Sex CC_addressH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w3 = nil;
    w5 = nil;
    w4 = a;
    w1 = a;
    a = cdr(q);
    w2 = a;
    a = car(w1);
    a = Lzerop(a);
    if(a == nil) goto    G0381;
    a = cdr(w1);
    if(a != nil) goto    G0381;
    a = mkfxat(0);
    goto    G0377;
   G0381:
    a = car(w2);
    a = Labs(a);
    w6 = a;
    a = car(w4);
    a = Labs(a);
    w3 = a;
    if(w6 < a) goto    G0379;
   G0384:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0388;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0390;
    a = w3;
    goto    G0377;
   G0390:
    q = w1;
    a = LITERAL[83];
    goto    G0399;
   G0388:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0392;
    q = w1;
    a = LITERAL[84];
   G0399:
    CC_errormsg(a, q);
    goto    G0393;
   G0392:
    a = car(a);
    a = Labs(a);
    w6 = a;
    a = car(w4);
    a = Labs(a);
    q = a;
    a = w6;
    a = (Sex)((long)a - (long)q + TAG_FIXNUM);
    w5 = a;
    a = Lminusp(a);
    if(a != nil) goto    G0379;
   G0393:
    a = car(w2);
    a = Labs(a);
    q = a;
    a = w3;
    a = Litimes2(a, q);
    q = w5;
    a = (Sex)((long)a - (long)q + TAG_FIXNUM);
    w3 = a;
    goto    G0384;
   G0379:
    q = w1;
    a = LITERAL[64];
    CC_errormsg(a, q);
    a = nil;
   G0377:
    popv(6);
    return a;
}

Sex CC_Wchkindex(Sex a)
{
    Sex q, m, arg4;
    arg4 = nil;
    m = a;
   G0403:
    a = m;
    if(a != nil) goto    G0405;
    a = true;
    goto    G0402;
   G0405:
    a = car(a);
    arg4 = a;
    if(is_cons(a)) goto    G0406;
    if(is_integer(a)) goto    G0413;
    if(!is_rational(a)) goto    G0411;
    goto    G0413;
   G0406:
    a = car(a);
    if(!is_integer(a)) goto    G0411;
    if(a >= value(LL_CmaxcanoC)) goto    G0411;
   G0413:
    a = cdr(m);
    m = a;
    goto    G0403;
   G0411:
    a = nil;
   G0402:
    return a;
}

Sex CC_convTrel2prd(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0419;
    a = car(a);
    if(!is_cons(a)) goto    G0421;
    CC_convTrel2prd(a);
    goto    G0423;
   G0421:
    if(!is_symbol(a)) goto    G0423;
#define LL_Brel2prd LITERAL[85]
    q = LL_Brel2prd;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0423;
    q = a;
    a = w1;
    car(a) = q;
   G0423:
    a = cdr(w1);
    a = CC_convTrel2prd(a);
   G0419:
    popv(1);
    return a;
}

Sex CC_convTprd2rel(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0428;
    a = car(a);
    if(!is_cons(a)) goto    G0430;
    CC_convTprd2rel(a);
    goto    G0432;
   G0430:
    if(!is_symbol(a)) goto    G0432;
#define LL_Bprd2rel LITERAL[86]
    q = LL_Bprd2rel;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0432;
    q = a;
    a = w1;
    car(a) = q;
   G0432:
    a = cdr(w1);
    a = CC_convTrel2prd(a);
   G0428:
    popv(1);
    return a;
}

Sex CC_Amkexpr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0436;
    if(!is_symbol(a)) goto    G0456;
#define LL_uniqrep LITERAL[87]
    q = LL_uniqrep;
    a = CC_getTsimprs(a, q);
    value(LL_Htemporal) = a;
    if(a != nil) goto    G0456;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
    goto    G0457;
   G0436:
    a = car(a);
    if(is_symbol(a)) goto    G0443;
    if(!is_integer(a)) goto    G0445;
#define LL_CmaxformC LITERAL[88]
    if(a < value(LL_CmaxformC)) goto    G0459;
   G0445:
    a = w1;
    a = CC_Warray(a);
    if(a == nil) goto    G0451;
    goto    G0459;
   G0443:
    q = LL_BctypeB;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0449;
#define LL_gal LITERAL[89]
    q = LL_gal;
    a = Lneq(a, q);
    if(a == nil) goto    G0451;
   G0459:
    a = w1;
    goto    G0456;
   G0451:
    q = LITERAL[90];
    a = mkfxat(3);
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
   G0449:
    q = LL_Bgid;
    a = car(w1);
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    value(LL_Htemporal) = a;
    q = a;
    a = LL_func;
    a = Lmemq(a, q);
    if(a == nil) goto    G0453;
    q = true;
    a = w1;
    {
        popv(1);
        return  CC_convTfunc2expr(a, q);
    }
   G0453:
    q = value(LL_Htemporal);
   G0457:
    a = w1;
    a = CC_convTid2expr(a, q);
   G0456:
    popv(1);
    return a;
}

Sex CC_Afunc2expr(Sex a)
{
    Sex q;
    q = true;
    {
        return  CC_convTfunc2expr(a, q);
    }
}

Sex CC_Avar2expr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0467;
    a = car(a);
   G0467:
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    q = a;
    a = w1;
    {
        popv(1);
        return  CC_convTid2expr(a, q);
    }
}

Sex CC_Aexpr2varfunc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0474;
    if(!is_symbol(a)) goto    G0487;
    goto    G0488;
   G0474:
    a = car(a);
    if(!is_integer(a)) goto    G0478;
    a = w1;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G0487;
    a = car(cdr(w1));
    goto    G0488;
   G0478:
    if(!is_symbol(a)) goto    G0487;
    q = LL_BctypeB;
    a = Lget(a, q);
    if(a == nil) goto    G0492;
    q = LITERAL[91];
    a = car(w1);
    a = Lmemq(a, q);
    if(a == nil) goto    G0487;
    a = car(cdr(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G0487;
    a = cdr(cdr(cdr(w1)));
    if(a != nil) goto    G0487;
    a = car(cdr(w1));
    w1 = a;
    if(!is_cons(a)) goto    G0488;
    a = car(a);
    a = CC_Wfunc(a);
    if(a == nil) goto    G0487;
   G0492:
    a = w1;
    goto    G0488;
   G0487:
#define LL_invalid LITERAL[92]
    a = LL_invalid;
   G0488:
    popv(1);
    return a;
}

Sex CC_mkTfunc(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = LL_gsimpH;
    CC_fmapelm(a, q);
    q = w2;
    a = w1;
    a = cons(a, q);
    w3 = a;
    a = w1;
    if(is_cons(a)) goto    G0499;
    a = w2;
    if(a == nil) goto    G0518;
    a = cdr(a);
    if(a != nil) goto    G0518;
    a = car(w2);
    w5 = a;
    if(is_number(a)) goto    G0507;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G0518;
    goto    G0507;
   G0499:
    a = cdr(a);
    if(a == nil) goto    G0506;
    a = car(a);
    w5 = a;
    if(!is_cons(a)) goto    G0506;
    q = LL_Bindex;
    a = car(a);
    a = Lneq(a, q);
    if(a != nil) goto    G0506;
    q = w2;
    a = w5;
    a = cons(a, q);
    q = car(w1);
    {
        popv(5);
        return  Lxcons(a, q);
    }
   G0506:
    q = w1;
    a = LITERAL[11];
    CC_errormsg(a, q);
   G0507:
    q = LL_uniqrep;
    a = w1;
    a = CC_getTsimprs(a, q);
    w4 = a;
    if(a != nil) goto    G0511;
    q = w3;
#define LL_head LITERAL[93]
    a = LL_head;
    a = Llist2(a, q);
    w4 = a;
    m = a;
    q = LL_uniqrep;
    a = w1;
    CC_putTsimprs(a, q, m);
    goto    G0518;
   G0511:
    q = cdr(car(cdr(w4)));
    a = w2;
    a = CC_orderRMS(a, q);
    w5 = a;
    if(a != CHAR_OF(61)) goto    G0513;
    a = car(cdr(w4));
    goto    G0496;
   G0513:
    if(a != CHAR_OF(62)) goto    G0514;
    q = cdr(w4);
    a = w3;
    a = cons(a, q);
    goto    G0522;
   G0514:
    a = cdr(w4);
    w4 = a;
    a = cdr(a);
    if(a != nil) goto    G0511;
    a = w3;
    a = Lncons(a);
   G0522:
    q = a;
    a = w4;
    cdr(a) = q;
   G0518:
    a = w3;
   G0496:
    popv(5);
    return a;
}

Sex CC_mkTpfunc(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
#define LL_Bargclass LITERAL[94]
    q = LL_Bargclass;
    a = Lget(a, q);
    w3 = a;
    if(!is_cons(a)) goto    G0530;
    a = car(a);
    w3 = a;
   G0530:
    a = w2;
    a = Llength(a);
    w6 = a;
    a = Lonep(a);
    if(a == nil) goto    G0534;
#define LL_arg1 LITERAL[95]
    q = LL_arg1;
    a = w3;
    a = Lneq(a, q);
    if(a != nil) goto    G0536;
   G0534:
    q = mkfxat(2);
    a = w6;
    a = Lequal(a, q);
    if(a == nil) goto    G0532;
    q = LITERAL[96];
    a = w3;
    a = Lmemq(a, q);
    if(a == nil) goto    G0532;
   G0536:
    a = w2;
    a = CC_tail(a);
    w7 = a;
    a = nil;
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
   G0532:
    q = LITERAL[97];
    a = w3;
    a = Lmemq(a, q);
    if(a == nil) goto    G0541;
    q = w2;
    a = LL_gsimpH;
    CC_fmapelm(a, q);
    goto    G0562;
   G0541:
    a = car(w2);
    a = CC_gsimpH(a);
    q = a;
    a = w2;
    car(a) = q;
    a = cdr(w2);
    w4 = a;
    a = w3;
#define LL_argxy1 LITERAL[98]
    if(a != LL_argxy1) goto    G0545;
    a = car(w4);
    a = CC_gsimpH(a);
    q = a;
    a = w4;
    car(a) = q;
    a = cdr(w4);
    w4 = a;
   G0545:
    a = car(w4);
    w6 = a;
    if(!is_cons(a)) goto    G0554;
#define LL_rM LITERAL[99]
    q = LL_rM;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0549;
    a = w6;
    a = CC_Aexpr2varfunc(a);
    w5 = a;
    goto    G0570;
   G0549:
    a = car(cdr(w6));
    a = CC_Aexpr2varfunc(a);
    w5 = a;
    m = car(cdr(cdr(w6)));
    q = a;
    a = car(w6);
    a = Llist3(a, q, m);
   G0570:
    w6 = a;
    q = LL_invalid;
    a = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G0553;
    q = w6;
    a = w4;
    car(a) = q;
    goto    G0554;
   G0553:
    q = w1;
    a = LITERAL[100];
    CC_errormsg(a, q);
   G0554:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0556;
    q = LITERAL[101];
    a = w3;
    a = Lmemq(a, q);
    if(a != nil) goto    G0545;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0545;
   G0556:
    a = car(w2);
    w6 = a;
    a = CC_Wsinglefunc(a);
    if(a == nil) goto    G0562;
    q = car(car(cdr(w6)));
    a = w1;
    a = Lneq(a, q);
    if(a == nil) goto    G0561;
   G0562:
    q = w2;
    a = w1;
    {
        popv(7);
        return  cons(a, q);
    }
   G0561:
#define LL_mkfunc LITERAL[102]
    q = LL_mkfunc;
    a = w1;
    a = CC_getTsimprs(a, q);
    w6 = a;
    if(a == nil) goto    G0565;
    m = cdr(w2);
    q = car(cdr(car(w2)));
    {
        popv(7);
        return  Lfuncall2(a, q, m);
    }
   G0565:
    q = cdr(w2);
    a = car(cdr(car(w2)));
    {
        popv(7);
        return  Lappend(a, q);
    }
}

Sex CC_convTid2expr(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
#define LL_var LITERAL[103]
    a = LL_var;
    a = Lmemq(a, q);
    if(a == nil) goto    G0574;
    a = cdr(w2);
    if(a != nil) goto    G0576;
    q = value(LL_CpolyC);
    a = w1;
    goto    G0605;
   G0576:
    q = w2;
    a = LL_uncom;
    a = Lmemq(a, q);
    if(a != nil) goto    G0600;
    a = car(w2);
#define LL_algf LITERAL[104]
    if(a != LL_algf) goto    G0578;
    a = w1;
    if(is_cons(a)) goto    G0580;
#define LL_CalgfC LITERAL[105]
    q = value(LL_CalgfC);
    goto    G0605;
   G0580:
    q = car(a);
    a = LITERAL[106];
    goto    G0602;
   G0578:
    q = value(LL_CpolyC);
    a = w1;
    goto    G0605;
   G0574:
    q = w2;
#define LL_num LITERAL[107]
    a = LL_num;
    a = Lmemq(a, q);
    if(a == nil) goto    G0583;
    a = car(w2);
#define LL_algn LITERAL[108]
    if(a != LL_algn) goto    G0585;
    a = w1;
    if(is_cons(a)) goto    G0587;
#define LL_CalgnC LITERAL[109]
    q = value(LL_CalgnC);
    goto    G0605;
   G0587:
    q = car(a);
    a = LITERAL[110];
   G0602:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0585:
    q = value(LL_CpolyC);
    a = w1;
    goto    G0605;
   G0583:
    q = w2;
    a = LL_func;
    a = Lmemq(a, q);
    if(a == nil) goto    G0590;
    a = w1;
    if(!is_cons(a)) goto    G0592;
    q = cdr(a);
    a = LL_Bindex;
    a = cons(a, q);
    q = a;
    a = car(w1);
    a = Llist2(a, q);
    w1 = a;
   G0592:
    q = nil;
    a = CC_mkTfunc(a, q);
    q = true;
    {
        popv(2);
        return  CC_convTfunc2expr(a, q);
    }
   G0590:
    q = w2;
#define LL_symbol LITERAL[111]
    a = LL_symbol;
    a = Lmemq(a, q);
    if(a == nil) goto    G0595;
    a = w1;
    goto    G0598;
   G0595:
    a = w1;
    if(!is_cons(a)) goto    G0598;
    q = w2;
    a = LL_uncom;
    a = Lmemq(a, q);
    if(a == nil) goto    G0597;
   G0600:
    q = LL_ncH;
    a = w1;
    {
        popv(2);
        return  CC_convTvar2pref(a, q);
    }
   G0597:
    q = value(LL_CpolyC);
    a = w1;
   G0605:
    a = CC_convTvar2cano(a, q);
   G0598:
    popv(2);
    return a;
}

Sex CC_convTfunc2expr(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    if(a == nil) goto    G0610;
    a = w1;
    goto    G0611;
   G0610:
    a = w1;
    a = CC_simpTfunc(a);
   G0611:
    w4 = a;
    if(!is_cons(a)) goto    G0614;
    q = car(w1);
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0613;
   G0614:
    a = w4;
    goto    G0608;
   G0613:
    q = LL_Bgid;
    a = car(w1);
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w3 = a;
    q = a;
    a = LL_uncom;
    a = Lmemq(a, q);
    if(a != nil) goto    G0620;
    q = LL_pfunc;
    a = car(w3);
    a = Lneq(a, q);
    if(a != nil) goto    G0624;
    q = nil;
    a = car(cdr(w1));
    a = CC_Wcommute(a, q);
    if(a == nil) goto    G0620;
   G0624:
#define LL_cH LITERAL[112]
    a = LL_cH;
    goto    G0621;
   G0620:
    a = LL_ncH;
   G0621:
    w3 = a;
    m = mkfxat(1);
    q = w4;
    a = Llist3(a, q, m);
   G0608:
    popv(4);
    return a;
}

Sex CC_convTvar2cano(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_cons(a)) goto    G0628;
    q = mkfxat(1);
    a = mkfxat(1);
    a = cons(a, q);
    m = a;
    q = w1;
    a = w2;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
   G0628:
    q = LL_uniqrep;
    a = CC_getTsimprs(a, q);
    value(LL_Htemporal) = a;
    if(a != nil) goto    G0631;
    q = mkfxat(1);
    a = mkfxat(1);
    a = cons(a, q);
    m = a;
    q = w1;
    a = w2;
    a = Llist3(a, q, m);
    w2 = a;
    m = a;
    q = LL_uniqrep;
    a = w1;
    CC_putTsimprs(a, q, m);
    a = w2;
   G0631:
    popv(2);
    return a;
}

Sex CC_convTvar2pref(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    m = mkfxat(1);
    w1 = q;
    q = a;
    a = w1;
    {
        popv(1);
        return  Llist3(a, q, m);
    }
}

Sex CC_convTlist2oset(Sex a)
{
    Sex q;
    if(a == nil) goto    G0638;
    q = LL_Boset;
    {
        return  Lxcons(a, q);
    }
   G0638:
    a = LL_Anil;
    return a;
}

Sex CC_convTlist2set(Sex a)
{
    Sex q;
    if(a == nil) goto    G0643;
    a = CC_topcopy(a);
    q = LL_Bset;
    a = Lxcons(a, q);
    {
        return  CC_seTsortset(a);
    }
   G0643:
    a = LL_Anil;
    return a;
}

Sex CC_convTarry2garry(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_prodelms(a);
    a = Labs(a);
    w3 = a;
    a = mkfxat(0);
    w5 = a;
    q = value(LL_CsimpenvC);
    a = value(LL_CordenvC);
    a = cons(a, q);
    q = value(LL_CevalenvC);
    a = Lxcons(a, q);
    w4 = a;
   G0650:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w6 = a;
    if(!is_cons(a)) goto    G0655;
    m = w4;
    q = nil;
    a = CC_convTgexpr2sexpr(a, q, m);
    m = a;
    q = w5;
    a = w1;
    Lputv(a, q, m);
   G0655:
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w3 >= a) goto    G0650;
    q = w2;
    a = w3;
    a = cons(a, q);
    q = w1;
    {
        popv(6);
        return  Lxcons(a, q);
    }
}

Sex CC_convTgarry2arry(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w2 = nil;
    w6 = nil;
    w1 = a;
    a = car(cdr(a));
    w4 = a;
    a = car(w1);
    w3 = a;
    a = w4;
    a = Lmkvect(a);
    w2 = a;
    a = mkfxat(0);
    w5 = a;
   G0665:
    q = w5;
    a = w3;
    a = Lgetv(a, q);
    a = CC_convTsexpr2gexpr(a);
    m = a;
    q = w5;
    a = w2;
    Lputv(a, q, m);
    a = w5;
    a = (Sex)((long)a + 0x10);
    w5 = a;
    if(w4 >= a) goto    G0665;
    a = w2;
    popv(6);
    return a;
}

Sex CC_convTarry2vect(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = car(q);
    a = Labs(a);
    q = w2;
    a = cons(a, q);
    q = w1;
    a = Lxcons(a, q);
    q = value(LL_CvectC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_convTarry2matx(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_prodelms(a);
    a = Labs(a);
    q = w2;
    a = cons(a, q);
    q = w1;
    a = Lxcons(a, q);
    q = value(LL_CmatxC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_convTarry2tens(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_prodelms(a);
    a = Labs(a);
    q = w2;
    a = cons(a, q);
    q = w1;
    a = Lxcons(a, q);
    q = value(LL_CtensC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_convTform2arry(Sex a)
{
    a = car(cdr(a));
    return a;
}

Sex CC_evlmodeT(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(3);
    a = Lgetv(a, q);
    a = car(a);
    if(a != nil) goto    G0696;
#define LL_Hevalmode LITERAL[113]
    a = value(LL_Hevalmode);
   G0696:
    return a;
}

Sex CC_cmpmodeT(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(4);
    a = Lgetv(a, q);
    a = car(a);
    if(a != nil) goto    G0703;
#define LL_Hcompmode LITERAL[114]
    a = value(LL_Hcompmode);
   G0703:
    return a;
}

Sex CC_smpmodeT(Sex a)
{
    Sex q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(5);
    a = Lgetv(a, q);
    a = car(a);
    if(a != nil) goto    G0710;
#define LL_Hsimpmode LITERAL[115]
    a = value(LL_Hsimpmode);
   G0710:
    return a;
}

Sex CC_Wcmparg(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0714;
    if(!is_symbol(a)) goto    G0741;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(3);
    a = Lgetv(a, q);
    a = car(a);
    w1 = a;
    if(a != LL_uneval) goto    G0744;
    goto    G0755;
   G0714:
    a = car(a);
    if(!is_integer(a)) goto    G0722;
    if(a != value(LL_CpolyC)) goto    G0741;
    a = cdr(cdr(cdr(w1)));
    if(a != nil) goto    G0741;
    a = car(cdr(cdr(w1)));
    value(LL_Htemporal) = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G0741;
    a = cdr(value(LL_Htemporal));
    a = Lonep(a);
    if(a == nil) goto    G0741;
    a = car(cdr(w1));
    w1 = a;
    if(!is_cons(a)) goto    G0733;
    a = car(a);
   G0733:
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(3);
    a = Lgetv(a, q);
    a = car(a);
    w1 = a;
    if(a != LL_uneval) goto    G0744;
    goto    G0755;
   G0722:
#define LL_cL LITERAL[116]
    if(a == LL_cL) goto    G0741;
    a = cdr(cdr(cdr(w1)));
    if(a != nil) goto    G0741;
    a = car(cdr(cdr(w1)));
    a = Lonep(a);
    if(a != nil) goto    G0740;
   G0741:
    a = true;
    goto    G0749;
   G0740:
    a = car(cdr(w1));
    if(is_cons(a)) goto    G0742;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(3);
    a = Lgetv(a, q);
    a = car(a);
    if(a != LL_uneval) goto    G0744;
   G0755:
    a = nil;
    goto    G0749;
   G0744:
    if(a != nil) goto    G0749;
    q = LL_uneval;
    a = value(LL_Hevalmode);
    {
        popv(1);
        return  Lneq(a, q);
    }
   G0742:
    a = cdr(a);
    a = Lnull(a);
   G0749:
    popv(1);
    return a;
}

Sex CC_evlTsexpr(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
   G0832:
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0761;
    if(is_symbol(q)) goto    G0763;
    a = q;
    goto    G0773;
   G0763:
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G0766;
    a = w1;
    a = CC_evlmodeT(a);
    goto    G0767;
   G0766:
    a = w1;
   G0767:
#define LL_eval LITERAL[117]
    if(a == LL_eval) goto    G0769;
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0769;
    a = w2;
    a = CC_evlmodeT(a);
    if(a != LL_uneval) goto    G0768;
   G0769:
    a = w2;
    goto    G0773;
   G0768:
    q = value(LL_Htemporal);
    a = w2;
    goto    G0832;  /* recursive call to evl:sexpr */
   G0761:
    q = value(LL_CevalenvC);
    a = car(car(w2));
    a = Leqn(a, q);
    if(a == nil) goto    G0772;
    a = w2;
    {
        popv(9);
        return  CC_convTsexpr2gexpr(a);
    }
   G0772:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G0781;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(3);
    a = Lgetv(a, q);
    w5 = a;
    a = cdr(a);
    if(a == nil) goto    G0781;
    q = value(LL_CevalenvC);
    a = car(cdr(w5));
    a = Leqn(a, q);
    if(a == nil) goto    G0781;
    a = cdr(cdr(w5));
    goto    G0773;
   G0781:
    a = cdr(cdr(w2));
    w3 = a;
    a = car(cdr(w2));
    w4 = a;
    if(is_cons(a)) goto    G0788;
    if(a == LL_array) goto    G0826;
#define LL_form LITERAL[118]
    if(a != LL_form) goto    G0788;
    q = w3;
    a = w1;
    a = CC_evlTgform(a, q);
    goto    G0830;
   G0788:
    q = value(LL_CordenvC);
    a = car(cdr(car(w2)));
    a = Leqn(a, q);
    if(a != nil) goto    G0777;
    a = w4;
    if(!is_cons(a)) goto    G0795;
    a = cdr(a);
    if(a == nil) goto    G0777;
    q = LL_Bgid;
    a = car(w4);
    a = Lget(a, q);
    q = mkfxat(0);
    a = Lgetv(a, q);
    w6 = a;
    a = cdr(w4);
    w8 = a;
   G0775:
    q = LL_Bgid;
    a = car(w8);
    a = Lget(a, q);
    q = mkfxat(0);
    a = Lgetv(a, q);
    w7 = a;
    q = a;
    a = w6;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0795;
    a = cdr(w8);
    w8 = a;
    if(a == nil) goto    G0777;
    a = w7;
    w6 = a;
    goto    G0775;
   G0795:
    a = w3;
    a = CC_reorderH(a);
    w3 = a;
   G0777:
    a = w5;
    if(a == nil) goto    G0802;
    a = car(a);
    if(a != nil) goto    G0831;
    a = value(LL_Hevalmode);
   G0831:
    if(a == LL_eval) goto    G0813;
   G0802:
    a = w4;
    a = CC_chkTevlid(a);
    w6 = a;
    if(a == nil) goto    G0813;
    a = w3;
    w8 = a;
    q = w6;
    a = CC_updateH(a, q);
    w3 = a;
    q = a;
    a = w8;
    a = Lneq(a, q);
    if(a == nil) goto    G0813;
    w4 = nil;
    a = true;
    w9 = a;
   G0813:
    q = value(LL_CsimpenvC);
    a = cdr(cdr(car(w2)));
    a = Leqn(a, q);
    if(a == nil) goto    G0815;
    a = w9;
    if(a == nil) goto    G0824;
   G0815:
    a = value(LL_Hsimpmode);
#define LL_unsimp LITERAL[119]
    if(a == LL_unsimp) goto    G0824;
#define LL_Bopnrules LITERAL[120]
    a = value(LL_Bopnrules);
    if(a != nil) goto    G0818;
    a = w4;
    if(a != nil) goto    G0822;
    a = w3;
    a = CC_idlistH(a);
   G0822:
    a = CC_chkTsmpfn(a);
    w6 = a;
    if(a != nil) goto    G0824;
   G0818:
    m = true;
    q = w6;
    a = w3;
    a = CC_simpfuncsH(a, q, m);
   G0830:
    w3 = a;
   G0824:
    a = w5;
    if(a == nil) goto    G0826;
    q = w3;
    a = value(LL_CevalenvC);
    a = cons(a, q);
    q = a;
    a = w1;
    CC_putTsavval(a, q);
   G0826:
    a = w3;
   G0773:
    popv(9);
    return a;
}

Sex CC_evlTgexpr(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0835;
    if(is_symbol(q)) goto    G0837;
    a = q;
    goto    G0846;
   G0837:
    if(!is_symbol(a)) goto    G0840;
    a = CC_evlmodeT(a);
    goto    G0841;
   G0840:
    a = car(a);
   G0841:
    if(a == LL_eval) goto    G0878;
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0878;
    a = w2;
    a = CC_evlmodeT(a);
    if(a == LL_uneval) goto    G0878;
    q = value(LL_Htemporal);
    a = w2;
    {
        popv(8);
        return  CC_evlTsexpr(a, q);
    }
   G0835:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    if(!is_cons(a)) goto    G0853;
    a = car(a);
    w3 = a;
    a = cdr(w1);
    goto    G0881;
   G0853:
    a = CC_evlmodeT(a);
    w3 = a;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    a = car(a);
   G0881:
    w4 = a;
    q = value(LL_CevalenvC);
    a = car(w4);
    a = Leqn(a, q);
    if(a != nil) goto    G0878;
    q = value(LL_CordenvC);
    a = car(cdr(w4));
    a = Leqn(a, q);
    if(a != nil) goto    G0849;
    a = w2;
    a = CC_reorderH(a);
    w2 = a;
   G0849:
    a = w3;
    if(a == LL_eval) goto    G0867;
    a = w2;
    a = CC_idlistH(a);
    w5 = a;
    a = CC_chkTevlid(a);
    w6 = a;
    if(a == nil) goto    G0867;
    a = w2;
    w7 = a;
    q = w6;
    a = CC_updateH(a, q);
    w2 = a;
    q = a;
    a = w7;
    a = Lneq(a, q);
    if(a == nil) goto    G0867;
    w5 = nil;
    a = true;
    w8 = a;
   G0867:
    q = value(LL_CsimpenvC);
    a = cdr(cdr(w4));
    a = Leqn(a, q);
    if(a == nil) goto    G0869;
    a = w8;
    if(a == nil) goto    G0878;
   G0869:
    a = value(LL_Hsimpmode);
    if(a == LL_unsimp) goto    G0878;
    a = value(LL_Bopnrules);
    if(a != nil) goto    G0872;
    a = w5;
    if(a != nil) goto    G0876;
    a = w2;
    a = CC_idlistH(a);
   G0876:
    a = CC_chkTsmpfn(a);
    w6 = a;
    if(a != nil) goto    G0878;
   G0872:
    m = true;
    q = w6;
    a = w2;
    a = CC_simpfuncsH(a, q, m);
    w2 = a;
   G0878:
    a = w2;
   G0846:
    popv(8);
    return a;
}

Sex CC_evlTgform(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    a = car(a);
    w9 = a;
    q = value(LL_CevalenvC);
    a = car(a);
    a = Leqn(a, q);
    if(a != nil) goto    G0909;
    a = w1;
    a = CC_evlmodeT(a);
    q = w9;
    a = cons(a, q);
    w5 = a;
    a = car(cdr(w2));
    w3 = a;
    a = car(cdr(cdr(w2)));
    w7 = a;
    a = mkfxat(0);
    w8 = a;
   G0886:
    a = w8;
    a = Ladd1(a);
    w8 = a;
    q = w7;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0888;
    q = w8;
    a = w3;
    a = Lgetv(a, q);
    w6 = a;
    q = a;
    a = w5;
    a = CC_evlTgexpr(a, q);
    w9 = a;
    if(a == w6) goto    G0886;
    q = mkfxat(-1);
    a = w8;
    a = plus2(a, q);
    arg4 = a;
    m = w7;
    q = nil;
    a = w3;
    a = CC_mkcopyTarry(a, q, m, arg4);
    w4 = a;
    m = w9;
    q = w8;
    Lputv(a, q, m);
   G0887:
    a = w8;
    a = Ladd1(a);
    w8 = a;
    q = w7;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0888;
    q = w8;
    a = w3;
    a = Lgetv(a, q);
    w6 = a;
    q = a;
    a = w5;
    a = CC_evlTgexpr(a, q);
    m = a;
    q = w8;
    a = w4;
    Lputv(a, q, m);
    goto    G0887;
   G0888:
    a = w4;
    if(a != nil) goto    G0905;
   G0909:
    a = w2;
    goto    G0885;
   G0905:
    q = cdr(cdr(w2));
    a = cons(a, q);
    q = car(w2);
    a = Lxcons(a, q);
   G0885:
    popv(9);
    return a;
}

Sex CC_mkcopyTarry(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = q;
    if(a != nil) goto    G0915;
    a = m;
    a = Lmkvect(a);
    w2 = a;
   G0915:
    a = mkfxat(0);
    w5 = a;
   G0913:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    m = a;
    q = w5;
    a = w2;
    Lputv(a, q, m);
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G0913;
    a = w2;
    popv(5);
    return a;
}

Sex CC_chkTsmpfn(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w1 = a;
   G0922:
    a = car(w1);
    w3 = a;
    a = CC_Wfunc(a);
    if(a == nil) goto    G0930;
    q = LL_Bgid;
    a = w3;
    a = Lget(a, q);
    q = mkfxat(5);
    a = Lgetv(a, q);
    w3 = a;
    q = LL_unsimp;
    a = car(a);
    a = Leq(a, q);
    if(a != nil) goto    G0930;
    a = car(w3);
    if(a != nil) goto    G0929;
    a = value(LL_Hsimpmode);
    if(a == LL_unsimp) goto    G0930;
   G0929:
    q = cdr(w3);
#define LL_userdef LITERAL[121]
    a = LL_userdef;
    a = Latsoc(a, q);
    if(a == nil) goto    G0930;
    q = w2;
    a = car(w1);
    a = cons(a, q);
    w2 = a;
   G0930:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0922;
    a = w2;
    {
        popv(3);
        return  Lreverse(a);
    }
}

Sex CC_chkTevlid(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w1 = a;
   G0937:
    a = car(w1);
    w3 = a;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    if(a == nil) goto    G0939;
    a = w3;
    a = CC_evlmodeT(a);
#define LL_steval LITERAL[122]
    if(a != LL_steval) goto    G0939;
    q = w2;
    a = w3;
    a = cons(a, q);
    w2 = a;
   G0939:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0937;
    a = w2;
    {
        popv(3);
        return  Lreverse(a);
    }
}

Sex CC_gTM(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    a = q;
    if(a != nil) goto    G0968;
    q = nil;
    a = LITERAL[123];
    CC_errormsg(a, q);
   G0968:
    a = w1;
    w6 = a;
    a = Llength(a);
    w5 = a;
   G0954:
    a = car(w6);
    w3 = a;
    if(is_cons(a)) goto    G0971;
    if(!is_symbol(a)) goto    G0960;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G0994;
    q = LL_Bgid;
    a = w3;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    w8 = a;
    a = cdr(a);
    if(a != nil) goto    G0975;
    q = LITERAL[124];
    a = car(w8);
    a = Lmemq(a, q);
    if(a != nil) goto    G0994;
   G0975:
    a = car(w8);
    if(a != LL_array) goto    G0979;
#define LL_Barray LITERAL[125]
    q = LL_Barray;
    goto    G1091;
   G0979:
    q = LITERAL[126];
    a = Lmemq(a, q);
    if(a == nil) goto    G0981;
#define LL_Bform LITERAL[127]
    q = LL_Bform;
   G1091:
    a = car(w6);
    a = cons(a, q);
    q = a;
    a = w6;
    car(a) = q;
    goto    G0994;
   G0981:
    q = w8;
#define LL_dummy LITERAL[128]
    a = LL_dummy;
    a = Lmemq(a, q);
    if(a != nil) goto    G0960;
    q = w8;
    a = LL_indxed;
    a = Lmemq(a, q);
    if(a != nil) goto    G0960;
    q = w8;
    a = LL_func;
    a = Lmemq(a, q);
    if(a != nil) goto    G0960;
    q = w8;
    a = LL_num;
    a = Lmemq(a, q);
    if(a == nil) goto    G0994;
    goto    G0960;
   G0971:
    a = car(a);
    w8 = a;
    if(!is_symbol(a)) goto    G0961;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G0961;
    q = LL_Bgid;
    a = w8;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    q = LITERAL[55];
    a = Lmemq(a, q);
    if(a == nil) goto    G0961;
    a = cdr(w3);
    a = CC_Wintlist(a);
    if(a != nil) goto    G0994;
    q = w8;
    a = LITERAL[129];
    CC_errormsg(a, q);
   G0994:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0954;
    a = w2;
    a = CC_gsimpH(a);
    w2 = a;
    m = nil;
    q = value(LL_Htemporal);
    a = CC_convTgexpr2sexpr(a, q, m);
    w4 = a;
    if(!is_cons(a)) goto    G1000;
    a = car(cdr(a));
    w6 = a;
    if(!is_cons(a)) goto    G1000;
    q = w1;
    a = CC_intersecq(a, q);
    w8 = a;
    if(a == nil) goto    G1000;
    q = car(a);
    a = LITERAL[130];
    CC_errormsg(a, q);
   G1000:
    a = car(w1);
    w3 = a;
    if(is_cons(a)) goto    G0956;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a != nil) goto    G1003;
    q = nil;
    a = w3;
    CC_internTid(a, q);
    a = w5;
    a = Lsub1(a);
    w5 = a;
   G1003:
    q = w4;
    a = w3;
    CC_putTsexpr(a, q);
    q = nil;
    a = w3;
    goto    G1095;
   G0956:
    a = cdr(w3);
    if(is_cons(a)) goto    G1005;
    a = w2;
    a = CC_Wsingleid(a);
    w6 = a;
    if(a == nil) goto    G1005;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w6 = a;
    if(!is_cons(a)) goto    G1005;
    a = car(cdr(a));
    w8 = a;
    if(is_cons(a)) goto    G1005;
    a = cdr(w3);
    if(a != LL_Barray) goto    G1009;
    a = w8;
    if(a == LL_array) goto    G1010;
   G1009:
    a = cdr(w3);
    if(a != LL_Bform) goto    G1005;
    a = w8;
    if(a != LL_form) goto    G1005;
   G1010:
    a = w6;
    w4 = a;
    a = cdr(cdr(a));
    w2 = a;
   G1005:
    a = w4;
    if(is_cons(a)) goto    G1012;
    if(is_number(a)) goto    G1028;
    q = LL_Bgid;
    a = car(w3);
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    if(a == LL_array) goto    G1028;
    a = w4;
    goto    G1093;
   G1012:
    a = car(cdr(a));
    w6 = a;
    if(is_cons(a)) goto    G1028;
    q = LL_Bgid;
    a = car(w3);
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
    w8 = a;
    if(a != LL_array) goto    G1020;
    a = cdr(w3);
    if(a != LL_Barray) goto    G1028;
    goto    G0959;
   G1020:
    q = LL_Bform;
    a = cdr(w3);
    a = Lneq(a, q);
    if(a != nil) goto    G1027;
    q = LL_form;
    a = w6;
    a = Lneq(a, q);
    if(a == nil) goto    G1026;
   G1027:
    a = w6;
   G1093:
    w2 = a;
    goto    G0962;
   G1028:
    a = cdr(w3);
    q = LL_Bgid;
    if(!is_cons(a)) goto    G0958;
    a = car(w3);
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w8 = a;
    if(a == nil) goto    G0964;
    a = car(cdr(a));
    if(a != LL_array) goto    G1042;
    a = cdr(cdr(w8));
    w6 = a;
    a = w4;
    w7 = a;
    goto    G1043;
   G1042:
    a = cdr(cdr(cdr(w8)));
    w6 = a;
    a = w2;
    w7 = a;
    q = LL_Bgid;
    a = car(w3);
    a = Lget(a, q);
    q = mkfxat(3);
    a = Lgetv(a, q);
    a = cdr(a);
    w8 = a;
    if(a == nil) goto    G1043;
    q = cdr(w6);
    a = cdr(w3);
    a = CC_addressH(a, q);
    m = w7;
    q = a;
    a = car(cdr(cdr(w8)));
    Lputv(a, q, m);
   G1043:
    q = cdr(w6);
    a = cdr(w3);
    a = CC_addressH(a, q);
    m = w7;
    q = a;
    a = car(w6);
    Lputv(a, q, m);
    a = w5;
    a = Lsub1(a);
    w5 = a;
    goto    G0965;
   G0958:
    a = car(w3);
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w8 = a;
    if(a == nil) goto    G0964;
    q = value(LL_CsimpenvC);
    a = value(LL_CordenvC);
    a = cons(a, q);
    q = value(LL_CevalenvC);
    a = Lxcons(a, q);
    q = a;
    a = w8;
    car(a) = q;
    a = car(cdr(w8));
    if(a != LL_form) goto    G1054;
    a = cdr(cdr(cdr(w8)));
    w6 = a;
    a = w2;
    goto    G1094;
   G1054:
    a = cdr(cdr(w8));
    w6 = a;
    a = w4;
   G1094:
    w7 = a;
    a = car(w6);
    w8 = a;
    a = mkfxat(0);
    w9 = a;
    a = car(cdr(w6));
    w10 = a;
    a = mkfxat(1);
    w11 = a;
    m = a;
    q = w10;
    a = w9;
    CC_Wchkfor(a, q, m);
   G1057:
    m = w7;
    q = w9;
    a = w8;
    a = Lputv(a, q, m);
    w12 = a;
    q = w11;
    a = w9;
    a = plus2(a, q);
    w9 = a;
    m = w11;
    q = w10;
    a = CC_Wendfor(a, q, m);
    if(a == nil) goto    G1057;
    q = nil;
    a = car(w3);
    goto    G1095;
   G1026:
    q = mkfxat(240);
    a = car(w2);
    a = Lilogand2(a, q);
    w6 = a;
    if(a != value(LL_CmatxC)) goto    G1032;
    a = w8;
    if(a == LL_matx) goto    G0959;
   G1032:
    a = w6;
    if(a != value(LL_CvectC)) goto    G1033;
    a = w8;
    if(a == LL_vect) goto    G0959;
   G1033:
    a = w6;
    if(a != value(LL_CtensC)) goto    G0963;
    a = w8;
    if(a != LL_tens) goto    G0963;
   G0959:
    a = car(w3);
    w3 = a;
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w6 = a;
    a = w2;
    w8 = a;
    a = car(a);
    if(!is_integer(a)) goto    G1064;
    a = cdr(w2);
    w8 = a;
    a = w6;
    if(a == nil) goto    G1066;
    a = cdr(cdr(cdr(a)));
    goto    G1071;
   G1066:
    q = cdr(w8);
    a = cons(a, q);
    goto    G1071;
   G1064:
    a = w6;
    if(a == nil) goto    G1070;
    a = cdr(cdr(a));
    goto    G1071;
   G1070:
    q = cdr(w8);
    a = cons(a, q);
   G1071:
    w6 = a;
    q = cdr(w8);
    a = cdr(w6);
    a = Lequal(a, q);
    if(a != nil) goto    G1075;
    q = car(cdr(w8));
    a = car(cdr(w6));
    a = Lequal(a, q);
    if(a == nil) goto    G1074;
    q = cdr(w8);
    a = w6;
    cdr(a) = q;
    q = w3;
    a = LITERAL[131];
    CC_optionmsg(a, q);
    goto    G1075;
   G1074:
    q = w3;
    a = LITERAL[132];
    CC_errormsg(a, q);
   G1075:
    a = car(w6);
    if(a != nil) goto    G1077;
    a = car(cdr(w8));
    a = Lmkvect(a);
    q = a;
    a = w6;
    car(a) = q;
   G1077:
    arg4 = car(cdr(w8));
    m = arg4;
    q = car(w6);
    a = car(w8);
    a = CC_mkcopyTarry(a, q, m, arg4);
    q = cdr(w8);
    cons(a, q);
    a = car(w2);
    if(!is_integer(a)) goto    G1081;
    q = w6;
    a = cons(a, q);
    goto    G1082;
   G1081:
    a = w6;
   G1082:
    q = car(cdr(w4));
    a = Lxcons(a, q);
    q = car(w4);
    a = Lxcons(a, q);
    w7 = a;
    q = a;
    a = w3;
    CC_putTsexpr(a, q);
    q = nil;
    a = w3;
   G1095:
    CC_putTsavval(a, q);
    goto    G0965;
   G0960:
    q = w3;
    a = LITERAL[133];
    CC_errormsg(a, q);
   G0961:
    q = w3;
    a = LITERAL[134];
    CC_errormsg(a, q);
   G0962:
    q = w2;
    a = LITERAL[135];
    CC_errormsg(a, q);
   G0963:
    q = car(w3);
    a = LITERAL[136];
    CC_errormsg(a, q);
   G0964:
    q = car(w3);
    a = LITERAL[137];
    CC_errormsg(a, q);
   G0965:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1000;
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G1089;
    a = value(LL_CevalenvC);
    a = Ladd1(a);
    value(LL_CevalenvC) = a;
    a = w4;
    if(!is_cons(a)) goto    G0953;
    q = cdr(car(a));
    a = value(LL_CevalenvC);
    a = cons(a, q);
    q = a;
    a = w4;
    car(a) = q;
   G1089:
    a = w2;
   G0953:
    popv(12);
    return a;
}

Sex CC_idlistH(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1100;
    if(!is_symbol(a)) goto    G1102;
    {
        popv(1);
        return  Lncons(a);
    }
   G1102:
    a = nil;
    goto    G1111;
   G1100:
    a = car(a);
    if(!is_integer(a)) goto    G1104;
    if(a >= value(LL_CmaxcanoC)) goto    G1106;
    a = w1;
    {
        popv(1);
        return  CC_idlistTcano(a);
    }
   G1106:
    a = w1;
    {
        popv(1);
        return  CC_idlistTform(a);
    }
   G1104:
    if(a != LL_cL) goto    G1108;
    a = w1;
    {
        popv(1);
        return  CC_idlistTcL(a);
    }
   G1108:
    if(a != LL_cH) goto    G1109;
    a = w1;
    {
        popv(1);
        return  CC_idlistTcH(a);
    }
   G1109:
    if(a != LL_ncH) goto    G1110;
    a = w1;
    {
        popv(1);
        return  CC_idlistTncH(a);
    }
   G1110:
    a = w1;
    a = CC_idlistTfunc(a);
   G1111:
    popv(1);
    return a;
}

Sex CC_idsetTrat(Sex a)
{
    a = CC_idlistH(a);
    {
        return  CC_convTlist2oset(a);
    }
}

Sex CC_idsetTrel(Sex a)
{
    a = CC_idlistTrel(a);
    {
        return  CC_convTlist2oset(a);
    }
}

Sex CC_idlistTrel(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(cdr(a));
    a = CC_idlistH(a);
    w2 = a;
    a = car(cdr(cdr(w1)));
    a = CC_idlistH(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_seTunionids(a, q);
    }
}

Sex CC_idlistTfunc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G1125;
    a = car(w1);
    {
        popv(3);
        return  Lncons(a);
    }
   G1125:
    w2 = nil;
    w3 = nil;
    a = car(w1);
    a = Lncons(a);
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G1128:
    a = car(w1);
    w3 = a;
    if(is_cons(a)) goto    G1130;
    if(!is_symbol(a)) goto    G1132;
    a = Lncons(a);
    goto    G1139;
   G1132:
    a = nil;
    goto    G1139;
   G1130:
    a = car(a);
    if(!is_integer(a)) goto    G1134;
    a = car(w1);
    a = CC_idlistTcano(a);
    goto    G1139;
   G1134:
    q = LL_BctypeB;
    a = Lget(a, q);
    w3 = a;
    if(a != LL_rat) goto    G1135;
    a = car(w1);
    a = CC_idlistTpref(a);
    goto    G1139;
   G1135:
#define LL_rel LITERAL[138]
    if(a != LL_rel) goto    G1136;
    a = car(w1);
    a = CC_idlistTrel(a);
    goto    G1139;
   G1136:
#define LL_set LITERAL[139]
    if(a != LL_set) goto    G1137;
    a = car(w1);
    a = CC_idlistTset(a);
    goto    G1139;
   G1137:
#define LL_log LITERAL[140]
    if(a != LL_log) goto    G1138;
    a = car(w1);
    a = CC_idlistTlog(a);
    goto    G1139;
   G1138:
    a = car(w1);
    a = CC_idlistTfunc(a);
    a = cdr(a);
   G1139:
    w3 = a;
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1128;
    a = w2;
    popv(3);
    return a;
}

Sex CC_idlistTcano(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
#define LL_CratfC LITERAL[141]
    if(car(a) >= value(LL_CratfC)) goto    G1146;
    a = cdr(a);
    {
        popv(3);
        return  CC_idlisTbpol(a);
    }
   G1146:
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = cdr(a);
    w1 = a;
   G1149:
    a = car(w1);
    w3 = a;
    a = car(a);
    if(!is_cons(a)) goto    G1151;
    a = cdr(car(w3));
    a = CC_idlisTbpol(a);
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
   G1151:
    a = cdr(w3);
    if(!is_cons(a)) goto    G1155;
    a = cdr(a);
    a = CC_idlisTbpol(a);
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
   G1155:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1149;
    a = w2;
    popv(3);
    return a;
}

Sex CC_idlistTpref(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G1162;
    a = w1;
    {
        popv(1);
        return  CC_idlistTcL(a);
    }
   G1162:
    if(a != LL_cH) goto    G1163;
    a = w1;
    {
        popv(1);
        return  CC_idlistTcH(a);
    }
   G1163:
    a = w1;
    {
        popv(1);
        return  CC_idlistTncH(a);
    }
}

Sex CC_idlistTform(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(cdr(a));
    a = CC_arrysizeT(a);
    w3 = a;
    a = car(cdr(w1));
    w1 = a;
    a = mkfxat(0);
    w4 = a;
   G1168:
    a = w4;
    a = Ladd1(a);
    w4 = a;
    q = a;
    a = w1;
    a = Lgetv(a, q);
    a = CC_idlistH(a);
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
    if(w4 < w3) goto    G1168;
    popv(4);
    return a;
}

Sex CC_idlistTncH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    a = cdr(a);
    w1 = a;
   G1176:
    a = car(w1);
    if(is_cons(a)) goto    G1178;
    if(!is_symbol(a)) goto    G1180;
    a = Lncons(a);
    goto    G1185;
   G1180:
    a = nil;
    goto    G1185;
   G1178:
    a = car(a);
    if(!is_integer(a)) goto    G1182;
    a = car(w1);
    a = CC_idlistTcano(a);
    goto    G1185;
   G1182:
    if(a != LL_cL) goto    G1183;
    a = car(w1);
    a = CC_idlistTcL(a);
    goto    G1185;
   G1183:
    if(a != LL_ncH) goto    G1184;
    a = car(w1);
    a = CC_idlistTncH(a);
    goto    G1185;
   G1184:
    a = car(w1);
    a = CC_idlistTfunc(a);
   G1185:
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
    a = car(cdr(w1));
    w3 = a;
    if(!is_cons(a)) goto    G1187;
    a = CC_idlistH(a);
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
   G1187:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G1176;
    a = w2;
    popv(3);
    return a;
}

Sex CC_idlistTcH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    a = cdr(a);
    w1 = a;
   G1194:
    a = car(w1);
    if(is_cons(a)) goto    G1196;
    a = nil;
    goto    G1199;
   G1196:
    a = car(a);
    if(!is_integer(a)) goto    G1197;
    a = car(w1);
    a = CC_idlistTcano(a);
    goto    G1199;
   G1197:
    if(a != LL_cL) goto    G1198;
    a = car(w1);
    a = CC_idlistTcL(a);
    goto    G1199;
   G1198:
    a = car(w1);
    a = CC_idlistTfunc(a);
   G1199:
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
    a = car(cdr(w1));
    w3 = a;
    if(!is_cons(a)) goto    G1201;
    a = CC_idlistH(a);
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
   G1201:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G1194;
    a = w2;
    popv(3);
    return a;
}

Sex CC_idlistTcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    a = car(a);
    if(is_number(a)) goto    G1225;
    a = car(a);
    if(!is_integer(a)) goto    G1212;
    a = car(w3);
    a = CC_idlistTcano(a);
    w2 = a;
   G1225:
    a = cdr(w3);
    w3 = a;
   G1212:
    a = car(car(w3));
    w4 = a;
    a = car(a);
    if(a == LL_cH) goto    G1209;
    a = w4;
    a = CC_idlistTncH(a);
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
    a = cdr(car(w3));
    w4 = a;
    if(!is_cons(a)) goto    G1218;
    a = CC_idlistH(a);
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
   G1218:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G1224;
    goto    G1212;
   G1209:
    a = car(car(w3));
    a = CC_idlistTcH(a);
    q = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1209;
   G1224:
    a = w2;
    popv(4);
    return a;
}

Sex CC_idlisTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w1 = a;
    a = car(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = w3;
    if(!is_symbol(a)) goto    G1232;
    a = Lncons(a);
    goto    G1233;
   G1232:
    a = CC_idlistTfunc(a);
   G1233:
    w2 = a;
   G1230:
    a = cdr(car(w1));
    w3 = a;
    if(is_number(a)) goto    G1238;
    a = car(a);
    if(!is_integer(a)) goto    G1236;
    a = cdr(w3);
    goto    G1242;
   G1236:
    a = w3;
   G1242:
    a = CC_idlisTbpol(a);
    q = a;
    a = w2;
    a = CC_seTunionids(a, q);
    w2 = a;
   G1238:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1230;
    a = w2;
    popv(3);
    return a;
}

Sex CC_reorderH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G1256;
    a = car(a);
    if(!is_integer(a)) goto    G1247;
    if(a >= value(LL_CmaxcanoC)) goto    G1257;
    a = w1;
    {
        popv(1);
        return  CC_orderTcano(a);
    }
   G1247:
    if(is_symbol(a)) goto    G1251;
   G1257:
    a = w1;
    goto    G1256;
   G1251:
    q = LL_BctypeB;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a != LL_rat) goto    G1252;
    a = w1;
    {
        popv(1);
        return  CC_orderTpref(a);
    }
   G1252:
    if(a != LL_rel) goto    G1253;
    a = w1;
    {
        popv(1);
        return  CC_orderTrel(a);
    }
   G1253:
    if(a != LL_set) goto    G1254;
    a = w1;
    {
        popv(1);
        return  CC_orderTset(a);
    }
   G1254:
    if(a != LL_log) goto    G1255;
    a = w1;
    {
        popv(1);
        return  CC_orderTlog(a);
    }
   G1255:
    a = w1;
    a = CC_orderTfunc(a);
   G1256:
    popv(1);
    return a;
}

Sex CC_updateH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G1261;
    if(!is_symbol(a)) goto    G1274;
    q = a;
    {
        popv(2);
        return  CC_evlTsexpr(a, q);
    }
   G1261:
    a = car(a);
    if(!is_integer(a)) goto    G1265;
    if(a >= value(LL_CmaxcanoC)) goto    G1276;
    goto    G1275;
   G1265:
    if(is_symbol(a)) goto    G1269;
   G1276:
    a = w1;
    goto    G1274;
   G1269:
    q = LL_BctypeB;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a != LL_rat) goto    G1270;
    q = w2;
   G1275:
    a = w1;
    {
        popv(2);
        return  CC_updateTcanpre(a, q);
    }
   G1270:
    if(a != LL_rel) goto    G1271;
    a = w1;
    {
        popv(2);
        return  CC_updateTrel(a);
    }
   G1271:
    if(a != LL_set) goto    G1272;
    a = w1;
    {
        popv(2);
        return  CC_updateTset(a);
    }
   G1272:
    if(a != LL_log) goto    G1273;
    a = w1;
    {
        popv(2);
        return  CC_updateTlog(a);
    }
   G1273:
    a = w1;
    a = CC_updateTfunc(a);
   G1274:
    popv(2);
    return a;
}

Sex CC_argevalH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    a = CC_gevcmpH(a);
    w1 = a;
    if(is_cons(a)) goto    G1280;
    if(!is_number(a)) goto    G1290;
    goto    G1295;
   G1280:
    a = car(a);
    if(!is_integer(a)) goto    G1284;
    a = w1;
    a = CC_Wsinglevar(a);
    if(a != nil) goto    G1298;
#define LL_Hrdstat LITERAL[142]
    a = value(LL_Hrdstat);
#define LL_rule LITERAL[143]
    if(a == LL_rule) goto    G1298;
    a = w1;
    a = CC_idlistTcano(a);
    q = a;
    a = w1;
    {
        popv(1);
        return  CC_simpTcano(a, q);
    }
   G1284:
    q = LITERAL[144];
    a = Lmemq(a, q);
    if(a == nil) goto    G1290;
    a = value(LL_Hrdstat);
    if(a != LL_rule) goto    G1292;
   G1298:
    a = w1;
    goto    G1295;
   G1292:
    a = w1;
    a = CC_idlistTpref(a);
    q = a;
    a = w1;
    {
        popv(1);
        return  CC_simpTpref(a, q);
    }
   G1290:
    q = LITERAL[145];
    a = mkfxat(3);
    a = CC_errormsg(a, q);
   G1295:
    popv(1);
    return a;
}

Sex CC_updateTcanpre(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = LL_head;
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G1302:
    q = LL_Bgid;
    a = car(w2);
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w5 = a;
    if(a == nil) goto    G1305;
    a = car(w2);
    a = CC_evlmodeT(a);
    q = LL_uneval;
    a = Lneq(a, q);
    if(a == nil) goto    G1305;
    q = w5;
    a = car(w2);
    a = CC_evlTsexpr(a, q);
    w5 = a;
    q = car(w2);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1305:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1302;
    a = cdr(w3);
    w4 = a;
    if(a == nil) goto    G1316;
   G1314:
    m = cdr(car(w4));
    q = car(car(w4));
    a = w1;
    a = CC_substH(a, q, m);
    w1 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1314;
   G1316:
    a = w1;
    popv(5);
    return a;
}

Sex CC_orderTcano(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(car(a) >= value(LL_CratfC)) goto    G1321;
    {
        popv(8);
        return  CC_orderTpol3(a);
    }
   G1321:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    a = value(LL_CratfC);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w4 = a;
    w5 = a;
   G1324:
    a = car(w4);
    w6 = a;
    a = car(a);
    w7 = a;
    if(!is_cons(a)) goto    G1329;
    a = CC_orderTpol3(a);
   G1329:
    w7 = a;
    a = cdr(w6);
    w8 = a;
    if(!is_cons(a)) goto    G1332;
    a = CC_orderTpol3(a);
   G1332:
    w8 = a;
    a = w7;
    if(a != car(w6)) goto    G1334;
    a = w8;
    if(a != cdr(w6)) goto    G1334;
    a = cdr(w4);
    w4 = a;
    goto    G1351;
   G1334:
    q = w4;
    a = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G1340;
    a = car(w5);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w5);
    w5 = a;
    goto    G1334;
   G1340:
    q = w8;
    a = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    w5 = a;
   G1351:
    if(a != nil) goto    G1324;
   G1347:
    a = w5;
    if(a != cdr(w1)) goto    G1349;
    a = w1;
    goto    G1322;
   G1349:
    q = a;
    a = w3;
    cdr(a) = q;
    a = w2;
    a = CC_sortTqratf(a);
   G1322:
    popv(8);
    return a;
}

Sex CC_orderTpref(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G1355;
    a = w1;
    {
        popv(1);
        return  CC_orderTcL(a);
    }
   G1355:
    if(a != LL_cH) goto    G1356;
    a = w1;
    {
        popv(1);
        return  CC_orderTcH(a);
    }
   G1356:
    a = w1;
    {
        popv(1);
        return  CC_orderTncH(a);
    }
}

Sex CC_orderTrel(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = car(cdr(a));
    w2 = a;
    a = car(cdr(cdr(w1)));
    w3 = a;
    a = w2;
    a = CC_reorderH(a);
    w4 = a;
    if(a != w2) goto    G1362;
    a = w3;
    a = CC_reorderH(a);
    w5 = a;
    if(a != w3) goto    G1362;
    a = w1;
    goto    G1360;
   G1362:
    m = w5;
    q = w4;
    a = car(w1);
    a = Llist3(a, q, m);
   G1360:
    popv(5);
    return a;
}

Sex CC_orderTset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G1392;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = car(w1);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w5 = a;
    w4 = a;
   G1372:
    a = car(w5);
    a = CC_reorderH(a);
    w7 = a;
    if(a != car(w5)) goto    G1376;
    a = car(w1);
    if(a == LL_Boset) goto    G1374;
    a = w6;
    if(a == nil) goto    G1374;
    q = w7;
    a = CC_Worder(a, q);
    if(a != nil) goto    G1374;
   G1376:
    q = w5;
    a = w4;
    a = Lneq(a, q);
    if(a == nil) goto    G1381;
    a = car(w4);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    goto    G1376;
   G1381:
    a = w7;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
   G1374:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G1387;
    a = w7;
    w6 = a;
    goto    G1372;
   G1387:
    a = cdr(w2);
    if(a != nil) goto    G1388;
   G1392:
    a = w1;
    goto    G1370;
   G1388:
    a = car(w1);
    if(a != LL_Boset) goto    G1389;
    q = w4;
    a = w3;
    cdr(a) = q;
    goto    G1390;
   G1389:
    a = w4;
    a = CC_topcopy(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = w2;
    CC_seTsortset(a);
   G1390:
    a = w2;
   G1370:
    popv(7);
    return a;
}

Sex CC_orderTpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(car(a) < value(LL_CpolyC)) goto    G1401;
    if(car(a) >= value(LL_CalgfC)) goto    G1397;
    w1 = a;
    a = cdr(a);
    a = CC_ordTbpol(a);
    value(LL_Htemporal) = a;
    if(a == cdr(w1)) goto    G1427;
    q = car(w1);
    {
        popv(7);
        return  Lxcons(a, q);
    }
   G1397:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = car(a);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w4 = a;
    a = cdr(a);
    w5 = a;
   G1403:
    a = cdr(car(w5));
    w6 = a;
    if(is_number(a)) goto    G1417;
    a = car(a);
    if(is_integer(a)) goto    G1428;
    q = w6;
    a = value(LL_CalgfC);
    a = cons(a, q);
    a = CC_orderTpol3(a);
    a = cdr(a);
    w7 = a;
    if(a != w6) goto    G1405;
   G1417:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G1403;
    a = cdr(w2);
    if(a != nil) goto    G1420;
   G1427:
    a = w1;
    goto    G1401;
   G1428:
    if(a < value(LL_CpolyC)) goto    G1417;
    a = cdr(w6);
    a = CC_ordTbpol(a);
    w7 = a;
    if(a == cdr(w6)) goto    G1417;
    q = value(LL_CpolyC);
    a = Lxcons(a, q);
    w7 = a;
   G1405:
    q = w5;
    a = w4;
    a = Lneq(a, q);
    if(a == nil) goto    G1422;
    a = car(w4);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    goto    G1405;
   G1422:
    a = w7;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
    goto    G1417;
   G1420:
    q = w4;
    a = w3;
    cdr(a) = q;
    a = w2;
   G1401:
    popv(7);
    return a;
}

Sex CC_orderTfunc(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G1481;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = car(w1);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w5 = a;
    w4 = a;
   G1435:
    a = car(w5);
    w7 = a;
    if(!is_cons(a)) goto    G1460;
    a = car(a);
    if(!is_integer(a)) goto    G1442;
    if(a != value(LL_CpolyC)) goto    G1444;
    a = cdr(w7);
    a = CC_WsvarTbpol(a);
    if(a != nil) goto    G1460;
   G1444:
    a = w7;
    a = CC_orderTcano(a);
    goto    G1479;
   G1442:
    q = LL_BctypeB;
    a = Lget(a, q);
    w6 = a;
    if(a != LL_rat) goto    G1447;
    a = w7;
    a = CC_orderTpref(a);
    goto    G1479;
   G1447:
    if(a != LL_rel) goto    G1448;
    a = w7;
    a = CC_orderTrel(a);
    goto    G1479;
   G1448:
    a = w7;
    a = CC_orderTfunc(a);
   G1479:
    w7 = a;
    a = w7;
    if(a == car(w5)) goto    G1460;
   G1451:
    q = w5;
    a = w4;
    a = Lneq(a, q);
    if(a == nil) goto    G1453;
    a = car(w4);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    goto    G1451;
   G1453:
    a = w7;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w5);
    w5 = a;
    w4 = a;
    goto    G1480;
   G1460:
    a = cdr(w5);
    w5 = a;
   G1480:
    if(a != nil) goto    G1435;
   G1462:
    a = cdr(cdr(w1));
    if(a == nil) goto    G1464;
    a = car(w1);
    a = CC_Wpfunc(a);
    if(a == nil) goto    G1464;
    q = LL_mkfunc;
    a = car(w1);
    a = CC_getTsimprs(a, q);
    w7 = a;
    if(a == nil) goto    G1464;
    a = w4;
    if(a != cdr(w1)) goto    G1469;
    a = w1;
    w2 = a;
    goto    G1470;
   G1469:
    q = a;
    a = w3;
    cdr(a) = q;
   G1470:
    q = car(cdr(w2));
    a = car(w2);
    a = Llist2(a, q);
    m = cdr(cdr(w2));
    q = a;
    a = w7;
    a = Lfuncall2(a, q, m);
    w2 = a;
    q = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G1473;
   G1481:
    a = w1;
    goto    G1433;
   G1464:
    a = w4;
    if(a == cdr(w1)) goto    G1481;
    q = a;
    a = w3;
    cdr(a) = q;
   G1473:
    a = w2;
   G1433:
    popv(7);
    return a;
}

Sex CC_orderTncH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = LL_ncH;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w5 = a;
    w4 = a;
   G1486:
    a = car(w5);
    w8 = a;
    if(!is_cons(a)) goto    G1495;
    a = car(a);
    if(a != LL_ncH) goto    G1492;
    a = w8;
    a = CC_orderTncH(a);
    goto    G1495;
   G1492:
    if(a != LL_cL) goto    G1493;
    a = w8;
    a = CC_orderTcL(a);
    goto    G1495;
   G1493:
    if(!is_integer(a)) goto    G1494;
    a = w8;
    a = CC_orderTcano(a);
    goto    G1495;
   G1494:
    a = w8;
    a = CC_orderTfunc(a);
   G1495:
    w6 = a;
    a = car(cdr(w5));
    w8 = a;
    if(is_number(a)) goto    G1498;
    a = CC_reorderH(a);
   G1498:
    w7 = a;
    a = w6;
    if(a != car(w5)) goto    G1500;
    a = w7;
    if(a == w8) goto    G1488;
   G1500:
    q = w5;
    a = w4;
    a = Lneq(a, q);
    if(a == nil) goto    G1503;
    a = car(cdr(w4));
    a = Lncons(a);
    q = car(w4);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w3 = a;
    a = cdr(cdr(w4));
    w4 = a;
    goto    G1500;
   G1503:
    a = w7;
    a = Lncons(a);
    q = w6;
    a = Lxcons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w3 = a;
    a = cdr(cdr(w5));
    w5 = a;
    w4 = a;
    goto    G1518;
   G1488:
    a = cdr(cdr(w5));
    w5 = a;
   G1518:
    if(a != nil) goto    G1486;
   G1515:
    a = cdr(w2);
    if(a != nil) goto    G1517;
    a = w1;
    goto    G1485;
   G1517:
    q = w4;
    a = w3;
    cdr(a) = q;
    a = w2;
   G1485:
    popv(8);
    return a;
}

Sex CC_orderTcH(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w3 = nil;
    w2 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = LL_cH;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w7 = a;
    w6 = a;
   G1522:
    a = car(w7);
    w10 = a;
    if(!is_cons(a)) goto    G1531;
    a = car(a);
    if(!is_integer(a)) goto    G1529;
    a = w10;
    a = CC_orderTcano(a);
    goto    G1531;
   G1529:
    if(a != LL_cL) goto    G1530;
    a = w10;
    a = CC_orderTcL(a);
    goto    G1531;
   G1530:
    a = w10;
    a = CC_orderTfunc(a);
   G1531:
    w8 = a;
    a = car(cdr(w7));
    w10 = a;
    if(is_number(a)) goto    G1534;
    a = CC_reorderH(a);
   G1534:
    w9 = a;
    a = w8;
    if(a != car(w7)) goto    G1536;
    a = w9;
    if(a != w10) goto    G1536;
    a = w5;
    if(a == nil) goto    G1524;
    q = w8;
    a = car(a);
    a = CC_Worder(a, q);
    if(a != nil) goto    G1524;
   G1536:
    q = w7;
    a = w6;
    a = Lneq(a, q);
    if(a == nil) goto    G1542;
    a = car(cdr(w6));
    a = Lncons(a);
    q = car(w6);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w3 = a;
    a = cdr(cdr(w6));
    w6 = a;
    goto    G1536;
   G1542:
    q = w4;
    a = w9;
    a = cons(a, q);
    q = w8;
    a = Lxcons(a, q);
    w4 = a;
    a = w7;
    w5 = a;
    a = cdr(a);
    a = cdr(a);
    w7 = a;
    w6 = a;
    goto    G1561;
   G1524:
    a = w7;
    w5 = a;
    a = cdr(a);
    a = cdr(a);
    w7 = a;
   G1561:
    if(a != nil) goto    G1522;
   G1553:
    a = cdr(w2);
    if(a != nil) goto    G1557;
    a = w1;
    goto    G1521;
   G1557:
    q = w6;
    a = w3;
    cdr(a) = q;
    a = cdr(w2);
    w2 = a;
   G1526:
    m = w2;
    q = car(cdr(w4));
    a = car(w4);
    a = CC_sortTbasexp(a, q, m);
    w2 = a;
    a = cdr(cdr(w4));
    w4 = a;
    if(a != nil) goto    G1526;
    q = w2;
    a = LL_cH;
    a = cons(a, q);
   G1521:
    popv(10);
    return a;
}

Sex CC_orderTcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w6 = nil;
    w1 = a;
    a = LL_cL;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w5 = a;
    w4 = a;
    a = car(a);
    w9 = a;
    if(is_number(a)) goto    G1599;
    a = car(a);
    if(!is_integer(a)) goto    G1572;
    a = w9;
    a = CC_orderTcano(a);
    if(a != car(w5)) goto    G1571;
   G1599:
    a = cdr(w5);
    w5 = a;
    goto    G1572;
   G1571:
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w5);
    w5 = a;
    w4 = a;
   G1572:
    a = car(w5);
    w9 = a;
    a = car(a);
    a = CC_orderTpref(a);
    w7 = a;
    a = cdr(w9);
    w8 = a;
    if(!is_cons(a)) goto    G1576;
    a = CC_reorderH(a);
    w8 = a;
   G1576:
    a = w7;
    if(a != car(w9)) goto    G1578;
    a = w8;
    if(a != cdr(w9)) goto    G1578;
    a = w6;
    if(a == nil) goto    G1567;
    q = w7;
    a = CC_Worder(a, q);
    if(a != nil) goto    G1567;
   G1578:
    q = w5;
    a = w4;
    a = Lneq(a, q);
    if(a == nil) goto    G1584;
    a = car(w4);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    goto    G1578;
   G1584:
    q = w8;
    a = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
   G1567:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G1591;
    a = w7;
    w6 = a;
    goto    G1572;
   G1591:
    a = cdr(w2);
    if(a != nil) goto    G1592;
    a = w1;
    goto    G1564;
   G1592:
    a = w4;
    a = CC_topcopy(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(cdr(w2));
    if(a != nil) goto    G1595;
    a = w2;
    goto    G1564;
   G1595:
#define LL_uncol LITERAL[146]
    q = LL_uncol;
#define LL_Hcolmode LITERAL[147]
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1596;
    a = w2;
    {
        popv(9);
        return  CC_seTcolsortTcL(a);
    }
   G1596:
    a = w2;
    a = CC_seTuncolsortTcL(a);
   G1564:
    popv(9);
    return a;
}

Sex CC_ordTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    q = a;
    a = car(a);
    a = CC_WregordTbpol(a, q);
    if(a == nil) goto    G1603;
    a = w1;
    goto    G1604;
   G1603:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = w1;
    a = CC_revordTbpol(a);
    w5 = a;
   G1606:
    a = car(cdr(w5));
    w6 = a;
    a = car(w5);
    w7 = a;
    if(!is_cons(a)) goto    G1609;
    a = CC_orderTfunc(a);
    w7 = a;
   G1609:
    q = car(w6);
    a = cons(a, q);
    q = w3;
    a = cons(a, q);
    w3 = a;
    q = w4;
    a = cdr(w5);
    a = cons(a, q);
    w4 = a;
    a = cdr(w6);
    w5 = a;
    if(!is_cons(a)) goto    G1612;
    a = car(a);
    if(!is_integer(a)) goto    G1606;
   G1612:
    q = w3;
    a = w5;
    a = cons(a, q);
    w3 = a;
    a = w3;
    a = CC_ordTmkmono(a);
    w2 = a;
    if(is_number(a)) goto    G1617;
    a = car(a);
    if(!is_integer(a)) goto    G1616;
   G1617:
    q = w4;
    a = cdr(w3);
    a = CC_ordTnextmono(a, q);
    w7 = a;
    a = car(a);
    w3 = a;
    a = cdr(w7);
    w4 = a;
    a = w3;
    a = CC_ordTmkmono(a);
    w5 = a;
    a = w2;
    q = w5;
    if(!is_number(a)) goto    G1619;
    a = CC_seLbnumbpol(a, q);
    goto    G1623;
   G1619:
    a = CC_seLpol3bpol(a, q);
    goto    G1623;
   G1616:
    q = w4;
    a = cdr(w3);
    a = CC_ordTnextmono(a, q);
    w7 = a;
    if(a == nil) goto    G1624;
    a = car(a);
    w3 = a;
    a = cdr(w7);
    w4 = a;
    a = w3;
    a = CC_ordTmkmono(a);
    w5 = a;
    q = w2;
    a = CC_seLbpolbpol(a, q);
   G1623:
    w2 = a;
    goto    G1616;
   G1624:
    a = w2;
   G1604:
    popv(7);
    return a;
}

Sex CC_ordTnextmono(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
   G1649:
    w1 = a;
    a = q;
    if(a == nil) goto    G1629;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(car(a));
    w5 = a;
    w2 = q;
    if(a != nil) goto    G1633;
    q = cdr(q);
    a = cdr(w1);
    goto    G1649;  /* recursive call to ord:nextmono */
   G1633:
    q = car(car(a));
    a = car(w1);
    cdr(a) = q;
    q = w5;
    a = w2;
    car(a) = q;
    a = cdr(car(w5));
    w3 = a;
    if(is_number(a)) goto    G1645;
    a = car(a);
    if(is_integer(a)) goto    G1645;
   G1636:
    a = car(cdr(w3));
    w4 = a;
    a = car(w3);
    w5 = a;
    if(!is_cons(a)) goto    G1641;
    a = CC_orderTfunc(a);
    w5 = a;
   G1641:
    q = car(w4);
    a = cons(a, q);
    q = w1;
    a = cons(a, q);
    w1 = a;
    q = w2;
    a = cdr(w3);
    a = cons(a, q);
    w2 = a;
    a = cdr(w4);
    w3 = a;
    if(is_number(a)) goto    G1645;
    a = car(a);
    if(!is_integer(a)) goto    G1636;
   G1645:
    q = w1;
    a = w3;
    a = cons(a, q);
    q = w2;
    a = cons(a, q);
   G1629:
    popv(5);
    return a;
}

Sex CC_ordTmkmono(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    w1 = a;
    q = car(a);
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    w2 = a;
   G1652:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G1671;
    a = cdr(car(a));
    a = Lzerop(a);
    if(a == nil) goto    G1672;
    goto    G1652;
   G1660:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1662;
   G1671:
    a = w2;
    {
        popv(3);
        return  CC_mkTmono(a);
    }
   G1662:
    a = cdr(car(a));
    a = Lzerop(a);
    if(a != nil) goto    G1660;
    q = car(car(w2));
    a = car(car(w1));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1665;
   G1672:
    q = w2;
    a = car(w1);
    a = cons(a, q);
    w2 = a;
    goto    G1660;
   G1665:
    a = w2;
    w3 = a;
   G1654:
    a = cdr(cdr(w3));
    if(a == nil) goto    G1668;
    q = car(car(cdr(w3)));
    a = car(car(w1));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1667;
   G1668:
    q = cdr(w3);
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    goto    G1660;
   G1667:
    a = cdr(w3);
    w3 = a;
    goto    G1654;
}

Sex CC_WregordTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_cons(a)) goto    G1676;
    a = CC_orderTfunc(a);
    q = a;
    a = w1;
    a = Lneq(a, q);
    if(a != nil) goto    G1686;
   G1676:
    w3 = nil;
    w4 = nil;
    a = cdr(w2);
    w2 = a;
   G1681:
    a = cdr(car(w2));
    w3 = a;
    if(is_number(a)) goto    G1685;
    a = car(a);
    if(is_integer(a)) goto    G1685;
    q = w1;
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G1686;
    q = w3;
    a = car(q);
    a = CC_WregordTbpol(a, q);
    if(a != nil) goto    G1685;
   G1686:
    a = nil;
    goto    G1679;
   G1685:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1681;
    a = true;
   G1679:
    popv(4);
    return a;
}

Sex CC_substH(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    if(is_cons(a)) goto    G1693;
    if(a != q) goto    G1697;
    a = m;
    goto    G1697;
   G1693:
    if(!is_number(m)) goto    G1699;
#define LL_bnum LITERAL[148]
    a = LL_bnum;
    goto    G1709;
   G1699:
    q = value(LL_CpolyC);
    a = car(m);
    a = Lequal(a, q);
    if(a == nil) goto    G1700;
#define LL_unexp LITERAL[149]
    q = LL_unexp;
#define LL_Hexpmode LITERAL[150]
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a != nil) goto    G1702;
    a = cdr(w3);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G1700;
   G1702:
#define LL_pol3 LITERAL[151]
    a = LL_pol3;
    goto    G1709;
   G1700:
#define LL_expr LITERAL[152]
    a = LL_expr;
   G1709:
#define LL_Hsubstype LITERAL[153]
    value(LL_Hsubstype) = a;
    a = car(w1);
    if(!is_symbol(a)) goto    G1705;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_substTpref(a, q, m);
    }
   G1705:
    if(a >= value(LL_CmaxcanoC)) goto    G1706;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_substTcano(a, q, m);
    }
   G1706:
    m = w3;
    q = w2;
    a = w1;
    a = CC_substTform(a, q, m);
   G1697:
    popv(3);
    return a;
}

Sex CC_substTexpt(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
#define LL_Hmod LITERAL[154]
    value(LL_Hmod) = nil;
#define LL_Hfcut LITERAL[155]
    value(LL_Hfcut) = nil;
    w1 = a;
    a = car(a);
    if(!is_integer(a)) goto    G1713;
    a = w1;
    a = CC_substTcano(a, q, m);
    goto    G1714;
   G1713:
    a = w1;
    a = CC_substTpref(a, q, m);
   G1714:
    w1 = a;
#define LL_Hfloat LITERAL[156]
    a = value(LL_Hfloat);
    if(a == nil) goto    G1717;
    a = cdr(a);
   G1717:
    value(LL_Hfcut) = a;
#define LL_HHmod LITERAL[157]
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = w1;
    popv(1);
    return a;
}

Sex CC_substTrat(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_number(a)) goto    G1722;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = q;
    w5 = a;
    if(!is_cons(a)) goto    G1724;
    q = LITERAL[158];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G1724;
    a = cdr(w5);
    if(a == nil) goto    G1724;
    a = cdr(a);
    if(a == nil) goto    G1724;
    a = car(cdr(w2));
    w3 = a;
    a = car(cdr(cdr(w2)));
    w4 = a;
    a = w3;
    a = CC_Aexpr2varfunc(a);
    w5 = a;
#define LL_Ainvalid LITERAL[159]
    q = LL_Ainvalid;
    a = Lneq(a, q);
    if(a == nil) goto    G1732;
    a = w5;
    w3 = a;
    goto    G1734;
   G1732:
    q = w3;
    a = LITERAL[160];
    CC_errormsg(a, q);
   G1734:
    a = w4;
    if(is_cons(a)) goto    G1736;
    if(!is_number(a)) goto    G1726;
    goto    G1743;
   G1736:
    a = car(a);
    if(!is_symbol(a)) goto    G1740;
    q = LL_BctypeB;
    a = Lget(a, q);
    q = LL_rat;
    a = Lneq(a, q);
    if(a != nil) goto    G1726;
   G1740:
    a = w3;
    if(is_symbol(a)) goto    G1747;
    a = car(a);
   G1747:
    q = nil;
    a = CC_Wcommute(a, q);
    if(a == nil) goto    G1743;
    q = nil;
    a = w4;
    a = CC_Wcommute(a, q);
    if(a == nil) goto    G1725;
   G1743:
    a = w4;
    if(!is_number(a)) goto    G1750;
    a = LL_bnum;
    goto    G1761;
   G1750:
    q = value(LL_CpolyC);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1751;
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a != nil) goto    G1753;
    a = cdr(w4);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G1751;
   G1753:
    a = LL_pol3;
    goto    G1761;
   G1751:
    a = LL_expr;
   G1761:
    value(LL_Hsubstype) = a;
    a = car(w1);
    if(!is_symbol(a)) goto    G1756;
    m = w4;
    q = w3;
    a = w1;
    {
        popv(5);
        return  CC_substTpref(a, q, m);
    }
   G1756:
    if(a >= value(LL_CmaxcanoC)) goto    G1757;
    m = w4;
    q = w3;
    a = w1;
    {
        popv(5);
        return  CC_substTcano(a, q, m);
    }
   G1757:
    m = w4;
    q = w3;
    a = w1;
    {
        popv(5);
        return  CC_substTform(a, q, m);
    }
   G1724:
    q = LITERAL[161];
    a = LITERAL[162];
    CC_errormsg(a, q);
   G1725:
    q = LITERAL[161];
    a = LITERAL[163];
    CC_errormsg(a, q);
   G1726:
    q = LITERAL[161];
    a = LITERAL[164];
    CC_errormsg(a, q);
    a = nil;
   G1722:
    popv(5);
    return a;
}

Sex CC_substTcano(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != value(LL_CratfC)) goto    G1765;
    a = w1;
    {
        popv(3);
        return  CC_subTratf(a, q, m);
    }
   G1765:
    a = value(LL_Hsubstype);
    if(a != LL_bnum) goto    G1766;
    a = w1;
    {
        popv(3);
        return  CC_subTbnum2pol3(a, q, m);
    }
   G1766:
    w2 = q;
    w3 = m;
    if(a != LL_pol3) goto    G1767;
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a != nil) goto    G1769;
    a = cdr(w3);
    a = CC_WspowTbpol(a);
    if(a == nil) goto    G1767;
   G1769:
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_subTpol32pol3(a, q, m);
    }
   G1767:
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_subTexpr2pol3(a, q, m);
    }
}

Sex CC_substTpref(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G1774;
    arg6 = m;
    arg5 = q;
    arg4 = w1;
#define LL_subTcterm LITERAL[165]
    m = LL_subTcterm;
#define LL_subTnterm LITERAL[166]
    q = LL_subTnterm;
#define LL_subTncan LITERAL[167]
    a = LL_subTncan;
    {
        popv(3);
        return  CC_map3TcLxxyy(a, q, m, arg4, arg5, arg6);
    }
   G1774:
    w2 = q;
    w3 = m;
    q = mkfxat(1);
    if(a != LL_cH) goto    G1775;
    a = w1;
    a = cons(a, q);
    m = w3;
    q = w2;
    a = CC_subTcterm(a, q, m);
    w1 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a == nil) goto    G1782;
    goto    G1787;
   G1775:
    a = w1;
    a = cons(a, q);
    m = w3;
    q = w2;
    a = CC_subTnterm(a, q, m);
    w1 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a == nil) goto    G1782;
   G1787:
    a = car(w1);
    goto    G1786;
   G1782:
    q = car(w1);
    a = cdr(w1);
    a = CC_multH(a, q);
   G1786:
    popv(3);
    return a;
}

Sex CC_substTfunc(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G1792;
    a = car(w1);
    if(a != q) goto    G1794;
    a = w1;
    {
        popv(6);
        return  CC_subTfnhead(a, q, m);
    }
   G1794:
    w4 = nil;
    w2 = q;
    w3 = m;
    a = CC_getTfncvars(a);
    w4 = a;
    if(a == nil) goto    G1798;
    q = a;
    a = w2;
    a = Lmember(a, q);
    if(a == nil) goto    G1839;
   G1798:
    q = true;
    a = w1;
    a = CC_convTfunc2expr(a, q);
    w1 = a;
    m = w3;
    q = w2;
    a = LL_rM;
    a = Llist3(a, q, m);
    q = a;
    a = w1;
    a = Llist2(a, q);
    w4 = a;
    goto    G1854;
   G1792:
    w2 = q;
    w3 = m;
    m = nil;
    a = w1;
    a = CC_WfreeTfunc(a, q, m);
    if(a != nil) goto    G1839;
    a = cdr(cdr(w1));
    if(a != nil) goto    G1803;
    a = car(cdr(w1));
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1803;
    a = w1;
    a = Lcadadr(a);
    q = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G1803;
    a = w3;
    a = Lncons(a);
    q = a;
    a = car(w1);
    a = CC_mkTfunc(a, q);
    goto    G1853;
   G1803:
    a = car(w1);
    a = CC_Wpfunc(a);
    if(a == nil) goto    G1808;
    q = true;
    a = w1;
    a = CC_convTfunc2expr(a, q);
    w1 = a;
    m = w3;
    q = w2;
    a = LL_rM;
    a = Llist3(a, q, m);
    q = a;
    a = w1;
    a = Llist2(a, q);
    goto    G1854;
   G1808:
    w4 = nil;
    w5 = nil;
    a = w1;
    a = CC_topcopy(a);
    w1 = a;
    a = cdr(a);
    w4 = a;
    a = w2;
    if(is_cons(a)) goto    G1818;
    if(a != car(w1)) goto    G1827;
    goto    G1824;
   G1818:
    q = car(a);
    a = car(w1);
    a = Lneq(a, q);
    if(a != nil) goto    G1827;
    a = cdr(w2);
    if(a == nil) goto    G1824;
    a = cdr(a);
    if(a != nil) goto    G1827;
    q = car(cdr(w2));
    a = car(cdr(w1));
    a = Lequal(a, q);
    if(a == nil) goto    G1827;
   G1824:
    m = w3;
    q = w2;
    a = w1;
    a = CC_subTfnhead(a, q, m);
    w1 = a;
    a = cdr(a);
    w4 = a;
    a = w2;
    if(!is_cons(a)) goto    G1827;
    a = cdr(a);
    if(a != nil) goto    G1845;
   G1827:
    a = car(w4);
    if(!is_cons(a)) goto    G1840;
    q = LL_Bindex;
    a = car(a);
    a = Lneq(a, q);
    if(a != nil) goto    G1840;
    m = w3;
    q = w2;
    a = car(w4);
    a = CC_subTindex(a, q, m);
    w5 = a;
    q = car(w4);
    a = Lneq(a, q);
    if(a == nil) goto    G1833;
    q = w5;
    a = w4;
    car(a) = q;
   G1833:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1840;
    a = car(w1);
    a = CC_getTfncvars(a);
    w5 = a;
    if(a == nil) goto    G1838;
    q = a;
    a = w2;
    a = Lmember(a, q);
    if(a != nil) goto    G1838;
   G1839:
    a = w1;
    goto    G1811;
   G1838:
    q = true;
    a = w1;
    a = CC_convTfunc2expr(a, q);
    w6 = a;
    m = w3;
    q = w2;
    a = LL_rM;
    a = Llist3(a, q, m);
    q = a;
    a = w6;
    a = Llist2(a, q);
    w5 = a;
   G1854:
    q = a;
#define LL_Asubst LITERAL[168]
    a = LL_Asubst;
    {
        popv(6);
        return  CC_mkTpfunc(a, q);
    }
   G1840:
    m = w3;
    q = w2;
    a = car(w4);
    a = CC_substH(a, q, m);
    w5 = a;
    q = car(w4);
    a = Lneq(a, q);
    if(a == nil) goto    G1845;
    q = w5;
    a = w4;
    car(a) = q;
   G1845:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1840;
    a = w1;
   G1853:
    a = CC_simpTfunc(a);
   G1811:
    popv(6);
    return a;
}

Sex CC_subTfnhead(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    if(is_cons(q)) goto    G1860;
    a = q;
    a = Lncons(a);
    w2 = a;
   G1860:
    a = w3;
    a = CC_Wsinglefunc(a);
    if(a == nil) goto    G1869;
    a = car(cdr(w3));
    w3 = a;
    a = cdr(a);
    if(a == nil) goto    G1858;
    a = car(cdr(w3));
    if(!is_cons(a)) goto    G1869;
    q = LL_Bindex;
    a = car(a);
    a = Lneq(a, q);
    if(a != nil) goto    G1869;
    a = cdr(w2);
    if(a != nil) goto    G1858;
    a = car(cdr(w1));
    if(!is_cons(a)) goto    G1858;
    a = car(a);
    if(a != LL_Bindex) goto    G1858;
   G1869:
    q = w3;
    a = LITERAL[169];
    CC_errormsg(a, q);
   G1858:
    a = car(w3);
    a = CC_Wpfunc(a);
    if(a != nil) goto    G1887;
    a = cdr(w3);
    if(a != nil) goto    G1872;
    a = cdr(w2);
    if(a == nil) goto    G1874;
    a = cdr(cdr(w1));
    goto    G1886;
   G1874:
    a = cdr(w1);
    goto    G1886;
   G1872:
    a = car(cdr(w1));
    if(!is_cons(a)) goto    G1879;
    q = LL_Bindex;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G1878;
   G1879:
    q = cdr(w1);
    a = car(cdr(w3));
    a = cons(a, q);
    goto    G1886;
   G1878:
    q = cdr(cdr(w1));
    a = car(cdr(w3));
    a = cons(a, q);
   G1886:
    q = car(w3);
    {
        popv(3);
        return  Lxcons(a, q);
    }
   G1887:
    q = car(w3);
    a = LITERAL[170];
    CC_errormsg(a, q);
    a = nil;
    popv(3);
    return a;
}

Sex CC_subTindex(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    m = nil;
    a = CC_WfreeTfunc(a, q, m);
    if(a != nil) goto    G1907;
    a = w3;
    if(is_cons(a)) goto    G1894;
    a = Lfixp(a);
    if(a != nil) goto    G1896;
    a = w3;
    a = Lrationalp(a);
    goto    G1896;
   G1894:
    a = car(a);
    a = Lfixp(a);
   G1896:
    if(a != nil) goto    G1892;
    q = w3;
    a = LITERAL[171];
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G1892:
    w4 = nil;
    w5 = nil;
    a = w1;
    a = CC_topcopy(a);
    w1 = a;
    a = cdr(a);
    w4 = a;
   G1899:
    a = car(w4);
    if(is_number(a)) goto    G1905;
    m = w3;
    q = w2;
    a = CC_substTcano(a, q, m);
    w5 = a;
    q = car(w4);
    a = Lneq(a, q);
    if(a == nil) goto    G1905;
    q = w5;
    a = w4;
    car(a) = q;
   G1905:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1899;
   G1907:
    a = w1;
    popv(5);
    return a;
}

Sex CC_subTncan(Sex a, Sex q, Sex m)
{
    if(is_number(a)) goto    G1913;
    a = CC_substTcano(a, q, m);
   G1913:
    return a;
}

Sex CC_subTratf(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    m = nil;
    a = CC_WfreeTcano(a, q, m);
    if(a == nil) goto    G1917;
    a = w1;
    goto    G1945;
   G1917:
    q = LL_expr;
    a = value(LL_Hsubstype);
    a = Lneq(a, q);
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    if(a == nil) goto    G1918;
    w11 = nil;
    a = value(LL_CratfC);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w1);
    w6 = a;
   G1920:
    a = car(w6);
    w7 = a;
    a = car(a);
    w8 = a;
    a = cdr(w7);
    w10 = a;
   G1921:
    a = w8;
    if(is_number(a)) goto    G1926;
    a = w3;
    m = a;
    q = w2;
    if(!is_number(a)) goto    G1925;
    a = w8;
    a = CC_subTbnum2pol3(a, q, m);
    goto    G1926;
   G1925:
    a = w8;
    a = CC_subTpol32pol3(a, q, m);
   G1926:
    w9 = a;
    a = w10;
    if(is_number(a)) goto    G1930;
    a = w3;
    m = a;
    q = w2;
    if(!is_number(a)) goto    G1929;
    a = w10;
    a = CC_subTbnum2pol3(a, q, m);
    goto    G1930;
   G1929:
    a = w10;
    a = CC_subTpol32pol3(a, q, m);
   G1930:
    w11 = a;
    a = w9;
    a = Lzerop(a);
    if(a == nil) goto    G1932;
    a = w11;
    a = Lzerop(a);
    if(a != nil) goto    G1922;
    q = LITERAL[161];
    a = LITERAL[172];
    CC_errormsg(a, q);
   G1932:
    a = w11;
    a = Lzerop(a);
    if(a != nil) goto    G1937;
    q = w9;
    a = w11;
    a = CC_convTnVd2srat(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G1937:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G1920;
    a = w4;
    a = CC_sortTqratf(a);
    {
        popv(11);
        return  CC_redcoefTncan(a);
    }
   G1922:
    m = mkfxat(1);
    q = w2;
    a = w8;
    a = CC_dfTcano(a, q, m);
    w8 = a;
    m = mkfxat(1);
    q = w2;
    a = w10;
    a = CC_dfTcano(a, q, m);
    w10 = a;
    goto    G1921;
   G1918:
    a = cdr(w1);
    w7 = a;
    a = mkfxat(0);
    w4 = a;
    a = value(LL_CratfC);
    a = Lncons(a);
    w6 = a;
    w5 = a;
   G1947:
    a = car(w7);
    w10 = a;
    a = car(a);
    w8 = a;
    a = cdr(w10);
    w9 = a;
    a = w8;
    if(!is_cons(a)) goto    G1949;
    m = w3;
    q = w2;
    a = CC_subTexpr2pol3(a, q, m);
    w8 = a;
   G1949:
    a = w9;
    if(!is_cons(a)) goto    G1951;
    m = w3;
    q = w2;
    a = CC_subTexpr2pol3(a, q, m);
    w9 = a;
   G1951:
    a = w8;
    if(a != car(w10)) goto    G1953;
    if(a != cdr(w10)) goto    G1953;
    a = w10;
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    goto    G1957;
   G1953:
    q = a;
    a = w9;
    a = CC_gV(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
    w4 = a;
   G1957:
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G1947;
    a = cdr(w5);
    if(a != nil) goto    G1962;
    a = w4;
    goto    G1945;
   G1962:
    a = cdr(a);
    if(a != nil) goto    G1964;
    a = car(cdr(w5));
    w10 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G1964;
    a = cdr(w10);
    w5 = a;
   G1964:
    q = w4;
    a = w5;
    a = CC_addH(a, q);
   G1945:
    popv(11);
    return a;
}

Sex CC_subTnterm(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    m = nil;
    a = car(a);
    a = CC_WfreeTc2H(a, q, m);
    if(a == nil) goto    G1972;
    m = nil;
    q = w2;
    a = cdr(w1);
    a = CC_WfreeH(a, q, m);
    if(a != nil) goto    G2073;
   G1972:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    a = LL_ncH;
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = car(w1);
    w11 = a;
    a = cdr(a);
    w12 = a;
    w14 = a;
    a = cdr(w1);
    w6 = a;
    if(is_number(a)) goto    G1988;
    a = car(a);
    m = w3;
    q = w2;
    if(!is_integer(a)) goto    G1987;
    a = w6;
    a = CC_substTcano(a, q, m);
    goto    G1988;
   G1987:
    a = w6;
    a = CC_substTpref(a, q, m);
   G1988:
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2080;
   G1990:
    a = car(w12);
    w7 = a;
    if(is_cons(a)) goto    G1993;
    if(a != w2) goto    G2000;
    goto    G2081;
   G1993:
    a = car(a);
    if(!is_integer(a)) goto    G1997;
    m = w3;
    q = w2;
    a = w7;
    a = CC_substTcano(a, q, m);
    goto    G2000;
   G1997:
    q = LITERAL[173];
    a = Lmemq(a, q);
    if(a == nil) goto    G1998;
    m = w3;
    q = w2;
    a = w7;
    a = CC_substTpref(a, q, m);
    goto    G2000;
   G1998:
    q = w2;
    a = w7;
    a = Lequal(a, q);
    if(a == nil) goto    G1999;
   G2081:
    a = w3;
    goto    G2000;
   G1999:
    m = w3;
    q = w2;
    a = w7;
    a = CC_substTfunc(a, q, m);
   G2000:
    w8 = a;
    a = car(cdr(w12));
    w9 = a;
    if(is_number(a)) goto    G2003;
    m = w3;
    q = w2;
    a = CC_substTexpt(a, q, m);
   G2003:
    w10 = a;
    a = w8;
    if(a != w7) goto    G2005;
    a = w10;
    if(a != w9) goto    G2005;
    a = w14;
    if(a != w11) goto    G1981;
    goto    G1983;
   G2005:
    a = w8;
    a = Lzerop(a);
    if(a == nil) goto    G2015;
    a = w10;
    if(!is_number(a)) goto    G2015;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2012;
   G2080:
    q = mkfxat(0);
    a = mkfxat(0);
    goto    G2082;
   G2012:
    a = w10;
    a = Lzerop(a);
    q = LITERAL[161];
    if(a == nil) goto    G2014;
    a = LITERAL[174];
    goto    G2083;
   G2014:
    a = LITERAL[175];
   G2083:
    CC_errormsg(a, q);
   G2015:
    q = w12;
    a = w14;
    a = Lneq(a, q);
    if(a == nil) goto    G2017;
    a = car(w14);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w13 = a;
    a = car(cdr(w14));
    a = Lncons(a);
    q = a;
    a = w13;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(cdr(w14));
    w14 = a;
    goto    G2015;
   G2017:
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G2064;
    a = w8;
    if(is_cons(a)) goto    G2024;
    if(!is_number(a)) goto    G1979;
    goto    G2029;
   G2024:
    a = CC_Wcfunc(a);
    if(a == nil) goto    G2028;
    q = true;
    a = w8;
    a = CC_convTfunc2expr(a, q);
    w8 = a;
    goto    G2029;
   G2028:
    q = nil;
    a = w8;
    a = CC_Wcommute(a, q);
    if(a == nil) goto    G1979;
   G2029:
    q = w10;
    a = w8;
    a = CC_unpowH(a, q);
    q = a;
    a = w6;
    a = CC_chkmultH(a, q);
    w6 = a;
    goto    G2064;
   G1979:
    a = w8;
    if(!is_cons(a)) goto    G1981;
    q = LITERAL[173];
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G1981;
    a = car(w8);
    if(a != LL_ncH) goto    G2034;
    a = cdr(cdr(cdr(w8)));
    if(a != nil) goto    G1981;
    q = w10;
    a = car(cdr(cdr(w8)));
    a = CC_multTexpt(a, q);
    w10 = a;
    a = car(cdr(w8));
    goto    G2084;
   G2034:
    a = w8;
    a = CC_convTcL2cnterm(a);
    w8 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a != nil) goto    G2089;
    q = w10;
    a = cdr(w8);
    a = CC_unpowH(a, q);
    q = a;
    a = w6;
    a = CC_chkmultH(a, q);
    w6 = a;
    a = car(w8);
   G2084:
    w8 = a;
    goto    G1979;
    a = car(w8);
    if(a != LL_ncH) goto    G1981;
    a = cdr(cdr(cdr(w8)));
    if(a == nil) goto    G1981;
    a = w10;
    a = Lonep(a);
    if(a == nil) goto    G1981;
    a = cdr(w4);
    if(a != nil) goto    G2045;
    a = w8;
    a = CC_topcopy(a);
    w4 = a;
    a = CC_tail2(a);
    goto    G2086;
   G2045:
    a = w8;
    a = CC_topcopy(a);
    q = a;
    a = w4;
    a = CC_multTncHncH(a, q);
    w4 = a;
    if(!is_number(a)) goto    G2050;
    q = a;
    a = w6;
    a = CC_multH(a, q);
    w6 = a;
    a = LL_ncH;
    a = Lncons(a);
    w5 = a;
    w4 = a;
    goto    G2064;
   G2050:
    q = LL_ncH;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G2051;
    m = mkfxat(1);
    q = w4;
    a = LL_ncH;
    a = Llist3(a, q, m);
    w4 = a;
    a = cdr(a);
    goto    G2086;
   G2051:
    a = w4;
    a = CC_tail2(a);
   G2086:
    w13 = a;
    goto    G2087;
   G2089:
    a = car(cdr(car(w8)));
    w8 = a;
   G1981:
    a = cdr(w4);
    if(a == nil) goto    G2057;
    q = w8;
    a = car(w13);
    a = Lequal(a, q);
    if(a != nil) goto    G2056;
   G2057:
    a = w8;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w13 = a;
    a = w10;
    a = Lncons(a);
    q = a;
    a = w13;
    cdr(a) = q;
   G2087:
    a = cdr(a);
    w5 = a;
    goto    G2064;
   G2056:
    q = w10;
    a = car(w5);
    a = CC_addTexpt(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2062;
    q = w9;
    a = w5;
    car(a) = q;
    goto    G2064;
   G2062:
    q = w13;
    a = w4;
    a = CC_before(a, q);
    w5 = a;
    q = nil;
    cdr(a) = q;
    a = cdr(w4);
    if(a == nil) goto    G2064;
    a = w4;
    a = CC_tail2(a);
    w13 = a;
   G2064:
    a = cdr(cdr(w12));
    w12 = a;
    w14 = a;
    goto    G2088;
   G1983:
    a = cdr(cdr(w12));
    w12 = a;
   G2088:
    if(a != nil) goto    G1990;
   G2070:
    a = w14;
    if(a != cdr(w11)) goto    G2072;
    a = w6;
    if(a != cdr(w1)) goto    G2072;
   G2073:
    a = w1;
    goto    G1974;
   G2072:
    q = w14;
    a = w5;
    cdr(a) = q;
    a = w4;
    a = CC_reduceTncH(a);
    w4 = a;
    q = nil;
    a = CC_Wcommute(a, q);
    if(a != nil) goto    G2075;
    q = w6;
    a = w4;
   G2082:
    {
        popv(14);
        return  cons(a, q);
    }
   G2075:
    q = w6;
    a = w4;
    a = CC_chkmultH(a, q);
    q = mkfxat(1);
    a = Lxcons(a, q);
   G1974:
    popv(14);
    return a;
}

Sex CC_subTcterm(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    m = nil;
    a = car(a);
    a = CC_WfreeTc2H(a, q, m);
    if(a != nil) goto    G2157;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    a = LL_cH;
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(car(w1));
    w8 = a;
    w9 = a;
    a = cdr(w1);
    w6 = a;
   G2096:
    a = car(w8);
    w10 = a;
    if(is_number(a)) goto    G2107;
    a = car(a);
    if(!is_integer(a)) goto    G2104;
    m = w3;
    q = w2;
    a = w10;
    a = CC_substTcano(a, q, m);
    goto    G2107;
   G2104:
    if(a != LL_cL) goto    G2105;
    m = w3;
    q = w2;
    a = w10;
    a = CC_substTpref(a, q, m);
    goto    G2107;
   G2105:
    q = w2;
    a = w10;
    a = Lequal(a, q);
    if(a == nil) goto    G2106;
    a = w3;
    goto    G2107;
   G2106:
    m = w3;
    q = w2;
    a = w10;
    a = CC_substTfunc(a, q, m);
   G2107:
    w11 = a;
    a = car(cdr(w8));
    w12 = a;
    if(is_number(a)) goto    G2110;
    m = w3;
    q = w2;
    a = CC_substTexpt(a, q, m);
   G2110:
    w13 = a;
    a = w11;
    if(a != w10) goto    G2112;
    a = w13;
    if(a == w12) goto    G2098;
   G2112:
    a = w11;
    a = Lzerop(a);
    if(a == nil) goto    G2114;
    a = w13;
    if(!is_number(a)) goto    G2114;
    a = cdr(cdr(w8));
    if(a == nil) goto    G2117;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(13);
        return  CC_limitTcterm(a, q, m);
    }
   G2117:
    q = mkfxat(0);
    a = w13;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2119;
    q = mkfxat(0);
    a = mkfxat(0);
    goto    G2158;
   G2119:
    a = w13;
    a = Lzerop(a);
    q = LITERAL[161];
    if(a == nil) goto    G2121;
    a = LITERAL[174];
    goto    G2159;
   G2121:
    a = LITERAL[175];
   G2159:
    CC_errormsg(a, q);
   G2114:
    q = w8;
    a = w9;
    a = Lneq(a, q);
    if(a == nil) goto    G2124;
    a = car(cdr(w9));
    a = Lncons(a);
    q = car(w9);
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
    a = cdr(cdr(w9));
    w9 = a;
    goto    G2114;
   G2124:
    a = w13;
    a = Lzerop(a);
    if(a != nil) goto    G2139;
    a = w11;
    if(a != w10) goto    G2131;
    a = w13;
    a = Lncons(a);
    q = w11;
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
    goto    G2139;
   G2131:
    if(!is_cons(a)) goto    G2136;
    a = car(a);
    if(!is_symbol(a)) goto    G2136;
    q = LITERAL[176];
    a = Lmemq(a, q);
    if(a != nil) goto    G2136;
    q = w7;
    a = w13;
    a = cons(a, q);
    q = w11;
    a = Lxcons(a, q);
    w7 = a;
    goto    G2139;
   G2136:
    q = w13;
    a = w11;
    a = CC_unpowH(a, q);
    q = a;
    a = w6;
    a = CC_chkmultH(a, q);
    w6 = a;
   G2139:
    a = cdr(cdr(w8));
    w8 = a;
    w9 = a;
    goto    G2160;
   G2098:
    a = cdr(cdr(w8));
    w8 = a;
   G2160:
    if(a != nil) goto    G2096;
   G2144:
    a = w9;
    if(a != cdr(car(w1))) goto    G2146;
   G2157:
    a = w1;
    goto    G2094;
   G2146:
    q = a;
    a = w5;
    cdr(a) = q;
    a = w7;
    if(a == nil) goto    G2101;
    a = cdr(w4);
    w4 = a;
   G2100:
    m = w4;
    q = car(cdr(w7));
    a = car(w7);
    a = CC_sortTbasexp(a, q, m);
    w4 = a;
    a = cdr(cdr(w7));
    w7 = a;
    if(a != nil) goto    G2100;
    q = w4;
    a = LL_cH;
    a = cons(a, q);
    w4 = a;
   G2101:
    a = w4;
    a = CC_reduceTcH(a);
    w4 = a;
    a = w6;
    if(!is_number(a)) goto    G2152;
    q = w4;
    goto    G2161;
   G2152:
    a = w4;
    if(!is_number(a)) goto    G2153;
    q = w6;
   G2161:
    {
        popv(13);
        return  Lxcons(a, q);
    }
   G2153:
    q = a;
    a = w6;
    a = CC_chkmultH(a, q);
    q = mkfxat(1);
   G2158:
    a = cons(a, q);
   G2094:
    popv(13);
    return a;
}

Sex CC_subTbnum2pol3(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(cdr(a));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2177;
    w4 = nil;
    a = cdr(w1);
    w4 = a;
    q = car(a);
    a = w2;
    a = Lequal(a, q);
    m = w3;
    q = w2;
    if(a == nil) goto    G2169;
    a = w4;
    a = CC_subTbnum2bpolvar(a, q, m);
    goto    G2170;
   G2169:
    a = w4;
    a = CC_subTbnum2bpolcof(a, q, m);
   G2170:
    w4 = a;
    if(a != cdr(w1)) goto    G2172;
   G2177:
    a = w1;
    goto    G2166;
   G2172:
    if(is_number(a)) goto    G2174;
    a = car(a);
    if(!is_integer(a)) goto    G2173;
   G2174:
    a = w4;
    goto    G2166;
   G2173:
    q = w4;
    a = car(w1);
    a = cons(a, q);
   G2166:
    popv(4);
    return a;
}

Sex CC_subTpol32pol3(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(cdr(a));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2204;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w1;
    a = CC_coefTpol3(a, q);
    w5 = a;
    a = cdr(car(a));
    if(a != w1) goto    G2188;
   G2204:
    a = w1;
    goto    G2182;
   G2188:
    a = car(car(w5));
    a = Lzerop(a);
    if(a != nil) goto    G2189;
    a = mkfxat(0);
    w4 = a;
    goto    G2190;
   G2189:
    a = cdr(car(w5));
    w4 = a;
    a = cdr(w5);
    w5 = a;
   G2190:
    a = mkfxat(0);
    w7 = a;
   G2184:
    q = w7;
    a = car(car(w5));
    a = diff2(a, q);
    w8 = a;
    a = car(car(w5));
    w7 = a;
    a = w6;
    q = w8;
    if(a != nil) goto    G2192;
    a = w3;
    a = CC_powTcanopint(a, q);
    goto    G2193;
   G2192:
    a = w3;
    a = CC_powTcanopint(a, q);
    q = w6;
    a = CC_psHanyany(a, q);
   G2193:
    w6 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2196;
    a = w4;
    goto    G2182;
   G2196:
    a = w4;
    a = Lzerop(a);
    q = w6;
    if(a == nil) goto    G2198;
    a = cdr(car(w5));
    a = CC_psHanyany(a, q);
    goto    G2199;
   G2198:
    a = cdr(car(w5));
    a = CC_psHanyany(a, q);
    q = a;
    a = w4;
    a = CC_Lanyany(a, q);
   G2199:
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G2184;
    a = w4;
    a = CC_redcoefTncan(a);
   G2182:
    popv(8);
    return a;
}

Sex CC_subTexpr2pol3(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(cdr(a));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2231;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w1;
    a = CC_coefTpol3(a, q);
    w5 = a;
    a = cdr(car(a));
    if(a != w1) goto    G2215;
   G2231:
    a = w1;
    goto    G2209;
   G2215:
    a = car(car(w5));
    a = Lzerop(a);
    if(a != nil) goto    G2216;
    a = mkfxat(0);
    w4 = a;
    goto    G2217;
   G2216:
    a = cdr(car(w5));
    w4 = a;
    a = cdr(w5);
    w5 = a;
   G2217:
    a = mkfxat(0);
    w7 = a;
   G2211:
    q = w7;
    a = car(car(w5));
    a = diff2(a, q);
    w8 = a;
    a = car(car(w5));
    w7 = a;
    a = value(LL_Hexpmode);
    if(a != LL_unexp) goto    G2219;
    q = w7;
    a = w3;
    a = CC_unpowH(a, q);
    goto    G2221;
   G2219:
    a = w6;
    q = w8;
    if(a != nil) goto    G2220;
    a = w3;
    a = CC_powH(a, q);
    goto    G2221;
   G2220:
    a = w3;
    a = CC_powH(a, q);
    q = w6;
    a = CC_multH(a, q);
   G2221:
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2230;
    a = w4;
    a = Lzerop(a);
    q = w6;
    if(a == nil) goto    G2226;
    a = cdr(car(w5));
    a = CC_chkmultH(a, q);
    goto    G2227;
   G2226:
    a = cdr(car(w5));
    a = CC_chkmultH(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
   G2227:
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G2211;
   G2230:
    a = w4;
   G2209:
    popv(8);
    return a;
}

Sex CC_subTbnum2bpolvar(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    a = Lzerop(a);
    if(a == nil) goto    G2236;
    a = w1;
    a = Llast(a);
    w3 = a;
    a = car(a);
    a = Lzerop(a);
    if(a == nil) goto    G2238;
    a = cdr(w3);
    goto    G2242;
   G2238:
    a = mkfxat(0);
    goto    G2242;
   G2236:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = mkfxat(0);
    w4 = a;
    a = cdr(w1);
    w1 = a;
   G2244:
    a = car(car(w1));
    w5 = a;
    q = a;
    if(!is_integer(a)) goto    G2246;
    a = w3;
    a = CC_powTbnumpint(a, q);
    goto    G2247;
   G2246:
    a = w3;
    a = CC_powTbnumbnum(a, q);
   G2247:
    w6 = a;
    q = cdr(car(w1));
    a = CC_Hbnumany(a, q);
    w6 = a;
    a = w4;
    a = Lzerop(a);
    if(a == nil) goto    G2249;
    a = w6;
    goto    G2250;
   G2249:
    q = w4;
    a = w6;
    a = CC_Lanyany(a, q);
   G2250:
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2244;
    a = w4;
   G2242:
    popv(6);
    return a;
}

Sex CC_subTbnum2bpolcof(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(a);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w1);
    w7 = a;
    w8 = a;
   G2256:
    a = cdr(car(w7));
    w6 = a;
    if(is_number(a)) goto    G2279;
    a = car(a);
    if(!is_integer(a)) goto    G2262;
    m = w3;
    q = w2;
    a = w6;
    a = CC_subTbnum2pol3(a, q, m);
    goto    G2286;
   G2262:
    q = a;
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G2263;
    m = w3;
    q = w2;
    a = w6;
    a = CC_subTbnum2bpolvar(a, q, m);
    goto    G2286;
   G2263:
    q = car(w6);
    a = w2;
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G2279;
    m = w3;
    q = w2;
    a = w6;
    a = CC_subTbnum2bpolcof(a, q, m);
   G2286:
    w9 = a;
    a = w9;
    if(a == w6) goto    G2279;
   G2267:
    q = w7;
    a = w8;
    a = Lneq(a, q);
    if(a == nil) goto    G2269;
    a = car(w8);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w8);
    w8 = a;
    goto    G2267;
   G2269:
    a = w9;
    a = Lzerop(a);
    if(a != nil) goto    G2273;
    q = w9;
    a = car(car(w7));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G2273:
    a = cdr(w7);
    w7 = a;
    w8 = a;
    goto    G2287;
   G2279:
    a = cdr(w7);
    w7 = a;
   G2287:
    if(a != nil) goto    G2256;
   G2281:
    a = w8;
    if(a != cdr(w1)) goto    G2283;
    a = w1;
    goto    G2255;
   G2283:
    q = a;
    a = w5;
    cdr(a) = q;
    a = w4;
    a = CC_reduceTbpol(a);
   G2255:
    popv(9);
    return a;
}



/* initialization procedure */
int init_bseval(void)
{
   long i;

   create_symbols(bseval_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; bseval_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(bseval_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m;
        a = LITERAL[177];
        CC_Aenter(a);
        m = LL_local;
        q = LL_BgevalB;
        a = LL_Bloc;
        Lput(a, q, m);
        m = LL_local;
        q = LL_BgevalB;
        a = LL_Bdcl;
        Lput(a, q, m);
        m = LL_local;
        q = LL_BgevalB;
        a = LL_Bgex;
        Lput(a, q, m);
#define LL_specl LITERAL[178]
        m = LL_specl;
        q = LL_BgevalB;
        a = LL_gTM;
        Lput(a, q, m);
        m = LL_specl;
        q = LL_BgevalB;
        a = LL_Bqid;
        Lput(a, q, m);
        m = LL_specl;
        q = LL_BgevalB;
        a = LL_Bquote;
        Lput(a, q, m);
        m = LL_specl;
        q = LL_BgevalB;
        a = LL_Bindex;
        Lput(a, q, m);
#define LL_WM LITERAL[179]
        m = LL_WM;
        q = LL_Brel2prd;
#define LL_gM LITERAL[180]
        a = LL_gM;
        Lput(a, q, m);
#define LL_WVM LITERAL[181]
        m = LL_WVM;
        q = LL_Brel2prd;
#define LL_gVM LITERAL[182]
        a = LL_gVM;
        Lput(a, q, m);
#define LL_WR LITERAL[183]
        m = LL_WR;
        q = LL_Brel2prd;
#define LL_gR LITERAL[184]
        a = LL_gR;
        Lput(a, q, m);
#define LL_WS LITERAL[185]
        m = LL_WS;
        q = LL_Brel2prd;
#define LL_gS LITERAL[186]
        a = LL_gS;
        Lput(a, q, m);
#define LL_WRM LITERAL[187]
        m = LL_WRM;
        q = LL_Brel2prd;
#define LL_gRM LITERAL[188]
        a = LL_gRM;
        Lput(a, q, m);
#define LL_WSM LITERAL[189]
        m = LL_WSM;
        q = LL_Brel2prd;
#define LL_gSM LITERAL[190]
        a = LL_gSM;
        Lput(a, q, m);
        m = LL_gM;
        q = LL_Bprd2rel;
        a = LL_WM;
        Lput(a, q, m);
        m = LL_gVM;
        q = LL_Bprd2rel;
        a = LL_WVM;
        Lput(a, q, m);
        m = LL_gR;
        q = LL_Bprd2rel;
        a = LL_WR;
        Lput(a, q, m);
        m = LL_gS;
        q = LL_Bprd2rel;
        a = LL_WS;
        Lput(a, q, m);
        m = LL_gRM;
        q = LL_Bprd2rel;
        a = LL_WRM;
        Lput(a, q, m);
        m = LL_gSM;
        q = LL_Bprd2rel;
        a = LL_WSM;
        a = Lput(a, q, m);
        return 1;
    }
}
Sex LITERAL[192];

const  char *bseval_literal_string[192] =
{
/* 0 */
"quote",
/* 1 */
"!!index",
/* 2 */
"(!!loc !!dcl)",
/* 3 */
"\"INVALID AS INDEXED-ID\"",
/* 4 */
"gev!:xfunc",
/* 5 */
"!!loc",
/* 6 */
"call!:name",
/* 7 */
"!!dcl",
/* 8 */
"!!gex",
/* 9 */
"!!qid",
/* 10 */
"gev!:func",
/* 11 */
"\"INVALID AS FUNCTION NAME\"",
/* 12 */
"!!geval!!",
/* 13 */
"!*temporal",
/* 14 */
"lisp",
/* 15 */
"flag",
/* 16 */
"flagcmnd!*",
/* 17 */
"local",
/* 18 */
"gev!:id",
/* 19 */
"g!:!=",
/* 20 */
"\"INVALID USE OF ' BEFORE\"",
/* 21 */
"gev!:xid",
/* 22 */
"!!quote",
/* 23 */
"\"MK!.GPROG\"",
/* 24 */
"!!gcmnd!!",
/* 25 */
"mk!.gprog",
/* 26 */
"!!pfunc",
/* 27 */
"gev!:pfunc",
/* 28 */
"!!narg",
/* 29 */
"gev!:narg",
/* 30 */
"!!unevl",
/* 31 */
"\"INVALID AS NAME\"",
/* 32 */
"list",
/* 33 */
"(g!:!= de ! !% ! !%!# ! enter)",
/* 34 */
"gsimp!*",
/* 35 */
"setq",
/* 36 */
"\"INVALID AS LEFT OF :=\"",
/* 37 */
"!!onfflg",
/* 38 */
"!.gstack",
/* 39 */
"\"PROBABLY, MISSING * BETWEEN NAME AND ( \"",
/* 40 */
"\"PROBABLY, MISSING ' FOR ARRAY/FORM NAME\"",
/* 41 */
"\"INVALID ID(...) FORM, ID EVALUATED TO\"",
/* 42 */
"\"INVALID ID(...) FORM, ID IS LOCAL-VAR\"",
/* 43 */
"!!gid",
/* 44 */
"uneval",
/* 45 */
"indxed",
/* 46 */
"\"MISSING INDEX TO INDEXED-ID\"",
/* 47 */
"\"MISSING INDEX TO\"",
/* 48 */
"\"INVALID INDEX TO\"",
/* 49 */
"\"NON-INDEXED IS USED AS INDEXED-ID\"",
/* 50 */
"uncomp",
/* 51 */
"mkquote",
/* 52 */
"pfunc",
/* 53 */
"func",
/* 54 */
"(array form)",
/* 55 */
"(array vect matx tens)",
/* 56 */
"\"VAR/NUM/SYMBOL IS USED AS FUNCTION-NAME\"",
/* 57 */
"!*sindex",
/* 58 */
"\"ELEMENT IS NOT DEFINED YET FOR\"",
/* 59 */
"! nil",
/* 60 */
"\"NIL ELEMENT DETECTED IN\"",
/* 61 */
"uncom",
/* 62 */
"nc!*",
/* 63 */
"!#poly!#",
/* 64 */
"\"INDEX IS OUT OF RANGE\"",
/* 65 */
"\"NON-FUNC IS USED AS FUNCTION-NAME\"",
/* 66 */
"galeval",
/* 67 */
"!!oset",
/* 68 */
"!!set",
/* 69 */
"array",
/* 70 */
"!#maxcano!#",
/* 71 */
"!!ctype!!",
/* 72 */
"rat",
/* 73 */
"\"<FORM>-ELEMENT IS NOT <BNUM/CANO/PREF>\"",
/* 74 */
"!#simpenv!#",
/* 75 */
"!#ordenv!#",
/* 76 */
"!#evalenv!#",
/* 77 */
"matx",
/* 78 */
"!#matx!#",
/* 79 */
"vect",
/* 80 */
"!#vect!#",
/* 81 */
"tens",
/* 82 */
"!#tens!#",
/* 83 */
"\"TOO FEW INDICES\"",
/* 84 */
"\"TOO MANY INDICES\"",
/* 85 */
"!!rel2prd",
/* 86 */
"!!prd2rel",
/* 87 */
"uniqrep",
/* 88 */
"!#maxform!#",
/* 89 */
"gal",
/* 90 */
"\"MKEXPR\"",
/* 91 */
"(c!* nc!*)",
/* 92 */
"invalid",
/* 93 */
"head",
/* 94 */
"!!argclass",
/* 95 */
"arg1",
/* 96 */
"(argxy1 argx2 argx2n)",
/* 97 */
"(arg1 arg2 argn)",
/* 98 */
"argxy1",
/* 99 */
"r!=",
/* 100 */
"\"INVALID IDENTIFIER-ARGUMENT FOR\"",
/* 101 */
"(argx1 argxy1 argxn)",
/* 102 */
"mkfunc",
/* 103 */
"var",
/* 104 */
"algf",
/* 105 */
"!#algf!#",
/* 106 */
"\"DO NOT INDEX THE <ALGF>\"",
/* 107 */
"num",
/* 108 */
"algn",
/* 109 */
"!#algn!#",
/* 110 */
"\"DO NOT INDEX THE <ALGN>\"",
/* 111 */
"symbol",
/* 112 */
"c!*",
/* 113 */
"!*evalmode",
/* 114 */
"!*compmode",
/* 115 */
"!*simpmode",
/* 116 */
"c!+",
/* 117 */
"eval",
/* 118 */
"form",
/* 119 */
"unsimp",
/* 120 */
"!!opnrules",
/* 121 */
"userdef",
/* 122 */
"steval",
/* 123 */
"\"ASSIGN VALUE IS NIL\"",
/* 124 */
"(var symbol)",
/* 125 */
"!!array",
/* 126 */
"(vect matx tens)",
/* 127 */
"!!form",
/* 128 */
"dummy",
/* 129 */
"\"INDEX IS NOT INTEGER FOR\"",
/* 130 */
"\"X:=F(..X..) IS DETECTED, WHERE X IS\"",
/* 131 */
"\"ARRAY/FORM-SIZE CHANGED FOR\"",
/* 132 */
"\"ARRAY/FORM SIZES MISMATCH FOR\"",
/* 133 */
"\"NOT ALLOWED TO ASSIGN TO\"",
/* 134 */
"\"LEFT OF := IS FUNCTION-FORM\"",
/* 135 */
"\"INVALID AS VECT/MATX/TENS ELEMENT\"",
/* 136 */
"\"<ARRAY/FORM> TYPE-MISMATCH IN := TO\"",
/* 137 */
"\"SIZE IS NOT DEFINED YET FOR\"",
/* 138 */
"rel",
/* 139 */
"set",
/* 140 */
"log",
/* 141 */
"!#ratf!#",
/* 142 */
"!*rdstat",
/* 143 */
"rule",
/* 144 */
"(c!* nc!* c!+)",
/* 145 */
"\"FUNCTION\"",
/* 146 */
"uncol",
/* 147 */
"!*colmode",
/* 148 */
"bnum",
/* 149 */
"unexp",
/* 150 */
"!*expmode",
/* 151 */
"pol3",
/* 152 */
"expr",
/* 153 */
"!*substype",
/* 154 */
"!*mod",
/* 155 */
"!*fcut",
/* 156 */
"!*float",
/* 157 */
"!*!*mod",
/* 158 */
"(r!= r!-!>)",
/* 159 */
"! invalid",
/* 160 */
"\"CAN NOT BE SUBSTITUTED FOR\"",
/* 161 */
"\"SUBST\"",
/* 162 */
"\"SECOND ARG MUST BE 'X = S' FORM\"",
/* 163 */
"\"<UNCOMM> UNSUBSTITUTABLE TO <COMM>\"",
/* 164 */
"\"SUBSTITUENT IS NOT <RAT-EXPR>\"",
/* 165 */
"sub!:cterm",
/* 166 */
"sub!:nterm",
/* 167 */
"sub!:ncan",
/* 168 */
"! subst",
/* 169 */
"\"CANNOT BE SUBSTITUTED FOR FUNC-NAME\"",
/* 170 */
"\"PFUNC-NAME IS NOT SUBSTITUTED\"",
/* 171 */
"\"INVALID AS SUBSTITUTE FOR INDEX\"",
/* 172 */
"\"0 DENOMINATOR BY\"",
/* 173 */
"(nc!* c!+)",
/* 174 */
"\"0**0 IS FORMED IN\"",
/* 175 */
"\"0**<NEGATIVE> IS FORMED IN\"",
/* 176 */
"(c!+ c!*)",
/* 177 */
"(lisp)",
/* 178 */
"specl",
/* 179 */
"!?!=",
/* 180 */
"g!=",
/* 181 */
"!?!/!=",
/* 182 */
"g!/!=",
/* 183 */
"!?!<",
/* 184 */
"g!<",
/* 185 */
"!?!>",
/* 186 */
"g!>",
/* 187 */
"!?!<!=",
/* 188 */
"g!<!=",
/* 189 */
"!?!>!=",
/* 190 */
"g!>!=",
/* 191 */ NULL
};
setup_type const bseval_g_setup[] =
{
    {"sub:bnum2bpolcof", (lisp_proc *)CC_subTbnum2bpolcof, 3},
    {"sub:bnum2bpolvar", (lisp_proc *)CC_subTbnum2bpolvar, 3},
    {"sub:expr2pol3", (lisp_proc *)CC_subTexpr2pol3, 3},
    {"sub:pol32pol3", (lisp_proc *)CC_subTpol32pol3, 3},
    {"sub:bnum2pol3", (lisp_proc *)CC_subTbnum2pol3, 3},
    {"sub:cterm", (lisp_proc *)CC_subTcterm, 3},
    {"sub:nterm", (lisp_proc *)CC_subTnterm, 3},
    {"sub:ratf", (lisp_proc *)CC_subTratf, 3},
    {"sub:ncan", (lisp_proc *)CC_subTncan, 3},
    {"sub:index", (lisp_proc *)CC_subTindex, 3},
    {"sub:fnhead", (lisp_proc *)CC_subTfnhead, 3},
    {"subst:func", (lisp_proc *)CC_substTfunc, 3},
    {"subst:pref", (lisp_proc *)CC_substTpref, 3},
    {"subst:cano", (lisp_proc *)CC_substTcano, 3},
    {"subst:rat", (lisp_proc *)CC_substTrat, 2},
    {"subst:expt", (lisp_proc *)CC_substTexpt, 3},
    {"subst*", (lisp_proc *)CC_substH, 3},
    {"?regord:bpol", (lisp_proc *)CC_WregordTbpol, 2},
    {"ord:mkmono", (lisp_proc *)CC_ordTmkmono, 1},
    {"ord:nextmono", (lisp_proc *)CC_ordTnextmono, 2},
    {"ord:bpol", (lisp_proc *)CC_ordTbpol, 1},
    {"order:c+", (lisp_proc *)CC_orderTcL, 1},
    {"order:c*", (lisp_proc *)CC_orderTcH, 1},
    {"order:nc*", (lisp_proc *)CC_orderTncH, 1},
    {"order:func", (lisp_proc *)CC_orderTfunc, 1},
    {"order:pol3", (lisp_proc *)CC_orderTpol3, 1},
    {"order:set", (lisp_proc *)CC_orderTset, 1},
    {"order:rel", (lisp_proc *)CC_orderTrel, 1},
    {"order:pref", (lisp_proc *)CC_orderTpref, 1},
    {"order:cano", (lisp_proc *)CC_orderTcano, 1},
    {"update:canpre", (lisp_proc *)CC_updateTcanpre, 2},
    {"argeval*", (lisp_proc *)CC_argevalH, 1},
    {"update*", (lisp_proc *)CC_updateH, 2},
    {"reorder*", (lisp_proc *)CC_reorderH, 1},
    {"idlis:bpol", (lisp_proc *)CC_idlisTbpol, 1},
    {"idlist:c+", (lisp_proc *)CC_idlistTcL, 1},
    {"idlist:c*", (lisp_proc *)CC_idlistTcH, 1},
    {"idlist:nc*", (lisp_proc *)CC_idlistTncH, 1},
    {"idlist:form", (lisp_proc *)CC_idlistTform, 1},
    {"idlist:pref", (lisp_proc *)CC_idlistTpref, 1},
    {"idlist:cano", (lisp_proc *)CC_idlistTcano, 1},
    {"idlist:func", (lisp_proc *)CC_idlistTfunc, 1},
    {"idlist:rel", (lisp_proc *)CC_idlistTrel, 1},
    {"idset:rel", (lisp_proc *)CC_idsetTrel, 1},
    {"idset:rat", (lisp_proc *)CC_idsetTrat, 1},
    {"idlist*", (lisp_proc *)CC_idlistH, 1},
    {"g:=", (lisp_proc *)CC_gTM, 2},
    {"chk:evlid", (lisp_proc *)CC_chkTevlid, 1},
    {"chk:smpfn", (lisp_proc *)CC_chkTsmpfn, 1},
    {"mkcopy:arry", (lisp_proc *)CC_mkcopyTarry, 4},
    {"evl:gform", (lisp_proc *)CC_evlTgform, 2},
    {"evl:gexpr", (lisp_proc *)CC_evlTgexpr, 2},
    {"evl:sexpr", (lisp_proc *)CC_evlTsexpr, 2},
    {"?cmparg", (lisp_proc *)CC_Wcmparg, 1},
    {"smpmode:", (lisp_proc *)CC_smpmodeT, 1},
    {"cmpmode:", (lisp_proc *)CC_cmpmodeT, 1},
    {"evlmode:", (lisp_proc *)CC_evlmodeT, 1},
    {"conv:form2arry", (lisp_proc *)CC_convTform2arry, 1},
    {"conv:arry2tens", (lisp_proc *)CC_convTarry2tens, 2},
    {"conv:arry2matx", (lisp_proc *)CC_convTarry2matx, 2},
    {"conv:arry2vect", (lisp_proc *)CC_convTarry2vect, 2},
    {"conv:garry2arry", (lisp_proc *)CC_convTgarry2arry, 1},
    {"conv:arry2garry", (lisp_proc *)CC_convTarry2garry, 2},
    {"conv:list2set", (lisp_proc *)CC_convTlist2set, 1},
    {"conv:list2oset", (lisp_proc *)CC_convTlist2oset, 1},
    {"conv:var2pref", (lisp_proc *)CC_convTvar2pref, 2},
    {"conv:var2cano", (lisp_proc *)CC_convTvar2cano, 2},
    {"conv:func2expr", (lisp_proc *)CC_convTfunc2expr, 2},
    {"conv:id2expr", (lisp_proc *)CC_convTid2expr, 2},
    {"mk:pfunc", (lisp_proc *)CC_mkTpfunc, 2},
    {"mk:func", (lisp_proc *)CC_mkTfunc, 2},
    {" expr2varfunc", (lisp_proc *)CC_Aexpr2varfunc, 1},
    {" var2expr", (lisp_proc *)CC_Avar2expr, 1},
    {" func2expr", (lisp_proc *)CC_Afunc2expr, 1},
    {" mkexpr", (lisp_proc *)CC_Amkexpr, 1},
    {"conv:prd2rel", (lisp_proc *)CC_convTprd2rel, 1},
    {"conv:rel2prd", (lisp_proc *)CC_convTrel2prd, 1},
    {"?chkindex", (lisp_proc *)CC_Wchkindex, 1},
    {"address*", (lisp_proc *)CC_addressH, 2},
    {"gev:arform", (lisp_proc *)CC_gevTarform, 3},
    {"gev:set", (lisp_proc *)CC_gevTset, 2},
    {"gev:xfunc", (lisp_proc *)CC_gevTxfunc, 3},
    {"gev:func", (lisp_proc *)CC_gevTfunc, 2},
    {"gev:pfunc", (lisp_proc *)CC_gevTpfunc, 2},
    {"gev:narg", (lisp_proc *)CC_gevTnarg, 2},
    {"gev:xid", (lisp_proc *)CC_gevTxid, 2},
    {"gev:id", (lisp_proc *)CC_gevTid, 1},
    {"call:name", (lisp_proc *)CC_callTname, 1},
    {"flagcmnd*", (lisp_proc *)CC_flagcmndH, 2},
    {"mk:errsetprog", (lisp_proc *)CC_mkTerrsetprog, 1},
    {"mk.gsetq", (lisp_proc *)CC_mkQgsetq, 2},
    {"mk.gsimp", (lisp_proc *)CC_mkQgsimp, 1},
    {"mk.gargs", (lisp_proc *)CC_mkQgargs, 1},
    {"quote:id", (lisp_proc *)CC_quoteTid, 1},
    {"mk.gprog", (lisp_proc *)CC_mkQgprog, 1},
    {"galeval", (lisp_proc *)CC_galeval, 1},
    {NULL, NULL, 0 }
};

