#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_bspoly.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex bspoly_literal_vector[];
const char *bspoly_literal_string[];
setup_type const  bspoly_g_setup[];
#define LITERAL bspoly_literal_vector




Sex CC_negTcano(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
#define LL_CratfC LITERAL[0]
    if(car(a) >= value(LL_CratfC)) goto    G0002;
    w1 = a;
#define LL_Hmod LITERAL[1]
    a = value(LL_Hmod);
    if(a == nil) goto    G0004;
    a = w1;
    a = CC_Kpol3(a);
    {
        popv(5);
        return  CC_redmodTncan(a);
    }
   G0004:
    a = w1;
    {
        popv(5);
        return  CC_Kpol3(a);
    }
   G0002:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = value(LL_CratfC);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w4 = a;
   G0009:
    a = cdr(car(w4));
    if(!is_cons(a)) goto    G0011;
    a = CC_Kpol3(a);
    goto    G0012;
   G0011:
    a = CC_negTbnum(a);
   G0012:
    q = car(car(w4));
    a = Lxcons(a, q);
    w5 = a;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0009;
    a = w2;
    popv(5);
    return a;
}

Sex CC_recipTcano(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    if(a != value(LL_CratfC)) goto    G0021;
    a = w1;
    {
        popv(1);
        return  CC_recipTratf(a);
    }
   G0021:
#define LL_CpolyC LITERAL[2]
    if(a != value(LL_CpolyC)) goto    G0022;
    a = w1;
    {
        popv(1);
        return  CC_recipTpol32ratf(a);
    }
   G0022:
#define LL_CalgnC LITERAL[3]
    if(a != value(LL_CalgnC)) goto    G0023;
    a = w1;
    {
        popv(1);
        return  CC_recipTalgn(a);
    }
   G0023:
    a = w1;
    {
        popv(1);
        return  CC_recipTalgf(a);
    }
}

Sex CC_addTbnumcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
#define LL_Hpowser LITERAL[4]
    a = value(LL_Hpowser);
    if(a == nil) goto    G0029;
    a = q;
    a = CC_redpowTncan(a);
    w2 = a;
    if(!is_number(a)) goto    G0029;
    q = a;
    a = w1;
    {
        popv(3);
        return  CC_addTbnumbnum(a, q);
    }
   G0029:
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G0034;
    a = w2;
    goto    G0036;
   G0034:
    a = car(w2);
    if(a != value(LL_CratfC)) goto    G0035;
    q = w2;
    a = w1;
    a = CC_Lbnumratf(a, q);
    goto    G0036;
   G0035:
    q = cdr(w2);
    a = w1;
    a = CC_Lbnumbpol(a, q);
    q = car(w2);
    a = Lxcons(a, q);
   G0036:
    w3 = a;
    a = value(LL_Hmod);
    if(a == nil) goto    G0039;
    a = w3;
    a = CC_redmodTncan(a);
    goto    G0041;
   G0039:
#define LL_Hfcut LITERAL[5]
    a = value(LL_Hfcut);
    if(a == nil) goto    G0040;
    a = w3;
    a = CC_redfloTncan(a);
   G0041:
    w3 = a;
   G0040:
    a = w3;
    popv(3);
    return a;
}

Sex CC_multTbnumcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G0045;
    a = mkfxat(0);
    goto    G0046;
   G0045:
    w3 = nil;
    a = value(LL_Hpowser);
    if(a == nil) goto    G0049;
    a = w2;
    a = CC_redpowTncan(a);
    w2 = a;
    if(!is_number(a)) goto    G0049;
    q = a;
    a = w1;
    {
        popv(3);
        return  CC_multTbnumbnum(a, q);
    }
   G0049:
    a = car(w2);
    if(a != value(LL_CratfC)) goto    G0054;
    q = w2;
    a = w1;
    a = CC_Hbnumratf(a, q);
    goto    G0055;
   G0054:
    q = cdr(w2);
    a = w1;
    a = CC_Hbnumbpol(a, q);
    q = car(w2);
    a = Lxcons(a, q);
   G0055:
    w3 = a;
    a = value(LL_Hmod);
    if(a == nil) goto    G0058;
    a = w3;
    a = CC_redmodTncan(a);
    goto    G0060;
   G0058:
    a = value(LL_Hfcut);
    if(a == nil) goto    G0059;
    a = w3;
    a = CC_redfloTncan(a);
   G0060:
    w3 = a;
   G0059:
    a = w3;
   G0046:
    popv(3);
    return a;
}

Sex CC_quotiTbnumcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(q);
    if(a != value(LL_CpolyC)) goto    G0064;
    w2 = q;
    a = w1;
    a = CC_psVbnumpoly(a, q);
    w2 = a;
    if(a == nil) goto    G0066;
    a = value(LL_Hmod);
    if(a == nil) goto    G0082;
    a = w2;
    {
        popv(2);
        return  CC_redmodTncan(a);
    }
   G0066:
    q = LITERAL[6];
    a = mkfxat(7);
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0064:
    if(a != value(LL_CalgnC)) goto    G0071;
    w2 = q;
    a = q;
    a = CC_recipTalgn(a);
    w2 = a;
    a = w1;
    a = Lonep(a);
    if(a != nil) goto    G0082;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_Hbnumpol3(a, q);
    }
   G0071:
#define LL_CalgfC LITERAL[7]
    if(a != value(LL_CalgfC)) goto    G0075;
    w2 = q;
    a = q;
    a = CC_recipTalgf(a);
    w2 = a;
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0077;
   G0082:
    a = w2;
    goto    G0079;
   G0077:
    q = w2;
    goto    G0083;
   G0075:
    a = q;
    a = CC_recipTratf(a);
    q = a;
   G0083:
    a = w1;
    a = CC_multTbnumcano(a, q);
   G0079:
    popv(2);
    return a;
}

Sex CC_quotiTcanobnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G0087;
    q = nil;
    a = mkfxat(7);
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
   G0087:
    w3 = nil;
    a = value(LL_Hpowser);
    if(a == nil) goto    G0091;
    a = w1;
    a = CC_redpowTncan(a);
    w1 = a;
    if(!is_number(a)) goto    G0091;
    q = w2;
    {
        popv(3);
        return  CC_flgdivTbnumbnum(a, q);
    }
   G0091:
    a = car(w1);
    q = w2;
    if(a != value(LL_CratfC)) goto    G0096;
    a = w1;
    a = CC_Vratfbnum(a, q);
    goto    G0097;
   G0096:
    a = cdr(w1);
    a = CC_Vbpolbnum(a, q);
    q = car(w1);
    a = Lxcons(a, q);
   G0097:
    w3 = a;
    a = value(LL_Hmod);
    if(a == nil) goto    G0100;
    a = w3;
    a = CC_redmodTncan(a);
    goto    G0102;
   G0100:
    a = value(LL_Hfcut);
    if(a == nil) goto    G0101;
    a = w3;
    a = CC_redfloTncan(a);
   G0102:
    w3 = a;
   G0101:
    a = w3;
    popv(3);
    return a;
}

Sex CC_addTcanocano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = value(LL_Hpowser);
    if(a == nil) goto    G0107;
    a = w1;
    a = CC_redpowTncan(a);
    w1 = a;
    a = w2;
    a = CC_redpowTncan(a);
    w2 = a;
    a = w1;
    if(!is_number(a)) goto    G0109;
    a = w2;
    if(!is_number(a)) goto    G0111;
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_addTbnumbnum(a, q);
    }
   G0111:
    q = a;
    if(car(a) >= value(LL_CratfC)) goto    G0112;
    a = w1;
    goto    G0139;
   G0112:
    a = w1;
    goto    G0140;
   G0109:
    a = w2;
    if(!is_number(a)) goto    G0107;
    if(car(w1) >= value(LL_CratfC)) goto    G0117;
    q = w1;
   G0139:
    {
        popv(6);
        return  CC_Lbnumpol3(a, q);
    }
   G0117:
    q = w1;
   G0140:
    {
        popv(6);
        return  CC_Lbnumratf(a, q);
    }
   G0107:
    a = car(w1);
    w3 = a;
    w6 = a;
    a = car(w2);
    w4 = a;
    if(a != w6) goto    G0121;
    if(a != value(LL_CratfC)) goto    G0125;
    q = w2;
    a = w1;
    a = CC_Lratfratf(a, q);
    goto    G0132;
   G0125:
    q = cdr(w2);
    a = cdr(w1);
    a = CC_Lbpolbpol(a, q);
    goto    G0132;
   G0121:
    if(w3 >= a) goto    G0127;
    if(a != value(LL_CratfC)) goto    G0129;
    q = w2;
    a = w1;
    goto    G0141;
   G0129:
    q = cdr(w2);
    a = w1;
    goto    G0142;
   G0127:
    a = w3;
    w4 = a;
    if(a != value(LL_CratfC)) goto    G0131;
    q = w1;
    a = w2;
   G0141:
    a = CC_Lpol3ratf(a, q);
    goto    G0132;
   G0131:
    q = cdr(w1);
    a = w2;
   G0142:
    a = CC_Lpol3bpol(a, q);
   G0132:
    w5 = a;
    if(!is_cons(a)) goto    G0134;
    a = car(a);
    if(is_integer(a)) goto    G0134;
    q = w5;
    a = w4;
    a = cons(a, q);
    w5 = a;
   G0134:
    a = value(LL_Hmod);
    if(a == nil) goto    G0137;
    a = w5;
    a = CC_redmodTncan(a);
    goto    G0143;
   G0137:
    a = value(LL_Hfcut);
    if(a == nil) goto    G0138;
    a = w5;
    a = CC_redfloTncan(a);
   G0143:
    w5 = a;
   G0138:
    a = w5;
    popv(6);
    return a;
}

Sex CC_multTcanocano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = value(LL_Hpowser);
    if(a == nil) goto    G0148;
    a = w1;
    a = CC_redpowTncan(a);
    w1 = a;
    a = w2;
    a = CC_redpowTncan(a);
    w2 = a;
    a = w1;
    if(!is_number(a)) goto    G0150;
    a = w2;
    if(!is_number(a)) goto    G0152;
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_multTbnumbnum(a, q);
    }
   G0152:
    if(car(a) >= value(LL_CratfC)) goto    G0153;
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_Hbnumpol3(a, q);
    }
   G0153:
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_Hbnumratf(a, q);
    }
   G0150:
    a = w2;
    if(!is_number(a)) goto    G0148;
    q = w1;
    if(car(w1) >= value(LL_CratfC)) goto    G0158;
    CC_Hbnumpol3(a, q);
    goto    G0148;
   G0158:
    CC_Hbnumratf(a, q);
   G0148:
    a = car(w1);
    w3 = a;
    w6 = a;
    a = car(w2);
    w4 = a;
    if(a != w6) goto    G0161;
    if(a != value(LL_CratfC)) goto    G0165;
    q = w2;
    a = w1;
    a = CC_Hratfratf(a, q);
    goto    G0175;
   G0165:
    a = value(LL_Hpowser);
    q = cdr(w2);
    if(a == nil) goto    G0166;
    a = cdr(w1);
    a = CC_psHbpolbpol(a, q);
    goto    G0175;
   G0166:
    a = cdr(w1);
    a = CC_Hbpolbpol(a, q);
    goto    G0175;
   G0161:
    if(w3 >= a) goto    G0168;
    if(a != value(LL_CratfC)) goto    G0170;
    q = w2;
    a = w1;
    goto    G0193;
   G0170:
    a = value(LL_Hpowser);
    q = cdr(w2);
    if(a == nil) goto    G0171;
    a = w1;
    goto    G0194;
   G0171:
    a = w1;
    goto    G0195;
   G0168:
    a = w3;
    w4 = a;
    if(a != value(LL_CratfC)) goto    G0173;
    q = w1;
    a = w2;
   G0193:
    a = CC_Hpol3ratf(a, q);
    goto    G0175;
   G0173:
    a = value(LL_Hpowser);
    q = cdr(w1);
    if(a == nil) goto    G0174;
    a = w2;
   G0194:
    a = CC_psHpol3bpol(a, q);
    goto    G0175;
   G0174:
    a = w2;
   G0195:
    a = CC_Hpol3bpol(a, q);
   G0175:
    w5 = a;
    if(!is_cons(a)) goto    G0177;
    a = car(a);
    if(is_integer(a)) goto    G0177;
    q = w5;
    a = w4;
    a = cons(a, q);
    w5 = a;
   G0177:
    a = value(LL_Hmod);
    if(a == nil) goto    G0180;
    a = w5;
    a = CC_redmodTncan(a);
    goto    G0196;
   G0180:
    a = value(LL_Hfcut);
    if(a == nil) goto    G0181;
    a = w5;
    a = CC_redfloTncan(a);
   G0196:
    w5 = a;
   G0181:
    a = w5;
    if(is_number(a)) goto    G0190;
    a = car(a);
    if(a == value(LL_CpolyC)) goto    G0190;
    if(a == value(LL_CratfC)) goto    G0190;
    w3 = a;
    if(a != value(LL_CalgnC)) goto    G0186;
    a = cdr(w5);
    a = CC_reduceTbalgn(a);
    goto    G0187;
   G0186:
    a = cdr(w5);
    a = CC_reduceTbalgf(a);
   G0187:
    w5 = a;
    if(is_number(a)) goto    G0190;
    a = car(a);
    if(!is_integer(a)) goto    G0189;
   G0190:
    a = w5;
    goto    G0146;
   G0189:
    q = w5;
    a = w3;
    a = cons(a, q);
   G0146:
    popv(6);
    return a;
}

Sex CC_quotiTcanocano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = value(LL_Hpowser);
    if(a == nil) goto    G0202;
    a = w1;
    a = CC_redpowTncan(a);
    w1 = a;
    a = w2;
    a = CC_redpowTncan(a);
    w2 = a;
    a = w1;
    if(!is_number(a)) goto    G0204;
    a = w2;
    if(is_number(a)) goto    G0222;
    if(car(a) >= value(LL_CratfC)) goto    G0207;
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_psVbnumany(a, q);
    }
   G0207:
    a = CC_recipTratf(a);
    w2 = a;
    if(!is_number(a)) goto    G0208;
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_multTbnumbnum(a, q);
    }
   G0208:
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_multTbnumcano(a, q);
    }
   G0204:
    a = w2;
    if(!is_number(a)) goto    G0216;
    if(car(w1) >= value(LL_CratfC)) goto    G0213;
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_Vpol3bnum(a, q);
    }
   G0213:
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_Vratfbnum(a, q);
    }
   G0202:
    a = value(LL_Hmod);
    if(a == nil) goto    G0216;
    a = car(q);
    if(a != value(LL_CpolyC)) goto    G0216;
    a = q;
    a = CC_Alncoef(a);
    w5 = a;
    a = Lonep(a);
    if(a != nil) goto    G0216;
    a = w5;
    a = CC_recipTbnum(a);
    w5 = a;
    q = w1;
    a = CC_multTbnumcano(a, q);
    w1 = a;
    q = w2;
    a = w5;
    a = CC_multTbnumcano(a, q);
    w2 = a;
    a = w1;
    if(!is_number(a)) goto    G0220;
    a = w2;
    if(!is_number(a)) goto    G0289;
   G0222:
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_flgdivTbnumbnum(a, q);
    }
   G0220:
    a = w2;
    if(!is_number(a)) goto    G0216;
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_quotiTcanobnum(a, q);
    }
   G0289:
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
   G0216:
    a = car(w1);
    w3 = a;
    w6 = a;
    a = car(w2);
    w4 = a;
    if(a != w6) goto    G0228;
    a = w3;
    if(a != value(LL_CpolyC)) goto    G0232;
#define LL_Hexctdiv LITERAL[8]
    a = value(LL_Hexctdiv);
    if(a == nil) goto    G0234;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_chkTdivble(a, q);
    if(a != nil) goto    G0234;
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
    goto    G0259;
   G0234:
    a = value(LL_Hpowser);
    q = cdr(w2);
    if(a == nil) goto    G0236;
    a = cdr(w1);
    a = CC_psVbpolbpol(a, q);
    goto    G0250;
   G0236:
    a = cdr(w1);
    a = CC_Vbpolbpol(a, q);
    goto    G0250;
   G0232:
    a = w4;
    if(a != value(LL_CratfC)) goto    G0240;
    a = w2;
    a = CC_recipTratf(a);
    goto    G0242;
   G0240:
    if(a != value(LL_CalgnC)) goto    G0241;
    a = w2;
    a = CC_recipTalgn(a);
    goto    G0242;
   G0241:
    a = w2;
    a = CC_recipTalgf(a);
   G0242:
    w5 = a;
    q = w2;
    goto    G0286;
   G0228:
    if(a >= w3) goto    G0244;
    if(a != value(LL_CpolyC)) goto    G0246;
    a = w3;
    if(a != value(LL_CratfC)) goto    G0248;
    q = w2;
    a = w1;
    a = CC_Vratfpol3(a, q);
    goto    G0250;
   G0248:
    a = value(LL_Hpowser);
    if(a == nil) goto    G0249;
    q = w2;
    a = w1;
    a = CC_psVpol3pol3(a, q);
    goto    G0250;
   G0246:
    if(a != value(LL_CalgnC)) goto    G0253;
    a = w2;
    a = CC_recipTalgn(a);
    goto    G0254;
   G0253:
    a = w2;
    a = CC_recipTalgf(a);
   G0254:
    w5 = a;
    q = a;
    a = w1;
    {
        popv(6);
        return  CC_multHcanocano(a, q);
    }
   G0244:
    if(a != value(LL_CpolyC)) goto    G0256;
    q = w2;
    a = mkfxat(1);
    a = CC_psVbnumpoly(a, q);
    q = a;
    goto    G0286;
   G0256:
    if(a != value(LL_CalgfC)) goto    G0261;
    a = w2;
    a = CC_recipTalgf(a);
    goto    G0262;
   G0261:
    a = w2;
    a = CC_recipTratf(a);
   G0262:
    w2 = a;
    q = a;
   G0286:
    a = w1;
    {
        popv(6);
        return  CC_multTcanocano(a, q);
    }
   G0249:
    q = w2;
    a = w1;
    a = CC_Vpol3pol3(a, q);
   G0250:
    w5 = a;
   G0259:
    a = w5;
    if(a != nil) goto    G0265;
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
    goto    G0266;
   G0265:
    if(!is_cons(a)) goto    G0266;
    a = car(a);
    if(is_integer(a)) goto    G0266;
    q = w5;
    a = w3;
    a = cons(a, q);
    w5 = a;
   G0266:
    a = value(LL_Hmod);
    if(a == nil) goto    G0269;
    a = w5;
    a = CC_redmodTncan(a);
    goto    G0287;
   G0269:
    a = value(LL_Hfcut);
    if(a == nil) goto    G0270;
    a = w5;
    a = CC_redfloTncan(a);
   G0287:
    w5 = a;
   G0270:
    a = w5;
    if(is_number(a)) goto    G0279;
    a = car(a);
    if(a == value(LL_CpolyC)) goto    G0279;
    if(a == value(LL_CratfC)) goto    G0279;
    w3 = a;
    if(a != value(LL_CalgnC)) goto    G0275;
    a = cdr(w5);
    a = CC_reduceTbalgn(a);
    goto    G0276;
   G0275:
    a = cdr(w5);
    a = CC_reduceTbalgf(a);
   G0276:
    w5 = a;
    if(is_number(a)) goto    G0279;
    a = car(a);
    if(!is_integer(a)) goto    G0278;
   G0279:
    a = w5;
    goto    G0200;
   G0278:
    q = w5;
    a = w3;
    a = cons(a, q);
   G0200:
    popv(6);
    return a;
}

Sex CC_reduceTbpol(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0296;
    a = cdr(a);
    if(a != nil) goto    G0294;
    a = mkfxat(0);
    goto    G0296;
   G0294:
    a = car(car(a));
    a = Lzerop(a);
    if(a == nil) goto    G0295;
    a = cdr(car(cdr(w1)));
    goto    G0296;
   G0295:
    a = w1;
   G0296:
    popv(1);
    return a;
}

Sex CC_reduceTbalgn(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w2 = nil;
   G0334:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
#define LL_defpoly LITERAL[9]
    q = LL_defpoly;
    a = car(a);
    a = CC_getTcompfn(a, q);
    w2 = a;
    if(a == nil) goto    G0332;
    q = car(car(cdr(w1)));
    a = car(car(cdr(a)));
    a = Lleq(a, q);
    if(a == nil) goto    G0306;
    q = w2;
    a = w1;
    a = CC_VLbpolbpol(a, q);
    a = cdr(a);
    w1 = a;
    if(is_number(a)) goto    G0299;
    q = car(w2);
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G0306;
    a = w1;
    goto    G0334;  /* recursive call to reduce:balgn */
   G0306:
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w6 = a;
    w5 = a;
   G0300:
    a = cdr(car(w6));
    w7 = a;
    if(is_number(a)) goto    G0302;
    a = CC_reduceTbalgn(a);
    w8 = a;
    if(a == w7) goto    G0302;
    a = true;
    w9 = a;
   G0301:
    q = w6;
    a = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G0317;
    a = car(w5);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    goto    G0301;
   G0317:
    a = w8;
    a = Lzerop(a);
    if(a != nil) goto    G0321;
    q = w8;
    a = car(car(w6));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0321:
    a = cdr(w6);
    w6 = a;
    w5 = a;
    goto    G0333;
   G0302:
    a = cdr(w6);
    w6 = a;
   G0333:
    if(a != nil) goto    G0300;
   G0328:
    a = w9;
    if(a != nil) goto    G0330;
   G0332:
    a = w1;
    goto    G0299;
   G0330:
    q = w5;
    a = w4;
    cdr(a) = q;
    a = w3;
    a = CC_reduceTbpol(a);
   G0299:
    popv(9);
    return a;
}

Sex CC_reduceTbalgf(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w2 = nil;
   G0374:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    q = LL_defpoly;
    a = car(a);
    a = CC_getTcompfn(a, q);
    w2 = a;
    if(a == nil) goto    G0372;
    q = car(car(cdr(w1)));
    a = car(car(cdr(a)));
    a = Lleq(a, q);
    if(a == nil) goto    G0343;
    q = w2;
    a = w1;
    a = CC_VLbpolbpol(a, q);
    a = cdr(a);
    w1 = a;
    if(is_number(a)) goto    G0372;
    a = car(a);
    if(is_integer(a)) goto    G0372;
    q = car(w2);
    a = Lneq(a, q);
    if(a == nil) goto    G0343;
    a = w1;
    goto    G0374;  /* recursive call to reduce:balgf */
   G0343:
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w6 = a;
    w5 = a;
   G0337:
    a = cdr(car(w6));
    w7 = a;
    if(is_number(a)) goto    G0339;
    if(car(a) < value(LL_CalgfC)) goto    G0339;
    a = CC_reduceTbalgf(a);
    w8 = a;
    if(a == w7) goto    G0339;
    a = true;
    w9 = a;
   G0338:
    q = w6;
    a = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G0356;
    a = car(w5);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    goto    G0338;
   G0356:
    a = w8;
    a = Lzerop(a);
    if(a != nil) goto    G0360;
    q = w8;
    a = car(car(w6));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0360:
    a = cdr(w6);
    w6 = a;
    w5 = a;
    goto    G0373;
   G0339:
    a = cdr(w6);
    w6 = a;
   G0373:
    if(a != nil) goto    G0337;
   G0367:
    a = w9;
    if(a != nil) goto    G0369;
   G0372:
    a = w1;
    goto    G0336;
   G0369:
    q = w5;
    a = w4;
    cdr(a) = q;
    a = w3;
    a = CC_reduceTbpol(a);
   G0336:
    popv(9);
    return a;
}

Sex CC_redmodTncan(Sex a)
{
    Sex q, m;
    if(!is_number(a)) goto    G0377;
    {
        return  CC_redmodTbnum(a);
    }
   G0377:
    if(car(a) >= value(LL_CratfC)) goto    G0378;
    {
        return  CC_redmodTpol3(a);
    }
   G0378:
    m = a;
#define LL_redmodTpol3 LITERAL[10]
    q = LL_redmodTpol3;
#define LL_redmodTbnum LITERAL[11]
    a = LL_redmodTbnum;
    {
        return  CC_qmap2Tratf(a, q, m);
    }
}

Sex CC_redfloTncan(Sex a)
{
    Sex q, m;
    if(!is_number(a)) goto    G0383;
    {
        return  CC_redfloTbnum(a);
    }
   G0383:
    if(car(a) >= value(LL_CratfC)) goto    G0384;
    {
        return  CC_redfloTpol3(a);
    }
   G0384:
    m = a;
#define LL_redfloTpol3 LITERAL[12]
    q = LL_redfloTpol3;
#define LL_redfloTbnum LITERAL[13]
    a = LL_redfloTbnum;
    {
        return  CC_qmap2Tratf(a, q, m);
    }
}

Sex CC_redpowTncan(Sex a)
{
    Sex q, m;
    if(is_number(a)) goto    G0391;
    if(car(a) >= value(LL_CratfC)) goto    G0390;
    {
        return  CC_redpowTpol3(a);
    }
   G0390:
    m = a;
#define LL_redpowTpol3 LITERAL[14]
    q = LL_redpowTpol3;
    a = nil;
    a = CC_map2Tratf(a, q, m);
   G0391:
    return a;
}

Sex CC_redmodTbnum(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_integer(a)) goto    G0402;
    if(!is_rational(a)) goto    G0396;
    a = Lnum(a);
    w2 = a;
    a = w1;
    a = Lden(a);
    a = CC_modrecip(a);
    q = a;
    a = w2;
    a = times2(a, q);
   G0402:
    q = value(LL_Hmod);
    {
        popv(2);
        return  remaind2(a, q);
    }
   G0396:
    q = a;
    a = LITERAL[15];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
}

Sex CC_redfloTbnum(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = Labs(a);
    q = value(LL_Hfcut);
    a = Llessp(a, q);
    if(a == nil) goto    G0406;
    a = mkfxat(0);
    goto    G0408;
   G0406:
    a = w1;
   G0408:
    popv(1);
    return a;
}

Sex CC_redmodTpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    a = CC_redmodTbpol(a);
#define LL_Htemporal LITERAL[16]
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G0413;
    a = car(a);
    if(!is_integer(a)) goto    G0412;
   G0413:
    a = value(LL_Htemporal);
    goto    G0414;
   G0412:
    q = value(LL_Htemporal);
    a = car(w1);
    a = cons(a, q);
   G0414:
    popv(1);
    return a;
}

Sex CC_redfloTpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = value(LL_Hfcut);
    a = cdr(a);
    a = CC_redfloTbpol(a, q);
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G0419;
    a = car(a);
    if(!is_integer(a)) goto    G0418;
   G0419:
    a = value(LL_Htemporal);
    goto    G0420;
   G0418:
    q = value(LL_Htemporal);
    a = car(w1);
    a = cons(a, q);
   G0420:
    popv(1);
    return a;
}

Sex CC_redpowTpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = value(LL_Hpowser);
    a = cdr(a);
    a = CC_redpowTbpol(a, q);
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G0425;
    a = car(a);
    if(!is_integer(a)) goto    G0424;
   G0425:
    a = value(LL_Htemporal);
    goto    G0426;
   G0424:
    q = value(LL_Htemporal);
    a = car(w1);
    a = cons(a, q);
   G0426:
    popv(1);
    return a;
}

Sex CC_redmodTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w6 = nil;
    w1 = a;
    a = car(a);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w4 = a;
   G0430:
    a = cdr(car(w4));
    w5 = a;
    if(!is_number(a)) goto    G0432;
    if(is_integer(a)) goto    G0454;
    if(!is_rational(a)) goto    G0442;
    a = Lnum(a);
    w7 = a;
    a = w5;
    a = Lden(a);
    a = CC_modrecip(a);
    q = a;
    a = w7;
    a = times2(a, q);
   G0454:
    q = value(LL_Hmod);
    a = remaind2(a, q);
    goto    G0456;
   G0432:
    a = car(a);
    if(is_integer(a)) goto    G0441;
    a = w5;
    a = CC_redmodTbpol(a);
    goto    G0456;
   G0441:
    w6 = a;
    a = cdr(w5);
    a = CC_redmodTbpol(a);
    w5 = a;
    if(!is_cons(a)) goto    G0442;
    a = car(a);
    if(is_integer(a)) goto    G0442;
    q = w5;
    a = w6;
    a = cons(a, q);
   G0456:
    w5 = a;
   G0442:
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G0447;
    q = w5;
    a = car(car(w4));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
   G0447:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0430;
    a = w2;
    {
        popv(7);
        return  CC_reduceTbpol(a);
    }
}

Sex CC_redfloTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w6 = a;
    w5 = a;
   G0460:
    a = cdr(car(w6));
    w7 = a;
    if(!is_number(a)) goto    G0464;
    a = Labs(a);
    q = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0474;
    a = mkfxat(0);
    goto    G0492;
   G0464:
    a = car(a);
    q = w2;
    if(is_integer(a)) goto    G0469;
    a = w7;
    a = CC_redfloTbpol(a, q);
    w8 = a;
    if(a != w7) goto    G0481;
    goto    G0474;
   G0469:
    a = cdr(w7);
    a = CC_redfloTbpol(a, q);
    w8 = a;
    if(a != cdr(w7)) goto    G0473;
   G0474:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0460;
    a = w5;
    if(a == cdr(w1)) goto    G0493;
    q = a;
    a = w4;
    cdr(a) = q;
    a = w3;
    {
        popv(8);
        return  CC_reduceTbpol(a);
    }
   G0473:
    if(!is_cons(a)) goto    G0481;
    a = car(a);
    if(is_integer(a)) goto    G0481;
    q = w8;
    a = car(w7);
    a = cons(a, q);
   G0492:
    w8 = a;
   G0481:
    q = w6;
    a = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G0484;
    a = car(w5);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    goto    G0481;
   G0484:
    a = w8;
    a = Lzerop(a);
    if(a != nil) goto    G0488;
    q = w8;
    a = car(car(w6));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0488:
    a = cdr(w5);
    w5 = a;
    goto    G0474;
   G0493:
    a = w1;
    popv(8);
    return a;
}

Sex CC_redpowTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
   G0541:
    w1 = a;
    a = q;
    if(a == nil) goto    G0540;
    w2 = q;
    q = car(car(a));
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G0498;
    q = cdr(w2);
    a = w1;
    goto    G0541;  /* recursive call to redpow:bpol */
   G0498:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = car(w1);
    w3 = a;
    a = cdr(w1);
    w6 = a;
    q = car(car(w2));
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G0510;
    a = cdr(car(w2));
    w8 = a;
    a = cdr(w2);
    w2 = a;
   G0508:
    q = w8;
    a = car(car(w6));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0510;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0508;
    a = mkfxat(0);
    goto    G0499;
   G0510:
    a = w3;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = w6;
    w5 = a;
   G0503:
    a = cdr(car(w6));
    w7 = a;
    if(is_number(a)) goto    G0521;
    a = car(a);
    q = w2;
    if(is_integer(a)) goto    G0516;
    a = w7;
    a = CC_redpowTbpol(a, q);
    w8 = a;
    if(a != w7) goto    G0529;
    goto    G0521;
   G0516:
    a = cdr(w7);
    a = CC_redpowTbpol(a, q);
    w8 = a;
    if(a != cdr(w7)) goto    G0520;
   G0521:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0503;
    a = w5;
    if(a == cdr(w1)) goto    G0540;
    q = a;
    a = w4;
    cdr(a) = q;
    a = w3;
    {
        popv(8);
        return  CC_reduceTbpol(a);
    }
   G0520:
    if(is_number(a)) goto    G0529;
    a = car(a);
    if(is_integer(a)) goto    G0529;
    q = w8;
    a = car(w7);
    a = cons(a, q);
    w8 = a;
   G0529:
    q = w6;
    a = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G0532;
    a = car(w5);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    goto    G0529;
   G0532:
    a = w8;
    a = Lzerop(a);
    if(a != nil) goto    G0536;
    q = w8;
    a = car(car(w6));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0536:
    a = cdr(w5);
    w5 = a;
    goto    G0521;
   G0540:
    a = w1;
   G0499:
    popv(8);
    return a;
}

Sex CC_revordTpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(car(a) < value(LL_CpolyC)) goto    G0547;
    if(car(a) >= value(LL_CalgfC)) goto    G0545;
    w1 = a;
    a = cdr(a);
    a = CC_revordTbpol(a);
    q = value(LL_CpolyC);
    {
        popv(4);
        return  Lxcons(a, q);
    }
   G0545:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w1 = a;
    a = cdr(a);
    w1 = a;
    a = value(LL_CalgfC);
    a = Lncons(a);
    w3 = a;
    w2 = a;
   G0549:
    a = cdr(car(w1));
    w4 = a;
    if(!is_number(a)) goto    G0551;
    a = car(w1);
    goto    G0561;
   G0551:
    a = CC_revordTpol3(a);
    q = car(car(w1));
    a = Lxcons(a, q);
   G0561:
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0549;
    a = w2;
   G0547:
    popv(4);
    return a;
}

Sex CC_revordTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = car(a);
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G0565:
    a = cdr(car(w1));
    w3 = a;
    if(is_number(a)) goto    G0568;
    a = car(a);
    if(!is_integer(a)) goto    G0567;
   G0568:
    q = w4;
    a = car(w1);
    goto    G0575;
   G0567:
    a = w3;
    a = CC_revordTbpol(a);
    q = car(car(w1));
    a = Lxcons(a, q);
    q = w4;
   G0575:
    a = cons(a, q);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0565;
    q = w4;
    a = w2;
    {
        popv(4);
        return  cons(a, q);
    }
}

Sex CC_Kany(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0579;
    {
        popv(1);
        return  Lminus(a);
    }
   G0579:
    a = car(a);
    if(!is_integer(a)) goto    G0580;
    a = cdr(w1);
    a = CC_Kbpol(a);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G0580:
    a = w1;
    {
        popv(1);
        return  CC_Kbpol(a);
    }
}

Sex CC_Kpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    a = CC_Kbpol(a);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
}

Sex CC_Lbnumpol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = cdr(q);
    a = CC_Lbnumbpol(a, q);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
}

Sex CC_Lbnumbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_topcopyB(a);
    w3 = a;
    a = value(LL_Htemporal);
    w4 = a;
    a = cdr(a);
    w5 = a;
    a = car(a);
    a = car(a);
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0593;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    goto    G0603;
   G0593:
    q = cdr(car(w5));
    a = w1;
    a = CC_Lbnumany(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0599;
    q = nil;
    a = w4;
   G0603:
    cdr(a) = q;
    goto    G0601;
   G0599:
    q = w6;
    a = mkfxat(0);
    a = cons(a, q);
    q = a;
    a = w5;
    car(a) = q;
   G0601:
    a = w3;
    popv(6);
    return a;
}

Sex CC_Lpol3pol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != car(q)) goto    G0607;
    w2 = q;
    q = cdr(q);
    a = cdr(w1);
    a = CC_Lbpolbpol(a, q);
    w2 = a;
    if(is_number(a)) goto    G0614;
    a = car(a);
    if(!is_integer(a)) goto    G0610;
    a = w2;
    goto    G0614;
   G0610:
    q = w2;
    a = car(w1);
    {
        popv(2);
        return  cons(a, q);
    }
   G0607:
    w2 = q;
    if(a >= car(q)) goto    G0612;
    q = cdr(q);
    a = w1;
    a = CC_Lpol3bpol(a, q);
    q = car(w2);
    goto    G0616;
   G0612:
    q = cdr(w1);
    a = w2;
    a = CC_Lpol3bpol(a, q);
    q = car(w1);
   G0616:
    a = Lxcons(a, q);
   G0614:
    popv(2);
    return a;
}

Sex CC_Lpol3bpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_topcopyB(a);
    w3 = a;
    a = value(LL_Htemporal);
    w4 = a;
    a = cdr(a);
    w5 = a;
    a = car(a);
    a = car(a);
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0621;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    goto    G0631;
   G0621:
    q = cdr(car(w5));
    a = w1;
    a = CC_Lpol3any(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0627;
    q = nil;
    a = w4;
   G0631:
    cdr(a) = q;
    goto    G0629;
   G0627:
    q = w6;
    a = mkfxat(0);
    a = cons(a, q);
    q = a;
    a = w5;
    car(a) = q;
   G0629:
    a = w3;
    popv(6);
    return a;
}

Sex CC_Lbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G0635;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_LbpolbpolTvarvar(a, q);
    }
   G0635:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0636;
    q = w1;
    a = w2;
    goto    G0638;
   G0636:
    q = w2;
    a = w1;
   G0638:
    {
        popv(2);
        return  CC_LbpolbpolTcofvar(a, q);
    }
}

Sex CC_Kbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G0642:
    a = cdr(car(w1));
    w4 = a;
    if(!is_number(a)) goto    G0644;
    a = Lminus(a);
    goto    G0646;
   G0644:
    a = car(a);
    if(!is_integer(a)) goto    G0645;
    a = w4;
    a = CC_Kpol3(a);
    goto    G0646;
   G0645:
    a = w4;
    a = CC_Kbpol(a);
   G0646:
    w4 = a;
    q = car(car(w1));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0642;
    a = w2;
    popv(4);
    return a;
}

Sex CC_seKbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    a = cdr(a);
    w1 = a;
   G0655:
    a = car(w1);
    w2 = a;
    a = cdr(a);
    if(!is_number(a)) goto    G0657;
    a = cdr(w2);
    a = Lminus(a);
    goto    G0665;
   G0657:
    a = car(cdr(w2));
    if(!is_integer(a)) goto    G0660;
    a = cdr(w2);
    a = CC_Kpol3(a);
   G0665:
    q = a;
    a = w2;
    cdr(a) = q;
    goto    G0662;
   G0660:
    a = cdr(w2);
    CC_seKbpol(a);
   G0662:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0655;
    popv(2);
    return a;
}

Sex CC_Lanyany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0669;
    {
        popv(1);
        return  CC_Lbnumany(a, q);
    }
   G0669:
    a = car(a);
    if(!is_integer(a)) goto    G0670;
    a = w1;
    {
        popv(1);
        return  CC_Lpol3any(a, q);
    }
   G0670:
    a = w1;
    {
        popv(1);
        return  CC_Lbpolany(a, q);
    }
}

Sex CC_Lany0any0(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0675;
    a = Lzerop(a);
    if(a == nil) goto    G0677;
    a = w2;
    goto    G0682;
   G0677:
    a = w2;
    a = Lzerop(a);
    if(a != nil) goto    G0683;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_Lbnumany(a, q);
    }
   G0675:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G0680;
   G0683:
    a = w1;
    goto    G0682;
   G0680:
    a = car(w1);
    if(!is_integer(a)) goto    G0681;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_Lpol3any(a, q);
    }
   G0681:
    q = w2;
    a = w1;
    a = CC_Lbpolany(a, q);
   G0682:
    popv(2);
    return a;
}

Sex CC_Lbnumany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0687;
    {
        popv(2);
        return  plus2(a, q);
    }
   G0687:
    a = car(q);
    if(is_integer(a)) goto    G0688;
    a = w1;
    {
        popv(2);
        return  CC_Lbnumbpol(a, q);
    }
   G0688:
    q = cdr(q);
    a = w1;
    a = CC_Lbnumbpol(a, q);
    q = car(w2);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_Lpol3any(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0694;
    q = cdr(a);
    a = w2;
    a = CC_Lbnumbpol(a, q);
    q = car(w1);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G0694:
    a = car(q);
    if(!is_integer(a)) goto    G0696;
    a = w1;
    {
        popv(2);
        return  CC_Lpol3pol3(a, q);
    }
   G0696:
    a = w1;
    {
        popv(2);
        return  CC_Lpol3bpol(a, q);
    }
}

Sex CC_Lbpolany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0701;
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_Lbnumbpol(a, q);
    }
   G0701:
    a = car(q);
    if(!is_integer(a)) goto    G0702;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_Lpol3bpol(a, q);
    }
   G0702:
    a = w1;
    {
        popv(2);
        return  CC_Lbpolbpol(a, q);
    }
}

Sex CC_LbpolbpolTcofvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_topcopyB(a);
    w3 = a;
    a = value(LL_Htemporal);
    w4 = a;
    a = cdr(a);
    w5 = a;
    a = car(a);
    a = car(a);
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0708;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    goto    G0718;
   G0708:
    q = cdr(car(w5));
    a = w1;
    a = CC_Lbpolany(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0714;
    q = nil;
    a = w4;
   G0718:
    cdr(a) = q;
    goto    G0716;
   G0714:
    q = w6;
    a = mkfxat(0);
    a = cons(a, q);
    q = a;
    a = w5;
    car(a) = q;
   G0716:
    a = w3;
    popv(6);
    return a;
}

Sex CC_LbpolbpolTvarvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = car(a);
    a = car(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    a = car(a);
    w6 = a;
   G0722:
    q = w6;
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0728;
    a = car(w1);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0732;
    a = car(car(a));
    w5 = a;
    goto    G0722;
   G0732:
    q = w2;
    a = w4;
    cdr(a) = q;
    goto    G0739;
   G0728:
    q = w5;
    a = w6;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0734;
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0738;
    a = car(car(a));
    goto    G0751;
   G0738:
    q = w1;
    a = w4;
    cdr(a) = q;
   G0739:
    a = w3;
    goto    G0721;
   G0734:
    q = cdr(car(w2));
    a = cdr(car(w1));
    a = CC_Lanyany(a, q);
    w7 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0740;
    q = w7;
    a = w5;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0740:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0746;
    q = cdr(w2);
    goto    G0752;
   G0746:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0753;
    a = car(car(w1));
    w5 = a;
    a = car(car(w2));
   G0751:
    w6 = a;
    goto    G0722;
   G0753:
    q = w1;
   G0752:
    a = w4;
    cdr(a) = q;
    a = w3;
    a = CC_reduceTbpol(a);
   G0721:
    popv(7);
    return a;
}

Sex CC_seLbnumany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0757;
    {
        popv(2);
        return  plus2(a, q);
    }
   G0757:
    a = car(q);
    if(is_integer(a)) goto    G0758;
    a = w1;
    {
        popv(2);
        return  CC_seLbnumbpol(a, q);
    }
   G0758:
    q = cdr(q);
    a = w1;
    a = CC_seLbnumbpol(a, q);
    q = car(w2);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_seLpol3any(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0764;
    q = cdr(a);
    a = w2;
    a = CC_Lbnumbpol(a, q);
    q = car(w1);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G0764:
    a = car(q);
    if(!is_integer(a)) goto    G0766;
    a = w1;
    {
        popv(2);
        return  CC_Lpol3pol3(a, q);
    }
   G0766:
    a = w1;
    {
        popv(2);
        return  CC_seLpol3bpol(a, q);
    }
}

Sex CC_seLbpolany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0771;
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_Lbnumbpol(a, q);
    }
   G0771:
    a = car(q);
    if(!is_integer(a)) goto    G0772;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_Lpol3bpol(a, q);
    }
   G0772:
    a = w1;
    {
        popv(2);
        return  CC_seLbpolbpol(a, q);
    }
}

Sex CC_seLanyany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0777;
    {
        popv(1);
        return  CC_seLbnumany(a, q);
    }
   G0777:
    a = car(a);
    if(!is_integer(a)) goto    G0778;
    a = w1;
    {
        popv(1);
        return  CC_seLpol3any(a, q);
    }
   G0778:
    a = w1;
    {
        popv(1);
        return  CC_seLbpolany(a, q);
    }
}

Sex CC_seLbnumbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_tail2(a);
    w3 = a;
    a = cdr(a);
    w4 = a;
    a = car(a);
    a = car(a);
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0784;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    goto    G0794;
   G0784:
    q = cdr(car(w4));
    a = w1;
    a = CC_seLbnumany(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0790;
    q = nil;
    a = w3;
    goto    G0794;
   G0790:
    q = w5;
    a = car(w4);
   G0794:
    cdr(a) = q;
    a = w2;
    popv(5);
    return a;
}

Sex CC_seLpol3bpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_tail2(a);
    w3 = a;
    a = cdr(a);
    w4 = a;
    a = car(a);
    a = car(a);
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0799;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    goto    G0809;
   G0799:
    q = cdr(car(w4));
    a = w1;
    a = CC_seLpol3any(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0805;
    q = nil;
    a = w3;
    goto    G0809;
   G0805:
    q = w5;
    a = car(w4);
   G0809:
    cdr(a) = q;
    a = w2;
    popv(5);
    return a;
}

Sex CC_seLbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G0813;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_seLbpolbpolTvarvar(a, q);
    }
   G0813:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0814;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_LbpolbpolTcofvar(a, q);
    }
   G0814:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_seLbpolbpolTcofvar(a, q);
    }
}

Sex CC_seLbpolbpolTcofvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_tail2(a);
    w3 = a;
    a = cdr(a);
    w4 = a;
    a = car(a);
    a = car(a);
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0820;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    goto    G0830;
   G0820:
    q = cdr(car(w4));
    a = w1;
    a = CC_seLbpolany(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0826;
    q = nil;
    a = w3;
    goto    G0830;
   G0826:
    q = w5;
    a = car(w4);
   G0830:
    cdr(a) = q;
    a = w2;
    popv(5);
    return a;
}

Sex CC_seLbpolbpolTvarvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w5 = nil;
    w7 = nil;
    w1 = a;
    a = q;
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
    w2 = q;
    a = car(a);
    a = car(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    a = car(a);
    w6 = a;
   G0834:
    q = w5;
    a = w6;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0840;
    a = w2;
    w4 = a;
    a = cdr(a);
    w2 = a;
    if(a == nil) goto    G0842;
    a = car(car(a));
    goto    G0859;
   G0840:
    q = w6;
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0845;
    q = w2;
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w4);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0848;
    a = car(car(a));
    w5 = a;
    goto    G0834;
   G0842:
    q = w1;
    a = w4;
    cdr(a) = q;
   G0848:
    a = w3;
    goto    G0833;
   G0845:
    q = cdr(car(w2));
    a = cdr(car(w1));
    a = CC_seLanyany(a, q);
    w7 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0849;
    q = cdr(w2);
    a = w4;
    goto    G0861;
   G0849:
    a = w2;
    w4 = a;
    a = car(a);
    q = w7;
   G0861:
    cdr(a) = q;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0857;
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0862;
    a = car(car(w1));
    w5 = a;
    a = car(car(w2));
   G0859:
    w6 = a;
    goto    G0834;
   G0862:
    q = w1;
    a = w4;
    cdr(a) = q;
   G0857:
    a = w3;
    a = CC_reduceTbpol(a);
   G0833:
    popv(7);
    return a;
}

Sex CC_seseLbpolany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0866;
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_seLbnumbpol(a, q);
    }
   G0866:
    a = car(q);
    if(!is_integer(a)) goto    G0867;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_seLpol3bpol(a, q);
    }
   G0867:
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0868;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_seseLbpolbpolTvarvar(a, q);
    }
   G0868:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0869;
    q = w1;
    a = w2;
    goto    G0871;
   G0869:
    q = w2;
    a = w1;
   G0871:
    {
        popv(2);
        return  CC_seseLbpolbpolTcofvar(a, q);
    }
}

Sex CC_seseLanyany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0875;
    {
        popv(2);
        return  CC_seLbnumany(a, q);
    }
   G0875:
    a = car(a);
    if(!is_integer(a)) goto    G0876;
    a = w1;
    {
        popv(2);
        return  CC_seLpol3any(a, q);
    }
   G0876:
    if(!is_number(q)) goto    G0877;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_seLbnumbpol(a, q);
    }
   G0877:
    a = car(q);
    if(!is_integer(a)) goto    G0878;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_seLpol3bpol(a, q);
    }
   G0878:
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0879;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_seseLbpolbpolTvarvar(a, q);
    }
   G0879:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0880;
    q = w1;
    a = w2;
    goto    G0882;
   G0880:
    q = w2;
    a = w1;
   G0882:
    {
        popv(2);
        return  CC_seseLbpolbpolTcofvar(a, q);
    }
}

Sex CC_seseLbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G0886;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_seseLbpolbpolTvarvar(a, q);
    }
   G0886:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0887;
    q = w1;
    a = w2;
    goto    G0889;
   G0887:
    q = w2;
    a = w1;
   G0889:
    {
        popv(2);
        return  CC_seseLbpolbpolTcofvar(a, q);
    }
}

Sex CC_seseLbpolbpolTcofvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_tail2(a);
    w3 = a;
    a = cdr(a);
    w4 = a;
    a = car(a);
    a = car(a);
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0894;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    goto    G0904;
   G0894:
    q = cdr(car(w4));
    a = w1;
    a = CC_seseLbpolany(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0900;
    q = nil;
    a = w3;
    goto    G0904;
   G0900:
    q = w5;
    a = car(w4);
   G0904:
    cdr(a) = q;
    a = w2;
    popv(5);
    return a;
}

Sex CC_seseLbpolbpolTvarvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w5 = nil;
    w7 = nil;
    w1 = a;
    a = q;
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
    w2 = q;
    a = car(a);
    a = car(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    a = car(a);
    w6 = a;
   G0908:
    q = w5;
    a = w6;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0914;
    a = w2;
    w4 = a;
    a = cdr(a);
    w2 = a;
    if(a == nil) goto    G0916;
    a = car(car(a));
    goto    G0933;
   G0914:
    q = w6;
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0919;
    q = w2;
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w4);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0922;
    a = car(car(a));
    w5 = a;
    goto    G0908;
   G0916:
    q = w1;
    a = w4;
    cdr(a) = q;
   G0922:
    a = w3;
    goto    G0907;
   G0919:
    q = cdr(car(w2));
    a = cdr(car(w1));
    a = CC_seseLanyany(a, q);
    w7 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0923;
    q = cdr(w2);
    a = w4;
    goto    G0935;
   G0923:
    a = w2;
    w4 = a;
    a = car(a);
    q = w7;
   G0935:
    cdr(a) = q;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0931;
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0936;
    a = car(car(w1));
    w5 = a;
    a = car(car(w2));
   G0933:
    w6 = a;
    goto    G0908;
   G0936:
    q = w1;
    a = w4;
    cdr(a) = q;
   G0931:
    a = w3;
    a = CC_reduceTbpol(a);
   G0907:
    popv(7);
    return a;
}

Sex CC_Hbnumpol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = cdr(q);
    a = CC_Hbnumbpol(a, q);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
}

Sex CC_Hbnumbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(q);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
   G0943:
    q = cdr(car(w2));
    a = w1;
    a = CC_Hbnumany(a, q);
    q = car(car(w2));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0943;
    a = w3;
    popv(4);
    return a;
}

Sex CC_Hpol3pol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = car(a);
    w3 = a;
    a = car(q);
    w4 = a;
    w2 = q;
    if(a == w3) goto    G0974;
    if(w3 >= a) goto    G0955;
    q = cdr(q);
    a = w1;
    a = CC_Hpol3bpol(a, q);
    q = w4;
    goto    G0972;
   G0955:
    q = cdr(w1);
    a = w2;
    a = CC_Hpol3bpol(a, q);
    q = w3;
   G0972:
    {
        popv(5);
        return  Lxcons(a, q);
    }
   G0974:
    q = cdr(q);
    a = cdr(w1);
    a = CC_Hbpolbpol(a, q);
    w5 = a;
    a = w3;
    if(a != value(LL_CpolyC)) goto    G0962;
    q = w5;
    a = value(LL_CpolyC);
    goto    G0973;
   G0962:
    if(a != value(LL_CalgnC)) goto    G0965;
    a = w5;
    a = CC_reduceTbalgn(a);
    goto    G0966;
   G0965:
    a = w5;
    a = CC_reduceTbalgf(a);
   G0966:
    w5 = a;
    if(is_number(a)) goto    G0969;
    a = car(a);
    if(!is_integer(a)) goto    G0968;
   G0969:
    a = w5;
    goto    G0952;
   G0968:
    q = w5;
    a = w3;
   G0973:
    a = cons(a, q);
   G0952:
    popv(5);
    return a;
}

Sex CC_psHpol3pol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = car(a);
    w3 = a;
    a = car(q);
    w4 = a;
    w2 = q;
    if(a != w3) goto    G0979;
    a = w3;
    q = cdr(q);
    if(a != value(LL_CalgnC)) goto    G0981;
    a = cdr(w1);
    a = CC_Hbpolbpol(a, q);
    goto    G1008;
   G0981:
    a = cdr(w1);
    a = CC_psHbpolbpol(a, q);
   G1008:
    w5 = a;
    goto    G0989;
   G0979:
    if(a >= w3) goto    G0983;
    q = cdr(w1);
    a = w2;
    a = CC_psHpol3bpol(a, q);
    w5 = a;
    if(is_number(a)) goto    G0977;
    a = car(a);
    if(is_integer(a)) goto    G1005;
    q = w5;
    a = w3;
    goto    G1014;
   G0983:
    q = cdr(q);
    a = w1;
    a = CC_psHpol3bpol(a, q);
    w5 = a;
    if(is_number(a)) goto    G0977;
    a = car(a);
    if(is_integer(a)) goto    G1005;
    q = w5;
    a = w4;
    goto    G1014;
    a = w5;
   G0989:
    if(is_number(a)) goto    G1005;
    a = car(a);
    if(is_integer(a)) goto    G1005;
    a = w3;
    if(a != value(LL_CpolyC)) goto    G0998;
    q = w5;
    a = value(LL_CpolyC);
    goto    G1014;
   G0998:
    if(a != value(LL_CalgnC)) goto    G1001;
    a = w5;
    a = CC_reduceTbalgn(a);
    goto    G1002;
   G1001:
    a = w5;
    a = CC_reduceTbalgf(a);
   G1002:
    w5 = a;
    if(is_number(a)) goto    G1005;
    a = car(a);
    if(!is_integer(a)) goto    G1004;
   G1005:
    a = w5;
    goto    G0977;
   G1004:
    q = w5;
    a = w3;
   G1014:
    a = cons(a, q);
   G0977:
    popv(5);
    return a;
}

Sex CC_Hpol3bpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(q);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
   G1018:
    q = cdr(car(w2));
    a = w1;
    a = CC_Hpol3any(a, q);
    q = car(car(w2));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1018;
    a = w3;
    popv(4);
    return a;
}

Sex CC_psHpol3bpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(q);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
   G1028:
    q = cdr(car(w2));
    a = w1;
    a = CC_psHpol3any(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1030;
    q = w5;
    a = car(car(w2));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1030:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1028;
    a = w3;
    {
        popv(5);
        return  CC_reduceTbpol(a);
    }
}

Sex CC_Hbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1040;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_HbpolbpolTvarvar(a, q);
    }
   G1040:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1041;
    q = w1;
    a = w2;
    goto    G1043;
   G1041:
    q = w2;
    a = w1;
   G1043:
    {
        popv(2);
        return  CC_HbpolbpolTcofvar(a, q);
    }
}

Sex CC_psHbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1047;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_psHbpolbpolTvarvar(a, q);
    }
   G1047:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1048;
    q = w1;
    a = w2;
    goto    G1050;
   G1048:
    q = w2;
    a = w1;
   G1050:
    {
        popv(2);
        return  CC_psHbpolbpolTcofvar(a, q);
    }
}

Sex CC_Hanyany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G1054;
    if(!is_number(q)) goto    G1056;
    {
        popv(2);
        return  times2(a, q);
    }
   G1056:
    a = car(q);
    if(is_integer(a)) goto    G1057;
    a = w1;
    goto    G1071;
   G1057:
    q = cdr(q);
    a = w1;
    a = CC_Hbnumbpol(a, q);
    q = car(w2);
    goto    G1072;
   G1054:
    a = car(a);
    if(!is_integer(a)) goto    G1060;
    if(!is_number(q)) goto    G1062;
    q = cdr(w1);
    a = w2;
    a = CC_Hbnumbpol(a, q);
    q = car(w1);
   G1072:
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G1062:
    a = car(q);
    if(!is_integer(a)) goto    G1064;
    a = w1;
    {
        popv(2);
        return  CC_Hpol3pol3(a, q);
    }
   G1064:
    a = w1;
    goto    G1073;
   G1060:
    if(!is_number(q)) goto    G1066;
    q = w1;
    a = w2;
   G1071:
    {
        popv(2);
        return  CC_Hbnumbpol(a, q);
    }
   G1066:
    a = car(q);
    if(!is_integer(a)) goto    G1067;
    q = w1;
    a = w2;
   G1073:
    {
        popv(2);
        return  CC_Hpol3bpol(a, q);
    }
   G1067:
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G1068;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_HbpolbpolTvarvar(a, q);
    }
   G1068:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1069;
    q = w1;
    a = w2;
    goto    G1074;
   G1069:
    q = w2;
    a = w1;
   G1074:
    {
        popv(2);
        return  CC_HbpolbpolTcofvar(a, q);
    }
}

Sex CC_Hany0any0(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G1078;
    a = Lzerop(a);
    if(a != nil) goto    G1097;
    a = w2;
    if(!is_number(a)) goto    G1081;
    q = a;
    a = w1;
    {
        popv(2);
        return  times2(a, q);
    }
   G1081:
    a = car(a);
    if(!is_integer(a)) goto    G1082;
    q = cdr(w2);
    a = w1;
    a = CC_Hbnumbpol(a, q);
    q = car(w2);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G1082:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_Hbnumbpol(a, q);
    }
   G1078:
    if(!is_number(q)) goto    G1085;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G1087;
   G1097:
    a = mkfxat(0);
    goto    G1096;
   G1087:
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_Hbnumany(a, q);
    }
   G1085:
    a = car(a);
    if(!is_integer(a)) goto    G1089;
    a = car(q);
    if(!is_integer(a)) goto    G1091;
    a = w1;
    {
        popv(2);
        return  CC_Hpol3pol3(a, q);
    }
   G1091:
    a = w1;
    goto    G1098;
   G1089:
    a = car(q);
    if(!is_integer(a)) goto    G1093;
    q = w1;
    a = w2;
   G1098:
    {
        popv(2);
        return  CC_Hpol3bpol(a, q);
    }
   G1093:
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G1094;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_HbpolbpolTvarvar(a, q);
    }
   G1094:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1095;
    q = w1;
    a = w2;
    goto    G1099;
   G1095:
    q = w2;
    a = w1;
   G1099:
    a = CC_HbpolbpolTcofvar(a, q);
   G1096:
    popv(2);
    return a;
}

Sex CC_Hbnumany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G1103;
    {
        popv(2);
        return  times2(a, q);
    }
   G1103:
    a = car(q);
    if(is_integer(a)) goto    G1104;
    a = w1;
    {
        popv(2);
        return  CC_Hbnumbpol(a, q);
    }
   G1104:
    q = cdr(q);
    a = w1;
    a = CC_Hbnumbpol(a, q);
    q = car(w2);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_Hpol3any(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G1110;
    q = cdr(a);
    a = w2;
    a = CC_Hbnumbpol(a, q);
    q = car(w1);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G1110:
    a = car(q);
    if(!is_integer(a)) goto    G1112;
    a = w1;
    {
        popv(2);
        return  CC_Hpol3pol3(a, q);
    }
   G1112:
    a = w1;
    {
        popv(2);
        return  CC_Hpol3bpol(a, q);
    }
}

Sex CC_Hbpolany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G1117;
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_Hbnumbpol(a, q);
    }
   G1117:
    a = car(q);
    if(!is_integer(a)) goto    G1118;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_Hpol3bpol(a, q);
    }
   G1118:
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G1119;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_HbpolbpolTvarvar(a, q);
    }
   G1119:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1120;
    q = w1;
    a = w2;
    goto    G1122;
   G1120:
    q = w2;
    a = w1;
   G1122:
    {
        popv(2);
        return  CC_HbpolbpolTcofvar(a, q);
    }
}

Sex CC_psHpol3any(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G1126;
    q = cdr(a);
    a = w2;
    a = CC_Hbnumbpol(a, q);
    q = car(w1);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G1126:
    a = car(q);
    if(!is_integer(a)) goto    G1128;
    a = w1;
    {
        popv(2);
        return  CC_psHpol3pol3(a, q);
    }
   G1128:
    a = w1;
    {
        popv(2);
        return  CC_psHpol3bpol(a, q);
    }
}

Sex CC_psHbpolany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G1133;
    q = a;
    a = w2;
    {
        popv(2);
        return  CC_Hbnumbpol(a, q);
    }
   G1133:
    a = car(q);
    if(!is_integer(a)) goto    G1134;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_psHpol3bpol(a, q);
    }
   G1134:
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G1135;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_psHbpolbpolTvarvar(a, q);
    }
   G1135:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1136;
    q = w1;
    a = w2;
    goto    G1138;
   G1136:
    q = w2;
    a = w1;
   G1138:
    {
        popv(2);
        return  CC_psHbpolbpolTcofvar(a, q);
    }
}

Sex CC_psHanyany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G1142;
    if(!is_number(q)) goto    G1144;
    {
        popv(2);
        return  times2(a, q);
    }
   G1144:
    a = car(q);
    if(is_integer(a)) goto    G1145;
    a = w1;
    goto    G1159;
   G1145:
    q = cdr(q);
    a = w1;
    a = CC_Hbnumbpol(a, q);
    q = car(w2);
    goto    G1160;
   G1142:
    a = car(a);
    if(!is_integer(a)) goto    G1148;
    if(!is_number(q)) goto    G1150;
    q = cdr(w1);
    a = w2;
    a = CC_Hbnumbpol(a, q);
    q = car(w1);
   G1160:
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G1150:
    a = car(q);
    if(!is_integer(a)) goto    G1152;
    a = w1;
    {
        popv(2);
        return  CC_psHpol3pol3(a, q);
    }
   G1152:
    a = w1;
    goto    G1161;
   G1148:
    if(!is_number(q)) goto    G1154;
    q = w1;
    a = w2;
   G1159:
    {
        popv(2);
        return  CC_Hbnumbpol(a, q);
    }
   G1154:
    a = car(q);
    if(!is_integer(a)) goto    G1155;
    q = w1;
    a = w2;
   G1161:
    {
        popv(2);
        return  CC_psHpol3bpol(a, q);
    }
   G1155:
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G1156;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_psHbpolbpolTvarvar(a, q);
    }
   G1156:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1157;
    q = w1;
    a = w2;
    goto    G1162;
   G1157:
    q = w2;
    a = w1;
   G1162:
    {
        popv(2);
        return  CC_psHbpolbpolTcofvar(a, q);
    }
}

Sex CC_HbpolbpolTcofvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(q);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
   G1166:
    q = cdr(car(w2));
    a = w1;
    a = CC_Hbpolany(a, q);
    q = car(car(w2));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1166;
    a = w3;
    popv(4);
    return a;
}

Sex CC_psHbpolbpolTcofvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(q);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
   G1176:
    q = cdr(car(w2));
    a = w1;
    a = CC_psHbpolany(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1178;
    q = w5;
    a = car(car(w2));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1178:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1176;
    a = w3;
    {
        popv(5);
        return  CC_reduceTbpol(a);
    }
}

Sex CC_HbpolbpolTvarvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w8 = nil;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = Llength(a);
    w12 = a;
    a = cdr(w2);
    w2 = a;
    a = Llength(a);
    q = a;
    a = w12;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1197;
    a = w1;
    w11 = a;
    a = w2;
    w1 = a;
    a = w11;
    w2 = a;
   G1197:
    a = w3;
    w5 = a;
    w4 = a;
    a = car(car(w1));
    w8 = a;
    a = cdr(car(w1));
    w7 = a;
    a = w2;
    w11 = a;
   G1188:
    if(a == nil) goto    G1203;
    q = car(car(a));
    a = w8;
    a = plus2(a, q);
    w12 = a;
    q = cdr(car(w11));
    a = w7;
    a = CC_Hanyany(a, q);
    q = w12;
    a = Lxcons(a, q);
    w9 = a;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w11);
    w11 = a;
    goto    G1188;
   G1203:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G1278;
    a = car(car(a));
    w8 = a;
    a = cdr(car(w1));
    w7 = a;
    a = w2;
    w11 = a;
    q = car(car(a));
    a = w8;
    a = plus2(a, q);
    q = a;
    a = w4;
    a = CC_pointTtm(a, q);
    w5 = a;
    w4 = a;
    a = cdr(a);
    w6 = a;
    a = w7;
    if(is_number(a)) goto    G1192;
    a = car(a);
    if(is_integer(a)) goto    G1194;
   G1214:
    q = car(car(w11));
    a = w8;
    a = plus2(a, q);
    w10 = a;
    q = cdr(car(w11));
    a = w7;
    a = CC_Hbpolany(a, q);
    w9 = a;
    a = w6;
   G1191:
    if(a != nil) goto    G1216;
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G1228;
   G1216:
    q = w10;
    a = car(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G1220;
    q = cdr(car(w6));
    a = w9;
    a = CC_seseLbpolany(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1222;
    q = cdr(w6);
    a = w5;
    goto    G1273;
   G1222:
    a = w6;
    w5 = a;
    a = car(a);
    q = w9;
    goto    G1273;
   G1220:
    q = w10;
    a = car(car(w6));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1226;
    a = w6;
    w5 = a;
    a = cdr(a);
    w6 = a;
    goto    G1191;
   G1226:
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = w6;
   G1273:
    cdr(a) = q;
   G1228:
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G1203;
    a = cdr(w5);
    w6 = a;
    goto    G1214;
   G1192:
    q = car(car(w11));
    a = w8;
    a = plus2(a, q);
    w10 = a;
    q = cdr(car(w11));
    a = w7;
    a = CC_Hbnumany(a, q);
    w9 = a;
    a = w6;
   G1193:
    if(a != nil) goto    G1235;
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G1247;
   G1235:
    q = w10;
    a = car(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G1239;
    q = cdr(car(w6));
    a = w9;
    a = CC_seseLanyany(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1241;
    q = cdr(w6);
    a = w5;
    goto    G1275;
   G1241:
    a = w6;
    w5 = a;
    a = car(a);
    q = w9;
    goto    G1275;
   G1239:
    q = w10;
    a = car(car(w6));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1245;
    a = w6;
    w5 = a;
    a = cdr(a);
    w6 = a;
    goto    G1193;
   G1245:
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = w6;
   G1275:
    cdr(a) = q;
   G1247:
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G1203;
    a = cdr(w5);
    w6 = a;
    goto    G1192;
   G1194:
    q = car(car(w11));
    a = w8;
    a = plus2(a, q);
    w10 = a;
    q = cdr(car(w11));
    a = w7;
    a = CC_Hpol3any(a, q);
    w9 = a;
    a = w6;
   G1195:
    if(a != nil) goto    G1254;
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G1266;
   G1254:
    q = w10;
    a = car(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G1258;
    q = cdr(car(w6));
    a = w9;
    a = CC_seseLanyany(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1260;
    q = cdr(w6);
    a = w5;
    goto    G1277;
   G1260:
    a = w6;
    w5 = a;
    a = car(a);
    q = w9;
    goto    G1277;
   G1258:
    q = w10;
    a = car(car(w6));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1264;
    a = w6;
    w5 = a;
    a = cdr(a);
    w6 = a;
    goto    G1195;
   G1264:
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = w6;
   G1277:
    cdr(a) = q;
   G1266:
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G1203;
    a = cdr(w5);
    w6 = a;
    goto    G1194;
   G1278:
    a = w3;
    popv(12);
    return a;
}

Sex CC_psHbpolbpolTvarvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w3 = a;
    q = value(LL_Hpowser);
    a = car(w1);
    a = Lassoc(a, q);
    w11 = a;
    if(a == nil) goto    G1289;
    a = cdr(a);
    w4 = a;
   G1289:
    a = w1;
    a = Llength(a);
    w12 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w12;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1291;
    a = w1;
    w11 = a;
    a = w2;
    w1 = a;
    a = w11;
    w2 = a;
   G1291:
    a = cdr(w2);
    w2 = a;
   G1282:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1295;
    a = w3;
    {
        popv(12);
        return  CC_reduceTbpol(a);
    }
   G1295:
    a = car(car(a));
    w8 = a;
    a = cdr(car(w1));
    w7 = a;
    a = w2;
    w11 = a;
    a = w4;
    if(a == nil) goto    G1300;
   G1298:
    q = car(car(w11));
    a = w8;
    a = plus2(a, q);
    q = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1300;
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G1282;
    goto    G1298;
   G1300:
    q = car(car(w11));
    a = w8;
    a = plus2(a, q);
    q = a;
    a = w3;
    a = CC_pointTtm(a, q);
    w5 = a;
    a = cdr(a);
    w6 = a;
   G1285:
    q = cdr(car(w11));
    a = w7;
    a = CC_psHanyany(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1323;
    q = car(car(w11));
    a = w8;
    a = plus2(a, q);
    w10 = a;
    a = w6;
   G1286:
    if(a != nil) goto    G1311;
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G1323;
   G1311:
    q = w10;
    a = car(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G1315;
    q = cdr(car(w6));
    a = w9;
    a = CC_seseLanyany(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1317;
    q = cdr(w6);
    a = w5;
    goto    G1330;
   G1317:
    a = w6;
    w5 = a;
    a = car(a);
    q = w9;
    goto    G1330;
   G1315:
    q = w10;
    a = car(car(w6));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1321;
    a = w6;
    w5 = a;
    a = cdr(a);
    w6 = a;
    goto    G1286;
   G1321:
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = w6;
   G1330:
    cdr(a) = q;
   G1323:
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G1282;
    a = cdr(w5);
    w6 = a;
    goto    G1285;
}

Sex CC_pointTtm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
   G1340:
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G1334;
    w2 = q;
    a = car(car(a));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1334;
    q = w2;
    a = cdr(w1);
    goto    G1340;  /* recursive call to point:tm */
   G1334:
    a = w1;
    popv(2);
    return a;
}

Sex CC_chkTdivble(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = cdr(q);
    a = cdr(a);
    a = CC_Vbpolbpol(a, q);
    w3 = a;
    if(a == nil) goto    G1342;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1346;
    a = car(w3);
    a = CC_Wtag(a);
    if(a == nil) goto    G1345;
   G1346:
    a = w3;
    goto    G1342;
   G1345:
    q = w3;
    a = car(w1);
    a = cons(a, q);
   G1342:
    popv(3);
    return a;
}

Sex CC_Vanybnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G1352;
    {
        popv(1);
        return  CC_flgdivTbnumbnum(a, q);
    }
   G1352:
    a = car(a);
    if(!is_integer(a)) goto    G1353;
    a = w1;
    {
        popv(1);
        return  CC_Vpol3bnum(a, q);
    }
   G1353:
    a = w1;
    {
        popv(1);
        return  CC_Vbpolbnum(a, q);
    }
}

Sex CC_Vanypol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G1358;
    a = car(q);
    if(a != value(LL_CpolyC)) goto    G1360;
    a = nil;
    goto    G1366;
   G1360:
    if(a != value(LL_CalgnC)) goto    G1361;
    a = q;
    a = CC_recipTalgn(a);
    q = a;
    a = w1;
    {
        popv(1);
        return  CC_Hbnumpol3(a, q);
    }
   G1361:
    a = q;
    a = CC_recipTalgf(a);
    q = a;
    a = w1;
    {
        popv(1);
        return  CC_multTbnumcano(a, q);
    }
   G1358:
    a = car(a);
    if(!is_integer(a)) goto    G1365;
    a = w1;
    {
        popv(1);
        return  CC_Vpol3pol3(a, q);
    }
   G1365:
    a = w1;
    a = CC_Vbpolpol3(a, q);
   G1366:
    popv(1);
    return a;
}

Sex CC_Vanyany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(q)) goto    G1370;
    {
        popv(1);
        return  CC_Vanybnum(a, q);
    }
   G1370:
    a = car(q);
    if(!is_integer(a)) goto    G1371;
    a = w1;
    {
        popv(1);
        return  CC_Vanypol3(a, q);
    }
   G1371:
    a = w1;
    if(is_number(a)) goto    G1373;
    a = car(a);
    if(!is_integer(a)) goto    G1372;
   G1373:
    a = nil;
    goto    G1374;
   G1372:
    a = w1;
    a = CC_Vbpolbpol(a, q);
   G1374:
    popv(1);
    return a;
}

Sex CC_psVanypol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G1378;
    a = car(q);
    if(a != value(LL_CpolyC)) goto    G1380;
    a = w1;
    {
        popv(1);
        return  CC_psVbnumpoly(a, q);
    }
   G1380:
    if(a != value(LL_CalgnC)) goto    G1381;
    a = q;
    a = CC_recipTalgn(a);
    q = a;
    a = w1;
    {
        popv(1);
        return  CC_Hbnumpol3(a, q);
    }
   G1381:
    a = q;
    a = CC_recipTalgf(a);
    q = a;
    a = w1;
    {
        popv(1);
        return  CC_multTbnumcano(a, q);
    }
   G1378:
    a = car(a);
    if(!is_integer(a)) goto    G1385;
    a = w1;
    {
        popv(1);
        return  CC_psVpol3pol3(a, q);
    }
   G1385:
    a = w1;
    {
        popv(1);
        return  CC_psVbpolpol3(a, q);
    }
}

Sex CC_psVanyany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G1390;
    {
        popv(2);
        return  CC_Vanybnum(a, q);
    }
   G1390:
    a = car(q);
    if(!is_integer(a)) goto    G1391;
    a = w1;
    {
        popv(2);
        return  CC_psVanypol3(a, q);
    }
   G1391:
    a = w1;
    if(!is_number(a)) goto    G1392;
    q = value(LL_Hpowser);
    a = car(w2);
    a = Lassoc(a, q);
    if(a == nil) goto    G1400;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_psVbnumbpol(a, q);
    }
   G1392:
    a = car(a);
    if(!is_integer(a)) goto    G1396;
    q = value(LL_Hpowser);
    a = car(w2);
    a = Lassoc(a, q);
    if(a == nil) goto    G1400;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_psVcofbpol(a, q);
    }
   G1396:
    a = w1;
    a = CC_psVbpolbpol(a, q);
   G1400:
    popv(2);
    return a;
}

Sex CC_psVbnumpoly(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = cdr(q);
    a = CC_psVbnumbpol(a, q);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
}

Sex CC_Vpol3bnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    a = CC_Vbpolbnum(a, q);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
}

Sex CC_Vpol3pol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = car(a);
    w3 = a;
    w2 = q;
    a = car(q);
    w4 = a;
    if(a != w3) goto    G1411;
    a = w3;
    if(a != value(LL_CpolyC)) goto    G1413;
    q = cdr(q);
    a = cdr(w1);
    a = CC_Vbpolbpol(a, q);
    goto    G1436;
   G1411:
    if(a >= w3) goto    G1420;
    if(a != value(LL_CpolyC)) goto    G1422;
    a = cdr(w1);
    a = CC_Vbpolpol3(a, q);
   G1436:
    w5 = a;
    goto    G1427;
   G1413:
    if(a != value(LL_CalgnC)) goto    G1426;
   G1422:
    a = q;
    a = CC_recipTalgn(a);
    q = a;
    a = w1;
    {
        popv(5);
        return  CC_Hpol3pol3(a, q);
    }
   G1420:
    if(a != value(LL_CpolyC)) goto    G1426;
    a = nil;
    goto    G1409;
   G1426:
    a = q;
    a = CC_recipTalgf(a);
    q = a;
    a = w1;
    {
        popv(5);
        return  CC_multTcanocano(a, q);
    }
    a = w5;
   G1427:
    if(a == nil) goto    G1409;
    if(is_number(a)) goto    G1409;
    a = car(a);
    if(!is_integer(a)) goto    G1433;
    a = w5;
    goto    G1409;
   G1433:
    q = w5;
    a = w3;
    a = cons(a, q);
   G1409:
    popv(5);
    return a;
}

Sex CC_psVpol3pol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = car(a);
    w3 = a;
    w2 = q;
    a = car(q);
    w4 = a;
    if(a != w3) goto    G1443;
    a = w3;
    if(a != value(LL_CpolyC)) goto    G1445;
    q = cdr(q);
    a = cdr(w1);
    a = CC_psVbpolbpol(a, q);
    goto    G1470;
   G1443:
    if(a >= w3) goto    G1452;
    if(a != value(LL_CpolyC)) goto    G1454;
    a = cdr(w1);
    a = CC_psVbpolpol3(a, q);
   G1470:
    w5 = a;
    goto    G1461;
   G1445:
    if(a != value(LL_CalgnC)) goto    G1458;
   G1454:
    a = q;
    a = CC_recipTalgn(a);
    q = a;
    a = w1;
    {
        popv(5);
        return  CC_Hpol3pol3(a, q);
    }
   G1452:
    if(a != value(LL_CpolyC)) goto    G1458;
    a = mkfxat(1);
    a = CC_psVbnumpoly(a, q);
    q = a;
    a = w1;
    {
        popv(5);
        return  CC_psHpol3pol3(a, q);
    }
   G1458:
    a = q;
    a = CC_recipTalgf(a);
    q = a;
    a = w1;
    {
        popv(5);
        return  CC_multTcanocano(a, q);
    }
    a = w5;
   G1461:
    if(a == nil) goto    G1441;
    if(is_number(a)) goto    G1441;
    a = car(a);
    if(!is_integer(a)) goto    G1467;
    a = w5;
    goto    G1441;
   G1467:
    q = w5;
    a = w3;
    a = cons(a, q);
   G1441:
    popv(5);
    return a;
}

Sex CC_psVbnumbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    a = car(q);
    w5 = a;
    w2 = q;
    a = q;
    a = Llast(a);
    w3 = a;
    a = cdr(a);
    w4 = a;
    a = car(w3);
    a = Lzerop(a);
    if(a == nil) goto    G1478;
    q = value(LL_Hpowser);
    a = w5;
    a = Lassoc(a, q);
    if(a != nil) goto    G1480;
   G1478:
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
   G1480:
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G1482;
    a = w1;
    goto    G1500;
   G1482:
    a = w4;
    if(!is_number(a)) goto    G1484;
    a = CC_recipTbnum(a);
    w4 = a;
    q = w2;
    a = CC_Hbnumbpol(a, q);
    w2 = a;
    q = w4;
    a = w1;
    a = times2(a, q);
    w1 = a;
   G1500:
    a = Lminus(a);
    q = w2;
    a = CC_Hbnumbpol(a, q);
    goto    G1502;
   G1484:
    a = car(a);
    if(!is_integer(a)) goto    G1486;
    a = w4;
    a = CC_recipTalgn(a);
    w4 = a;
    q = w2;
    a = CC_Hpol3bpol(a, q);
    w2 = a;
    q = w4;
    a = w1;
    a = CC_Hbnumpol3(a, q);
    w1 = a;
    a = CC_Kany(a);
    q = w2;
    a = CC_Hpol3bpol(a, q);
    goto    G1502;
   G1486:
    q = w4;
    a = mkfxat(1);
    a = CC_psVbnumbpol(a, q);
    w4 = a;
    q = a;
    a = w2;
    a = CC_psHbpolany(a, q);
    w2 = a;
    q = w4;
    a = w1;
    a = CC_Hbnumany(a, q);
    w1 = a;
    a = CC_Kany(a);
    q = w2;
    a = CC_psHanyany(a, q);
   G1502:
    w3 = a;
    a = w3;
    if(is_number(a)) goto    G1503;
    q = w5;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1503;
    a = w3;
    a = CC_tail2(a);
    q = nil;
    cdr(a) = q;
    q = w2;
    a = w3;
    a = CC_psVbpolbpol(a, q);
    w2 = a;
    if(a == nil) goto    G1504;
    if(!is_number(a)) goto    G1496;
   G1503:
    a = w1;
    goto    G1475;
   G1504:
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
   G1496:
    a = w2;
    a = CC_tail(a);
    w6 = a;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = w2;
   G1475:
    popv(6);
    return a;
}

Sex CC_psVcofbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w1 = a;
    a = car(q);
    w4 = a;
    w2 = q;
    a = q;
    a = Llast(a);
    w5 = a;
    a = car(a);
    a = Lzerop(a);
    if(a == nil) goto    G1509;
    q = value(LL_Hpowser);
    a = w4;
    a = Lassoc(a, q);
    if(a != nil) goto    G1511;
   G1509:
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
   G1511:
    a = cdr(w5);
    w5 = a;
    a = Lonep(a);
    if(a != nil) goto    G1515;
    q = w5;
    a = w1;
    a = CC_psVanyany(a, q);
    w1 = a;
    if(a != nil) goto    G1515;
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
   G1515:
    q = w1;
    a = w2;
    a = CC_psHbpolany(a, q);
    w3 = a;
    if(is_number(a)) goto    G1526;
    q = car(a);
    a = w4;
    a = Lequal(a, q);
    if(a == nil) goto    G1526;
    a = w3;
    a = CC_tail2(a);
    q = nil;
    cdr(a) = q;
    a = w3;
    a = CC_Kbpol(a);
    w3 = a;
    q = w2;
    a = CC_psVbpolbpol(a, q);
    w2 = a;
    if(a == nil) goto    G1527;
    if(!is_number(a)) goto    G1522;
   G1526:
    a = w1;
    goto    G1507;
   G1527:
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
   G1522:
    a = w2;
    a = CC_tail(a);
    w6 = a;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = w2;
   G1507:
    popv(6);
    return a;
}

Sex CC_Vbpolbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G1531;
    a = w1;
    goto    G1532;
   G1531:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G1534:
    a = cdr(car(w1));
    w5 = a;
    if(!is_number(a)) goto    G1536;
    q = w2;
    a = CC_flgdivTbnumbnum(a, q);
    goto    G1538;
   G1536:
    a = car(a);
    q = w2;
    if(is_integer(a)) goto    G1537;
    a = w5;
    a = CC_Vbpolbnum(a, q);
    goto    G1538;
   G1537:
    a = cdr(w5);
    a = CC_Vbpolbnum(a, q);
    q = car(w5);
    a = Lxcons(a, q);
   G1538:
    w6 = a;
    q = car(car(w1));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1534;
    a = w3;
   G1532:
    popv(6);
    return a;
}

Sex CC_Vbpolpol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G1548:
    a = cdr(car(w1));
    w5 = a;
    if(!is_number(a)) goto    G1550;
    a = nil;
    goto    G1547;
   G1550:
    a = car(a);
    q = w2;
    if(!is_integer(a)) goto    G1551;
    a = w5;
    a = CC_Vpol3pol3(a, q);
    goto    G1561;
   G1551:
    a = w5;
    a = CC_Vbpolpol3(a, q);
   G1561:
    w6 = a;
    a = w6;
    if(a == nil) goto    G1547;
    q = car(car(w1));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1548;
    a = w3;
   G1547:
    popv(6);
    return a;
}

Sex CC_psVbpolpol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G1565:
    a = cdr(car(w1));
    w5 = a;
    if(!is_number(a)) goto    G1567;
    a = car(w2);
    if(a != value(LL_CpolyC)) goto    G1569;
    q = w2;
    a = w5;
    a = CC_psVbnumpoly(a, q);
    goto    G1573;
   G1569:
    a = w2;
    a = CC_recipTalgn(a);
    q = a;
    a = w5;
    a = CC_Hbnumpol3(a, q);
    goto    G1573;
   G1567:
    a = car(a);
    q = w2;
    if(!is_integer(a)) goto    G1572;
    a = w5;
    a = CC_psVpol3pol3(a, q);
    goto    G1573;
   G1572:
    a = w5;
    a = CC_psVbpolpol3(a, q);
   G1573:
    w6 = a;
    if(a == nil) goto    G1564;
    a = Lzerop(a);
    if(a != nil) goto    G1576;
    q = w6;
    a = car(car(w1));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1576:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1565;
    a = w3;
    a = CC_reduceTbpol(a);
   G1564:
    popv(6);
    return a;
}

Sex CC_Vbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1586;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    a = car(w1);
    w3 = a;
    a = car(cdr(w1));
    w10 = a;
    a = car(cdr(w2));
    w8 = a;
    a = car(w10);
    w4 = a;
    w11 = a;
    a = car(w8);
    w5 = a;
    q = a;
    a = w11;
    a = Llessp(a, q);
    if(a != nil) goto    G1662;
    a = cdr(cdr(w2));
    w9 = a;
    if(a == nil) goto    G1594;
    q = w3;
    a = Lxcons(a, q);
    a = CC_Kbpol(a);
    goto    G1596;
   G1594:
    a = mkfxat(0);
   G1596:
    w2 = a;
    a = cdr(w8);
    w6 = a;
    a = w3;
    a = Lncons(a);
    w9 = a;
    w8 = a;
   G1588:
    q = w5;
    a = w4;
    a = Llessp(a, q);
    if(a != nil) goto    G1607;
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G1604;
    a = cdr(w10);
    goto    G1605;
   G1604:
    q = w6;
    a = cdr(w10);
    a = CC_Vanyany(a, q);
   G1605:
    w7 = a;
    if(a != nil) goto    G1680;
   G1607:
    a = value(LL_Hexctdiv);
    if(a == nil) goto    G1657;
    goto    G1677;
   G1680:
    q = w5;
    a = w4;
    a = diff2(a, q);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(a);
    w9 = a;
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G1618;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G1677;
    a = car(a);
    w10 = a;
    a = car(a);
    w4 = a;
    q = w1;
    a = w3;
    a = cons(a, q);
    w1 = a;
    goto    G1588;
   G1618:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G1679;
    a = value(LL_Hexctdiv);
    if(a == nil) goto    G1657;
    goto    G1677;
   G1679:
    q = w3;
    a = Lxcons(a, q);
    w1 = a;
    q = w5;
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1631;
    q = car(w9);
    a = w3;
    a = Llist2(a, q);
    q = w2;
    a = CC_HbpolbpolTvarvar(a, q);
    goto    G1634;
   G1631:
    a = car(car(cdr(w2)));
    a = Lzerop(a);
    q = w7;
    if(a != nil) goto    G1633;
    a = w2;
    a = CC_Hbpolany(a, q);
    goto    G1634;
   G1633:
    a = cdr(car(cdr(w2)));
    a = CC_Hanyany(a, q);
    q = mkfxat(0);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    a = Llist2(a, q);
   G1634:
    w10 = a;
    q = a;
    a = w1;
    a = CC_seLbpolbpolTvarvar(a, q);
    w1 = a;
    a = value(LL_Hmod);
    if(a == nil) goto    G1638;
    a = w1;
    if(is_number(a)) goto    G1641;
    a = car(a);
    if(!is_integer(a)) goto    G1640;
   G1641:
    a = w1;
    a = CC_redmodTncan(a);
    goto    G1675;
   G1640:
    a = w1;
    a = CC_redmodTbpol(a);
   G1675:
    w1 = a;
   G1638:
    a = w1;
    if(!is_number(a)) goto    G1644;
    a = Lzerop(a);
    if(a != nil) goto    G1677;
    a = value(LL_Hexctdiv);
    if(a == nil) goto    G1657;
    goto    G1677;
   G1644:
    q = w3;
    a = car(a);
    a = Lequal(a, q);
    if(a != nil) goto    G1650;
    a = value(LL_Hexctdiv);
    if(a == nil) goto    G1657;
   G1677:
    a = w8;
    {
        popv(11);
        return  CC_reduceTbpol(a);
    }
   G1650:
    a = car(cdr(w1));
    w10 = a;
    a = car(a);
    w4 = a;
    goto    G1588;
   G1586:
    q = car(w1);
    a = car(w2);
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G1662;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G1659:
    a = cdr(car(w1));
    w5 = a;
    if(is_number(a)) goto    G1662;
    a = car(a);
    if(!is_integer(a)) goto    G1661;
   G1662:
    a = nil;
    goto    G1657;
   G1661:
    q = w2;
    a = w5;
    a = CC_Vbpolbpol(a, q);
    w5 = a;
    if(a == nil) goto    G1657;
    q = car(car(w1));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1659;
    a = w3;
   G1657:
    popv(11);
    return a;
}

Sex CC_psVbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1684;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    a = car(w1);
    w3 = a;
    q = value(LL_Hpowser);
    a = Lassoc(a, q);
    w11 = a;
    if(a == nil) goto    G1689;
    a = cdr(a);
    w4 = a;
    a = w1;
    a = Llast(a);
    w11 = a;
    a = w2;
    a = Llast(a);
    w9 = a;
    a = car(w11);
    w5 = a;
    w12 = a;
    a = car(w9);
    w6 = a;
    q = a;
    a = w12;
    a = Llessp(a, q);
    if(a != nil) goto    G1847;
    a = w1;
    a = CC_topcopy(a);
    w1 = a;
    a = cdr(w9);
    w7 = a;
    w9 = nil;
    a = w6;
    a = Lminus(a);
    q = a;
    a = w4;
    a = plus2(a, q);
    w4 = a;
    a = cdr(cdr(w2));
    if(a != nil) goto    G1703;
    a = mkfxat(0);
    w2 = a;
    goto    G1704;
   G1703:
    a = w2;
    a = CC_Kbpol(a);
    w2 = a;
    a = CC_tail2(a);
    q = nil;
    cdr(a) = q;
   G1704:
    a = w6;
    a = Lminus(a);
    q = a;
    a = w5;
    a = plus2(a, q);
    w5 = a;
    q = w4;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1756;
    a = w7;
    a = Lonep(a);
    if(a == nil) goto    G1711;
    a = cdr(w11);
    goto    G1712;
   G1711:
    q = w7;
    a = cdr(w11);
    a = CC_psVanyany(a, q);
   G1712:
    w8 = a;
    if(a == nil) goto    G1853;
    a = Lzerop(a);
    if(a == nil) goto    G1718;
    q = w4;
    a = w5;
    a = Lequal(a, q);
    if(a != nil) goto    G1756;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1756;
    a = w1;
    a = CC_tail2(a);
    q = nil;
    cdr(a) = q;
    w11 = a;
    a = car(a);
    goto    G1849;
   G1718:
    q = w8;
    a = w5;
    a = cons(a, q);
    q = w9;
    a = cons(a, q);
    w9 = a;
    q = w4;
    a = w5;
    a = Lequal(a, q);
    if(a != nil) goto    G1756;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1729;
    a = w1;
    a = CC_tail2(a);
    q = nil;
    cdr(a) = q;
    goto    G1731;
   G1729:
    a = mkfxat(0);
    w1 = a;
   G1731:
    a = value(LL_Hmod);
    if(a == nil) goto    G1733;
    a = w1;
    if(is_number(a)) goto    G1736;
    a = car(a);
    if(!is_integer(a)) goto    G1735;
   G1736:
    a = w1;
    a = CC_redmodTncan(a);
    goto    G1850;
   G1735:
    a = w1;
    a = CC_redmodTbpol(a);
   G1850:
    w1 = a;
   G1733:
    a = w2;
    a = Lzerop(a);
    if(a != nil) goto    G1745;
    a = w5;
    a = Lzerop(a);
    if(a == nil) goto    G1740;
    q = w8;
    a = w2;
    a = CC_psHbpolany(a, q);
    goto    G1851;
   G1740:
    q = car(w9);
    a = w3;
    a = Llist2(a, q);
    q = w2;
    a = CC_psHbpolbpolTvarvar(a, q);
   G1851:
    w11 = a;
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G1744;
    a = w11;
    goto    G1852;
   G1744:
    a = w11;
    a = Lzerop(a);
    if(a != nil) goto    G1745;
    q = w11;
    a = w1;
    a = CC_seLbpolany(a, q);
   G1852:
    w1 = a;
   G1745:
    a = w1;
    if(is_number(a)) goto    G1862;
    q = w3;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1853;
    a = w1;
    a = Llast(a);
   G1849:
    w11 = a;
    a = car(a);
    w5 = a;
    goto    G1704;
   G1862:
    a = Lzerop(a);
    if(a != nil) goto    G1756;
   G1853:
    a = value(LL_Hexctdiv);
    if(a == nil) goto    G1824;
   G1756:
    q = w9;
    a = w3;
    a = cons(a, q);
    goto    G1860;
   G1689:
    a = car(cdr(w1));
    w11 = a;
    a = car(cdr(w2));
    w9 = a;
    a = car(w11);
    w5 = a;
    w12 = a;
    a = car(w9);
    w6 = a;
    q = a;
    a = w12;
    a = Llessp(a, q);
    if(a == nil) goto    G1761;
   G1847:
    a = nil;
    goto    G1824;
   G1761:
    a = cdr(cdr(w2));
    w10 = a;
    if(a == nil) goto    G1765;
    q = w3;
    a = Lxcons(a, q);
    a = CC_Kbpol(a);
    goto    G1767;
   G1765:
    a = mkfxat(0);
   G1767:
    w2 = a;
    a = cdr(w9);
    w7 = a;
    a = w3;
    a = Lncons(a);
    w10 = a;
    w9 = a;
   G1690:
    a = w6;
    a = Lminus(a);
    q = a;
    a = w5;
    a = plus2(a, q);
    w5 = a;
    a = Lminusp(a);
    if(a != nil) goto    G1857;
    a = w7;
    a = Lonep(a);
    if(a == nil) goto    G1776;
    a = cdr(w11);
    goto    G1777;
   G1776:
    q = w7;
    a = cdr(w11);
    a = CC_psVanyany(a, q);
   G1777:
    w8 = a;
    if(a == nil) goto    G1857;
    a = Lzerop(a);
    if(a != nil) goto    G1816;
    q = w8;
    a = w5;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    w10 = a;
    a = w2;
    a = Lzerop(a);
    if(a != nil) goto    G1816;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G1857;
    a = w5;
    a = Lplusp(a);
    if(a == nil) goto    G1794;
    q = car(w10);
    a = w3;
    a = Llist2(a, q);
    q = w2;
    a = CC_psHbpolbpolTvarvar(a, q);
    goto    G1797;
   G1794:
    a = car(car(cdr(w2)));
    a = Lzerop(a);
    q = w8;
    if(a != nil) goto    G1796;
    a = w2;
    a = CC_psHbpolany(a, q);
    goto    G1797;
   G1796:
    a = cdr(car(cdr(w2)));
    a = CC_psHanyany(a, q);
   G1797:
    w11 = a;
    a = car(car(w1));
    a = Lzerop(a);
    if(a == nil) goto    G1799;
    q = cdr(car(w1));
    a = w11;
    a = CC_Lanyany(a, q);
    goto    G1801;
   G1799:
    a = w11;
    a = Lzerop(a);
    q = w1;
    if(a == nil) goto    G1800;
    a = w3;
    a = cons(a, q);
    goto    G1801;
   G1800:
    a = w3;
    a = cons(a, q);
    q = w11;
    a = CC_seLbpolany(a, q);
   G1801:
    w1 = a;
    a = value(LL_Hmod);
    if(a == nil) goto    G1804;
    a = w1;
    if(is_number(a)) goto    G1807;
    a = car(a);
    if(!is_integer(a)) goto    G1806;
   G1807:
    a = w1;
    a = CC_redmodTncan(a);
    goto    G1858;
   G1806:
    a = w1;
    a = CC_redmodTbpol(a);
   G1858:
    w1 = a;
   G1804:
    a = w1;
    if(is_number(a)) goto    G1861;
    q = w3;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1824;
    a = car(cdr(w1));
    w11 = a;
    a = car(a);
    w5 = a;
    goto    G1690;
   G1816:
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G1820;
    a = car(a);
    w11 = a;
    a = car(a);
    w5 = a;
    q = w1;
    a = w3;
    a = cons(a, q);
    w1 = a;
    goto    G1690;
   G1861:
    a = Lzerop(a);
    if(a != nil) goto    G1820;
   G1857:
    a = value(LL_Hexctdiv);
    if(a == nil) goto    G1824;
   G1820:
    a = w9;
    goto    G1860;
   G1684:
    q = car(w1);
    a = car(w2);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1823;
    q = w2;
    a = w1;
    {
        popv(12);
        return  CC_psVcofbpol(a, q);
    }
   G1823:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    q = value(LL_Hpowser);
    a = car(w1);
    a = Lassoc(a, q);
    w5 = a;
    if(a == nil) goto    G1829;
    a = cdr(a);
    w3 = a;
   G1829:
    a = car(w1);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w1);
    w1 = a;
   G1826:
    a = car(car(w1));
    w6 = a;
    a = w3;
    if(a == nil) goto    G1831;
    q = a;
    a = w6;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1831;
    a = w4;
    goto    G1860;
   G1831:
    a = cdr(car(w1));
    w7 = a;
    if(!is_number(a)) goto    G1835;
    q = w2;
    a = CC_psVbnumbpol(a, q);
    goto    G1837;
   G1835:
    a = car(a);
    q = w2;
    if(!is_integer(a)) goto    G1836;
    a = w7;
    a = CC_psVcofbpol(a, q);
    goto    G1837;
   G1836:
    a = w7;
    a = CC_psVbpolbpol(a, q);
   G1837:
    w7 = a;
    if(a == nil) goto    G1824;
    a = Lzerop(a);
    if(a != nil) goto    G1840;
    q = w7;
    a = w6;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G1840:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1826;
    a = w4;
   G1860:
    a = CC_reduceTbpol(a);
   G1824:
    popv(12);
    return a;
}

Sex CC_VLbpolbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G1866;
    q = mkfxat(0);
    a = w1;
    goto    G1869;
   G1866:
    q = w2;
    a = w1;
    a = CC_Vbpolbnum(a, q);
    q = mkfxat(0);
   G1869:
    {
        popv(2);
        return  cons(a, q);
    }
}

Sex CC_VLpol3pol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    if(a != car(q)) goto    G1874;
    a = value(LL_Hpowser);
    q = cdr(q);
    if(a == nil) goto    G1876;
    a = cdr(w1);
    a = CC_psVLbpolbpol(a, q);
    goto    G1889;
   G1876:
    a = cdr(w1);
    a = CC_VLbpolbpol(a, q);
    goto    G1889;
   G1874:
    q = car(q);
    a = Llessp(a, q);
    if(a == nil) goto    G1878;
    q = w1;
    a = mkfxat(0);
    {
        popv(3);
        return  cons(a, q);
    }
   G1878:
    q = w2;
    a = cdr(w1);
    a = CC_VLbpolpol3(a, q);
   G1889:
    w3 = a;
    a = w3;
    if(a != nil) goto    G1882;
    q = LITERAL[17];
    a = mkfxat(7);
    CC_printmsg(a, q);
    a = nil;
    goto    G1872;
   G1882:
    a = car(a);
    a = CC_Wncan(a);
    if(a != nil) goto    G1884;
    q = car(w3);
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
   G1884:
    a = cdr(w3);
    a = CC_Wncan(a);
    if(a != nil) goto    G1887;
    q = cdr(w3);
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
   G1887:
    a = w3;
   G1872:
    popv(3);
    return a;
}

Sex CC_VLpolypoly(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = value(LL_Hpowser);
    q = cdr(q);
    if(a == nil) goto    G1894;
    a = cdr(w1);
    a = CC_psVLbpolbpol(a, q);
    goto    G1895;
   G1894:
    a = cdr(w1);
    a = CC_VLbpolbpol(a, q);
   G1895:
    w3 = a;
    if(a != nil) goto    G1897;
    q = LITERAL[18];
    a = mkfxat(7);
    CC_printmsg(a, q);
    a = nil;
    goto    G1892;
   G1897:
    a = car(a);
    a = CC_Wncan(a);
    if(a != nil) goto    G1899;
    q = car(w3);
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
   G1899:
    a = cdr(w3);
    a = CC_Wncan(a);
    if(a != nil) goto    G1902;
    q = cdr(w3);
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
   G1902:
    a = w3;
   G1892:
    popv(3);
    return a;
}

Sex CC_VLalgfpoly(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    a = car(cdr(a));
    w9 = a;
    a = cdr(cdr(w1));
    w3 = a;
    w2 = q;
    a = w9;
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = w9;
    a = Lncons(a);
    w7 = a;
    w6 = a;
   G1907:
    a = cdr(car(w3));
    w8 = a;
    if(is_number(a)) goto    G1949;
    a = car(a);
    if(!is_integer(a)) goto    G1914;
    if(a != value(LL_CalgnC)) goto    G1916;
   G1949:
    a = car(w3);
    goto    G1950;
   G1916:
    q = w2;
    a = w8;
    a = CC_VLpolypoly(a, q);
    w9 = a;
    if(a == nil) goto    G1921;
    goto    G1928;
   G1914:
    q = w8;
    a = value(LL_CalgfC);
    a = cons(a, q);
    q = w2;
    a = CC_VLalgfpoly(a, q);
    w9 = a;
    if(a != nil) goto    G1923;
   G1921:
    q = LITERAL[19];
    a = mkfxat(7);
    CC_printmsg(a, q);
    a = nil;
    goto    G1906;
   G1923:
    a = car(a);
    if(!is_cons(a)) goto    G1925;
    a = car(a);
    if(a != value(LL_CalgfC)) goto    G1925;
    q = cdr(car(w9));
    a = w9;
    car(a) = q;
   G1925:
    a = cdr(w9);
    if(!is_cons(a)) goto    G1928;
    a = car(a);
    if(a != value(LL_CalgfC)) goto    G1928;
    q = cdr(cdr(w9));
    a = w9;
    cdr(a) = q;
   G1928:
    a = car(w9);
    a = Lzerop(a);
    if(a != nil) goto    G1931;
    q = car(w9);
    a = car(car(w3));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G1931:
    a = cdr(w9);
    a = Lzerop(a);
    if(a != nil) goto    G1936;
    q = cdr(w9);
    a = car(car(w3));
    a = cons(a, q);
   G1950:
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
   G1936:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1907;
    a = w4;
    a = CC_reduceTbpol(a);
    w4 = a;
    a = w6;
    a = CC_reduceTbpol(a);
    w6 = a;
    a = w4;
    if(!is_cons(a)) goto    G1943;
    a = car(a);
    if(is_integer(a)) goto    G1943;
    q = w4;
    a = value(LL_CalgfC);
    a = cons(a, q);
    w4 = a;
   G1943:
    a = w6;
    if(!is_cons(a)) goto    G1946;
    a = car(a);
    if(is_integer(a)) goto    G1946;
    q = w6;
    a = value(LL_CalgfC);
    a = cons(a, q);
    w6 = a;
   G1946:
    q = w6;
    a = w4;
    a = cons(a, q);
   G1906:
    popv(9);
    return a;
}

Sex CC_VLbpolpol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    a = car(a);
    w8 = a;
    a = cdr(w1);
    w1 = a;
    w2 = q;
    a = w8;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = w8;
    a = Lncons(a);
    w6 = a;
    w5 = a;
   G1955:
    a = cdr(car(w1));
    w7 = a;
    if(!is_number(a)) goto    G1958;
    a = car(w1);
    goto    G1980;
   G1958:
    a = car(a);
    q = w2;
    if(!is_integer(a)) goto    G1961;
    a = w7;
    a = CC_VLpol3pol3(a, q);
    goto    G1981;
   G1961:
    a = w7;
    a = CC_VLbpolpol3(a, q);
   G1981:
    w8 = a;
    a = w8;
    if(a != nil) goto    G1964;
    q = LITERAL[20];
    a = mkfxat(7);
    CC_printmsg(a, q);
    a = nil;
    goto    G1954;
   G1964:
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G1966;
    q = car(w8);
    a = car(car(w1));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1966:
    a = cdr(w8);
    a = Lzerop(a);
    if(a != nil) goto    G1971;
    q = cdr(w8);
    a = car(car(w1));
    a = cons(a, q);
   G1980:
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G1971:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1955;
    a = w3;
    a = CC_reduceTbpol(a);
    w9 = a;
    a = w5;
    a = CC_reduceTbpol(a);
    q = w9;
    a = Lxcons(a, q);
   G1954:
    popv(9);
    return a;
}

Sex CC_VLbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1985;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    a = car(w1);
    w3 = a;
    a = car(car(cdr(w1)));
    w5 = a;
    a = car(car(cdr(w2)));
    w6 = a;
    q = a;
    a = w5;
    a = Llessp(a, q);
    if(a == nil) goto    G1991;
    q = w1;
    a = mkfxat(0);
    goto    G2067;
   G1991:
    a = car(cdr(w1));
    w4 = a;
    a = cdr(car(cdr(w2)));
    w7 = a;
    a = w3;
    a = Lncons(a);
    w10 = a;
    w9 = a;
    a = cdr(cdr(w2));
    w11 = a;
    if(a == nil) goto    G1994;
    q = w3;
    a = Lxcons(a, q);
    a = CC_Kbpol(a);
    goto    G1996;
   G1994:
    a = mkfxat(0);
   G1996:
    w2 = a;
   G1988:
    q = w6;
    a = w5;
    a = Llessp(a, q);
    if(a != nil) goto    G1989;
    a = w7;
    a = Lonep(a);
    if(a == nil) goto    G2000;
    a = cdr(w4);
    goto    G2001;
   G2000:
    q = w7;
    a = cdr(w4);
    a = CC_Vanyany(a, q);
   G2001:
    w8 = a;
    if(a == nil) goto    G2035;
    q = w6;
    a = w5;
    a = diff2(a, q);
    q = w8;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    w10 = a;
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G2010;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G2068;
    a = car(a);
    w4 = a;
    a = car(a);
    w5 = a;
    q = w1;
    a = w3;
    a = cons(a, q);
    w1 = a;
    goto    G1988;
   G2010:
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G2014;
    q = w3;
    a = Lxcons(a, q);
    goto    G2063;
   G2014:
    a = mkfxat(0);
   G2063:
    w1 = a;
    q = w6;
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2017;
    q = car(w10);
    a = w3;
    a = Llist2(a, q);
    q = w2;
    a = CC_HbpolbpolTvarvar(a, q);
    goto    G2020;
   G2017:
    a = car(car(cdr(w2)));
    a = Lzerop(a);
    q = w8;
    if(a != nil) goto    G2019;
    a = w2;
    a = CC_Hbpolany(a, q);
    goto    G2020;
   G2019:
    a = cdr(car(cdr(w2)));
    a = CC_Hanyany(a, q);
    q = mkfxat(0);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    a = Llist2(a, q);
   G2020:
    w11 = a;
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G2024;
    a = w11;
    goto    G2025;
   G2024:
    q = w11;
    a = w1;
    a = CC_seLbpolbpolTvarvar(a, q);
   G2025:
    w1 = a;
    if(is_number(a)) goto    G1989;
    q = w3;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1989;
    a = car(cdr(w1));
    w4 = a;
    a = car(a);
    w5 = a;
    goto    G1988;
   G2068:
    a = mkfxat(0);
    w1 = a;
   G1989:
    a = w9;
    a = CC_reduceTbpol(a);
    w9 = a;
    a = w1;
    a = CC_Wncan(a);
    if(a == nil) goto    G2030;
    q = w1;
    a = w9;
    goto    G2067;
   G2030:
    a = w1;
    a = CC_reduceTbpol(a);
    q = w9;
    {
        popv(11);
        return  Lxcons(a, q);
    }
   G1985:
    q = car(w1);
    a = car(w2);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2034;
    q = w1;
    a = mkfxat(0);
    goto    G2067;
   G2034:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = cdr(w1);
    w1 = a;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G2037:
    a = cdr(car(w1));
    w6 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G2039;
    a = nil;
    goto    G2035;
   G2039:
    q = w2;
    a = w6;
    a = CC_Vbpolbpol(a, q);
    w5 = a;
    if(a == nil) goto    G2035;
    q = car(car(w1));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    q = mkfxat(0);
    if(a != nil) goto    G2047;
    a = w3;
    goto    G2067;
   G2047:
    a = car(car(a));
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2037;
    a = cdr(car(w1));
    w6 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G2051;
    q = w6;
    a = w3;
    goto    G2067;
   G2051:
    q = w2;
    a = w6;
    a = CC_VLbpolbpol(a, q);
    w6 = a;
    if(a == nil) goto    G2035;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2057;
    q = car(w6);
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
   G2057:
    q = cdr(w6);
    a = w3;
   G2067:
    a = cons(a, q);
   G2035:
    popv(11);
    return a;
}

Sex CC_psVLbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G2072;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    a = car(w1);
    w3 = a;
    q = value(LL_Hpowser);
    a = Lassoc(a, q);
    if(a != nil) goto    G2076;
    a = car(cdr(w1));
    w10 = a;
    a = car(cdr(w2));
    w8 = a;
    a = car(w10);
    w4 = a;
    w11 = a;
    a = car(w8);
    w5 = a;
    q = a;
    a = w11;
    a = Llessp(a, q);
    if(a == nil) goto    G2081;
    q = w1;
    a = mkfxat(0);
    goto    G2172;
   G2081:
    a = cdr(cdr(w2));
    w9 = a;
    if(a == nil) goto    G2086;
    q = w3;
    a = Lxcons(a, q);
    a = CC_Kbpol(a);
    goto    G2088;
   G2086:
    a = mkfxat(0);
   G2088:
    w2 = a;
    a = cdr(w8);
    w6 = a;
    a = w3;
    a = Lncons(a);
    w9 = a;
    w8 = a;
   G2074:
    q = w5;
    a = w4;
    a = Llessp(a, q);
    if(a != nil) goto    G2075;
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G2092;
    a = cdr(w10);
    goto    G2093;
   G2092:
    q = w6;
    a = cdr(w10);
    a = CC_psVanyany(a, q);
   G2093:
    w7 = a;
    if(a == nil) goto    G2140;
    q = w5;
    a = w4;
    a = diff2(a, q);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(a);
    w9 = a;
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G2102;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G2173;
    a = car(a);
    w10 = a;
    a = car(a);
    w4 = a;
    q = w1;
    a = w3;
    a = cons(a, q);
    w1 = a;
    goto    G2074;
   G2102:
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G2107;
    q = w3;
    a = Lxcons(a, q);
    goto    G2166;
   G2107:
    a = mkfxat(0);
   G2166:
    w1 = a;
    q = w5;
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2110;
    q = car(w9);
    a = w3;
    a = Llist2(a, q);
    q = w2;
    a = CC_psHbpolbpolTvarvar(a, q);
    goto    G2113;
   G2110:
    a = car(car(cdr(w2)));
    a = Lzerop(a);
    q = w7;
    if(a != nil) goto    G2112;
    a = w2;
    a = CC_psHbpolany(a, q);
    goto    G2113;
   G2112:
    a = cdr(car(cdr(w2)));
    a = CC_psHanyany(a, q);
    q = mkfxat(0);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    a = Llist2(a, q);
   G2113:
    w10 = a;
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G2117;
    a = w10;
    goto    G2118;
   G2117:
    q = w10;
    a = w1;
    a = CC_seLbpolbpolTvarvar(a, q);
   G2118:
    w1 = a;
    if(is_number(a)) goto    G2075;
    q = w3;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G2075;
    a = car(cdr(w1));
    w10 = a;
    a = car(a);
    w4 = a;
    goto    G2074;
   G2173:
    a = mkfxat(0);
    w1 = a;
   G2075:
    a = w1;
    if(!is_cons(a)) goto    G2124;
    a = car(a);
    if(is_integer(a)) goto    G2124;
    a = w1;
    a = CC_reduceTbpol(a);
    w1 = a;
   G2124:
    a = w8;
    a = CC_reduceTbpol(a);
    w8 = a;
    q = w1;
    goto    G2172;
   G2076:
    a = w2;
    a = Llast(a);
    a = car(a);
    w5 = a;
    q = a;
    a = car(car(cdr(w1)));
    a = Llessp(a, q);
    if(a == nil) goto    G2128;
    q = w1;
    a = mkfxat(0);
    goto    G2172;
   G2128:
    q = w5;
    a = w1;
    a = CC_pointTtm(a, q);
    w9 = a;
    q = car(car(cdr(a)));
    a = w5;
    a = Lequal(a, q);
    if(a == nil) goto    G2133;
    a = cdr(w9);
    w9 = a;
   G2133:
    a = w9;
    if(a == nil) goto    G2077;
    q = a;
    a = w1;
    a = CC_copyto(a, q);
    w1 = a;
   G2077:
    q = w2;
    a = w1;
    a = CC_psVbpolbpol(a, q);
    w7 = a;
    if(a == nil) goto    G2140;
    q = w9;
    goto    G2172;
   G2072:
    q = car(w1);
    a = car(w2);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2139;
    q = w1;
    a = mkfxat(0);
    goto    G2172;
   G2139:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G2142:
    a = cdr(car(w1));
    w6 = a;
    if(is_number(a)) goto    G2145;
    a = car(a);
    if(is_integer(a)) goto    G2145;
    q = w2;
    a = w6;
    a = CC_psVbpolbpol(a, q);
    w5 = a;
    if(a != nil) goto    G2144;
   G2145:
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
    goto    G2146;
   G2144:
    q = car(car(w1));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G2146:
    a = cdr(w1);
    w1 = a;
    q = mkfxat(0);
    if(a != nil) goto    G2151;
    a = w3;
    goto    G2172;
   G2151:
    a = car(car(a));
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2142;
    a = cdr(car(w1));
    w6 = a;
    if(is_number(a)) goto    G2156;
    a = car(a);
    if(!is_integer(a)) goto    G2155;
   G2156:
    q = w6;
    a = w3;
    goto    G2172;
   G2155:
    q = w2;
    a = w6;
    a = CC_psVLbpolbpol(a, q);
    w6 = a;
    if(a == nil) goto    G2140;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2160;
    q = car(w6);
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
   G2160:
    q = cdr(w6);
    a = w3;
   G2172:
    a = cons(a, q);
   G2140:
    popv(11);
    return a;
}

Sex CC_recipTpol32ratf(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = CC_normlzTpol3(a);
    w2 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a != nil) goto    G2178;
    a = cdr(w2);
    a = CC_recipTbnum(a);
    q = a;
    a = w2;
    cdr(a) = q;
   G2178:
    q = w2;
    a = value(LL_CratfC);
    {
        popv(2);
        return  Llist2(a, q);
    }
}

Sex CC_recipTalgn(Sex a)
{
    Sex q, m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w2 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = cdr(a);
    w1 = a;
    a = car(a);
    w3 = a;
    q = LL_defpoly;
    a = CC_getTcompfn(a, q);
    w2 = a;
    q = mkfxat(2);
    a = car(car(cdr(a)));
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2184;
    a = cdr(w1);
    w1 = a;
    a = cdr(cdr(w2));
    w2 = a;
    a = cdr(car(w1));
    w4 = a;
    a = cdr(w1);
    if(a == nil) goto    G2191;
    a = cdr(car(a));
    goto    G2192;
   G2191:
    a = mkfxat(0);
   G2192:
    w5 = a;
    a = car(car(w2));
    a = Lzerop(a);
    if(a == nil) goto    G2194;
    a = mkfxat(0);
    w6 = a;
    a = cdr(car(w2));
    goto    G2253;
   G2194:
    a = cdr(car(w2));
    w6 = a;
    a = cdr(car(cdr(w2)));
   G2253:
    w7 = a;
    a = w4;
    if(is_number(a)) goto    G2197;
    q = value(LL_CalgnC);
    a = Lxcons(a, q);
    w4 = a;
   G2197:
    a = w5;
    if(is_number(a)) goto    G2199;
    q = value(LL_CalgnC);
    a = Lxcons(a, q);
    w5 = a;
   G2199:
    a = w6;
    if(is_number(a)) goto    G2201;
    q = value(LL_CalgnC);
    a = Lxcons(a, q);
    w6 = a;
   G2201:
    a = w7;
    if(is_number(a)) goto    G2203;
    q = value(LL_CalgnC);
    a = Lxcons(a, q);
    w7 = a;
   G2203:
    a = w6;
    a = Lzerop(a);
    if(a == nil) goto    G2205;
    a = w5;
    goto    G2208;
   G2205:
    a = w5;
    a = Lzerop(a);
    q = w6;
    if(a == nil) goto    G2206;
    a = w4;
    a = CC_Hany0any0(a, q);
    a = CC_Kany(a);
    goto    G2208;
   G2206:
    a = w4;
    a = CC_Hany0any0(a, q);
    a = CC_Kany(a);
    q = a;
    a = w5;
    a = CC_Lanyany(a, q);
   G2208:
    w9 = a;
    q = w4;
    a = q;
    a = CC_Hany0any0(a, q);
    q = w7;
    a = CC_Hany0any0(a, q);
    w8 = a;
    q = w9;
    a = w5;
    a = CC_Hany0any0(a, q);
    q = a;
    a = w8;
    a = CC_Lany0any0(a, q);
    if(!is_number(a)) goto    G2214;
    a = CC_recipTbnum(a);
    goto    G2215;
   G2214:
    a = CC_recipTalgn(a);
   G2215:
    w8 = a;
    q = a;
    a = w4;
    a = CC_Hany0any0(a, q);
    a = CC_Kany(a);
    w4 = a;
    q = w8;
    a = w9;
    a = CC_Hany0any0(a, q);
    w5 = a;
    a = w4;
    if(is_number(a)) goto    G2218;
    a = cdr(a);
    w4 = a;
   G2218:
    a = w5;
    if(is_number(a)) goto    G2220;
    a = cdr(a);
    w5 = a;
   G2220:
    a = Lzerop(a);
    if(a == nil) goto    G2222;
    q = w4;
    a = mkfxat(1);
    a = cons(a, q);
    m = a;
    q = w3;
    a = value(LL_CalgnC);
    {
        popv(10);
        return  Llist3(a, q, m);
    }
   G2222:
    q = w4;
    a = mkfxat(1);
    a = cons(a, q);
    w10 = a;
    q = w5;
    a = mkfxat(0);
    a = cons(a, q);
    arg4 = a;
    m = w10;
    q = w3;
    a = value(LL_CalgnC);
    {
        popv(10);
        return  Llist4(a, q, m, arg4);
    }
   G2184:
    a = mkfxat(0);
    w4 = a;
    q = value(LL_CalgnC);
    a = w2;
    a = CC_putTalgtag(a, q);
    w6 = a;
    a = mkfxat(1);
    w5 = a;
    q = value(LL_CalgnC);
    a = w1;
    a = CC_putTalgtag(a, q);
    w7 = a;
   G2185:
    a = cdr(car(cdr(w7)));
    w9 = a;
    a = Lonep(a);
    if(a != nil) goto    G2186;
    a = w9;
    if(!is_number(a)) goto    G2232;
    a = CC_recipTbnum(a);
    goto    G2233;
   G2232:
    a = CC_recipTalgn(a);
   G2233:
    w8 = a;
    q = a;
    a = w5;
    a = CC_Hanyany(a, q);
    w5 = a;
    q = w8;
    a = w7;
    a = CC_Hbpolany(a, q);
    w7 = a;
   G2186:
    q = w7;
    a = w6;
    a = CC_VLbpolbpol(a, q);
    w9 = a;
    a = car(a);
    w8 = a;
    a = w7;
    w6 = a;
    a = cdr(w9);
    w7 = a;
    a = w4;
    a = Lzerop(a);
    q = w5;
    if(a == nil) goto    G2235;
    a = w8;
    a = CC_Hbpolany(a, q);
    a = CC_Kbpol(a);
    goto    G2237;
   G2235:
    a = w8;
    a = CC_Hbpolany(a, q);
    a = CC_Kbpol(a);
    q = w4;
    a = CC_Lbpolany(a, q);
   G2237:
    w9 = a;
    a = w5;
    w4 = a;
    a = w9;
    w5 = a;
    a = w7;
    if(!is_cons(a)) goto    G2241;
    a = car(a);
    if(a == w3) goto    G2185;
   G2241:
    a = w7;
    if(!is_cons(a)) goto    G2244;
    a = car(a);
    if(a != value(LL_CalgnC)) goto    G2244;
    a = car(cdr(cdr(w7)));
    w9 = a;
    a = car(a);
    a = Lzerop(a);
    if(a == nil) goto    G2244;
    a = cdr(w9);
    w7 = a;
   G2244:
    a = w7;
    if(!is_number(a)) goto    G2249;
    a = CC_recipTbnum(a);
    goto    G2250;
   G2249:
    a = CC_recipTalgn(a);
   G2250:
    w8 = a;
    q = value(LL_CalgnC);
    a = w5;
    a = CC_sedelTalgtag(a, q);
    q = value(LL_CalgnC);
    a = Lxcons(a, q);
    w5 = a;
    q = w8;
    {
        popv(10);
        return  CC_Hpol3any(a, q);
    }
}

Sex CC_recipTratf(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = cdr(cdr(a));
    if(a == nil) goto    G2258;
    a = w1;
    a = CC_collectTratf(a);
    w3 = a;
    if(!is_number(a)) goto    G2260;
    {
        popv(3);
        return  CC_recipTbnum(a);
    }
   G2260:
    a = car(a);
    if(a == value(LL_CratfC)) goto    G2276;
    a = w3;
    {
        popv(3);
        return  CC_recipTcano(a);
    }
   G2276:
    a = w3;
    w1 = a;
   G2258:
    a = car(cdr(w1));
    w3 = a;
    a = cdr(a);
    if(!is_number(a)) goto    G2266;
    q = cdr(w3);
    a = car(w3);
    {
        popv(3);
        return  CC_Vpol3bnum(a, q);
    }
   G2266:
    a = cdr(w3);
    a = CC_normlzTpol3(a);
    w2 = a;
    a = car(w3);
    w3 = a;
    a = cdr(w2);
    a = Lonep(a);
    if(a != nil) goto    G2270;
    q = cdr(w2);
    a = w3;
    a = CC_Vpol3bnum(a, q);
    w3 = a;
   G2270:
    q = w3;
    a = car(w2);
    a = cons(a, q);
    w3 = a;
    q = mkfxat(0);
    a = mkfxat(1);
    a = cons(a, q);
    w2 = a;
    q = a;
    a = w3;
    a = CC_simpTsrat(a, q);
    w3 = a;
    a = cdr(a);
    a = Lzerop(a);
    if(a == nil) goto    G2273;
    a = nil;
    goto    G2274;
   G2273:
    a = w3;
    a = Lncons(a);
   G2274:
    w3 = a;
    q = a;
    a = w2;
    {
        popv(3);
        return  CC_convTirbr2cano(a, q);
    }
}

Sex CC_putTalgtag(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w1 = a;
    a = cdr(a);
    w4 = a;
    w2 = q;
   G2280:
    a = cdr(car(w4));
    w5 = a;
    if(is_number(a)) goto    G2284;
    a = car(a);
    if(!is_integer(a)) goto    G2283;
   G2284:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G2280;
    a = w1;
    goto    G2279;
   G2283:
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G2281:
    a = cdr(car(w1));
    w5 = a;
    if(is_number(a)) goto    G2290;
    a = car(a);
    if(!is_integer(a)) goto    G2289;
   G2290:
    a = car(w1);
    goto    G2300;
   G2289:
    q = w5;
    a = w2;
    a = cons(a, q);
    q = car(car(w1));
    a = Lxcons(a, q);
   G2300:
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2281;
    a = w3;
   G2279:
    popv(5);
    return a;
}

Sex CC_sedelTalgtag(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
   G2304:
    a = cdr(car(w3));
    w4 = a;
    if(!is_cons(a)) goto    G2306;
    a = car(a);
    if(a != w2) goto    G2306;
    q = cdr(w4);
    a = car(w3);
    cdr(a) = q;
   G2306:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G2304;
    a = w1;
    popv(4);
    return a;
}

Sex CC_normlzTpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = CC_Wncoeftype(a);
    w2 = a;
#define LL_AZ LITERAL[21]
    if(a != LL_AZ) goto    G2317;
    q = cdr(w1);
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    w2 = a;
    a = w1;
    a = CC_Alncoef(a);
    a = Lminusp(a);
    if(a == nil) goto    G2322;
    a = w2;
    a = Lminus(a);
    w2 = a;
   G2322:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G2324;
    q = mkfxat(1);
    a = w1;
    goto    G2338;
   G2324:
    q = w2;
    a = w1;
    a = CC_Vpol3bnum(a, q);
    q = w2;
    goto    G2338;
   G2314:
    a = w1;
    a = CC_Alncoef(a);
    w2 = a;
    q = LITERAL[22];
    a = Leqn(a, q);
    if(a == nil) goto    G2329;
    q = mkfxat(1);
    a = w1;
    goto    G2338;
   G2329:
    a = w2;
    a = CC_recipTbnum(a);
    q = w1;
    a = CC_Hbnumpol3(a, q);
    q = w2;
   G2338:
    {
        popv(3);
        return  cons(a, q);
    }
   G2317:
#define LL_AF LITERAL[23]
    if(a == LL_AF) goto    G2314;
    q = cdr(w1);
    a = mkfxat(0);
    a = CC_denlcmTbpol(a, q);
    w3 = a;
    q = w1;
    a = w3;
    a = CC_Hbnumpol3(a, q);
    w1 = a;
    a = CC_normlzTpol3(a);
    w2 = a;
    q = w3;
    a = cdr(a);
    a = Lmkrational(a, q);
    q = a;
    a = w2;
    cdr(a) = q;
    a = w2;
    popv(3);
    return a;
}

Sex CC_collectTratf(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
#define LL_Hcolmode LITERAL[24]
    a = value(LL_Hcolmode);
    w8 = a;
#define LL_stcol LITERAL[25]
    a = LL_stcol;
    value(LL_Hcolmode) = a;
    a = car(car(w2));
    if(!is_cons(a)) goto    G2347;
    q = mkfxat(0);
    a = mkfxat(1);
    a = cons(a, q);
    w3 = a;
    goto    G2348;
   G2347:
    q = cdr(car(w2));
    a = mkfxat(1);
    a = cons(a, q);
    w3 = a;
    a = cdr(w2);
    w2 = a;
   G2348:
    a = car(w2);
    w7 = a;
    a = car(a);
    w4 = a;
    a = cdr(w7);
    w5 = a;
   G2343:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G2350;
    a = car(a);
    w7 = a;
    goto    G2353;
   G2350:
    a = cdr(w3);
    a = Lzerop(a);
    if(a != nil) goto    G2345;
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G2371;
    a = w3;
    w7 = a;
    a = Lncons(a);
    w2 = a;
    q = mkfxat(0);
    a = mkfxat(1);
    a = cons(a, q);
    w3 = a;
   G2353:
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G2361;
    a = car(w7);
    a = Lonep(a);
    if(a != nil) goto    G2361;
    q = car(w7);
    a = w4;
    a = CC_testTmultpl(a, q);
    w6 = a;
    if(a == nil) goto    G2361;
    a = cdr(a);
    if(a != nil) goto    G2358;
    a = w4;
    w4 = a;
    q = cdr(w7);
    a = car(w6);
    a = CC_psHanyany(a, q);
    w6 = a;
    goto    G2376;
   G2358:
    a = car(w7);
    w4 = a;
    q = w5;
    a = cdr(w6);
    a = CC_psHanyany(a, q);
    w6 = a;
    a = cdr(w7);
    w5 = a;
    a = w6;
   G2376:
    a = Lzerop(a);
    if(a != nil) goto    G2344;
    q = w6;
    a = w5;
    a = CC_Lanyany(a, q);
    w5 = a;
    goto    G2344;
   G2361:
    q = w5;
    a = car(w7);
    a = CC_psHanyany(a, q);
    w5 = a;
    q = w4;
    a = cdr(w7);
    a = CC_psHanyany(a, q);
    w6 = a;
    q = w4;
    a = car(w7);
    a = CC_psHanyany(a, q);
    w4 = a;
    a = w6;
    a = Lzerop(a);
    if(a == nil) goto    G2365;
    a = w5;
    goto    G2367;
   G2365:
    a = w5;
    a = Lzerop(a);
    if(a == nil) goto    G2366;
    a = w6;
    goto    G2367;
   G2366:
    q = w6;
    a = w5;
    a = CC_Lanyany(a, q);
   G2367:
    w5 = a;
   G2344:
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G2377;
    q = w5;
    a = w4;
    a = cons(a, q);
    q = w3;
    a = CC_simpTsrat(a, q);
    w7 = a;
    a = car(a);
    w4 = a;
    a = cdr(w7);
    w5 = a;
    goto    G2343;
   G2377:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G2348;
   G2371:
    a = w3;
    w7 = a;
   G2345:
    a = w8;
    value(LL_Hcolmode) = a;
    a = w7;
    {
        popv(8);
        return  CC_convTsrat2cano(a);
    }
}

Sex CC_simpTsrat(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = cdr(a);
    a = Lzerop(a);
    if(a != nil) goto    G2424;
    a = car(w1);
    a = Lonep(a);
    if(a == nil) goto    G2382;
    q = w2;
    a = cdr(w1);
    CC_seLnpolirat(a, q);
    goto    G2424;
   G2382:
    a = cdr(w1);
    if(is_number(a)) goto    G2425;
    w3 = nil;
    w4 = nil;
    w5 = nil;
#define LL_Hsimpratf LITERAL[26]
    a = value(LL_Hsimpratf);
    q = cdr(w1);
    if(a != nil) goto    G2386;
    a = car(w1);
    a = CC_testTmultpl(a, q);
    w3 = a;
    if(a == nil) goto    G2387;
    a = car(a);
    if(a != nil) goto    G2394;
    q = w2;
    a = cdr(w3);
    goto    G2426;
   G2394:
    w3 = a;
    if(!is_number(a)) goto    G2395;
    a = CC_recipTbnum(a);
    q = w2;
   G2426:
    CC_seLnpolirat(a, q);
    q = mkfxat(0);
    a = mkfxat(1);
    a = cons(a, q);
    w3 = a;
    goto    G2400;
   G2395:
    a = CC_normlzTpol3(a);
    w3 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a != nil) goto    G2400;
    a = cdr(w3);
    a = CC_recipTbnum(a);
    q = a;
    a = w3;
    cdr(a) = q;
   G2400:
    a = w3;
    goto    G2384;
   G2386:
    a = car(w1);
    a = CC_gcdTpol3pol3(a, q);
    w4 = a;
    if(is_number(a)) goto    G2410;
    a = true;
    w5 = a;
    q = w4;
    a = car(w1);
    a = CC_Vpol3pol3(a, q);
    w3 = a;
    q = w4;
    a = cdr(w1);
    a = CC_Vpol3pol3(a, q);
    goto    G2427;
   G2387:
    a = car(w1);
    a = CC_Amonocont(a);
    w4 = a;
    if(is_number(a)) goto    G2410;
    a = cdr(w1);
    a = CC_Amonocont(a);
    w3 = a;
    if(is_number(a)) goto    G2410;
    q = a;
    a = w4;
    a = CC_gcdTmon3mon3(a, q);
    w4 = a;
    if(is_number(a)) goto    G2410;
    a = true;
    w5 = a;
    q = w4;
    a = car(w1);
    a = CC_Vpol3mon3(a, q);
    w3 = a;
    q = w4;
    a = cdr(w1);
    a = CC_Vpol3mon3(a, q);
   G2427:
    q = w3;
    a = Lxcons(a, q);
    w1 = a;
   G2410:
#define LL_stdiv LITERAL[27]
    q = LL_stdiv;
#define LL_Hdivmode LITERAL[28]
    a = value(LL_Hdivmode);
    a = Lneq(a, q);
    if(a != nil) goto    G2389;
    a = value(LL_Hcolmode);
    if(a == LL_stcol) goto    G2389;
    a = car(w1);
    if(is_number(a)) goto    G2389;
    a = cdr(w1);
    if(is_number(a)) goto    G2389;
    q = car(w1);
    a = CC_VLpol3pol3(a, q);
    w4 = a;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2389;
    q = w2;
    a = car(w4);
    CC_seLnpolirat(a, q);
    q = cdr(w4);
    a = car(w1);
    a = cons(a, q);
    w1 = a;
    a = true;
    w5 = a;
   G2389:
    a = w5;
    if(a != nil) goto    G2418;
   G2425:
    a = w1;
    goto    G2384;
   G2418:
    a = w1;
    a = CC_normlzTsrat(a);
    w4 = a;
    a = car(a);
    if(!is_cons(a)) goto    G2419;
    a = w4;
    goto    G2384;
   G2419:
    q = w2;
    a = cdr(w4);
    CC_seLnpolirat(a, q);
   G2424:
    q = mkfxat(0);
    a = mkfxat(1);
    a = cons(a, q);
   G2384:
    popv(5);
    return a;
}

Sex CC_normlzTratf(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    a = car(car(a));
    a = Lonep(a);
    if(a == nil) goto    G2432;
    a = cdr(w3);
    w3 = a;
   G2432:
    a = cdr(car(w3));
    w2 = a;
    if(is_number(a)) goto    G2434;
    a = CC_normlzTpol3(a);
    a = cdr(a);
    w2 = a;
   G2434:
    a = Lonep(a);
    if(a == nil) goto    G2437;
    q = mkfxat(1);
    a = w1;
    goto    G2445;
   G2437:
    a = w2;
    if(!is_integer(a)) goto    G2438;
    q = a;
    a = w1;
    a = CC_Vratfbnum(a, q);
    q = w2;
    goto    G2445;
   G2438:
    a = CC_recipTbnum(a);
    q = w1;
    a = CC_Hbnumratf(a, q);
    q = w2;
   G2445:
    {
        popv(3);
        return  cons(a, q);
    }
}

Sex CC_Lbnumratf(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G2449;
    a = w2;
    goto    G2461;
   G2449:
    a = cdr(w2);
    w2 = a;
    a = cdr(a);
    if(a != nil) goto    G2451;
    q = LL_stcol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2450;
   G2451:
    a = car(car(w2));
    if(!is_cons(a)) goto    G2454;
    q = w1;
    a = mkfxat(1);
    a = cons(a, q);
    q = w2;
    goto    G2465;
   G2454:
    q = cdr(car(w2));
    a = w1;
    a = CC_Lbnumany(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2456;
    a = cdr(w2);
    goto    G2458;
   G2456:
    q = w1;
    a = mkfxat(1);
    a = cons(a, q);
    q = cdr(w2);
   G2465:
    a = cons(a, q);
   G2458:
    q = value(LL_CratfC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G2450:
    q = w1;
    a = mkfxat(1);
    a = cons(a, q);
    q = w2;
    a = cons(a, q);
    q = value(LL_CratfC);
    a = Lxcons(a, q);
    a = CC_collectTratf(a);
   G2461:
    popv(2);
    return a;
}

Sex CC_Lpol3ratf(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = cdr(q);
    w2 = a;
    a = cdr(a);
    if(a != nil) goto    G2470;
    q = LL_stcol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2469;
   G2470:
    a = car(car(w2));
    if(!is_cons(a)) goto    G2473;
    q = w1;
    a = mkfxat(1);
    a = cons(a, q);
    q = w2;
    goto    G2484;
   G2473:
    q = cdr(car(w2));
    a = w1;
    a = CC_Lpol3any(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2475;
    a = cdr(w2);
    goto    G2477;
   G2475:
    q = w1;
    a = mkfxat(1);
    a = cons(a, q);
    q = cdr(w2);
   G2484:
    a = cons(a, q);
   G2477:
    q = value(LL_CratfC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G2469:
    q = w1;
    a = mkfxat(1);
    a = cons(a, q);
    q = w2;
    a = cons(a, q);
    q = value(LL_CratfC);
    a = Lxcons(a, q);
    {
        popv(2);
        return  CC_collectTratf(a);
    }
}

Sex CC_Lratfratf(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w3 = nil;
    w4 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w1 = a;
    a = cdr(a);
    w5 = a;
    a = cdr(q);
    w6 = a;
    w2 = q;
    a = value(LL_Hcolmode);
    if(a != LL_stcol) goto    G2493;
    a = cdr(w5);
    if(a != nil) goto    G2493;
    a = cdr(w6);
    if(a != nil) goto    G2493;
    q = w6;
    a = car(w5);
    a = cons(a, q);
    q = value(LL_CratfC);
    a = Lxcons(a, q);
    {
        popv(10);
        return  CC_collectTratf(a);
    }
   G2493:
    a = car(car(w5));
    if(!is_cons(a)) goto    G2499;
    a = car(car(w6));
    if(!is_cons(a)) goto    G2501;
    q = mkfxat(0);
    a = mkfxat(1);
    a = cons(a, q);
    w7 = a;
    goto    G2504;
   G2501:
    q = cdr(car(w6));
    a = mkfxat(1);
    a = cons(a, q);
    w7 = a;
    goto    G2531;
   G2499:
    a = car(car(w6));
    if(!is_cons(a)) goto    G2503;
    q = cdr(car(w5));
    a = mkfxat(1);
    a = cons(a, q);
    w7 = a;
    a = cdr(w5);
    w5 = a;
    goto    G2504;
   G2503:
    q = cdr(car(w6));
    a = cdr(car(w5));
    a = CC_Lanyany(a, q);
    q = mkfxat(1);
    a = Lxcons(a, q);
    w7 = a;
    a = cdr(w5);
    w5 = a;
   G2531:
    a = cdr(w6);
    w6 = a;
   G2504:
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = car(car(w5));
    w8 = a;
    a = car(car(w6));
    w9 = a;
   G2488:
    q = w9;
    a = w8;
    a = Lequal(a, q);
    if(a != nil) goto    G2489;
    q = w9;
    a = w8;
    a = CC_Worder(a, q);
    m = w7;
    q = w4;
    if(a == nil) goto    G2508;
    a = car(w5);
    a = CC_seLsratbrat(a, q, m);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G2490;
    a = car(car(a));
    w8 = a;
    goto    G2488;
   G2508:
    a = car(w6);
    a = CC_seLsratbrat(a, q, m);
    w4 = a;
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G2532;
    a = car(car(a));
    goto    G2533;
   G2489:
    q = cdr(car(w6));
    a = cdr(car(w5));
    a = CC_Lanyany(a, q);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2519;
    q = w10;
    a = w8;
    a = cons(a, q);
    q = w7;
    a = CC_simpTsrat(a, q);
    w10 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G2517;
    q = w7;
    a = cdr(w10);
    CC_seLnpolirat(a, q);
    goto    G2519;
   G2517:
    m = w7;
    q = w4;
    a = w10;
    CC_seLsratbrat(a, q, m);
   G2519:
    a = cdr(w5);
    w5 = a;
    a = cdr(w6);
    w6 = a;
    a = w5;
    if(a != nil) goto    G2521;
    a = w6;
    if(a != nil) goto    G2490;
    goto    G2529;
   G2521:
    a = w6;
    if(a == nil) goto    G2532;
    a = car(car(w5));
    w8 = a;
    a = car(car(w6));
   G2533:
    w9 = a;
    goto    G2488;
   G2532:
    a = w5;
    w6 = a;
   G2490:
    a = cdr(w4);
    if(a != nil) goto    G2527;
    q = w6;
    a = w4;
    cdr(a) = q;
    goto    G2529;
   G2527:
    m = w7;
    q = w4;
    a = car(w6);
    a = CC_seLsratbrat(a, q, m);
    w4 = a;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G2490;
   G2529:
    q = cdr(w3);
    a = w7;
    {
        popv(10);
        return  CC_convTirbr2cano(a, q);
    }
}

Sex CC_Hbnumratf(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G2537;
    a = mkfxat(0);
    goto    G2538;
   G2537:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = value(LL_CratfC);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w5 = a;
   G2540:
    q = cdr(car(w5));
    a = w1;
    a = CC_Hbnumany(a, q);
    q = car(car(w5));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G2540;
    a = w3;
   G2538:
    popv(5);
    return a;
}

Sex CC_Hpol3ratf(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w5 = a;
    a = car(car(a));
    if(!is_cons(a)) goto    G2552;
    q = mkfxat(0);
    a = mkfxat(1);
    a = cons(a, q);
    w6 = a;
    goto    G2553;
   G2552:
    q = cdr(car(w5));
    a = w1;
    a = CC_psHpol3any(a, q);
    q = mkfxat(1);
    a = Lxcons(a, q);
    w6 = a;
    a = cdr(w5);
    w5 = a;
   G2553:
    m = w6;
    q = car(w5);
    a = w1;
    a = CC_Hpol3srat(a, q, m);
    w7 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G2556;
    q = w6;
    a = cdr(w7);
    CC_seLnpolirat(a, q);
    goto    G2559;
   G2556:
    a = w4;
    if(a == w3) goto    G2558;
    q = car(car(a));
    a = car(w7);
    a = CC_Worder(a, q);
    if(a != nil) goto    G2557;
   G2558:
    m = w6;
    q = w4;
    goto    G2563;
   G2557:
    m = w6;
    q = w3;
   G2563:
    a = w7;
    a = CC_seLsratbrat(a, q, m);
    w4 = a;
   G2559:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G2553;
    q = cdr(w3);
    a = w6;
    {
        popv(7);
        return  CC_convTirbr2cano(a, q);
    }
}

Sex CC_Hratfratf(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    a = cdr(w1);
    w5 = a;
    a = cdr(w2);
    w6 = a;
    q = mkfxat(0);
    a = mkfxat(1);
    a = cons(a, q);
    w7 = a;
    a = car(car(w5));
    if(is_cons(a)) goto    G2597;
    a = car(car(w6));
    if(is_cons(a)) goto    G2579;
    q = cdr(car(w6));
    a = cdr(car(w5));
    a = CC_psHanyany(a, q);
    q = a;
    a = w7;
    cdr(a) = q;
    m = w7;
    q = cdr(w6);
    a = car(w5);
    a = CC_Hiratbrat(a, q, m);
    w4 = a;
    w3 = a;
    a = cdr(w5);
    w5 = a;
    m = w7;
    q = a;
    a = car(w6);
    a = CC_Hiratbrat(a, q, m);
    w9 = a;
    a = cdr(w6);
    w6 = a;
   G2568:
    a = cdr(w9);
    w9 = a;
    if(a == nil) goto    G2569;
    m = w7;
    q = w4;
    a = car(a);
    a = CC_seLsratbrat(a, q, m);
    w4 = a;
    goto    G2568;
   G2597:
    a = car(car(w6));
    if(is_cons(a)) goto    G2569;
    a = w5;
    w11 = a;
    a = w6;
    w5 = a;
    a = w11;
    w6 = a;
   G2579:
    m = w7;
    q = w6;
    a = car(w5);
    a = CC_Hiratbrat(a, q, m);
    w3 = a;
    a = cdr(w5);
    w5 = a;
   G2569:
    a = w3;
    w4 = a;
    a = car(w5);
    w8 = a;
    a = w6;
    w9 = a;
   G2570:
    m = w7;
    q = car(w9);
    a = w8;
    a = CC_Hsratsrat(a, q, m);
    w10 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G2585;
    q = w7;
    a = cdr(w10);
    CC_seLnpolirat(a, q);
    goto    G2589;
   G2585:
    a = w4;
    if(a == w3) goto    G2587;
    q = car(car(a));
    a = car(w10);
    a = CC_orderRMS(a, q);
    w11 = a;
    if(a != CHAR_OF(60)) goto    G2586;
   G2587:
    m = w7;
    q = w4;
    goto    G2596;
   G2586:
    if(a != CHAR_OF(62)) goto    G2588;
    m = w7;
    q = w3;
    goto    G2596;
   G2588:
    q = w4;
    a = w3;
    a = CC_before(a, q);
    m = w7;
    q = a;
   G2596:
    a = w10;
    a = CC_seLsratbrat(a, q, m);
    w4 = a;
   G2589:
    a = cdr(w9);
    w9 = a;
    if(a != nil) goto    G2570;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G2569;
    q = cdr(w3);
    a = w7;
    {
        popv(11);
        return  CC_convTirbr2cano(a, q);
    }
}

Sex CC_Vratfbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G2601;
    q = nil;
    a = mkfxat(7);
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G2601:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = value(LL_CratfC);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w5 = a;
   G2604:
    q = w2;
    a = cdr(car(w5));
    a = CC_Vanybnum(a, q);
    q = car(car(w5));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G2604;
    a = w3;
    popv(5);
    return a;
}

Sex CC_Vratfpol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = value(LL_CratfC);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w5 = a;
   G2614:
    q = w2;
    a = cdr(car(w5));
    a = CC_psVanypol3(a, q);
    w6 = a;
    if(a == nil) goto    G2613;
    q = car(car(w5));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G2614;
    a = w3;
   G2613:
    popv(6);
    return a;
}

Sex CC_gcdTmon3mon3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = (Sex)((long)a - (long)q + TAG_FIXNUM);
    value(LL_Htemporal) = a;
    a = Lzerop(a);
    if(a == nil) goto    G2626;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = car(w1);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
   G2629:
    q = car(w2);
    a = car(w1);
    a = Lequal(a, q);
    if(a != nil) goto    G2642;
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G2683;
    a = cdr(car(cdr(w2)));
    w2 = a;
    if(!is_number(a)) goto    G2648;
    goto    G2676;
   G2642:
    q = car(car(cdr(w2)));
    a = car(car(cdr(w1)));
    a = Lmin2(a, q);
    a = Lncons(a);
    w6 = a;
    q = a;
    a = car(w1);
    a = Llist2(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = w6;
    w5 = a;
    a = cdr(car(cdr(w1)));
    w1 = a;
    a = cdr(car(cdr(w2)));
    w2 = a;
    a = w1;
    if(is_number(a)) goto    G2650;
    a = car(a);
    if(is_integer(a)) goto    G2631;
    a = w2;
    if(is_number(a)) goto    G2676;
   G2648:
    a = car(a);
    if(!is_integer(a)) goto    G2629;
    a = w1;
    w6 = a;
    a = w2;
    w1 = a;
    a = w6;
    goto    G2677;
   G2650:
    a = w2;
    if(is_number(a)) goto    G2654;
    a = car(a);
    if(!is_integer(a)) goto    G2653;
    a = w2;
    goto    G2678;
   G2653:
    q = w2;
    a = value(LL_CpolyC);
    a = cons(a, q);
   G2678:
    a = CC_Alncoef(a);
    w2 = a;
   G2654:
    q = w2;
    a = w1;
    a = CC_gcdTbnumbnum(a, q);
    goto    G2679;
   G2683:
    a = cdr(car(cdr(w1)));
    w1 = a;
    if(is_number(a)) goto    G2650;
    a = car(a);
    if(!is_integer(a)) goto    G2629;
   G2631:
    a = w2;
    if(!is_number(a)) goto    G2658;
   G2676:
    a = w1;
    w6 = a;
    a = w2;
    w1 = a;
    a = w6;
    w2 = a;
    goto    G2650;
   G2658:
    a = car(a);
    q = w2;
    if(is_integer(a)) goto    G2682;
    a = value(LL_CpolyC);
    a = cons(a, q);
    a = CC_Alowfactor(a);
   G2677:
    w2 = a;
    goto    G2631;
   G2682:
    a = w1;
    a = CC_gcdTmon3mon3(a, q);
   G2679:
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(w4);
    w6 = a;
    if(is_number(a)) goto    G2673;
    if(is_integer(a)) goto    G2673;
    q = w3;
    {
        popv(6);
        return  Lxcons(a, q);
    }
   G2626:
    a = value(LL_Htemporal);
    a = Lminusp(a);
    if(a == nil) goto    G2668;
    a = w2;
    a = CC_Alowfactor(a);
    w2 = a;
    if(!is_number(a)) goto    G2670;
    q = w1;
    goto    G2680;
   G2670:
    q = a;
    a = w1;
    goto    G2681;
   G2668:
    a = w1;
    a = CC_Alowfactor(a);
    if(!is_number(a)) goto    G2672;
    q = a;
    a = w2;
   G2680:
    {
        popv(6);
        return  CC_gcdTanyany(a, q);
    }
   G2672:
    q = w2;
   G2681:
    a = CC_gcdTmon3mon3(a, q);
   G2673:
    popv(6);
    return a;
}

Sex CC_Vpol3mon3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = (Sex)((long)a - (long)q + TAG_FIXNUM);
    value(LL_Htemporal) = a;
    a = Lzerop(a);
    if(a == nil) goto    G2687;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_Vbpolbmon(a, q);
    w1 = a;
    if(is_number(a)) goto    G2691;
    a = car(a);
    if(!is_integer(a)) goto    G2690;
   G2691:
    a = w1;
    goto    G2694;
   G2690:
    q = w1;
    a = car(w2);
    {
        popv(2);
        return  cons(a, q);
    }
   G2687:
    a = value(LL_Htemporal);
    a = Lminusp(a);
    if(a == nil) goto    G2693;
    q = nil;
    a = mkfxat(7);
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G2693:
    q = w2;
    a = cdr(w1);
    a = CC_Vbpolpol3(a, q);
    q = car(w1);
    a = Lxcons(a, q);
   G2694:
    popv(2);
    return a;
}

Sex CC_Vbpolbmon(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G2699;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = car(cdr(w2));
    w4 = a;
    a = car(a);
    w5 = a;
    a = cdr(w4);
    w6 = a;
    a = cdr(w1);
    w3 = a;
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w1 = a;
    a = w6;
    if(is_number(a)) goto    G2758;
    a = car(a);
    if(is_integer(a)) goto    G2704;
   G2711:
    q = w5;
    a = car(car(w3));
    a = diff2(a, q);
    w7 = a;
    q = w6;
    a = cdr(car(w3));
    a = CC_Vbpolbmon(a, q);
    q = w7;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G2741;
    goto    G2711;
   G2758:
    a = Lonep(a);
    if(a == nil) goto    G2703;
   G2702:
    q = w5;
    a = car(car(w3));
    a = diff2(a, q);
    q = cdr(car(w3));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G2741;
    goto    G2702;
   G2703:
    q = w5;
    a = car(car(w3));
    a = diff2(a, q);
    w7 = a;
    q = w6;
    a = cdr(car(w3));
    a = CC_Vanybnum(a, q);
    q = w7;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G2741;
    goto    G2703;
   G2704:
    q = w5;
    a = car(car(w3));
    a = diff2(a, q);
    w7 = a;
    q = w6;
    a = cdr(car(w3));
    a = CC_Vanypol3(a, q);
    q = w7;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G2704;
   G2741:
    a = w1;
    {
        popv(7);
        return  CC_reduceTbpol(a);
    }
   G2699:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(w1);
    w3 = a;
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w1 = a;
   G2745:
    a = cdr(car(w3));
    w5 = a;
    if(is_number(a)) goto    G2748;
    a = car(a);
    if(!is_integer(a)) goto    G2747;
   G2748:
    q = nil;
    a = mkfxat(7);
    CC_errormsg(a, q);
   G2747:
    q = w2;
    a = w5;
    a = CC_Vbpolbmon(a, q);
    q = car(car(w3));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G2745;
    a = w1;
    popv(7);
    return a;
}

Sex CC_convTsrat2cano(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    a = Lzerop(a);
    if(a == nil) goto    G2762;
    a = mkfxat(0);
    goto    G2764;
   G2762:
    a = car(w1);
    a = Lonep(a);
    if(a == nil) goto    G2763;
    a = cdr(w1);
    goto    G2764;
   G2763:
    q = w1;
    a = value(LL_CratfC);
    a = Llist2(a, q);
   G2764:
    popv(1);
    return a;
}

Sex CC_convTirbr2cano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    if(a != nil) goto    G2768;
    a = w1;
    {
        popv(2);
        return  CC_convTsrat2cano(a);
    }
   G2768:
    w2 = q;
    a = cdr(w1);
    a = Lzerop(a);
    if(a == nil) goto    G2771;
    a = w2;
    goto    G2772;
   G2771:
    q = w2;
    a = w1;
    a = cons(a, q);
   G2772:
    q = value(LL_CratfC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_normlzTsrat(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    if(!is_number(a)) goto    G2777;
    a = Lonep(a);
    if(a != nil) goto    G2787;
    q = car(w1);
    a = cdr(w1);
    a = CC_Vanybnum(a, q);
    q = mkfxat(1);
    goto    G2788;
   G2777:
    a = CC_normlzTpol3(a);
    value(LL_Htemporal) = a;
    a = cdr(a);
    a = Lonep(a);
    if(a == nil) goto    G2782;
   G2787:
    a = w1;
    goto    G2785;
   G2782:
    q = cdr(value(LL_Htemporal));
    a = cdr(w1);
    a = CC_Vanybnum(a, q);
    q = car(value(LL_Htemporal));
   G2788:
    a = Lxcons(a, q);
   G2785:
    popv(1);
    return a;
}

Sex CC_testTmultpl(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    if(a == car(q)) goto    G2797;
    q = car(q);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2796;
    q = w2;
    a = cdr(w1);
    a = CC_Vbpolpol3(a, q);
    goto    G2817;
   G2796:
    q = w1;
    a = cdr(w2);
    a = CC_Vbpolpol3(a, q);
    goto    G2818;
   G2797:
    a = cdr(w1);
    w3 = a;
    a = cdr(w2);
    w4 = a;
    q = car(a);
    a = car(w3);
    a = Lequal(a, q);
    if(a == nil) goto    G2799;
    q = car(car(cdr(w4)));
    a = car(car(cdr(w3)));
    a = Lgeq(a, q);
    if(a == nil) goto    G2801;
    q = w4;
    a = w3;
    a = CC_Vbpolbpol(a, q);
    goto    G2817;
   G2801:
    q = w3;
    a = w4;
    a = CC_Vbpolbpol(a, q);
    goto    G2818;
   G2799:
    q = car(w4);
    a = car(w3);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2803;
    q = w4;
    a = w3;
    a = CC_Vbpolbpol(a, q);
   G2817:
    w5 = a;
    goto    G2804;
   G2803:
    q = w3;
    a = w4;
    a = CC_Vbpolbpol(a, q);
   G2818:
    w5 = a;
    goto    G2793;
    a = w5;
   G2804:
    if(a == nil) goto    G2791;
    if(!is_cons(a)) goto    G2807;
    a = car(a);
    if(is_integer(a)) goto    G2807;
    q = w5;
    a = car(w1);
    a = cons(a, q);
    w5 = a;
   G2807:
    a = w5;
    {
        popv(5);
        return  Lncons(a);
    }
    a = w5;
   G2793:
    if(a == nil) goto    G2791;
    if(!is_cons(a)) goto    G2812;
    a = car(a);
    if(is_integer(a)) goto    G2812;
    q = w5;
    a = car(w2);
    a = cons(a, q);
    w5 = a;
   G2812:
    q = w5;
    a = nil;
    a = cons(a, q);
   G2791:
    popv(5);
    return a;
}

Sex CC_seLnpolirat(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G2822;
    a = w2;
    goto    G2824;
   G2822:
    a = cdr(w2);
    a = Lzerop(a);
    if(a == nil) goto    G2823;
    q = w1;
    goto    G2826;
   G2823:
    q = cdr(w2);
    a = w1;
    a = CC_Lanyany(a, q);
    q = a;
   G2826:
    a = w2;
    cdr(a) = q;
   G2824:
    popv(2);
    return a;
}

Sex CC_seLsratbrat(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
   G2830:
    a = cdr(w2);
    if(a != nil) goto    G2832;
    a = w1;
    a = Lncons(a);
    goto    G2850;
   G2832:
    a = car(a);
    w4 = a;
    a = car(a);
    q = a;
    a = car(w1);
    a = CC_orderRMS(a, q);
    w5 = a;
    if(a != CHAR_OF(60)) goto    G2836;
    a = cdr(w2);
    w2 = a;
    goto    G2830;
   G2836:
    if(a != CHAR_OF(62)) goto    G2839;
    q = cdr(w2);
    a = w1;
    a = cons(a, q);
   G2850:
    q = a;
    a = w2;
    cdr(a) = q;
    {
        popv(5);
        return cdr(a);
    }
   G2839:
    q = cdr(w4);
    a = cdr(w1);
    a = CC_Lanyany(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2844;
    q = cdr(cdr(w2));
    a = w2;
    {
        popv(5);
        cdr(a) = q;
 return a;
    }
   G2844:
    q = w5;
    a = car(w4);
    a = cons(a, q);
    w5 = a;
    q = w3;
    a = CC_simpTsrat(a, q);
    w4 = a;
    q = a;
    a = w5;
    a = Leq(a, q);
    if(a == nil) goto    G2846;
    q = w5;
    a = cdr(w2);
    {
        popv(5);
        car(a) = q;
 return a;
    }
   G2846:
    q = cdr(cdr(w2));
    a = w2;
    cdr(a) = q;
    a = car(w4);
    a = Lonep(a);
    if(a == nil) goto    G2848;
    q = w3;
    a = cdr(w4);
    CC_seLnpolirat(a, q);
    goto    G2849;
   G2848:
    m = w3;
    q = w2;
    a = w4;
    CC_seLsratbrat(a, q, m);
   G2849:
    a = w2;
    popv(5);
    return a;
}

Sex CC_Hpol3srat(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = car(q);
    a = CC_testTmultpl(a, q);
    w4 = a;
    if(a != nil) goto    G2855;
    q = cdr(w2);
    a = w1;
    a = CC_psHpol3any(a, q);
    w4 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2870;
    q = w4;
    a = car(w2);
    a = cons(a, q);
    q = w3;
    goto    G2869;
   G2855:
    a = cdr(a);
    if(a != nil) goto    G2860;
    q = cdr(w2);
    a = car(w4);
    a = CC_psHanyany(a, q);
    w4 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2870;
    q = w3;
    a = w4;
    CC_seLnpolirat(a, q);
    goto    G2870;
   G2860:
    w4 = a;
    if(!is_number(a)) goto    G2863;
    q = a;
    a = cdr(w2);
    a = CC_Vanybnum(a, q);
    w4 = a;
    q = w3;
    CC_seLnpolirat(a, q);
   G2870:
    q = mkfxat(0);
    a = mkfxat(1);
    {
        popv(4);
        return  cons(a, q);
    }
   G2863:
    a = CC_normlzTpol3(a);
    w4 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a == nil) goto    G2864;
    q = cdr(w2);
    a = w4;
    {
        popv(4);
        cdr(a) = q;
 return a;
    }
   G2864:
    q = cdr(w4);
    a = cdr(w2);
    a = CC_Vanybnum(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    q = w3;
    a = w4;
   G2869:
    {
        popv(4);
        return  CC_simpTsrat(a, q);
    }
}

Sex CC_Hsratsrat(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = cdr(a);
    if(is_number(a)) goto    G2877;
    q = car(q);
    a = CC_testTmultpl(a, q);
    w5 = a;
    if(a == nil) goto    G2877;
    a = true;
    w6 = a;
    a = car(w5);
    if(a == nil) goto    G2879;
    q = car(w1);
    a = Lxcons(a, q);
    w1 = a;
    q = cdr(w2);
    a = mkfxat(1);
    goto    G2894;
   G2879:
    q = mkfxat(1);
    a = car(w1);
    a = cons(a, q);
    w1 = a;
    q = cdr(w2);
    a = cdr(w5);
   G2894:
    a = cons(a, q);
    w2 = a;
   G2877:
    a = cdr(w2);
    if(is_number(a)) goto    G2883;
    q = car(w1);
    a = CC_testTmultpl(a, q);
    w5 = a;
    if(a == nil) goto    G2883;
    a = true;
    w6 = a;
    a = car(w5);
    if(a == nil) goto    G2885;
    q = car(w2);
    a = Lxcons(a, q);
    w2 = a;
    q = cdr(w1);
    a = mkfxat(1);
    goto    G2895;
   G2885:
    q = mkfxat(1);
    a = car(w2);
    a = cons(a, q);
    w2 = a;
    q = cdr(w1);
    a = cdr(w5);
   G2895:
    a = cons(a, q);
    w1 = a;
   G2883:
    q = car(w2);
    a = car(w1);
    a = CC_psHanyany(a, q);
    w4 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2874;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_psHanyany(a, q);
    w5 = a;
    a = w6;
    q = w5;
    if(a == nil) goto    G2890;
    a = w4;
    a = cons(a, q);
    a = CC_normlzTsrat(a);
    goto    G2892;
   G2890:
    a = w4;
    a = cons(a, q);
   G2892:
    w5 = a;
    q = w3;
    {
        popv(6);
        return  CC_simpTsrat(a, q);
    }
   G2874:
    a = LITERAL[29];
    w5 = a;
    q = nil;
    CC_errormsg(a, q);
    a = nil;
    popv(6);
    return a;
}

Sex CC_Hiratbrat(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    a = cdr(a);
    w2 = q;
    w3 = m;
    if(!is_number(a)) goto    G2899;
    a = value(LL_CratfC);
    a = cons(a, q);
    q = a;
    a = cdr(w1);
    a = CC_Hbnumratf(a, q);
    q = CHAR_OF(104);
    {
        popv(8);
        car(a) = q;
 return a;
    }
   G2899:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w1);
    w7 = a;
    a = w2;
    w6 = a;
   G2904:
    m = w3;
    q = car(w6);
    a = w7;
    a = CC_Hpol3srat(a, q, m);
    w8 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G2906;
    q = w3;
    a = cdr(w8);
    CC_seLnpolirat(a, q);
    goto    G2909;
   G2906:
    a = w5;
    if(a == w4) goto    G2908;
    q = car(car(a));
    a = car(w8);
    a = CC_Worder(a, q);
    if(a != nil) goto    G2907;
   G2908:
    m = w3;
    q = w5;
    goto    G2912;
   G2907:
    m = w3;
    q = w4;
   G2912:
    a = w8;
    a = CC_seLsratbrat(a, q, m);
    w5 = a;
   G2909:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G2904;
    a = w4;
    popv(8);
    return a;
}

Sex CC_denlcmTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
   G2916:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G2918;
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G2920;
    a = mkfxat(1);
    goto    G2915;
   G2918:
    a = cdr(car(a));
    w3 = a;
    if(!is_number(a)) goto    G2923;
    if(!is_rational(a)) goto    G2916;
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G2926;
    a = w3;
    a = Lden(a);
    goto    G2935;
   G2926:
    a = w3;
    a = Lden(a);
    q = a;
    a = w1;
    a = Llcm(a, q);
    goto    G2935;
   G2923:
    a = car(a);
    if(!is_integer(a)) goto    G2931;
    a = cdr(w3);
    goto    G2932;
   G2931:
    a = w3;
   G2932:
    q = a;
    a = w1;
    a = CC_denlcmTbpol(a, q);
   G2935:
    w1 = a;
    goto    G2916;
   G2920:
    a = w1;
   G2915:
    popv(3);
    return a;
}

Sex CC_gcdTpol3pol3(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != car(q)) goto    G2939;
    if(a != value(LL_CpolyC)) goto    G2941;
    w2 = q;
    q = cdr(q);
    a = cdr(w1);
    a = CC_gcdTbpolbpol(a, q);
    w1 = a;
    if(is_number(a)) goto    G2953;
    a = car(a);
    if(!is_integer(a)) goto    G2944;
    a = w1;
    goto    G2953;
   G2944:
    q = w1;
    a = value(LL_CpolyC);
    {
        popv(2);
        return  cons(a, q);
    }
   G2941:
    if(a != value(LL_CalgnC)) goto    G2946;
    a = w1;
    {
        popv(2);
        return  CC_gcdTalgnalgn(a, q);
    }
   G2946:
    a = w1;
    {
        popv(2);
        return  CC_gcdTalgfalgf(a, q);
    }
   G2939:
    w2 = q;
    q = car(q);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2948;
    a = car(w1);
    q = w1;
    if(a != value(LL_CpolyC)) goto    G2950;
    a = w2;
    goto    G2954;
   G2950:
    a = w2;
    goto    G2955;
   G2948:
    a = car(w2);
    if(a != value(LL_CpolyC)) goto    G2952;
    q = w2;
    a = w1;
   G2954:
    {
        popv(2);
        return  CC_algncontTbpol(a, q);
    }
   G2952:
    q = w2;
    a = w1;
   G2955:
    a = CC_gcdTpolyalgf(a, q);
   G2953:
    popv(2);
    return a;
}

Sex CC_gcdTpolyalgf(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = cdr(q);
    w3 = a;
    w2 = q;
   G2959:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G2983;
    a = cdr(car(a));
    w4 = a;
    if(!is_number(a)) goto    G2962;
    q = cdr(w2);
    a = mkfxat(0);
    goto    G2985;
   G2962:
    a = car(a);
    if(!is_integer(a)) goto    G2964;
    if(a != value(LL_CpolyC)) goto    G2966;
    q = w4;
    a = w1;
    a = CC_gcdTpol3pol3(a, q);
    goto    G2986;
   G2966:
    q = cdr(w1);
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    w1 = a;
    a = Lonep(a);
    if(a != nil) goto    G2970;
    q = cdr(w2);
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    w4 = a;
    a = Lonep(a);
    if(a == nil) goto    G2969;
   G2970:
    a = mkfxat(1);
    goto    G2958;
   G2969:
    q = w1;
    a = w4;
    {
        popv(4);
        return  CC_gcdTbnumbnum(a, q);
    }
   G2964:
    q = w4;
    a = value(LL_CalgfC);
    a = cons(a, q);
    q = a;
    a = w1;
    a = CC_gcdTpolyalgf(a, q);
   G2986:
    w1 = a;
    a = w1;
    if(!is_number(a)) goto    G2978;
    a = cdr(w3);
    if(a == nil) goto    G2983;
    q = w3;
    a = w1;
   G2985:
    {
        popv(4);
        return  CC_ncontTbpol(a, q);
    }
   G2978:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G2959;
   G2983:
    a = w1;
   G2958:
    popv(4);
    return a;
}

Sex CC_gcdTbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G2991;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_gcdTbpolvarvar(a, q);
    }
   G2991:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2992;
    q = w1;
    a = w2;
    goto    G2994;
   G2992:
    q = w2;
    a = w1;
   G2994:
    {
        popv(2);
        return  CC_gcdTbpolcofvar(a, q);
    }
}

Sex CC_gcdTbpolvarvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = value(LL_CpolyC);
    a = Lxcons(a, q);
    a = CC_Wunivar(a);
    if(a == nil) goto    G2998;
    q = w2;
    a = value(LL_CpolyC);
    a = cons(a, q);
    a = CC_Wunivar(a);
    if(a == nil) goto    G2998;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_gcdTbpoluni(a, q);
    }
   G2998:
    q = LITERAL[30];
    a = LITERAL[31];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
}

Sex CC_gcdTbpoluni(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_Hmod);
    w3 = nil;
    if(a == nil) goto    G3006;
    w2 = q;
    q = car(car(cdr(q)));
    a = car(car(cdr(w1)));
    a = Llessp(a, q);
    if(a == nil) goto    G3010;
    a = w1;
    w3 = a;
    a = w2;
    w1 = a;
    a = w3;
    w2 = a;
   G3010:
    a = cdr(car(cdr(w2)));
    w3 = a;
    a = Lonep(a);
    if(a != nil) goto    G3012;
    a = w3;
    if(!is_number(a)) goto    G3015;
    a = CC_recipTbnum(a);
    q = w2;
    a = CC_Hbnumbpol(a, q);
    goto    G3017;
   G3015:
    a = CC_recipTalgn(a);
    q = w2;
    a = CC_Hpol3bpol(a, q);
   G3017:
    w2 = a;
    a = CC_redmodTbpol(a);
    w2 = a;
   G3012:
    q = w2;
    a = w1;
    a = CC_VLbpolbpol(a, q);
    w3 = a;
    a = w2;
    w1 = a;
    a = cdr(w3);
    w2 = a;
    if(!is_number(a)) goto    G3020;
    a = CC_redmodTbnum(a);
    goto    G3022;
   G3020:
    a = car(a);
    if(!is_integer(a)) goto    G3021;
    a = w2;
    a = CC_redmodTncan(a);
    goto    G3022;
   G3021:
    a = w2;
    a = CC_redmodTbpol(a);
   G3022:
    w2 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3053;
    a = w2;
    if(is_number(a)) goto    G3048;
    a = car(a);
    if(!is_integer(a)) goto    G3010;
    goto    G3048;
    a = nil;
    goto    G3028;
   G3006:
    w4 = nil;
    w2 = q;
    q = w1;
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    w3 = a;
    a = Lonep(a);
    if(a != nil) goto    G3033;
    q = w2;
    a = w3;
    a = CC_ncontTbpol(a, q);
    w3 = a;
   G3033:
    q = car(car(cdr(w2)));
    a = car(car(cdr(w1)));
    a = Llessp(a, q);
    if(a == nil) goto    G3036;
    a = w1;
    w4 = a;
    a = w2;
    w1 = a;
    a = w4;
    w2 = a;
   G3036:
    a = cdr(car(cdr(w2)));
    w4 = a;
    a = Lonep(a);
    if(a != nil) goto    G3038;
    a = w4;
    if(!is_number(a)) goto    G3041;
    a = CC_recipTbnum(a);
    q = w2;
    a = CC_Hbnumbpol(a, q);
    goto    G3043;
   G3041:
    a = CC_recipTalgn(a);
    q = w2;
    a = CC_Hpol3bpol(a, q);
   G3043:
    w2 = a;
   G3038:
    q = w2;
    a = w1;
    a = CC_VLbpolbpol(a, q);
    w4 = a;
    a = w2;
    w1 = a;
    a = cdr(w4);
    w2 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3049;
    a = w2;
    if(is_number(a)) goto    G3048;
    a = car(a);
    if(!is_integer(a)) goto    G3036;
   G3048:
    a = mkfxat(1);
    goto    G3028;
   G3049:
    q = w1;
    a = mkfxat(0);
    a = CC_denlcmTbpol(a, q);
    w4 = a;
    a = Lonep(a);
    if(a != nil) goto    G3051;
    q = w1;
    a = w4;
    a = CC_Hbnumbpol(a, q);
    w1 = a;
   G3051:
    q = w1;
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    w4 = a;
    q = a;
    a = w3;
    a = CC_divTbnumbnum(a, q);
    w4 = a;
    a = Lonep(a);
    if(a != nil) goto    G3053;
    q = w1;
    a = w4;
    a = CC_Hbnumbpol(a, q);
    w1 = a;
   G3053:
    a = w1;
   G3028:
    popv(4);
    return a;
}

Sex CC_gcdTbpolcofvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w1 = a;
    a = car(q);
    w4 = a;
    a = cdr(q);
    w3 = a;
    w2 = q;
   G3059:
    a = cdr(car(w2));
    w5 = a;
    if(is_number(a)) goto    G3062;
    a = car(a);
    if(!is_integer(a)) goto    G3061;
   G3062:
    q = w1;
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    w1 = a;
    a = Lonep(a);
    if(a != nil) goto    G3084;
    q = w2;
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    w2 = a;
    a = Lonep(a);
    if(a != nil) goto    G3084;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_gcdTbnumbnum(a, q);
    }
   G3061:
    q = w4;
    a = Lequal(a, q);
    if(a == nil) goto    G3071;
    q = w1;
    a = w5;
    a = CC_gcdTbpolvarvar(a, q);
    goto    G3073;
   G3071:
    q = car(w5);
    a = w4;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G3072;
    q = w1;
    a = w5;
    goto    G3085;
   G3072:
    q = w5;
    a = w1;
   G3085:
    a = CC_gcdTbpolcofvar(a, q);
   G3073:
    w1 = a;
    if(!is_number(a)) goto    G3075;
    a = Lonep(a);
    if(a == nil) goto    G3077;
   G3084:
    a = mkfxat(1);
    goto    G3058;
   G3077:
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_ncontTbpol(a, q);
    }
   G3075:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G3059;
    a = w1;
   G3058:
    popv(5);
    return a;
}

Sex CC_divideTalgnbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G3089;
    q = nil;
    a = mkfxat(6);
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G3089:
    a = mkfxat(0);
#define LL_Hremainder LITERAL[32]
    value(LL_Hremainder) = a;
    q = w2;
    a = cdr(w1);
    a = CC_Vbpolbnum(a, q);
    q = value(LL_CalgnC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_divideTpolybnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G3095;
    q = nil;
    a = mkfxat(6);
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G3095:
    a = mkfxat(0);
    value(LL_Hremainder) = a;
    q = w2;
    a = cdr(w1);
    a = CC_Vbpolbnum(a, q);
    q = value(LL_CpolyC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_divideTalgfbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G3101;
    q = nil;
    a = mkfxat(6);
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G3101:
    a = mkfxat(0);
    value(LL_Hremainder) = a;
    q = w2;
    a = cdr(w1);
    a = CC_Vbpolbnum(a, q);
    q = value(LL_CalgfC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}



/* initialization procedure */
int init_bspoly(void)
{
   long i;

   create_symbols(bspoly_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; bspoly_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(bspoly_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a;
        a = LITERAL[33];
        a = CC_Aenter(a);
        return 1;
    }
}
Sex LITERAL[35];

const  char *bspoly_literal_string[35] =
{
/* 0 */
"!#ratf!#",
/* 1 */
"!*mod",
/* 2 */
"!#poly!#",
/* 3 */
"!#algn!#",
/* 4 */
"!*powser",
/* 5 */
"!*fcut",
/* 6 */
"\"//\"",
/* 7 */
"!#algf!#",
/* 8 */
"!*exctdiv",
/* 9 */
"defpoly",
/* 10 */
"redmod!:pol3",
/* 11 */
"redmod!:bnum",
/* 12 */
"redflo!:pol3",
/* 13 */
"redflo!:bnum",
/* 14 */
"redpow!:pol3",
/* 15 */
"\"FLOAT-NUMBER IN MOD-ARITHMETIC\"",
/* 16 */
"!*temporal",
/* 17 */
"\"/+pol3pol3\"",
/* 18 */
"\"/+polypoly\"",
/* 19 */
"\"/+algfpoly\"",
/* 20 */
"\"/+\"",
/* 21 */
"! Z",
/* 22 */
"1.000000000000000",
/* 23 */
"! F",
/* 24 */
"!*colmode",
/* 25 */
"stcol",
/* 26 */
"!*simpratf",
/* 27 */
"stdiv",
/* 28 */
"!*divmode",
/* 29 */
"\"0 DENOMINATOR BY POWER-SERIES MULTIPLICATION\"",
/* 30 */
"\"GCD\"",
/* 31 */
"\"EZ-GCD NOT PROGRAMMED YET\"",
/* 32 */
"!*remainder",
/* 33 */
"(lisp)",
/* 34 */ NULL
};
setup_type const bspoly_g_setup[] =
{
    {"divide:algfbnum", (lisp_proc *)CC_divideTalgfbnum, 2},
    {"divide:polybnum", (lisp_proc *)CC_divideTpolybnum, 2},
    {"divide:algnbnum", (lisp_proc *)CC_divideTalgnbnum, 2},
    {"gcd:bpolcofvar", (lisp_proc *)CC_gcdTbpolcofvar, 2},
    {"gcd:bpoluni", (lisp_proc *)CC_gcdTbpoluni, 2},
    {"gcd:bpolvarvar", (lisp_proc *)CC_gcdTbpolvarvar, 2},
    {"gcd:bpolbpol", (lisp_proc *)CC_gcdTbpolbpol, 2},
    {"gcd:polyalgf", (lisp_proc *)CC_gcdTpolyalgf, 2},
    {"gcd:pol3pol3", (lisp_proc *)CC_gcdTpol3pol3, 2},
    {"denlcm:bpol", (lisp_proc *)CC_denlcmTbpol, 2},
    {"*iratbrat", (lisp_proc *)CC_Hiratbrat, 3},
    {"*sratsrat", (lisp_proc *)CC_Hsratsrat, 3},
    {"*pol3srat", (lisp_proc *)CC_Hpol3srat, 3},
    {"se+sratbrat", (lisp_proc *)CC_seLsratbrat, 3},
    {"se+npolirat", (lisp_proc *)CC_seLnpolirat, 2},
    {"test:multpl", (lisp_proc *)CC_testTmultpl, 2},
    {"normlz:srat", (lisp_proc *)CC_normlzTsrat, 1},
    {"conv:irbr2cano", (lisp_proc *)CC_convTirbr2cano, 2},
    {"conv:srat2cano", (lisp_proc *)CC_convTsrat2cano, 1},
    {"/bpolbmon", (lisp_proc *)CC_Vbpolbmon, 2},
    {"/pol3mon3", (lisp_proc *)CC_Vpol3mon3, 2},
    {"gcd:mon3mon3", (lisp_proc *)CC_gcdTmon3mon3, 2},
    {"/ratfpol3", (lisp_proc *)CC_Vratfpol3, 2},
    {"/ratfbnum", (lisp_proc *)CC_Vratfbnum, 2},
    {"*ratfratf", (lisp_proc *)CC_Hratfratf, 2},
    {"*pol3ratf", (lisp_proc *)CC_Hpol3ratf, 2},
    {"*bnumratf", (lisp_proc *)CC_Hbnumratf, 2},
    {"+ratfratf", (lisp_proc *)CC_Lratfratf, 2},
    {"+pol3ratf", (lisp_proc *)CC_Lpol3ratf, 2},
    {"+bnumratf", (lisp_proc *)CC_Lbnumratf, 2},
    {"normlz:ratf", (lisp_proc *)CC_normlzTratf, 1},
    {"simp:srat", (lisp_proc *)CC_simpTsrat, 2},
    {"collect:ratf", (lisp_proc *)CC_collectTratf, 1},
    {"normlz:pol3", (lisp_proc *)CC_normlzTpol3, 1},
    {"sedel:algtag", (lisp_proc *)CC_sedelTalgtag, 2},
    {"put:algtag", (lisp_proc *)CC_putTalgtag, 2},
    {"recip:ratf", (lisp_proc *)CC_recipTratf, 1},
    {"recip:algn", (lisp_proc *)CC_recipTalgn, 1},
    {"recip:pol32ratf", (lisp_proc *)CC_recipTpol32ratf, 1},
    {"ps/+bpolbpol", (lisp_proc *)CC_psVLbpolbpol, 2},
    {"/+bpolbpol", (lisp_proc *)CC_VLbpolbpol, 2},
    {"/+bpolpol3", (lisp_proc *)CC_VLbpolpol3, 2},
    {"/+algfpoly", (lisp_proc *)CC_VLalgfpoly, 2},
    {"/+polypoly", (lisp_proc *)CC_VLpolypoly, 2},
    {"/+pol3pol3", (lisp_proc *)CC_VLpol3pol3, 2},
    {"/+bpolbnum", (lisp_proc *)CC_VLbpolbnum, 2},
    {"ps/bpolbpol", (lisp_proc *)CC_psVbpolbpol, 2},
    {"/bpolbpol", (lisp_proc *)CC_Vbpolbpol, 2},
    {"ps/bpolpol3", (lisp_proc *)CC_psVbpolpol3, 2},
    {"/bpolpol3", (lisp_proc *)CC_Vbpolpol3, 2},
    {"/bpolbnum", (lisp_proc *)CC_Vbpolbnum, 2},
    {"ps/cofbpol", (lisp_proc *)CC_psVcofbpol, 2},
    {"ps/bnumbpol", (lisp_proc *)CC_psVbnumbpol, 2},
    {"ps/pol3pol3", (lisp_proc *)CC_psVpol3pol3, 2},
    {"/pol3pol3", (lisp_proc *)CC_Vpol3pol3, 2},
    {"/pol3bnum", (lisp_proc *)CC_Vpol3bnum, 2},
    {"ps/bnumpoly", (lisp_proc *)CC_psVbnumpoly, 2},
    {"ps/anyany", (lisp_proc *)CC_psVanyany, 2},
    {"ps/anypol3", (lisp_proc *)CC_psVanypol3, 2},
    {"/anyany", (lisp_proc *)CC_Vanyany, 2},
    {"/anypol3", (lisp_proc *)CC_Vanypol3, 2},
    {"/anybnum", (lisp_proc *)CC_Vanybnum, 2},
    {"chk:divble", (lisp_proc *)CC_chkTdivble, 2},
    {"point:tm", (lisp_proc *)CC_pointTtm, 2},
    {"ps*bpolbpol:varvar", (lisp_proc *)CC_psHbpolbpolTvarvar, 2},
    {"*bpolbpol:varvar", (lisp_proc *)CC_HbpolbpolTvarvar, 2},
    {"ps*bpolbpol:cofvar", (lisp_proc *)CC_psHbpolbpolTcofvar, 2},
    {"*bpolbpol:cofvar", (lisp_proc *)CC_HbpolbpolTcofvar, 2},
    {"ps*anyany", (lisp_proc *)CC_psHanyany, 2},
    {"ps*bpolany", (lisp_proc *)CC_psHbpolany, 2},
    {"ps*pol3any", (lisp_proc *)CC_psHpol3any, 2},
    {"*bpolany", (lisp_proc *)CC_Hbpolany, 2},
    {"*pol3any", (lisp_proc *)CC_Hpol3any, 2},
    {"*bnumany", (lisp_proc *)CC_Hbnumany, 2},
    {"*any0any0", (lisp_proc *)CC_Hany0any0, 2},
    {"*anyany", (lisp_proc *)CC_Hanyany, 2},
    {"ps*bpolbpol", (lisp_proc *)CC_psHbpolbpol, 2},
    {"*bpolbpol", (lisp_proc *)CC_Hbpolbpol, 2},
    {"ps*pol3bpol", (lisp_proc *)CC_psHpol3bpol, 2},
    {"*pol3bpol", (lisp_proc *)CC_Hpol3bpol, 2},
    {"ps*pol3pol3", (lisp_proc *)CC_psHpol3pol3, 2},
    {"*pol3pol3", (lisp_proc *)CC_Hpol3pol3, 2},
    {"*bnumbpol", (lisp_proc *)CC_Hbnumbpol, 2},
    {"*bnumpol3", (lisp_proc *)CC_Hbnumpol3, 2},
    {"sese+bpolbpol:varvar", (lisp_proc *)CC_seseLbpolbpolTvarvar, 2},
    {"sese+bpolbpol:cofvar", (lisp_proc *)CC_seseLbpolbpolTcofvar, 2},
    {"sese+bpolbpol", (lisp_proc *)CC_seseLbpolbpol, 2},
    {"sese+anyany", (lisp_proc *)CC_seseLanyany, 2},
    {"sese+bpolany", (lisp_proc *)CC_seseLbpolany, 2},
    {"se+bpolbpol:varvar", (lisp_proc *)CC_seLbpolbpolTvarvar, 2},
    {"se+bpolbpol:cofvar", (lisp_proc *)CC_seLbpolbpolTcofvar, 2},
    {"se+bpolbpol", (lisp_proc *)CC_seLbpolbpol, 2},
    {"se+pol3bpol", (lisp_proc *)CC_seLpol3bpol, 2},
    {"se+bnumbpol", (lisp_proc *)CC_seLbnumbpol, 2},
    {"se+anyany", (lisp_proc *)CC_seLanyany, 2},
    {"se+bpolany", (lisp_proc *)CC_seLbpolany, 2},
    {"se+pol3any", (lisp_proc *)CC_seLpol3any, 2},
    {"se+bnumany", (lisp_proc *)CC_seLbnumany, 2},
    {"+bpolbpol:varvar", (lisp_proc *)CC_LbpolbpolTvarvar, 2},
    {"+bpolbpol:cofvar", (lisp_proc *)CC_LbpolbpolTcofvar, 2},
    {"+bpolany", (lisp_proc *)CC_Lbpolany, 2},
    {"+pol3any", (lisp_proc *)CC_Lpol3any, 2},
    {"+bnumany", (lisp_proc *)CC_Lbnumany, 2},
    {"+any0any0", (lisp_proc *)CC_Lany0any0, 2},
    {"+anyany", (lisp_proc *)CC_Lanyany, 2},
    {"se-bpol", (lisp_proc *)CC_seKbpol, 1},
    {"-bpol", (lisp_proc *)CC_Kbpol, 1},
    {"+bpolbpol", (lisp_proc *)CC_Lbpolbpol, 2},
    {"+pol3bpol", (lisp_proc *)CC_Lpol3bpol, 2},
    {"+pol3pol3", (lisp_proc *)CC_Lpol3pol3, 2},
    {"+bnumbpol", (lisp_proc *)CC_Lbnumbpol, 2},
    {"+bnumpol3", (lisp_proc *)CC_Lbnumpol3, 2},
    {"-pol3", (lisp_proc *)CC_Kpol3, 1},
    {"-any", (lisp_proc *)CC_Kany, 1},
    {"revord:bpol", (lisp_proc *)CC_revordTbpol, 1},
    {"revord:pol3", (lisp_proc *)CC_revordTpol3, 1},
    {"redpow:bpol", (lisp_proc *)CC_redpowTbpol, 2},
    {"redflo:bpol", (lisp_proc *)CC_redfloTbpol, 2},
    {"redmod:bpol", (lisp_proc *)CC_redmodTbpol, 1},
    {"redpow:pol3", (lisp_proc *)CC_redpowTpol3, 1},
    {"redflo:pol3", (lisp_proc *)CC_redfloTpol3, 1},
    {"redmod:pol3", (lisp_proc *)CC_redmodTpol3, 1},
    {"redflo:bnum", (lisp_proc *)CC_redfloTbnum, 1},
    {"redmod:bnum", (lisp_proc *)CC_redmodTbnum, 1},
    {"redpow:ncan", (lisp_proc *)CC_redpowTncan, 1},
    {"redflo:ncan", (lisp_proc *)CC_redfloTncan, 1},
    {"redmod:ncan", (lisp_proc *)CC_redmodTncan, 1},
    {"reduce:balgf", (lisp_proc *)CC_reduceTbalgf, 1},
    {"reduce:balgn", (lisp_proc *)CC_reduceTbalgn, 1},
    {"reduce:bpol", (lisp_proc *)CC_reduceTbpol, 1},
    {"quoti:canocano", (lisp_proc *)CC_quotiTcanocano, 2},
    {"mult:canocano", (lisp_proc *)CC_multTcanocano, 2},
    {"add:canocano", (lisp_proc *)CC_addTcanocano, 2},
    {"quoti:canobnum", (lisp_proc *)CC_quotiTcanobnum, 2},
    {"quoti:bnumcano", (lisp_proc *)CC_quotiTbnumcano, 2},
    {"mult:bnumcano", (lisp_proc *)CC_multTbnumcano, 2},
    {"add:bnumcano", (lisp_proc *)CC_addTbnumcano, 2},
    {"recip:cano", (lisp_proc *)CC_recipTcano, 1},
    {"neg:cano", (lisp_proc *)CC_negTcano, 1},
    {NULL, NULL, 0 }
};

