#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_bspref.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex bspref_literal_vector[];
const char *bspref_literal_string[];
setup_type const  bspref_g_setup[];
#define LITERAL bspref_literal_vector




Sex CC_gL(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_gL LITERAL[0]
    a = LL_gL;
    a = Lmkquote(a);
    m = cdr(w1);
    q = a;
#define LL_fcallxyTrexp LITERAL[1]
    a = LL_fcallxyTrexp;
    {
        popv(1);
        return  CC_expndQargn(a, q, m);
    }
}

Sex CC_gK(Sex a)
{
    Sex q;
    q = a;
#define LL_gK LITERAL[2]
    a = LL_gK;
    {
        return  CC_fcallxTrexp(a, q);
    }
}

Sex CC_gH(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_gH LITERAL[3]
    a = LL_gH;
    a = Lmkquote(a);
    m = cdr(w1);
    q = a;
    a = LL_fcallxyTrexp;
    {
        popv(1);
        return  CC_expndQargn(a, q, m);
    }
}

Sex CC_gHH(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
#define LL_gHH LITERAL[4]
    a = LL_gHH;
    {
        return  CC_fcallx1Trexp(a, q, m);
    }
}

Sex CC_gV(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
#define LL_gV LITERAL[5]
    a = LL_gV;
    {
        return  CC_fcallx1Trexp(a, q, m);
    }
}

Sex CC_gVV(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
#define LL_gVV LITERAL[6]
    a = LL_gVV;
    {
        return  CC_fcallx1Trexp(a, q, m);
    }
}

Sex CC_gVL(Sex a, Sex q)
{
    Sex m;
    m = q;
    q = a;
#define LL_gVL LITERAL[7]
    a = LL_gVL;
    {
        return  CC_fcallx1Trexp(a, q, m);
    }
}

Sex CC_tail3(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
   G0018:
    a = cdr(cdr(w1));
    w2 = a;
    a = cdr(a);
    if(a == nil) goto    G0022;
    a = w2;
    w1 = a;
    goto    G0018;
   G0022:
    a = w1;
    popv(2);
    return a;
}

Sex CC_topcopy2(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w2 = a;
    a = cdr(w1);
    w1 = a;
    a = cdr(a);
    a = cdr(a);
    w3 = a;
   G0026:
    if(a == nil) goto    G0037;
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = w3;
    w1 = a;
    a = cdr(a);
    a = cdr(a);
    w3 = a;
    goto    G0026;
   G0037:
    q = w1;
    a = w4;
    cdr(a) = q;
#define LL_Htemporal LITERAL[8]
    value(LL_Htemporal) = a;
    a = w2;
    popv(4);
    return a;
}

Sex CC_reduceTncH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G0041;
    a = mkfxat(1);
    goto    G0046;
   G0041:
    a = cdr(cdr(a));
    if(a != nil) goto    G0045;
    a = car(cdr(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G0045;
    a = car(cdr(w1));
    value(LL_Htemporal) = a;
    if(!is_cons(a)) goto    G0045;
#define LL_BctypeB LITERAL[9]
    q = LL_BctypeB;
    a = car(a);
    a = Lget(a, q);
    if(a == nil) goto    G0045;
    a = value(LL_Htemporal);
    goto    G0046;
   G0045:
    a = w1;
   G0046:
    popv(1);
    return a;
}

Sex CC_reduceTcH(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G0053;
    a = mkfxat(1);
    goto    G0058;
   G0053:
    a = cdr(cdr(a));
    if(a != nil) goto    G0056;
    a = car(cdr(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G0056;
    a = car(cdr(w1));
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G0057;
    a = car(a);
    if(is_integer(a)) goto    G0057;
#define LL_cL LITERAL[10]
    if(a != LL_cL) goto    G0056;
   G0057:
    a = value(LL_Htemporal);
    goto    G0058;
   G0056:
    a = w1;
   G0058:
    popv(1);
    return a;
}

Sex CC_reduceTcL(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G0064;
    a = mkfxat(0);
    goto    G0069;
   G0064:
    a = cdr(a);
    if(a != nil) goto    G0068;
    a = car(cdr(w1));
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G0069;
    a = car(a);
    if(!is_integer(a)) goto    G0067;
    a = value(LL_Htemporal);
    goto    G0069;
   G0067:
    a = cdr(value(LL_Htemporal));
    a = Lonep(a);
    if(a == nil) goto    G0068;
    a = car(value(LL_Htemporal));
    goto    G0069;
   G0068:
    a = w1;
   G0069:
    popv(1);
    return a;
}

Sex CC_redcoefTncan(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Hfcut LITERAL[11]
    a = value(LL_Hfcut);
    if(a == nil) goto    G0074;
    a = w1;
    if(!is_number(a)) goto    G0076;
    {
        popv(1);
        return  CC_redfloTbnum(a);
    }
   G0076:
#define LL_CratfC LITERAL[12]
    if(car(a) >= value(LL_CratfC)) goto    G0077;
    {
        popv(1);
        return  CC_redfloTpol3(a);
    }
   G0077:
    m = a;
#define LL_redfloTpol3 LITERAL[13]
    q = LL_redfloTpol3;
#define LL_redfloTbnum LITERAL[14]
    a = LL_redfloTbnum;
    goto    G0085;
   G0074:
#define LL_Hmod LITERAL[15]
    a = value(LL_Hmod);
    if(a == nil) goto    G0079;
    a = w1;
    if(!is_number(a)) goto    G0081;
    {
        popv(1);
        return  CC_redmodTbnum(a);
    }
   G0081:
    if(car(a) >= value(LL_CratfC)) goto    G0082;
    {
        popv(1);
        return  CC_redmodTpol3(a);
    }
   G0082:
    m = a;
#define LL_redmodTpol3 LITERAL[16]
    q = LL_redmodTpol3;
#define LL_redmodTbnum LITERAL[17]
    a = LL_redmodTbnum;
   G0085:
    {
        popv(1);
        return  CC_qmap2Tratf(a, q, m);
    }
   G0079:
    a = w1;
    popv(1);
    return a;
}

Sex CC_seTredcoefTcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_Hfcut);
    if(a == nil) goto    G0089;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = w1;
    w2 = a;
    a = cdr(a);
    w3 = a;
    if(a == nil) goto    G0150;
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G0098;
    a = w3;
    w2 = a;
    a = cdr(a);
    w3 = a;
    if(a == nil) goto    G0151;
   G0098:
    a = car(car(car(w3)));
#define LL_cH LITERAL[18]
    if(a == LL_cH) goto    G0092;
    a = w3;
    w2 = a;
    a = cdr(a);
    w3 = a;
    if(a == nil) goto    G0119;
    goto    G0098;
   G0092:
    a = cdr(car(w3));
    a = CC_redfloTbnum(a);
    w4 = a;
    if(a == cdr(car(w3))) goto    G0110;
    a = Lzerop(a);
    if(a == nil) goto    G0157;
    a = cdr(w3);
    w3 = a;
    q = a;
    a = w2;
    cdr(a) = q;
    a = w3;
    goto    G0152;
   G0157:
    q = w4;
    a = car(car(w3));
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
   G0110:
    a = w3;
    w2 = a;
    a = cdr(a);
    w3 = a;
   G0152:
    if(a == nil) goto    G0119;
    goto    G0092;
   G0089:
    a = value(LL_Hmod);
    if(a == nil) goto    G0119;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = w1;
    w2 = a;
    a = cdr(a);
    w3 = a;
    if(a != nil) goto    G0125;
   G0150:
    a = mkfxat(0);
    goto    G0149;
   G0125:
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G0128;
    a = w3;
    w2 = a;
    a = cdr(a);
    w3 = a;
    if(a != nil) goto    G0128;
   G0151:
    a = car(w2);
    goto    G0149;
   G0128:
    a = car(car(car(w3)));
    if(a == LL_cH) goto    G0122;
    a = w3;
    w2 = a;
    a = cdr(a);
    w3 = a;
    if(a == nil) goto    G0119;
    goto    G0128;
   G0122:
    a = cdr(car(w3));
    a = CC_redmodTbnum(a);
    w4 = a;
    if(a == cdr(car(w3))) goto    G0140;
    a = Lzerop(a);
    if(a == nil) goto    G0156;
    a = cdr(w3);
    w3 = a;
    q = a;
    a = w2;
    cdr(a) = q;
    a = w3;
    goto    G0154;
   G0156:
    q = w4;
    a = car(car(w3));
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
   G0140:
    a = w3;
    w2 = a;
    a = cdr(a);
    w3 = a;
   G0154:
    if(a != nil) goto    G0122;
   G0119:
    a = w1;
    a = CC_reduceTcL(a);
   G0149:
    popv(4);
    return a;
}

Sex CC_chkaddH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Hcolmode LITERAL[19]
    a = value(LL_Hcolmode);
#define LL_uncol LITERAL[20]
    if(a != LL_uncol) goto    G0161;
    a = w1;
    {
        popv(1);
        return  CC_unaddH(a, q);
    }
   G0161:
    a = w1;
    {
        popv(1);
        return  CC_addH(a, q);
    }
}

Sex CC_addH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0166;
    if(!is_number(q)) goto    G0168;
    {
        popv(2);
        return  CC_addTbnumbnum(a, q);
    }
   G0168:
    a = car(q);
    if(!is_integer(a)) goto    G0169;
    a = w1;
    goto    G0181;
   G0169:
    a = w1;
    goto    G0182;
   G0166:
    if(!is_number(q)) goto    G0171;
    a = car(a);
    if(!is_integer(a)) goto    G0173;
    q = w1;
    a = w2;
   G0181:
    {
        popv(2);
        return  CC_addTbnumcano(a, q);
    }
   G0173:
    q = w1;
    a = w2;
   G0182:
    {
        popv(2);
        return  CC_addTbnumpref(a, q);
    }
   G0171:
    a = car(a);
    if(!is_integer(a)) goto    G0175;
    a = car(q);
    if(!is_integer(a)) goto    G0177;
    a = w1;
    {
        popv(2);
        return  CC_addTcanocano(a, q);
    }
   G0177:
    a = w1;
    goto    G0183;
   G0175:
    a = car(q);
    if(!is_integer(a)) goto    G0179;
    q = w1;
    a = w2;
   G0183:
    {
        popv(2);
        return  CC_addTcanopref(a, q);
    }
   G0179:
    a = w1;
    {
        popv(2);
        return  CC_addTprefpref(a, q);
    }
}

Sex CC_addTexpt(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0187;
    if(!is_number(q)) goto    G0187;
    {
        popv(2);
        return  plus2(a, q);
    }
   G0187:
    value(LL_Hmod) = nil;
    if(!is_number(a)) goto    G0191;
    a = car(q);
    if(!is_integer(a)) goto    G0193;
    a = w1;
    goto    G0205;
   G0193:
    a = w1;
    goto    G0206;
   G0191:
    if(!is_number(q)) goto    G0195;
    a = car(a);
    q = w1;
    if(!is_integer(a)) goto    G0197;
    a = w2;
   G0205:
    a = CC_addTbnumcano(a, q);
    goto    G0204;
   G0197:
    a = w2;
   G0206:
    a = CC_addTbnumpref(a, q);
    goto    G0204;
   G0195:
    a = car(a);
    if(!is_integer(a)) goto    G0199;
    a = car(q);
    if(!is_integer(a)) goto    G0201;
    a = w1;
    a = CC_addTcanocano(a, q);
    goto    G0204;
   G0201:
    a = w1;
    goto    G0207;
   G0199:
    a = car(q);
    if(!is_integer(a)) goto    G0203;
    q = w1;
    a = w2;
   G0207:
    a = CC_addTcanopref(a, q);
    goto    G0204;
   G0203:
    a = w1;
    a = CC_addTprefpref(a, q);
   G0204:
    w1 = a;
#define LL_HHmod LITERAL[21]
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = w1;
    popv(2);
    return a;
}

Sex CC_unaddH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0211;
    if(!is_number(q)) goto    G0213;
    {
        popv(2);
        return  CC_addTbnumbnum(a, q);
    }
   G0213:
    a = car(q);
    if(!is_integer(a)) goto    G0214;
    a = w1;
    goto    G0231;
   G0214:
    a = w1;
    goto    G0232;
   G0211:
    if(!is_number(q)) goto    G0216;
    a = car(a);
    if(!is_integer(a)) goto    G0218;
    q = w1;
    a = w2;
   G0231:
    {
        popv(2);
        return  CC_addTbnumcano(a, q);
    }
   G0218:
    q = w1;
    a = w2;
   G0232:
    {
        popv(2);
        return  CC_addTbnumpref(a, q);
    }
   G0216:
    a = car(a);
    if(!is_integer(a)) goto    G0220;
    a = car(q);
    if(!is_integer(a)) goto    G0222;
    a = w1;
    {
        popv(2);
        return  CC_addTcanocano(a, q);
    }
   G0222:
    a = w1;
    goto    G0233;
   G0220:
    a = car(q);
    if(!is_integer(a)) goto    G0224;
    q = w1;
    a = w2;
   G0233:
    {
        popv(2);
        return  CC_addTcanopref(a, q);
    }
   G0224:
    a = car(w1);
    if(a != LL_cL) goto    G0225;
    a = car(q);
    if(a != LL_cL) goto    G0227;
    a = w1;
    {
        popv(2);
        return  CC_unaddTcLcL(a, q);
    }
   G0227:
    q = w1;
    a = w2;
    goto    G0234;
   G0225:
    a = car(q);
    if(a != LL_cL) goto    G0229;
    a = w1;
   G0234:
    {
        popv(2);
        return  CC_unaddTcHcL(a, q);
    }
   G0229:
    a = w1;
    {
        popv(2);
        return  CC_unaddTcHcH(a, q);
    }
}

Sex CC_negH(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0238;
    {
        popv(1);
        return  CC_negTbnum(a);
    }
   G0238:
    a = car(a);
    if(!is_integer(a)) goto    G0239;
    a = w1;
    {
        popv(1);
        return  CC_negTcano(a);
    }
   G0239:
    if(a != LL_cL) goto    G0240;
    a = w1;
    {
        popv(1);
        return  CC_negTcL(a);
    }
   G0240:
    a = w1;
    {
        popv(1);
        return  CC_negTcH(a);
    }
}

Sex CC_negTexpt(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0245;
    {
        popv(1);
        return  Lminus(a);
    }
   G0245:
    value(LL_Hmod) = nil;
    a = car(a);
    if(!is_integer(a)) goto    G0248;
    a = w1;
    a = CC_negTcano(a);
    goto    G0250;
   G0248:
    if(a != LL_cL) goto    G0249;
    a = w1;
    a = CC_negTcL(a);
    goto    G0250;
   G0249:
    a = w1;
    a = CC_negTcH(a);
   G0250:
    w1 = a;
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = w1;
    popv(1);
    return a;
}

Sex CC_chkmultH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Hexpmode LITERAL[22]
    a = value(LL_Hexpmode);
#define LL_unexp LITERAL[23]
    if(a != LL_unexp) goto    G0254;
    a = w1;
    {
        popv(1);
        return  CC_unmultH(a, q);
    }
   G0254:
    a = w1;
    {
        popv(1);
        return  CC_multH(a, q);
    }
}

Sex CC_multH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0259;
    if(!is_number(q)) goto    G0261;
    {
        popv(2);
        return  CC_multTbnumbnum(a, q);
    }
   G0261:
    a = car(q);
    if(!is_integer(a)) goto    G0262;
    a = w1;
    goto    G0274;
   G0262:
    a = w1;
    goto    G0275;
   G0259:
    if(!is_number(q)) goto    G0264;
    a = car(a);
    if(!is_integer(a)) goto    G0266;
    q = w1;
    a = w2;
   G0274:
    {
        popv(2);
        return  CC_multTbnumcano(a, q);
    }
   G0266:
    q = w1;
    a = w2;
   G0275:
    {
        popv(2);
        return  CC_multTbnumpref(a, q);
    }
   G0264:
    a = car(a);
    if(!is_integer(a)) goto    G0268;
    a = car(q);
    if(!is_integer(a)) goto    G0270;
    a = w1;
    {
        popv(2);
        return  CC_multTcanocano(a, q);
    }
   G0270:
    a = w1;
    goto    G0276;
   G0268:
    a = car(q);
    if(!is_integer(a)) goto    G0272;
    q = w1;
    a = w2;
   G0276:
    {
        popv(2);
        return  CC_multTcanopref(a, q);
    }
   G0272:
    a = w1;
    {
        popv(2);
        return  CC_multTprefpref(a, q);
    }
}

Sex CC_multTexpt(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0280;
    if(!is_number(q)) goto    G0280;
    {
        popv(2);
        return  times2(a, q);
    }
   G0280:
    value(LL_Hmod) = nil;
    if(!is_number(a)) goto    G0284;
    a = car(q);
    if(!is_integer(a)) goto    G0286;
    a = w1;
    goto    G0298;
   G0286:
    a = w1;
    goto    G0299;
   G0284:
    if(!is_number(q)) goto    G0288;
    a = car(a);
    q = w1;
    if(!is_integer(a)) goto    G0290;
    a = w2;
   G0298:
    a = CC_multTbnumcano(a, q);
    goto    G0297;
   G0290:
    a = w2;
   G0299:
    a = CC_multTbnumpref(a, q);
    goto    G0297;
   G0288:
    a = car(a);
    if(!is_integer(a)) goto    G0292;
    a = car(q);
    if(!is_integer(a)) goto    G0294;
    a = w1;
    a = CC_multTcanocano(a, q);
    goto    G0297;
   G0294:
    a = w1;
    goto    G0300;
   G0292:
    a = car(q);
    if(!is_integer(a)) goto    G0296;
    q = w1;
    a = w2;
   G0300:
    a = CC_multTcanopref(a, q);
    goto    G0297;
   G0296:
    a = w1;
    a = CC_multTprefpref(a, q);
   G0297:
    w1 = a;
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = w1;
    popv(2);
    return a;
}

Sex CC_unmultH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0304;
    if(!is_number(q)) goto    G0306;
    {
        popv(2);
        return  CC_multTbnumbnum(a, q);
    }
   G0306:
    a = car(q);
    if(!is_integer(a)) goto    G0307;
    a = w1;
    goto    G0319;
   G0307:
    a = w1;
    goto    G0320;
   G0304:
    if(!is_number(q)) goto    G0309;
    a = car(a);
    if(!is_integer(a)) goto    G0311;
    q = w1;
    a = w2;
   G0319:
    {
        popv(2);
        return  CC_multTbnumcano(a, q);
    }
   G0311:
    q = w1;
    a = w2;
   G0320:
    {
        popv(2);
        return  CC_multTbnumpref(a, q);
    }
   G0309:
    a = car(a);
    if(!is_integer(a)) goto    G0313;
    a = car(q);
    if(!is_integer(a)) goto    G0315;
    a = w1;
    {
        popv(2);
        return  CC_unmultTcanocano(a, q);
    }
   G0315:
    a = w1;
    goto    G0321;
   G0313:
    a = car(q);
    if(!is_integer(a)) goto    G0317;
    q = w1;
    a = w2;
   G0321:
    {
        popv(2);
        return  CC_unmultTcanopref(a, q);
    }
   G0317:
    a = w1;
    {
        popv(2);
        return  CC_unmultTprefpref(a, q);
    }
}

Sex CC_powH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0325;
    if(!is_number(q)) goto    G0327;
    {
        popv(1);
        return  CC_exptTbnumbnum(a, q);
    }
   G0327:
    {
        popv(1);
        return  CC_unpowTbnum(a, q);
    }
   G0325:
    if(is_integer(q)) goto    G0329;
    a = car(a);
    if(!is_integer(a)) goto    G0331;
    a = w1;
    {
        popv(1);
        return  CC_unpowTcano(a, q);
    }
   G0331:
    a = w1;
    {
        popv(1);
        return  CC_unpowTpref(a, q);
    }
   G0329:
    a = car(a);
    if(!is_integer(a)) goto    G0333;
    a = w1;
    {
        popv(1);
        return  CC_powTcanoint(a, q);
    }
   G0333:
    a = w1;
    {
        popv(1);
        return  CC_powTprefint(a, q);
    }
}

Sex CC_unpowH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0338;
    if(!is_number(q)) goto    G0340;
    {
        popv(2);
        return  CC_exptTbnumbnum(a, q);
    }
   G0340:
    {
        popv(2);
        return  CC_unpowTbnum(a, q);
    }
   G0338:
    if(is_integer(q)) goto    G0342;
    a = car(a);
    if(!is_integer(a)) goto    G0353;
    goto    G0352;
   G0342:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G0346;
    a = mkfxat(1);
    goto    G0351;
   G0346:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G0347;
    a = w1;
    goto    G0351;
   G0347:
    a = w2;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G0348;
    a = w1;
    {
        popv(2);
        return  CC_recipH(a);
    }
   G0348:
    a = car(w1);
    if(!is_integer(a)) goto    G0350;
    q = w2;
   G0352:
    a = w1;
    {
        popv(2);
        return  CC_unpowTcano(a, q);
    }
   G0350:
    q = w2;
   G0353:
    a = w1;
    a = CC_unpowTpref(a, q);
   G0351:
    popv(2);
    return a;
}

Sex CC_recipH(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0357;
    {
        popv(1);
        return  CC_recipTbnum(a);
    }
   G0357:
    a = car(a);
    if(!is_integer(a)) goto    G0358;
#define LL_CmaxcanoC LITERAL[24]
    if(a >= value(LL_CmaxcanoC)) goto    G0360;
    a = w1;
    {
        popv(1);
        return  CC_recipTcano(a);
    }
   G0360:
    a = w1;
    {
        popv(1);
        return  CC_recipTform(a);
    }
   G0358:
    a = w1;
    {
        popv(1);
        return  CC_recipTpref(a);
    }
}

Sex CC_quotiH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0366;
    {
        popv(1);
        return  CC_quotiTbnum(a, q);
    }
   G0366:
    a = car(a);
    if(!is_integer(a)) goto    G0367;
    if(a >= value(LL_CmaxcanoC)) goto    G0369;
    a = w1;
    {
        popv(1);
        return  CC_quotiTcano(a, q);
    }
   G0369:
    a = w1;
    {
        popv(1);
        return  CC_quotiTform(a, q);
    }
   G0367:
    a = w1;
    {
        popv(1);
        return  CC_quotiTpref(a, q);
    }
}

Sex CC_plusTbnumbnum(Sex a, Sex q)
{
    {
        return  CC_addTbnumbnum(a, q);
    }
}

Sex CC_plusTbnumcano(Sex a, Sex q)
{
    {
        return  CC_addTbnumcano(a, q);
    }
}

Sex CC_plusTbnumpref(Sex a, Sex q)
{
    {
        return  CC_addTbnumpref(a, q);
    }
}

Sex CC_plusTcanocano(Sex a, Sex q)
{
    {
        return  CC_addTcanocano(a, q);
    }
}

Sex CC_plusTcanopref(Sex a, Sex q)
{
    {
        return  CC_addTcanopref(a, q);
    }
}

Sex CC_plusTprefpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0385;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_addTprefpref(a, q);
    }
   G0385:
    a = car(w1);
    if(a != LL_cL) goto    G0386;
    a = car(w2);
    if(a != LL_cL) goto    G0388;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_unaddTcLcL(a, q);
    }
   G0388:
    q = w1;
    a = w2;
    goto    G0392;
   G0386:
    a = car(w2);
    if(a != LL_cL) goto    G0390;
    q = w2;
    a = w1;
   G0392:
    {
        popv(2);
        return  CC_unaddTcHcL(a, q);
    }
   G0390:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_unaddTcHcH(a, q);
    }
}

Sex CC_negTpref(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G0396;
    a = w1;
    {
        popv(1);
        return  CC_negTcL(a);
    }
   G0396:
    a = w1;
    {
        popv(1);
        return  CC_negTcH(a);
    }
}

Sex CC_timesTbnumbnum(Sex a, Sex q)
{
    {
        return  CC_multTbnumbnum(a, q);
    }
}

Sex CC_timesTbnumcano(Sex a, Sex q)
{
    {
        return  CC_multTbnumcano(a, q);
    }
}

Sex CC_timesTbnumpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(q);
    if(a != LL_cL) goto    G0405;
    a = w1;
    {
        popv(2);
        return  CC_multTbnumcL(a, q);
    }
   G0405:
    w2 = q;
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G0406;
    a = mkfxat(0);
    goto    G0408;
   G0406:
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0407;
    a = w2;
    goto    G0408;
   G0407:
    q = w1;
    a = w2;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G0408:
    popv(2);
    return a;
}

Sex CC_timesTcanocano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0413;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_multTcanocano(a, q);
    }
   G0413:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_unmultTcanocano(a, q);
    }
}

Sex CC_timesTcanopref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0418;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_multTcanopref(a, q);
    }
   G0418:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_unmultTcanopref(a, q);
    }
}

Sex CC_timesTprefpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0423;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_multTprefpref(a, q);
    }
   G0423:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_unmultTprefpref(a, q);
    }
}

Sex CC_exptTbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0428;
    if(!is_number(q)) goto    G0430;
    {
        popv(2);
        return  CC_exptTbnumbnum(a, q);
    }
   G0430:
    q = LITERAL[25];
    a = mkfxat(3);
    goto    G0445;
   G0428:
    a = car(q);
    if(!is_integer(a)) goto    G0432;
    if(a < value(LL_CmaxcanoC)) goto    G0434;
    q = nil;
    a = mkfxat(9);
    goto    G0445;
   G0434:
    a = w1;
    a = Lzerop(a);
    if(a != nil) goto    G0446;
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0441;
    goto    G0447;
   G0432:
    q = LL_BctypeB;
    a = Lget(a, q);
#define LL_rat LITERAL[26]
    if(a != LL_rat) goto    G0438;
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G0440;
   G0446:
    a = mkfxat(0);
    goto    G0443;
   G0440:
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0441;
   G0447:
    a = mkfxat(1);
    goto    G0443;
   G0441:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_unpowTbnum(a, q);
    }
   G0438:
    q = LITERAL[25];
    a = mkfxat(3);
   G0445:
    a = CC_errormsg(a, q);
   G0443:
    popv(2);
    return a;
}

Sex CC_exptTcano(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0452;
    if(!is_integer(q)) goto    G0454;
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0456;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_powTcanoint(a, q);
    }
   G0456:
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G0457;
    a = mkfxat(1);
    goto    G0474;
   G0457:
    a = w2;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G0458;
    a = w1;
    {
        popv(2);
        return  CC_recipTcano(a);
    }
   G0458:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G0460;
    a = w1;
    goto    G0474;
   G0460:
    q = w2;
    goto    G0479;
   G0454:
    if(!is_rational(q)) goto    G0462;
#define LL_Hfracpow LITERAL[27]
    a = value(LL_Hfracpow);
    if(a == nil) goto    G0479;
    a = w1;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G0462;
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    m = a;
    q = car(cdr(w1));
    a = car(w1);
    {
        popv(2);
        return  Llist3(a, q, m);
    }
   G0462:
    q = LITERAL[25];
    a = mkfxat(3);
    goto    G0480;
   G0452:
    a = car(q);
    if(!is_integer(a)) goto    G0469;
    if(a < value(LL_CmaxcanoC)) goto    G0479;
    q = nil;
    a = mkfxat(9);
    goto    G0480;
   G0469:
    q = LL_BctypeB;
    a = Lget(a, q);
    if(a != LL_rat) goto    G0473;
    q = w2;
   G0479:
    a = w1;
    {
        popv(2);
        return  CC_unpowTcano(a, q);
    }
   G0473:
    q = LITERAL[25];
    a = mkfxat(3);
   G0480:
    a = CC_errormsg(a, q);
   G0474:
    popv(2);
    return a;
}

Sex CC_exptTpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0484;
    if(!is_integer(q)) goto    G0486;
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0488;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_powTprefint(a, q);
    }
   G0488:
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G0489;
    a = mkfxat(1);
    goto    G0501;
   G0489:
    a = w2;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G0490;
    a = w1;
    {
        popv(2);
        return  CC_recipTpref(a);
    }
   G0490:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G0492;
    a = w1;
    goto    G0501;
   G0492:
    q = w2;
    a = w1;
    goto    G0505;
   G0486:
    if(is_number(q)) goto    G0505;
    q = LITERAL[25];
    a = mkfxat(3);
    goto    G0506;
   G0484:
    a = car(q);
    if(!is_integer(a)) goto    G0496;
    if(a >= value(LL_CmaxcanoC)) goto    G0498;
    a = w1;
    goto    G0505;
   G0498:
    q = nil;
    a = mkfxat(9);
    goto    G0506;
   G0496:
    q = LL_BctypeB;
    a = Lget(a, q);
    if(a != LL_rat) goto    G0500;
    q = w2;
    a = w1;
   G0505:
    {
        popv(2);
        return  CC_unpowTpref(a, q);
    }
   G0500:
    q = LITERAL[25];
    a = mkfxat(3);
   G0506:
    a = CC_errormsg(a, q);
   G0501:
    popv(2);
    return a;
}

Sex CC_ratioTbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0510;
    if(is_number(q)) goto    G0512;
    q = LITERAL[28];
    a = mkfxat(3);
    goto    G0540;
   G0512:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G0513;
    q = LITERAL[28];
    a = mkfxat(6);
    goto    G0540;
   G0513:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_divTbnumbnum(a, q);
    }
   G0510:
    a = car(q);
    if(!is_integer(a)) goto    G0515;
#define LL_CmaxformC LITERAL[29]
    if(a < value(LL_CmaxformC)) goto    G0517;
    q = LITERAL[28];
    a = mkfxat(3);
    goto    G0540;
   G0517:
    if(a < value(LL_CmaxcanoC)) goto    G0518;
    a = q;
    a = CC_recipTform(a);
    q = a;
    a = w1;
    {
        popv(2);
        return  CC_timesTbnumform(a, q);
    }
   G0518:
#define LL_Hdivmode LITERAL[30]
    a = value(LL_Hdivmode);
#define LL_div LITERAL[31]
    if(a != LL_div) goto    G0520;
    a = car(q);
    if(a != value(LL_CratfC)) goto    G0522;
    a = q;
    a = CC_recipTratf(a);
    w2 = a;
    if(!is_number(a)) goto    G0530;
    goto    G0545;
   G0522:
    a = q;
    a = CC_recipTpol32ratf(a);
    goto    G0530;
   G0520:
#define LL_undiv LITERAL[32]
    if(a != LL_undiv) goto    G0528;
    a = q;
    a = CC_unrecipTcano(a);
    q = a;
    goto    G0544;
   G0528:
    a = q;
    a = CC_recipTcano(a);
    w2 = a;
    if(is_number(a)) goto    G0545;
   G0530:
    q = a;
    goto    G0546;
   G0515:
    q = LL_BctypeB;
    a = Lget(a, q);
    if(a != LL_rat) goto    G0532;
    a = w2;
    a = CC_recipTpref(a);
    w2 = a;
    if(!is_number(a)) goto    G0534;
   G0545:
    q = a;
    a = w1;
    {
        popv(2);
        return  CC_multTbnumbnum(a, q);
    }
   G0534:
    a = car(a);
    if(!is_integer(a)) goto    G0535;
    q = w2;
   G0546:
    a = w1;
    {
        popv(2);
        return  CC_multTbnumcano(a, q);
    }
   G0535:
    q = w2;
   G0544:
    a = w1;
    {
        popv(2);
        return  CC_multTbnumpref(a, q);
    }
   G0532:
    q = LITERAL[28];
    a = mkfxat(3);
   G0540:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
}

Sex CC_ratioTcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0550;
    if(!is_number(q)) goto    G0571;
    {
        popv(2);
        return  CC_quotiTcanobnum(a, q);
    }
   G0550:
    a = car(q);
    if(!is_integer(a)) goto    G0554;
    if(a >= value(LL_CmaxformC)) goto    G0571;
    if(a < value(LL_CmaxcanoC)) goto    G0557;
    a = q;
    a = CC_recipTform(a);
    q = a;
    a = w1;
    {
        popv(2);
        return  CC_timesTcanoform(a, q);
    }
   G0557:
    a = value(LL_Hdivmode);
    if(a != LL_div) goto    G0559;
    a = car(q);
    if(a != value(LL_CratfC)) goto    G0561;
    a = q;
    a = CC_recipTratf(a);
    w2 = a;
    if(!is_number(a)) goto    G0569;
    goto    G0583;
   G0561:
    a = q;
    a = CC_recipTpol32ratf(a);
    goto    G0569;
   G0559:
    if(a != LL_undiv) goto    G0567;
    a = q;
    a = CC_unrecipTcano(a);
    q = a;
    goto    G0582;
   G0567:
    a = q;
    a = CC_recipTcano(a);
    w2 = a;
    if(is_number(a)) goto    G0583;
   G0569:
    q = a;
    goto    G0584;
   G0554:
    q = LL_BctypeB;
    a = Lget(a, q);
    if(a != LL_rat) goto    G0571;
    a = w2;
    a = CC_recipTpref(a);
    w2 = a;
    if(!is_number(a)) goto    G0573;
   G0583:
    q = w1;
    {
        popv(2);
        return  CC_multTbnumcano(a, q);
    }
   G0573:
    a = car(a);
    if(!is_integer(a)) goto    G0574;
    q = w2;
   G0584:
    a = w1;
    {
        popv(2);
        return  CC_timesTcanocano(a, q);
    }
   G0574:
    q = w2;
   G0582:
    a = w1;
    {
        popv(2);
        return  CC_timesTcanopref(a, q);
    }
   G0571:
    q = LITERAL[28];
    a = mkfxat(3);
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
}

Sex CC_ratioTpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0588;
    if(!is_number(q)) goto    G0609;
    {
        popv(2);
        return  CC_quotiTprefbnum(a, q);
    }
   G0588:
    a = car(q);
    if(!is_integer(a)) goto    G0592;
    if(a >= value(LL_CmaxformC)) goto    G0609;
    if(a < value(LL_CmaxcanoC)) goto    G0595;
    a = q;
    a = CC_recipTform(a);
    q = a;
    a = w1;
    {
        popv(2);
        return  CC_timesTprefform(a, q);
    }
   G0595:
    a = value(LL_Hdivmode);
    if(a != LL_div) goto    G0597;
    a = car(q);
    if(a != value(LL_CratfC)) goto    G0599;
    a = q;
    a = CC_recipTratf(a);
    w2 = a;
    if(!is_number(a)) goto    G0607;
    goto    G0622;
   G0599:
    a = q;
    a = CC_recipTpol32ratf(a);
    goto    G0607;
   G0597:
    if(a != LL_undiv) goto    G0605;
    a = q;
    a = CC_unrecipTcano(a);
    q = a;
    goto    G0621;
   G0605:
    a = q;
    a = CC_recipTcano(a);
    w2 = a;
    if(is_number(a)) goto    G0622;
   G0607:
    q = w1;
    goto    G0623;
   G0592:
    q = LL_BctypeB;
    a = Lget(a, q);
    if(a != LL_rat) goto    G0609;
    q = w2;
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G0611;
    a = mkfxat(1);
    goto    G0615;
   G0611:
    a = w2;
    a = CC_recipTpref(a);
    w2 = a;
    if(!is_number(a)) goto    G0612;
   G0622:
    q = w1;
    {
        popv(2);
        return  CC_multTbnumpref(a, q);
    }
   G0612:
    a = car(a);
    if(!is_integer(a)) goto    G0613;
    q = w1;
    a = w2;
   G0623:
    {
        popv(2);
        return  CC_timesTcanopref(a, q);
    }
   G0613:
    q = w2;
   G0621:
    a = w1;
    {
        popv(2);
        return  CC_timesTprefpref(a, q);
    }
   G0609:
    q = LITERAL[28];
    a = mkfxat(3);
    a = CC_errormsg(a, q);
   G0615:
    popv(2);
    return a;
}

Sex CC_quotiTbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0627;
    if(is_number(q)) goto    G0629;
    q = LITERAL[33];
    a = mkfxat(3);
    goto    G0636;
   G0629:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G0630;
    q = LITERAL[33];
    a = mkfxat(6);
    goto    G0636;
   G0630:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_flgdivTbnumbnum(a, q);
    }
   G0627:
    a = Lzerop(a);
    if(a == nil) goto    G0632;
    a = mkfxat(0);
    goto    G0634;
   G0632:
    if(car(w2) < value(LL_CmaxcanoC)) goto    G0633;
    q = LITERAL[33];
    a = mkfxat(3);
   G0636:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0633:
    q = w2;
    a = w1;
    a = CC_quotiTbnumcano(a, q);
   G0634:
    popv(2);
    return a;
}

Sex CC_quotiTcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G0640;
    if(is_number(q)) goto    G0642;
    q = LITERAL[33];
    a = mkfxat(3);
    goto    G0656;
   G0642:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G0643;
    q = LITERAL[33];
    a = mkfxat(6);
    goto    G0656;
   G0643:
    q = w2;
    a = w1;
    a = CC_quotiTcanobnum(a, q);
    w1 = a;
    if(a != nil) goto    G0652;
    q = LITERAL[33];
    a = mkfxat(7);
    goto    G0656;
   G0640:
    if(car(q) < value(LL_CmaxcanoC)) goto    G0646;
    q = LITERAL[33];
    a = mkfxat(3);
   G0656:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0646:
    a = car(q);
#define LL_CpolyC LITERAL[34]
    if(a != value(LL_CpolyC)) goto    G0647;
    a = w1;
    {
        popv(2);
        return  CC_quotiTcanocano(a, q);
    }
   G0647:
#define LL_CalgnC LITERAL[35]
    if(a != value(LL_CalgnC)) goto    G0648;
    a = q;
    a = CC_recipTalgn(a);
    goto    G0658;
   G0648:
#define LL_CalgfC LITERAL[36]
    if(a != value(LL_CalgfC)) goto    G0650;
    a = q;
    a = CC_recipTalgf(a);
    goto    G0658;
   G0650:
    a = q;
    a = CC_recipTratf(a);
   G0658:
    q = a;
    a = w1;
    a = CC_multTcanocano(a, q);
   G0652:
    popv(2);
    return a;
}

Sex CC_addTbnumpref(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G0662;
    a = w2;
    goto    G0664;
   G0662:
    a = car(w2);
    if(a != LL_cL) goto    G0663;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_addTbnumcL(a, q);
    }
   G0663:
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    m = a;
    q = w1;
    a = LL_cL;
    a = Llist3(a, q, m);
   G0664:
    popv(2);
    return a;
}

Sex CC_addTcanopref(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(q);
    if(a != LL_cL) goto    G0669;
    a = w1;
    {
        popv(2);
        return  CC_addTcanocL(a, q);
    }
   G0669:
    w2 = q;
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    m = a;
    q = w1;
    a = LL_cL;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
}

Sex CC_addTprefpref(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G0675;
    a = car(q);
    if(a != LL_cL) goto    G0677;
    a = w1;
    {
        popv(3);
        return  CC_addTcLcL(a, q);
    }
   G0677:
    w2 = q;
    q = w1;
    a = w2;
    goto    G0692;
   G0675:
    if(a != LL_cH) goto    G0679;
    a = car(q);
    if(a != LL_cL) goto    G0681;
    a = w1;
    goto    G0692;
   G0681:
    if(a == LL_cH) goto    G0693;
    w2 = q;
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    w3 = a;
    q = mkfxat(1);
    a = w1;
    goto    G0694;
   G0679:
    a = car(q);
    if(a != LL_cL) goto    G0686;
    a = w1;
   G0692:
    {
        popv(3);
        return  CC_addTcHcL(a, q);
    }
   G0686:
#define LL_ncH LITERAL[37]
    if(a != LL_ncH) goto    G0687;
   G0693:
    a = w1;
    {
        popv(3);
        return  CC_addTcHcH(a, q);
    }
   G0687:
    w2 = q;
    q = mkfxat(1);
    a = w1;
    a = cons(a, q);
    w3 = a;
    q = mkfxat(1);
    a = w2;
   G0694:
    a = cons(a, q);
    m = a;
    q = w3;
    a = LL_cL;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
}

Sex CC_addTbnumcL(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = car(cdr(q));
    w2 = q;
    if(!is_number(a)) goto    G0698;
    q = a;
    a = w1;
    a = CC_addTbnumbnum(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0707;
    goto    G0714;
   G0698:
    a = car(a);
    if(!is_integer(a)) goto    G0705;
    q = car(cdr(q));
    a = w1;
    a = CC_addTbnumcano(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0707;
   G0714:
    q = cdr(cdr(w2));
    a = LL_cL;
    a = cons(a, q);
    {
        popv(2);
        return  CC_reduceTcL(a);
    }
   G0707:
    q = cdr(cdr(w2));
    goto    G0716;
   G0705:
    q = cdr(q);
   G0716:
    a = w1;
    a = cons(a, q);
    q = LL_cL;
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_addTcanocL(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = car(cdr(q));
    w2 = q;
    if(!is_number(a)) goto    G0720;
    q = w1;
    a = CC_addTbnumcano(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0729;
    goto    G0736;
   G0720:
    a = car(a);
    if(!is_integer(a)) goto    G0727;
    q = car(cdr(q));
    a = w1;
    a = CC_addTcanocano(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0729;
   G0736:
    q = cdr(cdr(w2));
    a = LL_cL;
    a = cons(a, q);
    {
        popv(2);
        return  CC_reduceTcL(a);
    }
   G0729:
    q = cdr(cdr(w2));
    goto    G0738;
   G0727:
    q = cdr(q);
   G0738:
    a = w1;
    a = cons(a, q);
    q = LL_cL;
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_addTcHcH(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    arg4 = mkfxat(1);
    m = q;
    q = mkfxat(1);
    a = CC_unifyRMS(a, q, m, arg4);
    value(LL_Htemporal) = a;
    if(a != CHAR_OF(62)) goto    G0742;
    q = mkfxat(1);
    a = w1;
    a = cons(a, q);
    w3 = a;
    q = mkfxat(1);
    a = w2;
    goto    G0756;
   G0742:
    if(a != CHAR_OF(60)) goto    G0745;
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    w3 = a;
    q = mkfxat(1);
    a = w1;
   G0756:
    a = cons(a, q);
    m = a;
    q = w3;
    a = LL_cL;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
   G0745:
    if(a != CHAR_OF(61)) goto    G0748;
    q = mkfxat(2);
    a = w1;
    a = cons(a, q);
    q = a;
    goto    G0757;
   G0748:
    a = CC_Wncan(a);
    if(a == nil) goto    G0750;
    a = value(LL_Htemporal);
    goto    G0755;
   G0750:
    a = cdr(value(LL_Htemporal));
    a = Lonep(a);
    if(a == nil) goto    G0751;
    a = car(value(LL_Htemporal));
    goto    G0755;
   G0751:
    q = LL_cL;
    a = car(car(value(LL_Htemporal)));
    a = Lneq(a, q);
    if(a == nil) goto    G0752;
    q = value(LL_Htemporal);
   G0757:
    a = LL_cL;
    {
        popv(3);
        return  Llist2(a, q);
    }
   G0752:
    a = cdr(value(LL_Htemporal));
    if(!is_number(a)) goto    G0753;
    q = car(value(LL_Htemporal));
    {
        popv(3);
        return  CC_multTbnumcL(a, q);
    }
   G0753:
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0754;
    q = car(value(LL_Htemporal));
    a = cdr(value(LL_Htemporal));
    {
        popv(3);
        return  CC_multH(a, q);
    }
   G0754:
    q = car(value(LL_Htemporal));
    a = cdr(value(LL_Htemporal));
    a = CC_unmultH(a, q);
   G0755:
    popv(3);
    return a;
}

Sex CC_addTcHcL(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    a = mkfxat(1);
    w6 = a;
    w2 = q;
   G0761:
    a = LL_cL;
    a = Lncons(a);
    w5 = a;
    w3 = a;
    w4 = nil;
    a = car(cdr(w2));
    w7 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G0766;
    a = w7;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
   G0766:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0770;
    q = w6;
    a = w1;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    goto    G0803;
   G0770:
    arg4 = cdr(car(a));
    m = car(car(a));
    q = w6;
    a = w1;
    a = CC_unifyRMS(a, q, m, arg4);
    w7 = a;
    if(a != CHAR_OF(60)) goto    G0773;
    a = w5;
    w4 = a;
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G0766;
   G0773:
    if(a != CHAR_OF(62)) goto    G0776;
    q = w6;
    a = w1;
    a = cons(a, q);
    q = w2;
    a = cons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = w3;
    goto    G0760;
   G0776:
    if(a != CHAR_OF(61)) goto    G0779;
    a = car(w1);
    q = cdr(car(w2));
    if(a != LL_cH) goto    G0781;
    a = w6;
    a = CC_addTbnumbnum(a, q);
    goto    G0782;
   G0781:
    a = w6;
    a = CC_addH(a, q);
   G0782:
    w6 = a;
    a = cdr(w2);
    w2 = a;
    a = w6;
    a = Lzerop(a);
    if(a != nil) goto    G0784;
    q = w6;
    a = w1;
    a = cons(a, q);
    q = w2;
    a = cons(a, q);
    w2 = a;
   G0784:
    q = w2;
   G0803:
    a = w5;
    goto    G0804;
   G0779:
    if(is_number(a)) goto    G0787;
    a = car(a);
    if(!is_integer(a)) goto    G0786;
   G0787:
    q = w3;
    a = w7;
    a = CC_seTaddTncancL(a, q);
    w5 = a;
    a = CC_tail(a);
    q = cdr(w2);
   G0804:
    cdr(a) = q;
    goto    G0764;
   G0786:
    q = LL_cL;
    a = car(a);
    a = Lneq(a, q);
    if(a != nil) goto    G0805;
    a = cdr(w7);
    if(!is_number(a)) goto    G0791;
    q = car(w7);
    a = CC_multTbnumcL(a, q);
    goto    G0793;
   G0791:
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    q = car(w7);
    if(a == nil) goto    G0792;
    a = cdr(w7);
    a = CC_multH(a, q);
    goto    G0793;
   G0805:
    a = car(w7);
    w1 = a;
    a = cdr(w7);
    w6 = a;
    a = car(w5);
    if(!is_cons(a)) goto    G0766;
    a = car(a);
    if(is_integer(a)) goto    G0766;
    q = a;
    a = w1;
    a = CC_Worder(a, q);
    if(a == nil) goto    G0766;
    a = w4;
    if(a == nil) goto    G0799;
    a = car(a);
    if(!is_cons(a)) goto    G0800;
    a = car(a);
    if(is_integer(a)) goto    G0800;
    q = a;
    a = w1;
    a = CC_Worder(a, q);
    if(a != nil) goto    G0799;
   G0800:
    q = cdr(w2);
    a = car(w5);
    a = cons(a, q);
    q = LL_cL;
    a = Lxcons(a, q);
    w2 = a;
    q = nil;
    a = w4;
    cdr(a) = q;
    w5 = a;
    w4 = nil;
    goto    G0766;
   G0799:
    q = cdr(w2);
    a = w5;
    cdr(a) = q;
    a = w3;
    w2 = a;
    goto    G0761;
   G0792:
    a = cdr(w7);
    a = CC_unmultH(a, q);
   G0793:
    w7 = a;
    a = cdr(w2);
    a = CC_topcopy(a);
    q = a;
    a = w5;
    cdr(a) = q;
    m = nil;
    q = w3;
    a = w7;
    CC_seTaddTcLcL(a, q, m);
   G0764:
    a = w3;
    a = CC_reduceTcL(a);
   G0760:
    popv(7);
    return a;
}

Sex CC_addTcLcL(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Llength(a);
    w3 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w3;
    a = Lleq(a, q);
    if(a == nil) goto    G0809;
    a = w2;
    a = CC_topcopy(a);
    w2 = a;
    m = nil;
    q = a;
    a = w1;
    CC_seTaddTcLcL(a, q, m);
    a = w2;
    goto    G0815;
   G0809:
    a = w1;
    a = CC_topcopy(a);
    w1 = a;
    m = nil;
    q = a;
    a = w2;
    CC_seTaddTcLcL(a, q, m);
    a = w1;
   G0815:
    {
        popv(3);
        return  CC_seTredcoefTcL(a);
    }
}

Sex CC_unaddTcHcH(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_orderRMS(a, q);
    value(LL_Htemporal) = a;
    if(a != CHAR_OF(61)) goto    G0819;
    q = mkfxat(2);
    a = w1;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(3);
        return  Llist2(a, q);
    }
   G0819:
    q = mkfxat(1);
    if(a != CHAR_OF(62)) goto    G0821;
    a = w1;
    a = cons(a, q);
    w3 = a;
    q = mkfxat(1);
    a = w2;
    goto    G0827;
   G0821:
    a = w2;
    a = cons(a, q);
    w3 = a;
    q = mkfxat(1);
    a = w1;
   G0827:
    a = cons(a, q);
    m = a;
    q = w3;
    a = LL_cL;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
}

Sex CC_unaddTcHcL(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w5 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a != nil) goto    G0853;
    a = w5;
   G0833:
    if(a != nil) goto    G0837;
    q = mkfxat(1);
    a = w1;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    goto    G0849;
   G0837:
    q = car(car(a));
    a = w1;
    a = CC_orderRMS(a, q);
    w6 = a;
    if(a != CHAR_OF(62)) goto    G0841;
    q = mkfxat(1);
    a = w1;
    a = cons(a, q);
    q = w5;
    a = cons(a, q);
    q = a;
    goto    G0855;
   G0841:
    if(a != CHAR_OF(60)) goto    G0844;
   G0853:
    a = car(w5);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    goto    G0833;
   G0844:
    q = cdr(car(w5));
    a = mkfxat(1);
    a = CC_addH(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0847;
    q = cdr(w5);
    goto    G0855;
   G0847:
    q = w6;
    a = w1;
    a = cons(a, q);
    q = cdr(w5);
    a = cons(a, q);
    q = a;
   G0855:
    a = w4;
    cdr(a) = q;
   G0849:
    a = w3;
    {
        popv(6);
        return  CC_reduceTcL(a);
    }
}

Sex CC_unaddTcLcL(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Llength(a);
    w3 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w3;
    a = Lleq(a, q);
    if(a == nil) goto    G0859;
    a = w2;
    a = CC_topcopy(a);
    w2 = a;
    m = nil;
    q = a;
    a = w1;
    CC_seTunaddTcLcL(a, q, m);
    a = w2;
    goto    G0865;
   G0859:
    a = w1;
    a = CC_topcopy(a);
    w1 = a;
    m = nil;
    q = a;
    a = w2;
    CC_seTunaddTcLcL(a, q, m);
    a = w1;
   G0865:
    {
        popv(3);
        return  CC_seTredcoefTcL(a);
    }
}

Sex CC_Kexponent(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(!is_number(a)) goto    G0869;
    {
        popv(2);
        return  Lminus(a);
    }
   G0869:
    w2 = nil;
    value(LL_Hmod) = nil;
    a = car(a);
    if(!is_integer(a)) goto    G0873;
    a = w1;
    a = CC_negTcano(a);
    goto    G0875;
   G0873:
    if(a != LL_cL) goto    G0874;
    a = w1;
    a = CC_negTcL(a);
    goto    G0875;
   G0874:
    a = w1;
    a = CC_negTcH(a);
   G0875:
    w2 = a;
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = w2;
    popv(2);
    return a;
}

Sex CC_negTcH(Sex a)
{
    Sex q;
    q = mkfxat(-1);
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        return  Llist2(a, q);
    }
}

Sex CC_negTcL(Sex a)
{
    Sex q;
    q = a;
    a = mkfxat(-1);
    {
        return  CC_multTbnumcL(a, q);
    }
}

Sex CC_multTbnumpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G0884;
    a = mkfxat(0);
    goto    G0887;
   G0884:
    a = car(w2);
    if(a != LL_cL) goto    G0885;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_multTbnumcL(a, q);
    }
   G0885:
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0886;
    a = w2;
    goto    G0887;
   G0886:
    q = w1;
    a = w2;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G0887:
    popv(2);
    return a;
}

Sex CC_multTcanopref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(q);
    if(a != LL_cL) goto    G0892;
    a = w1;
    {
        popv(2);
        return  CC_multTcanocL(a, q);
    }
   G0892:
    if(a != LL_cH) goto    G0893;
    a = w1;
    {
        popv(2);
        return  CC_multTcanocH(a, q);
    }
   G0893:
    w2 = q;
    q = w1;
    a = w2;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(2);
        return  Llist2(a, q);
    }
}

Sex CC_multTprefpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G0899;
    a = car(q);
    if(a != LL_cL) goto    G0901;
    a = w1;
    {
        popv(2);
        return  CC_multTcLcL(a, q);
    }
   G0901:
    if(a != LL_cH) goto    G0902;
    w2 = q;
    q = w1;
    a = w2;
    goto    G0917;
   G0902:
    a = w1;
    {
        popv(2);
        return  CC_multTcLncH(a, q);
    }
   G0899:
    if(a != LL_cH) goto    G0904;
    a = car(q);
    if(a != LL_cL) goto    G0906;
    a = w1;
   G0917:
    {
        popv(2);
        return  CC_multTcHcL(a, q);
    }
   G0906:
    if(a != LL_cH) goto    G0907;
    a = value(LL_Hexpmode);
#define LL_exp LITERAL[38]
    if(a != LL_exp) goto    G0909;
    a = w1;
    {
        popv(2);
        return  CC_multTcHcH(a, q);
    }
   G0909:
    a = w1;
    {
        popv(2);
        return  CC_stmultTcHcH(a, q);
    }
   G0907:
    w2 = q;
    q = w1;
    a = w2;
    goto    G0918;
   G0904:
    a = car(q);
    if(a != LL_cL) goto    G0913;
    a = w1;
    {
        popv(2);
        return  CC_multTncHcL(a, q);
    }
   G0913:
    if(a != LL_ncH) goto    G0914;
    a = w1;
    {
        popv(2);
        return  CC_multTncHncH(a, q);
    }
   G0914:
    a = w1;
   G0918:
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(2);
        return  Llist2(a, q);
    }
}

Sex CC_multTbnumcL(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = Lonep(a);
    if(a == nil) goto    G0922;
    a = w2;
    goto    G0923;
   G0922:
    q = w2;
    a = w1;
    a = CC_qmultTbnumcL(a, q);
    a = CC_seTredcoefTcL(a);
   G0923:
    popv(2);
    return a;
}

Sex CC_multTcanocH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = nil;
    w2 = q;
    a = CC_convTcano2cterm(a);
    w3 = a;
    a = car(a);
    w1 = a;
    a = cdr(w3);
    w3 = a;
#define LL_stexp LITERAL[39]
    q = LL_stexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    q = w2;
    if(a == nil) goto    G0929;
    a = w1;
    a = CC_multTcHcH(a, q);
    goto    G0930;
   G0929:
    a = w1;
    a = CC_stmultTcHcH(a, q);
   G0930:
    w2 = a;
    a = w3;
    a = Lonep(a);
    if(a == nil) goto    G0932;
    a = w2;
    goto    G0927;
   G0932:
    a = w2;
    if(!is_number(a)) goto    G0933;
    q = a;
    a = w3;
    {
        popv(3);
        return  CC_multTbnumbnum(a, q);
    }
   G0933:
    a = car(a);
    if(!is_integer(a)) goto    G0934;
    q = w2;
    a = w3;
    {
        popv(3);
        return  CC_multTbnumcano(a, q);
    }
   G0934:
    q = w2;
    a = w3;
    a = CC_multTbnumpref(a, q);
   G0927:
    popv(3);
    return a;
}

Sex CC_multTcanocL(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    w5 = a;
    if(!is_number(a)) goto    G0943;
    q = w1;
    a = CC_multTbnumcano(a, q);
    goto    G0970;
   G0943:
    a = car(a);
    if(!is_integer(a)) goto    G0947;
    q = w1;
    a = w5;
    a = CC_multTcanocano(a, q);
   G0970:
    w5 = a;
    a = cdr(w2);
    w2 = a;
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G0947;
    a = w5;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0947:
    a = car(car(car(w2)));
    if(a == LL_cH) goto    G0941;
    q = cdr(car(w2));
    a = w1;
    a = CC_multH(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0952;
    q = w5;
    a = car(car(w2));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0952:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0947;
    a = w3;
    {
        popv(5);
        return  CC_reduceTcL(a);
    }
   G0941:
    a = w1;
    a = CC_convTcano2cterm(a);
    w5 = a;
    q = w2;
    a = LL_cL;
    a = cons(a, q);
    w2 = a;
    a = value(LL_Hexpmode);
    arg5 = w2;
    arg4 = w5;
    if(a != LL_exp) goto    G0961;
#define LL_multTctermcterm LITERAL[40]
    m = LL_multTctermcterm;
    goto    G0971;
   G0961:
#define LL_stmultTctermcterm LITERAL[41]
    m = LL_stmultTctermcterm;
   G0971:
    q = nil;
    a = nil;
    a = CC_qmap3TxxcL(a, q, m, arg4, arg5);
    a = cdr(a);
    w2 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a != nil) goto    G0964;
    q = w2;
    a = w4;
    goto    G0972;
   G0964:
    q = w3;
    a = car(w2);
    CC_seTaddTncancL(a, q);
    a = w3;
    a = CC_tail(a);
    q = cdr(w2);
   G0972:
    cdr(a) = q;
    a = w3;
    {
        popv(5);
        return  CC_seTredcoefTcL(a);
    }
}

Sex CC_multTncHncH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = LL_ncH;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
   G0976:
    q = car(cdr(w1));
    a = car(w1);
    a = Llist2(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G0983;
    a = cdr(cdr(w4));
    w4 = a;
    goto    G0976;
   G0983:
    a = car(cdr(w4));
    w7 = a;
    if(!is_cons(a)) goto    G0985;
    a = car(a);
    if(!is_integer(a)) goto    G0985;
    a = car(w2);
    w7 = a;
    if(!is_cons(a)) goto    G0985;
    a = car(a);
    if(!is_integer(a)) goto    G0985;
    a = car(cdr(cdr(w4)));
    w7 = a;
    if(!is_integer(a)) goto    G0985;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G0985;
    a = car(cdr(w2));
    w7 = a;
    if(!is_integer(a)) goto    G0985;
    a = Labs(a);
    a = Lonep(a);
    if(a != nil) goto    G0979;
   G0985:
    q = car(w2);
    a = car(cdr(w4));
    a = Lequal(a, q);
    if(a != nil) goto    G0993;
    q = w2;
    a = cdr(cdr(w4));
    goto    G1023;
   G0993:
    q = car(cdr(w2));
    a = car(cdr(cdr(w4)));
    a = CC_addTexpt(a, q);
    w5 = a;
    a = cdr(cdr(w2));
    w2 = a;
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G1025;
    a = cdr(cdr(w4));
    w4 = a;
    q = w5;
    car(a) = q;
    q = w2;
    goto    G1023;
   G1025:
    q = nil;
    a = w4;
    cdr(a) = q;
    a = w2;
   G0996:
    if(a == nil) goto    G1013;
    a = w3;
    if(a == w4) goto    G1024;
    a = CC_tail3(a);
    w4 = a;
    goto    G0983;
   G0979:
    a = car(cdr(cdr(w4)));
    a = Lonep(a);
    if(a == nil) goto    G1002;
    a = car(cdr(w4));
    goto    G1003;
   G1002:
    a = car(cdr(w4));
    a = CC_recipTcano(a);
   G1003:
    w5 = a;
    a = car(cdr(w2));
    a = Lonep(a);
    if(a == nil) goto    G1005;
    a = car(w2);
    goto    G1006;
   G1005:
    a = car(w2);
    a = CC_recipTcano(a);
   G1006:
    q = a;
    a = w5;
    a = CC_multTcanocano(a, q);
    w7 = a;
    if(!is_cons(a)) goto    G1008;
    q = mkfxat(1);
    a = Llist2(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(cdr(w2));
    w2 = a;
    if(a == nil) goto    G1013;
    goto    G0983;
   G1008:
    a = w6;
    if(a == nil) goto    G1015;
    q = w7;
    a = CC_multH(a, q);
    goto    G1016;
   G1015:
    a = w7;
   G1016:
    w6 = a;
    q = nil;
    a = w4;
    cdr(a) = q;
    a = cdr(cdr(w2));
    w2 = a;
    goto    G0996;
   G1024:
    q = w2;
   G1023:
    cdr(a) = q;
   G1013:
    a = w3;
    a = CC_reduceTncH(a);
    w3 = a;
    a = w6;
    if(a == nil) goto    G1019;
    a = Lonep(a);
    if(a == nil) goto    G1018;
   G1019:
    a = w3;
    goto    G0975;
   G1018:
    q = w3;
    a = w6;
    a = CC_multH(a, q);
   G0975:
    popv(7);
    return a;
}

Sex CC_multTcHcH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = LL_cH;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    a = mkfxat(0);
    w8 = a;
   G1029:
    q = car(w2);
    a = car(w1);
    a = CC_orderRMS(a, q);
    w7 = a;
    if(a != CHAR_OF(62)) goto    G1034;
    a = car(cdr(w1));
    w5 = a;
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = car(w1);
    a = CC_Wmon4(a);
    if(a == nil) goto    G1041;
    a = w5;
    if(!is_integer(a)) goto    G1041;
    a = w8;
    a = Ladd1(a);
    w8 = a;
   G1041:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G1029;
    a = w2;
    goto    G1100;
   G1034:
    if(a != CHAR_OF(60)) goto    G1045;
    a = car(cdr(w2));
    w5 = a;
    a = Lncons(a);
    q = car(w2);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = car(w2);
    a = CC_Wmon4(a);
    if(a == nil) goto    G1052;
    a = w5;
    if(!is_integer(a)) goto    G1052;
    a = w8;
    a = Ladd1(a);
    w8 = a;
   G1052:
    a = cdr(cdr(w2));
    w2 = a;
    goto    G1101;
   G1045:
    a = car(w1);
    a = CC_Wmon4(a);
    if(a == nil) goto    G1056;
    a = car(cdr(w1));
    if(!is_integer(a)) goto    G1056;
    a = car(cdr(w2));
    if(!is_integer(a)) goto    G1056;
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = car(cdr(w2));
    a = Lncons(a);
    q = car(w2);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    q = mkfxat(2);
    a = w8;
    a = plus2(a, q);
    w8 = a;
    goto    G1066;
   G1056:
    q = car(cdr(w2));
    a = car(cdr(w1));
    a = CC_addTexpt(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1066;
    q = w5;
    a = car(w1);
    a = CC_chksimpTnfactr(a, q);
    w7 = a;
    if(a == nil) goto    G1069;
    a = w6;
    if(a == nil) goto    G1071;
    q = w7;
    a = CC_multTbnumbnum(a, q);
    goto    G1072;
   G1071:
    a = w7;
   G1072:
    w6 = a;
    goto    G1066;
   G1069:
    a = w5;
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
   G1066:
    a = cdr(cdr(w1));
    w1 = a;
    a = cdr(cdr(w2));
    w2 = a;
    a = w1;
    if(a == nil) goto    G1079;
    a = w2;
   G1101:
    if(a == nil) goto    G1083;
    goto    G1029;
   G1079:
    a = w2;
    if(a == nil) goto    G1083;
   G1100:
    w1 = a;
   G1083:
    a = w1;
    if(a == nil) goto    G1085;
    q = a;
    a = w4;
    cdr(a) = q;
   G1085:
    q = mkfxat(2);
    a = w8;
    a = Llessp(a, q);
    if(a != nil) goto    G1032;
    a = w1;
    if(a == nil) goto    G1089;
    a = CC_topcopy(a);
    q = a;
    a = w4;
    cdr(a) = q;
   G1089:
    a = w3;
    w4 = a;
   G1031:
    a = car(car(cdr(w4)));
    if(is_integer(a)) goto    G1092;
    a = cdr(cdr(w4));
    w4 = a;
    goto    G1031;
   G1092:
    a = w4;
    a = CC_seTunifymono(a);
    w7 = a;
    a = w6;
    if(a == nil) goto    G1094;
    q = w7;
    a = CC_multTbnumbnum(a, q);
    goto    G1095;
   G1094:
    a = w7;
   G1095:
    w6 = a;
   G1032:
    a = w3;
    a = CC_reduceTcH(a);
    w3 = a;
    a = w6;
    if(a == nil) goto    G1097;
    q = w3;
    {
        popv(8);
        return  CC_multH(a, q);
    }
   G1097:
    a = w3;
    popv(8);
    return a;
}

Sex CC_stmultTcHcH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    a = LL_cH;
    a = Lncons(a);
    w5 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
   G1105:
    q = car(w2);
    a = car(w1);
    a = CC_orderRMS(a, q);
    w9 = a;
    if(a != CHAR_OF(62)) goto    G1111;
    a = w5;
    w6 = a;
    w10 = a;
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
    a = cdr(cdr(w1));
    w1 = a;
    goto    G1138;
   G1111:
    if(a != CHAR_OF(60)) goto    G1117;
    a = w5;
    w6 = a;
    w10 = a;
    a = car(cdr(w2));
    a = Lncons(a);
    q = car(w2);
    a = Lxcons(a, q);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
    goto    G1179;
   G1117:
    a = car(w1);
    if(!is_cons(a)) goto    G1123;
    a = car(a);
    if(!is_integer(a)) goto    G1123;
    a = car(cdr(w1));
    w7 = a;
    if(!is_integer(a)) goto    G1123;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1123;
    a = car(cdr(w2));
    w9 = a;
    if(!is_integer(a)) goto    G1123;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1123;
    q = w9;
    a = w7;
    a = plus2(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G1123;
    a = w4;
    if(a != nil) goto    G1129;
    a = w5;
    w4 = a;
   G1129:
    a = w7;
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
    a = cdr(cdr(w1));
    w1 = a;
    a = w9;
    a = Lncons(a);
    q = car(w2);
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
    a = cdr(cdr(w2));
    w2 = a;
    goto    G1154;
   G1123:
    q = car(cdr(w2));
    a = car(cdr(w1));
    a = CC_addTexpt(a, q);
    w7 = a;
    w6 = nil;
    a = Lzerop(a);
    if(a != nil) goto    G1145;
    q = w7;
    a = car(w1);
    a = CC_chksimpTnfactr(a, q);
    w9 = a;
    if(a == nil) goto    G1141;
    a = w8;
    if(a == nil) goto    G1143;
    q = w9;
    a = CC_multTbnumbnum(a, q);
    goto    G1144;
   G1143:
    a = w9;
   G1144:
    w8 = a;
    goto    G1145;
   G1141:
    a = w5;
    w6 = a;
    w10 = a;
    a = w7;
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
   G1145:
    a = cdr(cdr(w1));
    w1 = a;
   G1179:
    a = cdr(cdr(w2));
    w2 = a;
   G1138:
    a = w4;
    if(a != nil) goto    G1154;
    a = w6;
    if(a == nil) goto    G1154;
    a = car(cdr(a));
    if(!is_cons(a)) goto    G1154;
    a = car(a);
    if(!is_integer(a)) goto    G1154;
    a = car(w5);
    if(!is_integer(a)) goto    G1154;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1154;
    a = w6;
    w4 = a;
   G1154:
    a = w1;
    if(a == nil) goto    G1158;
    a = w2;
    if(a == nil) goto    G1162;
    goto    G1105;
   G1158:
    a = w2;
    if(a != nil) goto    G1180;
   G1162:
    a = w1;
    if(a == nil) goto    G1108;
    a = car(cdr(a));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
    a = cdr(cdr(w1));
   G1180:
    w1 = a;
    goto    G1162;
   G1108:
    a = w4;
    if(a == nil) goto    G1170;
    a = cdr(cdr(cdr(a)));
    if(a == nil) goto    G1170;
    a = w4;
    a = CC_seTunifycano(a);
    w9 = a;
    a = w8;
    if(a == nil) goto    G1173;
    q = w9;
    a = CC_multTbnumbnum(a, q);
    goto    G1174;
   G1173:
    a = w9;
   G1174:
    w8 = a;
   G1170:
    a = w3;
    a = CC_reduceTcH(a);
    w3 = a;
    a = w8;
    if(a == nil) goto    G1176;
    q = w3;
    {
        popv(10);
        return  CC_multH(a, q);
    }
   G1176:
    a = w3;
    popv(10);
    return a;
}

Sex CC_multTncHcL(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G1184;
    q = w2;
    a = w1;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(5);
        return  Llist2(a, q);
    }
   G1184:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G1191;
    a = car(w2);
    w5 = a;
    a = cdr(w2);
    w2 = a;
   G1191:
    a = car(car(car(w2)));
    if(a == LL_cH) goto    G1197;
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1191;
   G1197:
    a = w5;
    if(a == nil) goto    G1199;
    q = w2;
    a = cons(a, q);
    goto    G1200;
   G1199:
    a = w2;
   G1200:
    q = LL_cL;
    a = Lxcons(a, q);
    a = CC_reduceTcL(a);
    w5 = a;
    arg5 = w3;
    arg4 = w1;
    m = nil;
#define LL_multTncHnterm LITERAL[42]
    q = LL_multTncHnterm;
    a = nil;
    a = CC_map3TxxcL(a, q, m, arg4, arg5);
    w3 = a;
    a = w5;
    a = Lzerop(a);
    if(a == nil) goto    G1204;
    a = w3;
    goto    G1186;
   G1204:
    a = w5;
    a = Lonep(a);
    if(a == nil) goto    G1206;
    a = w1;
    goto    G1207;
   G1206:
    q = w5;
    a = w1;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G1207:
    w5 = a;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1210;
    q = w5;
    a = w3;
    {
        popv(5);
        return  CC_addH(a, q);
    }
   G1210:
    q = w5;
    a = w3;
    a = CC_unaddH(a, q);
   G1186:
    popv(5);
    return a;
}

Sex CC_multTcLncH(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G1216;
    q = w1;
    a = w2;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(5);
        return  Llist2(a, q);
    }
   G1216:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G1223;
    a = car(w1);
    w5 = a;
    a = cdr(w1);
    w1 = a;
   G1223:
    a = car(car(car(w1)));
    if(a == LL_cH) goto    G1229;
    a = car(w1);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1223;
   G1229:
    a = w5;
    if(a == nil) goto    G1231;
    q = w1;
    a = cons(a, q);
    goto    G1232;
   G1231:
    a = w1;
   G1232:
    q = LL_cL;
    a = Lxcons(a, q);
    a = CC_reduceTcL(a);
    w5 = a;
    arg5 = w2;
    arg4 = w3;
    m = nil;
#define LL_multTntermncH LITERAL[43]
    q = LL_multTntermncH;
    a = nil;
    a = CC_map3TcLxx(a, q, m, arg4, arg5);
    w3 = a;
    a = w5;
    a = Lzerop(a);
    if(a == nil) goto    G1236;
    a = w3;
    goto    G1218;
   G1236:
    a = w5;
    a = Lonep(a);
    if(a == nil) goto    G1238;
    a = w2;
    goto    G1239;
   G1238:
    q = w5;
    a = w2;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G1239:
    w5 = a;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1242;
    q = w5;
    a = w3;
    {
        popv(5);
        return  CC_addH(a, q);
    }
   G1242:
    q = w5;
    a = w3;
    a = CC_unaddH(a, q);
   G1218:
    popv(5);
    return a;
}

Sex CC_multTcHcL(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G1248;
    a = value(LL_Hexpmode);
    arg5 = w2;
    arg4 = w1;
    if(a != LL_exp) goto    G1250;
#define LL_multTcHcterm LITERAL[44]
    m = LL_multTcHcterm;
    goto    G1282;
   G1250:
#define LL_stmultTcHcterm LITERAL[45]
    m = LL_stmultTcHcterm;
   G1282:
    q = nil;
#define LL_multH LITERAL[46]
    a = LL_multH;
    {
        popv(6);
        return  CC_map3TxxcL(a, q, m, arg4, arg5);
    }
   G1248:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G1257;
    a = car(w2);
    w5 = a;
    a = cdr(w2);
    w2 = a;
   G1257:
    a = car(car(car(w2)));
    if(a == LL_cH) goto    G1255;
    q = cdr(car(w2));
    a = w1;
    a = CC_multH(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1260;
    q = w6;
    a = car(car(w2));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1260:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1257;
    a = w3;
    {
        popv(6);
        return  CC_reduceTcL(a);
    }
   G1255:
    a = w5;
    if(a == nil) goto    G1269;
    q = w2;
    a = cons(a, q);
    goto    G1270;
   G1269:
    a = w2;
   G1270:
    q = LL_cL;
    a = Lxcons(a, q);
    w2 = a;
    a = value(LL_Hexpmode);
    arg5 = w2;
    arg4 = w1;
    if(a != LL_exp) goto    G1273;
    m = LL_multTcHcterm;
    goto    G1283;
   G1273:
    m = LL_stmultTcHcterm;
   G1283:
    q = nil;
    a = LL_multH;
    a = CC_qmap3TxxcL(a, q, m, arg4, arg5);
    w5 = a;
    a = cdr(a);
    w5 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a != nil) goto    G1276;
    q = w5;
    a = w4;
    goto    G1284;
   G1276:
    q = w3;
    a = car(w5);
    CC_seTaddTncancL(a, q);
    a = w3;
    a = CC_tail(a);
    q = cdr(w5);
   G1284:
    cdr(a) = q;
    a = w3;
    {
        popv(6);
        return  CC_seTredcoefTcL(a);
    }
}

Sex CC_multTcLcL(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    a = cdr(cdr(a));
    if(a != nil) goto    G1288;
    a = cdr(cdr(q));
    if(a != nil) goto    G1288;
    a = car(cdr(w1));
    w1 = a;
    a = car(cdr(q));
    w2 = a;
    q = cdr(a);
    a = cdr(w1);
    a = CC_multH(a, q);
    w8 = a;
    q = car(w2);
    a = car(w1);
    a = CC_multTprefpref(a, q);
    q = a;
    a = w8;
    {
        popv(9);
        return  CC_multH(a, q);
    }
   G1288:
    a = w1;
    if(a != w2) goto    G1307;
    a = CC_splitTcL(a);
    w8 = a;
    a = car(a);
    w6 = a;
    w5 = a;
    a = cdr(w8);
    w2 = a;
    w1 = a;
    a = w5;
    if(a == nil) goto    G1311;
    a = w1;
    if(a == nil) goto    G1311;
    a = CC_reduceTcL(a);
    w2 = a;
    w1 = a;
    goto    G1311;
   G1307:
    a = CC_splitTcL(a);
    w8 = a;
    a = car(a);
    w5 = a;
    a = cdr(w8);
    w1 = a;
    a = w5;
    if(a == nil) goto    G1313;
    a = w1;
    if(a == nil) goto    G1313;
    a = CC_reduceTcL(a);
    w1 = a;
   G1313:
    a = w2;
    a = CC_splitTcL(a);
    w8 = a;
    a = car(a);
    w6 = a;
    a = cdr(w8);
    w2 = a;
    a = w6;
    if(a == nil) goto    G1311;
    a = w2;
    if(a == nil) goto    G1311;
    a = CC_reduceTcL(a);
    w2 = a;
   G1311:
    a = w5;
    if(a != nil) goto    G1431;
    a = w6;
    if(a == nil) goto    G1294;
    goto    G1344;
   G1431:
    a = w6;
    if(a == nil) goto    G1291;
    a = LL_cL;
    a = Lncons(a);
    w3 = a;
    a = cdr(w6);
    w4 = a;
   G1290:
    arg5 = car(w4);
    arg4 = w5;
    m = nil;
#define LL_multTntermnterm LITERAL[47]
    q = LL_multTntermnterm;
    a = nil;
    a = CC_qmap3TcLxx(a, q, m, arg4, arg5);
    w8 = a;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w3;
    if(a == nil) goto    G1326;
    a = w8;
    CC_seTaddTcLcL(a, q, m);
    goto    G1327;
   G1326:
    a = w8;
    CC_seTunaddTcLcL(a, q, m);
   G1327:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1290;
    a = w2;
    if(a != nil) goto    G1291;
    a = w1;
    if(a == nil) goto    G1425;
    goto    G1344;
   G1291:
    a = w2;
    if(!is_number(a)) goto    G1334;
    q = w5;
    a = CC_qmultTbnumcL(a, q);
    goto    G1335;
   G1334:
    arg5 = w5;
    arg4 = a;
    m = nil;
#define LL_multTcexprnterm LITERAL[48]
    q = LL_multTcexprnterm;
    a = nil;
    a = CC_qmap3TxxcL(a, q, m, arg4, arg5);
   G1335:
    w8 = a;
    a = w3;
    if(a != nil) goto    G1337;
    a = w8;
    w3 = a;
    goto    G1339;
   G1337:
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w3;
    if(a == nil) goto    G1338;
    a = w8;
    CC_seTaddTcLcL(a, q, m);
    goto    G1339;
   G1338:
    a = w8;
    CC_seTunaddTcLcL(a, q, m);
   G1339:
    a = w1;
    if(a == nil) goto    G1425;
    a = w6;
    if(a == nil) goto    G1353;
   G1344:
    a = w1;
    if(!is_number(a)) goto    G1346;
    q = w6;
    a = CC_qmultTbnumcL(a, q);
    goto    G1347;
   G1346:
    arg5 = w6;
    arg4 = a;
    m = nil;
    q = LL_multTcexprnterm;
    a = nil;
    a = CC_qmap3TxxcL(a, q, m, arg4, arg5);
   G1347:
    w8 = a;
    a = w3;
    if(a != nil) goto    G1349;
    a = w8;
    w3 = a;
    goto    G1351;
   G1349:
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w3;
    if(a == nil) goto    G1350;
    a = w8;
    CC_seTaddTcLcL(a, q, m);
    goto    G1351;
   G1350:
    a = w8;
    CC_seTunaddTcLcL(a, q, m);
   G1351:
    a = w2;
    if(a != nil) goto    G1353;
   G1425:
    a = w3;
    goto    G1429;
   G1353:
    a = w1;
    if(!is_cons(a)) goto    G1356;
    a = car(a);
    if(a != LL_cL) goto    G1356;
    a = w2;
    if(!is_cons(a)) goto    G1356;
    a = car(a);
    if(a == LL_cL) goto    G1294;
   G1356:
    q = w2;
    a = w1;
    a = CC_multH(a, q);
    a = CC_convTrat2qcL(a);
    w4 = a;
    goto    G1392;
   G1294:
    a = car(cdr(w1));
    w8 = a;
    if(!is_number(a)) goto    G1360;
    q = w2;
    a = CC_qmultTbnumcL(a, q);
    goto    G1427;
   G1360:
    a = car(a);
    if(!is_integer(a)) goto    G1366;
    q = w2;
    a = w8;
    a = CC_multTcanocL(a, q);
    a = CC_convTrat2qcL(a);
   G1427:
    w4 = a;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1392;
    q = LL_cL;
    a = Lxcons(a, q);
    w1 = a;
   G1366:
    a = car(cdr(w2));
    w8 = a;
    if(!is_number(a)) goto    G1368;
    q = w1;
    a = CC_qmultTbnumcL(a, q);
    goto    G1428;
   G1368:
    a = car(a);
    if(!is_integer(a)) goto    G1378;
    q = w1;
    a = w8;
    a = CC_multTcanocL(a, q);
    a = CC_convTrat2qcL(a);
   G1428:
    w6 = a;
    a = w4;
    if(a != nil) goto    G1373;
    a = w6;
    w4 = a;
    goto    G1375;
   G1373:
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w4;
    if(a == nil) goto    G1374;
    a = w6;
    CC_seTaddTcLcL(a, q, m);
    goto    G1375;
   G1374:
    a = w6;
    CC_seTunaddTcLcL(a, q, m);
   G1375:
    a = cdr(cdr(w2));
    if(a == nil) goto    G1392;
    q = LL_cL;
    a = Lxcons(a, q);
    w2 = a;
   G1378:
    a = w1;
    a = Llength(a);
    w9 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w9;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1380;
    a = w1;
    w8 = a;
    a = w2;
    w1 = a;
    a = w8;
    w2 = a;
   G1380:
    a = cdr(w1);
    w1 = a;
    a = w4;
    if(a != nil) goto    G1384;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
   G1384:
    a = value(LL_Hexpmode);
    if(a != LL_exp) goto    G1386;
    a = LL_multTctermcterm;
    goto    G1387;
   G1386:
    a = LL_stmultTctermcterm;
   G1387:
    w7 = a;
   G1297:
    arg5 = w2;
    arg4 = car(w1);
    m = w7;
    q = nil;
    a = nil;
    a = CC_qmap3TxxcL(a, q, m, arg4, arg5);
    w8 = a;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w4;
    if(a == nil) goto    G1389;
    a = w8;
    CC_seTaddTcLcL(a, q, m);
    goto    G1390;
   G1389:
    a = w8;
    CC_seTunaddTcLcL(a, q, m);
   G1390:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1297;
   G1392:
    a = w3;
    if(a == nil) goto    G1395;
    a = cdr(a);
    if(a != nil) goto    G1394;
   G1395:
    a = w4;
    goto    G1429;
   G1394:
    a = w4;
    if(a == nil) goto    G1399;
    a = cdr(a);
    if(a != nil) goto    G1398;
   G1399:
    a = w3;
   G1429:
    {
        popv(9);
        return  CC_seTredcoefTcL(a);
    }
   G1398:
    a = w3;
    a = CC_cLneck(a);
    w1 = a;
   G1299:
    a = cdr(w1);
    if(a == nil) goto    G1402;
    a = car(car(car(a)));
    if(a != LL_ncH) goto    G1402;
    a = cdr(w1);
    w1 = a;
    goto    G1299;
   G1402:
    a = cdr(w1);
    w2 = a;
    q = nil;
    a = w1;
    cdr(a) = q;
    a = w2;
    if(a == nil) goto    G1408;
    q = LL_cL;
    a = Lxcons(a, q);
    w2 = a;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w4;
    if(a == nil) goto    G1407;
    a = w2;
    CC_seTaddTcLcL(a, q, m);
    goto    G1408;
   G1407:
    a = w2;
    CC_seTunaddTcLcL(a, q, m);
   G1408:
    a = w4;
    CC_seTredcoefTcL(a);
    a = w4;
    a = CC_Wncan(a);
    if(a == nil) goto    G1410;
    q = w3;
    a = w4;
    goto    G1430;
   G1410:
    a = car(w4);
    if(a != LL_cH) goto    G1411;
    q = mkfxat(1);
    a = w4;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    goto    G1415;
   G1411:
    a = cdr(w4);
    w4 = a;
    a = car(a);
    w8 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G1417;
    a = cdr(w4);
    w4 = a;
    goto    G1420;
   G1417:
    w8 = nil;
   G1420:
    q = w4;
    a = w1;
    cdr(a) = q;
    a = w8;
    if(a == nil) goto    G1415;
    q = w3;
   G1430:
    CC_seTaddTncancL(a, q);
   G1415:
    a = w3;
    {
        popv(9);
        return  CC_reduceTcL(a);
    }
}

Sex CC_unmultTcanocano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Wmon4(a);
    if(a == nil) goto    G1435;
    a = w2;
    a = CC_Wmon4(a);
    if(a == nil) goto    G1435;
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_multTcanocano(a, q);
    }
   G1435:
    w3 = nil;
    w4 = nil;
    a = w1;
    a = CC_convTcano2cterm(a);
    w1 = a;
    a = w2;
    a = CC_convTcano2cterm(a);
    w2 = a;
    q = car(a);
    a = car(w1);
    a = CC_multTcHcH(a, q);
    w3 = a;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_multTbnumbnum(a, q);
    w4 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1440;
    a = mkfxat(0);
    goto    G1437;
   G1440:
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G1441;
    a = w3;
    goto    G1437;
   G1441:
    a = w3;
    if(!is_number(a)) goto    G1442;
    q = a;
    a = w4;
    {
        popv(4);
        return  CC_multTbnumbnum(a, q);
    }
   G1442:
    a = car(a);
    if(!is_integer(a)) goto    G1443;
    q = w3;
    a = w4;
    {
        popv(4);
        return  CC_multTbnumcano(a, q);
    }
   G1443:
    q = w4;
    a = w3;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G1437:
    popv(4);
    return a;
}

Sex CC_unmultTcanopref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(q);
    if(a != LL_cL) goto    G1450;
    a = w1;
    {
        popv(2);
        return  CC_unmultTcanocL(a, q);
    }
   G1450:
    if(a != LL_cH) goto    G1451;
    a = w1;
    {
        popv(2);
        return  CC_multTcanocH(a, q);
    }
   G1451:
    w2 = q;
    q = w1;
    a = w2;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(2);
        return  Llist2(a, q);
    }
}

Sex CC_unmultTprefpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G1457;
    a = car(q);
    if(a != LL_cL) goto    G1459;
    a = w1;
    {
        popv(2);
        return  CC_unmultTcLcL(a, q);
    }
   G1459:
    if(a != LL_cH) goto    G1460;
    w2 = q;
    q = w1;
    a = w2;
    goto    G1472;
   G1460:
    a = w1;
    {
        popv(2);
        return  CC_unmultTcLncH(a, q);
    }
   G1457:
    if(a != LL_cH) goto    G1462;
    a = car(q);
    if(a != LL_cL) goto    G1464;
    a = w1;
   G1472:
    {
        popv(2);
        return  CC_unmultTcHcL(a, q);
    }
   G1464:
    if(a != LL_cH) goto    G1465;
    a = w1;
    {
        popv(2);
        return  CC_multTcHcH(a, q);
    }
   G1465:
    w2 = q;
    q = w1;
    a = w2;
    goto    G1473;
   G1462:
    a = car(q);
    if(a != LL_cL) goto    G1468;
    a = w1;
    {
        popv(2);
        return  CC_unmultTncHcL(a, q);
    }
   G1468:
    if(a != LL_ncH) goto    G1469;
    a = w1;
    {
        popv(2);
        return  CC_multTncHncH(a, q);
    }
   G1469:
    a = w1;
   G1473:
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(2);
        return  Llist2(a, q);
    }
}

Sex CC_unmultTcanocL(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G1481;
    a = car(w2);
    w5 = a;
    a = cdr(w2);
    w2 = a;
   G1481:
    a = car(car(car(w2)));
    if(a == LL_cH) goto    G1478;
    q = w1;
    a = cdr(car(w2));
    a = CC_unmultH(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1484;
    q = w6;
    a = car(car(w2));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1484:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G1479;
    goto    G1481;
   G1478:
    a = w5;
    if(a == nil) goto    G1492;
    q = w2;
    a = cons(a, q);
    goto    G1493;
   G1492:
    a = w2;
   G1493:
    q = LL_cL;
    a = Lxcons(a, q);
    w2 = a;
    a = w1;
    a = CC_convTcano2cterm(a);
    w1 = a;
    a = w2;
    a = CC_convTcL2cnterm(a);
    w2 = a;
    q = a;
    a = w1;
    a = CC_multTctermcterm(a, q);
    w6 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a == nil) goto    G1496;
    a = car(w6);
    goto    G1497;
   G1496:
    q = car(w6);
    a = cdr(w6);
    a = CC_multH(a, q);
   G1497:
    w5 = a;
   G1479:
    a = w5;
    if(a == nil) goto    G1508;
    a = CC_Wncan(a);
    if(a == nil) goto    G1500;
    q = w3;
    a = w5;
    goto    G1510;
   G1500:
    q = LL_cL;
    a = car(w5);
    a = Lneq(a, q);
    if(a == nil) goto    G1501;
    q = mkfxat(1);
    a = w5;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    goto    G1508;
   G1501:
    a = cdr(w5);
    w5 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a != nil) goto    G1505;
    q = w5;
    a = w4;
    cdr(a) = q;
    goto    G1508;
   G1505:
    q = cdr(w5);
    a = w4;
    cdr(a) = q;
    q = w3;
    a = car(w5);
   G1510:
    CC_seTaddTncancL(a, q);
   G1508:
    a = w3;
    {
        popv(6);
        return  CC_reduceTcL(a);
    }
}

Sex CC_unmultTncHcL(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G1514;
    q = w2;
    a = w1;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(5);
        return  Llist2(a, q);
    }
   G1514:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = w2;
    a = CC_splitTcL(a);
    w5 = a;
    a = car(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
    a = w3;
    a = CC_convTcL2cnterm(a);
    w5 = a;
    q = car(a);
    a = w1;
    a = CC_multTncHncH(a, q);
    w3 = a;
    a = cdr(w5);
    a = Lonep(a);
    if(a != nil) goto    G1519;
    q = w3;
    a = cdr(w5);
    a = CC_unmultH(a, q);
    w3 = a;
   G1519:
    a = w4;
    if(a == nil) goto    G1522;
    a = CC_reduceTcL(a);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1521;
   G1522:
    a = w3;
    goto    G1516;
   G1521:
    a = w5;
    a = Lonep(a);
    if(a == nil) goto    G1525;
    a = w1;
    goto    G1526;
   G1525:
    q = w5;
    a = w1;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G1526:
    w4 = a;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1529;
    q = w4;
    a = w3;
    {
        popv(5);
        return  CC_addH(a, q);
    }
   G1529:
    q = w4;
    a = w3;
    a = CC_unaddH(a, q);
   G1516:
    popv(5);
    return a;
}

Sex CC_unmultTcLncH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G1535;
    q = w1;
    a = w2;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(5);
        return  Llist2(a, q);
    }
   G1535:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = w1;
    a = CC_splitTcL(a);
    w5 = a;
    a = car(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
    a = w3;
    a = CC_convTcL2cnterm(a);
    w5 = a;
    q = w2;
    a = car(a);
    a = CC_multTncHncH(a, q);
    w3 = a;
    a = cdr(w5);
    a = Lonep(a);
    if(a != nil) goto    G1540;
    q = w3;
    a = cdr(w5);
    a = CC_unmultH(a, q);
    w3 = a;
   G1540:
    a = w4;
    if(a == nil) goto    G1543;
    a = CC_reduceTcL(a);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1542;
   G1543:
    a = w3;
    goto    G1537;
   G1542:
    a = w5;
    a = Lonep(a);
    if(a == nil) goto    G1546;
    a = w2;
    goto    G1547;
   G1546:
    q = w5;
    a = w2;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G1547:
    w4 = a;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1550;
    q = w4;
    a = w3;
    {
        popv(5);
        return  CC_addH(a, q);
    }
   G1550:
    q = w4;
    a = w3;
    a = CC_unaddH(a, q);
   G1537:
    popv(5);
    return a;
}

Sex CC_unmultTcHcL(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w2 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G1560;
    a = car(w2);
    w5 = a;
    a = cdr(w2);
    w2 = a;
   G1560:
    a = car(car(car(w2)));
    if(a == LL_cH) goto    G1557;
    q = w1;
    a = cdr(car(w2));
    a = CC_unmultH(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1563;
    q = w6;
    a = car(car(w2));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1563:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G1558;
    goto    G1560;
   G1557:
    a = w5;
    if(a == nil) goto    G1571;
    q = w2;
    a = cons(a, q);
    goto    G1572;
   G1571:
    a = w2;
   G1572:
    q = LL_cL;
    a = Lxcons(a, q);
    a = CC_convTcL2cnterm(a);
    w2 = a;
    q = a;
    a = w1;
    a = CC_multTcHcterm(a, q);
    w6 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a == nil) goto    G1575;
    a = car(w6);
    goto    G1576;
   G1575:
    q = car(w6);
    a = cdr(w6);
    a = CC_multH(a, q);
   G1576:
    w5 = a;
   G1558:
    a = w5;
    if(a == nil) goto    G1587;
    a = CC_Wncan(a);
    if(a == nil) goto    G1579;
    q = w3;
    a = w5;
    goto    G1589;
   G1579:
    q = LL_cL;
    a = car(w5);
    a = Lneq(a, q);
    if(a == nil) goto    G1580;
    q = mkfxat(1);
    a = w5;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    goto    G1587;
   G1580:
    a = cdr(w5);
    w5 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a != nil) goto    G1584;
    q = w5;
    a = w4;
    cdr(a) = q;
    goto    G1587;
   G1584:
    q = cdr(w5);
    a = w4;
    cdr(a) = q;
    q = w3;
    a = car(w5);
   G1589:
    CC_seTaddTncancL(a, q);
   G1587:
    a = w3;
    {
        popv(6);
        return  CC_seTredcoefTcL(a);
    }
}

Sex CC_unmultTcLcL(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = cdr(cdr(a));
    if(a != nil) goto    G1593;
    a = cdr(cdr(q));
    if(a != nil) goto    G1593;
    a = car(cdr(w1));
    w1 = a;
    a = car(cdr(q));
    w2 = a;
    q = cdr(a);
    a = cdr(w1);
    a = CC_unmultH(a, q);
    w7 = a;
    q = car(w2);
    a = car(w1);
    a = CC_unmultTprefpref(a, q);
    q = a;
    a = w7;
    {
        popv(7);
        return  CC_unmultH(a, q);
    }
   G1593:
    a = w1;
    if(a != w2) goto    G1607;
    a = CC_splitTcL(a);
    w7 = a;
    a = car(a);
    w6 = a;
    w5 = a;
    a = cdr(w7);
    w2 = a;
    w1 = a;
    a = w5;
    if(a == nil) goto    G1611;
    a = w1;
    if(a == nil) goto    G1611;
    a = CC_reduceTcL(a);
    w2 = a;
    w1 = a;
    goto    G1611;
   G1607:
    a = CC_splitTcL(a);
    w7 = a;
    a = car(a);
    w5 = a;
    a = cdr(w7);
    w1 = a;
    a = w5;
    if(a == nil) goto    G1613;
    a = w1;
    if(a == nil) goto    G1613;
    a = CC_reduceTcL(a);
    w1 = a;
   G1613:
    a = w2;
    a = CC_splitTcL(a);
    w7 = a;
    a = car(a);
    w6 = a;
    a = cdr(w7);
    w2 = a;
    a = w6;
    if(a == nil) goto    G1611;
    a = w2;
    if(a == nil) goto    G1611;
    a = CC_reduceTcL(a);
    w2 = a;
   G1611:
    a = w1;
    if(a == nil) goto    G1643;
    a = w2;
    if(a == nil) goto    G1595;
    a = w1;
    if(is_number(a)) goto    G1627;
    q = LL_cL;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G1626;
   G1627:
    q = mkfxat(1);
    a = w7;
    a = cons(a, q);
    goto    G1628;
   G1626:
    a = w1;
    a = CC_convTcL2cnterm(a);
   G1628:
    w3 = a;
    a = w1;
    if(a != w2) goto    G1630;
    a = w3;
    goto    G1633;
   G1630:
    a = w2;
    if(is_number(a)) goto    G1632;
    q = LL_cL;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G1631;
   G1632:
    q = mkfxat(1);
    a = w7;
    a = cons(a, q);
    goto    G1633;
   G1631:
    a = w2;
    a = CC_convTcL2cnterm(a);
   G1633:
    w4 = a;
    q = cdr(a);
    a = cdr(w3);
    a = CC_multTbnumbnum(a, q);
    w7 = a;
    q = car(w4);
    a = car(w3);
    a = CC_unmultH(a, q);
    q = a;
    a = w7;
    a = CC_multH(a, q);
    a = CC_convTrat2qcL(a);
    w4 = a;
    w3 = nil;
    a = w6;
    if(a != nil) goto    G1595;
    a = w5;
    if(a == nil) goto    G1668;
    goto    G1645;
   G1595:
    a = w1;
    if(!is_number(a)) goto    G1640;
    q = w6;
    a = CC_qmultTbnumcL(a, q);
    goto    G1641;
   G1640:
    arg5 = w6;
    arg4 = a;
    m = nil;
#define LL_unmultTcexprnterm LITERAL[49]
    q = LL_unmultTcexprnterm;
    a = nil;
    a = CC_qmap3TxxcL(a, q, m, arg4, arg5);
   G1641:
    w3 = a;
    a = w5;
    if(a == nil) goto    G1598;
   G1643:
    a = w2;
    if(a == nil) goto    G1654;
   G1645:
    a = w2;
    if(!is_number(a)) goto    G1647;
    q = w5;
    a = CC_qmultTbnumcL(a, q);
    goto    G1648;
   G1647:
    arg5 = w5;
    arg4 = a;
    m = nil;
    q = LL_unmultTcexprnterm;
    a = nil;
    a = CC_qmap3TxxcL(a, q, m, arg4, arg5);
   G1648:
    w7 = a;
    a = w3;
    if(a != nil) goto    G1650;
    a = w7;
    goto    G1652;
   G1650:
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w3;
    if(a == nil) goto    G1651;
    a = w7;
    a = CC_seTaddTcLcL(a, q, m);
    goto    G1652;
   G1651:
    a = w7;
    a = CC_seTunaddTcLcL(a, q, m);
   G1652:
    w3 = a;
    a = w6;
    if(a == nil) goto    G1598;
   G1654:
    a = cdr(cdr(w5));
    if(a == nil) goto    G1656;
    a = w5;
    a = CC_convTcL2cnterm(a);
    goto    G1657;
   G1656:
    a = car(cdr(w5));
   G1657:
    w5 = a;
    a = cdr(cdr(w6));
    if(a == nil) goto    G1659;
    a = w6;
    a = CC_convTcL2cnterm(a);
    goto    G1660;
   G1659:
    a = car(cdr(w6));
   G1660:
    w6 = a;
    q = car(a);
    a = car(w5);
    a = CC_multTncHncH(a, q);
    w7 = a;
    q = cdr(w6);
    a = cdr(w5);
    a = CC_unmultH(a, q);
    q = a;
    a = w7;
    a = CC_unmultH(a, q);
    a = CC_convTrat2qcL(a);
    w7 = a;
    a = w3;
    if(a != nil) goto    G1663;
    a = w7;
    goto    G1665;
   G1663:
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w3;
    if(a == nil) goto    G1664;
    a = w7;
    a = CC_seTaddTcLcL(a, q, m);
    goto    G1665;
   G1664:
    a = w7;
    a = CC_seTunaddTcLcL(a, q, m);
   G1665:
    w3 = a;
   G1598:
    a = w3;
    if(a == nil) goto    G1668;
    a = cdr(a);
    if(a != nil) goto    G1667;
   G1668:
    a = w4;
    goto    G1699;
   G1667:
    a = w4;
    if(a == nil) goto    G1672;
    a = cdr(a);
    if(a != nil) goto    G1671;
   G1672:
    a = w3;
   G1699:
    {
        popv(7);
        return  CC_seTredcoefTcL(a);
    }
   G1671:
    a = w3;
    a = CC_cLneck(a);
    w1 = a;
   G1599:
    a = cdr(w1);
    if(a == nil) goto    G1675;
    a = car(car(car(a)));
    if(a != LL_ncH) goto    G1675;
    a = cdr(w1);
    w1 = a;
    goto    G1599;
   G1675:
    a = cdr(w1);
    w2 = a;
    q = nil;
    a = w1;
    cdr(a) = q;
    a = w2;
    if(a == nil) goto    G1681;
    q = LL_cL;
    a = Lxcons(a, q);
    w2 = a;
    q = LL_uncol;
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    m = true;
    q = w4;
    if(a == nil) goto    G1680;
    a = w2;
    CC_seTaddTcLcL(a, q, m);
    goto    G1681;
   G1680:
    a = w2;
    CC_seTunaddTcLcL(a, q, m);
   G1681:
    a = w4;
    CC_seTredcoefTcL(a);
    a = w4;
    a = CC_Wncan(a);
    if(a == nil) goto    G1683;
    q = w3;
    a = w4;
    goto    G1700;
   G1683:
    a = car(w4);
    if(a != LL_cH) goto    G1684;
    q = mkfxat(1);
    a = w4;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    goto    G1688;
   G1684:
    a = cdr(w4);
    w4 = a;
    a = car(a);
    w7 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G1690;
    a = cdr(w4);
    w4 = a;
    goto    G1693;
   G1690:
    w7 = nil;
   G1693:
    q = w4;
    a = w1;
    cdr(a) = q;
    a = w7;
    if(a == nil) goto    G1688;
    q = w3;
   G1700:
    CC_seTaddTncancL(a, q);
   G1688:
    a = w3;
    {
        popv(7);
        return  CC_reduceTcL(a);
    }
}

Sex CC_multTntermnterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = CC_multTncHncH(a, q);
    w3 = a;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_multH(a, q);
    w4 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1705;
    q = mkfxat(1);
    a = mkfxat(0);
    goto    G1713;
   G1705:
    a = w3;
    if(is_number(a)) goto    G1708;
    q = LL_ncH;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G1707;
   G1708:
    q = w4;
    a = w3;
    a = CC_multH(a, q);
    q = mkfxat(1);
    goto    G1713;
   G1707:
    q = w4;
    a = w3;
   G1713:
    {
        popv(4);
        return  cons(a, q);
    }
}

Sex CC_multTncHnterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    q = car(q);
    a = CC_multTncHncH(a, q);
    w1 = a;
    a = Lpairp(a);
    if(a == nil) goto    G1719;
    q = LL_ncH;
    a = car(w1);
    a = Leq(a, q);
   G1719:
    if(a != nil) goto    G1718;
    a = cdr(w2);
    if(!is_number(a)) goto    G1717;
   G1718:
    q = cdr(w2);
    a = w1;
    goto    G1725;
   G1717:
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    q = cdr(w2);
    if(a == nil) goto    G1720;
    a = w1;
    a = CC_multH(a, q);
    q = mkfxat(1);
    goto    G1725;
   G1720:
    a = w1;
    a = CC_unmultH(a, q);
    q = mkfxat(1);
   G1725:
    {
        popv(2);
        return  cons(a, q);
    }
}

Sex CC_multTntermncH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = car(a);
    a = CC_multTncHncH(a, q);
    w2 = a;
    a = Lpairp(a);
    if(a == nil) goto    G1731;
    q = LL_ncH;
    a = car(w2);
    a = Leq(a, q);
   G1731:
    if(a != nil) goto    G1730;
    a = cdr(w1);
    if(!is_number(a)) goto    G1729;
   G1730:
    q = cdr(w1);
    a = w2;
    goto    G1737;
   G1729:
    q = LL_unexp;
    a = value(LL_Hexpmode);
    a = Lneq(a, q);
    q = cdr(w1);
    if(a == nil) goto    G1732;
    a = w2;
    a = CC_multH(a, q);
    q = mkfxat(1);
    goto    G1737;
   G1732:
    a = w2;
    a = CC_unmultH(a, q);
    q = mkfxat(1);
   G1737:
    {
        popv(2);
        return  cons(a, q);
    }
}

Sex CC_multTcexprnterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    q = cdr(q);
    a = CC_multH(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1741;
    q = mkfxat(1);
    a = mkfxat(0);
    goto    G1744;
   G1741:
    q = w1;
    a = car(w2);
   G1744:
    {
        popv(2);
        return  cons(a, q);
    }
}

Sex CC_unmultTcexprnterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    q = cdr(q);
    a = CC_unmultH(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1748;
    q = mkfxat(1);
    a = mkfxat(0);
    goto    G1751;
   G1748:
    q = w1;
    a = car(w2);
   G1751:
    {
        popv(2);
        return  cons(a, q);
    }
}

Sex CC_multTcHnterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    q = cdr(q);
    a = CC_multH(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1755;
    q = mkfxat(1);
    a = mkfxat(0);
    goto    G1758;
   G1755:
    q = w1;
    a = car(w2);
   G1758:
    {
        popv(2);
        return  cons(a, q);
    }
}

Sex CC_unmultTcHnterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    q = cdr(q);
    a = CC_unmultH(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1762;
    q = mkfxat(1);
    a = mkfxat(0);
    goto    G1765;
   G1762:
    q = w1;
    a = car(w2);
   G1765:
    {
        popv(2);
        return  cons(a, q);
    }
}

Sex CC_multTctermcterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = CC_multTcHcH(a, q);
    w3 = a;
    q = cdr(w2);
    a = cdr(w1);
    a = times2(a, q);
    q = w3;
    {
        popv(3);
        return  Lxcons(a, q);
    }
}

Sex CC_stmultTctermcterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = CC_stmultTcHcH(a, q);
    w3 = a;
    q = cdr(w2);
    a = cdr(w1);
    a = times2(a, q);
    q = w3;
    {
        popv(3);
        return  Lxcons(a, q);
    }
}

Sex CC_multTcHcterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = car(q);
    a = CC_multTcHcH(a, q);
    q = cdr(w1);
    {
        popv(1);
        return  cons(a, q);
    }
}

Sex CC_stmultTcHcterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    q = car(q);
    a = CC_stmultTcHcH(a, q);
    q = cdr(w1);
    {
        popv(1);
        return  cons(a, q);
    }
}

Sex CC_exptTbnumbnum(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G1783;
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G1785;
    q = nil;
    a = LITERAL[50];
    goto    G1868;
   G1785:
    a = w2;
    a = Lplusp(a);
    if(a == nil) goto    G1786;
    a = mkfxat(0);
    goto    G1854;
   G1786:
    q = nil;
    a = LITERAL[51];
    goto    G1868;
   G1783:
    a = w2;
    if(!is_integer(a)) goto    G1788;
    a = w1;
    if(!is_integer(a)) goto    G1790;
#define LL_Hintexp LITERAL[52]
    a = value(LL_Hintexp);
    if(a != nil) goto    G1793;
    a = w2;
    a = Labs(a);
    q = mkfxat(1);
    a = Lleq(a, q);
    if(a == nil) goto    G1792;
   G1793:
    a = w2;
    a = Lplusp(a);
    if(a == nil) goto    G1796;
    q = w2;
    a = w1;
    goto    G1857;
   G1796:
    q = w1;
    a = mkfxat(1);
    a = Lmkrational(a, q);
    w3 = a;
    a = w2;
    a = Lminus(a);
    q = a;
    a = w3;
   G1857:
    {
        popv(4);
        return  CC_powTbnumpint(a, q);
    }
   G1792:
    a = w1;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1800;
    a = w1;
    a = Lonep(a);
    if(a != nil) goto    G1858;
    a = w2;
    a = Levenp(a);
    if(a != nil) goto    G1858;
    a = mkfxat(-1);
    goto    G1854;
   G1800:
    a = w1;
    a = Lplusp(a);
    if(a == nil) goto    G1806;
    m = w2;
    q = w1;
    goto    G1867;
   G1806:
    a = w2;
    a = Levenp(a);
    if(a == nil) goto    G1807;
    a = w1;
    a = Lminus(a);
    m = w2;
    q = a;
    goto    G1867;
   G1807:
    a = w1;
    a = Lminus(a);
    m = w2;
    q = a;
    a = LL_cH;
    a = Llist3(a, q, m);
    q = mkfxat(-1);
    a = cons(a, q);
    q = a;
    a = LL_cL;
    {
        popv(4);
        return  Llist2(a, q);
    }
   G1790:
    if(!is_rational(a)) goto    G1813;
    a = value(LL_Hintexp);
    if(a == nil) goto    G1815;
    q = w2;
    a = w1;
    {
        popv(4);
        return  Lexpt(a, q);
    }
   G1815:
    a = w1;
    goto    G1861;
   G1813:
    q = w2;
    goto    G1865;
   G1788:
    if(!is_float(a)) goto    G1823;
    a = w1;
    a = Lplusp(a);
    if(a == nil) goto    G1825;
    q = w2;
    a = w1;
    goto    G1865;
   G1825:
    q = nil;
    a = LITERAL[53];
    goto    G1868;
   G1823:
    if(!is_rational(a)) goto    G1827;
    a = value(LL_Hintexp);
    if(a == nil) goto    G1829;
    a = w1;
    a = Lplusp(a);
    if(a == nil) goto    G1831;
    q = w2;
    a = w1;
    goto    G1865;
   G1831:
    q = nil;
    a = LITERAL[54];
    goto    G1868;
   G1829:
    a = w1;
    if(!is_integer(a)) goto    G1833;
    a = Lonep(a);
    if(a == nil) goto    G1835;
   G1858:
    a = mkfxat(1);
    goto    G1854;
   G1835:
    a = w1;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G1836;
    m = w2;
    q = mkfxat(-1);
    goto    G1867;
   G1836:
    a = w1;
    a = Lplusp(a);
    if(a == nil) goto    G1838;
    m = w2;
    q = w1;
   G1867:
    a = LL_cH;
    {
        popv(4);
        return  Llist3(a, q, m);
    }
   G1838:
    a = w1;
    a = Lminus(a);
    arg5 = w2;
    arg4 = mkfxat(-1);
    m = arg5;
    q = a;
    a = LL_cH;
    {
        popv(4);
        return  Llist5(a, q, m, arg4, arg5);
    }
   G1833:
    if(!is_rational(a)) goto    G1841;
   G1861:
    a = Lnum(a);
    q = w2;
    a = CC_exptTbnumbnum(a, q);
    w3 = a;
    a = w1;
    a = Lden(a);
    w4 = a;
    a = w2;
    a = Lminus(a);
    q = a;
    a = w4;
    a = CC_exptTbnumbnum(a, q);
    q = a;
    a = w3;
    {
        popv(4);
        return  CC_multH(a, q);
    }
   G1841:
    a = Llog(a);
    q = a;
    a = w2;
    a = times2(a, q);
    {
        popv(4);
        return  Lexp(a);
    }
   G1827:
    if(!is_complex(a)) goto    G1850;
    a = w1;
    a = Lplusp(a);
    if(a == nil) goto    G1852;
    q = w2;
    a = w1;
   G1865:
    {
        popv(4);
        return  CC_powTbnumbnum(a, q);
    }
   G1852:
    q = nil;
    a = LITERAL[55];
    goto    G1868;
   G1850:
    q = nil;
    a = LITERAL[56];
   G1868:
    a = CC_errormsg(a, q);
   G1854:
    popv(4);
    return a;
}

Sex CC_unpowTbnum(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_rational(a)) goto    G1872;
    a = Lnum(a);
    q = w2;
    a = CC_unpowTbnum(a, q);
    w3 = a;
    a = w1;
    a = Lden(a);
    w4 = a;
    a = w2;
    a = CC_negH(a);
    q = a;
    a = w4;
    a = CC_unpowTbnum(a, q);
    q = a;
    a = w3;
    {
        popv(4);
        return  CC_unmultH(a, q);
    }
   G1872:
    a = Lplusp(a);
    if(a == nil) goto    G1878;
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G1880;
    a = mkfxat(1);
    goto    G1884;
   G1880:
    m = w2;
    q = w1;
    goto    G1886;
   G1878:
    a = w1;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G1882;
    m = w2;
    q = mkfxat(-1);
   G1886:
    a = LL_cH;
    {
        popv(4);
        return  Llist3(a, q, m);
    }
   G1882:
    a = w1;
    a = Lminus(a);
    arg5 = w2;
    arg4 = mkfxat(-1);
    m = arg5;
    q = a;
    a = LL_cH;
    a = Llist5(a, q, m, arg4, arg5);
   G1884:
    popv(4);
    return a;
}

Sex CC_unpowTcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Wmon4(a);
    if(a == nil) goto    G1890;
    a = w2;
    if(!is_integer(a)) goto    G1890;
    q = a;
    a = w1;
    {
        popv(4);
        return  CC_powTcanoint(a, q);
    }
   G1890:
    w3 = nil;
    w4 = nil;
    a = w1;
    a = CC_convTcano2cterm(a);
    w1 = a;
    a = cdr(car(a));
    w3 = a;
   G1894:
    q = w2;
    a = car(cdr(w3));
    a = CC_multTexpt(a, q);
    w4 = a;
    q = a;
    a = cdr(w3);
    car(a) = q;
    a = cdr(cdr(w3));
    w3 = a;
    if(a != nil) goto    G1894;
    a = cdr(w1);
    w4 = a;
    a = car(w1);
    w1 = a;
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G1898;
    a = w1;
    goto    G1892;
   G1898:
    q = w2;
    a = w4;
    a = CC_exptTbnumbnum(a, q);
    q = w1;
    a = CC_unmultH(a, q);
   G1892:
    popv(4);
    return a;
}

Sex CC_unpowTpref(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != LL_cL) goto    G1905;
    w3 = nil;
    w2 = q;
    a = cdr(cdr(w1));
    if(a != nil) goto    G1907;
    a = car(cdr(w1));
    w3 = a;
    a = car(a);
    a = CC_unpowTpref(a, q);
    w4 = a;
    q = w2;
    a = cdr(w3);
    a = CC_unpowH(a, q);
    q = a;
    a = w4;
    goto    G1922;
   G1907:
    a = w1;
    a = CC_convTcL2cnterm(a);
    w3 = a;
    a = car(a);
    w1 = a;
    a = cdr(w3);
    w3 = a;
    q = w2;
    a = cdr(cdr(w1));
    car(a) = q;
    a = w3;
    a = Lonep(a);
    if(a == nil) goto    G1914;
    a = w1;
    goto    G1920;
   G1914:
    q = w2;
    a = w3;
    a = CC_unpowH(a, q);
    q = a;
    a = w1;
   G1922:
    {
        popv(4);
        return  CC_unmultH(a, q);
    }
   G1905:
    if(a != LL_cH) goto    G1918;
    a = w1;
    {
        popv(4);
        return  CC_powTcHint(a, q);
    }
   G1918:
    a = cdr(cdr(cdr(w1)));
    if(a == nil) goto    G1919;
    m = q;
    q = w1;
    a = LL_ncH;
    {
        popv(4);
        return  Llist3(a, q, m);
    }
   G1919:
    a = car(cdr(cdr(w1)));
    a = CC_multTexpt(a, q);
    m = a;
    q = car(cdr(w1));
    a = LL_ncH;
    a = Llist3(a, q, m);
    a = CC_reduceTncH(a);
   G1920:
    popv(4);
    return a;
}

Sex CC_powTcanoint(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G1926;
    a = mkfxat(1);
    goto    G1962;
   G1926:
    a = w2;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1927;
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1930;
    a = w1;
    goto    G1962;
   G1930:
    a = w1;
    goto    G1960;
   G1927:
    a = car(w1);
    if(a != value(LL_CpolyC)) goto    G1932;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1932;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = cdr(w1);
    w1 = a;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    q = value(LL_CpolyC);
    a = Lxcons(a, q);
    w3 = a;
   G1935:
    a = w2;
    a = Labs(a);
    q = car(car(cdr(w1)));
    a = times2(a, q);
    w6 = a;
    a = Lncons(a);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
#define LL_Hpowser LITERAL[57]
    q = value(LL_Hpowser);
    a = car(w4);
    a = Lassoc(a, q);
    w5 = a;
    if(a == nil) goto    G1944;
    q = cdr(a);
    a = w6;
    a = Lleq(a, q);
    if(a != nil) goto    G1944;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1964;
    q = nil;
    a = LITERAL[58];
    CC_errormsg(a, q);
   G1944:
    a = car(cdr(w4));
    w4 = a;
    a = cdr(car(cdr(w1)));
    w1 = a;
    if(!is_number(a)) goto    G1946;
    a = w2;
    a = Labs(a);
    q = a;
    a = w1;
    a = CC_powTbnumbnum(a, q);
    goto    G1965;
   G1946:
    a = car(a);
    if(is_integer(a)) goto    G1967;
    a = Lncons(a);
    w6 = a;
    q = a;
    a = w4;
    cdr(a) = q;
    a = w6;
    w4 = a;
    goto    G1935;
   G1967:
    a = w2;
    a = Labs(a);
    q = a;
    a = w1;
    a = CC_powTcanoint(a, q);
   G1965:
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w4);
    a = Lzerop(a);
    if(a == nil) goto    G1955;
   G1964:
    a = mkfxat(0);
    goto    G1962;
   G1955:
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1956;
    a = w3;
    goto    G1962;
   G1932:
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1959;
    q = w2;
    a = w1;
    {
        popv(6);
        return  CC_powTcanopint(a, q);
    }
   G1959:
    a = w2;
    a = Lminus(a);
    q = a;
    a = w1;
    a = CC_powTcanopint(a, q);
    if(!is_number(a)) goto    G1960;
    {
        popv(6);
        return  CC_recipTbnum(a);
    }
   G1956:
    a = w3;
   G1960:
    a = CC_recipTcano(a);
   G1962:
    popv(6);
    return a;
}

Sex CC_powTprefint(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G1971;
    a = mkfxat(1);
    goto    G2000;
   G1971:
    a = w2;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1972;
    a = w2;
    a = Lonep(a);
    if(a != nil) goto    G2002;
    a = w1;
    {
        popv(3);
        return  CC_recipTpref(a);
    }
   G1972:
    a = car(w1);
    if(a != LL_cL) goto    G1977;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1979;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1981;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_powTcLpint(a, q);
    }
   G1981:
    a = w2;
    a = Lminus(a);
    q = a;
    a = w1;
    a = CC_powTcLpint(a, q);
    goto    G2004;
   G1979:
    a = w2;
    a = Labs(a);
    q = a;
    a = car(car(cdr(w1)));
    a = CC_powTprefint(a, q);
    w3 = a;
    a = w2;
    a = Labs(a);
    q = a;
    a = cdr(car(cdr(w1)));
    a = CC_powH(a, q);
    q = a;
    a = w3;
    a = CC_multH(a, q);
    w1 = a;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1991;
   G2002:
    a = w1;
    goto    G2000;
   G1991:
    a = w1;
    goto    G2004;
   G1977:
    if(a != LL_cH) goto    G1993;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_powTcHint(a, q);
    }
   G1993:
    a = cdr(cdr(cdr(w1)));
    if(a == nil) goto    G1994;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1996;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_powTncHpint(a, q);
    }
   G1996:
    a = w2;
    a = Lminus(a);
    q = a;
    a = w1;
    a = CC_powTncHpint(a, q);
   G2004:
    {
        popv(3);
        return  CC_recipH(a);
    }
   G1994:
    q = w2;
    a = car(cdr(cdr(w1)));
    a = CC_multTexpt(a, q);
    m = a;
    q = car(cdr(w1));
    a = LL_ncH;
    a = Llist3(a, q, m);
    a = CC_reduceTncH(a);
   G2000:
    popv(3);
    return a;
}

Sex CC_powTcanopint(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G2008;
    a = w1;
    goto    G2009;
   G2008:
    w3 = nil;
    q = mkfxat(2);
    a = w2;
    a = quot2(a, q);
    q = a;
    a = w1;
    a = CC_powTcanopint(a, q);
    w3 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2013;
    a = mkfxat(0);
    goto    G2009;
   G2013:
    a = w3;
    q = a;
    if(!is_number(a)) goto    G2016;
    a = CC_multTbnumbnum(a, q);
    goto    G2017;
   G2016:
    a = CC_multTcanocano(a, q);
   G2017:
    w3 = a;
    a = w2;
    a = Levenp(a);
    if(a == nil) goto    G2019;
    a = w3;
    goto    G2009;
   G2019:
    a = w3;
    if(!is_number(a)) goto    G2020;
    q = w1;
    {
        popv(3);
        return  CC_multTbnumcano(a, q);
    }
   G2020:
    q = a;
    a = w1;
    a = CC_multTcanocano(a, q);
   G2009:
    popv(3);
    return a;
}

Sex CC_powTncHpint(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G2026;
    a = w1;
    goto    G2033;
   G2026:
    a = w2;
    a = Levenp(a);
    q = mkfxat(2);
    if(a == nil) goto    G2027;
    a = w2;
    a = quot2(a, q);
    q = a;
    a = w1;
    a = CC_powTncHpint(a, q);
    w2 = a;
    if(!is_cons(a)) goto    G2030;
    a = car(a);
    if(a != LL_ncH) goto    G2030;
    q = w2;
    a = q;
    goto    G2043;
   G2030:
    q = w2;
    a = q;
    goto    G2044;
   G2027:
    a = w2;
    a = quot2(a, q);
    q = a;
    a = w1;
    a = CC_powTncHpint(a, q);
    w2 = a;
    if(!is_cons(a)) goto    G2036;
    a = car(a);
    if(a != LL_ncH) goto    G2036;
    q = w2;
    a = q;
    a = CC_multTncHncH(a, q);
    goto    G2038;
   G2036:
    q = w2;
    a = q;
    a = CC_multH(a, q);
   G2038:
    w2 = a;
    if(!is_cons(a)) goto    G2040;
    a = car(a);
    if(a != LL_ncH) goto    G2040;
    q = w2;
    a = w1;
   G2043:
    {
        popv(2);
        return  CC_multTncHncH(a, q);
    }
   G2040:
    q = w2;
    a = w1;
   G2044:
    a = CC_multH(a, q);
   G2033:
    popv(2);
    return a;
}

Sex CC_powTcHint(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a != nil) goto    G2091;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = w1;
    a = CC_topcopy(a);
    w3 = a;
    w1 = a;
    a = mkfxat(0);
    w9 = a;
   G2051:
    a = car(cdr(w3));
    w4 = a;
    q = w2;
    a = car(cdr(cdr(w3)));
    a = CC_multTexpt(a, q);
    w5 = a;
    a = w4;
    if(!is_number(a)) goto    G2056;
    q = w5;
    a = CC_chksimpTnfactr(a, q);
    w6 = a;
    if(a == nil) goto    G2069;
    a = w7;
    if(a == nil) goto    G2061;
    q = w6;
    a = CC_multTbnumbnum(a, q);
    goto    G2062;
   G2061:
    a = w6;
   G2062:
    w7 = a;
    q = cdr(cdr(cdr(w3)));
    a = w3;
    cdr(a) = q;
    a = cdr(w3);
    goto    G2095;
   G2056:
    a = car(a);
    if(!is_integer(a)) goto    G2069;
    a = w5;
    if(!is_integer(a)) goto    G2069;
    a = w4;
    a = CC_Wmon4(a);
    if(a == nil) goto    G2068;
    a = true;
    w8 = a;
    goto    G2070;
   G2068:
    a = w5;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G2069;
    a = value(LL_Hexpmode);
    if(a != LL_stexp) goto    G2069;
   G2070:
    a = w9;
    a = Ladd1(a);
    w9 = a;
   G2069:
    q = w5;
    a = cdr(cdr(w3));
    car(a) = q;
    a = cdr(cdr(w3));
    w3 = a;
    a = cdr(a);
   G2095:
    if(a != nil) goto    G2051;
   G2073:
    a = w8;
    if(a != nil) goto    G2076;
    q = mkfxat(2);
    a = w9;
    a = Llessp(a, q);
    if(a != nil) goto    G2086;
   G2076:
    a = w1;
    w3 = a;
   G2053:
    a = car(car(cdr(w3)));
    if(is_integer(a)) goto    G2079;
    a = cdr(cdr(w3));
    w3 = a;
    goto    G2053;
   G2079:
    a = w8;
    if(a == nil) goto    G2081;
    a = w3;
    a = CC_seTunifymono(a);
    w6 = a;
    a = w7;
    if(a == nil) goto    G2083;
    q = w6;
    a = CC_multTbnumbnum(a, q);
    goto    G2084;
   G2083:
    a = w6;
   G2084:
    w7 = a;
   G2081:
    q = mkfxat(1);
    a = w9;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2086;
    a = w3;
    a = CC_seTunifycano(a);
    w6 = a;
    a = w7;
    if(a == nil) goto    G2088;
    q = w6;
    a = CC_multTbnumbnum(a, q);
    goto    G2089;
   G2088:
    a = w6;
   G2089:
    w7 = a;
   G2086:
    a = w1;
    a = CC_reduceTcH(a);
    w1 = a;
    a = w7;
    if(a == nil) goto    G2091;
    q = w1;
    {
        popv(9);
        return  CC_multH(a, q);
    }
   G2091:
    a = w1;
    popv(9);
    return a;
}

Sex CC_powTcLpint(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G2100;
    a = w1;
    goto    G2107;
   G2100:
    a = w2;
    a = Levenp(a);
    q = mkfxat(2);
    if(a == nil) goto    G2101;
    a = w2;
    a = quot2(a, q);
    q = a;
    a = w1;
    a = CC_powTcLpint(a, q);
    w2 = a;
    if(!is_cons(a)) goto    G2104;
    a = car(a);
    if(a != LL_cL) goto    G2104;
    q = w2;
    a = q;
    goto    G2117;
   G2104:
    q = w2;
    a = q;
    goto    G2118;
   G2101:
    a = w2;
    a = quot2(a, q);
    q = a;
    a = w1;
    a = CC_powTcLpint(a, q);
    w2 = a;
    if(!is_cons(a)) goto    G2110;
    a = car(a);
    if(a != LL_cL) goto    G2110;
    q = w2;
    a = q;
    a = CC_multTcLcL(a, q);
    goto    G2112;
   G2110:
    q = w2;
    a = q;
    a = CC_multH(a, q);
   G2112:
    w2 = a;
    if(!is_cons(a)) goto    G2114;
    a = car(a);
    if(a != LL_cL) goto    G2114;
    q = w2;
    a = w1;
   G2117:
    {
        popv(2);
        return  CC_multTcLcL(a, q);
    }
   G2114:
    q = w2;
    a = w1;
   G2118:
    a = CC_multH(a, q);
   G2107:
    popv(2);
    return a;
}

Sex CC_recipTpref(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != LL_cH) goto    G2122;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = cdr(w1);
    w4 = a;
    a = LL_cH;
    a = Lncons(a);
    w3 = a;
    w2 = a;
   G2124:
    a = car(cdr(w4));
    a = CC_Kexponent(a);
    a = Lncons(a);
    q = car(w4);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w3 = a;
    a = cdr(cdr(w4));
    w4 = a;
    if(a != nil) goto    G2124;
    a = w2;
    {
        popv(4);
        return  CC_reduceTcH(a);
    }
   G2122:
    if(a != LL_ncH) goto    G2133;
    w2 = nil;
    w3 = nil;
    a = cdr(w1);
    w3 = a;
   G2135:
    a = car(cdr(w3));
    a = CC_Kexponent(a);
    q = w2;
    a = cons(a, q);
    q = car(w3);
    a = Lxcons(a, q);
    w2 = a;
    a = cdr(cdr(w3));
    w3 = a;
    if(a != nil) goto    G2135;
    q = w2;
    a = LL_ncH;
    a = cons(a, q);
    {
        popv(4);
        return  CC_reduceTncH(a);
    }
   G2133:
    a = cdr(cdr(w1));
    if(a == nil) goto    G2142;
    a = w1;
    a = CC_WcommTcL(a);
    m = mkfxat(-1);
    q = w1;
    if(a == nil) goto    G2144;
    a = LL_cH;
    goto    G2149;
   G2144:
    a = LL_ncH;
   G2149:
    {
        popv(4);
        return  Llist3(a, q, m);
    }
   G2142:
    a = cdr(car(cdr(w1)));
    a = CC_recipH(a);
    w2 = a;
    a = car(car(cdr(w1)));
    a = CC_recipTpref(a);
    q = a;
    a = w2;
    {
        popv(4);
        return  CC_multH(a, q);
    }
}

Sex CC_unrecipTcano(Sex a)
{
    Sex q, m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w1 = a;
    if(car(a) >= value(LL_CratfC)) goto    G2156;
    a = CC_normlzTpol3(a);
    goto    G2184;
   G2156:
    a = cdr(cdr(a));
    if(a == nil) goto    G2157;
    a = w1;
    a = CC_normlzTratf(a);
   G2184:
    w4 = a;
    a = cdr(w4);
    a = CC_recipTbnum(a);
    w3 = a;
    a = Lonep(a);
    m = mkfxat(-1);
    q = car(w4);
    if(a != nil) goto    G2185;
    goto    G2186;
   G2157:
    a = car(cdr(w1));
    w2 = a;
    a = cdr(a);
    if(!is_number(a)) goto    G2154;
    a = cdr(w2);
    a = CC_recipTbnum(a);
    w3 = a;
    a = Lonep(a);
    if(a == nil) goto    G2168;
    m = mkfxat(1);
    q = car(w2);
   G2185:
    a = LL_cH;
    {
        popv(4);
        return  Llist3(a, q, m);
    }
   G2168:
    m = mkfxat(1);
    q = car(w2);
   G2186:
    a = LL_cH;
    a = Llist3(a, q, m);
    q = w3;
    goto    G2187;
   G2154:
    a = cdr(w2);
    a = CC_normlzTpol3(a);
    w4 = a;
    a = cdr(a);
    a = CC_recipTbnum(a);
    w3 = a;
    a = car(w4);
    w4 = a;
    q = car(w2);
    a = Lequal(a, q);
    if(a == nil) goto    G2174;
    a = w3;
    goto    G2152;
   G2174:
    q = w4;
    a = car(w2);
    a = CC_Worder(a, q);
    if(a == nil) goto    G2177;
    arg5 = mkfxat(-1);
    arg4 = w4;
    m = mkfxat(1);
    q = car(w2);
    goto    G2188;
   G2177:
    arg5 = mkfxat(1);
    arg4 = car(w2);
    m = mkfxat(-1);
    q = w4;
   G2188:
    a = LL_cH;
    a = Llist5(a, q, m, arg4, arg5);
    w4 = a;
    a = w3;
    a = Lonep(a);
    if(a == nil) goto    G2180;
    a = w4;
    goto    G2152;
   G2180:
    q = w3;
    a = w4;
   G2187:
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G2152:
    popv(4);
    return a;
}

Sex CC_Wncan(Sex a)
{
    if(!is_cons(a)) goto    G2192;
    a = car(a);
    {
        return  Lfixp(a);
    }
   G2192:
    {
        return  Lnumberp(a);
    }
}

Sex CC_Wmon4(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G2206;
    a = car(a);
    if(!is_integer(a)) goto    G2206;
    if(a >= value(LL_CratfC)) goto    G2199;
    a = cdr(w1);
    goto    G2208;
   G2199:
    a = cdr(cdr(w1));
    if(a == nil) goto    G2200;
   G2206:
    a = nil;
    goto    G2204;
   G2200:
    a = car(cdr(w1));
    w1 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a == nil) goto    G2201;
    a = cdr(car(w1));
    goto    G2208;
   G2201:
    a = cdr(car(w1));
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G2204;
    a = cdr(cdr(w1));
   G2208:
    a = CC_WmonoTbpol(a);
   G2204:
    popv(1);
    return a;
}

Sex CC_cLneck(Sex a)
{
    Sex q, m;
    m = a;
    a = cdr(a);
    if(a == nil) goto    G2214;
    a = car(a);
    if(is_number(a)) goto    G2217;
    a = car(a);
    if(!is_integer(a)) goto    G2214;
   G2217:
    a = cdr(m);
    goto    G2215;
   G2214:
    a = m;
   G2215:
    return a;
}

Sex CC_splitTcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G2221;
    q = w1;
    a = nil;
    {
        popv(6);
        return  cons(a, q);
    }
   G2221:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(w1);
    w1 = a;
    w2 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G2228;
    a = car(w2);
    w5 = a;
    a = cdr(w2);
    w1 = a;
    w2 = a;
   G2228:
    a = car(car(car(w2)));
    if(a == LL_cH) goto    G2225;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G2228;
    q = w1;
    a = LL_cL;
    a = cons(a, q);
    w6 = a;
    a = w5;
    if(a == nil) goto    G2236;
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G2236:
    q = w6;
    goto    G2248;
   G2225:
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = w5;
    if(a == nil) goto    G2240;
    q = w2;
    a = cons(a, q);
    goto    G2241;
   G2240:
    a = w2;
   G2241:
    w5 = a;
   G2226:
    q = w2;
    a = w1;
    a = Lneq(a, q);
    if(a == nil) goto    G2243;
    a = car(w1);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    goto    G2226;
   G2243:
    q = w5;
    a = LL_cL;
    a = cons(a, q);
    q = w3;
   G2248:
    {
        popv(6);
        return  Lxcons(a, q);
    }
}

Sex CC_convTcano2cterm(Sex a)
{
    Sex q, m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(car(a) >= value(LL_CratfC)) goto    G2252;
    a = CC_normlzTpol3(a);
    goto    G2270;
   G2252:
    a = cdr(cdr(a));
    if(a != nil) goto    G2255;
    a = value(LL_Hexpmode);
    if(a != LL_stexp) goto    G2254;
   G2255:
    a = w1;
    a = CC_normlzTratf(a);
   G2270:
    w1 = a;
    m = mkfxat(1);
    q = car(a);
    a = LL_cH;
    a = Llist3(a, q, m);
    q = cdr(w1);
    goto    G2273;
   G2254:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = car(car(cdr(w1)));
    w2 = a;
    a = cdr(car(cdr(w1)));
    w4 = a;
    if(is_number(a)) goto    G2261;
    a = CC_normlzTpol3(a);
    w4 = a;
    a = car(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
   G2261:
    a = w3;
    if(a != nil) goto    G2263;
    m = mkfxat(-1);
    q = w2;
    a = LL_cH;
    a = Llist3(a, q, m);
    q = w4;
    goto    G2273;
   G2263:
    q = a;
    a = w2;
    a = CC_Worder(a, q);
    if(a == nil) goto    G2265;
    arg5 = mkfxat(1);
    arg4 = w3;
    m = mkfxat(-1);
    q = w2;
    a = LL_cH;
    a = Llist5(a, q, m, arg4, arg5);
    q = w4;
    goto    G2273;
   G2265:
    arg5 = mkfxat(-1);
    arg4 = w2;
    m = mkfxat(1);
    q = w3;
    a = LL_cH;
    a = Llist5(a, q, m, arg4, arg5);
    q = w4;
   G2273:
    {
        popv(4);
        return  cons(a, q);
    }
}

Sex CC_convTcL2cnterm(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = cdr(cdr(a));
    if(a != nil) goto    G2278;
    a = car(cdr(w1));
    goto    G2276;
   G2278:
    a = w1;
    a = CC_numcontTcL(a);
    w2 = a;
    a = w1;
    a = CC_Amcoef(a);
    a = Lminusp(a);
    if(a == nil) goto    G2280;
    a = w2;
    a = Lminus(a);
    w2 = a;
   G2280:
    a = w2;
    a = Lonep(a);
    if(a != nil) goto    G2283;
    a = w2;
    a = CC_recipTbnum(a);
    q = w1;
    a = CC_multTbnumcL(a, q);
    w1 = a;
   G2283:
    a = w1;
    a = CC_WcommTcL(a);
    m = mkfxat(1);
    q = w1;
    if(a == nil) goto    G2286;
    a = LL_cH;
    goto    G2291;
   G2286:
    a = LL_ncH;
   G2291:
    a = Llist3(a, q, m);
    q = w2;
    a = cons(a, q);
   G2276:
    popv(2);
    return a;
}

Sex CC_convTrat2qcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_number(a)) goto    G2296;
    a = car(a);
    if(!is_integer(a)) goto    G2295;
   G2296:
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G2298;
    a = LL_cL;
    {
        popv(1);
        return  Lncons(a);
    }
   G2298:
    q = w1;
    goto    G2303;
   G2295:
    if(a != LL_cL) goto    G2300;
    a = w1;
    goto    G2301;
   G2300:
    q = mkfxat(1);
    a = w1;
    a = cons(a, q);
    q = a;
   G2303:
    a = LL_cL;
    a = Llist2(a, q);
   G2301:
    popv(1);
    return a;
}

Sex CC_chksimpTnfactr(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_integer(a)) goto    G2307;
    if(!is_integer(q)) goto    G2307;
    a = value(LL_Hintexp);
    if(a != nil) goto    G2309;
    a = w1;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G2307;
   G2309:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_powTbnumbnum(a, q);
    }
   G2307:
    a = nil;
    popv(2);
    return a;
}

Sex CC_seTunifycano(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w3 = nil;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w2 = a;
    w1 = a;
   G2315:
    a = car(cdr(cdr(w2)));
    w5 = a;
    if(!is_integer(a)) goto    G2336;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G2336;
    a = car(cdr(w2));
    w7 = a;
    if(is_number(a)) goto    G2336;
    a = w4;
    if(a == nil) goto    G2355;
#define LL_init LITERAL[59]
    if(a != LL_init) goto    G2325;
    a = car(cdr(w3));
    w4 = a;
    a = cdr(cdr(w3));
    if(a != w2) goto    G2327;
    a = w3;
    w2 = a;
   G2327:
    a = car(cdr(cdr(w3)));
    a = Lminusp(a);
    if(a == nil) goto    G2329;
    a = w4;
    a = CC_recipTcano(a);
    w4 = a;
   G2329:
    q = cdr(cdr(cdr(w3)));
    a = w3;
    cdr(a) = q;
   G2325:
    q = cdr(cdr(cdr(w2)));
    a = w2;
    cdr(a) = q;
    a = w5;
    a = Lminusp(a);
    if(a == nil) goto    G2331;
    a = w7;
    a = CC_recipTcano(a);
    w7 = a;
   G2331:
    q = w4;
    a = w7;
    a = CC_multH(a, q);
    w4 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2333;
    a = mkfxat(0);
    goto    G2314;
   G2333:
    a = cdr(w2);
    if(a == nil) goto    G2340;
    goto    G2315;
   G2355:
    a = w2;
    w3 = a;
    a = LL_init;
    w4 = a;
   G2336:
    a = cdr(cdr(w2));
    w2 = a;
    a = cdr(a);
    if(a != nil) goto    G2315;
    a = w4;
    if(a == nil) goto    G2341;
    if(a != LL_init) goto    G2340;
   G2341:
    a = mkfxat(1);
    goto    G2314;
   G2340:
    a = w4;
    if(is_number(a)) goto    G2314;
    a = CC_convTcano2cterm(a);
    w7 = a;
    a = cdr(car(a));
    w4 = a;
    a = cdr(w7);
    w6 = a;
   G2318:
    a = cdr(w1);
    if(a != nil) goto    G2345;
    q = w4;
    a = w1;
    cdr(a) = q;
    goto    G2353;
   G2345:
    q = car(w4);
    a = car(a);
    a = CC_orderRMS(a, q);
    w7 = a;
    if(a != CHAR_OF(62)) goto    G2346;
    a = cdr(cdr(w1));
    w1 = a;
    goto    G2318;
   G2346:
    if(a != CHAR_OF(60)) goto    G2347;
    q = cdr(w1);
    a = car(cdr(w4));
    a = cons(a, q);
    w2 = a;
    q = car(w4);
    a = Lxcons(a, q);
    q = a;
    a = w1;
    cdr(a) = q;
    a = w2;
    w1 = a;
    goto    G2351;
   G2347:
    q = car(cdr(w4));
    a = car(cdr(cdr(w1)));
    a = CC_addTexpt(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2349;
    q = cdr(cdr(cdr(w1)));
    a = w1;
    cdr(a) = q;
    goto    G2351;
   G2349:
    q = w5;
    a = cdr(cdr(w1));
    car(a) = q;
   G2351:
    a = cdr(cdr(w4));
    w4 = a;
    if(a != nil) goto    G2318;
   G2353:
    a = w6;
   G2314:
    popv(7);
    return a;
}

Sex CC_seTunifymono(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w2 = a;
    w1 = a;
   G2359:
    a = car(cdr(w2));
    w5 = a;
    a = CC_Wmon4(a);
    if(a == nil) goto    G2363;
    a = car(cdr(cdr(w2)));
    w4 = a;
    if(is_integer(a)) goto    G2369;
   G2363:
    a = cdr(cdr(w2));
    w2 = a;
    a = cdr(a);
    if(a != nil) goto    G2359;
    a = w3;
    if(a != nil) goto    G2376;
    a = mkfxat(1);
    goto    G2358;
   G2369:
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G2371;
    q = w4;
    a = w5;
    a = CC_powTcanoint(a, q);
    w5 = a;
   G2371:
    a = w3;
    if(a == nil) goto    G2373;
    q = w5;
    a = CC_multH(a, q);
    goto    G2374;
   G2373:
    a = w5;
   G2374:
    w3 = a;
    q = cdr(cdr(cdr(w2)));
    a = w2;
    cdr(a) = q;
    a = cdr(w2);
    if(a != nil) goto    G2359;
   G2376:
    a = w3;
    if(is_number(a)) goto    G2358;
    a = CC_convTcano2cterm(a);
    w5 = a;
    a = cdr(car(a));
    w3 = a;
    a = cdr(w5);
    w5 = a;
   G2361:
    a = cdr(w1);
    if(a != nil) goto    G2380;
    q = w3;
    a = w1;
    cdr(a) = q;
    goto    G2385;
   G2380:
    q = car(w3);
    a = car(a);
    a = CC_orderRMS(a, q);
    if(a != CHAR_OF(62)) goto    G2381;
    a = cdr(cdr(w1));
    w1 = a;
    goto    G2361;
   G2381:
    q = cdr(w1);
    a = car(cdr(w3));
    a = cons(a, q);
    w2 = a;
    q = car(w3);
    a = Lxcons(a, q);
    q = a;
    a = w1;
    cdr(a) = q;
    a = w2;
    w1 = a;
    a = cdr(cdr(w3));
    w3 = a;
    if(a != nil) goto    G2361;
   G2385:
    a = w5;
   G2358:
    popv(5);
    return a;
}

Sex CC_unifyRMS(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != car(m)) goto    G2390;
    w2 = q;
    w3 = m;
    w4 = arg4;
    if(a != LL_ncH) goto    G2392;
    if(is_cons(q)) goto    G2394;
    if(!is_cons(arg4)) goto    G2392;
   G2394:
    q = cdr(m);
    a = cdr(w1);
    goto    G2643;
   G2392:
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = cdr(w1);
    w5 = a;
    a = cdr(m);
    w6 = a;
   G2397:
    a = car(w5);
    w8 = a;
    q = car(w6);
    a = Lequal(a, q);
    if(a == nil) goto    G2405;
    a = cdr(w5);
    w5 = a;
    a = car(a);
    w10 = a;
    a = cdr(w6);
    w6 = a;
    a = car(a);
    q = a;
    a = w10;
    a = Lequal(a, q);
    if(a == nil) goto    G2408;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G2414;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G2397;
    a = cdr(cdr(w5));
    if(a != nil) goto    G2606;
    m = w4;
    q = w2;
    a = w5;
    a = CC_colTfactrcof(a, q, m);
    w9 = a;
    if(a == nil) goto    G2606;
    goto    G2564;
   G2414:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G2420;
    a = cdr(cdr(a));
    if(a != nil) goto    G2603;
    m = w2;
    q = w4;
    a = w6;
    a = CC_colTfactrcof(a, q, m);
    w9 = a;
    if(a == nil) goto    G2603;
    a = w3;
    w1 = a;
    a = w6;
    w5 = a;
    w6 = nil;
    goto    G2564;
   G2420:
    a = CHAR_OF(61);
    goto    G2604;
   G2408:
    a = value(LL_Hcolmode);
#define LL_col LITERAL[60]
    if(a == LL_col) goto    G2428;
    a = w8;
    a = CC_Wncan(a);
    if(a == nil) goto    G2428;
    a = car(w5);
    if(!is_integer(a)) goto    G2428;
    a = car(w6);
    if(is_integer(a)) goto    G2426;
   G2428:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2426:
    a = w5;
    a = Llength(a);
    w10 = a;
    a = w6;
    a = Llength(a);
    a = Lminus(a);
    q = a;
    a = w10;
    a = plus2(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2430;
    q = cdr(w6);
    a = cdr(w5);
    a = Lequal(a, q);
    if(a == nil) goto    G2436;
    a = w8;
    if(is_number(a)) goto    G2438;
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2438:
    q = w5;
    a = cons(a, q);
    w5 = a;
    q = w6;
    a = w8;
    a = cons(a, q);
    w6 = a;
    arg4 = w4;
    m = a;
    q = w2;
    a = w5;
    a = CC_stcolTnfactr(a, q, m, arg4);
    w9 = a;
    if(a != nil) goto    G2619;
    q = car(cdr(w6));
    a = car(cdr(w5));
    goto    G2643;
   G2436:
    a = cdr(w5);
    if(a == nil) goto    G2443;
    q = cdr(cdr(cdr(w6)));
    a = cdr(cdr(a));
    a = Lequal(a, q);
    if(a == nil) goto    G2443;
    a = cdr(w5);
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2443;
    a = cdr(w6);
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2443;
    q = w5;
    a = w8;
    a = cons(a, q);
    w10 = a;
    q = w6;
    a = w8;
    a = cons(a, q);
    arg5 = true;
    goto    G2612;
   G2443:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2430:
    a = w9;
    if(a != mkfxat(2)) goto    G2449;
    q = cdr(w6);
    a = cdr(cdr(cdr(w5)));
    a = Lequal(a, q);
    if(a == nil) goto    G2451;
    a = cdr(w5);
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2451;
    q = w5;
    a = w8;
    a = cons(a, q);
    w10 = a;
    q = w6;
    a = w8;
    a = cons(a, q);
    arg5 = nil;
   G2612:
    arg4 = w4;
    m = a;
    q = w2;
    goto    G2614;
   G2451:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2449:
    if(a != mkfxat(-2)) goto    G2457;
    q = cdr(cdr(cdr(w6)));
    a = cdr(w5);
    a = Lequal(a, q);
    if(a == nil) goto    G2459;
    a = cdr(w6);
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2459;
    q = w6;
    a = w8;
    a = cons(a, q);
    w10 = a;
    q = w5;
    a = w8;
    a = cons(a, q);
    arg5 = nil;
    arg4 = w2;
    m = a;
    q = w4;
   G2614:
    a = w10;
    goto    G2624;
   G2459:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2457:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2405:
    a = w5;
    a = Llength(a);
    w10 = a;
    a = w6;
    a = Llength(a);
    a = Lminus(a);
    q = a;
    a = w10;
    a = plus2(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2467;
    q = cdr(cdr(w6));
    a = cdr(cdr(w5));
    a = Lequal(a, q);
    if(a == nil) goto    G2473;
    a = w5;
    a = CC_WcancLHHi(a);
    if(a == nil) goto    G2475;
    a = w6;
    a = CC_WcancLHHi(a);
    if(a != nil) goto    G2399;
   G2475:
    a = value(LL_Hcolmode);
#define LL_stcol LITERAL[61]
    if(a != LL_stcol) goto    G2477;
    a = w5;
    a = CC_WbnumHHi(a);
    if(a == nil) goto    G2477;
    a = w6;
    a = CC_WbnumHHi(a);
    if(a == nil) goto    G2477;
    arg4 = w4;
    m = w6;
    q = w2;
    a = w5;
    a = CC_stcolTnfactr(a, q, m, arg4);
    w9 = a;
    if(a != nil) goto    G2619;
   G2477:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2473:
    a = value(LL_Hcolmode);
    if(a != LL_stcol) goto    G2481;
    a = cdr(cdr(w5));
    if(a == nil) goto    G2481;
    a = w5;
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2481;
    a = w6;
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2481;
    a = w5;
    a = Lcddddr(a);
    w10 = a;
    a = w6;
    a = Lcddddr(a);
    q = a;
    a = w10;
    a = Lequal(a, q);
    if(a == nil) goto    G2481;
    a = cdr(cdr(w5));
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2481;
    a = cdr(cdr(w6));
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2481;
    arg5 = true;
    arg4 = w4;
    m = w6;
    q = w2;
    a = w5;
    goto    G2624;
   G2481:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2467:
    a = w9;
    if(a != mkfxat(2)) goto    G2487;
    q = w6;
    a = cdr(cdr(w5));
    a = Lequal(a, q);
    if(a == nil) goto    G2489;
    a = w5;
    a = CC_WcancLHHi(a);
    if(a != nil) goto    G2399;
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2489:
    a = value(LL_Hcolmode);
    if(a != LL_stcol) goto    G2494;
    a = w5;
    a = Lcddddr(a);
    q = cdr(cdr(w6));
    a = Lequal(a, q);
    if(a == nil) goto    G2494;
    a = w5;
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2494;
    a = cdr(cdr(w5));
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2494;
    a = w6;
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2494;
    arg5 = nil;
    arg4 = w4;
    m = w6;
    q = w2;
    a = w5;
    goto    G2624;
   G2494:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2487:
    if(a != mkfxat(-2)) goto    G2499;
    q = cdr(cdr(w6));
    a = w5;
    a = Lequal(a, q);
    if(a == nil) goto    G2501;
    a = w6;
    a = CC_WcancLHHi(a);
    if(a != nil) goto    G2399;
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2501:
    a = value(LL_Hcolmode);
    if(a != LL_stcol) goto    G2506;
    a = w6;
    a = Lcddddr(a);
    q = a;
    a = cdr(cdr(w5));
    a = Lequal(a, q);
    if(a == nil) goto    G2506;
    a = w6;
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2506;
    a = cdr(cdr(w6));
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2506;
    a = w5;
    a = CC_WcanoHHi(a);
    if(a == nil) goto    G2506;
    arg5 = nil;
    arg4 = w2;
    m = w5;
    q = w4;
    a = w6;
   G2624:
    a = CC_stcolTcfactr2(a, q, m, arg4, arg5);
    w9 = a;
    goto    G2511;
   G2506:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2499:
    q = car(w6);
    a = car(w5);
    goto    G2643;
    a = w9;
   G2511:
    if(a != nil) goto    G2514;
    q = w6;
    a = w5;
    goto    G2643;
   G2514:
    a = Lzerop(a);
    if(a != nil) goto    G2645;
    q = w6;
    a = w5;
    a = CC_Worder(a, q);
    q = w9;
    if(a == nil) goto    G2516;
    a = w3;
    goto    G2639;
   G2516:
    a = w1;
    goto    G2639;
   G2399:
    a = w9;
    if(a != mkfxat(0)) goto    G2520;
    a = car(cdr(w5));
    a = Lonep(a);
    if(a == nil) goto    G2522;
    a = car(w5);
    w8 = a;
    goto    G2533;
   G2522:
    a = car(cdr(w5));
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G2523;
    a = car(car(w5));
    if(is_integer(a)) goto    G2524;
   G2523:
    a = value(LL_Hcolmode);
    if(a != LL_stcol) goto    G2526;
    a = car(car(w5));
    if(!is_integer(a)) goto    G2526;
    a = car(car(w6));
    if(!is_integer(a)) goto    G2526;
    arg4 = w4;
    m = w6;
    q = w2;
    a = w5;
    a = CC_stcolTcfactr1(a, q, m, arg4);
    w9 = a;
    if(a == nil) goto    G2526;
    a = Lzerop(a);
    if(a != nil) goto    G2645;
    q = car(w6);
    a = car(w5);
    a = CC_Worder(a, q);
    q = w9;
    if(a == nil) goto    G2530;
    a = w3;
    goto    G2639;
   G2530:
    a = w1;
    goto    G2639;
   G2526:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2524:
    w8 = nil;
   G2533:
    a = car(cdr(w6));
    a = Lonep(a);
    if(a == nil) goto    G2536;
    a = car(w6);
    w9 = a;
    goto    G2547;
   G2536:
    a = car(cdr(w6));
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G2537;
    a = car(car(w6));
    if(is_integer(a)) goto    G2538;
   G2537:
    a = value(LL_Hcolmode);
    if(a != LL_stcol) goto    G2540;
    a = car(car(w5));
    if(!is_integer(a)) goto    G2540;
    a = car(car(w6));
    if(!is_integer(a)) goto    G2540;
    arg4 = w4;
    m = w6;
    q = w2;
    a = w5;
    a = CC_stcolTcfactr1(a, q, m, arg4);
    w9 = a;
    if(a == nil) goto    G2540;
    a = Lzerop(a);
    if(a != nil) goto    G2645;
    q = car(w6);
    a = car(w5);
    a = CC_Worder(a, q);
    q = w9;
    if(a == nil) goto    G2544;
    a = w3;
    goto    G2639;
   G2544:
    a = w1;
    goto    G2639;
   G2540:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2538:
    w9 = nil;
   G2547:
    a = w8;
    if(a != nil) goto    G2550;
    a = car(w5);
    a = CC_recipTcano(a);
    w8 = a;
   G2550:
    a = w9;
    if(a != nil) goto    G2552;
    a = car(w6);
    a = CC_recipTcano(a);
    w9 = a;
   G2552:
    q = w8;
    a = w2;
    a = CC_multH(a, q);
    w10 = a;
    q = w9;
    a = w4;
    a = CC_multH(a, q);
    q = a;
    a = w10;
    a = CC_addH(a, q);
    w9 = a;
   G2619:
    a = cdr(cdr(w6));
    goto    G2641;
   G2520:
    if(a != mkfxat(2)) goto    G2555;
    a = car(cdr(w5));
    a = Lonep(a);
    if(a == nil) goto    G2557;
    a = car(w5);
    goto    G2642;
   G2557:
    a = car(cdr(w5));
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G2558;
    a = car(car(w5));
    if(is_integer(a)) goto    G2559;
   G2558:
    q = car(w6);
    a = car(w5);
    goto    G2643;
   G2559:
    a = car(w5);
    a = CC_recipTcano(a);
   G2642:
    w9 = a;
    q = w9;
    a = w2;
    a = CC_multH(a, q);
    q = w4;
    a = CC_addH(a, q);
    w9 = a;
    goto    G2564;
   G2555:
    a = car(cdr(w6));
    a = Lonep(a);
    if(a == nil) goto    G2566;
    a = car(w6);
    goto    G2644;
   G2566:
    a = car(cdr(w6));
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G2567;
    a = car(car(w6));
    if(is_integer(a)) goto    G2568;
   G2567:
    q = car(w6);
    a = car(w5);
   G2643:
    {
        popv(10);
        return  CC_orderRMS(a, q);
    }
   G2568:
    a = car(w6);
    a = CC_recipTcano(a);
   G2644:
    w9 = a;
    q = w9;
    a = w4;
    a = CC_multH(a, q);
    q = a;
    a = w2;
    a = CC_addH(a, q);
    w9 = a;
    a = w3;
    w1 = a;
    a = w5;
    w8 = a;
    a = w6;
    w5 = a;
    a = w8;
   G2641:
    w6 = a;
   G2564:
    a = car(w1);
    a = Lncons(a);
    w8 = a;
    w7 = a;
    a = cdr(w1);
    w1 = a;
   G2401:
    q = w5;
    a = w1;
    a = Lneq(a, q);
    if(a == nil) goto    G2574;
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w8 = a;
    a = cdr(cdr(w1));
    w1 = a;
    goto    G2401;
   G2574:
    a = car(w7);
    if(a == LL_ncH) goto    G2403;
    q = w6;
    a = w8;
    cdr(a) = q;
    a = w9;
    if(!is_number(a)) goto    G2582;
    a = Lzerop(a);
    if(a == nil) goto    G2587;
    goto    G2645;
   G2582:
    a = car(a);
    if(!is_integer(a)) goto    G2586;
    a = w9;
    a = CC_convTcano2cterm(a);
    w9 = a;
    q = w7;
    a = cdr(car(a));
    CC_seTmergTcanoscH(a, q);
    goto    G2646;
   G2586:
    a = w9;
    a = CC_convTcL2cnterm(a);
    w9 = a;
    a = cdr(w7);
    if(a != nil) goto    G2589;
    a = car(w9);
    goto    G2590;
   G2589:
    q = w7;
    a = car(w9);
    a = CC_multTcHcH(a, q);
   G2590:
    w7 = a;
   G2646:
    a = cdr(w9);
    w9 = a;
   G2587:
    a = w7;
    a = CC_reduceTcH(a);
    w7 = a;
   G2402:
    if(!is_number(a)) goto    G2592;
    q = a;
    a = w9;
    {
        popv(10);
        return  CC_multTbnumbnum(a, q);
    }
   G2592:
    a = car(a);
    if(!is_integer(a)) goto    G2593;
    q = w7;
    a = w9;
    {
        popv(10);
        return  CC_multTbnumcano(a, q);
    }
   G2593:
    q = w9;
    a = w7;
   G2639:
    {
        popv(10);
        return  cons(a, q);
    }
   G2403:
    a = w9;
    if(!is_number(a)) goto    G2597;
    a = Lzerop(a);
    if(a == nil) goto    G2602;
   G2645:
    a = mkfxat(0);
    goto    G2604;
   G2597:
    a = car(a);
    if(!is_integer(a)) goto    G2601;
    a = w9;
    a = CC_convTcano2cterm(a);
    goto    G2647;
   G2601:
    a = w9;
    a = CC_convTcL2cnterm(a);
   G2647:
    w9 = a;
    q = cdr(car(a));
    a = w8;
    cdr(a) = q;
    a = w8;
    a = CC_tail(a);
    w8 = a;
    a = cdr(w9);
    w9 = a;
   G2602:
    q = w6;
    a = w8;
    cdr(a) = q;
    a = w7;
    a = CC_reduceTncH(a);
    w7 = a;
    goto    G2402;
   G2390:
    if(a != LL_ncH) goto    G2603;
   G2606:
    a = CHAR_OF(62);
    goto    G2604;
   G2603:
    a = CHAR_OF(60);
   G2604:
    popv(10);
    return a;
}

Sex CC_WbnumHHi(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    a = Lnumberp(a);
    if(a == nil) goto    G2650;
    a = car(cdr(w1));
    a = Lfixp(a);
   G2650:
    popv(1);
    return a;
}

Sex CC_WcanoHHi(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    a = Lpairp(a);
    if(a == nil) goto    G2653;
    a = car(car(w1));
    a = Lfixp(a);
    if(a == nil) goto    G2653;
    a = car(cdr(w1));
    a = Lfixp(a);
   G2653:
    popv(1);
    return a;
}

Sex CC_WcancLHHi(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    a = Lpairp(a);
    if(a == nil) goto    G2658;
    a = car(cdr(w1));
    a = Lfixp(a);
    if(a == nil) goto    G2658;
    a = car(car(w1));
    a = Lfixp(a);
    if(a != nil) goto    G2658;
    q = LL_cL;
    a = car(car(w1));
    a = Leq(a, q);
    if(a == nil) goto    G2658;
    a = car(cdr(w1));
    a = Lonep(a);
   G2658:
    popv(1);
    return a;
}

Sex CC_colTfactrcof(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(cdr(a));
    w4 = a;
    if(!is_integer(a)) goto    G2686;
    a = car(w1);
    if(is_cons(a)) goto    G2664;
    if(!is_number(a)) goto    G2686;
    a = value(LL_Hcolmode);
    if(a != LL_stcol) goto    G2686;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2669;
    a = w3;
    a = Lminusp(a);
    if(a != nil) goto    G2670;
   G2669:
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G2686;
    q = mkfxat(0);
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2686;
   G2670:
    q = w4;
    a = car(w1);
    a = CC_powTbnumbnum(a, q);
    w5 = a;
    q = a;
    a = w2;
    a = CC_multTbnumbnum(a, q);
    q = w3;
    a = CC_addTbnumbnum(a, q);
    w5 = a;
    a = w2;
    a = Labs(a);
    w6 = a;
    a = w3;
    a = Labs(a);
    q = a;
    a = w6;
    a = Lmax2(a, q);
    w2 = a;
    a = w5;
    a = Labs(a);
    q = w2;
    a = Lleq(a, q);
    if(a == nil) goto    G2661;
    a = w5;
    goto    G2661;
   G2664:
    a = car(a);
    if(!is_integer(a)) goto    G2680;
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G2682;
    a = car(w1);
    goto    G2694;
   G2682:
    a = w4;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G2661;
    a = car(w1);
    a = CC_recipTcano(a);
    goto    G2694;
   G2680:
    if(a != LL_cL) goto    G2686;
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G2687;
   G2686:
    a = nil;
    goto    G2661;
   G2687:
    a = car(w1);
   G2694:
    w5 = a;
    q = w5;
    a = w2;
    a = CC_multH(a, q);
    q = w3;
    a = CC_addH(a, q);
   G2661:
    popv(6);
    return a;
}

Sex CC_stcolTnfactr(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2700;
    q = mkfxat(0);
    a = w4;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2701;
   G2700:
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G2698;
    a = w4;
    a = Lminusp(a);
    if(a == nil) goto    G2698;
   G2701:
    a = nil;
    goto    G2702;
   G2698:
    q = car(cdr(w1));
    a = car(w1);
    a = CC_powTbnumbnum(a, q);
    w1 = a;
    a = w3;
    if(a != nil) goto    G2704;
    a = w4;
    goto    G2705;
   G2704:
    q = car(cdr(a));
    a = car(a);
    a = CC_powTbnumbnum(a, q);
    w3 = a;
    q = a;
    a = w4;
    a = CC_multTbnumbnum(a, q);
   G2705:
    w3 = a;
    q = w1;
    a = w2;
    a = CC_multTbnumbnum(a, q);
    q = w3;
    a = CC_addTbnumbnum(a, q);
    w1 = a;
    a = w2;
    a = Labs(a);
    w5 = a;
    a = w4;
    a = Labs(a);
    q = a;
    a = w5;
    a = Lmax2(a, q);
    w2 = a;
    a = w1;
    a = Labs(a);
    q = w2;
    a = Lleq(a, q);
    if(a == nil) goto    G2702;
    a = w1;
   G2702:
    popv(5);
    return a;
}

Sex CC_stcolTcfactr1(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(car(a));
    if(a == car(car(m))) goto    G2716;
    a = nil;
    goto    G2717;
   G2716:
    w2 = q;
    w3 = m;
    w4 = arg4;
    if(a == value(LL_CratfC)) goto    G2724;
    q = car(cdr(car(m)));
    a = car(cdr(car(w1)));
    a = Lequal(a, q);
    if(a == nil) goto    G2717;
    a = car(w1);
    a = CC_Adeg(a);
    q = car(cdr(w1));
    a = times2(a, q);
    w5 = a;
    a = car(w3);
    a = CC_Adeg(a);
    q = car(cdr(w3));
    a = times2(a, q);
    q = a;
    a = w5;
    a = Lequal(a, q);
    if(a == nil) goto    G2717;
   G2724:
    q = car(cdr(w1));
    a = car(w1);
    a = CC_powTcanoint(a, q);
    w1 = a;
    q = car(cdr(w3));
    a = car(w3);
    a = CC_powTcanoint(a, q);
    w3 = a;
    q = a;
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G2717;
    q = w4;
    a = w2;
    a = plus2(a, q);
   G2717:
    popv(5);
    return a;
}

Sex CC_stcolTcfactr2(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(car(a));
    if(a == car(car(m))) goto    G2736;
    a = nil;
    goto    G2737;
   G2736:
    w6 = nil;
    w7 = nil;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(a == value(LL_CratfC)) goto    G2757;
    q = car(cdr(car(m)));
    a = car(cdr(car(w1)));
    a = Lequal(a, q);
    if(a == nil) goto    G2737;
    a = car(w1);
    a = CC_Adeg(a);
    q = car(cdr(w1));
    a = times2(a, q);
    w6 = a;
    a = car(w3);
    a = CC_Adeg(a);
    q = car(cdr(w3));
    a = times2(a, q);
    w7 = a;
    q = car(cdr(car(cdr(cdr(w1)))));
    a = car(cdr(car(w1)));
    a = Lequal(a, q);
    if(a == nil) goto    G2746;
    a = car(cdr(cdr(w1)));
    a = CC_Adeg(a);
    w8 = a;
    a = w1;
    a = Lcadddr(a);
    q = a;
    a = w8;
    a = times2(a, q);
    q = a;
    a = w6;
    a = plus2(a, q);
    w6 = a;
   G2746:
    a = w5;
    if(a == nil) goto    G2751;
    q = car(cdr(car(cdr(cdr(w3)))));
    a = car(cdr(car(w3)));
    a = Lequal(a, q);
    if(a == nil) goto    G2751;
    a = car(cdr(cdr(w3)));
    a = CC_Adeg(a);
    w8 = a;
    a = w3;
    a = Lcadddr(a);
    q = a;
    a = w8;
    a = times2(a, q);
    q = a;
    a = w7;
    a = plus2(a, q);
    w7 = a;
   G2751:
    q = w7;
    a = w6;
    a = Lequal(a, q);
    if(a == nil) goto    G2737;
   G2757:
    q = car(cdr(w1));
    a = car(w1);
    a = CC_powTcanoint(a, q);
    w8 = a;
    a = w1;
    a = Lcadddr(a);
    q = a;
    a = car(cdr(cdr(w1)));
    a = CC_powTcanoint(a, q);
    q = a;
    a = w8;
    a = CC_multH(a, q);
    w6 = a;
    q = car(cdr(w3));
    a = car(w3);
    a = CC_powTcanoint(a, q);
    w7 = a;
    a = w5;
    if(a == nil) goto    G2762;
    a = w3;
    a = Lcadddr(a);
    q = a;
    a = car(cdr(cdr(w3)));
    a = CC_powTcanoint(a, q);
    q = a;
    a = w7;
    a = CC_multH(a, q);
    w7 = a;
   G2762:
    q = w7;
    a = w6;
    a = Lequal(a, q);
    if(a == nil) goto    G2737;
    q = w4;
    a = w2;
    a = plus2(a, q);
   G2737:
    popv(8);
    return a;
}

Sex CC_seTmergTcanoscH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w5 = nil;
    w1 = a;
    a = q;
    w4 = a;
    w2 = q;
    a = cdr(a);
    if(a != nil) goto    G2772;
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G2820;
    goto    G2773;
   G2772:
    a = car(cdr(w4));
    w5 = a;
    if(is_cons(a)) goto    G2783;
    a = w1;
    a = CC_tail(a);
    q = cdr(w4);
    cdr(a) = q;
    goto    G2788;
   G2783:
    a = car(a);
    if(is_integer(a)) goto    G2825;
    a = cdr(cdr(w4));
    w4 = a;
    a = cdr(a);
    if(a != nil) goto    G2772;
   G2788:
    q = w1;
    a = w4;
    {
        popv(5);
        cdr(a) = q;
 return a;
    }
   G2825:
    a = cdr(w4);
    w3 = a;
    q = nil;
    a = w4;
    cdr(a) = q;
   G2773:
    q = car(w1);
    a = car(w3);
    a = CC_orderRMS(a, q);
    w5 = a;
    if(a != CHAR_OF(62)) goto    G2792;
    a = car(cdr(w3));
    a = Lncons(a);
    q = car(w3);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = cdr(cdr(w3));
    w3 = a;
    if(a != nil) goto    G2773;
    a = w1;
    goto    G2823;
   G2792:
    if(a != CHAR_OF(60)) goto    G2799;
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = cdr(cdr(w1));
    w1 = a;
    goto    G2824;
   G2799:
    q = car(cdr(w1));
    a = car(cdr(w3));
    a = CC_addTexpt(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2808;
    a = w5;
    a = Lncons(a);
    q = car(w3);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
   G2808:
    a = cdr(cdr(w3));
    w3 = a;
    a = cdr(cdr(w1));
    w1 = a;
    a = w3;
    if(a == nil) goto    G2814;
    a = w1;
   G2824:
    if(a == nil) goto    G2806;
    goto    G2773;
   G2814:
    a = w1;
    if(a == nil) goto    G2806;
   G2823:
    w3 = a;
   G2806:
    a = w3;
    if(a == nil) goto    G2820;
    q = a;
    a = w4;
    cdr(a) = q;
   G2820:
    a = w2;
    popv(5);
    return a;
}

Sex CC_quotiTpref(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G2829;
    if(!is_number(q)) goto    G2837;
    {
        popv(2);
        return  CC_quotiTprefbnum(a, q);
    }
   G2829:
    a = car(q);
    if(!is_integer(a)) goto    G2833;
    if(a >= value(LL_CmaxcanoC)) goto    G2837;
    a = w1;
    {
        popv(2);
        return  CC_quotiTprefcano(a, q);
    }
   G2833:
    if(!is_symbol(a)) goto    G2837;
    q = LL_BctypeB;
    a = Lget(a, q);
    if(a != LL_rat) goto    G2837;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_quotiTprefpref(a, q);
    }
   G2837:
    a = LITERAL[33];
    {
        popv(2);
        return  CC_argerror(a);
    }
}

Sex CC_quotiTprefbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    a = CC_recipTbnum(a);
    w2 = a;
    a = Lonep(a);
    if(a == nil) goto    G2845;
    a = w1;
    goto    G2848;
   G2845:
    a = car(w1);
    if(a != LL_cL) goto    G2847;
    q = w1;
    a = w2;
    {
        popv(2);
        return  CC_multTbnumcL(a, q);
    }
   G2847:
    q = w2;
    a = w1;
    a = cons(a, q);
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
   G2848:
    popv(2);
    return a;
}

Sex CC_divideH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G2853;
    {
        popv(1);
        return  CC_divideTbnum(a, q);
    }
   G2853:
    a = car(a);
    if(!is_integer(a)) goto    G2854;
    if(a >= value(LL_CmaxcanoC)) goto    G2856;
    a = w1;
    {
        popv(1);
        return  CC_divideTcano(a, q);
    }
   G2856:
    a = w1;
    {
        popv(1);
        return  CC_divideTform(a, q);
    }
   G2854:
    a = w1;
    {
        popv(1);
        return  CC_divideTpref(a, q);
    }
}

Sex CC_divideTbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G2862;
    if(is_number(q)) goto    G2864;
    q = LITERAL[62];
    a = mkfxat(3);
    goto    G2871;
   G2864:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G2865;
    q = LITERAL[62];
    a = mkfxat(6);
    goto    G2871;
   G2865:
    a = value(LL_Hmod);
    if(a == nil) goto    G2866;
    a = mkfxat(0);
#define LL_Hremainder LITERAL[63]
    value(LL_Hremainder) = a;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_divTbnumbnum(a, q);
    }
   G2866:
    q = w2;
    a = w1;
    a = Ldivide(a, q);
    w1 = a;
    a = cdr(a);
    value(LL_Hremainder) = a;
    a = car(w1);
    goto    G2869;
   G2862:
    if(car(q) < value(LL_CmaxcanoC)) goto    G2868;
    q = LITERAL[62];
    a = mkfxat(3);
   G2871:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G2868:
    value(LL_Hremainder) = a;
    a = mkfxat(0);
   G2869:
    popv(2);
    return a;
}

Sex CC_divideTcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G2875;
    if(is_number(q)) goto    G2877;
    q = LITERAL[62];
    a = mkfxat(3);
    goto    G2897;
   G2877:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G2878;
    q = LITERAL[62];
    a = mkfxat(6);
    goto    G2897;
   G2878:
    a = mkfxat(0);
    value(LL_Hremainder) = a;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_quotiTcanobnum(a, q);
    }
   G2875:
    if(car(q) < value(LL_CmaxcanoC)) goto    G2880;
    q = LITERAL[62];
    a = mkfxat(3);
    goto    G2897;
   G2880:
    a = car(q);
    if(a != value(LL_CpolyC)) goto    G2881;
    a = car(w1);
    if(a == value(LL_CalgnC)) goto    G2896;
    if(a != value(LL_CpolyC)) goto    G2886;
    a = w1;
    a = CC_VLpolypoly(a, q);
    goto    G2888;
   G2886:
    if(a != value(LL_CalgfC)) goto    G2887;
    a = w1;
    a = CC_VLalgfpoly(a, q);
    goto    G2888;
   G2887:
    a = w1;
    a = CC_VLratfpoly(a, q);
   G2888:
    w1 = a;
    a = Lnull(a);
    if(a == nil) goto    G2884;
    q = LITERAL[62];
    a = mkfxat(7);
    goto    G2897;
   G2884:
    a = value(LL_Hmod);
    if(a == nil) goto    G2889;
    a = cdr(w1);
    a = CC_redmodTncan(a);
    value(LL_Hremainder) = a;
    a = car(w1);
    {
        popv(2);
        return  CC_redmodTncan(a);
    }
   G2889:
    a = cdr(w1);
    value(LL_Hremainder) = a;
    a = car(w1);
    goto    G2892;
   G2881:
    if(a != value(LL_CalgnC)) goto    G2891;
   G2896:
    a = w1;
    value(LL_Hremainder) = a;
    a = mkfxat(0);
    goto    G2892;
   G2891:
    q = LITERAL[64];
    a = LITERAL[65];
   G2897:
    a = CC_errormsg(a, q);
   G2892:
    popv(2);
    return a;
}

Sex CC_remainH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G2901;
    {
        popv(1);
        return  CC_remainTbnum(a, q);
    }
   G2901:
    a = car(a);
    if(!is_integer(a)) goto    G2902;
    if(a >= value(LL_CmaxcanoC)) goto    G2904;
    a = w1;
    {
        popv(1);
        return  CC_remainTcano(a, q);
    }
   G2904:
    a = w1;
    {
        popv(1);
        return  CC_remainTform(a, q);
    }
   G2902:
    a = w1;
    {
        popv(1);
        return  CC_remainTpref(a, q);
    }
}

Sex CC_remainTbnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G2910;
    if(is_number(q)) goto    G2912;
    q = LITERAL[62];
    a = mkfxat(3);
    goto    G2919;
   G2912:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G2913;
    q = LITERAL[62];
    a = mkfxat(6);
    goto    G2919;
   G2913:
    a = value(LL_Hmod);
    q = w2;
    if(a == nil) goto    G2914;
    a = w1;
    a = CC_divTbnumbnum(a, q);
#define LL_Hquotient LITERAL[66]
    value(LL_Hquotient) = a;
    a = mkfxat(0);
    goto    G2917;
   G2914:
    a = w1;
    a = Ldivide(a, q);
    w1 = a;
    a = car(a);
    value(LL_Hquotient) = a;
    a = cdr(w1);
    goto    G2917;
   G2910:
    if(car(q) < value(LL_CmaxcanoC)) goto    G2916;
    q = LITERAL[62];
    a = mkfxat(3);
   G2919:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G2916:
    a = mkfxat(0);
    value(LL_Hquotient) = a;
    a = w1;
   G2917:
    popv(2);
    return a;
}

Sex CC_remainTcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_cons(q)) goto    G2923;
    if(is_number(q)) goto    G2925;
    q = LITERAL[62];
    a = mkfxat(3);
    goto    G2945;
   G2925:
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G2926;
    q = LITERAL[62];
    a = mkfxat(6);
    goto    G2945;
   G2926:
    q = w2;
    a = w1;
    a = CC_quotiTcanobnum(a, q);
    value(LL_Hquotient) = a;
    a = mkfxat(0);
    goto    G2940;
   G2923:
    if(car(q) < value(LL_CmaxcanoC)) goto    G2928;
    q = LITERAL[62];
    a = mkfxat(3);
    goto    G2945;
   G2928:
    a = car(q);
    if(a != value(LL_CpolyC)) goto    G2929;
    a = car(w1);
    if(a == value(LL_CalgnC)) goto    G2944;
    if(a != value(LL_CpolyC)) goto    G2934;
    a = w1;
    a = CC_VLpolypoly(a, q);
    goto    G2936;
   G2934:
    if(a != value(LL_CalgfC)) goto    G2935;
    a = w1;
    a = CC_VLalgfpoly(a, q);
    goto    G2936;
   G2935:
    a = w1;
    a = CC_VLratfpoly(a, q);
   G2936:
    w1 = a;
    a = Lnull(a);
    if(a == nil) goto    G2932;
    q = LITERAL[62];
    a = mkfxat(7);
    goto    G2945;
   G2932:
    a = value(LL_Hmod);
    if(a == nil) goto    G2937;
    a = car(w1);
    a = CC_redmodTncan(a);
    value(LL_Hquotient) = a;
    a = cdr(w1);
    {
        popv(2);
        return  CC_redmodTncan(a);
    }
   G2937:
    a = car(w1);
    value(LL_Hquotient) = a;
    a = cdr(w1);
    goto    G2940;
   G2929:
    if(a != value(LL_CalgnC)) goto    G2939;
   G2944:
    a = mkfxat(0);
    value(LL_Hquotient) = a;
    a = w1;
    goto    G2940;
   G2939:
    q = LITERAL[64];
    a = LITERAL[65];
   G2945:
    a = CC_errormsg(a, q);
   G2940:
    popv(2);
    return a;
}



/* initialization procedure */
int init_bspref(void)
{
   long i;

   create_symbols(bspref_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; bspref_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(bspref_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4, arg5;
        a = LITERAL[67];
        CC_Aenter(a);
        arg5 = nil;
#define LL_rexp LITERAL[68]
        arg4 = LL_rexp;
#define LL_argn LITERAL[69]
        m = LL_argn;
#define LL_plus LITERAL[70]
        q = LL_plus;
        a = LL_gL;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_rexp;
#define LL_arg1 LITERAL[71]
        m = LL_arg1;
#define LL_neg LITERAL[72]
        q = LL_neg;
        a = LL_gK;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_rexp;
        m = LL_argn;
#define LL_times LITERAL[73]
        q = LL_times;
        a = LL_gH;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_rexp;
#define LL_argx1 LITERAL[74]
        m = LL_argx1;
#define LL_expt LITERAL[75]
        q = LL_expt;
        a = LL_gHH;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_rexp;
        m = LL_argx1;
#define LL_ratio LITERAL[76]
        q = LL_ratio;
        a = LL_gV;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_rexp;
        m = LL_argx1;
#define LL_quoti LITERAL[77]
        q = LL_quoti;
        a = LL_gVV;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_rexp;
        m = LL_argx1;
#define LL_remain LITERAL[78]
        q = LL_remain;
        a = LL_gVL;
        CC_genprogram(a, q, m, arg4, arg5);
        m = LITERAL[79];
#define LL_macro LITERAL[80]
        q = LL_macro;
        a = LL_gL;
        Lput(a, q, m);
        m = LITERAL[81];
        q = LL_macro;
        a = LL_gH;
        a = Lput(a, q, m);
        return 1;
    }
}
Sex LITERAL[83];

const  char *bspref_literal_string[83] =
{
/* 0 */
"g!+",
/* 1 */
"fcallxy!:rexp",
/* 2 */
"g!-",
/* 3 */
"g!*",
/* 4 */
"g!*!*",
/* 5 */
"g!/",
/* 6 */
"g!/!/",
/* 7 */
"g!/!+",
/* 8 */
"!*temporal",
/* 9 */
"!!ctype!!",
/* 10 */
"c!+",
/* 11 */
"!*fcut",
/* 12 */
"!#ratf!#",
/* 13 */
"redflo!:pol3",
/* 14 */
"redflo!:bnum",
/* 15 */
"!*mod",
/* 16 */
"redmod!:pol3",
/* 17 */
"redmod!:bnum",
/* 18 */
"c!*",
/* 19 */
"!*colmode",
/* 20 */
"uncol",
/* 21 */
"!*!*mod",
/* 22 */
"!*expmode",
/* 23 */
"unexp",
/* 24 */
"!#maxcano!#",
/* 25 */
"\"**\"",
/* 26 */
"rat",
/* 27 */
"!*fracpow",
/* 28 */
"\"/\"",
/* 29 */
"!#maxform!#",
/* 30 */
"!*divmode",
/* 31 */
"div",
/* 32 */
"undiv",
/* 33 */
"\"//\"",
/* 34 */
"!#poly!#",
/* 35 */
"!#algn!#",
/* 36 */
"!#algf!#",
/* 37 */
"nc!*",
/* 38 */
"exp",
/* 39 */
"stexp",
/* 40 */
"mult!:ctermcterm",
/* 41 */
"stmult!:ctermcterm",
/* 42 */
"mult!:nc!*nterm",
/* 43 */
"mult!:ntermnc!*",
/* 44 */
"mult!:c!*cterm",
/* 45 */
"stmult!:c!*cterm",
/* 46 */
"mult!*",
/* 47 */
"mult!:ntermnterm",
/* 48 */
"mult!:cexprnterm",
/* 49 */
"unmult!:cexprnterm",
/* 50 */
"\"0**0 IS FORMED\"",
/* 51 */
"\"0**<NEGATIVE> IS FORMED\"",
/* 52 */
"!*intexp",
/* 53 */
"\"NEGATIVE**<FLOAT> IS FORMED\"",
/* 54 */
"\"NEGATIVE**<RATN> IS FORMED\"",
/* 55 */
"\"NEGATIVE**<COMPL> IS FORMED\"",
/* 56 */
"\"EXPONNT IS <EFLOAT/ECOMPL/INTVAL>\"",
/* 57 */
"!*powser",
/* 58 */
"\"0**NEGATIVE IS FORMED\"",
/* 59 */
"init",
/* 60 */
"col",
/* 61 */
"stcol",
/* 62 */
"\"/+\"",
/* 63 */
"!*remainder",
/* 64 */
"\"\\+\"",
/* 65 */
"\"DIVISOR IS NOT <ALGN/POLY>\"",
/* 66 */
"!*quotient",
/* 67 */
"(lisp)",
/* 68 */
"rexp",
/* 69 */
"argn",
/* 70 */
"plus",
/* 71 */
"arg1",
/* 72 */
"neg",
/* 73 */
"times",
/* 74 */
"argx1",
/* 75 */
"expt",
/* 76 */
"ratio",
/* 77 */
"quoti",
/* 78 */
"remain",
/* 79 */
"((!,u) (expnd!.argn 'fcallxy!:rexp (mkquote 'g!+) (cdr !,u)))",
/* 80 */
"macro",
/* 81 */
"((!,u) (expnd!.argn 'fcallxy!:rexp (mkquote 'g!*) (cdr !,u)))",
/* 82 */ NULL
};
setup_type const bspref_g_setup[] =
{
    {"remain:cano", (lisp_proc *)CC_remainTcano, 2},
    {"remain:bnum", (lisp_proc *)CC_remainTbnum, 2},
    {"remain*", (lisp_proc *)CC_remainH, 2},
    {"divide:cano", (lisp_proc *)CC_divideTcano, 2},
    {"divide:bnum", (lisp_proc *)CC_divideTbnum, 2},
    {"divide*", (lisp_proc *)CC_divideH, 2},
    {"quoti:prefbnum", (lisp_proc *)CC_quotiTprefbnum, 2},
    {"quoti:pref", (lisp_proc *)CC_quotiTpref, 2},
    {"se:merg:canosc*", (lisp_proc *)CC_seTmergTcanoscH, 2},
    {"stcol:cfactr2", (lisp_proc *)CC_stcolTcfactr2, 5},
    {"stcol:cfactr1", (lisp_proc *)CC_stcolTcfactr1, 4},
    {"stcol:nfactr", (lisp_proc *)CC_stcolTnfactr, 4},
    {"col:factrcof", (lisp_proc *)CC_colTfactrcof, 3},
    {"?canc+**i", (lisp_proc *)CC_WcancLHHi, 1},
    {"?cano**i", (lisp_proc *)CC_WcanoHHi, 1},
    {"?bnum**i", (lisp_proc *)CC_WbnumHHi, 1},
    {"unify<=>", (lisp_proc *)CC_unifyRMS, 4},
    {"se:unifymono", (lisp_proc *)CC_seTunifymono, 1},
    {"se:unifycano", (lisp_proc *)CC_seTunifycano, 1},
    {"chksimp:nfactr", (lisp_proc *)CC_chksimpTnfactr, 2},
    {"conv:rat2qc+", (lisp_proc *)CC_convTrat2qcL, 1},
    {"conv:c+2cnterm", (lisp_proc *)CC_convTcL2cnterm, 1},
    {"conv:cano2cterm", (lisp_proc *)CC_convTcano2cterm, 1},
    {"split:c+", (lisp_proc *)CC_splitTcL, 1},
    {"c+neck", (lisp_proc *)CC_cLneck, 1},
    {"?mon4", (lisp_proc *)CC_Wmon4, 1},
    {"?ncan", (lisp_proc *)CC_Wncan, 1},
    {"unrecip:cano", (lisp_proc *)CC_unrecipTcano, 1},
    {"recip:pref", (lisp_proc *)CC_recipTpref, 1},
    {"pow:c+pint", (lisp_proc *)CC_powTcLpint, 2},
    {"pow:c*int", (lisp_proc *)CC_powTcHint, 2},
    {"pow:nc*pint", (lisp_proc *)CC_powTncHpint, 2},
    {"pow:canopint", (lisp_proc *)CC_powTcanopint, 2},
    {"pow:prefint", (lisp_proc *)CC_powTprefint, 2},
    {"pow:canoint", (lisp_proc *)CC_powTcanoint, 2},
    {"unpow:pref", (lisp_proc *)CC_unpowTpref, 2},
    {"unpow:cano", (lisp_proc *)CC_unpowTcano, 2},
    {"unpow:bnum", (lisp_proc *)CC_unpowTbnum, 2},
    {"expt:bnumbnum", (lisp_proc *)CC_exptTbnumbnum, 2},
    {"stmult:c*cterm", (lisp_proc *)CC_stmultTcHcterm, 2},
    {"mult:c*cterm", (lisp_proc *)CC_multTcHcterm, 2},
    {"stmult:ctermcterm", (lisp_proc *)CC_stmultTctermcterm, 2},
    {"mult:ctermcterm", (lisp_proc *)CC_multTctermcterm, 2},
    {"unmult:c*nterm", (lisp_proc *)CC_unmultTcHnterm, 2},
    {"mult:c*nterm", (lisp_proc *)CC_multTcHnterm, 2},
    {"unmult:cexprnterm", (lisp_proc *)CC_unmultTcexprnterm, 2},
    {"mult:cexprnterm", (lisp_proc *)CC_multTcexprnterm, 2},
    {"mult:ntermnc*", (lisp_proc *)CC_multTntermncH, 2},
    {"mult:nc*nterm", (lisp_proc *)CC_multTncHnterm, 2},
    {"mult:ntermnterm", (lisp_proc *)CC_multTntermnterm, 2},
    {"unmult:c+c+", (lisp_proc *)CC_unmultTcLcL, 2},
    {"unmult:c*c+", (lisp_proc *)CC_unmultTcHcL, 2},
    {"unmult:c+nc*", (lisp_proc *)CC_unmultTcLncH, 2},
    {"unmult:nc*c+", (lisp_proc *)CC_unmultTncHcL, 2},
    {"unmult:canoc+", (lisp_proc *)CC_unmultTcanocL, 2},
    {"unmult:prefpref", (lisp_proc *)CC_unmultTprefpref, 2},
    {"unmult:canopref", (lisp_proc *)CC_unmultTcanopref, 2},
    {"unmult:canocano", (lisp_proc *)CC_unmultTcanocano, 2},
    {"mult:c+c+", (lisp_proc *)CC_multTcLcL, 2},
    {"mult:c*c+", (lisp_proc *)CC_multTcHcL, 2},
    {"mult:c+nc*", (lisp_proc *)CC_multTcLncH, 2},
    {"mult:nc*c+", (lisp_proc *)CC_multTncHcL, 2},
    {"stmult:c*c*", (lisp_proc *)CC_stmultTcHcH, 2},
    {"mult:c*c*", (lisp_proc *)CC_multTcHcH, 2},
    {"mult:nc*nc*", (lisp_proc *)CC_multTncHncH, 2},
    {"mult:canoc+", (lisp_proc *)CC_multTcanocL, 2},
    {"mult:canoc*", (lisp_proc *)CC_multTcanocH, 2},
    {"mult:bnumc+", (lisp_proc *)CC_multTbnumcL, 2},
    {"mult:prefpref", (lisp_proc *)CC_multTprefpref, 2},
    {"mult:canopref", (lisp_proc *)CC_multTcanopref, 2},
    {"mult:bnumpref", (lisp_proc *)CC_multTbnumpref, 2},
    {"neg:c+", (lisp_proc *)CC_negTcL, 1},
    {"neg:c*", (lisp_proc *)CC_negTcH, 1},
    {"-exponent", (lisp_proc *)CC_Kexponent, 1},
    {"unadd:c+c+", (lisp_proc *)CC_unaddTcLcL, 2},
    {"unadd:c*c+", (lisp_proc *)CC_unaddTcHcL, 2},
    {"unadd:c*c*", (lisp_proc *)CC_unaddTcHcH, 2},
    {"add:c+c+", (lisp_proc *)CC_addTcLcL, 2},
    {"add:c*c+", (lisp_proc *)CC_addTcHcL, 2},
    {"add:c*c*", (lisp_proc *)CC_addTcHcH, 2},
    {"add:canoc+", (lisp_proc *)CC_addTcanocL, 2},
    {"add:bnumc+", (lisp_proc *)CC_addTbnumcL, 2},
    {"add:prefpref", (lisp_proc *)CC_addTprefpref, 2},
    {"add:canopref", (lisp_proc *)CC_addTcanopref, 2},
    {"add:bnumpref", (lisp_proc *)CC_addTbnumpref, 2},
    {"quoti:cano", (lisp_proc *)CC_quotiTcano, 2},
    {"quoti:bnum", (lisp_proc *)CC_quotiTbnum, 2},
    {"ratio:pref", (lisp_proc *)CC_ratioTpref, 2},
    {"ratio:cano", (lisp_proc *)CC_ratioTcano, 2},
    {"ratio:bnum", (lisp_proc *)CC_ratioTbnum, 2},
    {"expt:pref", (lisp_proc *)CC_exptTpref, 2},
    {"expt:cano", (lisp_proc *)CC_exptTcano, 2},
    {"expt:bnum", (lisp_proc *)CC_exptTbnum, 2},
    {"times:prefpref", (lisp_proc *)CC_timesTprefpref, 2},
    {"times:canopref", (lisp_proc *)CC_timesTcanopref, 2},
    {"times:canocano", (lisp_proc *)CC_timesTcanocano, 2},
    {"times:bnumpref", (lisp_proc *)CC_timesTbnumpref, 2},
    {"times:bnumcano", (lisp_proc *)CC_timesTbnumcano, 2},
    {"times:bnumbnum", (lisp_proc *)CC_timesTbnumbnum, 2},
    {"neg:pref", (lisp_proc *)CC_negTpref, 1},
    {"plus:prefpref", (lisp_proc *)CC_plusTprefpref, 2},
    {"plus:canopref", (lisp_proc *)CC_plusTcanopref, 2},
    {"plus:canocano", (lisp_proc *)CC_plusTcanocano, 2},
    {"plus:bnumpref", (lisp_proc *)CC_plusTbnumpref, 2},
    {"plus:bnumcano", (lisp_proc *)CC_plusTbnumcano, 2},
    {"plus:bnumbnum", (lisp_proc *)CC_plusTbnumbnum, 2},
    {"quoti*", (lisp_proc *)CC_quotiH, 2},
    {"recip*", (lisp_proc *)CC_recipH, 1},
    {"unpow*", (lisp_proc *)CC_unpowH, 2},
    {"pow*", (lisp_proc *)CC_powH, 2},
    {"unmult*", (lisp_proc *)CC_unmultH, 2},
    {"mult:expt", (lisp_proc *)CC_multTexpt, 2},
    {"mult*", (lisp_proc *)CC_multH, 2},
    {"chkmult*", (lisp_proc *)CC_chkmultH, 2},
    {"neg:expt", (lisp_proc *)CC_negTexpt, 1},
    {"neg*", (lisp_proc *)CC_negH, 1},
    {"unadd*", (lisp_proc *)CC_unaddH, 2},
    {"add:expt", (lisp_proc *)CC_addTexpt, 2},
    {"add*", (lisp_proc *)CC_addH, 2},
    {"chkadd*", (lisp_proc *)CC_chkaddH, 2},
    {"se:redcoef:c+", (lisp_proc *)CC_seTredcoefTcL, 1},
    {"redcoef:ncan", (lisp_proc *)CC_redcoefTncan, 1},
    {"reduce:c+", (lisp_proc *)CC_reduceTcL, 1},
    {"reduce:c*", (lisp_proc *)CC_reduceTcH, 1},
    {"reduce:nc*", (lisp_proc *)CC_reduceTncH, 1},
    {"topcopy2", (lisp_proc *)CC_topcopy2, 1},
    {"tail3", (lisp_proc *)CC_tail3, 1},
    {"g/+", (lisp_proc *)CC_gVL, 2},
    {"g//", (lisp_proc *)CC_gVV, 2},
    {"g/", (lisp_proc *)CC_gV, 2},
    {"g**", (lisp_proc *)CC_gHH, 2},
    {"g*", (lisp_proc *)CC_gH, -2},
    {"g-", (lisp_proc *)CC_gK, 1},
    {"g+", (lisp_proc *)CC_gL, -2},
    {NULL, NULL, 0 }
};

