#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_bssimp.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex bssimp_literal_vector[];
const char *bssimp_literal_string[];
setup_type const  bssimp_g_setup[];
#define LITERAL bssimp_literal_vector




Sex CC_gsimpH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Bopnrules LITERAL[0]
    a = value(LL_Bopnrules);
    if(a == nil) goto    G0004;
#define LL_Hsimpmode LITERAL[1]
    a = value(LL_Hsimpmode);
#define LL_unsimp LITERAL[2]
    if(a == LL_unsimp) goto    G0004;
    a = w1;
    if(!is_cons(a)) goto    G0004;
    a = CC_Wsinglevar(a);
    if(a != nil) goto    G0004;
    a = cdr(car(cdr(value(LL_Bopnrules))));
    if(a != nil) goto    G0002;
    a = value(LL_Bopnrules);
    a = Lcdaddr(a);
    if(a != nil) goto    G0002;
   G0004:
#define LL_Htemporal LITERAL[3]
    value(LL_Htemporal) = nil;
    a = w1;
    goto    G0020;
   G0002:
    a = cdr(value(LL_Bopnrules));
#define LL_Hrules LITERAL[4]
    value(LL_Hrules) = a;
    a = car(w1);
    a = Lfixp(a);
    if(a == nil) goto    G0005;
#define LL_CmaxcanoC LITERAL[5]
    if(car(w1) >= value(LL_CmaxcanoC)) goto    G0007;
    a = w1;
    a = CC_idlistTcano(a);
    goto    G0021;
   G0007:
#define LL_CmaxformC LITERAL[6]
    if(car(w1) >= value(LL_CmaxformC)) goto    G0019;
    a = w1;
    {
        popv(1);
        return  CC_simpTform(a);
    }
   G0005:
    a = car(w1);
    if(!is_symbol(a)) goto    G0011;
#define LL_BctypeB LITERAL[7]
    q = LL_BctypeB;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
#define LL_rat LITERAL[8]
    if(a != LL_rat) goto    G0013;
    a = w1;
    a = CC_idlistTpref(a);
   G0021:
    q = a;
    a = w1;
    {
        popv(1);
        return  CC_simpH(a, q);
    }
   G0013:
#define LL_set LITERAL[9]
    if(a != LL_set) goto    G0015;
    a = w1;
    {
        popv(1);
        return  CC_simpTset(a);
    }
   G0015:
#define LL_rel LITERAL[10]
    if(a != LL_rel) goto    G0016;
    a = w1;
    {
        popv(1);
        return  CC_simpTrel(a);
    }
   G0016:
#define LL_log LITERAL[11]
    if(a != LL_log) goto    G0019;
    a = w1;
    {
        popv(1);
        return  CC_simpTlog(a);
    }
   G0011:
    if(!is_vector(a)) goto    G0019;
    a = w1;
    {
        popv(1);
        return  CC_simpTarray(a);
    }
   G0019:
    q = LITERAL[12];
    a = mkfxat(1);
    a = CC_errormsg(a, q);
   G0020:
    popv(1);
    return a;
}

Sex CC_simpH(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0027;
    a = q;
    goto    G0052;
   G0027:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = value(LL_Hrules);
    w3 = a;
    a = mkfxat(0);
    w6 = a;
   G0030:
    a = cdr(car(w3));
    w4 = a;
    if(a == nil) goto    G0044;
    a = w2;
    if(a != nil) goto    G0038;
    a = w1;
    a = CC_idlistH(a);
    w2 = a;
   G0038:
    m = w2;
    q = cdr(car(w4));
    a = w1;
    a = CC_rewriteH(a, q, m);
    w5 = a;
    a = value(LL_Htemporal);
    w2 = a;
    a = w5;
    if(a == w1) goto    G0041;
    a = true;
    w7 = a;
    a = w5;
    w1 = a;
    a = Latom(a);
    if(a != nil) goto    G0035;
   G0041:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0038;
   G0044:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0030;
    a = value(LL_Hsimpmode);
#define LL_simp LITERAL[13]
    if(a == LL_simp) goto    G0035;
    a = w7;
    if(a == nil) goto    G0035;
    a = w6;
    a = Ladd1(a);
    w6 = a;
#define LL_Crewrite LITERAL[14]
    q = value(LL_Crewrite);
    a = Llessp(a, q);
    if(a == nil) goto    G0050;
    a = value(LL_Hrules);
    w3 = a;
    w7 = nil;
    goto    G0030;
   G0050:
    q = value(LL_Crewrite);
    a = LITERAL[15];
    CC_printmsg(a, q);
   G0035:
    a = w2;
   G0052:
    value(LL_Htemporal) = a;
    a = w1;
    popv(8);
    return a;
}

Sex CC_simpfuncsH(Sex a, Sex q, Sex m)
{
    return a;
}

Sex CC_simpTfunc(Sex a)
{
    return a;
}

Sex CC_sssimpTfunc(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    a = car(a);
    w2 = a;
#define LL_Bgid LITERAL[16]
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(5);
    a = Lgetv(a, q);
    a = cdr(a);
    q = a;
#define LL_func LITERAL[17]
    a = LL_func;
    a = Latsoc(a, q);
    w4 = a;
    if(a == nil) goto    G0061;
    a = cdr(a);
    value(LL_Hrules) = a;
    a = w1;
    a = CC_sinpfnT(a);
    w3 = a;
    if(is_number(a)) goto    G0059;
    a = car(a);
    if(a == w2) goto    G0116;
#define LL_Hrdstat LITERAL[18]
    a = value(LL_Hrdstat);
#define LL_rule LITERAL[19]
    if(a != LL_rule) goto    G0082;
    a = w3;
    goto    G0059;
   G0116:
    a = w3;
    w1 = a;
   G0061:
    a = cdr(car(value(LL_Bopnrules)));
    value(LL_Hrules) = a;
    if(a == nil) goto    G0062;
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(5);
    a = Lgetv(a, q);
    a = car(a);
    w4 = a;
    if(a == LL_unsimp) goto    G0062;
    if(a != nil) goto    G0080;
    a = value(LL_Hsimpmode);
    if(a == LL_unsimp) goto    G0062;
   G0080:
    a = value(LL_Hrdstat);
    if(a == LL_rule) goto    G0062;
    a = w1;
    a = CC_simpfnH(a);
    w3 = a;
    if(is_number(a)) goto    G0059;
    a = car(a);
    if(a == w2) goto    G0115;
   G0082:
    a = value(LL_Bopnrules);
    value(LL_Hrules) = a;
    a = w3;
    a = CC_idlistH(a);
    m = true;
    q = a;
    a = w3;
    {
        popv(4);
        return  CC_simpfuncsH(a, q, m);
    }
   G0115:
    a = w3;
    w1 = a;
   G0062:
    q = LL_Bgid;
    a = w2;
    a = Lget(a, q);
    q = mkfxat(4);
    a = Lgetv(a, q);
    a = car(a);
    w4 = a;
#define LL_uncomp LITERAL[20]
    if(a == LL_uncomp) goto    G0114;
    a = w2;
    a = CC_Wpfunc(a);
    if(a == nil) goto    G0089;
    a = w4;
    if(a != nil) goto    G0091;
#define LL_Hcompmode LITERAL[21]
    a = value(LL_Hcompmode);
    if(a == LL_uncomp) goto    G0114;
   G0091:
    a = w1;
    {
        popv(4);
        return  CC_compfnH(a);
    }
   G0089:
    a = w4;
    if(a != nil) goto    G0095;
#define LL_Hfuncomp LITERAL[22]
    a = value(LL_Hfuncomp);
#define LL_off LITERAL[23]
    if(a == LL_off) goto    G0114;
   G0095:
    a = cdr(w1);
    w4 = a;
    if(a == nil) goto    G0114;
    a = car(a);
    if(!is_cons(a)) goto    G0099;
    a = car(a);
#define LL_Bindex LITERAL[24]
    if(a != LL_Bindex) goto    G0099;
    a = cdr(car(w4));
    a = CC_WbnumTarglis(a);
    if(a == nil) goto    G0114;
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0114;
   G0099:
    a = w4;
    a = CC_Wnumlist(a);
    if(a != nil) goto    G0105;
   G0114:
    a = w1;
    goto    G0059;
   G0105:
    a = w1;
    a = CC_ncompfnH(a);
   G0059:
    popv(4);
    return a;
}

Sex CC_simpfnH(Sex a)
{
    return a;
}

Sex CC_compfuncH(Sex a, Sex q)
{
    return a;
}

Sex CC_compfnH(Sex a)
{
    return a;
}

Sex CC_ncompfnH(Sex a)
{
    return a;
}

Sex CC_rewriteH(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    a = mkfxat(0);
    w10 = a;
    a = car(car(q));
    w11 = a;
    w2 = q;
    w3 = m;
    arg4 = cdr(a);
    m = car(a);
    q = w3;
    a = w1;
    a = CC_Wmchcheck(a, q, m, arg4);
    if(a == nil) goto    G0161;
    a = cdr(w2);
    w5 = a;
    q = car(a);
#define LL_CordenvC LITERAL[25]
    a = value(LL_CordenvC);
    a = Leqn(a, q);
    if(a != nil) goto    G0136;
    a = car(w11);
    a = CC_reorderH(a);
    q = a;
    a = w11;
    car(a) = q;
    a = cdr(w5);
    a = CC_reorderH(a);
    q = a;
    a = w5;
    cdr(a) = q;
    q = value(LL_CordenvC);
    a = w5;
    car(a) = q;
   G0136:
    a = cdr(w5);
    w5 = a;
    a = car(car(w2));
    w11 = a;
    a = car(a);
    w4 = a;
    a = cdr(w11);
    w8 = a;
    a = cdr(car(w2));
    w11 = a;
    a = car(a);
    w6 = a;
    a = cdr(w11);
    w7 = a;
    a = w6;
    CC_initTdlis(a);
   G0128:
    a = w6;
    if(a != nil) goto    G0140;
    m = w5;
    q = w4;
    a = w1;
    a = CC_replaceH(a, q, m);
    w11 = a;
    if(a == w1) goto    G0161;
    w1 = a;
    goto    G0131;
   G0140:
    a = w1;
    a = CC_Wmonomial(a);
    if(a == nil) goto    G0147;
    arg5 = nil;
    arg4 = nil;
    m = w6;
    q = w4;
    a = w1;
    a = CC_matchH(a, q, m, arg4, arg5);
    if(a == nil) goto    G0161;
    a = w7;
    a = CC_Wchkpreds(a);
    if(a == nil) goto    G0161;
    goto    G0153;
   G0147:
    a = nil;
    a = Lncons(a);
#define LL_Hsave LITERAL[26]
    value(LL_Hsave) = a;
    arg5 = w9;
    arg4 = nil;
    m = w6;
    q = w4;
    a = w1;
    a = CC_matchH(a, q, m, arg4, arg5);
    w9 = a;
    if(a == nil) goto    G0161;
    a = w7;
    a = CC_Wchkpreds(a);
    if(a == nil) goto    G0147;
   G0153:
#define LL_untrac LITERAL[27]
    q = LL_untrac;
#define LL_Htracmode LITERAL[28]
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    q = w6;
    a = w4;
    a = CC_substTptn(a, q);
    w12 = a;
    q = w6;
    a = w5;
    a = CC_substTptn(a, q);
    m = a;
    q = w12;
    a = w1;
    a = CC_replaceH(a, q, m);
    w1 = a;
   G0131:
    a = CC_idlistH(a);
    w3 = a;
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = value(LL_Crewrite);
    a = Lgeq(a, q);
    if(a != nil) goto    G0162;
    arg4 = w8;
    m = w4;
    q = w3;
    a = w1;
    a = CC_Wmchcheck(a, q, m, arg4);
    if(a == nil) goto    G0161;
    a = w6;
    CC_initTdlis(a);
    a = nil;
    value(LL_Hsave) = a;
    w9 = a;
    goto    G0128;
   G0162:
    q = value(LL_Crewrite);
    a = LITERAL[15];
    CC_printmsg(a, q);
   G0161:
    a = w3;
    value(LL_Htemporal) = a;
    a = w1;
    popv(12);
    return a;
}

Sex CC_replaceH(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    if(!is_cons(a)) goto    G0167;
    if(is_cons(q)) goto    G0166;
   G0167:
    if(is_number(a)) goto    G0200;
    if(!is_number(q)) goto    G0202;
    goto    G0200;
   G0166:
    a = car(q);
    if(!is_integer(a)) goto    G0174;
    a = q;
    a = CC_Wstruct(a);
    if(a != nil) goto    G0202;
   G0174:
    a = w3;
    if(!is_cons(a)) goto    G0172;
    a = car(a);
    if(!is_integer(a)) goto    G0172;
    a = w3;
    a = CC_Wstruct(a);
    if(a != nil) goto    G0202;
   G0172:
    a = car(w1);
    if(!is_integer(a)) goto    G0176;
    a = w1;
    a = CC_Wstruct(a);
    if(a == nil) goto    G0178;
    arg4 = w3;
    m = w2;
    q = w1;
#define LL_replacH LITERAL[29]
    a = LL_replacH;
    {
        popv(4);
        return  CC_mapcanoT3arg(a, q, m, arg4);
    }
   G0178:
    w4 = nil;
    m = true;
    q = w2;
    a = w1;
    a = CC_trysbtrH(a, q, m);
    w4 = a;
    if(a != nil) goto    G0192;
    goto    G0203;
   G0176:
#define LL_cL LITERAL[30]
    if(a != LL_cL) goto    G0186;
    a = w2;
    a = CC_Wmonomial(a);
    if(a == nil) goto    G0188;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(4);
        return  CC_rpfctrTcL(a, q, m);
    }
   G0188:
    w4 = nil;
    m = true;
    q = w2;
    a = w1;
    a = CC_trysbtrH(a, q, m);
    w4 = a;
    if(a != nil) goto    G0192;
   G0203:
    a = w1;
    goto    G0200;
   G0192:
    a = w2;
    a = CC_negH(a);
    q = a;
    a = w3;
    a = CC_addH(a, q);
    q = a;
    a = w4;
    a = CC_multH(a, q);
    w4 = a;
    q = a;
    a = w1;
    {
        popv(4);
        return  CC_addH(a, q);
    }
   G0186:
    q = LITERAL[31];
    a = Lmemq(a, q);
    if(a != nil) goto    G0196;
   G0202:
    q = LITERAL[32];
    a = mkfxat(3);
    {
        popv(4);
        return  CC_errormsg(a, q);
    }
   G0196:
    a = car(w2);
    if(is_integer(a)) goto    G0198;
    a = cdr(cdr(cdr(w2)));
    if(a != nil) goto    G0198;
    a = car(cdr(cdr(w2)));
    a = Lonep(a);
    if(a == nil) goto    G0198;
    a = car(cdr(w2));
    if(!is_cons(a)) goto    G0198;
    a = car(a);
    a = CC_Wfunc(a);
    if(a == nil) goto    G0198;
    m = w3;
    q = car(cdr(w2));
    a = w1;
    {
        popv(4);
        return  CC_rpfuncH(a, q, m);
    }
   G0198:
    m = w3;
    q = w2;
    a = w1;
    a = CC_rpfctrTcH(a, q, m);
   G0200:
    popv(4);
    return a;
}

Sex CC_rpfuncH(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    if(is_number(a)) goto    G0210;
    a = car(a);
    if(!is_integer(a)) goto    G0209;
   G0210:
    a = w1;
    goto    G0212;
   G0209:
    q = LL_cL;
    a = Lneq(a, q);
    if(a == nil) goto    G0211;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_rpfuncTcH(a, q, m);
    }
   G0211:
    arg6 = w1;
    arg5 = w3;
    arg4 = w2;
#define LL_rpfuncTcH LITERAL[33]
    m = LL_rpfuncTcH;
#define LL_unity LITERAL[34]
    q = LL_unity;
    a = LL_unity;
    a = CC_mapTcLargarg(a, q, m, arg4, arg5, arg6);
   G0212:
    popv(3);
    return a;
}

Sex CC_rpfuncTcH(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    a = cdr(a);
    w4 = a;
    w2 = q;
    w3 = m;
   G0216:
    a = car(cdr(w4));
    w6 = a;
    if(!is_cons(a)) goto    G0220;
    a = car(a);
    if(!is_symbol(a)) goto    G0220;
    m = w3;
    q = w2;
    a = w6;
    a = CC_rpfuncH(a, q, m);
    w6 = a;
   G0220:
    a = car(w4);
    w5 = a;
    if(is_number(a)) goto    G0226;
    a = car(a);
    if(is_integer(a)) goto    G0226;
    q = LITERAL[35];
    a = Lmemq(a, q);
    m = w3;
    q = w2;
    if(a == nil) goto    G0225;
    a = w5;
    a = CC_rpfuncH(a, q, m);
    goto    G0284;
   G0225:
    a = w5;
    a = CC_rpfuncTfunc(a, q, m);
   G0284:
    w5 = a;
   G0226:
    a = w5;
    if(a != car(w4)) goto    G0228;
    a = w6;
    if(a != car(cdr(w4))) goto    G0228;
    a = cdr(cdr(w4));
    w4 = a;
    if(a == nil) goto    G0231;
    q = w6;
    a = w5;
    a = cons(a, q);
    q = w7;
    a = cons(a, q);
    w7 = a;
    goto    G0216;
   G0231:
    a = w8;
    if(a != nil) goto    G0233;
    a = w1;
    goto    G0215;
   G0233:
    q = w6;
    a = w5;
    a = cons(a, q);
    q = w7;
    a = cons(a, q);
    q = a;
    goto    G0285;
   G0228:
    a = w5;
    if(!is_number(a)) goto    G0239;
    q = w6;
    a = CC_powH(a, q);
    w9 = a;
    if(!is_number(a)) goto    G0241;
    q = nil;
    a = Lxcons(a, q);
    goto    G0298;
   G0241:
    q = mkfxat(1);
    a = cdr(a);
    a = cons(a, q);
    goto    G0298;
   G0239:
    if(!is_integer(a)) goto    G0243;
    a = CC_numcontH(a);
    w9 = a;
    a = Lonep(a);
    if(a == nil) goto    G0245;
    q = w6;
    a = w5;
    a = Llist2(a, q);
    q = mkfxat(1);
    a = cons(a, q);
    goto    G0298;
   G0245:
    q = w9;
    a = w5;
    a = CC_quotiH(a, q);
    w5 = a;
    q = w6;
    a = w9;
    a = CC_powH(a, q);
    w9 = a;
    a = Lnumberp(a);
    if(a == nil) goto    G0248;
    q = w6;
    a = w5;
    a = Llist2(a, q);
    q = w9;
    a = cons(a, q);
    goto    G0298;
   G0248:
    q = cdr(w9);
    a = w6;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    q = mkfxat(1);
    a = cons(a, q);
    goto    G0298;
   G0243:
    a = car(a);
#define LL_cH LITERAL[36]
    if(a != LL_cH) goto    G0254;
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G0256;
    q = mkfxat(1);
    a = cdr(w5);
    a = cons(a, q);
    goto    G0298;
   G0256:
    a = mkfxat(1);
    w9 = a;
    goto    G0218;
   G0254:
#define LL_ncH LITERAL[37]
    if(a != LL_ncH) goto    G0258;
    q = w6;
    a = w5;
    a = Llist2(a, q);
    q = mkfxat(1);
    a = cons(a, q);
    goto    G0298;
   G0258:
    a = cdr(cdr(w5));
    if(a == nil) goto    G0260;
    q = w6;
    a = w5;
    a = Llist2(a, q);
    q = mkfxat(1);
    a = cons(a, q);
    goto    G0298;
   G0260:
    a = car(cdr(w5));
    w5 = a;
    a = car(a);
    a = car(a);
    if(a != LL_ncH) goto    G0262;
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G0266;
    q = mkfxat(1);
    a = car(w5);
    a = Llist2(a, q);
    q = cdr(w5);
    a = cons(a, q);
    goto    G0298;
   G0266:
    q = w6;
    a = cdr(w5);
    a = CC_powH(a, q);
    w9 = a;
    if(!is_number(a)) goto    G0268;
    q = w6;
    a = car(w5);
    a = Llist2(a, q);
    q = w9;
    a = cons(a, q);
    goto    G0298;
   G0268:
    q = cdr(a);
    a = w6;
    a = cons(a, q);
    q = car(w5);
    a = Lxcons(a, q);
    q = mkfxat(1);
    a = cons(a, q);
    goto    G0298;
   G0273:
    q = w5;
    a = CHAR_OF(42);
    a = cons(a, q);
    q = w7;
    a = cons(a, q);
    w7 = a;
    a = cdr(cdr(w4));
    w4 = a;
    if(a != nil) goto    G0216;
    q = w7;
   G0285:
    a = car(w1);
    {
        popv(9);
        return  CC_subTmkterm(a, q);
    }
   G0262:
    a = cdr(w5);
    w9 = a;
    a = car(w5);
    w5 = a;
   G0218:
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G0279;
    q = w9;
    a = cdr(w5);
    a = cons(a, q);
    goto    G0298;
   G0279:
    q = w6;
    a = w5;
    a = CC_powH(a, q);
    w5 = a;
    q = w6;
    a = w9;
    a = CC_powH(a, q);
    w9 = a;
    if(!is_number(a)) goto    G0281;
    q = cdr(w5);
    a = Lxcons(a, q);
    goto    G0298;
   G0281:
    q = cdr(a);
    a = cdr(w5);
    a = Lnconc(a, q);
    q = mkfxat(1);
    a = cons(a, q);
   G0298:
    w5 = a;
    goto    G0273;
   G0215:
    popv(9);
    return a;
}

Sex CC_rpfuncTfunc(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = mkfxat(1);
    w5 = a;
    w2 = q;
    w3 = m;
    a = cdr(w1);
    w4 = a;
    if(a == nil) goto    G0306;
    a = car(a);
    if(!is_cons(a)) goto    G0306;
    a = car(a);
    if(a != LL_Bindex) goto    G0306;
    a = cdr(w4);
    w4 = a;
    a = mkfxat(2);
    goto    G0316;
   G0306:
    a = w4;
    if(a == nil) goto    G0304;
    m = w3;
    q = w2;
    a = car(a);
    a = CC_rpfuncH(a, q, m);
    w7 = a;
    if(a == car(w4)) goto    G0303;
    a = w1;
    a = CC_topcopy(a);
    w1 = a;
    q = w5;
    a = CC_ncdr(a, q);
    q = w7;
    car(a) = q;
   G0303:
    a = cdr(w4);
    w4 = a;
    a = w5;
    a = Ladd1(a);
   G0316:
    w5 = a;
    goto    G0306;
   G0304:
    q = car(w2);
    a = car(w1);
    a = Lneq(a, q);
    if(a != nil) goto    G0314;
    q = w2;
    a = w1;
    a = CC_Wequal(a, q);
    if(a == nil) goto    G0314;
    a = w3;
    goto    G0301;
   G0314:
    a = w1;
   G0301:
    popv(7);
    return a;
}

Sex CC_subTmkterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a != LL_cH) goto    G0323;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = mkfxat(1);
    w4 = a;
    w2 = q;
   G0325:
    a = car(w2);
    w7 = a;
    a = car(a);
    q = CHAR_OF(42);
    a = Lneq(a, q);
    if(a != nil) goto    G0359;
    q = cdr(cdr(w7));
    a = w4;
    a = times2(a, q);
    w4 = a;
    a = car(cdr(w7));
    w7 = a;
    if(a == nil) goto    G0336;
    q = w4;
    a = car(a);
    a = CC_Wcommute(a, q);
    if(a == nil) goto    G0327;
    q = w5;
    a = w7;
    goto    G0357;
   G0359:
    q = w3;
    a = cdr(w7);
    a = cons(a, q);
    q = car(w7);
    a = Lxcons(a, q);
    w3 = a;
   G0336:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0325;
    w8 = nil;
    a = w5;
   G0340:
    if(a == nil) goto    G0339;
    q = car(cdr(a));
    a = car(a);
    a = Llist2(a, q);
    q = w3;
    a = CC_mergeTcH(a, q);
    w3 = a;
    a = cdr(cdr(w5));
    w5 = a;
    w8 = a;
    goto    G0340;
   G0339:
    a = w3;
    a = CC_reduceTcH(a);
    w3 = a;
    a = w6;
    if(a == nil) goto    G0345;
    q = w3;
    a = CC_multH(a, q);
    w3 = a;
   G0345:
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G0347;
    a = w3;
    goto    G0356;
   G0347:
    q = w3;
    a = w4;
    {
        popv(8);
        return  CC_multH(a, q);
    }
   G0327:
    a = w6;
    q = car(cdr(w7));
    if(a != nil) goto    G0351;
    a = car(w7);
    a = CC_powH(a, q);
    goto    G0358;
   G0351:
    a = car(w7);
    a = CC_powH(a, q);
    q = w6;
    a = CC_multH(a, q);
   G0358:
    w6 = a;
    a = cdr(cdr(w7));
    w7 = a;
    if(a == nil) goto    G0336;
    q = w5;
   G0357:
    a = Lappend(a, q);
    w5 = a;
    goto    G0336;
   G0323:
    a = nil;
   G0356:
    popv(8);
    return a;
}

Sex CC_ptntypeT(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_cons(a)) goto    G0374;
    a = car(a);
    if(is_integer(a)) goto    G0381;
    q = LITERAL[31];
    a = Lmemq(a, q);
    if(a == nil) goto    G0369;
    a = w1;
    a = CC_Wsinglefunc(a);
    if(a == nil) goto    G0374;
    a = LL_func;
    goto    G0375;
   G0369:
    q = LL_cL;
    a = car(w1);
    a = Lneq(a, q);
    if(a == nil) goto    G0373;
   G0377:
#define LL_other LITERAL[38]
    a = LL_other;
    goto    G0375;
   G0373:
    a = cdr(cdr(w1));
    if(a == nil) goto    G0374;
   G0379:
#define LL_mult LITERAL[39]
    a = LL_mult;
    goto    G0375;
   G0381:
    if(a >= value(LL_CmaxcanoC)) goto    G0377;
    a = w1;
    a = CC_Wmonomial(a);
    if(a == nil) goto    G0379;
   G0374:
#define LL_mono LITERAL[40]
    a = LL_mono;
   G0375:
    popv(1);
    return a;
}

Sex CC_mkTdmypreds(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = w1;
    a = CC_idlistH(a);
    w6 = a;
    w7 = a;
    if(a != nil) goto    G0389;
    {
        popv(7);
        return  Lncons(a);
    }
   G0389:
    a = w2;
    if(!is_cons(a)) goto    G0392;
    a = car(a);
#define LL_and LITERAL[41]
    if(a != LL_and) goto    G0392;
    a = cdr(w2);
    goto    G0394;
   G0392:
    a = w2;
    a = Lncons(a);
   G0394:
    w2 = a;
   G0385:
    a = car(w7);
    a = CC_Wdummy(a);
    if(a == nil) goto    G0396;
    a = nil;
    a = Lncons(a);
    q = car(w7);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0396:
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G0385;
    a = cdr(w3);
    w3 = a;
   G0386:
    value(LL_Hsave) = nil;
    a = w2;
    if(a != nil) goto    G0404;
    a = w5;
    a = Lreverse(a);
    q = w3;
    {
        popv(7);
        return  Lxcons(a, q);
    }
   G0404:
    a = car(a);
    if(!is_cons(a)) goto    G0409;
    CC_mkTpred(a);
   G0409:
    a = value(LL_Hsave);
    w7 = a;
   G0387:
    if(a == nil) goto    G0413;
    q = w6;
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0421;
    a = cdr(w7);
    w7 = a;
    goto    G0387;
   G0421:
    q = car(w7);
    a = LITERAL[42];
    CC_errormsg(a, q);
   G0413:
    a = value(LL_Hsave);
    if(a == nil) goto    G0417;
    a = cdr(a);
    if(a == nil) goto    G0416;
    q = w5;
    a = car(w2);
    a = cons(a, q);
    w5 = a;
    goto    G0417;
   G0416:
    q = w3;
    a = car(value(LL_Hsave));
    a = Latsoc(a, q);
    a = cdr(a);
    w4 = a;
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = cdr(w4);
    a = Lnconc(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
   G0417:
    a = cdr(w2);
    w2 = a;
    goto    G0386;
}

Sex CC_mkTpred(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a == nil) goto    G0429;
    w1 = a;
    a = car(a);
    if(!is_cons(a)) goto    G0426;
    CC_mkTpred(a);
    goto    G0433;
   G0426:
    if(!is_symbol(a)) goto    G0433;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a == nil) goto    G0433;
    a = car(w1);
    a = CC_Wdummy(a);
    if(a == nil) goto    G0433;
    a = car(w1);
    a = Lncons(a);
    q = value(LL_Hsave);
    a = CC_seTunionids(a, q);
    value(LL_Hsave) = a;
    q = car(w1);
#define LL_Bloc LITERAL[43]
    a = LL_Bloc;
    a = Llist2(a, q);
    q = a;
    a = w1;
    car(a) = q;
   G0433:
    a = cdr(w1);
    a = CC_mkTpred(a);
   G0429:
    popv(1);
    return a;
}

Sex CC_Wchkpreds(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a != nil) goto    G0437;
    a = true;
    goto    G0440;
   G0437:
    w1 = a;
    a = car(a);
    a = Lcopy(a);
    a = CC_galeval(a);
    if(a == nil) goto    G0440;
    a = cdr(w1);
    a = CC_Wchkpreds(a);
   G0440:
    popv(1);
    return a;
}

Sex CC_mkTmchlis(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
#define LL_Boset LITERAL[44]
    a = LL_Boset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = w1;
   G0444:
    if(a == nil) goto    G0450;
    m = car(cdr(car(a)));
    q = car(car(a));
#define LL_rM LITERAL[45]
    a = LL_rM;
    a = Llist3(a, q, m);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    goto    G0444;
   G0450:
    a = w2;
    popv(3);
    return a;
}

Sex CC_substTptn(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    a = CC_valdlisT(a);
    w2 = a;
    if(a == nil) goto    G0468;
    a = w1;
    if(is_cons(a)) goto    G0455;
    if(is_number(a)) goto    G0460;
    q = w2;
    a = Latsoc(a, q);
    w2 = a;
    if(a == nil) goto    G0468;
    a = car(cdr(a));
    goto    G0460;
   G0455:
    a = CC_idlistH(a);
    q = w2;
    a = CC_dlisT(a, q);
    w2 = a;
   G0462:
    if(a == nil) goto    G0468;
    a = car(cdr(car(a)));
    a = CC_Amkexpr(a);
    m = a;
    q = car(car(w2));
    a = w1;
    a = CC_substH(a, q, m);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    goto    G0462;
   G0468:
    a = w1;
   G0460:
    popv(2);
    return a;
}

Sex CC_initTdlis(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a != nil) goto    G0472;
    a = true;
    goto    G0474;
   G0472:
    w1 = a;
    a = car(cdr(car(a)));
    if(a == nil) goto    G0475;
    q = nil;
    a = cdr(car(w1));
    car(a) = q;
    q = nil;
    a = car(car(w1));
    Lset(a, q);
   G0475:
    a = cdr(w1);
    a = CC_initTdlis(a);
   G0474:
    popv(1);
    return a;
}

Sex CC_copyTdlis(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G0482;
    w1 = a;
    a = car(cdr(car(a)));
    if(a == nil) goto    G0480;
    a = cdr(w1);
    a = CC_copyTdlis(a);
    q = car(w1);
    goto    G0486;
   G0480:
    q = cdr(cdr(car(w1)));
    a = cons(a, q);
    q = car(car(w1));
    a = Lxcons(a, q);
    w2 = a;
    a = cdr(w1);
    a = CC_copyTdlis(a);
    q = w2;
   G0486:
    a = Lxcons(a, q);
   G0482:
    popv(2);
    return a;
}

Sex CC_recovTdlis(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a != nil) goto    G0490;
    a = true;
    goto    G0491;
   G0490:
    w1 = a;
    w2 = q;
    a = q;
    if(a == nil) goto    G0494;
    a = car(cdr(car(a)));
    if(a != nil) goto    G0493;
   G0494:
    a = car(w1);
    CC_remTmch(a);
   G0493:
    a = w2;
    if(a == nil) goto    G0497;
    a = cdr(a);
   G0497:
    q = a;
    a = cdr(w1);
    a = CC_recovTdlis(a, q);
   G0491:
    popv(2);
    return a;
}

Sex CC_remTmch(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = nil;
    a = cdr(a);
    car(a) = q;
    q = nil;
    a = car(w1);
    {
        popv(1);
        return  Lset(a, q);
    }
}

Sex CC_Amatch(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_ptntypeT(a);
    if(a != LL_other) goto    G0506;
    q = LITERAL[46];
    a = LITERAL[47];
    goto    G0522;
   G0506:
    a = w2;
    a = CC_ptntypeT(a);
    if(a != LL_other) goto    G0507;
    q = LITERAL[46];
    a = LITERAL[48];
   G0522:
    CC_errormsg(a, q);
   G0507:
    arg4 = nil;
    m = w2;
    q = nil;
    a = w1;
    a = CC_Wmchcheck(a, q, m, arg4);
    if(a == nil) goto    G0524;
    q = w3;
    a = w2;
    a = CC_mkTdmypreds(a, q);
    w7 = a;
    a = car(a);
    w4 = a;
    a = cdr(w7);
    w5 = a;
    a = w4;
    if(a != nil) goto    G0525;
    q = w2;
    a = w1;
    a = CC_Wequal(a, q);
    if(a == nil) goto    G0524;
    a = nil;
    goto    G0503;
   G0525:
    a = nil;
    a = Lncons(a);
    w6 = a;
   G0512:
    arg5 = w6;
    arg4 = true;
    m = w4;
    q = w2;
    a = w1;
    a = CC_matchH(a, q, m, arg4, arg5);
    w7 = a;
#define LL_fail LITERAL[49]
    if(a != LL_fail) goto    G0518;
   G0524:
    a = LL_fail;
    goto    G0503;
   G0518:
    if(a == nil) goto    G0512;
    a = w5;
    a = CC_Wchkpreds(a);
    if(a == nil) goto    G0512;
    a = w4;
    a = CC_mkTmchlis(a);
   G0503:
    popv(7);
    return a;
}

Sex CC_Apartmatch(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_ptntypeT(a);
    if(a != LL_other) goto    G0531;
    q = LITERAL[50];
    a = LITERAL[47];
    goto    G0547;
   G0531:
    a = w2;
    a = CC_ptntypeT(a);
    if(a != LL_other) goto    G0532;
    q = LITERAL[50];
    a = LITERAL[48];
   G0547:
    CC_errormsg(a, q);
   G0532:
    arg4 = nil;
    m = w2;
    q = nil;
    a = w1;
    a = CC_Wmchcheck(a, q, m, arg4);
    if(a == nil) goto    G0549;
    q = w3;
    a = w2;
    a = CC_mkTdmypreds(a, q);
    w7 = a;
    a = car(a);
    w4 = a;
    a = cdr(w7);
    w5 = a;
    a = w4;
    if(a != nil) goto    G0550;
    q = w2;
    a = w1;
    a = CC_Wpartequal(a, q);
    if(a == nil) goto    G0549;
    a = nil;
    goto    G0528;
   G0550:
    a = nil;
    a = Lncons(a);
    w6 = a;
   G0537:
    arg5 = w6;
    arg4 = nil;
    m = w4;
    q = w2;
    a = w1;
    a = CC_matchH(a, q, m, arg4, arg5);
    w7 = a;
    if(a != LL_fail) goto    G0543;
   G0549:
    a = LL_fail;
    goto    G0528;
   G0543:
    if(a == nil) goto    G0537;
    a = w5;
    a = CC_Wchkpreds(a);
    if(a == nil) goto    G0537;
    a = w4;
    a = CC_mkTmchlis(a);
   G0528:
    popv(7);
    return a;
}

Sex CC_matchH(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = m;
    a = CC_valdlisT(a);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G0554;
    q = a;
    a = w2;
    a = CC_substTptn(a, q);
    w2 = a;
    a = Lnumberp(a);
    if(a != nil) goto    G0556;
    a = w3;
    a = CC_WallvTdms(a);
   G0556:
    if(a == nil) goto    G0554;
    a = w4;
    q = w2;
    if(a == nil) goto    G0560;
    a = w1;
    a = CC_Wequal(a, q);
    goto    G0561;
   G0560:
    a = w1;
    a = CC_Wpartequal(a, q);
   G0561:
    if(a == nil) goto    G0558;
    a = mkfxat(1);
    goto    G0569;
   G0558:
    a = LL_fail;
    goto    G0569;
   G0554:
    a = w1;
    if(!is_number(a)) goto    G0563;
    arg4 = true;
    m = w3;
    q = w2;
    {
        popv(5);
        return  CC_mchTbnumptn(a, q, m, arg4);
    }
   G0563:
    a = car(a);
    if(!is_integer(a)) goto    G0564;
    a = car(w2);
    if(!is_integer(a)) goto    G0566;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTcanocano(a, q, m, arg4, arg5);
    }
   G0566:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTcanopref(a, q, m, arg4, arg5);
    }
   G0564:
    a = car(w2);
    if(!is_integer(a)) goto    G0568;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTprefcano(a, q, m, arg4, arg5);
    }
   G0568:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    a = CC_mchTprefpref(a, q, m, arg4, arg5);
   G0569:
    popv(5);
    return a;
}

Sex CC_mchTcanocano(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
#define LL_CratfC LITERAL[51]
    if(a != value(LL_CratfC)) goto    G0573;
    a = car(q);
    if(a != value(LL_CratfC)) goto    G0575;
    a = w1;
    {
        popv(5);
        return  CC_mchTratfratf(a, q, m, arg4, arg5);
    }
   G0575:
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = cdr(q);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0576;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTratfterm(a, q, m, arg4, arg5);
    }
   G0576:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTratfsum(a, q, m, arg4, arg5);
    }
   G0573:
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = cdr(w1);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0578;
    a = car(w2);
    if(a != value(LL_CratfC)) goto    G0580;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTtermratf(a, q, m, arg4, arg5);
    }
   G0580:
    a = cdr(w2);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0581;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTtermterm(a, q, m, arg4, arg5);
    }
   G0581:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTtermsum(a, q, m, arg4, arg5);
    }
   G0578:
    a = car(w2);
    if(a != value(LL_CratfC)) goto    G0583;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumratf(a, q, m, arg4, arg5);
    }
   G0583:
    a = cdr(w2);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0584;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumterm(a, q, m, arg4, arg5);
    }
   G0584:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumsum(a, q, m, arg4, arg5);
    }
}

Sex CC_mchTcanopref(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != value(LL_CratfC)) goto    G0589;
    a = car(q);
    if(a == LL_cH) goto    G0608;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(a == LL_ncH) goto    G0605;
    a = q;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G0605;
    a = cdr(cdr(w2));
    if(a == nil) goto    G0594;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTratfsum(a, q, m, arg4, arg5);
    }
   G0594:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
   G0608:
    a = w1;
    {
        popv(5);
        return  CC_mchTratfterm(a, q, m, arg4, arg5);
    }
   G0589:
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = cdr(w1);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0596;
    a = car(w2);
    if(a == LL_cH) goto    G0601;
    if(a == LL_ncH) goto    G0605;
    a = w2;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G0605;
    a = cdr(cdr(w2));
    if(a == nil) goto    G0601;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTtermsum(a, q, m, arg4, arg5);
    }
   G0601:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTtermterm(a, q, m, arg4, arg5);
    }
   G0596:
    a = car(w2);
    if(a == LL_cH) goto    G0606;
    if(a == LL_ncH) goto    G0605;
    a = w2;
    a = CC_WcommTcL(a);
    if(a != nil) goto    G0604;
   G0605:
    a = LL_fail;
    goto    G0607;
   G0604:
    a = cdr(cdr(w2));
    if(a == nil) goto    G0606;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumsum(a, q, m, arg4, arg5);
    }
   G0606:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    a = CC_mchTsumterm(a, q, m, arg4, arg5);
   G0607:
    popv(5);
    return a;
}

Sex CC_mchTprefcano(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != LL_cH) goto    G0616;
    a = car(q);
    if(a == value(LL_CratfC)) goto    G0631;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = cdr(w1);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0629;
    goto    G0632;
   G0616:
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(a == LL_ncH) goto    G0622;
    a = w1;
    a = CC_WcommTcL(a);
    if(a != nil) goto    G0621;
   G0622:
    a = LL_fail;
    goto    G0630;
   G0621:
    a = cdr(cdr(w1));
    if(a == nil) goto    G0623;
    a = car(w2);
    if(a != value(LL_CratfC)) goto    G0625;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumratf(a, q, m, arg4, arg5);
    }
   G0625:
    a = cdr(w2);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0626;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumterm(a, q, m, arg4, arg5);
    }
   G0626:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumsum(a, q, m, arg4, arg5);
    }
   G0623:
    a = car(w2);
    if(a != value(LL_CratfC)) goto    G0628;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
   G0631:
    a = w1;
    {
        popv(5);
        return  CC_mchTtermratf(a, q, m, arg4, arg5);
    }
   G0628:
    a = cdr(w1);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G0629;
   G0632:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTtermterm(a, q, m, arg4, arg5);
    }
   G0629:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    a = CC_mchTtermsum(a, q, m, arg4, arg5);
   G0630:
    popv(5);
    return a;
}

Sex CC_mchTprefpref(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    if(a != LL_cH) goto    G0637;
    a = car(q);
    if(a == LL_cH) goto    G0682;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(a == LL_ncH) goto    G0670;
    a = q;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G0670;
    a = cdr(cdr(w2));
    if(a != nil) goto    G0661;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    goto    G0682;
   G0637:
    if(a != LL_ncH) goto    G0644;
    a = car(q);
    if(a == LL_ncH) goto    G0680;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(a == LL_cH) goto    G0670;
    a = q;
    a = CC_WcommTcL(a);
    if(a != nil) goto    G0670;
    a = cdr(cdr(w2));
    if(a != nil) goto    G0671;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    goto    G0680;
   G0644:
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = w1;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G0651;
    a = car(w2);
    if(a != LL_cH) goto    G0653;
    a = cdr(cdr(w1));
    if(a != nil) goto    G0681;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    goto    G0682;
   G0653:
    if(a == LL_ncH) goto    G0670;
    a = w2;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G0670;
    a = cdr(cdr(w2));
    if(a == nil) goto    G0659;
    a = cdr(cdr(w1));
    if(a == nil) goto    G0661;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumsum(a, q, m, arg4, arg5);
    }
   G0661:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTtermsum(a, q, m, arg4, arg5);
    }
   G0659:
    a = cdr(cdr(w1));
    if(a == nil) goto    G0663;
   G0681:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTsumterm(a, q, m, arg4, arg5);
    }
   G0663:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
   G0682:
    a = w1;
    {
        popv(5);
        return  CC_mchTtermterm(a, q, m, arg4, arg5);
    }
   G0651:
    a = car(w2);
    if(a != LL_ncH) goto    G0665;
    a = cdr(cdr(w1));
    if(a == nil) goto    G0667;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTnsumnterm(a, q, m, arg4, arg5);
    }
   G0667:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
   G0680:
    a = w1;
    {
        popv(5);
        return  CC_mchTntermnterm(a, q, m, arg4, arg5);
    }
   G0665:
    if(a == LL_cH) goto    G0670;
    a = w2;
    a = CC_WcommTcL(a);
    if(a == nil) goto    G0669;
   G0670:
    a = LL_fail;
    goto    G0672;
   G0669:
    a = cdr(cdr(w1));
    if(a == nil) goto    G0671;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_mchTnsumnsum(a, q, m, arg4, arg5);
    }
   G0671:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    a = CC_mchTntermnsum(a, q, m, arg4, arg5);
   G0672:
    popv(5);
    return a;
}

Sex CC_mchTbnumptn(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    if(!is_number(q)) goto    G0687;
    arg5 = arg4;
    arg4 = nil;
    m = mkfxat(1);
    goto    G0757;
   G0687:
    a = car(q);
    if(!is_integer(a)) goto    G0688;
#define LL_CpolyC LITERAL[52]
    if(a != value(LL_CpolyC)) goto    G0754;
    a = car(cdr(q));
    if(is_cons(a)) goto    G0754;
    q = m;
    a = CC_dlisT(a, q);
    w3 = a;
    if(a == nil) goto    G0754;
    a = car(cdr(cdr(w2)));
    value(LL_Htemporal) = a;
    a = cdr(a);
    a = CC_Wbnum(a);
    if(a == nil) goto    G0754;
    a = car(cdr(car(w3)));
    if(a == nil) goto    G0694;
    w2 = a;
    if(!is_number(a)) goto    G0754;
    a = w4;
    if(a != nil) goto    G0697;
    q = w2;
    a = w1;
    {
        popv(10);
        return  CC_divTbnumbnum(a, q);
    }
   G0697:
    q = w2;
    a = w1;
    a = Leqn(a, q);
    if(a == nil) goto    G0755;
    a = mkfxat(1);
    goto    G0755;
   G0694:
    w5 = nil;
    w6 = nil;
    a = car(value(LL_Htemporal));
    w5 = a;
    a = cdr(value(LL_Htemporal));
    w6 = a;
    a = Lonep(a);
    if(a != nil) goto    G0703;
    q = w6;
    a = w1;
    a = CC_divTbnumbnum(a, q);
    w1 = a;
   G0703:
    arg5 = w4;
    arg4 = w3;
    m = w5;
    q = car(cdr(w2));
    a = w1;
   G0757:
    {
        popv(10);
        return  CC_mchTbnumbpow(a, q, m, arg4, arg5);
    }
   G0688:
    if(a != LL_cH) goto    G0705;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    a = cdr(q);
    w5 = a;
    a = car(a);
    w6 = a;
    if(is_number(a)) goto    G0719;
    a = car(a);
    if(a != value(LL_CpolyC)) goto    G0754;
    a = car(cdr(w6));
    if(is_cons(a)) goto    G0754;
    a = cdr(w6);
    w6 = a;
    a = cdr(a);
    a = car(a);
    a = cdr(a);
    a = Lonep(a);
    if(a == nil) goto    G0754;
    q = w3;
    a = car(w6);
    a = CC_dlisT(a, q);
    w8 = a;
    if(a == nil) goto    G0754;
    a = car(cdr(car(a)));
    w9 = a;
    if(a == nil) goto    G0719;
    if(!is_number(a)) goto    G0754;
    q = cdr(cdr(w2));
    a = cons(a, q);
    q = LL_cH;
    a = Lxcons(a, q);
    w2 = a;
   G0719:
    a = car(cdr(w5));
    w7 = a;
    if(is_number(a)) goto    G0728;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G0754;
    a = car(cdr(w7));
    if(!is_symbol(a)) goto    G0754;
    q = w3;
    a = CC_dlisT(a, q);
    w9 = a;
    if(a == nil) goto    G0754;
    q = a;
    a = w8;
    a = Lappend(a, q);
    w8 = a;
   G0728:
    a = cdr(cdr(w5));
    w5 = a;
    if(a == nil) goto    G0732;
    a = car(a);
    if(!is_number(a)) goto    G0754;
    goto    G0719;
   G0732:
    a = cdr(w2);
    w5 = a;
    a = car(a);
    if(!is_number(a)) goto    G0734;
    a = w4;
    w10 = a;
    goto    G0736;
   G0734:
    a = true;
    w10 = a;
    a = cdr(cdr(w5));
    if(a == nil) goto    G0736;
    w5 = a;
   G0736:
    a = car(cdr(w5));
    w7 = a;
    if(is_number(a)) goto    G0744;
    q = w8;
    a = car(cdr(a));
    a = Latsoc(a, q);
    w9 = a;
    a = cdr(a);
    a = car(a);
    if(a == nil) goto    G0744;
    a = car(cdr(w9));
    w7 = a;
    if(!is_number(a)) goto    G0754;
   G0744:
    a = car(w5);
    w6 = a;
    if(is_number(a)) goto    G0746;
    a = car(cdr(a));
    w6 = a;
   G0746:
    arg5 = w10;
    arg4 = w8;
    m = w7;
    q = a;
    a = w1;
    a = CC_mchTbnumbpow(a, q, m, arg4, arg5);
    w1 = a;
    if(a == nil) goto    G0755;
    a = cdr(cdr(w5));
    w5 = a;
    if(a != nil) goto    G0736;
    a = car(cdr(w2));
    if(!is_number(a)) goto    G0751;
    a = w1;
    goto    G0755;
   G0751:
    m = car(cdr(cdr(w2)));
    q = a;
    a = LL_cH;
    a = Llist3(a, q, m);
    w2 = a;
    goto    G0736;
   G0705:
    if(a == LL_ncH) goto    G0754;
    a = cdr(cdr(q));
    if(a != nil) goto    G0754;
    q = LL_cH;
    a = car(car(cdr(w2)));
    a = Lneq(a, q);
    if(a == nil) goto    G0753;
   G0754:
    a = nil;
    goto    G0755;
   G0753:
    q = cdr(car(cdr(w2)));
    a = w1;
    a = CC_divTbnumbnum(a, q);
    arg4 = w4;
    m = w3;
    q = car(car(cdr(w2)));
    a = CC_mchTbnumptn(a, q, m, arg4);
   G0755:
    popv(10);
    return a;
}

Sex CC_mchTtermterm(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 17;
    w17 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = car(m);
    if(!is_cons(a)) goto    G0805;
    a = car(q);
    if(is_integer(a)) goto    G0797;
    if(a != LL_cH) goto    G0799;
    a = q;
    goto    G0800;
   G0799:
    a = car(car(cdr(q)));
   G0800:
    w14 = a;
    a = cdr(a);
    a = CC_WmonoTbcH(a);
    if(a != nil) goto    G0797;
    a = w1;
    a = CC_Wmonomial(a);
    if(a != nil) goto    G1010;
   G0797:
    a = car(w3);
    if(!is_cons(a)) goto    G0805;
    q = w3;
    a = w2;
    a = CC_belisT(a, q);
    w3 = a;
   G0805:
    a = car(w3);
    if(a != nil) goto    G0807;
    a = w4;
    if(a == nil) goto    G0807;
    a = true;
    w15 = a;
   G0807:
    a = cdr(w3);
    w3 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w8 = a;
    w7 = a;
    a = car(w1);
    if(is_integer(a)) goto    G1038;
    if(a != LL_cL) goto    G0817;
    a = cdr(car(cdr(w1)));
    w13 = a;
    a = car(car(cdr(w1)));
    w1 = a;
   G0817:
    a = LL_cH;
    a = Lncons(a);
    w6 = a;
    a = cdr(w1);
    w1 = a;
    goto    G0773;
   G1038:
    a = car(car(car(w3)));
    w10 = a;
    if(!is_cons(a)) goto    G0812;
    a = car(a);
    if(!is_integer(a)) goto    G1010;
   G0812:
    a = car(w1);
    w12 = a;
    a = Lncons(a);
    w6 = a;
    a = cdr(w1);
    w1 = a;
   G0815:
    a = car(w3);
    w9 = a;
    a = car(car(a));
    w10 = a;
    a = cdr(car(w9));
    w11 = a;
    if(a == nil) goto    G0829;
    a = CC_WallvTdms(a);
    if(a == nil) goto    G0820;
    q = w11;
    a = w10;
    a = CC_substTptnbase(a, q);
    w10 = a;
    if(!is_number(a)) goto    G0822;
    a = Lncons(a);
    q = cdr(w9);
    a = cons(a, q);
    w9 = a;
    a = w3;
    a = CC_tail(a);
    w17 = a;
    a = w9;
    a = Lncons(a);
    q = a;
    a = w17;
    cdr(a) = q;
    a = cdr(a);
    goto    G0845;
   G0820:
    a = w10;
    if(!is_cons(a)) goto    G0866;
    a = cdr(a);
    if(!is_cons(a)) goto    G0866;
    q = w11;
    a = car(a);
    a = Latsoc(a, q);
    w14 = a;
    if(a != nil) goto    G0833;
    a = true;
    w16 = a;
    goto    G0866;
   G0833:
    a = car(cdr(a));
    w14 = a;
    if(a == nil) goto    G0866;
    q = cdr(cdr(w10));
    a = cons(a, q);
    q = car(w10);
    a = Lxcons(a, q);
    w10 = a;
    a = true;
    w16 = a;
    q = cdr(car(w9));
    a = w10;
    a = cons(a, q);
    q = cdr(w9);
    a = cons(a, q);
    w9 = a;
    goto    G0866;
   G0822:
    a = car(a);
    if(!is_integer(a)) goto    G1010;
   G0829:
    a = w10;
    if(!is_number(a)) goto    G0840;
    arg4 = w15;
    m = w9;
    q = a;
    a = w1;
    a = CC_sdelTmon3Vnum(a, q, m, arg4);
    goto    G0841;
   G0840:
    arg5 = w15;
    arg4 = w6;
    m = w9;
    q = a;
    a = w1;
    a = CC_sdelTmon3Vvar(a, q, m, arg4, arg5);
   G0841:
    w1 = a;
    if(a == nil) goto    G1010;
    if(!is_number(a)) goto    G0844;
    w12 = nil;
    goto    G0845;
   G0844:
    a = car(a);
    if(!is_integer(a)) goto    G0845;
    w12 = a;
    a = cdr(w1);
    w1 = a;
   G0845:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0775;
    a = w1;
    if(!is_number(a)) goto    G0815;
    goto    G0937;
   G0773:
    a = car(w3);
    w9 = a;
    a = car(car(a));
    w10 = a;
    a = cdr(car(w9));
    w11 = a;
    if(a == nil) goto    G0859;
    a = CC_WallvTdms(a);
    if(a == nil) goto    G0851;
    q = w11;
    a = w10;
    a = CC_substTptnbase(a, q);
    w10 = a;
    if(!is_number(a)) goto    G0859;
    a = Lncons(a);
    q = cdr(w9);
    a = cons(a, q);
    w9 = a;
    a = w3;
    a = CC_tail(a);
    w17 = a;
    a = w9;
    a = Lncons(a);
    q = a;
    a = w17;
    cdr(a) = q;
    a = cdr(a);
    goto    G0876;
   G0851:
    a = w10;
    if(!is_cons(a)) goto    G0866;
    a = cdr(a);
    if(!is_cons(a)) goto    G0866;
    a = car(w10);
    if(a == LL_func) goto    G0863;
    if(!is_integer(a)) goto    G0866;
   G0863:
    q = w11;
    a = car(cdr(w10));
    a = Latsoc(a, q);
    w14 = a;
    if(a != nil) goto    G0865;
    a = true;
    w16 = a;
    goto    G0866;
   G0865:
    a = car(cdr(a));
    w14 = a;
    if(a == nil) goto    G0866;
    q = cdr(cdr(w10));
    a = cons(a, q);
    q = car(w10);
    a = Lxcons(a, q);
    w10 = a;
    a = true;
    w16 = a;
    q = cdr(car(w9));
    a = w10;
    a = cons(a, q);
    q = cdr(w9);
    a = cons(a, q);
    w9 = a;
   G0866:
    a = w9;
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
    goto    G0845;
   G0859:
    a = w10;
    if(!is_number(a)) goto    G0872;
    arg5 = w15;
    arg4 = w6;
    m = w9;
    q = a;
    a = w1;
    a = CC_sdelTcHVnum(a, q, m, arg4, arg5);
    goto    G0874;
   G0872:
    a = car(a);
    arg5 = w15;
    arg4 = w6;
    m = w9;
    if(!is_integer(a)) goto    G0873;
    q = w10;
    a = w1;
    a = CC_sdelTcHVvar(a, q, m, arg4, arg5);
    goto    G0874;
   G0873:
    q = cdr(w10);
    a = w1;
    a = CC_sdelTcHVbase(a, q, m, arg4, arg5);
   G0874:
    w1 = a;
    if(a == nil) goto    G1010;
   G0876:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0775;
    a = w1;
    if(!is_number(a)) goto    G0773;
    goto    G0937;
   G0775:
    a = w16;
    if(a == nil) goto    G0780;
    w16 = nil;
    a = cdr(w7);
    w3 = a;
    if(a == nil) goto    G0984;
    a = w1;
    if(is_number(a)) goto    G0937;
    a = CHAR_OF(104);
    a = Lncons(a);
    w8 = a;
    w7 = a;
    a = car(w6);
    if(a == LL_cH) goto    G0778;
   G0886:
    a = car(w3);
    w9 = a;
    a = car(car(a));
    w10 = a;
    a = cdr(car(w9));
    w11 = a;
    a = cdr(w10);
    if(!is_cons(a)) goto    G0889;
    q = w11;
    a = car(a);
    a = Latsoc(a, q);
    if(a == nil) goto    G0888;
   G0889:
    a = w9;
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
    goto    G0895;
   G0888:
    arg5 = w15;
    arg4 = w6;
    m = w9;
    q = w10;
    a = w1;
    a = CC_margTmon3Vivar(a, q, m, arg4, arg5);
    w1 = a;
    if(a == nil) goto    G1010;
    if(!is_number(a)) goto    G0894;
    w12 = nil;
    goto    G0895;
   G0894:
    a = car(a);
    if(!is_integer(a)) goto    G0895;
    w12 = a;
    a = cdr(w1);
    w1 = a;
   G0895:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0780;
    a = w1;
    if(!is_number(a)) goto    G0886;
    goto    G0937;
   G0778:
    a = car(w3);
    w9 = a;
    a = car(car(a));
    w10 = a;
    a = cdr(car(w9));
    w11 = a;
    a = w10;
    if(!is_cons(a)) goto    G0901;
    a = cdr(a);
    if(!is_cons(a)) goto    G0901;
    a = car(w10);
    if(a == LL_func) goto    G0902;
    if(!is_integer(a)) goto    G0901;
   G0902:
    q = w11;
    a = car(cdr(w10));
    a = Latsoc(a, q);
    if(a == nil) goto    G0900;
   G0901:
    a = w9;
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
    goto    G0909;
   G0900:
    a = car(w10);
    arg5 = w15;
    arg4 = w6;
    m = w9;
    if(!is_integer(a)) goto    G0906;
    q = w10;
    a = w1;
    a = CC_margTcHVivar(a, q, m, arg4, arg5);
    goto    G0907;
   G0906:
    q = cdr(w10);
    a = w1;
    a = CC_margTcHVfunc(a, q, m, arg4, arg5);
   G0907:
    w1 = a;
    if(a == nil) goto    G1010;
   G0909:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0780;
    a = w1;
    if(!is_number(a)) goto    G0778;
    goto    G0937;
   G0780:
    a = cdr(w7);
    w3 = a;
    if(a == nil) goto    G0984;
    a = cdr(a);
    if(a == nil) goto    G0785;
    a = w3;
    w11 = a;
    q = car(a);
    a = CHAR_OF(104);
    a = Llist2(a, q);
    w3 = a;
   G0781:
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G1037;
    a = car(a);
    w9 = a;
    a = car(car(a));
    w10 = a;
    a = w3;
    w8 = a;
   G0782:
    a = car(cdr(w8));
    w7 = a;
    a = car(a);
    a = car(a);
    a = cdr(a);
    if(is_cons(a)) goto    G0929;
    a = cdr(w10);
    if(is_cons(a)) goto    G0931;
    a = car(cdr(w7));
    a = Lonep(a);
    if(a == nil) goto    G0929;
    a = car(cdr(w9));
    a = Lonep(a);
    if(a == nil) goto    G0931;
    a = cdr(cdr(car(cdr(car(w7)))));
    if(a != nil) goto    G0929;
    a = cdr(cdr(car(cdr(car(w9)))));
    if(a != nil) goto    G0931;
   G0929:
    a = cdr(w8);
    w8 = a;
    a = cdr(a);
    if(a != nil) goto    G0782;
   G0931:
    q = cdr(w8);
    a = w9;
    a = cons(a, q);
    q = a;
    a = w8;
    cdr(a) = q;
    goto    G0781;
   G1037:
    a = cdr(w3);
    w3 = a;
   G0785:
    a = w1;
    if(!is_number(a)) goto    G0935;
   G0937:
    a = w13;
    if(a == nil) goto    G0939;
    q = w1;
    a = times2(a, q);
    w1 = a;
    w13 = nil;
   G0939:
    a = car(w3);
    w9 = a;
    a = car(car(a));
    w10 = a;
    a = cdr(car(w9));
    w11 = a;
    a = w10;
    if(is_number(a)) goto    G0949;
    a = w11;
    a = CC_WallvTdms(a);
    if(a == nil) goto    G0942;
    a = car(cdr(car(w11)));
    w10 = a;
    if(!is_number(a)) goto    G1010;
    goto    G0949;
   G0942:
    a = cdr(w10);
    if(is_cons(a)) goto    G1010;
    a = cdr(w3);
    if(a != nil) goto    G0947;
    a = w4;
    if(a == nil) goto    G0947;
    a = car(cdr(w9));
    a = Lonep(a);
    if(a != nil) goto    G0973;
   G0947:
    a = w1;
    a = Lonep(a);
    if(a != nil) goto    G1010;
   G0949:
    q = cdr(cdr(w9));
    a = w11;
    a = Lappend(a, q);
    w11 = a;
    a = w10;
    if(!is_cons(a)) goto    G0951;
    a = cdr(a);
    w10 = a;
   G0951:
    arg5 = nil;
    arg4 = w11;
    m = car(cdr(w9));
    q = a;
    a = w1;
    a = CC_mchTbnumbpow(a, q, m, arg4, arg5);
    w1 = a;
    if(a == nil) goto    G1010;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0984;
    goto    G0937;
   G0935:
    a = w12;
    if(a == nil) goto    G0789;
   G0787:
    a = car(w3);
    w9 = a;
    a = car(car(a));
    w10 = a;
    a = cdr(car(w9));
    w11 = a;
    a = CC_WallvTdms(a);
    if(a != nil) goto    G0791;
    a = cdr(w3);
    if(a != nil) goto    G0958;
    a = w4;
    if(a == nil) goto    G0958;
    a = cdr(w10);
    if(!is_symbol(a)) goto    G0958;
    a = car(cdr(w9));
    a = Lonep(a);
    if(a != nil) goto    G0973;
   G0958:
    a = car(w10);
    if(is_symbol(a)) goto    G1010;
    q = cdr(w10);
    a = w12;
    a = cons(a, q);
    arg5 = w15;
    arg4 = w6;
    m = w9;
    q = a;
    a = w1;
    a = CC_mdelTmon3Vvar(a, q, m, arg4, arg5);
    w1 = a;
    if(a == nil) goto    G1010;
    if(!is_number(a)) goto    G0965;
    w12 = nil;
    goto    G0966;
   G0965:
    a = car(a);
    if(!is_integer(a)) goto    G0966;
    w12 = a;
    a = cdr(w1);
    w1 = a;
   G0966:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0984;
    a = w1;
    if(!is_number(a)) goto    G0787;
    goto    G0937;
   G0789:
    a = car(w3);
    w9 = a;
    a = car(car(a));
    w10 = a;
    a = cdr(car(w9));
    w11 = a;
    a = CC_WallvTdms(a);
    if(a != nil) goto    G0791;
    a = cdr(w3);
    if(a != nil) goto    G0972;
    a = w4;
    if(a == nil) goto    G0972;
    a = cdr(w10);
    if(!is_symbol(a)) goto    G0972;
    a = car(cdr(w9));
    a = Lonep(a);
    if(a != nil) goto    G0973;
   G0972:
    a = car(w10);
    arg5 = w15;
    arg4 = w6;
    m = w9;
    q = w10;
    if(!is_integer(a)) goto    G0975;
    a = w1;
    a = CC_mdelTcHVvar(a, q, m, arg4, arg5);
    goto    G0976;
   G0975:
    a = w1;
    a = CC_mdelTcHVbase(a, q, m, arg4, arg5);
   G0976:
    w1 = a;
    if(a == nil) goto    G1010;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0984;
    a = w1;
    if(!is_number(a)) goto    G0789;
    goto    G0937;
   G0791:
    a = CHAR_OF(104);
    a = Lncons(a);
    w8 = a;
    w7 = a;
    a = w12;
    if(a == nil) goto    G0773;
    goto    G0815;
   G0973:
#define LL_Zvar LITERAL[53]
    a = LL_Zvar;
    w3 = a;
   G0984:
    a = cdr(w6);
    if(a != nil) goto    G0986;
    a = mkfxat(1);
    w6 = a;
    goto    G0987;
   G0986:
    q = w15;
    a = w6;
    a = CC_mchexptTptns(a, q);
    w6 = a;
    if(a == nil) goto    G1010;
   G0987:
    a = w4;
    if(a == nil) goto    G0991;
    q = LL_Zvar;
    a = w3;
    a = Lneq(a, q);
    if(a == nil) goto    G0991;
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G1010;
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G1010;
    goto    G1034;
   G0991:
    a = w1;
    if(is_number(a)) goto    G1001;
    a = w12;
    q = w1;
    if(a == nil) goto    G1000;
    a = cons(a, q);
    goto    G1001;
   G1000:
    a = LL_cH;
    a = cons(a, q);
    a = CC_reduceTcH(a);
   G1001:
    w1 = a;
    a = w6;
    a = Lonep(a);
    if(a != nil) goto    G1004;
    q = w6;
    a = w1;
    a = CC_unmultH(a, q);
    w1 = a;
   G1004:
    a = w13;
    if(a == nil) goto    G1006;
    q = w1;
    a = CC_multH(a, q);
    w1 = a;
   G1006:
    a = w3;
    if(a != LL_Zvar) goto    G1008;
    m = w11;
    q = cdr(w10);
    a = w1;
    a = CC_mchTid(a, q, m);
    if(a != nil) goto    G1036;
   G1010:
    a = LL_fail;
    goto    G0768;
   G1036:
    a = mkfxat(1);
    w1 = a;
   G1008:
    a = w4;
    if(a == nil) goto    G1013;
   G1034:
    a = mkfxat(1);
    goto    G0768;
   G1013:
    a = w1;
   G0768:
    popv(17);
    return a;
}

Sex CC_Wmchcheck(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    if(is_number(m)) goto    G1066;
    w5 = nil;
    w6 = nil;
    a = q;
    if(a != nil) goto    G1049;
    a = w1;
    a = CC_idlistH(a);
    w2 = a;
   G1049:
    a = w4;
    if(a != nil) goto    G1051;
    a = w3;
    a = CC_idlistH(a);
    w4 = a;
   G1051:
    a = car(w4);
    w5 = a;
    a = CC_Wdummy(a);
    if(a == nil) goto    G1053;
    a = w5;
    a = CC_Wfunc(a);
    if(a == nil) goto    G1064;
    a = w2;
    goto    G1068;
   G1060:
    a = car(w6);
    a = CC_Wfunc(a);
    if(a != nil) goto    G1064;
    a = cdr(w6);
   G1068:
    w6 = a;
    if(a == nil) goto    G1043;
    goto    G1060;
   G1053:
    q = w2;
    a = w5;
    a = Lmemq(a, q);
    if(a == nil) goto    G1043;
   G1064:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1051;
   G1066:
    a = true;
   G1043:
    popv(6);
    return a;
}

Sex CC_mchTid(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = m;
    a = w2;
    a = Latsoc(a, q);
    a = cdr(a);
    w4 = a;
    a = car(a);
    if(a == nil) goto    G1074;
    q = w1;
    {
        popv(4);
        return  CC_Wequal(a, q);
    }
   G1074:
    q = w1;
    a = w4;
    car(a) = q;
    q = w1;
    a = w2;
    Lset(a, q);
    a = cdr(w4);
    a = CC_Wchkpreds(a);
    if(a == nil) goto    G1077;
    a = true;
    goto    G1071;
   G1077:
    q = nil;
    a = w4;
    car(a) = q;
    q = nil;
    a = w2;
    Lset(a, q);
    a = nil;
   G1071:
    popv(4);
    return a;
}

Sex CC_mchTxid(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    q = m;
    a = w2;
    a = Latsoc(a, q);
    if(a == nil) goto    G1081;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_mchTid(a, q, m);
    }
   G1081:
    q = w2;
    a = w1;
    {
        popv(3);
        return  Leq(a, q);
    }
}

Sex CC_dlisT(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = q;
    if(a == nil) goto    G1091;
    a = w1;
    w2 = q;
    if(is_cons(a)) goto    G1087;
    a = Latsoc(a, q);
    w1 = a;
    if(a == nil) goto    G1091;
    {
        popv(5);
        return  Lncons(a);
    }
   G1087:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G1093:
    q = w2;
    a = car(w1);
    a = Latsoc(a, q);
    w5 = a;
    if(a == nil) goto    G1095;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1095:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1093;
    a = cdr(w3);
   G1091:
    popv(5);
    return a;
}

Sex CC_valdlisT(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
   G1107:
    if(a == nil) goto    G1105;
    w1 = a;
    a = car(cdr(car(a)));
    if(a != nil) goto    G1104;
    a = cdr(w1);
    goto    G1107;  /* recursive call to valdlis: */
   G1104:
    a = cdr(w1);
    a = CC_valdlisT(a);
    q = car(w1);
    a = Lxcons(a, q);
   G1105:
    popv(1);
    return a;
}

Sex CC_WallvTdms(Sex a)
{
    Sex q, m;
    if(a != nil) goto    G1110;
    a = true;
    goto    G1112;
   G1110:
    m = a;
    a = car(cdr(car(a)));
    if(a == nil) goto    G1112;
    a = cdr(m);
    a = CC_WallvTdms(a);
   G1112:
    return a;
}

Sex CC_WmchchkTid(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a == q) goto    G1120;
    w1 = a;
    w2 = q;
    q = m;
    a = w2;
    a = Latsoc(a, q);
    if(a == nil) goto    G1119;
    a = car(cdr(a));
    if(a != nil) goto    G1118;
   G1120:
    a = true;
    goto    G1119;
   G1118:
    q = a;
    a = w1;
    a = Leq(a, q);
   G1119:
    popv(2);
    return a;
}

Sex CC_WmchchkTfn(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = CC_WmchchkTid(a, q, m);
    if(a == nil) goto    G1143;
    a = w1;
    a = Llength(a);
    w3 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G1143;
    a = cdr(w1);
    if(a == nil) goto    G1142;
    a = car(cdr(w2));
    w2 = a;
    if(is_cons(a)) goto    G1129;
    q = car(cdr(w1));
    a = Lequal(a, q);
    if(a == nil) goto    G1143;
    goto    G1142;
   G1129:
    a = car(a);
    if(a != LL_Bindex) goto    G1133;
    a = car(cdr(w1));
    w1 = a;
    if(!is_cons(a)) goto    G1136;
    q = LL_Bindex;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G1135;
   G1136:
    a = nil;
    goto    G1143;
   G1135:
    a = w1;
    a = Llength(a);
    w3 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G1143;
    goto    G1142;
   G1133:
    a = car(cdr(w1));
    if(!is_cons(a)) goto    G1142;
    q = LL_Bindex;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G1143;
   G1142:
    a = true;
   G1143:
    popv(3);
    return a;
}

Sex CC_mchTargs(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = w2;
   G1150:
    if(a != nil) goto    G1152;
    a = true;
    goto    G1149;
   G1152:
    a = car(a);
    if(is_cons(a)) goto    G1153;
    q = a;
    a = car(w1);
    a = Lequal(a, q);
    goto    G1175;
   G1153:
    a = CC_Wsinglevar(a);
    if(a != nil) goto    G1157;
    a = car(car(w2));
    if(a != LL_Bindex) goto    G1159;
    m = w3;
    q = cdr(car(w2));
    a = cdr(car(w1));
    a = CC_mchTargs(a, q, m);
    goto    G1175;
   G1159:
    arg5 = nil;
    arg4 = true;
    m = w3;
    q = car(w2);
    a = car(w1);
    a = CC_matchH(a, q, m, arg4, arg5);
    goto    G1175;
   G1157:
    a = car(cdr(car(w2)));
    w5 = a;
    if(!is_symbol(a)) goto    G1165;
    m = w3;
    q = a;
    a = car(w1);
    a = CC_mchTxid(a, q, m);
   G1175:
    if(a == nil) goto    G1149;
    goto    G1172;
   G1165:
    a = car(w1);
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1170;
    a = car(cdr(car(w1)));
    w4 = a;
    if(!is_cons(a)) goto    G1170;
    m = w3;
    q = car(w5);
    a = car(a);
    a = CC_mchTxid(a, q, m);
    if(a == nil) goto    G1149;
    m = w3;
    q = cdr(w5);
    a = cdr(w4);
    a = CC_mchTargs(a, q, m);
    if(a == nil) goto    G1149;
   G1172:
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    goto    G1150;
   G1170:
    a = nil;
   G1149:
    popv(5);
    return a;
}

Sex CC_belisT(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    a = car(a);
    w2 = q;
    if(!is_integer(a)) goto    G1179;
    if(a != value(LL_CratfC)) goto    G1181;
    a = w1;
    a = CC_idlistTratf(a);
    goto    G1289;
   G1181:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = nil;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = car(w1);
    w5 = a;
    a = cdr(w1);
    w1 = a;
   G1189:
    a = car(w1);
    w6 = a;
    q = w5;
    if(!is_symbol(a)) goto    G1192;
    a = Lxcons(a, q);
    w7 = a;
    q = w2;
    a = w6;
    a = CC_dlisT(a, q);
    q = w7;
    a = Lxcons(a, q);
    w6 = a;
    a = cdr(car(a));
    a = CC_Wdummy(a);
    if(a == nil) goto    G1198;
    a = cdr(w6);
    if(a == nil) goto    G1198;
    a = car(car(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G1198;
    q = true;
    a = w3;
    car(a) = q;
    goto    G1198;
   G1192:
    a = Lxcons(a, q);
    w7 = a;
    a = w6;
    a = CC_idlistTfunc(a);
    q = w2;
    a = CC_dlisT(a, q);
    q = w7;
    a = Lxcons(a, q);
    w6 = a;
   G1198:
    a = car(car(cdr(w1)));
    a = Lncons(a);
    q = w6;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(car(cdr(w1)));
    w1 = a;
    if(!is_number(a)) goto    G1207;
    a = Lonep(a);
    if(a != nil) goto    G1274;
    a = w1;
    a = Lncons(a);
    w7 = a;
    a = mkfxat(1);
    a = Lncons(a);
    q = w7;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    goto    G1274;
   G1207:
    a = car(a);
    if(!is_integer(a)) goto    G1189;
    w5 = a;
    a = cdr(w1);
    w1 = a;
    goto    G1189;
   G1179:
    if(a != LL_cL) goto    G1218;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1220;
    a = w1;
    a = CC_idlistTcL(a);
   G1289:
    q = w2;
    a = CC_dlisT(a, q);
    w2 = a;
    q = w1;
#define LL_rexp LITERAL[54]
    a = LL_rexp;
    a = cons(a, q);
    q = w2;
    a = cons(a, q);
    w3 = a;
    a = mkfxat(1);
    a = Lncons(a);
    q = w3;
    a = Lxcons(a, q);
    q = a;
    a = nil;
    {
        popv(9);
        return  Llist2(a, q);
    }
   G1220:
    w3 = nil;
    w4 = nil;
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = CC_belisT(a, q);
    w3 = a;
    a = cdr(w1);
    a = Lncons(a);
    w5 = a;
    a = mkfxat(1);
    a = Lncons(a);
    q = w5;
    a = Lxcons(a, q);
    w4 = a;
    a = w3;
    a = CC_tail(a);
    w5 = a;
    a = w4;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    goto    G1274;
   G1218:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = cdr(w1);
    w1 = a;
    a = nil;
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G1235:
    a = car(w1);
    w8 = a;
    if(!is_number(a)) goto    G1240;
    a = Lncons(a);
    goto    G1295;
   G1240:
    a = car(a);
    if(!is_integer(a)) goto    G1241;
    if(a != value(LL_CratfC)) goto    G1243;
    q = w8;
    a = LL_rexp;
    a = cons(a, q);
    w9 = a;
    a = w8;
    a = CC_idlistTratf(a);
    q = w2;
    a = CC_dlisT(a, q);
    q = w9;
    a = Lxcons(a, q);
    goto    G1295;
   G1243:
    a = cdr(w8);
    a = CC_WmonoTbpol(a);
    if(a != nil) goto    G1237;
    q = w8;
    a = LL_rexp;
    a = cons(a, q);
    w9 = a;
    a = cdr(w8);
    a = CC_idlisTbpol(a);
    q = w2;
    a = CC_dlisT(a, q);
    q = w9;
    a = Lxcons(a, q);
    goto    G1295;
   G1241:
    q = LITERAL[55];
    a = Lmemq(a, q);
    q = w8;
    if(a == nil) goto    G1252;
    a = LL_rexp;
    a = cons(a, q);
    w9 = a;
    a = w8;
    a = CC_idlistH(a);
    q = w2;
    a = CC_dlisT(a, q);
    q = w9;
    a = Lxcons(a, q);
    goto    G1295;
   G1252:
    a = LL_func;
    a = cons(a, q);
    w9 = a;
    a = w8;
    a = CC_idlistTfunc(a);
    q = w2;
    a = CC_dlisT(a, q);
    q = w9;
    a = Lxcons(a, q);
   G1295:
    w8 = a;
    a = car(cdr(w1));
    w6 = a;
    if(!is_number(a)) goto    G1261;
    a = Lncons(a);
    goto    G1296;
   G1237:
    q = w2;
    a = w8;
    a = CC_belisT(a, q);
    w8 = a;
    q = cdr(a);
    a = w4;
    cdr(a) = q;
    a = w4;
    a = CC_tail(a);
    w4 = a;
    a = car(w8);
    if(a == nil) goto    G1276;
    q = true;
    a = w3;
    car(a) = q;
   G1276:
    a = car(cdr(w1));
    w6 = a;
    a = Lonep(a);
    if(a != nil) goto    G1266;
    a = cdr(w8);
    w5 = a;
    a = w6;
    if(!is_number(a)) goto    G1281;
    a = nil;
    goto    G1282;
   G1281:
    a = CC_idlistH(a);
    q = w2;
    a = CC_dlisT(a, q);
   G1282:
    w7 = a;
   G1238:
    a = cdr(car(w5));
    w8 = a;
    q = w6;
    a = car(a);
    a = CC_multTexpt(a, q);
    q = a;
    a = w8;
    car(a) = q;
    a = w7;
    if(a == nil) goto    G1286;
    q = a;
    a = w8;
    cdr(a) = q;
   G1286:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G1266;
    goto    G1238;
   G1261:
    a = CC_idlistH(a);
    q = w2;
    a = CC_dlisT(a, q);
    q = w6;
    a = Lxcons(a, q);
   G1296:
    q = w8;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1266:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G1235;
   G1274:
    a = w3;
    popv(9);
    return a;
}

Sex CC_substTptnbase(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = q;
    if(a != nil) goto    G1300;
    a = w1;
    goto    G1301;
   G1300:
    w3 = nil;
    w4 = nil;
    a = cdr(w1);
    w3 = a;
    w2 = q;
    a = car(w1);
    if(is_integer(a)) goto    G1347;
    if(a == LL_rexp) goto    G1331;
   G1312:
    q = w2;
    a = car(w3);
    a = Latsoc(a, q);
    w4 = a;
    if(a == nil) goto    G1314;
    a = car(cdr(a));
    w4 = a;
    if(a != nil) goto    G1316;
   G1314:
    a = car(w3);
    w4 = a;
   G1316:
    q = w2;
    a = cdr(w3);
    a = CC_substTptnargs(a, q);
    w3 = a;
    q = w4;
    a = Lxcons(a, q);
    goto    G1324;
   G1347:
    a = w3;
    if(is_cons(a)) goto    G1312;
    q = w2;
    a = w3;
    a = Latsoc(a, q);
    a = cdr(a);
    a = car(a);
    w4 = a;
    if(is_cons(a)) goto    G1320;
    if(is_number(a)) goto    G1301;
   G1324:
    q = car(w1);
    {
        popv(4);
        return  Lxcons(a, q);
    }
   G1320:
    a = car(a);
    if(is_integer(a)) goto    G1328;
    q = LITERAL[35];
    a = Lmemq(a, q);
    if(a == nil) goto    G1327;
   G1328:
    a = w4;
    w3 = a;
    goto    G1336;
   G1327:
    a = car(w4);
    a = CC_Wvar(a);
    q = w4;
    if(a == nil) goto    G1329;
    a = car(w1);
    goto    G1346;
   G1329:
    a = LL_func;
    goto    G1346;
   G1331:
    a = car(cdr(car(w2)));
    a = CC_Amkexpr(a);
    m = a;
    q = car(car(w2));
    a = w3;
    a = CC_substH(a, q, m);
    w3 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1331;
    a = w3;
    if(is_number(a)) goto    G1301;
    a = w3;
   G1336:
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1338;
    q = car(cdr(w3));
    a = car(w3);
    goto    G1346;
   G1338:
    a = w3;
    a = CC_Wsinglefunc(a);
    if(a == nil) goto    G1339;
    q = car(cdr(w3));
    a = LL_func;
    goto    G1346;
   G1339:
    q = w3;
    a = LL_rexp;
   G1346:
    a = cons(a, q);
   G1301:
    popv(4);
    return a;
}

Sex CC_substTptnargs(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G1352;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    w3 = a;
    if(is_number(a)) goto    G1368;
    a = CC_Wsinglevar(a);
    if(a != nil) goto    G1358;
    a = w3;
    a = CC_idlistH(a);
    q = w2;
    a = CC_dlisT(a, q);
    goto    G1380;
   G1358:
    a = car(cdr(w3));
    w4 = a;
    q = w2;
    if(is_cons(a)) goto    G1363;
    a = Latsoc(a, q);
    w5 = a;
    if(a == nil) goto    G1368;
    a = car(cdr(a));
    w5 = a;
    if(a == nil) goto    G1368;
    goto    G1381;
   G1363:
    a = car(a);
    a = Latsoc(a, q);
    w5 = a;
    if(a == nil) goto    G1371;
    a = car(cdr(a));
    w5 = a;
    if(a != nil) goto    G1370;
   G1371:
    a = car(w4);
    w5 = a;
   G1370:
    q = w2;
    a = cdr(w4);
    a = CC_substTptnargs(a, q);
    q = w5;
    a = Lxcons(a, q);
    w4 = a;
    q = car(cdr(w3));
    a = Lequal(a, q);
    if(a != nil) goto    G1368;
    a = w4;
   G1381:
    a = CC_Amkexpr(a);
    w3 = a;
   G1368:
    q = w2;
    a = cdr(w1);
    a = CC_substTptnargs(a, q);
    q = w3;
    {
        popv(5);
        return  Lxcons(a, q);
    }
   G1355:
    a = car(cdr(car(w5)));
    a = CC_Amkexpr(a);
    m = a;
    q = car(car(w5));
    a = w3;
    a = CC_substH(a, q, m);
    w3 = a;
    a = cdr(w5);
   G1380:
    w5 = a;
    if(a == nil) goto    G1368;
    goto    G1355;
   G1352:
    popv(5);
    return a;
}

Sex CC_mchTbnumbpow(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
   G1584:
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(!is_cons(m)) goto    G1385;
    a = m;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1582;
    a = car(cdr(w3));
    w3 = a;
    if(is_cons(a)) goto    G1582;
    arg5 = w5;
    arg4 = w4;
    m = a;
    q = w2;
    a = w1;
    goto    G1584;  /* recursive call to mch:bnumbpow */
   G1385:
    if(!is_symbol(q)) goto    G1390;
    q = arg4;
    a = w2;
    a = CC_dlisT(a, q);
    value(LL_Htemporal) = a;
    if(a == nil) goto    G1535;
    a = w3;
    if(!is_symbol(a)) goto    G1393;
    a = w1;
    if(!is_rational(a)) goto    G1395;
    a = Lnum(a);
    a = Lonep(a);
    if(a == nil) goto    G1395;
    a = w1;
    a = Lden(a);
    m = w4;
    q = w2;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1399;
    m = w4;
    q = w3;
    a = mkfxat(-1);
    a = CC_mchTid(a, q, m);
    if(a != nil) goto    G1531;
   G1399:
    q = w4;
    a = w2;
    a = CC_dlisT(a, q);
    a = car(a);
    CC_remTmch(a);
    goto    G1582;
   G1395:
    m = w4;
    q = w2;
    a = w1;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1405;
    m = w4;
    q = w3;
    a = mkfxat(1);
    a = CC_mchTid(a, q, m);
    if(a != nil) goto    G1531;
   G1405:
    q = w4;
    a = w2;
    a = CC_dlisT(a, q);
    a = car(a);
    CC_remTmch(a);
    goto    G1582;
   G1393:
    a = w1;
    if(!is_integer(a)) goto    G1410;
    a = w3;
    if(!is_integer(a)) goto    G1410;
    q = mkfxat(0);
    a = Lleq(a, q);
    if(a != nil) goto    G1582;
    a = w5;
    if(a == nil) goto    G1413;
    a = w1;
    a = Lminusp(a);
    if(a == nil) goto    G1413;
    a = w3;
    a = Levenp(a);
    if(a != nil) goto    G1582;
   G1413:
    a = w1;
    a = Labs(a);
    a = Lonep(a);
    if(a != nil) goto    G1417;
    a = w3;
    a = Lonep(a);
    if(a == nil) goto    G1416;
   G1417:
    a = w5;
    if(a == nil) goto    G1422;
    a = w1;
    goto    G1423;
   G1422:
    a = w1;
    a = Labs(a);
   G1423:
    m = w4;
    q = w2;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1535;
    a = w5;
    if(a != nil) goto    G1531;
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1574;
    goto    G1531;
   G1416:
    w6 = nil;
    w7 = nil;
    a = w1;
    a = Labs(a);
    q = w3;
    a = CC_partroot(a, q);
    w6 = a;
    q = w3;
    a = Lexpt(a, q);
    w7 = a;
    a = w5;
    if(a != nil) goto    G1432;
    m = w4;
    q = w2;
    a = w6;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1535;
    q = w7;
    a = w1;
    {
        popv(9);
        return  quot2(a, q);
    }
   G1432:
    a = w1;
    a = Labs(a);
    q = w7;
    a = Lequal(a, q);
    if(a == nil) goto    G1535;
    a = w1;
    a = Lminusp(a);
    if(a == nil) goto    G1440;
    a = w6;
    a = Lminus(a);
    w6 = a;
   G1440:
    m = w4;
    q = w2;
    a = w6;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1535;
    goto    G1531;
   G1410:
    a = w3;
    a = Lminusp(a);
    if(a == nil) goto    G1447;
    a = w1;
    a = CC_recipTbnum(a);
    w1 = a;
   G1447:
    a = w1;
    a = Lminusp(a);
    if(a == nil) goto    G1455;
    a = w3;
    if(!is_rational(a)) goto    G1450;
    a = Lnum(a);
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1450;
    a = w3;
    a = Lden(a);
    a = Levenp(a);
    if(a == nil) goto    G1450;
    a = w1;
    a = Lminus(a);
    w1 = a;
    goto    G1455;
   G1450:
    a = w5;
   G1455:
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1457;
    a = w3;
    a = Labs(a);
    q = a;
    a = w1;
    a = CC_nthroot(a, q);
    goto    G1459;
   G1457:
    a = w1;
    a = Lminus(a);
    w6 = a;
    a = w3;
    a = Labs(a);
    q = a;
    a = w6;
    a = CC_nthroot(a, q);
    a = Lminus(a);
   G1459:
    w1 = a;
    a = Labs(a);
    m = w4;
    q = w2;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1535;
    q = mkfxat(0);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1574;
    goto    G1531;
   G1390:
    if(!is_number(m)) goto    G1468;
    a = q;
    a = Lminusp(a);
    if(a == nil) goto    G1470;
    a = w3;
    if(!is_integer(a)) goto    G1582;
   G1470:
    q = w3;
    a = w2;
    a = Lexpt(a, q);
    w2 = a;
    a = w5;
    q = w2;
    if(a != nil) goto    G1474;
    goto    G1576;
   G1468:
    a = arg5;
    if(a == nil) goto    G1477;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = w1;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1481;
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G1484;
    a = mkfxat(0);
    goto    G1579;
   G1484:
    q = mkfxat(-1);
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G1535;
    a = mkfxat(1);
    goto    G1579;
   G1481:
    a = w2;
    a = Labs(a);
    a = Lonep(a);
    if(a != nil) goto    G1582;
    a = w1;
    if(!is_integer(a)) goto    G1490;
    a = w2;
    if(!is_integer(a)) goto    G1490;
    a = w1;
    a = Labs(a);
    w9 = a;
    a = w2;
    a = Labs(a);
    q = a;
    a = w9;
    a = CC_partpower(a, q);
    w6 = a;
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G1497;
    a = w6;
    a = Lminus(a);
    w6 = a;
   G1497:
    q = w6;
    a = w2;
    a = Lexpt(a, q);
    q = a;
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G1535;
    goto    G1510;
   G1490:
    a = w1;
    a = Labs(a);
    a = Llog(a);
    w9 = a;
    a = w2;
    a = Labs(a);
    a = Llog(a);
    q = a;
    a = w9;
    a = CC_divTbnumbnum(a, q);
    w6 = a;
    a = Ltruncate(a);
    w7 = a;
    q = a;
    a = w6;
    a = diff2(a, q);
    w8 = a;
    q = LITERAL[56];
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1505;
    a = w7;
    a = Ladd1(a);
    goto    G1581;
   G1505:
    q = LITERAL[57];
    a = w8;
    a = Llessp(a, q);
    if(a == nil) goto    G1506;
    a = w7;
    a = Lsub1(a);
   G1581:
    w6 = a;
    goto    G1507;
   G1506:
    a = w8;
    a = Labs(a);
    q = LITERAL[58];
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1510;
   G1507:
    q = w7;
    a = w2;
    a = Lexpt(a, q);
    q = a;
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G1510;
    a = w7;
   G1579:
    w6 = a;
   G1510:
    m = w4;
    q = w3;
    a = w6;
    a = CC_mchTid(a, q, m);
    w8 = a;
    if(a == nil) goto    G1535;
    a = w6;
    goto    G1535;
   G1477:
    if(is_float(q)) goto    G1518;
    a = w1;
    if(!is_integer(a)) goto    G1516;
    if(!is_rational(q)) goto    G1516;
    a = q;
    a = Lnum(a);
    a = Labs(a);
    a = Lonep(a);
    if(a != nil) goto    G1516;
   G1518:
    a = w2;
    a = Labs(a);
    a = Lonep(a);
    if(a != nil) goto    G1582;
    a = w2;
    a = Lminusp(a);
    if(a != nil) goto    G1582;
    a = w1;
    a = Labs(a);
    a = Llog(a);
    w6 = a;
    a = w2;
    a = Llog(a);
    q = a;
    a = w6;
    a = CC_divTbnumbnum(a, q);
    w2 = a;
    m = w4;
    q = w3;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1535;
    a = w1;
    a = Lminusp(a);
    if(a == nil) goto    G1531;
   G1574:
    a = mkfxat(-1);
    goto    G1535;
   G1474:
    a = w1;
    a = Leqn(a, q);
    if(a == nil) goto    G1535;
   G1531:
    a = mkfxat(1);
    goto    G1535;
   G1516:
    a = w1;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G1533;
   G1582:
    a = nil;
    goto    G1535;
   G1533:
    w6 = nil;
    a = w1;
    if(!is_integer(a)) goto    G1538;
    a = w2;
    if(!is_integer(a)) goto    G1540;
    a = w1;
    a = Labs(a);
    w7 = a;
    a = w2;
    a = Labs(a);
    q = a;
    a = w7;
    goto    G1583;
   G1540:
    a = w1;
    a = Labs(a);
    w7 = a;
    a = w2;
    a = Lden(a);
    q = a;
    a = w7;
    a = CC_partpower(a, q);
    a = Lminus(a);
    goto    G1550;
   G1538:
    a = w2;
    if(!is_integer(a)) goto    G1547;
    a = w1;
    a = Lnum(a);
    a = Labs(a);
    q = w2;
   G1583:
    a = CC_partpower(a, q);
    goto    G1550;
   G1547:
    a = w1;
    a = Lnum(a);
    a = Labs(a);
    w7 = a;
    a = w2;
    a = Lnum(a);
    a = Labs(a);
    q = a;
    a = w7;
    a = CC_partpower(a, q);
    w7 = a;
    a = w1;
    a = Lden(a);
    w8 = a;
    a = w2;
    a = Lden(a);
    q = a;
    a = w8;
    a = CC_partpower(a, q);
    q = a;
    a = w7;
    a = Lmin2(a, q);
   G1550:
    w6 = a;
    m = w4;
    q = w3;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1535;
    q = w6;
    a = w2;
    a = Lexpt(a, q);
    q = a;
   G1576:
    a = w1;
    a = CC_divTbnumbnum(a, q);
   G1535:
    popv(9);
    return a;
}

Sex CC_sdelTmon3Vnum(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = mkfxat(2);
    a = Lxcons(a, q);
    a = CC_Alncoef(a);
    value(LL_Htemporal) = a;
    a = Lonep(a);
    if(a == nil) goto    G1587;
    a = nil;
    goto    G1590;
   G1587:
    w5 = nil;
    w6 = nil;
    a = value(LL_Htemporal);
    w5 = a;
    arg5 = w4;
    arg4 = cdr(cdr(w3));
    m = car(cdr(w3));
    q = w2;
    a = CC_mchTbnumbpow(a, q, m, arg4, arg5);
    w6 = a;
    if(a == nil) goto    G1590;
    q = a;
    a = w5;
    a = CC_divTbnumbnum(a, q);
    q = a;
    a = w1;
    a = CC_Vbpolbnum(a, q);
   G1590:
    popv(6);
    return a;
}

Sex CC_sdelTmon3Vvar(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = car(a);
    a = cdr(w2);
    a = Lequal(a, q);
    if(a == nil) goto    G1599;
    w6 = nil;
    w7 = nil;
    a = car(car(cdr(w1)));
    w6 = a;
    a = car(cdr(w3));
    w7 = a;
    if(!is_number(a)) goto    G1602;
    a = w5;
    q = w7;
    if(a == nil) goto    G1604;
    a = w6;
    a = Lequal(a, q);
    if(a == nil) goto    G1627;
    goto    G1615;
   G1604:
    a = w6;
    a = CC_signdiff(a, q);
    w6 = a;
    if(a == nil) goto    G1627;
    a = Lzerop(a);
    if(a != nil) goto    G1615;
    a = w4;
    a = CC_tail(a);
    w8 = a;
    a = w6;
    a = Lncons(a);
    goto    G1636;
   G1602:
    a = w4;
    a = CC_tail(a);
    w8 = a;
    q = cdr(w3);
    a = w6;
    a = cons(a, q);
   G1636:
    q = w2;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
   G1615:
    a = cdr(car(cdr(w1)));
    goto    G1627;
   G1599:
    q = car(w1);
    a = cdr(w2);
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G1637;
    a = cdr(car(cdr(w1)));
    value(LL_Htemporal) = a;
    if(!is_number(a)) goto    G1621;
   G1637:
    a = nil;
    goto    G1627;
   G1621:
    a = car(a);
    if(is_integer(a)) goto    G1622;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = value(LL_Htemporal);
    a = CC_sdelTmon3Vvar(a, q, m, arg4, arg5);
    w3 = a;
    if(a == nil) goto    G1627;
    q = car(car(cdr(w1)));
    a = Lxcons(a, q);
    goto    G1638;
   G1622:
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = value(LL_Htemporal);
    w6 = a;
    a = car(a);
    w7 = a;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = cdr(w6);
    a = CC_sdelTmon3Vvar(a, q, m, arg4, arg5);
    w8 = a;
    if(a == nil) goto    G1627;
    if(!is_cons(a)) goto    G1632;
    a = car(a);
    if(is_integer(a)) goto    G1632;
    q = w8;
    a = w7;
    a = cons(a, q);
    w8 = a;
   G1632:
    q = w8;
    a = car(car(cdr(w1)));
    a = cons(a, q);
   G1638:
    q = a;
    a = car(w1);
    a = Llist2(a, q);
   G1627:
    popv(8);
    return a;
}

Sex CC_margTmon3Vivar(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w10 = nil;
    w8 = nil;
    w7 = nil;
    w12 = nil;
    w1 = a;
    a = cdr(q);
    w6 = a;
    a = w1;
    w11 = a;
    a = cdr(car(m));
    w9 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = CC_copyTdlis(a);
    w10 = a;
    a = car(cdr(w3));
    w8 = a;
   G1642:
    a = car(w11);
    q = car(w6);
    if(!is_symbol(a)) goto    G1649;
    a = CC_WorderTid(a, q);
    if(a == nil) goto    G1641;
    goto    G1645;
   G1649:
    a = car(a);
    a = CC_orderRMS(a, q);
    w12 = a;
    if(a == CHAR_OF(62)) goto    G1645;
    if(a == CHAR_OF(60)) goto    G1684;
    m = w9;
    q = cdr(w6);
    a = cdr(car(w11));
    a = CC_mchTargs(a, q, m);
    if(a == nil) goto    G1644;
    a = car(car(cdr(w11)));
    w7 = a;
    a = w8;
    if(is_number(a)) goto    G1658;
    a = cdr(w3);
    w12 = a;
    goto    G1665;
   G1658:
    a = w5;
    q = w8;
    if(a == nil) goto    G1659;
    a = w7;
    a = Lequal(a, q);
    if(a == nil) goto    G1644;
    goto    G1643;
   G1659:
    a = w7;
    a = CC_signdiff(a, q);
    w7 = a;
    if(a == nil) goto    G1644;
    a = Lzerop(a);
    if(a != nil) goto    G1643;
    w12 = nil;
   G1665:
    a = w4;
    a = CC_tail(a);
    w13 = a;
    q = car(w11);
    a = car(w2);
    a = cons(a, q);
    w14 = a;
    q = w12;
    a = w7;
    a = cons(a, q);
    q = w14;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w13;
    cdr(a) = q;
   G1643:
    a = cdr(car(cdr(w11)));
    goto    G1685;
   G1644:
    q = w10;
    a = w9;
    CC_recovTdlis(a, q);
   G1645:
    a = cdr(car(cdr(w11)));
    w11 = a;
    if(!is_number(a)) goto    G1672;
   G1684:
    a = nil;
    goto    G1641;
   G1672:
    a = car(a);
    if(!is_integer(a)) goto    G1642;
    q = cdr(w2);
    a = cons(a, q);
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = a;
    a = cdr(w11);
    a = CC_margTmon3Vivar(a, q, m, arg4, arg5);
    w12 = a;
    if(a == nil) goto    G1641;
    if(!is_cons(a)) goto    G1678;
    a = car(a);
    if(is_integer(a)) goto    G1678;
    q = w12;
    a = car(w11);
    a = cons(a, q);
   G1685:
    w12 = a;
   G1678:
    a = CHAR_OF(104);
    a = Lncons(a);
    w10 = a;
    w9 = a;
   G1647:
    q = w11;
    a = w1;
    a = Lneq(a, q);
    if(a == nil) goto    G1681;
    a = car(car(cdr(w1)));
    a = Lncons(a);
    q = a;
    a = car(w1);
    a = Llist2(a, q);
    q = a;
    a = w10;
    cdr(a) = q;
    a = car(cdr(cdr(w10)));
    w10 = a;
    a = cdr(car(cdr(w1)));
    w1 = a;
    goto    G1647;
   G1681:
    q = w12;
    a = w10;
    cdr(a) = q;
    a = cdr(w9);
   G1641:
    popv(14);
    return a;
}

Sex CC_mdelTmon3Vvar(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w10 = nil;
    w8 = nil;
    w7 = nil;
    w12 = nil;
    w1 = a;
    a = cdr(q);
    w6 = a;
    a = w1;
    w11 = a;
    a = cdr(car(m));
    w9 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = CC_copyTdlis(a);
    w10 = a;
    a = car(cdr(w3));
    w8 = a;
   G1689:
    a = w6;
    if(!is_symbol(a)) goto    G1696;
    m = w9;
    q = a;
    a = car(w11);
    a = CC_mchTid(a, q, m);
    goto    G1732;
   G1696:
    a = car(w11);
    if(is_symbol(a)) goto    G1692;
    m = w9;
    q = car(w6);
    a = car(a);
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1691;
    m = w9;
    q = cdr(w6);
    a = cdr(car(w11));
    a = CC_mchTargs(a, q, m);
   G1732:
    w12 = a;
    a = w12;
    if(a == nil) goto    G1691;
    a = car(car(cdr(w11)));
    w7 = a;
    a = w8;
    a = Lnumberp(a);
    a = Lnull(a);
    if(a == nil) goto    G1702;
    a = cdr(w3);
    w12 = a;
    goto    G1710;
   G1702:
    a = w5;
    q = w8;
    if(a == nil) goto    G1704;
    a = w7;
    a = Lequal(a, q);
    if(a == nil) goto    G1691;
    goto    G1690;
   G1704:
    a = w7;
    a = CC_signdiff(a, q);
    w7 = a;
    if(a == nil) goto    G1691;
    a = Lzerop(a);
    if(a != nil) goto    G1690;
    w12 = nil;
   G1710:
    a = w4;
    a = CC_tail(a);
    w13 = a;
    q = car(w11);
    a = car(w2);
    a = cons(a, q);
    w14 = a;
    q = w12;
    a = w7;
    a = cons(a, q);
    q = w14;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w13;
    cdr(a) = q;
   G1690:
    a = cdr(car(cdr(w11)));
    goto    G1733;
   G1691:
    q = w10;
    a = w9;
    CC_recovTdlis(a, q);
   G1692:
    a = cdr(car(cdr(w11)));
    w11 = a;
    if(!is_number(a)) goto    G1717;
    arg5 = w5;
    arg4 = w9;
    m = w8;
    q = w6;
    a = CC_mchTbnumbpow(a, q, m, arg4, arg5);
    w12 = a;
    if(a == nil) goto    G1688;
    goto    G1726;
   G1717:
    a = car(a);
    if(!is_integer(a)) goto    G1689;
    q = cdr(w2);
    a = car(w11);
    a = cons(a, q);
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = a;
    a = cdr(w11);
    a = CC_mdelTmon3Vvar(a, q, m, arg4, arg5);
    w12 = a;
    if(a == nil) goto    G1688;
    if(!is_cons(a)) goto    G1726;
    a = car(a);
    if(is_integer(a)) goto    G1726;
    q = w12;
    a = car(w11);
    a = cons(a, q);
   G1733:
    w12 = a;
   G1726:
    a = CHAR_OF(104);
    a = Lncons(a);
    w10 = a;
    w9 = a;
   G1694:
    q = w11;
    a = w1;
    a = Lneq(a, q);
    if(a == nil) goto    G1729;
    a = car(car(cdr(w1)));
    a = Lncons(a);
    q = a;
    a = car(w1);
    a = Llist2(a, q);
    q = a;
    a = w10;
    cdr(a) = q;
    a = car(cdr(cdr(w10)));
    w10 = a;
    a = cdr(car(cdr(w1)));
    w1 = a;
    goto    G1694;
   G1729:
    q = w12;
    a = w10;
    cdr(a) = q;
    a = cdr(w9);
   G1688:
    popv(14);
    return a;
}

Sex CC_sdelTcHVvar(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w1 = a;
    a = car(a);
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(is_number(a)) goto    G1753;
    a = car(a);
    if(!is_integer(a)) goto    G1738;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    a = car(cdr(w1));
    w7 = a;
    a = car(w1);
    w11 = a;
    a = CC_Wmonomial(a);
    if(a == nil) goto    G1741;
    a = w11;
    goto    G1743;
   G1741:
    a = w11;
    a = CC_Amonocont(a);
   G1743:
    w6 = a;
    if(is_number(a)) goto    G1753;
    if(car(a) < value(LL_CratfC)) goto    G1751;
    q = cdr(car(car(cdr(a))));
    a = w2;
    a = CC_pointTvar(a, q);
    w11 = a;
    if(a == nil) goto    G1750;
    a = Lminus(a);
    w11 = a;
    goto    G1753;
   G1750:
    a = cdr(car(cdr(w6)));
    w11 = a;
    if(is_number(a)) goto    G1753;
   G1751:
    q = cdr(a);
    a = w2;
    a = CC_pointTvar(a, q);
    w11 = a;
    if(a == nil) goto    G1759;
   G1753:
    a = nil;
    goto    G1759;
   G1738:
    a = cdr(cdr(w1));
    if(a == nil) goto    G1759;
    a = CC_sdelTcHVvar(a, q, m, arg4, arg5);
    w4 = a;
    if(a == nil) goto    G1759;
    a = Lonep(a);
    if(a == nil) goto    G1757;
    w4 = nil;
   G1757:
    q = w4;
    a = car(cdr(w1));
    a = cons(a, q);
    q = car(w1);
    a = Lxcons(a, q);
   G1759:
    popv(11);
    return a;
}

Sex CC_sdelTcHVbase(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = car(a);
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G1767;
    w6 = nil;
    w7 = nil;
    a = car(cdr(w1));
    w6 = a;
    a = car(cdr(w3));
    w7 = a;
    a = w6;
    if(!is_number(a)) goto    G1770;
    a = w7;
    if(!is_number(a)) goto    G1770;
    a = w5;
    q = w7;
    if(a == nil) goto    G1773;
    a = w6;
    a = Lequal(a, q);
    if(a == nil) goto    G1799;
    goto    G1784;
   G1773:
    a = w6;
    a = CC_signdiff(a, q);
    w6 = a;
    if(a == nil) goto    G1799;
    a = Lzerop(a);
    if(a != nil) goto    G1784;
    a = w4;
    a = CC_tail(a);
    w8 = a;
    a = w6;
    a = Lncons(a);
    goto    G1800;
   G1770:
    a = w4;
    a = CC_tail(a);
    w8 = a;
    q = cdr(w3);
    a = w6;
    a = cons(a, q);
   G1800:
    q = w2;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
   G1784:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G1799;
    a = mkfxat(1);
    goto    G1799;
   G1767:
    q = car(w1);
    a = w2;
    a = CC_Worder(a, q);
    if(a != nil) goto    G1794;
    a = cdr(cdr(w1));
    if(a != nil) goto    G1793;
   G1794:
    a = nil;
    goto    G1799;
   G1793:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = CC_sdelTcHVbase(a, q, m, arg4, arg5);
    w4 = a;
    if(a == nil) goto    G1799;
    a = Lonep(a);
    if(a == nil) goto    G1797;
    w4 = nil;
   G1797:
    q = w4;
    a = car(cdr(w1));
    a = cons(a, q);
    q = car(w1);
    a = Lxcons(a, q);
   G1799:
    popv(8);
    return a;
}

Sex CC_margTcHVfunc(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w8 = nil;
    w9 = nil;
    w11 = nil;
    w12 = nil;
    w6 = a;
    w1 = a;
    a = cdr(car(m));
    w10 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
   G1804:
    a = car(w6);
    w7 = a;
    if(!is_cons(a)) goto    G1845;
    q = car(w2);
    a = car(a);
    a = CC_orderRMS(a, q);
    w12 = a;
    if(a != CHAR_OF(60)) goto    G1811;
   G1845:
    a = nil;
    goto    G1803;
   G1811:
    if(a == CHAR_OF(62)) goto    G1808;
    m = w10;
    q = w2;
    a = w7;
    a = CC_WmchchkTfn(a, q, m);
    if(a == nil) goto    G1808;
    a = w11;
    if(a != nil) goto    G1814;
    a = w10;
    a = CC_copyTdlis(a);
    w11 = a;
   G1814:
    a = car(w7);
    a = CC_Wpfunc(a);
    m = w10;
    q = cdr(w2);
    if(a == nil) goto    G1816;
    a = cdr(w7);
    a = CC_mchTpfargs(a, q, m);
    goto    G1817;
   G1816:
    a = cdr(w7);
    a = CC_mchTargs(a, q, m);
   G1817:
    w12 = a;
    if(a == nil) goto    G1807;
    a = car(cdr(w6));
    w8 = a;
    if(is_cons(a)) goto    G1821;
    a = car(cdr(w3));
    w9 = a;
    if(!is_cons(a)) goto    G1820;
   G1821:
    a = cdr(w3);
    w12 = a;
    goto    G1828;
   G1820:
    a = w5;
    q = w9;
    if(a == nil) goto    G1822;
    a = w8;
    a = Lequal(a, q);
    if(a == nil) goto    G1807;
    goto    G1805;
   G1822:
    a = w8;
    a = CC_signdiff(a, q);
    w8 = a;
    if(a == nil) goto    G1807;
    a = Lzerop(a);
    if(a != nil) goto    G1805;
    w12 = nil;
   G1828:
    a = w4;
    a = CC_tail(a);
    w13 = a;
    q = w12;
    a = w8;
    a = cons(a, q);
    q = w7;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w13;
    cdr(a) = q;
   G1805:
    a = CHAR_OF(104);
    a = Lncons(a);
    w11 = a;
    w10 = a;
   G1806:
    q = w6;
    a = w1;
    a = Lneq(a, q);
    if(a == nil) goto    G1834;
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w11;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w11 = a;
    a = cdr(cdr(w1));
    w1 = a;
    goto    G1806;
   G1834:
    q = cdr(cdr(w1));
    a = w11;
    cdr(a) = q;
    a = cdr(w10);
    if(a != nil) goto    G1803;
    a = mkfxat(1);
    goto    G1803;
   G1807:
    q = w11;
    a = w10;
    CC_recovTdlis(a, q);
   G1808:
    a = cdr(cdr(w6));
    w6 = a;
    if(a != nil) goto    G1804;
   G1803:
    popv(13);
    return a;
}

Sex CC_mdelTcHVbase(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w8 = nil;
    w10 = nil;
    w12 = nil;
    w13 = nil;
    w6 = a;
    w1 = a;
    a = cdr(q);
    w9 = a;
    a = cdr(car(m));
    w11 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
   G1849:
    a = car(w6);
    w7 = a;
    if(!is_cons(a)) goto    G1907;
    a = car(w2);
    if(a == LL_rexp) goto    G1908;
    a = car(w7);
    if(!is_integer(a)) goto    G1864;
   G1907:
    a = nil;
    goto    G1848;
   G1864:
    if(a == LL_cL) goto    G1856;
    m = w11;
    q = w9;
    a = w7;
    a = CC_WmchchkTfn(a, q, m);
    if(a == nil) goto    G1856;
    a = w12;
    if(a != nil) goto    G1868;
    a = w11;
    a = CC_copyTdlis(a);
    w12 = a;
   G1868:
    m = w11;
    q = car(w9);
    a = car(w7);
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1855;
    a = car(w7);
    a = CC_Wpfunc(a);
    m = w11;
    q = cdr(w9);
    if(a == nil) goto    G1872;
    a = cdr(w7);
    a = CC_mchTpfargs(a, q, m);
    goto    G1873;
   G1872:
    a = cdr(w7);
    a = CC_mchTargs(a, q, m);
   G1873:
    w13 = a;
    if(a == nil) goto    G1855;
    goto    G1880;
   G1908:
    a = car(w7);
    if(is_integer(a)) goto    G1876;
    if(a != LL_cL) goto    G1856;
   G1876:
    a = w12;
    if(a != nil) goto    G1878;
    a = w11;
    a = CC_copyTdlis(a);
    w12 = a;
   G1878:
    arg5 = nil;
    arg4 = true;
    m = w11;
    q = w9;
    a = w7;
    a = CC_matchH(a, q, m, arg4, arg5);
    if(a == nil) goto    G1855;
   G1880:
    a = car(cdr(w6));
    w8 = a;
    if(is_cons(a)) goto    G1883;
    a = car(cdr(w3));
    w10 = a;
    if(!is_cons(a)) goto    G1882;
   G1883:
    a = cdr(w3);
    w13 = a;
    goto    G1890;
   G1882:
    a = w5;
    q = w10;
    if(a == nil) goto    G1884;
    a = w8;
    a = Lequal(a, q);
    if(a == nil) goto    G1855;
    goto    G1853;
   G1884:
    a = w8;
    a = CC_signdiff(a, q);
    w8 = a;
    if(a == nil) goto    G1855;
    a = Lzerop(a);
    if(a != nil) goto    G1853;
    w13 = nil;
   G1890:
    a = w4;
    a = CC_tail(a);
    w14 = a;
    q = w13;
    a = w8;
    a = cons(a, q);
    q = w7;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w14;
    cdr(a) = q;
   G1853:
    a = CHAR_OF(104);
    a = Lncons(a);
    w12 = a;
    w11 = a;
   G1854:
    q = w6;
    a = w1;
    a = Lneq(a, q);
    if(a == nil) goto    G1896;
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w12;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w12 = a;
    a = cdr(cdr(w1));
    w1 = a;
    goto    G1854;
   G1896:
    q = cdr(cdr(w1));
    a = w12;
    cdr(a) = q;
    a = cdr(w11);
    if(a != nil) goto    G1848;
    a = mkfxat(1);
    goto    G1848;
   G1855:
    q = w12;
    a = w11;
    CC_recovTdlis(a, q);
   G1856:
    a = cdr(cdr(w6));
    w6 = a;
    if(a != nil) goto    G1849;
   G1848:
    popv(14);
    return a;
}

Sex CC_mchexptTptns(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
#define LL_Hmod LITERAL[59]
    value(LL_Hmod) = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
    a = q;
    if(a != nil) goto    G1917;
   G1923:
    a = cdr(car(w3));
    w7 = a;
    a = cdr(a);
    if(a == nil) goto    G1930;
    q = cdr(a);
    a = car(a);
    a = CC_WaZLb(a, q);
    w8 = a;
    if(a == nil) goto    G2036;
    a = car(a);
#define LL_aZLb LITERAL[60]
    if(a != LL_aZLb) goto    G1927;
    q = cdr(cdr(w7));
    a = w8;
    a = cons(a, q);
    q = a;
    a = w7;
    cdr(a) = q;
   G2036:
    a = true;
    w9 = a;
    goto    G1930;
   G1927:
    q = cdr(w8);
    a = car(w7);
    a = CC_WincludeH(a, q);
    w8 = a;
    if(a == nil) goto    G2007;
    q = a;
    a = w7;
    car(a) = q;
    q = nil;
    a = w7;
    cdr(a) = q;
   G1930:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1923;
    a = w9;
    if(a == nil) goto    G1919;
    a = cdr(w1);
    w3 = a;
    w9 = nil;
   G1913:
    a = cdr(car(w3));
    w7 = a;
    a = cdr(a);
    if(a == nil) goto    G1944;
    a = car(cdr(w7));
    w8 = a;
    a = car(a);
    q = LL_aZLb;
    a = Lneq(a, q);
    if(a != nil) goto    G1941;
    a = w5;
    if(a != nil) goto    G1940;
    a = w7;
    a = Lncons(a);
    w4 = a;
    w5 = a;
    a = car(cdr(w8));
    w6 = a;
    goto    G1944;
   G1940:
    a = w6;
    if(a != car(cdr(w8))) goto    G1941;
    a = w7;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G1944;
   G1941:
    a = true;
    w9 = a;
   G1944:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1913;
    a = w5;
    if(a == nil) goto    G1947;
    a = cdr(a);
    if(a != nil) goto    G1949;
    a = car(w5);
    w7 = a;
    arg4 = nil;
    m = cdr(cdr(a));
    q = car(cdr(a));
    a = car(a);
    a = CC_pmchTaZLb(a, q, m, arg4);
    w8 = a;
    if(a == nil) goto    G2007;
    q = a;
    a = w7;
    car(a) = q;
    q = nil;
    a = w7;
    cdr(a) = q;
    w5 = nil;
    goto    G1995;
   G1949:
    a = w5;
    w4 = a;
   G1915:
    a = car(w4);
    w7 = a;
    arg4 = true;
    m = cdr(cdr(a));
    q = car(cdr(a));
    a = car(a);
    a = CC_pmchTaZLb(a, q, m, arg4);
    w8 = a;
    if(a == nil) goto    G2007;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1915;
    a = cdr(cdr(car(w5)));
    w7 = a;
    a = car(cdr(car(a)));
    w8 = a;
    a = car(w7);
    CC_remTmch(a);
    a = cdr(w8);
    if(!is_number(a)) goto    G1960;
    q = a;
    a = car(w8);
    a = times2(a, q);
    goto    G1962;
   G1960:
    a = car(a);
    q = cdr(w8);
    if(!is_integer(a)) goto    G1961;
    a = car(w8);
    a = CC_multTbnumcano(a, q);
    goto    G1962;
   G1961:
    a = car(w8);
    a = CC_multTbnumpref(a, q);
   G1962:
    w6 = a;
    m = w7;
    q = car(car(m));
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G1911;
   G1964:
    a = car(w5);
    w7 = a;
    a = Lcddadr(a);
    w8 = a;
    a = w6;
    if(!is_number(a)) goto    G1966;
    a = car(w8);
    a = Lonep(a);
    if(a == nil) goto    G1968;
    a = cdr(w8);
    if(a == nil) goto    G2040;
    q = w6;
    goto    G2039;
   G1968:
    a = cdr(w8);
    q = w6;
    if(a != nil) goto    G1972;
    a = car(w8);
    a = times2(a, q);
    goto    G1986;
   G1972:
    a = car(w8);
    a = times2(a, q);
    q = a;
    a = cdr(w8);
   G2039:
    a = plus2(a, q);
    goto    G1986;
   G1966:
    a = car(w8);
    a = Lonep(a);
    if(a == nil) goto    G1975;
    a = cdr(w8);
    if(a != nil) goto    G1977;
   G2040:
    a = w6;
    goto    G1986;
   G1977:
    a = car(w6);
    q = w6;
    if(is_integer(a)) goto    G2041;
    goto    G2042;
   G1975:
    a = car(w6);
    if(!is_integer(a)) goto    G1980;
    a = cdr(w8);
    q = w6;
    if(a != nil) goto    G1982;
    a = car(w8);
    a = CC_multTbnumcano(a, q);
    goto    G1986;
   G1982:
    a = car(w8);
    a = CC_multTbnumcano(a, q);
    q = a;
   G2041:
    a = cdr(w8);
    a = CC_addTbnumcano(a, q);
    goto    G1986;
   G1980:
    a = cdr(w8);
    q = w6;
    if(a != nil) goto    G1985;
    a = car(w8);
    a = CC_multTbnumpref(a, q);
    goto    G1986;
   G1985:
    a = car(w8);
    a = CC_multTbnumpref(a, q);
    q = a;
   G2042:
    a = cdr(w8);
    a = CC_addTbnumpref(a, q);
   G1986:
    w8 = a;
    a = w6;
    if(!is_number(a)) goto    G1989;
    q = w8;
    a = car(w7);
    a = diff2(a, q);
    goto    G1992;
   G1989:
    a = car(a);
    if(!is_integer(a)) goto    G1990;
    a = w8;
    a = CC_negTcano(a);
    q = a;
    a = car(w7);
    a = CC_addTcanocano(a, q);
    goto    G1992;
   G1990:
    a = w8;
    a = CC_negTpref(a);
    q = a;
    a = car(w7);
    a = CC_addTprefpref(a, q);
   G1992:
    w8 = a;
    q = a;
    a = w7;
    car(a) = q;
    q = nil;
    a = w7;
    cdr(a) = q;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G1964;
   G1995:
    a = cdr(w1);
    w3 = a;
    w9 = nil;
    goto    G1913;
   G1947:
    a = w9;
    if(a == nil) goto    G1919;
    a = cdr(w1);
    w3 = a;
   G1917:
    a = cdr(car(w3));
    w7 = a;
    a = LITERAL[61];
    Lprinc(a);
    a = cdr(w7);
    Lprint(a);
    a = cdr(w7);
    if(a == nil) goto    G2004;
    a = car(a);
    w8 = a;
    if(!is_number(a)) goto    G1998;
    a = car(w7);
    if(!is_number(a)) goto    G1998;
    q = w8;
    a = CC_signdiff(a, q);
    goto    G2043;
   G1998:
    arg5 = nil;
    arg4 = w2;
    m = cdr(cdr(w7));
    q = w8;
    a = car(w7);
    a = CC_matchH(a, q, m, arg4, arg5);
   G2043:
    w8 = a;
    if(a == nil) goto    G2007;
   G2004:
    q = w8;
    a = w7;
    car(a) = q;
    q = nil;
    a = w7;
    cdr(a) = q;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G1919;
    goto    G1917;
   G2007:
#define LL_HHmod LITERAL[62]
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = nil;
    goto    G1911;
   G1919:
    a = value(LL_HHmod);
    value(LL_Hmod) = a;
    a = car(w1);
    if(!is_integer(a)) goto    G2009;
    a = mkfxat(1);
    goto    G2018;
   G2009:
    w6 = nil;
    a = mkfxat(1);
    goto    G2045;
   G2010:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G2046;
    a = car(cdr(car(a)));
    w8 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2010;
    a = car(car(w1));
    w7 = a;
    q = mkfxat(1);
    a = w8;
    a = cons(a, q);
    m = a;
    q = cdr(w7);
    a = car(w7);
    a = Llist3(a, q, m);
    w7 = a;
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G2017;
    a = w7;
    goto    G2018;
   G2017:
    q = w7;
    a = w6;
    a = CC_Hpol3pol3(a, q);
   G2018:
    w6 = a;
    goto    G2010;
   G1921:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2020;
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G2022;
    q = w6;
    a = LL_cH;
    a = cons(a, q);
    {
        popv(9);
        return  CC_reduceTcH(a);
    }
   G2022:
    q = w6;
    a = LL_cH;
    a = cons(a, q);
    a = CC_reduceTcH(a);
    q = a;
    a = w4;
    {
        popv(9);
        return  CC_multH(a, q);
    }
   G2020:
    a = car(cdr(car(a)));
    w8 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1921;
    a = car(car(w1));
    w7 = a;
    if(!is_number(a)) goto    G2030;
    a = w8;
    if(!is_integer(a)) goto    G2030;
    a = Labs(a);
    a = Lonep(a);
    if(a != nil) goto    G2032;
    a = w7;
    a = Labs(a);
    a = Lonep(a);
    if(a == nil) goto    G2030;
   G2032:
    q = w8;
    a = w7;
    a = Lexpt(a, q);
    q = a;
    a = w4;
    a = CC_multTbnumbnum(a, q);
   G2045:
    w4 = a;
    goto    G1921;
   G2030:
    m = w6;
    q = w8;
    a = w7;
    a = CC_sortTbasexp(a, q, m);
    w6 = a;
    goto    G1921;
   G2046:
    a = w6;
   G1911:
    popv(9);
    return a;
}

Sex CC_WincludeH(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G2050;
    if(is_number(q)) goto    G2052;
    a = nil;
    goto    G2061;
   G2052:
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2053;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2061;
    q = w2;
    a = w1;
    a = Lgeq(a, q);
    if(a == nil) goto    G2061;
    goto    G2059;
   G2053:
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G2061;
    q = w2;
    a = w1;
    a = Lleq(a, q);
    if(a == nil) goto    G2061;
   G2059:
    q = w2;
    a = w1;
    {
        popv(2);
        return  diff2(a, q);
    }
   G2050:
    m = nil;
    a = CC_trysbtrH(a, q, m);
   G2061:
    popv(2);
    return a;
}

Sex CC_WmZLn(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = q;
    if(a != nil) goto    G2066;
    q = w1;
#define LL_valued LITERAL[63]
    a = LL_valued;
    {
        popv(5);
        return  cons(a, q);
    }
   G2066:
    w2 = q;
    a = CC_WallvTdms(a);
    if(a == nil) goto    G2067;
    q = w2;
    a = w1;
    a = CC_substTptn(a, q);
    q = LL_valued;
    goto    G2081;
   G2067:
    a = car(w1);
    if(a != value(LL_CpolyC)) goto    G2083;
    a = car(cdr(w1));
    if(is_cons(a)) goto    G2083;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(cdr(w1));
    w5 = a;
    a = car(car(a));
    a = Lonep(a);
    if(a == nil) goto    G2083;
    a = cdr(car(w5));
    w3 = a;
    if(is_cons(a)) goto    G2083;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G2084;
    a = cdr(car(a));
    w4 = a;
    if(!is_cons(a)) goto    G2077;
   G2083:
    a = nil;
    goto    G2071;
   G2084:
    a = mkfxat(0);
    w4 = a;
   G2077:
    q = w3;
    a = Lxcons(a, q);
    q = car(cdr(w1));
    a = Lxcons(a, q);
#define LL_mZLn LITERAL[64]
    q = LL_mZLn;
   G2081:
    a = Lxcons(a, q);
   G2071:
    popv(5);
    return a;
}

Sex CC_WaZLb(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    a = CC_WmZLn(a, q);
    w1 = a;
    if(a == nil) goto    G2090;
    a = car(a);
    if(a != LL_valued) goto    G2089;
    a = w1;
    goto    G2090;
   G2089:
    q = LL_aZLb;
    a = w1;
    car(a) = q;
   G2090:
    popv(1);
    return a;
}

Sex CC_pmchTaZLb(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    if(!is_number(a)) goto    G2094;
    a = cdr(q);
    w2 = a;
    a = car(a);
    w5 = a;
    a = car(cdr(w2));
    w6 = a;
    a = cdr(cdr(w2));
    w7 = a;
    if(a == nil) goto    G2097;
    q = a;
    a = w1;
    a = diff2(a, q);
    w1 = a;
   G2097:
    a = w6;
    q = a;
    if(!is_integer(a)) goto    G2099;
    a = w1;
    a = quot2(a, q);
    goto    G2100;
   G2099:
    a = w1;
    a = CC_divTbnumbnum(a, q);
   G2100:
    w8 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2171;
    a = w4;
    if(a != nil) goto    G2103;
    m = w3;
    q = w5;
    a = w8;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G2121;
    a = w6;
    if(!is_integer(a)) goto    G2167;
    q = a;
    a = w1;
    {
        popv(10);
        return  remaind2(a, q);
    }
   G2103:
    a = car(cdr(car(w3)));
    w9 = a;
    if(a == nil) goto    G2108;
    a = w8;
    a = CC_sign(a);
    q = a;
    a = cdr(w9);
    a = Lequal(a, q);
    if(a == nil) goto    G2110;
    a = w8;
    a = Labs(a);
    q = a;
    a = car(w9);
    a = Lmin2(a, q);
    q = a;
    a = w9;
    goto    G2172;
   G2110:
    a = car(w3);
    CC_remTmch(a);
    goto    G2171;
   G2108:
    m = w3;
    q = w5;
    a = w8;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G2121;
    a = w8;
    a = Labs(a);
    w10 = a;
    a = w8;
    a = CC_sign(a);
    q = w10;
    a = Lxcons(a, q);
    q = a;
    a = cdr(car(w3));
    goto    G2172;
   G2094:
    a = cdr(q);
    w2 = a;
    a = car(a);
    w5 = a;
    a = car(cdr(w2));
    w6 = a;
    a = cdr(cdr(w2));
    w7 = a;
    if(a != nil) goto    G2124;
    a = w1;
    goto    G2127;
   G2124:
    a = car(w1);
    if(!is_integer(a)) goto    G2125;
    a = w7;
    a = Lminus(a);
    q = w1;
    a = CC_addTbnumcano(a, q);
    goto    G2127;
   G2125:
    a = w7;
    a = Lminus(a);
    q = w1;
    a = CC_addTbnumpref(a, q);
   G2127:
    w1 = a;
    a = CC_Anumcont(a);
    w7 = a;
    a = w6;
    if(!is_integer(a)) goto    G2130;
    a = w7;
    if(!is_integer(a)) goto    G2130;
    a = w6;
    a = Labs(a);
    q = w7;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2171;
   G2130:
    a = w6;
    a = Lminusp(a);
    if(a == nil) goto    G2134;
    a = w6;
    a = Lminus(a);
    w6 = a;
    a = w7;
    a = Lminus(a);
    goto    G2135;
   G2134:
    a = w7;
   G2135:
    w9 = a;
    a = Lonep(a);
    if(a == nil) goto    G2137;
    a = w1;
    goto    G2139;
   G2137:
    a = car(w1);
    q = w9;
    if(!is_integer(a)) goto    G2138;
    a = w1;
    a = CC_quotiTcanobnum(a, q);
    goto    G2139;
   G2138:
    a = w1;
    a = CC_quotiTprefbnum(a, q);
   G2139:
    w8 = a;
    a = w6;
    q = a;
    if(!is_integer(a)) goto    G2141;
    a = w7;
    a = quot2(a, q);
    w10 = a;
    q = w6;
    a = w7;
    a = remaind2(a, q);
    q = w10;
    a = Lxcons(a, q);
    goto    G2144;
   G2141:
    a = w7;
    a = CC_divTbnumbnum(a, q);
    q = mkfxat(0);
    a = cons(a, q);
   G2144:
    w7 = a;
    a = car(cdr(car(w3)));
    w9 = a;
    if(a == nil) goto    G2147;
    q = w8;
    a = cdr(a);
    a = Lequal(a, q);
    if(a == nil) goto    G2149;
    q = car(w7);
    a = car(w9);
    a = Lmin2(a, q);
    q = a;
    a = w9;
    goto    G2172;
   G2149:
    a = car(w3);
    CC_remTmch(a);
   G2171:
    a = nil;
    goto    G2121;
   G2147:
    a = car(w7);
    a = Lonep(a);
    if(a != nil) goto    G2173;
    a = cdr(w7);
    a = Lzerop(a);
    if(a == nil) goto    G2155;
   G2173:
    a = w8;
    goto    G2157;
   G2155:
    a = car(w8);
    q = w8;
    if(!is_integer(a)) goto    G2156;
    a = car(w7);
    a = CC_multTbnumcano(a, q);
    goto    G2157;
   G2156:
    a = car(w7);
    a = CC_multTbnumpref(a, q);
   G2157:
    w9 = a;
    m = w3;
    q = w5;
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G2121;
    a = w4;
    if(a == nil) goto    G2160;
    q = w8;
    a = car(w7);
    a = cons(a, q);
    q = a;
    a = cdr(car(w3));
   G2172:
    {
        popv(10);
        car(a) = q;
 return a;
    }
   G2160:
    a = cdr(w7);
    a = Lzerop(a);
    if(a == nil) goto    G2162;
   G2167:
    a = mkfxat(0);
    goto    G2121;
   G2162:
    a = car(w8);
    if(!is_integer(a)) goto    G2163;
    q = w8;
    a = cdr(w7);
    {
        popv(10);
        return  CC_multTbnumcano(a, q);
    }
   G2163:
    q = w8;
    a = cdr(w7);
    a = CC_multTbnumpref(a, q);
   G2121:
    popv(10);
    return a;
}

Sex CC_pointTvar(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = Lequal(a, q);
    if(a != nil) goto    G2179;
    a = w1;
    if(!is_cons(a)) goto    G2178;
    a = cdr(a);
    if(a != nil) goto    G2178;
    a = car(w2);
    if(!is_cons(a)) goto    G2178;
    a = car(w1);
    if(a != car(car(w2))) goto    G2178;
   G2179:
    a = w2;
    goto    G2182;
   G2178:
    q = car(w2);
    a = w1;
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G2188;
    a = cdr(car(cdr(w2)));
    w2 = a;
    if(!is_number(a)) goto    G2181;
   G2188:
    a = nil;
    goto    G2182;
   G2181:
    a = car(a);
    if(!is_integer(a)) goto    G2184;
    a = cdr(w2);
    goto    G2185;
   G2184:
    a = w2;
   G2185:
    q = a;
    a = w1;
    a = CC_pointTvar(a, q);
   G2182:
    popv(2);
    return a;
}

Sex CC_pointTbase(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = car(q);
    a = Lequal(a, q);
    if(a != nil) goto    G2199;
    a = w1;
    if(is_cons(a)) goto    G2193;
    q = car(w2);
    a = CC_Worder(a, q);
    if(a != nil) goto    G2203;
    a = cdr(cdr(w2));
    w2 = a;
    if(a == nil) goto    G2203;
    q = a;
    goto    G2207;
   G2193:
    a = cdr(a);
    if(a != nil) goto    G2198;
    a = car(w1);
    if(a != car(car(w2))) goto    G2198;
   G2199:
    a = w2;
    goto    G2204;
   G2198:
    q = car(w2);
    a = w1;
    a = CC_Worder(a, q);
    if(a != nil) goto    G2203;
    a = cdr(cdr(w2));
    w2 = a;
    if(a == nil) goto    G2203;
    a = car(a);
    if(is_number(a)) goto    G2203;
    a = car(a);
    if(!is_integer(a)) goto    G2202;
   G2203:
    a = nil;
    goto    G2204;
   G2202:
    q = w2;
   G2207:
    a = w1;
    a = CC_pointTbase(a, q);
   G2204:
    popv(2);
    return a;
}

Sex CC_mchTtermsum(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w9 = nil;
    w10 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = m;
    a = CC_copyTdlis(a);
    w8 = a;
    a = w2;
    a = CC_setTpptr(a);
    w11 = a;
    q = w2;
    a = CC_ltermTptn(a, q);
    w6 = a;
    q = w2;
    a = w11;
    a = CC_rtermTptn(a, q);
    w7 = a;
    q = w2;
    a = car(a);
    a = CC_rtermTptn(a, q);
    if(a != nil) goto    G2239;
    q = w2;
    a = car(w7);
    a = CC_ltermTptn(a, q);
    w11 = a;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G2239;
    a = car(cdr(w11));
    w11 = a;
    if(!is_symbol(a)) goto    G2239;
    m = w3;
    q = a;
    a = mkfxat(0);
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G2239;
    a = w11;
    w10 = a;
    a = w6;
    a = CC_idlistH(a);
    q = w3;
    a = CC_dlisT(a, q);
    w11 = a;
    a = CC_WallvTdms(a);
    if(a == nil) goto    G2225;
    q = w11;
    a = w6;
    a = CC_substTptn(a, q);
    q = a;
    a = w1;
    a = CC_Wequal(a, q);
    if(a == nil) goto    G2239;
    goto    G2262;
   G2225:
    a = car(w6);
    if(!is_integer(a)) goto    G2233;
    if(a != value(LL_CratfC)) goto    G2233;
    arg5 = w5;
    arg4 = true;
    m = w11;
    q = w6;
    a = w1;
    a = CC_mchTtermratio(a, q, m, arg4, arg5);
    goto    G2236;
   G2233:
    q = LL_ncH;
    a = Lneq(a, q);
    arg5 = w5;
    arg4 = true;
    m = w11;
    q = w6;
    if(a == nil) goto    G2235;
    a = w1;
    a = CC_mchTtermterm(a, q, m, arg4, arg5);
    goto    G2236;
   G2235:
    a = w1;
    a = CC_mchTtermnterm(a, q, m, arg4, arg5);
   G2236:
    w11 = a;
    if(a == nil) goto    G2238;
   G2262:
    a = mkfxat(1);
    goto    G2213;
   G2238:
    q = w8;
    a = w3;
    CC_recovTdlis(a, q);
   G2239:
    a = w4;
    if(a != nil) goto    G2263;
    a = w1;
    if(is_number(a)) goto    G2263;
   G2241:
    a = w1;
    a = CC_lfactorH(a);
    w7 = a;
    a = CC_basexptT(a);
    w11 = a;
    a = car(a);
    a = CC_Wmonomial(a);
    if(a != nil) goto    G2264;
    a = cdr(w11);
    a = Lonep(a);
    if(a == nil) goto    G2250;
    arg5 = w5;
    arg4 = true;
    m = w3;
    q = w2;
    a = car(w11);
    a = CC_mchTsumsum(a, q, m, arg4, arg5);
    if(a != nil) goto    G2257;
   G2250:
    a = w1;
    a = CC_rfactorH(a);
    w1 = a;
    a = Lonep(a);
    if(a == nil) goto    G2253;
   G2263:
    a = nil;
    goto    G2213;
   G2253:
    q = w9;
    a = w7;
    a = cons(a, q);
    w9 = a;
    q = w8;
    a = w3;
    CC_recovTdlis(a, q);
    goto    G2241;
   G2264:
    a = w10;
    if(a == nil) goto    G2250;
    m = w3;
    q = a;
    a = mkfxat(0);
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G2250;
    arg5 = w5;
    arg4 = nil;
    m = w3;
    q = w6;
    a = w7;
    a = CC_mchTtermterm(a, q, m, arg4, arg5);
    w11 = a;
    if(a == nil) goto    G2250;
    a = Lonep(a);
    if(a != nil) goto    G2257;
    q = w9;
    a = w11;
    a = cons(a, q);
    w9 = a;
   G2257:
    a = w1;
    a = CC_rfactorH(a);
    w1 = a;
    w12 = nil;
    a = w9;
   G2259:
    if(a == nil) goto    G2258;
    q = w1;
    a = car(a);
    a = CC_multH(a, q);
    w1 = a;
    a = cdr(w9);
    w9 = a;
    w12 = a;
    goto    G2259;
   G2258:
    a = w1;
   G2213:
    popv(12);
    return a;
}

Sex CC_mchTsumterm(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
   G2299:
    w1 = a;
    a = cdr(arg5);
    if(a != nil) goto    G2268;
    a = arg4;
    if(a != nil) goto    G2298;
    w6 = nil;
    w7 = nil;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = m;
    a = w2;
    a = CC_belisT(a, q);
    w6 = a;
    a = w3;
    a = CC_copyTdlis(a);
    w7 = a;
    a = w1;
    a = CC_setTpptr(a);
    q = w7;
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(w6);
    if(a == nil) goto    G2280;
    a = cdr(a);
    if(a != nil) goto    G2283;
   G2280:
    arg5 = w5;
    arg4 = true;
    m = w6;
    q = w2;
    a = w1;
    a = CC_mchTtermterm(a, q, m, arg4, arg5);
    if(a != nil) goto    G2297;
    q = w7;
    a = w3;
    CC_recovTdlis(a, q);
   G2283:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    goto    G2299;  /* recursive call to mch:sumterm */
   G2268:
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w10 = a;
    a = car(a);
    w8 = a;
    a = cdr(cdr(w10));
    w9 = a;
    a = car(cdr(w10));
    w10 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
   G2287:
    a = w10;
    if(a == nil) goto    G2285;
    a = car(a);
    w6 = a;
    a = cdr(w10);
    w7 = a;
    q = w1;
    a = w6;
    a = CC_ltermTptn(a, q);
    arg5 = w5;
    arg4 = nil;
    m = w8;
    q = w2;
    a = CC_mchTtermterm(a, q, m, arg4, arg5);
    if(a == nil) goto    G2291;
    q = w1;
    a = w6;
    a = CC_rtermTptn(a, q);
    q = w9;
    a = cons(a, q);
    w10 = a;
    q = w8;
    a = Lxcons(a, q);
    q = a;
    a = w5;
    {
        popv(10);
        cdr(a) = q;
 return a;
    }
   G2291:
    q = w1;
    a = w6;
    a = CC_rtermTptn(a, q);
    w10 = a;
    q = w9;
    a = w3;
    CC_recovTdlis(a, q);
    goto    G2287;
   G2298:
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    arg4 = true;
    a = w1;
    a = CC_mchTtermterm(a, q, m, arg4, arg5);
    if(a == nil) goto    G2285;
   G2297:
    a = w5;
   G2285:
    popv(10);
    return a;
}

Sex CC_mchTsumsum(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 18;
    w7 = nil;
    w6 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = m;
#define LL_ZxtraZ LITERAL[65]
    a = LL_ZxtraZ;
    a = Latsoc(a, q);
    if(a == nil) goto    G2311;
    a = true;
    w17 = a;
    a = mkfxat(1);
    w15 = a;
   G2311:
    a = w1;
    a = CC_setTpptr(a);
    w7 = a;
    a = w5;
    if(a == nil) goto    G2314;
    a = cdr(a);
    w6 = a;
    if(a != nil) goto    G2313;
   G2314:
    a = w2;
    a = CC_setTpptr(a);
    w9 = a;
    a = w3;
    a = CC_copyTdlis(a);
    w13 = a;
    goto    G2403;
   G2313:
    a = car(a);
    w18 = a;
    a = cdr(w6);
    w6 = a;
    a = car(w18);
    w7 = a;
    a = car(cdr(w18));
    w9 = a;
    a = cdr(cdr(w18));
    w13 = a;
    q = a;
    a = w3;
    CC_recovTdlis(a, q);
    q = w1;
    a = w7;
    a = CC_rtermTptn(a, q);
    w8 = a;
    if(a == nil) goto    G2355;
   G2316:
    q = w2;
    a = w9;
    a = CC_ltermTptn(a, q);
    w10 = a;
    a = CC_idlistH(a);
    q = w3;
    a = CC_dlisT(a, q);
    w11 = a;
    a = CC_WallvTdms(a);
    if(a == nil) goto    G2319;
    q = w2;
    a = w9;
    a = CC_rtermTptn(a, q);
    w9 = a;
    if(a == nil) goto    G2354;
   G2403:
    a = w7;
    goto    G2360;
   G2319:
    a = w17;
    if(a != nil) goto    G2323;
    a = w10;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G2323;
    a = car(cdr(w10));
    if(!is_symbol(a)) goto    G2323;
    q = w2;
    a = w9;
    a = CC_rtermTptn(a, q);
    w18 = a;
    if(a == nil) goto    G2325;
    a = CC_Wncan(a);
    if(a == nil) goto    G2323;
   G2325:
    a = w10;
    w14 = a;
    goto    G2307;
   G2323:
    a = w17;
    if(a == nil) goto    G2327;
    a = w10;
    a = CC_Anumfactor(a);
    a = Labs(a);
    w16 = a;
    a = Lonep(a);
    if(a != nil) goto    G2327;
    q = w16;
    a = w10;
    a = CC_quotiH(a, q);
    w10 = a;
   G2327:
    a = car(w10);
    if(!is_integer(a)) goto    G2332;
    if(a == value(LL_CratfC)) goto    G2334;
   G2332:
    q = w11;
    a = w10;
    a = CC_belisT(a, q);
    w12 = a;
   G2334:
    q = w1;
    a = w8;
    a = CC_ltermTptn(a, q);
    w18 = a;
    a = w17;
    if(a == nil) goto    G2336;
    a = w18;
    a = CC_Anumfactor(a);
    a = Labs(a);
    w16 = a;
    a = Lonep(a);
    if(a != nil) goto    G2336;
    q = w16;
    a = w18;
    a = CC_quotiH(a, q);
    w18 = a;
    q = w16;
    a = w15;
    a = Lmin2(a, q);
    w15 = a;
   G2336:
    a = car(w10);
    if(!is_integer(a)) goto    G2341;
    if(a != value(LL_CratfC)) goto    G2341;
    arg5 = w5;
    arg4 = true;
    m = w3;
    q = w10;
    a = w18;
    a = CC_mchTtermratio(a, q, m, arg4, arg5);
    goto    G2344;
   G2341:
    q = LL_ncH;
    a = Lneq(a, q);
    arg5 = w5;
    arg4 = true;
    m = w12;
    q = w10;
    if(a == nil) goto    G2343;
    a = w18;
    a = CC_mchTtermterm(a, q, m, arg4, arg5);
    goto    G2344;
   G2343:
    a = w18;
    a = CC_mchTtermnterm(a, q, m, arg4, arg5);
   G2344:
    w18 = a;
    if(a != nil) goto    G2305;
    q = w1;
    a = w8;
    a = CC_rtermTptn(a, q);
    w18 = a;
    if(a == nil) goto    G2355;
    w8 = a;
    q = w13;
    a = w3;
    CC_recovTdlis(a, q);
    goto    G2334;
   G2355:
    a = w6;
    if(a == nil) goto    G2301;
    a = car(a);
    w18 = a;
    a = cdr(w6);
    w6 = a;
    a = car(cdr(w18));
    w9 = a;
    a = cdr(cdr(w18));
    w13 = a;
    q = a;
    a = w3;
    CC_recovTdlis(a, q);
    q = w1;
    a = car(w18);
    a = CC_rtermTptn(a, q);
    w18 = a;
    if(a == nil) goto    G2355;
   G2360:
    w8 = a;
    goto    G2316;
   G2305:
    q = w13;
    a = w9;
    a = cons(a, q);
    q = w8;
    a = Lxcons(a, q);
    q = w6;
    a = cons(a, q);
    w6 = a;
    a = w3;
    a = CC_WallvTdms(a);
    if(a != nil) goto    G2354;
    a = w3;
    a = CC_copyTdlis(a);
    w13 = a;
    a = w7;
    w8 = a;
    q = w2;
    a = w9;
    a = CC_rtermTptn(a, q);
    w9 = a;
    if(a != nil) goto    G2316;
   G2354:
    w14 = nil;
   G2307:
    a = w17;
    if(a == nil) goto    G2362;
    a = w15;
    a = Lonep(a);
    if(a != nil) goto    G2408;
    q = w3;
    a = LL_ZxtraZ;
    a = Latsoc(a, q);
    w18 = a;
    q = car(cdr(a));
    a = w15;
    a = CC_multH(a, q);
    q = a;
    a = cdr(w18);
    car(a) = q;
    goto    G2408;
   G2362:
    a = w14;
    if(a != nil) goto    G2367;
   G2408:
    a = w2;
    goto    G2409;
   G2367:
    a = w2;
    a = CC_negH(a);
   G2409:
    w18 = a;
    q = w3;
    a = w18;
    a = CC_substTptn(a, q);
    w18 = a;
    m = true;
    q = a;
    a = w1;
    a = CC_trysbtrH(a, q, m);
    w16 = a;
    if(a == nil) goto    G2355;
    a = w17;
    if(a == nil) goto    G2372;
    a = w16;
    a = Lonep(a);
    if(a != nil) goto    G2398;
    q = w3;
    a = LL_ZxtraZ;
    a = Latsoc(a, q);
    w18 = a;
    q = car(cdr(a));
    a = w16;
    a = CC_multH(a, q);
    q = a;
    a = cdr(w18);
    car(a) = q;
    goto    G2398;
   G2372:
    a = w14;
    if(a != nil) goto    G2377;
    a = w4;
    if(a == nil) goto    G2398;
   G2377:
    a = w14;
    if(a == nil) goto    G2379;
    a = car(cdr(a));
    w14 = a;
   G2379:
    a = w18;
    a = CC_negH(a);
    q = a;
    a = w1;
    a = CC_addH(a, q);
    w18 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2381;
    a = w14;
    if(a == nil) goto    G2398;
    m = w3;
    q = a;
    a = mkfxat(0);
    goto    G2410;
   G2381:
    a = w4;
    if(a != nil) goto    G2411;
   G2388:
    a = w18;
    a = CC_ltermH(a);
    m = w3;
    q = w14;
    a = CC_mchTid(a, q, m);
    if(a != nil) goto    G2398;
    a = w18;
    a = CC_rtermH(a);
    w18 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2388;
    goto    G2355;
   G2411:
    a = w14;
    if(a == nil) goto    G2355;
    m = w3;
    q = a;
    a = w18;
   G2410:
    a = CC_mchTid(a, q, m);
    if(a == nil) goto    G2355;
   G2398:
    a = w5;
    if(a != nil) goto    G2400;
    a = mkfxat(1);
    goto    G2301;
   G2400:
    q = w6;
    cdr(a) = q;
   G2301:
    popv(18);
    return a;
}

Sex CC_setTpptr(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(a);
    if(!is_symbol(a)) goto    G2415;
    a = car(cdr(w1));
    a = CC_Wncan(a);
    if(a == nil) goto    G2420;
    goto    G2422;
   G2415:
    if(a < value(LL_CratfC)) goto    G2420;
    a = car(car(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G2420;
   G2422:
    a = cdr(cdr(w1));
    goto    G2421;
   G2420:
    a = cdr(w1);
   G2421:
    popv(1);
    return a;
}

Sex CC_ltermTptn(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = car(q);
    w2 = q;
    if(!is_integer(a)) goto    G2428;
    a = w1;
    if(is_number(a)) goto    G2431;
    a = car(a);
    if(!is_integer(a)) goto    G2430;
   G2431:
    a = w1;
    goto    G2437;
   G2430:
    if(is_symbol(a)) goto    G2433;
    a = car(a);
    if(!is_symbol(a)) goto    G2432;
   G2433:
    a = w1;
    a = CC_ltermTbpol(a);
    q = car(w2);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G2432:
    q = car(w1);
    a = value(LL_CratfC);
    goto    G2438;
   G2428:
    a = cdr(car(w1));
    a = Lonep(a);
    if(a == nil) goto    G2436;
    a = car(car(w1));
    goto    G2437;
   G2436:
    q = car(w1);
    a = LL_cL;
   G2438:
    a = Llist2(a, q);
   G2437:
    popv(2);
    return a;
}

Sex CC_rtermTptn(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(q);
    if(!is_integer(a)) goto    G2442;
    a = w1;
    if(is_number(a)) goto    G2461;
    a = car(a);
    if(is_integer(a)) goto    G2461;
    if(is_symbol(a)) goto    G2447;
    a = car(a);
    if(!is_symbol(a)) goto    G2446;
   G2447:
    a = w1;
    a = CC_rtermTbpol(a);
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2461;
    a = w1;
    goto    G2462;
   G2446:
    a = cdr(w1);
    if(a != nil) goto    G2462;
    a = cdr(q);
    w1 = a;
    a = car(a);
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G2462;
    a = cdr(car(w1));
    w1 = a;
    if(is_number(a)) goto    G2462;
    a = cdr(a);
    goto    G2462;
   G2442:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2462;
    a = cdr(car(q));
    w1 = a;
    if(is_number(a)) goto    G2462;
    a = car(a);
    if(!is_integer(a)) goto    G2461;
    a = cdr(w1);
    goto    G2462;
   G2461:
    a = nil;
   G2462:
    popv(1);
    return a;
}



/* initialization procedure */
int init_bssimp(void)
{
   long i;

   create_symbols(bssimp_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; bssimp_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(bssimp_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a;
        a = LITERAL[66];
        a = CC_Aenter(a);
        return 1;
    }
}
Sex LITERAL[68];

const  char *bssimp_literal_string[68] =
{
/* 0 */
"!!opnrules",
/* 1 */
"!*simpmode",
/* 2 */
"unsimp",
/* 3 */
"!*temporal",
/* 4 */
"!*rules",
/* 5 */
"!#maxcano!#",
/* 6 */
"!#maxform!#",
/* 7 */
"!!ctype!!",
/* 8 */
"rat",
/* 9 */
"set",
/* 10 */
"rel",
/* 11 */
"log",
/* 12 */
"\"GSIMP!*\"",
/* 13 */
"simp",
/* 14 */
"!#rewrite",
/* 15 */
"\"RULE APPLICATION IS CUTOFF AT TIMES\"",
/* 16 */
"!!gid",
/* 17 */
"func",
/* 18 */
"!*rdstat",
/* 19 */
"rule",
/* 20 */
"uncomp",
/* 21 */
"!*compmode",
/* 22 */
"!*funcomp",
/* 23 */
"off",
/* 24 */
"!!index",
/* 25 */
"!#ordenv!#",
/* 26 */
"!*save",
/* 27 */
"untrac",
/* 28 */
"!*tracmode",
/* 29 */
"replac!*",
/* 30 */
"c!+",
/* 31 */
"(c!* nc!*)",
/* 32 */
"\"REPLACE\"",
/* 33 */
"rpfunc!:c!*",
/* 34 */
"unity",
/* 35 */
"(c!* nc!* c!+)",
/* 36 */
"c!*",
/* 37 */
"nc!*",
/* 38 */
"other",
/* 39 */
"mult",
/* 40 */
"mono",
/* 41 */
"and",
/* 42 */
"\"PATTERN-CONDITION CONTAINS NEW ID\"",
/* 43 */
"!!loc",
/* 44 */
"!!oset",
/* 45 */
"r!=",
/* 46 */
"\"MATCH\"",
/* 47 */
"\"EXPRESSION IS NOT <RAT-EXPR>\"",
/* 48 */
"\"PATTERN IS NOT <RAT-EXPR>\"",
/* 49 */
"fail",
/* 50 */
"\"PARTMATCH\"",
/* 51 */
"!#ratf!#",
/* 52 */
"!#poly!#",
/* 53 */
"!@var",
/* 54 */
"rexp",
/* 55 */
"(nc!* c!+)",
/* 56 */
"0.9990000000000000",
/* 57 */
"-0.9990000000000000",
/* 58 */
"0.001000000000000000",
/* 59 */
"!*mod",
/* 60 */
"a!@!+b",
/* 61 */
"\"PtnEXPNT at EMCH = \"",
/* 62 */
"!*!*mod",
/* 63 */
"valued",
/* 64 */
"m!@!+n",
/* 65 */
"!@xtra!@",
/* 66 */
"(lisp)",
/* 67 */ NULL
};
setup_type const bssimp_g_setup[] =
{
    {"rterm:ptn", (lisp_proc *)CC_rtermTptn, 2},
    {"lterm:ptn", (lisp_proc *)CC_ltermTptn, 2},
    {"set:pptr", (lisp_proc *)CC_setTpptr, 1},
    {"mch:sumsum", (lisp_proc *)CC_mchTsumsum, 5},
    {"mch:sumterm", (lisp_proc *)CC_mchTsumterm, 5},
    {"mch:termsum", (lisp_proc *)CC_mchTtermsum, 5},
    {"point:base", (lisp_proc *)CC_pointTbase, 2},
    {"point:var", (lisp_proc *)CC_pointTvar, 2},
    {"pmch:a@+b", (lisp_proc *)CC_pmchTaZLb, 4},
    {"?a@+b", (lisp_proc *)CC_WaZLb, 2},
    {"?m@+n", (lisp_proc *)CC_WmZLn, 2},
    {"?include*", (lisp_proc *)CC_WincludeH, 2},
    {"mchexpt:ptns", (lisp_proc *)CC_mchexptTptns, 2},
    {"mdel:c*/base", (lisp_proc *)CC_mdelTcHVbase, 5},
    {"marg:c*/func", (lisp_proc *)CC_margTcHVfunc, 5},
    {"sdel:c*/base", (lisp_proc *)CC_sdelTcHVbase, 5},
    {"sdel:c*/var", (lisp_proc *)CC_sdelTcHVvar, 5},
    {"mdel:mon3/var", (lisp_proc *)CC_mdelTmon3Vvar, 5},
    {"marg:mon3/ivar", (lisp_proc *)CC_margTmon3Vivar, 5},
    {"sdel:mon3/var", (lisp_proc *)CC_sdelTmon3Vvar, 5},
    {"sdel:mon3/num", (lisp_proc *)CC_sdelTmon3Vnum, 4},
    {"mch:bnumbpow", (lisp_proc *)CC_mchTbnumbpow, 5},
    {"subst:ptnargs", (lisp_proc *)CC_substTptnargs, 2},
    {"subst:ptnbase", (lisp_proc *)CC_substTptnbase, 2},
    {"belis:", (lisp_proc *)CC_belisT, 2},
    {"mch:args", (lisp_proc *)CC_mchTargs, 3},
    {"?mchchk:fn", (lisp_proc *)CC_WmchchkTfn, 3},
    {"?mchchk:id", (lisp_proc *)CC_WmchchkTid, 3},
    {"?allv:dms", (lisp_proc *)CC_WallvTdms, 1},
    {"valdlis:", (lisp_proc *)CC_valdlisT, 1},
    {"dlis:", (lisp_proc *)CC_dlisT, 2},
    {"mch:xid", (lisp_proc *)CC_mchTxid, 3},
    {"mch:id", (lisp_proc *)CC_mchTid, 3},
    {"?mchcheck", (lisp_proc *)CC_Wmchcheck, 4},
    {"mch:termterm", (lisp_proc *)CC_mchTtermterm, 5},
    {"mch:bnumptn", (lisp_proc *)CC_mchTbnumptn, 4},
    {"mch:prefpref", (lisp_proc *)CC_mchTprefpref, 5},
    {"mch:prefcano", (lisp_proc *)CC_mchTprefcano, 5},
    {"mch:canopref", (lisp_proc *)CC_mchTcanopref, 5},
    {"mch:canocano", (lisp_proc *)CC_mchTcanocano, 5},
    {"match*", (lisp_proc *)CC_matchH, 5},
    {" partmatch", (lisp_proc *)CC_Apartmatch, 3},
    {" match", (lisp_proc *)CC_Amatch, 3},
    {"rem:mch", (lisp_proc *)CC_remTmch, 1},
    {"recov:dlis", (lisp_proc *)CC_recovTdlis, 2},
    {"copy:dlis", (lisp_proc *)CC_copyTdlis, 1},
    {"init:dlis", (lisp_proc *)CC_initTdlis, 1},
    {"subst:ptn", (lisp_proc *)CC_substTptn, 2},
    {"mk:mchlis", (lisp_proc *)CC_mkTmchlis, 1},
    {"?chkpreds", (lisp_proc *)CC_Wchkpreds, 1},
    {"mk:pred", (lisp_proc *)CC_mkTpred, 1},
    {"mk:dmypreds", (lisp_proc *)CC_mkTdmypreds, 2},
    {"ptntype:", (lisp_proc *)CC_ptntypeT, 1},
    {"sub:mkterm", (lisp_proc *)CC_subTmkterm, 2},
    {"rpfunc:func", (lisp_proc *)CC_rpfuncTfunc, 3},
    {"rpfunc:c*", (lisp_proc *)CC_rpfuncTcH, 3},
    {"rpfunc*", (lisp_proc *)CC_rpfuncH, 3},
    {"replace*", (lisp_proc *)CC_replaceH, 3},
    {"rewrite*", (lisp_proc *)CC_rewriteH, 3},
    {"ncompfn*", (lisp_proc *)CC_ncompfnH, 1},
    {"compfn*", (lisp_proc *)CC_compfnH, 1},
    {"compfunc*", (lisp_proc *)CC_compfuncH, 2},
    {"simpfn*", (lisp_proc *)CC_simpfnH, 1},
    {"sssimp:func", (lisp_proc *)CC_sssimpTfunc, 1},
    {"simp:func", (lisp_proc *)CC_simpTfunc, 1},
    {"simpfuncs*", (lisp_proc *)CC_simpfuncsH, 3},
    {"simp*", (lisp_proc *)CC_simpH, 2},
    {"gsimp*", (lisp_proc *)CC_gsimpH, 1},
    {NULL, NULL, 0 }
};

