#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_compart.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex compart_literal_vector[];
const char *compart_literal_string[];
setup_type const  compart_g_setup[];
#define LITERAL compart_literal_vector




Sex CC_Cterms(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G0002;
    if(!is_number(a)) goto    G0013;
    goto    G0015;
   G0002:
    a = car(a);
    if(!is_integer(a)) goto    G0006;
#define LL_CratfC LITERAL[0]
    if(a >= value(LL_CratfC)) goto    G0008;
    a = cdr(w1);
    {
        popv(1);
        return  CC_termsTbpol(a);
    }
   G0008:
    if(a == value(LL_CratfC)) goto    G0017;
#define LL_CmaxformC LITERAL[1]
    if(a >= value(LL_CmaxformC)) goto    G0013;
    a = car(cdr(cdr(w1)));
    goto    G0014;
   G0006:
#define LL_cL LITERAL[2]
    if(a != LL_cL) goto    G0012;
   G0017:
    a = cdr(w1);
    {
        popv(1);
        return  Llength(a);
    }
   G0012:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G0013;
   G0015:
    a = mkfxat(1);
    goto    G0014;
   G0013:
    a = LITERAL[4];
    a = CC_argerror(a);
   G0014:
    popv(1);
    return a;
}

Sex CC_Celements(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G0022;
    if(a == nil) goto    G0025;
#define LL_Anil LITERAL[5]
    if(a != LL_Anil) goto    G0024;
   G0025:
    a = mkfxat(0);
    goto    G0053;
   G0024:
    if(!is_number(a)) goto    G0049;
    a = mkfxat(1);
    goto    G0053;
   G0022:
    a = car(a);
    if(!is_integer(a)) goto    G0028;
    if(a >= value(LL_CratfC)) goto    G0030;
    a = cdr(w1);
    {
        popv(2);
        return  CC_termsTbpol(a);
    }
   G0030:
    if(a != value(LL_CratfC)) goto    G0031;
    a = cdr(w1);
    goto    G0057;
   G0031:
    if(a >= value(LL_CmaxformC)) goto    G0049;
    a = car(cdr(cdr(w1)));
    goto    G0053;
   G0028:
    a = w1;
    a = CC_Warray(a);
    if(a == nil) goto    G0034;
    a = car(cdr(w1));
    goto    G0053;
   G0034:
#define LL_BctypeB LITERAL[6]
    q = LL_BctypeB;
    a = car(w1);
    a = Lget(a, q);
#define LL_Htemporal LITERAL[7]
    value(LL_Htemporal) = a;
#define LL_rat LITERAL[8]
    if(a != LL_rat) goto    G0035;
    q = LL_cL;
    a = car(w1);
    a = Lneq(a, q);
    if(a == nil) goto    G0037;
    a = cdr(w1);
    a = Llength(a);
    q = mkfxat(2);
    {
        popv(2);
        return  quot2(a, q);
    }
   G0037:
    a = cdr(cdr(w1));
    if(a != nil) goto    G0039;
    a = w1;
    a = Lcdaadr(a);
    a = Llength(a);
    q = mkfxat(2);
    a = quot2(a, q);
    {
        popv(2);
        return  Ladd1(a);
    }
   G0039:
    a = cdr(w1);
    w1 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a != nil) goto    G0043;
    a = w1;
    goto    G0057;
   G0043:
    a = car(w1);
    a = CC_Celements(a);
    w2 = a;
    a = cdr(w1);
    a = Llength(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  plus2(a, q);
    }
   G0035:
#define LL_set LITERAL[9]
    if(a != LL_set) goto    G0049;
    q = LITERAL[10];
    a = car(w1);
    a = Lmemq(a, q);
    if(a == nil) goto    G0051;
    a = cdr(w1);
   G0057:
    {
        popv(2);
        return  Llength(a);
    }
   G0051:
#define LL_indef LITERAL[11]
    a = LL_indef;
    goto    G0053;
   G0049:
    a = LITERAL[12];
    a = CC_argerror(a);
   G0053:
    popv(2);
    return a;
}

Sex CC_Amonocoef(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = CC_Wpol3(a);
    if(a == nil) goto    G0062;
    a = w2;
    a = CC_Wpol3(a);
    if(a != nil) goto    G0061;
   G0062:
    q = LITERAL[13];
    a = mkfxat(8);
    goto    G0070;
   G0061:
    a = car(w1);
    if(a == car(w2)) goto    G0063;
    q = LITERAL[13];
    a = LITERAL[14];
    goto    G0070;
   G0063:
    a = cdr(w2);
    a = CC_WmonoTbpol(a);
    if(a != nil) goto    G0064;
    q = LITERAL[13];
    a = LITERAL[15];
   G0070:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0064:
    q = cdr(w2);
    a = cdr(w1);
    a = CC_mncoefTbpol(a, q);
    w2 = a;
    if(a != nil) goto    G0065;
    a = mkfxat(0);
    goto    G0068;
   G0065:
    if(is_number(a)) goto    G0067;
    a = car(a);
    if(!is_integer(a)) goto    G0066;
   G0067:
    a = w2;
    goto    G0068;
   G0066:
    q = w2;
    a = car(w1);
    a = cons(a, q);
   G0068:
    popv(2);
    return a;
}

Sex CC_Acoefpart(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = CC_Wpol3(a);
    if(a == nil) goto    G0075;
    a = w2;
    a = CC_Wpol3(a);
    if(a != nil) goto    G0074;
   G0075:
    q = LITERAL[16];
    a = mkfxat(8);
    goto    G0083;
   G0074:
    a = car(w1);
    if(a == car(w2)) goto    G0076;
    q = LITERAL[16];
    a = LITERAL[14];
    goto    G0083;
   G0076:
    a = cdr(w2);
    a = CC_WmonoTbpol(a);
    if(a != nil) goto    G0077;
    q = LITERAL[16];
    a = LITERAL[15];
   G0083:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0077:
    q = cdr(w2);
    a = cdr(w1);
    a = CC_cfpartTbpol(a, q);
    w2 = a;
    if(a != nil) goto    G0078;
    a = mkfxat(0);
    goto    G0081;
   G0078:
    if(is_number(a)) goto    G0080;
    a = car(a);
    if(!is_integer(a)) goto    G0079;
   G0080:
    a = w2;
    goto    G0081;
   G0079:
    q = w2;
    a = car(w1);
    a = cons(a, q);
   G0081:
    popv(2);
    return a;
}

Sex CC_Apoly2coefset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Adeg(a);
    w3 = a;
    a = w2;
    a = Lsub1(a);
    q = a;
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0087;
    q = LITERAL[17];
    a = LITERAL[18];
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
   G0087:
    q = w2;
    a = w1;
    a = CC_poly2coeflist(a, q);
#define LL_Boset LITERAL[19]
    q = LL_Boset;
    {
        popv(3);
        return  Lxcons(a, q);
    }
}

Sex CC_Acoef(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = q;
    if(a != nil) goto    G0100;
    q = LITERAL[20];
    a = mkfxat(2);
    {
        popv(13);
        return  CC_errormsg(a, q);
    }
   G0100:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w2 = q;
    w3 = m;
    a = m;
    if(a == nil) goto    G0112;
    if(!is_cons(a)) goto    G0107;
    a = CC_Warray(a);
    if(a != nil) goto    G0112;
   G0107:
    a = w3;
    a = CC_Aexpr2varfunc(a);
    w6 = a;
    if(!is_symbol(a)) goto    G0110;
#define LL_Ainvalid LITERAL[21]
    q = LL_Ainvalid;
    a = Lneq(a, q);
    if(a == nil) goto    G0110;
    a = w6;
    a = CC_Warray(a);
    if(a == nil) goto    G0110;
    a = w6;
    w3 = a;
    goto    G0112;
   G0110:
    q = w3;
    a = LITERAL[22];
    CC_errormsg(a, q);
   G0112:
    a = w2;
    a = CC_coefptnT(a);
    w4 = a;
    w5 = a;
   G0104:
    a = car(car(w5));
    w6 = a;
    if(!is_cons(a)) goto    G0117;
    a = car(a);
   G0117:
    a = CC_Wuncom(a);
    if(a == nil) goto    G0114;
    q = w6;
    a = LITERAL[23];
    CC_errormsg(a, q);
    goto    G0119;
   G0114:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0104;
   G0119:
    a = w1;
    if(is_cons(a)) goto    G0121;
    if(!is_number(a)) goto    G0133;
    q = mkfxat(0);
    a = Lxcons(a, q);
    goto    G0166;
   G0121:
    a = car(a);
    if(!is_integer(a)) goto    G0126;
#define LL_CmaxcanoC LITERAL[24]
    if(a >= value(LL_CmaxcanoC)) goto    G0128;
    q = w4;
    a = w1;
    a = CC_coefTcano(a, q);
    goto    G0135;
   G0128:
    if(a >= value(LL_CmaxformC)) goto    G0133;
    q = w4;
    a = w1;
    a = CC_coefTform(a, q);
    goto    G0135;
   G0126:
    if(a != LL_cL) goto    G0131;
    q = w4;
    a = w1;
    a = CC_coefTcL(a, q);
    goto    G0135;
   G0131:
#define LL_cH LITERAL[25]
    if(a != LL_cH) goto    G0132;
    q = w4;
    a = w1;
    a = CC_coefTcH(a, q);
    goto    G0135;
   G0132:
#define LL_ncH LITERAL[26]
    if(a != LL_ncH) goto    G0133;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
   G0166:
    a = Lncons(a);
    goto    G0135;
   G0133:
    q = LITERAL[20];
    a = mkfxat(3);
    a = CC_errormsg(a, q);
   G0135:
    w6 = a;
    a = Llast(a);
    a = car(a);
    w8 = a;
    a = w3;
    if(a == nil) goto    G0169;
    if(!is_cons(a)) goto    G0139;
    a = car(a);
    w7 = a;
    a = cdr(w3);
    goto    G0170;
   G0139:
#define LL_Bgid LITERAL[27]
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(2);
    a = Lgetv(a, q);
    w5 = a;
    if(a != nil) goto    G0140;
   G0169:
    a = w8;
    a = Lmkvect(a);
    w7 = a;
    goto    G0142;
   G0140:
    a = CC_convTsexpr2gexpr(a);
    w5 = a;
    a = car(a);
    w7 = a;
    a = cdr(w5);
   G0170:
    w9 = a;
   G0142:
    a = w9;
    if(a != nil) goto    G0144;
    q = w8;
    a = q;
    a = Llist2(a, q);
    w9 = a;
   G0144:
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    a = mkfxat(0);
    w10 = a;
    a = car(w9);
    w11 = a;
    a = mkfxat(1);
    w12 = a;
    m = a;
    q = w11;
    a = w10;
    CC_Wchkfor(a, q, m);
   G0146:
    m = mkfxat(0);
    q = w10;
    a = w7;
    a = Lputv(a, q, m);
    w13 = a;
    q = w12;
    a = w10;
    a = plus2(a, q);
    w10 = a;
    m = w12;
    q = w11;
    a = CC_Wendfor(a, q, m);
    if(a == nil) goto    G0146;
    a = car(cdr(w9));
    w5 = a;
    q = a;
    a = w8;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0151;
    a = w5;
    w8 = a;
   G0151:
    a = mkfxat(0);
    w5 = a;
   G0105:
    q = w5;
    a = car(car(w6));
    a = Lequal(a, q);
    if(a == nil) goto    G0155;
    m = nil;
    q = nil;
    a = cdr(car(w6));
    a = CC_convTgexpr2sexpr(a, q, m);
    m = a;
    q = w5;
    a = w7;
    Lputv(a, q, m);
    a = cdr(w6);
    w6 = a;
   G0155:
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w8;
    a = Lleq(a, q);
    if(a != nil) goto    G0105;
    a = w3;
    if(a != nil) goto    G0161;
    q = w9;
    a = w7;
    {
        popv(13);
        return  cons(a, q);
    }
   G0161:
    if(is_cons(a)) goto    G0101;
    q = w9;
    a = w7;
    a = cons(a, q);
    q = a;
    a = w3;
    CC_setqTgexpr(a, q);
    a = w3;
   G0101:
    popv(13);
    return a;
}

Sex CC_poly2coeflist(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w6 = nil;
    w4 = nil;
    w3 = nil;
    w7 = nil;
    w1 = a;
    a = cdr(cdr(a));
    w5 = a;
    w2 = q;
    a = q;
    a = CC_listzero(a);
    w4 = a;
    w3 = a;
    a = w2;
    a = Lsub1(a);
    w8 = a;
   G0174:
    a = car(car(w5));
    w6 = a;
   G0175:
    q = w8;
    a = w6;
    a = Llessp(a, q);
    if(a == nil) goto    G0177;
    a = cdr(w4);
    w4 = a;
    a = w8;
    a = Lsub1(a);
    w8 = a;
    goto    G0175;
   G0177:
    a = cdr(car(w5));
    w7 = a;
    if(!is_cons(a)) goto    G0180;
    if(is_integer(a)) goto    G0180;
    q = car(w1);
    a = Lxcons(a, q);
    w7 = a;
   G0180:
    q = a;
    a = w4;
    car(a) = q;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0174;
    a = w3;
    popv(8);
    return a;
}

Sex CC_coefTcano(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(car(q));
    value(LL_Htemporal) = a;
    a = CC_Watom(a);
    if(a == nil) goto    G0188;
    a = value(LL_Htemporal);
    goto    G0190;
   G0188:
    a = car(value(LL_Htemporal));
   G0190:
    a = CC_Wfunc(a);
    if(a != nil) goto    G0241;
    if(car(w1) >= value(LL_CratfC)) goto    G0193;
    w3 = nil;
    a = w2;
    w3 = a;
   G0195:
    a = cdr(car(w3));
    a = CC_Wminus(a);
    if(a != nil) goto    G0241;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0195;
    q = w2;
    a = w1;
    {
        popv(7);
        return  CC_coefTpol3(a, q);
    }
   G0193:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = w2;
    w6 = a;
   G0204:
    a = cdr(car(w6));
    a = CC_Wminus(a);
    if(a != nil) goto    G0241;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0204;
    a = cdr(w1);
    w6 = a;
    w5 = a;
#define LL_head LITERAL[28]
    a = LL_head;
    a = Lncons(a);
    w3 = a;
   G0205:
    a = car(w6);
    w4 = a;
    a = cdr(a);
    w7 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0207;
    q = w2;
    a = w7;
    a = CC_coefTpol3(a, q);
    w7 = a;
    a = car(a);
    a = cdr(a);
    if(a == cdr(w4)) goto    G0207;
    a = car(w4);
    a = CC_Wone(a);
    if(a != nil) goto    G0221;
    q = mkfxat(1);
    a = car(w4);
    a = cons(a, q);
    q = a;
    a = value(LL_CratfC);
    a = Llist2(a, q);
    q = w7;
    CC_secofTmultsome(a, q);
    m = nil;
    q = w3;
    a = w7;
    CC_secofTaddcoef(a, q, m);
   G0221:
    q = w6;
    a = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G0225;
    a = car(car(w5));
    a = CC_Wone(a);
    if(a == nil) goto    G0227;
    a = cdr(car(w5));
    goto    G0228;
   G0227:
    q = car(w5);
    a = value(LL_CratfC);
    a = Llist2(a, q);
   G0228:
    w7 = a;
    q = mkfxat(0);
    a = Lxcons(a, q);
    m = true;
    q = w3;
    CC_secofTaddcoef(a, q, m);
    a = cdr(w5);
    w5 = a;
    goto    G0221;
   G0225:
    a = cdr(w6);
    w6 = a;
    w5 = a;
    goto    G0242;
   G0207:
    a = cdr(w6);
    w6 = a;
   G0242:
    if(a != nil) goto    G0205;
   G0233:
    a = w5;
    if(a != cdr(w1)) goto    G0235;
   G0241:
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    {
        popv(7);
        return  Lncons(a);
    }
   G0235:
    a = cdr(w3);
    popv(7);
    return a;
}

Sex CC_coefTcH(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(cdr(a));
    a = car(car(w2));
    a = CC_orderRMS(a, q);
    value(LL_Htemporal) = a;
    if(a != CHAR_OF(62)) goto    G0246;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    goto    G0305;
   G0246:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w8 = a;
    a = cdr(w1);
    w3 = a;
    a = car(a);
    a = car(a);
    a = CC_Wtag(a);
    if(a != nil) goto    G0284;
   G0255:
    a = w8;
    if(a == CHAR_OF(60)) goto    G0303;
    a = car(cdr(w3));
    w7 = a;
    a = CC_Wbnum(a);
    if(a == nil) goto    G0303;
    a = cdr(car(w2));
    w6 = a;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    q = w6;
    if(a == nil) goto    G0265;
    a = w7;
    a = Lgeq(a, q);
    goto    G0304;
   G0265:
    a = w7;
    a = Lleq(a, q);
   G0304:
    if(a == nil) goto    G0253;
    q = w7;
    a = w6;
    a = cons(a, q);
    q = car(w3);
    a = Lxcons(a, q);
    q = w4;
    a = cons(a, q);
    w4 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0277;
    q = cdr(cdr(w3));
    a = w4;
    a = CC_cofTppowcof(a, q);
    goto    G0305;
   G0277:
    a = cdr(cdr(w3));
    w3 = a;
    if(a == nil) goto    G0253;
    q = car(a);
    a = car(car(w2));
    a = CC_orderRMS(a, q);
    w8 = a;
    if(a == CHAR_OF(62)) goto    G0253;
    a = car(car(w3));
    a = CC_Wtag(a);
    if(a == nil) goto    G0255;
   G0284:
    a = car(car(w2));
    w8 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G0286;
    a = car(w8);
    w8 = a;
   G0286:
    a = w8;
    a = CC_Wfunc(a);
    if(a != nil) goto    G0253;
    a = cdr(car(w2));
    a = Lminusp(a);
    if(a != nil) goto    G0253;
    a = car(cdr(w3));
    a = CC_Wone(a);
    if(a != nil) goto    G0291;
   G0303:
    q = car(cdr(w3));
    goto    G0306;
   G0291:
    q = w2;
    a = car(w3);
    a = CC_coefTcano(a, q);
    w5 = a;
    a = car(a);
    a = cdr(a);
    if(a != car(w3)) goto    G0294;
    q = mkfxat(1);
   G0306:
    a = mkfxat(0);
    a = cons(a, q);
    q = car(w3);
    a = Lxcons(a, q);
    q = w4;
    a = cons(a, q);
    w4 = a;
    goto    G0277;
   G0294:
    arg4 = cdr(cdr(w3));
    m = w2;
    q = w5;
    a = w4;
    {
        popv(8);
        return  CC_cofTpcpowcofs(a, q, m, arg4);
    }
   G0253:
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
   G0305:
    {
        popv(8);
        return  Lncons(a);
    }
}

Sex CC_coefTcL(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w9 = nil;
    w8 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w7 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    a = LL_cL;
    a = Lncons(a);
    w4 = a;
    w3 = a;
#define LL_coef LITERAL[29]
    a = LL_coef;
    a = Lncons(a);
    w5 = a;
    a = cdr(w1);
    w8 = a;
    w9 = a;
    a = car(w8);
    a = CC_Wbnum(a);
    if(a != nil) goto    G0378;
    a = car(car(w8));
    a = CC_Wtag(a);
    if(a == nil) goto    G0323;
    q = w2;
    a = car(w8);
    a = CC_coefTcano(a, q);
    w6 = a;
    q = car(w8);
    a = cdr(car(a));
    a = Leq(a, q);
    if(a == nil) goto    G0322;
   G0378:
    a = cdr(w8);
    w8 = a;
    goto    G0323;
   G0322:
    m = nil;
    q = w5;
    a = w6;
    CC_secofTaddcoef(a, q, m);
    a = cdr(w8);
    w8 = a;
    w9 = a;
   G0323:
    a = car(car(car(w8)));
    if(a == LL_cH) goto    G0343;
    a = cdr(car(w8));
    w11 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0340;
    a = car(w11);
    a = CC_Wtag(a);
    if(a == nil) goto    G0329;
    q = w2;
    a = w11;
    a = CC_coefTcano(a, q);
    goto    G0331;
   G0329:
    a = car(w11);
    q = w2;
    if(a != LL_cH) goto    G0330;
    a = w11;
    a = CC_coefTcH(a, q);
    goto    G0331;
   G0330:
    a = w11;
    a = CC_coefTcL(a, q);
   G0331:
    w6 = a;
    a = cdr(car(a));
    if(a == w11) goto    G0340;
   G0333:
    q = w8;
    a = w9;
    a = Lneq(a, q);
    if(a == nil) goto    G0335;
    a = car(w9);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w9);
    w9 = a;
    goto    G0333;
   G0335:
    q = w6;
    a = car(car(w8));
    CC_secofTmultsome(a, q);
    q = w7;
    a = w6;
    a = cons(a, q);
    w7 = a;
    a = cdr(w8);
    w8 = a;
    w9 = a;
    goto    G0379;
   G0340:
    a = cdr(w8);
    w8 = a;
   G0379:
    if(a == nil) goto    G0368;
    goto    G0323;
   G0343:
    a = car(car(w8));
    w10 = a;
    a = car(cdr(a));
    w11 = a;
    a = CC_Watom(a);
    if(a != nil) goto    G0363;
    a = car(w11);
    a = CC_Wid(a);
    if(a == nil) goto    G0345;
    q = car(car(w2));
    a = w11;
    a = CC_Worder(a, q);
    if(a == nil) goto    G0363;
   G0345:
    q = w2;
    a = w10;
    a = CC_coefTcH(a, q);
    w6 = a;
    a = car(a);
    a = cdr(a);
    if(a != w10) goto    G0349;
    a = cdr(w8);
    w8 = a;
    goto    G0381;
   G0349:
    q = w8;
    a = w9;
    a = Lneq(a, q);
    if(a == nil) goto    G0356;
    a = car(w9);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w9);
    w9 = a;
    goto    G0349;
   G0356:
    a = cdr(car(w8));
    a = CC_Wone(a);
    if(a != nil) goto    G0360;
    q = w6;
    a = cdr(car(w8));
    CC_secofTmultsome(a, q);
   G0360:
    m = nil;
    q = w5;
    a = w6;
    CC_secofTaddcoef(a, q, m);
    a = cdr(w8);
    w8 = a;
    w9 = a;
    goto    G0381;
   G0363:
    a = w8;
    if(a == nil) goto    G0365;
    q = LL_cL;
    a = car(car(car(a)));
    a = Lneq(a, q);
    if(a == nil) goto    G0365;
    a = cdr(w8);
    w8 = a;
    goto    G0363;
   G0365:
    a = w8;
   G0381:
    if(a != nil) goto    G0343;
   G0368:
    a = w9;
    if(a != cdr(w1)) goto    G0370;
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    {
        popv(11);
        return  Lncons(a);
    }
   G0370:
    q = a;
    a = w4;
    cdr(a) = q;
    a = w3;
    a = CC_reduceTcL(a);
    w3 = a;
    a = CC_Wzero(a);
    if(a != nil) goto    G0374;
    q = w3;
    a = mkfxat(0);
    a = cons(a, q);
    m = true;
    q = w5;
    CC_secofTaddcoef(a, q, m);
   G0374:
    a = w7;
    if(a == nil) goto    G0382;
    m = nil;
    q = w5;
    a = car(a);
    CC_secofTaddcoef(a, q, m);
    a = cdr(w7);
    w7 = a;
    goto    G0374;
   G0382:
    a = cdr(w5);
    popv(11);
    return a;
}

Sex CC_coefTpol3(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(car(q));
    a = car(cdr(a));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0407;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = LL_coef;
    a = Lncons(a);
    w3 = a;
    arg4 = a;
    m = nil;
    q = cdr(w1);
    a = w2;
    a = CC_cofTbpolscan(a, q, m, arg4);
    w5 = a;
    if(a != cdr(w1)) goto    G0392;
   G0407:
    q = w1;
    a = mkfxat(0);
    a = cons(a, q);
    {
        popv(5);
        return  Lncons(a);
    }
   G0392:
    a = CC_Wzero(a);
    if(a == nil) goto    G0396;
    a = cdr(w3);
    goto    G0397;
   G0396:
    q = w5;
    a = mkfxat(0);
    a = cons(a, q);
    q = cdr(w3);
    a = cons(a, q);
   G0397:
    w4 = a;
    w3 = a;
   G0390:
    a = cdr(car(w4));
    w5 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0403;
    a = car(w5);
    a = CC_Wtag(a);
    if(a != nil) goto    G0403;
    q = cdr(car(w4));
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = car(w4);
    cdr(a) = q;
   G0403:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0390;
    a = w3;
    popv(5);
    return a;
}

Sex CC_coefptnT(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Watom(a);
    if(a == nil) goto    G0411;
    a = w1;
    if(a == nil) goto    G0413;
    a = CC_Wid(a);
    if(a == nil) goto    G0413;
    q = LL_Bgid;
    a = w1;
    a = Lget(a, q);
    if(a == nil) goto    G0413;
    q = mkfxat(1);
    a = w1;
    a = cons(a, q);
    {
        popv(6);
        return  Lncons(a);
    }
   G0413:
    q = w1;
    a = LITERAL[30];
    goto    G0461;
   G0411:
    a = car(w1);
    a = CC_Wtag(a);
    if(a == nil) goto    G0417;
    if(car(w1) >= value(LL_CratfC)) goto    G0419;
    a = w1;
    {
        popv(6);
        return  CC_cofptnTpol3(a);
    }
   G0419:
    q = nil;
    a = LITERAL[31];
    goto    G0461;
   G0417:
    a = car(w1);
    if(a != LL_cH) goto    G0421;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G0423:
    a = car(w1);
    w4 = a;
    a = CC_Wbnum(a);
    if(a == nil) goto    G0425;
    q = w4;
    a = LITERAL[32];
    goto    G0460;
   G0425:
    a = car(cdr(w1));
    w5 = a;
    a = CC_Wint(a);
    if(a != nil) goto    G0427;
    q = w5;
    a = LITERAL[33];
    goto    G0460;
   G0427:
    a = car(w4);
    a = CC_Wtag(a);
    if(a == nil) goto    G0429;
    if(car(w4) >= value(LL_CratfC)) goto    G0431;
    w6 = nil;
    a = w2;
    w3 = a;
    a = w4;
    a = CC_cofptnTpol3(a);
    w6 = a;
   G0433:
    a = cdr(w3);
    if(a != nil) goto    G0436;
    q = w6;
    a = w3;
    cdr(a) = q;
    goto    G0443;
   G0436:
    q = car(car(w6));
    a = car(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G0437;
    q = cdr(car(w6));
    a = cdr(car(cdr(w3)));
    a = plus2(a, q);
    q = a;
    a = car(cdr(w3));
    goto    G0458;
   G0437:
    q = car(car(w6));
    a = car(car(cdr(w3)));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0439;
    a = cdr(w3);
    w3 = a;
    goto    G0433;
   G0439:
    q = cdr(w3);
    a = car(w6);
    a = cons(a, q);
    q = a;
    a = w3;
   G0458:
    cdr(a) = q;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0433;
   G0443:
    a = w3;
    a = CC_tail(a);
    goto    G0459;
   G0431:
    q = nil;
    a = LITERAL[31];
    goto    G0460;
   G0429:
    a = car(w4);
    a = CC_Wfunc(a);
    if(a == nil) goto    G0445;
    q = w5;
    a = w4;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
   G0459:
    w3 = a;
    goto    G0449;
   G0445:
    q = LITERAL[20];
    a = mkfxat(3);
   G0460:
    CC_errormsg(a, q);
   G0449:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G0423;
    a = cdr(w2);
    goto    G0453;
   G0421:
    q = nil;
    if(a != LL_ncH) goto    G0452;
    a = LITERAL[34];
    goto    G0461;
   G0452:
    a = LITERAL[35];
   G0461:
    a = CC_errormsg(a, q);
   G0453:
    popv(6);
    return a;
}

Sex CC_cofptnTpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    a = cdr(a);
    w1 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    w2 = a;
   G0465:
    q = car(car(cdr(w1)));
    a = car(w1);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G0470;
    q = nil;
    a = LITERAL[35];
    goto    G0480;
   G0470:
    a = cdr(car(w1));
    w1 = a;
    a = CC_Wbnum(a);
    if(a == nil) goto    G0472;
    a = w1;
    a = CC_Wone(a);
    if(a != nil) goto    G0478;
    q = w1;
    a = LITERAL[36];
   G0480:
    CC_errormsg(a, q);
    goto    G0478;
   G0472:
    a = car(w1);
    a = CC_Wtag(a);
    if(a == nil) goto    G0465;
    a = w1;
    a = CC_cofptnTpol3(a);
    q = a;
    a = w2;
    Lnconc(a, q);
   G0478:
    a = cdr(w2);
    popv(3);
    return a;
}

Sex CC_mncoefTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
   G0520:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
   G0484:
    q = car(w2);
    a = car(w1);
    a = Lequal(a, q);
    if(a != nil) goto    G0495;
    q = car(w1);
    a = car(w2);
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G0519;
    a = w1;
    a = Llast(a);
    w5 = a;
    a = car(a);
    a = Lzerop(a);
    if(a == nil) goto    G0483;
    a = cdr(w5);
    w5 = a;
    if(is_number(a)) goto    G0519;
    a = car(a);
    if(is_integer(a)) goto    G0519;
    a = w5;
    w1 = a;
    goto    G0484;
   G0495:
    a = cdr(w1);
    w3 = a;
    a = cdr(w2);
    w4 = a;
    a = car(car(a));
    w6 = a;
   G0485:
    q = w6;
    a = car(car(w3));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0497;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0483;
    goto    G0485;
   G0497:
    q = w6;
    a = car(car(w3));
    a = Llessp(a, q);
    if(a != nil) goto    G0519;
    a = cdr(car(w4));
    w2 = a;
    if(is_number(a)) goto    G0486;
    a = cdr(car(w3));
    w1 = a;
    if(!is_number(a)) goto    G0503;
   G0519:
    a = nil;
    goto    G0483;
   G0503:
    a = car(w2);
    if(!is_integer(a)) goto    G0504;
    q = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0483;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
   G0504:
    q = w2;
    a = w1;
    goto    G0520;  /* recursive call to mncoef:bpol */
   G0486:
    a = cdr(car(w3));
    w1 = a;
    if(is_number(a)) goto    G0483;
    a = car(a);
    if(!is_integer(a)) goto    G0511;
    a = w1;
    goto    G0483;
   G0511:
    a = w1;
    a = CC_tail(a);
    w3 = a;
    a = car(a);
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G0486;
   G0483:
    popv(6);
    return a;
}

Sex CC_cfpartTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
   G0523:
    q = car(w2);
    a = car(w1);
    a = Lequal(a, q);
    if(a != nil) goto    G0533;
    q = car(w1);
    a = car(w2);
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G0549;
    a = w1;
    a = Llast(a);
    w5 = a;
    a = car(a);
    a = Lzerop(a);
    if(a == nil) goto    G0522;
    a = cdr(w5);
    w5 = a;
    if(is_number(a)) goto    G0549;
    a = car(a);
    if(is_integer(a)) goto    G0549;
    a = w5;
    w1 = a;
    goto    G0523;
   G0533:
    a = cdr(w1);
    w3 = a;
    a = cdr(w2);
    w4 = a;
    a = car(car(a));
    w6 = a;
   G0524:
    q = w6;
    a = car(car(w3));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0535;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0522;
    goto    G0524;
   G0535:
    q = w6;
    a = car(car(w3));
    a = Llessp(a, q);
    if(a != nil) goto    G0549;
    a = cdr(car(w4));
    w2 = a;
    if(!is_number(a)) goto    G0540;
    a = cdr(car(w3));
    goto    G0522;
   G0540:
    a = cdr(car(w3));
    w1 = a;
    if(!is_number(a)) goto    G0541;
   G0549:
    a = nil;
    goto    G0522;
   G0541:
    a = car(w2);
    if(!is_integer(a)) goto    G0542;
    q = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0522;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
   G0542:
    q = w2;
    a = w1;
    a = CC_cfpartTbpol(a, q);
   G0522:
    popv(6);
    return a;
}

Sex CC_cofTbpolscan(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = car(q);
    a = car(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G0553;
    q = car(car(cdr(w2)));
    a = cdr(car(w1));
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0678;
    a = cdr(w1);
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    if(a != nil) goto    G0556;
    w12 = nil;
    a = car(w2);
    w6 = a;
    a = cdr(w2);
    w5 = a;
    a = cdr(car(w1));
    w8 = a;
   G0558:
    q = car(car(w5));
    a = w8;
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    q = w3;
    a = cons(a, q);
    w12 = a;
    q = cdr(car(w5));
    a = CC_cofTcpowcof(a, q);
    w7 = a;
    a = w4;
    w11 = a;
    a = car(w7);
    w9 = a;
   G0559:
    a = cdr(w11);
    if(a != nil) goto    G0563;
    a = w7;
    a = Lncons(a);
    q = a;
    a = w11;
    cdr(a) = q;
    a = cdr(a);
    goto    G0572;
   G0563:
    a = car(car(a));
    w10 = a;
    q = w9;
    a = Llessp(a, q);
    if(a == nil) goto    G0566;
    a = cdr(w11);
    w11 = a;
    goto    G0559;
   G0566:
    q = w9;
    a = w10;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0568;
    q = cdr(w11);
    a = w7;
    a = cons(a, q);
    q = a;
    goto    G0672;
   G0568:
    q = cdr(car(cdr(w11)));
    a = cdr(w7);
    a = CC_Lanyany(a, q);
    w12 = a;
    a = CC_Wzero(a);
    if(a == nil) goto    G0570;
    q = cdr(cdr(w11));
   G0672:
    a = w11;
    goto    G0673;
   G0570:
    q = w12;
    a = car(cdr(w11));
   G0673:
    cdr(a) = q;
   G0572:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0574;
    a = mkfxat(0);
    goto    G0622;
   G0574:
    q = w8;
    a = car(car(a));
    a = Lgeq(a, q);
    if(a != nil) goto    G0558;
    q = w5;
    a = w6;
    a = cons(a, q);
    goto    G0679;
   G0556:
    a = car(w2);
    w9 = a;
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = cdr(w2);
    w7 = a;
    w8 = a;
   G0580:
    a = cdr(car(w7));
    w10 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0582;
    a = car(w10);
    a = CC_Wtag(a);
    if(a == nil) goto    G0680;
    q = car(cdr(w10));
    a = w9;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0582;
    q = car(car(w7));
    a = cdr(car(w1));
    a = cons(a, q);
    q = w9;
    a = Lxcons(a, q);
    q = w3;
    a = cons(a, q);
    w11 = a;
    q = car(w10);
    a = Lxcons(a, q);
    arg4 = w4;
    m = a;
    q = cdr(w10);
    a = cdr(w1);
    a = CC_cofTbpolscan(a, q, m, arg4);
    w11 = a;
    if(a == cdr(w10)) goto    G0582;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0592;
    a = car(w11);
    a = CC_Wtag(a);
    if(a != nil) goto    G0592;
    q = w11;
    a = car(w10);
    a = cons(a, q);
    w11 = a;
   G0592:
    q = w7;
    a = w8;
    a = Lneq(a, q);
    if(a == nil) goto    G0602;
    a = car(w8);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = cdr(w8);
    w8 = a;
    goto    G0592;
   G0602:
    a = w11;
    a = CC_Wzero(a);
    if(a != nil) goto    G0606;
    q = w11;
    a = car(car(w7));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G0606:
    a = cdr(w7);
    w7 = a;
    w8 = a;
    if(a == nil) goto    G0611;
    q = cdr(car(w1));
    a = car(car(a));
    a = Lgeq(a, q);
    if(a != nil) goto    G0580;
   G0611:
    q = w8;
    a = w6;
    cdr(a) = q;
    a = w5;
    goto    G0679;
   G0680:
    q = car(car(w7));
    a = cdr(car(w1));
    a = cons(a, q);
    q = w9;
    a = Lxcons(a, q);
    q = w3;
    a = cons(a, q);
    w11 = a;
    arg4 = w4;
    m = a;
    q = w10;
    a = cdr(w1);
    a = CC_cofTbpolscan(a, q, m, arg4);
    w11 = a;
    if(a != w10) goto    G0592;
   G0582:
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G0615;
    q = cdr(car(w1));
    a = car(car(a));
    a = Lgeq(a, q);
    if(a != nil) goto    G0580;
   G0615:
    a = w8;
    if(a == cdr(w2)) goto    G0678;
    q = a;
    a = w6;
    cdr(a) = q;
    a = w5;
    goto    G0679;
   G0553:
    q = car(w2);
    a = car(car(w1));
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G0678;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    a = car(w2);
    w9 = a;
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = cdr(w2);
    w7 = a;
    w8 = a;
   G0624:
    a = cdr(car(w7));
    w10 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0626;
    a = car(w10);
    a = CC_Wtag(a);
    if(a != nil) goto    G0630;
    a = car(car(w7));
    w11 = a;
    a = CC_Wzero(a);
    if(a == nil) goto    G0632;
    a = w3;
    goto    G0634;
   G0630:
    q = car(cdr(w10));
    a = w9;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0626;
    a = car(car(w7));
    w11 = a;
    a = CC_Wzero(a);
    if(a == nil) goto    G0642;
    a = w3;
    goto    G0644;
   G0642:
    q = w11;
    a = mkfxat(0);
    a = cons(a, q);
    q = w9;
    a = Lxcons(a, q);
    q = w3;
    a = cons(a, q);
   G0644:
    w11 = a;
    q = car(w10);
    a = Lxcons(a, q);
    arg4 = w4;
    m = a;
    q = cdr(w10);
    a = w1;
    a = CC_cofTbpolscan(a, q, m, arg4);
    w11 = a;
    if(a == cdr(w10)) goto    G0626;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0640;
    a = car(w11);
    a = CC_Wtag(a);
    if(a != nil) goto    G0640;
    q = w11;
    a = car(w10);
    a = cons(a, q);
    w11 = a;
   G0640:
    q = w7;
    a = w8;
    a = Lneq(a, q);
    if(a == nil) goto    G0654;
    a = car(w8);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = cdr(w8);
    w8 = a;
    goto    G0640;
   G0654:
    a = w11;
    a = CC_Wzero(a);
    if(a != nil) goto    G0658;
    q = w11;
    a = car(car(w7));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G0658:
    a = cdr(w7);
    w7 = a;
    w8 = a;
    if(a != nil) goto    G0624;
    a = w5;
    goto    G0679;
   G0632:
    q = w11;
    a = mkfxat(0);
    a = cons(a, q);
    q = w9;
    a = Lxcons(a, q);
    q = w3;
    a = cons(a, q);
   G0634:
    w11 = a;
    arg4 = w4;
    m = a;
    q = w10;
    a = w1;
    a = CC_cofTbpolscan(a, q, m, arg4);
    w11 = a;
    if(a != w10) goto    G0640;
   G0626:
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G0624;
    a = w8;
    if(a != cdr(w2)) goto    G0668;
   G0678:
    a = w2;
    goto    G0622;
   G0668:
    q = a;
    a = w6;
    cdr(a) = q;
    a = w5;
   G0679:
    a = CC_reduceTbpol(a);
   G0622:
    popv(12);
    return a;
}

Sex CC_cofTcpowcof(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w3 = nil;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w5 = a;
    w1 = a;
    w2 = q;
    a = car(a);
    a = CC_Watom(a);
    if(a == nil) goto    G0688;
    a = cdr(w5);
    w5 = a;
   G0688:
    a = cdr(cdr(car(w5)));
    w3 = a;
    a = CC_Wone(a);
    if(a != nil) goto    G0701;
   G0690:
    a = car(w5);
    a = CC_Watom(a);
    if(a != nil) goto    G0697;
    a = cdr(car(w5));
    w7 = a;
    a = car(a);
    a = CC_Wzero(a);
    if(a != nil) goto    G0697;
    q = car(w7);
    a = cdr(w7);
    a = quot2(a, q);
    q = w3;
    a = Lmin2(a, q);
    w3 = a;
    a = CC_Wone(a);
    if(a != nil) goto    G0701;
   G0697:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0690;
   G0701:
    a = w2;
    w4 = a;
   G0686:
    a = car(w1);
    w6 = a;
    a = CC_Watom(a);
    if(a == nil) goto    G0703;
    a = w4;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0712;
    a = car(w4);
    a = CC_Wtag(a);
    if(a != nil) goto    G0712;
    q = w4;
    a = w6;
    a = cons(a, q);
    goto    G0721;
   G0703:
    a = car(cdr(w6));
    w5 = a;
    a = CC_Wzero(a);
    if(a == nil) goto    G0709;
    q = w4;
    a = cdr(cdr(w6));
    a = cons(a, q);
    q = a;
    a = car(w6);
    a = Llist2(a, q);
    goto    G0721;
   G0709:
    q = w3;
    a = w5;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = cdr(cdr(w6));
    a = plus2(a, q);
    w7 = a;
    a = CC_Wzero(a);
    if(a != nil) goto    G0712;
    q = w4;
    a = w7;
    a = cons(a, q);
    q = a;
    a = car(w6);
    a = Llist2(a, q);
   G0721:
    w4 = a;
   G0712:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0686;
    q = w4;
    a = w3;
    {
        popv(7);
        return  cons(a, q);
    }
}

Sex CC_cofTppowcof(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = cdr(cdr(car(a)));
    a = Labs(a);
    w3 = a;
    a = CC_Wone(a);
    if(a != nil) goto    G0741;
    a = w1;
    w5 = a;
   G0725:
    a = cdr(car(w5));
    w7 = a;
    a = car(a);
    a = CC_Wzero(a);
    if(a != nil) goto    G0735;
    a = cdr(w7);
    a = Labs(a);
    w8 = a;
    a = car(w7);
    a = Labs(a);
    q = a;
    a = w8;
    a = quot2(a, q);
    q = w3;
    a = Lmin2(a, q);
    w3 = a;
    a = CC_Wone(a);
    if(a != nil) goto    G0741;
   G0735:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0725;
   G0741:
    a = w2;
    w4 = a;
   G0727:
    a = car(w1);
    w6 = a;
    a = cdr(a);
    a = car(a);
    w5 = a;
    a = CC_Wzero(a);
    if(a == nil) goto    G0743;
    q = w4;
    a = cdr(cdr(w6));
    goto    G0759;
   G0743:
    q = w3;
    a = w5;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = cdr(cdr(w6));
    a = plus2(a, q);
    w7 = a;
    a = CC_Wzero(a);
    if(a != nil) goto    G0752;
    q = w4;
    a = w7;
   G0759:
    a = cons(a, q);
    q = car(w6);
    a = Lxcons(a, q);
    w4 = a;
   G0752:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0727;
    q = w4;
    a = LL_cH;
    a = cons(a, q);
    a = CC_reduceTcH(a);
    q = w3;
    {
        popv(8);
        return  Lxcons(a, q);
    }
}

Sex CC_cofTpcpowcofs(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w6 = nil;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = LL_coef;
    a = Lncons(a);
    w5 = a;
    a = w2;
    a = Lreverse(a);
    w2 = a;
    a = car(car(a));
    w6 = a;
    a = CC_Wone(a);
    if(a != nil) goto    G0784;
    a = w1;
    if(a == nil) goto    G0784;
    w7 = a;
   G0763:
    a = cdr(car(w7));
    w14 = a;
    a = car(a);
    a = CC_Wzero(a);
    if(a != nil) goto    G0778;
    a = cdr(w14);
    a = Labs(a);
    w15 = a;
    a = car(w14);
    a = Labs(a);
    q = a;
    a = w15;
    a = quot2(a, q);
    q = w6;
    a = Lmin2(a, q);
    w6 = a;
    a = CC_Wone(a);
    if(a != nil) goto    G0784;
   G0778:
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G0763;
   G0784:
    w11 = nil;
   G0765:
    a = w6;
    a = Lminus(a);
    q = a;
    a = car(car(w2));
    a = plus2(a, q);
    w14 = a;
    a = Lminusp(a);
    if(a != nil) goto    G0801;
    a = w14;
    a = CC_Wzero(a);
    if(a != nil) goto    G0791;
    a = w12;
    if(a != nil) goto    G0791;
    a = w3;
    a = CC_cofTvlis2mono(a);
    w12 = a;
   G0791:
    a = w14;
    a = CC_Wzero(a);
    if(a == nil) goto    G0793;
    a = cdr(car(w2));
    goto    G0795;
   G0793:
    a = w14;
    a = CC_Wone(a);
    if(a == nil) goto    G0794;
    q = cdr(car(w2));
    a = w12;
    goto    G0841;
   G0794:
    q = w14;
    a = w12;
    a = CC_powTcanopint(a, q);
    q = cdr(car(w2));
   G0841:
    a = CC_multH(a, q);
   G0795:
    w14 = a;
    a = w11;
    if(a == nil) goto    G0798;
    q = w14;
    a = CC_addH(a, q);
    goto    G0799;
   G0798:
    a = w14;
   G0799:
    w11 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0765;
   G0801:
    a = w4;
    w10 = a;
    a = w1;
    w8 = a;
   G0767:
    if(a == nil) goto    G0803;
    a = car(a);
    w14 = a;
    a = car(a);
    a = car(a);
    a = CC_Wtag(a);
    if(a == nil) goto    G0803;
    q = w10;
    a = cdr(cdr(w14));
    a = cons(a, q);
    q = car(w14);
    a = Lxcons(a, q);
    w10 = a;
    a = cdr(w8);
    w8 = a;
    goto    G0767;
   G0803:
    q = w10;
    a = LL_cH;
    a = cons(a, q);
    a = CC_reduceTcH(a);
    q = a;
    a = w11;
    a = CC_multH(a, q);
    w10 = a;
    a = mkfxat(1);
    w13 = a;
    a = w8;
    if(a == nil) goto    G0836;
    a = w10;
    a = CC_Wbnum(a);
    if(a == nil) goto    G0813;
    a = w10;
    w13 = a;
    w10 = nil;
    goto    G0815;
   G0813:
    a = car(w10);
    a = CC_Wtag(a);
    if(a != nil) goto    G0814;
    a = cdr(w10);
    w10 = a;
    goto    G0815;
   G0814:
    if(car(w10) >= value(LL_CratfC)) goto    G0817;
    a = w10;
    a = CC_normlzTpol3(a);
    goto    G0818;
   G0817:
    a = w10;
    a = CC_normlzTratf(a);
   G0818:
    w14 = a;
    q = mkfxat(1);
    a = car(a);
    a = Llist2(a, q);
    w10 = a;
    a = cdr(w14);
    w13 = a;
   G0815:
    a = car(w8);
    w9 = a;
    a = cdr(a);
    a = car(a);
    w7 = a;
    a = CC_Wzero(a);
    if(a != nil) goto    G0821;
    a = w6;
    a = CC_Wzero(a);
    if(a == nil) goto    G0820;
   G0821:
    q = w10;
    a = cdr(cdr(w9));
    goto    G0842;
   G0820:
    q = w6;
    a = w7;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = cdr(cdr(w9));
    a = plus2(a, q);
    w14 = a;
    a = CC_Wzero(a);
    if(a != nil) goto    G0830;
    q = w10;
    a = w14;
   G0842:
    a = cons(a, q);
    q = car(w9);
    a = Lxcons(a, q);
    w10 = a;
   G0830:
    a = cdr(w8);
    w8 = a;
    if(a != nil) goto    G0815;
    q = w10;
    a = LL_cH;
    a = cons(a, q);
    a = CC_reduceTcH(a);
    w10 = a;
    a = w13;
    a = CC_Wone(a);
    if(a != nil) goto    G0836;
    q = w10;
    a = w13;
    a = CC_multH(a, q);
    w10 = a;
   G0836:
    q = w10;
    a = w6;
    a = cons(a, q);
    m = true;
    q = w5;
    CC_secofTaddcoef(a, q, m);
    a = w2;
    if(a != nil) goto    G0839;
    a = cdr(w5);
    goto    G0762;
   G0839:
    a = car(car(a));
    w6 = a;
    goto    G0784;
    a = nil;
   G0762:
    popv(15);
    return a;
}

Sex CC_secofTaddcoef(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    if(a == nil) goto    G0848;
    a = w1;
    goto    G0868;
   G0848:
    a = car(w1);
    goto    G0868;
   G0850:
    a = cdr(w2);
    if(a != nil) goto    G0853;
    a = w6;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    a = cdr(a);
    w2 = a;
    goto    G0862;
   G0853:
    a = car(car(a));
    w5 = a;
    q = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0856;
    a = cdr(w2);
    w2 = a;
    goto    G0850;
   G0856:
    q = w4;
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0858;
    q = cdr(w2);
    a = w6;
    a = cons(a, q);
    q = a;
    goto    G0869;
   G0858:
    q = cdr(car(cdr(w2)));
    a = cdr(w6);
    a = CC_addH(a, q);
    w7 = a;
    a = CC_Wzero(a);
    if(a == nil) goto    G0860;
    q = cdr(cdr(w2));
   G0869:
    a = w2;
    goto    G0870;
   G0860:
    q = w7;
    a = car(cdr(w2));
   G0870:
    cdr(a) = q;
   G0862:
    a = w3;
    if(a != nil) goto    G0865;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0865;
    a = car(a);
   G0868:
    w6 = a;
    a = car(a);
    w4 = a;
    goto    G0850;
   G0865:
    a = w2;
    popv(7);
    return a;
}

Sex CC_secofTmultsome(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    if(a == nil) goto    G0875;
    w2 = q;
    q = cdr(car(a));
    a = w1;
    a = CC_multH(a, q);
    q = a;
    a = car(w2);
    cdr(a) = q;
    q = cdr(w2);
    a = w1;
    a = CC_secofTmultsome(a, q);
   G0875:
    popv(2);
    return a;
}

Sex CC_cofTvlis2mono(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w2 = nil;
    w4 = nil;
    w1 = a;
   G0880:
    a = car(car(w1));
    w3 = a;
    a = CC_Watom(a);
    if(a == nil) goto    G0882;
#define LL_uniqrep LITERAL[37]
    q = LL_uniqrep;
    a = w3;
    a = CC_getTsimprs(a, q);
    goto    G0888;
   G0882:
    q = LL_Bgid;
    a = car(w3);
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
#define LL_algn LITERAL[38]
    if(a != LL_algn) goto    G0884;
#define LL_CalgnC LITERAL[39]
    q = value(LL_CalgnC);
    goto    G0898;
   G0884:
#define LL_algf LITERAL[40]
    if(a != LL_algf) goto    G0887;
#define LL_CalgfC LITERAL[41]
    q = value(LL_CalgfC);
    goto    G0898;
   G0887:
#define LL_CpolyC LITERAL[42]
    q = value(LL_CpolyC);
   G0898:
    a = w3;
    a = CC_convTvar2cano(a, q);
   G0888:
    w4 = a;
    a = cdr(car(w1));
    w3 = a;
    a = CC_Wone(a);
    if(a != nil) goto    G0890;
    q = w3;
    a = w4;
    a = CC_powTcanopint(a, q);
    w4 = a;
   G0890:
    a = w2;
    if(a == nil) goto    G0893;
    q = w4;
    a = CC_Hpol3pol3(a, q);
    goto    G0894;
   G0893:
    a = w4;
   G0894:
    w2 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0880;
    a = w2;
    popv(4);
    return a;
}

Sex CC_Amvar(Sex a)
{
    if(!is_number(a)) goto    G0902;
    a = LL_Anil;
    goto    G0903;
   G0902:
    a = car(cdr(a));
   G0903:
    return a;
}

Sex CC_Adeg(Sex a)
{
    if(!is_number(a)) goto    G0907;
    a = mkfxat(0);
    goto    G0908;
   G0907:
    a = Lcaaddr(a);
   G0908:
    return a;
}

Sex CC_Avdeg(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(is_number(a)) goto    G0919;
    a = q;
    a = CC_Aexpr2varfunc(a);
    w2 = a;
#define LL_invalid LITERAL[43]
    if(a != LL_invalid) goto    G0913;
    q = a;
    a = LITERAL[44];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0913:
    a = cdr(w1);
    w1 = a;
    a = car(a);
    q = a;
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G0914;
    a = car(car(cdr(w1)));
    goto    G0918;
   G0914:
    q = car(w1);
    a = w2;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0917;
   G0919:
    a = mkfxat(0);
    goto    G0918;
   G0917:
    m = mkfxat(0);
    q = w2;
    a = w1;
    a = CC_vdegTbpol(a, q, m);
   G0918:
    popv(2);
    return a;
}

Sex CC_Atdeg(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_number(a)) goto    G0923;
    a = mkfxat(0);
    goto    G0924;
   G0923:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(cdr(a));
    w2 = a;
    a = car(car(a));
    w4 = a;
   G0926:
    a = cdr(car(w2));
    w3 = a;
    if(is_number(a)) goto    G0930;
    a = car(a);
    if(is_integer(a)) goto    G0930;
    a = car(w2);
    a = CC_Atdeg(a);
    q = a;
    a = car(car(w2));
    a = plus2(a, q);
    w5 = a;
    q = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0930;
    a = w5;
    w4 = a;
   G0930:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0926;
    a = w4;
   G0924:
    popv(5);
    return a;
}

Sex CC_Alcoef(Sex a)
{
    Sex q, m;
    m = a;
    if(is_number(a)) goto    G0941;
    a = cdr(car(cdr(cdr(a))));
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G0940;
    a = car(a);
    if(!is_integer(a)) goto    G0939;
   G0940:
    a = value(LL_Htemporal);
    goto    G0941;
   G0939:
    q = value(LL_Htemporal);
    a = car(m);
    a = cons(a, q);
   G0941:
    return a;
}

Sex CC_Aemaxmin(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_number(a)) goto    G0945;
    a = LL_Anil;
    goto    G0946;
   G0945:
    w2 = nil;
    w3 = nil;
    a = CC_emaxminH(a);
    w3 = a;
    w2 = a;
   G0948:
    q = car(w3);
    a = LL_Boset;
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0948;
    q = w2;
    a = LL_Boset;
    a = cons(a, q);
   G0946:
    popv(3);
    return a;
}

Sex CC_Aeminmax(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_number(a)) goto    G0956;
    a = LL_Anil;
    goto    G0957;
   G0956:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = CC_emaxminH(a);
    w3 = a;
    w2 = a;
   G0959:
    a = car(w3);
    w4 = a;
    m = car(cdr(a));
    q = car(cdr(cdr(a)));
    a = car(a);
    a = Llist3(a, q, m);
    q = LL_Boset;
    a = Lxcons(a, q);
    q = a;
    a = w3;
    car(a) = q;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0959;
    q = w2;
    a = LL_Boset;
    a = cons(a, q);
   G0957:
    popv(4);
    return a;
}

Sex CC_emaxminH(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
#define LL_var LITERAL[45]
    a = LL_var;
    a = Lncons(a);
    w3 = a;
    q = a;
    a = cdr(w1);
    CC_varsTbpol(a, q);
    a = cdr(w3);
    w3 = a;
    w2 = a;
   G0968:
    m = nil;
    q = mkfxat(0);
    a = car(w3);
    a = Llist3(a, q, m);
    q = a;
    a = w3;
    car(a) = q;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0968;
    q = w2;
    a = cdr(w1);
    CC_emxmnTbpol(a, q);
    a = w2;
    popv(3);
    return a;
}

Sex CC_Alncoef(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_number(a)) goto    G0979;
    a = car(cdr(cdr(a)));
    w1 = a;
    a = cdr(a);
    if(!is_number(a)) goto    G0976;
    a = cdr(w1);
    goto    G0979;
   G0976:
    a = car(cdr(w1));
    if(!is_integer(a)) goto    G0978;
    a = cdr(w1);
    goto    G0980;
   G0978:
    a = w1;
   G0980:
    a = CC_Alncoef(a);
   G0979:
    popv(1);
    return a;
}

Sex CC_Amcoef(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_number(a)) goto    G0997;
    a = car(a);
    if(!is_integer(a)) goto    G0985;
    if(a >= value(LL_CratfC)) goto    G0987;
    a = w1;
    goto    G0994;
   G0987:
    a = cdr(w1);
    w1 = a;
    a = car(a);
    a = car(a);
    if(!is_number(a)) goto    G0990;
    a = cdr(w1);
    w1 = a;
   G0990:
    a = cdr(car(w1));
    if(is_number(a)) goto    G0997;
   G0994:
    {
        popv(1);
        return  CC_Alncoef(a);
    }
   G0985:
    q = LL_cL;
    a = Lneq(a, q);
    if(a == nil) goto    G0996;
    a = mkfxat(1);
    goto    G0997;
   G0996:
    a = cdr(w1);
    w1 = a;
    a = car(a);
    a = CC_Wncan(a);
    if(a == nil) goto    G0999;
    a = cdr(w1);
    w1 = a;
   G0999:
    a = cdr(car(w1));
    if(is_number(a)) goto    G0997;
    a = CC_Amcoef(a);
   G0997:
    popv(1);
    return a;
}

Sex CC_Alpart(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1009;
    if(!is_number(a)) goto    G1042;
    goto    G1043;
   G1009:
    a = car(a);
    if(!is_integer(a)) goto    G1013;
    if(a >= value(LL_CratfC)) goto    G1015;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1017;
    a = cdr(w1);
    a = CC_WspowTbpol(a);
    if(a == nil) goto    G1019;
    a = mkfxat(0);
    goto    G1043;
   G1019:
    a = cdr(w1);
    a = CC_lfctrTbpol(a);
    goto    G1045;
   G1017:
    a = cdr(w1);
    a = CC_ltermTbpol(a);
   G1045:
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G1015:
    if(a != value(LL_CratfC)) goto    G1024;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1046;
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G1027;
    a = cdr(w1);
    goto    G1043;
   G1027:
    q = w1;
    a = value(LL_CratfC);
    goto    G1047;
   G1024:
    if(a >= value(LL_CmaxformC)) goto    G1042;
    a = w1;
    {
        popv(1);
        return  CC_lpartTform(a);
    }
   G1013:
    q = LL_BctypeB;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a != LL_rat) goto    G1033;
    a = car(w1);
    if(a == LL_cL) goto    G1035;
    a = w1;
    goto    G1049;
   G1035:
    a = cdr(cdr(w1));
    if(a != nil) goto    G1036;
    a = car(car(cdr(w1)));
   G1049:
    {
        popv(1);
        return  CC_Alfactor(a);
    }
   G1036:
    a = car(cdr(w1));
    w1 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G1037;
   G1046:
    a = w1;
    goto    G1043;
   G1037:
    a = cdr(w1);
    a = Lonep(a);
    if(a == nil) goto    G1039;
    a = car(w1);
    goto    G1043;
   G1039:
    q = w1;
    a = LL_cL;
   G1047:
    {
        popv(1);
        return  Llist2(a, q);
    }
   G1033:
#define LL_rel LITERAL[46]
    if(a == LL_rel) goto    G1050;
    if(a != LL_set) goto    G1042;
   G1050:
    a = car(cdr(w1));
    goto    G1043;
   G1042:
    a = LITERAL[47];
    a = CC_argerror(a);
   G1043:
    popv(1);
    return a;
}

Sex CC_Arpart(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1054;
    if(!is_number(a)) goto    G1079;
    goto    G1067;
   G1054:
    a = car(a);
    if(!is_integer(a)) goto    G1058;
    if(a >= value(LL_CratfC)) goto    G1060;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a != nil) goto    G1062;
    a = w1;
    {
        popv(1);
        return  CC_Arterm(a);
    }
   G1060:
    if(a != value(LL_CratfC)) goto    G1065;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1067;
    q = value(LL_CratfC);
    goto    G1088;
   G1062:
    a = cdr(w1);
    a = CC_WspowTbpol(a);
    if(a == nil) goto    G1087;
   G1067:
    a = mkfxat(0);
    goto    G1083;
   G1065:
    if(a >= value(LL_CmaxformC)) goto    G1079;
    a = w1;
    {
        popv(1);
        return  CC_rpartTform(a);
    }
   G1058:
    q = LL_BctypeB;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a != LL_rat) goto    G1071;
    a = car(w1);
    if(a == LL_cL) goto    G1073;
   G1087:
    a = w1;
    {
        popv(1);
        return  CC_Arfactor(a);
    }
   G1073:
    a = cdr(cdr(w1));
    if(a == nil) goto    G1074;
    q = LL_cL;
    a = Lxcons(a, q);
    {
        popv(1);
        return  CC_reduceTcL(a);
    }
   G1074:
    a = car(car(cdr(w1)));
    a = CC_Arfactor(a);
    q = a;
    a = cdr(car(cdr(w1)));
    {
        popv(1);
        return  CC_multH(a, q);
    }
   G1071:
    if(a != LL_rel) goto    G1078;
    a = car(cdr(cdr(w1)));
    goto    G1083;
   G1078:
    if(a != LL_set) goto    G1079;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1081;
    q = car(w1);
   G1088:
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G1081:
    a = LL_Anil;
    goto    G1083;
   G1079:
    a = LITERAL[48];
    a = CC_argerror(a);
   G1083:
    popv(1);
    return a;
}

Sex CC_Alterm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1093;
    if(!is_number(a)) goto    G1115;
    goto    G1116;
   G1093:
    a = car(a);
    if(!is_integer(a)) goto    G1097;
    if(a >= value(LL_CratfC)) goto    G1099;
    a = cdr(w1);
    a = CC_ltermTbpol(a);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G1099:
    if(a != value(LL_CratfC)) goto    G1115;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1121;
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G1104;
    a = cdr(w1);
    goto    G1116;
   G1104:
    q = w1;
    a = value(LL_CratfC);
    goto    G1119;
   G1097:
    if(a != LL_cL) goto    G1109;
    a = car(cdr(w1));
    w1 = a;
    if(is_number(a)) goto    G1121;
    a = car(a);
    if(is_integer(a)) goto    G1121;
    a = cdr(w1);
    a = Lonep(a);
    if(a == nil) goto    G1113;
    a = car(w1);
    goto    G1116;
   G1113:
    q = w1;
    a = LL_cL;
   G1119:
    {
        popv(1);
        return  Llist2(a, q);
    }
   G1109:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1115;
   G1121:
    a = w1;
    goto    G1116;
   G1115:
    a = LITERAL[49];
    a = CC_argerror(a);
   G1116:
    popv(1);
    return a;
}

Sex CC_Arterm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1125;
    if(!is_number(a)) goto    G1143;
    goto    G1147;
   G1125:
    a = car(a);
    if(!is_integer(a)) goto    G1129;
    if(a >= value(LL_CratfC)) goto    G1131;
    a = cdr(w1);
    a = CC_rtermTbpol(a);
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G1134;
    a = car(a);
    if(!is_integer(a)) goto    G1133;
   G1134:
    a = value(LL_Htemporal);
    goto    G1144;
   G1133:
    q = value(LL_Htemporal);
    a = car(w1);
    {
        popv(1);
        return  cons(a, q);
    }
   G1131:
    if(a != value(LL_CratfC)) goto    G1143;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1147;
    q = value(LL_CratfC);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G1129:
    if(a != LL_cL) goto    G1141;
    q = cdr(cdr(w1));
    a = LL_cL;
    a = cons(a, q);
    {
        popv(1);
        return  CC_reduceTcL(a);
    }
   G1141:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1143;
   G1147:
    a = mkfxat(0);
    goto    G1144;
   G1143:
    a = LITERAL[50];
    a = CC_argerror(a);
   G1144:
    popv(1);
    return a;
}

Sex CC_Alfactor(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
   G1178:
    w1 = a;
    if(is_cons(a)) goto    G1152;
    if(!is_number(a)) goto    G1169;
    goto    G1173;
   G1152:
    a = car(a);
    if(!is_integer(a)) goto    G1156;
    if(a >= value(LL_CratfC)) goto    G1158;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1176;
    a = cdr(w1);
    a = CC_lfctrTbpol(a);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G1158:
    if(a != value(LL_CratfC)) goto    G1169;
    goto    G1176;
   G1156:
    if(a != LL_cH) goto    G1165;
    m = car(cdr(cdr(w1)));
    q = car(cdr(w1));
    a = LL_cH;
    a = Llist3(a, q, m);
    {
        popv(1);
        return  CC_reduceTcH(a);
    }
   G1165:
    if(a != LL_ncH) goto    G1167;
    m = car(cdr(cdr(w1)));
    q = car(cdr(w1));
    a = LL_ncH;
    a = Llist3(a, q, m);
    {
        popv(1);
        return  CC_reduceTncH(a);
    }
   G1167:
    if(a != LL_cL) goto    G1169;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1171;
   G1176:
    a = w1;
    goto    G1173;
   G1171:
    a = car(car(cdr(w1)));
    goto    G1178;  /* recursive call to  lfactor */
   G1169:
    a = LITERAL[51];
    a = CC_argerror(a);
   G1173:
    popv(1);
    return a;
}

Sex CC_Arfactor(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1181;
    if(!is_number(a)) goto    G1207;
    goto    G1213;
   G1181:
    a = car(a);
    if(!is_integer(a)) goto    G1185;
    if(a >= value(LL_CratfC)) goto    G1187;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1213;
    a = cdr(car(cdr(cdr(w1))));
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G1191;
    a = car(a);
    if(!is_integer(a)) goto    G1190;
   G1191:
    a = value(LL_Htemporal);
    goto    G1209;
   G1190:
    q = value(LL_Htemporal);
    a = car(w1);
    {
        popv(1);
        return  cons(a, q);
    }
   G1187:
    if(a != value(LL_CratfC)) goto    G1207;
    goto    G1213;
   G1185:
    if(a != LL_cL) goto    G1195;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1197;
   G1213:
    a = mkfxat(1);
    goto    G1209;
   G1197:
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = cdr(a);
    a = cdr(a);
    a = cdr(a);
    if(a != nil) goto    G1198;
    a = cdr(w1);
    goto    G1209;
   G1198:
    a = car(w1);
    a = CC_Arfactor(a);
    q = a;
    a = cdr(w1);
    {
        popv(1);
        return  CC_multH(a, q);
    }
   G1195:
    if(a != LL_cH) goto    G1205;
    q = cdr(cdr(cdr(w1)));
    a = LL_cH;
    a = cons(a, q);
    {
        popv(1);
        return  CC_reduceTcH(a);
    }
   G1205:
    if(a != LL_ncH) goto    G1207;
    q = cdr(cdr(cdr(w1)));
    a = LL_ncH;
    a = cons(a, q);
    {
        popv(1);
        return  CC_reduceTncH(a);
    }
   G1207:
    a = LITERAL[52];
    a = CC_argerror(a);
   G1209:
    popv(1);
    return a;
}

Sex CC_Agetfactor(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
   G1264:
    w1 = a;
    w2 = q;
    if(is_symbol(q)) goto    G1218;
    if(!is_cons(q)) goto    G1234;
    a = q;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1221;
    q = car(cdr(w2));
    goto    G1255;
   G1221:
    a = w2;
    a = CC_Wsinglefunc(a);
    if(a == nil) goto    G1234;
    q = car(car(cdr(w2)));
   G1255:
    a = w1;
    goto    G1264;  /* recursive call to  getfactor */
   G1218:
    if(!is_cons(a)) goto    G1263;
    a = car(a);
    if(!is_integer(a)) goto    G1225;
    if(a >= value(LL_CmaxcanoC)) goto    G1234;
    a = w1;
    {
        popv(5);
        return  CC_getfctrTcano(a, q);
    }
   G1225:
    if(a != LL_cH) goto    G1229;
    q = nil;
    a = w2;
    a = CC_Wcommute(a, q);
    if(a == nil) goto    G1263;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_getfctrTcH(a, q);
    }
   G1229:
    if(a != LL_ncH) goto    G1233;
    a = w1;
    {
        popv(5);
        return  CC_getfctrTncH(a, q);
    }
   G1233:
    if(a != LL_cL) goto    G1234;
    a = w1;
    a = CC_Wmonomial(a);
    w3 = nil;
    if(a == nil) goto    G1236;
    w4 = nil;
    w5 = nil;
    a = car(cdr(w1));
    w5 = a;
    a = car(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
    q = nil;
    a = w2;
    a = CC_Wcommute(a, q);
    if(a != nil) goto    G1239;
    q = LL_ncH;
    a = car(w3);
    a = Lneq(a, q);
    if(a != nil) goto    G1263;
    q = w2;
    a = w3;
    a = CC_getfctrTncH(a, q);
    goto    G1261;
   G1239:
    a = car(w3);
    q = w2;
    if(a != LL_ncH) goto    G1243;
    a = w4;
    a = CC_Agetfactor(a, q);
    w5 = a;
    a = w3;
    w4 = a;
    goto    G1244;
   G1243:
    a = w3;
    a = CC_getfctrTcH(a, q);
   G1261:
    w5 = a;
   G1244:
    a = w5;
    if(a == LL_Anil) goto    G1263;
    q = w4;
#define LL_Hremainder LITERAL[53]
    a = value(LL_Hremainder);
    a = CC_multH(a, q);
    value(LL_Hremainder) = a;
    a = w5;
    goto    G1253;
   G1236:
    a = w1;
    a = CC_monocontTcL(a);
    w3 = a;
    if(is_number(a)) goto    G1263;
    q = w2;
    a = CC_Agetfactor(a, q);
    w3 = a;
    if(a != LL_Anil) goto    G1252;
   G1263:
    a = LL_Anil;
    goto    G1253;
   G1252:
    q = a;
    a = w1;
    a = CC_quotiTpref(a, q);
    value(LL_Hremainder) = a;
    a = w3;
    goto    G1253;
   G1234:
    a = LITERAL[54];
    a = CC_argerror(a);
   G1253:
    popv(5);
    return a;
}

Sex CC_Alpoly(Sex a)
{
    Sex q, m;
    if(is_number(a)) goto    G1268;
    m = car(cdr(cdr(a)));
    q = car(cdr(a));
    a = car(a);
    a = Llist3(a, q, m);
   G1268:
    return a;
}

Sex CC_Arpoly(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_number(a)) goto    G1273;
    a = cdr(cdr(cdr(a)));
    value(LL_Htemporal) = a;
    if(a != nil) goto    G1272;
   G1273:
    a = mkfxat(0);
    goto    G1278;
   G1272:
    a = car(car(a));
    a = Lzerop(a);
    if(a != nil) goto    G1274;
    q = value(LL_Htemporal);
    a = car(cdr(w1));
    a = cons(a, q);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G1274:
    a = cdr(car(value(LL_Htemporal)));
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G1277;
    a = car(a);
    if(!is_integer(a)) goto    G1276;
   G1277:
    a = value(LL_Htemporal);
    goto    G1278;
   G1276:
    q = value(LL_Htemporal);
    a = car(w1);
    a = cons(a, q);
   G1278:
    popv(1);
    return a;
}

Sex CC_Alowpart(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G1282;
    a = mkfxat(1);
    goto    G1284;
   G1282:
    a = cdr(a);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1283;
    a = w1;
    {
        popv(1);
        return  CC_Alowfactor(a);
    }
   G1283:
    a = w1;
    a = CC_Alowterm(a);
   G1284:
    popv(1);
    return a;
}

Sex CC_Alowterm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_number(a)) goto    G1296;
    a = CC_tail(a);
    w1 = a;
    a = car(a);
    a = car(a);
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1289;
   G1296:
    a = mkfxat(0);
    goto    G1295;
   G1289:
    a = cdr(car(w1));
    w1 = a;
    if(is_number(a)) goto    G1294;
    a = car(a);
    if(!is_integer(a)) goto    G1293;
   G1294:
    a = w1;
    goto    G1295;
   G1293:
    a = w1;
    a = CC_Alowterm(a);
   G1295:
    popv(1);
    return a;
}

Sex CC_Alowfactor(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_number(a)) goto    G1307;
    a = cdr(cdr(a));
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G1301;
   G1307:
    a = mkfxat(1);
    goto    G1306;
   G1301:
    a = car(w1);
    w1 = a;
    a = cdr(a);
    if(is_number(a)) goto    G1304;
    a = car(cdr(w1));
    if(!is_integer(a)) goto    G1303;
   G1304:
    a = cdr(w1);
    goto    G1306;
   G1303:
    a = w1;
    a = CC_Alowfactor(a);
   G1306:
    popv(1);
    return a;
}

Sex CC_Anthpart(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_integer(q)) goto    G1350;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1350;
    a = w1;
    if(is_cons(a)) goto    G1313;
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1350;
    a = w1;
    if(!is_number(a)) goto    G1350;
    goto    G1356;
   G1313:
    a = car(a);
    if(!is_integer(a)) goto    G1318;
    if(a >= value(LL_CratfC)) goto    G1320;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1322;
    a = cdr(w1);
    a = CC_WspowTbpol(a);
    if(a != nil) goto    G1322;
    q = w2;
    a = cdr(w1);
    a = CC_nthfctrTbpol(a, q);
    goto    G1324;
   G1322:
    q = w2;
    a = cdr(w1);
    a = CC_nthtermTbpol(a, q);
   G1324:
    w2 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G1326;
    a = w2;
    goto    G1356;
   G1326:
    q = w2;
    a = car(w1);
    {
        popv(2);
        return  cons(a, q);
    }
   G1320:
    if(a != value(LL_CratfC)) goto    G1328;
    a = w2;
    a = Lsub1(a);
    q = a;
    a = cdr(w1);
    a = CC_ncdr(a, q);
    w1 = a;
    if(a != nil) goto    G1330;
    a = mkfxat(0);
    goto    G1356;
   G1330:
    a = car(car(a));
    a = Lonep(a);
    if(a == nil) goto    G1332;
    a = cdr(car(w1));
    goto    G1356;
   G1332:
    q = car(w1);
    a = value(LL_CratfC);
    {
        popv(2);
        return  Llist2(a, q);
    }
   G1328:
    if(a >= value(LL_CmaxformC)) goto    G1350;
    q = car(cdr(cdr(w1)));
    a = w2;
    a = Lleq(a, q);
    if(a == nil) goto    G1353;
    q = w2;
    a = car(cdr(w1));
    {
        popv(2);
        return  Lgetv(a, q);
    }
   G1318:
    q = LL_BctypeB;
    a = Lget(a, q);
    value(LL_Htemporal) = a;
    if(a != LL_rat) goto    G1337;
    q = LL_cL;
    a = car(w1);
    a = Lneq(a, q);
    if(a == nil) goto    G1339;
    q = w2;
    a = w1;
    goto    G1361;
   G1339:
    a = cdr(cdr(w1));
    if(a == nil) goto    G1340;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_Anthterm(a, q);
    }
   G1340:
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = cdr(a);
    a = Llength(a);
    q = mkfxat(2);
    a = quot2(a, q);
    a = Ladd1(a);
    value(LL_Htemporal) = a;
    q = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1341;
    q = w2;
    a = car(w1);
   G1361:
    {
        popv(2);
        return  CC_nthfctrTcH(a, q);
    }
   G1341:
    q = w2;
    a = value(LL_Htemporal);
    a = Lequal(a, q);
    if(a == nil) goto    G1348;
    a = cdr(w1);
    goto    G1356;
   G1348:
    a = mkfxat(1);
    goto    G1356;
   G1337:
    if(a != LL_set) goto    G1350;
    q = LITERAL[10];
    a = car(w1);
    a = Lmemq(a, q);
    if(a == nil) goto    G1350;
    a = w2;
    a = Lsub1(a);
    q = a;
    a = cdr(w1);
    a = CC_ncdr(a, q);
    if(a == nil) goto    G1353;
    a = car(a);
    goto    G1356;
   G1353:
    q = w2;
    a = LITERAL[55];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G1350:
    a = LITERAL[56];
    a = CC_argerror(a);
   G1356:
    popv(2);
    return a;
}

Sex CC_Anthterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_integer(q)) goto    G1398;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1398;
    a = w1;
    if(is_cons(a)) goto    G1367;
    if(!is_number(a)) goto    G1398;
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1400;
    goto    G1411;
   G1367:
    a = car(a);
    if(!is_integer(a)) goto    G1374;
    if(a >= value(LL_CratfC)) goto    G1376;
    q = w2;
    a = cdr(w1);
    a = CC_nthtermTbpol(a, q);
    w2 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G1378;
    a = w2;
    goto    G1402;
   G1378:
    q = w2;
    a = car(w1);
    {
        popv(2);
        return  cons(a, q);
    }
   G1376:
    if(a != value(LL_CratfC)) goto    G1381;
    a = w2;
    a = Lsub1(a);
    q = a;
    a = cdr(w1);
    a = CC_ncdr(a, q);
    w1 = a;
    if(a == nil) goto    G1400;
    a = car(car(a));
    a = Lonep(a);
    if(a == nil) goto    G1385;
    a = cdr(car(w1));
    goto    G1402;
   G1385:
    q = car(w1);
    a = value(LL_CratfC);
    goto    G1408;
   G1381:
    if(a >= value(LL_CmaxformC)) goto    G1398;
    q = car(cdr(cdr(w1)));
    a = w2;
    a = Lleq(a, q);
    if(a == nil) goto    G1388;
    q = w2;
    a = car(cdr(w1));
    {
        popv(2);
        return  Lgetv(a, q);
    }
   G1388:
    q = w2;
    a = LITERAL[57];
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G1374:
    if(a != LL_cL) goto    G1390;
    a = w2;
    a = Lsub1(a);
    q = a;
    a = cdr(w1);
    a = CC_ncdr(a, q);
    w1 = a;
    if(a == nil) goto    G1400;
    a = car(a);
    w1 = a;
    if(is_number(a)) goto    G1411;
    a = car(a);
    if(is_integer(a)) goto    G1411;
    a = cdr(w1);
    a = Lonep(a);
    if(a == nil) goto    G1396;
    a = car(w1);
    goto    G1402;
   G1396:
    q = w1;
    a = LL_cL;
   G1408:
    {
        popv(2);
        return  Llist2(a, q);
    }
   G1390:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1398;
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1400;
   G1411:
    a = w1;
    goto    G1402;
   G1400:
    a = mkfxat(0);
    goto    G1402;
   G1398:
    a = LITERAL[58];
    a = CC_argerror(a);
   G1402:
    popv(2);
    return a;
}

Sex CC_Anthfactor(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_integer(q)) goto    G1455;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1455;
    a = w1;
    if(is_cons(a)) goto    G1417;
    if(!is_number(a)) goto    G1455;
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1453;
    goto    G1463;
   G1417:
    a = car(a);
    if(!is_integer(a)) goto    G1424;
    if(a >= value(LL_CratfC)) goto    G1426;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1428;
    q = w2;
    a = cdr(w1);
    a = CC_nthfctrTbpol(a, q);
    w2 = a;
    if(is_number(a)) goto    G1431;
    a = car(a);
    if(!is_integer(a)) goto    G1430;
   G1431:
    a = w2;
    goto    G1456;
   G1430:
    q = w2;
    a = car(w1);
    {
        popv(2);
        return  cons(a, q);
    }
   G1428:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1453;
    goto    G1463;
   G1426:
    if(a != value(LL_CratfC)) goto    G1455;
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1453;
    goto    G1463;
   G1424:
    if(a != LL_cL) goto    G1440;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1442;
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1453;
   G1463:
    a = w1;
    goto    G1456;
   G1442:
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = cdr(a);
    a = Llength(a);
    q = mkfxat(2);
    a = quot2(a, q);
    a = Ladd1(a);
    value(LL_Htemporal) = a;
    q = w2;
    a = Lgreaterp(a, q);
    q = w2;
    if(a == nil) goto    G1446;
    a = car(w1);
    goto    G1467;
   G1446:
    a = value(LL_Htemporal);
    a = Lequal(a, q);
    if(a == nil) goto    G1453;
    a = cdr(w1);
    goto    G1456;
   G1453:
    a = mkfxat(1);
    goto    G1456;
   G1440:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1455;
    q = w2;
    a = w1;
   G1467:
    {
        popv(2);
        return  CC_nthfctrTcH(a, q);
    }
   G1455:
    a = LITERAL[59];
    a = CC_argerror(a);
   G1456:
    popv(2);
    return a;
}

Sex CC_Alastterm(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G1471;
    if(is_number(a)) goto    G1487;
    a = LITERAL[60];
    {
        popv(2);
        return  CC_argerror(a);
    }
   G1471:
    a = car(a);
    if(!is_integer(a)) goto    G1475;
    if(a >= value(LL_CratfC)) goto    G1477;
    w2 = nil;
    a = w1;
    a = Llast(a);
    w2 = a;
    a = car(a);
    a = Lplusp(a);
    if(a == nil) goto    G1480;
    m = w2;
    q = car(cdr(w1));
    a = car(w1);
    {
        popv(2);
        return  Llist3(a, q, m);
    }
   G1480:
    a = cdr(w2);
    w2 = a;
    if(is_number(a)) goto    G1482;
    a = car(a);
    if(!is_integer(a)) goto    G1481;
   G1482:
    a = w2;
    goto    G1487;
   G1481:
    q = w2;
    a = car(w1);
    {
        popv(2);
        return  cons(a, q);
    }
   G1477:
    a = w1;
    a = Llast(a);
    q = value(LL_CratfC);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G1475:
    q = LITERAL[60];
    a = LITERAL[61];
    a = CC_errormsg(a, q);
   G1487:
    popv(2);
    return a;
}

Sex CC_Atermfromto(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = CC_Wpol3(a);
    if(a != nil) goto    G1491;
    q = LITERAL[62];
    a = mkfxat(8);
    goto    G1508;
   G1491:
    a = w2;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1494;
    a = true;
    goto    G1495;
   G1494:
    a = w2;
    a = CC_Avar2expr(a);
    w2 = a;
   G1495:
    if(a != nil) goto    G1492;
    q = LITERAL[62];
    a = LITERAL[63];
    goto    G1508;
   G1492:
    a = car(w1);
    if(a == car(w2)) goto    G1496;
    q = LITERAL[62];
    a = LITERAL[14];
    goto    G1508;
   G1496:
    a = w3;
    if(is_integer(a)) goto    G1499;
    if(!is_rational(a)) goto    G1498;
   G1499:
    a = w4;
    if(is_integer(a)) goto    G1500;
    if(!is_rational(a)) goto    G1498;
   G1500:
    q = mkfxat(0);
    a = w3;
    a = Lgeq(a, q);
    if(a == nil) goto    G1498;
    q = w3;
    a = w4;
    a = Lgeq(a, q);
    if(a != nil) goto    G1497;
   G1498:
    q = LITERAL[62];
    a = LITERAL[64];
   G1508:
    {
        popv(4);
        return  CC_errormsg(a, q);
    }
   G1497:
    q = car(cdr(w2));
    a = car(cdr(w1));
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G1501;
    a = w3;
    a = Lzerop(a);
    if(a == nil) goto    G1503;
    a = w1;
    goto    G1505;
   G1503:
    a = mkfxat(0);
    goto    G1505;
   G1501:
    arg4 = w4;
    m = w3;
    q = car(cdr(w2));
    a = w1;
    a = CC_termfromtoH(a, q, m, arg4);
   G1505:
    popv(4);
    return a;
}

Sex CC_termfromtoH(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    arg6 = a;
    arg5 = nil;
    arg4 = w4;
    m = w3;
    q = w2;
    a = cdr(w1);
    CC_termfrtoTbpol(a, q, m, arg4, arg5, arg6);
    a = cdr(w5);
    if(a == nil) goto    G1515;
    w5 = a;
    a = car(a);
    goto    G1524;
   G1515:
    a = mkfxat(0);
    goto    G1511;
   G1517:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G1513;
    q = w6;
    a = car(a);
    a = CC_seLbpolbpol(a, q);
   G1524:
    w6 = a;
    goto    G1517;
   G1513:
    a = w6;
    a = CC_reduceTbpol(a);
    w6 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G1521;
    a = w6;
    goto    G1511;
   G1521:
    q = w6;
    a = car(w1);
    a = cons(a, q);
   G1511:
    popv(6);
    return a;
}

Sex CC_Adenom(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1528;
    if(!is_number(a)) goto    G1533;
    if(!is_rational(a)) goto    G1542;
    {
        popv(1);
        return  Lden(a);
    }
   G1528:
    a = car(a);
    if(!is_integer(a)) goto    G1533;
    if(a >= value(LL_CmaxcanoC)) goto    G1533;
    if(a < value(LL_CratfC)) goto    G1542;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1537;
   G1542:
    a = mkfxat(1);
    goto    G1539;
   G1537:
    a = car(car(cdr(w1)));
    goto    G1539;
   G1533:
    a = LITERAL[65];
    a = CC_argerror(a);
   G1539:
    popv(1);
    return a;
}

Sex CC_Anumer(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1546;
    if(!is_number(a)) goto    G1551;
    if(!is_rational(a)) goto    G1557;
    {
        popv(1);
        return  Lnum(a);
    }
   G1546:
    a = car(a);
    if(!is_integer(a)) goto    G1551;
    if(a >= value(LL_CmaxcanoC)) goto    G1551;
    if(a < value(LL_CratfC)) goto    G1559;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1555;
   G1559:
    a = w1;
    goto    G1557;
   G1555:
    a = cdr(car(cdr(w1)));
    goto    G1557;
   G1551:
    a = LITERAL[66];
    a = CC_argerror(a);
   G1557:
    popv(1);
    return a;
}

Sex CC_Apolypart(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1563;
    if(!is_number(a)) goto    G1567;
    goto    G1575;
   G1563:
    a = car(a);
    if(!is_integer(a)) goto    G1567;
    if(a >= value(LL_CmaxcanoC)) goto    G1567;
    if(a >= value(LL_CratfC)) goto    G1570;
    a = w1;
    goto    G1575;
   G1570:
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G1571;
    a = cdr(w1);
    goto    G1575;
   G1571:
    a = mkfxat(0);
    goto    G1575;
   G1567:
    a = LITERAL[67];
    a = CC_argerror(a);
   G1575:
    popv(1);
    return a;
}

Sex CC_Aratiopart(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1580;
    if(!is_number(a)) goto    G1584;
    goto    G1591;
   G1580:
    a = car(a);
    if(!is_integer(a)) goto    G1584;
    if(a >= value(LL_CmaxcanoC)) goto    G1584;
    if(a >= value(LL_CratfC)) goto    G1587;
   G1591:
    a = mkfxat(0);
    goto    G1590;
   G1587:
    a = car(car(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G1588;
    q = cdr(cdr(w1));
    a = value(LL_CratfC);
    {
        popv(1);
        return  cons(a, q);
    }
   G1588:
    a = w1;
    goto    G1590;
   G1584:
    a = LITERAL[68];
    a = CC_argerror(a);
   G1590:
    popv(1);
    return a;
}

Sex CC_Alratio(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1596;
    if(!is_number(a)) goto    G1600;
    goto    G1610;
   G1596:
    a = car(a);
    if(!is_integer(a)) goto    G1600;
    if(a >= value(LL_CmaxcanoC)) goto    G1600;
    if(a >= value(LL_CratfC)) goto    G1603;
   G1610:
    a = mkfxat(0);
    goto    G1609;
   G1603:
    a = car(car(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G1606;
    a = car(cdr(cdr(w1)));
    goto    G1607;
   G1606:
    a = car(cdr(w1));
   G1607:
    q = a;
    a = value(LL_CratfC);
    {
        popv(1);
        return  Llist2(a, q);
    }
   G1600:
    a = LITERAL[69];
    a = CC_argerror(a);
   G1609:
    popv(1);
    return a;
}

Sex CC_Arratio(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1615;
    if(!is_number(a)) goto    G1619;
    goto    G1633;
   G1615:
    a = car(a);
    if(!is_integer(a)) goto    G1619;
    if(a >= value(LL_CmaxcanoC)) goto    G1619;
    if(a < value(LL_CratfC)) goto    G1633;
    a = car(car(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G1625;
    a = cdr(cdr(w1));
    goto    G1626;
   G1625:
    a = cdr(w1);
   G1626:
    a = cdr(a);
    if(a != nil) goto    G1628;
   G1633:
    a = mkfxat(0);
    goto    G1630;
   G1628:
    q = value(LL_CratfC);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G1619:
    a = LITERAL[70];
    a = CC_argerror(a);
   G1630:
    popv(1);
    return a;
}

Sex CC_Aldenom(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1637;
    if(is_number(a)) goto    G1639;
    a = LITERAL[70];
    goto    G1653;
   G1639:
    if(!is_rational(a)) goto    G1654;
    {
        popv(1);
        return  Lden(a);
    }
   G1637:
    a = car(a);
    if(!is_integer(a)) goto    G1642;
    if(a >= value(LL_CmaxcanoC)) goto    G1642;
    if(a >= value(LL_CratfC)) goto    G1645;
   G1654:
    a = mkfxat(1);
    goto    G1652;
   G1645:
    a = car(car(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G1648;
    a = cdr(cdr(w1));
    goto    G1649;
   G1648:
    a = cdr(w1);
   G1649:
    a = car(a);
    {
        popv(1);
        return car(a);
    }
   G1642:
    a = LITERAL[71];
   G1653:
    a = CC_argerror(a);
   G1652:
    popv(1);
    return a;
}

Sex CC_Alnumer(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1658;
    if(is_number(a)) goto    G1660;
    a = LITERAL[70];
    goto    G1674;
   G1660:
    if(!is_rational(a)) goto    G1675;
    {
        popv(1);
        return  Lnum(a);
    }
   G1658:
    a = car(a);
    if(!is_integer(a)) goto    G1663;
    if(a >= value(LL_CmaxcanoC)) goto    G1663;
    if(a >= value(LL_CratfC)) goto    G1666;
   G1675:
    a = mkfxat(0);
    goto    G1673;
   G1666:
    a = car(car(cdr(w1)));
    a = Lonep(a);
    if(a == nil) goto    G1669;
    a = cdr(cdr(w1));
    goto    G1670;
   G1669:
    a = cdr(w1);
   G1670:
    a = car(a);
    {
        popv(1);
        return cdr(a);
    }
   G1663:
    a = LITERAL[72];
   G1674:
    a = CC_argerror(a);
   G1673:
    popv(1);
    return a;
}

Sex CC_Anumpart(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1679;
    if(!is_number(a)) goto    G1704;
    goto    G1705;
   G1679:
    a = car(a);
    if(!is_integer(a)) goto    G1683;
    if(a >= value(LL_CratfC)) goto    G1685;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1687;
    a = cdr(w1);
    {
        popv(1);
        return  CC_nfctrTbpol(a);
    }
   G1687:
    a = cdr(w1);
    goto    G1695;
   G1685:
    a = w1;
    a = CC_Wstruct(a);
    if(a != nil) goto    G1704;
    a = cdr(cdr(w1));
    if(a == nil) goto    G1690;
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G1702;
    a = car(cdr(w1));
    if(is_number(a)) goto    G1705;
   G1695:
    {
        popv(1);
        return  CC_ntermTbpol(a);
    }
   G1690:
    a = w1;
    {
        popv(1);
        return  CC_numfctrTratf(a);
    }
   G1683:
    if(a != LL_cL) goto    G1698;
    a = cdr(cdr(w1));
    if(a != nil) goto    G1700;
    a = cdr(car(cdr(w1)));
    goto    G1705;
   G1700:
    a = car(cdr(w1));
    w1 = a;
    if(is_number(a)) goto    G1705;
    a = car(a);
    if(!is_integer(a)) goto    G1702;
    a = w1;
    {
        popv(1);
        return  CC_Anumterm(a);
    }
   G1702:
    a = mkfxat(0);
    goto    G1705;
   G1698:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1704;
    a = mkfxat(1);
    goto    G1705;
   G1704:
    a = LITERAL[73];
    a = CC_argerror(a);
   G1705:
    popv(1);
    return a;
}

Sex CC_Anumterm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
   G1739:
    w1 = a;
    if(is_cons(a)) goto    G1713;
    if(!is_number(a)) goto    G1732;
    goto    G1733;
   G1713:
    a = car(a);
    if(!is_integer(a)) goto    G1717;
    if(a >= value(LL_CratfC)) goto    G1719;
    a = cdr(w1);
    goto    G1724;
   G1719:
    a = w1;
    a = CC_Wstruct(a);
    if(a != nil) goto    G1732;
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G1738;
    a = car(cdr(w1));
    if(is_number(a)) goto    G1733;
   G1724:
    {
        popv(1);
        return  CC_ntermTbpol(a);
    }
   G1717:
    if(a != LL_cL) goto    G1726;
    a = cdr(cdr(w1));
    if(a != nil) goto    G1728;
    a = cdr(car(cdr(w1)));
    goto    G1733;
   G1728:
    a = car(cdr(w1));
    w1 = a;
    if(is_number(a)) goto    G1733;
    a = car(a);
    if(!is_integer(a)) goto    G1738;
    a = w1;
    goto    G1739;  /* recursive call to  numterm */
   G1726:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1732;
   G1738:
    a = mkfxat(0);
    goto    G1733;
   G1732:
    a = LITERAL[74];
    a = CC_argerror(a);
   G1733:
    popv(1);
    return a;
}

Sex CC_Aconstterm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G1742;
    if(!is_number(a)) goto    G1785;
    goto    G1786;
   G1742:
    a = car(a);
    if(!is_integer(a)) goto    G1746;
    if(a >= value(LL_CratfC)) goto    G1748;
    a = cdr(w1);
    a = CC_cnstermTbpol(a);
    w1 = a;
    if(is_number(a)) goto    G1788;
    a = car(a);
    if(is_integer(a)) goto    G1788;
    q = w1;
    a = value(LL_CpolyC);
    {
        popv(4);
        return  cons(a, q);
    }
   G1748:
    a = w1;
    a = CC_Wstruct(a);
    if(a != nil) goto    G1785;
    a = w1;
    {
        popv(4);
        return  CC_consttermTratf(a);
    }
   G1746:
    if(a != LL_cL) goto    G1755;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = cdr(w1);
    w1 = a;
    a = car(a);
    if(is_number(a)) goto    G1761;
    a = LL_cL;
    a = Lncons(a);
    w2 = a;
    goto    G1762;
   G1761:
    q = a;
    a = LL_cL;
    a = Llist2(a, q);
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G1762:
    a = car(car(w1));
    if(!is_integer(a)) goto    G1791;
    a = car(w1);
    a = CC_Aconstterm(a);
    w4 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1768;
    a = w4;
    q = w2;
    if(!is_number(a)) goto    G1767;
    CC_seTaddTbnumcL(a, q);
    goto    G1768;
   G1767:
    CC_seTaddTcanocL(a, q);
   G1768:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G1779;
    goto    G1762;
   G1791:
    a = w2;
    a = CC_tail(a);
    w3 = a;
   G1771:
    a = car(car(w1));
    w4 = a;
    a = car(a);
    if(a == LL_ncH) goto    G1775;
    a = w4;
    a = CC_WconstTcH(a);
    if(a == nil) goto    G1775;
    a = car(w1);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
   G1775:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1771;
   G1779:
    a = w2;
    {
        popv(4);
        return  CC_reduceTcL(a);
    }
   G1755:
    if(a != LL_cH) goto    G1781;
    a = w1;
    a = CC_WconstTcH(a);
    if(a == nil) goto    G1790;
   G1788:
    a = w1;
    goto    G1786;
   G1781:
    if(a != LL_ncH) goto    G1785;
   G1790:
    a = mkfxat(0);
    goto    G1786;
   G1785:
    a = LITERAL[75];
    a = CC_argerror(a);
   G1786:
    popv(4);
    return a;
}

Sex CC_Anumfactor(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1795;
    if(!is_number(a)) goto    G1811;
    goto    G1812;
   G1795:
    a = car(a);
    if(!is_integer(a)) goto    G1799;
    if(a >= value(LL_CratfC)) goto    G1801;
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a == nil) goto    G1816;
    a = cdr(w1);
    {
        popv(1);
        return  CC_nfctrTbpol(a);
    }
   G1801:
    a = w1;
    a = CC_Wstruct(a);
    if(a != nil) goto    G1811;
    a = w1;
    {
        popv(1);
        return  CC_numfctrTratf(a);
    }
   G1799:
    if(a != LL_cL) goto    G1807;
    a = cdr(cdr(w1));
    if(a != nil) goto    G1816;
    a = cdr(car(cdr(w1)));
    goto    G1812;
   G1807:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1811;
   G1816:
    a = mkfxat(1);
    goto    G1812;
   G1811:
    a = LITERAL[76];
    a = CC_argerror(a);
   G1812:
    popv(1);
    return a;
}

Sex CC_Anumcont(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1820;
    if(!is_number(a)) goto    G1829;
    {
        popv(1);
        return  Labs(a);
    }
   G1820:
    a = car(a);
    if(!is_integer(a)) goto    G1824;
    if(a >= value(LL_CratfC)) goto    G1826;
    q = cdr(w1);
    a = mkfxat(0);
    {
        popv(1);
        return  CC_ncontTbpol(a, q);
    }
   G1826:
    a = w1;
    {
        popv(1);
        return  CC_numcontTratf(a);
    }
   G1824:
    if(a != LL_cL) goto    G1828;
    a = w1;
    {
        popv(1);
        return  CC_numcontTcL(a);
    }
   G1828:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1829;
    a = mkfxat(1);
    goto    G1830;
   G1829:
    q = LITERAL[77];
    a = mkfxat(3);
    a = CC_errormsg(a, q);
   G1830:
    popv(1);
    return a;
}

Sex CC_Amonocont(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1835;
    if(!is_number(a)) goto    G1845;
    {
        popv(1);
        return  Labs(a);
    }
   G1835:
    a = car(a);
    if(!is_integer(a)) goto    G1839;
    if(a >= value(LL_CratfC)) goto    G1841;
    a = w1;
    {
        popv(1);
        return  CC_monocontTpol3(a);
    }
   G1841:
    if(a != value(LL_CratfC)) goto    G1845;
    a = w1;
    {
        popv(1);
        return  CC_monocontTratf(a);
    }
   G1839:
    if(a != LL_cL) goto    G1844;
    a = w1;
    {
        popv(1);
        return  CC_monocontTcL(a);
    }
   G1844:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G1845;
    a = w1;
    goto    G1846;
   G1845:
    q = LITERAL[78];
    a = mkfxat(3);
    a = CC_errormsg(a, q);
   G1846:
    popv(1);
    return a;
}

Sex CC_Avarlist(Sex a)
{
    Sex q;
    if(!is_number(a)) goto    G1852;
    a = LL_Anil;
    goto    G1853;
   G1852:
    a = CC_varlistH(a);
#define LL_Bset LITERAL[79]
    q = LL_Bset;
    a = Lxcons(a, q);
   G1853:
    return a;
}

Sex CC_varlistH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = LL_var;
    a = Lncons(a);
    q = a;
    a = cdr(w1);
    a = CC_varsTbpol(a, q);
    {
        popv(1);
        return cdr(a);
    }
}

Sex CC_Abase(Sex a)
{
    a = CC_basexptT(a);
    {
        return car(a);
    }
}

Sex CC_Aexponent(Sex a)
{
    a = CC_basexptT(a);
    {
        return cdr(a);
    }
}

Sex CC_Acomexpt(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(is_cons(a)) goto    G1868;
    if(!is_number(a)) goto    G1894;
    goto    G1903;
   G1868:
    a = car(a);
    if(!is_integer(a)) goto    G1872;
    if(a >= value(LL_CratfC)) goto    G1874;
    a = cdr(w1);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G1903;
    a = cdr(w1);
    {
        popv(1);
        return  CC_comexptTbpol(a);
    }
   G1874:
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    if(a == nil) goto    G1894;
    a = cdr(cdr(w1));
    if(a != nil) goto    G1903;
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    if(is_number(a)) goto    G1903;
    a = car(cdr(w1));
    if(is_number(a)) goto    G1903;
    a = cdr(car(w1));
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G1903;
    a = cdr(car(cdr(w1)));
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G1903;
    a = cdr(car(w1));
    a = CC_comexptTbpol(a);
    value(LL_Htemporal) = a;
    a = Lonep(a);
    if(a != nil) goto    G1903;
    a = cdr(car(cdr(w1)));
    a = CC_comexptTbpol(a);
    q = a;
    a = value(LL_Htemporal);
    {
        popv(1);
        return  gcd(a, q);
    }
   G1872:
    if(a != LL_cH) goto    G1889;
    a = w1;
    {
        popv(1);
        return  CC_comexptTcH(a);
    }
   G1889:
    if(a != LL_ncH) goto    G1890;
    a = cdr(cdr(cdr(w1)));
    if(a != nil) goto    G1903;
    a = car(cdr(cdr(w1)));
    goto    G1895;
   G1890:
    if(a != LL_cL) goto    G1894;
   G1903:
    a = mkfxat(1);
    goto    G1895;
   G1894:
    q = LITERAL[80];
    a = mkfxat(3);
    a = CC_errormsg(a, q);
   G1895:
    popv(1);
    return a;
}

Sex CC_Acombase(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
   G1930:
    w1 = a;
    a = q;
    if(a != nil) goto    G1907;
    w2 = q;
    a = w1;
    a = CC_Acomexpt(a);
    q = a;
    a = w1;
    goto    G1930;  /* recursive call to  combase */
   G1907:
    w2 = q;
    a = Lonep(a);
    if(a != nil) goto    G1928;
    a = w1;
    if(is_number(a)) goto    G1928;
    a = car(a);
    if(!is_integer(a)) goto    G1911;
    if(a >= value(LL_CratfC)) goto    G1913;
    q = w2;
    a = cdr(w1);
    a = CC_combaseTbpol(a, q);
    q = car(w1);
    {
        popv(3);
        return  Lxcons(a, q);
    }
   G1913:
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    if(a == nil) goto    G1926;
    w3 = nil;
    a = car(cdr(w1));
    w1 = a;
    q = w2;
    a = cdr(car(a));
    a = CC_combaseTbpol(a, q);
    q = car(car(w1));
    a = Lxcons(a, q);
    w3 = a;
    q = w2;
    a = cdr(car(cdr(w1)));
    a = CC_combaseTbpol(a, q);
    q = car(car(cdr(w1)));
    a = Lxcons(a, q);
    w1 = a;
    q = cdr(w3);
    a = cons(a, q);
    q = w3;
    a = Lxcons(a, q);
    q = a;
    a = value(LL_CratfC);
    {
        popv(3);
        return  Llist2(a, q);
    }
   G1911:
    if(a != LL_cH) goto    G1924;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_combaseTcH(a, q);
    }
   G1924:
    if(a != LL_ncH) goto    G1925;
    m = mkfxat(1);
    q = car(cdr(w1));
    a = LL_ncH;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
   G1925:
    if(a != LL_cL) goto    G1926;
   G1928:
    a = w1;
    goto    G1927;
   G1926:
    q = LITERAL[81];
    a = mkfxat(3);
    a = CC_errormsg(a, q);
   G1927:
    popv(3);
    return a;
}

Sex CC_vdegTbpol(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w1 = a;
    a = cdr(a);
    w4 = a;
    w2 = q;
    w3 = m;
   G1933:
    a = cdr(car(w4));
    w5 = a;
    if(is_number(a)) goto    G1940;
    a = car(a);
    if(!is_integer(a)) goto    G1937;
    q = w2;
    a = w5;
    a = CC_Avdeg(a, q);
    q = a;
    goto    G1943;
   G1937:
    q = a;
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G1939;
    q = car(car(cdr(w5)));
   G1943:
    a = w3;
    a = Lmax2(a, q);
    goto    G1944;
   G1939:
    m = w3;
    q = w2;
    a = w5;
    a = CC_vdegTbpol(a, q, m);
   G1944:
    w3 = a;
   G1940:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1933;
    a = w3;
    popv(5);
    return a;
}

Sex CC_ltermTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = car(cdr(a));
    w2 = a;
    a = cdr(a);
    if(is_number(a)) goto    G1951;
    a = car(a);
    if(is_integer(a)) goto    G1951;
    a = cdr(w2);
    a = CC_ltermTbpol(a);
    q = car(w2);
    a = Lxcons(a, q);
    w2 = a;
   G1951:
    q = w2;
    a = car(w1);
    {
        popv(2);
        return  Llist2(a, q);
    }
}

Sex CC_lfctrTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = mkfxat(1);
    a = car(car(cdr(a)));
    a = cons(a, q);
    q = a;
    a = car(w1);
    {
        popv(1);
        return  Llist2(a, q);
    }
}

Sex CC_rtermTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = cdr(car(cdr(a)));
    w2 = a;
    if(is_number(a)) goto    G1963;
    a = car(a);
    if(is_integer(a)) goto    G1963;
    a = w2;
    a = CC_rtermTbpol(a);
    w2 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1963;
    q = w2;
    a = car(car(cdr(w1)));
    a = cons(a, q);
    q = cdr(cdr(w1));
    a = cons(a, q);
    q = car(w1);
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G1963:
    a = cdr(cdr(w1));
    w2 = a;
    if(a != nil) goto    G1969;
    a = mkfxat(0);
    goto    G1959;
   G1969:
    a = car(car(a));
    a = Lzerop(a);
    if(a == nil) goto    G1970;
    a = cdr(car(w2));
    goto    G1959;
   G1970:
    q = w2;
    a = car(w1);
    a = cons(a, q);
   G1959:
    popv(2);
    return a;
}

Sex CC_nthtermTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
   G1976:
    a = cdr(car(w3));
    w4 = a;
    if(is_number(a)) goto    G1979;
    a = car(a);
    if(!is_integer(a)) goto    G1978;
   G1979:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G1981;
    q = car(w3);
    goto    G1994;
   G1981:
    a = w2;
    a = Lsub1(a);
    goto    G1995;
   G1978:
    a = w4;
    a = CC_termsTbpol(a);
    w5 = a;
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G1996;
    q = w2;
    a = w4;
    a = CC_nthtermTbpol(a, q);
    q = car(car(w3));
    a = Lxcons(a, q);
    q = a;
   G1994:
    a = car(w1);
    {
        popv(5);
        return  Llist2(a, q);
    }
   G1996:
    a = w5;
    a = Lminus(a);
    q = a;
    a = w2;
    a = plus2(a, q);
   G1995:
    w2 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1976;
    a = mkfxat(0);
    popv(5);
    return a;
}

Sex CC_nthfctrTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G2000;
    q = mkfxat(1);
    a = car(car(cdr(w1)));
    a = cons(a, q);
    q = a;
    a = car(w1);
    {
        popv(2);
        return  Llist2(a, q);
    }
   G2000:
    a = cdr(car(cdr(w1)));
    w1 = a;
    if(is_number(a)) goto    G2003;
    a = car(a);
    if(!is_integer(a)) goto    G2002;
   G2003:
    q = mkfxat(2);
    a = w2;
    a = Leqn(a, q);
    if(a == nil) goto    G2005;
    a = w1;
    goto    G2007;
   G2005:
    a = mkfxat(1);
    goto    G2007;
   G2002:
    a = w2;
    a = Lsub1(a);
    q = a;
    a = w1;
    a = CC_nthfctrTbpol(a, q);
   G2007:
    popv(2);
    return a;
}

Sex CC_nthfctrTcH(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = q;
    a = Lsub1(a);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    q = a;
    a = cdr(w1);
    a = CC_ncdr(a, q);
    w2 = a;
    if(a != nil) goto    G2012;
    a = mkfxat(1);
    goto    G2017;
   G2012:
    a = car(w1);
    if(a != LL_cH) goto    G2015;
    m = car(cdr(w2));
    q = car(w2);
    a = LL_cH;
    a = Llist3(a, q, m);
    {
        popv(2);
        return  CC_reduceTcH(a);
    }
   G2015:
    m = car(cdr(w2));
    q = car(w2);
    a = LL_ncH;
    a = Llist3(a, q, m);
    a = CC_reduceTncH(a);
   G2017:
    popv(2);
    return a;
}

Sex CC_ntermTbpol(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    a = CC_tail(a);
    w1 = a;
    a = car(a);
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2022;
    a = mkfxat(0);
    goto    G2027;
   G2022:
    a = cdr(car(w1));
    w1 = a;
    if(is_number(a)) goto    G2027;
    a = car(a);
    if(!is_integer(a)) goto    G2029;
    a = cdr(w1);
    goto    G2030;
   G2029:
    a = w1;
   G2030:
    a = CC_ntermTbpol(a);
   G2027:
    popv(1);
    return a;
}

Sex CC_nfctrTbpol(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    a = cdr(car(cdr(a)));
    w1 = a;
    if(is_number(a)) goto    G2038;
    a = car(a);
    if(is_integer(a)) goto    G2036;
    a = w1;
    goto    G2039;
   G2036:
    a = cdr(w1);
    a = CC_WstermTbpol(a);
    if(a != nil) goto    G2037;
    a = mkfxat(1);
    goto    G2038;
   G2037:
    a = cdr(w1);
   G2039:
    a = CC_nfctrTbpol(a);
   G2038:
    popv(1);
    return a;
}

Sex CC_termfrtoTbpol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    q = car(a);
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G2043;
    q = car(car(cdr(w1)));
    a = w3;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2086;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = cdr(w1);
    w7 = a;
   G2048:
    q = w4;
    a = car(car(w7));
    a = Lleq(a, q);
    if(a != nil) goto    G2088;
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G2069;
    goto    G2048;
   G2088:
    a = w2;
    a = Lncons(a);
    w9 = a;
    w8 = a;
   G2054:
    q = car(car(w7));
    a = w3;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2060;
    a = car(w7);
    a = Lncons(a);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(a);
    w9 = a;
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G2054;
   G2060:
    a = cdr(w8);
    if(a == nil) goto    G2069;
    q = w8;
    a = w5;
    a = CC_termfrtoTmktm(a, q);
    w8 = a;
    q = cdr(w6);
    a = cons(a, q);
    q = a;
    a = w6;
    cdr(a) = q;
   G2086:
    a = nil;
    goto    G2069;
   G2043:
    q = car(w1);
    a = w2;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2064;
    a = w3;
    a = Lzerop(a);
    if(a == nil) goto    G2069;
    q = w1;
    a = w5;
    a = CC_termfrtoTmktm(a, q);
    w1 = a;
    q = cdr(w6);
    a = cons(a, q);
    q = a;
    a = w6;
    {
        popv(10);
        cdr(a) = q;
 return a;
    }
   G2064:
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    a = car(w1);
    w8 = a;
    a = cdr(w1);
    w7 = a;
   G2071:
    a = cdr(car(w7));
    w9 = a;
    if(is_number(a)) goto    G2075;
    a = car(a);
    if(!is_integer(a)) goto    G2074;
   G2075:
    a = w3;
    a = Lzerop(a);
    if(a == nil) goto    G2072;
    q = car(w7);
    a = w8;
    a = Llist2(a, q);
    q = a;
    a = w5;
    a = CC_termfrtoTmktm(a, q);
    w10 = a;
    q = cdr(w6);
    a = cons(a, q);
    q = a;
    a = w6;
    cdr(a) = q;
    goto    G2072;
   G2074:
    a = car(car(w7));
    a = Lzerop(a);
    if(a == nil) goto    G2081;
    a = w5;
    goto    G2087;
   G2081:
    q = car(car(w7));
    a = w8;
    a = cons(a, q);
    q = w5;
    a = cons(a, q);
   G2087:
    w10 = a;
    arg6 = w6;
    arg5 = w10;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w9;
    CC_termfrtoTbpol(a, q, m, arg4, arg5, arg6);
   G2072:
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G2071;
   G2069:
    popv(10);
    return a;
}

Sex CC_termfrtoTmktm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(a != nil) goto    G2092;
    a = q;
    goto    G2093;
   G2092:
    w1 = a;
    a = cdr(car(a));
    a = cons(a, q);
    q = a;
    a = car(car(w1));
    a = Llist2(a, q);
    q = a;
    a = cdr(w1);
    a = CC_termfrtoTmktm(a, q);
   G2093:
    popv(1);
    return a;
}

Sex CC_varsTbpol(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
   G2099:
    a = cdr(car(w3));
    w4 = a;
    if(is_number(a)) goto    G2103;
    a = car(a);
    if(is_integer(a)) goto    G2103;
    q = w2;
    a = w4;
    CC_varsTbpol(a, q);
   G2103:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G2099;
#define LL_WorderTvar LITERAL[82]
    m = LL_WorderTvar;
    q = w2;
    a = car(w1);
    CC_seTinsert(a, q, m);
    a = w2;
    popv(4);
    return a;
}

Sex CC_emxmnTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
   G2133:
    w1 = a;
    w2 = q;
    q = car(car(q));
    a = car(a);
    a = Lequal(a, q);
    if(a != nil) goto    G2109;
    q = mkfxat(0);
    a = cdr(cdr(car(w2)));
    car(a) = q;
    q = cdr(w2);
    a = w1;
    goto    G2133;  /* recursive call to emxmn:bpol */
   G2109:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = cdr(w1);
    w3 = a;
    q = car(cdr(car(w2)));
    a = car(car(a));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2117;
    q = car(car(w3));
    a = cdr(car(w2));
    car(a) = q;
   G2117:
    a = cdr(car(w3));
    w5 = a;
    if(is_number(a)) goto    G2120;
    a = car(a);
    if(!is_integer(a)) goto    G2119;
   G2120:
    a = cdr(w2);
    goto    G2132;
   G2119:
    q = cdr(w2);
    a = w5;
    CC_emxmnTbpol(a, q);
   G2124:
    a = cdr(w3);
    if(a == nil) goto    G2115;
    w3 = a;
    goto    G2117;
   G2114:
    q = mkfxat(0);
    a = cdr(cdr(car(w6)));
    car(a) = q;
    a = cdr(w6);
   G2132:
    w6 = a;
    if(a == nil) goto    G2124;
    goto    G2114;
   G2115:
    a = w2;
    a = Lcaddar(a);
    w4 = a;
    if(a == nil) goto    G2131;
    q = a;
    a = car(car(w3));
    a = Llessp(a, q);
    if(a == nil) goto    G2130;
   G2131:
    q = car(car(w3));
    a = cdr(cdr(car(w2)));
    car(a) = q;
   G2130:
    a = nil;
    popv(6);
    return a;
}

Sex CC_cnstermTbpol(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    a = Llast(a);
    w1 = a;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2136;
    a = mkfxat(0);
    goto    G2141;
   G2136:
    a = cdr(w1);
    w1 = a;
    if(is_number(a)) goto    G2141;
    a = car(a);
    if(a != value(LL_CalgnC)) goto    G2140;
    a = w1;
    goto    G2141;
   G2140:
    a = cdr(w1);
    a = CC_cnstermTbpol(a);
   G2141:
    popv(1);
    return a;
}

Sex CC_constfctrTcH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = LL_cH;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G2145:
    a = car(w1);
    w4 = a;
    if(is_number(a)) goto    G2155;
    a = car(a);
    if(!is_integer(a)) goto    G2149;
    a = w4;
    a = CC_WconstTcano(a);
    goto    G2172;
   G2149:
    if(a != LL_cL) goto    G2146;
    a = w4;
    a = CC_Wconst(a);
   G2172:
    if(a == nil) goto    G2146;
   G2155:
    a = car(cdr(w1));
    w4 = a;
    if(is_number(a)) goto    G2164;
    a = car(a);
    if(!is_integer(a)) goto    G2158;
    a = w4;
    a = CC_WconstTcano(a);
    goto    G2173;
   G2158:
    if(a != LL_cL) goto    G2146;
    a = w4;
    a = CC_Wconst(a);
   G2173:
    if(a == nil) goto    G2146;
   G2164:
    a = car(cdr(w1));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w3 = a;
   G2146:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G2145;
    a = w2;
    {
        popv(4);
        return  CC_reduceTcH(a);
    }
}

Sex CC_termsTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    a = mkfxat(0);
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G2177:
    a = cdr(car(w1));
    w3 = a;
    if(is_number(a)) goto    G2180;
    a = car(a);
    if(!is_integer(a)) goto    G2179;
   G2180:
    a = w2;
    a = Ladd1(a);
    goto    G2185;
   G2179:
    a = w3;
    a = CC_termsTbpol(a);
    q = a;
    a = w2;
    a = plus2(a, q);
   G2185:
    w2 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2177;
    a = w2;
    popv(3);
    return a;
}

Sex CC_numcontTcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    a = cdr(a);
    w1 = a;
    a = car(a);
    if(!is_number(a)) goto    G2192;
    a = Labs(a);
    goto    G2196;
   G2192:
    a = car(a);
    if(!is_integer(a)) goto    G2193;
    if(a >= value(LL_CratfC)) goto    G2195;
    q = cdr(car(w1));
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    goto    G2196;
   G2195:
    a = cdr(car(w1));
    a = CC_numcontTratf(a);
   G2196:
    w2 = a;
    goto    G2197;
   G2193:
    a = mkfxat(0);
    w2 = a;
    goto    G2189;
    a = w2;
   G2197:
    a = Lonep(a);
    if(a == nil) goto    G2199;
    a = mkfxat(1);
    goto    G2188;
   G2199:
    a = cdr(w1);
    w1 = a;
   G2189:
    a = car(car(car(w1)));
    if(a == LL_cH) goto    G2190;
    a = cdr(car(w1));
    a = CC_Anumcont(a);
    q = a;
    a = w2;
    a = CC_gcdTbnumbnum(a, q);
    w2 = a;
    a = Lonep(a);
    if(a != nil) goto    G2209;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G2209;
    goto    G2189;
   G2190:
    q = cdr(car(w1));
    a = w2;
    a = CC_gcdTbnumbnum(a, q);
    w2 = a;
    a = Lonep(a);
    if(a != nil) goto    G2209;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2190;
   G2209:
    a = w2;
   G2188:
    popv(2);
    return a;
}

Sex CC_monocontTpol3(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    a = CC_mncontTbpol(a);
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G2218;
    a = car(a);
    if(!is_integer(a)) goto    G2217;
   G2218:
    a = value(LL_Htemporal);
    goto    G2219;
   G2217:
    q = value(LL_Htemporal);
    a = car(w1);
    a = cons(a, q);
   G2219:
    popv(1);
    return a;
}

Sex CC_mncontTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    a = cdr(a);
    w2 = a;
   G2223:
    a = cdr(car(w2));
    w3 = a;
    if(!is_number(a)) goto    G2224;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G2223;
    q = w1;
    a = w3;
    a = CC_ncontTbpol(a, q);
    w3 = a;
    a = w2;
    a = Llast(a);
    a = car(a);
    w2 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2229;
    a = w3;
    goto    G2222;
   G2229:
    q = w3;
    a = w2;
    a = cons(a, q);
    q = a;
    a = car(w1);
    {
        popv(3);
        return  Llist2(a, q);
    }
   G2224:
    a = LL_head;
    a = Lncons(a);
    w2 = a;
    q = w1;
    CC_intlzTmono(a, q);
    q = w1;
    a = w2;
    CC_mcnTbpol(a, q);
    a = cdr(w2);
    a = CC_mkTmono(a);
   G2222:
    popv(3);
    return a;
}

Sex CC_monocontTcL(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = CC_numcontTcL(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    a = car(a);
    if(is_number(a)) goto    G2260;
    a = car(a);
    if(!is_integer(a)) goto    G2244;
    a = car(w1);
    a = CC_Amonocont(a);
    goto    G2259;
   G2245:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2247;
    a = w2;
    goto    G2239;
   G2247:
    a = car(car(a));
    if(!is_integer(a)) goto    G2241;
    a = w2;
    if(is_number(a)) goto    G2260;
    a = car(w1);
    a = CC_Amonocont(a);
    w3 = a;
    if(is_number(a)) goto    G2260;
    q = a;
    a = w2;
    a = CC_gcdTmonomono(a, q);
   G2259:
    w2 = a;
    goto    G2245;
   G2244:
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G2241:
    a = w2;
    if(!is_number(a)) goto    G2253;
   G2260:
    a = w4;
    goto    G2239;
   G2253:
    q = car(car(w1));
    a = CC_gengcdTmonocH(a, q);
    w2 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2241;
    q = w2;
    a = w4;
    a = CC_multH(a, q);
   G2239:
    popv(4);
    return a;
}

Sex CC_basexptT(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G2264;
    q = mkfxat(1);
    goto    G2297;
   G2264:
    a = car(a);
    if(!is_integer(a)) goto    G2265;
    if(a >= value(LL_CratfC)) goto    G2267;
    a = cdr(w1);
    a = CC_WspowTbpol(a);
    if(a != nil) goto    G2269;
    q = mkfxat(1);
    a = w1;
    goto    G2297;
   G2269:
    q = car(w1);
    a = car(cdr(w1));
    a = CC_convTvar2cano(a, q);
    w2 = a;
    a = w1;
    a = Lcaaddr(a);
    goto    G2292;
   G2267:
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    if(a == nil) goto    G2288;
    a = cdr(cdr(w1));
    if(a != nil) goto    G2275;
    a = car(cdr(w1));
    value(LL_Htemporal) = a;
    a = car(a);
    if(!is_cons(a)) goto    G2275;
    a = cdr(car(value(LL_Htemporal)));
    a = CC_WspowTbpol(a);
    if(a == nil) goto    G2275;
    a = car(cdr(value(LL_Htemporal)));
    a = Lonep(a);
    if(a == nil) goto    G2275;
    a = car(value(LL_Htemporal));
    w1 = a;
    q = car(a);
    a = car(cdr(a));
    a = CC_convTvar2cano(a, q);
    w2 = a;
    a = w1;
    a = Lcaaddr(a);
    a = Lminus(a);
   G2292:
    q = w2;
    {
        popv(2);
        return  Lxcons(a, q);
    }
   G2275:
    q = mkfxat(1);
    a = w1;
    goto    G2297;
   G2265:
    q = LITERAL[3];
    a = Lmemq(a, q);
    if(a == nil) goto    G2282;
    a = cdr(cdr(cdr(w1)));
    if(a == nil) goto    G2284;
    q = mkfxat(1);
    a = w1;
    goto    G2297;
   G2284:
    a = car(cdr(w1));
    a = CC_Wncan(a);
    if(a == nil) goto    G2285;
    q = car(cdr(cdr(w1)));
    a = car(cdr(w1));
    goto    G2297;
   G2285:
    q = car(w1);
    a = car(cdr(w1));
    a = CC_convTvar2pref(a, q);
    q = car(cdr(cdr(w1)));
    goto    G2297;
   G2282:
    a = car(w1);
    if(a != LL_cL) goto    G2288;
    q = mkfxat(1);
    a = w1;
   G2297:
    {
        popv(2);
        return  cons(a, q);
    }
   G2288:
    q = LITERAL[83];
    a = mkfxat(3);
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
}

Sex CC_comexptTbpol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    a = car(cdr(a));
    w1 = a;
    a = car(a);
    w2 = a;
    a = cdr(w1);
    w1 = a;
   G2301:
    a = w2;
    a = Lonep(a);
    if(a != nil) goto    G2305;
    a = w1;
    if(!is_number(a)) goto    G2304;
   G2305:
    a = w2;
    goto    G2300;
   G2304:
    a = car(a);
    if(!is_integer(a)) goto    G2306;
    a = cdr(w1);
    a = CC_WmonoTbpol(a);
    if(a == nil) goto    G2315;
    a = cdr(w1);
    a = CC_comexptTbpol(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  gcd(a, q);
    }
   G2306:
    a = car(cdr(w1));
    w1 = a;
    a = car(a);
    q = a;
    a = w2;
    a = gcd(a, q);
    w2 = a;
    a = cdr(w1);
    w1 = a;
    goto    G2301;
   G2315:
    a = mkfxat(1);
   G2300:
    popv(2);
    return a;
}

Sex CC_comexptTcH(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    a = cdr(a);
    w1 = a;
    a = car(cdr(a));
    w3 = a;
    w2 = a;
    if(!is_integer(a)) goto    G2320;
    a = w2;
   G2322:
    a = Lonep(a);
    if(a != nil) goto    G2340;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G2340;
    a = car(cdr(a));
    w3 = a;
    if(!is_integer(a)) goto    G2338;
    a = w2;
    a = Lminusp(a);
    if(a == nil) goto    G2327;
    a = w3;
    a = Lminusp(a);
    if(a == nil) goto    G2338;
    a = w2;
    a = Lminus(a);
    w4 = a;
    a = w3;
    a = Lminus(a);
    q = a;
    a = w4;
    a = gcd(a, q);
    a = Lminus(a);
    goto    G2342;
   G2327:
    a = w3;
    a = Lminusp(a);
    if(a != nil) goto    G2338;
    q = w3;
    a = w2;
    a = gcd(a, q);
   G2342:
    w2 = a;
    goto    G2322;
   G2320:
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G2337;
   G2340:
    a = w2;
    goto    G2318;
   G2337:
    q = car(cdr(a));
    a = w2;
    a = Lequal(a, q);
    if(a != nil) goto    G2320;
   G2338:
    a = mkfxat(1);
   G2318:
    popv(4);
    return a;
}

Sex CC_combaseTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = cdr(car(cdr(a)));
    w3 = a;
    w2 = q;
    if(!is_number(a)) goto    G2349;
    a = mkfxat(1);
    goto    G2352;
   G2349:
    a = car(a);
    if(!is_integer(a)) goto    G2350;
    a = cdr(w3);
    a = CC_combaseTbpol(a, q);
    q = car(w3);
    a = Lxcons(a, q);
    goto    G2352;
   G2350:
    a = w3;
    a = CC_combaseTbpol(a, q);
   G2352:
    w3 = a;
    q = w2;
    a = car(car(cdr(w1)));
    a = quot2(a, q);
    q = w3;
    a = cons(a, q);
    q = a;
    a = car(w1);
    {
        popv(4);
        return  Llist2(a, q);
    }
}

Sex CC_combaseTcH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    a = cdr(a);
    w1 = a;
    w2 = q;
    a = LL_cH;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = w2;
    if(!is_integer(a)) goto    G2370;
   G2362:
    q = w2;
    a = car(cdr(w1));
    a = quot2(a, q);
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G2376;
    goto    G2362;
   G2370:
    a = mkfxat(1);
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w4 = a;
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G2370;
   G2376:
    a = w3;
    popv(4);
    return a;
}

Sex CC_getfctrTcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    w3 = nil;
    if(a != value(LL_CratfC)) goto    G2382;
    w4 = nil;
    w2 = q;
    a = w1;
    a = CC_monocontTratf(a);
    w3 = a;
    if(is_number(a)) goto    G2406;
    if(car(a) >= value(LL_CratfC)) goto    G2386;
    q = w2;
    a = CC_getfctrTcano(a, q);
    w4 = a;
    if(a == LL_Anil) goto    G2406;
    q = a;
    a = w1;
    a = CC_Vratfpol3(a, q);
    value(LL_Hremainder) = a;
    goto    G2397;
   G2386:
    a = car(cdr(a));
    w3 = a;
    q = w2;
    a = car(a);
    a = CC_getfctrTcano(a, q);
    w4 = a;
    if(!is_cons(a)) goto    G2391;
    q = value(LL_Hremainder);
    a = cdr(w3);
    a = CC_gV(a, q);
    value(LL_Hremainder) = a;
    q = w4;
    a = mkfxat(1);
    {
        popv(4);
        return  CC_ratioTbnum(a, q);
    }
   G2391:
    a = cdr(w3);
    if(is_number(a)) goto    G2406;
    q = w2;
    a = CC_getfctrTcano(a, q);
    w4 = a;
    if(!is_cons(a)) goto    G2397;
    q = car(w3);
    a = value(LL_Hremainder);
    a = CC_gV(a, q);
    value(LL_Hremainder) = a;
   G2397:
    a = w4;
    goto    G2398;
   G2382:
    w2 = q;
    a = cdr(w1);
    a = CC_getfctrTbpol(a, q);
    w3 = a;
    if(is_cons(a)) goto    G2401;
   G2406:
    a = LL_Anil;
    goto    G2398;
   G2401:
    a = car(a);
    if(is_integer(a)) goto    G2402;
    q = w3;
    a = car(w1);
    a = cons(a, q);
    w3 = a;
   G2402:
    q = w3;
    a = w1;
    a = CC_Vpol3pol3(a, q);
    value(LL_Hremainder) = a;
    a = w3;
   G2398:
    popv(4);
    return a;
}

Sex CC_getfctrTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
   G2429:
    w1 = a;
    w2 = q;
    q = car(a);
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G2410;
    a = cdr(cdr(w1));
    if(a != nil) goto    G2412;
    q = mkfxat(1);
    a = car(car(cdr(w1)));
    goto    G2426;
   G2412:
    a = w1;
    a = CC_tail(a);
    w1 = a;
    a = car(a);
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2428;
    q = mkfxat(1);
    a = car(car(w1));
   G2426:
    a = cons(a, q);
    q = a;
    a = w2;
    {
        popv(2);
        return  Llist2(a, q);
    }
   G2410:
    q = car(w1);
    a = w2;
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G2428;
    a = cdr(car(cdr(w1)));
    w1 = a;
    if(!is_number(a)) goto    G2421;
   G2428:
    a = LL_Anil;
    goto    G2425;
   G2421:
    a = car(a);
    if(is_integer(a)) goto    G2422;
    q = w2;
    a = w1;
    goto    G2429;  /* recursive call to getfctr:bpol */
   G2422:
    q = w2;
    a = cdr(w1);
    a = CC_getfctrTbpol(a, q);
    w2 = a;
    if(!is_cons(a)) goto    G2424;
    a = car(a);
    if(!is_integer(a)) goto    G2423;
   G2424:
    a = w2;
    goto    G2425;
   G2423:
    q = w2;
    a = car(w1);
    a = cons(a, q);
   G2425:
    popv(2);
    return a;
}

Sex CC_getfctrTncH(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = nil;
    a = w2;
    a = CC_Wcommute(a, q);
    if(a == nil) goto    G2432;
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_getfctrTcH(a, q);
    }
   G2432:
    a = cdr(w1);
    w1 = a;
    a = car(a);
    q = w2;
    if(is_cons(a)) goto    G2433;
    a = car(w1);
    a = Lneq(a, q);
    if(a == nil) goto    G2439;
    goto    G2442;
   G2433:
    a = car(car(w1));
    a = Lneq(a, q);
    if(a == nil) goto    G2439;
   G2442:
    a = LL_Anil;
    goto    G2440;
   G2439:
    q = cdr(cdr(w1));
    a = LL_ncH;
    a = cons(a, q);
    a = CC_reduceTncH(a);
    value(LL_Hremainder) = a;
    m = car(cdr(w1));
    q = car(w1);
    a = LL_ncH;
    a = Llist3(a, q, m);
   G2440:
    popv(2);
    return a;
}

Sex CC_getfctrTcH(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
   G2447:
    a = car(w3);
    w7 = a;
    if(!is_cons(a)) goto    G2458;
    a = car(a);
    if(!is_symbol(a)) goto    G2456;
    if(a != LL_cL) goto    G2458;
    q = w2;
    a = w7;
    a = CC_Agetfactor(a, q);
    w7 = a;
    if(is_cons(a)) goto    G2464;
    goto    G2465;
   G2458:
    if(a != w2) goto    G2465;
    goto    G2448;
   G2456:
    q = w2;
    a = w7;
    a = CC_getfctrTcano(a, q);
    w7 = a;
    if(is_cons(a)) goto    G2464;
   G2465:
    a = cdr(cdr(w3));
    w3 = a;
    if(a != nil) goto    G2447;
    a = LL_Anil;
    goto    G2446;
   G2464:
    a = value(LL_Hremainder);
    w6 = a;
   G2448:
    a = car(w1);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w1);
    w1 = a;
   G2449:
    if(a == w3) goto    G2450;
    a = car(cdr(a));
    a = Lncons(a);
    q = car(w1);
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w5 = a;
    a = cdr(cdr(w1));
    w1 = a;
    goto    G2449;
   G2450:
    q = cdr(cdr(w3));
    a = w5;
    cdr(a) = q;
    a = car(w4);
    if(a != LL_cH) goto    G2475;
    a = w4;
    a = CC_reduceTcH(a);
    goto    G2476;
   G2475:
    a = w4;
    a = CC_reduceTncH(a);
   G2476:
    value(LL_Hremainder) = a;
    a = w6;
    if(a != nil) goto    G2478;
    m = car(cdr(w3));
    q = car(w3);
    a = car(w4);
    {
        popv(7);
        return  Llist3(a, q, m);
    }
   G2478:
    a = car(cdr(w3));
    a = Lonep(a);
    if(a != nil) goto    G2481;
    q = car(cdr(w3));
    a = w7;
    a = CC_unpowH(a, q);
    w7 = a;
    q = car(cdr(w3));
    a = w6;
    a = CC_unpowH(a, q);
    w6 = a;
   G2481:
    q = w6;
    a = value(LL_Hremainder);
    a = CC_multH(a, q);
    value(LL_Hremainder) = a;
    a = w7;
   G2446:
    popv(7);
    return a;
}

Sex CC_ncontTany(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G2487;
    if(is_integer(q)) goto    G2489;
    if(is_rational(q)) goto    G2489;
    a = mkfxat(1);
    goto    G2494;
   G2489:
    a = Lzerop(a);
    if(a == nil) goto    G2491;
    a = w2;
    {
        popv(2);
        return  Labs(a);
    }
   G2491:
    q = w2;
    a = w1;
    {
        popv(2);
        return  CC_gcdTbnumbnum(a, q);
    }
   G2487:
    a = car(q);
    if(!is_integer(a)) goto    G2493;
    q = cdr(q);
   G2493:
    a = w1;
    a = CC_ncontTbpol(a, q);
   G2494:
    popv(2);
    return a;
}

Sex CC_ncontTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    a = cdr(q);
    w3 = a;
    w2 = q;
   G2499:
    q = cdr(car(w3));
    a = w1;
    a = CC_ncontTany(a, q);
    w1 = a;
    a = Lonep(a);
    if(a == nil) goto    G2501;
    a = mkfxat(1);
    goto    G2498;
   G2501:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G2499;
    a = w1;
   G2498:
    popv(3);
    return a;
}

Sex CC_intlzTmono(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
   G2527:
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G2508;
    if(is_integer(q)) goto    G2511;
    if(!is_rational(q)) goto    G2510;
   G2511:
    a = q;
    a = Labs(a);
    q = mkfxat(1);
    a = Lxcons(a, q);
    goto    G2526;
   G2510:
    q = mkfxat(1);
    a = mkfxat(1);
    a = cons(a, q);
    goto    G2526;
   G2508:
    a = car(q);
    if(!is_integer(a)) goto    G2518;
    a = cdr(q);
    value(LL_Htemporal) = a;
    a = car(q);
    a = Lncons(a);
    w2 = a;
    q = value(LL_Htemporal);
    CC_intlzTmono(a, q);
    q = w2;
    a = mkfxat(1);
    a = cons(a, q);
   G2526:
    a = Lncons(a);
    q = a;
    a = w1;
    {
        popv(2);
        cdr(a) = q;
 return a;
    }
   G2518:
    q = car(car(cdr(q)));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    q = cdr(car(cdr(w2)));
    goto    G2527;  /* recursive call to intlz:mono */
}

Sex CC_mkTmono(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = car(car(a));
    if(!is_integer(a)) goto    G2530;
    a = Lzerop(a);
    if(a == nil) goto    G2532;
    a = cdr(car(w1));
    goto    G2536;
   G2532:
    a = cdr(car(w1));
    w1 = a;
    if(is_number(a)) goto    G2536;
    a = cdr(a);
    a = CC_mkTmono(a);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G2530:
    a = cdr(w1);
    a = CC_mkTmono(a);
    q = cdr(car(w1));
    a = Lxcons(a, q);
    q = a;
    a = car(car(w1));
    a = Llist2(a, q);
   G2536:
    popv(1);
    return a;
}

Sex CC_mcnTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    w2 = q;
   G2542:
    a = cdr(w2);
    w3 = a;
    a = car(cdr(w1));
    w4 = a;
    q = car(w2);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G2546;
    a = w2;
    a = Llast(a);
    a = car(a);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2548;
    q = cdr(cdr(w1));
    goto    G2572;
   G2548:
    q = cdr(w4);
    a = w5;
    a = Lmin2(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w1);
    w1 = a;
    goto    G2553;
   G2546:
    q = car(w2);
    a = car(w4);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G2553;
    q = cdr(cdr(w1));
    a = w1;
    cdr(a) = q;
    a = cdr(cdr(w1));
    if(a != nil) goto    G2542;
   G2553:
    a = cdr(cdr(w1));
    if(a == nil) goto    G2557;
    a = cdr(car(w3));
    w5 = a;
    if(is_number(a)) goto    G2560;
    a = car(a);
    if(!is_integer(a)) goto    G2559;
   G2560:
    a = w1;
    a = CC_tail(a);
    q = a;
   G2572:
    a = w1;
    cdr(a) = q;
    goto    G2553;
   G2557:
    a = car(cdr(w1));
    w4 = a;
    a = cdr(a);
    a = Lonep(a);
    if(a != nil) goto    G2570;
    a = cdr(w4);
    q = w2;
    if(!is_number(a)) goto    G2566;
    a = CC_ncontTbpol(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    goto    G2570;
   G2566:
    a = w4;
    CC_mcnTlowcano(a, q);
    goto    G2570;
   G2559:
    q = w5;
    a = w1;
    CC_mcnTbpol(a, q);
    a = w3;
    w2 = a;
    a = cdr(a);
    w3 = a;
    if(a != nil) goto    G2553;
   G2570:
    a = w1;
    popv(5);
    return a;
}

Sex CC_mcnTlowcano(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w1 = a;
    a = cdr(q);
    w3 = a;
    a = cdr(w1);
    w4 = a;
    a = car(a);
    w5 = a;
    w2 = q;
   G2579:
    a = cdr(car(w3));
    w7 = a;
    if(is_number(a)) goto    G2580;
    a = car(a);
    if(is_integer(a)) goto    G2583;
    q = w7;
    goto    G2602;
   G2583:
    w6 = a;
    if(a != w5) goto    G2584;
    q = cdr(w7);
    a = w4;
    CC_mcnTbpol(a, q);
    goto    G2588;
   G2584:
    if(w5 < a) goto    G2603;
    a = w4;
    a = Llast(a);
    a = cdr(a);
    w7 = a;
    if(is_number(a)) goto    G2580;
    w4 = a;
    a = car(a);
    w5 = a;
    q = w4;
    a = w1;
    cdr(a) = q;
    goto    G2579;
   G2603:
    q = cdr(w7);
   G2602:
    a = w1;
    CC_mcnTlowcano(a, q);
   G2588:
    a = cdr(w1);
    w7 = a;
    if(is_number(a)) goto    G2580;
    a = cdr(cdr(w4));
    if(a != nil) goto    G2594;
    a = cdr(car(cdr(w4)));
    w7 = a;
    if(is_number(a)) goto    G2580;
    w4 = a;
    a = car(a);
    w5 = a;
    q = w4;
    a = w1;
    cdr(a) = q;
   G2594:
    a = w3;
    w2 = a;
    a = cdr(a);
    w3 = a;
    if(a != nil) goto    G2579;
    a = w1;
    goto    G2578;
   G2580:
    a = w7;
    a = Lonep(a);
    if(a != nil) goto    G2600;
    q = w2;
    a = w7;
    a = CC_ncontTbpol(a, q);
    w7 = a;
   G2600:
    q = w7;
    a = w1;
    cdr(a) = q;
   G2578:
    popv(7);
    return a;
}



/* initialization procedure */
int init_compart(void)
{
   long i;

   create_symbols(compart_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; compart_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(compart_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4;
        a = LITERAL[84];
        CC_Aenter(a);
        arg4 = nil;
        m = nil;
#define LL_Cfactors LITERAL[85]
        q = LL_Cfactors;
#define LL_Cfctrs LITERAL[86]
        a = LL_Cfctrs;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Cfactors;
        a = LL_Cfactors;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Cterms LITERAL[87]
        q = LL_Cterms;
        a = LL_Cterms;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Cparts LITERAL[88]
        q = LL_Cparts;
        a = LL_Cparts;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Celements LITERAL[89]
        q = LL_Celements;
#define LL_Celmnts LITERAL[90]
        a = LL_Celmnts;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Celements;
        a = LL_Celements;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Amonocoef LITERAL[91]
        q = LL_Amonocoef;
#define LL_monocoef LITERAL[92]
        a = LL_monocoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Amonocoef;
#define LL_monocoeff LITERAL[93]
        a = LL_monocoeff;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acoefpart LITERAL[94]
        q = LL_Acoefpart;
#define LL_coefpart LITERAL[95]
        a = LL_coefpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Acoefpart;
#define LL_coeffpart LITERAL[96]
        a = LL_coeffpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
#define LL_argchk LITERAL[97]
        m = LL_argchk;
#define LL_Apoly2coefset LITERAL[98]
        q = LL_Apoly2coefset;
#define LL_poly2coefset LITERAL[99]
        a = LL_poly2coefset;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(3);
        m = LL_argchk;
#define LL_Acoef LITERAL[100]
        q = LL_Acoef;
        a = LL_coef;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(3);
        m = LL_argchk;
        q = LL_Acoef;
#define LL_coeff LITERAL[101]
        a = LL_coeff;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Amvar LITERAL[102]
        q = LL_Amvar;
#define LL_mvar LITERAL[103]
        a = LL_mvar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Amvar;
#define LL_mainvar LITERAL[104]
        a = LL_mainvar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Adeg LITERAL[105]
        q = LL_Adeg;
#define LL_deg LITERAL[106]
        a = LL_deg;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Adeg;
#define LL_degree LITERAL[107]
        a = LL_degree;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Avdeg LITERAL[108]
        q = LL_Avdeg;
#define LL_vdeg LITERAL[109]
        a = LL_vdeg;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Avdeg;
#define LL_vardeg LITERAL[110]
        a = LL_vardeg;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Atdeg LITERAL[111]
        q = LL_Atdeg;
#define LL_tdeg LITERAL[112]
        a = LL_tdeg;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Atdeg;
#define LL_totdeg LITERAL[113]
        a = LL_totdeg;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alcoef LITERAL[114]
        q = LL_Alcoef;
#define LL_lcoef LITERAL[115]
        a = LL_lcoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Alcoef;
#define LL_lcoeff LITERAL[116]
        a = LL_lcoeff;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aemaxmin LITERAL[117]
        q = LL_Aemaxmin;
#define LL_emaxmin LITERAL[118]
        a = LL_emaxmin;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aeminmax LITERAL[119]
        q = LL_Aeminmax;
#define LL_eminmax LITERAL[120]
        a = LL_eminmax;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alncoef LITERAL[121]
        q = LL_Alncoef;
#define LL_lncoef LITERAL[122]
        a = LL_lncoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Alncoef;
#define LL_lncoeff LITERAL[123]
        a = LL_lncoeff;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Amcoef LITERAL[124]
        q = LL_Amcoef;
#define LL_mcoef LITERAL[125]
        a = LL_mcoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Amcoef;
#define LL_mcoeff LITERAL[126]
        a = LL_mcoeff;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alterm LITERAL[127]
        q = LL_Alterm;
#define LL_hterm LITERAL[128]
        a = LL_hterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Alterm;
#define LL_headterm LITERAL[129]
        a = LL_headterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Alterm;
#define LL_lterm LITERAL[130]
        a = LL_lterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Alterm;
#define LL_leftterm LITERAL[131]
        a = LL_leftterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Arterm LITERAL[132]
        q = LL_Arterm;
#define LL_rterm LITERAL[133]
        a = LL_rterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Arterm;
#define LL_rightterm LITERAL[134]
        a = LL_rightterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alfactor LITERAL[135]
        q = LL_Alfactor;
#define LL_lfactor LITERAL[136]
        a = LL_lfactor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Alfactor;
#define LL_leftfactor LITERAL[137]
        a = LL_leftfactor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Arfactor LITERAL[138]
        q = LL_Arfactor;
#define LL_rfactor LITERAL[139]
        a = LL_rfactor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Arfactor;
#define LL_rightfactor LITERAL[140]
        a = LL_rightfactor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alpart LITERAL[141]
        q = LL_Alpart;
#define LL_lpart LITERAL[142]
        a = LL_lpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Alpart;
#define LL_leftpart LITERAL[143]
        a = LL_leftpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Arpart LITERAL[144]
        q = LL_Arpart;
#define LL_rpart LITERAL[145]
        a = LL_rpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Arpart;
#define LL_rightpart LITERAL[146]
        a = LL_rightpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alpoly LITERAL[147]
        q = LL_Alpoly;
#define LL_lpoly LITERAL[148]
        a = LL_lpoly;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Arpoly LITERAL[149]
        q = LL_Arpoly;
#define LL_rpoly LITERAL[150]
        a = LL_rpoly;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alowpart LITERAL[151]
        q = LL_Alowpart;
#define LL_lowpart LITERAL[152]
        a = LL_lowpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alowterm LITERAL[153]
        q = LL_Alowterm;
#define LL_lowterm LITERAL[154]
        a = LL_lowterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alowfactor LITERAL[155]
        q = LL_Alowfactor;
#define LL_lowfactor LITERAL[156]
        a = LL_lowfactor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Anthterm LITERAL[157]
        q = LL_Anthterm;
#define LL_nthterm LITERAL[158]
        a = LL_nthterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Anthfactor LITERAL[159]
        q = LL_Anthfactor;
#define LL_nthfctr LITERAL[160]
        a = LL_nthfctr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Anthpart LITERAL[161]
        q = LL_Anthpart;
#define LL_nthpart LITERAL[162]
        a = LL_nthpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Anthfactor;
#define LL_nthfactor LITERAL[163]
        a = LL_nthfactor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alastterm LITERAL[164]
        q = LL_Alastterm;
#define LL_lastterm LITERAL[165]
        a = LL_lastterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Agetfactor LITERAL[166]
        q = LL_Agetfactor;
#define LL_getfactor LITERAL[167]
        a = LL_getfactor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Atermfromto LITERAL[168]
        q = LL_Atermfromto;
#define LL_termfromto LITERAL[169]
        a = LL_termfromto;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Adenom LITERAL[170]
        q = LL_Adenom;
#define LL_denom LITERAL[171]
        a = LL_denom;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Anumer LITERAL[172]
        q = LL_Anumer;
#define LL_numer LITERAL[173]
        a = LL_numer;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Apolypart LITERAL[174]
        q = LL_Apolypart;
#define LL_polypart LITERAL[175]
        a = LL_polypart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aratiopart LITERAL[176]
        q = LL_Aratiopart;
#define LL_ratiopart LITERAL[177]
        a = LL_ratiopart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alratio LITERAL[178]
        q = LL_Alratio;
#define LL_lratio LITERAL[179]
        a = LL_lratio;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Arratio LITERAL[180]
        q = LL_Arratio;
#define LL_rratio LITERAL[181]
        a = LL_rratio;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aldenom LITERAL[182]
        q = LL_Aldenom;
#define LL_ldenom LITERAL[183]
        a = LL_ldenom;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Alnumer LITERAL[184]
        q = LL_Alnumer;
#define LL_lnumer LITERAL[185]
        a = LL_lnumer;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Anumpart LITERAL[186]
        q = LL_Anumpart;
#define LL_numpart LITERAL[187]
        a = LL_numpart;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Anumterm LITERAL[188]
        q = LL_Anumterm;
#define LL_numterm LITERAL[189]
        a = LL_numterm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Anumfactor LITERAL[190]
        q = LL_Anumfactor;
#define LL_numfactor LITERAL[191]
        a = LL_numfactor;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Anumfactor;
#define LL_numfctr LITERAL[192]
        a = LL_numfctr;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Anumcont LITERAL[193]
        q = LL_Anumcont;
#define LL_ncont LITERAL[194]
        a = LL_ncont;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Anumcont;
#define LL_numcont LITERAL[195]
        a = LL_numcont;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Amonocont LITERAL[196]
        q = LL_Amonocont;
#define LL_mncont LITERAL[197]
        a = LL_mncont;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Amonocont;
#define LL_monocont LITERAL[198]
        a = LL_monocont;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Avarlist LITERAL[199]
        q = LL_Avarlist;
#define LL_varlist LITERAL[200]
        a = LL_varlist;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Abase LITERAL[201]
        q = LL_Abase;
#define LL_base LITERAL[202]
        a = LL_base;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Aexponent LITERAL[203]
        q = LL_Aexponent;
#define LL_expnt LITERAL[204]
        a = LL_expnt;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
        q = LL_Aexponent;
#define LL_exponent LITERAL[205]
        a = LL_exponent;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = nil;
#define LL_Acomexpt LITERAL[206]
        q = LL_Acomexpt;
#define LL_comexpt LITERAL[207]
        a = LL_comexpt;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
#define LL_Acombase LITERAL[208]
        q = LL_Acombase;
#define LL_combase LITERAL[209]
        a = LL_combase;
        a = CC_defcommand(a, q, m, arg4);
        return 1;
    }
}
Sex LITERAL[211];

const  char *compart_literal_string[211] =
{
/* 0 */
"!#ratf!#",
/* 1 */
"!#maxform!#",
/* 2 */
"c!+",
/* 3 */
"(c!* nc!*)",
/* 4 */
"\"#TERMS\"",
/* 5 */
"! nil",
/* 6 */
"!!ctype!!",
/* 7 */
"!*temporal",
/* 8 */
"rat",
/* 9 */
"set",
/* 10 */
"(!!set !!oset)",
/* 11 */
"indef",
/* 12 */
"\"#ELEMNTS\"",
/* 13 */
"\"MONOCOEF\"",
/* 14 */
"\"ARGUMENT TYPES MISMATCH\"",
/* 15 */
"\"SECOND ARG IS NOT MONOMIAL\"",
/* 16 */
"\"COEFPART\"",
/* 17 */
"\"POLY2COEFSET\"",
/* 18 */
"\"SIZE IS TOO SMALL\"",
/* 19 */
"!!oset",
/* 20 */
"\"COEF\"",
/* 21 */
"! invalid",
/* 22 */
"\"INVALID AS COEFFICIENT-ARRAY\"",
/* 23 */
"\"COEF-PATTERN IS NOT COMMUTATIVE\"",
/* 24 */
"!#maxcano!#",
/* 25 */
"c!*",
/* 26 */
"nc!*",
/* 27 */
"!!gid",
/* 28 */
"head",
/* 29 */
"coef",
/* 30 */
"\"INVALID AS COEF-PATTERN\"",
/* 31 */
"\"RATIONAL AS COEF-PATTERN\"",
/* 32 */
"\"NUMBER NOT ALLOWED IN COEF-PATTERN\"",
/* 33 */
"\"NON-INTEGRAL EXPT. IN COEF-PATTERN\"",
/* 34 */
"\"NON-COMMUTATIVE IN COEF-PATTERN\"",
/* 35 */
"\"NON-MONOMIAL AS COEF-PATTERN\"",
/* 36 */
"\"INVALID IN COEF-PATTERN\"",
/* 37 */
"uniqrep",
/* 38 */
"algn",
/* 39 */
"!#algn!#",
/* 40 */
"algf",
/* 41 */
"!#algf!#",
/* 42 */
"!#poly!#",
/* 43 */
"invalid",
/* 44 */
"\"INVALID SECOND ARGUMENT TO VDEG\"",
/* 45 */
"var",
/* 46 */
"rel",
/* 47 */
"\"LPART\"",
/* 48 */
"\"RPART\"",
/* 49 */
"\"LTERM\"",
/* 50 */
"\"RTERM\"",
/* 51 */
"\"LFACTOR\"",
/* 52 */
"\"RFACTOR\"",
/* 53 */
"!*remainder",
/* 54 */
"\"GETFACTOR\"",
/* 55 */
"\"'N' IN NTHPART IS TOO LARGE\"",
/* 56 */
"\"NTHPART\"",
/* 57 */
"\"'N' IN NTHTERM IS TOO LARGE\"",
/* 58 */
"\"NTHTERM\"",
/* 59 */
"\"NTHFACTOR\"",
/* 60 */
"\"LASTTERM\"",
/* 61 */
"\"NOT YET\"",
/* 62 */
"\"TERMFROMTO\"",
/* 63 */
"\"SECOND ARG IS NOT <VAR>\"",
/* 64 */
"\"INVALID EXPONENT RANGE\"",
/* 65 */
"\"DENOM\"",
/* 66 */
"\"NUMER\"",
/* 67 */
"\"POLYPART\"",
/* 68 */
"\"RATIOPART\"",
/* 69 */
"\"LRATIO\"",
/* 70 */
"\"RRATIO\"",
/* 71 */
"\"LDENOM\"",
/* 72 */
"\"LNUMER\"",
/* 73 */
"\"NUMPART\"",
/* 74 */
"\"NUMTERM\"",
/* 75 */
"\"CONSTTERM\"",
/* 76 */
"\"NUMFACTOR\"",
/* 77 */
"\"NUMCONT\"",
/* 78 */
"\"MONOCONT\"",
/* 79 */
"!!set",
/* 80 */
"\"COMEXPT\"",
/* 81 */
"\"COMBASE\"",
/* 82 */
"!?order!:var",
/* 83 */
"\"COMBASE-EXPT\"",
/* 84 */
"(lisp)",
/* 85 */
"!#factors",
/* 86 */
"!#fctrs",
/* 87 */
"!#terms",
/* 88 */
"!#parts",
/* 89 */
"!#elements",
/* 90 */
"!#elmnts",
/* 91 */
"! monocoef",
/* 92 */
"monocoef",
/* 93 */
"monocoeff",
/* 94 */
"! coefpart",
/* 95 */
"coefpart",
/* 96 */
"coeffpart",
/* 97 */
"argchk",
/* 98 */
"! poly2coefset",
/* 99 */
"poly2coefset",
/* 100 */
"! coef",
/* 101 */
"coeff",
/* 102 */
"! mvar",
/* 103 */
"mvar",
/* 104 */
"mainvar",
/* 105 */
"! deg",
/* 106 */
"deg",
/* 107 */
"degree",
/* 108 */
"! vdeg",
/* 109 */
"vdeg",
/* 110 */
"vardeg",
/* 111 */
"! tdeg",
/* 112 */
"tdeg",
/* 113 */
"totdeg",
/* 114 */
"! lcoef",
/* 115 */
"lcoef",
/* 116 */
"lcoeff",
/* 117 */
"! emaxmin",
/* 118 */
"emaxmin",
/* 119 */
"! eminmax",
/* 120 */
"eminmax",
/* 121 */
"! lncoef",
/* 122 */
"lncoef",
/* 123 */
"lncoeff",
/* 124 */
"! mcoef",
/* 125 */
"mcoef",
/* 126 */
"mcoeff",
/* 127 */
"! lterm",
/* 128 */
"hterm",
/* 129 */
"headterm",
/* 130 */
"lterm",
/* 131 */
"leftterm",
/* 132 */
"! rterm",
/* 133 */
"rterm",
/* 134 */
"rightterm",
/* 135 */
"! lfactor",
/* 136 */
"lfactor",
/* 137 */
"leftfactor",
/* 138 */
"! rfactor",
/* 139 */
"rfactor",
/* 140 */
"rightfactor",
/* 141 */
"! lpart",
/* 142 */
"lpart",
/* 143 */
"leftpart",
/* 144 */
"! rpart",
/* 145 */
"rpart",
/* 146 */
"rightpart",
/* 147 */
"! lpoly",
/* 148 */
"lpoly",
/* 149 */
"! rpoly",
/* 150 */
"rpoly",
/* 151 */
"! lowpart",
/* 152 */
"lowpart",
/* 153 */
"! lowterm",
/* 154 */
"lowterm",
/* 155 */
"! lowfactor",
/* 156 */
"lowfactor",
/* 157 */
"! nthterm",
/* 158 */
"nthterm",
/* 159 */
"! nthfactor",
/* 160 */
"nthfctr",
/* 161 */
"! nthpart",
/* 162 */
"nthpart",
/* 163 */
"nthfactor",
/* 164 */
"! lastterm",
/* 165 */
"lastterm",
/* 166 */
"! getfactor",
/* 167 */
"getfactor",
/* 168 */
"! termfromto",
/* 169 */
"termfromto",
/* 170 */
"! denom",
/* 171 */
"denom",
/* 172 */
"! numer",
/* 173 */
"numer",
/* 174 */
"! polypart",
/* 175 */
"polypart",
/* 176 */
"! ratiopart",
/* 177 */
"ratiopart",
/* 178 */
"! lratio",
/* 179 */
"lratio",
/* 180 */
"! rratio",
/* 181 */
"rratio",
/* 182 */
"! ldenom",
/* 183 */
"ldenom",
/* 184 */
"! lnumer",
/* 185 */
"lnumer",
/* 186 */
"! numpart",
/* 187 */
"numpart",
/* 188 */
"! numterm",
/* 189 */
"numterm",
/* 190 */
"! numfactor",
/* 191 */
"numfactor",
/* 192 */
"numfctr",
/* 193 */
"! numcont",
/* 194 */
"ncont",
/* 195 */
"numcont",
/* 196 */
"! monocont",
/* 197 */
"mncont",
/* 198 */
"monocont",
/* 199 */
"! varlist",
/* 200 */
"varlist",
/* 201 */
"! base",
/* 202 */
"base",
/* 203 */
"! exponent",
/* 204 */
"expnt",
/* 205 */
"exponent",
/* 206 */
"! comexpt",
/* 207 */
"comexpt",
/* 208 */
"! combase",
/* 209 */
"combase",
/* 210 */ NULL
};
setup_type const compart_g_setup[] =
{
    {"mcn:lowcano", (lisp_proc *)CC_mcnTlowcano, 2},
    {"mcn:bpol", (lisp_proc *)CC_mcnTbpol, 2},
    {"mk:mono", (lisp_proc *)CC_mkTmono, 1},
    {"intlz:mono", (lisp_proc *)CC_intlzTmono, 2},
    {"ncont:bpol", (lisp_proc *)CC_ncontTbpol, 2},
    {"ncont:any", (lisp_proc *)CC_ncontTany, 2},
    {"getfctr:c*", (lisp_proc *)CC_getfctrTcH, 2},
    {"getfctr:nc*", (lisp_proc *)CC_getfctrTncH, 2},
    {"getfctr:bpol", (lisp_proc *)CC_getfctrTbpol, 2},
    {"getfctr:cano", (lisp_proc *)CC_getfctrTcano, 2},
    {"combase:c*", (lisp_proc *)CC_combaseTcH, 2},
    {"combase:bpol", (lisp_proc *)CC_combaseTbpol, 2},
    {"comexpt:c*", (lisp_proc *)CC_comexptTcH, 1},
    {"comexpt:bpol", (lisp_proc *)CC_comexptTbpol, 1},
    {"basexpt:", (lisp_proc *)CC_basexptT, 1},
    {"monocont:c+", (lisp_proc *)CC_monocontTcL, 1},
    {"mncont:bpol", (lisp_proc *)CC_mncontTbpol, 1},
    {"monocont:pol3", (lisp_proc *)CC_monocontTpol3, 1},
    {"numcont:c+", (lisp_proc *)CC_numcontTcL, 1},
    {"terms:bpol", (lisp_proc *)CC_termsTbpol, 1},
    {"constfctr:c*", (lisp_proc *)CC_constfctrTcH, 1},
    {"cnsterm:bpol", (lisp_proc *)CC_cnstermTbpol, 1},
    {"emxmn:bpol", (lisp_proc *)CC_emxmnTbpol, 2},
    {"vars:bpol", (lisp_proc *)CC_varsTbpol, 2},
    {"termfrto:mktm", (lisp_proc *)CC_termfrtoTmktm, 2},
    {"termfrto:bpol", (lisp_proc *)CC_termfrtoTbpol, 6},
    {"nfctr:bpol", (lisp_proc *)CC_nfctrTbpol, 1},
    {"nterm:bpol", (lisp_proc *)CC_ntermTbpol, 1},
    {"nthfctr:c*", (lisp_proc *)CC_nthfctrTcH, 2},
    {"nthfctr:bpol", (lisp_proc *)CC_nthfctrTbpol, 2},
    {"nthterm:bpol", (lisp_proc *)CC_nthtermTbpol, 2},
    {"rterm:bpol", (lisp_proc *)CC_rtermTbpol, 1},
    {"lfctr:bpol", (lisp_proc *)CC_lfctrTbpol, 1},
    {"lterm:bpol", (lisp_proc *)CC_ltermTbpol, 1},
    {"vdeg:bpol", (lisp_proc *)CC_vdegTbpol, 3},
    {" combase", (lisp_proc *)CC_Acombase, 2},
    {" comexpt", (lisp_proc *)CC_Acomexpt, 1},
    {" exponent", (lisp_proc *)CC_Aexponent, 1},
    {" base", (lisp_proc *)CC_Abase, 1},
    {"varlist*", (lisp_proc *)CC_varlistH, 1},
    {" varlist", (lisp_proc *)CC_Avarlist, 1},
    {" monocont", (lisp_proc *)CC_Amonocont, 1},
    {" numcont", (lisp_proc *)CC_Anumcont, 1},
    {" numfactor", (lisp_proc *)CC_Anumfactor, 1},
    {" constterm", (lisp_proc *)CC_Aconstterm, 1},
    {" numterm", (lisp_proc *)CC_Anumterm, 1},
    {" numpart", (lisp_proc *)CC_Anumpart, 1},
    {" lnumer", (lisp_proc *)CC_Alnumer, 1},
    {" ldenom", (lisp_proc *)CC_Aldenom, 1},
    {" rratio", (lisp_proc *)CC_Arratio, 1},
    {" lratio", (lisp_proc *)CC_Alratio, 1},
    {" ratiopart", (lisp_proc *)CC_Aratiopart, 1},
    {" polypart", (lisp_proc *)CC_Apolypart, 1},
    {" numer", (lisp_proc *)CC_Anumer, 1},
    {" denom", (lisp_proc *)CC_Adenom, 1},
    {"termfromto*", (lisp_proc *)CC_termfromtoH, 4},
    {" termfromto", (lisp_proc *)CC_Atermfromto, 4},
    {" lastterm", (lisp_proc *)CC_Alastterm, 1},
    {" nthfactor", (lisp_proc *)CC_Anthfactor, 2},
    {" nthterm", (lisp_proc *)CC_Anthterm, 2},
    {" nthpart", (lisp_proc *)CC_Anthpart, 2},
    {" lowfactor", (lisp_proc *)CC_Alowfactor, 1},
    {" lowterm", (lisp_proc *)CC_Alowterm, 1},
    {" lowpart", (lisp_proc *)CC_Alowpart, 1},
    {" rpoly", (lisp_proc *)CC_Arpoly, 1},
    {" lpoly", (lisp_proc *)CC_Alpoly, 1},
    {" getfactor", (lisp_proc *)CC_Agetfactor, 2},
    {" rfactor", (lisp_proc *)CC_Arfactor, 1},
    {" lfactor", (lisp_proc *)CC_Alfactor, 1},
    {" rterm", (lisp_proc *)CC_Arterm, 1},
    {" lterm", (lisp_proc *)CC_Alterm, 1},
    {" rpart", (lisp_proc *)CC_Arpart, 1},
    {" lpart", (lisp_proc *)CC_Alpart, 1},
    {" mcoef", (lisp_proc *)CC_Amcoef, 1},
    {" lncoef", (lisp_proc *)CC_Alncoef, 1},
    {"emaxmin*", (lisp_proc *)CC_emaxminH, 1},
    {" eminmax", (lisp_proc *)CC_Aeminmax, 1},
    {" emaxmin", (lisp_proc *)CC_Aemaxmin, 1},
    {" lcoef", (lisp_proc *)CC_Alcoef, 1},
    {" tdeg", (lisp_proc *)CC_Atdeg, 1},
    {" vdeg", (lisp_proc *)CC_Avdeg, 2},
    {" deg", (lisp_proc *)CC_Adeg, 1},
    {" mvar", (lisp_proc *)CC_Amvar, 1},
    {"cof:vlis2mono", (lisp_proc *)CC_cofTvlis2mono, 1},
    {"secof:multsome", (lisp_proc *)CC_secofTmultsome, 2},
    {"secof:addcoef", (lisp_proc *)CC_secofTaddcoef, 3},
    {"cof:pcpowcofs", (lisp_proc *)CC_cofTpcpowcofs, 4},
    {"cof:ppowcof", (lisp_proc *)CC_cofTppowcof, 2},
    {"cof:cpowcof", (lisp_proc *)CC_cofTcpowcof, 2},
    {"cof:bpolscan", (lisp_proc *)CC_cofTbpolscan, 4},
    {"cfpart:bpol", (lisp_proc *)CC_cfpartTbpol, 2},
    {"mncoef:bpol", (lisp_proc *)CC_mncoefTbpol, 2},
    {"cofptn:pol3", (lisp_proc *)CC_cofptnTpol3, 1},
    {"coefptn:", (lisp_proc *)CC_coefptnT, 1},
    {"coef:pol3", (lisp_proc *)CC_coefTpol3, 2},
    {"coef:c+", (lisp_proc *)CC_coefTcL, 2},
    {"coef:c*", (lisp_proc *)CC_coefTcH, 2},
    {"coef:cano", (lisp_proc *)CC_coefTcano, 2},
    {"poly2coeflist", (lisp_proc *)CC_poly2coeflist, 2},
    {" coef", (lisp_proc *)CC_Acoef, 3},
    {" poly2coefset", (lisp_proc *)CC_Apoly2coefset, 2},
    {" coefpart", (lisp_proc *)CC_Acoefpart, 2},
    {" monocoef", (lisp_proc *)CC_Amonocoef, 2},
    {"#elements", (lisp_proc *)CC_Celements, 1},
    {"#terms", (lisp_proc *)CC_Cterms, 1},
    {NULL, NULL, 0 }
};

