#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_comproc.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex comproc_literal_vector[];
const char *comproc_literal_string[];
setup_type const  comproc_g_setup[];
#define LITERAL comproc_literal_vector




Sex CC_Wdecorder(Sex a)
{
    Sex q;
#define LL_compllessp LITERAL[0]
    q = LL_compllessp;
    {
        return  CC_WorderCs(a, q);
    }
}

Sex CC_Aabs(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = CC_Wbnum(a);
    if(a == nil) goto    G0004;
    a = w1;
    {
        popv(1);
        return  Labs(a);
    }
   G0004:
    a = LITERAL[1];
    {
        popv(1);
        return  CC_argerror(a);
    }
}

Sex CC_gB(Sex a)
{
    {
        return  CC_Afact(a);
    }
}

Sex CC_gBB(Sex a)
{
    {
        return  CC_Adfact(a);
    }
}

Sex CC_Afact(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = Lminusp(a);
    if(a == nil) goto    G0015;
    a = LITERAL[2];
    CC_argerror(a);
   G0015:
    a = w1;
    a = Lzerop(a);
    if(a != nil) goto    G0018;
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0017;
   G0018:
    a = mkfxat(1);
    goto    G0012;
   G0017:
    a = mkfxat(1);
    w3 = a;
    w2 = a;
   G0013:
    a = w3;
    a = Ladd1(a);
    w3 = a;
    q = w2;
    a = times2(a, q);
    w2 = a;
    q = w1;
    a = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G0013;
    a = w2;
   G0012:
    popv(3);
    return a;
}

Sex CC_Adfact(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    w1 = a;
    a = Lminusp(a);
    if(a == nil) goto    G0027;
    a = LITERAL[3];
    CC_argerror(a);
   G0027:
    a = w1;
    a = Lzerop(a);
    if(a != nil) goto    G0030;
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G0029;
   G0030:
    a = mkfxat(1);
    goto    G0024;
   G0029:
    a = w1;
    a = Loddp(a);
    if(a == nil) goto    G0032;
    a = mkfxat(1);
    w3 = a;
    w2 = a;
    goto    G0033;
   G0032:
    a = mkfxat(1);
    w2 = a;
    a = mkfxat(0);
    w3 = a;
   G0033:
    q = mkfxat(2);
    a = w3;
    a = plus2(a, q);
    w3 = a;
    q = w2;
    a = times2(a, q);
    w2 = a;
    q = w1;
    a = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G0033;
    a = w2;
   G0024:
    popv(3);
    return a;
}

Sex CC_Acombi(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    q = mkfxat(1);
    a = Llessp(a, q);
    if(a != nil) goto    G0056;
    q = w2;
    a = w1;
    a = Llessp(a, q);
    if(a == nil) goto    G0043;
   G0056:
    a = LITERAL[4];
    CC_argerror(a);
    goto    G0045;
   G0043:
    a = w2;
    a = Lzerop(a);
    if(a != nil) goto    G0057;
    q = w2;
    a = mkfxat(2);
    a = times2(a, q);
    q = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0045;
    a = w2;
    a = Lminus(a);
    q = a;
    a = w1;
    a = plus2(a, q);
    w2 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0057;
   G0045:
    a = w1;
    w3 = a;
    a = mkfxat(1);
    w4 = a;
    w5 = a;
   G0040:
    q = w2;
    a = w5;
    a = Lequal(a, q);
    if(a == nil) goto    G0052;
    q = w4;
    a = w3;
    {
        popv(5);
        return  Lmkrational(a, q);
    }
   G0052:
    a = w1;
    a = Lsub1(a);
    w1 = a;
    q = w3;
    a = times2(a, q);
    w3 = a;
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w4;
    a = times2(a, q);
    w4 = a;
    goto    G0040;
   G0057:
    a = mkfxat(1);
    popv(5);
    return a;
}

Sex CC_ArandomB24(Sex a)
{
    Sex q;
    if(a != nil) goto    G0061;
#define LL_Hrandom LITERAL[5]
    q = value(LL_Hrandom);
    goto    G0067;
   G0061:
    q = a;
   G0067:
    a = mkfxat(61);
    a = times2(a, q);
    q = mkfxat(5382391);
    a = plus2(a, q);
    q = mkfxat(16777216);
    a = remaind2(a, q);
    value(LL_Hrandom) = a;
    return a;
}

Sex CC_ArandomD8(Sex a)
{
    Sex q;
    if(a != nil) goto    G0071;
    q = value(LL_Hrandom);
    goto    G0077;
   G0071:
    q = a;
   G0077:
    a = mkfxat(137);
    a = times2(a, q);
    q = mkfxat(4273851);
    a = plus2(a, q);
    q = mkfxat(10000000);
    a = remaind2(a, q);
    value(LL_Hrandom) = a;
    return a;
}

Sex CC_Arandom1(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(a != nil) goto    G0081;
    a = mkfxat(3);
    a = Lfloat(a);
    q = mkfxat(7);
    a = quot2(a, q);
    goto    G0088;
   G0081:
    q = a;
    a = LITERAL[6];
    a = times2(a, q);
   G0088:
    q = LITERAL[7];
    a = plus2(a, q);
    w1 = a;
    a = Ltruncate(a);
    q = a;
    a = w1;
    a = diff2(a, q);
    value(LL_Hrandom) = a;
    popv(1);
    return a;
}

Sex CC_ArandomUniPol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6, Sex arg7, Sex arg8, Sex arg9)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 24;
    w24 = nil;
    w23 = nil;
    w22 = nil;
    w21 = nil;
    w20 = nil;
    w19 = nil;
    w18 = nil;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    w7 = arg7;
    w8 = arg8;
    w9 = arg9;
    q = mkfxat(0);
    a = Lleq(a, q);
    if(a != nil) goto    G0093;
    q = mkfxat(2);
    a = w3;
    a = Lleq(a, q);
    if(a != nil) goto    G0093;
    q = mkfxat(1);
    a = w4;
    a = Lleq(a, q);
    if(a == nil) goto    G0092;
   G0093:
    q = LITERAL[8];
    goto    G0153;
   G0092:
    q = mkfxat(0);
    a = w5;
    a = Lleq(a, q);
    if(a != nil) goto    G0095;
    q = mkfxat(1);
    a = w5;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0095;
    q = w5;
    a = w3;
    a = times2(a, q);
    q = LITERAL[9];
    a = Llessp(a, q);
    if(a == nil) goto    G0094;
   G0095:
    q = LITERAL[10];
    goto    G0153;
   G0094:
    q = LITERAL[11];
    a = w8;
    a = Lmember(a, q);
    if(a != nil) goto    G0097;
    q = LITERAL[12];
   G0153:
    a = mkfxat(3);
    {
        popv(24);
        return  CC_errormsg(a, q);
    }
   G0097:
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w19 = nil;
    w20 = nil;
    w21 = nil;
    w22 = nil;
    w23 = nil;
    a = w2;
    if(!is_cons(a)) goto    G0106;
    a = CC_Aexpr2varfunc(a);
    w2 = a;
   G0106:
    q = LITERAL[13];
    a = w6;
    a = Lmemq(a, q);
    if(a == nil) goto    G0108;
    a = nil;
    goto    G0109;
   G0108:
    a = true;
   G0109:
    w6 = a;
    q = LITERAL[13];
    a = w7;
    a = Lmemq(a, q);
    if(a == nil) goto    G0111;
    a = nil;
    goto    G0112;
   G0111:
    a = true;
   G0112:
    w7 = a;
    q = LITERAL[13];
    a = w9;
    a = Lmemq(a, q);
    if(a == nil) goto    G0114;
    a = nil;
    goto    G0115;
   G0114:
    a = true;
   G0115:
    w9 = a;
#define LL_Boset LITERAL[14]
    a = LL_Boset;
    a = Lncons(a);
    w11 = a;
    w10 = a;
    a = w3;
    a = Lfloat(a);
    w19 = a;
    q = mkfxat(2);
    a = quot2(a, q);
    w20 = a;
    q = mkfxat(3);
    a = w19;
    a = quot2(a, q);
    w21 = a;
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    w22 = a;
    a = w6;
    if(a == nil) goto    G0117;
    a = mkfxat(1);
    goto    G0118;
   G0117:
    a = w3;
    a = Llog(a);
   G0118:
    w23 = a;
    q = w4;
    a = mkfxat(2);
    a = times2(a, q);
    w14 = a;
    a = w9;
    if(a == nil) goto    G0120;
#define LL_Hrndmsave LITERAL[15]
    a = value(LL_Hrndmsave);
    if(a != nil) goto    G0100;
   G0120:
    a = LITERAL[16];
    a = CC_Arandom1(a);
    w24 = a;
    a = mkfxat(8765432);
    a = CC_ArandomD8(a);
    q = w24;
    a = Lxcons(a, q);
    value(LL_Hrndmsave) = a;
   G0100:
    a = w2;
    a = Lncons(a);
    w13 = a;
#define LL_CpolyC LITERAL[17]
    q = value(LL_CpolyC);
    a = Lxcons(a, q);
    w12 = a;
    a = car(value(LL_Hrndmsave));
    value(LL_Hrandom) = a;
    arg4 = w7;
    m = w6;
    q = w5;
    a = w3;
    a = CC_rndmUPolTexs(a, q, m, arg4);
    a = cdr(a);
    w15 = a;
    q = value(LL_Hrandom);
    a = value(LL_Hrndmsave);
    car(a) = q;
    q = w15;
    a = w13;
    cdr(a) = q;
    a = cdr(w13);
    w13 = a;
    a = w6;
    if(a == nil) goto    G0127;
    q = mkfxat(1);
    a = w3;
    a = cons(a, q);
    q = a;
    a = w13;
    car(a) = q;
    a = cdr(w13);
    w13 = a;
   G0127:
    a = cdr(value(LL_Hrndmsave));
    value(LL_Hrandom) = a;
   G0101:
    a = value(LL_Hrandom);
    a = CC_ArandomD8(a);
    value(LL_Hrandom) = a;
    q = w14;
    a = remaind2(a, q);
    w18 = a;
    a = w4;
    a = Lminus(a);
    q = a;
    a = w18;
    a = plus2(a, q);
    w17 = a;
    a = car(w13);
    w16 = a;
    arg8 = w23;
    arg7 = w22;
    arg6 = w21;
    arg5 = w20;
    arg4 = w19;
    m = a;
    q = w17;
    a = w8;
    a = CC_rndmCofTnrmlz(a, q, m, arg4, arg5, arg6, arg7, arg8);
    w17 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0131;
    q = w17;
    goto    G0155;
   G0131:
    q = w3;
    a = w16;
    a = Lequal(a, q);
    if(a != nil) goto    G0101;
    q = w4;
    a = w18;
    a = Llessp(a, q);
    if(a == nil) goto    G0134;
    q = mkfxat(-1);
    goto    G0155;
   G0134:
    q = mkfxat(1);
   G0155:
    a = w16;
    a = cons(a, q);
    q = a;
    a = w13;
    car(a) = q;
    a = cdr(w13);
    w13 = a;
    if(a != nil) goto    G0101;
    q = value(LL_Hrandom);
    a = value(LL_Hrndmsave);
    cdr(a) = q;
    a = w12;
    a = CC_Anumcont(a);
    a = Lonep(a);
    if(a == nil) goto    G0100;
    a = w12;
    a = CC_Alcoef(a);
    a = Lminusp(a);
    if(a == nil) goto    G0145;
    a = w12;
    a = CC_negTcano(a);
    w12 = a;
   G0145:
    a = w12;
    a = Lncons(a);
    q = a;
    a = w11;
    cdr(a) = q;
    a = cdr(a);
    w11 = a;
    a = w1;
    a = Lsub1(a);
    w1 = a;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0100;
    a = w10;
    popv(24);
    return a;
}

Sex CC_rndmUPolTexs(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = arg4;
    if(a == nil) goto    G0161;
    q = w1;
    a = w2;
    a = times2(a, q);
    w8 = a;
    a = w1;
    a = Ladd1(a);
    q = a;
    a = w8;
    a = quot2(a, q);
    goto    G0164;
   G0161:
    a = q;
   G0164:
    w7 = a;
    m = mkfxat(0);
    q = mkfxat(-1);
    a = w1;
    a = CC_AintSequence(a, q, m);
    w5 = a;
    a = cdr(a);
    w6 = a;
   G0159:
    a = value(LL_Hrandom);
    a = CC_Arandom1(a);
    value(LL_Hrandom) = a;
    q = w7;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0166;
    q = cdr(cdr(w6));
    a = w6;
    cdr(a) = q;
    goto    G0167;
   G0166:
    a = cdr(w6);
    w6 = a;
   G0167:
    a = cdr(w6);
    if(a == nil) goto    G0173;
    a = cdr(a);
    if(a != nil) goto    G0159;
    a = w4;
    if(a == nil) goto    G0159;
   G0173:
    a = w5;
    popv(8);
    return a;
}

Sex CC_rndmCofTnrmlz(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6, Sex arg7, Sex arg8)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    w7 = arg7;
    w8 = arg8;
    q = mkfxat(333333);
    a = Lequal(a, q);
    if(a != nil) goto    G0228;
    q = mkfxat(123321);
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G0178;
    q = w6;
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0180;
    a = w3;
    a = Lminus(a);
    q = w8;
    a = plus2(a, q);
    q = a;
    a = w4;
    goto    G0222;
   G0180:
    q = w7;
    a = w3;
    a = Llessp(a, q);
    if(a == nil) goto    G0228;
    q = w8;
    a = w3;
   G0222:
    a = plus2(a, q);
    q = a;
    a = w2;
    a = times2(a, q);
    w9 = a;
    q = w8;
    a = w7;
    goto    G0227;
   G0178:
    q = mkfxat(123456);
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G0193;
    a = w3;
    a = Lminus(a);
    q = w8;
    a = plus2(a, q);
    q = a;
    a = w4;
    a = plus2(a, q);
    q = a;
    a = w2;
    a = times2(a, q);
    w9 = a;
    q = w8;
    a = w4;
    goto    G0227;
   G0193:
    q = mkfxat(654321);
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G0200;
    q = w8;
    a = w3;
    a = plus2(a, q);
    q = a;
    a = w2;
    a = times2(a, q);
    w9 = a;
    q = w8;
    a = w4;
    goto    G0227;
   G0200:
    q = mkfxat(123444);
    a = w1;
    a = Lequal(a, q);
    q = w5;
    if(a == nil) goto    G0205;
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0228;
    a = w3;
    a = Lminus(a);
    q = w8;
    a = plus2(a, q);
    q = a;
    a = w4;
    a = plus2(a, q);
    q = a;
    a = w2;
    a = times2(a, q);
    w9 = a;
    q = w8;
    a = w5;
    goto    G0227;
   G0205:
    a = w3;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0215;
   G0228:
    a = w2;
    goto    G0216;
   G0215:
    q = w8;
    a = w3;
    a = plus2(a, q);
    q = a;
    a = w2;
    a = times2(a, q);
    w9 = a;
    q = w8;
    a = w5;
   G0227:
    a = plus2(a, q);
    q = a;
    a = w9;
    a = quot2(a, q);
    a = Ltruncate(a);
   G0216:
    popv(9);
    return a;
}

Sex CC_AintSequence(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = q;
    a = Lzerop(a);
    if(a != nil) goto    G0257;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    q = w3;
    if(a == nil) goto    G0236;
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0241;
    goto    G0257;
   G0236:
    a = w1;
    a = Llessp(a, q);
    if(a == nil) goto    G0241;
   G0257:
    a = LITERAL[18];
    CC_argerror(a);
   G0241:
    a = w1;
    a = Lncons(a);
    w5 = a;
    q = LL_Boset;
    a = Lxcons(a, q);
    w4 = a;
    a = w1;
    w6 = a;
    q = mkfxat(0);
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0233;
   G0245:
    q = w2;
    a = w6;
    a = plus2(a, q);
    w6 = a;
    q = w3;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0258;
    a = w6;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G0245;
   G0233:
    q = w2;
    a = w6;
    a = plus2(a, q);
    w6 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G0258;
    a = w6;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G0233;
   G0258:
    a = w4;
    popv(6);
    return a;
}

Sex CC_Adecsort(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = CC_Wnoargchk();
    if(a != nil) goto    G0266;
    a = w1;
    a = CC_Woset(a);
    if(a != nil) goto    G0265;
    q = LITERAL[19];
    a = LITERAL[20];
    goto    G0269;
   G0265:
    q = cdr(w1);
#define LL_numberp LITERAL[21]
    a = LL_numberp;
    a = CC_Wchklist(a, q);
    if(a != nil) goto    G0266;
    q = LITERAL[19];
    a = LITERAL[22];
   G0269:
    CC_errormsg(a, q);
   G0266:
#define LL_complgeqp LITERAL[23]
    q = LL_complgeqp;
    a = cdr(w1);
    a = CC_sortCs(a, q);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
}

Sex CC_Asortbyabs(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(a);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w4 = a;
   G0273:
    a = car(w4);
    a = CC_abs2(a);
    q = car(w4);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0273;
#define LL_greaterp LITERAL[24]
    q = LL_greaterp;
    a = cdr(w2);
    a = CC_seTsortbycar(a, q);
    w3 = a;
    CC_seTlistcdr(a);
    q = w3;
    a = w2;
    {
        popv(4);
        cdr(a) = q;
 return a;
    }
}

Sex CC_Acluster(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    a = CC_Wnoargchk();
    if(a != nil) goto    G0303;
    a = w1;
    a = CC_Wset(a);
    if(a != nil) goto    G0298;
    a = w1;
    a = CC_Woset(a);
    if(a != nil) goto    G0298;
    q = LITERAL[25];
    a = LITERAL[26];
    goto    G0366;
   G0298:
    q = cdr(w1);
    a = LL_numberp;
    a = CC_Wchklist(a, q);
    if(a != nil) goto    G0300;
    q = LITERAL[25];
    a = LITERAL[22];
    goto    G0366;
   G0300:
    a = w2;
    if(a == nil) goto    G0303;
#define LL_Anil LITERAL[27]
    if(a == LL_Anil) goto    G0303;
    if(!is_number(a)) goto    G0304;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0303;
   G0304:
    q = LITERAL[25];
    a = LITERAL[28];
   G0366:
    CC_errormsg(a, q);
   G0303:
    a = cdr(cdr(w1));
    if(a != nil) goto    G0306;
    q = w1;
#define LL_Bset LITERAL[29]
    a = LL_Bset;
    {
        popv(12);
        return  Llist2(a, q);
    }
   G0306:
    a = car(w1);
    w10 = a;
#define LL_rpartgeqp LITERAL[30]
    q = LL_rpartgeqp;
    a = cdr(w1);
    a = CC_sortCs(a, q);
    w1 = a;
    a = w2;
    if(is_number(a)) goto    G0287;
    a = car(w1);
    a = CC_realpart(a);
    w12 = a;
    a = w1;
    a = Llast(a);
    a = CC_realpart(a);
    a = Lminus(a);
    q = a;
    a = w12;
    a = plus2(a, q);
    w2 = a;
#define LL_ipartgeqp LITERAL[31]
    q = LL_ipartgeqp;
    a = w1;
    a = CC_sortCs(a, q);
    w5 = a;
    a = car(a);
    a = CC_imagpart(a);
    w12 = a;
    a = w5;
    a = Llast(a);
    a = CC_imagpart(a);
    a = Lminus(a);
    q = a;
    a = w12;
    a = plus2(a, q);
    w7 = a;
    a = w2;
    a = Labs(a);
    w12 = a;
    a = w7;
    a = Labs(a);
    q = a;
    a = w12;
    a = Lmax2(a, q);
    q = a;
    a = LITERAL[32];
    a = times2(a, q);
    w12 = a;
    a = w1;
    a = Llength(a);
    q = a;
    a = w12;
    a = quot2(a, q);
    w2 = a;
   G0287:
    a = LL_Bset;
    a = Lncons(a);
    w5 = a;
    w3 = a;
   G0288:
    a = w10;
    a = Lncons(a);
    w7 = a;
    w6 = a;
    a = car(w1);
    w8 = a;
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
   G0289:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0290;
    a = car(a);
    w9 = a;
    a = w8;
    a = CC_realpart(a);
    w12 = a;
    a = w9;
    a = CC_realpart(a);
    a = Lminus(a);
    q = a;
    a = w12;
    a = plus2(a, q);
    w8 = a;
    a = Labs(a);
    q = w2;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0290;
    a = w9;
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = w9;
    w8 = a;
    goto    G0289;
   G0290:
    a = w6;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = w1;
    if(a != nil) goto    G0288;
    a = w11;
    if(a != nil) goto    G0364;
    a = cdr(w3);
    w4 = a;
    a = LL_Bset;
    a = Lncons(a);
    w5 = a;
    w3 = a;
   G0291:
    a = car(w4);
    w1 = a;
    a = cdr(cdr(a));
    if(a != nil) goto    G0343;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G0362;
   G0343:
    q = LL_ipartgeqp;
    a = cdr(w1);
    a = CC_sortCs(a, q);
    w1 = a;
   G0292:
    a = w10;
    a = Lncons(a);
    w7 = a;
    w6 = a;
    a = car(w1);
    w8 = a;
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
   G0293:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0294;
    a = car(a);
    w9 = a;
    a = w8;
    a = CC_imagpart(a);
    w12 = a;
    a = w9;
    a = CC_imagpart(a);
    a = Lminus(a);
    q = a;
    a = w12;
    a = plus2(a, q);
    w8 = a;
    a = Labs(a);
    q = w2;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0294;
    a = w9;
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = w9;
    w8 = a;
    goto    G0293;
   G0294:
    a = w6;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = w1;
    if(a != nil) goto    G0292;
   G0362:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0291;
   G0364:
    a = w3;
    popv(12);
    return a;
}

Sex CC_Acluster2(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Wnoargchk();
    if(a != nil) goto    G0386;
    a = w1;
    a = CC_Wset(a);
    if(a != nil) goto    G0378;
    a = w1;
    a = CC_Woset(a);
    if(a == nil) goto    G0379;
   G0378:
    a = w2;
    a = CC_Wset(a);
    if(a != nil) goto    G0376;
    a = w2;
    a = CC_Woset(a);
    if(a != nil) goto    G0376;
   G0379:
    q = LITERAL[33];
    a = LITERAL[26];
    goto    G0403;
   G0376:
    a = w1;
    a = Llength(a);
    w10 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w10;
    a = Lequal(a, q);
    if(a != nil) goto    G0380;
    q = LITERAL[33];
    a = LITERAL[34];
    goto    G0403;
   G0380:
    q = cdr(w2);
    a = LL_numberp;
    a = CC_Wchklist(a, q);
    if(a != nil) goto    G0383;
    q = LITERAL[33];
    a = LITERAL[35];
    goto    G0403;
   G0383:
    a = w3;
    if(a == nil) goto    G0386;
    if(a == LL_Anil) goto    G0386;
    if(!is_number(a)) goto    G0387;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0386;
   G0387:
    q = LITERAL[33];
    a = LITERAL[36];
   G0403:
    CC_errormsg(a, q);
   G0386:
    a = cdr(cdr(w1));
    if(a != nil) goto    G0389;
    q = w1;
    a = LL_Bset;
    {
        popv(10);
        return  Llist2(a, q);
    }
   G0389:
    a = car(w1);
    w9 = a;
    q = cdr(w1);
    a = cdr(w2);
    a = Lpair(a, q);
    w1 = a;
    CC_killargchk();
    q = w3;
    a = w2;
    a = CC_Acluster(a, q);
    w2 = a;
    CC_recovargchk();
    a = w2;
#define LL_Hbyproduct LITERAL[37]
    value(LL_Hbyproduct) = a;
    a = LL_Bset;
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w2);
    w2 = a;
   G0372:
    a = w9;
    a = Lncons(a);
    w7 = a;
    w6 = a;
    a = cdr(car(w2));
    w8 = a;
   G0373:
    q = w1;
    a = car(w8);
    a = Lassoc(a, q);
    a = cdr(a);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = cdr(w8);
    w8 = a;
    if(a != nil) goto    G0373;
    a = w6;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0372;
    a = w4;
    popv(10);
    return a;
}

Sex CC_mksymbol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_var LITERAL[38]
    if(a != LL_var) goto    G0407;
    a = Lgensym();
    q = LL_var;
    goto    G0413;
   G0407:
    q = LITERAL[39];
    a = Lmemq(a, q);
    if(a != nil) goto    G0410;
    q = LITERAL[40];
    a = w1;
    a = Lmemq(a, q);
    if(a != nil) goto    G0410;
    q = LITERAL[41];
    a = w1;
    a = Lmemq(a, q);
    if(a != nil) goto    G0410;
    q = LITERAL[42];
    a = w1;
    a = Lmemq(a, q);
    if(a == nil) goto    G0409;
   G0410:
    a = Lgensym();
    q = w1;
   G0413:
    {
        popv(1);
        return  CC_internTid(a, q);
    }
   G0409:
    q = w1;
    a = LITERAL[43];
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
}

Sex CC_Amkvar(void)
{
    Sex a, q;
    a = Lgensym();
    q = LL_var;
    {
        return  CC_internTid(a, q);
    }
}

Sex CC_Amkpow(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_cons(a)) goto    G0421;
    a = car(a);
   G0421:
#define LL_Bgid LITERAL[44]
    q = LL_Bgid;
    a = Lget(a, q);
    q = mkfxat(1);
    a = Lgetv(a, q);
    a = car(a);
#define LL_Htemporal LITERAL[45]
    value(LL_Htemporal) = a;
#define LL_algn LITERAL[46]
    if(a != LL_algn) goto    G0426;
#define LL_CalgnC LITERAL[47]
    a = value(LL_CalgnC);
    goto    G0428;
   G0426:
#define LL_algf LITERAL[48]
    if(a != LL_algf) goto    G0427;
#define LL_CalgfC LITERAL[49]
    a = value(LL_CalgfC);
    goto    G0428;
   G0427:
    a = value(LL_CpolyC);
   G0428:
    value(LL_Htemporal) = a;
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    m = a;
    q = w1;
    a = value(LL_Htemporal);
    {
        popv(2);
        return  Llist3(a, q, m);
    }
}

Sex CC_Aputtdeg(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
   G0449:
    w1 = a;
    w2 = q;
    if(is_number(a)) goto    G0444;
    a = CC_Wnoargchk();
    if(a != nil) goto    G0443;
    a = w1;
    a = CC_Wbnum(a);
    if(a == nil) goto    G0436;
    a = w1;
    goto    G0444;
   G0436:
    a = w1;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0437;
    q = LITERAL[50];
    a = mkfxat(8);
    goto    G0448;
   G0437:
    a = w2;
    if(a == nil) goto    G0439;
    if(a != LL_Anil) goto    G0438;
   G0439:
    a = CC_Amkvar();
    w2 = a;
    a = Lncons(a);
    CC_Aorder(a);
    q = w2;
    a = w1;
    goto    G0449;  /* recursive call to  puttdeg */
   G0438:
    a = CC_Wsingleid(a);
    w2 = a;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0441;
    q = LITERAL[50];
    a = LITERAL[51];
    goto    G0448;
   G0441:
    q = w2;
    a = car(cdr(w1));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0443;
    q = w2;
    a = LITERAL[52];
   G0448:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
   G0443:
    q = w2;
    a = cdr(w1);
    a = CC_puttdegTbpol(a, q);
    q = car(w1);
    a = Lxcons(a, q);
   G0444:
    popv(2);
    return a;
}

Sex CC_Aputtdeg1(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_number(a)) goto    G0453;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = CC_Wnoargchk();
    if(a != nil) goto    G0461;
    a = w1;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0482;
    a = w1;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0460;
    q = LITERAL[53];
    a = mkfxat(8);
    goto    G0480;
   G0460:
    a = w2;
    if(a == nil) goto    G0462;
    if(a == LL_Anil) goto    G0462;
    a = CC_Wsingleid(a);
    w2 = a;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0461;
   G0462:
    q = LITERAL[53];
    a = LITERAL[51];
   G0480:
    CC_errormsg(a, q);
   G0461:
    a = cdr(w1);
    w4 = a;
    a = car(a);
    w6 = a;
   G0456:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0465;
    q = w3;
    a = car(w1);
    {
        popv(7);
        return  cons(a, q);
    }
   G0465:
    a = cdr(car(a));
    w5 = a;
    if(is_number(a)) goto    G0471;
    a = car(a);
    a = CC_Wtag(a);
    if(a != nil) goto    G0471;
    q = w2;
    a = car(w5);
    a = CC_WorderTvar(a, q);
    q = w2;
    if(a == nil) goto    G0470;
    a = LITERAL[52];
    CC_errormsg(a, q);
    goto    G0471;
   G0470:
    a = w5;
    a = CC_puttdegTbpol(a, q);
    w5 = a;
   G0471:
    a = car(car(w4));
    w7 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0473;
    q = w5;
    a = w3;
    a = CC_seseLbpolany(a, q);
    goto    G0479;
   G0473:
    q = mkfxat(1);
    a = w7;
    a = cons(a, q);
    q = a;
    a = w6;
    a = Llist2(a, q);
    q = w5;
    a = CC_Hbpolany(a, q);
    w7 = a;
    a = w3;
    if(a != nil) goto    G0478;
    a = w7;
    goto    G0479;
   G0478:
    q = a;
    a = w7;
    a = CC_seseLbpolbpol(a, q);
   G0479:
    w3 = a;
    goto    G0456;
   G0482:
    a = w1;
   G0453:
    popv(7);
    return a;
}

Sex CC_puttdegTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w9 = nil;
    w8 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w10 = nil;
    w1 = a;
    w2 = q;
    a = CC_revordTbpol(a);
    w8 = a;
   G0486:
    a = car(cdr(w8));
    w9 = a;
    q = car(a);
    a = car(w8);
    a = cons(a, q);
    q = w6;
    a = cons(a, q);
    w6 = a;
    q = w7;
    a = cdr(w8);
    a = cons(a, q);
    w7 = a;
    a = cdr(w9);
    w8 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G0493;
    a = car(w8);
    a = CC_Wtag(a);
    if(a == nil) goto    G0486;
   G0493:
    q = w6;
    a = w8;
    a = cons(a, q);
    w6 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    goto    G0488;
   G0487:
    q = w7;
    a = cdr(w6);
    a = CC_tdgTnextmono(a, q);
    w10 = a;
    a = CC_Wnull(a);
    if(a == nil) goto    G0496;
    q = w2;
    a = w3;
    {
        popv(10);
        car(a) = q;
 return a;
    }
   G0496:
    a = car(w10);
    w6 = a;
    a = cdr(w10);
    w7 = a;
   G0488:
    a = mkfxat(0);
    w4 = a;
    a = car(w6);
    w5 = a;
    a = w6;
    w8 = a;
   G0489:
    a = cdr(w8);
    w8 = a;
    a = CC_Wnull(a);
    if(a == nil) goto    G0499;
    a = w3;
    goto    G0516;
   G0499:
    a = cdr(car(w8));
    w10 = a;
    a = CC_Wzero(a);
    if(a != nil) goto    G0489;
    q = w5;
    a = w10;
    a = cons(a, q);
    q = a;
    a = car(car(w8));
    a = Llist2(a, q);
    w5 = a;
    q = w10;
    a = w4;
    a = plus2(a, q);
    w4 = a;
    goto    G0489;
   G0503:
    a = cdr(w8);
    w10 = a;
    a = CC_Wnull(a);
    if(a == nil) goto    G0506;
    q = w5;
    a = w4;
    a = cons(a, q);
    a = Lncons(a);
    goto    G0517;
   G0506:
    q = car(car(w10));
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0510;
    q = w5;
    a = w4;
    a = cons(a, q);
    q = w10;
    a = cons(a, q);
   G0517:
    q = a;
    a = w8;
    goto    G0518;
   G0510:
    q = car(car(w10));
    a = w4;
    a = Lequal(a, q);
    if(a == nil) goto    G0513;
    q = cdr(car(w10));
    a = w5;
    a = CC_seseLbpolbpol(a, q);
    q = a;
    a = car(w10);
   G0518:
    cdr(a) = q;
    goto    G0487;
   G0513:
    a = w10;
   G0516:
    w8 = a;
    goto    G0503;
}

Sex CC_tdgTnextmono(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
   G0541:
    w1 = a;
    a = q;
    if(a == nil) goto    G0523;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(car(a));
    w5 = a;
    w2 = q;
    if(a != nil) goto    G0527;
    q = cdr(q);
    a = cdr(w1);
    goto    G0541;  /* recursive call to tdg:nextmono */
   G0527:
    q = car(car(a));
    a = car(w1);
    cdr(a) = q;
    q = w5;
    a = w2;
    car(a) = q;
    a = cdr(car(w5));
    w3 = a;
    if(is_number(a)) goto    G0537;
    a = car(a);
    if(is_integer(a)) goto    G0537;
   G0530:
    a = car(cdr(w3));
    w4 = a;
    q = car(a);
    a = car(w3);
    a = cons(a, q);
    q = w1;
    a = cons(a, q);
    w1 = a;
    q = w2;
    a = cdr(w3);
    a = cons(a, q);
    w2 = a;
    a = cdr(w4);
    w3 = a;
    if(is_number(a)) goto    G0537;
    a = car(a);
    if(!is_integer(a)) goto    G0530;
   G0537:
    q = w1;
    a = w3;
    a = cons(a, q);
    q = w2;
    a = cons(a, q);
   G0523:
    popv(5);
    return a;
}

Sex CC_Altelim(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Wnoargchk();
    if(a != nil) goto    G0548;
    a = w1;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0549;
    a = w2;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0548;
   G0549:
    q = LITERAL[54];
    a = LITERAL[55];
    CC_errormsg(a, q);
   G0548:
    q = w2;
    a = w1;
    a = CC_ltelimTpolypoly(a, q);
    w3 = a;
    a = car(a);
#define LL_Hquotient LITERAL[56]
    value(LL_Hquotient) = a;
    a = cdr(w3);
    popv(3);
    return a;
}

Sex CC_ltelimTpolypoly(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = cdr(q);
    a = cdr(a);
    a = CC_ltelimTbpolbpol(a, q);
    w3 = a;
    a = car(a);
    if(is_number(a)) goto    G0556;
    a = car(a);
    if(is_integer(a)) goto    G0556;
    q = car(w3);
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
   G0556:
    a = cdr(w3);
    if(is_number(a)) goto    G0561;
    a = car(a);
    if(is_integer(a)) goto    G0561;
    q = cdr(w3);
    a = car(w1);
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
   G0561:
    a = w3;
    popv(3);
    return a;
}

Sex CC_ltelimTbpolbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G0566;
    q = w2;
    a = w1;
    {
        popv(9);
        return  CC_VLbpolbpol(a, q);
    }
   G0566:
    q = car(w1);
    a = car(w2);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0567;
    q = w1;
    a = mkfxat(0);
    {
        popv(9);
        return  cons(a, q);
    }
   G0567:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = car(w1);
    w8 = a;
    a = cdr(w1);
    w1 = a;
    a = w8;
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = w8;
    a = Lncons(a);
    w6 = a;
    w5 = a;
   G0570:
    a = cdr(car(w1));
    w8 = a;
    if(is_number(a)) goto    G0574;
    a = car(a);
    if(!is_integer(a)) goto    G0573;
   G0574:
    a = car(w1);
    goto    G0592;
   G0573:
    q = w2;
    a = w8;
    a = CC_ltelimTbpolbpol(a, q);
    w8 = a;
    a = car(car(w1));
    w7 = a;
    a = car(w8);
    a = Lzerop(a);
    if(a != nil) goto    G0578;
    q = car(w8);
    a = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0578:
    a = cdr(w8);
    a = Lzerop(a);
    if(a != nil) goto    G0583;
    q = cdr(w8);
    a = w7;
    a = cons(a, q);
   G0592:
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G0583:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0570;
    a = w3;
    a = CC_reduceTbpol(a);
    w9 = a;
    a = w5;
    a = CC_reduceTbpol(a);
    q = w9;
    {
        popv(9);
        return  Lxcons(a, q);
    }
}

Sex CC_Agcrpower(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(is_cons(a)) goto    G0596;
    if(!is_number(a)) goto    G0623;
    goto    G0621;
   G0596:
    a = car(a);
    if(!is_integer(a)) goto    G0623;
    q = mkfxat(240);
    a = Lilogand2(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G0601;
   G0623:
    q = LITERAL[57];
    a = mkfxat(3);
    {
        popv(4);
        return  CC_errormsg(a, q);
    }
   G0601:
#define LL_CratfC LITERAL[58]
    if(car(w1) >= value(LL_CratfC)) goto    G0603;
    w2 = nil;
    w3 = nil;
    q = mkfxat(0);
    a = car(cdr(w1));
    a = cons(a, q);
    a = Lncons(a);
    w2 = a;
    q = a;
    a = cdr(w1);
    CC_gcrpowTbpol(a, q);
    q = w2;
    a = CHAR_OF(104);
    a = cons(a, q);
    w3 = a;
    w2 = a;
   G0605:
    a = cdr(car(cdr(w3)));
    a = Lonep(a);
    if(a == nil) goto    G0608;
    q = cdr(cdr(w3));
    a = w3;
    cdr(a) = q;
    goto    G0609;
   G0608:
    a = cdr(w3);
    w3 = a;
   G0609:
    a = cdr(w3);
    if(a != nil) goto    G0605;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0613;
   G0621:
    a = mkfxat(1);
    goto    G0620;
   G0613:
    q = a;
    a = w1;
    a = CC_reduceTvars(a, q);
    value(LL_Hbyproduct) = a;
    a = w2;
    a = CC_tail(a);
    w4 = a;
    q = mkfxat(1);
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = w2;
    a = CC_mkTmono(a);
    q = car(w1);
    {
        popv(4);
        return  Lxcons(a, q);
    }
   G0603:
    a = w1;
    a = CC_gcrpowTratf(a);
   G0620:
    popv(4);
    return a;
}

Sex CC_gcrpowTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(car(q));
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G0627;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = cdr(w1);
    w3 = a;
    a = cdr(car(w2));
    w4 = a;
   G0629:
    a = car(car(w3));
    w5 = a;
    a = cdr(car(w3));
    w6 = a;
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G0631;
    q = w4;
    a = w5;
    a = gcd(a, q);
    w4 = a;
   G0631:
    a = w6;
    if(is_number(a)) goto    G0635;
    a = car(a);
    if(is_integer(a)) goto    G0635;
    q = w2;
    a = w6;
    CC_gcrpowTbpol(a, q);
   G0635:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0629;
    q = w4;
    a = car(w2);
    cdr(a) = q;
    a = nil;
    goto    G0642;
   G0627:
    a = cdr(w2);
    if(a != nil) goto    G0638;
    q = mkfxat(0);
    a = car(w1);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    goto    G0646;
   G0638:
    q = car(car(a));
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G0646;
    q = mkfxat(0);
    a = car(w1);
    a = cons(a, q);
    q = cdr(w2);
    a = cons(a, q);
    q = a;
    a = w2;
    cdr(a) = q;
   G0646:
    q = cdr(w2);
    a = w1;
    a = CC_gcrpowTbpol(a, q);
   G0642:
    popv(6);
    return a;
}

Sex CC_Arevunipol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(cdr(a));
    w4 = a;
    a = car(car(a));
    w3 = a;
   G0650:
    a = car(w4);
    w5 = a;
    a = car(a);
    a = Lminus(a);
    q = a;
    a = w3;
    a = plus2(a, q);
    w6 = a;
    q = cdr(w5);
    a = cons(a, q);
    q = w2;
    a = cons(a, q);
    w2 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0650;
    q = w2;
    a = car(cdr(w1));
    a = cons(a, q);
    w2 = a;
    q = car(w1);
    {
        popv(6);
        return  Lxcons(a, q);
    }
}

Sex CC_reduceTvars(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    if(car(a) >= value(LL_CratfC)) goto    G0660;
    w1 = a;
    a = cdr(a);
    a = CC_redvarsTbpol(a, q);
    q = car(w1);
    {
        popv(1);
        return  Lxcons(a, q);
    }
   G0660:
    {
        popv(1);
        return  CC_redvarsTratf(a, q);
    }
}

Sex CC_redvarsTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = car(car(q));
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G0666;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = cdr(w1);
    w3 = a;
    a = cdr(car(w2));
    w4 = a;
    a = car(w1);
    a = Lncons(a);
    w8 = a;
    w7 = a;
   G0668:
    q = w4;
    a = car(car(w3));
    a = quot2(a, q);
    w5 = a;
    a = cdr(car(w3));
    w6 = a;
    if(is_number(a)) goto    G0673;
    a = car(a);
    if(is_integer(a)) goto    G0673;
    a = cdr(w2);
    if(a == nil) goto    G0673;
    q = a;
    a = w6;
    a = CC_redvarsTbpol(a, q);
    w6 = a;
   G0673:
    q = w6;
    a = w5;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0668;
    a = w7;
    goto    G0692;
   G0666:
    q = car(car(w2));
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0679;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = cdr(w1);
    w3 = a;
    a = car(w1);
    a = Lncons(a);
    w7 = a;
    w6 = a;
   G0681:
    a = car(car(w3));
    w4 = a;
    a = cdr(car(w3));
    w5 = a;
    if(is_number(a)) goto    G0685;
    a = car(a);
    if(is_integer(a)) goto    G0685;
    q = w2;
    a = w5;
    a = CC_redvarsTbpol(a, q);
    w5 = a;
   G0685:
    q = w5;
    a = w4;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0681;
    a = w6;
    goto    G0692;
   G0679:
    a = cdr(w2);
    if(a != nil) goto    G0691;
    a = w1;
    goto    G0692;
   G0691:
    q = a;
    a = w1;
    a = CC_redvarsTbpol(a, q);
   G0692:
    popv(8);
    return a;
}

Sex CC_Aiqdiv2polnum(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Wbnum(a);
    if(a == nil) goto    G0696;
    q = w2;
    a = w1;
    a = CC_iqdiv2(a, q);
    w2 = a;
    m = cdr(a);
    q = car(a);
    goto    G0706;
   G0696:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    q = w2;
    a = cdr(w1);
    a = CC_iqdiv2Tbpolnum(a, q);
    w5 = a;
    a = car(a);
    w3 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G0700;
    q = w3;
    a = car(w1);
    a = cons(a, q);
    w3 = a;
   G0700:
    a = cdr(w5);
    w4 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G0703;
    q = w4;
    a = car(w1);
    a = cons(a, q);
    w4 = a;
   G0703:
    m = w4;
    q = w3;
   G0706:
    a = LL_Boset;
    {
        popv(5);
        return  Llist3(a, q, m);
    }
}

Sex CC_iqdiv2Tbpolnum(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = car(w1);
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = cdr(w1);
    w7 = a;
   G0710:
    a = car(w7);
    w8 = a;
    a = cdr(a);
    w9 = a;
    a = CC_Wbnum(a);
    q = w2;
    if(a == nil) goto    G0713;
    a = w9;
    a = CC_iqdiv2(a, q);
    goto    G0732;
   G0713:
    a = w9;
    a = CC_iqdiv2Tbpolnum(a, q);
   G0732:
    w9 = a;
    a = car(w9);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0718;
    q = w10;
    a = car(w8);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0718:
    a = cdr(w9);
    w11 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0725;
    q = w11;
    a = car(w8);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G0725:
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G0710;
    a = w3;
    a = CC_reduceTbpol(a);
    w3 = a;
    a = w5;
    a = CC_reduceTbpol(a);
    w5 = a;
    q = w3;
    {
        popv(11);
        return  Lxcons(a, q);
    }
}

Sex CC_Anorm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = LITERAL[59];
#define LL_Hchkcoef LITERAL[60]
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_normTbnum LITERAL[61]
    a = LL_normTbnum;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    popv(1);
    return a;
}

Sex CC_normTbnum(Sex a)
{
    Sex q;
    a = Labs(a);
    q = a;
    a = value(LL_Hchkcoef);
    a = Lmax2(a, q);
    value(LL_Hchkcoef) = a;
    return a;
}

Sex CC_Anorm1(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = LITERAL[59];
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_norm1Tbnum LITERAL[62]
    a = LL_norm1Tbnum;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    popv(1);
    return a;
}

Sex CC_norm1Tbnum(Sex a)
{
    Sex q;
    a = Labs(a);
    q = a;
    a = value(LL_Hchkcoef);
    a = plus2(a, q);
    value(LL_Hchkcoef) = a;
    return a;
}

Sex CC_Anorm2(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = LITERAL[59];
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_norm2Tbnum LITERAL[63]
    a = LL_norm2Tbnum;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    {
        popv(1);
        return  Lsqrt(a);
    }
}

Sex CC_norm2Tbnum(Sex a)
{
    Sex q;
    a = Labs(a);
    q = mkfxat(2);
    a = Lexpt(a, q);
    q = a;
    a = value(LL_Hchkcoef);
    a = plus2(a, q);
    value(LL_Hchkcoef) = a;
    return a;
}

Sex CC_Ammc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0752;
    {
        popv(1);
        return  Labs(a);
    }
   G0752:
    a = car(a);
    if(!is_integer(a)) goto    G0753;
    q = value(LL_CratfC);
    a = Llessp(a, q);
    if(a == nil) goto    G0753;
    q = mkfxat(0);
    a = cdr(w1);
    {
        popv(1);
        return  CC_mmcTbpol(a, q);
    }
   G0753:
    q = LITERAL[64];
    a = LITERAL[55];
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
}

Sex CC_Ammcrat(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(!is_number(a)) goto    G0759;
    {
        popv(2);
        return  Labs(a);
    }
   G0759:
    a = car(a);
    if(!is_integer(a)) goto    G0760;
    q = value(LL_CratfC);
    a = Llessp(a, q);
    if(a == nil) goto    G0762;
    q = mkfxat(0);
    a = cdr(w1);
    {
        popv(2);
        return  CC_mmcTbpol(a, q);
    }
   G0762:
    q = value(LL_CratfC);
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G0763;
    a = w1;
    a = CC_Anumer(a);
    a = CC_Ammc(a);
    w2 = a;
    a = w1;
    a = CC_Adenom(a);
    a = CC_Ammc(a);
    q = a;
    a = w2;
    {
        popv(2);
        return  quot2(a, q);
    }
   G0763:
    q = LITERAL[64];
    a = LITERAL[65];
    goto    G0770;
   G0760:
    q = LITERAL[64];
    a = LITERAL[66];
   G0770:
    {
        popv(2);
        return  CC_errormsg(a, q);
    }
}

Sex CC_Aqmmc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0774;
    {
        popv(1);
        return  CC_qabs(a);
    }
   G0774:
    a = car(a);
    if(!is_integer(a)) goto    G0775;
    q = value(LL_CratfC);
    a = Llessp(a, q);
    if(a == nil) goto    G0775;
    q = mkfxat(0);
    a = cdr(w1);
    {
        popv(1);
        return  CC_qmmcTbpol(a, q);
    }
   G0775:
    q = LITERAL[67];
    a = LITERAL[55];
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
}

Sex CC_Asqnorm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_number(a)) goto    G0781;
    {
        popv(4);
        return  Labs(a);
    }
   G0781:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = cdr(cdr(a));
    w2 = a;
    a = mkfxat(0);
    w4 = a;
   G0784:
    a = cdr(car(w2));
    w3 = a;
    q = a;
    a = times2(a, q);
    q = a;
    a = w4;
    a = plus2(a, q);
    w4 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0784;
    a = w4;
    {
        popv(4);
        return  Lsqrt(a);
    }
}

Sex CC_mmcTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
   G0792:
    a = cdr(car(w3));
    w4 = a;
    if(!is_number(a)) goto    G0794;
    a = Labs(a);
    q = a;
    a = w2;
    a = Lmax2(a, q);
    goto    G0797;
   G0794:
    a = car(a);
    q = w2;
    if(!is_integer(a)) goto    G0796;
    a = cdr(w4);
    goto    G0800;
   G0796:
    a = w4;
   G0800:
    a = CC_mmcTbpol(a, q);
   G0797:
    w2 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0792;
    a = w2;
    popv(4);
    return a;
}

Sex CC_qmmcTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = cdr(a);
    w3 = a;
    w2 = q;
   G0804:
    a = cdr(car(w3));
    w4 = a;
    if(!is_number(a)) goto    G0806;
    a = CC_qabs(a);
    q = a;
    a = w2;
    a = Lmax2(a, q);
    goto    G0809;
   G0806:
    a = car(a);
    q = w2;
    if(!is_integer(a)) goto    G0808;
    a = cdr(w4);
    goto    G0812;
   G0808:
    a = w4;
   G0812:
    a = CC_qmmcTbpol(a, q);
   G0809:
    w2 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0804;
    a = w2;
    popv(4);
    return a;
}

Sex CC_Aepartmax(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = LITERAL[59];
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_epartmaxTefitv LITERAL[68]
    a = LL_epartmaxTefitv;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    popv(1);
    return a;
}

Sex CC_Aepartmin(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
#define LL_Hmachineps LITERAL[69]
    q = value(LL_Hmachineps);
    a = LITERAL[70];
    a = quot2(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_epartminTefitv LITERAL[71]
    a = LL_epartminTefitv;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    popv(1);
    return a;
}

Sex CC_Aacccoef(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    q = value(LL_Hmachineps);
    a = LITERAL[70];
    a = quot2(a, q);
    q = LITERAL[59];
    a = cons(a, q);
    value(LL_Hchkcoef) = a;
    q = cdr(w2);
    a = cdr(w1);
    CC_acccofTbpol(a, q);
    m = cdr(value(LL_Hchkcoef));
    q = car(value(LL_Hchkcoef));
    a = LL_Boset;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
}

Sex CC_Aaccmin(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = value(LL_Hmachineps);
    a = LITERAL[70];
    a = quot2(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_accminTefitv LITERAL[72]
    a = LL_accminTefitv;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    popv(1);
    return a;
}

Sex CC_Aaccmax(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = LITERAL[59];
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_accmaxTefitv LITERAL[73]
    a = LL_accmaxTefitv;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    popv(1);
    return a;
}

Sex CC_Aaccmaxmin(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = value(LL_Hmachineps);
    a = LITERAL[70];
    a = quot2(a, q);
    q = LITERAL[59];
    a = cons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_accminmaxTefitv LITERAL[74]
    a = LL_accminmaxTefitv;
    CC_mapTchkcoef(a, q);
    m = car(value(LL_Hchkcoef));
    q = cdr(value(LL_Hchkcoef));
    a = LL_Boset;
    {
        popv(1);
        return  Llist3(a, q, m);
    }
}

Sex CC_Aaccminmax(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = value(LL_Hmachineps);
    a = LITERAL[70];
    a = quot2(a, q);
    q = LITERAL[59];
    a = cons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
    a = LL_accminmaxTefitv;
    CC_mapTchkcoef(a, q);
    m = cdr(value(LL_Hchkcoef));
    q = car(value(LL_Hchkcoef));
    a = LL_Boset;
    {
        popv(1);
        return  Llist3(a, q, m);
    }
}

Sex CC_Acofmaxmin(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    q = LITERAL[59];
    a = Lxcons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_cofmaxminTefitv LITERAL[75]
    a = LL_cofmaxminTefitv;
    CC_mapTchkcoef(a, q);
    m = cdr(value(LL_Hchkcoef));
    q = car(value(LL_Hchkcoef));
    a = LL_Boset;
    {
        popv(1);
        return  Llist3(a, q, m);
    }
}

Sex CC_cofmaxminTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G0837;
    a = Lefloat_value(a);
    goto    G0854;
   G0837:
    if(!is_befloat(a)) goto    G0839;
    a = Lbefloat_value(a);
    goto    G0854;
   G0839:
    if(!is_interval(a)) goto    G0841;
    a = Linterval_mid(a);
   G0854:
    a = Labs(a);
    goto    G0855;
   G0841:
    a = Lecomplexp(a);
    if(a == nil) goto    G0843;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w3 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w3;
    a = plus2(a, q);
   G0855:
    w2 = a;
    goto    G0848;
   G0843:
    q = w1;
    a = LITERAL[76];
    CC_errormsg(a, q);
   G0848:
    q = car(value(LL_Hchkcoef));
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0850;
    q = w2;
    a = value(LL_Hchkcoef);
    car(a) = q;
   G0850:
    q = cdr(value(LL_Hchkcoef));
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0852;
    q = w2;
    a = value(LL_Hchkcoef);
    cdr(a) = q;
   G0852:
    a = value(LL_Hchkcoef);
    popv(3);
    return a;
}

Sex CC_Aaccmaxmin2(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = LITERAL[59];
    a = Lncons(a);
    w2 = a;
    q = value(LL_Hmachineps);
    a = LITERAL[70];
    a = quot2(a, q);
    a = Lncons(a);
    q = w2;
    a = Lxcons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_accmnmx2Tefitv LITERAL[77]
    a = LL_accmnmx2Tefitv;
    CC_mapTchkcoef(a, q);
    m = cdr(value(LL_Hchkcoef));
    q = car(value(LL_Hchkcoef));
    a = LL_Boset;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
}



Sex CC_accmnmx2Tefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0894;
    a = w1;
    if(is_float(a)) goto    G0894;
    if(!is_efloat(a)) goto    G0869;
    a = Lefloat_error(a);
    w5 = a;
    a = w1;
    a = Lefloat_value(a);
    goto    G0897;
   G0869:
    if(!is_befloat(a)) goto    G0873;
    a = Lbefloat_error(a);
    w5 = a;
    a = w1;
    a = Lbefloat_value(a);
    goto    G0897;
   G0873:
    if(!is_interval(a)) goto    G0877;
    a = Linterval_width(a);
    w5 = a;
    a = w1;
    a = Linterval_mid(a);
   G0897:
    a = Labs(a);
    goto    G0898;
   G0877:
    a = Lecomplexp(a);
    if(a == nil) goto    G0881;
    a = w1;
    a = Lbefloat_error(a);
    w5 = a;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w6 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w6;
    a = plus2(a, q);
   G0898:
    q = a;
    a = w5;
    a = quot2(a, q);
    w4 = a;
    goto    G0888;
   G0881:
    q = w1;
    a = LITERAL[76];
    CC_errormsg(a, q);
   G0888:
    a = car(value(LL_Hchkcoef));
    w2 = a;
    q = car(a);
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0890;
    q = car(w2);
    a = w2;
    cdr(a) = q;
    q = w4;
    a = w2;
    car(a) = q;
    goto    G0891;
   G0890:
    q = cdr(w2);
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0891;
    q = w4;
    a = w2;
    cdr(a) = q;
   G0891:
    a = cdr(value(LL_Hchkcoef));
    w3 = a;
    q = car(a);
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0893;
    q = car(w3);
    a = w3;
    cdr(a) = q;
    q = w4;
    a = w3;
    car(a) = q;
    goto    G0894;
   G0893:
    q = cdr(w3);
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0894;
    q = w4;
    a = w3;
    cdr(a) = q;
   G0894:
    a = value(LL_Hchkcoef);
    popv(6);
    return a;
}

Sex CC_Acofmaxmin2(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = LITERAL[59];
    a = Lncons(a);
    w2 = a;
    a = LITERAL[59];
    a = Lncons(a);
    q = w2;
    a = Lxcons(a, q);
    w2 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    a = Lncons(a);
    w3 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    a = Lncons(a);
    q = w3;
    a = Lxcons(a, q);
    q = w2;
    a = Lxcons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_cofmxmn2Tefitv LITERAL[78]
    a = LL_cofmxmn2Tefitv;
    CC_mapTchkcoef(a, q);
    m = cdr(cdr(car(value(LL_Hchkcoef))));
    q = cdr(car(car(value(LL_Hchkcoef))));
    a = LL_Boset;
    a = Llist3(a, q, m);
    w2 = a;
    m = cdr(cdr(cdr(value(LL_Hchkcoef))));
    q = cdr(car(cdr(value(LL_Hchkcoef))));
    a = LL_Boset;
    a = Llist3(a, q, m);
    m = a;
    q = w2;
    a = LL_Boset;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
}

Sex CC_cofmxmn2Tefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0939;
    a = w1;
    if(is_float(a)) goto    G0939;
    if(!is_efloat(a)) goto    G0919;
    a = Lefloat_value(a);
    goto    G0943;
   G0919:
    if(!is_befloat(a)) goto    G0921;
    a = Lbefloat_value(a);
    goto    G0943;
   G0921:
    if(!is_interval(a)) goto    G0923;
    a = Linterval_mid(a);
   G0943:
    a = Labs(a);
    goto    G0944;
   G0923:
    a = Lecomplexp(a);
    if(a == nil) goto    G0925;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w5 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w5;
    a = plus2(a, q);
   G0944:
    w4 = a;
    goto    G0930;
   G0925:
    q = w1;
    a = LITERAL[76];
    CC_errormsg(a, q);
   G0930:
    a = car(value(LL_Hchkcoef));
    w2 = a;
    q = car(car(a));
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0932;
    q = car(w2);
    a = w2;
    cdr(a) = q;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w2;
    car(a) = q;
    goto    G0934;
   G0932:
    q = car(cdr(w2));
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0934;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w2;
    cdr(a) = q;
   G0934:
    a = cdr(value(LL_Hchkcoef));
    w3 = a;
    q = car(car(a));
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0937;
    q = car(w3);
    a = w3;
    cdr(a) = q;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
    goto    G0939;
   G0937:
    q = car(cdr(w3));
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G0939;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
   G0939:
    a = value(LL_Hchkcoef);
    popv(5);
    return a;
}

Sex CC_Aaccmaxmincof(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = LITERAL[59];
    a = Lncons(a);
    w2 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    a = Lncons(a);
    q = w2;
    a = Lxcons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_accmxmncofTefitv LITERAL[79]
    a = LL_accmxmncofTefitv;
    CC_mapTchkcoef(a, q);
    m = cdr(car(value(LL_Hchkcoef)));
    q = car(car(value(LL_Hchkcoef)));
    a = LL_Boset;
    a = Llist3(a, q, m);
    w2 = a;
    m = cdr(cdr(value(LL_Hchkcoef)));
    q = car(cdr(value(LL_Hchkcoef)));
    a = LL_Boset;
    a = Llist3(a, q, m);
    m = a;
    q = w2;
    a = LL_Boset;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
}

Sex CC_accmxmncofTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G0956;
    a = Lefloat_error(a);
    w3 = a;
    a = w1;
    a = Lefloat_value(a);
    goto    G0984;
   G0956:
    if(!is_befloat(a)) goto    G0960;
    a = Lbefloat_error(a);
    w3 = a;
    a = w1;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    goto    G0984;
   G0960:
    if(!is_interval(a)) goto    G0965;
    a = Linterval_width(a);
    w3 = a;
    a = w1;
    a = Linterval_mid(a);
   G0984:
    q = a;
    a = w3;
    a = quot2(a, q);
    a = Labs(a);
    goto    G0985;
   G0965:
    a = Lecomplexp(a);
    if(a == nil) goto    G0969;
    a = w1;
    a = Lecomplex_error(a);
    w3 = a;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w4 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w4;
    a = plus2(a, q);
    q = a;
    a = w3;
    a = quot2(a, q);
   G0985:
    w2 = a;
    goto    G0976;
   G0969:
    q = w1;
    a = LITERAL[76];
    CC_errormsg(a, q);
   G0976:
    q = car(car(value(LL_Hchkcoef)));
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0978;
    q = w1;
    a = w2;
    a = cons(a, q);
    q = a;
    a = value(LL_Hchkcoef);
    car(a) = q;
   G0978:
    q = car(cdr(value(LL_Hchkcoef)));
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G0981;
    q = w1;
    a = w2;
    a = cons(a, q);
    q = a;
    a = value(LL_Hchkcoef);
    cdr(a) = q;
   G0981:
    a = value(LL_Hchkcoef);
    popv(4);
    return a;
}

Sex CC_Aaccmaxmincof2(Sex a)
{
    Sex q, m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Wmonomial(a);
    if(a != nil) goto    G0990;
    a = w1;
    a = CC_Wbinomial(a);
    if(a == nil) goto    G0989;
   G0990:
    a = w1;
    {
        popv(3);
        return  CC_Aaccmaxmincof(a);
    }
   G0989:
    a = LITERAL[59];
    a = Lncons(a);
    w2 = a;
    a = LITERAL[59];
    a = Lncons(a);
    q = w2;
    a = Lxcons(a, q);
    w2 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    a = Lncons(a);
    w3 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    a = Lncons(a);
    q = w3;
    a = Lxcons(a, q);
    q = w2;
    a = Lxcons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_accmxmncof2Tefitv LITERAL[80]
    a = LL_accmxmncof2Tefitv;
    CC_mapTchkcoef(a, q);
    arg5 = cdr(cdr(car(value(LL_Hchkcoef))));
    arg4 = car(cdr(car(value(LL_Hchkcoef))));
    m = cdr(car(car(value(LL_Hchkcoef))));
    q = car(car(car(value(LL_Hchkcoef))));
    a = LL_Boset;
    a = Llist5(a, q, m, arg4, arg5);
    w2 = a;
    arg5 = cdr(cdr(cdr(value(LL_Hchkcoef))));
    arg4 = car(cdr(cdr(value(LL_Hchkcoef))));
    m = cdr(car(cdr(value(LL_Hchkcoef))));
    q = car(car(cdr(value(LL_Hchkcoef))));
    a = LL_Boset;
    a = Llist5(a, q, m, arg4, arg5);
    m = a;
    q = w2;
    a = LL_Boset;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
}

Sex CC_accmxmncof2Tefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w2 = nil;
    w4 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G1008;
    a = Lefloat_error(a);
    w5 = a;
    a = w1;
    a = Lefloat_value(a);
    goto    G1040;
   G1008:
    if(!is_befloat(a)) goto    G1012;
    a = Lbefloat_error(a);
    w5 = a;
    a = w1;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    goto    G1040;
   G1012:
    if(!is_interval(a)) goto    G1017;
    a = Linterval_width(a);
    w5 = a;
    a = w1;
    a = Linterval_mid(a);
   G1040:
    q = a;
    a = w5;
    a = quot2(a, q);
    a = Labs(a);
    goto    G1041;
   G1017:
    a = Lecomplexp(a);
    if(a == nil) goto    G1021;
    a = w1;
    a = Lecomplex_error(a);
    w5 = a;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w6 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w6;
    a = plus2(a, q);
    q = a;
    a = w5;
    a = quot2(a, q);
   G1041:
    w4 = a;
    goto    G1028;
   G1021:
    q = w1;
    a = LITERAL[76];
    CC_errormsg(a, q);
   G1028:
    a = car(value(LL_Hchkcoef));
    w2 = a;
    q = car(car(a));
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1030;
    q = car(w2);
    a = w2;
    cdr(a) = q;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w2;
    car(a) = q;
    goto    G1032;
   G1030:
    q = car(cdr(w2));
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1032;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w2;
    cdr(a) = q;
   G1032:
    a = cdr(value(LL_Hchkcoef));
    w3 = a;
    q = car(car(a));
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G1035;
    q = car(w3);
    a = w3;
    cdr(a) = q;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
    goto    G1037;
   G1035:
    q = car(cdr(w3));
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G1037;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
   G1037:
    a = value(LL_Hchkcoef);
    popv(6);
    return a;
}

Sex CC_Acofmaxminacc(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    a = LITERAL[59];
    a = Lncons(a);
    w2 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    a = Lncons(a);
    q = w2;
    a = Lxcons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_cofmxmnaccTefitv LITERAL[81]
    a = LL_cofmxmnaccTefitv;
    CC_mapTchkcoef(a, q);
    m = cdr(car(value(LL_Hchkcoef)));
    q = car(car(value(LL_Hchkcoef)));
    a = LL_Boset;
    a = Llist3(a, q, m);
    w2 = a;
    m = cdr(cdr(value(LL_Hchkcoef)));
    q = car(cdr(value(LL_Hchkcoef)));
    a = LL_Boset;
    a = Llist3(a, q, m);
    m = a;
    q = w2;
    a = LL_Boset;
    {
        popv(2);
        return  Llist3(a, q, m);
    }
}

Sex CC_cofmxmnaccTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w2 = nil;
    w3 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G1053;
    a = Lefloat_value(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
    q = w2;
    goto    G1078;
   G1053:
    if(!is_befloat(a)) goto    G1056;
    a = Lbefloat_value(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lbefloat_error(a);
    w4 = a;
    a = w2;
    a = Lfloat(a);
    q = a;
    a = w4;
    goto    G1078;
   G1056:
    if(!is_interval(a)) goto    G1060;
    a = Linterval_mid(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Linterval_width(a);
    q = w2;
    goto    G1078;
   G1060:
    a = Lecomplexp(a);
    if(a == nil) goto    G1063;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w4 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w4;
    a = plus2(a, q);
    w2 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = w2;
   G1078:
    a = quot2(a, q);
    w3 = a;
    goto    G1069;
   G1063:
    q = w1;
    a = LITERAL[76];
    CC_errormsg(a, q);
   G1069:
    q = car(car(value(LL_Hchkcoef)));
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1071;
    q = w3;
    a = w2;
    a = cons(a, q);
    q = a;
    a = value(LL_Hchkcoef);
    car(a) = q;
   G1071:
    q = car(cdr(value(LL_Hchkcoef)));
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G1074;
    q = w3;
    a = w2;
    a = cons(a, q);
    q = a;
    a = value(LL_Hchkcoef);
    cdr(a) = q;
   G1074:
    a = value(LL_Hchkcoef);
    popv(4);
    return a;
}

Sex CC_Acofmaxminacc2(Sex a)
{
    Sex q, m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Wmonomial(a);
    if(a != nil) goto    G1083;
    a = w1;
    a = CC_Wbinomial(a);
    if(a == nil) goto    G1082;
   G1083:
    a = w1;
    {
        popv(3);
        return  CC_Acofmaxminacc(a);
    }
   G1082:
    a = LITERAL[59];
    a = Lncons(a);
    w2 = a;
    a = LITERAL[59];
    a = Lncons(a);
    q = w2;
    a = Lxcons(a, q);
    w2 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    a = Lncons(a);
    w3 = a;
    q = value(LL_Hmachineps);
    a = mkfxat(100);
    a = quot2(a, q);
    a = Lncons(a);
    q = w3;
    a = Lxcons(a, q);
    q = w2;
    a = Lxcons(a, q);
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_cofmxmnacc2Tefitv LITERAL[82]
    a = LL_cofmxmnacc2Tefitv;
    CC_mapTchkcoef(a, q);
    arg5 = cdr(cdr(car(value(LL_Hchkcoef))));
    arg4 = car(cdr(car(value(LL_Hchkcoef))));
    m = cdr(car(car(value(LL_Hchkcoef))));
    q = car(car(car(value(LL_Hchkcoef))));
    a = LL_Boset;
    a = Llist5(a, q, m, arg4, arg5);
    w2 = a;
    arg5 = cdr(cdr(cdr(value(LL_Hchkcoef))));
    arg4 = car(cdr(cdr(value(LL_Hchkcoef))));
    m = cdr(car(cdr(value(LL_Hchkcoef))));
    q = car(car(cdr(value(LL_Hchkcoef))));
    a = LL_Boset;
    a = Llist5(a, q, m, arg4, arg5);
    m = a;
    q = w2;
    a = LL_Boset;
    {
        popv(3);
        return  Llist3(a, q, m);
    }
}

Sex CC_cofmxmnacc2Tefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w3 = nil;
    w2 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G1101;
    a = Lefloat_value(a);
    a = Labs(a);
    w4 = a;
    a = w1;
    a = Lefloat_error(a);
    q = w4;
    goto    G1130;
   G1101:
    if(!is_befloat(a)) goto    G1104;
    a = Lbefloat_value(a);
    a = Labs(a);
    w4 = a;
    a = w1;
    a = Lbefloat_error(a);
    w6 = a;
    a = w4;
    a = Lfloat(a);
    q = a;
    a = w6;
    goto    G1130;
   G1104:
    if(!is_interval(a)) goto    G1108;
    a = Linterval_mid(a);
    a = Labs(a);
    w4 = a;
    a = w1;
    a = Linterval_width(a);
    q = w4;
    goto    G1130;
   G1108:
    a = Lecomplexp(a);
    if(a == nil) goto    G1111;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w6 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w6;
    a = plus2(a, q);
    w4 = a;
    a = w1;
    a = Lecomplex_error(a);
    q = w4;
   G1130:
    a = quot2(a, q);
    w5 = a;
    goto    G1117;
   G1111:
    q = w1;
    a = LITERAL[76];
    CC_errormsg(a, q);
   G1117:
    a = car(value(LL_Hchkcoef));
    w2 = a;
    q = car(car(a));
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1119;
    q = car(w2);
    a = w2;
    cdr(a) = q;
    q = w5;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w2;
    car(a) = q;
    goto    G1121;
   G1119:
    q = car(cdr(w2));
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1121;
    q = w5;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w2;
    cdr(a) = q;
   G1121:
    a = cdr(value(LL_Hchkcoef));
    w3 = a;
    q = car(car(a));
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G1124;
    q = car(w3);
    a = w3;
    cdr(a) = q;
    q = w5;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
    goto    G1126;
   G1124:
    q = car(cdr(w3));
    a = w4;
    a = Llessp(a, q);
    if(a == nil) goto    G1126;
    q = w5;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
   G1126:
    a = value(LL_Hchkcoef);
    popv(6);
    return a;
}

Sex CC_accminmaxTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G1135;
    a = Lefloat_error(a);
    w3 = a;
    a = w1;
    a = Lefloat_value(a);
    goto    G1161;
   G1135:
    if(!is_befloat(a)) goto    G1139;
    a = Lbefloat_error(a);
    w3 = a;
    a = w1;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    goto    G1161;
   G1139:
    if(!is_interval(a)) goto    G1144;
    a = Linterval_width(a);
    w3 = a;
    a = w1;
    a = Linterval_mid(a);
   G1161:
    q = a;
    a = w3;
    a = quot2(a, q);
    a = Labs(a);
    goto    G1162;
   G1144:
    a = Lecomplexp(a);
    if(a == nil) goto    G1148;
    a = w1;
    a = Lecomplex_error(a);
    w3 = a;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w4 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w4;
    a = plus2(a, q);
    q = a;
    a = w3;
    a = quot2(a, q);
   G1162:
    w2 = a;
    goto    G1155;
   G1148:
    q = w1;
    a = LITERAL[76];
    CC_argprint(a, q);
   G1155:
    q = car(value(LL_Hchkcoef));
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G1157;
    q = w2;
    a = value(LL_Hchkcoef);
    car(a) = q;
   G1157:
    q = cdr(value(LL_Hchkcoef));
    a = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1159;
    q = w2;
    a = value(LL_Hchkcoef);
    cdr(a) = q;
   G1159:
    a = value(LL_Hchkcoef);
    popv(4);
    return a;
}

Sex CC_accminTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G1166;
    a = Lefloat_error(a);
    w2 = a;
    a = w1;
    a = Lefloat_value(a);
    goto    G1194;
   G1166:
    if(!is_befloat(a)) goto    G1171;
    a = Lbefloat_error(a);
    w2 = a;
    a = w1;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    goto    G1194;
   G1171:
    if(!is_interval(a)) goto    G1177;
    a = Linterval_width(a);
    w2 = a;
    a = w1;
    a = Linterval_mid(a);
   G1194:
    q = a;
    a = w2;
    a = quot2(a, q);
    a = Labs(a);
    goto    G1195;
   G1177:
    if(is_float(a)) goto    G1183;
    if(!is_complex(a)) goto    G1182;
   G1183:
    q = a;
    a = LITERAL[76];
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
   G1182:
    a = Lecomplexp(a);
    if(a != nil) goto    G1184;
    a = LITERAL[59];
    value(LL_Hchkcoef) = a;
#define LL_stop LITERAL[83]
    a = LL_stop;
    goto    G1185;
   G1184:
    a = w1;
    a = Lecomplex_error(a);
    w2 = a;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w3 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w3;
    a = plus2(a, q);
    q = a;
    a = w2;
    a = quot2(a, q);
   G1195:
    q = a;
    a = value(LL_Hchkcoef);
    a = Lmin2(a, q);
    value(LL_Hchkcoef) = a;
   G1185:
    popv(3);
    return a;
}

Sex CC_accmaxTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G1199;
    a = Lefloat_error(a);
    w2 = a;
    a = w1;
    a = Lefloat_value(a);
    goto    G1227;
   G1199:
    if(!is_befloat(a)) goto    G1204;
    a = Lbefloat_error(a);
    w2 = a;
    a = w1;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    goto    G1227;
   G1204:
    if(!is_interval(a)) goto    G1210;
    a = Linterval_width(a);
    w2 = a;
    a = w1;
    a = Linterval_mid(a);
   G1227:
    q = a;
    a = w2;
    a = quot2(a, q);
    a = Labs(a);
    goto    G1228;
   G1210:
    if(is_float(a)) goto    G1216;
    if(!is_complex(a)) goto    G1215;
   G1216:
    q = a;
    a = LITERAL[76];
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
   G1215:
    a = Lecomplexp(a);
    if(a != nil) goto    G1217;
    a = true;
    goto    G1218;
   G1217:
    a = w1;
    a = Lecomplex_error(a);
    w2 = a;
    a = w1;
    a = Lecomplex_real(a);
    a = Labs(a);
    w3 = a;
    a = w1;
    a = Lecomplex_imag(a);
    a = Labs(a);
    q = a;
    a = w3;
    a = plus2(a, q);
    q = a;
    a = w2;
    a = quot2(a, q);
   G1228:
    q = a;
    a = value(LL_Hchkcoef);
    a = Lmax2(a, q);
    value(LL_Hchkcoef) = a;
   G1218:
    popv(3);
    return a;
}

Sex CC_epartmaxTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_efloat(a)) goto    G1232;
    a = Lefloat_error(a);
    goto    G1245;
   G1232:
    if(!is_befloat(a)) goto    G1234;
    a = Lbefloat_error(a);
    goto    G1245;
   G1234:
    if(!is_interval(a)) goto    G1236;
    a = Linterval_width(a);
    goto    G1245;
   G1236:
    if(is_float(a)) goto    G1239;
    if(!is_complex(a)) goto    G1238;
   G1239:
    q = a;
    a = LITERAL[84];
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
   G1238:
    a = Lecomplexp(a);
    if(a != nil) goto    G1240;
    a = true;
    goto    G1241;
   G1240:
    a = w1;
    a = Lecomplex_error(a);
   G1245:
    q = a;
    a = value(LL_Hchkcoef);
    a = Lmax2(a, q);
    value(LL_Hchkcoef) = a;
   G1241:
    popv(1);
    return a;
}

Sex CC_epartminTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_efloat(a)) goto    G1249;
    a = Lefloat_error(a);
    goto    G1262;
   G1249:
    if(!is_befloat(a)) goto    G1251;
    a = Lbefloat_error(a);
    goto    G1262;
   G1251:
    if(!is_interval(a)) goto    G1253;
    a = Linterval_width(a);
    goto    G1262;
   G1253:
    if(is_float(a)) goto    G1256;
    if(!is_complex(a)) goto    G1255;
   G1256:
    q = a;
    a = LITERAL[84];
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
   G1255:
    a = Lecomplexp(a);
    if(a != nil) goto    G1257;
    a = true;
    goto    G1258;
   G1257:
    a = w1;
    a = Lecomplex_error(a);
   G1262:
    q = a;
    a = value(LL_Hchkcoef);
    a = Lmin2(a, q);
    value(LL_Hchkcoef) = a;
   G1258:
    popv(1);
    return a;
}

Sex CC_vpartmaxTefitv(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_efloat(a)) goto    G1266;
    a = Lefloat_value(a);
    goto    G1280;
   G1266:
    if(!is_befloat(a)) goto    G1269;
    a = Lbefloat_value(a);
   G1280:
    a = Labs(a);
    goto    G1282;
   G1269:
    if(!is_interval(a)) goto    G1272;
    a = Linterval_width(a);
    goto    G1282;
   G1272:
    if(is_float(a)) goto    G1275;
    if(!is_complex(a)) goto    G1274;
   G1275:
    q = a;
    a = LITERAL[84];
    {
        popv(1);
        return  CC_errormsg(a, q);
    }
   G1274:
    a = Lecomplexp(a);
    if(a != nil) goto    G1276;
    a = true;
    goto    G1277;
   G1276:
    a = w1;
    a = Lecomplex_value(a);
    a = Labs(a);
   G1282:
    q = a;
    a = value(LL_Hchkcoef);
    a = Lmax2(a, q);
    value(LL_Hchkcoef) = a;
   G1277:
    popv(1);
    return a;
}

Sex CC_acccofTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
   G1286:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G1285;
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G1285;
    q = car(car(a));
    a = car(car(w1));
    a = Lequal(a, q);
    if(a == nil) goto    G1287;
    a = cdr(car(w1));
    w3 = a;
    if(!is_number(a)) goto    G1293;
    a = cdr(car(w2));
    w4 = a;
    if(!is_number(a)) goto    G1287;
    q = a;
    a = w3;
    a = diff2(a, q);
    q = w4;
    a = quot2(a, q);
    a = Labs(a);
    w5 = a;
    q = car(value(LL_Hchkcoef));
    a = Lmin2(a, q);
    q = a;
    a = value(LL_Hchkcoef);
    car(a) = q;
    q = cdr(value(LL_Hchkcoef));
    a = w5;
    a = Lmax2(a, q);
    q = a;
    a = value(LL_Hchkcoef);
    cdr(a) = q;
    goto    G1286;
   G1293:
    a = cdr(car(w2));
    w4 = a;
    if(is_number(a)) goto    G1287;
    q = a;
    a = w3;
    CC_acccofTbpol(a, q);
    goto    G1286;
   G1287:
    q = LITERAL[85];
    a = LITERAL[86];
    CC_errormsg(a, q);
    a = nil;
   G1285:
    popv(5);
    return a;
}

Sex CC_Amultfromto(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = CC_Wpoly(a);
    if(a == nil) goto    G1307;
    a = w2;
    a = CC_Wpoly(a);
    if(a != nil) goto    G1306;
   G1307:
    q = LITERAL[87];
    a = mkfxat(8);
    goto    G1320;
   G1306:
    a = w3;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1310;
    a = true;
    goto    G1311;
   G1310:
    a = w3;
    a = CC_Avar2expr(a);
    w3 = a;
   G1311:
    if(a != nil) goto    G1308;
    q = LITERAL[87];
    a = LITERAL[88];
    goto    G1320;
   G1308:
    a = car(w3);
    if(a == value(LL_CpolyC)) goto    G1312;
    q = LITERAL[87];
    a = LITERAL[89];
    goto    G1320;
   G1312:
    a = w4;
    if(!is_integer(a)) goto    G1314;
    q = mkfxat(0);
    a = Lgeq(a, q);
    if(a == nil) goto    G1314;
    a = w5;
    if(!is_integer(a)) goto    G1314;
    q = mkfxat(0);
    a = Lgeq(a, q);
    if(a == nil) goto    G1314;
    q = w5;
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1313;
   G1314:
    q = LITERAL[87];
    a = LITERAL[90];
   G1320:
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G1313:
    arg5 = w5;
    arg4 = w4;
    m = car(cdr(w3));
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_multfromtoH(a, q, m, arg4, arg5);
    }
}

Sex CC_multfromtoH(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w1 = a;
    a = cdr(a);
    w6 = a;
    a = cdr(q);
    w7 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = m;
    a = car(w6);
    a = Lequal(a, q);
    q = w3;
    if(a == nil) goto    G1325;
    a = car(w7);
    a = Lequal(a, q);
    if(a == nil) goto    G1327;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w7;
    a = w6;
    a = CC_multfrtoTvarvar(a, q, m, arg4, arg5);
    goto    G1337;
   G1327:
    q = w3;
    a = car(w7);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1333;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w6;
    a = w7;
    goto    G1346;
   G1325:
    a = car(w6);
    a = CC_WorderTvar(a, q);
    q = w3;
    if(a == nil) goto    G1330;
    a = car(w7);
    a = Lequal(a, q);
    if(a == nil) goto    G1332;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w7;
    a = w6;
   G1346:
    a = CC_multfrtoTbplvar(a, q, m, arg4, arg5);
    goto    G1337;
   G1332:
    q = w3;
    a = car(w7);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1333;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w7;
    a = w6;
    a = CC_multfrtoTbplbpl(a, q, m, arg4, arg5);
    goto    G1337;
   G1333:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w7;
    a = w6;
    goto    G1348;
   G1330:
    a = car(w7);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1335;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w6;
    a = w7;
   G1348:
    a = CC_multfrtoTbplcof(a, q, m, arg4, arg5);
    goto    G1337;
   G1335:
    a = w4;
    a = Lzerop(a);
    if(a != nil) goto    G1336;
    a = mkfxat(0);
    goto    G1337;
   G1336:
    q = w7;
    a = w6;
    a = CC_psHbpolbpol(a, q);
   G1337:
    w8 = a;
    if(!is_cons(a)) goto    G1339;
    a = car(a);
    if(is_integer(a)) goto    G1339;
    q = w8;
    a = car(w1);
    a = cons(a, q);
    w8 = a;
   G1339:
#define LL_Hmod LITERAL[91]
    a = value(LL_Hmod);
    if(a == nil) goto    G1342;
    a = w8;
    {
        popv(8);
        return  CC_redmodTncan(a);
    }
   G1342:
#define LL_Hfcut LITERAL[92]
    a = value(LL_Hfcut);
    if(a == nil) goto    G1343;
    a = w8;
    {
        popv(8);
        return  CC_redfloTncan(a);
    }
   G1343:
    a = w8;
    popv(8);
    return a;
}

Sex CC_multfrtoTvarvar(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 16;
    w16 = nil;
    w12 = nil;
    w11 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = Llength(a);
    w16 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w16;
    a = Llessp(a, q);
    if(a == nil) goto    G1358;
    a = w1;
    w15 = a;
    a = w2;
    w1 = a;
    a = w15;
    w2 = a;
   G1358:
    a = cdr(w1);
    a = CC_topcopy(a);
    w1 = a;
    a = cdr(w2);
    a = Lreverse(a);
    w2 = a;
   G1352:
    a = car(car(w2));
    w15 = a;
    a = Lminus(a);
    q = a;
    a = w4;
    a = plus2(a, q);
    w11 = a;
    a = w15;
    a = Lminus(a);
    q = a;
    a = w5;
    a = plus2(a, q);
    w12 = a;
   G1353:
    a = car(car(w1));
    w15 = a;
    q = w12;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1364;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G1389;
    goto    G1353;
   G1364:
    q = w11;
    a = w15;
    a = Llessp(a, q);
    if(a != nil) goto    G1355;
    q = w11;
    a = w15;
    a = Lequal(a, q);
    if(a == nil) goto    G1371;
    a = w1;
    goto    G1397;
   G1371:
    q = w11;
    a = w1;
    a = CC_pointTtm(a, q);
    w7 = a;
    a = cdr(a);
    if(a == nil) goto    G1372;
    q = w11;
    a = car(car(cdr(w7)));
    a = Lequal(a, q);
    if(a == nil) goto    G1372;
    a = cdr(w7);
   G1397:
    w7 = a;
   G1372:
    a = cdr(w7);
    w8 = a;
    q = nil;
    a = w7;
    cdr(a) = q;
    a = w3;
    a = Lncons(a);
    w13 = a;
    w9 = a;
    a = w1;
    w14 = a;
    a = car(car(w2));
    w12 = a;
    a = cdr(car(w2));
    w10 = a;
   G1354:
    q = cdr(car(w14));
    a = w10;
    a = CC_psHanyany(a, q);
    w15 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1377;
    q = car(car(w14));
    a = w12;
    a = plus2(a, q);
    q = w15;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w13;
    cdr(a) = q;
    a = cdr(a);
    w13 = a;
   G1377:
    a = cdr(w14);
    w14 = a;
    if(a != nil) goto    G1354;
    q = w8;
    a = w7;
    cdr(a) = q;
    a = cdr(w9);
    if(a != nil) goto    G1385;
    a = w6;
    goto    G1387;
   G1385:
    a = w6;
    if(a != nil) goto    G1386;
    a = w9;
    goto    G1387;
   G1386:
    q = a;
    a = w9;
    a = CC_seseLbpolany(a, q);
   G1387:
    w6 = a;
   G1355:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1352;
   G1389:
    a = w6;
    if(a != nil) goto    G1391;
    a = mkfxat(0);
    goto    G1351;
   G1391:
    if(is_number(a)) goto    G1394;
    a = car(a);
    if(!is_integer(a)) goto    G1393;
   G1394:
    a = w6;
    goto    G1351;
   G1393:
    a = w6;
    a = CC_reduceTbpol(a);
   G1351:
    popv(16);
    return a;
}

Sex CC_multfrtoTbplvar(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = car(a);
    a = Lncons(a);
    w7 = a;
    w6 = a;
    a = cdr(w1);
    w1 = a;
   G1401:
    a = cdr(car(w1));
    w8 = a;
    if(is_number(a)) goto    G1404;
    a = car(a);
    if(is_integer(a)) goto    G1404;
    q = w3;
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G1403;
   G1404:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w8;
    a = w2;
    a = CC_multfrtoTbplcof(a, q, m, arg4, arg5);
    goto    G1406;
   G1403:
    q = w3;
    a = car(w8);
    a = Lequal(a, q);
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    if(a == nil) goto    G1405;
    a = w8;
    a = CC_multfrtoTvarvar(a, q, m, arg4, arg5);
    goto    G1406;
   G1405:
    a = w8;
    a = CC_multfrtoTbplvar(a, q, m, arg4, arg5);
   G1406:
    w9 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1408;
    q = w9;
    a = car(car(w1));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
   G1408:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1401;
    a = w6;
    {
        popv(9);
        return  CC_reduceTbpol(a);
    }
}

Sex CC_multfrtoTbplbpl(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = car(q);
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1418;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    a = w1;
    a = Llength(a);
    w12 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w12;
    a = Llessp(a, q);
    if(a == nil) goto    G1424;
    a = w1;
    w11 = a;
    a = w2;
    w1 = a;
    a = w11;
    w2 = a;
   G1424:
    a = car(w1);
    w9 = a;
    a = cdr(w2);
    w2 = a;
   G1420:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = cdr(car(w2));
    a = w1;
    a = CC_multfrtoTbplany(a, q, m, arg4, arg5);
    w7 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1434;
    a = w7;
    if(is_number(a)) goto    G1430;
    q = w9;
    a = car(a);
    a = Lequal(a, q);
    if(a != nil) goto    G1429;
   G1430:
    q = w7;
    a = mkfxat(0);
    a = cons(a, q);
    q = a;
    a = w9;
    a = Llist2(a, q);
    w7 = a;
   G1429:
    a = car(car(w2));
    w10 = a;
    a = cdr(w7);
    w8 = a;
   G1421:
    a = car(w8);
    w11 = a;
    q = w10;
    a = car(a);
    a = plus2(a, q);
    q = a;
    a = w11;
    car(a) = q;
    a = cdr(w8);
    w8 = a;
    if(a != nil) goto    G1421;
   G1434:
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G1438;
    a = w6;
    if(a != nil) goto    G1437;
    a = w7;
    goto    G1461;
   G1437:
    q = a;
    a = w7;
    a = CC_seseLanyany(a, q);
   G1461:
    w6 = a;
   G1438:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1420;
    a = w6;
    if(a != nil) goto    G1442;
    a = mkfxat(0);
    goto    G1460;
   G1442:
    if(is_number(a)) goto    G1444;
    a = car(a);
    if(!is_integer(a)) goto    G1458;
   G1444:
    a = w6;
    goto    G1460;
   G1418:
    q = car(w2);
    a = car(w1);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1447;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = car(w1);
    a = Lncons(a);
    w7 = a;
    w6 = a;
    a = cdr(w1);
    w1 = a;
   G1450:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = cdr(car(w1));
    a = w2;
    a = CC_multfrtoTbplany(a, q, m, arg4, arg5);
    w8 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1453;
    q = w8;
    a = car(car(w1));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
   G1453:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1450;
   G1458:
    a = w6;
    {
        popv(12);
        return  CC_reduceTbpol(a);
    }
   G1447:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w1;
    a = w2;
    a = CC_multfrtoTbplbpl(a, q, m, arg4, arg5);
   G1460:
    popv(12);
    return a;
}

Sex CC_multfrtoTbplcof(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w1 = a;
    a = value(LL_CpolyC);
    w7 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = w1;
    a = cons(a, q);
    arg4 = w5;
    m = w4;
    q = w3;
    a = CC_termfromtoH(a, q, m, arg4);
    w6 = a;
    if(!is_cons(a)) goto    G1468;
    q = w7;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1468;
    a = cdr(w6);
    w6 = a;
   G1468:
    q = w6;
    a = w2;
    {
        popv(7);
        return  CC_Hanyany(a, q);
    }
}

Sex CC_multfrtoTbplany(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(is_number(q)) goto    G1475;
    a = car(q);
    if(is_integer(a)) goto    G1475;
    q = m;
    a = CC_WorderTvar(a, q);
    if(a != nil) goto    G1474;
   G1475:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_multfrtoTbplcof(a, q, m, arg4, arg5);
    }
   G1474:
    q = w3;
    a = car(w2);
    a = Lequal(a, q);
    if(a == nil) goto    G1476;
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_multfrtoTbplvar(a, q, m, arg4, arg5);
    }
   G1476:
    arg5 = w5;
    arg4 = w4;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(5);
        return  CC_multfrtoTbplbpl(a, q, m, arg4, arg5);
    }
}

Sex CC_Adefdffunc(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
#define LL_gal LITERAL[93]
    q = LL_gal;
#define LL_Qprocmode LITERAL[94]
    a = value(LL_Qprocmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1482;
    q = LITERAL[95];
    a = LITERAL[96];
    CC_errormsg(a, q);
   G1482:
    a = w1;
    a = CC_Watom(a);
    if(a != nil) goto    G1485;
    a = w2;
    a = CC_Watom(a);
    if(a == nil) goto    G1484;
   G1485:
    a = LITERAL[95];
    CC_argerror(a);
    goto    G1488;
   G1484:
    a = w1;
    a = CC_Aexpr2varfunc(a);
    w1 = a;
    a = CC_Watom(a);
    if(a == nil) goto    G1486;
    q = LITERAL[95];
    a = LITERAL[97];
    goto    G1494;
   G1486:
    a = cdr(w1);
    if(a == nil) goto    G1489;
    a = cdr(a);
    if(a != nil) goto    G1489;
    a = car(cdr(w1));
    w3 = a;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1489;
    q = CHAR_OF(64);
    a = car(cdr(w3));
    a = Lneq(a, q);
    if(a == nil) goto    G1488;
   G1489:
    q = LITERAL[95];
    a = LITERAL[98];
   G1494:
    CC_errormsg(a, q);
   G1488:
    a = w2;
    a = CC_idlistH(a);
    q = a;
    a = CHAR_OF(64);
    a = Lmemq(a, q);
    if(a != nil) goto    G1492;
    q = LITERAL[95];
    a = LITERAL[99];
    CC_errormsg(a, q);
   G1492:
    m = w2;
#define LL_df LITERAL[100]
    q = LL_df;
    a = car(w1);
    CC_putTcompfn(a, q, m);
    a = LITERAL[101];
    popv(3);
    return a;
}

Sex CC_mkfuncTdf(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = nil;
    w6 = nil;
    w2 = q;
    a = CC_topcopy(a);
    w1 = a;
    a = cdr(a);
    w5 = a;
   G1498:
    a = car(w2);
    w3 = a;
    a = car(cdr(w2));
    w4 = a;
    if(a != nil) goto    G1503;
    a = mkfxat(1);
    w4 = a;
   G1503:
    a = cdr(cdr(w1));
    if(a == nil) goto    G1517;
   G1505:
    a = car(cdr(w5));
    w6 = a;
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G1511;
    q = w4;
    a = car(cdr(cdr(w5)));
    a = plus2(a, q);
    q = a;
    a = cdr(cdr(w5));
    car(a) = q;
    goto    G1519;
   G1511:
    q = w6;
    a = w3;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1514;
    q = cdr(w5);
    a = w4;
    a = cons(a, q);
    q = w3;
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    goto    G1519;
   G1514:
    a = cdr(cdr(w5));
    w5 = a;
    a = cdr(a);
    if(a != nil) goto    G1505;
   G1517:
    a = w4;
    a = Lncons(a);
    q = w3;
    a = Lxcons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
   G1519:
    a = cdr(cdr(w2));
    w2 = a;
    if(a == nil) goto    G1525;
    a = cdr(w1);
    w5 = a;
    goto    G1498;
   G1525:
    a = w1;
    popv(6);
    return a;
}

Sex CC_dfTbnum(Sex a, Sex q, Sex m)
{
    a = mkfxat(0);
    return a;
}

Sex CC_dfTcano(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w1 = a;
    w3 = m;
    a = q;
    a = CC_Aexpr2varfunc(a);
    w2 = a;
#define LL_Ainvalid LITERAL[102]
    if(a != LL_Ainvalid) goto    G1532;
    q = nil;
    a = LITERAL[103];
    goto    G1545;
   G1532:
    a = w3;
    if(a != nil) goto    G1533;
    a = mkfxat(1);
    w3 = a;
    goto    G1536;
   G1533:
    a = CC_Wint(a);
    if(a == nil) goto    G1534;
    q = mkfxat(0);
    a = w3;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1536;
   G1534:
    q = nil;
    a = LITERAL[104];
   G1545:
    CC_errormsg(a, q);
   G1536:
    a = car(w1);
    if(a != value(LL_CratfC)) goto    G1538;
    arg4 = w3;
    m = w2;
    q = w1;
#define LL_dfTsrat LITERAL[105]
    a = LL_dfTsrat;
    {
        popv(3);
        return  CC_mapTratfxxyy(a, q, m, arg4);
    }
   G1538:
    m = nil;
    q = w2;
    a = cdr(w1);
    a = CC_WfreeTbpol(a, q, m);
    if(a == nil) goto    G1539;
    a = mkfxat(0);
    goto    G1540;
   G1539:
    m = w3;
    q = w2;
    a = cdr(w1);
    a = CC_dfTbpol(a, q, m);
    w2 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G1542;
    a = car(w2);
    a = CC_Wtag(a);
    if(a != nil) goto    G1542;
    q = w2;
    a = car(w1);
    a = cons(a, q);
    w2 = a;
   G1542:
    a = w2;
    a = CC_redcoefTncan(a);
   G1540:
    popv(3);
    return a;
}

Sex CC_dfTpref(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w1 = a;
    w3 = m;
    a = q;
    a = CC_Aexpr2varfunc(a);
    w2 = a;
    if(a != LL_Ainvalid) goto    G1549;
    q = nil;
    a = LITERAL[103];
    goto    G1569;
   G1549:
    a = w3;
    if(a != nil) goto    G1550;
    a = mkfxat(1);
    w3 = a;
    goto    G1553;
   G1550:
    a = CC_Wint(a);
    if(a == nil) goto    G1551;
    q = mkfxat(0);
    a = w3;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1553;
   G1551:
    q = nil;
    a = LITERAL[104];
   G1569:
    CC_errormsg(a, q);
   G1553:
    m = nil;
    q = w2;
    a = w1;
    a = CC_WfreeTpref(a, q, m);
    if(a == nil) goto    G1555;
    a = mkfxat(0);
    goto    G1568;
   G1555:
    a = car(w1);
#define LL_cL LITERAL[106]
    if(a != LL_cL) goto    G1556;
    arg6 = w3;
    arg5 = w2;
    arg4 = w1;
#define LL_dfTcterm LITERAL[107]
    m = LL_dfTcterm;
#define LL_dfTnterm LITERAL[108]
    q = LL_dfTnterm;
#define LL_dfTncan LITERAL[109]
    a = LL_dfTncan;
    {
        popv(3);
        return  CC_map3TcLxxyy(a, q, m, arg4, arg5, arg6);
    }
   G1556:
    q = mkfxat(1);
#define LL_cH LITERAL[110]
    if(a != LL_cH) goto    G1557;
    a = w1;
    a = cons(a, q);
    m = w3;
    q = w2;
    a = CC_dfTcterm(a, q, m);
    w2 = a;
    a = cdr(a);
    a = CC_Wone(a);
    if(a == nil) goto    G1564;
    goto    G1570;
   G1557:
    a = w1;
    a = cons(a, q);
    m = w3;
    q = w2;
    a = CC_dfTnterm(a, q, m);
    w2 = a;
    a = cdr(a);
    a = CC_Wone(a);
    if(a == nil) goto    G1564;
   G1570:
    a = car(w2);
    goto    G1568;
   G1564:
    q = car(w2);
    a = cdr(w2);
    a = CC_multH(a, q);
   G1568:
    popv(3);
    return a;
}

Sex CC_dfTncan(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Wbnum(a);
    if(a == nil) goto    G1575;
    a = mkfxat(0);
    goto    G1576;
   G1575:
    m = w3;
    q = w2;
    a = w1;
    a = CC_dfTcano(a, q, m);
   G1576:
    popv(3);
    return a;
}

Sex CC_dfTcterm(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    a = Lonep(a);
    q = w2;
    if(a == nil) goto    G1580;
    a = car(w1);
    a = CC_dfTcH(a, q);
    goto    G1581;
   G1580:
    a = car(w1);
    a = CC_dfTcH(a, q);
    w4 = a;
    q = mkfxat(-1);
    a = w3;
    a = plus2(a, q);
    arg4 = a;
    m = w2;
    q = w4;
#define LL_Adf LITERAL[111]
    a = LL_Adf;
    a = CC_fcallx2Trexp(a, q, m, arg4);
   G1581:
    q = cdr(w1);
    {
        popv(4);
        return  cons(a, q);
    }
}

Sex CC_dfTcH(Sex a, Sex q)
{
    Sex m, arg4, arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w11 = nil;
    w9 = nil;
    w8 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w10 = nil;
    w12 = nil;
    w1 = a;
    a = cdr(a);
    w7 = a;
    w2 = q;
    a = mkfxat(0);
    a = Lncons(a);
    w4 = a;
    q = LL_cL;
    a = Lxcons(a, q);
    w3 = a;
    a = LL_cH;
    a = Lncons(a);
    w6 = a;
    w5 = a;
   G1588:
    q = cdr(cdr(w7));
    a = w6;
    cdr(a) = q;
    a = car(w7);
    w8 = a;
    a = CC_Wbnum(a);
    if(a == nil) goto    G1592;
    a = mkfxat(0);
    goto    G1596;
   G1592:
    a = car(w8);
    a = CC_Wtag(a);
    if(a == nil) goto    G1594;
    m = mkfxat(1);
    q = w2;
    a = w8;
    a = CC_dfTcano(a, q, m);
    goto    G1596;
   G1594:
    a = car(w8);
    if(a != LL_cL) goto    G1595;
    arg6 = mkfxat(1);
    arg5 = w2;
    arg4 = w8;
    m = LL_dfTcterm;
    q = LL_dfTnterm;
    a = LL_dfTncan;
    a = CC_map3TcLxxyy(a, q, m, arg4, arg5, arg6);
    goto    G1596;
   G1595:
    a = true;
    w12 = a;
    q = w2;
    a = w8;
    a = CC_dfTfunc(a, q);
   G1596:
    w11 = a;
    a = car(cdr(w7));
    w9 = a;
    a = CC_Wone(a);
    if(a != nil) goto    G1613;
    a = w9;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1601;
    m = nil;
    q = w2;
    a = w9;
    a = CC_WfreeH(a, q, m);
    if(a == nil) goto    G1600;
   G1601:
    q = w11;
    a = w9;
    a = CC_chkmultH(a, q);
    w11 = a;
    q = mkfxat(-1);
    a = w9;
    a = CC_addTexpt(a, q);
    w9 = a;
    m = a;
    q = w8;
    a = LL_cH;
    a = Llist3(a, q, m);
    q = a;
    a = w11;
    goto    G1636;
   G1600:
    a = w12;
    if(a == nil) goto    G1604;
    m = mkfxat(1);
    q = w8;
    a = LL_cH;
    a = Llist3(a, q, m);
    goto    G1605;
   G1604:
    a = w8;
   G1605:
    w8 = a;
    a = Lncons(a);
    q = a;
#define LL_Alog LITERAL[112]
    a = LL_Alog;
    a = CC_mkTfunc(a, q);
    q = nil;
    a = CC_convTfunc2expr(a, q);
    w10 = a;
    a = w11;
    a = CC_Wzero(a);
    if(a == nil) goto    G1609;
    q = w9;
    a = w8;
    a = CC_unpowH(a, q);
    w13 = a;
    arg4 = mkfxat(1);
    m = w2;
    q = w9;
    a = LL_Adf;
    a = CC_fcallx2Trexp(a, q, m, arg4);
    q = a;
    a = w13;
    a = CC_chkmultH(a, q);
    q = a;
    a = w10;
    goto    G1636;
   G1609:
    arg4 = mkfxat(1);
    m = w2;
    q = w9;
    a = LL_Adf;
    a = CC_fcallx2Trexp(a, q, m, arg4);
    q = w10;
    a = CC_chkmultH(a, q);
    w13 = a;
    a = w8;
    a = CC_recipH(a);
    q = a;
    a = w11;
    a = CC_chkmultH(a, q);
    q = a;
    a = w9;
    a = CC_chkmultH(a, q);
    q = a;
    a = w13;
    a = CC_chkaddH(a, q);
    w11 = a;
    q = w9;
    a = w8;
    a = CC_unpowH(a, q);
    q = a;
    a = w11;
   G1636:
    a = CC_chkmultH(a, q);
    w11 = a;
   G1613:
    a = w5;
    a = CC_topcopy(a);
    a = CC_reduceTcH(a);
    q = w11;
    a = CC_chkmultH(a, q);
    w11 = a;
    q = mkfxat(1);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = car(cdr(w7));
    a = Lncons(a);
    q = car(w7);
    a = Lxcons(a, q);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    w6 = a;
    a = cdr(cdr(w7));
    w7 = a;
    if(a == nil) goto    G1630;
    w12 = nil;
    goto    G1588;
   G1630:
#define LL_uncol LITERAL[113]
    q = LL_uncol;
#define LL_Hcolmode LITERAL[114]
    a = value(LL_Hcolmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1632;
    a = w3;
    CC_seTcolsortTcL(a);
    goto    G1633;
   G1632:
    a = w3;
    CC_seTuncolsortTcL(a);
   G1633:
    a = w3;
    {
        popv(13);
        return  CC_seTredcoefTcL(a);
    }
}

Sex CC_dfTfunc(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    m = nil;
    a = CC_WfreeTfunc(a, q, m);
    if(a == nil) goto    G1640;
    a = mkfxat(0);
    goto    G1641;
   G1640:
    w3 = nil;
    w4 = nil;
    a = cdr(w1);
    if(a == nil) goto    G1648;
    q = LL_df;
    a = car(w1);
    a = CC_getTcompfn(a, q);
    w4 = a;
    if(a != nil) goto    G1661;
   G1648:
    q = true;
    a = w1;
    a = CC_convTfunc2expr(a, q);
    m = mkfxat(1);
    q = w2;
    a = Llist3(a, q, m);
    w4 = a;
    q = a;
    a = LL_Adf;
    a = CC_mkTpfunc(a, q);
    q = true;
    {
        popv(4);
        return  CC_convTfunc2expr(a, q);
    }
   G1661:
    a = cdr(cdr(w1));
    if(a != nil) goto    G1645;
    a = car(cdr(w1));
    w3 = a;
    m = a;
    q = CHAR_OF(64);
    a = w4;
    a = CC_substH(a, q, m);
    w4 = a;
    a = w3;
    a = CC_Wsinglevar(a);
    if(a == nil) goto    G1656;
    q = car(cdr(w3));
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G1656;
    a = w4;
    goto    G1641;
   G1656:
    arg4 = mkfxat(1);
    m = w2;
    q = w3;
    a = LL_Adf;
    a = CC_fcallx2Trexp(a, q, m, arg4);
    q = w4;
    {
        popv(4);
        return  CC_chkmultH(a, q);
    }
   G1645:
    a = car(w4);
   G1641:
    popv(4);
    return a;
}

Sex CC_dfTbpol(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G1665;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = car(w1);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w1);
    w1 = a;
   G1667:
    a = car(car(w1));
    w6 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G1699;
    a = w6;
    w8 = a;
    q = w3;
    a = diff2(a, q);
    w7 = a;
   G1668:
    a = w6;
    a = Lsub1(a);
    w6 = a;
    q = w7;
    a = CC_Weqn(a, q);
    if(a != nil) goto    G1674;
    q = w8;
    a = w6;
    a = times2(a, q);
    w8 = a;
    goto    G1668;
   G1674:
    q = cdr(car(w1));
    a = w8;
    a = CC_Hbnumany(a, q);
    q = w7;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G1699;
    goto    G1667;
   G1665:
    q = car(w1);
    a = w2;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1683;
    a = mkfxat(0);
    goto    G1684;
   G1683:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = car(w1);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w1);
    w1 = a;
   G1686:
    a = cdr(car(w1));
    w6 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1694;
    a = car(w6);
    a = CC_Wid(a);
    m = w3;
    q = w2;
    if(a == nil) goto    G1691;
    a = w6;
    a = CC_dfTbpol(a, q, m);
    goto    G1703;
   G1691:
    a = w6;
    a = CC_dfTcano(a, q, m);
   G1703:
    w6 = a;
    a = w6;
    a = CC_Wzero(a);
    if(a != nil) goto    G1694;
    q = w6;
    a = car(car(w1));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G1694:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1686;
   G1699:
    a = w4;
    a = CC_reduceTbpol(a);
   G1684:
    popv(8);
    return a;
}

Sex CC_dfTsrat(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
   G1738:
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(a);
    a = CC_Wbnum(a);
    if(a != nil) goto    G1708;
    m = nil;
    q = w2;
    a = cdr(car(w1));
    a = CC_WfreeTbpol(a, q, m);
    if(a == nil) goto    G1707;
   G1708:
    a = cdr(w1);
    a = CC_Wbnum(a);
    if(a != nil) goto    G1711;
    m = w3;
    q = w2;
    a = cdr(w1);
    a = CC_dfTcano(a, q, m);
    w2 = a;
    a = CC_Wzero(a);
    if(a == nil) goto    G1710;
   G1711:
    q = mkfxat(0);
    a = mkfxat(1);
    goto    G1736;
   G1710:
    q = w2;
    a = car(w1);
    goto    G1736;
   G1707:
    a = cdr(w1);
    a = CC_Wbnum(a);
    if(a != nil) goto    G1715;
    m = nil;
    q = w2;
    a = cdr(cdr(w1));
    a = CC_WfreeTbpol(a, q, m);
    if(a == nil) goto    G1714;
   G1715:
    w4 = nil;
    w5 = nil;
    m = mkfxat(1);
    q = w2;
    a = car(w1);
    a = CC_dfTcano(a, q, m);
    w5 = a;
    a = cdr(w1);
    a = CC_Kany(a);
    q = w5;
    a = CC_psHanyany(a, q);
    w5 = a;
    q = car(w1);
    a = q;
    a = CC_psHpol3pol3(a, q);
    w4 = a;
    a = w3;
    a = CC_Wone(a);
    if(a == nil) goto    G1730;
    q = w5;
    a = w4;
    goto    G1736;
   G1714:
    w4 = nil;
    w5 = nil;
    m = mkfxat(1);
    q = w2;
    a = car(w1);
    a = CC_dfTcano(a, q, m);
    q = cdr(w1);
    a = CC_psHanyany(a, q);
    a = CC_Kany(a);
    w5 = a;
    m = mkfxat(1);
    q = w2;
    a = cdr(w1);
    a = CC_dfTcano(a, q, m);
    q = car(w1);
    a = CC_psHanyany(a, q);
    q = w5;
    a = CC_Lanyany(a, q);
    w5 = a;
    q = car(w1);
    a = q;
    a = CC_psHpol3pol3(a, q);
    w4 = a;
    a = w3;
    a = CC_Wone(a);
    if(a == nil) goto    G1730;
    q = w5;
    a = w4;
   G1736:
    {
        popv(5);
        return  cons(a, q);
    }
   G1730:
    q = w4;
    a = w5;
    a = CC_convTnVd2srat(a, q);
    w1 = a;
    a = w3;
    a = Lsub1(a);
    m = a;
    q = w2;
    a = w1;
    goto    G1738;  /* recursive call to df:srat */
}



/* initialization procedure */
int init_comproc(void)
{
   long i;

   create_symbols(comproc_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; comproc_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(comproc_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4, arg5;
        Sex *sp = stack;
        stackcheck();
        stack = sp + 1;
        w1 = nil;
        a = LITERAL[115];
        CC_Aenter(a);
        a = LITERAL[116];
        Lglobal(a);
        arg4 = nil;
#define LL_command LITERAL[117]
        m = LL_command;
#define LL_Aidset LITERAL[118]
        q = LL_Aidset;
#define LL_idset LITERAL[119]
        a = LL_idset;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_Aidset;
#define LL_idlist LITERAL[120]
        a = LL_idlist;
        CC_defcommand(a, q, m, arg4);
#define LL_argxn LITERAL[121]
        arg4 = LL_argxn;
#define LL_dvpfunc LITERAL[122]
        m = LL_dvpfunc;
#define LL_Asubst LITERAL[123]
        q = LL_Asubst;
#define LL_subst LITERAL[124]
        a = LL_subst;
        CC_defcommand(a, q, m, arg4);
        arg5 = nil;
#define LL_gexp LITERAL[125]
        arg4 = LL_gexp;
#define LL_arg1 LITERAL[126]
        m = LL_arg1;
        q = LL_idset;
        a = LL_Aidset;
        CC_genprogram(a, q, m, arg4, arg5);
        arg5 = nil;
        arg4 = LL_gexp;
        m = LL_argxn;
        q = LL_subst;
        a = LL_Asubst;
        CC_genprogram(a, q, m, arg4, arg5);
        arg4 = nil;
        m = LL_command;
#define LL_Wdecorder LITERAL[127]
        q = LL_Wdecorder;
        a = LL_Wdecorder;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_Wdecorder;
#define LL_Wdecrorder LITERAL[128]
        a = LL_Wdecrorder;
        CC_defcommand(a, q, m, arg4);
        arg4 = LL_arg1;
        m = LL_command;
#define LL_ArandomB24 LITERAL[129]
        q = LL_ArandomB24;
#define LL_randomB24 LITERAL[130]
        a = LL_randomB24;
        CC_defcommand(a, q, m, arg4);
        arg4 = LL_arg1;
        m = LL_command;
#define LL_ArandomD8 LITERAL[131]
        q = LL_ArandomD8;
#define LL_randomD8 LITERAL[132]
        a = LL_randomD8;
        CC_defcommand(a, q, m, arg4);
        arg4 = LL_arg1;
        m = LL_command;
#define LL_Arandom1 LITERAL[133]
        q = LL_Arandom1;
#define LL_random1 LITERAL[134]
        a = LL_random1;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_ArandomUniPol LITERAL[135]
        q = LL_ArandomUniPol;
#define LL_randomUPol LITERAL[136]
        a = LL_randomUPol;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_ArandomUniPol;
#define LL_randomUniPol LITERAL[137]
        a = LL_randomUniPol;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_AintSequence LITERAL[138]
        q = LL_AintSequence;
#define LL_intSequence LITERAL[139]
        a = LL_intSequence;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aabs LITERAL[140]
        q = LL_Aabs;
#define LL_abs LITERAL[141]
        a = LL_abs;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Afact LITERAL[142]
        q = LL_Afact;
#define LL_fact LITERAL[143]
        a = LL_fact;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Adfact LITERAL[144]
        q = LL_Adfact;
#define LL_dfact LITERAL[145]
        a = LL_dfact;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Acombi LITERAL[146]
        q = LL_Acombi;
#define LL_combi LITERAL[147]
        a = LL_combi;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_nthroot LITERAL[148]
        q = LL_nthroot;
        a = LL_nthroot;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_sqrt LITERAL[149]
        q = LL_sqrt;
        a = LL_sqrt;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Adecsort LITERAL[150]
        q = LL_Adecsort;
#define LL_decsort LITERAL[151]
        a = LL_decsort;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_Adecsort;
#define LL_decrsort LITERAL[152]
        a = LL_decrsort;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Asortbyabs LITERAL[153]
        q = LL_Asortbyabs;
#define LL_sortbyabs LITERAL[154]
        a = LL_sortbyabs;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Acluster LITERAL[155]
        q = LL_Acluster;
#define LL_cluster LITERAL[156]
        a = LL_cluster;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Amkvar LITERAL[157]
        q = LL_Amkvar;
#define LL_mkvar LITERAL[158]
        a = LL_mkvar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_Amkvar;
#define LL_newvar LITERAL[159]
        a = LL_newvar;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Amkpow LITERAL[160]
        q = LL_Amkpow;
#define LL_mkpow LITERAL[161]
        a = LL_mkpow;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_Amkpow;
#define LL_mkpower LITERAL[162]
        a = LL_mkpower;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aputtdeg LITERAL[163]
        q = LL_Aputtdeg;
#define LL_puttdeg LITERAL[164]
        a = LL_puttdeg;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aputtdeg1 LITERAL[165]
        q = LL_Aputtdeg1;
#define LL_puttdeg1 LITERAL[166]
        a = LL_puttdeg1;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Altelim LITERAL[167]
        q = LL_Altelim;
#define LL_ltelim LITERAL[168]
        a = LL_ltelim;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Ahtelim LITERAL[169]
        q = LL_Ahtelim;
#define LL_htelim LITERAL[170]
        a = LL_htelim;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Agcrpower LITERAL[171]
        q = LL_Agcrpower;
#define LL_gcrpow LITERAL[172]
        a = LL_gcrpow;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_Agcrpower;
#define LL_gcrpower LITERAL[173]
        a = LL_gcrpower;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Arevunipol LITERAL[174]
        q = LL_Arevunipol;
#define LL_revpol LITERAL[175]
        a = LL_revpol;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_Arevunipol;
#define LL_revunipol LITERAL[176]
        a = LL_revunipol;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aiqdiv2polnum LITERAL[177]
        q = LL_Aiqdiv2polnum;
#define LL_iqdiv2pol LITERAL[178]
        a = LL_iqdiv2pol;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Anorm LITERAL[179]
        q = LL_Anorm;
#define LL_norm LITERAL[180]
        a = LL_norm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Anorm1 LITERAL[181]
        q = LL_Anorm1;
#define LL_norm1 LITERAL[182]
        a = LL_norm1;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Anorm2 LITERAL[183]
        q = LL_Anorm2;
#define LL_norm2 LITERAL[184]
        a = LL_norm2;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Ammc LITERAL[185]
        q = LL_Ammc;
#define LL_mmc LITERAL[186]
        a = LL_mmc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aqmmc LITERAL[187]
        q = LL_Aqmmc;
#define LL_qmmc LITERAL[188]
        a = LL_qmmc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Asqnorm LITERAL[189]
        q = LL_Asqnorm;
#define LL_sqnorm LITERAL[190]
        a = LL_sqnorm;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aacccoef LITERAL[191]
        q = LL_Aacccoef;
#define LL_acccoef LITERAL[192]
        a = LL_acccoef;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aepartmax LITERAL[193]
        q = LL_Aepartmax;
#define LL_epartmax LITERAL[194]
        a = LL_epartmax;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aaccmax LITERAL[195]
        q = LL_Aaccmax;
#define LL_accmax LITERAL[196]
        a = LL_accmax;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aaccmin LITERAL[197]
        q = LL_Aaccmin;
#define LL_accmin LITERAL[198]
        a = LL_accmin;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aaccmaxmin LITERAL[199]
        q = LL_Aaccmaxmin;
#define LL_accmaxmin LITERAL[200]
        a = LL_accmaxmin;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aaccminmax LITERAL[201]
        q = LL_Aaccminmax;
#define LL_accminmax LITERAL[202]
        a = LL_accminmax;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Acofmaxmin LITERAL[203]
        q = LL_Acofmaxmin;
#define LL_cofmaxmin LITERAL[204]
        a = LL_cofmaxmin;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aaccmaxmin2 LITERAL[205]
        q = LL_Aaccmaxmin2;
#define LL_accmaxmin2 LITERAL[206]
        a = LL_accmaxmin2;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Acofmaxmin2 LITERAL[207]
        q = LL_Acofmaxmin2;
#define LL_cofmaxmin2 LITERAL[208]
        a = LL_cofmaxmin2;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aaccmaxmincof LITERAL[209]
        q = LL_Aaccmaxmincof;
#define LL_accmaxmincof LITERAL[210]
        a = LL_accmaxmincof;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aaccmaxmincof2 LITERAL[211]
        q = LL_Aaccmaxmincof2;
#define LL_accmaxmincof2 LITERAL[212]
        a = LL_accmaxmincof2;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Acofmaxminacc LITERAL[213]
        q = LL_Acofmaxminacc;
#define LL_cofmaxminacc LITERAL[214]
        a = LL_cofmaxminacc;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Acofmaxminacc2 LITERAL[215]
        q = LL_Acofmaxminacc2;
#define LL_cofmaxminacc2 LITERAL[216]
        a = LL_cofmaxminacc2;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Amultfromto LITERAL[217]
        q = LL_Amultfromto;
#define LL_multfromto LITERAL[218]
        a = LL_multfromto;
        CC_defcommand(a, q, m, arg4);
#define LL_argx2n LITERAL[219]
        arg4 = LL_argx2n;
#define LL_pfunc LITERAL[220]
        m = LL_pfunc;
        q = LL_Adf;
        a = LL_df;
        CC_defcommand(a, q, m, arg4);
        arg5 = nil;
#define LL_rexp LITERAL[221]
        arg4 = LL_rexp;
        m = LL_argx2n;
        q = LL_df;
        a = LL_Adf;
        CC_genprogram(a, q, m, arg4, arg5);
        a = LITERAL[222];
        CC_Aenter(a);
        a = CHAR_OF(64);
        a = CC_gevTid(a);
        a = Lncons(a);
        q = a;
#define LL_Asin LITERAL[223]
        a = LL_Asin;
        a = CC_gevTfunc(a, q);
        w1 = a;
        a = CHAR_OF(64);
        a = CC_gevTid(a);
        a = Lncons(a);
        q = a;
#define LL_Acos LITERAL[224]
        a = LL_Acos;
        a = CC_gevTfunc(a, q);
        q = a;
        a = w1;
        a = CC_Adefdffunc(a, q);
        CC_gsimpH(a);
        a = CHAR_OF(64);
        a = CC_gevTid(a);
        a = Lncons(a);
        q = a;
        a = LL_Acos;
        a = CC_gevTfunc(a, q);
        w1 = a;
        a = CHAR_OF(64);
        a = CC_gevTid(a);
        a = Lncons(a);
        q = a;
        a = LL_Asin;
        a = CC_gevTfunc(a, q);
        a = CC_gK(a);
        q = a;
        a = w1;
        a = CC_Adefdffunc(a, q);
        CC_gsimpH(a);
        a = CHAR_OF(64);
        a = CC_gevTid(a);
        a = Lncons(a);
        q = a;
#define LL_Aexp LITERAL[225]
        a = LL_Aexp;
        a = CC_gevTfunc(a, q);
        w1 = a;
        a = CHAR_OF(64);
        a = CC_gevTid(a);
        a = Lncons(a);
        q = a;
        a = LL_Aexp;
        a = CC_gevTfunc(a, q);
        q = a;
        a = w1;
        a = CC_Adefdffunc(a, q);
        CC_gsimpH(a);
        a = CHAR_OF(64);
        a = CC_gevTid(a);
        a = Lncons(a);
        q = a;
        a = LL_Alog;
        a = CC_gevTfunc(a, q);
        w1 = a;
        a = CHAR_OF(64);
        a = CC_gevTid(a);
        q = a;
        a = mkfxat(1);
        a = CC_gV(a, q);
        q = a;
        a = w1;
        a = CC_Adefdffunc(a, q);
        CC_gsimpH(a);
        a = LITERAL[115];
        CC_Aenter(a);
#define LL_mkfuncTdf LITERAL[226]
        m = LL_mkfuncTdf;
#define LL_mkfunc LITERAL[227]
        q = LL_mkfunc;
        a = LL_Adf;
        popv(1);
        a = CC_putTsimprs(a, q, m);
        return 1;
    }
}
Sex LITERAL[229];

const  char *comproc_literal_string[229] =
{
/* 0 */
"compllessp",
/* 1 */
"\"ABS\"",
/* 2 */
"\"FACTORIAL\"",
/* 3 */
"\"DoubleFACTORIAL\"",
/* 4 */
"\"COMBI\"",
/* 5 */
"!*random",
/* 6 */
"157.0000000000000",
/* 7 */
"0.6784521000000000",
/* 8 */
"\"either N, DEG or COFSZ\"",
/* 9 */
"1.100000000000000",
/* 10 */
"\"either DNSTY or DEG*DNSTY\"",
/* 11 */
"(333333 123321 123456 654321 123444 444321)",
/* 12 */
"\"TYPE\"",
/* 13 */
"(nil ! nil ! NIL)",
/* 14 */
"!!oset",
/* 15 */
"!*rndmsave",
/* 16 */
"0.3456789000000000",
/* 17 */
"!#poly!#",
/* 18 */
"\"intSequence\"",
/* 19 */
"\"DECSORT\"",
/* 20 */
"\"ARGUMENT IS NOT <OrdSET>\"",
/* 21 */
"numberp",
/* 22 */
"\"ELEMENTS ARE NOT NUMBERS\"",
/* 23 */
"complgeqp",
/* 24 */
"greaterp",
/* 25 */
"\"CLUSTER\"",
/* 26 */
"\"ARGUMENT IS NOT <SET/OSET>\"",
/* 27 */
"! nil",
/* 28 */
"\"SECOND ARG MUST BE NUMBER\"",
/* 29 */
"!!set",
/* 30 */
"rpartgeqp",
/* 31 */
"ipartgeqp",
/* 32 */
"0.1000000000000000",
/* 33 */
"\"CLUSTER2\"",
/* 34 */
"\"ARGS ARE OF DIFFERENT SIZES\"",
/* 35 */
"\"SECOND SET IS NOR NUMERIC\"",
/* 36 */
"\"THIRD ARG MUST BE NUMBER\"",
/* 37 */
"!*byproduct",
/* 38 */
"var",
/* 39 */
"(poly algn tran algf ratf)",
/* 40 */
"(vect matx tens array)",
/* 41 */
"(func pfunc set oset)",
/* 42 */
"(oper symbol)",
/* 43 */
"\"Invalid as type for MKSYMBOL\"",
/* 44 */
"!!gid",
/* 45 */
"!*temporal",
/* 46 */
"algn",
/* 47 */
"!#algn!#",
/* 48 */
"algf",
/* 49 */
"!#algf!#",
/* 50 */
"\"PUTTDEG\"",
/* 51 */
"\"SECOND ARGUMENT IS NOT <VAR>\"",
/* 52 */
"\"TDEG-VAR ORDER IS NOT HIGHEST\"",
/* 53 */
"\"PUTTDEG1\"",
/* 54 */
"\"LTELIM\"",
/* 55 */
"\"ARGUMENT IS NOT <POLY>\"",
/* 56 */
"!*quotient",
/* 57 */
"\"GCRPOWER\"",
/* 58 */
"!#ratf!#",
/* 59 */
"0.000000000000000",
/* 60 */
"!*chkcoef",
/* 61 */
"norm!:bnum",
/* 62 */
"norm1!:bnum",
/* 63 */
"norm2!:bnum",
/* 64 */
"\"MMC\"",
/* 65 */
"\"ARGUMENT IS NOT <RATF>\"",
/* 66 */
"\"ARGUMENT IS NOT <CANO>\"",
/* 67 */
"\"QMMC\"",
/* 68 */
"epartmax!:efitv",
/* 69 */
"!*machineps",
/* 70 */
"100.0000000000000",
/* 71 */
"epartmin!:efitv",
/* 72 */
"accmin!:efitv",
/* 73 */
"accmax!:efitv",
/* 74 */
"accminmax!:efitv",
/* 75 */
"cofmaxmin!:efitv",
/* 76 */
"\"ACCURACY UNDETECTABLE FOR\"",
/* 77 */
"accmnmx2!:efitv",
/* 78 */
"cofmxmn2!:efitv",
/* 79 */
"accmxmncof!:efitv",
/* 80 */
"accmxmncof2!:efitv",
/* 81 */
"cofmxmnacc!:efitv",
/* 82 */
"cofmxmnacc2!:efitv",
/* 83 */
"stop",
/* 84 */
"\"PRECISION UNDETECTABLE FOR\"",
/* 85 */
"\"ACCCOEF\"",
/* 86 */
"\"POLYNOMIAL MISMATCH\"",
/* 87 */
"\"MULTFROMTO\"",
/* 88 */
"\"SECOND ARG IS NOT <VAR>\"",
/* 89 */
"\"ARGUMENT TYPES MISMATCH\"",
/* 90 */
"\"INVALID RANGE PARAMETER\"",
/* 91 */
"!*mod",
/* 92 */
"!*fcut",
/* 93 */
"gal",
/* 94 */
"!.procmode",
/* 95 */
"\"DEFDFFUNC\"",
/* 96 */
"\"SHOULD BE USED IN GAL-MODE\"",
/* 97 */
"\"FIRST ARGUMENT IS NOT <FUNC>\"",
/* 98 */
"\"FISRST ARG IS NOT 'F(@)' FORM\"",
/* 99 */
"\"NO '@' IN SECOND ARGUMENT\"",
/* 100 */
"df",
/* 101 */
"\"DEFINED\"",
/* 102 */
"! invalid",
/* 103 */
"\"SECOND ARG TO 'DF' IS NOT <VAR/FUNC>\"",
/* 104 */
"\"THIRD ARG TO 'DF' IS NOT INTEGER > 0\"",
/* 105 */
"df!:srat",
/* 106 */
"c!+",
/* 107 */
"df!:cterm",
/* 108 */
"df!:nterm",
/* 109 */
"df!:ncan",
/* 110 */
"c!*",
/* 111 */
"! df",
/* 112 */
"! log",
/* 113 */
"uncol",
/* 114 */
"!*colmode",
/* 115 */
"(lisp)",
/* 116 */
"(!*rndmsave)",
/* 117 */
"command",
/* 118 */
"! idset",
/* 119 */
"idset",
/* 120 */
"idlist",
/* 121 */
"argxn",
/* 122 */
"dvpfunc",
/* 123 */
"! subst",
/* 124 */
"subst",
/* 125 */
"gexp",
/* 126 */
"arg1",
/* 127 */
"!?decorder",
/* 128 */
"!?decrorder",
/* 129 */
"! randomB24",
/* 130 */
"randomB24",
/* 131 */
"! randomD8",
/* 132 */
"randomD8",
/* 133 */
"! random1",
/* 134 */
"random1",
/* 135 */
"! randomUniPol",
/* 136 */
"randomUPol",
/* 137 */
"randomUniPol",
/* 138 */
"! intSequence",
/* 139 */
"intSequence",
/* 140 */
"! abs",
/* 141 */
"abs",
/* 142 */
"! fact",
/* 143 */
"fact",
/* 144 */
"! dfact",
/* 145 */
"dfact",
/* 146 */
"! combi",
/* 147 */
"combi",
/* 148 */
"nthroot",
/* 149 */
"sqrt",
/* 150 */
"! decsort",
/* 151 */
"decsort",
/* 152 */
"decrsort",
/* 153 */
"! sortbyabs",
/* 154 */
"sortbyabs",
/* 155 */
"! cluster",
/* 156 */
"cluster",
/* 157 */
"! mkvar",
/* 158 */
"mkvar",
/* 159 */
"newvar",
/* 160 */
"! mkpow",
/* 161 */
"mkpow",
/* 162 */
"mkpower",
/* 163 */
"! puttdeg",
/* 164 */
"puttdeg",
/* 165 */
"! puttdeg1",
/* 166 */
"puttdeg1",
/* 167 */
"! ltelim",
/* 168 */
"ltelim",
/* 169 */
"! htelim",
/* 170 */
"htelim",
/* 171 */
"! gcrpower",
/* 172 */
"gcrpow",
/* 173 */
"gcrpower",
/* 174 */
"! revunipol",
/* 175 */
"revpol",
/* 176 */
"revunipol",
/* 177 */
"! iqdiv2polnum",
/* 178 */
"iqdiv2pol",
/* 179 */
"! norm",
/* 180 */
"norm",
/* 181 */
"! norm1",
/* 182 */
"norm1",
/* 183 */
"! norm2",
/* 184 */
"norm2",
/* 185 */
"! mmc",
/* 186 */
"mmc",
/* 187 */
"! qmmc",
/* 188 */
"qmmc",
/* 189 */
"! sqnorm",
/* 190 */
"sqnorm",
/* 191 */
"! acccoef",
/* 192 */
"acccoef",
/* 193 */
"! epartmax",
/* 194 */
"epartmax",
/* 195 */
"! accmax",
/* 196 */
"accmax",
/* 197 */
"! accmin",
/* 198 */
"accmin",
/* 199 */
"! accmaxmin",
/* 200 */
"accmaxmin",
/* 201 */
"! accminmax",
/* 202 */
"accminmax",
/* 203 */
"! cofmaxmin",
/* 204 */
"cofmaxmin",
/* 205 */
"! accmaxmin2",
/* 206 */
"accmaxmin2",
/* 207 */
"! cofmaxmin2",
/* 208 */
"cofmaxmin2",
/* 209 */
"! accmaxmincof",
/* 210 */
"accmaxmincof",
/* 211 */
"! accmaxmincof2",
/* 212 */
"accmaxmincof2",
/* 213 */
"! cofmaxminacc",
/* 214 */
"cofmaxminacc",
/* 215 */
"! cofmaxminacc2",
/* 216 */
"cofmaxminacc2",
/* 217 */
"! multfromto",
/* 218 */
"multfromto",
/* 219 */
"argx2n",
/* 220 */
"pfunc",
/* 221 */
"rexp",
/* 222 */
"(gal)",
/* 223 */
"! sin",
/* 224 */
"! cos",
/* 225 */
"! exp",
/* 226 */
"mkfunc!:df",
/* 227 */
"mkfunc",
/* 228 */ NULL
};
setup_type const comproc_g_setup[] =
{
    {"df:srat", (lisp_proc *)CC_dfTsrat, 3},
    {"df:bpol", (lisp_proc *)CC_dfTbpol, 3},
    {"df:func", (lisp_proc *)CC_dfTfunc, 2},
    {"df:c*", (lisp_proc *)CC_dfTcH, 2},
    {"df:cterm", (lisp_proc *)CC_dfTcterm, 3},
    {"df:ncan", (lisp_proc *)CC_dfTncan, 3},
    {"df:pref", (lisp_proc *)CC_dfTpref, 3},
    {"df:cano", (lisp_proc *)CC_dfTcano, 3},
    {"df:bnum", (lisp_proc *)CC_dfTbnum, 3},
    {"mkfunc:df", (lisp_proc *)CC_mkfuncTdf, 2},
    {" defdffunc", (lisp_proc *)CC_Adefdffunc, 2},
    {"multfrto:bplany", (lisp_proc *)CC_multfrtoTbplany, 5},
    {"multfrto:bplcof", (lisp_proc *)CC_multfrtoTbplcof, 5},
    {"multfrto:bplbpl", (lisp_proc *)CC_multfrtoTbplbpl, 5},
    {"multfrto:bplvar", (lisp_proc *)CC_multfrtoTbplvar, 5},
    {"multfrto:varvar", (lisp_proc *)CC_multfrtoTvarvar, 5},
    {"multfromto*", (lisp_proc *)CC_multfromtoH, 5},
    {" multfromto", (lisp_proc *)CC_Amultfromto, 5},
    {"acccof:bpol", (lisp_proc *)CC_acccofTbpol, 2},
    {"vpartmax:efitv", (lisp_proc *)CC_vpartmaxTefitv, 1},
    {"epartmin:efitv", (lisp_proc *)CC_epartminTefitv, 1},
    {"epartmax:efitv", (lisp_proc *)CC_epartmaxTefitv, 1},
    {"accmax:efitv", (lisp_proc *)CC_accmaxTefitv, 1},
    {"accmin:efitv", (lisp_proc *)CC_accminTefitv, 1},
    {"accminmax:efitv", (lisp_proc *)CC_accminmaxTefitv, 1},
    {"cofmxmnacc2:efitv", (lisp_proc *)CC_cofmxmnacc2Tefitv, 1},
    {" cofmaxminacc2", (lisp_proc *)CC_Acofmaxminacc2, 1},
    {"cofmxmnacc:efitv", (lisp_proc *)CC_cofmxmnaccTefitv, 1},
    {" cofmaxminacc", (lisp_proc *)CC_Acofmaxminacc, 1},
    {"accmxmncof2:efitv", (lisp_proc *)CC_accmxmncof2Tefitv, 1},
    {" accmaxmincof2", (lisp_proc *)CC_Aaccmaxmincof2, 1},
    {"accmxmncof:efitv", (lisp_proc *)CC_accmxmncofTefitv, 1},
    {" accmaxmincof", (lisp_proc *)CC_Aaccmaxmincof, 1},
    {"cofmxmn2:efitv", (lisp_proc *)CC_cofmxmn2Tefitv, 1},
    {" cofmaxmin2", (lisp_proc *)CC_Acofmaxmin2, 1},
    {"accmnmx2:efitv", (lisp_proc *)CC_accmnmx2Tefitv, 1},
    {" accmaxmin2", (lisp_proc *)CC_Aaccmaxmin2, 1},
    {"cofmaxmin:efitv", (lisp_proc *)CC_cofmaxminTefitv, 1},
    {" cofmaxmin", (lisp_proc *)CC_Acofmaxmin, 1},
    {" accminmax", (lisp_proc *)CC_Aaccminmax, 1},
    {" accmaxmin", (lisp_proc *)CC_Aaccmaxmin, 1},
    {" accmax", (lisp_proc *)CC_Aaccmax, 1},
    {" accmin", (lisp_proc *)CC_Aaccmin, 1},
    {" acccoef", (lisp_proc *)CC_Aacccoef, 2},
    {" epartmin", (lisp_proc *)CC_Aepartmin, 1},
    {" epartmax", (lisp_proc *)CC_Aepartmax, 1},
    {"qmmc:bpol", (lisp_proc *)CC_qmmcTbpol, 2},
    {"mmc:bpol", (lisp_proc *)CC_mmcTbpol, 2},
    {" sqnorm", (lisp_proc *)CC_Asqnorm, 1},
    {" qmmc", (lisp_proc *)CC_Aqmmc, 1},
    {" mmcrat", (lisp_proc *)CC_Ammcrat, 1},
    {" mmc", (lisp_proc *)CC_Ammc, 1},
    {"norm2:bnum", (lisp_proc *)CC_norm2Tbnum, 1},
    {" norm2", (lisp_proc *)CC_Anorm2, 1},
    {"norm1:bnum", (lisp_proc *)CC_norm1Tbnum, 1},
    {" norm1", (lisp_proc *)CC_Anorm1, 1},
    {"norm:bnum", (lisp_proc *)CC_normTbnum, 1},
    {" norm", (lisp_proc *)CC_Anorm, 1},
    {"iqdiv2:bpolnum", (lisp_proc *)CC_iqdiv2Tbpolnum, 2},
    {" iqdiv2polnum", (lisp_proc *)CC_Aiqdiv2polnum, 2},
    {"redvars:bpol", (lisp_proc *)CC_redvarsTbpol, 2},
    {"reduce:vars", (lisp_proc *)CC_reduceTvars, 2},
    {" revunipol", (lisp_proc *)CC_Arevunipol, 1},
    {"gcrpow:bpol", (lisp_proc *)CC_gcrpowTbpol, 2},
    {" gcrpower", (lisp_proc *)CC_Agcrpower, 1},
    {"ltelim:bpolbpol", (lisp_proc *)CC_ltelimTbpolbpol, 2},
    {"ltelim:polypoly", (lisp_proc *)CC_ltelimTpolypoly, 2},
    {" ltelim", (lisp_proc *)CC_Altelim, 2},
    {"tdg:nextmono", (lisp_proc *)CC_tdgTnextmono, 2},
    {"puttdeg:bpol", (lisp_proc *)CC_puttdegTbpol, 2},
    {" puttdeg1", (lisp_proc *)CC_Aputtdeg1, 2},
    {" puttdeg", (lisp_proc *)CC_Aputtdeg, 2},
    {" mkpow", (lisp_proc *)CC_Amkpow, 2},
    {" mkvar", (lisp_proc *)CC_Amkvar, 0},
    {"mksymbol", (lisp_proc *)CC_mksymbol, 1},
    {" cluster2", (lisp_proc *)CC_Acluster2, 3},
    {" cluster", (lisp_proc *)CC_Acluster, 2},
    {" sortbyabs", (lisp_proc *)CC_Asortbyabs, 1},
    {" decsort", (lisp_proc *)CC_Adecsort, 1},
    {" intSequence", (lisp_proc *)CC_AintSequence, 3},
    {"rndmCof:nrmlz", (lisp_proc *)CC_rndmCofTnrmlz, 8},
    {"rndmUPol:exs", (lisp_proc *)CC_rndmUPolTexs, 4},
    {" randomUniPol", (lisp_proc *)CC_ArandomUniPol, 9},
    {" random1", (lisp_proc *)CC_Arandom1, 1},
    {" randomD8", (lisp_proc *)CC_ArandomD8, 1},
    {" randomB24", (lisp_proc *)CC_ArandomB24, 1},
    {" combi", (lisp_proc *)CC_Acombi, 2},
    {" dfact", (lisp_proc *)CC_Adfact, 1},
    {" fact", (lisp_proc *)CC_Afact, 1},
    {"g!!", (lisp_proc *)CC_gBB, 1},
    {"g!", (lisp_proc *)CC_gB, 1},
    {" abs", (lisp_proc *)CC_Aabs, 1},
    {"?decorder", (lisp_proc *)CC_Wdecorder, 1},
    {NULL, NULL, 0 }
};

