#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_libalg.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex libalg_literal_vector[];
const char *libalg_literal_string[];
setup_type const  libalg_g_setup[];
#define LITERAL libalg_literal_vector




Sex CC_negTunipol(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    if(!is_number(a)) goto    G0002;
    {
        popv(5);
        return  CC_negTbnum(a);
    }
   G0002:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = cdr(cdr(a));
    w4 = a;
    a = car(cdr(w1));
    a = Lncons(a);
    w3 = a;
    q = car(w1);
    a = Lxcons(a, q);
    w2 = a;
   G0005:
    a = cdr(car(w4));
    a = CC_negTbnum(a);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0008;
    q = w5;
    a = car(car(w4));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
   G0008:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0005;
    a = cdr(w2);
    a = CC_reduceTbpol(a);
    w3 = a;
    if(!is_number(a)) goto    G0015;
    w2 = a;
   G0015:
    a = w2;
    popv(5);
    return a;
}

Sex CC_addTunipol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_number(a)) goto    G0020;
    if(!is_number(q)) goto    G0019;
   G0020:
    {
        popv(8);
        return  CC_addH(a, q);
    }
   G0019:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = car(cdr(a));
    a = Lncons(a);
    w4 = a;
    q = car(w1);
    a = Lxcons(a, q);
    w3 = a;
    a = cdr(cdr(w1));
    w1 = a;
    a = car(car(a));
    w5 = a;
    a = cdr(car(w1));
    w7 = a;
    a = cdr(cdr(w2));
    w2 = a;
    a = car(car(a));
    w6 = a;
    a = cdr(car(w2));
    w8 = a;
   G0023:
    q = w6;
    a = w5;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0024;
    q = w6;
    a = w5;
    a = Llessp(a, q);
    if(a != nil) goto    G0025;
    q = w8;
    a = w7;
    a = plus2(a, q);
    w7 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0032;
    q = w7;
    a = w5;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G0032:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0038;
    q = cdr(w2);
    goto    G0056;
   G0038:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0040;
    q = w1;
    goto    G0056;
   G0040:
    a = car(car(w1));
    w5 = a;
    a = cdr(car(w1));
    w7 = a;
    a = car(car(w2));
    goto    G0055;
   G0024:
    a = car(w1);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0044;
    q = w2;
    goto    G0056;
   G0044:
    a = car(car(a));
    w5 = a;
    a = cdr(car(w1));
    w7 = a;
    goto    G0023;
   G0025:
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G0057;
    a = car(car(a));
   G0055:
    w6 = a;
    a = cdr(car(w2));
    w8 = a;
    goto    G0023;
   G0057:
    q = w1;
   G0056:
    a = w4;
    cdr(a) = q;
    a = cdr(w3);
    a = CC_reduceTbpol(a);
    w4 = a;
    if(!is_number(a)) goto    G0050;
    w3 = a;
   G0050:
#define LL_Hmod LITERAL[0]
    a = value(LL_Hmod);
    if(a == nil) goto    G0052;
    a = w3;
    a = CC_redmodTncan(a);
    w3 = a;
   G0052:
    a = w3;
    popv(8);
    return a;
}

Sex CC_multTunipol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_number(a)) goto    G0062;
    if(!is_number(q)) goto    G0061;
   G0062:
    {
        popv(12);
        return  CC_multH(a, q);
    }
   G0061:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    a = Llength(a);
    w12 = a;
    a = w2;
    a = Llength(a);
    q = a;
    a = w12;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0071;
    a = w1;
    w6 = a;
    a = w2;
    w1 = a;
    a = w6;
    w2 = a;
   G0071:
    a = car(cdr(w1));
    a = Lncons(a);
    w4 = a;
    q = car(w1);
    a = Lxcons(a, q);
    w3 = a;
    a = cdr(cdr(w1));
    w1 = a;
    a = cdr(cdr(w2));
    w2 = a;
    a = w4;
    w5 = a;
    a = car(car(w1));
    w8 = a;
    a = cdr(car(w1));
    w7 = a;
    a = w2;
    w11 = a;
   G0065:
    if(a == nil) goto    G0076;
    q = car(car(a));
    a = w8;
    a = plus2(a, q);
    w12 = a;
    q = cdr(car(w11));
    a = w7;
    a = times2(a, q);
    q = w12;
    a = Lxcons(a, q);
    w9 = a;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w11);
    w11 = a;
    goto    G0065;
   G0076:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G0069;
    a = car(car(a));
    w8 = a;
    a = cdr(car(w1));
    w7 = a;
    a = w2;
    w11 = a;
    q = car(car(a));
    a = w8;
    a = plus2(a, q);
    q = a;
    a = w4;
    a = CC_pointTtm(a, q);
    w5 = a;
    w4 = a;
    a = cdr(a);
    w6 = a;
   G0067:
    q = car(car(w11));
    a = w8;
    a = plus2(a, q);
    w10 = a;
    q = cdr(car(w11));
    a = w7;
    a = times2(a, q);
    w9 = a;
    a = w6;
   G0068:
    if(a != nil) goto    G0086;
    q = w9;
    a = w10;
    a = cons(a, q);
    a = Lncons(a);
    goto    G0105;
   G0086:
    q = w10;
    a = car(car(a));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0090;
    a = w6;
    w5 = a;
    a = cdr(a);
    w6 = a;
    goto    G0068;
   G0090:
    q = w10;
    a = car(car(w6));
    a = Llessp(a, q);
    if(a == nil) goto    G0092;
    q = w9;
    a = w10;
    a = cons(a, q);
    q = w6;
    a = cons(a, q);
   G0105:
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G0098;
   G0092:
    q = cdr(car(w6));
    a = w9;
    a = plus2(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0096;
    q = cdr(w6);
    a = w5;
    goto    G0106;
   G0096:
    a = w6;
    w5 = a;
    a = car(a);
    q = w9;
   G0106:
    cdr(a) = q;
   G0098:
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G0076;
    a = cdr(w5);
    w6 = a;
    goto    G0067;
   G0069:
    a = value(LL_Hmod);
    if(a == nil) goto    G0104;
    a = w3;
    a = CC_redmodTncan(a);
    w3 = a;
   G0104:
    a = w3;
    popv(12);
    return a;
}

Sex CC_powTunipol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lzerop(a);
    if(a == nil) goto    G0110;
    a = mkfxat(1);
    goto    G0113;
   G0110:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G0111;
    a = w1;
    goto    G0113;
   G0111:
    q = mkfxat(2);
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G0112;
    q = w1;
    a = q;
    goto    G0120;
   G0112:
    w3 = nil;
    q = mkfxat(2);
    a = w2;
    a = quot2(a, q);
    q = a;
    a = w1;
    a = CC_powTunipol(a, q);
    w3 = a;
    q = a;
    a = CC_multTunipol(a, q);
    w3 = a;
    a = w2;
    a = Levenp(a);
    if(a == nil) goto    G0117;
    a = w3;
    goto    G0113;
   G0117:
    q = w3;
    a = w1;
   G0120:
    a = CC_multTunipol(a, q);
   G0113:
    popv(3);
    return a;
}

Sex CC_xctdivTunipol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0124;
    if(is_number(q)) goto    G0126;
    q = mkfxat(0);
    {
        popv(14);
        return  Lxcons(a, q);
    }
   G0126:
    a = CC_flgdivTbnumbnum(a, q);
    goto    G0182;
   G0124:
    if(!is_number(q)) goto    G0129;
    a = CC_quotiH(a, q);
   G0182:
    q = mkfxat(0);
    goto    G0184;
   G0129:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    a = CC_Adeg(a);
    w14 = a;
    a = w2;
    a = CC_Adeg(a);
    q = a;
    a = w14;
    a = Llessp(a, q);
    if(a == nil) goto    G0140;
    q = w1;
    a = mkfxat(0);
    goto    G0184;
   G0140:
    a = car(cdr(w1));
    a = Lncons(a);
    w4 = a;
    q = car(w1);
    a = Lxcons(a, q);
    w3 = a;
    a = cdr(w1);
    a = CC_topcopy(a);
    w1 = a;
    a = cdr(cdr(w2));
    w2 = a;
    a = car(car(a));
    w9 = a;
    a = cdr(car(w2));
    w12 = a;
    a = cdr(w2);
    w2 = a;
   G0133:
    a = car(cdr(w1));
    w13 = a;
    a = w9;
    a = Lminus(a);
    q = a;
    a = car(w13);
    a = plus2(a, q);
    w7 = a;
    a = Lminusp(a);
    if(a != nil) goto    G0174;
    q = w12;
    a = cdr(w13);
    a = CC_flgdivTbnumbnum(a, q);
    w10 = a;
    q = cdr(cdr(w1));
    a = w1;
    cdr(a) = q;
    w5 = a;
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G0172;
    q = w10;
    a = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = w2;
    if(a == nil) goto    G0172;
    w13 = a;
    a = w10;
    a = Lminus(a);
    w10 = a;
   G0134:
    q = car(car(w13));
    a = w7;
    a = plus2(a, q);
    w8 = a;
    q = cdr(car(w13));
    a = w10;
    a = times2(a, q);
    w11 = a;
   G0135:
    a = cdr(w5);
    w6 = a;
    if(a != nil) goto    G0157;
    q = w11;
    a = w8;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    goto    G0185;
   G0157:
    q = w8;
    a = car(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G0161;
    q = cdr(car(w6));
    a = w11;
    a = plus2(a, q);
    w11 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0163;
    q = cdr(w6);
    a = w5;
    goto    G0186;
   G0163:
    q = w11;
    a = w8;
    a = cons(a, q);
    q = a;
    a = w6;
    car(a) = q;
   G0185:
    w5 = a;
    goto    G0167;
   G0161:
    q = w8;
    a = car(car(w6));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0166;
    a = w6;
    w5 = a;
    goto    G0135;
   G0166:
    q = w11;
    a = w8;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = w6;
   G0186:
    cdr(a) = q;
   G0167:
    a = cdr(w13);
    w13 = a;
    if(a != nil) goto    G0134;
   G0172:
    a = cdr(w1);
    if(a != nil) goto    G0133;
   G0174:
    a = w1;
    a = CC_reduceTbpol(a);
    w1 = a;
    if(is_number(a)) goto    G0176;
    q = car(w3);
    a = Lxcons(a, q);
    w1 = a;
   G0176:
    a = cdr(w3);
    a = CC_reduceTbpol(a);
    w4 = a;
    if(!is_number(a)) goto    G0178;
    w3 = a;
   G0178:
    a = value(LL_Hmod);
    if(a == nil) goto    G0180;
    a = w1;
    a = CC_redmodTncan(a);
    w1 = a;
   G0180:
    q = w1;
    a = w3;
   G0184:
    {
        popv(14);
        return  cons(a, q);
    }
}

Sex CC_xctquoTunipol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G0190;
    if(!is_number(q)) goto    G0244;
    {
        popv(14);
        return  CC_flgdivTbnumbnum(a, q);
    }
   G0190:
    if(!is_number(q)) goto    G0194;
    {
        popv(14);
        return  CC_quotiH(a, q);
    }
   G0194:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    a = CC_Adeg(a);
    w14 = a;
    a = w2;
    a = CC_Adeg(a);
    q = a;
    a = w14;
    a = Llessp(a, q);
    if(a == nil) goto    G0204;
   G0244:
    a = mkfxat(0);
    goto    G0195;
   G0204:
    a = car(cdr(w1));
    a = Lncons(a);
    w4 = a;
    q = car(w1);
    a = Lxcons(a, q);
    w3 = a;
    a = cdr(w1);
    a = CC_topcopy(a);
    w1 = a;
    a = cdr(cdr(w2));
    w2 = a;
    a = car(car(a));
    w9 = a;
    a = cdr(car(w2));
    w12 = a;
    a = cdr(w2);
    w2 = a;
   G0197:
    a = car(cdr(w1));
    w13 = a;
    a = w9;
    a = Lminus(a);
    q = a;
    a = car(w13);
    a = plus2(a, q);
    w7 = a;
    a = Lminusp(a);
    if(a != nil) goto    G0239;
    q = w12;
    a = cdr(w13);
    a = CC_flgdivTbnumbnum(a, q);
    w10 = a;
    q = cdr(cdr(w1));
    a = w1;
    cdr(a) = q;
    w5 = a;
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G0237;
    q = w10;
    a = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = w2;
    if(a == nil) goto    G0237;
    w13 = a;
    a = w10;
    a = Lminus(a);
    w10 = a;
   G0198:
    q = car(car(w13));
    a = w7;
    a = plus2(a, q);
    w8 = a;
    q = w9;
    a = Llessp(a, q);
    if(a != nil) goto    G0237;
    q = cdr(car(w13));
    a = w10;
    a = times2(a, q);
    w11 = a;
   G0199:
    a = cdr(w5);
    w6 = a;
    if(a != nil) goto    G0222;
    q = w11;
    a = w8;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    goto    G0245;
   G0222:
    q = w8;
    a = car(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G0226;
    q = cdr(car(w6));
    a = w11;
    a = plus2(a, q);
    w11 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0228;
    q = cdr(w6);
    a = w5;
    goto    G0246;
   G0228:
    q = w11;
    a = w8;
    a = cons(a, q);
    q = a;
    a = w6;
    car(a) = q;
   G0245:
    w5 = a;
    goto    G0232;
   G0226:
    q = w8;
    a = car(car(w6));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0231;
    a = w6;
    w5 = a;
    goto    G0199;
   G0231:
    q = w11;
    a = w8;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = w6;
   G0246:
    cdr(a) = q;
   G0232:
    a = cdr(w13);
    w13 = a;
    if(a != nil) goto    G0198;
   G0237:
    a = cdr(w1);
    if(a != nil) goto    G0197;
   G0239:
    a = w1;
    a = CC_reduceTbpol(a);
    w1 = a;
    if(is_number(a)) goto    G0241;
    q = car(w3);
    a = Lxcons(a, q);
    w1 = a;
   G0241:
    a = cdr(w3);
    a = CC_reduceTbpol(a);
    w4 = a;
    if(!is_number(a)) goto    G0243;
    w3 = a;
   G0243:
    a = w3;
   G0195:
    popv(14);
    return a;
}

Sex CC_trydivTunipolZ(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_number(q)) goto    G0250;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G0252;
    a = w1;
    goto    G0263;
   G0252:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    a = cdr(cdr(w1));
    w5 = a;
    q = car(cdr(w1));
    a = car(w1);
    a = Llist2(a, q);
    w3 = a;
    a = cdr(a);
    w4 = a;
   G0255:
    q = w2;
    a = cdr(car(w5));
    a = Ldivide(a, q);
    w6 = a;
    a = cdr(a);
    a = Lzerop(a);
    if(a == nil) goto    G0263;
    q = car(w6);
    a = car(car(w5));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G0314;
    goto    G0255;
   G0250:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    q = car(cdr(a));
    a = car(a);
    a = Llist2(a, q);
    w3 = a;
    a = cdr(a);
    w4 = a;
    a = cdr(cdr(w1));
    a = CC_topcopy(a);
    w1 = a;
    a = cdr(cdr(w2));
    w2 = a;
   G0265:
    a = car(car(w1));
    w8 = a;
    a = car(car(w2));
    w11 = a;
    q = a;
    a = w8;
    a = Llessp(a, q);
    if(a == nil) goto    G0272;
    a = nil;
    goto    G0263;
   G0272:
    q = cdr(car(w2));
    a = cdr(car(w1));
    a = Ldivide(a, q);
    w6 = a;
    a = cdr(a);
    a = Lzerop(a);
    if(a == nil) goto    G0263;
    a = car(w6);
    w6 = a;
    a = w11;
    a = Lminus(a);
    q = a;
    a = w8;
    a = plus2(a, q);
    w5 = a;
    q = w6;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = w1;
    w7 = a;
    a = cdr(w2);
    w10 = a;
   G0266:
    a = w10;
    if(a == nil) goto    G0270;
    a = cdr(w7);
    if(a == nil) goto    G0299;
    a = car(car(cdr(w7)));
    w8 = a;
    q = w5;
    a = car(car(w10));
    a = plus2(a, q);
    w11 = a;
    q = a;
    a = w8;
    a = Lequal(a, q);
    if(a == nil) goto    G0289;
    q = cdr(car(w10));
    a = w6;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = cdr(car(cdr(w7)));
    a = plus2(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0295;
    q = cdr(cdr(w7));
    a = w7;
    cdr(a) = q;
    goto    G0319;
   G0295:
    q = w9;
    a = w8;
    a = cons(a, q);
    q = a;
    a = cdr(w7);
    car(a) = q;
    a = cdr(w7);
    w7 = a;
    goto    G0319;
   G0289:
    q = w11;
    a = w8;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0269;
   G0268:
    a = cdr(w7);
    w7 = a;
    a = cdr(a);
    if(a == nil) goto    G0299;
    q = w11;
    a = car(car(cdr(w7)));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0266;
    goto    G0268;
   G0269:
    a = w6;
    a = Lminus(a);
    q = cdr(car(w10));
    a = times2(a, q);
    w12 = a;
    q = w11;
    a = Lxcons(a, q);
    q = cdr(w7);
    a = cons(a, q);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(w7);
    w7 = a;
   G0319:
    a = cdr(w10);
    w10 = a;
    goto    G0266;
   G0299:
    a = w6;
    a = Lminus(a);
    q = w5;
    a = Lxcons(a, q);
    q = a;
    a = CHAR_OF(86);
    a = Llist2(a, q);
    w13 = a;
    q = w10;
    a = CHAR_OF(86);
    a = cons(a, q);
    q = a;
    a = w13;
    a = CC_Hbpolbpol(a, q);
    w10 = a;
    q = cdr(a);
    a = w7;
    cdr(a) = q;
   G0270:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0265;
    a = car(cdr(cdr(w3)));
    w4 = a;
    a = car(a);
    a = Lzerop(a);
    if(a == nil) goto    G0314;
    a = cdr(w4);
    w3 = a;
   G0314:
    a = w3;
   G0263:
    popv(13);
    return a;
}

Sex CC_dfTunipol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Adeg(a);
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G0345;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = cdr(w1);
    w3 = a;
   G0327:
    a = car(w3);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w3);
    w3 = a;
   G0328:
    a = car(car(w3));
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0330;
    q = cdr(car(w3));
    a = w6;
    a = CC_Hbnumany(a, q);
    w7 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0330;
    a = w6;
    a = Lsub1(a);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G0330:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0328;
    a = w4;
    a = CC_reduceTbpol(a);
    w3 = a;
    if(is_number(a)) goto    G0343;
    a = car(a);
    if(!is_integer(a)) goto    G0342;
   G0343:
    a = w2;
    a = Lonep(a);
    if(a == nil) goto    G0345;
    a = w3;
    goto    G0325;
   G0345:
    a = mkfxat(0);
    goto    G0325;
   G0342:
    q = mkfxat(-1);
    a = w2;
    a = plus2(a, q);
    w2 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0327;
    q = w3;
    a = car(w1);
    a = cons(a, q);
   G0325:
    popv(7);
    return a;
}

Sex CC_WdivoverZpQA(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = CC_Wmodulo();
    q = w1;
    if(a != nil) goto    G0355;
    a = w2;
    a = CC_Vpol3pol3(a, q);
    goto    G0361;
   G0355:
    a = w2;
    a = CC_VLpol3pol3(a, q);
    w1 = a;
    a = cdr(a);
    a = CC_redmodTncan(a);
    a = Lzerop(a);
    if(a == nil) goto    G0356;
    a = car(w1);
    a = CC_redmodTncan(a);
   G0361:
#define LL_Hbyproduct LITERAL[1]
    value(LL_Hbyproduct) = a;
   G0356:
    popv(2);
    return a;
}

Sex CC_Aclearden(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    if(!is_number(a)) goto    G0365;
    if(!is_rational(a)) goto    G0367;
    {
        popv(1);
        return  Lden(a);
    }
   G0367:
    a = mkfxat(1);
    goto    G0372;
   G0365:
#define LL_CmaxcanoC LITERAL[2]
    if(car(a) < value(LL_CmaxcanoC)) goto    G0369;
    a = LITERAL[3];
    {
        popv(1);
        return  CC_argerror(a);
    }
   G0369:
#define LL_CratfC LITERAL[4]
    if(car(a) >= value(LL_CratfC)) goto    G0370;
    q = cdr(a);
    a = mkfxat(0);
    a = CC_denlcmTbpol(a, q);
    value(LL_Hbyproduct) = a;
    q = w1;
    {
        popv(1);
        return  CC_Hbnumpol3(a, q);
    }
   G0370:
    a = cdr(cdr(a));
    if(a != nil) goto    G0371;
    a = car(car(cdr(w1)));
    value(LL_Hbyproduct) = a;
    a = cdr(car(cdr(w1)));
    goto    G0372;
   G0371:
    a = w1;
    a = CC_collectTratf(a);
    a = CC_Aclearden(a);
   G0372:
    popv(1);
    return a;
}

Sex CC_Apowroot(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_cons(a)) goto    G0377;
    if(!is_integer(a)) goto    G0458;
    a = Lplusp(a);
    if(a == nil) goto    G0458;
    a = w2;
    if(!is_integer(a)) goto    G0458;
    a = Lplusp(a);
    if(a == nil) goto    G0458;
    a = w1;
    if(!is_integer(a)) goto    G0383;
    q = w2;
    a = CC_nthroot(a, q);
    w1 = a;
    if(!is_integer(a)) goto    G0464;
    goto    G0398;
   G0383:
    if(!is_rational(a)) goto    G0458;
    w3 = nil;
    w4 = nil;
    a = Lnum(a);
    q = w2;
    a = CC_nthroot(a, q);
    w3 = a;
    if(!is_integer(a)) goto    G0464;
    a = w1;
    a = Lden(a);
    q = w2;
    a = CC_nthroot(a, q);
    w4 = a;
    if(!is_integer(a)) goto    G0464;
    q = a;
    a = w3;
    {
        popv(10);
        return  Lmkrational(a, q);
    }
   G0377:
    if(car(a) < value(LL_CmaxcanoC)) goto    G0397;
   G0458:
    a = LITERAL[5];
    {
        popv(10);
        return  CC_argerror(a);
    }
   G0397:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G0403;
    a = w1;
    goto    G0398;
   G0403:
    a = car(w1);
    if(a == value(LL_CratfC)) goto    G0401;
    a = w1;
    a = CC_Adeg(a);
    w8 = a;
    q = w2;
    a = w8;
    a = remaind2(a, q);
    a = Lzerop(a);
    if(a == nil) goto    G0464;
    a = w1;
    a = CC_Alcoef(a);
    w7 = a;
    a = Lonep(a);
    if(a != nil) goto    G0411;
    q = w2;
    a = w7;
    a = CC_Apowroot(a, q);
    w7 = a;
#define LL_Anil LITERAL[6]
    if(a == LL_Anil) goto    G0464;
   G0411:
    a = w2;
    a = Lsub1(a);
    q = a;
    a = w7;
    a = CC_powH(a, q);
    q = a;
    a = w2;
    a = CC_multH(a, q);
    w9 = a;
    a = w1;
    a = CC_Amvar(a);
    w5 = a;
    a = w7;
    if(!is_cons(a)) goto    G0418;
    a = car(a);
    if(!is_integer(a)) goto    G0418;
    a = cdr(w7);
    w7 = a;
   G0418:
    a = w5;
    a = Lncons(a);
    w6 = a;
    q = car(w1);
    a = Lxcons(a, q);
    w3 = a;
    q = w2;
    a = w8;
    a = quot2(a, q);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = w3;
    a = CC_Adeg(a);
    w10 = a;
    q = mkfxat(-1);
    a = w2;
    a = plus2(a, q);
    q = a;
    a = w10;
    a = times2(a, q);
    w8 = a;
   G0400:
    q = w2;
    a = w3;
    a = CC_powH(a, q);
    a = CC_negH(a);
    q = a;
    a = w1;
    a = CC_addH(a, q);
    w4 = a;
    if(!is_number(a)) goto    G0430;
    a = Lzerop(a);
    if(a == nil) goto    G0464;
    a = w3;
    goto    G0398;
   G0430:
    a = CC_Amvar(a);
    q = w5;
    a = Lequal(a, q);
    if(a == nil) goto    G0464;
    a = w4;
    a = CC_Alcoef(a);
    q = w9;
    a = CC_Vanyany(a, q);
    w7 = a;
    if(a == nil) goto    G0464;
    a = CC_Wmodulo();
    if(a == nil) goto    G0440;
    a = w7;
    a = CC_redmodTncan(a);
    w7 = a;
   G0440:
    a = w7;
    if(!is_cons(a)) goto    G0442;
    a = car(a);
    if(!is_integer(a)) goto    G0442;
    a = cdr(w7);
    w7 = a;
   G0442:
    a = w4;
    a = CC_Adeg(a);
    q = w8;
    a = diff2(a, q);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    goto    G0400;
   G0401:
    q = w2;
    a = car(car(cdr(w1)));
    a = CC_Apowroot(a, q);
    w8 = a;
    if(a == nil) goto    G0464;
    q = w2;
    a = cdr(car(cdr(w1)));
    a = CC_Apowroot(a, q);
    w7 = a;
    if(a != nil) goto    G0452;
   G0464:
    a = LL_Anil;
    goto    G0398;
   G0452:
    q = w8;
    a = Lxcons(a, q);
    q = a;
    a = value(LL_CratfC);
    a = Llist2(a, q);
   G0398:
    popv(10);
    return a;
}

Sex CC_AuniHensel(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w14 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    CC_savemod();
    a = CC_Atellmod();
    w5 = a;
    a = CC_Wnoargchk();
    if(a != nil) goto    G0490;
    a = w1;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0474;
    a = w2;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0474;
    a = w3;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0473;
   G0474:
    q = LITERAL[7];
    a = LITERAL[8];
    goto    G0508;
   G0473:
    a = w1;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0476;
    a = w2;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0476;
    a = w3;
    a = CC_Wunivar(a);
    if(a != nil) goto    G0475;
   G0476:
    q = LITERAL[7];
    a = LITERAL[9];
    goto    G0508;
   G0475:
    a = w1;
    a = CC_Amvar(a);
    w14 = a;
    a = w2;
    a = CC_Amvar(a);
    q = a;
    a = w14;
    a = Lequal(a, q);
    if(a == nil) goto    G0478;
    a = w1;
    a = CC_Amvar(a);
    w14 = a;
    a = w3;
    a = CC_Amvar(a);
    q = a;
    a = w14;
    a = Lequal(a, q);
    if(a != nil) goto    G0477;
   G0478:
    q = LITERAL[7];
    a = LITERAL[10];
    goto    G0508;
   G0477:
    a = w4;
    if(!is_integer(a)) goto    G0484;
    a = Lplusp(a);
    if(a != nil) goto    G0483;
   G0484:
    q = w4;
    a = LITERAL[11];
    goto    G0508;
   G0483:
    a = w1;
    a = CC_Adeg(a);
    w14 = a;
    a = w2;
    a = CC_Adeg(a);
    w15 = a;
    a = w3;
    a = CC_Adeg(a);
    q = a;
    a = w15;
    a = plus2(a, q);
    q = a;
    a = w14;
    a = Lequal(a, q);
    if(a != nil) goto    G0485;
    q = LITERAL[7];
    a = LITERAL[12];
    goto    G0508;
   G0485:
    a = w5;
    if(a == nil) goto    G0492;
    if(!is_integer(a)) goto    G0492;
    a = Lplusp(a);
    if(a != nil) goto    G0490;
   G0492:
    q = LITERAL[7];
    a = LITERAL[13];
   G0508:
    CC_errormsg(a, q);
   G0490:
    q = w3;
    a = w2;
    a = CC_cofact0Tunipol(a, q);
    w13 = a;
    a = car(a);
    w7 = a;
    a = cdr(w13);
    w8 = a;
    a = w5;
    w6 = a;
    a = mkfxat(1);
    w12 = a;
    a = w2;
    w9 = a;
    a = w3;
    w10 = a;
   G0469:
    q = w6;
    a = w5;
    a = times2(a, q);
    w6 = a;
    CC_setmod(a);
    a = w12;
    a = Ladd1(a);
    w12 = a;
    q = w10;
    a = w9;
    a = CC_multTunipol(a, q);
    a = CC_negTunipol(a);
    q = a;
    a = w1;
    a = CC_addTunipol(a, q);
    w13 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0501;
    q = w8;
    a = w13;
    a = CC_multTunipol(a, q);
    q = w2;
    a = CC_xctdivTunipol(a, q);
    w11 = a;
    q = cdr(a);
    a = w9;
    a = CC_addTunipol(a, q);
    w9 = a;
    q = w3;
    a = car(w11);
    a = CC_multTunipol(a, q);
    w11 = a;
    q = w7;
    a = w13;
    a = CC_multTunipol(a, q);
    q = w11;
    a = CC_addTunipol(a, q);
    w11 = a;
    q = a;
    a = w10;
    a = CC_addTunipol(a, q);
    w10 = a;
    q = w4;
    a = w12;
    a = Lleq(a, q);
    if(a != nil) goto    G0469;
   G0501:
    q = w6;
    a = w9;
    a = CC_Amodulo2(a, q);
    w9 = a;
    q = w6;
    a = w10;
    a = CC_Amodulo2(a, q);
    w10 = a;
    CC_recovmod();
    q = w10;
    a = w9;
    a = Llist2(a, q);
    {
        popv(15);
        return  CC_convTlist2oset(a);
    }
}

Sex CC_AmultiHensel(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 17;
    w17 = nil;
    w16 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = CC_Wnoargchk();
    if(a == nil) goto    G0519;
    a = w1;
    a = CC_Adeg(a);
    w5 = a;
    goto    G0535;
   G0519:
    a = w1;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0521;
    a = w2;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0521;
    a = w3;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0520;
   G0521:
    q = LITERAL[14];
    a = LITERAL[8];
    goto    G0586;
   G0520:
    a = w1;
    a = CC_Amvar(a);
    w16 = a;
    a = w2;
    a = CC_Amvar(a);
    q = a;
    a = w16;
    a = Lequal(a, q);
    if(a == nil) goto    G0523;
    a = w1;
    a = CC_Amvar(a);
    w16 = a;
    a = w3;
    a = CC_Amvar(a);
    q = a;
    a = w16;
    a = Lequal(a, q);
    if(a != nil) goto    G0522;
   G0523:
    q = LITERAL[14];
    a = LITERAL[15];
    goto    G0586;
   G0522:
    a = w1;
    a = CC_Adeg(a);
    w5 = a;
    w16 = a;
    a = w2;
    a = CC_Adeg(a);
    w17 = a;
    a = w3;
    a = CC_Adeg(a);
    q = a;
    a = w17;
    a = plus2(a, q);
    q = a;
    a = w16;
    a = Lequal(a, q);
    if(a != nil) goto    G0528;
    q = LITERAL[14];
    a = LITERAL[12];
    goto    G0586;
   G0528:
    a = w4;
    if(!is_integer(a)) goto    G0534;
    a = Lplusp(a);
    if(a != nil) goto    G0533;
   G0534:
    q = w4;
    a = LITERAL[11];
    goto    G0586;
   G0533:
    a = w1;
    a = CC_multisubstTsub0(a);
    w16 = a;
    a = w2;
    a = CC_multisubstTsub0(a);
    w17 = a;
    a = w3;
    a = CC_multisubstTsub0(a);
    q = a;
    a = w17;
    a = CC_multH(a, q);
    q = a;
    a = w16;
    a = Lequal(a, q);
    if(a != nil) goto    G0535;
    q = LITERAL[14];
    a = LITERAL[16];
   G0586:
    CC_errormsg(a, q);
   G0535:
    a = w2;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0541;
    a = w3;
    a = CC_Wunivar(a);
    if(a != nil) goto    G0550;
    q = w3;
    a = cons(a, q);
    goto    G0588;
   G0541:
    a = w3;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0545;
    a = w2;
    a = Lncons(a);
    goto    G0588;
   G0545:
    q = w3;
    a = w2;
    a = cons(a, q);
   G0588:
    w15 = a;
    a = car(w15);
    if(a == nil) goto    G0548;
    a = w2;
    a = CC_multisubstTsub0(a);
    w2 = a;
   G0548:
    a = cdr(w15);
    if(a == nil) goto    G0550;
    a = w3;
    a = CC_multisubstTsub0(a);
    w3 = a;
   G0550:
    q = w3;
    a = w2;
    a = CC_cofact0Tunipol(a, q);
    w14 = a;
    a = car(a);
    w9 = a;
    a = Lncons(a);
    w11 = a;
    a = cdr(w14);
    w10 = a;
    a = Lncons(a);
    w12 = a;
    a = mkfxat(1);
    w13 = a;
    a = w1;
    a = CC_Amvar(a);
    a = CC_Amkexpr(a);
    w6 = a;
   G0514:
    q = w13;
    a = w6;
    a = CC_powH(a, q);
    w7 = a;
    q = w9;
    a = CC_multH(a, q);
    q = w3;
    a = CC_remainH(a, q);
    w14 = a;
    q = w11;
    a = cons(a, q);
    w11 = a;
    q = w5;
    a = w13;
    a = Lequal(a, q);
    if(a == nil) goto    G0556;
#define LL_Hquotient LITERAL[17]
    a = value(LL_Hquotient);
    w14 = a;
    goto    G0559;
   G0556:
    q = w10;
    a = w7;
    a = CC_multH(a, q);
    q = w2;
    a = CC_remainH(a, q);
    w14 = a;
    q = w12;
    a = cons(a, q);
    w12 = a;
    a = w13;
    a = Ladd1(a);
    w13 = a;
    q = w5;
    a = Lleq(a, q);
    if(a != nil) goto    G0514;
   G0559:
    q = w2;
    a = w14;
    a = CC_multH(a, q);
    w16 = a;
    q = w10;
    a = w7;
    a = CC_multH(a, q);
    q = a;
    a = w16;
    a = CC_addH(a, q);
    w14 = a;
    q = w12;
    a = cons(a, q);
    w12 = a;
    a = w1;
    a = CC_Amvar(a);
    w6 = a;
    a = mkfxat(1);
    w13 = a;
    a = CC_Amkvar();
    w8 = a;
    q = w6;
    a = Llist2(a, q);
    CC_Aorder(a);
    q = w8;
    a = w1;
    a = CC_Aputtdeg1(a, q);
    w1 = a;
    a = w15;
    if(a == nil) goto    G0569;
    a = car(a);
    if(a == nil) goto    G0567;
    q = w8;
    a = CC_Aputtdeg1(a, q);
    w2 = a;
   G0567:
    a = cdr(w15);
    if(a == nil) goto    G0569;
    q = w8;
    a = CC_Aputtdeg1(a, q);
    w3 = a;
   G0569:
    a = w13;
    a = Lonep(a);
    if(a == nil) goto    G0571;
    a = w15;
    if(a != nil) goto    G0571;
    arg4 = mkfxat(1);
    m = mkfxat(1);
    q = w8;
    a = w1;
    a = CC_termfromtoH(a, q, m, arg4);
    goto    G0573;
   G0571:
    arg4 = w13;
    m = arg4;
    q = w8;
    a = w1;
    a = CC_termfromtoH(a, q, m, arg4);
    w16 = a;
    arg5 = w13;
    arg4 = arg5;
    m = w8;
    q = w3;
    a = w2;
    a = CC_multfromtoH(a, q, m, arg4, arg5);
    a = CC_negH(a);
    q = a;
    a = w16;
    a = CC_addH(a, q);
   G0573:
    arg5 = w5;
    arg4 = w12;
    m = w11;
    q = w6;
    a = CC_HenselTideallift(a, q, m, arg4, arg5);
    w14 = a;
    q = w2;
    a = car(a);
    a = CC_addH(a, q);
    w2 = a;
    q = w3;
    a = cdr(w14);
    a = CC_addH(a, q);
    w3 = a;
    a = w13;
    a = Ladd1(a);
    w13 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G0569;
    m = mkfxat(1);
    q = w8;
    a = w2;
    a = CC_substH(a, q, m);
    w2 = a;
    m = mkfxat(1);
    q = w8;
    a = w3;
    a = CC_substH(a, q, m);
    w3 = a;
    CC_Aunorder();
    a = w8;
    a = Lncons(a);
    CC_Aerase(a);
    q = w3;
    a = w2;
    a = Llist2(a, q);
    {
        popv(17);
        return  CC_convTlist2oset(a);
    }
}

Sex CC_AmultiHensel2(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w19 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Wnoargchk();
    if(a == nil) goto    G0602;
    a = w1;
    a = CC_Adeg(a);
    w8 = a;
    goto    G0616;
   G0602:
    a = w1;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0604;
    a = w2;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0604;
    a = w3;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0603;
   G0604:
    q = LITERAL[18];
    a = LITERAL[8];
    goto    G0690;
   G0603:
    a = w1;
    a = CC_Amvar(a);
    w19 = a;
    a = w2;
    a = CC_Amvar(a);
    q = a;
    a = w19;
    a = Lequal(a, q);
    if(a == nil) goto    G0606;
    a = w1;
    a = CC_Amvar(a);
    w19 = a;
    a = w3;
    a = CC_Amvar(a);
    q = a;
    a = w19;
    a = Lequal(a, q);
    if(a != nil) goto    G0605;
   G0606:
    q = LITERAL[18];
    a = LITERAL[19];
    goto    G0690;
   G0605:
    a = w1;
    a = CC_Adeg(a);
    w8 = a;
    w19 = a;
    a = w2;
    a = CC_Adeg(a);
    w20 = a;
    a = w3;
    a = CC_Adeg(a);
    q = a;
    a = w20;
    a = plus2(a, q);
    q = a;
    a = w19;
    a = Lequal(a, q);
    if(a != nil) goto    G0611;
    q = LITERAL[18];
    a = LITERAL[12];
    goto    G0690;
   G0611:
    a = w1;
    a = CC_multisubstTsub0(a);
    w19 = a;
    a = w5;
    a = CC_multisubstTsub0(a);
    w20 = a;
    a = w6;
    a = CC_multisubstTsub0(a);
    q = a;
    a = w20;
    a = CC_multH(a, q);
    q = a;
    a = w19;
    a = Lequal(a, q);
    if(a != nil) goto    G0616;
    q = LITERAL[18];
    a = LITERAL[16];
   G0690:
    CC_errormsg(a, q);
   G0616:
    a = w1;
    w4 = a;
    a = w2;
    w5 = a;
    a = w3;
    w6 = a;
    a = w2;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0622;
    a = w3;
    a = CC_Wunivar(a);
    if(a != nil) goto    G0631;
    q = w3;
    a = cons(a, q);
    goto    G0692;
   G0622:
    a = w3;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0626;
    a = w2;
    a = Lncons(a);
    goto    G0692;
   G0626:
    q = w3;
    a = w2;
    a = cons(a, q);
   G0692:
    w7 = a;
    a = car(w7);
    if(a == nil) goto    G0629;
    a = w5;
    a = CC_multisubstTsub0(a);
    w2 = a;
   G0629:
    a = cdr(w7);
    if(a == nil) goto    G0631;
    a = w6;
    a = CC_multisubstTsub0(a);
    w3 = a;
   G0631:
    q = w3;
    a = w2;
    a = CC_cofact0Tunipol(a, q);
    w18 = a;
    a = car(a);
    w12 = a;
    a = Lncons(a);
    w14 = a;
    a = cdr(w18);
    w13 = a;
    a = Lncons(a);
    w15 = a;
    a = mkfxat(1);
    w17 = a;
    a = w1;
    a = CC_Amvar(a);
    a = CC_Amkexpr(a);
    w9 = a;
   G0594:
    q = w17;
    a = w9;
    a = CC_powH(a, q);
    w10 = a;
    q = w12;
    a = CC_multH(a, q);
    q = w3;
    a = CC_remainH(a, q);
    w18 = a;
    q = w14;
    a = cons(a, q);
    w14 = a;
    q = w8;
    a = w17;
    a = Lequal(a, q);
    if(a == nil) goto    G0637;
    a = value(LL_Hquotient);
    w18 = a;
    goto    G0640;
   G0637:
    q = w13;
    a = w10;
    a = CC_multH(a, q);
    q = w2;
    a = CC_remainH(a, q);
    w18 = a;
    q = w15;
    a = cons(a, q);
    w15 = a;
    a = w17;
    a = Ladd1(a);
    w17 = a;
    q = w8;
    a = Lleq(a, q);
    if(a != nil) goto    G0594;
   G0640:
    q = w2;
    a = w18;
    a = CC_multH(a, q);
    w19 = a;
    q = w13;
    a = w10;
    a = CC_multH(a, q);
    q = a;
    a = w19;
    a = CC_addH(a, q);
    w18 = a;
    q = w15;
    a = cons(a, q);
    w15 = a;
    a = w1;
    a = CC_Amvar(a);
    w9 = a;
    a = mkfxat(1);
    w17 = a;
    a = CC_Amkvar();
    w11 = a;
    a = Lncons(a);
    CC_Aorder(a);
    q = w11;
    a = w4;
    a = CC_Aputtdeg1(a, q);
    w1 = a;
    q = w11;
    a = CC_Avdeg(a, q);
    q = mkfxat(2);
    a = quot2(a, q);
    w16 = a;
    a = w7;
    if(a == nil) goto    G0651;
    a = car(a);
    if(a == nil) goto    G0649;
    q = w11;
    a = CC_Aputtdeg1(a, q);
    w5 = a;
   G0649:
    a = cdr(w7);
    if(a == nil) goto    G0651;
    q = w11;
    a = CC_Aputtdeg1(a, q);
    w6 = a;
   G0651:
    a = w17;
    a = Lonep(a);
    if(a == nil) goto    G0653;
    a = w7;
    if(a != nil) goto    G0653;
    arg4 = mkfxat(1);
    m = mkfxat(1);
    q = w11;
    a = w1;
    a = CC_termfromtoH(a, q, m, arg4);
    goto    G0655;
   G0653:
    arg4 = w17;
    m = arg4;
    q = w11;
    a = w1;
    a = CC_termfromtoH(a, q, m, arg4);
    w19 = a;
    arg5 = w17;
    arg4 = arg5;
    m = w11;
    q = w6;
    a = w5;
    a = CC_multfromtoH(a, q, m, arg4, arg5);
    a = CC_negH(a);
    q = a;
    a = w19;
    a = CC_addH(a, q);
   G0655:
    w18 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0660;
    q = mkfxat(0);
    a = mkfxat(0);
    a = cons(a, q);
    w18 = a;
    goto    G0661;
   G0660:
    arg5 = w8;
    arg4 = w15;
    m = w14;
    q = w9;
    a = w18;
    a = CC_HenselTideallift(a, q, m, arg4, arg5);
    w18 = a;
    q = w5;
    a = car(a);
    a = CC_addH(a, q);
    w5 = a;
    q = w6;
    a = cdr(w18);
    a = CC_addH(a, q);
    w6 = a;
   G0661:
    a = car(w18);
    a = Lzerop(a);
    if(a != nil) goto    G0598;
    a = cdr(w18);
    a = Lzerop(a);
    if(a != nil) goto    G0599;
   G0665:
    a = w17;
    a = Ladd1(a);
    w17 = a;
    q = w16;
    a = Lleq(a, q);
    if(a != nil) goto    G0651;
    m = mkfxat(1);
    q = w11;
    a = w5;
    a = CC_substH(a, q, m);
    w2 = a;
    q = w4;
    a = CC_WdivoverZpQA(a, q);
    w3 = a;
    if(a != nil) goto    G0600;
    m = mkfxat(1);
    q = w11;
    a = w6;
    a = CC_substH(a, q, m);
    w3 = a;
    q = w4;
    a = CC_WdivoverZpQA(a, q);
    w2 = a;
    if(a != nil) goto    G0600;
    w3 = a;
    w2 = a;
    goto    G0600;
   G0598:
    m = mkfxat(1);
    q = w11;
    a = w5;
    a = CC_substH(a, q, m);
    w2 = a;
    q = w4;
    a = CC_WdivoverZpQA(a, q);
    w3 = a;
    if(a != nil) goto    G0600;
    q = w16;
    a = w17;
    a = Llessp(a, q);
    if(a != nil) goto    G0665;
    w2 = nil;
    goto    G0600;
   G0599:
    m = mkfxat(1);
    q = w11;
    a = w6;
    a = CC_substH(a, q, m);
    w3 = a;
    q = w4;
    a = CC_WdivoverZpQA(a, q);
    w2 = a;
    if(a != nil) goto    G0600;
    q = w16;
    a = w17;
    a = Llessp(a, q);
    if(a != nil) goto    G0665;
    w3 = nil;
   G0600:
    CC_Aunorder();
    a = w11;
    a = Lncons(a);
    CC_Aerase(a);
    a = w2;
    if(a == nil) goto    G0684;
    a = w3;
    if(a != nil) goto    G0683;
   G0684:
    a = LL_Anil;
    goto    G0591;
   G0683:
    q = a;
    a = w2;
    a = Llist2(a, q);
    a = CC_convTlist2oset(a);
   G0591:
    popv(20);
    return a;
}

Sex CC_HenselTideallift(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = CC_Alterm(a);
    a = CC_Alfactor(a);
    w6 = a;
    a = w1;
    a = CC_Alcoef(a);
    w1 = a;
    a = CC_Amvar(a);
    q = a;
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G0720;
    a = w5;
    a = Ladd1(a);
    w11 = a;
    a = mkfxat(0);
    w8 = a;
    w7 = a;
   G0696:
    a = w1;
    if(is_number(a)) goto    G0707;
    a = CC_Amvar(a);
    q = a;
    a = w2;
    a = Lequal(a, q);
    if(a != nil) goto    G0706;
   G0707:
    a = mkfxat(0);
    w9 = a;
    a = w1;
    w10 = a;
    a = mkfxat(0);
    w1 = a;
    goto    G0697;
   G0706:
    a = w1;
    a = CC_Alpoly(a);
    w10 = a;
    a = CC_Adeg(a);
    w9 = a;
    a = w10;
    a = CC_Alcoef(a);
    w10 = a;
   G0697:
    a = w11;
    a = Lsub1(a);
    w11 = a;
    q = w9;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0710;
    a = cdr(w3);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    goto    G0697;
   G0710:
    q = car(w4);
    a = w10;
    a = CC_multH(a, q);
    q = w7;
    a = CC_addH(a, q);
    w7 = a;
    q = car(w3);
    a = w10;
    a = CC_multH(a, q);
    q = w8;
    a = CC_addH(a, q);
    w8 = a;
    a = w1;
    a = CC_Arpoly(a);
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0698;
    a = cdr(w3);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    goto    G0696;
   G0720:
    a = w4;
    a = Llast(a);
    q = a;
    a = w1;
    a = CC_multH(a, q);
    w7 = a;
    a = w3;
    a = Llast(a);
    q = a;
    a = w1;
    a = CC_multH(a, q);
    w8 = a;
   G0698:
    q = w7;
    a = w6;
    a = CC_multH(a, q);
    w12 = a;
    q = w8;
    a = w6;
    a = CC_multH(a, q);
    q = w12;
    {
        popv(12);
        return  Lxcons(a, q);
    }
}

Sex CC_cofact0Tunipol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    w3 = a;
    a = CC_Adeg(a);
    w12 = a;
    a = w2;
    w4 = a;
    a = CC_Adeg(a);
    q = a;
    a = w12;
    a = Llessp(a, q);
    if(a == nil) goto    G0726;
    a = w2;
    w3 = a;
    a = w1;
    w4 = a;
    a = true;
    w11 = a;
   G0726:
    a = mkfxat(1);
    w5 = a;
    a = mkfxat(0);
    w7 = a;
    w6 = a;
    a = mkfxat(1);
    w8 = a;
   G0724:
    q = w4;
    a = w3;
    a = CC_xctdivTunipol(a, q);
    w10 = a;
    a = w4;
    w3 = a;
    a = cdr(w10);
    w4 = a;
    a = car(w10);
    a = CC_negTunipol(a);
    w9 = a;
    q = w6;
    a = CC_multTunipol(a, q);
    q = a;
    a = w5;
    a = CC_addTunipol(a, q);
    w10 = a;
    a = w6;
    w5 = a;
    a = w10;
    w6 = a;
    q = w8;
    a = w9;
    a = CC_multTunipol(a, q);
    q = a;
    a = w7;
    a = CC_addTunipol(a, q);
    w10 = a;
    a = w8;
    w7 = a;
    a = w10;
    w8 = a;
    a = w4;
    if(!is_number(a)) goto    G0724;
    a = CC_recipH(a);
    w10 = a;
    q = w6;
    a = CC_multTunipol(a, q);
    w6 = a;
    q = w8;
    a = w10;
    a = CC_multTunipol(a, q);
    w8 = a;
    a = w11;
    if(a == nil) goto    G0736;
    q = w6;
    a = w8;
    goto    G0739;
   G0736:
    q = w8;
    a = w6;
   G0739:
    {
        popv(12);
        return  cons(a, q);
    }
}

Sex CC_cofactTunipol(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w12 = nil;
    w11 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w13 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = a;
    a = CC_Adeg(a);
    w14 = a;
    a = w2;
    w6 = a;
    a = CC_Adeg(a);
    q = a;
    a = w14;
    a = Llessp(a, q);
    if(a == nil) goto    G0749;
    a = w2;
    w5 = a;
    a = w1;
    w6 = a;
    a = true;
    w13 = a;
   G0749:
    a = w4;
    if(a != nil) goto    G0755;
    a = w13;
    if(a == nil) goto    G0757;
    a = mkfxat(1);
    w9 = a;
    a = mkfxat(0);
    w10 = a;
    w7 = a;
    a = mkfxat(1);
    goto    G0788;
   G0757:
    a = mkfxat(1);
    w7 = a;
    a = mkfxat(0);
    w8 = a;
    w9 = a;
    a = mkfxat(1);
    goto    G0789;
   G0755:
    a = w13;
    if(a == nil) goto    G0759;
    a = mkfxat(1);
    w9 = a;
    a = mkfxat(0);
   G0789:
    w10 = a;
    goto    G0760;
   G0759:
    a = mkfxat(1);
    w7 = a;
    a = mkfxat(0);
   G0788:
    w8 = a;
   G0760:
    q = w6;
    a = w5;
    a = CC_xctdivTunipol(a, q);
    w12 = a;
    a = w6;
    w5 = a;
    a = cdr(w12);
    w6 = a;
    a = car(w12);
    a = CC_negTunipol(a);
    w11 = a;
    a = w8;
    if(a == nil) goto    G0744;
    q = a;
    a = w11;
    a = CC_multTunipol(a, q);
    q = a;
    a = w7;
    a = CC_addTunipol(a, q);
    w12 = a;
    a = w8;
    w7 = a;
    a = w12;
    w8 = a;
   G0744:
    a = w10;
    if(a == nil) goto    G0745;
    q = a;
    a = w11;
    a = CC_multTunipol(a, q);
    q = a;
    a = w9;
    a = CC_addTunipol(a, q);
    w12 = a;
    a = w10;
    w9 = a;
    a = w12;
    w10 = a;
   G0745:
    a = w6;
    if(!is_number(a)) goto    G0760;
    a = Lzerop(a);
    if(a == nil) goto    G0769;
    q = LITERAL[20];
    a = LITERAL[21];
    CC_errormsg(a, q);
    goto    G0771;
   G0769:
    a = w6;
    a = Lonep(a);
    if(a != nil) goto    G0771;
    a = w8;
    if(a == nil) goto    G0773;
    q = w6;
    a = CC_quotiH(a, q);
    w8 = a;
   G0773:
    a = w10;
    if(a == nil) goto    G0771;
    q = w6;
    a = CC_quotiH(a, q);
    w10 = a;
   G0771:
    a = w8;
    if(a != nil) goto    G0746;
    q = w2;
    a = w10;
    a = CC_multTunipol(a, q);
    a = CC_negTunipol(a);
    q = a;
    a = mkfxat(1);
    a = CC_addH(a, q);
    w12 = a;
    q = w1;
    a = CC_xctquoTunipol(a, q);
    w8 = a;
    w10 = nil;
   G0746:
    a = w3;
    if(a == nil) goto    G0747;
    a = Lonep(a);
    if(a != nil) goto    G0747;
    q = w3;
    a = w8;
    a = CC_multTunipol(a, q);
    q = w2;
    a = CC_xctdivTunipol(a, q);
    w12 = a;
    a = cdr(a);
    w8 = a;
    a = w4;
    if(a != nil) goto    G0747;
    q = w1;
    a = car(w12);
    a = CC_multTunipol(a, q);
    w12 = a;
    q = w3;
    a = w10;
    a = CC_multTunipol(a, q);
    q = w12;
    a = CC_addTunipol(a, q);
    w10 = a;
   G0747:
    q = w10;
    a = w8;
    {
        popv(14);
        return  cons(a, q);
    }
}

Sex CC_interpolTlagpoly0(Sex a)
{
    Sex q, m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w2 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    a = car(a);
    w4 = a;
    a = cdr(w1);
    w3 = a;
   G0793:
    q = w4;
    a = car(w3);
    a = CC_multTunipol(a, q);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G0793;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    w2 = a;
   G0794:
    a = car(w1);
    w5 = a;
    q = a;
    a = w4;
    a = CC_xctquoTunipol(a, q);
    w6 = a;
    arg4 = true;
    m = mkfxat(1);
    q = w5;
    a = CC_cofactTunipol(a, q, m, arg4);
    a = car(a);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G0794;
    a = cdr(w2);
    popv(6);
    return a;
}

Sex CC_interpolTlagpoly(Sex a)
{
    Sex q, m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w2 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = car(a);
    w5 = a;
    a = car(cdr(w1));
    w4 = a;
    a = cdr(w1);
    w3 = a;
   G0806:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0809;
    q = w4;
    a = car(a);
    a = CC_multTunipol(a, q);
    w4 = a;
    goto    G0806;
   G0809:
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = mkfxat(1);
    w7 = a;
   G0807:
    arg4 = nil;
    m = w7;
    q = w5;
    a = w4;
    a = CC_cofactTunipol(a, q, m, arg4);
    w6 = a;
    a = car(a);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w6);
    w7 = a;
    a = cdr(w1);
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G0817;
    a = car(w1);
    w5 = a;
    q = a;
    a = w4;
    a = CC_xctquoTunipol(a, q);
    w4 = a;
    goto    G0807;
   G0817:
    a = w7;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(w2);
    popv(7);
    return a;
}

Sex CC_multisubstTsub0(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = CC_Wnoargchk();
    if(a != nil) goto    G0828;
    a = w1;
    if(is_number(a)) goto    G0827;
    a = CC_Walgn(a);
    if(a == nil) goto    G0826;
   G0827:
    a = w1;
    goto    G0820;
   G0826:
    a = w1;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0828;
    q = LITERAL[22];
    a = LITERAL[23];
    CC_errormsg(a, q);
   G0828:
    a = car(cdr(w1));
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w4 = a;
   G0822:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0823;
    a = cdr(car(a));
    w5 = a;
    if(is_number(a)) goto    G0833;
    a = car(a);
    if(is_integer(a)) goto    G0833;
    a = w5;
    a = CC_cnstermTbpol(a);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0822;
   G0833:
    q = w5;
    a = car(car(w4));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    goto    G0822;
   G0823:
    a = w2;
    a = CC_reduceTbpol(a);
    w2 = a;
    a = CC_Wncan(a);
    if(a == nil) goto    G0839;
    a = w2;
    goto    G0820;
   G0839:
    q = w2;
    a = car(w1);
    a = cons(a, q);
   G0820:
    popv(5);
    return a;
}

Sex CC_multisubstTbnum(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
   G0845:
    a = w1;
    if(a == nil) goto    G0844;
    if(is_number(a)) goto    G0844;
    a = car(w2);
    w3 = a;
    m = cdr(a);
    q = car(a);
    a = w1;
    a = CC_subTbnum2pol3(a, q, m);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0845;
    a = w1;
   G0844:
    popv(3);
    return a;
}

Sex CC_multishiftTorgn(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    if(is_number(a)) goto    G0855;
    w4 = nil;
    w5 = nil;
   G0857:
    a = car(w2);
    w4 = a;
    a = cdr(a);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0858;
    a = w3;
    if(a == nil) goto    G0862;
    a = w5;
    a = Lminus(a);
    w5 = a;
   G0862:
    q = mkfxat(1);
    a = mkfxat(1);
    a = cons(a, q);
    w6 = a;
    q = w5;
    a = mkfxat(0);
    a = cons(a, q);
    arg4 = a;
    m = w6;
    q = car(w4);
    a = car(w1);
    a = Llist4(a, q, m, arg4);
    w5 = a;
    m = a;
    q = car(w4);
    a = w1;
    a = CC_subTpol32pol3(a, q, m);
    w1 = a;
   G0858:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0857;
    a = w1;
   G0855:
    popv(6);
    return a;
}

Sex CC_tdegTcoef(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = cdr(a);
    w3 = a;
    a = mkfxat(0);
    w2 = a;
   G0870:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0878;
    a = cdr(car(a));
    w4 = a;
    if(is_number(a)) goto    G0870;
    a = car(a);
    if(is_integer(a)) goto    G0870;
    q = w4;
    a = car(w1);
    a = cons(a, q);
    w4 = a;
    a = w4;
    a = CC_Atdeg(a);
    q = a;
    a = w2;
    a = Lmax2(a, q);
    w2 = a;
    goto    G0870;
   G0878:
    a = w2;
    popv(4);
    return a;
}

Sex CC_Aprem(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = CC_Alcoef(a);
    w3 = a;
    a = Lonep(a);
    if(a != nil) goto    G0883;
    a = w1;
    a = CC_Adeg(a);
    w5 = a;
    a = w2;
    a = CC_Adeg(a);
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w5;
    a = plus2(a, q);
    w4 = a;
    a = w3;
    q = w4;
    if(!is_number(a)) goto    G0889;
    a = Lexpt(a, q);
    q = w1;
    a = CC_Hbnumpol3(a, q);
    goto    G0891;
   G0889:
    a = CC_powTcanopint(a, q);
    q = w1;
    a = CC_Hpol3pol3(a, q);
   G0891:
    w1 = a;
   G0883:
    q = w2;
    a = w1;
    a = CC_VLpolypoly(a, q);
    {
        popv(5);
        return cdr(a);
    }
}

Sex CC_Ares(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 16;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0899;
    a = w2;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0898;
   G0899:
    q = LITERAL[24];
    a = LITERAL[25];
    {
        popv(16);
        return  CC_errormsg(a, q);
    }
   G0898:
    a = w1;
    a = CC_Wunivar(a);
    if(a == nil) goto    G0900;
    a = w2;
    a = CC_Wunivar(a);
    if(a != nil) goto    G0959;
   G0900:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    a = w1;
    a = CC_Adeg(a);
    w6 = a;
    a = w2;
    a = CC_Adeg(a);
    w7 = a;
    a = w1;
    a = CC_Amvar(a);
    w14 = a;
    a = w3;
    if(a == nil) goto    G0911;
    a = CC_Aexpr2varfunc(a);
    goto    G0912;
   G0911:
    a = w14;
   G0912:
    w3 = a;
    q = w7;
    a = w6;
    a = Lmax2(a, q);
    a = Lonep(a);
    if(a == nil) goto    G0914;
   G0959:
    m = w3;
    q = w2;
    a = w1;
    {
        popv(16);
        return  CC_Ares1(a, q, m);
    }
   G0914:
    q = w14;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G0918;
    a = w2;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a != nil) goto    G0921;
   G0918:
    a = true;
    w15 = a;
    a = w3;
    a = Lncons(a);
    CC_Aorder(a);
    a = w1;
    a = CC_reorderH(a);
    w1 = a;
    a = w2;
    a = CC_reorderH(a);
    w2 = a;
    a = w1;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G0925;
    a = w2;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a != nil) goto    G0921;
   G0925:
    CC_Aunorder();
    q = w3;
    a = LITERAL[26];
    CC_errormsg(a, q);
   G0921:
    q = w7;
    a = w6;
    a = Llessp(a, q);
    if(a == nil) goto    G0929;
    a = w1;
    w14 = a;
    a = w2;
    w1 = a;
    a = w14;
    w2 = a;
    a = w6;
    w14 = a;
    a = w7;
    w6 = a;
    a = w14;
    w7 = a;
   G0929:
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = w7;
    a = Lminus(a);
    q = a;
    a = w6;
    a = plus2(a, q);
    w8 = a;
    a = w1;
    a = CC_Amvar(a);
    w3 = a;
    a = w8;
    a = Lzerop(a);
    if(a != nil) goto    G0907;
    q = mkfxat(1);
    a = w8;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0904;
    q = mkfxat(-1);
    a = w8;
    a = plus2(a, q);
    q = a;
    a = w3;
    a = CC_Amkpow(a, q);
    q = w2;
    a = CC_multH(a, q);
    w2 = a;
   G0904:
    q = w6;
    a = w2;
    a = CC_poly2coeflist(a, q);
    w14 = a;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = mkfxat(0);
    w13 = a;
   G0905:
    a = w13;
    a = Ladd1(a);
    w13 = a;
    q = w8;
    a = Lequal(a, q);
    if(a != nil) goto    G0906;
    a = w14;
    a = CC_topcopyB(a);
    q = mkfxat(0);
    a = Lxcons(a, q);
    w14 = a;
    q = nil;
#define LL_Htemporal LITERAL[27]
    a = value(LL_Htemporal);
    cdr(a) = q;
    a = w14;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G0905;
   G0906:
    q = mkfxat(1);
    a = w3;
    a = CC_Amkpow(a, q);
    q = w2;
    a = CC_multH(a, q);
    w2 = a;
   G0907:
    a = w6;
    w13 = a;
   G0908:
    q = w13;
    a = w3;
    a = CC_Amkpow(a, q);
    w14 = a;
    q = a;
    a = w1;
    a = CC_remainH(a, q);
    w11 = a;
    a = value(LL_Hquotient);
    w9 = a;
    q = w14;
    a = w2;
    a = CC_remainH(a, q);
    w12 = a;
    a = value(LL_Hquotient);
    w10 = a;
    q = w12;
    a = w9;
    a = CC_multH(a, q);
    w16 = a;
    q = w11;
    a = w10;
    a = CC_multH(a, q);
    a = CC_negH(a);
    q = a;
    a = w16;
    a = CC_addH(a, q);
    w14 = a;
    q = w6;
    a = CC_poly2coeflist(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = w13;
    a = Lsub1(a);
    w13 = a;
    q = w8;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G0908;
    a = w15;
    if(a == nil) goto    G0957;
    CC_Aunorder();
   G0957:
    a = cdr(w4);
    {
        popv(16);
#define LL_detminorT LITERAL[28]
        return  apply1(LL_detminorT, a);
    }
}

Sex CC_Ares1(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0964;
    a = w2;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0963;
   G0964:
    q = LITERAL[24];
    a = LITERAL[25];
    {
        popv(13);
        return  CC_errormsg(a, q);
    }
   G0963:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    a = w1;
    a = CC_Amvar(a);
    w10 = a;
    a = w3;
    if(a == nil) goto    G0970;
    a = CC_Aexpr2varfunc(a);
    goto    G0971;
   G0970:
    a = w10;
   G0971:
    w3 = a;
    q = w10;
    a = Lequal(a, q);
    if(a == nil) goto    G0973;
    a = w2;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a != nil) goto    G0976;
   G0973:
    a = true;
    w11 = a;
    a = w3;
    a = Lncons(a);
    CC_Aorder(a);
    a = w1;
    a = CC_reorderH(a);
    w1 = a;
    a = w2;
    a = CC_reorderH(a);
    w2 = a;
    a = w1;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G0980;
    a = w2;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a != nil) goto    G0976;
   G0980:
    CC_Aunorder();
    q = w3;
    a = LITERAL[26];
    CC_errormsg(a, q);
   G0976:
#define LL_Hexctdiv LITERAL[29]
    a = value(LL_Hexctdiv);
    w12 = a;
    a = true;
    value(LL_Hexctdiv) = a;
    a = w1;
    a = CC_Adeg(a);
    w7 = a;
    a = w2;
    a = CC_Adeg(a);
    w8 = a;
    q = a;
    a = w7;
    a = Llessp(a, q);
    if(a == nil) goto    G0984;
    a = w1;
    w10 = a;
    a = w2;
    w1 = a;
    a = w10;
    w2 = a;
    a = w7;
    w10 = a;
    a = w8;
    w7 = a;
    a = w10;
    w8 = a;
   G0984:
    q = w2;
    a = w1;
    a = CC_Aprem(a, q);
    w4 = a;
    a = w2;
    w1 = a;
    a = w4;
    w2 = a;
    if(is_number(a)) goto    G0968;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G0968;
    a = mkfxat(1);
    w6 = a;
    a = w8;
    a = Lminus(a);
    q = a;
    a = w7;
    a = plus2(a, q);
    w9 = a;
    a = w1;
    a = CC_Alcoef(a);
    w5 = a;
   G0967:
    a = w9;
    a = Lzerop(a);
    if(a == nil) goto    G0991;
    a = w6;
    goto    G0993;
   G0991:
    a = w9;
    a = Lonep(a);
    if(a == nil) goto    G0992;
    a = w5;
    goto    G0993;
   G0992:
    q = w9;
    a = w5;
    a = CC_powH(a, q);
    w13 = a;
    q = mkfxat(-1);
    a = w9;
    a = plus2(a, q);
    q = a;
    a = w6;
    a = CC_powH(a, q);
    q = a;
    a = w13;
    a = CC_quotiH(a, q);
   G0993:
    w6 = a;
    a = w8;
    w7 = a;
    a = w2;
    a = CC_Adeg(a);
    w8 = a;
    a = Lminus(a);
    q = a;
    a = w7;
    a = plus2(a, q);
    w9 = a;
    q = w2;
    a = w1;
    a = CC_Aprem(a, q);
    w4 = a;
    a = Lzerop(a);
    if(a != nil) goto    G0968;
    q = w9;
    a = w6;
    a = CC_powH(a, q);
    q = a;
    a = w5;
    a = CC_multH(a, q);
    q = a;
    a = w4;
    a = CC_quotiH(a, q);
    w4 = a;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G0968;
    a = w2;
    w1 = a;
    a = w4;
    w2 = a;
    a = w1;
    a = CC_Alcoef(a);
    w5 = a;
    goto    G0967;
   G0968:
    a = w4;
    a = CC_Alncoef(a);
    a = Lminusp(a);
    if(a == nil) goto    G1006;
    a = w4;
    a = CC_Kany(a);
    w4 = a;
   G1006:
    a = w11;
    if(a == nil) goto    G1009;
    CC_Aunorder();
   G1009:
    a = w12;
    value(LL_Hexctdiv) = a;
    a = w4;
    popv(13);
    return a;
}

Sex CC_Agcd(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    if(is_number(a)) goto    G1015;
    a = CC_Wpoly(a);
    if(a == nil) goto    G1013;
   G1015:
    a = w2;
    if(is_number(a)) goto    G1016;
    a = CC_Wpoly(a);
    if(a == nil) goto    G1013;
   G1016:
    a = w1;
    a = CC_Wexactcoef(a);
    if(a == nil) goto    G1018;
    a = w2;
    a = CC_Wexactcoef(a);
    if(a == nil) goto    G1018;
    m = nil;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_exactgcdH(a, q, m);
    }
   G1018:
    m = w3;
    q = w2;
    a = w1;
    {
        popv(3);
        return  CC_approxgcdH(a, q, m);
    }
   G1013:
    q = LITERAL[30];
    a = LITERAL[23];
    {
        popv(3);
        return  CC_errormsg(a, q);
    }
}

Sex CC_gcdTmonomono(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = cdr(q);
    a = cdr(a);
    a = CC_gcdTbmonbmon(a, q);
    w3 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1027;
    a = car(w3);
    a = CC_Wtag(a);
    if(a == nil) goto    G1026;
   G1027:
    a = w3;
    goto    G1024;
   G1026:
    q = w3;
    a = car(w1);
    a = cons(a, q);
   G1024:
    popv(3);
    return a;
}

Sex CC_gcdTbmonbmon(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = car(w1);
    w5 = a;
    a = car(w2);
    w6 = a;
   G1032:
    q = w6;
    a = w5;
    a = Lequal(a, q);
    if(a != nil) goto    G1035;
    q = w6;
    a = w5;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1037;
    a = cdr(car(cdr(w1)));
    w1 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1033;
    a = car(w1);
    a = CC_Wtag(a);
    if(a != nil) goto    G1033;
    a = car(w1);
    w5 = a;
    goto    G1032;
   G1035:
    q = car(car(cdr(w2)));
    a = car(car(cdr(w1)));
    a = Lmin2(a, q);
    w7 = a;
    a = Lncons(a);
    a = Lncons(a);
    q = w5;
    a = Lxcons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    a = cdr(a);
    a = car(a);
    w4 = a;
    a = cdr(car(cdr(w1)));
    w1 = a;
    a = cdr(car(cdr(w2)));
    w2 = a;
    a = w1;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1033;
    a = car(w1);
    a = CC_Wtag(a);
    if(a != nil) goto    G1033;
    a = w2;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1033;
    a = car(w2);
    a = CC_Wtag(a);
    if(a != nil) goto    G1033;
    a = car(w1);
    w5 = a;
   G1060:
    a = car(w2);
    w6 = a;
    goto    G1032;
   G1037:
    a = cdr(car(cdr(w2)));
    w2 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1033;
    a = car(w2);
    a = CC_Wtag(a);
    if(a == nil) goto    G1060;
   G1033:
    a = cdr(w3);
    if(a != nil) goto    G1059;
    a = mkfxat(1);
    goto    G1031;
   G1059:
    q = mkfxat(1);
    a = w4;
    cdr(a) = q;
    a = cdr(w3);
   G1031:
    popv(7);
    return a;
}

Sex CC_exactgcdH(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    if(!is_number(a)) goto    G1064;
    if(is_number(q)) goto    G1097;
    a = q;
    a = CC_Anumcont(a);
    q = a;
    a = w1;
    goto    G1097;
   G1064:
    if(!is_number(q)) goto    G1069;
    a = CC_Anumcont(a);
    q = a;
    a = w2;
   G1097:
    {
        popv(7);
        return  CC_gcdTbnumbnum(a, q);
    }
   G1069:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    CC_killargchk();
    a = w3;
    if(a != nil) goto    G1073;
    a = w1;
    a = CC_Wncoeftype(a);
    w5 = a;
#define LL_AQ LITERAL[31]
    if(a != LL_AQ) goto    G1077;
    a = w1;
    a = CC_Aclearden(a);
    w1 = a;
   G1077:
    a = w2;
    a = CC_Wncoeftype(a);
    w6 = a;
    if(a != LL_AQ) goto    G1079;
    a = w2;
    a = CC_Aclearden(a);
    w2 = a;
   G1079:
    a = w5;
#define LL_AA LITERAL[32]
    if(a == LL_AA) goto    G1082;
    a = w6;
    if(a != LL_AA) goto    G1081;
   G1082:
    a = CHAR_OF(65);
    goto    G1083;
   G1081:
    a = CHAR_OF(90);
   G1083:
    w3 = a;
   G1073:
    a = w1;
    a = CC_Wunivar(a);
    if(a != nil) goto    G1085;
    a = w2;
    a = CC_Wunivar(a);
    m = w3;
    if(a != nil) goto    G1087;
    q = w2;
    a = w1;
    a = CC_xctgcdTmultipol(a, q, m);
    goto    G1101;
   G1087:
    q = w1;
    a = w2;
    a = CC_xctgcdTunimulti(a, q, m);
    goto    G1101;
   G1085:
    a = w2;
    a = CC_Wunivar(a);
    if(a != nil) goto    G1089;
    m = w3;
    q = w2;
    a = w1;
    a = CC_xctgcdTunimulti(a, q, m);
    goto    G1101;
   G1089:
    a = w1;
    a = CC_Amvar(a);
    w7 = a;
    a = w2;
    a = CC_Amvar(a);
    q = a;
    a = w7;
    a = Lequal(a, q);
    if(a == nil) goto    G1090;
    m = w3;
    q = w2;
    a = w1;
    a = CC_xctgcdTunipol(a, q, m);
    goto    G1101;
   G1090:
    a = w1;
    a = CC_Anumcont(a);
    w7 = a;
    a = w2;
    a = CC_Anumcont(a);
    q = a;
    a = w7;
    a = CC_gcdTbnumbnum(a, q);
   G1101:
    w4 = a;
    CC_recovargchk();
    a = w4;
    popv(7);
    return a;
}

Sex CC_xctgcdTunimulti(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Amvar(a);
    w4 = a;
    a = w2;
    a = CC_Amvar(a);
    w5 = a;
    q = a;
    a = w4;
    a = Lequal(a, q);
    if(a == nil) goto    G1106;
    a = w2;
    a = CC_Alcoef(a);
    w6 = a;
    if(is_number(a)) goto    G1116;
    q = a;
    a = w2;
    a = CC_chkTdivble(a, q);
    w6 = a;
    if(a == nil) goto    G1116;
    a = CC_Wunivar(a);
    if(a != nil) goto    G1110;
   G1116:
    a = w2;
    a = CC_Anumcont(a);
    w2 = a;
    a = w1;
    a = CC_Anumcont(a);
    w1 = a;
    goto    G1113;
   G1110:
    a = w6;
    goto    G1118;
   G1106:
    q = w5;
    a = w4;
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G1112;
    a = w1;
    a = CC_Anumcont(a);
    w1 = a;
    a = w2;
    a = CC_Anumcont(a);
    goto    G1118;
   G1112:
    q = w3;
    a = w2;
    a = CC_xctcontTmultipol(a, q);
   G1118:
    w2 = a;
   G1113:
    m = w3;
    q = w2;
    a = w1;
    a = CC_exactgcdH(a, q, m);
    w6 = a;
    m = w3;
    q = w2;
    a = w1;
    {
        popv(6);
        return  CC_exactgcdH(a, q, m);
    }
}

Sex CC_xctgcdTpriPRS(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    a = CC_Alcoef(a);
    w6 = a;
    a = w2;
    a = CC_Alcoef(a);
    q = a;
    a = w6;
    a = CC_gcdTbnumbnum(a, q);
    w4 = a;
    a = w1;
    a = CC_Adeg(a);
    w6 = a;
    a = w2;
    a = CC_Adeg(a);
    q = a;
    a = w6;
    a = Llessp(a, q);
    if(a == nil) goto    G1127;
    a = w1;
    w5 = a;
    a = w2;
    w1 = a;
    a = w5;
    w2 = a;
   G1127:
    a = CC_Wmodulo();
    if(a == nil) goto    G1131;
    a = mkfxat(1);
    w3 = a;
    goto    G1122;
   G1131:
    q = nil;
    a = w1;
    a = CC_xctppTunipol(a, q);
    w1 = a;
    a = value(LL_Hbyproduct);
    w3 = a;
    q = nil;
    a = w2;
    a = CC_xctppTunipol(a, q);
    w2 = a;
    q = value(LL_Hbyproduct);
    a = w3;
    a = CC_gcdTbnumbnum(a, q);
    w3 = a;
   G1122:
    a = w2;
    a = CC_Alcoef(a);
    w5 = a;
    a = Lonep(a);
    if(a != nil) goto    G1133;
    q = w5;
    a = w2;
    a = CC_Vpol3bnum(a, q);
    w2 = a;
   G1133:
    q = w2;
    a = w1;
    a = CC_xctdivTunipol(a, q);
    a = cdr(a);
    w5 = a;
    if(is_number(a)) goto    G1137;
    a = w2;
    w1 = a;
    a = w5;
    w2 = a;
    goto    G1122;
   G1137:
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G1139;
    a = w3;
    goto    G1121;
   G1139:
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G1141;
    q = w2;
    a = w4;
    a = CC_multH(a, q);
    w2 = a;
   G1141:
    a = w2;
    a = CC_Adeg(a);
    w6 = a;
    a = w5;
    a = CC_Adeg(a);
    q = a;
    a = w6;
    a = Lequal(a, q);
    if(a != nil) goto    G1143;
    q = nil;
    a = w2;
    a = CC_xctppTunipol(a, q);
    w2 = a;
   G1143:
    a = w3;
    a = Lonep(a);
    if(a != nil) goto    G1147;
    q = w2;
    a = w3;
    a = CC_Hbnumpol3(a, q);
    w2 = a;
   G1147:
    a = w2;
   G1121:
    popv(6);
    return a;
}

Sex CC_xctgcdTCollins(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w3 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    a = mkfxat(1);
    w4 = a;
    w2 = q;
    a = w1;
    a = CC_Adeg(a);
    w7 = a;
    a = w2;
    a = CC_Adeg(a);
    q = a;
    a = w7;
    a = Llessp(a, q);
    if(a == nil) goto    G1154;
    a = w1;
    w6 = a;
    a = w2;
    w1 = a;
    a = w6;
    w2 = a;
   G1154:
    a = CC_Wmodulo();
    if(a == nil) goto    G1158;
    a = mkfxat(1);
    w3 = a;
    goto    G1151;
   G1158:
    q = nil;
    a = w1;
    a = CC_xctppTunipol(a, q);
    w1 = a;
    a = value(LL_Hbyproduct);
    w3 = a;
    q = nil;
    a = w2;
    a = CC_xctppTunipol(a, q);
    w2 = a;
    q = value(LL_Hbyproduct);
    a = w3;
    a = CC_gcdTbnumbnum(a, q);
    w3 = a;
   G1151:
    a = w2;
    a = CC_Alcoef(a);
    w7 = a;
    a = w1;
    a = CC_Adeg(a);
    w8 = a;
    a = w2;
    a = CC_Adeg(a);
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w8;
    a = plus2(a, q);
    q = a;
    a = w7;
    a = Lexpt(a, q);
    w5 = a;
    q = w1;
    a = CC_Hbnumpol3(a, q);
    q = w2;
    a = CC_xctdivTunipol(a, q);
    a = cdr(a);
    w6 = a;
    if(is_number(a)) goto    G1152;
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G1170;
    q = w4;
    a = w6;
    a = CC_Vpol3bnum(a, q);
    w6 = a;
   G1170:
    a = w2;
    w1 = a;
    a = w6;
    w2 = a;
    a = w5;
    w4 = a;
    goto    G1151;
   G1152:
    a = w6;
    a = Lzerop(a);
    if(a != nil) goto    G1172;
    a = w3;
    goto    G1150;
   G1172:
    a = w2;
    a = CC_Adeg(a);
    w7 = a;
    a = w6;
    a = CC_Adeg(a);
    q = a;
    a = w7;
    a = Lequal(a, q);
    if(a != nil) goto    G1174;
    q = nil;
    a = w2;
    a = CC_xctppTunipol(a, q);
    w2 = a;
   G1174:
    a = w3;
    a = Lonep(a);
    if(a != nil) goto    G1178;
    q = w2;
    a = w3;
    a = CC_Hbnumpol3(a, q);
    w2 = a;
   G1178:
    a = w2;
   G1150:
    popv(8);
    return a;
}

Sex CC_xctgcdTunipol(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w19 = nil;
    w18 = nil;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    if(is_number(a)) goto    G1183;
    if(!is_number(q)) goto    G1182;
   G1183:
    {
        popv(20);
        return  CC_exactgcdH(a, q, m);
    }
   G1182:
    a = CC_Wmodulo();
    if(a == nil) goto    G1184;
    w4 = nil;
    w5 = nil;
    a = w1;
    a = CC_Alcoef(a);
    w6 = a;
    a = w2;
    a = CC_Alcoef(a);
    q = a;
    a = w6;
    a = gcd(a, q);
    w4 = a;
    a = w1;
    a = CC_Adeg(a);
    w6 = a;
    a = w2;
    a = CC_Adeg(a);
    q = a;
    a = w6;
    a = Llessp(a, q);
    if(a == nil) goto    G1191;
    a = w1;
    w5 = a;
    goto    G1303;
   G1191:
    q = w2;
    a = w1;
    a = CC_xctdivTunipol(a, q);
    a = cdr(a);
    w5 = a;
    if(is_number(a)) goto    G1196;
   G1303:
    a = w2;
    w1 = a;
    a = w5;
    w2 = a;
    goto    G1191;
   G1196:
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G1198;
    a = mkfxat(1);
    goto    G1203;
   G1198:
    a = w2;
    a = CC_Alcoef(a);
    w5 = a;
    q = w4;
    a = Lequal(a, q);
    if(a != nil) goto    G1200;
    q = w5;
    a = w4;
    a = CC_flgdivTbnumbnum(a, q);
    q = w2;
    a = CC_multH(a, q);
    w2 = a;
   G1200:
    q = value(LL_Hmod);
    a = w2;
    {
        popv(20);
        return  CC_Amodulo2(a, q);
    }
   G1184:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    a = w1;
    a = CC_Adeg(a);
    w19 = a;
    a = w2;
    a = CC_Adeg(a);
    q = a;
    a = w19;
    a = Llessp(a, q);
    if(a == nil) goto    G1215;
    a = w1;
    w18 = a;
    a = w2;
    w1 = a;
    a = w18;
    w2 = a;
   G1215:
    q = w3;
    a = w1;
    a = CC_xctppTunipol(a, q);
    w1 = a;
    a = value(LL_Hbyproduct);
    w4 = a;
    q = w3;
    a = w2;
    a = CC_xctppTunipol(a, q);
    w2 = a;
    q = value(LL_Hbyproduct);
    a = w4;
    a = gcd(a, q);
    w4 = a;
    q = w2;
    a = w1;
    a = CC_Vpol3pol3(a, q);
    if(a != nil) goto    G1304;
    a = w1;
    a = CC_Adeg(a);
    w19 = a;
    a = w2;
    a = CC_Adeg(a);
    q = a;
    a = w19;
    a = plus2(a, q);
    q = mkfxat(10);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1207;
    a = mkfxat(1);
    w15 = a;
   G1205:
    a = w2;
    a = CC_Alcoef(a);
    w19 = a;
    a = w1;
    a = CC_Adeg(a);
    w20 = a;
    a = w2;
    a = CC_Adeg(a);
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w20;
    a = plus2(a, q);
    q = a;
    a = w19;
    a = Lexpt(a, q);
    w16 = a;
    q = w1;
    a = CC_Hbnumpol3(a, q);
    q = w2;
    a = CC_xctdivTunipol(a, q);
    a = cdr(a);
    w18 = a;
    if(!is_number(a)) goto    G1237;
    a = Lzerop(a);
    if(a == nil) goto    G1305;
   G1304:
    a = w2;
    w11 = a;
    goto    G1213;
   G1237:
    a = w15;
    a = Lonep(a);
    if(a != nil) goto    G1239;
    q = w15;
    a = w18;
    a = CC_Vpol3bnum(a, q);
    w18 = a;
   G1239:
    a = w2;
    w1 = a;
    a = w18;
    w2 = a;
    a = w16;
    w15 = a;
    goto    G1205;
   G1207:
    CC_savemod();
    a = w1;
    a = CC_Alcoef(a);
    w19 = a;
    a = w2;
    a = CC_Alcoef(a);
    q = a;
    a = w19;
    a = gcd(a, q);
    w5 = a;
    a = w1;
    a = CC_Asqnorm(a);
    w19 = a;
    a = w2;
    a = CC_Asqnorm(a);
    q = a;
    a = w19;
    a = Lmax2(a, q);
    w18 = a;
    q = mkfxat(5);
    a = mkfxat(10);
    a = Lexpt(a, q);
    q = a;
    a = w18;
    a = Llessp(a, q);
    if(a == nil) goto    G1245;
#define LL_Hmedprimes LITERAL[33]
    a = value(LL_Hmedprimes);
    goto    G1247;
   G1245:
#define LL_Hbigprimes LITERAL[34]
    a = value(LL_Hbigprimes);
   G1247:
    w6 = a;
    a = w2;
    a = CC_Adeg(a);
    q = mkfxat(2);
    a = quot2(a, q);
    q = a;
    a = mkfxat(2);
    a = Lexpt(a, q);
    q = a;
    a = w18;
    a = times2(a, q);
    q = a;
    a = w5;
    a = times2(a, q);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    w9 = a;
   G1208:
    q = w5;
    a = mkfxat(10);
    a = times2(a, q);
    q = a;
    a = w6;
    a = CC_setmodTint(a, q);
    w6 = a;
    if(a != nil) goto    G1255;
    CC_recovmod();
    a = nil;
    goto    G1203;
   G1255:
    a = CC_Atellmod();
    w8 = a;
    w7 = a;
    arg4 = w3;
    m = w2;
    q = w1;
#define LL_xctgcdTunipol LITERAL[35]
    a = LL_xctgcdTunipol;
    a = Llist4(a, q, m, arg4);
    a = CC_mkTerrsetprog(a);
    w18 = a;
#define LL_Hbacktrace LITERAL[36]
    m = value(LL_Hbacktrace);
    q = mkfxat(0);
    a = Lerrorset(a, q, m);
    w18 = a;
    if(!is_cons(a)) goto    G1208;
    a = car(a);
    w11 = a;
    a = w11;
    if(is_number(a)) goto    G1297;
    q = w7;
    a = CC_Amodulo2(a, q);
    w11 = a;
    a = w15;
    if(a == nil) goto    G1263;
    a = w16;
    if(a != nil) goto    G1266;
   G1263:
    a = w5;
    a = Lonep(a);
    if(a == nil) goto    G1265;
    a = w1;
    w15 = a;
    a = w2;
    goto    G1306;
   G1265:
    q = w1;
    a = w5;
    a = CC_Hbnumpol3(a, q);
    w15 = a;
    q = w2;
    a = w5;
    a = CC_Hbnumpol3(a, q);
   G1306:
    w16 = a;
   G1266:
    q = w11;
    a = w15;
    a = CC_Vpol3pol3(a, q);
    if(a == nil) goto    G1268;
    q = w11;
    a = w16;
    a = CC_Vpol3pol3(a, q);
    if(a != nil) goto    G1297;
   G1268:
    arg4 = w3;
    m = w2;
    q = w1;
    a = w11;
    a = CC_setTgcdcofctrs(a, q, m, arg4);
    w18 = a;
    a = car(a);
    w13 = a;
    a = car(cdr(w18));
    w14 = a;
    a = cdr(cdr(w18));
    w12 = a;
    a = w13;
    a = Lzerop(a);
    if(a == nil) goto    G1271;
    a = w2;
    goto    G1273;
   G1271:
    a = w14;
    a = Lzerop(a);
    if(a == nil) goto    G1272;
    a = w1;
    goto    G1273;
   G1272:
    q = w1;
    a = w13;
    a = CC_Hbnumpol3(a, q);
    w19 = a;
    q = w2;
    a = w14;
    a = CC_Hbnumpol3(a, q);
    q = a;
    a = w19;
    a = CC_Lpol3pol3(a, q);
   G1273:
    w10 = a;
    a = w5;
    a = Lonep(a);
    if(a != nil) goto    G1277;
    q = w10;
    a = w5;
    a = CC_Hbnumpol3(a, q);
    w10 = a;
    q = w12;
    a = w5;
    a = CC_Hbnumpol3(a, q);
    w12 = a;
   G1277:
    m = w12;
    q = w11;
#define LL_cofact0Tunipol LITERAL[37]
    a = LL_cofact0Tunipol;
    a = Llist3(a, q, m);
    a = CC_mkTerrsetprog(a);
    w18 = a;
    m = value(LL_Hbacktrace);
    q = mkfxat(0);
    a = Lerrorset(a, q, m);
    w18 = a;
    if(!is_cons(a)) goto    G1208;
    a = car(a);
    w18 = a;
    a = car(a);
    w13 = a;
    a = cdr(w18);
    w14 = a;
   G1210:
    q = w7;
    a = w8;
    a = times2(a, q);
    w7 = a;
    CC_setmod(a);
    q = w12;
    a = w11;
    a = CC_multTunipol(a, q);
    a = CC_negTunipol(a);
    q = a;
    a = w10;
    a = CC_addTunipol(a, q);
    w18 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1290;
    q = w14;
    a = w18;
    a = CC_multTunipol(a, q);
    q = w11;
    a = CC_xctdivTunipol(a, q);
    w17 = a;
    q = cdr(a);
    a = w11;
    a = CC_addTunipol(a, q);
    w11 = a;
    q = w12;
    a = car(w17);
    a = CC_multTunipol(a, q);
    w17 = a;
    q = w13;
    a = w18;
    a = CC_multTunipol(a, q);
    q = w17;
    a = CC_addTunipol(a, q);
    w17 = a;
    q = a;
    a = w12;
    a = CC_addTunipol(a, q);
    w12 = a;
    a = CC_Wsttrace();
    if(a == nil) goto    G1290;
    Lterpri();
    a = LITERAL[38];
    Lprinc(a);
    a = CC_Atellmod();
    Lprint(a);
   G1290:
    q = w7;
    a = w11;
    a = CC_Amodulo2(a, q);
    w11 = a;
    q = a;
    a = w15;
    a = CC_Vpol3pol3(a, q);
    if(a == nil) goto    G1293;
    q = w11;
    a = w16;
    a = CC_Vpol3pol3(a, q);
    if(a != nil) goto    G1297;
   G1293:
    q = w9;
    a = w7;
    a = Llessp(a, q);
    if(a == nil) goto    G1208;
    goto    G1210;
   G1297:
    CC_recovmod();
    a = w11;
   G1213:
    if(!is_number(a)) goto    G1299;
   G1305:
    a = w4;
    goto    G1203;
   G1299:
    q = w3;
    a = CC_xctppTunipol(a, q);
    w11 = a;
    a = w4;
    a = Labs(a);
    w4 = a;
    a = Lonep(a);
    if(a != nil) goto    G1301;
    q = w11;
    a = w4;
    a = CC_Hbnumpol3(a, q);
    w11 = a;
   G1301:
    a = w11;
   G1203:
    popv(20);
    return a;
}

Sex CC_setmodTint(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = mkfxat(1);
    w3 = a;
    w2 = q;
    a = w1;
    goto    G1325;
   G1315:
    q = LITERAL[39];
    a = LITERAL[40];
    CC_printmsg(a, q);
    q = LITERAL[41];
    a = LITERAL[42];
    CC_printmsg(a, q);
    a = nil;
    goto    G1309;
   G1311:
    a = car(w1);
    w4 = a;
    q = w2;
    a = gcd(a, q);
    a = Lonep(a);
    if(a != nil) goto    G1317;
    a = cdr(w1);
    w1 = a;
   G1325:
    if(a == nil) goto    G1315;
    goto    G1311;
   G1317:
    q = w3;
    a = w4;
    a = times2(a, q);
    w3 = a;
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G1317;
    a = w3;
    CC_setmod(a);
    a = cdr(w1);
   G1309:
    popv(4);
    return a;
}

Sex CC_xctppTunipol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_number(a)) goto    G1338;
    a = q;
    if(a != CHAR_OF(65)) goto    G1330;
    a = w1;
   G1338:
    value(LL_Hbyproduct) = a;
    a = mkfxat(1);
    goto    G1331;
   G1330:
    w3 = nil;
    q = cdr(w1);
    a = mkfxat(0);
    a = CC_ncontTbpol(a, q);
    a = Labs(a);
    w3 = a;
    a = cdr(car(cdr(cdr(w1))));
    a = Lminusp(a);
    if(a == nil) goto    G1335;
    a = w3;
    a = Lminus(a);
    w3 = a;
   G1335:
    a = w3;
    a = Lonep(a);
    if(a != nil) goto    G1337;
    q = w3;
    a = w1;
    a = CC_Vpol3bnum(a, q);
    w1 = a;
   G1337:
    a = w3;
    value(LL_Hbyproduct) = a;
    a = w1;
   G1331:
    popv(3);
    return a;
}

Sex CC_xctgcdTmultipol(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 19;
    w19 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Wuntrace();
    if(a != nil) goto    G1352;
    a = true;
    w18 = a;
    CC_killtrace();
   G1352:
    a = w18;
    if(a == nil) goto    G1354;
    Lterpri();
    a = LITERAL[43];
    Lprinc(a);
    Lterpri();
    a = CC_Wsttrace();
    if(a == nil) goto    G1354;
    a = LITERAL[44];
    Lprinc(a);
    a = w1;
    CC_msgTpoly(a);
    a = LITERAL[45];
    Lprinc(a);
    a = w2;
    CC_msgTpoly(a);
   G1354:
    a = w1;
    a = CC_varlistH(a);
    w12 = a;
    a = w2;
    a = CC_varlistH(a);
    w13 = a;
    a = mkfxat(1);
    w6 = a;
    w16 = nil;
    q = car(w13);
    a = car(w12);
    a = Lequal(a, q);
    if(a != nil) goto    G1358;
    q = car(w12);
    a = car(w13);
    a = CC_Worder(a, q);
    if(a == nil) goto    G1360;
    a = w1;
    w16 = a;
    a = w2;
    w1 = a;
    a = w16;
    w2 = a;
   G1360:
    a = w1;
    a = CC_Adeg(a);
    a = Ladd1(a);
    q = cdr(w2);
    a = cons(a, q);
    w13 = a;
    q = cdr(cdr(w1));
    a = cons(a, q);
    q = car(cdr(w1));
    a = Lxcons(a, q);
    w12 = a;
    q = car(w1);
    a = Lxcons(a, q);
    q = w3;
    a = CC_xctcontTmultipol(a, q);
    w9 = a;
    a = w18;
    if(a == nil) goto    G1350;
    a = w16;
    if(a == nil) goto    G1368;
    a = LITERAL[46];
    goto    G1433;
   G1368:
    a = LITERAL[47];
   G1433:
    Lprinc(a);
    a = w9;
    CC_msgTpoly(a);
    goto    G1350;
   G1358:
    q = cdr(w13);
    a = cdr(w12);
    a = CC_seTunionvars(a, q);
    w4 = a;
    a = w1;
    a = CC_Adeg(a);
    w19 = a;
    a = w2;
    a = CC_Adeg(a);
    q = a;
    a = w19;
    a = Llessp(a, q);
    if(a == nil) goto    G1371;
    a = w1;
    w16 = a;
    a = w2;
    w1 = a;
    a = w16;
    w2 = a;
   G1371:
    q = w3;
    a = w1;
    a = CC_xctcontTmultipol(a, q);
    w12 = a;
    a = Lonep(a);
    if(a != nil) goto    G1375;
    q = w12;
    a = w1;
    a = CC_quotiH(a, q);
    w1 = a;
   G1375:
    q = w3;
    a = w2;
    a = CC_xctcontTmultipol(a, q);
    w13 = a;
    a = Lonep(a);
    if(a != nil) goto    G1377;
    q = w13;
    a = w2;
    a = CC_quotiH(a, q);
    w2 = a;
   G1377:
    m = w3;
    q = w13;
    a = w12;
    a = CC_exactgcdH(a, q, m);
    w6 = a;
    q = w1;
    a = w2;
    a = CC_WdivoverZpQA(a, q);
    if(a == nil) goto    G1379;
    a = w2;
    goto    G1437;
   G1379:
    a = w2;
    a = CC_Adeg(a);
    a = Lonep(a);
    if(a == nil) goto    G1381;
    a = mkfxat(1);
    goto    G1437;
   G1381:
    a = w1;
    a = CC_Alcoef(a);
    w19 = a;
    a = w2;
    a = CC_Alcoef(a);
    m = w3;
    q = a;
    a = w19;
    a = CC_exactgcdH(a, q, m);
    w7 = a;
   G1343:
    a = w1;
    a = CC_Alcoef(a);
    w19 = a;
    a = w2;
    a = CC_Alcoef(a);
    m = a;
    q = w19;
    a = w4;
    a = CC_setmodTideal(a, q, m);
    w4 = a;
    a = Lcopy(a);
    w5 = a;
    a = w18;
    if(a == nil) goto    G1388;
    a = LITERAL[48];
    Lprinc(a);
    a = w5;
    Lprint(a);
   G1388:
    q = w5;
    a = w1;
    a = CC_multisubstTbnum(a, q);
    w12 = a;
    q = w5;
    a = w2;
    a = CC_multisubstTbnum(a, q);
    w13 = a;
    a = w18;
    if(a == nil) goto    G1390;
    a = LITERAL[49];
    Lprinc(a);
    a = w12;
    CC_msgTpoly(a);
    a = LITERAL[50];
    Lprinc(a);
    a = w13;
    CC_msgTpoly(a);
   G1390:
    m = w3;
    q = w13;
    a = w12;
    a = CC_xctgcdTunipol(a, q, m);
    w9 = a;
    if(!is_number(a)) goto    G1392;
    a = mkfxat(1);
    goto    G1437;
   G1392:
    arg5 = w3;
    arg4 = w9;
    m = w2;
    q = w1;
    a = w4;
    a = CC_chkmodTxctgcd(a, q, m, arg4, arg5);
    w16 = a;
    q = car(a);
    a = w9;
    a = Lequal(a, q);
    if(a != nil) goto    G1398;
    a = car(w16);
    w9 = a;
    a = car(cdr(w16));
    w5 = a;
    a = cdr(cdr(w16));
    w16 = a;
    a = car(a);
    w12 = a;
    a = car(cdr(w16));
    w13 = a;
    a = w18;
    if(a == nil) goto    G1396;
    Lterpri();
    a = LITERAL[51];
    Lprinc(a);
    a = w5;
    Lprint(a);
    a = LITERAL[49];
    Lprinc(a);
    a = w12;
    CC_msgTpoly(a);
    a = LITERAL[50];
    Lprinc(a);
    a = w13;
    CC_msgTpoly(a);
   G1396:
    a = w9;
    if(!is_number(a)) goto    G1398;
    a = mkfxat(1);
    goto    G1437;
   G1398:
    arg4 = w3;
    m = w13;
    q = w12;
    a = w9;
    a = CC_setTgcdcofctrs(a, q, m, arg4);
    w10 = a;
    a = car(a);
    w12 = a;
    a = car(cdr(w10));
    w13 = a;
    a = cdr(cdr(w10));
    w10 = a;
    a = w12;
    a = Lzerop(a);
    if(a == nil) goto    G1400;
    a = w2;
    goto    G1402;
   G1400:
    a = w13;
    a = Lzerop(a);
    if(a == nil) goto    G1401;
    a = w1;
    goto    G1402;
   G1401:
    q = w1;
    a = w12;
    a = CC_multH(a, q);
    w19 = a;
    q = w2;
    a = w13;
    a = CC_multH(a, q);
    q = a;
    a = w19;
    a = CC_addH(a, q);
   G1402:
    w8 = a;
    a = w18;
    if(a == nil) goto    G1406;
    a = LITERAL[52];
    Lprinc(a);
    a = w9;
    CC_msgTpoly(a);
    a = LITERAL[53];
    Lprinc(a);
    a = w10;
    CC_msgTpoly(a);
   G1406:
    a = w10;
    if(is_number(a)) goto    G1438;
    a = w8;
    a = CC_Alcoef(a);
    w16 = a;
    m = nil;
    q = w5;
    a = w8;
    a = CC_multishiftTorgn(a, q, m);
    w8 = a;
    a = CC_Alcoef(a);
    w14 = a;
    m = nil;
    q = w5;
    a = w7;
    a = CC_multishiftTorgn(a, q, m);
    w15 = a;
    q = w5;
    a = w7;
    a = CC_multisubstTbnum(a, q);
    w19 = a;
    a = w9;
    a = CC_Alcoef(a);
    q = a;
    a = w19;
    a = quot2(a, q);
    q = w9;
    a = CC_multH(a, q);
    w9 = a;
    q = w5;
    a = w16;
    a = CC_multisubstTbnum(a, q);
    w19 = a;
    a = w10;
    a = CC_Alcoef(a);
    q = a;
    a = w19;
    a = quot2(a, q);
    q = w10;
    a = CC_multH(a, q);
    w10 = a;
    q = w15;
    a = w9;
    a = CC_replaceTlc(a, q);
    w9 = a;
    q = w14;
    a = w10;
    a = CC_replaceTlc(a, q);
    w10 = a;
    a = w7;
    a = Lonep(a);
    if(a != nil) goto    G1419;
    q = w8;
    a = w15;
    a = CC_multH(a, q);
    w8 = a;
   G1419:
    a = LITERAL[54];
    Lprinc(a);
    a = w9;
    CC_msgTpoly(a);
    a = LITERAL[55];
    Lprinc(a);
    a = w10;
    CC_msgTpoly(a);
    m = w10;
    q = w9;
    a = w8;
    a = CC_AmultiHensel2(a, q, m);
    w16 = a;
    if(!is_cons(a)) goto    G1426;
    q = mkfxat(1);
    a = CC_Anthpart(a, q);
    w9 = a;
    a = LITERAL[56];
    Lprinc(a);
    a = w9;
    CC_msgTpoly(a);
    m = true;
    q = w5;
    a = w9;
    a = CC_multishiftTorgn(a, q, m);
    w9 = a;
    a = LITERAL[57];
    Lprinc(a);
    a = w9;
    CC_msgTpoly(a);
    q = w3;
    a = w9;
    a = CC_xctcontTmultipol(a, q);
    w7 = a;
    a = Lonep(a);
    if(a != nil) goto    G1424;
    q = w7;
    a = w9;
    a = CC_quotiH(a, q);
    w9 = a;
   G1424:
    q = w1;
    a = w9;
    a = CC_WdivoverZpQA(a, q);
    if(a != nil) goto    G1350;
   G1426:
    a = w18;
    if(a == nil) goto    G1343;
    a = LITERAL[58];
    Lprinc(a);
    Lterpri();
    goto    G1343;
   G1438:
    q = w1;
    a = w2;
    a = CC_WdivoverZpQA(a, q);
    if(a == nil) goto    G1426;
    a = w2;
   G1437:
    w9 = a;
   G1350:
    a = w6;
    a = Lonep(a);
    if(a != nil) goto    G1430;
    q = w9;
    a = w6;
    a = CC_multH(a, q);
    w9 = a;
   G1430:
    a = w18;
    if(a == nil) goto    G1432;
    a = LITERAL[59];
    Lprinc(a);
    Lterpri();
    Lterpri();
    CC_recovtrace();
   G1432:
    a = w9;
    popv(19);
    return a;
}

Sex CC_xctcontTmultipol(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w3 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = cdr(cdr(a));
    w4 = a;
    w2 = q;
   G1442:
    a = cdr(car(w4));
    w5 = a;
    if(is_number(a)) goto    G1465;
    a = car(a);
    if(!is_integer(a)) goto    G1449;
    a = mkfxat(1);
    goto    G1441;
   G1465:
    a = true;
    w3 = a;
   G1449:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1442;
    a = w3;
    if(a == nil) goto    G1453;
    a = w1;
    a = CC_Anumcont(a);
    w3 = a;
    goto    G1446;
   G1453:
    a = cdr(cdr(w1));
    w4 = a;
    a = car(w1);
    w7 = a;
    q = cdr(car(w4));
    a = cons(a, q);
    q = a;
    a = CHAR_OF(104);
    a = Llist2(a, q);
    w6 = a;
   G1443:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G1444;
    q = cdr(car(a));
    a = w7;
    a = cons(a, q);
#define LL_Worder LITERAL[60]
    m = LL_Worder;
    q = w6;
    CC_seTinsert(a, q, m);
    goto    G1443;
   G1444:
    a = cdr(w6);
    a = Lnreverse(a);
    w4 = a;
    a = car(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G1446;
    CC_killtrace();
   G1445:
    m = w2;
    q = car(w4);
    a = w3;
    a = CC_exactgcdH(a, q, m);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1445;
    CC_recovtrace();
   G1446:
    a = w1;
    a = CC_Alncoef(a);
    a = Lminusp(a);
    if(a == nil) goto    G1463;
    a = w3;
    a = CC_negH(a);
    w3 = a;
   G1463:
    a = w3;
   G1441:
    popv(7);
    return a;
}

Sex CC_xctcontTwrtvar(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = mkfxat(1);
    a = w2;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w1;
    a = CC_coefTcano(a, q);
    w6 = a;
    w5 = a;
    a = cdr(a);
    if(a != nil) goto    G1475;
    a = cdr(car(w5));
    goto    G1468;
   G1475:
    CC_killtrace();
   G1469:
    a = cdr(car(w6));
    a = CC_Cterms(a);
    a = Lminus(a);
    q = a;
    a = car(w6);
    car(a) = q;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G1469;
    q = LL_Worder;
    a = w5;
    a = CC_sortany(a, q);
    w5 = a;
    a = cdr(car(a));
    w4 = a;
   G1470:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G1471;
    m = w3;
    q = cdr(car(a));
    a = w4;
    a = CC_exactgcdH(a, q, m);
    w4 = a;
    if(!is_number(a)) goto    G1470;
   G1471:
    CC_recovtrace();
    a = w4;
   G1468:
    popv(7);
    return a;
}

Sex CC_setTgcdcofctrs(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w6 = nil;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = a;
    a = m;
    a = CC_xctquoTunipol(a, q);
    w6 = a;
    m = w4;
    q = w1;
    a = CC_xctgcdTunipol(a, q, m);
    w10 = a;
    if(!is_number(a)) goto    G1490;
    q = w6;
    a = mkfxat(1);
    a = cons(a, q);
    q = mkfxat(0);
    goto    G1525;
   G1490:
    q = w1;
    a = w2;
    a = CC_xctquoTunipol(a, q);
    w5 = a;
    m = w4;
    q = w1;
    a = CC_xctgcdTunipol(a, q, m);
    w10 = a;
    if(!is_number(a)) goto    G1494;
    q = w5;
    a = mkfxat(0);
    a = cons(a, q);
    q = mkfxat(1);
    goto    G1525;
   G1494:
    q = w6;
    a = w5;
    a = CC_addTunipol(a, q);
    w7 = a;
    m = w4;
    q = w1;
    a = CC_xctgcdTunipol(a, q, m);
    w10 = a;
    if(!is_number(a)) goto    G1498;
    q = w7;
    a = mkfxat(1);
    a = cons(a, q);
    q = mkfxat(1);
    goto    G1525;
   G1498:
    a = w6;
    a = CC_negTunipol(a);
    q = a;
    a = w5;
    a = CC_addTunipol(a, q);
    w7 = a;
    m = w4;
    q = w1;
    a = CC_xctgcdTunipol(a, q, m);
    w10 = a;
    if(!is_number(a)) goto    G1503;
    q = w7;
    a = mkfxat(1);
    a = cons(a, q);
    a = Lminus(a);
    q = mkfxat(1);
    goto    G1525;
   G1503:
    a = mkfxat(1);
    w8 = a;
   G1487:
    a = w8;
    a = Ladd1(a);
    w8 = a;
    a = Lminus(a);
    a = Ladd1(a);
    w9 = a;
   G1488:
    q = w5;
    a = w8;
    a = CC_multH(a, q);
    w11 = a;
    q = w6;
    a = w9;
    a = CC_multH(a, q);
    q = a;
    a = w11;
    a = CC_addTunipol(a, q);
    w7 = a;
    m = w4;
    q = w1;
    a = CC_xctgcdTunipol(a, q, m);
    w10 = a;
    if(!is_number(a)) goto    G1511;
    q = w7;
    a = w9;
    a = cons(a, q);
    q = w8;
   G1525:
    {
        popv(11);
        return  Lxcons(a, q);
    }
   G1511:
    a = w8;
    a = Levenp(a);
    if(a == nil) goto    G1515;
    q = mkfxat(2);
    a = w9;
    a = plus2(a, q);
    goto    G1516;
   G1515:
    a = w9;
    a = Ladd1(a);
   G1516:
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1518;
    a = w9;
    a = Ladd1(a);
    w9 = a;
   G1518:
    q = w8;
    a = w9;
    a = Llessp(a, q);
    if(a == nil) goto    G1487;
    goto    G1488;
}

Sex CC_chkmodTxctgcd(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = Lcopy(a);
    w7 = a;
    a = w4;
    a = CC_Adeg(a);
    w14 = a;
    a = w2;
    a = CC_Alcoef(a);
    w12 = a;
    a = w3;
    a = CC_Alcoef(a);
    w13 = a;
   G1529:
    m = w13;
    q = w12;
    a = w1;
    CC_setmodTideal(a, q, m);
    q = w1;
    a = w2;
    a = CC_multisubstTbnum(a, q);
    w8 = a;
    q = w1;
    a = w3;
    a = CC_multisubstTbnum(a, q);
    w9 = a;
    m = w5;
    q = a;
    a = w8;
    a = CC_xctgcdTunipol(a, q, m);
    w6 = a;
    a = CC_Adeg(a);
    w15 = a;
    q = w14;
    a = Lequal(a, q);
    if(a == nil) goto    G1531;
    arg4 = w11;
    m = w10;
    q = w7;
    a = w4;
    {
        popv(15);
        return  Llist4(a, q, m, arg4);
    }
   G1531:
    q = w14;
    a = w15;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1529;
    a = w6;
    w4 = a;
    a = w1;
    a = Lcopy(a);
    w7 = a;
    a = w15;
    w14 = a;
    a = w8;
    w10 = a;
    a = w9;
    w11 = a;
    goto    G1529;
}

Sex CC_setmodTideal(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(a);
    if(!is_cons(a)) goto    G1541;
    a = cdr(a);
    if(is_number(a)) goto    G1537;
   G1541:
    a = w1;
    a = Llength(a);
    a = CC_listzero(a);
    q = a;
    a = w1;
    a = Lpair(a, q);
    w1 = a;
    goto    G1549;
   G1537:
    a = cdr(car(w1));
    w5 = a;
    a = w1;
    w4 = a;
   G1538:
    if(a != nil) goto    G1546;
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = a;
    a = car(w1);
    goto    G1557;
   G1546:
    q = w5;
    a = cdr(car(a));
    a = Lequal(a, q);
    if(a == nil) goto    G1548;
    a = cdr(w4);
    w4 = a;
    goto    G1538;
   G1548:
    a = cdr(car(w4));
    a = Ladd1(a);
    q = a;
    a = car(w4);
   G1557:
    cdr(a) = q;
   G1549:
    q = w1;
    a = w2;
    a = CC_multisubstTbnum(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G1537;
    q = w1;
    a = w3;
    a = CC_multisubstTbnum(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G1537;
    a = w1;
    popv(5);
    return a;
}

Sex CC_replaceTlc(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    if(!is_cons(q)) goto    G1561;
    a = car(q);
    if(!is_integer(a)) goto    G1561;
    a = cdr(q);
    w2 = a;
   G1561:
    q = w2;
    a = car(car(cdr(cdr(w1))));
    a = cons(a, q);
    value(LL_Htemporal) = a;
    q = cdr(cdr(cdr(w1)));
    a = cons(a, q);
    q = car(cdr(w1));
    a = Lxcons(a, q);
    q = car(w1);
    {
        popv(2);
        return  Lxcons(a, q);
    }
}

Sex CC_Asqfr(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G1568;
    {
        popv(5);
        return  CC_sqfrTbnum(a);
    }
   G1568:
    a = CC_Wpoly(a);
    if(a != nil) goto    G1569;
    q = LITERAL[61];
    a = LITERAL[23];
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G1569:
    w3 = nil;
    a = w1;
    a = CC_Wexactcoef(a);
    if(a == nil) goto    G1573;
    q = nil;
    a = w1;
    a = CC_exactsqfrH(a, q);
    goto    G1574;
   G1573:
    q = w2;
    a = w1;
    a = CC_approxsqfrH(a, q);
   G1574:
    w3 = a;
    w4 = nil;
    goto    G1576;
   G1575:
    w5 = a;
    a = car(a);
    a = CC_convTlist2oset(a);
    q = w4;
    a = cons(a, q);
    w4 = a;
    a = cdr(w5);
   G1576:
    if(a != nil) goto    G1575;
    a = w4;
    a = Lnreverse(a);
    w3 = a;
    {
        popv(5);
        return  CC_convTlist2oset(a);
    }
}

Sex CC_exactsqfrH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(!is_number(a)) goto    G1583;
    q = a;
    a = mkfxat(1);
    a = Llist2(a, q);
    {
        popv(4);
        return  Lncons(a);
    }
   G1583:
    w3 = nil;
    w4 = nil;
    CC_killargchk();
    a = w2;
    if(a != nil) goto    G1593;
    a = w1;
    a = CC_Wncoeftype(a);
    w2 = a;
#define LL_AZ LITERAL[62]
    if(a != LL_AZ) goto    G1591;
    a = CHAR_OF(90);
    goto    G1601;
   G1591:
    if(a != LL_AA) goto    G1592;
    a = CHAR_OF(65);
   G1601:
    w2 = a;
    goto    G1593;
   G1592:
    a = w1;
    a = CC_Aclearden(a);
    w1 = a;
    a = CHAR_OF(90);
    w2 = a;
    q = value(LL_Hbyproduct);
    a = mkfxat(1);
    a = Lmkrational(a, q);
    q = a;
    a = mkfxat(1);
    a = Llist2(a, q);
    a = Lncons(a);
    w4 = a;
   G1593:
    a = w1;
    a = CC_Wunivar(a);
    q = w2;
    if(a == nil) goto    G1597;
    a = w1;
    a = CC_xctsqfrTunipol(a, q);
    goto    G1598;
   G1597:
    a = w1;
    a = CC_xctsqfrTmultipol(a, q);
   G1598:
    w3 = a;
    a = w4;
    if(a == nil) goto    G1600;
    q = w3;
    a = CC_mergTsqfrlist(a, q);
    w3 = a;
   G1600:
    CC_recovargchk();
    a = w3;
    popv(4);
    return a;
}

Sex CC_xctsqfrTunipol(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Adeg(a);
    q = mkfxat(1);
    a = Lleq(a, q);
    if(a != nil) goto    G1642;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    q = w2;
    a = w1;
    a = CC_xctppTunipol(a, q);
    w5 = a;
    a = value(LL_Hbyproduct);
    w4 = a;
    q = mkfxat(1);
    a = w5;
    a = CC_dfTunipol(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1613;
    m = w2;
    q = w6;
    a = w5;
    a = CC_xctgcdTunipol(a, q, m);
    w6 = a;
    if(!is_number(a)) goto    G1619;
   G1642:
    q = w1;
    a = mkfxat(1);
    a = Llist2(a, q);
    {
        popv(12);
        return  Lncons(a);
    }
   G1619:
    q = a;
    a = w5;
    a = CC_xctquoTunipol(a, q);
    w7 = a;
    a = mkfxat(1);
    w11 = a;
    a = w7;
    a = CC_Adeg(a);
    w10 = a;
   G1610:
    m = w2;
    q = w7;
    a = w6;
    a = CC_xctgcdTunipol(a, q, m);
    w8 = a;
    a = CC_Adeg(a);
    q = a;
    a = w10;
    a = Lequal(a, q);
    if(a == nil) goto    G1612;
   G1623:
    a = w11;
    a = Ladd1(a);
    w11 = a;
    a = w6;
    w5 = a;
    a = w8;
    w7 = a;
    q = a;
    a = w5;
    a = CC_xctquoTunipol(a, q);
    w6 = a;
    goto    G1610;
   G1612:
    a = w8;
    if(!is_number(a)) goto    G1626;
    a = w7;
    goto    G1627;
   G1626:
    q = a;
    a = w7;
    a = CC_xctquoTunipol(a, q);
   G1627:
    w9 = a;
    q = a;
    a = w11;
    a = Llist2(a, q);
    q = w3;
    a = cons(a, q);
    w3 = a;
    a = w9;
    a = CC_Adeg(a);
    q = a;
    a = w10;
    a = Lequal(a, q);
    if(a != nil) goto    G1630;
    a = w8;
    a = CC_Adeg(a);
    w10 = a;
    goto    G1623;
   G1630:
    a = w6;
    if(!is_number(a)) goto    G1613;
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G1615;
    q = w4;
    a = mkfxat(1);
    a = Llist2(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    a = CC_mergTsqfrlist(a, q);
    w3 = a;
    goto    G1615;
   G1613:
    a = CC_Atellmod();
    w11 = a;
    a = w3;
    w5 = a;
    q = w11;
    a = w6;
    a = CC_replaceTppow(a, q);
    w6 = a;
    q = w2;
    a = CC_xctsqfrTunipol(a, q);
    w3 = a;
    w12 = a;
   G1614:
    q = car(car(w12));
    a = w11;
    a = times2(a, q);
    q = a;
    a = car(w12);
    car(a) = q;
    a = cdr(w12);
    w12 = a;
    if(a != nil) goto    G1614;
    a = w3;
    a = CC_tail(a);
    q = w5;
    cdr(a) = q;
    q = LL_Worder;
    a = w3;
    a = CC_sortany(a, q);
    w3 = a;
   G1615:
    a = w3;
    popv(12);
    return a;
}

Sex CC_replaceTppow(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    a = car(cdr(a));
    w3 = a;
    w2 = q;
    a = Lncons(a);
    w5 = a;
    q = car(w1);
    a = Lxcons(a, q);
    w4 = a;
    a = cdr(cdr(w1));
    w1 = a;
   G1646:
    a = car(w1);
    w6 = a;
    q = w2;
    a = car(a);
    a = quot2(a, q);
    q = cdr(w6);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G1646;
    a = w4;
    popv(6);
    return a;
}

Sex CC_xctsqfrTmultipol(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 21;
    w21 = nil;
    w20 = nil;
    w19 = nil;
    w18 = nil;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Adeg(a);
    a = Lonep(a);
    if(a == nil) goto    G1657;
    q = w1;
    a = mkfxat(1);
    a = Llist2(a, q);
    {
        popv(21);
        return  Lncons(a);
    }
   G1657:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w19 = nil;
    a = CC_Wuntrace();
    if(a != nil) goto    G1674;
    a = true;
    w19 = a;
    CC_killtrace();
   G1674:
    a = w19;
    if(a == nil) goto    G1676;
    Lterpri();
    a = LITERAL[63];
    Lprinc(a);
    Lterpri();
    a = CC_Wsttrace();
    if(a == nil) goto    G1676;
    a = LITERAL[64];
    Lprinc(a);
    a = w1;
    CC_msgTpoly(a);
   G1676:
    q = w2;
    a = w1;
    a = CC_xctcontTmultipol(a, q);
    w18 = a;
    a = Lonep(a);
    if(a != nil) goto    G1680;
    q = mkfxat(-1);
    a = w18;
    a = Lequal(a, q);
    if(a != nil) goto    G1680;
    q = w18;
    a = w1;
    a = CC_quotiH(a, q);
    w1 = a;
    q = w2;
    a = w18;
    a = CC_exactsqfrH(a, q);
    w5 = a;
    a = w19;
    if(a == nil) goto    G1683;
    a = LITERAL[65];
    Lprinc(a);
    a = w18;
    CC_msgTpoly(a);
   G1683:
    a = LITERAL[66];
    Lprinc(a);
    w20 = nil;
    a = w5;
    goto    G1685;
   G1684:
    w21 = a;
    a = car(a);
    a = CC_convTlist2oset(a);
    q = w20;
    a = cons(a, q);
    w20 = a;
    a = cdr(w21);
   G1685:
    if(a != nil) goto    G1684;
    a = w20;
    a = Lnreverse(a);
    w18 = a;
    a = CC_convTlist2oset(a);
    q = nil;
    CC_fprinTset(a, q);
    Lterpri();
   G1680:
    a = w1;
    a = CC_Wunivar(a);
    if(a == nil) goto    G1690;
    q = w2;
    a = w1;
    a = CC_xctsqfrTunipol(a, q);
    w3 = a;
    goto    G1672;
   G1690:
    a = w1;
    a = CC_varlistH(a);
    a = cdr(a);
    w6 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G1663:
    a = w1;
    a = CC_Alcoef(a);
    m = nil;
    q = a;
    a = w6;
    a = CC_setmodTideal(a, q, m);
    w6 = a;
    a = Lcopy(a);
    w7 = a;
    a = w19;
    if(a == nil) goto    G1694;
    a = LITERAL[48];
    Lprinc(a);
    a = w7;
    Lprint(a);
   G1694:
    q = w7;
    a = w1;
    a = CC_multisubstTbnum(a, q);
    w8 = a;
    a = w19;
    if(a == nil) goto    G1696;
    a = LITERAL[67];
    Lprinc(a);
    a = w8;
    CC_msgTpoly(a);
   G1696:
    q = w2;
    a = w8;
    a = CC_xctsqfrTunipol(a, q);
    w9 = a;
    a = car(car(a));
    w16 = a;
    a = w19;
    if(a == nil) goto    G1698;
    a = LITERAL[68];
    Lprinc(a);
    w20 = nil;
    a = w9;
    goto    G1700;
   G1699:
    w21 = a;
    a = car(a);
    a = CC_convTlist2oset(a);
    q = w20;
    a = cons(a, q);
    w20 = a;
    a = cdr(w21);
   G1700:
    if(a != nil) goto    G1699;
    a = w20;
    a = Lnreverse(a);
    w18 = a;
    a = CC_convTlist2oset(a);
    q = nil;
    CC_fprinTset(a, q);
   G1698:
    a = w16;
    a = Lonep(a);
    if(a != nil) goto    G1772;
    arg4 = w2;
    m = w9;
    q = w1;
    a = w6;
    a = CC_chkmodTxctsqfr(a, q, m, arg4);
    w18 = a;
    q = car(a);
    a = w9;
    a = Lequal(a, q);
    if(a != nil) goto    G1714;
    a = car(w18);
    w9 = a;
    a = car(cdr(w18));
    w7 = a;
    a = car(cdr(cdr(w18)));
    w8 = a;
    a = car(car(w9));
    w16 = a;
    a = w19;
    if(a == nil) goto    G1712;
    Lterpri();
    a = LITERAL[51];
    Lprinc(a);
    a = w7;
    Lprint(a);
   G1712:
    a = w16;
    a = Lonep(a);
    if(a != nil) goto    G1772;
   G1714:
    m = nil;
    q = w7;
    a = w1;
    a = CC_multishiftTorgn(a, q, m);
    w10 = a;
    q = w16;
    a = car(cdr(car(w9)));
    a = CC_powTunipol(a, q);
    w11 = a;
    q = a;
    a = w8;
    a = CC_xctquoTunipol(a, q);
    w13 = a;
    w12 = a;
    a = w19;
    if(a == nil) goto    G1719;
    a = LITERAL[69];
    Lprinc(a);
    a = w11;
    CC_msgTpoly(a);
    a = LITERAL[70];
    Lprinc(a);
    a = w12;
    CC_msgTpoly(a);
   G1719:
    a = w12;
    if(!is_number(a)) goto    G1721;
    q = w16;
    a = w1;
    a = CC_Apowroot(a, q);
    w11 = a;
    if(a == LL_Anil) goto    G1671;
    a = w19;
    if(a == nil) goto    G1725;
    a = LITERAL[71];
    Lprinc(a);
    a = w11;
    CC_msgTpoly(a);
   G1725:
    q = w11;
    a = w16;
    a = Llist2(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G1672;
   G1721:
    a = w1;
    a = CC_Alcoef(a);
    w15 = a;
    q = w16;
    a = CC_sqfrTcandlc(a, q);
    w14 = a;
    q = w7;
    a = CC_multisubstTbnum(a, q);
    w20 = a;
    a = w11;
    a = CC_Alcoef(a);
    q = a;
    a = w20;
    a = quot2(a, q);
    q = w11;
    a = CC_multH(a, q);
    w11 = a;
    q = w7;
    a = w15;
    a = CC_multisubstTbnum(a, q);
    w20 = a;
    a = w12;
    a = CC_Alcoef(a);
    q = a;
    a = w20;
    a = quot2(a, q);
    q = w12;
    a = CC_multH(a, q);
    w12 = a;
    a = w10;
    a = CC_Alcoef(a);
    w15 = a;
    m = nil;
    q = w7;
    a = w14;
    a = CC_multishiftTorgn(a, q, m);
    w14 = a;
    q = a;
    a = w11;
    a = CC_replaceTlc(a, q);
    w11 = a;
    q = w15;
    a = w12;
    a = CC_replaceTlc(a, q);
    w12 = a;
    q = w10;
    a = w14;
    a = CC_multH(a, q);
    w10 = a;
    a = w19;
    if(a == nil) goto    G1736;
    a = LITERAL[54];
    Lprinc(a);
    a = w11;
    CC_msgTpoly(a);
    a = LITERAL[55];
    Lprinc(a);
    a = w12;
    CC_msgTpoly(a);
   G1736:
    m = w12;
    q = w11;
    a = w10;
    a = CC_AmultiHensel2(a, q, m);
    w18 = a;
    if(!is_cons(a)) goto    G1671;
    q = mkfxat(1);
    a = CC_Anthpart(a, q);
    w11 = a;
    a = w19;
    if(a == nil) goto    G1741;
    a = LITERAL[56];
    Lprinc(a);
    a = w11;
    CC_msgTpoly(a);
   G1741:
    m = true;
    q = w7;
    a = w11;
    a = CC_multishiftTorgn(a, q, m);
    w11 = a;
    a = w19;
    if(a == nil) goto    G1743;
    a = LITERAL[57];
    Lprinc(a);
    a = w11;
    CC_msgTpoly(a);
   G1743:
    q = w2;
    a = w11;
    a = CC_xctcontTmultipol(a, q);
    w14 = a;
    a = Lonep(a);
    if(a != nil) goto    G1745;
    q = w14;
    a = w11;
    a = CC_quotiH(a, q);
    w11 = a;
   G1745:
    q = w1;
    a = w11;
    a = CC_WdivoverZpQA(a, q);
    w12 = a;
    if(a == nil) goto    G1671;
    q = w16;
    a = w11;
    a = CC_Apowroot(a, q);
    w11 = a;
    if(a != LL_Anil) goto    G1750;
   G1671:
    a = w19;
    if(a == nil) goto    G1663;
    a = LITERAL[58];
    Lprinc(a);
    Lterpri();
    goto    G1663;
   G1750:
    a = w19;
    if(a == nil) goto    G1752;
    a = LITERAL[71];
    Lprinc(a);
    a = w11;
    CC_msgTpoly(a);
   G1752:
    q = w11;
    a = w16;
    a = Llist2(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = w12;
    if(is_number(a)) goto    G1672;
    w1 = a;
    a = w13;
    w8 = a;
    a = cdr(w9);
    w9 = a;
    a = car(car(a));
    w16 = a;
    a = Lonep(a);
    if(a == nil) goto    G1714;
   G1772:
    q = w1;
    a = mkfxat(1);
    a = Llist2(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
   G1672:
    a = w19;
    if(a == nil) goto    G1766;
    CC_recovtrace();
    a = LITERAL[72];
    Lprinc(a);
    Lterpri();
    Lterpri();
   G1766:
    a = w5;
    if(a != nil) goto    G1768;
    a = cdr(w3);
    goto    G1660;
   G1768:
    q = cdr(w3);
    a = CC_mergTsqfrlist(a, q);
   G1660:
    popv(21);
    return a;
}

Sex CC_chkmodTxctsqfr(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = Lcopy(a);
    w6 = a;
    a = w2;
    a = CC_Alcoef(a);
    w7 = a;
   G1776:
    m = nil;
    q = w7;
    a = w1;
    CC_setmodTideal(a, q, m);
    q = w1;
    a = w2;
    a = CC_multisubstTbnum(a, q);
    w8 = a;
    q = w4;
    a = CC_xctsqfrTunipol(a, q);
    w5 = a;
    a = w3;
    w10 = a;
    a = w5;
    w11 = a;
   G1777:
    a = car(car(w10));
    w12 = a;
    a = car(car(w11));
    w13 = a;
    q = a;
    a = w12;
    a = Llessp(a, q);
    if(a != nil) goto    G1776;
    q = w13;
    a = w12;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1787;
    a = car(cdr(car(w10)));
    a = CC_Adeg(a);
    w12 = a;
    a = car(cdr(car(w11)));
    a = CC_Adeg(a);
    w13 = a;
    q = a;
    a = w12;
    a = Llessp(a, q);
    if(a != nil) goto    G1776;
    q = w13;
    a = w12;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1783;
   G1787:
    a = w5;
    w3 = a;
    a = w1;
    a = Lcopy(a);
    w6 = a;
    a = w8;
    w9 = a;
    goto    G1776;
   G1783:
    a = cdr(w10);
    w10 = a;
    a = cdr(w11);
    w11 = a;
    a = w10;
    if(a != nil) goto    G1777;
    m = w9;
    q = w6;
    a = w3;
    {
        popv(13);
        return  Llist3(a, q, m);
    }
}

Sex CC_mergTsqfrlist(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G1791:
    a = car(car(w1));
    w5 = a;
    a = car(car(w2));
    w6 = a;
    q = a;
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1793;
    a = car(w1);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    goto    G1799;
   G1793:
    q = w6;
    a = w5;
    a = Llessp(a, q);
    if(a == nil) goto    G1796;
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G1809;
   G1796:
    q = car(cdr(car(w2)));
    a = car(cdr(car(w1)));
    a = CC_multH(a, q);
    w7 = a;
    q = a;
    a = w5;
    a = Llist2(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
   G1809:
    a = cdr(w2);
    w2 = a;
    a = w1;
   G1799:
    if(a == nil) goto    G1804;
    a = w2;
    if(a != nil) goto    G1791;
    q = w1;
    goto    G1810;
   G1804:
    a = w2;
    if(a == nil) goto    G1808;
    q = a;
   G1810:
    a = w4;
    cdr(a) = q;
   G1808:
    a = cdr(w3);
    popv(7);
    return a;
}

Sex CC_sqfrTcandlc(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    q = nil;
    a = CC_exactsqfrH(a, q);
    w3 = a;
   G1814:
    a = car(car(w3));
    w5 = a;
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G1824;
    q = w2;
    a = w5;
    a = quot2(a, q);
    q = a;
    a = car(cdr(car(w3)));
    a = CC_powH(a, q);
    w6 = a;
    a = w4;
    if(a == nil) goto    G1821;
    q = a;
    a = w6;
    a = CC_multH(a, q);
    goto    G1822;
   G1821:
    a = w6;
   G1822:
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1814;
   G1824:
    a = w4;
    if(a == nil) goto    G1826;
    q = w2;
    a = CC_powH(a, q);
    goto    G1827;
   G1826:
    a = mkfxat(1);
   G1827:
    w4 = a;
    a = w3;
    if(a == nil) goto    G1836;
    a = CC_tail(a);
    w3 = a;
    a = car(car(a));
    a = Lonep(a);
    if(a != nil) goto    G1832;
   G1836:
    a = w4;
    goto    G1813;
   G1832:
    a = car(cdr(car(w3)));
    a = CC_Anumcont(a);
    q = w4;
    a = CC_multH(a, q);
   G1813:
    popv(6);
    return a;
}

Sex CC_Afactorize(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    if(is_number(a)) goto    G1844;
    a = CC_Wpoly(a);
    if(a != nil) goto    G1841;
    q = LITERAL[73];
    a = LITERAL[23];
    goto    G1859;
   G1841:
    a = w2;
    if(a == nil) goto    G1842;
    if(is_number(a)) goto    G1842;
    q = LITERAL[73];
    a = LITERAL[74];
   G1859:
    {
        popv(5);
        return  CC_errormsg(a, q);
    }
   G1842:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = w1;
    a = CC_Wexactcoef(a);
    if(a == nil) goto    G1849;
    a = w2;
    if(a != nil) goto    G1849;
    q = nil;
    a = w1;
    a = CC_exactfactrzH(a, q);
    goto    G1851;
   G1849:
    q = w2;
    a = w1;
    a = CC_approxfactrzH(a, q);
   G1851:
    w3 = a;
#define LL_cH LITERAL[75]
    a = LL_cH;
    a = Lncons(a);
    w5 = a;
    a = car(w3);
    w4 = a;
   G1846:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G1847;
    q = w5;
    a = car(a);
    CC_seTmergTcanoscH(a, q);
    goto    G1846;
   G1847:
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G1855;
    a = w5;
    {
        popv(5);
        return  CC_reduceTcH(a);
    }
   G1855:
    q = w4;
    a = w5;
    a = cons(a, q);
    q = a;
#define LL_cL LITERAL[76]
    a = LL_cL;
    a = Llist2(a, q);
   G1844:
    popv(5);
    return a;
}

Sex CC_exactfactrzH(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    CC_killargchk();
    a = w2;
    if(a == nil) goto    G1873;
    a = mkfxat(1);
    goto    G1927;
   G1873:
    a = w1;
    a = CC_Wncoeftype(a);
    w2 = a;
    if(a != LL_AZ) goto    G1875;
    a = CHAR_OF(90);
    goto    G1928;
   G1875:
    if(a != LL_AA) goto    G1876;
    a = CHAR_OF(65);
   G1928:
    w2 = a;
    goto    G1877;
   G1876:
    a = w1;
    a = CC_Aclearden(a);
    w1 = a;
    a = CHAR_OF(90);
    w2 = a;
    q = value(LL_Hbyproduct);
    a = mkfxat(1);
    a = Lmkrational(a, q);
    w9 = a;
   G1877:
    a = w1;
    a = CC_Alncoef(a);
    w8 = a;
    a = CC_Wmodulo();
    if(a == nil) goto    G1879;
    a = w8;
    goto    G1881;
   G1879:
    q = mkfxat(0);
    a = w8;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1880;
    a = w1;
    a = CC_Anumcont(a);
    goto    G1881;
   G1880:
    a = w1;
    a = CC_Anumcont(a);
    a = Lminus(a);
   G1881:
    w3 = a;
    a = Lonep(a);
    if(a != nil) goto    G1884;
    q = w3;
    a = w1;
    a = CC_quotiH(a, q);
    w1 = a;
   G1884:
    a = w9;
    if(a == nil) goto    G1886;
    q = a;
    a = w3;
    a = CC_multH(a, q);
   G1927:
    w3 = a;
   G1886:
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    a = w1;
    a = CC_Amonocont(a);
    w9 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1888;
    q = w9;
    a = w1;
    a = CC_quotiH(a, q);
    w1 = a;
    q = mkfxat(1);
    a = w9;
    a = Llist2(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
   G1888:
    a = w1;
    a = CC_varlistH(a);
    w8 = a;
    a = cdr(a);
    if(a == nil) goto    G1904;
   G1894:
    m = w2;
    q = car(w8);
    a = w1;
    a = CC_xctcontTwrtvar(a, q, m);
    w9 = a;
    if(is_number(a)) goto    G1866;
    q = a;
    a = w1;
    a = CC_quotiH(a, q);
    w1 = a;
    a = CC_Wuntrace();
    if(a != nil) goto    G1898;
    Lterpri();
    a = LITERAL[77];
    Lprinc(a);
    a = w9;
    CC_msgTpoly(a);
   G1898:
    CC_killtrace();
    q = w2;
    a = w9;
    a = CC_exactfactrzH(a, q);
    w6 = a;
    CC_recovtrace();
   G1865:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G1866;
    m = LL_Worder;
    q = w5;
    a = car(a);
    CC_seTinsert(a, q, m);
    goto    G1865;
   G1866:
    a = w1;
    if(!is_number(a)) goto    G1902;
    q = a;
    a = w3;
    a = times2(a, q);
    w3 = a;
    goto    G1925;
   G1902:
    a = cdr(w8);
    w8 = a;
    if(a != nil) goto    G1894;
   G1904:
    CC_killtrace();
    q = w2;
    a = w1;
    a = CC_exactsqfrH(a, q);
    w4 = a;
    CC_recovtrace();
    a = CC_Wuntrace();
    if(a != nil) goto    G1906;
    a = car(car(w4));
    a = Lonep(a);
    if(a != nil) goto    G1906;
    Lterpri();
    a = LITERAL[78];
    Lprinc(a);
    w10 = nil;
    a = w4;
    goto    G1909;
   G1908:
    w11 = a;
    a = car(a);
    a = CC_convTlist2oset(a);
    q = w10;
    a = cons(a, q);
    w10 = a;
    a = cdr(w11);
   G1909:
    if(a != nil) goto    G1908;
    a = w10;
    a = Lnreverse(a);
    a = CC_convTlist2oset(a);
    q = nil;
    CC_fprinTset(a, q);
   G1906:
    a = car(w4);
    w9 = a;
    a = car(a);
    w7 = a;
    a = car(cdr(w9));
    w1 = a;
    if(!is_number(a)) goto    G1914;
    q = a;
    a = w3;
    a = times2(a, q);
    w3 = a;
    goto    G1923;
   G1914:
    a = CC_Wunivar(a);
    if(a == nil) goto    G1916;
    a = CC_Wmodulo();
    if(a == nil) goto    G1918;
    a = w1;
    a = CC_xctfactTBerl(a);
    goto    G1920;
   G1918:
    q = w2;
    a = w1;
    a = CC_xctfactTunipol(a, q);
    goto    G1920;
   G1916:
    q = w2;
    a = w1;
    a = CC_xctfactTmultipol(a, q);
   G1920:
    w6 = a;
   G1869:
    q = w7;
    a = car(w6);
    a = Llist2(a, q);
    m = LL_Worder;
    q = w5;
    CC_seTinsert(a, q, m);
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G1869;
   G1923:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1906;
   G1925:
    CC_recovargchk();
    q = w3;
    a = w5;
    {
        popv(11);
        car(a) = q;
 return a;
    }
}

Sex CC_exactcontH(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    CC_killtrace();
    a = w1;
    if(!is_number(a)) goto    G1933;
    a = mkfxat(1);
    goto    G1935;
   G1933:
    a = CC_Wunivar(a);
    if(a == nil) goto    G1934;
    a = w1;
    a = CC_Anumcont(a);
    goto    G1935;
   G1934:
    q = w2;
    a = w1;
    a = CC_xctcontTmultipol(a, q);
   G1935:
    w3 = a;
    CC_recovtrace();
    a = w3;
    popv(3);
    return a;
}

Sex CC_selectTmitem(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    if(a != nil) goto    G1967;
    a = w1;
    w4 = a;
    a = mkfxat(0);
    w7 = a;
   G1940:
    q = mkfxat(1);
    a = w4;
    car(a) = q;
    a = w7;
    a = Ladd1(a);
    w7 = a;
    q = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G1965;
    a = w1;
    goto    G1938;
   G1967:
    a = q;
    w6 = a;
   G1941:
    a = w1;
    w4 = a;
    a = mkfxat(0);
    w7 = a;
   G1942:
    a = car(w4);
    a = Lonep(a);
    if(a == nil) goto    G1950;
    a = w7;
    a = Ladd1(a);
    w7 = a;
   G1950:
    q = w6;
    a = w7;
    a = Llessp(a, q);
    if(a == nil) goto    G1952;
    a = cdr(w4);
    w4 = a;
    goto    G1942;
   G1952:
    a = cdr(w4);
    a = Llength(a);
    w8 = a;
    a = w6;
    a = Lminus(a);
    q = a;
    a = w2;
    a = plus2(a, q);
    q = a;
    a = w8;
    a = Lleq(a, q);
    if(a != nil) goto    G1944;
    a = w4;
    w5 = a;
   G1943:
    q = mkfxat(0);
    a = w5;
    car(a) = q;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G1943;
    q = mkfxat(-1);
    a = w6;
    a = plus2(a, q);
    w7 = a;
   G1965:
    a = cdr(w4);
    w4 = a;
    goto    G1940;
   G1944:
    q = mkfxat(-1);
    a = w6;
    a = plus2(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1964;
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G1941;
    a = w3;
    a = Lonep(a);
    if(a == nil) goto    G1941;
   G1964:
    a = nil;
   G1938:
    popv(8);
    return a;
}

Sex CC_oldselectTmitem(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w4 = nil;
    w5 = nil;
    w7 = nil;
    w1 = a;
    a = q;
    w6 = a;
    w2 = q;
    w3 = m;
    a = m;
    if(a == nil) goto    G1991;
    goto    G1980;
   G1985:
    a = w1;
    w4 = a;
    a = mkfxat(0);
    w7 = a;
   G1972:
    q = mkfxat(1);
    a = w4;
    car(a) = q;
    a = w7;
   G1973:
    a = Ladd1(a);
    w7 = a;
    q = w2;
    a = Lequal(a, q);
    if(a != nil) goto    G2004;
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G1970;
    goto    G1972;
   G1991:
    a = w1;
    w4 = a;
    a = mkfxat(0);
    w7 = a;
    a = w4;
   G1975:
    if(a != nil) goto    G1993;
    a = w7;
    a = Lzerop(a);
    if(a == nil) goto    G1970;
    goto    G1985;
   G1993:
    a = car(w4);
    a = Lonep(a);
    if(a == nil) goto    G1998;
    a = w7;
    a = Ladd1(a);
    w7 = a;
   G1998:
    q = w6;
    a = w7;
    a = Llessp(a, q);
    if(a == nil) goto    G2000;
    a = cdr(w4);
    w4 = a;
    goto    G1975;
   G2000:
    q = mkfxat(0);
    a = w4;
    car(a) = q;
    a = w6;
    a = Lsub1(a);
    w7 = a;
    a = w4;
    w5 = a;
   G1976:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G2002;
   G1977:
    q = mkfxat(0);
    a = w5;
    car(a) = q;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G1977;
    a = w6;
    a = Lsub1(a);
    w6 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1991;
    a = w1;
    w4 = a;
   G1979:
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G2011;
    q = mkfxat(0);
    a = w4;
    car(a) = q;
   G2011:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G1970;
    goto    G1979;
   G1980:
    q = w1;
    a = CHAR_OF(104);
    a = cons(a, q);
    w4 = a;
    w1 = a;
    w5 = nil;
   G1981:
    a = car(cdr(w4));
    a = Lzerop(a);
    if(a == nil) goto    G2015;
    a = cdr(w4);
    w4 = a;
    goto    G2017;
   G2015:
    q = cdr(cdr(w4));
    a = w4;
    cdr(a) = q;
    a = w5;
    if(a != nil) goto    G2017;
    a = w4;
    w5 = a;
   G2017:
    a = cdr(w4);
    if(a != nil) goto    G1981;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G1970;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G1970;
    q = mkfxat(1);
    car(a) = q;
    w4 = a;
    a = mkfxat(0);
    w7 = a;
    goto    G1973;
   G2002:
    q = mkfxat(1);
    car(a) = q;
    a = w7;
    a = Ladd1(a);
    w7 = a;
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G1976;
   G2004:
    a = w1;
   G1970:
    popv(7);
    return a;
}

Sex CC_multTmfactr(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w1 = a;
    a = mkfxat(0);
    w5 = a;
    w2 = q;
    w3 = m;
   G2027:
    a = car(w2);
    a = Lzerop(a);
    if(a != nil) goto    G2035;
    a = w5;
    a = Lzerop(a);
    if(a == nil) goto    G2032;
    a = car(w1);
    goto    G2033;
   G2032:
    q = w4;
    a = car(w1);
    a = CC_multH(a, q);
   G2033:
    w4 = a;
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w3;
    a = Lequal(a, q);
    if(a != nil) goto    G2037;
   G2035:
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    goto    G2027;
   G2037:
    a = w4;
    popv(5);
    return a;
}

Sex CC_multTcofactr(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
   G2041:
    a = car(w2);
    a = Lonep(a);
    if(a != nil) goto    G2042;
    a = w4;
    if(a != nil) goto    G2046;
    a = car(w1);
    goto    G2047;
   G2046:
    q = a;
    a = car(w1);
    a = CC_multH(a, q);
   G2047:
    w4 = a;
   G2042:
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G2041;
    a = w4;
    popv(4);
    return a;
}

Sex CC_delTmfactr(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
   G2053:
    a = car(w2);
    a = Lzerop(a);
    if(a == nil) goto    G2056;
    a = w1;
    goto    G2063;
   G2056:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G2052;
    a = cdr(w2);
    w2 = a;
    goto    G2053;
   G2054:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G2064;
    a = car(a);
    a = Lonep(a);
    if(a == nil) goto    G2061;
    q = cdr(cdr(w3));
    a = w3;
    cdr(a) = q;
    goto    G2054;
   G2061:
    a = cdr(w3);
   G2063:
    w3 = a;
    goto    G2054;
   G2064:
    a = w1;
   G2052:
    popv(3);
    return a;
}

Sex CC_xctfactTBerl(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 16;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Adeg(a);
    q = mkfxat(1);
    a = Lleq(a, q);
    if(a != nil) goto    G2204;
    a = w1;
    a = CC_Alcoef(a);
    a = Lonep(a);
    if(a != nil) goto    G2074;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = w1;
    a = CC_Alcoef(a);
    w3 = a;
    q = a;
    a = w1;
    a = CC_quotiH(a, q);
    w2 = a;
    a = CC_Alcoef(a);
    a = Lonep(a);
    if(a != nil) goto    G2078;
    q = mkfxat(1);
    a = car(cdr(cdr(w2)));
    cdr(a) = q;
   G2078:
    a = w2;
    a = CC_xctfactTBerl(a);
    w4 = a;
    a = cdr(a);
    if(a != nil) goto    G2081;
   G2204:
    a = w1;
    {
        popv(16);
        return  Lncons(a);
    }
   G2081:
    q = car(w4);
    a = w3;
    a = CC_multH(a, q);
    q = a;
    a = w4;
    {
        popv(16);
        car(a) = q;
 return a;
    }
   G2074:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    a = CC_Wuntrace();
    if(a != nil) goto    G2103;
    a = true;
    w15 = a;
    CC_killtrace();
   G2103:
    a = w15;
    if(a == nil) goto    G2105;
    Lterpri();
    a = LITERAL[79];
    Lprinc(a);
    Lterpri();
    a = CC_Wsttrace();
    if(a == nil) goto    G2105;
    a = LITERAL[80];
    Lprinc(a);
    a = w1;
    CC_msgTpoly(a);
   G2105:
    a = w1;
    a = CC_Alcoef(a);
    w14 = a;
    a = Lonep(a);
    if(a != nil) goto    G2109;
    q = w14;
    a = w1;
    a = CC_quotiH(a, q);
    w1 = a;
   G2109:
    a = CC_Atellmod();
    w2 = a;
    a = w1;
    a = CC_Adeg(a);
    w3 = a;
    a = w1;
    a = CC_Amvar(a);
    w4 = a;
    q = w2;
    a = CC_Amkpow(a, q);
    q = w1;
    a = CC_xctdivTunipol(a, q);
    a = cdr(a);
    w8 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w12 = a;
    w5 = a;
    a = mkfxat(1);
    w7 = a;
    w10 = a;
   G2088:
    q = w7;
    a = w8;
    a = CC_multTunipol(a, q);
    q = w1;
    a = CC_xctdivTunipol(a, q);
    a = cdr(a);
    w7 = a;
    if(!is_number(a)) goto    G2116;
    q = mkfxat(0);
    a = Lxcons(a, q);
    m = a;
    q = w4;
    a = CHAR_OF(104);
    a = Llist3(a, q, m);
    w7 = a;
   G2116:
    q = w3;
    a = CC_poly2coeflist(a, q);
    w6 = a;
    a = Lncons(a);
    q = a;
    a = w12;
    cdr(a) = q;
    a = cdr(a);
    w12 = a;
    a = w10;
    a = Lminus(a);
    q = mkfxat(-1);
    a = plus2(a, q);
    q = a;
    a = w3;
    a = plus2(a, q);
    q = a;
    a = w6;
    a = CC_ncdr(a, q);
    w13 = a;
    a = car(a);
    a = Lsub1(a);
    q = value(LL_Hmod);
    a = remaind2(a, q);
    q = a;
    a = w13;
    car(a) = q;
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G2088;
    a = cdr(w5);
    w6 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w12 = a;
    w5 = a;
   G2089:
    a = w6;
    a = CC_listcar(a);
    q = mkfxat(0);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w12;
    cdr(a) = q;
    a = cdr(a);
    w12 = a;
    a = cdr(car(w6));
    if(a == nil) goto    G2133;
    a = w6;
    CC_seTlistcdr(a);
    goto    G2089;
   G2133:
    a = w15;
    if(a == nil) goto    G2135;
    a = LITERAL[81];
    Lprinc(a);
    Lterpri();
    a = w5;
    w12 = a;
    w16 = nil;
   G2137:
    a = cdr(w12);
    w12 = a;
    if(a == nil) goto    G2135;
    a = LITERAL[82];
    Lprinc(a);
    a = car(w12);
    a = Lprint(a);
    w16 = a;
    goto    G2137;
   G2135:
    a = cdr(w5);
    w5 = a;
    a = mkfxat(1);
    w10 = a;
    a = w5;
    a = CC_topcopy(a);
    w7 = a;
   G2090:
    a = w5;
    w12 = a;
    a = w7;
    CC_seTlistcdr(a);
    a = w7;
    w13 = a;
   G2091:
    a = car(car(w12));
    a = Lzerop(a);
    if(a == nil) goto    G2145;
    a = car(w13);
    w6 = a;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2145;
    a = car(w6);
    a = Lminus(a);
    a = CC_recipTbnum(a);
    w14 = a;
    q = mkfxat(-1);
    goto    G2205;
   G2145:
    a = cdr(w13);
    w13 = a;
    a = cdr(w12);
    w12 = a;
    if(a != nil) goto    G2091;
    q = w9;
    a = w10;
    a = cons(a, q);
    w9 = a;
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G2090;
    a = w15;
    if(a == nil) goto    G2153;
    a = LITERAL[83];
    Lprinc(a);
    Lterpri();
    q = w5;
    a = CHAR_OF(104);
    a = cons(a, q);
    w12 = a;
    w16 = nil;
   G2155:
    a = cdr(w12);
    w12 = a;
    if(a == nil) goto    G2153;
    a = LITERAL[82];
    Lprinc(a);
    a = car(w12);
    a = Lprint(a);
    w16 = a;
    goto    G2155;
   G2092:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G2159;
    q = car(a);
    a = w14;
    a = CC_multTbnumbnum(a, q);
    w11 = a;
    q = a;
   G2205:
    a = w6;
    car(a) = q;
    goto    G2092;
   G2159:
    a = car(w13);
    w6 = a;
    a = w5;
    w12 = a;
    a = w7;
    w13 = a;
   G2093:
    a = car(w13);
    if(a != w6) goto    G2161;
    q = w10;
    a = car(w12);
    car(a) = q;
    goto    G2162;
   G2161:
    q = w6;
    CC_BerlTelimrow(a, q);
   G2162:
    a = cdr(w13);
    w13 = a;
    a = cdr(w12);
    w12 = a;
    if(a != nil) goto    G2093;
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G2090;
    a = w9;
    if(a != nil) goto    G2206;
    q = w1;
    a = CHAR_OF(104);
    a = Llist2(a, q);
    w7 = a;
    w8 = nil;
    goto    G2198;
   G2153:
    a = w9;
   G2206:
    a = Lreverse(a);
    w9 = a;
#define LL_Boset LITERAL[84]
    a = LL_Boset;
    a = Lncons(a);
    w12 = a;
    w6 = a;
    a = mkfxat(1);
    w10 = a;
    a = w5;
    a = CC_topcopy(a);
    w13 = a;
    CC_seTlistcdr(a);
   G2095:
    q = car(w9);
    a = w10;
    a = Llessp(a, q);
    if(a == nil) goto    G2171;
    a = w10;
    a = Ladd1(a);
    w10 = a;
    a = w13;
    CC_seTlistcdr(a);
    goto    G2095;
   G2171:
    q = mkfxat(1);
    a = w10;
    a = cons(a, q);
    q = a;
    a = w4;
    a = Llist2(a, q);
    w8 = a;
    m = w13;
    q = w5;
    a = CC_BerlTmkupol(a, q, m);
    w8 = a;
    q = car(w1);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w12;
    cdr(a) = q;
    a = cdr(a);
    w12 = a;
    a = cdr(w9);
    w9 = a;
    if(a != nil) goto    G2095;
    a = w15;
    if(a == nil) goto    G2179;
    a = LITERAL[85];
    Lprinc(a);
    q = nil;
    a = w6;
    CC_fprinTset(a, q);
   G2179:
    a = cdr(w6);
    w6 = a;
    a = Llength(a);
    a = Ladd1(a);
    w11 = a;
    a = w1;
    a = Lncons(a);
    w8 = a;
    a = mkfxat(0);
    w10 = a;
   G2097:
    a = w6;
    w12 = a;
   G2098:
    a = LL_Boset;
    a = Lncons(a);
    w7 = a;
   G2099:
    a = car(w8);
    w13 = a;
    m = CHAR_OF(90);
    q = car(w12);
    a = CC_xctgcdTunipol(a, q, m);
    w14 = a;
    a = cdr(w8);
    w8 = a;
    a = w14;
    m = LL_Worder;
    q = w7;
    if(!is_number(a)) goto    G2183;
    a = w13;
    goto    G2207;
   G2183:
    CC_seTinsert(a, q, m);
    a = w13;
    a = CC_Adeg(a);
    w16 = a;
    a = w14;
    a = CC_Adeg(a);
    q = a;
    a = w16;
    a = Lequal(a, q);
    if(a != nil) goto    G2184;
    q = w14;
    a = w13;
    a = CC_xctquoTunipol(a, q);
    w13 = a;
    m = LL_Worder;
    q = w7;
   G2207:
    CC_seTinsert(a, q, m);
   G2184:
    a = w8;
    a = Llength(a);
    w16 = a;
    a = cdr(w7);
    a = Llength(a);
    q = a;
    a = w16;
    a = plus2(a, q);
    q = w11;
    a = Lequal(a, q);
    if(a != nil) goto    G2198;
    a = w8;
    if(a != nil) goto    G2099;
    a = cdr(w7);
    w8 = a;
    a = cdr(w12);
    w12 = a;
    if(a != nil) goto    G2098;
    a = w6;
    CC_BerlTadd1ulis(a);
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G2097;
   G2198:
    a = w8;
    if(a == nil) goto    G2201;
    m = LL_Worder;
    q = w7;
    a = car(a);
    CC_seTinsert(a, q, m);
    a = cdr(w8);
    w8 = a;
    goto    G2198;
   G2201:
    a = w15;
    if(a == nil) goto    G2203;
    CC_recovtrace();
    a = LITERAL[86];
    Lprinc(a);
    Lterpri();
    Lterpri();
   G2203:
    a = cdr(w7);
    popv(16);
    return a;
}

Sex CC_BerlTelimrow(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lzerop(a);
    if(a == nil) goto    G2211;
    a = nil;
    goto    G2212;
   G2211:
    w3 = nil;
    w4 = nil;
    a = car(w1);
    w3 = a;
   G2214:
    q = car(w2);
    a = w3;
    a = times2(a, q);
    q = car(w1);
    a = CC_addTbnumbnum(a, q);
    w4 = a;
    q = a;
    a = w1;
    car(a) = q;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    a = w1;
    if(a != nil) goto    G2214;
   G2212:
    popv(4);
    return a;
}

Sex CC_BerlTmkupol(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = q;
    w4 = a;
    w2 = q;
    w3 = m;
   G2221:
    a = car(car(w4));
    a = Lzerop(a);
    if(a != nil) goto    G2222;
    a = car(car(w3));
    a = Lzerop(a);
    if(a != nil) goto    G2222;
    q = car(car(w3));
    a = car(car(w4));
    a = cons(a, q);
    m = LL_Worder;
    q = w1;
    CC_seTinsert(a, q, m);
   G2222:
    a = cdr(w4);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    a = w4;
    if(a != nil) goto    G2221;
    a = w1;
    popv(5);
    return a;
}

Sex CC_BerlTgetcoef(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2248;
    w4 = nil;
    w5 = nil;
    q = w2;
    a = w1;
    a = CC_ncdr(a, q);
    a = car(a);
    w4 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2237;
   G2248:
    a = nil;
    goto    G2233;
   G2237:
    a = mkfxat(1);
    w5 = a;
   G2235:
    q = w5;
    a = w1;
    a = CC_ncdr(a, q);
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2241;
    q = w4;
    a = w5;
    {
        popv(5);
        return  cons(a, q);
    }
   G2241:
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G2235;
   G2233:
    popv(5);
    return a;
}

Sex CC_BerlTadd1ulis(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w2 = nil;
    w3 = nil;
    w1 = a;
   G2252:
    a = car(w1);
    a = CC_tail(a);
    w2 = a;
    a = car(car(a));
    a = Lzerop(a);
    q = mkfxat(1);
    if(a != nil) goto    G2254;
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    a = cdr(a);
    goto    G2261;
   G2254:
    a = cdr(car(w2));
    a = CC_addTbnumbnum(a, q);
    w3 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2258;
    a = car(w1);
    a = CC_tail2(a);
    q = nil;
    cdr(a) = q;
    goto    G2261;
   G2258:
    q = w3;
    a = mkfxat(0);
    a = cons(a, q);
    q = a;
    a = w2;
    car(a) = q;
   G2261:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2252;
    popv(3);
    return a;
}

Sex CC_xctfactTBerl2(Sex a)
{
    Sex q, m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CC_Adeg(a);
    q = mkfxat(1);
    a = Lleq(a, q);
    if(a != nil) goto    G2360;
    a = w1;
    a = CC_Alcoef(a);
    a = Lonep(a);
    if(a != nil) goto    G2270;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    a = w1;
    a = CC_Alcoef(a);
    w3 = a;
    q = a;
    a = w1;
    a = CC_quotiH(a, q);
    w2 = a;
    a = CC_Alcoef(a);
    a = Lonep(a);
    if(a != nil) goto    G2274;
    q = mkfxat(1);
    a = car(cdr(cdr(w2)));
    cdr(a) = q;
   G2274:
    a = w2;
    a = CC_xctfactTBerl(a);
    w4 = a;
    a = cdr(a);
    if(a == nil) goto    G2360;
    q = car(w4);
    a = w3;
    a = CC_multH(a, q);
    q = a;
    a = w4;
    {
        popv(15);
        car(a) = q;
 return a;
    }
   G2270:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    a = w1;
    a = CC_Alcoef(a);
    w14 = a;
    a = Lonep(a);
    if(a != nil) goto    G2301;
    q = w14;
    a = w1;
    a = CC_quotiH(a, q);
    w1 = a;
   G2301:
    a = CC_Atellmod();
    w3 = a;
    a = w1;
    a = CC_Adeg(a);
    w4 = a;
    a = w1;
    a = CC_Amvar(a);
    w5 = a;
    a = w4;
    a = Lmkvect(a);
    w2 = a;
    a = mkfxat(0);
    w10 = a;
   G2283:
    a = w10;
    a = Ladd1(a);
    w10 = a;
    w15 = a;
    a = w4;
    a = Lmkvect(a);
    m = a;
    q = w15;
    a = w2;
    Lputv(a, q, m);
    q = w4;
    a = w10;
    a = Llessp(a, q);
    if(a != nil) goto    G2283;
    q = w3;
    a = w5;
    a = CC_Amkpow(a, q);
    q = w1;
    a = CC_xctdivTunipol(a, q);
    a = cdr(a);
    w8 = a;
    a = mkfxat(1);
    w7 = a;
    w10 = a;
    goto    G2285;
   G2284:
    q = w7;
    a = w8;
    a = CC_multTunipol(a, q);
    q = w1;
    a = CC_xctdivTunipol(a, q);
    a = cdr(a);
    w7 = a;
   G2285:
    if(!is_number(a)) goto    G2312;
    q = mkfxat(0);
    a = Lxcons(a, q);
    a = Lncons(a);
    goto    G2314;
   G2312:
    a = cdr(cdr(a));
   G2314:
    w12 = a;
    a = CC_tail(a);
    w13 = a;
    a = car(a);
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G2316;
    q = mkfxat(0);
    a = mkfxat(0);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w13;
    cdr(a) = q;
    a = cdr(a);
   G2316:
    a = w4;
    w9 = a;
   G2286:
    a = w9;
    a = Lsub1(a);
    w9 = a;
    q = a;
    a = w4;
    a = diff2(a, q);
    q = a;
    a = w2;
    a = Lgetv(a, q);
    w13 = a;
    q = car(car(w12));
    a = w9;
    a = Lequal(a, q);
    if(a != nil) goto    G2325;
    m = mkfxat(0);
    q = w10;
    a = w13;
    Lputv(a, q, m);
    goto    G2326;
   G2325:
    m = cdr(car(w12));
    q = w10;
    a = w13;
    Lputv(a, q, m);
    a = cdr(w12);
    w12 = a;
   G2326:
    a = w12;
    if(a != nil) goto    G2286;
    a = w10;
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w4;
    a = plus2(a, q);
    q = a;
    a = w2;
    a = Lgetv(a, q);
    w13 = a;
    q = w10;
    a = Lgetv(a, q);
    a = Lsub1(a);
    q = value(LL_Hmod);
    a = remaind2(a, q);
    m = a;
    q = w10;
    a = w13;
    Lputv(a, q, m);
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G2284;
    a = mkfxat(2);
    w10 = a;
   G2287:
    a = mkfxat(1);
    w9 = a;
   G2288:
    q = w9;
    a = w2;
    a = Lgetv(a, q);
    w13 = a;
    q = mkfxat(0);
    a = Lgetv(a, q);
    a = Lonep(a);
    if(a != nil) goto    G2344;
    q = w10;
    a = w13;
    a = Lgetv(a, q);
    w14 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2344;
    q = mkfxat(-1);
    a = w14;
    a = Lequal(a, q);
    if(a == nil) goto    G2343;
    a = mkfxat(1);
    w9 = a;
    goto    G2290;
   G2344:
    a = w9;
    a = Ladd1(a);
    w9 = a;
    q = w4;
    a = Lleq(a, q);
    if(a == nil) goto    G2291;
    goto    G2288;
   G2343:
    a = w14;
    a = Lminus(a);
    a = CC_recipTbnum(a);
    w14 = a;
    m = mkfxat(-1);
    q = w10;
    a = w13;
    Lputv(a, q, m);
    a = w10;
    w9 = a;
   G2289:
    a = w9;
    a = Ladd1(a);
    w9 = a;
    q = w4;
    a = Lleq(a, q);
    if(a == nil) goto    G2350;
    q = w9;
    a = w13;
    a = Lgetv(a, q);
    q = a;
    a = w14;
    a = CC_multTbnumbnum(a, q);
    w11 = a;
    m = a;
    q = w9;
    a = w13;
    Lputv(a, q, m);
    goto    G2289;
   G2350:
    a = mkfxat(1);
    w9 = a;
   G2290:
    q = w9;
    a = w2;
    a = Lgetv(a, q);
    w12 = a;
    if(a != w13) goto    G2354;
    m = mkfxat(1);
    q = mkfxat(0);
    a = w13;
    Lputv(a, q, m);
    goto    G2355;
   G2354:
    arg4 = w4;
    m = w10;
    q = w13;
    CC_Berl2Telimrow(a, q, m, arg4);
   G2355:
    a = w9;
    a = Ladd1(a);
    w9 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G2290;
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G2287;
   G2360:
    a = w1;
    {
        popv(15);
        return  Lncons(a);
    }
   G2291:
    a = LL_Boset;
    a = Lncons(a);
    w12 = a;
    w6 = a;
    a = w10;
    w11 = a;
   G2292:
    q = mkfxat(-1);
    a = w10;
    a = plus2(a, q);
    q = mkfxat(1);
    a = cons(a, q);
    q = a;
    a = w5;
    a = Llist2(a, q);
    w8 = a;
    a = mkfxat(1);
    w9 = a;
   G2293:
    q = w9;
    a = w2;
    a = Lgetv(a, q);
    m = w11;
    q = w10;
    a = CC_Berl2Tgetcoef(a, q, m);
    w14 = a;
    if(a == nil) goto    G2367;
    m = LL_Worder;
    q = w8;
    CC_seTinsert(a, q, m);
   G2367:
    a = w9;
    a = Ladd1(a);
    w9 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G2293;
    q = w8;
    a = car(w1);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w12;
    cdr(a) = q;
    a = cdr(a);
    w12 = a;
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G2292;
    a = cdr(w6);
    w6 = a;
    a = Llength(a);
    a = Ladd1(a);
    w11 = a;
    a = w1;
    a = Lncons(a);
    w8 = a;
    a = mkfxat(0);
    w10 = a;
   G2295:
    a = w6;
    w12 = a;
   G2296:
    a = LL_Boset;
    a = Lncons(a);
    w7 = a;
   G2297:
    a = car(w8);
    w13 = a;
    m = CHAR_OF(90);
    q = car(w12);
    a = CC_xctgcdTunipol(a, q, m);
    w14 = a;
    a = cdr(w8);
    w8 = a;
    a = w14;
    m = LL_Worder;
    q = w7;
    if(!is_number(a)) goto    G2380;
    a = w13;
    goto    G2401;
   G2380:
    CC_seTinsert(a, q, m);
    a = w13;
    a = CC_Adeg(a);
    w15 = a;
    a = w14;
    a = CC_Adeg(a);
    q = a;
    a = w15;
    a = Lequal(a, q);
    if(a != nil) goto    G2381;
    q = w14;
    a = w13;
    a = CC_xctquoTunipol(a, q);
    w13 = a;
    m = LL_Worder;
    q = w7;
   G2401:
    CC_seTinsert(a, q, m);
   G2381:
    a = w8;
    a = Llength(a);
    w15 = a;
    a = cdr(w7);
    a = Llength(a);
    q = a;
    a = w15;
    a = plus2(a, q);
    q = w11;
    a = Lequal(a, q);
    if(a != nil) goto    G2395;
    a = w8;
    if(a != nil) goto    G2297;
    a = cdr(w7);
    w8 = a;
    a = cdr(w12);
    w12 = a;
    if(a != nil) goto    G2296;
    a = w6;
    CC_BerlTadd1ulis(a);
    a = w10;
    a = Ladd1(a);
    w10 = a;
    q = w4;
    a = Llessp(a, q);
    if(a != nil) goto    G2295;
   G2395:
    a = w8;
    if(a == nil) goto    G2402;
    m = LL_Worder;
    q = w7;
    a = car(a);
    CC_seTinsert(a, q, m);
    a = cdr(w8);
    w8 = a;
    goto    G2395;
   G2402:
    a = cdr(w7);
    popv(15);
    return a;
}

Sex CC_Berl2Telimrow(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = m;
    a = Lgetv(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2408;
    a = nil;
    goto    G2405;
   G2408:
    a = w3;
    w6 = a;
   G2406:
    q = w6;
    a = w2;
    a = Lgetv(a, q);
    q = a;
    a = w5;
    a = times2(a, q);
    w8 = a;
    q = w6;
    a = w1;
    a = Lgetv(a, q);
    q = a;
    a = w8;
    a = CC_addTbnumbnum(a, q);
    w7 = a;
    m = a;
    q = w6;
    a = w1;
    Lputv(a, q, m);
    a = w6;
    a = Ladd1(a);
    w6 = a;
    q = w4;
    a = Lleq(a, q);
    if(a != nil) goto    G2406;
   G2405:
    popv(8);
    return a;
}

Sex CC_Berl2Tgetcoef(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = mkfxat(0);
    a = Lgetv(a, q);
    if(a == nil) goto    G2420;
    w4 = nil;
    w5 = nil;
    q = w2;
    a = w1;
    a = Lgetv(a, q);
    w4 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2424;
    a = nil;
    goto    G2420;
   G2424:
    a = mkfxat(2);
    w5 = a;
   G2422:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G2427;
    q = mkfxat(-1);
    a = w5;
    a = plus2(a, q);
    q = w4;
    {
        popv(5);
        return  cons(a, q);
    }
   G2427:
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G2422;
   G2420:
    popv(5);
    return a;
}

Sex CC_xctfactTunipol(Sex a, Sex q)
{
    Sex m, arg4, arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 21;
    w21 = nil;
    w20 = nil;
    w19 = nil;
    w18 = nil;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Adeg(a);
    q = mkfxat(1);
    a = Lleq(a, q);
    if(a != nil) goto    G2550;
    a = w1;
    a = CC_Alcoef(a);
    a = Lminusp(a);
    if(a == nil) goto    G2441;
    w3 = nil;
    w4 = nil;
    a = w1;
    a = CC_negH(a);
    w3 = a;
    q = w2;
    a = CC_xctfactTunipol(a, q);
    w4 = a;
    a = cdr(a);
    if(a != nil) goto    G2445;
   G2550:
    a = w1;
    {
        popv(21);
        return  Lncons(a);
    }
   G2445:
    a = car(w4);
    a = CC_negH(a);
    q = a;
    a = w4;
    {
        popv(21);
        car(a) = q;
 return a;
    }
   G2441:
    a = w1;
    a = CC_Alastterm(a);
    value(LL_Htemporal) = a;
    if(!is_cons(a)) goto    G2449;
    a = CC_Amvar(a);
    w3 = a;
    a = w1;
    a = CC_Amvar(a);
    q = a;
    a = w3;
    a = Lequal(a, q);
    if(a == nil) goto    G2449;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = value(LL_Htemporal);
    w5 = a;
    a = CC_Alcoef(a);
    q = a;
    a = w5;
    a = CC_quotiH(a, q);
    w5 = a;
    q = a;
    a = w1;
    a = CC_quotiH(a, q);
    w3 = a;
    q = w2;
    a = CC_xctfactTunipol(a, q);
    w4 = a;
    q = CHAR_OF(104);
    a = Lxcons(a, q);
    w4 = a;
    m = LL_Worder;
    q = a;
    a = w5;
    CC_seTinsert(a, q, m);
    a = cdr(w4);
    goto    G2455;
   G2449:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w19 = nil;
    w20 = nil;
    a = true;
    w17 = a;
    a = CC_Wuntrace();
    if(a != nil) goto    G2469;
    a = true;
    w20 = a;
    CC_killtrace();
   G2469:
    a = w20;
    if(a == nil) goto    G2471;
    Lterpri();
    a = LITERAL[87];
    Lprinc(a);
    Lterpri();
    a = CC_Wsttrace();
    if(a == nil) goto    G2471;
    a = LITERAL[80];
    Lprinc(a);
    a = w1;
    CC_msgTpoly(a);
   G2471:
    CC_savemod();
    q = mkfxat(4);
#define LL_Hprimes LITERAL[88]
    a = value(LL_Hprimes);
    a = CC_ncdr(a, q);
    w3 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w8 = a;
    a = w1;
    a = CC_Alcoef(a);
    w11 = a;
    q = w1;
    a = CC_multH(a, q);
    w10 = a;
   G2458:
    a = car(w3);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    q = w4;
    a = w11;
    a = remaind2(a, q);
    a = Lzerop(a);
    if(a != nil) goto    G2458;
    a = w4;
    CC_setmod(a);
    a = w11;
    a = Lonep(a);
    if(a == nil) goto    G2478;
    a = w1;
    goto    G2479;
   G2478:
    q = w11;
    a = w1;
    a = CC_quotiH(a, q);
   G2479:
    w9 = a;
    q = mkfxat(1);
    a = CC_dfTunipol(a, q);
    m = w2;
    q = a;
    a = w9;
    a = CC_xctgcdTunipol(a, q, m);
    w12 = a;
    if(!is_number(a)) goto    G2458;
    a = w20;
    if(a == nil) goto    G2484;
    a = LITERAL[89];
    Lprinc(a);
    a = w4;
    Lprint(a);
   G2484:
    a = w9;
    a = CC_xctfactTBerl(a);
    w6 = a;
    a = w20;
    if(a == nil) goto    G2486;
    a = LITERAL[90];
    Lprinc(a);
    q = w6;
    a = LL_Boset;
    a = cons(a, q);
    q = nil;
    CC_fprinTset(a, q);
   G2486:
    a = w6;
    a = Llength(a);
    w13 = a;
    a = Lonep(a);
    if(a == nil) goto    G2489;
    q = w1;
    a = CHAR_OF(104);
    a = Llist2(a, q);
    w8 = a;
    goto    G2467;
   G2489:
    a = w6;
    a = CC_interpolTlagpoly(a);
    w7 = a;
    a = w20;
    if(a == nil) goto    G2491;
    a = LITERAL[91];
    Lprinc(a);
    q = w7;
    a = LL_Boset;
    a = cons(a, q);
    q = nil;
    CC_fprinTset(a, q);
   G2491:
    a = mkfxat(1);
    w14 = a;
    a = w1;
    a = CC_Ammc(a);
    q = a;
    a = w11;
    a = times2(a, q);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    q = a;
    a = w4;
    a = CC_calTmodpow(a, q);
    w15 = a;
    q = a;
    a = w14;
    a = Lequal(a, q);
    if(a == nil) goto    G2497;
    a = w14;
    a = Ladd1(a);
    w15 = a;
   G2497:
    arg6 = w15;
    arg5 = w14;
    arg4 = w4;
    m = w7;
    q = w6;
    a = w1;
    a = CC_parHenselTunipol(a, q, m, arg4, arg5, arg6);
    w6 = a;
    a = w20;
    if(a == nil) goto    G2499;
    a = LITERAL[92];
    Lprinc(a);
    q = w6;
    a = LL_Boset;
    a = cons(a, q);
    q = nil;
    CC_fprinTset(a, q);
   G2499:
    a = w6;
    a = Llength(a);
    a = CC_listzero(a);
    w5 = a;
    a = mkfxat(1);
    w12 = a;
    m = nil;
    q = a;
    a = w5;
    goto    G2551;
   G2462:
    m = w17;
    q = w12;
    a = w5;
    a = CC_selectTmitem(a, q, m);
    w5 = a;
    if(a == nil) goto    G2528;
   G2503:
    m = w12;
    q = w5;
    a = w6;
    a = CC_multTmfactr(a, q, m);
    w16 = a;
    a = w11;
    a = Lonep(a);
    if(a != nil) goto    G2505;
    q = w16;
    a = w11;
    a = CC_multH(a, q);
    w16 = a;
   G2505:
    a = CC_Atellmod();
    q = a;
    a = w16;
    a = CC_Amodulo2(a, q);
    w16 = a;
    q = a;
    a = w10;
    a = CC_trydivTunipolZ(a, q);
    value(LL_Hbyproduct) = a;
    if(a == nil) goto    G2462;
    w1 = a;
    a = w16;
    a = CC_Anumcont(a);
    q = a;
    a = w16;
    a = CC_trydivTunipolZ(a, q);
    w16 = a;
    a = w1;
    a = CC_Anumcont(a);
    q = a;
    a = w1;
    a = CC_trydivTunipolZ(a, q);
    w1 = a;
    a = CC_Alcoef(a);
    w11 = a;
    q = a;
    a = w1;
    a = CC_Hanyany(a, q);
    w10 = a;
    m = LL_Worder;
    q = w8;
    a = w16;
    CC_seTinsert(a, q, m);
    a = w20;
    if(a == nil) goto    G2513;
    a = LITERAL[93];
    Lprinc(a);
    a = w16;
    CC_msgTpoly(a);
   G2513:
    a = w5;
    a = Llength(a);
    q = a;
    a = w12;
    a = Lequal(a, q);
    if(a != nil) goto    G2467;
    q = w5;
    a = w6;
    a = CC_delTmfactr(a, q);
    w6 = a;
    q = w5;
    a = w7;
    a = CC_delTmfactr(a, q);
    w7 = a;
    a = w5;
    a = Lcopy(a);
    w19 = a;
    q = a;
    a = w5;
    a = CC_delTmfactr(a, q);
    w18 = a;
    w5 = a;
    w21 = nil;
   G2519:
    a = car(w19);
    a = Lzerop(a);
    if(a == nil) goto    G2518;
    a = cdr(w18);
    w18 = a;
    a = cdr(w19);
    w19 = a;
    w21 = a;
    goto    G2519;
   G2518:
    a = w18;
    a = Llength(a);
    q = w12;
    a = Llessp(a, q);
    if(a != nil) goto    G2528;
    a = w5;
    a = Llength(a);
    q = mkfxat(2);
    a = quot2(a, q);
    q = a;
    a = w12;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2547;
    m = nil;
    q = w12;
    a = w18;
    CC_selectTmitem(a, q, m);
    goto    G2503;
   G2528:
    a = w12;
    a = Ladd1(a);
    w12 = a;
    a = w6;
    a = Llength(a);
    q = mkfxat(2);
    a = quot2(a, q);
    q = a;
    a = w12;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2547;
    q = w12;
    a = mkfxat(2);
    a = times2(a, q);
    w21 = a;
    a = w7;
    a = Llength(a);
    q = a;
    a = w21;
    a = Lequal(a, q);
    if(a == nil) goto    G2534;
    a = mkfxat(1);
    w17 = a;
   G2534:
    a = w6;
    a = Llength(a);
    a = CC_listzero(a);
    w5 = a;
    m = nil;
    q = w12;
   G2551:
    a = CC_selectTmitem(a, q, m);
    w5 = a;
    goto    G2503;
    a = w14;
    a = Lonep(a);
    if(a == nil) goto    G2547;
    a = w15;
    w14 = a;
    a = w1;
    a = CC_Adeg(a);
    q = mkfxat(2);
    a = quot2(a, q);
    q = a;
    a = mkfxat(2);
    a = Lexpt(a, q);
    w15 = a;
    a = w1;
    a = CC_Asqnorm(a);
    q = w15;
    a = times2(a, q);
    q = a;
    a = w11;
    a = times2(a, q);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    q = a;
    a = w4;
    a = CC_calTmodpow(a, q);
    w15 = a;
    q = w14;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2497;
   G2547:
    m = LL_Worder;
    q = w8;
    a = w1;
    CC_seTinsert(a, q, m);
   G2467:
    CC_recovmod();
    a = w20;
    if(a == nil) goto    G2549;
    CC_recovtrace();
    a = LITERAL[94];
    Lprinc(a);
    Lterpri();
    Lterpri();
   G2549:
    a = cdr(w8);
   G2455:
    popv(21);
    return a;
}

Sex CC_parHenselTunipol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 16;
    w13 = nil;
    w11 = nil;
    w9 = nil;
    w7 = nil;
    w8 = nil;
    w10 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w1 = a;
    a = arg5;
    w12 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    q = a;
    a = arg4;
    a = Lexpt(a, q);
    w7 = a;
    a = w2;
    a = CC_topcopy(a);
    w11 = a;
   G2555:
    a = w12;
    a = Ladd1(a);
    w12 = a;
    q = w7;
    a = w4;
    a = times2(a, q);
    w7 = a;
    CC_setmod(a);
    a = car(w2);
    w9 = a;
    a = w2;
    w13 = a;
   G2556:
    a = cdr(w13);
    w13 = a;
    if(a == nil) goto    G2562;
    q = w9;
    a = car(a);
    a = CC_multTunipol(a, q);
    w9 = a;
    goto    G2556;
   G2562:
    a = w1;
    a = CC_Alcoef(a);
    w16 = a;
    a = Lonep(a);
    if(a == nil) goto    G2564;
    a = w1;
    goto    G2566;
   G2564:
    a = w16;
    a = CC_recipH(a);
    q = w1;
    a = CC_multH(a, q);
   G2566:
    w8 = a;
    a = w9;
    a = CC_negTunipol(a);
    q = a;
    a = w8;
    a = CC_addTunipol(a, q);
    w10 = a;
    a = w2;
    w13 = a;
    a = w11;
    w14 = a;
    a = w3;
    w15 = a;
   G2557:
    q = w10;
    a = car(w15);
    a = CC_multTunipol(a, q);
    q = car(w14);
    a = CC_xctdivTunipol(a, q);
    w16 = a;
    q = cdr(a);
    a = car(w13);
    a = CC_addTunipol(a, q);
    q = a;
    a = w13;
    car(a) = q;
    a = cdr(w13);
    w13 = a;
    a = cdr(w14);
    w14 = a;
    a = cdr(w15);
    w15 = a;
    a = w13;
    if(a != nil) goto    G2557;
    q = w6;
    a = w12;
    a = Llessp(a, q);
    if(a != nil) goto    G2555;
    a = w2;
    popv(16);
    return a;
}

Sex CC_calTmodpow(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = q;
    a = Labs(a);
    w2 = a;
    a = mkfxat(1);
    w3 = a;
    a = w1;
    w4 = a;
   G2578:
    q = w2;
    a = w4;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2581;
    a = w3;
    a = Ladd1(a);
    w3 = a;
    q = w4;
    a = w1;
    a = times2(a, q);
    w4 = a;
    goto    G2578;
   G2581:
    a = w3;
    popv(4);
    return a;
}

Sex CC_xctfactTmultipol(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w19 = nil;
    w18 = nil;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_Adeg(a);
    q = mkfxat(1);
    a = Lleq(a, q);
    if(a == nil) goto    G2585;
    a = w1;
    {
        popv(20);
        return  Lncons(a);
    }
   G2585:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w19 = nil;
    a = CC_Wuntrace();
    if(a != nil) goto    G2602;
    a = true;
    w19 = a;
    CC_killtrace();
   G2602:
    a = w19;
    if(a == nil) goto    G2604;
    Lterpri();
    a = LITERAL[95];
    Lprinc(a);
    Lterpri();
    a = CC_Wsttrace();
    if(a == nil) goto    G2604;
    a = LITERAL[80];
    Lprinc(a);
    a = w1;
    CC_msgTpoly(a);
   G2604:
    a = CHAR_OF(104);
    a = Lncons(a);
    w4 = a;
    a = w1;
    a = CC_varlistH(a);
    a = cdr(a);
    w3 = a;
    a = w1;
    a = CC_Alcoef(a);
    w5 = a;
   G2590:
    m = nil;
    q = w5;
    a = w3;
    a = CC_setmodTideal(a, q, m);
    w3 = a;
    q = a;
    a = w1;
    a = CC_multisubstTbnum(a, q);
    w7 = a;
    q = mkfxat(1);
    a = CC_dfTunipol(a, q);
    m = w2;
    q = a;
    a = w7;
    a = CC_xctgcdTunipol(a, q, m);
    w17 = a;
    if(!is_number(a)) goto    G2590;
    a = w19;
    if(a == nil) goto    G2612;
    Lterpri();
    a = LITERAL[96];
    Lprinc(a);
    a = w3;
    Lprint(a);
    a = LITERAL[97];
    Lprinc(a);
    a = w7;
    CC_msgTpoly(a);
   G2612:
    q = w2;
    a = w7;
    a = CC_xctfactTunipol(a, q);
    w11 = a;
    a = Llength(a);
    w13 = a;
    a = Lonep(a);
    if(a == nil) goto    G2614;
    q = w1;
    a = CHAR_OF(104);
    a = Llist2(a, q);
    w4 = a;
    goto    G2600;
   G2614:
    a = w11;
    a = CC_monicizeTfactrs(a);
    w11 = a;
    a = w19;
    if(a == nil) goto    G2616;
    a = LITERAL[98];
    Lprinc(a);
    q = w11;
    a = LL_Boset;
    a = cons(a, q);
    q = nil;
    CC_fprinTset(a, q);
   G2616:
    a = w11;
    a = CC_interpolTlagpoly(a);
    w6 = a;
    a = w19;
    if(a == nil) goto    G2619;
    a = LITERAL[91];
    Lprinc(a);
    q = w6;
    a = LL_Boset;
    a = cons(a, q);
    q = nil;
    CC_fprinTset(a, q);
   G2619:
    m = nil;
    q = w3;
    a = w1;
    a = CC_multishiftTorgn(a, q, m);
    w7 = a;
    a = CC_Alcoef(a);
    w5 = a;
    a = CC_Amkvar();
    w8 = a;
    a = Lncons(a);
    CC_Aorder(a);
    q = w8;
    a = w7;
    a = CC_Aputtdeg1(a, q);
    w9 = a;
    q = w8;
    a = w5;
    a = CC_Aputtdeg(a, q);
    w10 = a;
    q = w7;
    a = w5;
    a = CC_multH(a, q);
    w7 = a;
    a = w9;
    a = CC_Adeg(a);
    w20 = a;
    a = w10;
    a = CC_Adeg(a);
    q = a;
    a = w20;
    a = plus2(a, q);
    q = mkfxat(2);
    a = quot2(a, q);
    w12 = a;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2626;
    q = w12;
    a = w8;
    CC_setpowser(a, q);
   G2626:
    a = w5;
    a = Lonep(a);
    if(a != nil) goto    G2628;
    q = w10;
    a = w9;
    a = CC_quotiH(a, q);
    w9 = a;
   G2628:
    arg5 = w12;
    arg4 = w8;
    m = w6;
    q = w11;
    a = w9;
    a = CC_parHenselTmultipol(a, q, m, arg4, arg5);
    w11 = a;
    a = w19;
    if(a == nil) goto    G2630;
    a = LITERAL[99];
    Lprinc(a);
    m = mkfxat(1);
    q = w8;
    a = w11;
    a = CC_substbnumTfactrs(a, q, m);
    w18 = a;
    q = LL_Boset;
    a = Lxcons(a, q);
    q = nil;
    CC_fprinTset(a, q);
   G2630:
    a = w11;
    a = Llength(a);
    a = CC_listzero(a);
    w14 = a;
    a = mkfxat(1);
    w15 = a;
   G2595:
    m = nil;
    q = w15;
    a = w14;
    a = CC_oldselectTmitem(a, q, m);
    w14 = a;
    if(a == nil) goto    G2666;
   G2634:
    m = w15;
    q = w14;
    a = w11;
    a = CC_multTmfactr(a, q, m);
    w16 = a;
    a = w10;
    a = Lonep(a);
    if(a != nil) goto    G2636;
    q = w16;
    a = w10;
    a = CC_multH(a, q);
    w16 = a;
   G2636:
    a = w16;
    a = CC_WoverQ(a);
    if(a != nil) goto    G2595;
    m = mkfxat(1);
    q = w8;
    a = w16;
    a = CC_substH(a, q, m);
    w16 = a;
    q = w7;
    a = CC_WdivoverZpQA(a, q);
    w18 = a;
    if(a != nil) goto    G2641;
    m = w15;
    q = w14;
    a = w11;
    a = CC_multTcofactr(a, q, m);
    w18 = a;
    a = w10;
    a = Lonep(a);
    if(a != nil) goto    G2643;
    q = w18;
    a = w10;
    a = CC_multH(a, q);
    w18 = a;
   G2643:
    m = mkfxat(1);
    q = w8;
    a = w18;
    a = CC_substH(a, q, m);
    w18 = a;
    q = w7;
    a = CC_WdivoverZpQA(a, q);
    w16 = a;
    if(a == nil) goto    G2595;
   G2641:
    a = w18;
    w7 = a;
    q = w2;
    a = w16;
    a = CC_exactcontH(a, q);
    w17 = a;
    q = a;
    a = w16;
    a = CC_Vanyany(a, q);
    w16 = a;
    q = w7;
    a = w17;
    a = CC_Hanyany(a, q);
    w20 = a;
    a = w16;
    a = CC_Alcoef(a);
    q = a;
    a = w20;
    a = CC_Vanyany(a, q);
    w7 = a;
    a = w16;
    a = CC_Alcoef(a);
    q = a;
    a = w5;
    a = CC_Vanyany(a, q);
    w5 = a;
    q = a;
    a = w7;
    a = CC_Vanyany(a, q);
    w9 = a;
    m = true;
    q = w3;
    a = w16;
    a = CC_multishiftTorgn(a, q, m);
    w16 = a;
    m = LL_Worder;
    q = w4;
    CC_seTinsert(a, q, m);
    a = w19;
    if(a == nil) goto    G2651;
    a = LITERAL[93];
    Lprinc(a);
    a = w16;
    CC_msgTpoly(a);
   G2651:
    a = w14;
    a = Llength(a);
    q = a;
    a = w15;
    a = Lequal(a, q);
    if(a != nil) goto    G2599;
    a = w4;
    a = Llength(a);
    q = a;
    a = w13;
    a = Lequal(a, q);
    if(a != nil) goto    G2669;
    q = w8;
    a = w9;
    a = CC_Aputtdeg1(a, q);
    w9 = a;
    q = w8;
    a = w5;
    a = CC_Aputtdeg(a, q);
    w10 = a;
    a = w9;
    a = CC_Adeg(a);
    w20 = a;
    a = w10;
    a = CC_Adeg(a);
    q = a;
    a = w20;
    a = plus2(a, q);
    q = mkfxat(2);
    a = quot2(a, q);
    w12 = a;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2662;
    q = w12;
    a = w8;
    CC_setpowser(a, q);
   G2662:
    a = w5;
    a = Lonep(a);
    if(a != nil) goto    G2664;
    q = w10;
    a = w9;
    a = CC_quotiH(a, q);
    w9 = a;
   G2664:
    q = w14;
    a = w11;
    a = CC_delTmfactr(a, q);
    w11 = a;
    q = w14;
    a = w6;
    a = CC_delTmfactr(a, q);
    w6 = a;
    m = true;
    q = w15;
    a = w14;
    a = CC_oldselectTmitem(a, q, m);
    w14 = a;
    if(a != nil) goto    G2634;
   G2666:
    a = w15;
    a = Ladd1(a);
    w15 = a;
    a = w11;
    a = Llength(a);
    a = CC_listzero(a);
    w14 = a;
    q = mkfxat(2);
    a = w13;
    a = quot2(a, q);
    q = a;
    a = w15;
    a = Lleq(a, q);
    if(a == nil) goto    G2669;
    a = w14;
    a = Llength(a);
    q = a;
    a = w15;
    a = Lleq(a, q);
    if(a != nil) goto    G2595;
   G2669:
    a = cdr(w4);
    if(a != nil) goto    G2674;
    a = w1;
    goto    G2680;
   G2674:
    m = true;
    q = w3;
    a = w7;
    a = CC_multishiftTorgn(a, q, m);
    w16 = a;
    q = w2;
    a = CC_exactcontH(a, q);
    q = a;
    a = w16;
    a = CC_Vanyany(a, q);
   G2680:
    w16 = a;
    m = LL_Worder;
    q = w4;
    a = w16;
    CC_seTinsert(a, q, m);
   G2599:
    CC_Aunorder();
    a = w8;
    a = Lncons(a);
    CC_Aerase(a);
   G2600:
    a = w19;
    if(a == nil) goto    G2679;
    CC_recovtrace();
    a = LITERAL[100];
    Lprinc(a);
    Lterpri();
    Lterpri();
   G2679:
    a = cdr(w4);
    popv(20);
    return a;
}

Sex CC_parHenselTmultipol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w10 = nil;
    w7 = nil;
    w6 = nil;
    w8 = nil;
    w9 = nil;
    w11 = nil;
    w12 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = q;
    a = CC_topcopy(a);
    w6 = a;
    a = mkfxat(1);
    w7 = a;
   G2684:
    q = w7;
    a = w4;
    CC_setpowser(a, q);
    a = car(w2);
    w13 = a;
    a = cdr(w2);
    w10 = a;
   G2685:
    q = w13;
    a = car(w10);
    a = CC_multH(a, q);
    w13 = a;
    a = cdr(w10);
    w10 = a;
    if(a != nil) goto    G2685;
    arg4 = w7;
    m = arg4;
    q = w4;
    a = w13;
    a = CC_termfromtoH(a, q, m, arg4);
    a = CC_negH(a);
    w13 = a;
    arg4 = w7;
    m = arg4;
    q = w4;
    a = w1;
    a = CC_termfromtoH(a, q, m, arg4);
    q = w13;
    a = CC_addH(a, q);
    w8 = a;
    a = w8;
    a = CC_Alterm(a);
    a = CC_Alfactor(a);
    w9 = a;
    a = w8;
    a = CC_Alcoef(a);
    w8 = a;
    a = w2;
    w10 = a;
    a = w6;
    w11 = a;
    a = w3;
    w12 = a;
   G2687:
    q = w8;
    a = car(w12);
    a = CC_multH(a, q);
    q = car(w11);
    a = CC_remainH(a, q);
    w13 = a;
    q = a;
    a = w9;
    a = CC_multH(a, q);
    q = a;
    a = car(w10);
    a = CC_addH(a, q);
    q = a;
    a = w10;
    car(a) = q;
    a = cdr(w10);
    w10 = a;
    a = cdr(w11);
    w11 = a;
    a = cdr(w12);
    w12 = a;
    a = w10;
    if(a != nil) goto    G2687;
    a = w7;
    a = Ladd1(a);
    w7 = a;
    q = w5;
    a = Lleq(a, q);
    if(a != nil) goto    G2684;
    a = w2;
    popv(13);
    return a;
}

Sex CC_monicizeTfactrs(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    w2 = a;
   G2704:
    a = car(w1);
    w4 = a;
    a = CC_Alncoef(a);
    q = a;
    a = w4;
    a = CC_quotiH(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2704;
    a = cdr(w2);
    popv(4);
    return a;
}

Sex CC_substbnumTfactrs(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CHAR_OF(104);
    a = Lncons(a);
    w5 = a;
    w4 = a;
   G2714:
    a = car(w1);
    w6 = a;
    if(is_number(a)) goto    G2718;
    a = CC_Walgn(a);
    if(a == nil) goto    G2717;
   G2718:
    a = w6;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G2715;
   G2717:
    m = w3;
    q = w2;
    a = w6;
    a = CC_subTbnum2pol3(a, q, m);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G2715:
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G2714;
    a = cdr(w4);
    popv(6);
    return a;
}



/* initialization procedure */
int init_libalg(void)
{
   long i;

   create_symbols(libalg_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; libalg_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(libalg_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4;
        a = LITERAL[101];
        CC_Aenter(a);
        arg4 = nil;
#define LL_command LITERAL[102]
        m = LL_command;
#define LL_Aclearden LITERAL[103]
        q = LL_Aclearden;
#define LL_clearden LITERAL[104]
        a = LL_clearden;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Apowroot LITERAL[105]
        q = LL_Apowroot;
#define LL_powerroot LITERAL[106]
        a = LL_powerroot;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
        q = LL_Apowroot;
#define LL_powroot LITERAL[107]
        a = LL_powroot;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_AuniHensel LITERAL[108]
        q = LL_AuniHensel;
#define LL_uniHensel LITERAL[109]
        a = LL_uniHensel;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_AmultiHensel LITERAL[110]
        q = LL_AmultiHensel;
#define LL_multiHensel LITERAL[111]
        a = LL_multiHensel;
        CC_defcommand(a, q, m, arg4);
        arg4 = nil;
        m = LL_command;
#define LL_Aprem LITERAL[112]
        q = LL_Aprem;
#define LL_prem LITERAL[113]
        a = LL_prem;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(3);
#define LL_argchk LITERAL[114]
        m = LL_argchk;
#define LL_Ares LITERAL[115]
        q = LL_Ares;
#define LL_res LITERAL[116]
        a = LL_res;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(3);
        m = LL_argchk;
        q = LL_Ares;
#define LL_resultant LITERAL[117]
        a = LL_resultant;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(3);
        m = LL_argchk;
#define LL_Ares1 LITERAL[118]
        q = LL_Ares1;
#define LL_res1 LITERAL[119]
        a = LL_res1;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(3);
        m = LL_argchk;
#define LL_Agcd LITERAL[120]
        q = LL_Agcd;
#define LL_gcd LITERAL[121]
        a = LL_gcd;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
#define LL_Asqfr LITERAL[122]
        q = LL_Asqfr;
#define LL_sqfr LITERAL[123]
        a = LL_sqfr;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
#define LL_Afactorize LITERAL[124]
        q = LL_Afactorize;
#define LL_factorize LITERAL[125]
        a = LL_factorize;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
        q = LL_Afactorize;
#define LL_factor LITERAL[126]
        a = LL_factor;
        a = CC_defcommand(a, q, m, arg4);
        return 1;
    }
}
Sex LITERAL[128];

const  char *libalg_literal_string[128] =
{
/* 0 */
"!*mod",
/* 1 */
"!*byproduct",
/* 2 */
"!#maxcano!#",
/* 3 */
"\"CLEARDEN\"",
/* 4 */
"!#ratf!#",
/* 5 */
"\"POWERROOT\"",
/* 6 */
"! nil",
/* 7 */
"\"UNIHENSEL\"",
/* 8 */
"\"ARGUMENTS ARE NOT <POLY>\"",
/* 9 */
"\"ARGUMENTS ARE NOT UniVARIATE\"",
/* 10 */
"\"VARIABLES ARE NOT THE SAME\"",
/* 11 */
"\"INVALID AS LIFTING-STEP NUMBER\"",
/* 12 */
"\"DEGREES MISMATCH\"",
/* 13 */
"\"MODULUS UNDEFINED\"",
/* 14 */
"\"MULTIHENSEL\"",
/* 15 */
"\"VARIABLES ARE DIFFERENT\"",
/* 16 */
"\"F /= G0*H0 (mod S)\"",
/* 17 */
"!*quotient",
/* 18 */
"\"MULTIHENSEL2\"",
/* 19 */
"\"MAIN-VARS ARE DIFFERENT\"",
/* 20 */
"\"COFACT\"",
/* 21 */
"\"RELATIVELY NOT PRIME IN\"",
/* 22 */
"\"MULTISUBST:\"",
/* 23 */
"\"ARGUMENT IS NOT <POLY>\"",
/* 24 */
"\"resultant\"",
/* 25 */
"\"ARGUMENT MUST BE <POLY> IN\"",
/* 26 */
"\"RESULTANT-ARGS INDEPENDENT OF\"",
/* 27 */
"!*temporal",
/* 28 */
"detminor!:",
/* 29 */
"!*exctdiv",
/* 30 */
"\"GCD\"",
/* 31 */
"! Q",
/* 32 */
"! A",
/* 33 */
"!*medprimes",
/* 34 */
"!*bigprimes",
/* 35 */
"xctgcd!:unipol",
/* 36 */
"!*backtrace",
/* 37 */
"cofact0!:unipol",
/* 38 */
"\"  Hensel construction for modulus = \"",
/* 39 */
"\"GCD:UNIPOL\"",
/* 40 */
"\"BUILT-IN PRIMES EXHAUSTED\"",
/* 41 */
"\"Dr. Sasaki\"",
/* 42 */
"\"      SEND THIS OUTPUT TO\"",
/* 43 */
"\"***** Entering MultiVariate GCD >>>>>\"",
/* 44 */
"\"  target polynomial 1 : \"",
/* 45 */
"\"  target polynomial 2 : \"",
/* 46 */
"\"  gcd(cont(P2),P1)  ==> \"",
/* 47 */
"\"  gcd(cont(P1),P2)  ==> \"",
/* 48 */
"\"  S  = ideal-modulus <== \"",
/* 49 */
"\"  U1 = P1(X,i1,..,ir)  : \"",
/* 50 */
"\"  U2 = P2(X,i1,..,ir)  : \"",
/* 51 */
"\"  modulus is changed ==> \"",
/* 52 */
"\"  G  = Unigcd(U1,U2) : \"",
/* 53 */
"\"  H  = (a*P1+b*P2)/G : \"",
/* 54 */
"\"  G' = replace:lc(G) : \"",
/* 55 */
"\"  H' = replace:lc(H) : \"",
/* 56 */
"\"  G' = Henselift(G') : \"",
/* 57 */
"\"  G  = ShiftORGN(G') : \"",
/* 58 */
"\"  *** unlucky MODULUS, try again \"",
/* 59 */
"\"<<<<< end of MultiVariate GCD *****\"",
/* 60 */
"!?order",
/* 61 */
"\"SQFR\"",
/* 62 */
"! Z",
/* 63 */
"\"***** Entering MultiVar SQFR-Decompos. >>>>>\"",
/* 64 */
"\"  target polynomial  : \"",
/* 65 */
"\"  cont(POL) removed  : \"",
/* 66 */
"\"  sqfr( cont(POL) )  : \"",
/* 67 */
"\"  U  = POL(X,i,..,j) : \"",
/* 68 */
"\"  Uni-SQFR decompos. : \"",
/* 69 */
"\"  G  =  Um^m factor  : \"",
/* 70 */
"\"  H  =  UniPOL // G  : \"",
/* 71 */
"\"  Qm = m Pow-Root(G) : \"",
/* 72 */
"\"<<<<< end of MultiVar SQFR-Decompos. *****\"",
/* 73 */
"\"FACTORIZE\"",
/* 74 */
"\"2nd ARG MUST BE <BNUM>\"",
/* 75 */
"c!*",
/* 76 */
"c!+",
/* 77 */
"\"  content factor found  : \"",
/* 78 */
"\"  Square-Free decompos. : \"",
/* 79 */
"\"***** Entering Factorization over Zp >>>>>\"",
/* 80 */
"\"  target polynomial : \"",
/* 81 */
"\"  Q matrix is constructed as \"",
/* 82 */
"\"    \"",
/* 83 */
"\"  Q matrix is eliminated as  \"",
/* 84 */
"!!oset",
/* 85 */
"\"  U-polynomials are : \"",
/* 86 */
"\"<<<<< end of Factorization over Zp *****\"",
/* 87 */
"\"***** Entering Factorization over Z >>>>>\"",
/* 88 */
"!*primes",
/* 89 */
"\"  prime P is selected as  \"",
/* 90 */
"\"  Factorization over Zp : \"",
/* 91 */
"\"  Lagrange intrpol-poly : \"",
/* 92 */
"\"  Hensel-lift Zp-factor : \"",
/* 93 */
"\"  An irreducible factor : \"",
/* 94 */
"\"<<<<< end of Factorization over Z *****\"",
/* 95 */
"\"***** Entering MultiVar Factorization >>>>>\"",
/* 96 */
"\"  S  = ideal-modulus  <== \"",
/* 97 */
"\"  UP = POL(X,I2,..,In)  : \"",
/* 98 */
"\"  UniVAR-Factorize(UP)  : \"",
/* 99 */
"\"  parallel Henselifting : \"",
/* 100 */
"\"<<<<< end of MultiVar Factorization *****\"",
/* 101 */
"(lisp)",
/* 102 */
"command",
/* 103 */
"! clearden",
/* 104 */
"clearden",
/* 105 */
"! powroot",
/* 106 */
"powerroot",
/* 107 */
"powroot",
/* 108 */
"! uniHensel",
/* 109 */
"uniHensel",
/* 110 */
"! multiHensel",
/* 111 */
"multiHensel",
/* 112 */
"! prem",
/* 113 */
"prem",
/* 114 */
"argchk",
/* 115 */
"! res",
/* 116 */
"res",
/* 117 */
"resultant",
/* 118 */
"! res1",
/* 119 */
"res1",
/* 120 */
"! gcd",
/* 121 */
"gcd",
/* 122 */
"! sqfr",
/* 123 */
"sqfr",
/* 124 */
"! factorize",
/* 125 */
"factorize",
/* 126 */
"factor",
/* 127 */ NULL
};
setup_type const libalg_g_setup[] =
{
    {"substbnum:factrs", (lisp_proc *)CC_substbnumTfactrs, 3},
    {"monicize:factrs", (lisp_proc *)CC_monicizeTfactrs, 1},
    {"parHensel:multipol", (lisp_proc *)CC_parHenselTmultipol, 5},
    {"xctfact:multipol", (lisp_proc *)CC_xctfactTmultipol, 2},
    {"cal:modpow", (lisp_proc *)CC_calTmodpow, 2},
    {"parHensel:unipol", (lisp_proc *)CC_parHenselTunipol, 6},
    {"xctfact:unipol", (lisp_proc *)CC_xctfactTunipol, 2},
    {"Berl2:getcoef", (lisp_proc *)CC_Berl2Tgetcoef, 3},
    {"Berl2:elimrow", (lisp_proc *)CC_Berl2Telimrow, 4},
    {"xctfact:Berl2", (lisp_proc *)CC_xctfactTBerl2, 1},
    {"Berl:add1ulis", (lisp_proc *)CC_BerlTadd1ulis, 1},
    {"Berl:getcoef", (lisp_proc *)CC_BerlTgetcoef, 3},
    {"Berl:mkupol", (lisp_proc *)CC_BerlTmkupol, 3},
    {"Berl:elimrow", (lisp_proc *)CC_BerlTelimrow, 2},
    {"xctfact:Berl", (lisp_proc *)CC_xctfactTBerl, 1},
    {"del:mfactr", (lisp_proc *)CC_delTmfactr, 2},
    {"mult:cofactr", (lisp_proc *)CC_multTcofactr, 3},
    {"mult:mfactr", (lisp_proc *)CC_multTmfactr, 3},
    {"oldselect:mitem", (lisp_proc *)CC_oldselectTmitem, 3},
    {"select:mitem", (lisp_proc *)CC_selectTmitem, 3},
    {"exactcont*", (lisp_proc *)CC_exactcontH, 2},
    {"exactfactrz*", (lisp_proc *)CC_exactfactrzH, 2},
    {" factorize", (lisp_proc *)CC_Afactorize, 2},
    {"sqfr:candlc", (lisp_proc *)CC_sqfrTcandlc, 2},
    {"merg:sqfrlist", (lisp_proc *)CC_mergTsqfrlist, 2},
    {"chkmod:xctsqfr", (lisp_proc *)CC_chkmodTxctsqfr, 4},
    {"xctsqfr:multipol", (lisp_proc *)CC_xctsqfrTmultipol, 2},
    {"replace:ppow", (lisp_proc *)CC_replaceTppow, 2},
    {"xctsqfr:unipol", (lisp_proc *)CC_xctsqfrTunipol, 2},
    {"exactsqfr*", (lisp_proc *)CC_exactsqfrH, 2},
    {" sqfr", (lisp_proc *)CC_Asqfr, 2},
    {"replace:lc", (lisp_proc *)CC_replaceTlc, 2},
    {"setmod:ideal", (lisp_proc *)CC_setmodTideal, 3},
    {"chkmod:xctgcd", (lisp_proc *)CC_chkmodTxctgcd, 5},
    {"set:gcdcofctrs", (lisp_proc *)CC_setTgcdcofctrs, 4},
    {"xctcont:wrtvar", (lisp_proc *)CC_xctcontTwrtvar, 3},
    {"xctcont:multipol", (lisp_proc *)CC_xctcontTmultipol, 2},
    {"xctgcd:multipol", (lisp_proc *)CC_xctgcdTmultipol, 3},
    {"xctpp:unipol", (lisp_proc *)CC_xctppTunipol, 2},
    {"setmod:int", (lisp_proc *)CC_setmodTint, 2},
    {"xctgcd:unipol", (lisp_proc *)CC_xctgcdTunipol, 3},
    {"xctgcd:Collins", (lisp_proc *)CC_xctgcdTCollins, 2},
    {"xctgcd:priPRS", (lisp_proc *)CC_xctgcdTpriPRS, 2},
    {"xctgcd:unimulti", (lisp_proc *)CC_xctgcdTunimulti, 3},
    {"exactgcd*", (lisp_proc *)CC_exactgcdH, 3},
    {"gcd:bmonbmon", (lisp_proc *)CC_gcdTbmonbmon, 2},
    {"gcd:monomono", (lisp_proc *)CC_gcdTmonomono, 2},
    {" gcd", (lisp_proc *)CC_Agcd, 3},
    {" res1", (lisp_proc *)CC_Ares1, 3},
    {" res", (lisp_proc *)CC_Ares, 3},
    {" prem", (lisp_proc *)CC_Aprem, 2},
    {"tdeg:coef", (lisp_proc *)CC_tdegTcoef, 1},
    {"multishift:orgn", (lisp_proc *)CC_multishiftTorgn, 3},
    {"multisubst:bnum", (lisp_proc *)CC_multisubstTbnum, 2},
    {"multisubst:sub0", (lisp_proc *)CC_multisubstTsub0, 1},
    {"interpol:lagpoly", (lisp_proc *)CC_interpolTlagpoly, 1},
    {"interpol:lagpoly0", (lisp_proc *)CC_interpolTlagpoly0, 1},
    {"cofact:unipol", (lisp_proc *)CC_cofactTunipol, 4},
    {"cofact0:unipol", (lisp_proc *)CC_cofact0Tunipol, 2},
    {"Hensel:ideallift", (lisp_proc *)CC_HenselTideallift, 5},
    {" multiHensel2", (lisp_proc *)CC_AmultiHensel2, 3},
    {" multiHensel", (lisp_proc *)CC_AmultiHensel, 4},
    {" uniHensel", (lisp_proc *)CC_AuniHensel, 4},
    {" powroot", (lisp_proc *)CC_Apowroot, 2},
    {" clearden", (lisp_proc *)CC_Aclearden, 1},
    {"?divoverZpQA", (lisp_proc *)CC_WdivoverZpQA, 2},
    {"df:unipol", (lisp_proc *)CC_dfTunipol, 2},
    {"trydiv:unipolZ", (lisp_proc *)CC_trydivTunipolZ, 2},
    {"xctquo:unipol", (lisp_proc *)CC_xctquoTunipol, 2},
    {"xctdiv:unipol", (lisp_proc *)CC_xctdivTunipol, 2},
    {"pow:unipol", (lisp_proc *)CC_powTunipol, 2},
    {"mult:unipol", (lisp_proc *)CC_multTunipol, 2},
    {"add:unipol", (lisp_proc *)CC_addTunipol, 2},
    {"neg:unipol", (lisp_proc *)CC_negTunipol, 1},
    {NULL, NULL, 0 }
};

