#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "tags.h"
#include "errors.h"
#include "externs.h"
#include "arith.h"
#include "macros.h"
#include "entries.h"
#include "gprotos.h"
#include "g_pkggb.h"

extern Sex *literal_vectors[];
extern int number_of_literal_vectors;
Sex pkggb_literal_vector[];
const char *pkggb_literal_string[];
setup_type const  pkggb_g_setup[];
#define LITERAL pkggb_literal_vector




Sex CC_ONEp(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(!is_efloat(a)) goto    G0002;
    a = Lefloat_value(a);
    q = LITERAL[0];
    a = plus2(a, q);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
    goto    G0013;
   G0002:
    if(!is_befloat(a)) goto    G0007;
    a = Lbefloat_value(a);
    q = LITERAL[0];
    a = plus2(a, q);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lbefloat_error(a);
   G0013:
    q = a;
    a = w2;
    {
        popv(2);
        return  Llessp(a, q);
    }
   G0007:
    {
        popv(2);
        return  Lonep(a);
    }
}

Sex CC_ZEROp(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = a;
    if(is_float(a)) goto    G0022;
    if(!is_efloat(a)) goto    G0018;
    a = Lefloat_value(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lefloat_error(a);
    goto    G0028;
   G0018:
    if(!is_befloat(a)) goto    G0022;
    a = Lbefloat_value(a);
    a = Labs(a);
    w2 = a;
    a = w1;
    a = Lbefloat_error(a);
   G0028:
    q = a;
    a = w2;
    {
        popv(2);
        return  Llessp(a, q);
    }
   G0022:
    {
        popv(2);
        return  Lzerop(a);
    }
}

Sex CC_Apkgparam(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = a;
    if(!is_cons(a)) goto    G0037;
    a = CC_Wcano(a);
    if(a == nil) goto    G0033;
    a = car(cdr(w1));
    w1 = a;
   G0037:
    a = w2;
    w4 = a;
    if(!is_cons(a)) goto    G0041;
    a = CC_Wcano(a);
    if(a == nil) goto    G0033;
    a = car(cdr(w2));
    w2 = a;
   G0041:
    a = w3;
    w4 = a;
    if(!is_cons(a)) goto    G0045;
    a = CC_Wcano(a);
    if(a == nil) goto    G0033;
    a = car(cdr(w3));
    w3 = a;
   G0045:
    a = w1;
    w4 = a;
    if(!is_symbol(a)) goto    G0033;
    a = Lexplode(a);
    w1 = a;
    a = w2;
    w4 = a;
    if(!is_symbol(a)) goto    G0033;
    a = Lexplode(a);
    w2 = a;
    a = w3;
    w4 = a;
    if(!is_symbol(a)) goto    G0053;
    a = Lexplode(a);
    w3 = a;
    goto    G0055;
   G0053:
    if(!is_number(a)) goto    G0033;
   G0055:
    a = car(cdr(w1));
#define LL_RblankS LITERAL[1]
    if(a != value(LL_RblankS)) goto    G0057;
    a = cdr(cdr(w1));
    w1 = a;
   G0057:
    a = car(cdr(w2));
    if(a != value(LL_RblankS)) goto    G0059;
    a = cdr(cdr(w2));
    w2 = a;
   G0059:
    a = w3;
    if(!is_cons(a)) goto    G0061;
    a = car(cdr(a));
    if(a != value(LL_RblankS)) goto    G0061;
    a = cdr(cdr(w3));
    a = Lmake_id(a);
    w3 = a;
   G0061:
    q = w2;
#define LL_RpercentS LITERAL[2]
    a = value(LL_RpercentS);
    a = cons(a, q);
    w2 = a;
    a = w1;
    a = CC_tail(a);
    q = w2;
    cdr(a) = q;
    a = w1;
    a = Lmake_id(a);
    w2 = a;
    q = w3;
    Lset(a, q);
    a = LITERAL[3];
    Lprinc(a);
    a = w2;
    Lprint(a);
    Lterpri();
    q = w2;
    a = LITERAL[4];
    CC_optionmsg(a, q);
    a = w3;
    goto    G0031;
   G0033:
    q = w4;
    a = LITERAL[5];
    CC_errormsg(a, q);
    a = nil;
   G0031:
    popv(4);
    return a;
}

Sex CC_ArandomD7(Sex a)
{
    Sex q;
    if(a != nil) goto    G0067;
#define LL_Hrandom LITERAL[6]
    q = value(LL_Hrandom);
    goto    G0073;
   G0067:
    q = a;
   G0073:
    a = mkfxat(1913);
    a = times2(a, q);
    q = mkfxat(3273851);
    a = plus2(a, q);
    q = mkfxat(10000000);
    a = remaind2(a, q);
    value(LL_Hrandom) = a;
    return a;
}

Sex CC_Afmmc(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = LITERAL[7];
#define LL_Hchkcoef LITERAL[8]
    value(LL_Hchkcoef) = a;
    q = w1;
#define LL_fmmcTbef2float LITERAL[9]
    a = LL_fmmcTbef2float;
    CC_mapTchkcoef(a, q);
    a = value(LL_Hchkcoef);
    popv(1);
    return a;
}

Sex CC_fmmcTbef2float(Sex a)
{
    Sex q;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    q = a;
    a = value(LL_Hchkcoef);
    a = Lmax2(a, q);
    value(LL_Hchkcoef) = a;
    return a;
}

Sex CC_truncat3dgt(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
    a = Ltruncate(a);
    w1 = a;
    a = Labs(a);
    w2 = a;
    a = mkfxat(1);
    w3 = a;
   G0083:
    q = w3;
    a = mkfxat(1000);
    a = times2(a, q);
    q = a;
    a = w2;
    a = Lgreaterp(a, q);
    q = w3;
    if(a == nil) goto    G0085;
    a = mkfxat(10);
    a = times2(a, q);
    w3 = a;
    goto    G0083;
   G0085:
    a = w1;
    a = quot2(a, q);
    q = w3;
    {
        popv(3);
        return  times2(a, q);
    }
}

Sex CC_delErrTerm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(a);
    a = CC_delErTmTbpol(a, q);
#define LL_Htemporal LITERAL[10]
    value(LL_Htemporal) = a;
    if(is_number(a)) goto    G0093;
    a = car(a);
    if(!is_integer(a)) goto    G0092;
   G0093:
    a = value(LL_Htemporal);
    goto    G0094;
   G0092:
    q = value(LL_Htemporal);
    a = car(w1);
    a = cons(a, q);
   G0094:
    popv(1);
    return a;
}

Sex CC_delErTmTbpol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w5 = a;
   G0098:
    a = cdr(car(w5));
    w6 = a;
    if(is_number(a)) goto    G0108;
    a = car(a);
    if(is_integer(a)) goto    G0103;
    q = w2;
    a = w6;
    a = CC_delErTmTbpol(a, q);
    w7 = a;
    if(a != w6) goto    G0102;
   G0103:
    q = w6;
    goto    G0131;
   G0102:
    a = Lzerop(a);
    if(a == nil) goto    G0107;
    a = true;
    w8 = a;
    goto    G0099;
   G0107:
    a = true;
    w8 = a;
    q = w7;
   G0131:
    a = car(car(w5));
    a = cons(a, q);
    goto    G0132;
   G0108:
    a = w6;
    a = Lbefloat_error(a);
    q = a;
#define LL_Hmachineps LITERAL[11]
    a = value(LL_Hmachineps);
    a = quot2(a, q);
    w9 = a;
    a = w6;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    q = a;
    a = w9;
    a = times2(a, q);
    w6 = a;
    a = Labs(a);
    q = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0117;
    a = car(w5);
   G0132:
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G0099;
   G0117:
#define LL_untrac LITERAL[12]
    q = LL_untrac;
#define LL_Htracmode LITERAL[13]
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0122;
    a = w8;
    if(a != nil) goto    G0124;
    Lterpri();
   G0124:
    a = LITERAL[14];
    Lprinc(a);
    a = cdr(car(w5));
    Lprint(a);
   G0122:
    a = true;
    w8 = a;
   G0099:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0098;
    a = w8;
    if(a != nil) goto    G0128;
    a = w1;
    goto    G0097;
   G0128:
    a = w3;
    a = CC_reduceTbpol(a);
   G0097:
    popv(9);
    return a;
}

Sex CC_acczerop(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G0136;
    a = true;
    goto    G0155;
   G0136:
    a = w1;
    if(!is_float(a)) goto    G0137;
    a = Labs(a);
    q = w2;
    goto    G0158;
   G0137:
    if(!is_efloat(a)) goto    G0139;
    a = Lefloat_value(a);
    a = Labs(a);
    q = a;
    a = value(LL_Hmachineps);
    a = times2(a, q);
    w3 = a;
    a = w1;
    a = Lefloat_error(a);
    q = a;
    a = w2;
    a = times2(a, q);
    q = a;
    a = w3;
    goto    G0158;
   G0139:
    if(!is_befloat(a)) goto    G0145;
    a = Lbefloat_error(a);
    q = a;
    a = value(LL_Hmachineps);
    a = quot2(a, q);
    w3 = a;
    a = w1;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    q = a;
    a = w3;
    a = times2(a, q);
    q = w2;
    goto    G0158;
   G0145:
    if(!is_interval(a)) goto    G0152;
    a = Linterval_width(a);
    a = Labs(a);
    q = w2;
   G0158:
    {
        popv(3);
        return  Llessp(a, q);
    }
   G0152:
#define LL_acczerop LITERAL[15]
    q = LL_acczerop;
    a = LITERAL[16];
    a = CC_errormsg(a, q);
   G0155:
    popv(3);
    return a;
}

Sex CC_gbEmaxcoferr(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
    a = LITERAL[7];
    w7 = a;
    w6 = a;
   G0162:
    a = cdr(car(w2));
    w3 = a;
    if(!is_efloat(a)) goto    G0165;
    a = Lefloat_value(a);
    a = Labs(a);
    w4 = a;
    a = w3;
    a = Lefloat_error(a);
    goto    G0177;
   G0165:
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w4 = a;
    a = w3;
    a = Lbefloat_error(a);
   G0177:
    w5 = a;
    q = w6;
    a = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0171;
    a = w4;
    w6 = a;
   G0171:
    q = w7;
    a = w5;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G0173;
    a = w5;
    w7 = a;
   G0173:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0162;
    q = w7;
    a = w6;
    {
        popv(7);
        return  cons(a, q);
    }
}

Sex CC_gbEvpartMax(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
    a = LITERAL[7];
    value(LL_Hchkcoef) = a;
   G0181:
    a = cdr(car(w2));
    a = CC_vpartmaxTefitv(a);
    w3 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0181;
    a = w3;
    popv(3);
    return a;
}

Sex CC_gbEepartMax(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
    a = LITERAL[7];
    value(LL_Hchkcoef) = a;
   G0187:
    a = cdr(car(w2));
    a = CC_epartmaxTefitv(a);
    w3 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0187;
    a = w3;
    popv(3);
    return a;
}

Sex CC_gbEaccMin(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
    q = value(LL_Hmachineps);
    a = LITERAL[17];
    a = quot2(a, q);
    value(LL_Hchkcoef) = a;
   G0193:
    a = cdr(car(w2));
    a = CC_accminTefitv(a);
    w3 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0193;
    a = w3;
    popv(3);
    return a;
}

Sex CC_gbEaccMax(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
    a = LITERAL[7];
    value(LL_Hchkcoef) = a;
   G0199:
    a = cdr(car(w2));
    a = CC_accmaxTefitv(a);
    w3 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0199;
    a = w3;
    popv(3);
    return a;
}

Sex CC_gbEaccMinMax(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = cdr(a);
    w2 = a;
    q = value(LL_Hmachineps);
    a = LITERAL[17];
    a = quot2(a, q);
    q = LITERAL[7];
    a = cons(a, q);
    value(LL_Hchkcoef) = a;
   G0205:
    a = cdr(car(w2));
    CC_accminmaxTefitv(a);
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G0205;
    a = value(LL_Hchkcoef);
    popv(2);
    return a;
}

Sex CC_AQgroeb(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_gbEcoeftype(a);
#define LL_AQ LITERAL[18]
    if(a == LL_AQ) goto    G0215;
#define LL_AZ LITERAL[19]
    if(a == LL_AZ) goto    G0215;
    q = nil;
    a = LITERAL[20];
    CC_errormsg(a, q);
   G0215:
#define LL_ratn LITERAL[21]
    a = LL_ratn;
#define LL_gbEcoftype LITERAL[22]
    value(LL_gbEcoftype) = a;
#define LL_times2 LITERAL[23]
    a = LL_times2;
#define LL_gbEmult LITERAL[24]
    value(LL_gbEmult) = a;
#define LL_divTbnumbnum LITERAL[25]
    a = LL_divTbnumbnum;
#define LL_gbEquoti LITERAL[26]
    value(LL_gbEquoti) = a;
#define LL_plus2 LITERAL[27]
    a = LL_plus2;
#define LL_gbEadd LITERAL[28]
    value(LL_gbEadd) = a;
#define LL_minus LITERAL[29]
    a = LL_minus;
#define LL_gbEneg LITERAL[30]
    value(LL_gbEneg) = a;
#define LL_gcdTbnumbnum LITERAL[31]
    a = LL_gcdTbnumbnum;
#define LL_gbEgcd LITERAL[32]
    value(LL_gbEgcd) = a;
    m = CHAR_OF(69);
    q = w2;
    a = w1;
    a = CC_gbEinitialz(a, q, m);
    w5 = a;
    a = car(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
    q = a;
    a = w3;
    {
        popv(5);
        return  CC_gbEQgroebH(a, q);
    }
}

Sex CC_AZpGroeb(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_gbEcoeftype(a);
    if(a == LL_AZ) goto    G0222;
    q = nil;
    a = LITERAL[33];
    CC_errormsg(a, q);
   G0222:
#define LL_Hmod LITERAL[34]
    a = value(LL_Hmod);
    if(a != nil) goto    G0224;
    q = nil;
    a = LITERAL[35];
    CC_errormsg(a, q);
   G0224:
#define LL_Zp LITERAL[36]
    a = LL_Zp;
    value(LL_gbEcoftype) = a;
#define LL_modmult LITERAL[37]
    a = LL_modmult;
    value(LL_gbEmult) = a;
#define LL_moddiv LITERAL[38]
    a = LL_moddiv;
    value(LL_gbEquoti) = a;
#define LL_modadd LITERAL[39]
    a = LL_modadd;
    value(LL_gbEadd) = a;
    a = LL_minus;
    value(LL_gbEneg) = a;
#define LL_gcd LITERAL[40]
    a = LL_gcd;
    value(LL_gbEgcd) = a;
    m = CHAR_OF(69);
    q = w2;
    a = w1;
    a = CC_gbEinitialz(a, q, m);
    w5 = a;
    a = car(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
    q = a;
    a = w3;
    {
        popv(5);
        return  CC_gbEQgroebH(a, q);
    }
}

Sex CC_AFgroeb(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_gbEcoeftype(a);
#define LL_AF LITERAL[41]
    if(a == LL_AF) goto    G0234;
#define LL_AC LITERAL[42]
    if(a == LL_AC) goto    G0234;
    if(a == LL_AQ) goto    G0233;
    if(a != LL_AZ) goto    G0232;
   G0233:
    q = nil;
    a = LITERAL[43];
    goto    G0236;
   G0232:
    q = nil;
    a = LITERAL[44];
   G0236:
    CC_errormsg(a, q);
   G0234:
#define LL_float LITERAL[45]
    a = LL_float;
    value(LL_gbEcoftype) = a;
    a = LL_times2;
    value(LL_gbEmult) = a;
#define LL_quotient LITERAL[46]
    a = LL_quotient;
    value(LL_gbEquoti) = a;
    a = LL_plus2;
    value(LL_gbEadd) = a;
    a = LL_minus;
    value(LL_gbEneg) = a;
    value(LL_gbEgcd) = nil;
    m = CHAR_OF(70);
    q = w2;
    a = w1;
    a = CC_gbEinitialz(a, q, m);
    w5 = a;
    a = car(a);
    w3 = a;
    a = cdr(w5);
    w4 = a;
    q = a;
    a = w3;
    {
        popv(5);
        return  CC_gbEQgroebH(a, q);
    }
}

Sex CC_gbEQgroebH(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Llast(a);
    w5 = a;
    a = w1;
    w3 = a;
   G0242:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0289;
    q = cdr(cdr(car(a)));
    a = car(car(cdr(car(a))));
    a = cons(a, q);
    w6 = a;
    q = w7;
    a = cons(a, q);
    w7 = a;
    goto    G0242;
   G0289:
    a = w7;
    a = Lreverse(a);
    w7 = a;
    m = w2;
    q = cdr(w1);
    a = w1;
    a = CC_gbEreduce(a, q, m);
    w3 = a;
#define LL_end LITERAL[47]
    if(a == LL_end) goto    G0246;
    a = Lonep(a);
    if(a != nil) goto    G0245;
#define LL_stop LITERAL[48]
    a = LL_stop;
    if(a == w3) goto    G0286;
   G0256:
    a = cdr(cdr(w1));
    if(a == nil) goto    G0288;
    m = w5;
    q = w2;
    a = w1;
    a = CC_gbEspol(a, q, m);
    w4 = a;
    a = w5;
    a = Ladd1(a);
    w5 = a;
    a = LL_end;
    if(a == w4) goto    G0246;
    a = w4;
    a = Lonep(a);
    if(a != nil) goto    G0245;
    a = car(w4);
    a = CC_gbEstop(a);
    if(a != nil) goto    G0286;
    m = w2;
    q = w4;
    a = w1;
    a = CC_gbEreduce(a, q, m);
    w3 = a;
    if(a == LL_end) goto    G0246;
    a = Lonep(a);
    if(a != nil) goto    G0245;
    a = LL_stop;
    if(a != w3) goto    G0256;
   G0286:
    a = w1;
    goto    G0241;
   G0245:
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G0287;
    a = car(cdr(w1));
    w6 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G0275;
    a = car(w6);
    w6 = a;
   G0275:
    Lterpri();
    a = LITERAL[49];
    Lprinc(a);
    a = w6;
    Lprin(a);
    a = LITERAL[50];
    w6 = a;
    Lprinc(a);
    Lterpri();
   G0287:
    q = mkfxat(1);
#define LL_Bset LITERAL[51]
    a = LL_Bset;
    {
        popv(8);
        return  Llist2(a, q);
    }
   G0288:
    q = nil;
    a = LITERAL[52];
    CC_optionmsg(a, q);
   G0246:
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G0279;
    a = LITERAL[53];
    w6 = a;
    Lterpri();
    Lterpri();
    a = w6;
    Lprinc(a);
    Lterpri();
    a = w1;
    w4 = a;
    w8 = nil;
   G0280:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0279;
    Lterpri();
    a = car(car(cdr(car(w4))));
    w6 = a;
    a = LITERAL[54];
    Lprinc(a);
    a = w6;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
#define LL_gbEorder LITERAL[56]
    m = value(LL_gbEorder);
#define LL_gbEvars LITERAL[57]
    q = value(LL_gbEvars);
    a = cdr(cdr(car(w4)));
    CC_gbEprint(a, q, m, arg4, arg5);
    a = Lterpri();
    w8 = a;
    goto    G0280;
   G0279:
    a = w1;
    a = CC_gbEwset2polyset(a);
    w3 = a;
#define LL_gbEsyzygy LITERAL[58]
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0284;
    a = w1;
    a = CC_gbEsyzy2polyset(a);
#define LL_Hbyproduct LITERAL[59]
    value(LL_Hbyproduct) = a;
   G0284:
    a = w3;
   G0241:
    popv(8);
    return a;
}

Sex CC_gbEinitialz(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = value(LL_gbEorder);
    if(a != nil) goto    G0308;
    q = nil;
    a = LITERAL[60];
    goto    G0378;
   G0308:
    q = LITERAL[61];
    a = Lmemq(a, q);
    if(a != nil) goto    G0309;
    q = nil;
    a = LITERAL[62];
   G0378:
    CC_errormsg(a, q);
   G0309:
    a = w2;
    if(a == nil) goto    G0315;
#define LL_Anil LITERAL[63]
    if(a == LL_Anil) goto    G0315;
    a = value(LL_gbEcoftype);
    if(a != LL_float) goto    G0313;
    q = nil;
    a = LITERAL[64];
    goto    G0380;
   G0313:
#define LL_gbEordpar LITERAL[65]
    a = value(LL_gbEordpar);
    if(a != nil) goto    G0314;
    q = nil;
    a = LITERAL[66];
    goto    G0380;
   G0314:
    q = LITERAL[61];
    a = Lmemq(a, q);
    if(a != nil) goto    G0315;
    q = nil;
    a = LITERAL[67];
   G0380:
    CC_errormsg(a, q);
   G0315:
    q = LITERAL[68];
#define LL_gbEredtype LITERAL[69]
    a = value(LL_gbEredtype);
    a = Lmemq(a, q);
    if(a != nil) goto    G0322;
    a = value(LL_gbEredtype);
    if(a != nil) goto    G0318;
    a = value(LL_gbEorder);
#define LL_lex LITERAL[70]
    if(a != LL_lex) goto    G0322;
    goto    G0322;
   G0318:
    q = nil;
    a = LITERAL[71];
    CC_errormsg(a, q);
   G0322:
    a = value(LL_gbEcoftype);
    if(a != LL_float) goto    G0324;
#define LL_head LITERAL[72]
    a = LL_head;
    value(LL_gbEredtype) = a;
   G0324:
    a = w1;
    w7 = a;
    a = mkfxat(0);
    w6 = a;
#define LL_PCs LITERAL[73]
    a = LL_PCs;
    a = Lncons(a);
    w5 = a;
#define LL_VAR LITERAL[74]
    a = LL_VAR;
    a = Lncons(a);
    value(LL_gbEvars) = a;
   G0297:
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G0383;
    a = car(a);
    w9 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G0327;
    a = w9;
    a = CC_Wpoly(a);
    if(a != nil) goto    G0332;
   G0327:
    a = w9;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0331;
    a = w9;
    a = CC_Walgn(a);
    if(a == nil) goto    G0330;
   G0331:
    q = w9;
    a = LITERAL[75];
    goto    G0381;
   G0330:
    q = LITERAL[76];
    a = mkfxat(3);
   G0381:
    CC_errormsg(a, q);
   G0332:
    a = w6;
    a = Ladd1(a);
    w6 = a;
#define LL_lessp LITERAL[77]
    m = LL_lessp;
    q = w5;
    CC_seTinsert(a, q, m);
    q = w9;
    a = w6;
    a = cons(a, q);
    q = w4;
    a = cons(a, q);
    w4 = a;
    q = value(LL_gbEvars);
    a = cdr(w9);
    CC_varsTbpol(a, q);
    goto    G0297;
   G0383:
    a = cdr(value(LL_gbEvars));
    value(LL_gbEvars) = a;
    a = w2;
    if(a == nil) goto    G0336;
    if(a != LL_Anil) goto    G0335;
   G0336:
#define LL_gbEpars LITERAL[78]
    value(LL_gbEpars) = nil;
    goto    G0347;
   G0335:
    w7 = a;
#define LL_PAR LITERAL[79]
    a = LL_PAR;
    a = Lncons(a);
    value(LL_gbEpars) = a;
   G0337:
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G0339;
    a = cdr(value(LL_gbEpars));
    value(LL_gbEpars) = a;
    goto    G0343;
   G0339:
    a = car(a);
    w9 = a;
    a = CC_Wpoly(a);
    if(a == nil) goto    G0341;
    a = w9;
    a = CC_Wmonomial(a);
    if(a == nil) goto    G0341;
    q = value(LL_gbEpars);
    a = cdr(w9);
    CC_varsTbpol(a, q);
    q = value(LL_gbEvars);
    a = car(cdr(w9));
    a = Ldelete(a, q);
    value(LL_gbEvars) = a;
    goto    G0337;
   G0341:
    q = LITERAL[76];
    a = mkfxat(3);
    CC_errormsg(a, q);
   G0343:
    a = value(LL_gbEpars);
    if(a == nil) goto    G0347;
    a = value(LL_gbEvars);
    if(a != nil) goto    G0346;
    q = nil;
    a = LITERAL[80];
    CC_printmsg(a, q);
    q = nil;
    a = LITERAL[81];
    goto    G0382;
   G0346:
    a = Llast(a);
    q = a;
    a = car(value(LL_gbEpars));
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0347;
    q = nil;
    a = LITERAL[82];
    CC_printmsg(a, q);
    q = nil;
    a = LITERAL[83];
   G0382:
    CC_errormsg(a, q);
   G0347:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0302;
#define LL_gbEsyzvar LITERAL[84]
    a = value(LL_gbEsyzvar);
    if(a != nil) goto    G0301;
    a = value(LL_gbEsyzygy);
    a = Lexplode(a);
    q = value(LL_RblankS);
    a = Lxcons(a, q);
    a = Lmake_id(a);
    value(LL_gbEsyzvar) = a;
    q = a;
#define LL_indxvar LITERAL[85]
    a = LL_indxvar;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = value(LL_gbEsyzvar);
    a = Lncons(a);
    CC_Aorder(a);
   G0301:
    a = mkfxat(100);
    a = Lmkvect(a);
    value(LL_gbEsyzygy) = a;
   G0302:
    a = w4;
    w7 = a;
#define LL_Wset LITERAL[86]
    a = LL_Wset;
    a = Lncons(a);
    w4 = a;
   G0303:
    a = car(w7);
    w8 = a;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = cdr(a);
    a = CC_gbEpoly2dist(a, q, m);
    w9 = a;
    m = w5;
    q = car(w8);
    a = CC_gbEmkwprep(a, q, m);
    q = w4;
    CC_gbEinswset(a, q);
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G0303;
    a = w4;
    w8 = a;
    w7 = a;
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G0363;
    a = LITERAL[87];
    w9 = a;
    Lterpri();
    a = w9;
    Lprinc(a);
    Lterpri();
    w10 = nil;
   G0364:
    a = cdr(w8);
    w8 = a;
    if(a == nil) goto    G0363;
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = car(w8);
    w9 = a;
    a = car(car(cdr(a)));
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = cdr(cdr(w9));
    CC_gbEprint(a, q, m, arg4, arg5);
    a = Lterpri();
    w10 = a;
    goto    G0364;
   G0363:
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G0306;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0370;
    a = car(car(cdr(car(w7))));
    w6 = a;
    a = Lncons(a);
    q = a;
    a = value(LL_gbEsyzvar);
    a = CC_gevTxid(a, q);
    m = a;
    q = w6;
    a = value(LL_gbEsyzygy);
    CC_gbEsyzysave(a, q, m);
   G0370:
    a = cdr(car(w7));
    w8 = a;
    a = w3;
    if(a != CHAR_OF(69)) goto    G0373;
    q = car(car(w8));
    a = cdr(w8);
    a = CC_gbEnormalz(a, q);
    goto    G0376;
   G0373:
    if(a != CHAR_OF(70)) goto    G0374;
    m = nil;
    q = car(car(w8));
    a = cdr(w8);
    a = CC_gbEFnormalz(a, q, m);
    goto    G0376;
   G0374:
    q = car(car(w8));
#define LL_hpr LITERAL[89]
    if(a != LL_hpr) goto    G0375;
    a = cdr(w8);
    a = CC_gbEHnormalz(a, q);
    goto    G0376;
   G0375:
    a = cdr(w8);
    a = CC_gbEFnormlz0(a, q);
   G0376:
    w9 = a;
    q = a;
    a = w8;
    cdr(a) = q;
    goto    G0363;
   G0306:
    q = w5;
    a = w4;
    {
        popv(10);
        return  cons(a, q);
    }
}

Sex CC_gbEmkwprep(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = a;
    a = cdr(m);
    w3 = a;
    w2 = q;
    a = Lcopy(a);
    q = w2;
    a = Lxcons(a, q);
    w4 = a;
    q = a;
    a = w2;
    CC_seTdelete(a, q);
    a = w1;
    a = CC_gbEhex(a);
    w5 = a;
    q = w1;
    a = w4;
    a = cons(a, q);
    q = w5;
    {
        popv(5);
        return  Lxcons(a, q);
    }
}

Sex CC_gbEinitunpCs(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = cdr(q);
    w2 = a;
    a = w1;
    w3 = a;
   G0394:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0399;
    a = car(a);
    if(!is_cons(a)) goto    G0394;
    a = car(cdr(a));
    w4 = a;
    a = w2;
    a = Lcopy(a);
    q = a;
    a = w4;
    cdr(a) = q;
    q = w4;
    a = car(q);
    CC_seTdelete(a, q);
    goto    G0394;
   G0399:
    a = true;
    popv(4);
    return a;
}

Sex CC_gbEinsunpC(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = q;
    w3 = a;
    w2 = q;
   G0403:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0412;
    a = car(a);
    if(!is_cons(a)) goto    G0403;
    a = car(cdr(a));
    w4 = a;
    a = car(a);
    q = a;
    a = w1;
    a = Lequal(a, q);
    if(a != nil) goto    G0403;
    m = LL_lessp;
    q = w4;
    a = w1;
    CC_seTinsert(a, q, m);
    goto    G0403;
   G0412:
    a = true;
    popv(4);
    return a;
}

Sex CC_gbEdelunpC(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    a = q;
    w3 = a;
    w2 = q;
   G0416:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0425;
    a = car(a);
    if(!is_cons(a)) goto    G0416;
    a = car(cdr(a));
    w4 = a;
    a = car(a);
    q = a;
    a = w1;
    a = Lequal(a, q);
    if(a != nil) goto    G0416;
    q = w4;
    a = w1;
    CC_seTdelete(a, q);
    goto    G0416;
   G0425:
    a = true;
    popv(4);
    return a;
}

Sex CC_gbEinswset(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = car(a);
    w3 = a;
    a = q;
    w4 = a;
    w2 = q;
    a = cdr(a);
    w5 = a;
   G0429:
    if(a == nil) goto    G0433;
    m = value(LL_gbEorder);
    q = w3;
    a = car(car(a));
    a = CC_gbEordS(a, q, m);
    if(a != nil) goto    G0433;
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    goto    G0429;
   G0433:
    q = w5;
    a = w1;
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w4);
    popv(5);
    return a;
}

Sex CC_gbEpaircof(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    a = value(LL_gbEcoftype);
    w2 = q;
    if(a != LL_float) goto    G0440;
    a = w1;
    a = Lminus(a);
    q = w2;
    goto    G0451;
   G0440:
    if(a != LL_ratn) goto    G0442;
    a = w1;
    a = CC_gcdTbnumbnum(a, q);
    value(LL_Htemporal) = a;
    a = w1;
    a = Lminus(a);
    w1 = a;
    a = value(LL_Htemporal);
    a = Lonep(a);
    if(a == nil) goto    G0444;
    q = w1;
    a = w2;
    {
        popv(3);
        return  cons(a, q);
    }
   G0444:
    q = value(LL_Htemporal);
    a = w2;
    a = CC_divTbnumbnum(a, q);
    w3 = a;
    q = value(LL_Htemporal);
    a = w1;
    a = CC_divTbnumbnum(a, q);
    q = w3;
    goto    G0451;
   G0442:
    a = w1;
    a = Lminus(a);
    q = w2;
   G0451:
    {
        popv(3);
        return  Lxcons(a, q);
    }
}

Sex CC_gbEspol(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w14 = nil;
    w4 = nil;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w1 = a;
    a = cdr(a);
    w6 = a;
    w2 = q;
    w3 = m;
   G0455:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0465;
    a = LL_end;
    goto    G0454;
   G0465:
    a = car(cdr(car(a)));
    w8 = a;
    a = cdr(w1);
    w5 = a;
   G0456:
    a = car(cdr(car(w5)));
    w7 = a;
    q = w8;
    a = car(a);
    a = Lmemq(a, q);
    if(a == nil) goto    G0472;
    q = w8;
    a = car(w7);
    CC_seTdelete(a, q);
    q = w7;
    a = car(w8);
    CC_seTdelete(a, q);
    arg4 = nil;
    m = value(LL_gbEorder);
    q = car(car(w6));
    a = car(car(w5));
    a = CC_gbEgcdchk(a, q, m, arg4);
    w13 = a;
#define LL_yes LITERAL[90]
    q = LL_yes;
    a = Lneq(a, q);
    if(a != nil) goto    G0460;
    a = LITERAL[91];
    goto    G0527;
   G0470:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0472;
    Lterpri();
    a = LITERAL[92];
    Lprinc(a);
    a = car(w7);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w8);
    Lprin(a);
    a = LITERAL[94];
    Lprinc(a);
    a = w12;
    Lprinc(a);
    Lterpri();
   G0472:
    a = cdr(w5);
    w5 = a;
    q = w6;
    a = Lneq(a, q);
    if(a == nil) goto    G0455;
    goto    G0456;
   G0460:
    a = cdr(cdr(car(w5)));
    a = CC_gbElc(a);
    w9 = a;
    a = cdr(cdr(car(w6)));
    a = CC_gbElc(a);
    w10 = a;
    a = value(LL_gbEpars);
    if(a != nil) goto    G0476;
    q = w10;
    a = w9;
    a = CC_gbEpaircof(a, q);
    w11 = a;
    goto    G0477;
   G0476:
    a = w9;
    a = CC_gbElc(a);
    w14 = a;
    a = w10;
    a = CC_gbElc(a);
    q = a;
    a = w14;
    a = CC_gbEpaircof(a, q);
    w11 = a;
    q = car(a);
    a = car(cdr(w13));
    a = cons(a, q);
    q = a;
    a = car(w9);
    a = Llist2(a, q);
    w14 = a;
    q = cdr(w11);
    a = cdr(cdr(w13));
    a = cons(a, q);
    q = a;
    a = car(w10);
    a = Llist2(a, q);
    q = w14;
    a = Lxcons(a, q);
    w11 = a;
    a = car(w13);
    w13 = a;
   G0477:
    a = cdr(cdr(car(w5)));
    a = CC_gbErest(a);
    w9 = a;
    a = cdr(cdr(car(w6)));
    a = CC_gbErest(a);
    w10 = a;
    a = w9;
    a = Lzerop(a);
    if(a == nil) goto    G0485;
    a = w10;
    a = Lzerop(a);
    if(a == nil) goto    G0487;
    a = mkfxat(0);
    goto    G0490;
   G0487:
    m = w10;
    q = cdr(w11);
    a = cdr(w13);
    goto    G0526;
   G0485:
    a = w10;
    a = Lzerop(a);
    m = w9;
    q = car(w11);
    if(a == nil) goto    G0489;
    a = car(w13);
   G0526:
    a = CC_gbEtermHdist(a, q, m);
    goto    G0490;
   G0489:
    a = car(w13);
    a = CC_gbEtermHdist(a, q, m);
    w14 = a;
    m = w10;
    q = cdr(w11);
    a = cdr(w13);
    a = CC_gbEtermHdist(a, q, m);
    q = a;
    a = w14;
    a = CC_gbEdistLdist(a, q);
   G0490:
    w4 = a;
    a = Lzerop(a);
    if(a == nil) goto    G0494;
    a = LITERAL[95];
    goto    G0527;
   G0494:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0496;
    a = w3;
    a = Ladd1(a);
    w14 = a;
    q = car(w11);
    a = car(w13);
    a = cons(a, q);
    q = car(w7);
    a = Lxcons(a, q);
    w15 = a;
    q = cdr(w11);
    a = cdr(w13);
    a = cons(a, q);
    q = car(w8);
    a = Lxcons(a, q);
    arg4 = a;
    m = w15;
    q = w14;
#define LL_spol LITERAL[96]
    a = LL_spol;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G0496:
    a = value(LL_Htracmode);
#define LL_sttrac LITERAL[97]
    if(a != LL_sttrac) goto    G0503;
    Lterpri();
    a = LITERAL[98];
    Lprinc(a);
    a = car(w7);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w8);
    Lprin(a);
    a = LITERAL[99];
    Lprinc(a);
    Lterpri();
    a = LITERAL[100];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w4;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G0503:
    a = w3;
    a = Ladd1(a);
    a = Lncons(a);
    arg4 = a;
    m = cdr(w1);
    q = w1;
    a = w4;
    a = CC_gbEredpol(a, q, m, arg4);
    w12 = a;
    a = CC_Wlist(a);
    if(a != nil) goto    G0528;
#define LL_same LITERAL[101]
    a = LL_same;
    if(a == w12) goto    G0510;
    a = w12;
    a = Lzerop(a);
    if(a == nil) goto    G0509;
    a = LITERAL[102];
   G0527:
    w12 = a;
    goto    G0470;
   G0509:
    a = w3;
    a = Ladd1(a);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    a = mkfxat(1);
    goto    G0454;
   G0528:
    a = w12;
    w4 = a;
   G0510:
    a = w3;
    a = Ladd1(a);
    w3 = a;
#define LL_gbEhowsimp LITERAL[103]
    a = value(LL_gbEhowsimp);
    if(a == nil) goto    G0515;
    q = w3;
    a = w4;
    a = CC_gbEsimp(a, q);
    w4 = a;
   G0515:
    q = w3;
    a = w4;
    a = CC_gbEnormalz(a, q);
    w4 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0517;
    Lterpri();
    a = LITERAL[104];
    Lprinc(a);
    a = car(w7);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w8);
    Lprin(a);
    a = LITERAL[105];
    Lprinc(a);
    Lterpri();
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w4;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G0517:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0519;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G0519;
    Lterpri();
    a = LITERAL[106];
    Lprinc(a);
    q = w3;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    q = nil;
    CC_fprinTcano(a, q);
    Lterpri();
   G0519:
    a = w2;
    a = CC_tail(a);
    w14 = a;
    a = w3;
    a = Lncons(a);
    q = a;
    a = w14;
    cdr(a) = q;
    a = cdr(a);
    q = w1;
    a = w3;
    CC_gbEinsunpC(a, q);
    m = w2;
    q = w3;
    a = w4;
    a = CC_gbEmkwprep(a, q, m);
    w13 = a;
    q = w1;
    a = CC_gbEinswset(a, q);
    w5 = a;
   G0454:
    popv(15);
    return a;
}

Sex CC_gbEreduce(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a == nil) goto    G0569;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    a = q;
    w5 = a;
    w2 = q;
    w3 = m;
   G0535:
    a = cdr(w5);
    if(a != nil) goto    G0542;
   G0569:
    a = w1;
    goto    G0533;
   G0542:
    a = car(a);
    w4 = a;
    a = car(car(cdr(a)));
    w8 = a;
    q = cdr(cdr(w5));
    a = w5;
    cdr(a) = q;
    arg4 = w8;
    m = w2;
    q = w1;
    a = cdr(cdr(w4));
    a = CC_gbEredpol(a, q, m, arg4);
    w6 = a;
    if(is_cons(a)) goto    G0544;
    if(a == LL_same) goto    G0570;
    a = Lzerop(a);
    if(a != nil) goto    G0537;
    a = w8;
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    a = mkfxat(1);
    goto    G0533;
   G0544:
    a = w6;
    a = CC_gbEhex(a);
    q = car(w4);
    a = Lequal(a, q);
    if(a == nil) goto    G0538;
    q = w6;
    a = cdr(w4);
    cdr(a) = q;
   G0570:
    q = cdr(w5);
    a = w4;
    a = cons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(w5);
    w5 = a;
    goto    G0535;
   G0537:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0558;
    Lterpri();
    a = LITERAL[107];
    Lprinc(a);
    a = w8;
    Lprin(a);
    a = LITERAL[108];
    Lprinc(a);
    Lterpri();
   G0558:
    q = w3;
    a = w8;
    CC_seTdelete(a, q);
    q = w1;
    a = w8;
    CC_gbEdelunpC(a, q);
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0535;
    a = w8;
    CC_gbEsyzyclear(a);
    goto    G0535;
   G0538:
    a = value(LL_gbEhowsimp);
    if(a == nil) goto    G0562;
    q = w8;
    a = w6;
    a = CC_gbEsimp(a, q);
    w6 = a;
   G0562:
    q = w8;
    a = w6;
    a = CC_gbEnormalz(a, q);
    w6 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G0564;
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = w8;
    Lprin(a);
    a = LITERAL[109];
    Lprinc(a);
    Lterpri();
    a = LITERAL[100];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w6;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G0564:
    m = w3;
    q = w8;
    a = w6;
    a = CC_gbEmkwprep(a, q, m);
    w4 = a;
    q = w1;
    a = w8;
    CC_gbEinsunpC(a, q);
    q = w1;
    a = w4;
    a = CC_gbEinswset(a, q);
    w5 = a;
    m = value(LL_gbEorder);
    q = car(car(w2));
    a = car(car(a));
    a = CC_gbEirred(a, q, m);
    if(a == nil) goto    G0566;
    a = w5;
    w2 = a;
   G0566:
    a = w4;
    a = CC_gbEstop(a);
    if(a == nil) goto    G0535;
    a = LL_stop;
   G0533:
    popv(10);
    return a;
}

Sex CC_gbEredpol(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w5 = a;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
   G0574:
    a = w1;
    a = CC_gbEhex(a);
    w6 = a;
    q = LL_float;
    a = value(LL_gbEcoftype);
    a = Lneq(a, q);
    if(a != nil) goto    G0575;
#define LL_gbEtol LITERAL[110]
    a = value(LL_gbEtol);
    if(a == nil) goto    G0575;
    a = Lzerop(a);
    if(a != nil) goto    G0575;
    q = value(LL_gbEtol);
    a = w1;
    a = CC_gbEdelSmall(a, q);
    w10 = a;
    if(a == w1) goto    G0575;
    a = value(LL_Htracmode);
    if(a != LL_untrac) goto    G0584;
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G0640;
    a = true;
    w11 = a;
    a = w10;
    w1 = a;
    goto    G0589;
   G0584:
    a = w10;
    a = Lzerop(a);
    if(a == nil) goto    G0588;
    Lterpri();
    a = LITERAL[111];
    Lprinc(a);
    a = LITERAL[112];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w1;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    goto    G0640;
   G0588:
    a = true;
    w11 = a;
    a = w10;
    w1 = a;
    Lterpri();
    a = LITERAL[111];
    Lprinc(a);
    a = LITERAL[113];
    Lprinc(a);
    a = w1;
   G0589:
    a = CC_gbEhex(a);
    w6 = a;
   G0575:
    a = cdr(cdr(car(w3)));
    w7 = a;
    if(a == w5) goto    G0578;
    m = value(LL_gbEorder);
    q = car(car(w3));
    a = w6;
    a = CC_gbEirred(a, q, m);
    if(a != nil) goto    G0578;
    a = value(LL_gbEredtype);
    m = nil;
    q = w7;
    if(a != LL_head) goto    G0594;
    a = w1;
    a = CC_gbEhred(a, q, m);
    goto    G0595;
   G0594:
    a = w1;
    a = CC_gbEfred(a, q, m);
   G0595:
    w10 = a;
    if(a != LL_same) goto    G0597;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0578;
    goto    G0575;
   G0597:
    a = cdr(w10);
    w1 = a;
    a = car(w10);
    w8 = a;
    a = w1;
    a = Lzerop(a);
    if(a != nil) goto    G0640;
    a = cdr(w1);
    if(a == nil) goto    G0603;
    a = cdr(a);
    if(a != nil) goto    G0606;
   G0603:
    a = car(car(cdr(w1)));
    a = CC_Wzerolist(a);
    if(a == nil) goto    G0606;
    a = w4;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    a = cdr(a);
    a = mkfxat(1);
    goto    G0573;
   G0606:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0610;
    a = car(car(cdr(car(w3))));
    w9 = a;
    a = w4;
    w10 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G0612;
    a = car(w10);
    w10 = a;
   G0612:
    q = w8;
    a = w9;
    a = cons(a, q);
    arg4 = a;
    m = nil;
    q = w10;
#define LL_mred LITERAL[114]
    a = LL_mred;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G0610:
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G0621;
    a = w4;
    a = CC_Wlist(a);
    if(a == nil) goto    G0617;
    a = value(LL_gbEredtype);
#define LL_full LITERAL[115]
    if(a != LL_full) goto    G0619;
    a = LITERAL[116];
    goto    G0620;
   G0619:
    a = LITERAL[117];
   G0620:
    w9 = a;
    Lterpri();
    a = LITERAL[118];
    Lprinc(a);
    a = w9;
    goto    G0641;
   G0617:
    a = value(LL_gbEredtype);
    if(a != LL_full) goto    G0623;
    a = LITERAL[119];
    goto    G0624;
   G0623:
    a = LITERAL[120];
   G0624:
    w9 = a;
    Lterpri();
    a = LITERAL[118];
    Lprinc(a);
    a = w9;
    Lprinc(a);
    a = w4;
    Lprin(a);
    a = LITERAL[121];
   G0641:
    Lprinc(a);
    a = car(car(cdr(car(w3))));
    Lprin(a);
   G0621:
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G0626;
   G0640:
    a = mkfxat(0);
    goto    G0573;
   G0626:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G0628;
    Lterpri();
    a = LITERAL[100];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w1;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G0628:
    a = true;
    w11 = a;
    a = cdr(w2);
    w3 = a;
    goto    G0574;
   G0578:
    a = w11;
    if(a != nil) goto    G0630;
    a = LL_same;
    goto    G0573;
   G0630:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0632;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G0632;
    Lterpri();
    a = LITERAL[106];
    Lprinc(a);
    a = w4;
    w10 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G0635;
    a = car(w10);
    w10 = a;
   G0635:
    q = w10;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w10 = a;
    q = nil;
    CC_fprinTcano(a, q);
    Lterpri();
   G0632:
    a = w1;
   G0573:
    popv(11);
    return a;
}

Sex CC_gbEhred(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w5 = nil;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w12 = nil;
    w13 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    if(a == nil) goto    G0653;
    a = value(LL_gbEordpar);
    goto    G0654;
   G0653:
    a = value(LL_gbEorder);
   G0654:
    w4 = a;
    a = car(cdr(q));
    w9 = a;
    a = q;
    a = CC_gbEhex(a);
    w10 = a;
    a = w1;
    w5 = a;
    q = cdr(cdr(w2));
    a = car(w2);
    a = cons(a, q);
    w2 = a;
    a = w3;
    if(a != nil) goto    G0657;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0656;
   G0657:
    a = w4;
    a = Lncons(a);
    w7 = a;
    w6 = a;
   G0656:
    a = car(cdr(w5));
    w8 = a;
    a = w5;
    a = CC_gbEhex(a);
    m = w4;
    q = w10;
    a = CC_gbEredchk(a, q, m);
    w11 = a;
#define LL_no LITERAL[122]
    if(a == LL_no) goto    G0651;
    a = w3;
    if(a != nil) goto    G0665;
    a = value(LL_gbEpars);
    if(a == nil) goto    G0665;
    m = true;
    q = cdr(w9);
    a = cdr(w8);
    a = CC_gbEhred(a, q, m);
    w13 = a;
    if(a == LL_same) goto    G0651;
    a = car(a);
    w12 = a;
    a = cdr(w13);
    w13 = a;
    a = w6;
    if(a == nil) goto    G0649;
    q = w12;
    a = w11;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    goto    G0649;
   G0665:
    a = value(LL_gbEcoftype);
#define LL_int LITERAL[123]
    if(a == LL_int) goto    G0648;
   G0666:
    m = cdr(w9);
    q = cdr(w8);
    a = value(LL_gbEquoti);
    a = Lfuncall2(a, q, m);
    q = a;
    a = value(LL_gbEneg);
    a = Lfuncall1(a, q);
    w12 = a;
    a = w6;
    if(a == nil) goto    G0648;
    q = w12;
    a = w11;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
   G0648:
    a = mkfxat(0);
    w13 = a;
   G0649:
    a = w13;
    a = Lzerop(a);
    if(a == nil) goto    G0681;
    q = cdr(cdr(w5));
    a = car(w5);
    a = cons(a, q);
    goto    G0682;
   G0681:
    q = w13;
    a = car(w8);
    a = cons(a, q);
    q = cdr(cdr(w5));
    a = cons(a, q);
    q = car(w5);
    a = Lxcons(a, q);
   G0682:
    w5 = a;
    a = cdr(w2);
    if(a == nil) goto    G0650;
    a = cdr(w5);
    m = w2;
    q = w12;
    if(a != nil) goto    G0688;
    a = w11;
    a = CC_gbEtermHdist(a, q, m);
    goto    G0689;
   G0688:
    a = w11;
    a = CC_gbEtermHdist(a, q, m);
    q = a;
    a = w5;
    a = CC_gbEdistLdist(a, q);
   G0689:
    w5 = a;
   G0650:
    a = w5;
    a = Lzerop(a);
    if(a != nil) goto    G0692;
    a = cdr(w5);
    if(a != nil) goto    G0656;
   G0692:
    q = mkfxat(0);
    a = w6;
    {
        popv(13);
        return  cons(a, q);
    }
   G0651:
    a = w5;
    a = CC_Wlist(a);
    if(a == nil) goto    G0696;
    a = cdr(w5);
    if(a != nil) goto    G0696;
    a = mkfxat(0);
    w5 = a;
   G0696:
    a = w5;
    if(a != w1) goto    G0699;
    a = LL_same;
    goto    G0644;
   G0699:
    q = w6;
    a = Lxcons(a, q);
   G0644:
    popv(13);
    return a;
}

Sex CC_gbEfred(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w10 = nil;
    w9 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w7 = nil;
    w8 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    if(a == nil) goto    G0716;
    a = value(LL_gbEordpar);
    goto    G0717;
   G0716:
    a = value(LL_gbEorder);
   G0717:
    w4 = a;
    a = car(w1);
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = car(cdr(w2));
    w10 = a;
    q = cdr(cdr(w2));
    a = car(w2);
    a = cons(a, q);
    w2 = a;
    a = w3;
    if(a != nil) goto    G0720;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G0719;
   G0720:
    a = w4;
    a = Lncons(a);
    w8 = a;
    w7 = a;
   G0719:
    a = car(cdr(w1));
    w9 = a;
    m = value(LL_gbEorder);
    q = car(w10);
    a = car(a);
    a = CC_gbEirred(a, q, m);
    if(a != nil) goto    G0763;
    m = w4;
    q = car(w10);
    a = car(w9);
    a = CC_gbEredchk(a, q, m);
    w11 = a;
    if(a == LL_no) goto    G0731;
    a = w3;
    if(a != nil) goto    G0729;
    a = value(LL_gbEpars);
    if(a != nil) goto    G0710;
   G0729:
    a = value(LL_gbEcoftype);
    if(a != LL_int) goto    G0736;
    goto    G0711;
   G0731:
    a = w9;
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    q = cdr(cdr(w1));
    a = car(w1);
    a = cons(a, q);
    w1 = a;
    a = cdr(a);
    goto    G0772;
   G0710:
    m = true;
    q = cdr(w10);
    a = cdr(w9);
    a = CC_gbEfred(a, q, m);
    w13 = a;
    if(a == LL_same) goto    G0731;
    a = car(a);
    w12 = a;
    a = cdr(w13);
    w13 = a;
    a = w7;
    if(a == nil) goto    G0712;
    q = w12;
    a = w11;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
    goto    G0712;
   G0736:
    m = cdr(w10);
    q = cdr(w9);
    a = value(LL_gbEquoti);
    a = Lfuncall2(a, q, m);
    q = a;
    a = value(LL_gbEneg);
    a = Lfuncall1(a, q);
    w12 = a;
    a = w7;
    if(a == nil) goto    G0711;
    q = w12;
    a = w11;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
   G0711:
    a = mkfxat(0);
    w13 = a;
   G0712:
    a = w13;
    a = Lzerop(a);
    if(a != nil) goto    G0751;
    q = w13;
    a = car(w9);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G0751:
    q = cdr(cdr(w1));
    a = car(w1);
    a = cons(a, q);
    w1 = a;
    a = true;
    w14 = a;
    a = cdr(w2);
    if(a == nil) goto    G0713;
    a = cdr(w1);
    m = w2;
    q = w12;
    if(a != nil) goto    G0758;
    a = w11;
    a = CC_gbEtermHdist(a, q, m);
    goto    G0759;
   G0758:
    a = w11;
    a = CC_gbEtermHdist(a, q, m);
    q = a;
    a = w1;
    a = CC_gbEdistLdist(a, q);
   G0759:
    w1 = a;
   G0713:
    a = w1;
    a = Lzerop(a);
    if(a != nil) goto    G0763;
    a = cdr(w1);
   G0772:
    if(a != nil) goto    G0719;
   G0763:
    a = w14;
    if(a != nil) goto    G0765;
    a = LL_same;
    goto    G0706;
   G0765:
    a = w1;
    a = CC_Wlist(a);
    if(a == nil) goto    G0767;
    q = cdr(w1);
    a = w6;
    cdr(a) = q;
   G0767:
    a = cdr(w5);
    if(a != nil) goto    G0769;
    a = mkfxat(0);
    w5 = a;
   G0769:
    q = w5;
    a = w7;
    a = cons(a, q);
   G0706:
    popv(14);
    return a;
}

Sex CC_gbEnum2dist(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = q;
    a = Llength(a);
    a = CC_listzero(a);
    w5 = a;
    q = w1;
    a = cons(a, q);
    q = a;
    a = w3;
    a = Llist2(a, q);
    w4 = a;
    a = w3;
    if(a != LL_lex) goto    G0780;
    a = w4;
    goto    G0776;
   G0780:
    q = a;
    a = w4;
    a = CC_gbElex2tord(a, q);
   G0776:
    popv(5);
    return a;
}

Sex CC_gbEpoly2dist(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = w2;
    arg5 = w5;
    arg4 = w6;
    if(a != value(LL_gbEpars)) goto    G0787;
    m = nil;
    q = value(LL_gbEpars);
    goto    G0793;
   G0787:
    m = value(LL_gbEpars);
    q = a;
   G0793:
    a = cdr(w1);
    CC_gbEbpol2dist(a, q, m, arg4, arg5);
    a = w3;
    if(a != LL_lex) goto    G0790;
    a = w4;
    goto    G0785;
   G0790:
    q = a;
    a = w4;
    a = CC_gbElex2tord(a, q);
   G0785:
    popv(6);
    return a;
}

Sex CC_gbEbpol2dist(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
   G0831:
    w1 = a;
    a = q;
    if(a != nil) goto    G0797;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = m;
    if(a == nil) goto    G0799;
    q = w1;
#define LL_CpolyC LITERAL[124]
    a = value(LL_CpolyC);
    a = cons(a, q);
    m = value(LL_gbEordpar);
    q = w3;
    a = CC_gbEpoly2dist(a, q, m);
    w1 = a;
   G0799:
    a = w4;
    a = Lreverse(a);
    q = w1;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    {
        popv(9);
        return cdr(a);
    }
   G0797:
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = car(a);
    a = car(w1);
    a = Lequal(a, q);
    if(a != nil) goto    G0805;
    q = w4;
    a = mkfxat(0);
    a = cons(a, q);
    arg5 = w5;
    arg4 = a;
    m = w3;
    q = cdr(w2);
    a = w1;
    goto    G0831;  /* recursive call to gb%bpol2dist */
   G0805:
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = cdr(w1);
    w6 = a;
    a = cdr(w2);
    w2 = a;
   G0809:
    q = w4;
    a = car(car(w6));
    a = cons(a, q);
    w8 = a;
    a = cdr(car(w6));
    w7 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0815;
    a = car(w7);
    a = CC_Wtag(a);
    if(a != nil) goto    G0815;
    arg5 = w5;
    arg4 = w8;
    m = w3;
    q = w2;
    a = w7;
    a = CC_gbEbpol2dist(a, q, m, arg4, arg5);
    w5 = a;
    goto    G0812;
    q = w7;
    a = mkfxat(2);
    a = cons(a, q);
    m = value(LL_gbEordpar);
    q = value(LL_gbEpars);
    goto    G0830;
   G0815:
    a = w2;
    w9 = a;
    a = w3;
    if(a == nil) goto    G0819;
    q = w7;
    a = mkfxat(0);
    a = cons(a, q);
    q = a;
    a = car(w3);
    a = Llist2(a, q);
    q = mkfxat(2);
    a = Lxcons(a, q);
    w7 = a;
    m = value(LL_gbEordpar);
    q = w3;
   G0830:
    a = CC_gbEpoly2dist(a, q, m);
    w7 = a;
   G0819:
    a = w9;
    if(a == nil) goto    G0823;
    q = w8;
    a = mkfxat(0);
    a = cons(a, q);
    w8 = a;
    a = cdr(w9);
    w9 = a;
    goto    G0819;
   G0823:
    a = w8;
    a = Lreverse(a);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G0812:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0809;
    a = w5;
    popv(9);
    return a;
}

Sex CC_gbElex2tord(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    a = q;
#define LL_pser LITERAL[125]
    if(a != LL_pser) goto    G0837;
    a = cdr(w1);
    goto    G0838;
   G0837:
    a = cdr(w1);
    a = Lreverse(a);
   G0838:
    w3 = a;
    a = w2;
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = car(car(w3));
    w4 = a;
    a = w2;
    if(a == LL_lex) goto    G0847;
#define LL_tdeg LITERAL[126]
    if(a != LL_tdeg) goto    G0841;
    a = w4;
    a = CC_sumelms(a);
    q = w4;
    a = cons(a, q);
    goto    G0882;
   G0841:
    if(a != LL_pser) goto    G0843;
    a = w4;
    a = CC_sumelms(a);
    a = Lminus(a);
    w9 = a;
    a = w4;
    a = CC_listneg(a);
    q = w9;
    a = Lxcons(a, q);
    goto    G0882;
   G0843:
    a = w4;
    a = CC_sumelms(a);
    w9 = a;
    a = w4;
    a = Lreverse(a);
    a = CC_seTlistneg(a);
    q = w9;
    a = Lxcons(a, q);
   G0882:
    w4 = a;
   G0847:
    q = cdr(car(w3));
    a = w4;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
   G0834:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G0885;
    a = car(car(a));
    w4 = a;
    a = w2;
    if(a == LL_lex) goto    G0864;
    if(a != LL_tdeg) goto    G0858;
    a = w4;
    a = CC_sumelms(a);
    q = w4;
    a = cons(a, q);
    goto    G0884;
   G0858:
    if(a != LL_pser) goto    G0860;
    a = w4;
    a = CC_sumelms(a);
    a = Lminus(a);
    w9 = a;
    a = w4;
    a = CC_listneg(a);
    q = w9;
    a = Lxcons(a, q);
    goto    G0884;
   G0860:
    a = w4;
    a = CC_sumelms(a);
    w9 = a;
    a = w4;
    a = Lreverse(a);
    a = CC_seTlistneg(a);
    q = w9;
    a = Lxcons(a, q);
   G0884:
    w4 = a;
   G0864:
    q = car(car(w7));
    a = w4;
    a = CC_Slis(a, q);
    if(a == nil) goto    G0869;
    a = w5;
    w6 = a;
    a = cdr(a);
    w7 = a;
   G0869:
    q = car(car(w7));
    a = w4;
    a = CC_Slis(a, q);
    if(a == nil) goto    G0872;
    q = cdr(car(w3));
    a = w4;
    a = cons(a, q);
    q = w7;
    a = cons(a, q);
    w7 = a;
    q = a;
    a = w6;
    cdr(a) = q;
    goto    G0834;
   G0872:
    a = w7;
    w6 = a;
    a = cdr(a);
    w7 = a;
    if(a != nil) goto    G0869;
    q = cdr(car(w3));
    a = w4;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    goto    G0834;
   G0885:
    a = w5;
    popv(9);
    return a;
}

Sex CC_gbEdist2poly(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_gbEdist2bpol(a, q, m);
    w4 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0891;
    a = car(w4);
    a = CC_Wtag(a);
    if(a == nil) goto    G0890;
   G0891:
    a = w4;
    goto    G0888;
   G0890:
    q = w4;
    a = value(LL_CpolyC);
    a = cons(a, q);
   G0888:
    popv(4);
    return a;
}

Sex CC_gbEdist2bpol(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    a = cdr(a);
    w5 = a;
    w2 = q;
    w3 = m;
    a = w3;
    if(a != LL_lex) goto    G0905;
    a = w5;
    a = Lreverse(a);
    w6 = a;
    goto    G0901;
   G0905:
    if(a != LL_tdeg) goto    G0906;
   G0908:
    q = cdr(car(w5));
    a = cdr(car(car(w5)));
    a = cons(a, q);
    q = w6;
    a = cons(a, q);
    w6 = a;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G0901;
    goto    G0908;
   G0906:
#define LL_trev LITERAL[127]
    if(a != LL_trev) goto    G0900;
   G0899:
    a = cdr(car(car(w5)));
    a = Lreverse(a);
    a = CC_seTlistneg(a);
    q = cdr(car(w5));
    a = cons(a, q);
    q = w6;
    a = cons(a, q);
    w6 = a;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G0901;
    goto    G0899;
   G0900:
    a = cdr(car(car(w5)));
    a = CC_listneg(a);
    q = cdr(car(w5));
    a = cons(a, q);
    q = w6;
    a = cons(a, q);
    w6 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G0900;
   G0901:
    a = cdr(car(w6));
    w7 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0925;
    a = car(w7);
    a = CC_Wtag(a);
    if(a != nil) goto    G0925;
    m = value(LL_gbEordpar);
    q = value(LL_gbEpars);
    a = w7;
    a = CC_gbEdist2bpol(a, q, m);
    w7 = a;
   G0925:
    m = w7;
    q = car(car(w6));
    a = w2;
    a = CC_gbEmkmono(a, q, m);
    w8 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0928;
    a = car(w8);
    a = CC_Wtag(a);
    if(a == nil) goto    G0927;
   G0928:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G0930;
    a = w8;
    w4 = a;
    goto    G0901;
   G0930:
    a = w8;
    goto    G0896;
   G0927:
    a = w4;
    if(a != nil) goto    G0932;
    a = w8;
    goto    G0950;
   G0932:
    a = CC_Wbnum(a);
    q = w8;
    if(a == nil) goto    G0933;
    a = w4;
    a = CC_seLbnumbpol(a, q);
    goto    G0950;
   G0933:
    a = w4;
    a = CC_seLpol3bpol(a, q);
    goto    G0950;
   G0902:
    a = cdr(car(w6));
    w7 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0939;
    a = car(w7);
    a = CC_Wtag(a);
    if(a != nil) goto    G0939;
    m = value(LL_gbEordpar);
    q = value(LL_gbEpars);
    a = w7;
    a = CC_gbEdist2bpol(a, q, m);
    w7 = a;
   G0939:
    m = w7;
    q = car(car(w6));
    a = w2;
    a = CC_gbEmkmono(a, q, m);
    w8 = a;
    q = car(a);
    a = car(w4);
    a = Lequal(a, q);
    if(a == nil) goto    G0941;
    q = w4;
    a = w8;
    a = CC_seLbpolbpolTvarvar(a, q);
    goto    G0950;
   G0941:
    q = car(w8);
    a = car(w4);
    a = CC_WorderTvar(a, q);
    if(a == nil) goto    G0942;
    q = w4;
    a = w8;
    a = CC_seLbpolbpolTcofvar(a, q);
    goto    G0950;
   G0942:
    q = w8;
    a = w4;
    a = CC_seLbpolbpolTcofvar(a, q);
   G0950:
    w4 = a;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G0902;
    a = w4;
   G0896:
    popv(9);
    return a;
}

Sex CC_gbEchgVarorder(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = car(a);
    w3 = a;
    a = cdr(w1);
    w4 = a;
    w2 = q;
    a = w3;
    if(a != LL_lex) goto    G0959;
    a = w4;
    a = Lreverse(a);
    w5 = a;
    goto    G0957;
   G0959:
    if(a != LL_tdeg) goto    G0960;
   G0962:
    q = cdr(car(w4));
    a = cdr(car(car(w4)));
    a = cons(a, q);
    q = w5;
    a = cons(a, q);
    w5 = a;
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0957;
    goto    G0962;
   G0960:
    if(a != LL_trev) goto    G0956;
   G0955:
    a = cdr(car(car(w4)));
    a = Lreverse(a);
    a = CC_seTlistneg(a);
    q = cdr(car(w4));
    a = cons(a, q);
    q = w5;
    a = cons(a, q);
    w5 = a;
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G0957;
    goto    G0955;
   G0956:
    a = cdr(car(car(w4)));
    a = CC_listneg(a);
    q = cdr(car(w4));
    a = cons(a, q);
    q = w5;
    a = cons(a, q);
    w5 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G0956;
   G0957:
    q = w5;
    a = LL_lex;
    a = cons(a, q);
    q = w2;
    a = CC_gbElex2tord(a, q);
    w1 = a;
    popv(5);
    return a;
}

Sex CC_gbEmkmono(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = nil;
   G0984:
    if(a != nil) goto    G0979;
    a = m;
    goto    G0981;
   G0979:
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(q);
    a = Lzerop(a);
    if(a == nil) goto    G0980;
    m = w3;
    q = cdr(w2);
    a = cdr(w1);
    goto    G0984;  /* recursive call to gb%mkmono */
   G0980:
    m = w3;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_gbEmkmono(a, q, m);
    q = car(w2);
    a = Lxcons(a, q);
    q = a;
    a = car(w1);
    a = Llist2(a, q);
   G0981:
    popv(3);
    return a;
}

Sex CC_gbEdistLdist(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a == nil) goto    G0987;
    a = w2;
    goto    G0989;
   G0987:
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G0988;
    a = w1;
    goto    G0989;
   G0988:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    a = w1;
    a = CC_gbElc(a);
    w10 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G0998;
    a = car(w10);
    a = CC_Wtag(a);
    if(a == nil) goto    G0997;
   G0998:
    a = value(LL_gbEadd);
    goto    G1000;
   G0997:
#define LL_gbEdistLdist LITERAL[128]
    a = LL_gbEdistLdist;
   G1000:
    w3 = a;
    a = car(w1);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w1);
    w6 = a;
    a = cdr(w2);
    w7 = a;
    a = car(car(w6));
    w8 = a;
    a = car(car(w7));
    w9 = a;
   G0991:
    q = w9;
    a = w8;
    a = Lequal(a, q);
    if(a != nil) goto    G0994;
    q = w8;
    a = w9;
    a = CC_Slis(a, q);
    if(a != nil) goto    G0993;
    a = car(w6);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G1007;
    a = car(car(a));
    w8 = a;
    goto    G0991;
   G1007:
    q = w7;
    a = w5;
    cdr(a) = q;
    goto    G1029;
   G0993:
    a = car(w7);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G1012;
    a = car(car(a));
    goto    G1028;
   G1012:
    q = w6;
    a = w5;
    cdr(a) = q;
    goto    G1029;
   G0994:
    m = cdr(car(w7));
    q = cdr(car(w6));
    a = w3;
    a = Lfuncall2(a, q, m);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1015;
    q = w10;
    a = w8;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G1015:
    a = cdr(w6);
    w6 = a;
    a = cdr(w7);
    w7 = a;
    a = w6;
    if(a != nil) goto    G1020;
    q = w7;
    goto    G1030;
   G1020:
    a = w7;
    if(a == nil) goto    G1031;
    a = car(car(w6));
    w8 = a;
    a = car(car(w7));
   G1028:
    w9 = a;
    goto    G0991;
   G1031:
    q = w6;
   G1030:
    a = w5;
    cdr(a) = q;
    a = cdr(w4);
    if(a == nil) goto    G1024;
   G1029:
    a = w4;
    goto    G0989;
   G1024:
    a = mkfxat(0);
   G0989:
    popv(10);
    return a;
}

Sex CC_gbEdistHdist(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = Lzerop(a);
    if(a != nil) goto    G1036;
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G1035;
   G1036:
    a = mkfxat(0);
    goto    G1037;
   G1035:
    w3 = nil;
    w4 = nil;
    a = cdr(w1);
    w3 = a;
    a = mkfxat(0);
    w4 = a;
   G1039:
    m = w2;
    q = cdr(car(w3));
    a = car(car(w3));
    a = CC_gbEtermHdist(a, q, m);
    q = w4;
    a = CC_gbEdistLdist(a, q);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1039;
    a = w4;
   G1037:
    popv(4);
    return a;
}

Sex CC_gbEseTdistLdist(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a != nil) goto    G1046;
    a = q;
    goto    G1048;
   G1046:
    a = cdr(q);
    if(a != nil) goto    G1047;
    a = w1;
    goto    G1048;
   G1047:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w2 = q;
    a = w1;
    a = CC_gbElc(a);
    w8 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1055;
    a = car(w8);
    a = CC_Wtag(a);
    if(a == nil) goto    G1054;
   G1055:
    a = value(LL_gbEadd);
    goto    G1057;
   G1054:
#define LL_gbEseTdistLdist LITERAL[129]
    a = LL_gbEseTdistLdist;
   G1057:
    w3 = a;
    a = w1;
    w4 = a;
    a = w2;
    w6 = a;
    a = cdr(a);
    w7 = a;
   G1050:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G1077;
    a = w7;
    if(a != nil) goto    G1078;
    q = w4;
    a = w6;
    cdr(a) = q;
    goto    G1077;
   G1078:
    a = car(car(w4));
    w5 = a;
   G1062:
    q = car(car(w7));
    a = w5;
    a = Lequal(a, q);
    if(a != nil) goto    G1069;
    q = car(car(w7));
    a = w5;
    a = CC_Slis(a, q);
    if(a == nil) goto    G1065;
    q = w7;
    a = car(w4);
    a = cons(a, q);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(w6);
    w6 = a;
    goto    G1050;
   G1069:
    m = cdr(car(w7));
    q = cdr(car(w4));
    a = w3;
    a = Lfuncall2(a, q, m);
    w8 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1072;
    a = cdr(w8);
    if(a != nil) goto    G1071;
   G1072:
    a = cdr(w7);
    w7 = a;
    q = a;
    a = w6;
    cdr(a) = q;
    goto    G1050;
   G1071:
    q = w8;
    a = car(car(w7));
    a = cons(a, q);
    w8 = a;
    q = a;
    a = w7;
    car(a) = q;
    a = w7;
    w6 = a;
    a = cdr(a);
    w7 = a;
    goto    G1050;
   G1065:
    a = w7;
    w6 = a;
    a = cdr(a);
    w7 = a;
    if(a != nil) goto    G1062;
    q = w4;
    a = w6;
    cdr(a) = q;
   G1077:
    a = w2;
   G1048:
    popv(8);
    return a;
}

Sex CC_gbEtermHdist(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G1082;
    q = w3;
    a = w2;
    {
        popv(7);
        return  CC_gbEcofHdist(a, q);
    }
   G1082:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    a = car(w3);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w3);
    w6 = a;
    a = w2;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1092;
    a = car(w2);
    a = CC_Wtag(a);
    if(a == nil) goto    G1089;
   G1092:
    m = cdr(car(w6));
    q = w2;
    a = value(LL_gbEmult);
    a = Lfuncall2(a, q, m);
    w7 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1094;
    q = car(car(w6));
    a = w1;
    a = CC_listsum(a, q);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G1094:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G1119;
    goto    G1092;
   G1089:
    a = cdr(cdr(w2));
    if(a != nil) goto    G1087;
    a = car(cdr(w2));
    w2 = a;
   G1086:
    m = cdr(car(w6));
    q = cdr(w2);
    a = car(w2);
    a = CC_gbEtermHdist(a, q, m);
    w7 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1103;
    q = car(car(w6));
    a = w1;
    a = CC_listsum(a, q);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G1103:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G1119;
    goto    G1086;
   G1087:
    q = cdr(car(w6));
    a = w2;
    a = CC_gbEdistHdist(a, q);
    w7 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1112;
    q = car(car(w6));
    a = w1;
    a = CC_listsum(a, q);
    q = w7;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G1112:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G1087;
   G1119:
    a = w4;
    popv(7);
    return a;
}

Sex CC_gbEcofHdist(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    a = car(q);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w2);
    w5 = a;
    a = w1;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1132;
    a = car(w1);
    a = CC_Wtag(a);
    if(a == nil) goto    G1129;
   G1132:
    m = cdr(car(w5));
    q = w1;
    a = value(LL_gbEmult);
    a = Lfuncall2(a, q, m);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1134;
    q = w6;
    a = car(car(w5));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1134:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G1156;
    goto    G1132;
   G1129:
    a = cdr(cdr(w1));
    if(a != nil) goto    G1127;
    a = car(cdr(w1));
    w1 = a;
   G1126:
    m = cdr(car(w5));
    q = cdr(w1);
    a = car(w1);
    a = CC_gbEtermHdist(a, q, m);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1142;
    q = w6;
    a = car(car(w5));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1142:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G1156;
    goto    G1126;
   G1127:
    q = cdr(car(w5));
    a = w1;
    a = CC_gbEdistHdist(a, q);
    w6 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1150;
    q = w6;
    a = car(car(w5));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G1150:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G1127;
   G1156:
    a = w3;
    popv(6);
    return a;
}

Sex CC_gbEhex(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = cdr(car(cdr(a)));
    value(LL_Htemporal) = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1163;
    a = car(value(LL_Htemporal));
    a = CC_Wtag(a);
    if(a == nil) goto    G1162;
   G1163:
    a = car(car(cdr(w1)));
    goto    G1165;
   G1162:
    q = car(car(cdr(value(LL_Htemporal))));
    a = car(car(cdr(w1)));
    a = cons(a, q);
   G1165:
    popv(1);
    return a;
}

Sex CC_gbEhc(Sex a)
{
    a = cdr(car(cdr(a)));
    value(LL_Htemporal) = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1170;
    a = car(value(LL_Htemporal));
    a = CC_Wtag(a);
    if(a == nil) goto    G1169;
   G1170:
    a = value(LL_Htemporal);
    goto    G1172;
   G1169:
    a = cdr(car(cdr(value(LL_Htemporal))));
   G1172:
    return a;
}

Sex CC_gbElc(Sex a)
{
    a = cdr(car(cdr(a)));
    return a;
}

Sex CC_gbErest(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(car(cdr(a)));
    value(LL_Htemporal) = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1179;
    a = car(value(LL_Htemporal));
    a = CC_Wtag(a);
    if(a == nil) goto    G1178;
   G1179:
    a = cdr(cdr(w1));
    if(a != nil) goto    G1192;
    a = mkfxat(0);
    goto    G1184;
   G1178:
    w2 = nil;
    w3 = nil;
    a = car(cdr(w1));
    w2 = a;
    a = cdr(cdr(cdr(a)));
    w3 = a;
    if(a != nil) goto    G1187;
    q = cdr(cdr(w1));
    a = car(w1);
    {
        popv(3);
        return  cons(a, q);
    }
   G1187:
    q = car(cdr(w2));
    a = Lxcons(a, q);
    q = car(w2);
    a = Lxcons(a, q);
    w2 = a;
    q = cdr(cdr(w1));
    a = cons(a, q);
   G1192:
    q = car(w1);
    a = Lxcons(a, q);
   G1184:
    popv(3);
    return a;
}

Sex CC_gbEhexS(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = car(a);
    a = CC_Watom(a);
    w3 = nil;
    if(a == nil) goto    G1196;
    value(LL_Htemporal) = nil;
   G1198:
    q = car(w2);
    a = car(w1);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1200;
    a = true;
    goto    G1204;
   G1196:
    q = car(w2);
    a = car(w1);
    a = CC_gbEhexS(a, q);
    w3 = a;
    a = value(LL_Htemporal);
    if(a == nil) goto    G1212;
    q = cdr(w2);
    a = cdr(w1);
    a = CC_gbEhexS(a, q);
    w3 = a;
    a = value(LL_Htemporal);
    if(a != nil) goto    G1209;
   G1212:
    a = w3;
    goto    G1204;
   G1200:
    q = car(w2);
    a = car(w1);
    a = Llessp(a, q);
    if(a != nil) goto    G1209;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    a = w1;
    if(a != nil) goto    G1198;
    a = CHAR_OF(61);
    value(LL_Htemporal) = a;
   G1209:
    a = nil;
   G1204:
    popv(3);
    return a;
}

Sex CC_gbEirred(Sex a, Sex q, Sex m)
{
    Sex arg4;
    arg4 = q;
    q = a;
    a = arg4;
    {
        return  CC_gbEordS(a, q, m);
    }
}

Sex CC_gbEordS(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = car(a);
    w2 = q;
    if(is_cons(a)) goto    G1218;
    q = LL_pser;
    a = m;
    a = Lneq(a, q);
    if(a == nil) goto    G1220;
    q = w2;
    a = w1;
    goto    G1227;
   G1220:
    q = car(w2);
    a = car(w1);
    a = Llessp(a, q);
    if(a == nil) goto    G1221;
    a = nil;
    goto    G1225;
   G1221:
    q = car(w2);
    a = car(w1);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1228;
    q = cdr(w2);
    a = cdr(w1);
   G1227:
    {
        popv(2);
        return  CC_Slis(a, q);
    }
   G1218:
    q = car(q);
    a = CC_gbEordS(a, q, m);
    if(a == nil) goto    G1224;
   G1228:
    a = true;
    goto    G1225;
   G1224:
    q = car(w2);
    a = car(w1);
    a = Lequal(a, q);
    if(a == nil) goto    G1225;
    m = value(LL_gbEordpar);
    q = cdr(w2);
    a = cdr(w1);
    a = CC_gbEordS(a, q, m);
   G1225:
    popv(2);
    return a;
}

Sex CC_gbEredchk(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    a = car(a);
    a = CC_Watom(a);
    if(a == nil) goto    G1232;
    m = w3;
    q = w2;
    a = w1;
    a = CC_gbEredchk0(a, q, m);
    if(a == nil) goto    G1237;
    q = w2;
    a = w1;
    goto    G1240;
   G1232:
    m = value(LL_gbEorder);
    q = car(w2);
    a = car(w1);
    a = CC_gbEredchk0(a, q, m);
    if(a == nil) goto    G1237;
    m = value(LL_gbEordpar);
    q = cdr(w2);
    a = cdr(w1);
    a = CC_gbEredchk0(a, q, m);
    if(a != nil) goto    G1236;
   G1237:
    a = LL_no;
    goto    G1238;
   G1236:
    q = car(w2);
    a = car(w1);
   G1240:
    a = CC_listdiff(a, q);
   G1238:
    popv(3);
    return a;
}

Sex CC_gbEredchk0(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = m;
    if(a == LL_lex) goto    G1256;
    q = car(q);
    if(a != LL_pser) goto    G1248;
    a = car(w1);
    a = Lgreaterp(a, q);
    goto    G1265;
   G1248:
    a = car(w1);
    a = Llessp(a, q);
   G1265:
    if(a != nil) goto    G1267;
   G1253:
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    a = w3;
    if(a != LL_tdeg) goto    G1245;
   G1256:
    q = car(w2);
    a = car(w1);
    a = Llessp(a, q);
    if(a != nil) goto    G1267;
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    a = w1;
    if(a == nil) goto    G1264;
    goto    G1256;
   G1245:
    q = car(w2);
    a = car(w1);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1262;
   G1267:
    a = nil;
    goto    G1243;
   G1262:
    a = cdr(w1);
    w1 = a;
    a = cdr(w2);
    w2 = a;
    a = w1;
    if(a != nil) goto    G1245;
   G1264:
    a = true;
   G1243:
    popv(4);
    return a;
}

Sex CC_gbEgcdchk(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = car(a);
    a = CC_Watom(a);
    w5 = nil;
    w6 = nil;
    if(a == nil) goto    G1272;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = w4;
    if(a == nil) goto    G1276;
    w5 = a;
    goto    G1282;
   G1276:
    a = w3;
    if(a != LL_lex) goto    G1278;
    q = w2;
    a = w1;
    goto    G1308;
   G1278:
    q = cdr(w2);
    if(a != LL_tdeg) goto    G1279;
    a = cdr(w1);
   G1308:
    a = CC_listmin(a, q);
    goto    G1280;
   G1279:
    a = cdr(w1);
    a = CC_listmax(a, q);
   G1280:
    w5 = a;
    a = CC_Wzerolist(a);
    if(a != nil) goto    G1306;
   G1282:
    a = w3;
    q = w5;
    if(a != LL_lex) goto    G1284;
    a = w1;
    a = CC_listdiff(a, q);
    w6 = a;
    q = w5;
    a = w2;
    goto    G1310;
   G1284:
    a = cdr(w1);
    a = CC_listdiff(a, q);
    w6 = a;
    q = w5;
    a = cdr(w2);
   G1310:
    a = CC_listdiff(a, q);
    w7 = a;
    a = w3;
    if(a != LL_lex) goto    G1287;
    q = w6;
    a = w7;
    {
        popv(10);
        return  cons(a, q);
    }
   G1287:
    a = w6;
    a = CC_sumelms(a);
    w8 = a;
    a = w7;
    a = CC_sumelms(a);
    w9 = a;
    a = w3;
    if(a != LL_trev) goto    G1290;
    a = w8;
    a = Lminus(a);
    w8 = a;
    a = w9;
    a = Lminus(a);
    w9 = a;
   G1290:
    q = w7;
    a = w9;
    a = cons(a, q);
    w10 = a;
    q = w6;
    a = w8;
    a = cons(a, q);
    q = w10;
    goto    G1311;
   G1272:
    a = value(LL_gbEorder);
    if(a != LL_lex) goto    G1297;
    q = car(w2);
    a = car(w1);
    goto    G1312;
   G1297:
    q = cdr(car(w2));
    if(a != LL_tdeg) goto    G1298;
    a = cdr(car(w1));
   G1312:
    a = CC_listmin(a, q);
    goto    G1299;
   G1298:
    a = cdr(car(w1));
    a = CC_listmax(a, q);
   G1299:
    w5 = a;
    a = value(LL_gbEordpar);
    if(a != LL_lex) goto    G1301;
    q = cdr(w2);
    a = cdr(w1);
    goto    G1313;
   G1301:
    q = cdr(cdr(w2));
    if(a != LL_tdeg) goto    G1302;
    a = cdr(cdr(w1));
   G1313:
    a = CC_listmin(a, q);
    goto    G1303;
   G1302:
    a = cdr(cdr(w1));
    a = CC_listmax(a, q);
   G1303:
    w6 = a;
    a = w5;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G1305;
    a = w6;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G1305;
   G1306:
    a = LL_yes;
    goto    G1294;
   G1305:
    arg4 = w5;
    m = value(LL_gbEorder);
    q = car(w2);
    a = car(w1);
    a = CC_gbEgcdchk(a, q, m, arg4);
    w5 = a;
    arg4 = w6;
    m = value(LL_gbEordpar);
    q = cdr(w2);
    a = cdr(w1);
    a = CC_gbEgcdchk(a, q, m, arg4);
    w6 = a;
    q = w5;
   G1311:
    a = Lxcons(a, q);
   G1294:
    popv(10);
    return a;
}

Sex CC_gbEcoeftype(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    a = mkfxat(1);
    w2 = a;
   G1317:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G1318;
    a = mkfxat(1);
    value(LL_Hchkcoef) = a;
    q = cdr(car(w1));
    CC_ncoftypTbpol(a, q);
    q = value(LL_Hchkcoef);
    a = w2;
    a = Lmax2(a, q);
    w2 = a;
    goto    G1317;
   G1318:
    q = mkfxat(1);
    a = w2;
    a = Leqn(a, q);
    if(a == nil) goto    G1323;
    a = LL_AZ;
    goto    G1316;
   G1323:
    q = mkfxat(2);
    a = w2;
    a = Leqn(a, q);
    if(a == nil) goto    G1324;
    a = LL_AQ;
    goto    G1316;
   G1324:
    q = mkfxat(3);
    a = w2;
    a = Leqn(a, q);
    if(a == nil) goto    G1325;
#define LL_AA LITERAL[130]
    a = LL_AA;
    goto    G1316;
   G1325:
    q = mkfxat(4);
    a = w2;
    a = Leqn(a, q);
    if(a == nil) goto    G1326;
    a = LL_AF;
    goto    G1316;
   G1326:
    a = LL_AC;
   G1316:
    popv(2);
    return a;
}

Sex CC_gbEnorm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_gbEpars);
    if(a != nil) goto    G1332;
    q = mkfxat(0);
    a = w1;
    {
        popv(3);
        return  CC_gbEnrm(a, q);
    }
   G1332:
    w2 = nil;
    w3 = nil;
    a = mkfxat(0);
    w2 = a;
    a = w1;
    w3 = a;
   G1335:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G1338;
    q = w2;
    a = cdr(car(a));
    a = CC_gbEnrm(a, q);
    w2 = a;
    goto    G1335;
   G1338:
    a = w2;
    popv(3);
    return a;
}

Sex CC_gbErnorm(Sex a)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = nil;
    a = CC_gbErest(a);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1342;
    a = mkfxat(0);
    goto    G1345;
   G1342:
#define LL_gbEFprec LITERAL[131]
    a = value(LL_gbEFprec);
    if(a == nil) goto    G1344;
    a = w1;
    {
        popv(1);
        return  CC_gbEfnorm(a);
    }
   G1344:
    a = w1;
    a = CC_gbEnorm(a);
   G1345:
    popv(1);
    return a;
}

Sex CC_gbEnrm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = a;
    w1 = a;
    w2 = q;
   G1349:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G1353;
    a = cdr(car(a));
    a = Labs(a);
    q = a;
    a = w2;
    a = Lmax2(a, q);
    w2 = a;
    goto    G1349;
   G1353:
    a = w2;
    popv(3);
    return a;
}

Sex CC_gbEnormalz(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_gbEhc(a);
    w3 = a;
    a = Lonep(a);
    if(a != nil) goto    G1360;
    q = w3;
    a = mkfxat(1);
    a = CC_flgdivTbnumbnum(a, q);
    w3 = a;
    q = w1;
    a = CC_gbEnumHdist(a, q);
    w1 = a;
   G1360:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G1363;
    arg4 = nil;
    m = w3;
    q = w2;
#define LL_nmlz LITERAL[132]
    a = LL_nmlz;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G1363:
    a = w1;
    popv(3);
    return a;
}

Sex CC_gbEFnormlz0(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    q = a;
    a = mkfxat(1);
    a = quot2(a, q);
    w3 = a;
    q = w1;
    a = CC_gbEnumHdist(a, q);
    w1 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G1369;
    arg4 = nil;
    m = w3;
    q = w2;
    a = LL_nmlz;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G1369:
    a = w1;
    popv(3);
    return a;
}

Sex CC_gbEcofmaxmin(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_gbEpars);
    if(a != nil) goto    G1373;
    a = mkfxat(0);
    a = Lncons(a);
    q = a;
    a = w1;
    {
        popv(3);
        return  CC_gbEcofmxmn(a, q);
    }
   G1373:
    w2 = nil;
    w3 = nil;
    a = mkfxat(0);
    a = Lncons(a);
    w2 = a;
    a = w1;
    w3 = a;
   G1377:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G1380;
    q = w2;
    a = cdr(car(a));
    CC_gbEcofmxmn(a, q);
    goto    G1377;
   G1380:
    a = w2;
    popv(3);
    return a;
}

Sex CC_gbEcofmxmn(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = a;
    w1 = a;
    w2 = q;
   G1384:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G1393;
    a = cdr(car(a));
    a = Labs(a);
    w4 = a;
    q = car(w2);
    a = Lmax2(a, q);
    q = a;
    a = w2;
    car(a) = q;
    a = cdr(w2);
    if(a != nil) goto    G1389;
    q = w4;
    goto    G1392;
   G1389:
    q = a;
    a = w4;
    a = Lmin2(a, q);
    q = a;
   G1392:
    a = w2;
    cdr(a) = q;
    goto    G1384;
   G1393:
    a = w2;
    popv(4);
    return a;
}

Sex CC_gbEnumHdist(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_gbEpars);
    w3 = nil;
    w4 = nil;
    w5 = nil;
    if(a != nil) goto    G1397;
    w2 = q;
    a = car(q);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = w2;
    w5 = a;
   G1399:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G1401;
    a = w3;
    goto    G1406;
   G1401:
    q = cdr(car(a));
    a = w1;
    a = times2(a, q);
    q = car(car(w5));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G1399;
   G1397:
    w6 = nil;
    w3 = a;
    value(LL_gbEpars) = nil;
    w2 = q;
    a = car(q);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(w2);
    w6 = a;
   G1408:
    q = cdr(car(w6));
    a = w1;
    a = CC_gbEcofHdist(a, q);
    q = car(car(w6));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G1408;
    a = w3;
    value(LL_gbEpars) = a;
    a = w4;
   G1406:
    popv(6);
    return a;
}

Sex CC_gbEwset2polyset(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w5 = nil;
    w1 = a;
    a = LL_Bset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = w1;
    w4 = a;
   G1418:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G1427;
    a = car(a);
    if(!is_cons(a)) goto    G1418;
    a = cdr(cdr(a));
    w5 = a;
    if(!is_cons(a)) goto    G1424;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = CC_gbEdist2poly(a, q, m);
    w5 = a;
   G1424:
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    goto    G1418;
   G1427:
    a = w2;
    popv(5);
    return a;
}

Sex CC_gbEsyzyupdate(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    if(a == LL_mred) goto    G1432;
    if(a == LL_spol) goto    G1433;
    a = w3;
    a = CC_ONEp(a);
    if(a == nil) goto    G1438;
    q = w2;
    a = value(LL_gbEsyzygy);
    {
        popv(12);
        return  Lgetv(a, q);
    }
   G1438:
    q = w2;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    q = a;
    a = w3;
    a = CC_multH(a, q);
    goto    G1447;
   G1432:
    q = car(w4);
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w8 = a;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = cdr(w4);
    a = CC_gbEdist2poly(a, q, m);
    w10 = a;
    q = w2;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w12 = a;
    q = w8;
    a = w10;
    a = CC_multH(a, q);
    q = a;
    a = w12;
    a = CC_addH(a, q);
   G1447:
    w11 = a;
    m = a;
    q = w2;
    a = value(LL_gbEsyzygy);
    Lputv(a, q, m);
    goto    G1448;
   G1433:
    q = car(w3);
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w5 = a;
    q = cdr(w3);
    a = value(LL_gbEorder);
    a = Llist2(a, q);
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = CC_gbEdist2poly(a, q, m);
    w7 = a;
    q = car(w4);
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w8 = a;
    q = cdr(w4);
    a = value(LL_gbEorder);
    a = Llist2(a, q);
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = CC_gbEdist2poly(a, q, m);
    w10 = a;
    q = w5;
    a = w7;
    a = CC_multH(a, q);
    w12 = a;
    q = w8;
    a = w10;
    a = CC_multH(a, q);
    q = a;
    a = w12;
    a = CC_addH(a, q);
    w11 = a;
    m = a;
    q = w2;
    a = value(LL_gbEsyzygy);
    CC_gbEsyzysave(a, q, m);
   G1448:
    a = w11;
    popv(12);
    return a;
}

Sex CC_gbEsyzyclear(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G1453;
    m = nil;
    q = w1;
    a = Lputv(a, q, m);
   G1453:
    popv(1);
    return a;
}

Sex CC_gbEsyzysave(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = Lupbv(a);
    q = a;
    a = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G1457;
    m = w3;
    q = w2;
    a = w1;
    goto    G1469;
   G1457:
    w4 = nil;
    w5 = nil;
    w6 = nil;
    q = mkfxat(100);
    a = w2;
    a = plus2(a, q);
    a = Lmkvect(a);
    w4 = a;
    value(LL_gbEsyzygy) = a;
    a = mkfxat(1);
    w5 = a;
   G1461:
    q = w5;
    a = w1;
    a = Lgetv(a, q);
    w6 = a;
    if(a == nil) goto    G1464;
    m = a;
    q = w5;
    a = w4;
    Lputv(a, q, m);
   G1464:
    a = w5;
    a = Ladd1(a);
    w5 = a;
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G1461;
    m = w3;
    q = w2;
    a = value(LL_gbEsyzygy);
   G1469:
    {
        popv(6);
        return  Lputv(a, q, m);
    }
}

Sex CC_gbEsyzy2polyset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_gbEsyzygy);
    if(a != nil) goto    G1473;
    a = LL_Anil;
    goto    G1474;
   G1473:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = LL_Bset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = w1;
    w4 = a;
   G1476:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G1481;
    q = car(car(cdr(car(a))));
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w5 = a;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    goto    G1476;
   G1481:
    a = w2;
   G1474:
    popv(5);
    return a;
}

Sex CC_gbEstop(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(car(a));
    a = CC_Watom(a);
    if(a == nil) goto    G1487;
    a = car(w1);
    goto    G1488;
   G1487:
    a = car(car(w1));
   G1488:
    a = CC_Wzerolist(a);
    if(a == nil) goto    G1490;
    w2 = nil;
    w3 = nil;
    a = car(w1);
    w2 = a;
    a = car(a);
    a = CC_Watom(a);
    if(a != nil) goto    G1505;
    a = value(LL_gbEcoftype);
    if(a == LL_float) goto    G1505;
#define LL_gbEhowstop LITERAL[133]
    a = value(LL_gbEhowstop);
#define LL_var LITERAL[134]
    if(a == LL_var) goto    G1493;
#define LL_par LITERAL[135]
    if(a == LL_par) goto    G1496;
    a = cdr(w2);
    a = CC_Wzerolist(a);
    if(a == nil) goto    G1490;
   G1505:
    a = LITERAL[136];
    w3 = a;
    a = mkfxat(1);
    w1 = a;
    goto    G1499;
   G1493:
#define LL_gbEcutvar LITERAL[137]
    a = value(LL_gbEcutvar);
    if(a == nil) goto    G1495;
    a = value(LL_gbEordpar);
    if(a != LL_tdeg) goto    G1508;
    a = car(cdr(w2));
    goto    G1534;
   G1508:
    if(a != LL_pser) goto    G1509;
    a = car(cdr(w2));
    a = Lminus(a);
    goto    G1534;
   G1509:
    a = cdr(w2);
    a = CC_sumelms(a);
    a = Labs(a);
   G1534:
    w3 = a;
    a = w3;
    a = Lzerop(a);
    if(a != nil) goto    G1505;
    q = value(LL_gbEcutvar);
    a = w3;
    a = Lgeq(a, q);
    if(a != nil) goto    G1537;
   G1515:
    a = LITERAL[138];
    goto    G1536;
   G1495:
    a = LITERAL[139];
   G1536:
    w3 = a;
    goto    G1499;
   G1496:
    a = cdr(w2);
    w2 = a;
    q = LL_lex;
    a = value(LL_gbEordpar);
    a = Lneq(a, q);
    if(a == nil) goto    G1517;
    a = cdr(w2);
    w2 = a;
   G1517:
    a = car(w2);
    a = Lzerop(a);
    if(a == nil) goto    G1519;
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G1505;
    goto    G1517;
   G1519:
    a = cdr(w2);
    if(a != nil) goto    G1537;
#define LL_gbEcutpar LITERAL[140]
    a = value(LL_gbEcutpar);
    if(a == nil) goto    G1498;
    q = a;
    a = car(w2);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1515;
   G1537:
    a = nil;
    goto    G1490;
   G1498:
    a = LITERAL[141];
    w3 = a;
   G1499:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1528;
    Lterpri();
    a = LITERAL[142];
    Lprinc(a);
    a = w3;
    Lprinc(a);
    Lterpri();
    a = LITERAL[143];
    Lprinc(a);
    Lterpri();
    Lterpri();
   G1528:
    a = w1;
    a = Lonep(a);
    if(a == nil) goto    G1530;
    a = mkfxat(1);
    goto    G1490;
   G1530:
    a = LL_stop;
   G1490:
    popv(3);
    return a;
}

Sex CC_gbEsimp(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_gbEcoftype);
    if(a == LL_int) goto    G1635;
    a = value(LL_gbEhowsimp);
    if(a == nil) goto    G1635;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w2 = q;
    a = mkfxat(1);
    w6 = a;
    a = value(LL_gbEpars);
    if(a == nil) goto    G1547;
    a = cdr(w1);
    w7 = a;
    a = w7;
    a = Lcaddar(a);
    w8 = a;
    a = car(a);
    w4 = a;
    a = cdr(w8);
    w5 = a;
    a = CC_Wfloat(a);
    if(a == nil) goto    G1554;
    a = mkfxat(1);
    w5 = a;
   G1554:
    a = value(LL_gbEhowsimp);
    if(a != nil) goto    G1557;
    a = mkfxat(1);
    goto    G1636;
   G1557:
    q = LL_lex;
    a = value(LL_gbEordpar);
    a = Lneq(a, q);
    if(a == nil) goto    G1558;
    q = cdr(w4);
    a = mkfxat(0);
    a = cons(a, q);
   G1636:
    w4 = a;
   G1558:
    m = w5;
    q = w4;
    a = cdr(car(w7));
    a = CC_gbEmnfctr(a, q, m);
    w8 = a;
    a = Lonep(a);
    if(a == nil) goto    G1560;
    a = mkfxat(1);
    goto    G1637;
   G1560:
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G1562;
    a = car(w8);
    w4 = a;
    a = cdr(w8);
    w5 = a;
    goto    G1558;
   G1562:
    a = w8;
   G1637:
    w6 = a;
    w7 = nil;
   G1547:
    a = value(LL_gbEpars);
    if(a != nil) goto    G1565;
    a = car(cdr(w1));
    w8 = a;
    a = cdr(a);
    w5 = a;
    a = value(LL_gbEhowsimp);
    if(a != LL_var) goto    G1567;
    a = car(w8);
    goto    G1568;
   G1567:
    a = mkfxat(1);
   G1568:
    w4 = a;
    goto    G1570;
   G1565:
    a = value(LL_gbEhowsimp);
    if(a == LL_var) goto    G1646;
    a = mkfxat(1);
    w4 = a;
    goto    G1638;
   G1646:
    a = car(car(cdr(w1)));
    w4 = a;
    a = mkfxat(1);
    w5 = a;
   G1570:
    a = cdr(cdr(w1));
    if(a != nil) goto    G1572;
    a = mkfxat(1);
    w4 = a;
   G1572:
    a = w5;
    a = CC_Wfloat(a);
    if(a == nil) goto    G1574;
    a = mkfxat(1);
    w5 = a;
   G1574:
    a = w4;
    a = CC_Wlist(a);
    if(a == nil) goto    G1576;
    q = LL_lex;
    a = value(LL_gbEorder);
    a = Lneq(a, q);
    if(a == nil) goto    G1576;
    q = cdr(w4);
    a = mkfxat(0);
    a = cons(a, q);
    w4 = a;
   G1576:
    m = w5;
    q = w4;
    a = w1;
    a = CC_gbEmnfctr(a, q, m);
    w8 = a;
    a = Lonep(a);
    if(a == nil) goto    G1579;
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G1582;
   G1635:
    a = w1;
    goto    G1543;
   G1582:
    a = mkfxat(1);
    w5 = a;
    w4 = a;
    goto    G1584;
   G1579:
    a = car(w8);
    w4 = a;
    a = cdr(w8);
   G1638:
    w5 = a;
   G1584:
    a = value(LL_gbEpars);
    if(a != nil) goto    G1586;
    a = w5;
    w3 = a;
    a = CC_recipH(a);
    goto    G1640;
   G1586:
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G1587;
    a = mkfxat(0);
    a = Lncons(a);
    q = mkfxat(1);
    a = cons(a, q);
    q = a;
    a = value(LL_gbEordpar);
    a = Llist2(a, q);
    w3 = a;
    goto    G1640;
   G1587:
    a = cdr(w6);
    w3 = a;
    a = CC_recipH(a);
    w5 = a;
    a = car(w6);
    w6 = a;
    a = Lonep(a);
    if(a == nil) goto    G1592;
    a = mkfxat(0);
    a = Lncons(a);
    goto    G1642;
   G1592:
    a = value(LL_gbEordpar);
    if(a != LL_lex) goto    G1593;
    a = w6;
    w8 = a;
    w7 = a;
    goto    G1594;
   G1593:
    a = cdr(w6);
    w7 = a;
    a = CC_sumelms(a);
    w8 = a;
    a = value(LL_gbEordpar);
    if(a != LL_tdeg) goto    G1596;
    q = w7;
    a = w8;
    a = cons(a, q);
    goto    G1642;
   G1596:
    a = w8;
    a = Lminus(a);
    q = w7;
    a = cons(a, q);
   G1642:
    w8 = a;
   G1594:
    q = w3;
    a = w8;
    a = cons(a, q);
    q = a;
    a = value(LL_gbEordpar);
    a = Llist2(a, q);
    w3 = a;
    w9 = nil;
    a = w8;
    goto    G1601;
   G1600:
    w10 = a;
    a = car(a);
    a = Lminus(a);
    q = w9;
    a = cons(a, q);
    w9 = a;
    a = cdr(w10);
   G1601:
    if(a != nil) goto    G1600;
    a = w9;
    a = Lnreverse(a);
    q = w5;
    a = cons(a, q);
    q = a;
    a = value(LL_gbEordpar);
    a = Llist2(a, q);
   G1640:
    w5 = a;
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G1607;
    a = mkfxat(0);
    a = Lncons(a);
    q = w3;
    a = cons(a, q);
    q = a;
    a = value(LL_gbEorder);
    a = Llist2(a, q);
    w3 = a;
    q = w7;
    a = nil;
    a = cons(a, q);
    w7 = a;
    goto    G1610;
   G1607:
    a = value(LL_gbEorder);
    if(a != LL_lex) goto    G1612;
    a = w4;
    w8 = a;
    q = w7;
    a = cons(a, q);
    w7 = a;
    goto    G1613;
   G1612:
    a = cdr(w4);
    w4 = a;
    q = w7;
    a = cons(a, q);
    w7 = a;
    a = w4;
    a = CC_sumelms(a);
    w8 = a;
    a = value(LL_gbEorder);
    if(a != LL_tdeg) goto    G1615;
    q = w4;
    a = w8;
    goto    G1643;
   G1615:
    a = w8;
    a = Lminus(a);
    q = w4;
   G1643:
    a = cons(a, q);
    w4 = a;
   G1613:
    q = w3;
    a = w4;
    a = cons(a, q);
    q = a;
    a = value(LL_gbEorder);
    a = Llist2(a, q);
    w3 = a;
    w9 = nil;
    a = w4;
    goto    G1620;
   G1619:
    w10 = a;
    a = car(a);
    a = Lminus(a);
    q = w9;
    a = cons(a, q);
    w9 = a;
    a = cdr(w10);
   G1620:
    if(a != nil) goto    G1619;
    a = w9;
    a = Lnreverse(a);
    w4 = a;
   G1610:
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G1624;
    a = w6;
    a = Lonep(a);
    if(a != nil) goto    G1549;
   G1624:
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G1549;
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G1627;
    a = value(LL_gbEpars);
    w8 = a;
    a = cdr(w7);
    goto    G1645;
   G1627:
    a = w6;
    a = Lonep(a);
    if(a == nil) goto    G1628;
    a = value(LL_gbEvars);
    w8 = a;
    a = car(w7);
    goto    G1645;
   G1628:
    q = value(LL_gbEpars);
    a = value(LL_gbEvars);
    a = Lappend(a, q);
    w8 = a;
    q = cdr(w7);
    a = car(w7);
    a = Lappend(a, q);
   G1645:
    w7 = a;
    Lterpri();
    a = LITERAL[144];
    Lprinc(a);
    q = w8;
    a = w7;
    CC_gbEprimono(a, q);
    a = LITERAL[145];
    Lprinc(a);
    a = w2;
    Lprint(a);
   G1549:
    a = w4;
    a = Lonep(a);
    if(a == nil) goto    G1631;
    q = w1;
    a = w5;
    {
        popv(10);
        return  CC_gbEcofHdist(a, q);
    }
   G1631:
    m = w1;
    q = w5;
    a = w4;
    a = CC_gbEtermHdist(a, q, m);
   G1543:
    popv(10);
    return a;
}

Sex CC_gbEmnfctr(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = cdr(a);
    w4 = a;
    w2 = q;
    w3 = m;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G1656;
    a = w3;
    a = Lonep(a);
    if(a == nil) goto    G1653;
    goto    G1684;
   G1656:
    a = w3;
    a = Lonep(a);
    if(a != nil) goto    G1651;
   G1660:
    q = car(car(w4));
    a = w2;
    a = CC_listmin(a, q);
    w2 = a;
    m = cdr(car(w4));
    q = w3;
    a = value(LL_gbEgcd);
    a = Lfuncall2(a, q, m);
    w3 = a;
    a = w2;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G1662;
    a = w3;
    a = Lonep(a);
    if(a == nil) goto    G1676;
    goto    G1684;
   G1662:
    a = w3;
    a = Lonep(a);
    if(a != nil) goto    G1670;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1660;
    q = w3;
    goto    G1683;
   G1651:
    q = car(car(w4));
    a = w2;
    a = CC_listmin(a, q);
    w2 = a;
    a = CC_Wzerolist(a);
    if(a != nil) goto    G1684;
   G1670:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1651;
    q = mkfxat(1);
   G1683:
    a = w2;
    goto    G1685;
   G1653:
    m = cdr(car(w4));
    q = w3;
    a = value(LL_gbEgcd);
    a = Lfuncall2(a, q, m);
    w3 = a;
    a = Lonep(a);
    if(a == nil) goto    G1676;
   G1684:
    a = mkfxat(1);
    goto    G1649;
   G1676:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G1653;
    q = w3;
    a = mkfxat(1);
   G1685:
    a = cons(a, q);
   G1649:
    popv(4);
    return a;
}

Sex CC_gbEepscof(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_gbEpars);
    if(a != nil) goto    G1689;
    a = cdr(w1);
    {
        popv(3);
        return  CC_gbEepscf(a, q);
    }
   G1689:
    w3 = nil;
    a = w1;
    w3 = a;
    w2 = q;
   G1692:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G1690;
    q = w2;
    a = cdr(cdr(car(a)));
    a = CC_gbEepscf(a, q);
    if(a == nil) goto    G1692;
    a = true;
   G1690:
    popv(3);
    return a;
}

Sex CC_gbEepscf(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G1702;
    w1 = a;
    w2 = q;
    a = cdr(car(a));
    a = Labs(a);
    q = w2;
    a = Llessp(a, q);
    if(a == nil) goto    G1700;
    a = true;
    goto    G1702;
   G1700:
    q = w2;
    a = cdr(w1);
    a = CC_gbEepscf(a, q);
   G1702:
    popv(2);
    return a;
}

Sex CC_gbEflessp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    a = Lfloat(a);
    a = Labs(a);
    q = w1;
    {
        popv(1);
        return  Llessp(a, q);
    }
}

Sex CC_gbEcutterm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = value(LL_gbEpars);
    if(a != nil) goto    G1710;
    a = w1;
    {
        popv(5);
        return  CC_gbEcuttrm(a, q);
    }
   G1710:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    a = w1;
    w3 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w1 = a;
   G1713:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1715;
    a = cdr(w1);
    if(a == nil) goto    G1717;
    a = w1;
    goto    G1711;
   G1715:
    q = w2;
    a = cdr(car(a));
    a = CC_gbEcuttrm(a, q);
    w5 = a;
    a = Lzerop(a);
    if(a != nil) goto    G1713;
    a = w5;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G1713;
   G1717:
    a = mkfxat(0);
   G1711:
    popv(5);
    return a;
}

Sex CC_gbEcuttrm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = nil;
    w3 = a;
    w2 = q;
    a = car(a);
    a = Lncons(a);
    w4 = a;
    w1 = a;
   G1727:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1729;
    a = cdr(w1);
    if(a == nil) goto    G1731;
    a = w1;
    goto    G1726;
   G1729:
    a = cdr(car(a));
    a = Labs(a);
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G1727;
    a = car(w3);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G1727;
   G1731:
    a = mkfxat(0);
   G1726:
    popv(4);
    return a;
}

Sex CC_gbEsmallp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 1;
    w1 = q;
    a = CC_gbEnorm(a);
    q = w1;
    {
        popv(1);
        return  Llessp(a, q);
    }
}

Sex CC_gbEdelSmall(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w7 = nil;
    w3 = nil;
    w4 = nil;
    w1 = a;
    a = cdr(a);
    w5 = a;
    w2 = q;
   G1745:
    a = cdr(car(w5));
    w6 = a;
    a = Lefloat_error(a);
    w7 = a;
    a = w6;
    a = Lefloat_value(a);
    q = a;
    a = w7;
    a = quot2(a, q);
    a = Labs(a);
    w6 = a;
    q = w2;
    a = times2(a, q);
    q = value(LL_Hmachineps);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1751;
    a = w3;
    if(a != nil) goto    G1756;
    q = w5;
    a = w1;
    a = CC_copyto(a, q);
    w3 = a;
    a = value(LL_Htemporal);
    goto    G1766;
   G1751:
    a = w3;
    if(a == nil) goto    G1756;
    a = car(w5);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
   G1766:
    w4 = a;
   G1756:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G1745;
    a = w3;
    if(a != nil) goto    G1762;
    a = w1;
    goto    G1744;
   G1762:
    a = cdr(a);
    if(a == nil) goto    G1763;
    a = w3;
    goto    G1744;
   G1763:
    a = mkfxat(0);
   G1744:
    popv(7);
    return a;
}

Sex CC_gbEprint(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(is_cons(a)) goto    G1770;
    {
        popv(11);
        return  Lprin(a);
    }
   G1770:
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    a = cdr(a);
    w6 = a;
    a = q;
    if(a != value(LL_gbEpars)) goto    G1776;
    a = true;
    w11 = a;
    a = car(arg4);
    w9 = a;
    goto    G1777;
   G1776:
    a = mkfxat(0);
    w9 = a;
    a = Lncons(a);
    w5 = a;
    w4 = a;
   G1777:
    a = value(LL_gbEcoftype);
    if(a != LL_float) goto    G1780;
    Lterpri();
   G1780:
    a = w3;
    if(a != LL_lex) goto    G1782;
    a = car(car(w6));
    goto    G1786;
   G1782:
    if(a != LL_tdeg) goto    G1783;
    a = cdr(car(car(w6)));
    goto    G1786;
   G1783:
    if(a != LL_trev) goto    G1784;
    a = cdr(car(car(w6)));
    a = Lreverse(a);
    a = CC_seTlistneg(a);
    goto    G1786;
   G1784:
    a = cdr(car(car(w6)));
    a = CC_listneg(a);
   G1786:
    w7 = a;
    a = cdr(car(w6));
    w8 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G1789;
    a = w8;
    if(a != nil) goto    G1788;
   G1789:
    a = w8;
    a = CC_Wminus(a);
    if(a == nil) goto    G1792;
    a = LITERAL[146];
    Lprinc(a);
    a = w8;
    a = Lminus(a);
    w8 = a;
    a = true;
    w10 = a;
    goto    G1793;
   G1792:
    a = w10;
    if(a == nil) goto    G1793;
    a = LITERAL[147];
    Lprinc(a);
   G1793:
    a = w8;
    a = CC_Wint(a);
    if(a == nil) goto    G1797;
    q = mkfxat(10000000);
    a = w8;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1799;
   G1797:
    a = w8;
    a = CC_Wratn(a);
    if(a == nil) goto    G1795;
    a = w8;
    a = Lnum(a);
    q = mkfxat(10000000);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1799;
    a = w8;
    a = Lden(a);
    q = mkfxat(10000000);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G1795;
   G1799:
    a = w10;
    if(a == nil) goto    G1803;
    a = LITERAL[148];
    Lprinc(a);
   G1803:
    a = LITERAL[149];
    Lprinc(a);
    a = w9;
    a = Ladd1(a);
    w9 = a;
    Lprin(a);
    a = w8;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    goto    G1810;
   G1795:
    a = w8;
    if(a != nil) goto    G1807;
    a = w10;
    if(a == nil) goto    G1809;
    a = LITERAL[148];
    Lprinc(a);
   G1809:
    a = LITERAL[149];
    Lprinc(a);
    goto    G1810;
   G1807:
    a = w10;
    if(a == nil) goto    G1812;
    a = LITERAL[148];
    Lprinc(a);
   G1812:
    a = w8;
    Lprin(a);
   G1810:
    q = w2;
    a = w7;
    CC_gbEprimono(a, q);
    a = true;
    w10 = a;
    goto    G1813;
   G1788:
    a = w10;
    if(a == nil) goto    G1815;
    a = LITERAL[147];
    Lprinc(a);
    goto    G1816;
   G1815:
    a = true;
    w10 = a;
   G1816:
    q = w2;
    a = w7;
    CC_gbEprimono(a, q);
    a = LITERAL[148];
    Lprinc(a);
    a = LITERAL[150];
    Lprinc(a);
    a = car(w8);
    a = CC_Wtag(a);
    if(a == nil) goto    G1818;
    q = w10;
    a = w8;
    CC_fprinTcano(a, q);
    goto    G1819;
   G1818:
    arg5 = w5;
    arg4 = w4;
    m = value(LL_gbEordpar);
    q = value(LL_gbEpars);
    a = w8;
    CC_gbEprint(a, q, m, arg4, arg5);
    a = w5;
    a = CC_tail(a);
    w5 = a;
   G1819:
    a = LITERAL[151];
    Lprinc(a);
   G1813:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G1821;
    a = LITERAL[148];
    Lprinc(a);
    goto    G1777;
   G1821:
    q = w9;
    a = w4;
    car(a) = q;
    a = w11;
    if(a != nil) goto    G1824;
    q = LL_sttrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a != nil) goto    G1824;
    a = cdr(w4);
    if(a == nil) goto    G1771;
    Lterpri();
    a = mkfxat(0);
    w9 = a;
   G1774:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G1771;
    Lterpri();
    a = LITERAL[152];
    Lprinc(a);
    a = w9;
    a = Ladd1(a);
    w9 = a;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    a = car(w4);
    Lprin(a);
    goto    G1774;
   G1824:
    a = nil;
   G1771:
    popv(11);
    return a;
}

Sex CC_gbEprimono(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = nil;
    w1 = nil;
    if(a == nil) goto    G1835;
    w1 = a;
    w2 = q;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G1838;
    a = car(w2);
    Lprinc(a);
    a = car(w1);
    a = Lonep(a);
    if(a != nil) goto    G1838;
    a = LITERAL[153];
    Lprinc(a);
    a = car(w1);
    Lprin(a);
   G1838:
    q = cdr(w2);
    a = cdr(w1);
    a = CC_gbEprimono(a, q);
   G1835:
    popv(2);
    return a;
}

Sex CC_gbEfnorm(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    a = LITERAL[7];
    w2 = a;
    a = cdr(w1);
    w3 = a;
   G1843:
    a = cdr(car(w3));
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    q = a;
    a = w2;
    a = Lmax2(a, q);
    w2 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G1843;
    a = w2;
    popv(3);
    return a;
}

Sex CC_gbEerrPolp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
#define LL_gbEcontrol LITERAL[154]
    a = car(value(LL_gbEcontrol));
    a = times2(a, q);
    q = a;
#define LL_gbEaccinit LITERAL[155]
    a = value(LL_gbEaccinit);
    a = times2(a, q);
    w3 = a;
    q = value(LL_Hmachineps);
    a = Lgeq(a, q);
    if(a == nil) goto    G1852;
    a = true;
   G1852:
    popv(3);
    return a;
}

Sex CC_gbEABspol(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 24;
    w24 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w19 = nil;
    w20 = nil;
    w21 = nil;
    w22 = nil;
    w23 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = LL_lex;
    a = value(LL_gbEorder);
    a = Lneq(a, q);
    if(a == nil) goto    G1873;
    a = w1;
    goto    G1874;
   G1873:
    a = w1;
    a = CC_gbEABsortWset(a);
   G1874:
    w5 = a;
    a = value(LL_gbEorder);
    if(a != LL_lex) goto    G1876;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G1876;
    q = LITERAL[156];
    a = w5;
    CC_gbEABpriHxInf4s(a, q);
   G1876:
    a = car(w3);
    w6 = a;
    a = w5;
    w7 = a;
    a = cdr(a);
    w8 = a;
    if(a == nil) goto    G1978;
   G1879:
    a = cdr(w8);
    w8 = a;
    if(a != nil) goto    G1881;
   G1978:
    a = LL_end;
    goto    G1860;
   G1881:
    a = car(a);
    w23 = a;
    if(!is_cons(a)) goto    G1879;
    a = car(cdr(a));
    w12 = a;
    a = cdr(a);
    if(a == nil) goto    G1879;
    a = car(w23);
    w14 = a;
    a = cdr(cdr(w23));
    w10 = a;
   G1862:
    a = cdr(w7);
    w7 = a;
    if(a == w8) goto    G1866;
    a = car(a);
    w23 = a;
    if(!is_cons(a)) goto    G1862;
    a = car(cdr(a));
    w11 = a;
    a = cdr(a);
    if(a == nil) goto    G1862;
    a = car(w23);
    w13 = a;
    a = cdr(cdr(w23));
    w9 = a;
    q = w12;
    a = car(w11);
    a = Lmemq(a, q);
    if(a == nil) goto    G1898;
    q = w12;
    a = car(w11);
    CC_seTdelete(a, q);
    q = w11;
    a = car(w12);
    CC_seTdelete(a, q);
    arg4 = nil;
    m = value(LL_gbEorder);
    q = car(w14);
    a = car(w13);
    a = CC_gbEgcdchk(a, q, m, arg4);
    w15 = a;
    q = LL_yes;
    a = Lneq(a, q);
    if(a != nil) goto    G1867;
    a = LITERAL[91];
    goto    G1988;
    a = w22;
   G1896:
    if(a == nil) goto    G1898;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1898;
    q = car(w12);
    a = car(w11);
    a = cons(a, q);
    m = w22;
    q = LITERAL[157];
    CC_gbEpriPmsgmsg(a, q, m);
   G1898:
    a = w6;
    a = Ladd1(a);
    goto    G1980;
   G1866:
    a = w5;
    w7 = a;
    goto    G1879;
   G1867:
    arg6 = car(w12);
    arg5 = car(w11);
    arg4 = w6;
    m = w15;
    q = w10;
    a = w9;
    a = CC_gbEABmkspol(a, q, m, arg4, arg5, arg6);
    w16 = a;
    a = Lzerop(a);
    if(a == nil) goto    G1903;
    a = LITERAL[158];
    goto    G1988;
   G1903:
    a = car(w16);
    a = CC_gbEhex(a);
    a = CC_Wzerolist(a);
    if(a == nil) goto    G1905;
    a = w6;
    a = Ladd1(a);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    goto    G1982;
   G1905:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G1911;
    Lterpri();
    a = LITERAL[142];
    Lprinc(a);
    q = car(w12);
    a = car(w11);
    CC_gbEpriSPOLij(a, q);
    a = LITERAL[159];
    Lprinc(a);
    Lterpri();
    q = nil;
    a = w16;
    CC_gbEABpriavpApB(a, q);
   G1911:
    a = car(w9);
    a = CC_gbEfnorm(a);
    w24 = a;
    a = car(w10);
    a = CC_gbEfnorm(a);
    q = a;
    a = w24;
    a = Lmax2(a, q);
    a = car(w16);
    a = CC_gbEfnorm(a);
    w22 = a;
    a = car(w16);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    q = a;
    a = w22;
    a = quot2(a, q);
    w22 = a;
    q = LITERAL[160];
    a = cons(a, q);
    w24 = a;
    q = mkfxat(1);
    a = mkfxat(1);
    a = cons(a, q);
    q = w24;
    a = Lxcons(a, q);
    w18 = a;
    a = w6;
    a = Ladd1(a);
    m = w18;
    q = a;
    a = w16;
    a = CC_gbEABevalInf4(a, q, m);
    w23 = a;
    if(is_cons(a)) goto    G1922;
#define LL_appZERO LITERAL[161]
    if(a != LL_appZERO) goto    G1924;
    a = LITERAL[162];
    goto    G1988;
   G1924:
    a = Lzerop(a);
    if(a == nil) goto    G1925;
    a = LITERAL[163];
    goto    G1988;
   G1925:
    a = LITERAL[164];
    goto    G1988;
   G1922:
    a = w23;
    w16 = a;
    a = car(a);
    a = CC_gbEhex(a);
    a = car(w16);
    a = CC_gbEhex(a);
    q = w18;
    a = cons(a, q);
    w17 = a;
    a = w6;
    a = Ladd1(a);
    m = w18;
    q = a;
    a = w16;
    a = CC_gbEABnormalz(a, q, m);
    w16 = a;
    a = w6;
    a = Ladd1(a);
    q = w16;
    a = cons(a, q);
    q = a;
    a = w5;
    CC_gbEABintlzSyzsIPs(a, q);
    a = w6;
    a = Ladd1(a);
    a = Lncons(a);
    arg5 = true;
    arg4 = a;
    m = w17;
    q = w1;
    a = w16;
    a = CC_gbEABredpol(a, q, m, arg4, arg5);
    w23 = a;
    a = CC_Wlist(a);
    if(a != nil) goto    G1989;
    a = LL_same;
    if(a == w23) goto    G1941;
    a = w23;
    a = Lzerop(a);
    if(a == nil) goto    G1937;
    a = LITERAL[102];
    goto    G1988;
   G1937:
    a = w23;
    a = Lonep(a);
    if(a == nil) goto    G1938;
   G1982:
    a = mkfxat(1);
    goto    G1860;
   G1938:
    a = w23;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G1939;
    a = LITERAL[162];
    goto    G1988;
   G1939:
    a = LITERAL[164];
    goto    G1988;
   G1989:
    a = cdr(w23);
    w16 = a;
    a = car(w23);
    w17 = a;
   G1941:
    a = w6;
    a = Ladd1(a);
    w6 = a;
    q = a;
    a = w3;
    car(a) = q;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1943;
    Lterpri();
    Lterpri();
    a = LITERAL[165];
    Lprinc(a);
    q = car(w12);
    a = car(w11);
    CC_gbEpriSPOLij(a, q);
    a = LITERAL[166];
    Lprinc(a);
    a = w6;
    Lprin(a);
    a = LITERAL[167];
    Lprinc(a);
    Lterpri();
    q = cdr(w17);
    a = w16;
    CC_gbEABpriavpApB(a, q);
   G1943:
    m = true;
    q = w6;
    a = w17;
    a = CC_gbEABbigMaxCp(a, q, m);
    if(a != nil) goto    G1870;
   G1945:
    a = w2;
    a = CC_tail(a);
    w24 = a;
    a = w6;
    a = Lncons(a);
    q = a;
    a = w24;
    cdr(a) = q;
    a = cdr(a);
    q = w1;
    a = w6;
    CC_gbEinsunpC(a, q);
    arg4 = w2;
    m = w6;
    q = w17;
    a = w16;
    a = CC_gbEABmkwprep(a, q, m, arg4);
    w23 = a;
    q = w1;
    a = CC_gbEABinsWset(a, q);
    w7 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1950;
    q = w4;
    a = w5;
    CC_gbEABpriElms(a, q);
   G1950:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G1952;
    q = LITERAL[168];
    a = w1;
    CC_gbEABpriHxInf4s(a, q);
   G1952:
    a = w7;
    goto    G1860;
   G1870:
    a = w6;
    a = Lncons(a);
    q = w16;
    a = cons(a, q);
    q = w17;
    a = Lxcons(a, q);
    w20 = a;
    m = w4;
    q = a;
    a = LL_spol;
    a = CC_gbEABredSsetSmHx(a, q, m);
    w23 = a;
    q = a;
    a = LITERAL[169];
    CC_argprint(a, q);
    a = w23;
    if(a == nil) goto    G1871;
    a = car(a);
    w21 = a;
    a = cdr(w23);
    w23 = a;
    a = CC_Wlist(a);
    if(a != nil) goto    G1965;
    a = w23;
    a = Lzerop(a);
    if(a != nil) goto    G1960;
    q = mkfxat(-1);
    a = w23;
    a = Lequal(a, q);
    if(a == nil) goto    G1959;
   G1960:
    q = w6;
    a = w21;
    a = Lneq(a, q);
    if(a == nil) goto    G1962;
    a = w21;
   G1980:
    CC_gbEsyzyclear(a);
    goto    G1862;
   G1962:
    q = mkfxat(-1);
    a = w6;
    a = plus2(a, q);
    w6 = a;
    q = a;
    a = w3;
    car(a) = q;
    a = LITERAL[102];
   G1988:
    w22 = a;
    goto    G1896;
   G1965:
    a = w23;
    w20 = a;
    a = cdr(cdr(a));
    w16 = a;
    a = car(w23);
    w17 = a;
    m = nil;
    q = w6;
    a = CC_gbEABbigMaxCp(a, q, m);
    if(a != nil) goto    G1871;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1945;
    m = LITERAL[170];
    q = LITERAL[171];
    a = w6;
    CC_gbEpriPmsgmsg(a, q, m);
    goto    G1945;
   G1871:
    q = w4;
    a = w20;
    CC_gbEABinsSset(a, q);
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1975;
    q = w4;
    a = w5;
    CC_gbEABpriElms(a, q);
   G1975:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G1862;
    q = LITERAL[172];
    a = w4;
    CC_gbEABpriHxInf4s(a, q);
    goto    G1862;
   G1959:
    a = w23;
    a = Lonep(a);
    if(a == nil) goto    G1967;
    a = w21;
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
   G1967:
    a = w23;
   G1860:
    popv(24);
    return a;
}

Sex CC_gbEABevalsysIC(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w5 = nil;
    w3 = nil;
    w6 = nil;
    w2 = a;
    w1 = a;
    a = car(a);
    w7 = a;
    a = car(a);
    w4 = a;
    q = LITERAL[160];
    a = cdr(w7);
    a = Lmax2(a, q);
    w5 = a;
   G1993:
    a = car(w2);
    w3 = a;
    q = w4;
    a = LITERAL[173];
    a = times2(a, q);
    q = a;
    a = car(w3);
    a = Llessp(a, q);
    if(a != nil) goto    G2008;
    q = mkfxat(1);
    a = cdr(w3);
    a = Llessp(a, q);
    if(a == nil) goto    G2003;
    q = LITERAL[160];
    a = w3;
    cdr(a) = q;
   G2003:
    a = cdr(w3);
    w7 = a;
    q = w5;
    a = Llessp(a, q);
    if(a == nil) goto    G2005;
    a = w7;
    w5 = a;
   G2005:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1993;
   G2008:
    a = w1;
    w2 = a;
    a = LITERAL[7];
    w6 = a;
    a = mkfxat(0);
    w7 = a;
   G1996:
    a = car(w2);
    w3 = a;
    q = w4;
    a = LITERAL[173];
    a = times2(a, q);
    q = a;
    a = car(w3);
    a = Llessp(a, q);
    if(a != nil) goto    G2017;
    q = w5;
    a = mkfxat(10);
    a = times2(a, q);
    q = a;
    a = cdr(w3);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G1997;
    q = car(w3);
    a = w7;
    a = plus2(a, q);
    w7 = a;
    q = cdr(w3);
    a = car(w3);
    a = times2(a, q);
    q = a;
    a = w6;
    a = plus2(a, q);
    w6 = a;
   G1997:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G1996;
   G2017:
    q = w7;
    a = w6;
    {
        popv(7);
        return  quot2(a, q);
    }
}

Sex CC_gbEABinsbigCCs(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = car(m);
    a = Llessp(a, q);
    if(a != nil) goto    G2055;
    w4 = nil;
    w5 = nil;
    q = mkfxat(1000);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2030;
    q = mkfxat(5);
    a = mkfxat(10);
    a = Lexpt(a, q);
    q = w1;
    a = times2(a, q);
    a = Ltruncate(a);
    w6 = a;
    q = mkfxat(-5);
    goto    G2054;
   G2030:
    q = mkfxat(1);
    a = w1;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2035;
    q = mkfxat(8);
    a = mkfxat(10);
    a = Lexpt(a, q);
    q = w1;
    a = times2(a, q);
    a = Ltruncate(a);
    w6 = a;
    q = mkfxat(-8);
   G2054:
    a = LITERAL[174];
    a = Lexpt(a, q);
    q = a;
    a = w6;
    a = times2(a, q);
    w1 = a;
   G2035:
    a = w3;
    w4 = a;
    a = cdr(a);
    w5 = a;
   G2025:
    if(a == nil) goto    G2027;
    q = car(car(a));
    a = w1;
    a = Lgeq(a, q);
    if(a != nil) goto    G2027;
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    goto    G2025;
   G2027:
    q = w2;
    a = w1;
    a = cons(a, q);
    q = w5;
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = car(w3);
    a = Lzerop(a);
    if(a == nil) goto    G2049;
    a = w3;
    a = Llength(a);
    q = mkfxat(7);
    a = Llessp(a, q);
    if(a != nil) goto    G2055;
   G2049:
    a = w4;
    a = CC_tail2(a);
    w4 = a;
    q = nil;
    cdr(a) = q;
    q = car(car(w4));
    a = w3;
    car(a) = q;
   G2055:
    a = w3;
    popv(6);
    return a;
}

Sex CC_gbEABevalInf4(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 21;
    w21 = nil;
    w19 = nil;
    w18 = nil;
    w17 = nil;
    w16 = nil;
    w14 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w15 = nil;
    w1 = a;
    a = cdr(cdr(value(LL_gbEcontrol)));
    w20 = a;
    a = car(a);
    w4 = a;
    a = cdr(w20);
    w5 = a;
    w2 = q;
    w3 = m;
    q = value(LL_gbEaccinit);
    a = mkfxat(1);
    a = quot2(a, q);
    w6 = a;
    a = LITERAL[7];
    w16 = a;
    a = mkfxat(0);
    a = Lncons(a);
    w17 = a;
#define LL_CC LITERAL[175]
    a = LL_CC;
    a = Lncons(a);
    w19 = a;
    w18 = a;
    a = cdr(car(w1));
    w7 = a;
    a = cdr(cdr(w1));
    w8 = a;
   G2061:
    a = cdr(car(w7));
    a = Lbefloat_value(a);
    w9 = a;
    a = cdr(car(w8));
    a = Lbefloat_value(a);
    w10 = a;
    q = a;
    a = w9;
    a = diff2(a, q);
    a = Lfloat(a);
    q = w6;
    a = times2(a, q);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    w20 = a;
    a = w9;
    a = Lfloat(a);
    w9 = a;
    a = w10;
    a = Lfloat(a);
    w10 = a;
    q = a;
    a = w9;
    a = plus2(a, q);
    q = a;
    a = w20;
    a = quot2(a, q);
    a = Labs(a);
    w14 = a;
    a = Lncons(a);
    q = a;
    a = w19;
    cdr(a) = q;
    a = cdr(a);
    w19 = a;
    a = w9;
    a = Labs(a);
    w9 = a;
    m = w17;
    q = w14;
    CC_gbEABinsbigCCs(a, q, m);
    a = cdr(car(w7));
    a = Lbefloat_error(a);
    w21 = a;
    q = w9;
    a = value(LL_gbEaccinit);
    a = times2(a, q);
    q = a;
    a = w21;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2065;
    a = w12;
    if(a != nil) goto    G2078;
    a = w9;
    w13 = a;
    w12 = a;
    goto    G2079;
   G2078:
    q = w9;
    a = w13;
    a = Llessp(a, q);
    if(a == nil) goto    G2079;
    a = w9;
    w13 = a;
   G2079:
    a = w15;
    if(a != nil) goto    G2081;
    a = w14;
    w16 = a;
    w15 = a;
    goto    G2082;
   G2081:
    q = w14;
    a = w16;
    a = Llessp(a, q);
    if(a == nil) goto    G2082;
    a = w14;
    w16 = a;
   G2082:
    a = cdr(w7);
    w7 = a;
    a = cdr(w8);
    w8 = a;
    if(a != nil) goto    G2061;
    q = LITERAL[176];
    a = w15;
    a = plus2(a, q);
    a = Ltruncate(a);
    q = mkfxat(1);
    a = Lmax2(a, q);
    w15 = a;
    q = LITERAL[176];
    a = w16;
    a = plus2(a, q);
    a = Ltruncate(a);
    q = mkfxat(1);
    a = Lmax2(a, q);
    w16 = a;
    a = cdr(w18);
    w19 = a;
    w21 = nil;
   G2090:
    if(a == nil) goto    G2089;
    q = LITERAL[176];
    a = car(a);
    a = plus2(a, q);
    a = Ltruncate(a);
    w14 = a;
    q = mkfxat(1);
    a = Lmax2(a, q);
    q = a;
    a = w19;
    car(a) = q;
    a = cdr(w19);
    w19 = a;
    w21 = a;
    goto    G2090;
   G2089:
    a = w2;
    a = CC_Wlist(a);
    if(a == nil) goto    G2096;
    a = car(w2);
    w2 = a;
   G2096:
    Lterpri();
    a = LITERAL[177];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    a = cdr(w18);
    Lprint(a);
    q = w5;
#define LL_gbEcanclvl LITERAL[178]
    a = value(LL_gbEcanclvl);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2098;
    q = cdr(w17);
    a = LITERAL[179];
    CC_argprint(a, q);
   G2098:
    a = cdr(w17);
    a = CC_gbEABevalsysIC(a);
    w11 = a;
    q = w12;
    a = w13;
    a = quot2(a, q);
    q = a;
    a = car(w3);
    car(a) = q;
    q = w15;
    a = cdr(w3);
    car(a) = q;
    q = w11;
    a = car(w3);
    cdr(a) = q;
    q = w16;
    a = cdr(w3);
    cdr(a) = q;
    q = w11;
    a = LITERAL[180];
    CC_argprint(a, q);
    q = value(LL_gbEtol);
    a = mkfxat(1);
    a = quot2(a, q);
    q = a;
    a = w11;
    a = Llessp(a, q);
    if(a == nil) goto    G2101;
    a = w1;
    goto    G2060;
   G2101:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2104;
    m = LITERAL[181];
    q = LITERAL[182];
    a = w2;
    CC_gbEpriPmsgmsg(a, q, m);
   G2104:
    arg4 = w11;
    m = w3;
    q = w2;
    a = w1;
    CC_gbEABsaveApZero(a, q, m, arg4);
#define LL_AppZERO LITERAL[183]
    a = LL_AppZERO;
    goto    G2060;
   G2065:
    a = LITERAL[184];
    w14 = a;
    Lterpri();
    a = LITERAL[185];
    Lprinc(a);
    a = w2;
    Lprin(a);
    Lterpri();
    a = w14;
    Lprinc(a);
    a = LITERAL[186];
    Lprinc(a);
    a = LITERAL[187];
    w14 = a;
    Lterpri();
    a = LITERAL[107];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = w14;
    Lprinc(a);
    Lterpri();
#define LL_PrecShort LITERAL[188]
    a = LL_PrecShort;
   G2060:
    popv(21);
    return a;
}

Sex CC_gbEABfindReducer(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 16;
    w14 = nil;
    w12 = nil;
    w10 = nil;
    w9 = nil;
    w11 = nil;
    w13 = nil;
    w15 = nil;
    w1 = a;
    a = cdr(value(LL_gbEcontrol));
    w16 = a;
    a = car(a);
    w5 = a;
    a = car(cdr(w16));
    w6 = a;
    a = cdr(cdr(w16));
    w7 = a;
    a = cdr(w1);
    w8 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = CHAR_OF(72);
    a = Lncons(a);
    w10 = a;
    a = car(car(w3));
    w12 = a;
    a = cdr(car(w3));
    w14 = a;
   G2108:
    a = car(w8);
    w9 = a;
    if(!is_cons(a)) goto    G2110;
    m = value(LL_gbEorder);
    q = car(car(a));
    a = w2;
    a = CC_gbEredchk(a, q, m);
    w11 = a;
    if(a == LL_no) goto    G2110;
    a = cdr(car(w9));
    w15 = a;
    a = car(a);
    w16 = a;
    q = w5;
    a = w14;
    a = times2(a, q);
    q = cdr(w16);
    a = Llessp(a, q);
    if(a != nil) goto    G2110;
    q = w7;
    a = car(w4);
    a = Lequal(a, q);
    if(a == nil) goto    G2120;
    q = w5;
    goto    G2139;
   G2120:
    q = mkfxat(2);
    a = w7;
    a = Lexpt(a, q);
    q = a;
    a = car(w4);
    a = Lequal(a, q);
    if(a == nil) goto    G2126;
    q = w6;
   G2139:
    a = w12;
    a = times2(a, q);
    q = car(w16);
    a = Llessp(a, q);
    if(a != nil) goto    G2110;
   G2126:
    q = w9;
    a = w11;
    a = cons(a, q);
    q = cdr(car(w15));
    a = Lxcons(a, q);
    w16 = a;
    m = LL_lessp;
    q = w10;
    CC_seTinsertbycar(a, q, m);
   G2110:
    a = w8;
    if(a == w4) goto    G2136;
    a = cdr(a);
    w8 = a;
    if(a != nil) goto    G2108;
   G2136:
    a = cdr(w10);
    w10 = a;
    if(a == nil) goto    G2107;
    a = cdr(car(a));
   G2107:
    popv(16);
    return a;
}

Sex CC_gbEABinsWset(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w6 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    a = car(car(a));
    w5 = a;
    a = cdr(car(cdr(car(w1))));
    w7 = a;
    a = q;
    w3 = a;
    w4 = a;
    w2 = q;
   G2143:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G2172;
    a = car(a);
    a = CC_Wlist(a);
    if(a != nil) goto    G2143;
    q = car(w4);
    a = w7;
    a = Llessp(a, q);
    if(a != nil) goto    G2145;
    a = w4;
    w3 = a;
    goto    G2143;
   G2145:
    a = cdr(w3);
    w4 = a;
   G2146:
    if(a == nil) goto    G2172;
    a = car(a);
    if(!is_cons(a)) goto    G2172;
    a = car(car(a));
    w8 = a;
    m = value(LL_gbEorder);
    q = w5;
    a = CC_gbEordS(a, q, m);
    if(a != nil) goto    G2172;
    q = w5;
    a = w8;
    a = Lequal(a, q);
    if(a != nil) goto    G2148;
    a = w4;
    w3 = a;
    a = cdr(a);
    w4 = a;
    goto    G2146;
   G2148:
    a = w3;
    w9 = a;
   G2149:
    a = car(w4);
    if(!is_cons(a)) goto    G2172;
    q = cdr(car(cdr(car(a))));
    a = w7;
    a = Llessp(a, q);
    if(a != nil) goto    G2172;
    a = w4;
    w3 = a;
    a = cdr(a);
    w4 = a;
    if(a == nil) goto    G2172;
    a = car(a);
    if(!is_cons(a)) goto    G2172;
    q = car(car(a));
    a = w5;
    a = Lequal(a, q);
    if(a != nil) goto    G2149;
   G2172:
    q = w4;
    a = w1;
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    a = w9;
    if(a == nil) goto    G2175;
    a = cdr(a);
    goto    G2142;
   G2175:
    a = cdr(w3);
   G2142:
    popv(9);
    return a;
}

Sex CC_gbEABinsSset(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a != nil) goto    G2181;
    w2 = q;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    {
        popv(8);
        return cdr(a);
    }
   G2181:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = car(car(w1));
    w5 = a;
    a = cdr(car(cdr(car(w1))));
    w8 = a;
    w2 = q;
    a = w2;
    w3 = a;
    a = cdr(a);
    w4 = a;
   G2187:
    if(a == nil) goto    G2209;
    if(!is_cons(a)) goto    G2209;
    a = car(car(car(a)));
    w6 = a;
    m = value(LL_gbEorder);
    q = w5;
    a = CC_gbEordS(a, q, m);
    if(a != nil) goto    G2209;
    q = w5;
    a = w6;
    a = Lequal(a, q);
    if(a != nil) goto    G2189;
    a = w4;
    w3 = a;
    a = cdr(a);
    w4 = a;
    goto    G2187;
   G2189:
    a = car(w4);
    if(!is_cons(a)) goto    G2209;
    q = cdr(car(cdr(car(a))));
    a = w8;
    a = Llessp(a, q);
    if(a != nil) goto    G2209;
    a = w4;
    w3 = a;
    a = cdr(a);
    w4 = a;
    if(a == nil) goto    G2209;
    a = car(a);
    if(!is_cons(a)) goto    G2209;
    q = car(car(a));
    a = w5;
    a = Lequal(a, q);
    if(a != nil) goto    G2189;
   G2209:
    q = w4;
    a = w1;
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(w3);
    popv(8);
    return a;
}

Sex CC_gbEABredSsetSmHx(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w7 = nil;
    w8 = nil;
    w10 = nil;
    w11 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w19 = nil;
    w1 = a;
    a = cdr(value(LL_gbEcontrol));
    w20 = a;
    a = car(a);
    w4 = a;
    a = car(cdr(w20));
    w5 = a;
    a = cdr(cdr(w20));
    w6 = a;
    w2 = q;
    w3 = m;
   G2214:
    a = w3;
    w12 = a;
    a = cdr(a);
    w13 = a;
    a = car(car(w2));
    w9 = a;
    a = w13;
   G2215:
    if(a == nil) goto    G2213;
    a = car(car(car(a)));
    w17 = a;
    m = value(LL_gbEorder);
    q = a;
    a = w9;
    a = CC_gbEordS(a, q, m);
    if(a == nil) goto    G2225;
   G2227:
    a = w13;
    w12 = a;
    a = cdr(a);
    w13 = a;
    goto    G2215;
   G2225:
    q = w17;
    a = w9;
    a = Lequal(a, q);
    if(a == nil) goto    G2213;
    a = car(w13);
    w14 = a;
    a = cdr(car(w2));
    w10 = a;
    a = cdr(car(w14));
    w18 = a;
    q = mkfxat(2);
    a = w6;
    a = Lexpt(a, q);
    q = a;
    a = cdr(car(w10));
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2219;
    q = w4;
    a = cdr(car(w10));
    a = times2(a, q);
    q = cdr(car(w18));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2233;
    q = w5;
    a = car(car(w10));
    a = times2(a, q);
    q = car(car(w18));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2233;
#define LL_PbySi LITERAL[189]
    a = LL_PbySi;
    goto    G2302;
   G2233:
    a = w1;
    if(a == LL_spol) goto    G2227;
    q = w4;
    a = cdr(car(w18));
    a = times2(a, q);
    q = cdr(car(w10));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2227;
    q = w5;
    a = car(car(w18));
    a = times2(a, q);
    q = car(car(w10));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2227;
#define LL_SibyP LITERAL[190]
    a = LL_SibyP;
   G2302:
    w11 = a;
    a = w11;
    if(a == LL_SibyP) goto    G2261;
    a = w1;
    if(a == LL_spol) goto    G2261;
    q = cdr(car(w10));
    a = cdr(car(w18));
    a = Lgeq(a, q);
    if(a == nil) goto    G2261;
    q = w5;
    a = car(car(w18));
    a = times2(a, q);
    q = car(car(w10));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2261;
    goto    G2262;
   G2219:
    q = w5;
    a = cdr(car(w10));
    a = times2(a, q);
    q = cdr(car(w18));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2251;
    a = LL_PbySi;
    goto    G2304;
   G2251:
    a = w1;
    if(a == LL_spol) goto    G2227;
    q = w5;
    a = cdr(car(w18));
    a = times2(a, q);
    q = cdr(car(w10));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2227;
    a = LL_SibyP;
   G2304:
    w11 = a;
    a = w11;
    if(a == LL_SibyP) goto    G2261;
    a = w1;
    if(a == LL_spol) goto    G2261;
    q = cdr(car(w10));
    a = cdr(car(w18));
    a = Lgeq(a, q);
    if(a == nil) goto    G2261;
    q = w5;
    a = car(car(w18));
    a = times2(a, q);
    q = car(car(w10));
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2261;
   G2262:
    a = LL_SibyP;
    w11 = a;
   G2261:
    a = w11;
    if(a != LL_SibyP) goto    G2265;
    q = cdr(w13);
    a = w2;
    a = cons(a, q);
    q = a;
    a = w12;
    cdr(a) = q;
    a = true;
    w19 = a;
    a = w2;
    w20 = a;
    a = w14;
    w2 = a;
    a = w20;
    w14 = a;
    a = w9;
    w20 = a;
    a = w17;
    w9 = a;
    a = w20;
    w17 = a;
    a = w10;
    w20 = a;
    a = w18;
    w10 = a;
    a = w20;
    w18 = a;
   G2265:
    a = cdr(cdr(w2));
    w7 = a;
    a = car(car(cdr(w2)));
    w8 = a;
    a = cdr(cdr(w14));
    w15 = a;
    a = car(car(cdr(w14)));
    w16 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2268;
    a = car(w3);
#define LL_STset LITERAL[191]
    if(a != LL_STset) goto    G2270;
#define LL_STORE LITERAL[192]
    a = LL_STORE;
    goto    G2271;
   G2270:
#define LL_STORE2 LITERAL[193]
    a = LL_STORE2;
   G2271:
    m = a;
    q = w16;
    a = w8;
    CC_gbEpriRedPbyQ(a, q, m);
   G2268:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G2273;
    arg4 = car(w14);
    m = w16;
    q = car(w2);
    a = w8;
    CC_gbEABpriHxinf4(a, q, m, arg4);
   G2273:
    m = value(LL_gbEorder);
    q = w17;
    a = w9;
    a = CC_gbEredchk(a, q, m);
    w20 = a;
    arg5 = w16;
    arg4 = w8;
    m = a;
    q = w15;
    a = w7;
    a = CC_gbEABhred(a, q, m, arg4, arg5);
    w7 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2275;
    a = mkfxat(0);
    w20 = a;
    a = LITERAL[102];
    goto    G2305;
   G2275:
    a = car(w7);
    a = CC_gbEhex(a);
    a = CC_Wzerolist(a);
    if(a == nil) goto    G2277;
    q = mkfxat(1);
    goto    G2308;
   G2277:
    m = w10;
    q = w8;
    a = w7;
    a = CC_gbEABevalInf4(a, q, m);
    w20 = a;
    if(is_cons(a)) goto    G2281;
    if(a != LL_appZERO) goto    G2283;
    a = mkfxat(-1);
    w20 = a;
    w13 = nil;
    goto    G2221;
   G2283:
    a = Lzerop(a);
    if(a != nil) goto    G2309;
    q = LL_PrecShort;
    goto    G2308;
   G2281:
    a = w20;
    w7 = a;
    a = car(a);
    a = CC_gbEhex(a);
    m = w10;
    q = w8;
    a = w7;
    a = CC_gbEABnormalz(a, q, m);
    w7 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2288;
    arg4 = w10;
    m = w7;
    q = w8;
    a = nil;
    CC_gbEABpriRedPol(a, q, m, arg4);
   G2288:
    a = car(w7);
    a = CC_gbEhex(a);
    q = w10;
    a = cons(a, q);
    w20 = a;
    a = w8;
    a = Lncons(a);
    q = w7;
    a = cons(a, q);
    q = w20;
    a = Lxcons(a, q);
    q = w8;
    {
        popv(20);
        return  Lxcons(a, q);
    }
   G2309:
    a = mkfxat(0);
    w20 = a;
    a = LITERAL[163];
   G2305:
    w13 = a;
   G2221:
    m = w13;
    q = LITERAL[194];
    a = w8;
    CC_gbEpriPmsgmsg(a, q, m);
    a = w11;
    if(a != LL_PbySi) goto    G2295;
    a = w19;
    if(a != nil) goto    G2295;
    q = w20;
    goto    G2308;
   G2295:
    a = w11;
    if(a != LL_SibyP) goto    G2299;
    a = w19;
    if(a == nil) goto    G2299;
    w19 = nil;
    goto    G2214;
   G2299:
    q = w20;
   G2308:
    a = w8;
    a = cons(a, q);
   G2213:
    popv(20);
    return a;
}

Sex CC_gbEBADmkspol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 24;
    w24 = nil;
    w23 = nil;
    w21 = nil;
    w20 = nil;
    w19 = nil;
    w18 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w7 = nil;
    w8 = nil;
    w17 = nil;
    w22 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    a = car(a);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w9 = a;
    a = cdr(w1);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w13 = a;
    a = car(w2);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w10 = a;
    a = cdr(w2);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w14 = a;
    q = w13;
    a = w9;
    a = plus2(a, q);
    q = mkfxat(2);
    a = quot2(a, q);
    w18 = a;
    q = w13;
    a = w9;
    a = diff2(a, q);
    q = w18;
    a = quot2(a, q);
    w20 = a;
    q = w14;
    a = w10;
    a = plus2(a, q);
    q = mkfxat(2);
    a = quot2(a, q);
    w19 = a;
    q = w14;
    a = w10;
    a = diff2(a, q);
    q = w19;
    a = quot2(a, q);
    w21 = a;
    a = w20;
    a = Labs(a);
    w23 = a;
    a = w21;
    a = Labs(a);
    q = a;
    a = w23;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2325;
    a = w18;
    a = Labs(a);
    q = a;
    a = w20;
    a = quot2(a, q);
    w22 = a;
    a = Ladd1(a);
    q = a;
    a = w18;
    a = times2(a, q);
    w9 = a;
    q = w22;
    a = mkfxat(1);
    a = diff2(a, q);
    q = a;
    a = w18;
    a = times2(a, q);
    w13 = a;
    goto    G2331;
   G2325:
    a = w19;
    a = Labs(a);
    q = a;
    a = w21;
    a = quot2(a, q);
    w22 = a;
    a = Ladd1(a);
    q = a;
    a = w19;
    a = times2(a, q);
    w10 = a;
    q = w22;
    a = mkfxat(1);
    a = diff2(a, q);
    q = a;
    a = w19;
    a = times2(a, q);
    w14 = a;
   G2331:
    a = car(w1);
    a = CC_gbErest(a);
    w11 = a;
    a = cdr(w1);
    a = CC_gbErest(a);
    w15 = a;
    a = car(w2);
    a = CC_gbErest(a);
    w12 = a;
    a = cdr(w2);
    a = CC_gbErest(a);
    w16 = a;
    a = w12;
    a = Lzerop(a);
    if(a == nil) goto    G2336;
    a = w11;
    a = Lzerop(a);
    if(a == nil) goto    G2338;
    a = mkfxat(0);
    w7 = a;
    goto    G2313;
   G2338:
    m = w11;
    q = w10;
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w7 = a;
    m = w15;
    q = w14;
    a = car(w3);
    goto    G2359;
   G2336:
    a = w11;
    a = Lzerop(a);
    if(a == nil) goto    G2340;
    a = w9;
    a = Lminus(a);
    m = w12;
    q = a;
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w7 = a;
    a = w13;
    a = Lminus(a);
    m = w16;
    q = a;
    a = cdr(w3);
   G2359:
    a = CC_gbEtermHdist(a, q, m);
    goto    G2360;
   G2340:
    m = w11;
    q = w10;
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w11 = a;
    m = w15;
    q = w14;
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w15 = a;
    a = w9;
    a = Lminus(a);
    m = w12;
    q = a;
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w12 = a;
    a = w13;
    a = Lminus(a);
    m = w16;
    q = a;
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w16 = a;
    q = w12;
    a = w11;
    a = CC_gbEdistLdist(a, q);
    w7 = a;
    q = w16;
    a = w15;
    a = CC_gbEdistLdist(a, q);
    w8 = a;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G2313;
    q = w8;
    a = w7;
    a = cons(a, q);
#define LL_all LITERAL[195]
    q = LL_all;
    a = CC_gbEABdelErrTerm(a, q);
    w22 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2349;
   G2313:
    a = w4;
    a = Ladd1(a);
    CC_gbEsyzyclear(a);
    a = mkfxat(0);
    goto    G2312;
   G2349:
    a = car(w22);
    w7 = a;
    a = cdr(w22);
   G2360:
    w8 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G2352;
    a = w4;
    a = Ladd1(a);
    w23 = a;
    q = mkfxat(1);
    a = car(w3);
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    w24 = a;
    q = mkfxat(-1);
    a = cdr(w3);
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    arg4 = a;
    m = w24;
    q = w23;
    a = LL_spol;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G2352:
    q = w8;
    a = w7;
    a = cons(a, q);
   G2312:
    popv(24);
    return a;
}

Sex CC_gbEABmatxMkMatx(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 18;
    w18 = nil;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w6 = nil;
    w5 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
#define LL_CMatx LITERAL[196]
    a = LL_CMatx;
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = w4;
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G2364:
    a = car(car(w3));
    w13 = a;
    a = cdr(car(w3));
    w10 = a;
    q = w2;
    a = w13;
    a = Lassoc(a, q);
    a = cdr(a);
    w15 = a;
    a = car(a);
    w14 = a;
    a = cdr(w15);
    w15 = a;
   G2365:
    a = car(w10);
    w11 = a;
    a = car(a);
    w18 = a;
    a = cdr(w14);
    w16 = a;
    a = cdr(w15);
    w17 = a;
#define LL_row LITERAL[197]
    a = LL_row;
    a = Lncons(a);
    w9 = a;
    w8 = a;
    a = w4;
    w12 = a;
   G2366:
    q = car(w12);
    a = w18;
    a = Lequal(a, q);
    if(a != nil) goto    G2376;
    a = mkfxat(0);
    a = Lncons(a);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(a);
    w9 = a;
    a = cdr(w12);
    w12 = a;
    goto    G2366;
   G2376:
    q = cdr(car(w17));
    a = cdr(car(w16));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(a);
    w9 = a;
    a = cdr(w12);
    w12 = a;
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G2383;
    a = cdr(w16);
    w16 = a;
    a = cdr(w17);
    w17 = a;
    a = car(w11);
    w18 = a;
    goto    G2366;
   G2383:
    a = w12;
    if(a == nil) goto    G2385;
    a = mkfxat(0);
    a = Lncons(a);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(a);
    w9 = a;
    a = cdr(w12);
    w12 = a;
    goto    G2383;
   G2385:
    a = w13;
    if(a != w1) goto    G2389;
    a = w8;
    w7 = a;
    goto    G2390;
   G2389:
    a = cdr(w8);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G2390:
    a = cdr(w10);
    w10 = a;
    if(a != nil) goto    G2365;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G2396;
    a = cdr(w2);
    w2 = a;
    goto    G2364;
   G2396:
    a = cdr(w7);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = cdr(w5);
    popv(18);
    return a;
}

Sex CC_gbEABGaussFelim(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 19;
    w19 = nil;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w13 = nil;
    w6 = nil;
    w4 = nil;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w14 = nil;
    w18 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = mkfxat(0);
    a = nil;
    a = cons(a, q);
    w13 = a;
    a = mkfxat(0);
    w16 = a;
    a = w1;
    w4 = a;
   G2402:
    a = car(w4);
    w6 = a;
    a = w16;
    a = Ladd1(a);
    w16 = a;
    a = mkfxat(0);
    w15 = a;
   G2403:
    a = w15;
    a = Ladd1(a);
    w15 = a;
    a = car(w6);
    w17 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2420;
    a = car(w17);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w17 = a;
    q = cdr(w13);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2420;
    q = w17;
    a = w13;
    cdr(a) = q;
    q = w16;
    a = w15;
    a = cons(a, q);
    w17 = a;
    q = a;
    a = w13;
    car(a) = q;
   G2420:
    a = cdr(w6);
    w6 = a;
    q = w2;
    a = w15;
    a = Llessp(a, q);
    if(a != nil) goto    G2403;
    a = cdr(w4);
    w4 = a;
    a = cdr(a);
    if(a != nil) goto    G2402;
    a = mkfxat(0);
    w14 = a;
   G2407:
    a = w14;
    a = Ladd1(a);
    w14 = a;
    a = car(car(w13));
    w15 = a;
    q = w14;
    a = Lneq(a, q);
    if(a == nil) goto    G2426;
    a = w14;
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w15;
    a = plus2(a, q);
    q = a;
    a = w1;
    a = CC_gbEmatxExchCol1(a, q);
    w1 = a;
   G2426:
    a = cdr(car(w13));
    w16 = a;
    a = Lonep(a);
    if(a != nil) goto    G2432;
    q = mkfxat(-2);
    a = w16;
    a = plus2(a, q);
    q = a;
    a = w1;
    a = CC_ncdr(a, q);
    w17 = a;
    a = car(cdr(a));
    w8 = a;
    q = cdr(cdr(w17));
    a = w17;
    cdr(a) = q;
    q = w1;
    a = w8;
    a = cons(a, q);
    w1 = a;
   G2432:
    q = mkfxat(0);
    a = nil;
    a = cons(a, q);
    w13 = a;
    a = car(w1);
    w5 = a;
    a = cdr(w1);
    w4 = a;
    a = mkfxat(1);
    w16 = a;
   G2408:
    a = car(w4);
    w8 = a;
    a = car(a);
    w10 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2436;
    arg6 = w3;
    arg5 = w2;
    arg4 = w14;
    m = w16;
    q = w8;
    a = w13;
    CC_gbEABrowPivot(a, q, m, arg4, arg5, arg6);
    goto    G2411;
   G2436:
    q = car(car(w5));
    a = car(w10);
    a = quot2(a, q);
    w11 = a;
    q = cdr(car(w5));
    a = cdr(w10);
    a = quot2(a, q);
    w12 = a;
    q = mkfxat(0);
    a = w8;
    car(a) = q;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
    a = w14;
    w15 = a;
    a = true;
    w18 = a;
    goto    G2459;
   G2409:
    a = car(w6);
    w7 = a;
    a = car(w9);
    w10 = a;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G2459;
    a = w10;
    a = Lzerop(a);
    q = car(w7);
    if(a == nil) goto    G2439;
    a = w11;
    a = times2(a, q);
    a = Lminus(a);
    w19 = a;
    q = cdr(w7);
    a = w12;
    a = times2(a, q);
    a = Lminus(a);
    goto    G2481;
   G2439:
    a = w11;
    a = times2(a, q);
    q = a;
    a = car(w10);
    a = diff2(a, q);
    w19 = a;
    q = cdr(w7);
    a = w12;
    a = times2(a, q);
    q = a;
    a = cdr(w10);
    a = diff2(a, q);
   G2481:
    q = w19;
    a = Lxcons(a, q);
    w17 = a;
    q = w3;
    a = car(w17);
    a = CC_acczerop(a, q);
    if(a == nil) goto    G2450;
    q = mkfxat(0);
    a = w9;
    goto    G2482;
   G2450:
    q = w17;
    a = w9;
    car(a) = q;
    w18 = nil;
    q = w2;
    a = w15;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G2459;
    a = cdr(w4);
    if(a == nil) goto    G2459;
    a = car(w17);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w17 = a;
    q = cdr(w13);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2459;
    q = w17;
    a = w13;
    cdr(a) = q;
    q = w16;
    a = w15;
    a = cons(a, q);
    w17 = a;
    q = a;
    a = w13;
   G2482:
    car(a) = q;
   G2459:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w15;
    a = Ladd1(a);
    w15 = a;
    a = w6;
    if(a != nil) goto    G2409;
    a = w18;
    if(a == nil) goto    G2411;
    a = w8;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G2411;
    q = w4;
    a = w1;
    a = CC_before(a, q);
    w17 = a;
    q = cdr(w4);
    cdr(a) = q;
    a = w16;
    a = Lsub1(a);
    w16 = a;
   G2411:
    a = w16;
    a = Ladd1(a);
    w16 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G2408;
    a = cdr(w1);
    a = CC_listcdr(a);
    w1 = a;
    a = car(a);
    a = Llength(a);
    q = a;
    a = LITERAL[198];
    CC_argprint(a, q);
    a = cdr(w1);
    if(a == nil) goto    G2413;
    a = car(w13);
    if(a != nil) goto    G2407;
    a = LITERAL[199];
    CC_enterto(a);
    q = w14;
    a = w2;
    a = diff2(a, q);
    q = a;
    a = w1;
    a = CC_gbEABchkdelZRlftcol(a, q);
    w17 = a;
    if(a == nil) goto    G2476;
    q = car(a);
    a = w14;
    a = plus2(a, q);
    w14 = a;
    a = cdr(w17);
    w1 = a;
   G2476:
    q = mkfxat(0);
    a = nil;
    a = cons(a, q);
    w13 = a;
    a = mkfxat(0);
    w16 = a;
    a = w1;
    w4 = a;
    a = w14;
    a = Lminus(a);
    q = a;
    a = w2;
    a = plus2(a, q);
    w2 = a;
    goto    G2402;
   G2413:
    q = w2;
    a = w14;
    a = Lgeq(a, q);
    if(a != nil) goto    G2480;
    a = car(car(w1));
    a = Lzerop(a);
    if(a == nil) goto    G2480;
    a = w1;
    a = CC_listcdr(a);
    w1 = a;
    a = w14;
    a = Ladd1(a);
    w14 = a;
    goto    G2413;
   G2480:
    a = w1;
    popv(19);
    return a;
}

Sex CC_AappGroeb(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 17;
    w17 = nil;
    w16 = nil;
    w12 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w10 = nil;
    w11 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w1 = a;
    a = value(LL_Hmachineps);
    value(LL_gbEFprec) = a;
    w2 = q;
    w3 = m;
    Lterpri();
    a = LITERAL[200];
    Lprinc(a);
    a = value(LL_gbEorder);
    Lprint(a);
    a = LITERAL[201];
    Lprinc(a);
    a = value(LL_gbEaccinit);
    Lprint(a);
    a = LITERAL[202];
    Lprinc(a);
    a = w2;
    Lprint(a);
    a = w1;
    a = CC_gbEcoeftype(a);
    if(a == LL_AF) goto    G2501;
    if(a == LL_AC) goto    G2501;
    if(a == LL_AQ) goto    G2501;
    if(a == LL_AZ) goto    G2501;
    q = nil;
    a = LITERAL[203];
    CC_errormsg(a, q);
   G2501:
    a = value(LL_gbEaccinit);
    a = CC_Wbnum(a);
    if(a != nil) goto    G2503;
    q = nil;
    a = LITERAL[204];
    goto    G2598;
   G2503:
    q = mkfxat(4);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = value(LL_gbEaccinit);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2504;
    q = mkfxat(4);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = LITERAL[205];
   G2598:
    CC_errormsg(a, q);
   G2504:
    a = w2;
    a = CC_Wbnum(a);
    if(a != nil) goto    G2508;
    q = LITERAL[206];
    a = w2;
    a = Lmemq(a, q);
    if(a != nil) goto    G2508;
    q = nil;
    a = LITERAL[207];
    goto    G2599;
   G2508:
    q = LITERAL[206];
    a = w2;
    a = Lmemq(a, q);
    if(a == nil) goto    G2510;
    q = value(LL_gbEaccinit);
    a = mkfxat(10);
    a = times2(a, q);
    goto    G2600;
   G2510:
    a = w2;
    a = CC_Wbnum(a);
    if(a == nil) goto    G2511;
    q = mkfxat(2);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = w2;
    a = Lleq(a, q);
    if(a == nil) goto    G2511;
    a = w2;
   G2600:
    value(LL_gbEtol) = a;
    goto    G2514;
   G2511:
    q = mkfxat(2);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = LITERAL[208];
   G2599:
    CC_errormsg(a, q);
   G2514:
    a = LL_plus2;
    value(LL_gbEadd) = a;
    a = LL_times2;
    value(LL_gbEmult) = a;
    a = LL_minus;
    value(LL_gbEneg) = a;
    a = LL_quotient;
    value(LL_gbEquoti) = a;
    value(LL_gbEgcd) = nil;
    a = LL_float;
    value(LL_gbEcoftype) = a;
    a = LL_head;
    value(LL_gbEredtype) = a;
    q = mkfxat(125);
    a = mkfxat(25);
    a = cons(a, q);
    q = mkfxat(5);
    a = Lxcons(a, q);
    value(LL_gbEcontrol) = a;
    q = LITERAL[209];
    a = value(LL_gbEaccinit);
    a = Lexpt(a, q);
    q = mkfxat(3);
    a = quot2(a, q);
    q = value(LL_gbEcontrol);
    a = cons(a, q);
    value(LL_gbEcontrol) = a;
    a = LITERAL[210];
    Lprinc(a);
    a = value(LL_gbEcontrol);
    Lprint(a);
    m = CHAR_OF(83);
    q = value(LL_RpercentS);
    a = value(LL_RblankS);
    a = Llist3(a, q, m);
    a = Lmake_id(a);
    value(LL_gbEsyzvar) = a;
#define LL_Bgid LITERAL[211]
    q = LL_Bgid;
    a = Lget(a, q);
    if(a != nil) goto    G2521;
    q = value(LL_gbEsyzvar);
    a = LL_indxvar;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = value(LL_gbEsyzvar);
    a = Lncons(a);
    CC_Aorder(a);
   G2521:
    a = w1;
    w4 = a;
    a = mkfxat(654321);
    a = CC_ArandomD7(a);
    value(LL_Hrandom) = a;
    a = w4;
    a = CC_Acoef2befloat(a);
    w1 = a;
#define LL_ApZEROs LITERAL[212]
    a = LL_ApZEROs;
    a = Lncons(a);
#define LL_gbEapZeros LITERAL[213]
    value(LL_gbEapZeros) = a;
#define LL_AcdInxC LITERAL[214]
    a = LL_AcdInxC;
    a = Lncons(a);
#define LL_gbEacdInxC LITERAL[215]
    value(LL_gbEacdInxC) = a;
#define LL_gbEhistry LITERAL[216]
    value(LL_gbEhistry) = nil;
    a = true;
    value(LL_gbEsyzygy) = a;
    w12 = nil;
#define LL_app LITERAL[217]
    m = LL_app;
    q = nil;
    a = w1;
    a = CC_gbEinitialz(a, q, m);
    w16 = a;
    a = car(a);
    w5 = a;
    a = cdr(w16);
    w8 = a;
    a = Llast(a);
    w9 = a;
    a = w5;
    a = CC_gbEwset2ABset(a);
    w6 = a;
    a = LL_STset;
    a = Lncons(a);
    w7 = a;
    q = value(LL_gbEaccinit);
    a = w6;
    CC_gbEABputmarks(a, q);
    a = cdr(cdr(cdr(value(LL_gbEcontrol))));
    w16 = a;
    value(LL_gbEcanclvl) = a;
    a = w6;
    a = CC_tail(a);
    w17 = a;
    a = w16;
    a = Lncons(a);
    q = a;
    a = w17;
    cdr(a) = q;
    a = cdr(a);
    w17 = a;
    q = mkfxat(2);
    a = w16;
    a = Lexpt(a, q);
    a = Lncons(a);
    q = a;
    a = w17;
    cdr(a) = q;
    a = cdr(a);
   G2489:
    a = w12;
    if(a != nil) goto    G2533;
    a = cdr(w6);
    w12 = a;
   G2533:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2535;
    Lterpri();
    a = LITERAL[218];
    CC_enterto(a);
    q = LITERAL[219];
    a = w6;
    CC_gbEABpriHxInf4s(a, q);
   G2535:
    arg4 = w7;
    m = w8;
    q = w12;
    a = w6;
    a = CC_gbEABreduce(a, q, m, arg4);
    w6 = a;
    if(a == LL_PrecShort) goto    G2492;
    if(a == LL_stop) goto    G2497;
    a = Lonep(a);
    if(a != nil) goto    G2493;
   G2539:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2541;
    Lterpri();
    a = LITERAL[220];
    CC_enterto(a);
    q = LITERAL[221];
    a = w6;
    CC_gbEABpriHxInf4s(a, q);
   G2541:
    a = w9;
    a = Lncons(a);
    w16 = a;
    arg4 = w7;
    m = a;
    q = w8;
    a = w6;
    a = CC_gbEABspol(a, q, m, arg4);
    w12 = a;
    a = car(w16);
    w9 = a;
    q = mkfxat(30);
    a = Lgeq(a, q);
    if(a == nil) goto    G2544;
    a = LITERAL[222];
    goto    G2485;
   G2544:
    a = LL_PrecShort;
    if(a == w12) goto    G2492;
    a = w12;
    a = CC_Wlist(a);
    if(a != nil) goto    G2553;
    a = w12;
    a = Lonep(a);
    if(a != nil) goto    G2493;
    a = LL_end;
    if(a != w12) goto    G2549;
    a = cdr(w7);
    if(a == nil) goto    G2494;
    a = cdr(w7);
    if(a == nil) goto    G2494;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2563;
    Lterpri();
    a = LITERAL[223];
    CC_enterto(a);
    q = LITERAL[224];
    a = w7;
    CC_gbEABpriHxInf4s(a, q);
   G2563:
    m = w8;
    q = w6;
    a = w7;
    a = CC_gbEABmoveCancPol(a, q, m);
    w12 = a;
    if(a == LL_PrecShort) goto    G2492;
    a = Lonep(a);
    if(a != nil) goto    G2493;
    a = w12;
    if(a == nil) goto    G2494;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2569;
    q = w7;
    a = w6;
    CC_gbEABpriElms(a, q);
   G2569:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2571;
    q = LITERAL[225];
    a = w6;
    CC_gbEABpriHxInf4s(a, q);
    q = LITERAL[225];
    a = w7;
    CC_gbEABpriHxInf4s(a, q);
   G2571:
    w12 = nil;
    goto    G2489;
   G2492:
    a = true;
    w10 = a;
    Lterpri();
    a = LITERAL[226];
    Lprinc(a);
    q = LL_Anil;
#define LL_prec LITERAL[227]
    a = LL_prec;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = nil;
    goto    G2485;
   G2493:
    q = LL_Anil;
    a = LL_prec;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G2601;
    a = car(cdr(w5));
    w16 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G2580;
    a = car(w16);
    w16 = a;
   G2580:
    Lterpri();
    a = LITERAL[228];
    Lprinc(a);
    a = w16;
    Lprin(a);
    a = LITERAL[50];
    w16 = a;
    Lprinc(a);
    Lterpri();
   G2601:
    q = mkfxat(1);
    a = LL_Bset;
    {
        popv(17);
        return  Llist2(a, q);
    }
   G2494:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2583;
    Lterpri();
    a = LITERAL[229];
    CC_enterto(a);
    q = LITERAL[230];
    a = w6;
    CC_gbEABpriHxInf4s(a, q);
   G2583:
    a = w10;
    if(a == nil) goto    G2585;
    Lterpri();
    Lterpri();
    a = LITERAL[231];
    Lprinc(a);
    a = LITERAL[232];
    Lprinc(a);
    Lterpri();
    Lterpri();
   G2585:
    a = w6;
    a = CC_gbEABwset2wset(a);
    w5 = a;
   G2495:
    a = cdr(value(LL_gbEapZeros));
    value(LL_gbEapZeros) = a;
    if(a == nil) goto    G2587;
    Lterpri();
    a = LITERAL[233];
    Lprinc(a);
    a = cdr(cdr(cdr(car(car(value(LL_gbEapZeros))))));
    Lprin(a);
    a = LITERAL[234];
    Lprinc(a);
    q = nil;
    a = cdr(cdr(car(value(LL_gbEapZeros))));
    CC_gbEABpriavpApB(a, q);
    goto    G2495;
   G2587:
    Lterpri();
    Lterpri();
    a = LITERAL[235];
    w16 = a;
    a = w10;
    if(a == nil) goto    G2589;
    a = LITERAL[236];
    w16 = a;
   G2589:
    a = w16;
    Lprinc(a);
    Lterpri();
    a = w5;
    w12 = a;
   G2496:
    a = cdr(w12);
    w12 = a;
    if(a == nil) goto    G2497;
    a = car(a);
    if(!is_cons(a)) goto    G2496;
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = cdr(cdr(car(w12)));
    w16 = a;
    a = car(car(cdr(car(w12))));
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w16;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    goto    G2496;
   G2549:
    a = car(w12);
    a = CC_gbEstop(a);
    if(a != nil) goto    G2494;
   G2553:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2555;
    Lterpri();
    a = LITERAL[218];
    CC_enterto(a);
    q = LITERAL[219];
    a = w6;
    CC_gbEABpriHxInf4s(a, q);
   G2555:
    arg4 = w7;
    m = w8;
    q = w12;
    a = w6;
    a = CC_gbEABreduce(a, q, m, arg4);
    w6 = a;
    if(a == LL_PrecShort) goto    G2492;
    a = Lonep(a);
    if(a != nil) goto    G2493;
    a = LL_stop;
    if(a != w6) goto    G2539;
   G2497:
    a = w3;
    if(a == nil) goto    G2595;
    q = w6;
    CC_gbEABredpolByGB(a, q);
    a = w3;
    a = CC_gbEABwset2wset(a);
    w3 = a;
    a = CC_gbEwset2polyset(a);
    w3 = a;
   G2595:
    q = LL_Anil;
    a = LL_prec;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    q = cdr(w6);
    a = LL_Bset;
    a = cons(a, q);
    value(LL_Hbyproduct) = a;
    a = w5;
    a = CC_gbEwset2polyset(a);
    w11 = a;
   G2485:
    popv(17);
    return a;
}

Sex CC_gbEABmkwprep(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = cdr(arg4);
    w4 = a;
    w2 = q;
    w3 = m;
    a = Lcopy(a);
    q = w3;
    a = Lxcons(a, q);
    w5 = a;
    q = a;
    a = w3;
    CC_seTdelete(a, q);
    q = w1;
    a = w5;
    a = cons(a, q);
    q = w2;
    {
        popv(5);
        return  Lxcons(a, q);
    }
}

Sex CC_gbEwset2ABset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
   G2611:
    a = car(w2);
    w3 = a;
    if(!is_cons(a)) goto    G2612;
    q = LITERAL[160];
    a = LITERAL[160];
    a = cons(a, q);
    w6 = a;
    q = mkfxat(1);
    a = mkfxat(1);
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    w4 = a;
    a = cdr(cdr(w3));
    w5 = a;
    a = CC_gbEfnorm(a);
    w6 = a;
    a = w5;
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    q = a;
    a = w6;
    a = quot2(a, q);
    w5 = a;
    a = Labs(a);
    q = a;
    a = car(w4);
    car(a) = q;
    q = w4;
    a = car(w3);
    a = cons(a, q);
    q = a;
    a = w3;
    car(a) = q;
   G2612:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G2611;
#define LL_ABset LITERAL[237]
    q = LL_ABset;
    a = w1;
    car(a) = q;
    a = w1;
    popv(6);
    return a;
}

Sex CC_gbEABwset2wset(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = car(cdr(a));
    a = Lonep(a);
    if(a == nil) goto    G2628;
    a = w1;
    goto    G2629;
   G2628:
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = w1;
    w4 = a;
    a = LL_Wset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w4 = a;
   G2631:
    a = car(w4);
    w5 = a;
    if(!is_cons(a)) goto    G2632;
    a = cdr(cdr(a));
    w8 = a;
    a = CC_Wlist(a);
    if(a != nil) goto    G2638;
    a = cdr(w5);
    a = Lcopy(a);
    q = car(car(w5));
    a = Lxcons(a, q);
    w5 = a;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    goto    G2632;
   G2638:
    a = car(w8);
    w6 = a;
    a = cdr(w8);
    w7 = a;
    q = mkfxat(2);
    a = LITERAL[160];
    a = quot2(a, q);
    w9 = a;
    q = w7;
    a = w6;
    a = CC_gbEdistLdist(a, q);
    q = a;
    a = w9;
    a = CC_gbEnumHdist(a, q);
    w8 = a;
    a = car(cdr(w5));
    a = Lcopy(a);
    q = w8;
    a = cons(a, q);
    w8 = a;
    q = car(car(w5));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
   G2632:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G2631;
    a = w2;
   G2629:
    popv(9);
    return a;
}

Sex CC_gbEABnormalz(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = car(a);
    w4 = a;
    a = cdr(w1);
    w5 = a;
    w2 = q;
    w3 = m;
    a = w4;
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w8 = a;
    a = w5;
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    q = a;
    a = w8;
    a = plus2(a, q);
    q = a;
    a = mkfxat(2);
    a = quot2(a, q);
    w6 = a;
    q = w4;
    a = CC_gbEnumHdist(a, q);
    w4 = a;
    q = w5;
    a = w6;
    a = CC_gbEnumHdist(a, q);
    w5 = a;
    a = w2;
    if(!is_cons(a)) goto    G2660;
    a = car(a);
    w2 = a;
   G2660:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G2662;
    arg4 = nil;
    m = w6;
    q = w2;
    a = LL_nmlz;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G2662:
    q = w5;
    a = w4;
    {
        popv(8);
        return  cons(a, q);
    }
}

Sex CC_gbEoldinsWset(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w6 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w1 = a;
    a = cdr(cdr(cdr(value(LL_gbEcontrol))));
    w3 = a;
    a = q;
    w4 = a;
    w5 = a;
    a = cdr(cdr(cdr(car(w1))));
    w7 = a;
    w2 = q;
   G2667:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G2702;
    a = car(a);
    a = CC_Wlist(a);
    if(a != nil) goto    G2667;
    q = car(w5);
    a = w7;
    a = Llessp(a, q);
    if(a != nil) goto    G2675;
    a = w5;
    w4 = a;
    goto    G2667;
   G2675:
    a = cdr(w4);
    w5 = a;
    a = car(car(w1));
    w6 = a;
    a = cdr(car(cdr(car(w1))));
    w9 = a;
    a = w5;
   G2668:
    if(a == nil) goto    G2702;
    a = car(a);
    if(!is_cons(a)) goto    G2702;
    a = car(car(a));
    w10 = a;
    m = value(LL_gbEorder);
    q = a;
    a = w6;
    a = CC_gbEordS(a, q, m);
    if(a == nil) goto    G2680;
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    goto    G2668;
   G2680:
    q = w10;
    a = w6;
    a = Lequal(a, q);
    if(a == nil) goto    G2702;
    a = car(cdr(cdr(car(w1))));
    w8 = a;
    a = cdr(car(cdr(car(w1))));
    w9 = a;
   G2669:
    a = car(w5);
    if(!is_cons(a)) goto    G2702;
    q = w3;
    a = w7;
    a = Llessp(a, q);
    if(a == nil) goto    G2686;
    q = car(cdr(cdr(car(car(w5)))));
    a = w8;
    goto    G2705;
   G2686:
    q = mkfxat(2);
    a = w3;
    a = Lexpt(a, q);
    q = a;
    a = w7;
    a = Llessp(a, q);
    if(a == nil) goto    G2690;
    q = cdr(cdr(cdr(car(car(w5)))));
    a = w7;
    goto    G2705;
   G2690:
    q = cdr(car(cdr(car(car(w5)))));
    a = w9;
   G2705:
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2702;
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(a == nil) goto    G2702;
    a = car(a);
    if(!is_cons(a)) goto    G2702;
    q = car(car(a));
    a = w6;
    a = Lequal(a, q);
    if(a != nil) goto    G2669;
   G2702:
    q = w5;
    a = w1;
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w4);
    popv(10);
    return a;
}

Sex CC_gbEoldinsSset(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a != nil) goto    G2709;
    w2 = q;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    {
        popv(9);
        return cdr(a);
    }
   G2709:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = cdr(cdr(cdr(value(LL_gbEcontrol))));
    w3 = a;
    w2 = q;
    a = w2;
    w4 = a;
    a = cdr(a);
    w5 = a;
    a = car(car(w1));
    w6 = a;
    a = cdr(cdr(cdr(car(w1))));
    w8 = a;
    a = w5;
   G2715:
    if(a == nil) goto    G2739;
    a = car(car(car(a)));
    w7 = a;
    m = value(LL_gbEorder);
    q = a;
    a = w6;
    a = CC_gbEordS(a, q, m);
    if(a == nil) goto    G2722;
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    goto    G2715;
   G2722:
    q = w7;
    a = w6;
    a = Lequal(a, q);
    if(a == nil) goto    G2739;
    a = cdr(car(cdr(car(w1))));
    w9 = a;
   G2716:
    q = mkfxat(2);
    a = w3;
    a = Lexpt(a, q);
    q = a;
    a = w8;
    a = Llessp(a, q);
    if(a == nil) goto    G2727;
    q = cdr(cdr(cdr(car(car(w5)))));
    a = w8;
    goto    G2741;
   G2727:
    q = cdr(car(cdr(car(car(w5)))));
    a = w9;
   G2741:
    a = Lgreaterp(a, q);
    if(a == nil) goto    G2739;
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(a == nil) goto    G2739;
    a = car(a);
    if(!is_cons(a)) goto    G2739;
    q = car(car(a));
    a = w6;
    a = Lequal(a, q);
    if(a != nil) goto    G2716;
   G2739:
    q = w5;
    a = w1;
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w4);
    popv(9);
    return a;
}

Sex CC_gbEABwset2polyset(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w5 = nil;
    w6 = nil;
    w1 = a;
    a = LL_Bset;
    a = Lncons(a);
    w3 = a;
    w2 = a;
    a = cdr(w1);
    w4 = a;
   G2745:
    a = car(w4);
    if(!is_cons(a)) goto    G2745;
    a = cdr(cdr(a));
    w6 = a;
    q = cdr(a);
    a = car(a);
    a = CC_gbEdistLdist(a, q);
    q = a;
    a = LITERAL[176];
    a = CC_gbEnumHdist(a, q);
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = CC_gbEdist2poly(a, q, m);
    w5 = a;
    a = w5;
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G2745;
    a = w2;
    popv(6);
    return a;
}

Sex CC_gbEABdelErrTerm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = car(value(LL_gbEcontrol));
    w3 = a;
    a = car(w1);
    w4 = a;
    a = cdr(w1);
    w5 = a;
    w2 = q;
   G2757:
    a = w4;
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    w8 = a;
    a = w5;
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    w9 = a;
    q = a;
    a = w8;
    a = plus2(a, q);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2780;
    q = w9;
    a = w8;
    a = diff2(a, q);
    q = w10;
    a = quot2(a, q);
    a = Labs(a);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    w10 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G2800;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G2780;
    Lterpri();
    a = LITERAL[14];
    Lprinc(a);
    a = w4;
    a = CC_gbEhc(a);
    Lprint(a);
    a = LITERAL[14];
    Lprinc(a);
    a = w5;
    a = CC_gbEhc(a);
    Lprint(a);
   G2780:
    a = w4;
    a = CC_gbErest(a);
    w4 = a;
    a = w5;
    a = CC_gbErest(a);
    w5 = a;
    a = w4;
    a = Lzerop(a);
    if(a == nil) goto    G2757;
    a = mkfxat(0);
    goto    G2756;
   G2759:
    a = cdr(w4);
    w6 = a;
    a = cdr(w5);
    w7 = a;
   G2760:
    a = cdr(w6);
    if(a == nil) goto    G2763;
    a = cdr(car(a));
    a = Lbefloat_value(a);
    a = Lfloat(a);
    w8 = a;
    a = cdr(car(cdr(w7)));
    a = Lbefloat_value(a);
    a = Lfloat(a);
    w9 = a;
    q = a;
    a = w8;
    a = plus2(a, q);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G2798;
    q = w9;
    a = w8;
    a = diff2(a, q);
    q = w10;
    a = quot2(a, q);
    a = Labs(a);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    w10 = a;
    q = w3;
    a = Llessp(a, q);
    if(a != nil) goto    G2762;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G2798;
    Lterpri();
    a = LITERAL[14];
    Lprinc(a);
    a = cdr(car(cdr(w6)));
    Lprint(a);
    a = LITERAL[14];
    Lprinc(a);
    a = cdr(car(cdr(w7)));
    Lprint(a);
   G2798:
    q = cdr(cdr(w6));
    a = w6;
    cdr(a) = q;
    q = cdr(cdr(w7));
    a = w7;
    cdr(a) = q;
    goto    G2760;
   G2762:
    a = cdr(w6);
    w6 = a;
    a = cdr(w7);
    w7 = a;
    goto    G2760;
   G2800:
    a = w2;
    if(a != LL_head) goto    G2759;
   G2763:
    q = w5;
    a = w4;
    a = cons(a, q);
   G2756:
    popv(10);
    return a;
}

Sex CC_gbEABbigMaxCp(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w2 = q;
    w1 = m;
    q = value(LL_gbEcanclvl);
    a = cdr(cdr(cdr(a)));
    a = Llessp(a, q);
    if(a == nil) goto    G2804;
    a = nil;
    goto    G2807;
   G2804:
    a = w1;
    if(a == nil) goto    G2808;
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G2808;
    Lterpri();
    a = LITERAL[238];
    Lprinc(a);
    a = LITERAL[239];
    Lprinc(a);
    a = LITERAL[240];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = LITERAL[241];
    Lprinc(a);
    Lterpri();
   G2808:
    a = true;
   G2807:
    popv(2);
    return a;
}

Sex CC_gbEABreduce(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a == nil) goto    G2825;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    a = q;
    w6 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
   G2815:
    a = w6;
    if(a == nil) goto    G2825;
    a = cdr(a);
    if(a != nil) goto    G2824;
   G2825:
    a = w1;
    goto    G2813;
   G2824:
    a = car(a);
    if(!is_cons(a)) goto    G2837;
    q = nil;
    a = w1;
    CC_gbEABintlzSyzsIPs(a, q);
    a = car(cdr(w6));
    w5 = a;
    a = car(car(cdr(a)));
    w8 = a;
    q = cdr(cdr(w6));
    a = w6;
    cdr(a) = q;
    arg5 = true;
    arg4 = w8;
    m = car(w5);
    q = w1;
    a = cdr(cdr(w5));
    a = CC_gbEABredpol(a, q, m, arg4, arg5);
    w10 = a;
    if(a == LL_same) goto    G2878;
    a = CC_Wlist(a);
    if(a == nil) goto    G2831;
    a = cdr(w10);
    w7 = a;
    a = car(w10);
    w9 = a;
    goto    G2818;
   G2831:
    a = LL_PrecShort;
    if(a != w10) goto    G2833;
    a = true;
    w14 = a;
    a = LITERAL[164];
    goto    G2876;
   G2833:
    a = w10;
    a = Lzerop(a);
    if(a == nil) goto    G2834;
    a = LITERAL[102];
    goto    G2876;
   G2834:
    a = w10;
    a = Lminus(a);
    a = Lonep(a);
    if(a != nil) goto    G2877;
    a = w10;
    a = Lonep(a);
    if(a == nil) goto    G2837;
    a = mkfxat(1);
    goto    G2813;
   G2878:
    q = cdr(w6);
    a = w5;
    a = cons(a, q);
    q = a;
    a = w6;
    cdr(a) = q;
   G2837:
    a = cdr(w6);
    w6 = a;
    goto    G2815;
   G2877:
    a = LITERAL[162];
   G2876:
    w11 = a;
   G2817:
    q = w3;
    a = w8;
    CC_seTdelete(a, q);
    q = w1;
    a = w8;
    CC_gbEdelunpC(a, q);
    a = w11;
    if(a == nil) goto    G2839;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2839;
    m = w11;
    q = LITERAL[194];
    a = w8;
    CC_gbEpriPmsgmsg(a, q, m);
   G2839:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2842;
    q = w4;
    a = w1;
    CC_gbEABpriElms(a, q);
   G2842:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G2815;
    a = w8;
    CC_gbEsyzyclear(a);
    goto    G2815;
   G2818:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2846;
    arg4 = cdr(w9);
    m = w7;
    q = w8;
    a = nil;
    CC_gbEABpriRedPol(a, q, m, arg4);
   G2846:
    m = true;
    q = w8;
    a = w9;
    a = CC_gbEABbigMaxCp(a, q, m);
    if(a != nil) goto    G2820;
   G2848:
    m = LL_lessp;
    q = w3;
    a = w8;
    CC_seTinsert(a, q, m);
    q = w1;
    a = w8;
    CC_gbEinsunpC(a, q);
    arg4 = w3;
    m = w8;
    q = w9;
    a = w7;
    a = CC_gbEABmkwprep(a, q, m, arg4);
    w5 = a;
    q = w1;
    a = CC_gbEABinsWset(a, q);
    w6 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2850;
    q = w4;
    a = w1;
    CC_gbEABpriElms(a, q);
   G2850:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G2852;
    q = LITERAL[242];
    a = w1;
    CC_gbEABpriHxInf4s(a, q);
   G2852:
    m = value(LL_gbEorder);
    q = car(car(car(w6)));
    a = car(car(car(w2)));
    a = CC_gbEordS(a, q, m);
    if(a == nil) goto    G2815;
    a = w6;
    w2 = a;
    goto    G2815;
   G2820:
    q = w3;
    a = w8;
    CC_seTdelete(a, q);
    q = w1;
    a = w8;
    CC_gbEdelunpC(a, q);
   G2821:
    a = w8;
    a = Lncons(a);
    q = w7;
    a = cons(a, q);
    q = w9;
    a = Lxcons(a, q);
    w5 = a;
    m = w4;
    q = a;
#define LL_redc LITERAL[243]
    a = LL_redc;
    a = CC_gbEABredSsetSmHx(a, q, m);
    w10 = a;
    if(a == nil) goto    G2822;
    a = car(a);
    w8 = a;
    a = cdr(w10);
    w10 = a;
    if(is_cons(a)) goto    G2860;
    a = Lonep(a);
    if(a != nil) goto    G2863;
    a = w10;
    if(is_symbol(a)) goto    G2863;
    w11 = nil;
    goto    G2817;
   G2860:
    w5 = a;
    a = cdr(cdr(a));
    w7 = a;
    a = car(w5);
    w9 = a;
    m = nil;
    q = w8;
    a = CC_gbEABbigMaxCp(a, q, m);
    if(a != nil) goto    G2821;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2848;
    m = LITERAL[170];
    q = LITERAL[171];
    a = w8;
    CC_gbEpriPmsgmsg(a, q, m);
    goto    G2848;
   G2822:
    q = w4;
    a = w5;
    a = CC_gbEABinsSset(a, q);
    w10 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2870;
    q = w4;
    a = w1;
    CC_gbEABpriElms(a, q);
   G2870:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G2815;
    q = LITERAL[172];
    a = w4;
    CC_gbEABpriHxInf4s(a, q);
    goto    G2815;
   G2863:
    a = w10;
   G2813:
    popv(14);
    return a;
}

Sex CC_gbEABsortWset(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w5 = a;
    w10 = nil;
    w1 = a;
   G2889:
    if(a == nil) goto    G2888;
    a = cdr(a);
    if(a == nil) goto    G2888;
    a = car(a);
    if(is_cons(a)) goto    G2888;
    a = cdr(w5);
    w5 = a;
    w10 = a;
    goto    G2889;
   G2888:
    a = w5;
    if(a == nil) goto    G2895;
    a = cdr(a);
    if(a != nil) goto    G2894;
   G2895:
    a = w1;
    goto    G2883;
   G2894:
    a = w5;
    w2 = a;
    a = car(cdr(a));
    w6 = a;
    a = car(car(a));
    w7 = a;
    a = CC_sumelms(a);
    q = w7;
    a = cons(a, q);
    w7 = a;
    q = cdr(car(w6));
    a = cons(a, q);
    q = cdr(w6);
    a = cons(a, q);
    w6 = a;
    q = a;
    a = car(w1);
    a = Llist2(a, q);
    w3 = a;
    a = cdr(w2);
    w2 = a;
   G2884:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G2917;
    a = car(a);
    w6 = a;
    if(!is_cons(a)) goto    G2884;
    a = car(car(a));
    w7 = a;
    a = CC_sumelms(a);
    q = w7;
    a = cons(a, q);
    w7 = a;
    q = cdr(car(w6));
    a = cons(a, q);
    q = cdr(w6);
    a = cons(a, q);
    w6 = a;
    a = w3;
    w4 = a;
    a = cdr(a);
    w5 = a;
   G2885:
    a = car(car(car(w5)));
    w8 = a;
    q = a;
    a = w7;
    a = Lequal(a, q);
    if(a != nil) goto    G2886;
    m = value(LL_gbEorder);
    q = w8;
    a = w7;
    a = CC_gbEordS(a, q, m);
    if(a != nil) goto    G2886;
    q = w5;
    a = w6;
    a = cons(a, q);
    goto    G2915;
   G2886:
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(a != nil) goto    G2885;
    q = w6;
    a = Lxcons(a, q);
   G2915:
    q = a;
    a = w4;
    cdr(a) = q;
    goto    G2884;
   G2917:
    a = w3;
    w5 = a;
   G2887:
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G2916;
    a = car(car(a));
    w9 = a;
    q = cdr(car(a));
    car(a) = q;
    goto    G2887;
   G2916:
    a = w3;
   G2883:
    popv(10);
    return a;
}

Sex CC_gbEABmkspol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w19 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w7 = nil;
    w8 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    a = car(a);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w9 = a;
    a = cdr(w1);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w13 = a;
    a = car(w2);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w10 = a;
    a = cdr(w2);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w14 = a;
    a = car(w1);
    a = CC_gbErest(a);
    w11 = a;
    a = cdr(w1);
    a = CC_gbErest(a);
    w15 = a;
    a = car(w2);
    a = CC_gbErest(a);
    w12 = a;
    a = cdr(w2);
    a = CC_gbErest(a);
    w16 = a;
    a = w12;
    a = Lzerop(a);
    if(a == nil) goto    G2929;
    a = w11;
    a = Lzerop(a);
    if(a == nil) goto    G2931;
    a = mkfxat(0);
    w7 = a;
    goto    G2921;
   G2931:
    m = w11;
    q = w10;
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w7 = a;
    m = w15;
    q = w14;
    a = car(w3);
    goto    G2952;
   G2929:
    a = w11;
    a = Lzerop(a);
    if(a == nil) goto    G2933;
    a = w9;
    a = Lminus(a);
    m = w12;
    q = a;
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w7 = a;
    a = w13;
    a = Lminus(a);
    m = w16;
    q = a;
    a = cdr(w3);
   G2952:
    a = CC_gbEtermHdist(a, q, m);
    goto    G2953;
   G2933:
    m = w11;
    q = w10;
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w11 = a;
    m = w15;
    q = w14;
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w15 = a;
    a = w9;
    a = Lminus(a);
    m = w12;
    q = a;
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w12 = a;
    a = w13;
    a = Lminus(a);
    m = w16;
    q = a;
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w16 = a;
    q = w12;
    a = w11;
    a = CC_gbEdistLdist(a, q);
    w7 = a;
    q = w16;
    a = w15;
    a = CC_gbEdistLdist(a, q);
    w8 = a;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G2921;
    q = w8;
    a = w7;
    a = cons(a, q);
    q = LL_all;
    a = CC_gbEABdelErrTerm(a, q);
    w18 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2942;
   G2921:
    a = w4;
    a = Ladd1(a);
    CC_gbEsyzyclear(a);
    a = mkfxat(0);
    goto    G2920;
   G2942:
    a = car(w18);
    w7 = a;
    a = cdr(w18);
   G2953:
    w8 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G2945;
    a = w4;
    a = Ladd1(a);
    w19 = a;
    q = mkfxat(1);
    a = car(w3);
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    w20 = a;
    q = mkfxat(-1);
    a = cdr(w3);
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    arg4 = a;
    m = w20;
    q = w19;
    a = LL_spol;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G2945:
    q = w8;
    a = w7;
    a = cons(a, q);
   G2920:
    popv(20);
    return a;
}

Sex CC_gbEABmkspol2(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w19 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w7 = nil;
    w8 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    a = car(a);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w9 = a;
    a = car(w2);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w10 = a;
    a = cdr(w1);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w13 = a;
    a = cdr(w2);
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    w14 = a;
    a = car(w1);
    a = CC_gbErest(a);
    w11 = a;
    a = car(w2);
    a = CC_gbErest(a);
    w12 = a;
    a = cdr(w1);
    a = CC_gbErest(a);
    w15 = a;
    a = cdr(w2);
    a = CC_gbErest(a);
    w16 = a;
    a = w11;
    a = Lzerop(a);
    if(a == nil) goto    G2965;
    a = w12;
    a = Lzerop(a);
    if(a != nil) goto    G2957;
   G2965:
    a = w11;
    a = Lzerop(a);
    if(a == nil) goto    G2968;
    m = w12;
    q = mkfxat(1);
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w7 = a;
    m = w16;
    q = mkfxat(1);
    a = cdr(w3);
    goto    G2988;
   G2968:
    a = w12;
    a = Lzerop(a);
    m = w11;
    q = mkfxat(1);
    if(a == nil) goto    G2969;
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w7 = a;
    m = w15;
    q = mkfxat(1);
    a = car(w3);
   G2988:
    a = CC_gbEtermHdist(a, q, m);
    goto    G2989;
   G2969:
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w11 = a;
    q = w10;
    a = w9;
    a = quot2(a, q);
    a = Lminus(a);
    m = w12;
    q = a;
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w12 = a;
    m = w15;
    q = mkfxat(1);
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w15 = a;
    q = w14;
    a = w13;
    a = quot2(a, q);
    a = Lminus(a);
    m = w16;
    q = a;
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w16 = a;
    q = w12;
    a = w11;
    a = CC_gbEdistLdist(a, q);
    w7 = a;
    q = w16;
    a = w15;
    a = CC_gbEdistLdist(a, q);
    w8 = a;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G2957;
    q = w8;
    a = w7;
    a = cons(a, q);
    q = LL_all;
    a = CC_gbEABdelErrTerm(a, q);
    w18 = a;
    a = Lzerop(a);
    if(a == nil) goto    G2978;
   G2957:
    a = w4;
    a = Ladd1(a);
    CC_gbEsyzyclear(a);
    a = mkfxat(0);
    goto    G2956;
   G2978:
    a = car(w18);
    w7 = a;
    a = cdr(w18);
   G2989:
    w8 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G2981;
    a = w4;
    a = Ladd1(a);
    w19 = a;
    q = mkfxat(1);
    a = car(w3);
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    w20 = a;
    q = mkfxat(-1);
    a = cdr(w3);
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    arg4 = a;
    m = w20;
    q = w19;
    a = LL_spol;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G2981:
    q = w8;
    a = w7;
    a = cons(a, q);
   G2956:
    popv(20);
    return a;
}

Sex CC_gbEABredpol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 16;
    w13 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w1 = a;
    a = q;
    w6 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    q = car(cdr(value(LL_gbEcontrol)));
    a = cdr(cdr(cdr(m)));
    a = times2(a, q);
    w13 = a;
   G2993:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G3002;
    a = car(a);
    a = CC_Wlist(a);
    if(a != nil) goto    G2993;
    q = car(w6);
    a = w13;
    a = Llessp(a, q);
    if(a == nil) goto    G2993;
   G3002:
    a = car(w3);
    w7 = a;
    a = cdr(w3);
    a = Lcopy(a);
    w8 = a;
    arg4 = w6;
    m = a;
    q = w7;
    a = w2;
    a = CC_gbEABfindReducer(a, q, m, arg4);
    w15 = a;
    if(a == nil) goto    G2997;
    a = car(a);
    a = CC_Wlist(a);
    if(a == nil) goto    G3006;
    a = car(w15);
    goto    G3031;
   G3006:
    Lterpri();
    a = LITERAL[244];
    Lprint(a);
    a = w7;
    a = Llength(a);
    a = CC_listzero(a);
   G3031:
    w14 = a;
    a = cdr(w15);
    w9 = a;
    a = true;
    w16 = a;
    a = cdr(car(w9));
    w11 = a;
    a = car(car(cdr(w9)));
    w12 = a;
    a = cdr(cdr(w9));
    w10 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3010;
    m = nil;
    q = w12;
    a = w4;
    CC_gbEpriRedPbyQ(a, q, m);
   G3010:
    arg5 = w12;
    arg4 = w4;
    m = w14;
    q = w10;
    a = w1;
    a = CC_gbEABhred(a, q, m, arg4, arg5);
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3032;
    a = car(w1);
    a = CC_gbEhex(a);
    a = CC_Wzerolist(a);
    if(a == nil) goto    G3014;
    a = w4;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    a = cdr(a);
    a = mkfxat(1);
    goto    G2992;
   G3014:
    m = w8;
    q = w4;
    a = w1;
    a = CC_gbEABevalInf4(a, q, m);
    w15 = a;
    if(is_cons(a)) goto    G3019;
    if(a != LL_appZERO) goto    G3021;
    a = mkfxat(-1);
    goto    G2992;
   G3021:
    a = Lzerop(a);
    if(a == nil) goto    G3022;
   G3032:
    a = mkfxat(0);
    goto    G2992;
   G3022:
    a = LL_PrecShort;
    goto    G2992;
   G3019:
    a = w15;
    w1 = a;
    a = car(a);
    a = CC_gbEhex(a);
    w15 = a;
    a = w5;
    if(a == nil) goto    G3025;
    m = w8;
    q = w4;
    a = w1;
    a = CC_gbEABnormalz(a, q, m);
    w1 = a;
   G3025:
    a = car(w1);
    a = CC_gbEhex(a);
    q = w8;
    a = cons(a, q);
    w3 = a;
    goto    G3002;
   G2997:
    a = w16;
    if(a != nil) goto    G3028;
    a = LL_same;
    goto    G2992;
   G3028:
    q = w8;
    a = w7;
    a = cons(a, q);
    q = w1;
    a = cons(a, q);
   G2992:
    popv(16);
    return a;
}

Sex CC_gbEABhred(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w19 = nil;
    w14 = nil;
    w12 = nil;
    w9 = nil;
    w7 = nil;
    w6 = nil;
    w8 = nil;
    w10 = nil;
    w11 = nil;
    w13 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = arg4;
    a = CC_Wlist(a);
    if(a == nil) goto    G3041;
    a = car(w4);
    goto    G3078;
   G3041:
    a = w4;
   G3078:
    w17 = a;
    a = car(w2);
    a = CC_gbEhex(a);
    w6 = a;
    a = car(w2);
    a = CC_gbErest(a);
    w9 = a;
    a = cdr(w2);
    a = CC_gbErest(a);
    w14 = a;
    a = w9;
    a = Lzerop(a);
    if(a != nil) goto    G3044;
    a = car(w2);
    a = CC_gbEhc(a);
    q = a;
    a = mkfxat(1);
    a = quot2(a, q);
    q = w9;
    a = CC_gbEnumHdist(a, q);
    w9 = a;
   G3044:
    a = w14;
    a = Lzerop(a);
    if(a != nil) goto    G3048;
    a = cdr(w2);
    a = CC_gbEhc(a);
    q = a;
    a = mkfxat(1);
    a = quot2(a, q);
    q = w14;
    a = CC_gbEnumHdist(a, q);
    w14 = a;
   G3048:
    a = car(w1);
    w7 = a;
    a = cdr(w1);
    w12 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G3052;
    q = mkfxat(2);
    a = LITERAL[160];
    a = quot2(a, q);
    a = Lminus(a);
    w19 = a;
    a = w7;
    a = CC_gbEhc(a);
    w20 = a;
    a = w12;
    a = CC_gbEhc(a);
    q = a;
    a = w20;
    a = plus2(a, q);
    q = a;
    a = w19;
    a = times2(a, q);
    w18 = a;
    q = w3;
    a = Lxcons(a, q);
    q = a;
    a = car(w7);
    a = Llist2(a, q);
    w18 = a;
    q = w5;
    a = Lxcons(a, q);
    arg4 = a;
    m = nil;
    q = w17;
    a = LL_mred;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G3052:
    a = w9;
    a = Lzerop(a);
    if(a == nil) goto    G3061;
    a = w7;
    a = CC_gbErest(a);
    w7 = a;
    a = w12;
    a = CC_gbErest(a);
    w12 = a;
    a = w7;
    a = Lzerop(a);
    if(a == nil) goto    G3071;
    a = w17;
    CC_gbEsyzyclear(a);
    goto    G3080;
   G3061:
    a = w7;
    a = CC_gbErest(a);
    w8 = a;
    a = w12;
    a = CC_gbErest(a);
    w13 = a;
    a = w7;
    a = CC_gbEhc(a);
    a = Lminus(a);
    m = w9;
    q = a;
    a = w3;
    a = CC_gbEtermHdist(a, q, m);
    w10 = a;
    a = w12;
    a = CC_gbEhc(a);
    a = Lminus(a);
    m = w14;
    q = a;
    a = w3;
    a = CC_gbEtermHdist(a, q, m);
    w15 = a;
    a = w8;
    a = Lzerop(a);
    if(a == nil) goto    G3069;
    a = w10;
    w7 = a;
    a = w15;
    w12 = a;
    goto    G3071;
   G3069:
    q = w10;
    a = w8;
    a = CC_gbEdistLdist(a, q);
    w7 = a;
    q = w15;
    a = w13;
    a = CC_gbEdistLdist(a, q);
    w12 = a;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G3080;
   G3071:
    q = w12;
    a = w7;
    a = cons(a, q);
    q = LL_head;
    a = CC_gbEABdelErrTerm(a, q);
    w18 = a;
    a = Lzerop(a);
    if(a == nil) goto    G3074;
   G3080:
    a = mkfxat(0);
    goto    G3035;
   G3074:
    a = car(w18);
    w7 = a;
    a = cdr(w18);
    w12 = a;
    q = w7;
    a = Lxcons(a, q);
    w1 = a;
    a = w7;
    a = CC_gbEhex(a);
    m = value(LL_gbEorder);
    q = w6;
    a = CC_gbEredchk(a, q, m);
    w3 = a;
    q = LL_no;
    a = Lneq(a, q);
    if(a != nil) goto    G3048;
    q = LL_all;
    a = w1;
    a = CC_gbEABdelErrTerm(a, q);
    w1 = a;
   G3035:
    popv(20);
    return a;
}

Sex CC_gbEABputmarks(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = mkfxat(7);
    a = mkfxat(10);
    a = Lexpt(a, q);
    a = Lfloat(a);
    w11 = a;
    q = mkfxat(7);
    a = mkfxat(10);
    a = Lexpt(a, q);
    q = mkfxat(2);
    a = quot2(a, q);
    a = Lfloat(a);
    w12 = a;
    a = LITERAL[160];
    a = CC_bnum2befloat(a);
    w13 = a;
    a = cdr(w1);
    w3 = a;
   G3084:
    a = cdr(cdr(car(w3)));
    w4 = a;
    a = cdr(a);
    w6 = a;
    a = w4;
    a = Lcopy(a);
    w5 = a;
    a = cdr(a);
    w7 = a;
    Lterpri();
   G3085:
    a = car(w6);
    w8 = a;
    a = car(w7);
    w9 = a;
    a = value(LL_Hrandom);
    a = CC_ArandomD7(a);
    value(LL_Hrandom) = a;
    a = Lfloat(a);
    w10 = a;
    q = w12;
    a = Lgreaterp(a, q);
    q = w10;
    if(a == nil) goto    G3092;
    a = LITERAL[245];
    a = times2(a, q);
    q = w11;
    a = quot2(a, q);
    goto    G3112;
   G3092:
    a = LITERAL[245];
    a = times2(a, q);
    q = w11;
    a = quot2(a, q);
    q = LITERAL[246];
    a = plus2(a, q);
   G3112:
    w10 = a;
    q = w2;
    a = w10;
    a = times2(a, q);
    q = a;
    a = w13;
    a = plus2(a, q);
    w14 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3100;
    a = LITERAL[247];
    Lprinc(a);
    a = w10;
    Lprint(a);
   G3100:
    q = w2;
    a = w10;
    a = times2(a, q);
    q = a;
    a = w13;
    a = plus2(a, q);
    q = cdr(w8);
    a = times2(a, q);
    q = a;
    a = w8;
    cdr(a) = q;
    q = w2;
    a = w10;
    a = times2(a, q);
    q = a;
    a = w13;
    a = diff2(a, q);
    q = cdr(w9);
    a = times2(a, q);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(w6);
    w6 = a;
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G3085;
    q = w5;
    a = w4;
    a = cons(a, q);
    q = a;
    a = cdr(car(w3));
    cdr(a) = q;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G3084;
    a = w1;
    popv(14);
    return a;
}

Sex CC_gbEABsaveApZero(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w14 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w1 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = CC_gbEABnormalz(a, q, m);
    w1 = a;
    a = car(a);
    a = CC_gbEhex(a);
    w8 = a;
    q = w3;
    a = cons(a, q);
    w15 = a;
    a = w2;
    a = Lncons(a);
    q = w1;
    a = cons(a, q);
    q = w15;
    a = Lxcons(a, q);
    w7 = a;
    a = LITERAL[248];
    w14 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3127;
    Lterpri();
    a = LITERAL[249];
    Lprinc(a);
    a = w14;
    Lprinc(a);
    a = w4;
    Lprin(a);
    a = LITERAL[151];
    Lprinc(a);
    Lterpri();
   G3127:
    a = value(LL_gbEapZeros);
    w5 = a;
    a = cdr(a);
    w6 = a;
   G3116:
    if(a == nil) goto    G3134;
    a = car(car(car(a)));
    w9 = a;
    m = value(LL_gbEorder);
    q = a;
    a = w8;
    a = CC_gbEordS(a, q, m);
    if(a == nil) goto    G3131;
    a = w6;
    w5 = a;
    a = cdr(a);
    goto    G3153;
   G3131:
    q = w9;
    a = w8;
    a = Lequal(a, q);
    if(a != nil) goto    G3118;
   G3134:
    q = w6;
    a = w7;
    a = cons(a, q);
    q = a;
    a = w5;
    cdr(a) = q;
    goto    G3152;
   G3118:
    m = value(LL_gbEorder);
    q = w9;
    a = w8;
    a = CC_gbEredchk(a, q, m);
    w11 = a;
    a = cdr(car(cdr(car(w7))));
    w10 = a;
    a = car(w6);
    w14 = a;
    a = cdr(cdr(a));
    w12 = a;
    a = car(car(cdr(w14)));
    w13 = a;
    q = cdr(car(cdr(car(w14))));
    a = w10;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3137;
    arg5 = w13;
    arg4 = w2;
    m = w11;
    q = w12;
    a = w1;
    a = CC_gbEABhred(a, q, m, arg4, arg5);
    w1 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3139;
    m = LITERAL[250];
    q = w13;
    a = w2;
    CC_gbEpriRedPbyQ(a, q, m);
   G3139:
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G3121;
    goto    G3122;
   G3137:
    q = w7;
    a = w6;
    car(a) = q;
    a = w14;
    w7 = a;
    arg5 = w2;
    arg4 = w13;
    m = w11;
    q = w1;
    a = w12;
    a = CC_gbEABhred(a, q, m, arg4, arg5);
    w1 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3143;
    m = LITERAL[250];
    q = w2;
    a = w13;
    CC_gbEpriRedPbyQ(a, q, m);
   G3143:
    a = w1;
    a = Lzerop(a);
    if(a != nil) goto    G3155;
    a = w13;
    w2 = a;
    a = cdr(car(w7));
    w3 = a;
   G3121:
    q = LITERAL[160];
    a = car(car(w3));
    a = cons(a, q);
    w14 = a;
    m = w3;
    q = w2;
    a = w1;
    CC_gbEABevalInf4(a, q, m);
    a = car(w1);
    a = CC_gbEhex(a);
    w8 = a;
    q = w3;
    a = cons(a, q);
    w15 = a;
    a = w2;
    a = Lncons(a);
    q = w1;
    a = cons(a, q);
    q = w15;
    a = Lxcons(a, q);
    w7 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3150;
    arg4 = w3;
    m = w1;
    q = w2;
    a = nil;
    CC_gbEABpriRedPol(a, q, m, arg4);
   G3150:
    a = value(LL_gbEapZeros);
    w5 = a;
    a = cdr(a);
   G3153:
    w6 = a;
    goto    G3116;
   G3155:
    a = w13;
    w2 = a;
   G3122:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3152;
    m = LITERAL[251];
    q = LITERAL[252];
    a = w2;
    CC_gbEpriPmsgmsg(a, q, m);
   G3152:
    a = LL_AppZERO;
    popv(15);
    return a;
}

Sex CC_gbEoldfindReducer(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 16;
    w16 = nil;
    w13 = nil;
    w12 = nil;
    w10 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w9 = nil;
    w11 = nil;
    w14 = nil;
    w15 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = LITERAL[253];
    a = w2;
    a = Lequal(a, q);
    if(a == nil) goto    G3167;
    q = w4;
    a = LITERAL[254];
    CC_argprint(a, q);
   G3167:
    a = car(cdr(w3));
    w12 = a;
    a = cdr(cdr(w3));
    w13 = a;
    a = CHAR_OF(72);
    a = Lncons(a);
    w10 = a;
    a = cdr(w1);
    w8 = a;
    a = cdr(value(LL_gbEcontrol));
    w16 = a;
    a = car(a);
    w5 = a;
    a = car(cdr(w16));
    w6 = a;
    a = cdr(cdr(w16));
    w7 = a;
    q = a;
    a = car(w4);
    a = Lequal(a, q);
    if(a != nil) goto    G3159;
    q = mkfxat(2);
    a = w7;
    a = Lexpt(a, q);
    q = a;
    a = car(w4);
    a = Lequal(a, q);
    if(a != nil) goto    G3186;
    a = cdr(car(w3));
    w14 = a;
    goto    G3200;
   G3159:
    a = car(w8);
    w9 = a;
    if(!is_cons(a)) goto    G3160;
    m = value(LL_gbEorder);
    q = car(car(a));
    a = w2;
    a = CC_gbEredchk(a, q, m);
    w11 = a;
    if(a == LL_no) goto    G3160;
    a = cdr(car(w9));
    w15 = a;
    a = cdr(a);
    w16 = a;
    q = w5;
    a = w12;
    a = times2(a, q);
    q = car(w16);
    a = Llessp(a, q);
    if(a != nil) goto    G3160;
    q = w5;
    a = w13;
    a = times2(a, q);
    q = cdr(w16);
    a = Llessp(a, q);
    if(a != nil) goto    G3160;
    q = w9;
    a = w11;
    a = cons(a, q);
    q = car(cdr(w15));
    a = Lxcons(a, q);
    w16 = a;
    m = LL_lessp;
    q = w10;
    CC_seTinsertbycar(a, q, m);
   G3160:
    a = w8;
    if(a == w4) goto    G3211;
    a = cdr(a);
    w8 = a;
    if(a != nil) goto    G3159;
   G3186:
    a = car(w8);
    w9 = a;
    if(!is_cons(a)) goto    G3162;
    m = value(LL_gbEorder);
    q = car(car(a));
    a = w2;
    a = CC_gbEredchk(a, q, m);
    w11 = a;
    if(a == LL_no) goto    G3162;
    a = cdr(car(w9));
    w15 = a;
    a = cdr(a);
    w16 = a;
    q = w5;
    a = w12;
    a = times2(a, q);
    q = car(w16);
    a = Llessp(a, q);
    if(a != nil) goto    G3162;
    q = w6;
    a = w13;
    a = times2(a, q);
    q = cdr(w16);
    a = Llessp(a, q);
    if(a != nil) goto    G3162;
    q = w9;
    a = w11;
    a = cons(a, q);
    q = cdr(car(w15));
    a = Lxcons(a, q);
    w16 = a;
    m = LL_lessp;
    q = w10;
    CC_seTinsertbycar(a, q, m);
   G3162:
    a = w8;
    if(a == w4) goto    G3211;
    a = cdr(a);
    w8 = a;
    if(a != nil) goto    G3186;
   G3200:
    a = car(w8);
    w9 = a;
    if(!is_cons(a)) goto    G3164;
    m = value(LL_gbEorder);
    q = car(car(a));
    a = w2;
    a = CC_gbEredchk(a, q, m);
    w11 = a;
    if(a == LL_no) goto    G3164;
    a = cdr(car(w9));
    w15 = a;
    a = car(a);
    w16 = a;
    q = w6;
    a = w14;
    a = times2(a, q);
    q = cdr(w16);
    a = Llessp(a, q);
    if(a != nil) goto    G3164;
    q = w9;
    a = w11;
    a = cons(a, q);
    q = cdr(car(w15));
    a = Lxcons(a, q);
    w16 = a;
    m = LL_lessp;
    q = w10;
    CC_seTinsertbycar(a, q, m);
   G3164:
    a = w8;
    if(a == w4) goto    G3211;
    a = cdr(a);
    w8 = a;
    if(a != nil) goto    G3200;
   G3211:
    a = cdr(w10);
    w10 = a;
    if(a == nil) goto    G3158;
    a = cdr(car(a));
   G3158:
    popv(16);
    return a;
}

Sex CC_gbEABmoveCancPol(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w1 = a;
    a = cdr(a);
    w6 = a;
    a = car(cdr(value(LL_gbEcontrol)));
    w4 = a;
    a = cdr(cdr(cdr(value(LL_gbEcontrol))));
    w5 = a;
    w2 = q;
    w3 = m;
    q = a;
    a = value(LL_gbEcanclvl);
    a = Lequal(a, q);
    if(a == nil) goto    G3232;
    q = mkfxat(2);
    a = w5;
    a = Lexpt(a, q);
    value(LL_gbEcanclvl) = a;
    goto    G3224;
   G3232:
    a = cdr(cdr(cdr(car(car(w6)))));
    w13 = a;
    q = a;
    a = CHAR_OF(104);
    a = Llist2(a, q);
    w11 = a;
    goto    G3219;
   G3218:
    a = cdr(cdr(cdr(car(car(w6)))));
    w13 = a;
    m = LL_lessp;
    q = w11;
    CC_seTinsert(a, q, m);
   G3219:
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G3218;
    a = cdr(w11);
    w11 = a;
    a = cdr(w1);
    w6 = a;
    q = value(LL_gbEcanclvl);
    a = car(w11);
    a = Lleq(a, q);
    if(a != nil) goto    G3259;
    a = mkfxat(3);
    w4 = a;
    a = cdr(w11);
    if(a == nil) goto    G3222;
    a = cdr(a);
    q = car(w11);
    if(a == nil) goto    G3221;
    a = w4;
    a = times2(a, q);
    q = car(cdr(w11));
    a = Llessp(a, q);
    if(a == nil) goto    G3241;
    a = cdr(w11);
    w11 = a;
   G3241:
    a = w11;
    a = CC_tail2(a);
    w12 = a;
    q = car(a);
    a = w4;
    a = times2(a, q);
    q = car(cdr(w12));
    a = Llessp(a, q);
    if(a == nil) goto    G3244;
    q = nil;
    a = w12;
    cdr(a) = q;
   G3244:
    a = w11;
    a = CC_sumelms(a);
    q = a;
    a = w4;
    a = times2(a, q);
    w15 = a;
    a = w11;
    a = Llength(a);
    q = a;
    a = w15;
    goto    G3291;
   G3221:
    a = w4;
    a = times2(a, q);
    q = car(cdr(w11));
    a = Lgreaterp(a, q);
    q = car(cdr(w11));
    if(a == nil) goto    G3250;
    a = car(w11);
    a = plus2(a, q);
    q = a;
    a = w4;
    a = times2(a, q);
    q = mkfxat(2);
   G3291:
    a = quot2(a, q);
    goto    G3292;
   G3250:
    a = w4;
    a = times2(a, q);
   G3292:
    value(LL_gbEcanclvl) = a;
    goto    G3223;
   G3222:
    q = car(w11);
    a = w4;
    a = times2(a, q);
    value(LL_gbEcanclvl) = a;
   G3223:
    a = value(LL_gbEcanclvl);
    a = CC_truncat3dgt(a);
    value(LL_gbEcanclvl) = a;
    a = w2;
    a = CC_tail(a);
    w15 = a;
    a = value(LL_gbEcanclvl);
    a = Lncons(a);
    q = a;
    a = w15;
    cdr(a) = q;
    a = cdr(a);
   G3224:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3259;
    Lterpri();
    a = LITERAL[255];
    Lprinc(a);
    a = LITERAL[256];
    Lprinc(a);
    a = value(LL_gbEcanclvl);
    Lprint(a);
   G3259:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3261;
    q = LITERAL[257];
    a = w2;
    CC_gbEABpriHxInf4s(a, q);
   G3261:
    a = cdr(w1);
    w6 = a;
#define LL_STset2 LITERAL[258]
    a = LL_STset2;
    a = Lncons(a);
    w14 = a;
   G3226:
    a = car(w6);
    w7 = a;
    a = car(car(cdr(a)));
    w8 = a;
    a = cdr(cdr(w7));
    w9 = a;
    a = car(w7);
    w10 = a;
    q = w9;
    a = w8;
    a = cons(a, q);
    q = a;
    a = w2;
    CC_gbEABintlzSyzsIPs(a, q);
    arg5 = true;
    arg4 = w8;
    m = w10;
    q = w2;
    a = w9;
    a = CC_gbEABredpol(a, q, m, arg4, arg5);
    w13 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G3264;
    a = cdr(w13);
    w9 = a;
    a = car(w13);
    w10 = a;
    goto    G3228;
   G3264:
    a = LL_same;
    if(a == w13) goto    G3229;
    a = w13;
    a = Lzerop(a);
    if(a == nil) goto    G3267;
    a = LITERAL[259];
    w12 = a;
    goto    G3273;
   G3267:
    a = w13;
    a = Lonep(a);
    if(a == nil) goto    G3268;
    a = mkfxat(1);
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    a = cdr(a);
    a = mkfxat(1);
    goto    G3216;
   G3268:
    a = w13;
    a = Lminus(a);
    a = Lonep(a);
    if(a != nil) goto    G3293;
    a = LL_PrecShort;
    goto    G3216;
   G3293:
    w12 = nil;
    a = w12;
   G3273:
    if(a == nil) goto    G3275;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3275;
    m = w12;
    q = LITERAL[260];
    a = w8;
    CC_gbEpriPmsgmsg(a, q, m);
   G3275:
    a = cdr(w6);
    w6 = a;
    if(a == nil) goto    G3230;
    goto    G3226;
   G3228:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3280;
    arg4 = cdr(w10);
    m = w9;
    q = w8;
    a = true;
    CC_gbEABpriRedPol(a, q, m, arg4);
   G3280:
    m = nil;
    q = w8;
    a = w10;
    a = CC_gbEABbigMaxCp(a, q, m);
    if(a == nil) goto    G3229;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3284;
    m = LITERAL[261];
    q = LITERAL[262];
    a = w8;
    CC_gbEpriPmsgmsg(a, q, m);
   G3284:
    a = w8;
    a = Lncons(a);
    q = w9;
    a = cons(a, q);
    q = w10;
    a = Lxcons(a, q);
    w7 = a;
    q = w14;
    CC_gbEABinsSset(a, q);
    goto    G3275;
   G3229:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3288;
    m = LITERAL[263];
    q = LITERAL[264];
    a = w8;
    CC_gbEpriPmsgmsg(a, q, m);
   G3288:
    m = LL_lessp;
    q = w3;
    a = w8;
    CC_seTinsert(a, q, m);
    q = w2;
    a = w8;
    CC_gbEinsunpC(a, q);
    arg4 = w3;
    m = w8;
    q = w10;
    a = w9;
    a = CC_gbEABmkwprep(a, q, m, arg4);
    w7 = a;
    q = w2;
    CC_gbEABinsWset(a, q);
    goto    G3275;
   G3230:
    q = cdr(w14);
    a = w1;
    cdr(a) = q;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3290;
    q = LITERAL[225];
    a = w1;
    CC_gbEABpriHxInf4s(a, q);
   G3290:
    a = w2;
   G3216:
    popv(15);
    return a;
}

Sex CC_gbEABintlzSyzsIPs(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    a = value(LL_gbEhistry);
    if(a != nil) goto    G3301;
    a = mkfxat(0);
    a = Lncons(a);
    value(LL_gbEhistry) = a;
   G3301:
    a = cdr(w1);
    w3 = a;
   G3297:
    a = car(w3);
    if(!is_cons(a)) goto    G3298;
    a = car(car(cdr(a)));
    w5 = a;
    a = cdr(cdr(car(w3)));
    w6 = a;
    a = w5;
    a = Lncons(a);
    q = a;
    a = value(LL_gbEsyzvar);
    a = CC_gevTxid(a, q);
    w7 = a;
    a = CC_Acoef2befloat(a);
    m = a;
    q = w5;
    a = value(LL_gbEsyzygy);
    Lputv(a, q, m);
    q = w6;
    a = w5;
    a = cons(a, q);
    m = LL_lessp;
    q = w4;
    a = CC_insertbycar(a, q, m);
    w4 = a;
   G3298:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G3297;
    a = w2;
    if(a == nil) goto    G3299;
    a = car(a);
    w5 = a;
    a = cdr(w2);
    w6 = a;
    a = w5;
    a = Lncons(a);
    q = a;
    a = value(LL_gbEsyzvar);
    a = CC_gevTxid(a, q);
    w7 = a;
    a = CC_Acoef2befloat(a);
    m = a;
    q = w5;
    a = value(LL_gbEsyzygy);
    Lputv(a, q, m);
    q = w6;
    a = w5;
    a = cons(a, q);
    m = LL_lessp;
    q = w4;
    a = CC_insertbycar(a, q, m);
    w4 = a;
   G3299:
    a = cdr(value(LL_gbEhistry));
    w8 = a;
    if(a == nil) goto    G3315;
    q = nil;
    cdr(a) = q;
   G3315:
    q = value(LL_gbEhistry);
    a = w4;
    a = cons(a, q);
    value(LL_gbEhistry) = a;
    a = w4;
    popv(8);
    return a;
}

Sex CC_gbEABevalSysInxC(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w19 = nil;
    w18 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3337;
    Lterpri();
    a = LITERAL[265];
    Lprinc(a);
    a = LITERAL[266];
    Lprinc(a);
    a = LITERAL[267];
    Lprinc(a);
    Lterpri();
   G3337:
    a = w2;
    if(!is_cons(a)) goto    G3339;
    a = car(a);
    w2 = a;
   G3339:
    a = car(value(LL_gbEhistry));
    w5 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w18 = a;
    w6 = a;
   G3319:
    a = car(w5);
    w19 = a;
    q = car(cdr(a));
    a = car(a);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w18;
    cdr(a) = q;
    a = cdr(a);
    w18 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G3319;
    a = car(value(LL_gbEhistry));
    w5 = a;
    a = cdr(w6);
    w6 = a;
    a = w5;
    a = CC_gbEABnrmlzIplis(a);
    w5 = a;
    q = w2;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w4 = a;
    m = w4;
    q = w6;
    a = w2;
    a = CC_gbEmatxMonoset(a, q, m);
    w7 = a;
    a = w7;
    a = CC_gbEmatxMergExs(a);
    w8 = a;
    a = car(w1);
    a = CC_gbEhex(a);
    q = w8;
    a = CC_gbEmatxHexpos(a, q);
    w9 = a;
    arg4 = w8;
    m = w7;
    q = w5;
    a = w2;
    a = CC_gbEABmatxMkMatx(a, q, m, arg4);
    w10 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3347;
    a = LITERAL[268];
    Lprinc(a);
    a = cdr(w10);
    a = Llength(a);
    Lprint(a);
    a = LITERAL[269];
    Lprinc(a);
    a = w8;
    a = Llength(a);
    Lprint(a);
    a = LITERAL[270];
    Lprinc(a);
    a = w9;
    Lprint(a);
   G3347:
    a = LITERAL[271];
    CC_enterto(a);
    q = mkfxat(-1);
    a = w9;
    a = plus2(a, q);
    q = a;
    a = w8;
    a = CC_ncdr(a, q);
    w13 = a;
    q = mkfxat(-1);
    a = w9;
    a = plus2(a, q);
    m = value(LL_gbEaccinit);
    q = a;
    a = cdr(w10);
    a = CC_gbEABGaussFelim(a, q, m);
    w10 = a;
    a = Lzerop(a);
    if(a == nil) goto    G3325;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3397;
    Lterpri();
    a = LITERAL[272];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = LITERAL[157];
    Lprinc(a);
    a = LITERAL[273];
    Lprinc(a);
    Lterpri();
    goto    G3397;
   G3325:
    a = cdr(w10);
    if(a != nil) goto    G3398;
    a = car(w10);
    w18 = a;
    goto    G3329;
   G3398:
    a = w10;
    w18 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3360;
    Lterpri();
    a = LITERAL[274];
    Lprinc(a);
    Lterpri();
   G3360:
    a = car(w18);
    a = CC_Wzerolist(a);
    if(a == nil) goto    G3362;
    Lterpri();
    a = LITERAL[275];
    w19 = a;
    Lprinc(a);
    Lterpri();
    goto    G3397;
   G3362:
    a = cdr(w18);
    w18 = a;
    if(a != nil) goto    G3360;
    a = w10;
    w18 = a;
   G3328:
    a = car(car(w18));
    a = Lzerop(a);
    if(a == nil) goto    G3368;
    a = cdr(w18);
    w18 = a;
    if(a != nil) goto    G3328;
    a = w10;
    a = CC_listcdr(a);
    w10 = a;
    w18 = a;
    a = cdr(w13);
    w13 = a;
    goto    G3328;
   G3368:
    a = car(w18);
    w18 = a;
   G3329:
    a = value(LL_gbEorder);
    a = Lncons(a);
    w16 = a;
    w14 = a;
    a = value(LL_gbEorder);
    a = Lncons(a);
    w17 = a;
    w15 = a;
   G3330:
    a = car(w18);
    w19 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3331;
    q = car(w19);
    a = car(w13);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w16;
    cdr(a) = q;
    a = cdr(a);
    w16 = a;
    q = cdr(w19);
    a = car(w13);
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w17;
    cdr(a) = q;
    a = cdr(a);
    w17 = a;
   G3331:
    a = cdr(w13);
    w13 = a;
    a = cdr(w18);
    w18 = a;
    if(a != nil) goto    G3330;
    a = car(w10);
    w18 = a;
    a = LITERAL[7];
    w12 = a;
   G3333:
    a = car(w18);
    a = Lzerop(a);
    if(a != nil) goto    G3334;
    a = car(car(w18));
    a = Lbefloat_value(a);
    a = Lfloat(a);
    w19 = a;
    a = Labs(a);
    q = a;
    a = w12;
    a = Lmax2(a, q);
    w12 = a;
   G3334:
    a = cdr(w18);
    w18 = a;
    if(a != nil) goto    G3333;
    a = w12;
    a = Lzerop(a);
    if(a == nil) goto    G3387;
   G3397:
    a = mkfxat(0);
    goto    G3318;
   G3387:
    q = value(LL_gbEaccinit);
    a = mkfxat(1);
    a = quot2(a, q);
    w20 = a;
    q = w12;
    a = mkfxat(1);
    a = quot2(a, q);
    q = a;
    a = w20;
    a = Lmin2(a, q);
    w11 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3391;
    a = LITERAL[276];
    Lprinc(a);
    a = LITERAL[277];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    q = LITERAL[176];
    a = w11;
    a = plus2(a, q);
    a = Ltruncate(a);
    Lprin(a);
    Lterpri();
   G3391:
    q = w15;
    a = w14;
    a = cons(a, q);
    q = w11;
    a = Lxcons(a, q);
   G3318:
    popv(20);
    return a;
}

Sex CC_gbEABnrmlzIplis(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = nil;
    w6 = nil;
    w2 = a;
    a = CHAR_OF(104);
    a = Lncons(a);
    w3 = a;
    w1 = a;
   G3402:
    a = cdr(car(w2));
    w9 = a;
    a = cdr(car(a));
    w7 = a;
    a = cdr(cdr(w9));
    w8 = a;
    q = cdr(car(a));
    a = cdr(car(w7));
    a = cons(a, q);
    w5 = a;
    a = car(a);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w4 = a;
    goto    G3411;
   G3403:
    a = cdr(car(w7));
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w9 = a;
    q = w4;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3411;
    a = w9;
    w4 = a;
    q = cdr(car(w8));
    a = cdr(car(w7));
    a = cons(a, q);
    w5 = a;
   G3411:
    a = cdr(w7);
    w7 = a;
    a = cdr(w8);
    w8 = a;
    a = w7;
    if(a != nil) goto    G3403;
    a = car(w5);
    a = Lbefloat_value(a);
    w10 = a;
    a = cdr(w5);
    a = Lbefloat_value(a);
    q = a;
    a = w10;
    a = plus2(a, q);
    q = a;
    a = mkfxat(2);
    a = quot2(a, q);
    w9 = a;
    a = CC_ONEp(a);
    if(a == nil) goto    G3418;
    a = car(w2);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
    goto    G3405;
   G3418:
    q = car(cdr(car(w2)));
    a = w9;
    a = CC_gbEnumHdist(a, q);
    w10 = a;
    q = cdr(cdr(car(w2)));
    a = w9;
    a = CC_gbEnumHdist(a, q);
    q = w10;
    a = Lxcons(a, q);
    w9 = a;
    q = car(car(w2));
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w3;
    cdr(a) = q;
    a = cdr(a);
    w3 = a;
   G3405:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G3402;
    a = cdr(w1);
    popv(10);
    return a;
}

Sex CC_gbEoldABmatxMkMatx(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 17;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = LL_CMatx;
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = w4;
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G3431:
    a = car(car(w3));
    w12 = a;
    a = cdr(car(w3));
    w9 = a;
    q = w2;
    a = w12;
    a = Lassoc(a, q);
    a = cdr(a);
    w14 = a;
    a = car(a);
    w13 = a;
    a = cdr(w14);
    w14 = a;
   G3432:
    a = car(w9);
    w10 = a;
    a = car(a);
    w17 = a;
    a = cdr(w13);
    w15 = a;
    a = cdr(w14);
    w16 = a;
    a = LL_row;
    a = Lncons(a);
    w8 = a;
    w7 = a;
    a = w4;
    w11 = a;
   G3433:
    q = car(w11);
    a = w17;
    a = Lequal(a, q);
    if(a != nil) goto    G3441;
    a = mkfxat(0);
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
    a = cdr(w11);
    w11 = a;
    goto    G3433;
   G3441:
    q = cdr(car(w16));
    a = cdr(car(w15));
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
    a = cdr(w11);
    w11 = a;
    a = cdr(w10);
    w10 = a;
    if(a == nil) goto    G3448;
    a = cdr(w15);
    w15 = a;
    a = cdr(w16);
    w16 = a;
    a = car(w10);
    w17 = a;
    goto    G3433;
   G3448:
    a = w11;
    if(a == nil) goto    G3450;
    a = mkfxat(0);
    a = Lncons(a);
    q = a;
    a = w8;
    cdr(a) = q;
    a = cdr(a);
    w8 = a;
    a = cdr(w11);
    w11 = a;
    goto    G3448;
   G3450:
    a = cdr(w7);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    if(a != nil) goto    G3432;
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G3458;
    a = cdr(w2);
    w2 = a;
    goto    G3431;
   G3458:
    a = cdr(w5);
    popv(17);
    return a;
}

Sex CC_gbEoldABGaussFelim(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w18 = nil;
    w16 = nil;
    w15 = nil;
    w13 = nil;
    w6 = nil;
    w4 = nil;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w14 = nil;
    w17 = nil;
    w19 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = mkfxat(0);
    a = nil;
    a = cons(a, q);
    w13 = a;
    a = mkfxat(0);
    w16 = a;
    a = w1;
    w4 = a;
   G3462:
    a = car(w4);
    w6 = a;
    a = w16;
    a = Ladd1(a);
    w16 = a;
    a = mkfxat(0);
    w15 = a;
   G3463:
    a = w15;
    a = Ladd1(a);
    w15 = a;
    a = car(w6);
    w18 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3481;
    a = car(w18);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w18 = a;
    q = cdr(w13);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3481;
    q = w18;
    a = w13;
    cdr(a) = q;
    q = w16;
    a = w15;
    a = cons(a, q);
    w18 = a;
    q = a;
    a = w13;
    car(a) = q;
   G3481:
    a = cdr(w6);
    w6 = a;
    q = w2;
    a = w15;
    a = Llessp(a, q);
    if(a != nil) goto    G3463;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G3462;
    a = car(w13);
    if(a == nil) goto    G3544;
    a = mkfxat(0);
    w14 = a;
   G3467:
    a = w14;
    a = Ladd1(a);
    w14 = a;
    a = car(car(w13));
    w15 = a;
    q = w14;
    a = Lneq(a, q);
    if(a == nil) goto    G3489;
    a = w14;
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w15;
    a = plus2(a, q);
    q = a;
    a = w1;
    a = CC_gbEmatxExchCol1(a, q);
    w1 = a;
   G3489:
    a = cdr(car(w13));
    w16 = a;
    a = Lonep(a);
    if(a != nil) goto    G3495;
    q = mkfxat(-2);
    a = w16;
    a = plus2(a, q);
    q = a;
    a = w1;
    a = CC_ncdr(a, q);
    w18 = a;
    a = car(cdr(a));
    w8 = a;
    q = cdr(cdr(w18));
    a = w18;
    cdr(a) = q;
    q = w1;
    a = w8;
    a = cons(a, q);
    w1 = a;
   G3495:
    q = mkfxat(0);
    a = nil;
    a = cons(a, q);
    w13 = a;
    a = car(w1);
    w5 = a;
    a = cdr(w1);
    w4 = a;
    a = mkfxat(1);
    w16 = a;
   G3468:
    a = car(w4);
    w8 = a;
    a = car(a);
    w10 = a;
    a = Lzerop(a);
    if(a == nil) goto    G3469;
    arg6 = w3;
    arg5 = w2;
    arg4 = w14;
    m = w16;
    q = w8;
    a = w13;
    CC_gbEABrowPivot(a, q, m, arg4, arg5, arg6);
    goto    G3472;
   G3469:
    q = car(car(w5));
    a = car(w10);
    a = quot2(a, q);
    w11 = a;
    q = cdr(car(w5));
    a = cdr(w10);
    a = quot2(a, q);
    w12 = a;
    q = mkfxat(0);
    a = w8;
    car(a) = q;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
    a = w14;
    w15 = a;
    w17 = nil;
    goto    G3522;
   G3470:
    a = car(w6);
    w7 = a;
    a = car(w9);
    w10 = a;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G3522;
    a = w10;
    a = Lzerop(a);
    q = car(w7);
    if(a == nil) goto    G3502;
    a = w11;
    a = times2(a, q);
    a = Lminus(a);
    w20 = a;
    q = cdr(w7);
    a = w12;
    a = times2(a, q);
    a = Lminus(a);
    goto    G3542;
   G3502:
    a = w11;
    a = times2(a, q);
    q = a;
    a = car(w10);
    a = diff2(a, q);
    w20 = a;
    q = cdr(w7);
    a = w12;
    a = times2(a, q);
    q = a;
    a = cdr(w10);
    a = diff2(a, q);
   G3542:
    q = w20;
    a = Lxcons(a, q);
    w18 = a;
    q = w3;
    a = car(w18);
    a = CC_acczerop(a, q);
    if(a == nil) goto    G3513;
    q = mkfxat(0);
    a = w9;
    goto    G3543;
   G3513:
    q = w18;
    a = w9;
    car(a) = q;
    q = w2;
    a = w15;
    a = Lleq(a, q);
    if(a == nil) goto    G3514;
    a = true;
    w17 = a;
   G3514:
    q = w2;
    a = w15;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G3522;
    a = car(w18);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w18 = a;
    q = cdr(w13);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3522;
    q = w18;
    a = w13;
    cdr(a) = q;
    q = w16;
    a = w15;
    a = cons(a, q);
    w18 = a;
    q = a;
    a = w13;
   G3543:
    car(a) = q;
   G3522:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w15;
    a = Ladd1(a);
    w15 = a;
    a = w6;
    if(a != nil) goto    G3470;
    a = w8;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G3472;
    a = cdr(cdr(w1));
    if(a != nil) goto    G3528;
    a = mkfxat(0);
    goto    G3461;
   G3528:
    q = w8;
    a = LITERAL[278];
    CC_argprint(a, q);
    q = w4;
    a = w1;
    a = CC_before(a, q);
    w18 = a;
    q = cdr(w4);
    cdr(a) = q;
    a = true;
    w19 = a;
    a = w16;
    a = Lsub1(a);
    w16 = a;
   G3472:
    a = w16;
    a = Ladd1(a);
    w16 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G3468;
    a = cdr(w1);
    a = CC_listcdr(a);
    w1 = a;
    q = w2;
    a = w14;
    a = Lgeq(a, q);
    if(a != nil) goto    G3544;
    a = car(w13);
    if(a != nil) goto    G3467;
    q = w14;
    a = w2;
    a = diff2(a, q);
    q = a;
    a = w1;
    a = CC_gbEABchkdelZRlftcol(a, q);
    w18 = a;
    if(a == nil) goto    G3539;
    a = cdr(a);
    w1 = a;
    q = car(w18);
    a = w14;
    a = plus2(a, q);
    w14 = a;
    q = w2;
    a = Lgeq(a, q);
    if(a != nil) goto    G3544;
   G3539:
    a = w14;
    a = Lminus(a);
    q = a;
    a = w2;
    a = plus2(a, q);
    w2 = a;
    a = mkfxat(0);
    w16 = a;
    q = nil;
    a = Lxcons(a, q);
    w13 = a;
    a = w1;
    w4 = a;
    goto    G3462;
   G3544:
    a = w1;
   G3461:
    popv(20);
    return a;
}

Sex CC_gbEABrowPivot(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w1 = a;
    a = cdr(q);
    w7 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
   G3548:
    a = w4;
    a = Ladd1(a);
    w4 = a;
    q = w5;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G3565;
    a = car(w7);
    w8 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3557;
    a = car(w8);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w8 = a;
    q = cdr(w1);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3557;
    q = w3;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w1;
    car(a) = q;
    q = w8;
    a = w1;
    cdr(a) = q;
   G3557:
    q = w6;
    a = cdr(w1);
    a = Llessp(a, q);
    if(a != nil) goto    G3565;
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G3548;
   G3565:
    a = w1;
    popv(8);
    return a;
}

Sex CC_gbEABGaussBelim(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 19;
    w19 = nil;
    w17 = nil;
    w16 = nil;
    w15 = nil;
    w14 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w18 = nil;
    w1 = a;
    a = mkfxat(0);
    w13 = a;
    w2 = q;
    w3 = m;
   G3571:
    q = mkfxat(0);
    a = nil;
    a = cons(a, q);
    w14 = a;
    a = w13;
    a = Ladd1(a);
    w16 = a;
    w15 = a;
    q = w13;
    a = w1;
    a = CC_ncdr(a, q);
    w4 = a;
   G3572:
    q = w13;
    a = car(w4);
    a = CC_ncdr(a, q);
    a = car(a);
    w17 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3591;
    a = car(w17);
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w17 = a;
    q = cdr(w14);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3591;
    q = w17;
    a = w14;
    cdr(a) = q;
    q = w16;
    a = w15;
    a = cons(a, q);
    w17 = a;
    q = a;
    a = w14;
    car(a) = q;
   G3591:
    a = w16;
    a = Ladd1(a);
    w16 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G3572;
    a = car(w14);
    if(a == nil) goto    G3621;
    a = cdr(a);
    w16 = a;
    a = Lonep(a);
    if(a != nil) goto    G3597;
    q = mkfxat(-2);
    a = w16;
    a = plus2(a, q);
    q = a;
    a = w1;
    a = CC_ncdr(a, q);
    w17 = a;
    a = car(cdr(a));
    w8 = a;
    q = cdr(cdr(w17));
    a = w17;
    cdr(a) = q;
    q = w1;
    a = w8;
    a = cons(a, q);
    w1 = a;
   G3597:
    q = w13;
    a = w1;
    a = CC_ncdr(a, q);
    w4 = a;
    q = w13;
    a = car(a);
    a = CC_ncdr(a, q);
    w5 = a;
   G3574:
    a = cdr(w4);
    w4 = a;
    q = w13;
    a = car(a);
    a = CC_ncdr(a, q);
    w8 = a;
    a = car(a);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3619;
    q = car(car(w5));
    a = car(w10);
    a = quot2(a, q);
    w11 = a;
    q = cdr(car(w5));
    a = cdr(w10);
    a = quot2(a, q);
    w12 = a;
    q = mkfxat(0);
    a = w8;
    car(a) = q;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
    goto    G3617;
   G3575:
    a = car(w6);
    w7 = a;
    a = car(w9);
    w10 = a;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G3617;
    a = w10;
    a = Lzerop(a);
    q = car(w7);
    if(a == nil) goto    G3605;
    a = w11;
    a = times2(a, q);
    a = Lminus(a);
    w19 = a;
    q = cdr(w7);
    a = w12;
    a = times2(a, q);
    a = Lminus(a);
    goto    G3658;
   G3605:
    a = w11;
    a = times2(a, q);
    q = a;
    a = car(w10);
    a = diff2(a, q);
    w19 = a;
    q = cdr(w7);
    a = w12;
    a = times2(a, q);
    q = a;
    a = cdr(w10);
    a = diff2(a, q);
   G3658:
    q = w19;
    a = Lxcons(a, q);
    w17 = a;
    q = w3;
    a = car(w17);
    a = CC_acczerop(a, q);
    if(a == nil) goto    G3616;
    q = mkfxat(0);
    goto    G3659;
   G3616:
    q = w17;
   G3659:
    a = w9;
    car(a) = q;
   G3617:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G3575;
   G3619:
    a = cdr(w4);
    if(a != nil) goto    G3574;
   G3621:
    a = w13;
    a = Ladd1(a);
    w13 = a;
    w19 = a;
    q = mkfxat(-1);
    a = w2;
    a = plus2(a, q);
    q = a;
    a = w19;
    a = Llessp(a, q);
    if(a != nil) goto    G3571;
    a = w1;
    a = Lreverse(a);
    w1 = a;
    q = a;
    a = LITERAL[279];
    CC_argprint(a, q);
    a = mkfxat(0);
    w13 = a;
   G3579:
    q = w13;
    a = w1;
    a = CC_ncdr(a, q);
    w4 = a;
    a = w13;
    a = Lminus(a);
    q = a;
    a = w2;
    a = plus2(a, q);
    w15 = a;
    q = mkfxat(-1);
    a = plus2(a, q);
    q = a;
    a = car(w4);
    a = CC_ncdr(a, q);
    w5 = a;
    a = car(a);
    a = Lzerop(a);
    if(a != nil) goto    G3652;
   G3629:
    a = cdr(w4);
    w4 = a;
    q = mkfxat(-1);
    a = w15;
    a = plus2(a, q);
    q = a;
    a = car(w4);
    a = CC_ncdr(a, q);
    w8 = a;
    a = car(a);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G3650;
    q = car(car(w5));
    a = car(w10);
    a = quot2(a, q);
    w11 = a;
    q = cdr(car(w5));
    a = cdr(w10);
    a = quot2(a, q);
    w12 = a;
    q = mkfxat(0);
    a = w8;
    car(a) = q;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
    goto    G3648;
   G3581:
    a = car(w6);
    w7 = a;
    a = car(w9);
    w10 = a;
    a = w7;
    a = Lzerop(a);
    if(a != nil) goto    G3648;
    a = w10;
    a = Lzerop(a);
    q = car(w7);
    if(a == nil) goto    G3636;
    a = w11;
    a = times2(a, q);
    a = Lminus(a);
    w19 = a;
    q = cdr(w7);
    a = w12;
    a = times2(a, q);
    a = Lminus(a);
    goto    G3660;
   G3636:
    a = w11;
    a = times2(a, q);
    q = a;
    a = car(w10);
    a = diff2(a, q);
    w19 = a;
    q = cdr(w7);
    a = w12;
    a = times2(a, q);
    q = a;
    a = cdr(w10);
    a = diff2(a, q);
   G3660:
    q = w19;
    a = Lxcons(a, q);
    w17 = a;
    q = w3;
    a = car(w17);
    a = CC_acczerop(a, q);
    if(a == nil) goto    G3647;
    q = mkfxat(0);
    goto    G3661;
   G3647:
    q = w17;
   G3661:
    a = w9;
    car(a) = q;
   G3648:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G3581;
   G3650:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G3629;
   G3652:
    a = w13;
    a = Ladd1(a);
    w13 = a;
    w19 = a;
    q = mkfxat(-1);
    a = w2;
    a = plus2(a, q);
    q = a;
    a = w19;
    a = Llessp(a, q);
    if(a != nil) goto    G3579;
    q = w1;
    a = LITERAL[280];
    CC_argprint(a, q);
    a = w1;
    {
        popv(19);
        return  CC_tail(a);
    }
}

Sex CC_gbEABchkdelZRlftcol(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = mkfxat(0);
    w4 = a;
    w2 = q;
   G3665:
    a = w1;
    w3 = a;
   G3666:
    a = car(car(w3));
    a = Lzerop(a);
    if(a == nil) goto    G3676;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G3666;
    a = w1;
    a = CC_listcdr(a);
    w1 = a;
    a = w4;
    a = Ladd1(a);
    w4 = a;
    q = w2;
    a = Llessp(a, q);
    if(a != nil) goto    G3665;
   G3676:
    a = w4;
    a = Lzerop(a);
    if(a == nil) goto    G3678;
    a = nil;
    goto    G3664;
   G3678:
    q = w1;
    a = w4;
    a = cons(a, q);
   G3664:
    popv(4);
    return a;
}

Sex CC_gbEABpriElms(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    a = LL_Wset;
    w3 = a;
    a = cdr(w1);
    w4 = a;
    w2 = q;
    Lterpri();
   G3683:
    a = w3;
    if(a != LL_Wset) goto    G3687;
    a = LITERAL[281];
    goto    G3699;
   G3687:
    a = LITERAL[282];
   G3699:
    Lprinc(a);
    a = w4;
    if(a == nil) goto    G3690;
    a = LITERAL[150];
    goto    G3700;
   G3690:
    a = LITERAL[283];
    Lprinc(a);
    Lterpri();
    goto    G3685;
   G3691:
    a = car(w4);
    if(is_cons(a)) goto    G3693;
    a = LITERAL[284];
    Lprinc(a);
    goto    G3694;
   G3693:
    a = car(car(cdr(a)));
    Lprin(a);
   G3694:
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G3696;
    a = LITERAL[148];
   G3700:
    Lprinc(a);
    goto    G3691;
   G3696:
    a = LITERAL[151];
    Lprinc(a);
    Lterpri();
   G3685:
    a = w3;
#define LL_Sset LITERAL[285]
    if(a == LL_Sset) goto    G3701;
    a = LL_Sset;
    w3 = a;
    a = cdr(w2);
    w4 = a;
    goto    G3683;
   G3701:
    a = nil;
    popv(5);
    return a;
}

Sex CC_gbEABpriHxInf4s(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(a);
    if(a == nil) goto    G3706;
    w3 = nil;
    w4 = nil;
    a = w1;
    w3 = a;
    w2 = q;
    Lterpri();
    a = LITERAL[286];
    Lprinc(a);
    a = car(w1);
    if(a != LL_ABset) goto    G3710;
    a = LITERAL[287];
    goto    G3718;
   G3710:
    if(a != LL_STset) goto    G3711;
    a = LITERAL[288];
    goto    G3718;
   G3711:
    a = LITERAL[289];
   G3718:
    Lprinc(a);
    a = w2;
    Lprinc(a);
    a = LITERAL[290];
    Lprinc(a);
    Lterpri();
   G3708:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G3716;
    a = car(a);
    if(!is_cons(a)) goto    G3708;
    a = LITERAL[291];
    Lprinc(a);
    a = car(cdr(car(w3)));
    w4 = a;
    a = car(a);
    Lprin(a);
    a = LITERAL[292];
    Lprinc(a);
    a = car(car(w3));
    Lprint(a);
    goto    G3708;
   G3716:
    a = nil;
   G3706:
    popv(4);
    return a;
}

Sex CC_gbEABpriHxinf4(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = arg4;
    w2 = q;
    w3 = m;
    w4 = arg4;
    if(a != nil) goto    G3722;
    a = w1;
    if(a == nil) goto    G3725;
    a = CC_Wlist(a);
    if(a == nil) goto    G3724;
   G3725:
    Lterpri();
    a = LITERAL[293];
    goto    G3728;
   G3724:
    Lterpri();
    a = LITERAL[294];
    Lprinc(a);
    a = w1;
    Lprin(a);
    a = LITERAL[55];
   G3728:
    Lprinc(a);
    a = w2;
    goto    G3729;
   G3722:
    Lterpri();
    a = LITERAL[294];
    Lprinc(a);
    a = w1;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    a = w2;
    Lprint(a);
    a = LITERAL[294];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    a = w4;
   G3729:
    {
        popv(4);
        return  Lprint(a);
    }
}

Sex CC_gbEABpriavpApB(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = nil;
    w2 = q;
    q = cdr(a);
    a = car(a);
    a = CC_gbEdistLdist(a, q);
    q = a;
    a = LITERAL[176];
    a = CC_gbEnumHdist(a, q);
    w1 = a;
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    a = w2;
    if(a == nil) goto    G3732;
    a = LITERAL[295];
    Lprinc(a);
    a = cdr(car(w2));
    Lprin(a);
    q = LITERAL[176];
    a = car(car(w2));
    a = plus2(a, q);
    a = Ltruncate(a);
    value(LL_Htemporal) = a;
    a = LITERAL[296];
    Lprinc(a);
    a = value(LL_Htemporal);
    Lprin(a);
    a = LITERAL[297];
    Lprinc(a);
    a = cdr(cdr(w2));
    Lprin(a);
    a = LITERAL[298];
    Lprinc(a);
    Lterpri();
    a = nil;
   G3732:
    popv(2);
    return a;
}

Sex CC_gbEpriRedPbyQ(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    Lterpri();
    a = w1;
    a = CC_Wlist(a);
    if(a == nil) goto    G3741;
    a = LITERAL[299];
    Lprinc(a);
    goto    G3745;
   G3741:
    a = LITERAL[300];
    Lprinc(a);
    a = w1;
    Lprin(a);
   G3745:
    a = LITERAL[121];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = w3;
    if(a == nil) goto    G3744;
    a = LITERAL[301];
    Lprinc(a);
    a = w3;
    Lprinc(a);
    Lterpri();
   G3744:
    a = nil;
    popv(3);
    return a;
}

Sex CC_gbEABpriRedPol(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    Lterpri();
    a = LITERAL[302];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = w1;
    if(a != nil) goto    G3750;
    a = LITERAL[109];
    goto    G3752;
   G3750:
    a = LITERAL[303];
   G3752:
    Lprinc(a);
    q = w4;
    a = w3;
    CC_gbEABpriavpApB(a, q);
    a = nil;
    popv(5);
    return a;
}

Sex CC_gbEpriPmsgmsg(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    w2 = q;
    w3 = m;
    if(is_cons(a)) goto    G3756;
    Lterpri();
    a = LITERAL[304];
    Lprinc(a);
    a = w1;
    Lprin(a);
    goto    G3758;
   G3756:
    Lterpri();
    a = LITERAL[305];
    Lprinc(a);
    q = cdr(w1);
    a = car(w1);
    CC_gbEpriSPOLij(a, q);
   G3758:
    a = w2;
    Lprinc(a);
    a = w3;
    Lprinc(a);
    {
        popv(3);
        return  Lterpri();
    }
}

Sex CC_gbEpriSPOLij(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 2;
    w1 = a;
    w2 = q;
    a = LITERAL[306];
    Lprinc(a);
    a = w1;
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = LITERAL[151];
    {
        popv(2);
        return  Lprinc(a);
    }
}

Sex CC_gbEABredpolByGB(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w1 = a;
    a = value(LL_gbEsyzygy);
    w3 = a;
    value(LL_gbEsyzygy) = nil;
    a = cdr(w1);
    w4 = a;
    w2 = q;
   G3764:
    a = car(w4);
    w5 = a;
    if(!is_cons(a)) goto    G3765;
    a = cdr(cdr(a));
    w6 = a;
    q = value(LL_gbEorder);
    a = car(a);
    a = CC_gbEchgVarorder(a, q);
    w7 = a;
    q = value(LL_gbEorder);
    a = cdr(w6);
    a = CC_gbEchgVarorder(a, q);
    w8 = a;
    a = w7;
    a = CC_gbEhex(a);
    q = a;
    a = car(w5);
    car(a) = q;
    q = w8;
    a = w7;
    a = cons(a, q);
    q = a;
    a = cdr(w5);
    cdr(a) = q;
   G3765:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G3764;
    a = cdr(w1);
    w4 = a;
   G3766:
    a = car(w4);
    w5 = a;
    if(!is_cons(a)) goto    G3769;
    a = car(car(cdr(a)));
    w9 = a;
    a = cdr(cdr(w5));
    w6 = a;
    Lterpri();
    arg5 = nil;
    arg4 = w9;
    m = car(w5);
    q = w2;
    a = w6;
    a = CC_gbEABredpol(a, q, m, arg4, arg5);
    w5 = a;
    if(a != LL_PrecShort) goto    G3779;
    a = w3;
    value(LL_gbEsyzygy) = a;
    a = LL_PrecShort;
    goto    G3763;
   G3779:
    if(a == LL_same) goto    G3787;
    a = CC_Wlist(a);
    if(a == nil) goto    G3781;
    a = cdr(w5);
    w6 = a;
    goto    G3787;
   G3781:
    a = w5;
    a = Lzerop(a);
    if(a == nil) goto    G3782;
    a = mkfxat(0);
    w6 = a;
    a = LITERAL[251];
    goto    G3791;
   G3782:
    a = w5;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G3783;
    a = mkfxat(0);
    w6 = a;
    a = LITERAL[307];
    goto    G3791;
   G3783:
    a = mkfxat(1);
    w6 = a;
    a = LITERAL[50];
   G3791:
    w10 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3787;
    Lterpri();
    a = LITERAL[107];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = w10;
    Lprinc(a);
    Lterpri();
   G3787:
    q = w6;
    a = cdr(car(w4));
    cdr(a) = q;
   G3769:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G3766;
    a = w3;
    value(LL_gbEsyzygy) = a;
    a = w1;
   G3763:
    popv(10);
    return a;
}

Sex CC_gbEMmatxReduce(Sex a, Sex q)
{
    {
        return  CC_gbEmatxGauss2(a, q);
    }
}

Sex CC_AmatGroeb(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w14 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w1 = a;
    w2 = q;
    q = mkfxat(16);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = mkfxat(2);
    a = times2(a, q);
    value(LL_gbEaccinit) = a;
    a = value(LL_Hmachineps);
    value(LL_gbEFprec) = a;
    a = w1;
    a = CC_gbEcoeftype(a);
    if(a == LL_AF) goto    G3813;
    if(a == LL_AC) goto    G3813;
    if(a == LL_AQ) goto    G3813;
    if(a == LL_AZ) goto    G3813;
    q = nil;
    a = LITERAL[203];
    CC_errormsg(a, q);
   G3813:
    a = w2;
    a = CC_Wlist(a);
    if(a == nil) goto    G3815;
    q = nil;
    a = LITERAL[207];
    goto    G3888;
   G3815:
    q = LITERAL[206];
    a = w2;
    a = Lmemq(a, q);
    if(a == nil) goto    G3816;
    a = mkfxat(0);
    goto    G3889;
   G3816:
    a = w2;
    a = CC_Wbnum(a);
    if(a == nil) goto    G3817;
    q = LITERAL[308];
    a = w2;
    a = Lleq(a, q);
    if(a == nil) goto    G3817;
    a = w2;
   G3889:
    value(LL_gbEtol) = a;
    goto    G3819;
   G3817:
    q = w2;
    a = LITERAL[309];
   G3888:
    CC_errormsg(a, q);
   G3819:
    a = value(LL_gbEaccinit);
    a = CC_Wbnum(a);
    if(a != nil) goto    G3821;
    q = nil;
    a = LITERAL[204];
    goto    G3890;
   G3821:
    q = mkfxat(5);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = value(LL_gbEaccinit);
    a = Lgreaterp(a, q);
    if(a != nil) goto    G3825;
    q = mkfxat(0);
    a = value(LL_gbEtol);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3822;
    q = value(LL_gbEtol);
    a = value(LL_gbEaccinit);
    a = Lgeq(a, q);
    if(a == nil) goto    G3822;
   G3825:
    q = nil;
    a = LITERAL[310];
   G3890:
    CC_errormsg(a, q);
   G3822:
    a = LL_float;
    value(LL_gbEcoftype) = a;
    a = LL_head;
    value(LL_gbEredtype) = a;
    a = LITERAL[160];
    value(LL_gbEcanclvl) = a;
    value(LL_gbEsyzygy) = nil;
#define LL_ClonInfo LITERAL[311]
    a = LL_ClonInfo;
    a = Lncons(a);
#define LL_gbEclones LITERAL[312]
    value(LL_gbEclones) = a;
    a = LL_plus2;
    value(LL_gbEadd) = a;
    a = LL_times2;
    value(LL_gbEmult) = a;
    a = LL_minus;
    value(LL_gbEneg) = a;
    a = LL_quotient;
    value(LL_gbEquoti) = a;
    value(LL_gbEgcd) = nil;
    q = mkfxat(5);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = value(LL_gbEaccinit);
    a = Lgeq(a, q);
    if(a != nil) goto    G3828;
    q = mkfxat(3);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = value(LL_gbEtol);
    a = Lgeq(a, q);
    if(a == nil) goto    G3827;
   G3828:
    q = mkfxat(100);
    a = mkfxat(30);
    goto    G3892;
   G3827:
    q = mkfxat(10);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = value(LL_gbEaccinit);
    a = Lgeq(a, q);
    if(a != nil) goto    G3832;
    q = mkfxat(6);
    a = LITERAL[173];
    a = Lexpt(a, q);
    q = a;
    a = value(LL_gbEtol);
    a = Lgeq(a, q);
    if(a == nil) goto    G3831;
   G3832:
    q = mkfxat(500);
    a = mkfxat(100);
    goto    G3892;
   G3831:
    q = mkfxat(2500);
    a = mkfxat(200);
   G3892:
    a = cons(a, q);
    value(LL_gbEcontrol) = a;
    q = mkfxat(0);
    a = value(LL_gbEtol);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3837;
#define LL_apZeros LITERAL[313]
    a = LL_apZeros;
    a = Lncons(a);
    value(LL_gbEapZeros) = a;
   G3837:
    q = value(LL_gbEaccinit);
    a = LITERAL[314];
    CC_argprint(a, q);
    q = mkfxat(0);
    a = value(LL_gbEtol);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G3839;
    q = value(LL_gbEtol);
    a = LITERAL[315];
    CC_argprint(a, q);
   G3839:
    q = value(LL_gbEcontrol);
    a = LITERAL[316];
    CC_argprint(a, q);
    m = CHAR_OF(83);
    q = value(LL_RpercentS);
    a = value(LL_RblankS);
    a = Llist3(a, q, m);
    a = Lmake_id(a);
    value(LL_gbEsyzvar) = a;
    q = LL_Bgid;
    a = Lget(a, q);
    if(a != nil) goto    G3842;
    q = value(LL_gbEsyzvar);
    a = LL_indxvar;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = value(LL_gbEsyzvar);
    a = Lncons(a);
    CC_Aorder(a);
   G3842:
    a = w1;
    w3 = a;
   G3800:
    q = value(LL_gbEFprec);
    a = LL_prec;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = w3;
    a = CC_Acoef2befloat(a);
    w1 = a;
    value(LL_gbEhistry) = nil;
    value(LL_gbEsyzygy) = nil;
#define LL_mat LITERAL[317]
    m = LL_mat;
    q = nil;
    a = w1;
    a = CC_gbEinitialz(a, q, m);
    w14 = a;
    a = cdr(a);
    w6 = a;
    a = Llast(a);
    w8 = a;
    q = w6;
    a = car(w14);
    a = CC_gbEwset2Mwset(a, q);
    w4 = a;
#define LL_PCs1 LITERAL[318]
    a = LL_PCs1;
    a = Lncons(a);
    w7 = a;
#define LL_MWset2 LITERAL[319]
    a = LL_MWset2;
    a = Lncons(a);
    w5 = a;
    a = mkfxat(100);
    a = Lmkvect(a);
    value(LL_gbEsyzygy) = a;
    a = w4;
    CC_gbEMintlzSyzsIPs(a);
    arg5 = w7;
    arg4 = w5;
    m = w6;
    q = cdr(w4);
    a = w4;
    a = CC_gbEMreduce(a, q, m, arg4, arg5);
    w14 = a;
    if(a == LL_PrecShort) goto    G3805;
    if(a == LL_stop) goto    G3882;
    a = Lonep(a);
    if(a != nil) goto    G3806;
   G3851:
    arg5 = w7;
    arg4 = w5;
    m = w8;
    q = w6;
    a = w4;
    a = CC_gbEMspol(a, q, m, arg4, arg5);
    w14 = a;
    if(is_cons(a)) goto    G3853;
    if(a == LL_PrecShort) goto    G3805;
    if(a != LL_end) goto    G3856;
    a = cdr(w5);
    if(a == nil) goto    G3807;
    goto    G3804;
   G3856:
    a = Lonep(a);
    if(a != nil) goto    G3806;
   G3853:
    a = w8;
    a = Ladd1(a);
    w8 = a;
    a = w14;
    if(!is_cons(a)) goto    G3851;
    a = car(a);
    a = CC_gbEstop(a);
    if(a != nil) goto    G3807;
    a = w14;
    goto    G3893;
   G3865:
    arg5 = w7;
    arg4 = w5;
    m = w6;
    q = w10;
    a = w4;
    a = CC_gbEMreduce(a, q, m, arg4, arg5);
    w14 = a;
    if(a == LL_PrecShort) goto    G3805;
#define LL_imprAll LITERAL[320]
    if(a == LL_imprAll) goto    G3804;
    if(a == LL_stop) goto    G3882;
    a = Lonep(a);
    if(a != nil) goto    G3806;
    a = w4;
    a = CC_gbEMmonitrSyz(a);
    if(a == nil) goto    G3851;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a != nil) goto    G3804;
    Lterpri();
    a = LITERAL[321];
    Lprinc(a);
    a = LITERAL[322];
    Lprinc(a);
   G3804:
    a = w4;
    CC_gbEMimprovePols(a);
    arg4 = w6;
    m = w4;
    q = w7;
    a = w5;
    CC_gbEMmoveCancPol(a, q, m, arg4);
    a = w4;
    CC_gbEMintlzSyzsIPs(a);
    a = cdr(w4);
   G3893:
    w10 = a;
    goto    G3865;
   G3805:
    Lterpri();
    Lterpri();
    a = LITERAL[323];
    Lprinc(a);
    a = LITERAL[324];
    Lprinc(a);
    Lterpri();
    Lterpri();
    q = value(LL_gbEFprec);
    a = mkfxat(2);
    a = times2(a, q);
    value(LL_gbEFprec) = a;
    goto    G3800;
   G3806:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3876;
    Lterpri();
    a = LITERAL[325];
    Lprinc(a);
    Lterpri();
   G3876:
    q = LL_Anil;
    a = LL_prec;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    q = mkfxat(1);
    a = LL_Bset;
    {
        popv(15);
        return  Llist2(a, q);
    }
   G3807:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3881;
    Lterpri();
    Lterpri();
    a = LITERAL[326];
    Lprinc(a);
    a = LITERAL[327];
    Lprinc(a);
    Lterpri();
   G3881:
    a = w4;
    CC_gbEMimprovePols(a);
    Lterpri();
    Lterpri();
    a = LITERAL[53];
    Lprinc(a);
    Lterpri();
    a = w4;
    w10 = a;
    w15 = nil;
   G3883:
    a = cdr(w10);
    w10 = a;
    if(a == nil) goto    G3882;
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = car(car(cdr(car(w10))));
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    a = cdr(cdr(car(w10)));
    w14 = a;
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    CC_gbEprint(a, q, m, arg4, arg5);
    a = Lterpri();
    w15 = a;
    goto    G3883;
   G3882:
    a = w4;
    a = CC_gbEwset2polyset(a);
    w9 = a;
    q = LL_Anil;
    a = LL_prec;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = w9;
    popv(15);
    return a;
}

Sex CC_gbEMreduce(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex arg6, arg7, arg8;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a == nil) goto    G3935;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    a = q;
    w7 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
   G3900:
    a = cdr(w7);
    if(a != nil) goto    G3906;
   G3935:
    a = w1;
    goto    G3898;
   G3906:
    a = car(a);
    w6 = a;
    a = car(car(cdr(a)));
    w9 = a;
    a = car(w6);
    w10 = a;
    arg4 = w9;
    m = cdr(a);
    q = w1;
    a = cdr(cdr(w6));
    a = CC_gbEMredpol(a, q, m, arg4);
    w11 = a;
    w12 = nil;
    if(a == LL_PrecShort) goto    G3898;
    if(a != LL_same) goto    G3910;
    a = cdr(w7);
    w7 = a;
    goto    G3900;
   G3910:
    if(!is_cons(a)) goto    G3914;
#define LL_bigC LITERAL[328]
    q = LL_bigC;
    a = car(a);
    a = Lneq(a, q);
    if(a == nil) goto    G3913;
    a = cdr(w11);
    goto    G3936;
   G3914:
    q = cdr(cdr(w7));
    a = w7;
    cdr(a) = q;
    a = w9;
    CC_gbEsyzyclear(a);
    q = w3;
    a = w9;
    CC_seTdelete(a, q);
    q = w1;
    a = w9;
    CC_gbEdelunpC(a, q);
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G3900;
    a = w11;
    a = Lzerop(a);
    if(a != nil) goto    G3937;
    a = w11;
    a = Lonep(a);
    if(a == nil) goto    G3900;
   G3902:
    Lterpri();
    a = LITERAL[54];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = LITERAL[50];
    Lprinc(a);
    Lterpri();
    a = mkfxat(1);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    a = mkfxat(1);
    goto    G3898;
   G3913:
    a = true;
    w12 = a;
    a = cdr(w11);
    w11 = a;
    a = cdr(a);
   G3936:
    w8 = a;
    a = car(w11);
    w10 = a;
    q = cdr(cdr(w7));
    a = w7;
    cdr(a) = q;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3922;
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = LITERAL[329];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w8;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    a = w8;
    a = CC_gbEaccMinMax(a);
    w11 = a;
    a = LITERAL[330];
    Lprinc(a);
    a = car(w11);
    Lprin(a);
    a = LITERAL[331];
    Lprinc(a);
    a = cdr(w11);
    Lprin(a);
    a = LITERAL[298];
    Lprinc(a);
    Lterpri();
   G3922:
    a = w12;
    if(a == nil) goto    G3924;
    q = car(cdr(w10));
    a = cdr(cdr(w10));
    a = quot2(a, q);
    w11 = a;
    arg8 = w5;
    arg7 = w4;
    arg6 = w3;
    arg5 = w1;
    arg4 = a;
    m = w9;
#define LL_Mred LITERAL[332]
    q = LL_Mred;
    a = w8;
    a = CC_gbEMimprCancPol(a, q, m, arg4, arg5, arg6, arg7, arg8);
    w11 = a;
#define LL_intoMwset2 LITERAL[333]
    if(a == LL_intoMwset2) goto    G3900;
    a = Lzerop(a);
    if(a == nil) goto    G3931;
   G3937:
    Lterpri();
    a = LITERAL[107];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = LITERAL[334];
    goto    G3938;
   G3931:
    a = w11;
    a = Lonep(a);
    if(a != nil) goto    G3902;
    a = w11;
    a = Lminus(a);
    a = Lonep(a);
    if(a == nil) goto    G3900;
    Lterpri();
    a = LITERAL[304];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = LITERAL[335];
   G3938:
    Lprinc(a);
    Lterpri();
    goto    G3900;
   G3924:
    arg4 = w3;
    m = w9;
    q = cdr(w10);
    a = w8;
    a = CC_gbEMmkwprep(a, q, m, arg4);
    w6 = a;
    q = w1;
    a = w9;
    CC_gbEinsunpC(a, q);
    q = w1;
    a = w6;
    a = CC_gbEMinswset(a, q);
    w7 = a;
    m = value(LL_gbEorder);
    q = car(car(car(w2)));
    a = car(car(car(a)));
    a = CC_gbEirred(a, q, m);
    if(a == nil) goto    G3926;
    a = w7;
    w2 = a;
   G3926:
    a = w6;
    a = CC_gbEstop(a);
    if(a == nil) goto    G3900;
    a = LL_stop;
   G3898:
    popv(12);
    return a;
}

Sex CC_gbEMspol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex arg6, arg7, arg8;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 21;
    w21 = nil;
    w6 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w19 = nil;
    w20 = nil;
    w1 = a;
    a = cdr(a);
    w7 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    if(a == nil) goto    G4014;
   G3953:
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G3955;
   G4014:
    a = LL_end;
    goto    G3941;
   G3955:
    a = car(a);
    w16 = a;
    a = cdr(w1);
    w6 = a;
    a = car(cdr(w16));
    w11 = a;
    a = car(w16);
    w13 = a;
    a = cdr(cdr(w16));
    w9 = a;
   G3943:
    a = car(w6);
    w16 = a;
    a = car(cdr(a));
    w10 = a;
    a = car(w16);
    w12 = a;
    a = cdr(cdr(w16));
    w8 = a;
    q = w11;
    a = car(w10);
    a = Lmemq(a, q);
    if(a == nil) goto    G3945;
    q = w11;
    a = car(w10);
    CC_seTdelete(a, q);
    q = w10;
    a = car(w11);
    CC_seTdelete(a, q);
    arg4 = nil;
    m = value(LL_gbEorder);
    q = car(w13);
    a = car(w12);
    a = CC_gbEgcdchk(a, q, m, arg4);
    w16 = a;
    q = LL_yes;
    a = Lneq(a, q);
    if(a != nil) goto    G3947;
    a = LITERAL[91];
    goto    G4017;
   G3960:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G3962;
    Lterpri();
    a = LITERAL[336];
    Lprinc(a);
    a = car(w10);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w11);
    Lprin(a);
    a = LITERAL[94];
    Lprinc(a);
    a = w19;
    Lprinc(a);
    Lterpri();
   G3962:
    a = w3;
    a = Ladd1(a);
    CC_gbEsyzyclear(a);
   G3945:
    a = cdr(w6);
    w6 = a;
    q = w7;
    a = Lneq(a, q);
    if(a == nil) goto    G3953;
    goto    G3943;
   G3947:
    q = car(cdr(w12));
    a = cdr(cdr(w12));
    a = quot2(a, q);
    w21 = a;
    q = car(cdr(w13));
    a = cdr(cdr(w13));
    a = quot2(a, q);
    q = a;
    a = w21;
    a = Lmax2(a, q);
    w17 = a;
    arg6 = car(w11);
    arg5 = car(w10);
    arg4 = w3;
    m = w16;
    q = w9;
    a = w8;
    a = CC_gbEMmkspol(a, q, m, arg4, arg5, arg6);
    w14 = a;
    if(a == LL_PrecShort) goto    G3941;
    a = Lzerop(a);
    if(a == nil) goto    G3970;
    a = LITERAL[158];
    goto    G4017;
   G3970:
    a = w14;
    if(!is_number(a)) goto    G3971;
    a = mkfxat(1);
    w16 = a;
    goto    G3986;
   G3971:
    q = car(cdr(w13));
    a = car(cdr(w12));
    a = Lmax2(a, q);
    w21 = a;
    a = w14;
    a = CC_gbEfnorm(a);
    q = a;
    a = w21;
    a = quot2(a, q);
    w18 = a;
    q = car(value(LL_gbEcontrol));
    a = Llessp(a, q);
    if(a != nil) goto    G3977;
    a = value(LL_Htracmode);
#define LL_untrace LITERAL[337]
    if(a != LL_untrace) goto    G3976;
    a = true;
    w20 = a;
    goto    G3977;
   G3976:
    a = true;
    w20 = a;
    Lterpri();
    a = LITERAL[305];
    Lprinc(a);
    a = LITERAL[338];
    Lprinc(a);
    a = w18;
    Lprin(a);
   G3977:
    a = w3;
    a = Ladd1(a);
    m = nil;
    q = a;
    a = w14;
    a = CC_gbEMnormalz(a, q, m);
    w14 = a;
    a = CC_gbEhex(a);
    w21 = a;
    a = w14;
    a = CC_gbEmaxcoferr(a);
    q = w21;
    a = Lxcons(a, q);
    w15 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G3982;
    Lterpri();
    a = LITERAL[98];
    Lprinc(a);
    a = car(w10);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w11);
    Lprin(a);
    a = LITERAL[99];
    Lprinc(a);
    Lterpri();
    a = LITERAL[100];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w14;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G3982:
    a = w3;
    a = Ladd1(a);
    a = Lncons(a);
    arg4 = a;
    m = cdr(w15);
    q = w1;
    a = w14;
    a = CC_gbEMredpol(a, q, m, arg4);
    w16 = a;
    if(a == LL_PrecShort) goto    G3941;
   G3986:
    a = LL_same;
    if(a == w16) goto    G4000;
    q = w16;
    a = mkfxat(-1);
    a = Lequal(a, q);
    if(a == nil) goto    G3989;
    a = LITERAL[162];
    goto    G4017;
   G3989:
    a = w16;
    a = Lzerop(a);
    if(a == nil) goto    G3990;
    a = LITERAL[102];
   G4017:
    w19 = a;
    goto    G3960;
   G3990:
    a = w16;
    a = Lonep(a);
    if(a == nil) goto    G3991;
    Lterpri();
    a = LITERAL[98];
    Lprinc(a);
    a = car(w10);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w11);
    Lprin(a);
    a = LITERAL[339];
    Lprinc(a);
    Lterpri();
    a = mkfxat(1);
    goto    G3941;
   G3991:
    a = car(w16);
    if(a != LL_bigC) goto    G3992;
    a = true;
    w20 = a;
    a = cdr(w16);
    w16 = a;
   G3992:
    a = cdr(w16);
    w14 = a;
    a = car(w16);
    w15 = a;
    q = w17;
    a = car(cdr(a));
    a = times2(a, q);
    q = a;
    a = cdr(cdr(w15));
    a = quot2(a, q);
    w18 = a;
    q = cdr(value(LL_gbEcontrol));
    a = mkfxat(10);
    a = times2(a, q);
    q = a;
    a = w18;
    a = Lgeq(a, q);
    if(a == nil) goto    G4000;
    a = true;
    w20 = a;
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G4000;
    Lterpri();
    a = LITERAL[305];
    Lprinc(a);
    a = LITERAL[340];
    w16 = a;
    Lprinc(a);
    a = w18;
    Lprin(a);
   G4000:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4002;
    Lterpri();
    Lterpri();
    a = LITERAL[104];
    Lprinc(a);
    a = car(w10);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w11);
    Lprin(a);
    a = LITERAL[105];
    Lprinc(a);
    Lterpri();
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = w3;
    a = Ladd1(a);
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w14;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    a = w14;
    a = CC_gbEaccMinMax(a);
    w16 = a;
    a = LITERAL[330];
    Lprinc(a);
    a = car(w16);
    Lprin(a);
    a = LITERAL[331];
    Lprinc(a);
    a = cdr(w16);
    Lprin(a);
    a = LITERAL[298];
    Lprinc(a);
    Lterpri();
   G4002:
    a = w3;
    a = Ladd1(a);
    w3 = a;
    a = w20;
    if(a != nil) goto    G3951;
    a = w2;
    a = CC_tail(a);
    w21 = a;
    a = w3;
    a = Lncons(a);
    q = a;
    a = w21;
    cdr(a) = q;
    a = cdr(a);
    q = w1;
    a = w3;
    CC_gbEinsunpC(a, q);
    arg4 = w2;
    m = w3;
    q = cdr(w15);
    a = w14;
    a = CC_gbEMmkwprep(a, q, m, arg4);
    w16 = a;
    q = w1;
    {
        popv(21);
        return  CC_gbEMinswset(a, q);
    }
   G3951:
    q = car(cdr(w15));
    a = cdr(cdr(w15));
    a = quot2(a, q);
    w17 = a;
    arg8 = w5;
    arg7 = w4;
    arg6 = w2;
    arg5 = w1;
    arg4 = a;
    m = w3;
#define LL_Spol LITERAL[341]
    q = LL_Spol;
    a = w14;
    a = CC_gbEMimprCancPol(a, q, m, arg4, arg5, arg6, arg7, arg8);
    w16 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G4011;
    a = w16;
    goto    G3941;
   G4011:
    q = mkfxat(-1);
    a = w3;
    a = plus2(a, q);
    w3 = a;
    a = w16;
    if(is_number(a)) goto    G3986;
    a = LL_intoMwset2;
   G3941:
    popv(21);
    return a;
}

Sex CC_gbEMmkspol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    a = CC_gbErest(a);
    w8 = a;
    a = w2;
    a = CC_gbErest(a);
    w9 = a;
    a = w8;
    a = Lzerop(a);
    if(a == nil) goto    G4025;
    a = w9;
    a = Lzerop(a);
    if(a != nil) goto    G4040;
    m = w9;
    q = mkfxat(-1);
    a = cdr(w3);
    goto    G4041;
   G4025:
    a = w9;
    a = Lzerop(a);
    m = w8;
    q = mkfxat(1);
    if(a != nil) goto    G4042;
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w8 = a;
    m = w9;
    q = mkfxat(-1);
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w9 = a;
    q = a;
    a = w8;
    a = CC_gbEdistLdist(a, q);
    w7 = a;
    a = Lzerop(a);
    if(a == nil) goto    G4023;
    a = w4;
    a = Ladd1(a);
    CC_gbEsyzyclear(a);
   G4040:
    a = mkfxat(0);
    goto    G4020;
   G4042:
    a = car(w3);
   G4041:
    a = CC_gbEtermHdist(a, q, m);
    w7 = a;
   G4023:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G4034;
    a = w4;
    a = Ladd1(a);
    w13 = a;
    q = mkfxat(1);
    a = car(w3);
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    w14 = a;
    q = mkfxat(-1);
    a = cdr(w3);
    a = cons(a, q);
    q = w6;
    a = Lxcons(a, q);
    arg4 = a;
    m = w14;
    q = w13;
    a = LL_spol;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G4034:
    a = w7;
   G4020:
    popv(14);
    return a;
}

Sex CC_gbEMredpol(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 17;
    w17 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w16 = nil;
    w1 = a;
    a = cdr(q);
    w5 = a;
    a = w1;
    w6 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = car(m);
    a = cdr(m);
    a = quot2(a, q);
    w14 = a;
    w13 = a;
    a = mkfxat(1);
    w15 = a;
   G4046:
    a = cdr(cdr(car(w5)));
    w7 = a;
    if(a == w6) goto    G4051;
    a = car(car(cdr(car(w5))));
    w8 = a;
    a = w1;
    a = CC_gbEhex(a);
    w17 = a;
    a = w7;
    a = CC_gbEhex(a);
    m = value(LL_gbEorder);
    q = a;
    a = w17;
    a = CC_gbEredchk(a, q, m);
    w9 = a;
    if(a == LL_no) goto    G4051;
    a = true;
    w11 = a;
    a = cdr(car(car(w5)));
    q = car(a);
    a = cdr(a);
    a = quot2(a, q);
    q = a;
    a = w14;
    a = Lmax2(a, q);
    w14 = a;
    a = w4;
    if(!is_cons(a)) goto    G4063;
    a = car(a);
   G4063:
    w12 = a;
    arg5 = w8;
    arg4 = w4;
    m = w9;
    q = w7;
    a = w1;
    a = CC_gbEMhred(a, q, m, arg4, arg5);
    w1 = a;
    if(a == LL_PrecShort) goto    G4045;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4067;
    m = nil;
    q = car(car(cdr(car(w5))));
    a = w4;
    CC_gbEpriRedPbyQ(a, q, m);
   G4067:
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G4069;
    a = mkfxat(0);
    goto    G4045;
   G4069:
    a = car(car(cdr(w1)));
    a = CC_Wzerolist(a);
    if(a == nil) goto    G4070;
    a = mkfxat(1);
    goto    G4045;
   G4070:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G4072;
    Lterpri();
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w1;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    a = w1;
    a = CC_gbEaccMinMax(a);
    w12 = a;
    a = LITERAL[330];
    Lprinc(a);
    a = car(w12);
    Lprin(a);
    a = LITERAL[331];
    Lprinc(a);
    a = cdr(w12);
    Lprin(a);
    a = LITERAL[298];
    Lprinc(a);
    Lterpri();
   G4072:
    a = w4;
    if(!is_cons(a)) goto    G4075;
    a = car(a);
   G4075:
    a = w1;
    a = CC_gbEhex(a);
    w17 = a;
    a = w1;
    a = CC_gbEmaxcoferr(a);
    w12 = a;
    q = w17;
    a = Lxcons(a, q);
    w10 = a;
    q = car(w12);
    a = w14;
    a = times2(a, q);
    q = a;
    a = cdr(w12);
    a = quot2(a, q);
    w12 = a;
    q = a;
    a = w15;
    a = times2(a, q);
    w15 = a;
    q = car(value(LL_gbEcontrol));
    a = w12;
    a = Lgeq(a, q);
    if(a == nil) goto    G4083;
    a = true;
    w16 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4083;
    Lterpri();
    a = LITERAL[305];
    Lprinc(a);
    a = LITERAL[338];
    Lprinc(a);
    a = w12;
    Lprin(a);
   G4083:
    a = w4;
    if(!is_cons(a)) goto    G4086;
    a = car(a);
   G4086:
    w12 = a;
    m = w10;
    q = a;
    a = w1;
    a = CC_gbEMnormalz(a, q, m);
    w1 = a;
    q = car(cdr(w10));
    a = cdr(cdr(w10));
    a = quot2(a, q);
    w14 = a;
    a = cdr(w2);
    w5 = a;
    goto    G4046;
   G4051:
    a = w1;
    a = CC_gbEhex(a);
    q = w2;
    a = CC_gbEMsamehexp(a, q);
    if(a == nil) goto    G4088;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G4046;
   G4088:
    q = cdr(value(LL_gbEcontrol));
    a = mkfxat(10);
    a = times2(a, q);
    q = a;
    a = w15;
    a = Lgeq(a, q);
    if(a == nil) goto    G4093;
    a = true;
    w16 = a;
   G4093:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G4046;
    a = w11;
    if(a != nil) goto    G4098;
    a = LL_same;
    goto    G4045;
   G4098:
    q = w13;
    a = car(cdr(w10));
    a = times2(a, q);
    q = a;
    a = cdr(cdr(w10));
    a = quot2(a, q);
    w15 = a;
    q = cdr(value(LL_gbEcontrol));
    a = mkfxat(10);
    a = times2(a, q);
    q = a;
    a = w15;
    a = Llessp(a, q);
    if(a != nil) goto    G4106;
    a = true;
    w16 = a;
    a = w4;
    a = CC_Wlist(a);
    if(a != nil) goto    G4106;
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G4106;
    Lterpri();
    a = LITERAL[305];
    Lprinc(a);
    a = LITERAL[340];
    w12 = a;
    Lprinc(a);
    a = w15;
    Lprin(a);
   G4106:
    q = cdr(cdr(w10));
    a = cdr(value(LL_gbEcontrol));
    a = times2(a, q);
    w17 = a;
    q = car(cdr(w10));
    a = value(LL_gbEaccinit);
    a = times2(a, q);
    q = a;
    a = w17;
    a = Llessp(a, q);
    if(a != nil) goto    G4111;
    Lterpri();
    a = LITERAL[142];
    Lprinc(a);
    a = LITERAL[342];
    Lprinc(a);
    q = car(cdr(w10));
    a = cdr(cdr(w10));
    a = quot2(a, q);
    Lprint(a);
    a = LL_PrecShort;
    goto    G4045;
   G4111:
    a = value(LL_gbEhistry);
    if(a == nil) goto    G4122;
    a = w16;
    if(a != nil) goto    G4117;
   G4122:
    q = w1;
    a = w10;
    {
        popv(17);
        return  cons(a, q);
    }
   G4117:
    q = w1;
    a = w10;
    a = cons(a, q);
    q = LL_bigC;
    {
        popv(17);
        return  Lxcons(a, q);
    }
    a = nil;
   G4045:
    popv(17);
    return a;
}

Sex CC_gbEMhred(Sex a, Sex q, Sex m, Sex arg4, Sex arg5)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w9 = nil;
    w7 = nil;
    w6 = nil;
    w8 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    a = arg4;
    a = CC_Wlist(a);
    if(a == nil) goto    G4130;
    a = car(w4);
    w4 = a;
   G4130:
    a = w2;
    a = CC_gbErest(a);
    w9 = a;
    a = w2;
    a = CC_gbEhex(a);
    w7 = a;
   G4126:
    a = w1;
    a = CC_gbEhc(a);
    a = Lminus(a);
    w6 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G4133;
    q = w6;
    a = w3;
    a = cons(a, q);
    q = a;
    a = car(w1);
    a = Llist2(a, q);
    w12 = a;
    q = w5;
    a = Lxcons(a, q);
    arg4 = a;
    m = nil;
    q = w4;
    a = LL_mred;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G4133:
    a = w9;
    a = Lzerop(a);
    if(a == nil) goto    G4137;
    a = w1;
    a = CC_gbErest(a);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G4145;
    a = w4;
    CC_gbEsyzyclear(a);
    goto    G4154;
   G4137:
    a = w1;
    a = CC_gbErest(a);
    w8 = a;
    m = w9;
    q = w6;
    a = w3;
    a = CC_gbEtermHdist(a, q, m);
    w10 = a;
    a = w8;
    a = Lzerop(a);
    if(a != nil) goto    G4155;
    q = w10;
    a = w8;
    a = CC_gbEdistLdist(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G4145;
    q = LL_untrace;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4145;
    m = nil;
    q = w5;
    a = w4;
    CC_gbEpriRedPbyQ(a, q, m);
    goto    G4154;
   G4155:
    a = w10;
    w1 = a;
   G4145:
    q = value(LL_gbEaccinit);
    a = mkfxat(10);
    a = times2(a, q);
    q = a;
    a = w1;
    a = CC_gbEMdelErrTerm(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G4149;
   G4154:
    a = mkfxat(0);
    goto    G4125;
   G4149:
    a = w1;
    a = CC_gbEhex(a);
    m = value(LL_gbEorder);
    q = w7;
    a = CC_gbEredchk(a, q, m);
    w3 = a;
    q = LL_no;
    a = Lneq(a, q);
    if(a != nil) goto    G4126;
    a = w1;
   G4125:
    popv(12);
    return a;
}

Sex CC_gbEMdelErrTerm(Sex a, Sex q)
{
    {
        return  CC_gbEHdelErrTerm(a, q);
    }
}

Sex CC_gbEMmonitrSyz(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    a = cdr(a);
    w2 = a;
   G4161:
    q = car(car(cdr(car(w2))));
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w3 = a;
    a = CC_Cterms(a);
    q = mkfxat(150);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G4164;
#define LL_Syz LITERAL[343]
    a = LL_Syz;
    goto    G4160;
   G4164:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G4161;
   G4160:
    popv(3);
    return a;
}

Sex CC_gbEMnormalz(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_gbEhc(a);
    a = Lbefloat_value(a);
    q = a;
    a = mkfxat(1);
    a = quot2(a, q);
    w4 = a;
    q = w1;
    a = CC_gbEnumHdist(a, q);
    w1 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G4175;
    arg4 = nil;
    m = w4;
    q = w2;
    a = LL_nmlz;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G4175:
    a = w3;
    if(a == nil) goto    G4181;
    a = w4;
    a = Lfloat(a);
    a = Labs(a);
    w4 = a;
    a = cdr(w3);
    w5 = a;
    q = car(a);
    a = w4;
    a = times2(a, q);
    w6 = a;
    q = cdr(w5);
    a = w4;
    a = times2(a, q);
    q = w6;
    a = Lxcons(a, q);
    w5 = a;
    q = a;
    a = w3;
    cdr(a) = q;
   G4181:
    a = w1;
    popv(6);
    return a;
}

Sex CC_gbEMmkwprep(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w1 = a;
    a = cdr(arg4);
    w4 = a;
    w2 = q;
    w3 = m;
    a = Lcopy(a);
    q = w3;
    a = Lxcons(a, q);
    w5 = a;
    q = a;
    a = w3;
    CC_seTdelete(a, q);
    a = w2;
    if(a != nil) goto    G4187;
    a = w1;
    a = CC_gbEmaxcoferr(a);
    w2 = a;
   G4187:
    a = w1;
    a = CC_gbEhex(a);
    q = w2;
    a = cons(a, q);
    w6 = a;
    q = w1;
    a = w5;
    a = cons(a, q);
    q = w6;
    {
        popv(6);
        return  Lxcons(a, q);
    }
}

Sex CC_gbEMsamehexp(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w1 = a;
    a = q;
    w3 = a;
    w2 = q;
   G4195:
    a = cdr(w3);
    w3 = a;
    if(a == nil) goto    G4194;
    a = car(a);
    if(!is_cons(a)) goto    G4195;
    q = car(car(a));
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G4195;
    a = w3;
   G4194:
    popv(3);
    return a;
}

Sex CC_gbEMimprCancPol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6, Sex arg7, Sex arg8)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 16;
    w16 = nil;
    w1 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    w7 = arg7;
    w8 = arg8;
    q = m;
    a = CC_gbEMimprovePol1(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G4242;
    a = w1;
    if(!is_number(a)) goto    G4212;
    a = mkfxat(1);
    goto    G4203;
   G4212:
    a = CC_gbEhex(a);
    w16 = a;
    a = w1;
    a = CC_gbEmaxcoferr(a);
    w15 = a;
    q = w16;
    a = Lxcons(a, q);
    w11 = a;
    a = w1;
    a = CC_gbErest(a);
    a = Lzerop(a);
    if(a != nil) goto    G4206;
    q = car(w15);
    a = cdr(w15);
    a = quot2(a, q);
    w9 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4219;
    Lterpri();
    a = LITERAL[344];
    Lprinc(a);
    q = w9;
    a = w4;
    a = quot2(a, q);
    Lprint(a);
   G4219:
    q = mkfxat(0);
    a = value(LL_gbEtol);
    a = Lgreaterp(a, q);
    q = w9;
    if(a != nil) goto    G4260;
    a = w1;
    a = CC_gbEerrPolp(a, q);
    if(a == nil) goto    G4228;
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G4242;
    a = LITERAL[345];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[346];
    Lprinc(a);
    Lterpri();
   G4242:
    q = w6;
    a = w3;
    CC_seTdelete(a, q);
    q = w5;
    a = w3;
    CC_gbEdelunpC(a, q);
    a = mkfxat(0);
    goto    G4203;
   G4260:
    a = value(LL_gbEtol);
    a = times2(a, q);
    q = value(LL_Hmachineps);
    a = Lgeq(a, q);
    if(a == nil) goto    G4228;
    q = w6;
    a = w3;
    CC_seTdelete(a, q);
    q = w5;
    a = w3;
    CC_gbEdelunpC(a, q);
    a = value(LL_gbEapZeros);
    a = CC_tail(a);
    w16 = a;
    a = w3;
    a = Lncons(a);
    q = w1;
    a = cons(a, q);
    q = w9;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w16;
    cdr(a) = q;
    a = cdr(a);
    a = mkfxat(-1);
    goto    G4203;
   G4206:
    a = w6;
    a = CC_tail(a);
    w16 = a;
    a = w3;
    a = Lncons(a);
    q = a;
    a = w16;
    cdr(a) = q;
    a = cdr(a);
    q = w5;
    a = w3;
    CC_gbEinsunpC(a, q);
    arg4 = w6;
    m = w3;
    q = cdr(w11);
    a = w1;
    a = CC_gbEMmkwprep(a, q, m, arg4);
    w12 = a;
    a = cdr(cdr(car(value(LL_gbEhistry))));
    w13 = a;
    q = w1;
    a = w3;
    a = cons(a, q);
    m = LL_lessp;
    q = w13;
    CC_seTinsertbycar(a, q, m);
    a = w3;
    a = Lncons(a);
    q = a;
    a = value(LL_gbEsyzvar);
    a = CC_gevTxid(a, q);
    a = CC_Acoef2befloat(a);
    w14 = a;
    m = a;
    q = w3;
    a = value(LL_gbEsyzygy);
    Lputv(a, q, m);
    q = w5;
    a = w12;
    {
        popv(16);
        return  CC_gbEMinswset(a, q);
    }
   G4228:
    q = value(LL_Hmachineps);
    a = w9;
    a = quot2(a, q);
    w10 = a;
    a = w2;
    if(a != LL_Spol) goto    G4232;
    q = car(value(LL_gbEcontrol));
    a = value(LL_gbEcanclvl);
    a = times2(a, q);
    q = a;
    a = w10;
    a = Llessp(a, q);
    if(a != nil) goto    G4206;
    q = w9;
    a = w4;
    a = quot2(a, q);
    q = cdr(value(LL_gbEcontrol));
    a = Lgeq(a, q);
    if(a != nil) goto    G4206;
   G4232:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4239;
    Lterpri();
    a = LITERAL[272];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[347];
    Lprinc(a);
    Lterpri();
   G4239:
    a = w2;
    if(a != LL_Spol) goto    G4208;
    a = w8;
    a = CC_tail(a);
    w16 = a;
    a = w3;
    a = Lncons(a);
    q = a;
    a = w16;
    cdr(a) = q;
    a = cdr(a);
    goto    G4259;
   G4208:
    q = w6;
    a = w3;
    CC_seTdelete(a, q);
    q = w5;
    a = w3;
    CC_gbEdelunpC(a, q);
    a = w3;
    CC_gbEsyzyclear(a);
    m = LL_lessp;
    q = w8;
    a = w3;
    CC_seTinsert(a, q, m);
   G4259:
    arg4 = nil;
    m = w3;
    q = cdr(w11);
    a = w1;
    a = CC_gbEMmkwprep(a, q, m, arg4);
    w12 = a;
    q = w7;
    CC_gbEMinswset(a, q);
    a = LL_intoMwset2;
   G4203:
    popv(16);
    return a;
}

Sex CC_gbEMmoveCancPol(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = cdr(a);
    if(a != nil) goto    G4270;
    a = m;
    goto    G4263;
   G4270:
    w5 = a;
   G4264:
    a = cdr(car(car(w5)));
    w13 = a;
    q = car(a);
    a = value(LL_Hmachineps);
    a = times2(a, q);
    q = a;
    a = cdr(w13);
    a = quot2(a, q);
    w6 = a;
    q = car(w5);
    a = cons(a, q);
    m = LL_lessp;
    q = w7;
    a = CC_insertbycar(a, q, m);
    w7 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G4264;
    a = car(car(w7));
    w6 = a;
    q = car(value(LL_gbEcontrol));
    a = Llessp(a, q);
    if(a == nil) goto    G4276;
    a = car(value(LL_gbEcontrol));
    goto    G4293;
   G4276:
    q = cdr(value(LL_gbEcontrol));
    a = w6;
    a = Llessp(a, q);
    if(a == nil) goto    G4277;
    a = cdr(value(LL_gbEcontrol));
    goto    G4293;
   G4277:
    q = car(value(LL_gbEcontrol));
    a = w6;
    a = times2(a, q);
    a = CC_truncat3dgt(a);
   G4293:
    value(LL_gbEcanclvl) = a;
    a = w1;
    w5 = a;
   G4267:
    a = car(cdr(w5));
    w13 = a;
    q = car(cdr(car(a)));
    a = value(LL_Hmachineps);
    a = times2(a, q);
    q = a;
    a = cdr(cdr(car(w13)));
    a = quot2(a, q);
    w6 = a;
    q = value(LL_gbEcanclvl);
    a = Llessp(a, q);
    if(a != nil) goto    G4283;
    a = cdr(w5);
    w5 = a;
    goto    G4268;
   G4283:
    a = car(car(cdr(w13)));
    w9 = a;
    q = w3;
    CC_gbEinsunpC(a, q);
    a = cdr(w4);
    a = Lcopy(a);
    q = a;
    a = car(cdr(w13));
    cdr(a) = q;
    m = LL_lessp;
    q = w4;
    a = w9;
    CC_seTinsert(a, q, m);
    q = w2;
    a = w9;
    CC_seTdelete(a, q);
    q = w3;
    a = w13;
    CC_gbEMinswset(a, q);
    q = cdr(cdr(w5));
    a = w5;
    cdr(a) = q;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4286;
    Lterpri();
    a = LITERAL[107];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = LITERAL[348];
    Lprinc(a);
    Lterpri();
   G4286:
    a = cdr(cdr(car(value(LL_gbEhistry))));
    w11 = a;
    a = cdr(cdr(w13));
    w10 = a;
    q = w9;
    a = Lxcons(a, q);
    m = LL_lessp;
    q = w11;
    CC_seTinsertbycar(a, q, m);
    a = w9;
    a = Lncons(a);
    q = a;
    a = value(LL_gbEsyzvar);
    a = CC_gevTxid(a, q);
    a = CC_Acoef2befloat(a);
    w12 = a;
    m = a;
    q = w9;
    a = value(LL_gbEsyzygy);
    Lputv(a, q, m);
   G4268:
    a = cdr(w5);
    if(a != nil) goto    G4267;
   G4263:
    popv(13);
    return a;
}

Sex CC_gbEMimprovePols(Sex a)
{
    Sex q, m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w1 = a;
    a = cdr(cdr(car(value(LL_gbEhistry))));
    w6 = a;
    a = cdr(w1);
    w2 = a;
   G4297:
    a = car(w2);
    w11 = a;
    a = car(car(a));
    w5 = a;
    a = car(car(cdr(w11)));
    w3 = a;
    a = cdr(cdr(w11));
    w4 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4308;
    Lterpri();
    a = LITERAL[349];
    Lprinc(a);
    a = w3;
    Lprint(a);
   G4308:
    q = w3;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w11 = a;
    if(!is_number(a)) goto    G4310;
    a = mkfxat(1);
    goto    G4345;
   G4310:
    a = CC_Cterms(a);
   G4345:
    w11 = a;
    a = Lonep(a);
    if(a == nil) goto    G4298;
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G4306;
    a = LITERAL[350];
    goto    G4346;
   G4298:
    a = w4;
    a = CC_gbEaccMax(a);
    w11 = a;
    a = value(LL_Hmachineps);
    a = Lfloat(a);
    q = a;
    a = mkfxat(5);
    a = times2(a, q);
    q = a;
    a = w11;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G4299;
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G4306;
    a = LITERAL[351];
   G4346:
    Lprinc(a);
    Lterpri();
    goto    G4306;
   G4299:
    a = LITERAL[352];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w4;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    q = w3;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    m = a;
    q = w6;
    a = w3;
    a = CC_gbEmatxMonoset(a, q, m);
    w7 = a;
    a = w7;
    a = CC_gbEmatxMergExs(a);
    w8 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G4324;
    Lterpri();
    Lterpri();
    a = LITERAL[353];
    Lprinc(a);
    a = w8;
    Lprint(a);
   G4324:
    q = w8;
    a = w5;
    a = CC_gbEmatxHexpos(a, q);
    w9 = a;
    m = w8;
    q = w7;
    a = w6;
    a = CC_gbEMmatxMkMatx(a, q, m);
    w10 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4326;
    a = LITERAL[268];
    Lprinc(a);
    a = cdr(w10);
    a = Llength(a);
    Lprint(a);
    a = LITERAL[269];
    Lprinc(a);
    a = w8;
    a = Llength(a);
    Lprint(a);
    a = LITERAL[270];
    Lprinc(a);
    a = w9;
    Lprint(a);
   G4326:
    a = w9;
    a = Lsub1(a);
    q = a;
    a = w10;
    a = CC_gbEMmatxReduce(a, q);
    w4 = a;
   G4305:
    a = w4;
    a = Lzerop(a);
    if(a == nil) goto    G4331;
    Lterpri();
    a = LITERAL[345];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[346];
    Lprinc(a);
    Lterpri();
    q = w2;
    a = w1;
    a = CC_before(a, q);
    w2 = a;
    q = cdr(cdr(a));
    cdr(a) = q;
    goto    G4306;
   G4331:
    a = w4;
    a = CC_gbEhex(a);
    a = CC_Wzerolist(a);
    if(a == nil) goto    G4332;
    a = mkfxat(1);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    a = mkfxat(1);
    goto    G4296;
   G4332:
    a = w4;
    a = CC_gbEmaxcoferr(a);
    w11 = a;
    q = car(a);
    a = cdr(a);
    a = quot2(a, q);
    q = a;
    a = w4;
    a = CC_gbEerrPolp(a, q);
    if(a == nil) goto    G4337;
    a = mkfxat(0);
    w4 = a;
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G4305;
    a = LITERAL[345];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[346];
    Lprinc(a);
    Lterpri();
    goto    G4305;
   G4337:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4342;
    a = LITERAL[345];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w4;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G4342:
    q = w4;
    a = cdr(car(w2));
    cdr(a) = q;
    q = w11;
    a = car(car(w2));
    cdr(a) = q;
   G4306:
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G4297;
    a = w1;
   G4296:
    popv(11);
    return a;
}

Sex CC_gbEMimprovePol1(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w1 = a;
    w2 = q;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4357;
    Lterpri();
    a = LITERAL[354];
    Lprinc(a);
    a = LITERAL[355];
    Lprinc(a);
    Lterpri();
   G4357:
    a = car(car(value(LL_gbEhistry)));
    w5 = a;
    w6 = a;
    q = w2;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w3 = a;
    q = value(LL_gbEhistry);
    a = w6;
    a = Lassoc(a, q);
    a = cdr(a);
    a = cdr(a);
    w8 = a;
    q = w6;
    a = w5;
    a = Lequal(a, q);
    if(a == nil) goto    G4361;
    a = w3;
    goto    G4362;
   G4361:
    m = w6;
    q = w3;
    a = w2;
    a = CC_gbEMimprContSyz(a, q, m);
   G4362:
    w4 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4364;
    Lterpri();
    a = LITERAL[349];
    Lprinc(a);
    a = w2;
    Lprint(a);
   G4364:
    m = w4;
    q = w8;
    a = w2;
    a = CC_gbEmatxMonoset(a, q, m);
    w9 = a;
    a = w9;
    a = CC_gbEmatxMergExs(a);
    w10 = a;
    a = w1;
    a = CC_gbEhex(a);
    q = w10;
    a = CC_gbEmatxHexpos(a, q);
    w11 = a;
    m = w10;
    q = w9;
    a = w8;
    a = CC_gbEMmatxMkMatx(a, q, m);
    w12 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4367;
    a = LITERAL[268];
    Lprinc(a);
    a = cdr(w12);
    a = Llength(a);
    Lprint(a);
    a = LITERAL[269];
    Lprinc(a);
    a = w10;
    a = Llength(a);
    Lprint(a);
    a = LITERAL[270];
    Lprinc(a);
    a = w11;
    Lprint(a);
   G4367:
    a = w11;
    a = Lsub1(a);
    q = a;
    a = w12;
    a = CC_gbEMmatxReduce(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G4372;
    a = mkfxat(0);
    goto    G4349;
   G4372:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G4374;
    a = LITERAL[345];
    Lprinc(a);
    a = w2;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w1;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    a = w1;
    a = CC_gbEaccMinMax(a);
    w13 = a;
    a = LITERAL[330];
    Lprinc(a);
    a = car(w13);
    Lprin(a);
    a = LITERAL[331];
    Lprinc(a);
    a = cdr(w13);
    Lprin(a);
    a = LITERAL[298];
    Lprinc(a);
    Lterpri();
   G4374:
    a = w1;
    a = CC_gbEhex(a);
    a = CC_Wzerolist(a);
    if(a == nil) goto    G4376;
    a = mkfxat(1);
    goto    G4349;
   G4376:
    a = w1;
   G4349:
    popv(13);
    return a;
}

Sex CC_gbEMintlzSyzsIPs(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    a = value(LL_gbEhistry);
    if(a == nil) goto    G4387;
    a = cdr(a);
    if(a == nil) goto    G4387;
    a = cdr(a);
    if(a == nil) goto    G4387;
    q = nil;
    a = cdr(value(LL_gbEhistry));
    cdr(a) = q;
   G4387:
    a = cdr(w1);
    w2 = a;
    a = value(LL_gbEhistry);
    if(a != nil) goto    G4383;
   G4390:
    a = car(car(cdr(car(w2))));
    w5 = a;
    a = cdr(cdr(car(w2)));
    w6 = a;
    q = w5;
    a = Lxcons(a, q);
    m = LL_lessp;
    q = w3;
    a = CC_insertbycar(a, q, m);
    w3 = a;
    a = w5;
    a = Lncons(a);
    q = a;
    a = value(LL_gbEsyzvar);
    a = CC_gevTxid(a, q);
    a = CC_Acoef2befloat(a);
    w7 = a;
    m = a;
    q = w5;
    a = value(LL_gbEsyzygy);
    Lputv(a, q, m);
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G4390;
    q = w3;
    a = cons(a, q);
    q = mkfxat(1);
    a = Lxcons(a, q);
    q = value(LL_gbEhistry);
    a = cons(a, q);
    value(LL_gbEhistry) = a;
    goto    G4385;
   G4383:
    a = car(car(cdr(car(w2))));
    w5 = a;
    a = cdr(cdr(car(w2)));
    w6 = a;
    q = w5;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    w7 = a;
    q = w6;
    a = w5;
    a = cons(a, q);
    m = LL_lessp;
    q = w3;
    a = CC_insertbycar(a, q, m);
    w3 = a;
    q = w7;
    a = w5;
    a = cons(a, q);
    m = LL_lessp;
    q = w4;
    a = CC_insertbycar(a, q, m);
    w4 = a;
    a = w5;
    a = Lncons(a);
    q = a;
    a = value(LL_gbEsyzvar);
    a = CC_gevTxid(a, q);
    a = CC_Acoef2befloat(a);
    w7 = a;
    m = a;
    q = w5;
    a = value(LL_gbEsyzygy);
    Lputv(a, q, m);
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G4383;
    a = car(value(LL_gbEhistry));
    w2 = a;
    q = w4;
    a = cdr(a);
    car(a) = q;
    a = car(w2);
    a = Ladd1(a);
    w5 = a;
    q = w3;
    a = nil;
    a = cons(a, q);
    q = w5;
    a = Lxcons(a, q);
    q = value(LL_gbEhistry);
    a = cons(a, q);
    value(LL_gbEhistry) = a;
   G4385:
    a = w3;
    popv(7);
    return a;
}

Sex CC_gbEMimprContSyz(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w7 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = q;
    if(a != nil) goto    G4414;
    q = w1;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
   G4414:
    a = cdr(a);
    w2 = a;
   G4409:
    a = cdr(car(cdr(w2)));
    w7 = a;
    a = CC_Wbnum(a);
    if(a != nil) goto    G4418;
    q = w7;
    a = value(LL_CpolyC);
    a = cons(a, q);
    w7 = a;
   G4418:
    q = w7;
    a = car(cdr(car(w2)));
    a = cons(a, q);
    q = w5;
    a = cons(a, q);
    w5 = a;
    a = cdr(cdr(w2));
    w2 = a;
    if(a == nil) goto    G4421;
    a = cdr(car(a));
    w2 = a;
    goto    G4409;
   G4421:
    a = mkfxat(0);
    w4 = a;
    q = value(LL_gbEhistry);
    a = w3;
    a = Lassoc(a, q);
    a = cdr(a);
    a = car(a);
    w6 = a;
   G4411:
    q = w6;
    a = car(car(w5));
    a = Lassoc(a, q);
    a = cdr(a);
    w8 = a;
    q = a;
    a = cdr(car(w5));
    a = CC_multH(a, q);
    q = a;
    a = w4;
    a = CC_addH(a, q);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G4411;
    a = w4;
    popv(8);
    return a;
}

Sex CC_gbEmatxMonoset(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    a = cdr(m);
    w3 = a;
    w2 = q;
   G4431:
    a = cdr(car(cdr(w3)));
    w9 = a;
    a = CC_Wbnum(a);
    if(a == nil) goto    G4437;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w9;
    a = CC_gbEnum2dist(a, q, m);
    goto    G4449;
   G4437:
    q = w9;
    a = value(LL_CpolyC);
    a = cons(a, q);
    w8 = a;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = CC_gbEpoly2dist(a, q, m);
   G4449:
    w8 = a;
    a = w8;
    a = Lzerop(a);
    if(a == nil) goto    G4441;
    q = nil;
    a = LITERAL[356];
    CC_errormsg(a, q);
   G4441:
    q = w8;
    a = car(w3);
    a = cons(a, q);
    q = w6;
    a = cons(a, q);
    w6 = a;
    a = cdr(cdr(w3));
    w3 = a;
    if(a == nil) goto    G4444;
    a = cdr(car(a));
    w3 = a;
    goto    G4431;
   G4444:
    a = CHAR_OF(72);
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = w6;
    w7 = a;
   G4434:
    a = car(cdr(car(car(w7))));
    w10 = a;
    m = w2;
    q = car(w7);
    a = CC_gbEmatxMns1(a, q, m);
    w11 = a;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G4434;
    a = cdr(w4);
    popv(11);
    return a;
}

Sex CC_gbEmatxMns1(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    q = m;
    a = Lassoc(a, q);
    a = cdr(a);
    w8 = a;
    a = w1;
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = cdr(cdr(w2));
    w2 = a;
   G4453:
    a = CHAR_OF(104);
    a = Lncons(a);
    w10 = a;
    w7 = a;
    a = car(car(w2));
    w6 = a;
    a = cdr(w8);
    w9 = a;
   G4454:
    q = car(car(w9));
    a = w6;
    a = CC_listsum(a, q);
    a = Lncons(a);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    w10 = a;
    a = cdr(w9);
    w9 = a;
    if(a != nil) goto    G4454;
    a = cdr(w7);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w2);
    w2 = a;
    if(a != nil) goto    G4453;
    a = w4;
    popv(11);
    return a;
}

Sex CC_gbEmatxMergExs(Sex a)
{
    Sex q, m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = CHAR_OF(72);
    a = Lncons(a);
    w2 = a;
   G4470:
    a = cdr(car(w1));
    w4 = a;
   G4471:
    a = car(w4);
    w5 = a;
    a = w2;
    w3 = a;
   G4472:
#define LL_Slis LITERAL[357]
    m = LL_Slis;
    q = w3;
    a = car(w5);
    a = CC_seTinsert(a, q, m);
    w3 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G4472;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G4471;
    a = cdr(w1);
    w1 = a;
    if(a != nil) goto    G4470;
    a = cdr(w2);
    popv(5);
    return a;
}

Sex CC_gbEMmatxMkMatx(Sex a, Sex q, Sex m)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w14 = nil;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = LL_CMatx;
    a = Lncons(a);
    w5 = a;
    w4 = a;
    a = w3;
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
   G4485:
    a = car(car(w2));
    w11 = a;
    a = cdr(car(w2));
    w8 = a;
    q = w1;
    a = w11;
    a = Lassoc(a, q);
    a = cdr(a);
    w12 = a;
   G4486:
    a = car(w8);
    w9 = a;
    a = car(a);
    w10 = a;
    a = cdr(w12);
    w13 = a;
    a = LL_row;
    a = Lncons(a);
    w7 = a;
    w6 = a;
    a = w3;
    w14 = a;
   G4487:
    q = car(w14);
    a = w10;
    a = Lequal(a, q);
    if(a != nil) goto    G4495;
    a = mkfxat(0);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = cdr(w14);
    w14 = a;
    goto    G4487;
   G4495:
    a = cdr(car(w13));
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = cdr(w14);
    w14 = a;
    a = cdr(w9);
    w9 = a;
    if(a == nil) goto    G4501;
    a = car(a);
    w10 = a;
    a = cdr(w13);
    w13 = a;
    goto    G4487;
   G4501:
    a = w14;
    if(a == nil) goto    G4503;
    a = mkfxat(0);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    a = cdr(w14);
    w14 = a;
    goto    G4501;
   G4503:
    a = cdr(w6);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    a = cdr(w8);
    w8 = a;
    if(a != nil) goto    G4486;
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G4511;
    a = cdr(w1);
    w1 = a;
    goto    G4485;
   G4511:
    a = cdr(w4);
    popv(14);
    return a;
}

Sex CC_gbEmatxHexpos(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = mkfxat(1);
    w4 = a;
    a = q;
    w3 = a;
    w2 = q;
   G4515:
    q = car(w3);
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G4517;
    a = w4;
    goto    G4514;
   G4517:
    a = w4;
    a = Ladd1(a);
    w4 = a;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G4515;
    q = nil;
    a = LITERAL[358];
    CC_errormsg(a, q);
    a = nil;
   G4514:
    popv(4);
    return a;
}

Sex CC_gbEmatxGauss1(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 19;
    w19 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    a = value(LL_gbEaccinit);
    w11 = a;
    a = cdr(w1);
    w3 = a;
    a = mkfxat(0);
    w12 = a;
    w2 = q;
   G4526:
    a = w12;
    a = Ladd1(a);
    w12 = a;
    w15 = nil;
    a = w3;
    w4 = a;
    w13 = nil;
    w14 = nil;
   G4527:
    a = car(car(w4));
    a = Lzerop(a);
    if(a != nil) goto    G4545;
    a = w13;
    if(a != nil) goto    G4543;
    a = car(car(w4));
    a = Lbefloat_value(a);
    a = Labs(a);
    goto    G4604;
   G4543:
    a = car(car(w4));
    a = Lbefloat_value(a);
    a = Labs(a);
    w17 = a;
    q = w14;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G4545;
    a = w17;
   G4604:
    w14 = a;
    a = w4;
    w13 = a;
   G4545:
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G4527;
    a = w13;
    if(a != nil) goto    G4551;
    a = cdr(w3);
    if(a == nil) goto    G4578;
    q = w2;
    a = w12;
    a = Lequal(a, q);
    if(a == nil) goto    G4554;
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    goto    G4578;
   G4554:
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    goto    G4526;
   G4551:
    q = w3;
    a = w13;
    a = Lneq(a, q);
    if(a == nil) goto    G4557;
    a = car(w3);
    w17 = a;
    q = car(w13);
    a = w3;
    car(a) = q;
    q = w17;
    a = w13;
    car(a) = q;
   G4557:
    a = cdr(w3);
    w4 = a;
   G4529:
    if(a == nil) goto    G4534;
    a = car(car(a));
    a = Lzerop(a);
    if(a != nil) goto    G4533;
    a = car(w3);
    w5 = a;
    a = car(w4);
    w8 = a;
    q = car(w5);
    a = car(a);
    a = quot2(a, q);
    w16 = a;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
    a = true;
    w15 = a;
   G4531:
    a = car(w6);
    w7 = a;
    a = car(w9);
    w10 = a;
    a = w7;
    a = Lzerop(a);
    if(a == nil) goto    G4562;
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G4568;
   G4562:
    q = w7;
    a = w16;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = w10;
    a = plus2(a, q);
    w17 = a;
    q = w11;
    a = CC_acczerop(a, q);
    if(a == nil) goto    G4567;
    q = LITERAL[7];
    goto    G4606;
   G4567:
    q = w17;
   G4606:
    a = w9;
    car(a) = q;
   G4568:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G4531;
    a = w8;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G4533;
    a = true;
    w18 = a;
    goto    G4607;
    q = w4;
    a = w3;
    a = CC_before(a, q);
    w17 = a;
    q = cdr(w4);
    cdr(a) = q;
   G4533:
    a = cdr(w4);
    w4 = a;
    goto    G4529;
   G4534:
    a = w15;
    if(a == nil) goto    G4574;
    a = cdr(w3);
    w3 = a;
   G4574:
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    q = w2;
    a = w12;
    a = Lgeq(a, q);
    if(a != nil) goto    G4578;
    a = cdr(w3);
    if(a != nil) goto    G4526;
   G4578:
    q = w2;
    a = car(w1);
    a = CC_ncdr(a, q);
    w5 = a;
    a = car(w3);
    a = Llength(a);
    w19 = a;
    a = w5;
    a = Llength(a);
    a = Lminus(a);
    q = a;
    a = w19;
    a = plus2(a, q);
    w17 = a;
    w19 = nil;
   G4583:
    q = mkfxat(0);
    a = w17;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G4582;
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    q = mkfxat(-1);
    a = w17;
    a = plus2(a, q);
    w17 = a;
    w19 = a;
    goto    G4583;
   G4582:
    a = w3;
    w4 = a;
    w19 = nil;
   G4587:
    if(a == nil) goto    G4586;
    a = car(car(a));
    a = Lzerop(a);
    if(a == nil) goto    G4586;
    a = cdr(w4);
    w4 = a;
    w19 = a;
    goto    G4587;
   G4586:
    a = w4;
    if(a != nil) goto    G4608;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G4593;
   G4607:
    a = mkfxat(0);
    goto    G4525;
   G4593:
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    goto    G4582;
   G4608:
    a = car(a);
    w8 = a;
    a = value(LL_gbEorder);
    a = Lncons(a);
    w4 = a;
    w13 = a;
    a = car(w8);
    w17 = a;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
   G4538:
    a = car(w9);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G4539;
    q = w17;
    a = w10;
    a = quot2(a, q);
    q = car(w6);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G4539:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G4538;
    a = w13;
   G4525:
    popv(19);
    return a;
}

Sex CC_gbEmatxGauss2(Sex a, Sex q)
{
    Sex m, arg4, arg5, arg6;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 20;
    w20 = nil;
    w18 = nil;
    w15 = nil;
    w14 = nil;
    w12 = nil;
    w6 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w13 = nil;
    w16 = nil;
    w17 = nil;
    w19 = nil;
    w1 = a;
    a = value(LL_gbEaccinit);
    w11 = a;
    w2 = q;
    a = LITERAL[359];
    CC_enterto(a);
    a = cdr(w1);
    w3 = a;
    q = mkfxat(0);
    a = nil;
    a = cons(a, q);
    w12 = a;
    a = mkfxat(0);
    w15 = a;
   G4616:
    a = car(w3);
    w6 = a;
    a = w15;
    a = Ladd1(a);
    w15 = a;
    a = mkfxat(0);
    w14 = a;
   G4617:
    a = w14;
    a = Ladd1(a);
    w14 = a;
    a = car(w6);
    w18 = a;
    a = Lzerop(a);
    if(a != nil) goto    G4638;
    a = w18;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w18 = a;
    q = cdr(w12);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G4638;
    q = w15;
    a = w14;
    a = cons(a, q);
    q = a;
    a = w12;
    car(a) = q;
    q = w18;
    a = w12;
    cdr(a) = q;
   G4638:
    a = cdr(w6);
    w6 = a;
    q = w2;
    a = w14;
    a = Llessp(a, q);
    if(a != nil) goto    G4617;
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G4616;
    a = cdr(w1);
    w3 = a;
    a = mkfxat(0);
    w13 = a;
   G4621:
    a = w13;
    a = Ladd1(a);
    w13 = a;
    a = car(car(w12));
    w14 = a;
    q = w13;
    a = Lneq(a, q);
    if(a == nil) goto    G4648;
    a = w13;
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w14;
    a = plus2(a, q);
    q = a;
    a = w3;
    a = CC_gbEmatxExchCol1(a, q);
    w3 = a;
   G4648:
    a = cdr(car(w12));
    w15 = a;
    a = Lonep(a);
    if(a != nil) goto    G4654;
    q = mkfxat(-2);
    a = w15;
    a = plus2(a, q);
    q = a;
    a = w3;
    a = CC_ncdr(a, q);
    w18 = a;
    a = car(cdr(a));
    w12 = a;
    q = cdr(cdr(w18));
    a = w18;
    cdr(a) = q;
    q = w3;
    a = w12;
    a = cons(a, q);
    w3 = a;
   G4654:
    q = LITERAL[7];
    a = nil;
    a = cons(a, q);
    w12 = a;
    a = car(w3);
    w5 = a;
    a = cdr(w3);
    w4 = a;
    a = mkfxat(1);
    w15 = a;
   G4622:
    a = car(w4);
    w8 = a;
    a = car(a);
    w10 = a;
    a = Lzerop(a);
    if(a == nil) goto    G4623;
    arg6 = w11;
    arg5 = w2;
    arg4 = w13;
    m = w15;
    q = w8;
    a = w12;
    CC_gbEMmatxPivot(a, q, m, arg4, arg5, arg6);
   G4623:
    q = car(w5);
    a = w10;
    a = quot2(a, q);
    w17 = a;
    q = LITERAL[7];
    a = w8;
    car(a) = q;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
    a = w13;
    w14 = a;
    w16 = nil;
    goto    G4672;
   G4624:
    a = car(w6);
    w7 = a;
    a = car(w9);
    w10 = a;
    a = w7;
    a = Lzerop(a);
    if(a == nil) goto    G4660;
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G4672;
   G4660:
    q = w7;
    a = w17;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = w10;
    a = plus2(a, q);
    w18 = a;
    q = w11;
    a = CC_acczerop(a, q);
    if(a == nil) goto    G4665;
    q = LITERAL[7];
    a = w9;
    car(a) = q;
    goto    G4672;
   G4665:
    q = w18;
    a = w9;
    car(a) = q;
    q = w2;
    a = w14;
    a = Lleq(a, q);
    if(a == nil) goto    G4666;
    a = true;
    w16 = a;
   G4666:
    q = w2;
    a = w14;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G4672;
    a = w18;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w18 = a;
    q = cdr(w12);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G4672;
    q = w15;
    a = w14;
    a = cons(a, q);
    q = a;
    a = w12;
    car(a) = q;
    q = w18;
    a = w12;
    cdr(a) = q;
   G4672:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w14;
    a = Ladd1(a);
    w14 = a;
    a = w6;
    if(a != nil) goto    G4624;
    a = w8;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G4626;
    a = true;
    w19 = a;
    a = cdr(cdr(w3));
    if(a == nil) goto    G4718;
    q = w4;
    a = w3;
    a = CC_before(a, q);
    w18 = a;
    q = cdr(w4);
    cdr(a) = q;
    a = w15;
    a = Lsub1(a);
    w15 = a;
   G4626:
    a = w16;
    if(a == nil) goto    G4692;
    a = w15;
    a = Ladd1(a);
    w15 = a;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G4622;
    a = cdr(w3);
    a = CC_listcdr(a);
    w3 = a;
    a = cdr(w12);
    a = Lzerop(a);
    if(a != nil) goto    G4692;
    a = cdr(w3);
    if(a == nil) goto    G4692;
    q = w2;
    a = w13;
    a = Llessp(a, q);
    if(a != nil) goto    G4621;
   G4692:
    q = w2;
    a = car(w1);
    a = CC_ncdr(a, q);
    w5 = a;
    a = car(w3);
    a = Llength(a);
    w20 = a;
    a = w5;
    a = Llength(a);
    a = Lminus(a);
    q = a;
    a = w20;
    a = plus2(a, q);
    w18 = a;
    w20 = nil;
   G4697:
    q = mkfxat(0);
    a = w18;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G4696;
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    q = mkfxat(-1);
    a = w18;
    a = plus2(a, q);
    w18 = a;
    w20 = a;
    goto    G4697;
   G4696:
    a = w3;
    w4 = a;
    w20 = nil;
   G4701:
    if(a == nil) goto    G4700;
    a = car(car(a));
    a = Lzerop(a);
    if(a == nil) goto    G4700;
    a = cdr(w4);
    w4 = a;
    w20 = a;
    goto    G4701;
   G4700:
    a = w4;
    if(a != nil) goto    G4719;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G4707;
   G4718:
    a = mkfxat(0);
    goto    G4615;
   G4707:
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    goto    G4696;
   G4719:
    a = car(a);
    w8 = a;
    a = value(LL_gbEorder);
    a = Lncons(a);
    w4 = a;
    w12 = a;
    a = car(w8);
    w18 = a;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
   G4631:
    a = car(w9);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G4632;
    q = w18;
    a = w10;
    a = quot2(a, q);
    q = car(w6);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G4632:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G4631;
    a = w12;
   G4615:
    popv(20);
    return a;
}

Sex CC_gbEMmatxPivot(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w1 = a;
    a = cdr(q);
    w7 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
   G4723:
    a = w4;
    a = Ladd1(a);
    w4 = a;
    q = w5;
    a = Lgreaterp(a, q);
    if(a != nil) goto    G4740;
    a = car(w7);
    w8 = a;
    a = Lzerop(a);
    if(a != nil) goto    G4732;
    a = w8;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    a = Labs(a);
    w8 = a;
    q = cdr(w1);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G4732;
    q = w3;
    a = w4;
    a = cons(a, q);
    q = a;
    a = w1;
    car(a) = q;
    q = w8;
    a = w1;
    cdr(a) = q;
   G4732:
    q = w6;
    a = cdr(w1);
    a = Llessp(a, q);
    if(a != nil) goto    G4740;
    a = cdr(w7);
    w7 = a;
    if(a != nil) goto    G4723;
   G4740:
    a = w1;
    popv(8);
    return a;
}

Sex CC_gbEmatxExchCol1(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = q;
    a = Lonep(a);
    if(a == nil) goto    G4746;
    a = w1;
    goto    G4747;
   G4746:
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    a = CHAR_OF(72);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = w1;
    w5 = a;
    q = mkfxat(-2);
    a = w2;
    a = plus2(a, q);
    w6 = a;
   G4749:
    a = car(w5);
    w7 = a;
    q = w6;
    a = CC_ncdr(a, q);
    w8 = a;
    a = car(cdr(a));
    w9 = a;
    q = cdr(cdr(w8));
    a = w8;
    cdr(a) = q;
    q = w7;
    a = w9;
    a = cons(a, q);
    w7 = a;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G4749;
    a = cdr(w3);
   G4747:
    popv(9);
    return a;
}

Sex CC_gbEmatxGivens0(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 18;
    w18 = nil;
    w14 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w1 = a;
    a = value(LL_gbEaccinit);
    w12 = a;
    a = cdr(w1);
    w3 = a;
    a = mkfxat(0);
    w13 = a;
    w2 = q;
   G4760:
    a = w13;
    a = Ladd1(a);
    w13 = a;
    w14 = nil;
    a = w3;
    w4 = a;
   G4761:
    a = car(car(w4));
    a = Lzerop(a);
    if(a == nil) goto    G4776;
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G4767;
    goto    G4761;
   G4776:
    q = w4;
    a = w3;
    a = Lneq(a, q);
    if(a == nil) goto    G4778;
    a = car(w3);
    w17 = a;
    q = car(w4);
    a = w3;
    car(a) = q;
    q = w17;
    a = w4;
    car(a) = q;
   G4778:
    a = cdr(w3);
    w4 = a;
   G4762:
    if(a == nil) goto    G4838;
    a = car(car(w4));
    a = Lzerop(a);
    if(a != nil) goto    G4766;
    a = car(w3);
    w5 = a;
    a = car(a);
    a = Lbefloat_value(a);
    w7 = a;
    a = car(w4);
    w8 = a;
    a = car(a);
    a = Lbefloat_value(a);
    w10 = a;
    q = w7;
    a = q;
    a = times2(a, q);
    w18 = a;
    q = w10;
    a = q;
    a = times2(a, q);
    q = a;
    a = w18;
    a = plus2(a, q);
    a = Lsqrt(a);
    w17 = a;
    q = a;
    a = w7;
    a = quot2(a, q);
    w15 = a;
    q = w17;
    a = w10;
    a = quot2(a, q);
    w16 = a;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
    a = true;
    w14 = a;
   G4764:
    a = car(w6);
    w7 = a;
    a = car(w9);
    w10 = a;
    a = w7;
    a = Lzerop(a);
    if(a == nil) goto    G4791;
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G4803;
   G4791:
    q = w15;
    a = w7;
    a = times2(a, q);
    w18 = a;
    q = w16;
    a = w10;
    a = times2(a, q);
    q = a;
    a = w18;
    a = plus2(a, q);
    w17 = a;
    q = w12;
    a = CC_acczerop(a, q);
    if(a == nil) goto    G4796;
    q = LITERAL[7];
    goto    G4835;
   G4796:
    q = w17;
   G4835:
    a = w6;
    car(a) = q;
    q = w15;
    a = w10;
    a = times2(a, q);
    w18 = a;
    q = w16;
    a = w7;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = w18;
    a = plus2(a, q);
    w17 = a;
    q = w12;
    a = CC_acczerop(a, q);
    if(a == nil) goto    G4802;
    q = LITERAL[7];
    goto    G4836;
   G4802:
    q = w17;
   G4836:
    a = w9;
    car(a) = q;
   G4803:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G4764;
    a = w8;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G4766;
    q = w4;
    a = w3;
    a = CC_before(a, q);
    w17 = a;
    q = cdr(w4);
    cdr(a) = q;
   G4766:
    a = cdr(w4);
    w4 = a;
    goto    G4762;
   G4838:
    a = w14;
    if(a != nil) goto    G4767;
    a = cdr(w3);
    w3 = a;
   G4767:
    a = w14;
    if(a == nil) goto    G4809;
    a = cdr(w3);
    w3 = a;
   G4809:
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    q = w2;
    a = w13;
    a = Lgeq(a, q);
    if(a != nil) goto    G4813;
    a = cdr(w3);
    if(a != nil) goto    G4760;
   G4813:
    q = w2;
    a = car(w1);
    a = CC_ncdr(a, q);
    w5 = a;
    a = cdr(w3);
    if(a != nil) goto    G4815;
    a = w13;
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w2;
    a = plus2(a, q);
    q = a;
    a = w8;
    a = CC_ncdr(a, q);
    w8 = a;
    goto    G4769;
   G4815:
    a = w3;
    w4 = a;
    w18 = nil;
   G4820:
    a = car(car(w4));
    a = Lzerop(a);
    if(a == nil) goto    G4819;
    a = cdr(w4);
    w4 = a;
    w18 = a;
    goto    G4820;
   G4819:
    a = car(w4);
    w8 = a;
   G4769:
    a = value(LL_gbEorder);
    a = Lncons(a);
    w4 = a;
    w11 = a;
    a = car(w8);
    w15 = a;
    a = Lzerop(a);
    if(a == nil) goto    G4824;
    a = mkfxat(0);
    goto    G4759;
   G4824:
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
   G4770:
    a = car(w9);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G4771;
    q = w15;
    a = w10;
    a = quot2(a, q);
    q = car(w6);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G4771:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G4770;
    a = w11;
   G4759:
    popv(18);
    return a;
}

Sex CC_gbEmatxGivens01(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 19;
    w19 = nil;
    w15 = nil;
    w14 = nil;
    w13 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    a = value(LL_gbEaccinit);
    w11 = a;
    a = cdr(w1);
    w3 = a;
    a = mkfxat(0);
    w12 = a;
    w2 = q;
   G4844:
    a = w12;
    a = Ladd1(a);
    w12 = a;
    w15 = nil;
    a = w3;
    w4 = a;
    w13 = nil;
    w14 = nil;
   G4845:
    if(a != nil) goto    G4859;
    a = cdr(w3);
    if(a == nil) goto    G4853;
    q = w2;
    a = w12;
    a = Lequal(a, q);
    if(a == nil) goto    G4903;
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    goto    G4853;
   G4859:
    a = car(car(a));
    a = Lzerop(a);
    if(a != nil) goto    G4930;
    a = w13;
    if(a != nil) goto    G4865;
    a = car(car(w4));
    a = Lbefloat_value(a);
    a = Labs(a);
    goto    G4925;
   G4865:
    a = car(car(w4));
    a = Lbefloat_value(a);
    a = Labs(a);
    w18 = a;
    q = w14;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G4867;
    a = w18;
   G4925:
    w14 = a;
    a = w4;
    w13 = a;
   G4867:
    a = cdr(w4);
    w4 = a;
    goto    G4845;
   G4930:
    a = cdr(w4);
    w4 = a;
    a = w13;
    if(a == nil) goto    G4852;
    q = w3;
    a = Lneq(a, q);
    if(a == nil) goto    G4873;
    a = car(w3);
    w18 = a;
    q = car(w13);
    a = w3;
    car(a) = q;
    q = w18;
    a = w13;
    car(a) = q;
   G4873:
    a = cdr(w3);
    w4 = a;
   G4847:
    if(a == nil) goto    G4852;
    a = car(car(a));
    a = Lzerop(a);
    if(a != nil) goto    G4851;
    a = car(w3);
    w5 = a;
    a = car(a);
    a = Lbefloat_value(a);
    w7 = a;
    a = car(w4);
    w8 = a;
    a = car(a);
    a = Lbefloat_value(a);
    w10 = a;
    q = w7;
    a = q;
    a = times2(a, q);
    w19 = a;
    q = w10;
    a = q;
    a = times2(a, q);
    q = a;
    a = w19;
    a = plus2(a, q);
    a = Lsqrt(a);
    w18 = a;
    q = a;
    a = w7;
    a = quot2(a, q);
    w16 = a;
    q = w18;
    a = w10;
    a = quot2(a, q);
    w17 = a;
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
    a = true;
    w15 = a;
   G4849:
    a = car(w6);
    w7 = a;
    a = car(w9);
    w10 = a;
    a = w7;
    a = Lzerop(a);
    if(a == nil) goto    G4881;
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G4893;
   G4881:
    q = w16;
    a = w7;
    a = times2(a, q);
    w19 = a;
    q = w17;
    a = w10;
    a = times2(a, q);
    q = a;
    a = w19;
    a = plus2(a, q);
    w18 = a;
    q = w11;
    a = CC_acczerop(a, q);
    if(a == nil) goto    G4886;
    q = LITERAL[7];
    goto    G4927;
   G4886:
    q = w18;
   G4927:
    a = w6;
    car(a) = q;
    q = w16;
    a = w10;
    a = times2(a, q);
    w19 = a;
    q = w17;
    a = w7;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = w19;
    a = plus2(a, q);
    w18 = a;
    q = w11;
    a = CC_acczerop(a, q);
    if(a == nil) goto    G4892;
    q = LITERAL[7];
    goto    G4928;
   G4892:
    q = w18;
   G4928:
    a = w9;
    car(a) = q;
   G4893:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G4849;
    a = w8;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G4851;
    q = w4;
    a = w3;
    a = CC_before(a, q);
    w18 = a;
    q = cdr(w4);
    cdr(a) = q;
   G4851:
    a = cdr(w4);
    w4 = a;
    goto    G4847;
   G4852:
    q = w2;
    a = w12;
    a = Lgeq(a, q);
    if(a != nil) goto    G4853;
    a = w15;
    if(a == nil) goto    G4901;
    a = cdr(w3);
    w3 = a;
   G4901:
    a = cdr(w3);
    if(a == nil) goto    G4853;
   G4903:
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    goto    G4844;
   G4853:
    q = w2;
    a = car(w1);
    a = CC_ncdr(a, q);
    w5 = a;
    a = cdr(w3);
    if(a != nil) goto    G4905;
    a = w12;
    a = Lminus(a);
    a = Ladd1(a);
    q = a;
    a = w2;
    a = plus2(a, q);
    q = a;
    a = w8;
    a = CC_ncdr(a, q);
    w8 = a;
    goto    G4854;
   G4905:
    a = w3;
    w4 = a;
    w19 = nil;
   G4910:
    a = car(car(w4));
    a = Lzerop(a);
    if(a == nil) goto    G4909;
    a = cdr(w4);
    w4 = a;
    w19 = a;
    goto    G4910;
   G4909:
    a = car(w4);
    w8 = a;
   G4854:
    a = value(LL_gbEorder);
    a = Lncons(a);
    w4 = a;
    w13 = a;
    a = car(w8);
    w16 = a;
    a = Lzerop(a);
    if(a == nil) goto    G4914;
    a = mkfxat(0);
    goto    G4843;
   G4914:
    a = w5;
    w6 = a;
    a = w8;
    w9 = a;
   G4855:
    a = car(w9);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G4856;
    q = w16;
    a = w10;
    a = quot2(a, q);
    q = car(w6);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
   G4856:
    a = cdr(w6);
    w6 = a;
    a = cdr(w9);
    w9 = a;
    a = w6;
    if(a != nil) goto    G4855;
    a = w13;
   G4843:
    popv(19);
    return a;
}

Sex CC_gbEmatxGivens1(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 19;
    w19 = nil;
    w13 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w1 = a;
    a = value(LL_gbEaccinit);
    w11 = a;
    a = cdr(w1);
    w3 = a;
    a = mkfxat(0);
    w12 = a;
    w2 = q;
   G4936:
    a = w12;
    a = Ladd1(a);
    w12 = a;
    w13 = nil;
    a = w3;
    w4 = a;
   G4937:
    a = car(car(w4));
    a = Lzerop(a);
    if(a == nil) goto    G4953;
    a = cdr(w4);
    w4 = a;
    if(a == nil) goto    G4945;
    goto    G4937;
   G4953:
    a = w4;
    w6 = a;
   G4939:
    a = w6;
    w5 = a;
    a = cdr(a);
    w6 = a;
    if(a == nil) goto    G4955;
    a = car(car(a));
    a = Lzerop(a);
    if(a == nil) goto    G4940;
    goto    G4939;
   G4955:
    a = w3;
    if(a != w4) goto    G4961;
    a = cdr(a);
    w3 = a;
    goto    G4945;
   G4961:
    q = w4;
    a = CC_before(a, q);
    w18 = a;
    q = cdr(w4);
    cdr(a) = q;
    goto    G4945;
   G4940:
    a = car(w4);
    w7 = a;
    a = car(a);
    a = Lbefloat_value(a);
    w16 = a;
    a = car(w6);
    w9 = a;
    a = car(a);
    a = Lbefloat_value(a);
    w17 = a;
    q = w16;
    a = q;
    a = times2(a, q);
    w19 = a;
    q = w17;
    a = q;
    a = times2(a, q);
    q = a;
    a = w19;
    a = plus2(a, q);
    a = Lsqrt(a);
    w18 = a;
    q = a;
    a = w16;
    a = quot2(a, q);
    w15 = a;
    q = w18;
    a = w17;
    a = quot2(a, q);
    w14 = a;
    a = w7;
    w8 = a;
    a = w9;
    w10 = a;
    a = true;
    w13 = a;
   G4941:
    a = car(w8);
    w16 = a;
    a = car(w10);
    w17 = a;
    a = w16;
    a = Lzerop(a);
    if(a == nil) goto    G4967;
    a = w17;
    a = Lzerop(a);
    if(a != nil) goto    G4979;
   G4967:
    q = w14;
    a = w16;
    a = times2(a, q);
    w19 = a;
    q = w15;
    a = w17;
    a = times2(a, q);
    a = Lminus(a);
    q = a;
    a = w19;
    a = plus2(a, q);
    w18 = a;
    q = w11;
    a = CC_acczerop(a, q);
    if(a == nil) goto    G4973;
    q = LITERAL[7];
    goto    G5014;
   G4973:
    q = w18;
   G5014:
    a = w8;
    car(a) = q;
    q = w14;
    a = w17;
    a = times2(a, q);
    w19 = a;
    q = w15;
    a = w16;
    a = times2(a, q);
    q = a;
    a = w19;
    a = plus2(a, q);
    w18 = a;
    q = w11;
    a = CC_acczerop(a, q);
    if(a == nil) goto    G4978;
    q = LITERAL[7];
    goto    G5015;
   G4978:
    q = w18;
   G5015:
    a = w10;
    car(a) = q;
   G4979:
    a = cdr(w8);
    w8 = a;
    a = cdr(w10);
    w10 = a;
    a = w8;
    if(a != nil) goto    G4941;
    a = w7;
    a = CC_Wzerolist(a);
    if(a == nil) goto    G4986;
    a = w3;
    if(a != w4) goto    G4985;
    a = cdr(a);
    w3 = a;
    goto    G4986;
   G4985:
    q = w4;
    a = CC_before(a, q);
    w18 = a;
    q = cdr(w4);
    cdr(a) = q;
   G4986:
    a = w5;
    w4 = a;
    a = w6;
    w6 = a;
   G4944:
    a = w6;
    w5 = a;
    a = cdr(a);
    w6 = a;
    if(a == nil) goto    G4988;
    a = car(car(a));
    a = Lzerop(a);
    if(a != nil) goto    G4944;
    a = cdr(w4);
    w4 = a;
    goto    G4940;
   G4988:
    q = cdr(cdr(w4));
    a = w4;
    cdr(a) = q;
   G4945:
    a = w3;
    a = CC_listcdr(a);
    w3 = a;
    Lterpri();
    a = LITERAL[360];
    Lprinc(a);
    a = w3;
    a = Llength(a);
    Lprint(a);
    a = LITERAL[361];
    Lprinc(a);
    a = car(w3);
    a = Llength(a);
    Lprint(a);
    q = w2;
    a = w12;
    a = Lgeq(a, q);
    if(a != nil) goto    G4998;
    a = cdr(w3);
    if(a != nil) goto    G4936;
   G4998:
    a = w3;
    w6 = a;
    w19 = nil;
   G5000:
    a = car(car(w6));
    a = Lzerop(a);
    if(a == nil) goto    G4999;
    a = cdr(w6);
    w6 = a;
    w19 = a;
    goto    G5000;
   G4999:
    q = w2;
    a = car(w1);
    a = CC_ncdr(a, q);
    w7 = a;
    a = car(w6);
    w9 = a;
    a = value(LL_gbEorder);
    a = Lncons(a);
    w6 = a;
    w5 = a;
    a = car(w9);
    w14 = a;
    a = Lzerop(a);
    if(a == nil) goto    G5004;
    a = mkfxat(0);
    goto    G4935;
   G5004:
    a = w7;
    w8 = a;
    a = w9;
    w10 = a;
   G4947:
    a = car(w10);
    w17 = a;
    a = Lzerop(a);
    if(a != nil) goto    G4948;
    q = w14;
    a = w17;
    a = quot2(a, q);
    q = car(w8);
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
   G4948:
    a = cdr(w8);
    w8 = a;
    a = cdr(w10);
    w10 = a;
    a = w8;
    if(a != nil) goto    G4947;
    a = w5;
   G4935:
    popv(19);
    return a;
}

Sex CC_gbEABwsRedrest(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(cdr(a));
    if(a == nil) goto    G5032;
    w2 = nil;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    a = cdr(w1);
    w2 = a;
   G5022:
    a = car(w2);
    w5 = a;
    a = cdr(cdr(a));
    w6 = a;
    a = cdr(w2);
    w3 = a;
   G5023:
    a = car(w3);
    w7 = a;
    a = cdr(cdr(a));
    w8 = a;
    q = w6;
    a = CC_gbEMredrest(a, q);
    w4 = a;
    if(a == LL_same) goto    G5024;
    a = CC_gbErnorm(a);
    q = a;
    a = cdr(car(w7));
    car(a) = q;
    q = w4;
    a = cdr(w7);
    cdr(a) = q;
   G5024:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G5023;
    a = cdr(w2);
    w2 = a;
    a = cdr(a);
    if(a != nil) goto    G5022;
   G5032:
    a = w1;
    popv(8);
    return a;
}

Sex CC_gbEMredrest(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 11;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(cdr(a));
    if(a == nil) goto    G5071;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w2 = q;
    a = car(cdr(w1));
    a = Lncons(a);
    w4 = a;
    q = car(w1);
    a = Lxcons(a, q);
    w3 = a;
    q = cdr(cdr(w1));
    a = car(w1);
    a = cons(a, q);
    w1 = a;
    a = car(cdr(w2));
    w10 = a;
    a = car(a);
    w7 = a;
    a = cdr(w10);
    w8 = a;
    a = cdr(cdr(w2));
    if(a == nil) goto    G5046;
    q = car(w2);
    a = Lxcons(a, q);
   G5046:
    w2 = a;
   G5040:
    a = car(cdr(w1));
    w5 = a;
    a = car(a);
    w6 = a;
    m = value(LL_gbEorder);
    q = w7;
    a = CC_gbEirred(a, q, m);
    if(a != nil) goto    G5066;
    m = value(LL_gbEorder);
    q = w7;
    a = w6;
    a = CC_gbEredchk(a, q, m);
    w9 = a;
    if(a != LL_no) goto    G5050;
    a = w5;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(cdr(w1));
    w1 = a;
    if(a != nil) goto    G5058;
    goto    G5066;
   G5050:
    a = true;
    w11 = a;
    a = w2;
    if(a != nil) goto    G5056;
    a = cdr(cdr(w1));
    w1 = a;
    if(a == nil) goto    G5066;
   G5058:
    q = car(w3);
    a = Lxcons(a, q);
    w1 = a;
    goto    G5040;
   G5056:
    q = cdr(cdr(w1));
    a = car(w1);
    a = cons(a, q);
    w1 = a;
    q = w8;
    a = cdr(w5);
    a = quot2(a, q);
    a = Lminus(a);
    w10 = a;
    a = cdr(w1);
    m = w2;
    q = w10;
    if(a != nil) goto    G5061;
    a = w9;
    a = CC_gbEtermHdist(a, q, m);
    goto    G5062;
   G5061:
    a = w9;
    a = CC_gbEtermHdist(a, q, m);
    q = a;
    a = w1;
    a = CC_gbEdistLdist(a, q);
   G5062:
    w1 = a;
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G5040;
   G5066:
    a = w11;
    if(a != nil) goto    G5068;
   G5071:
    a = LL_same;
    goto    G5038;
   G5068:
    a = w1;
    a = CC_Wlist(a);
    if(a == nil) goto    G5070;
    q = cdr(w1);
    a = w4;
    cdr(a) = q;
   G5070:
    a = w3;
   G5038:
    popv(11);
    return a;
}

Sex CC_gbEwset2Mwset(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
#define LL_MWset LITERAL[362]
    a = LL_MWset;
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G5076:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G5077;
    a = car(a);
    w8 = a;
    a = car(car(cdr(a)));
    w6 = a;
    a = cdr(cdr(w8));
    m = nil;
    q = w6;
    a = CC_gbEMnormalz(a, q, m);
    w5 = a;
    arg4 = w2;
    m = w6;
    q = nil;
    a = CC_gbEMmkwprep(a, q, m, arg4);
    w8 = a;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G5076;
   G5077:
    a = w3;
    popv(8);
    return a;
}

Sex CC_gbEMinswset(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w1 = a;
    a = q;
    w4 = a;
    a = car(car(w1));
    w3 = a;
    w2 = q;
   G5085:
    a = cdr(w4);
    w5 = a;
    if(a != nil) goto    G5088;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    {
        popv(5);
        return cdr(a);
    }
   G5088:
    m = value(LL_gbEorder);
    q = car(car(car(a)));
    a = w3;
    a = CC_gbEordS(a, q, m);
    if(a == nil) goto    G5092;
    a = cdr(w4);
    w4 = a;
    goto    G5085;
   G5092:
    q = w5;
    a = w1;
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w4);
    popv(5);
    return a;
}

Sex CC_AhprGroeb(Sex a, Sex q)
{
    Sex m, arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 13;
    w13 = nil;
    w12 = nil;
    w11 = nil;
    w8 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w9 = nil;
    w10 = nil;
    w1 = a;
#define LL_RedSub LITERAL[363]
    a = LL_RedSub;
#define LL_gbEstrtgy LITERAL[364]
    value(LL_gbEstrtgy) = a;
    w2 = q;
    a = w1;
    a = CC_gbEcoeftype(a);
    if(a == LL_AF) goto    G5110;
    if(a == LL_AC) goto    G5110;
    if(a == LL_AQ) goto    G5110;
    if(a == LL_AZ) goto    G5110;
    q = nil;
    a = LITERAL[203];
    CC_errormsg(a, q);
   G5110:
    a = w1;
    a = Lcopy(a);
    w3 = a;
    a = mkfxat(30);
    value(LL_gbEFprec) = a;
   G5101:
    q = value(LL_gbEFprec);
    a = LL_prec;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = w1;
    a = CC_Acoef2befloat(a);
    w1 = a;
    a = LL_float;
    value(LL_gbEcoftype) = a;
    a = LL_plus2;
    value(LL_gbEadd) = a;
    a = LL_times2;
    value(LL_gbEmult) = a;
    a = LL_minus;
    value(LL_gbEneg) = a;
    a = LL_quotient;
    value(LL_gbEquoti) = a;
    value(LL_gbEgcd) = nil;
    m = LL_hpr;
    q = w2;
    a = w1;
    a = CC_gbEinitialz(a, q, m);
    w12 = a;
    a = cdr(a);
    w5 = a;
    a = Llast(a);
    w8 = a;
    a = w5;
    a = Lcopy(a);
#define LL_selfreds LITERAL[365]
    q = LL_selfreds;
    car(a) = q;
    w11 = a;
#define LL_gbESRlist LITERAL[366]
    value(LL_gbESRlist) = a;
    w13 = nil;
   G5115:
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G5114;
    q = LITERAL[160];
    a = car(a);
    a = cons(a, q);
    q = a;
    a = w11;
    car(a) = q;
    w13 = a;
    goto    G5115;
   G5114:
    q = w5;
    a = car(w12);
    a = CC_gbEpreWset2Fwset(a, q);
    w4 = a;
#define LL_clones LITERAL[367]
    a = LL_clones;
    a = Lncons(a);
    value(LL_gbEclones) = a;
    m = w5;
    q = cdr(w4);
    a = w4;
    a = CC_gbEHreduce(a, q, m);
    w12 = a;
#define LL_PrecShortage LITERAL[368]
    if(a == LL_PrecShortage) goto    G5104;
    if(a == LL_stop) goto    G5105;
   G5122:
    m = w8;
    q = w5;
    a = w4;
    a = CC_gbEHspol(a, q, m);
    w7 = a;
    if(a == LL_PrecShortage) goto    G5104;
    if(a == LL_end) goto    G5105;
    a = car(a);
    a = CC_gbEstop(a);
    if(a != nil) goto    G5105;
    m = w5;
    q = w7;
    a = w4;
    a = CC_gbEHreduce(a, q, m);
    w12 = a;
    if(a == LL_PrecShortage) goto    G5104;
    if(a == LL_stop) goto    G5105;
    a = w8;
    a = Ladd1(a);
    w8 = a;
    goto    G5122;
   G5104:
    Lterpri();
    Lterpri();
    a = LITERAL[323];
    Lprinc(a);
    a = LITERAL[324];
    Lprinc(a);
    Lterpri();
    Lterpri();
    q = value(LL_gbEFprec);
    a = mkfxat(2);
    a = times2(a, q);
    value(LL_gbEFprec) = a;
    a = w3;
    a = Lcopy(a);
    w1 = a;
    goto    G5101;
   G5105:
    a = value(LL_Htracmode);
    if(a == LL_untrac) goto    G5137;
    Lterpri();
    Lterpri();
    a = LITERAL[53];
    Lprinc(a);
    a = car(cdr(w4));
    a = Lonep(a);
    if(a == nil) goto    G5135;
    a = LITERAL[369];
    Lprinc(a);
    Lterpri();
    q = mkfxat(1);
    a = LL_Bset;
    {
        popv(13);
        return  Llist2(a, q);
    }
   G5135:
    Lterpri();
    a = w4;
    w7 = a;
    w13 = nil;
   G5138:
    a = cdr(w7);
    w7 = a;
    if(a == nil) goto    G5137;
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = car(car(cdr(car(w7))));
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    a = cdr(cdr(car(w7)));
    w12 = a;
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    CC_gbEprint(a, q, m, arg4, arg5);
    a = Lterpri();
    w13 = a;
    goto    G5138;
   G5137:
    a = value(LL_gbEstrtgy);
#define LL_Syzygy LITERAL[370]
    if(a != LL_Syzygy) goto    G5142;
    a = w4;
    CC_gbEFcalMCIC(a);
    goto    G5143;
   G5142:
    a = w4;
    CC_gbEFcalSRIC(a);
   G5143:
    q = LL_Anil;
    a = LL_prec;
    a = Llist2(a, q);
    a = Lncons(a);
    q = true;
    CC_Adeclare(a, q);
    a = w4;
    a = CC_gbEwset2polyset(a);
    w6 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G5147;
    a = w4;
    a = CC_gbEsyzy2polyset(a);
    value(LL_Hbyproduct) = a;
   G5147:
    a = w6;
    popv(13);
    return a;
}

Sex CC_gbEFnormalz(Sex a, Sex q, Sex m)
{
    Sex arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w4 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    a = CC_gbEhc(a);
    w4 = a;
    a = CC_ONEp(a);
    if(a != nil) goto    G5155;
    q = w4;
    a = mkfxat(1);
    a = quot2(a, q);
    w4 = a;
    q = w1;
    a = CC_gbEnumHdist(a, q);
    w1 = a;
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G5155;
    arg4 = nil;
    m = w4;
    q = w2;
    a = LL_nmlz;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G5155:
    a = w3;
    if(a == nil) goto    G5159;
    a = w1;
    a = CC_gbErnorm(a);
    q = a;
    a = cdr(w3);
    car(a) = q;
   G5159:
    a = w1;
    popv(4);
    return a;
}

Sex CC_gbEHnormalz(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    a = CC_gbEhc(a);
    w3 = a;
    a = CC_ONEp(a);
    if(a != nil) goto    G5166;
    q = w3;
    a = mkfxat(1);
    a = quot2(a, q);
    w3 = a;
    q = w1;
    a = CC_gbEnumHdist(a, q);
    w1 = a;
    q = w3;
    a = w2;
    CC_gbEFclonupdate(a, q);
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G5166;
    arg4 = nil;
    m = w3;
    q = w2;
    a = LL_nmlz;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G5166:
    a = w1;
    popv(3);
    return a;
}

Sex CC_gbEFmkwprep(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 6;
    w6 = nil;
    w5 = nil;
    w1 = a;
    a = cdr(arg4);
    w4 = a;
    w2 = q;
    w3 = m;
    a = Lcopy(a);
    q = w3;
    a = Lxcons(a, q);
    w5 = a;
    q = a;
    a = w3;
    CC_seTdelete(a, q);
    a = w2;
    if(a != nil) goto    G5173;
    a = w1;
    a = CC_gbErnorm(a);
    a = Lncons(a);
    w2 = a;
   G5173:
    a = w1;
    a = CC_gbEhex(a);
    q = w2;
    a = cons(a, q);
    w6 = a;
    q = w1;
    a = w5;
    a = cons(a, q);
    q = w6;
    {
        popv(6);
        return  Lxcons(a, q);
    }
}

Sex CC_gbEwset2Fwset(Sex a, Sex q)
{
    Sex m, arg4;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
#define LL_FWset LITERAL[371]
    a = LL_FWset;
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G5182:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G5183;
    a = car(a);
    w8 = a;
    a = car(car(cdr(a)));
    w6 = a;
    a = cdr(cdr(w8));
    m = nil;
    q = w6;
    a = CC_gbEFnormalz(a, q, m);
    w5 = a;
    arg4 = w2;
    m = w6;
    q = nil;
    a = CC_gbEFmkwprep(a, q, m, arg4);
    w8 = a;
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G5182;
   G5183:
    a = w3;
    popv(8);
    return a;
}

Sex CC_gbEpreWset2Fwset(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w4 = nil;
    w3 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w1 = a;
    w2 = q;
    a = LL_FWset;
    a = Lncons(a);
    w4 = a;
    w3 = a;
   G5191:
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G5192;
    a = car(a);
    w8 = a;
    a = car(car(cdr(a)));
    w6 = a;
    a = cdr(cdr(w8));
    q = w6;
    a = CC_gbEHnormalz(a, q);
    w5 = a;
    a = CC_gbErnorm(a);
    w7 = a;
    q = w5;
    a = cdr(w8);
    cdr(a) = q;
    q = w7;
    a = car(w8);
    a = cons(a, q);
    q = a;
    a = w8;
    car(a) = q;
    q = w3;
    a = w8;
    CC_gbEHinswset(a, q);
    goto    G5191;
   G5192:
    a = w3;
    popv(8);
    return a;
}

Sex CC_gbEHinswset(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 7;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w1 = a;
    w2 = q;
    a = cdr(q);
    if(a != nil) goto    G5203;
    a = w1;
    a = Lncons(a);
    q = a;
    a = w2;
    cdr(a) = q;
    {
        popv(7);
        return cdr(a);
    }
   G5203:
    a = q;
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(a == nil) goto    G5222;
    a = car(car(w1));
    w3 = a;
    a = cdr(car(w1));
    w6 = a;
    a = value(LL_gbEstrtgy);
#define LL_AbLate LITERAL[372]
    if(a == LL_AbLate) goto    G5215;
    if(a == LL_RedSub) goto    G5200;
    if(a == LL_Syzygy) goto    G5200;
   G5215:
    a = cdr(car(car(w5)));
    w7 = a;
    q = a;
    a = w6;
    a = Llessp(a, q);
    if(a != nil) goto    G5222;
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(a == nil) goto    G5222;
    goto    G5215;
   G5200:
    m = value(LL_gbEorder);
    q = car(car(car(w5)));
    a = w3;
    a = CC_gbEirred(a, q, m);
    if(a != nil) goto    G5222;
    a = w5;
    w4 = a;
    a = cdr(a);
    w5 = a;
    if(a != nil) goto    G5200;
   G5222:
    q = w5;
    a = w1;
    a = cons(a, q);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(w4);
    popv(7);
    return a;
}

Sex CC_gbEHspol(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5, arg6, arg7, arg8;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w4 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w1 = a;
    a = cdr(a);
    w5 = a;
    w2 = q;
    w3 = m;
    if(a == nil) goto    G5275;
   G5236:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G5238;
   G5275:
    a = LL_end;
    goto    G5227;
   G5238:
    a = car(a);
    w14 = a;
    a = cdr(w1);
    w4 = a;
    a = car(cdr(w14));
    w9 = a;
    a = car(w14);
    w11 = a;
    a = cdr(cdr(w14));
    w7 = a;
   G5229:
    a = car(w4);
    w14 = a;
    a = car(cdr(a));
    w8 = a;
    a = car(w14);
    w10 = a;
    a = cdr(cdr(w14));
    w6 = a;
    q = w9;
    a = car(w8);
    a = Lmemq(a, q);
    if(a == nil) goto    G5245;
    q = w9;
    a = car(w8);
    CC_seTdelete(a, q);
    q = w8;
    a = car(w9);
    CC_seTdelete(a, q);
    arg4 = nil;
    m = value(LL_gbEorder);
    q = car(w11);
    a = car(w10);
    a = CC_gbEgcdchk(a, q, m, arg4);
    w14 = a;
    q = LL_yes;
    a = Lneq(a, q);
    if(a != nil) goto    G5233;
    a = LITERAL[91];
    goto    G5277;
   G5243:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5245;
    Lterpri();
    a = LITERAL[336];
    Lprinc(a);
    a = car(w8);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w9);
    Lprin(a);
    a = LITERAL[94];
    Lprinc(a);
    a = w13;
    Lprinc(a);
    Lterpri();
   G5245:
    a = cdr(w4);
    w4 = a;
    q = w5;
    a = Lneq(a, q);
    if(a == nil) goto    G5236;
    goto    G5229;
   G5233:
    arg8 = car(w9);
    arg7 = car(w8);
    arg6 = w3;
    arg5 = cdr(w11);
    arg4 = cdr(w10);
    m = w14;
    q = w7;
    a = w6;
    a = CC_gbEHmkspol(a, q, m, arg4, arg5, arg6, arg7, arg8);
    w12 = a;
    if(a == LL_PrecShortage) goto    G5227;
    a = Lzerop(a);
    if(a == nil) goto    G5251;
    a = LITERAL[102];
    goto    G5277;
   G5251:
    a = w3;
    a = Ladd1(a);
    q = a;
    a = w12;
    a = CC_gbEHnormalz(a, q);
    w12 = a;
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G5254;
    Lterpri();
    a = LITERAL[98];
    Lprinc(a);
    a = car(w8);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w9);
    Lprin(a);
    a = LITERAL[99];
    Lprinc(a);
    Lterpri();
    a = LITERAL[100];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w12;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    a = w12;
    a = CC_gbEaccMinMax(a);
    w14 = a;
    a = LITERAL[330];
    Lprinc(a);
    a = car(w14);
    Lprin(a);
    a = LITERAL[331];
    Lprinc(a);
    a = cdr(w14);
    Lprin(a);
    a = LITERAL[298];
    Lprinc(a);
    Lterpri();
   G5254:
    a = w12;
    a = CC_gbEhex(a);
    w15 = a;
    a = w12;
    a = CC_gbErnorm(a);
    q = w15;
    a = Lxcons(a, q);
    w14 = a;
    a = w3;
    a = Ladd1(a);
    a = Lncons(a);
    arg4 = a;
    m = w14;
    q = w1;
    a = w12;
    a = CC_gbEHredpol(a, q, m, arg4);
    w13 = a;
    if(a == LL_PrecShortage) goto    G5227;
    if(a == LL_same) goto    G5267;
    a = Lzerop(a);
    if(a == nil) goto    G5263;
    a = LITERAL[102];
   G5277:
    w13 = a;
    goto    G5243;
   G5263:
    a = w13;
    a = Lonep(a);
    if(a == nil) goto    G5264;
    Lterpri();
    Lterpri();
    a = LITERAL[373];
    Lprinc(a);
    a = car(w8);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w9);
    Lprin(a);
    Lterpri();
    a = mkfxat(1);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    a = LL_stop;
    goto    G5227;
   G5264:
    a = cdr(w13);
    w12 = a;
    a = car(w13);
    w13 = a;
   G5267:
    a = w3;
    a = Ladd1(a);
    w3 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5269;
    Lterpri();
    Lterpri();
    a = LITERAL[104];
    Lprinc(a);
    a = car(w8);
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = car(w9);
    Lprin(a);
    a = LITERAL[105];
    Lprinc(a);
    Lterpri();
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w12;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    a = w12;
    a = CC_gbEaccMinMax(a);
    w14 = a;
    a = LITERAL[330];
    Lprinc(a);
    a = car(w14);
    Lprin(a);
    a = LITERAL[331];
    Lprinc(a);
    a = cdr(w14);
    Lprin(a);
    a = LITERAL[298];
    Lprinc(a);
    Lterpri();
   G5269:
    a = w2;
    a = CC_tail(a);
    w15 = a;
    a = w3;
    a = Lncons(a);
    q = a;
    a = w15;
    cdr(a) = q;
    a = cdr(a);
    q = w1;
    a = w3;
    CC_gbEinsunpC(a, q);
    a = w12;
    a = CC_gbErnorm(a);
    arg4 = w2;
    m = w3;
    q = a;
    a = w12;
    a = CC_gbEFmkwprep(a, q, m, arg4);
    w14 = a;
    q = w1;
    a = CC_gbEHinswset(a, q);
   G5227:
    popv(15);
    return a;
}

Sex CC_gbEHmkspol(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6, Sex arg7, Sex arg8)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 17;
    w17 = nil;
    w16 = nil;
    w11 = nil;
    w10 = nil;
    w9 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    w7 = arg7;
    w8 = arg8;
    a = CC_gbErest(a);
    w10 = a;
    a = w2;
    a = CC_gbErest(a);
    w11 = a;
    a = w10;
    a = Lzerop(a);
    if(a == nil) goto    G5289;
    a = w11;
    a = Lzerop(a);
    if(a != nil) goto    G5351;
    m = w11;
    q = mkfxat(-1);
    a = cdr(w3);
    goto    G5352;
   G5289:
    a = w11;
    a = Lzerop(a);
    m = w10;
    q = mkfxat(1);
    if(a == nil) goto    G5293;
    a = car(w3);
   G5352:
    a = CC_gbEtermHdist(a, q, m);
    w9 = a;
    goto    G5287;
   G5293:
    a = car(w3);
    a = CC_gbEtermHdist(a, q, m);
    w10 = a;
    m = w11;
    q = mkfxat(-1);
    a = cdr(w3);
    a = CC_gbEtermHdist(a, q, m);
    w11 = a;
    a = value(LL_gbEstrtgy);
    if(a != LL_Syzygy) goto    G5295;
    q = w11;
    a = w10;
    a = CC_gbEdistLdist(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a == nil) goto    G5287;
    goto    G5342;
   G5295:
    arg4 = w11;
    m = w10;
    q = w8;
    a = w7;
    a = CC_gbEFchkselfred(a, q, m, arg4);
    w14 = a;
    if(a == nil) goto    G5300;
    q = LL_sttrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5300;
    Lterpri();
    a = LITERAL[98];
    Lprinc(a);
    a = w7;
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = w8;
    Lprin(a);
    a = LITERAL[374];
    Lprinc(a);
    a = LITERAL[375];
    Lprinc(a);
    Lterpri();
   G5300:
    a = w14;
    if(a == nil) goto    G5303;
    q = w8;
    a = w7;
    a = cons(a, q);
    value(LL_Htemporal) = a;
    arg6 = cdr(w14);
    arg5 = car(w14);
    arg4 = w5;
    m = w4;
    q = w11;
    a = w10;
    a = CC_gbEFsubtrredcer(a, q, m, arg4, arg5, arg6);
    w14 = a;
    a = w6;
    a = Ladd1(a);
    arg4 = value(LL_Htemporal);
    m = w8;
    q = w7;
    a = CC_gbEFSRupdate(a, q, m, arg4);
    w15 = a;
    if(a == LL_PrecShortage) goto    G5280;
    a = car(w14);
    w10 = a;
    a = CC_gbEnorm(a);
    a = Lfloat(a);
    w4 = a;
    a = cdr(w14);
    w11 = a;
    a = CC_gbEnorm(a);
    a = Lfloat(a);
    w5 = a;
   G5303:
    q = w11;
    a = w10;
    a = CC_gbEdistLdist(a, q);
    w9 = a;
    a = Lzerop(a);
    if(a != nil) goto    G5342;
    arg4 = w8;
    m = nil;
    q = w5;
    a = w4;
    a = CC_gbEFchkclone(a, q, m, arg4);
    if(a == nil) goto    G5312;
    q = w11;
    a = mkfxat(-1);
    a = cons(a, q);
    q = w8;
    a = Lxcons(a, q);
    w14 = a;
    a = w6;
    a = Ladd1(a);
    q = w14;
    CC_gbEFaddclone(a, q);
    a = w8;
    goto    G5353;
   G5312:
    arg4 = w7;
    m = nil;
    q = w4;
    a = w5;
    a = CC_gbEFchkclone(a, q, m, arg4);
    if(a == nil) goto    G5287;
    q = w10;
    a = mkfxat(1);
    a = cons(a, q);
    q = w7;
    a = Lxcons(a, q);
    w14 = a;
    a = w6;
    a = Ladd1(a);
    q = w14;
    CC_gbEFaddclone(a, q);
    a = w7;
   G5353:
    w14 = a;
    arg4 = w8;
    m = nil;
    q = w5;
    a = w4;
    a = CC_gbEFchkclone(a, q, m, arg4);
    w14 = a;
    if(a == nil) goto    G5284;
#define LL_clone LITERAL[376]
    if(a != LL_clone) goto    G5322;
    q = w11;
    a = mkfxat(-1);
    a = cons(a, q);
    q = w8;
    goto    G5354;
   G5322:
    a = w8;
    a = Lminus(a);
    w16 = a;
    q = w11;
    a = mkfxat(-1);
    a = cons(a, q);
    q = w16;
   G5354:
    a = Lxcons(a, q);
    w14 = a;
    a = w6;
    a = Ladd1(a);
    q = w14;
    CC_gbEFaddclone(a, q);
    a = car(w14);
    a = Lminusp(a);
    if(a != nil) goto    G5342;
    a = w8;
    w14 = a;
    goto    G5285;
   G5284:
    arg4 = w7;
    m = nil;
    q = w4;
    a = w5;
    a = CC_gbEFchkclone(a, q, m, arg4);
    w14 = a;
    if(a == nil) goto    G5287;
    if(a != LL_clone) goto    G5333;
    q = w10;
    a = mkfxat(1);
    a = cons(a, q);
    q = w7;
    goto    G5355;
   G5333:
    a = w7;
    a = Lminus(a);
    w16 = a;
    q = w10;
    a = mkfxat(1);
    a = cons(a, q);
    q = w16;
   G5355:
    a = Lxcons(a, q);
    w14 = a;
    a = w6;
    a = Ladd1(a);
    q = w14;
    CC_gbEFaddclone(a, q);
    a = car(w14);
    a = Lminusp(a);
    if(a != nil) goto    G5342;
    a = w7;
    w14 = a;
   G5285:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a != nil) goto    G5356;
   G5342:
    a = w6;
    a = Ladd1(a);
    CC_gbEsyzyclear(a);
   G5351:
    a = mkfxat(0);
    goto    G5280;
   G5356:
    Lterpri();
    a = LITERAL[377];
    Lprinc(a);
    a = w14;
    Lprin(a);
    a = LITERAL[378];
    Lprinc(a);
    Lterpri();
   G5287:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G5345;
    a = w6;
    a = Ladd1(a);
    w16 = a;
    q = mkfxat(1);
    a = car(w3);
    a = cons(a, q);
    q = w7;
    a = Lxcons(a, q);
    w17 = a;
    q = mkfxat(-1);
    a = cdr(w3);
    a = cons(a, q);
    q = w8;
    a = Lxcons(a, q);
    arg4 = a;
    m = w17;
    q = w16;
    a = LL_spol;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G5345:
    a = w9;
   G5280:
    popv(17);
    return a;
}

Sex CC_gbEHreduce(Sex a, Sex q, Sex m)
{
    Sex arg4, arg5;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w9 = nil;
    w8 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w4 = nil;
    w3 = nil;
    w2 = nil;
    w1 = a;
    a = cdr(q);
    if(a == nil) goto    G5393;
    w4 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    a = q;
    w5 = a;
    w2 = q;
    w3 = m;
    a = value(LL_gbEstrtgy);
    if(a != LL_AbLate) goto    G5368;
    a = cdr(w1);
    goto    G5394;
   G5368:
    a = cdr(w5);
    if(a != nil) goto    G5370;
   G5393:
    a = w1;
    goto    G5361;
   G5370:
    a = car(a);
    w4 = a;
    a = car(car(cdr(a)));
    w9 = a;
    arg4 = a;
    m = car(w4);
    q = w1;
    a = cdr(cdr(w4));
    a = CC_gbEHredpol(a, q, m, arg4);
    w10 = a;
    if(a == LL_PrecShortage) goto    G5361;
    if(a == LL_same) goto    G5364;
    q = cdr(cdr(w5));
    a = w5;
    cdr(a) = q;
    a = w10;
    a = Lzerop(a);
    if(a != nil) goto    G5365;
    a = w10;
    a = Lonep(a);
    if(a == nil) goto    G5378;
    Lterpri();
    a = LITERAL[54];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = LITERAL[50];
    Lprinc(a);
    Lterpri();
    a = mkfxat(1);
    a = Lncons(a);
    q = a;
    a = w1;
    cdr(a) = q;
    a = cdr(a);
    goto    G5395;
   G5364:
    a = cdr(w5);
   G5394:
    w5 = a;
    goto    G5368;
   G5365:
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5382;
    Lterpri();
    a = LITERAL[107];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = LITERAL[379];
    Lprinc(a);
    Lterpri();
   G5382:
    q = w3;
    a = w9;
    CC_seTdelete(a, q);
    q = w1;
    a = w9;
    CC_gbEdelunpC(a, q);
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G5368;
    a = w9;
    CC_gbEsyzyclear(a);
    goto    G5368;
   G5378:
    a = cdr(w10);
    w6 = a;
    a = cdr(car(w10));
    w8 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5386;
    Lterpri();
    Lterpri();
    a = LITERAL[88];
    Lprinc(a);
    a = w9;
    Lprin(a);
    a = LITERAL[329];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w6;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G5386:
    arg4 = w3;
    m = w9;
    q = w8;
    a = w6;
    a = CC_gbEFmkwprep(a, q, m, arg4);
    w4 = a;
    q = w1;
    a = w9;
    CC_gbEinsunpC(a, q);
    q = w1;
    a = w4;
    a = CC_gbEHinswset(a, q);
    w5 = a;
    m = value(LL_gbEorder);
    q = car(car(car(w2)));
    a = car(car(car(a)));
    a = CC_gbEirred(a, q, m);
    if(a == nil) goto    G5388;
    a = w5;
    w2 = a;
   G5388:
    a = value(LL_gbEstrtgy);
    if(a != LL_AbLate) goto    G5390;
    a = cdr(w1);
    w2 = a;
    w5 = a;
   G5390:
    a = w4;
    a = CC_gbEstop(a);
    if(a == nil) goto    G5368;
   G5395:
    a = LL_stop;
   G5361:
    popv(10);
    return a;
}

Sex CC_gbEHredpol(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex arg5, arg6, arg7;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 14;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w1 = a;
    a = cdr(q);
    w5 = a;
    a = w1;
    w6 = a;
    a = car(m);
    w7 = a;
    a = cdr(m);
    w8 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
   G5399:
    a = cdr(cdr(car(w5)));
    w9 = a;
    if(a == w6) goto    G5402;
    a = cdr(car(car(w5)));
    w11 = a;
    a = car(car(cdr(car(w5))));
    w10 = a;
    a = w4;
    if(!is_cons(a)) goto    G5408;
    a = car(a);
   G5408:
    w13 = a;
    a = w9;
    a = CC_gbEhex(a);
    m = value(LL_gbEorder);
    q = a;
    a = w7;
    a = CC_gbEredchk(a, q, m);
    w12 = a;
    if(a == LL_no) goto    G5402;
    a = true;
    w14 = a;
    arg7 = w10;
    arg6 = w4;
    arg5 = w11;
    arg4 = w8;
    m = w12;
    q = w9;
    a = w1;
    a = CC_gbEHhred(a, q, m, arg4, arg5, arg6, arg7);
    w1 = a;
    if(a == LL_PrecShortage) goto    G5398;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5415;
    m = nil;
    q = car(car(cdr(car(w5))));
    a = w4;
    CC_gbEpriRedPbyQ(a, q, m);
   G5415:
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G5417;
    a = mkfxat(0);
    goto    G5398;
   G5417:
    a = car(car(cdr(w1)));
    a = CC_Wzerolist(a);
    if(a == nil) goto    G5418;
    a = mkfxat(1);
    goto    G5398;
   G5418:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G5420;
    Lterpri();
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w1;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    a = w1;
    a = CC_gbEaccMinMax(a);
    w13 = a;
    a = LITERAL[330];
    Lprinc(a);
    a = car(w13);
    Lprin(a);
    a = LITERAL[331];
    Lprinc(a);
    a = cdr(w13);
    Lprin(a);
    a = LITERAL[298];
    Lprinc(a);
    Lterpri();
   G5420:
    a = w1;
    a = CC_gbErnorm(a);
    w8 = a;
    a = w1;
    a = CC_gbEhex(a);
    w7 = a;
    q = w8;
    a = cons(a, q);
    w3 = a;
    a = cdr(w2);
    w5 = a;
    goto    G5399;
   G5402:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G5399;
    a = w14;
    if(a != nil) goto    G5424;
    a = LL_same;
    goto    G5398;
   G5424:
    q = w1;
    a = w3;
    a = cons(a, q);
   G5398:
    popv(14);
    return a;
}

Sex CC_gbEHhred(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6, Sex arg7)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 15;
    w15 = nil;
    w10 = nil;
    w8 = nil;
    w9 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    w7 = arg7;
    a = arg6;
    a = CC_Wlist(a);
    if(a == nil) goto    G5436;
    a = car(w6);
    w6 = a;
   G5436:
    a = w2;
    a = CC_gbErest(a);
    w10 = a;
    a = w2;
    a = CC_gbEhex(a);
    w8 = a;
   G5429:
    a = value(LL_gbEsyzygy);
    if(a == nil) goto    G5438;
    q = mkfxat(-1);
    a = w3;
    a = cons(a, q);
    q = a;
    a = car(w1);
    a = Llist2(a, q);
    w13 = a;
    q = w7;
    a = Lxcons(a, q);
    arg4 = a;
    m = nil;
    q = w6;
    a = LL_mred;
    CC_gbEsyzyupdate(a, q, m, arg4);
   G5438:
    a = w10;
    a = Lzerop(a);
    if(a == nil) goto    G5442;
    a = w1;
    a = CC_gbErest(a);
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G5449;
    goto    G5468;
   G5442:
    a = w1;
    a = CC_gbErest(a);
    w9 = a;
    m = w10;
    q = mkfxat(-1);
    a = w3;
    a = CC_gbEtermHdist(a, q, m);
    w11 = a;
    a = w9;
    a = Lzerop(a);
    if(a == nil) goto    G5446;
    a = w11;
    w1 = a;
    goto    G5468;
   G5446:
    a = value(LL_gbEstrtgy);
    if(a != LL_Syzygy) goto    G5447;
    q = w11;
    a = w9;
    a = CC_gbEdistLdist(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G5468;
   G5449:
    a = w6;
    CC_gbEsyzyclear(a);
    goto    G5478;
   G5447:
    arg4 = w11;
    m = w9;
    q = w7;
    a = w6;
    a = CC_gbEFchkselfred(a, q, m, arg4);
    w13 = a;
    if(a == nil) goto    G5451;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5451;
    Lterpri();
    a = LITERAL[380];
    Lprinc(a);
    a = w6;
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = w7;
    Lprin(a);
    a = LITERAL[374];
    Lprinc(a);
    a = LITERAL[375];
    Lprinc(a);
    Lterpri();
   G5451:
    q = w11;
    a = w9;
    a = CC_gbEdistLdist(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a != nil) goto    G5478;
    arg4 = w7;
    m = w6;
    q = w5;
    a = w4;
    a = CC_gbEFchkclone(a, q, m, arg4);
    w13 = a;
    if(a != nil) goto    G5456;
    a = w6;
    CC_gbEFdelclone(a);
    goto    G5468;
   G5456:
    if(a != LL_clone) goto    G5458;
    q = w11;
    a = mkfxat(1);
    a = cons(a, q);
    q = w7;
    goto    G5479;
   G5458:
    a = w7;
    a = Lminus(a);
    w15 = a;
    q = w11;
    a = mkfxat(1);
    a = cons(a, q);
    q = w15;
   G5479:
    a = Lxcons(a, q);
    q = a;
    a = w6;
    CC_gbEFaddclone(a, q);
    a = w13;
    if(is_number(a)) goto    G5468;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5468;
    Lterpri();
    a = LITERAL[107];
    Lprinc(a);
    a = w6;
    Lprin(a);
    a = LITERAL[381];
    Lprinc(a);
    a = w7;
    Lprin(a);
    a = LITERAL[382];
    Lprinc(a);
    Lterpri();
   G5468:
    q = value(LL_gbEaccinit);
    a = mkfxat(10);
    a = times2(a, q);
    q = a;
    a = w1;
    a = CC_gbEHdelErrTerm(a, q);
    w1 = a;
    a = Lzerop(a);
    if(a == nil) goto    G5471;
   G5478:
    a = mkfxat(0);
    goto    G5428;
   G5471:
    q = w6;
    a = w1;
    a = CC_gbEHnormalz(a, q);
    w1 = a;
    a = CC_gbEhex(a);
    m = value(LL_gbEorder);
    q = w8;
    a = CC_gbEredchk(a, q, m);
    w3 = a;
    if(a == LL_no) goto    G5434;
    a = w1;
    a = CC_gbErnorm(a);
    a = Lfloat(a);
    w4 = a;
    goto    G5429;
   G5434:
    a = w1;
   G5428:
    popv(15);
    return a;
}

Sex CC_gbEHdelErrTerm(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 8;
    w8 = nil;
    w3 = nil;
    w4 = nil;
    w7 = nil;
    w1 = a;
    a = cdr(a);
    w5 = a;
    w2 = q;
   G5483:
    a = cdr(car(w5));
    w6 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G5491;
    a = cdr(w6);
    w6 = a;
   G5491:
    a = w6;
    a = Lbefloat_error(a);
    q = a;
    a = value(LL_Hmachineps);
    a = quot2(a, q);
    w8 = a;
    a = w6;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    q = a;
    a = w8;
    a = times2(a, q);
    w6 = a;
    a = Labs(a);
    q = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G5498;
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G5483;
    a = w1;
    goto    G5482;
   G5498:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G5485;
    a = w7;
    if(a != nil) goto    G5503;
    Lterpri();
   G5503:
    a = true;
    w7 = a;
    a = LITERAL[14];
    Lprinc(a);
    a = cdr(car(w5));
    Lprint(a);
   G5485:
    a = car(w1);
    a = Lncons(a);
    w4 = a;
    w3 = a;
    a = cdr(w1);
    w1 = a;
   G5486:
    a = w1;
    if(a == w5) goto    G5525;
    a = car(a);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    a = cdr(w1);
    w1 = a;
    if(a == nil) goto    G5525;
    goto    G5486;
   G5488:
    a = cdr(car(w5));
    w6 = a;
    a = CC_Wlist(a);
    if(a == nil) goto    G5513;
    a = cdr(w6);
    w6 = a;
   G5513:
    a = w6;
    a = Lbefloat_error(a);
    q = a;
    a = value(LL_Hmachineps);
    a = quot2(a, q);
    w8 = a;
    a = w6;
    a = Lbefloat_value(a);
    a = Lfloat(a);
    q = a;
    a = w8;
    a = times2(a, q);
    w6 = a;
    a = Labs(a);
    q = w2;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G5520;
    a = car(w5);
    a = Lncons(a);
    q = a;
    a = w4;
    cdr(a) = q;
    a = cdr(a);
    w4 = a;
    goto    G5525;
   G5520:
    a = value(LL_Htracmode);
    if(a != LL_sttrac) goto    G5525;
    a = w7;
    if(a != nil) goto    G5527;
    Lterpri();
   G5527:
    a = true;
    w7 = a;
    a = LITERAL[14];
    Lprinc(a);
    a = cdr(car(w5));
    Lprint(a);
   G5525:
    a = cdr(w5);
    w5 = a;
    if(a != nil) goto    G5488;
    a = cdr(w3);
    if(a == nil) goto    G5531;
    a = w3;
    goto    G5482;
   G5531:
    a = mkfxat(0);
   G5482:
    popv(8);
    return a;
}

Sex CC_gbEFaddclone(Sex a, Sex q)
{
    Sex m;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 3;
    w3 = nil;
    w1 = a;
    w2 = q;
    q = value(LL_gbEclones);
    a = Lassoc(a, q);
    w3 = a;
    if(a == nil) goto    G5538;
    q = cdr(a);
    a = w2;
    a = cons(a, q);
    q = a;
    a = w3;
    cdr(a) = q;
    goto    G5540;
   G5538:
    q = w2;
    a = w1;
    a = Llist2(a, q);
    m = LL_lessp;
    q = value(LL_gbEclones);
    CC_seTinsertbycar(a, q, m);
   G5540:
    a = value(LL_gbEclones);
    popv(3);
    return a;
}

Sex CC_gbEFdelclone(Sex a)
{
    Sex q;
    a = Lncons(a);
    q = value(LL_gbEclones);
    {
        return  CC_seTdeletebycar(a, q);
    }
}

Sex CC_gbEFclonupdate(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w3 = nil;
    w4 = nil;
    w5 = nil;
    w1 = a;
    w2 = q;
    q = value(LL_gbEclones);
    a = Lassoc(a, q);
    w3 = a;
    if(a == nil) goto    G5547;
    a = cdr(a);
    w4 = a;
   G5551:
    a = car(cdr(car(w4)));
    w5 = a;
    q = a;
    a = w2;
    a = times2(a, q);
    q = a;
    a = cdr(car(w4));
    car(a) = q;
    a = cdr(w4);
    w4 = a;
    if(a != nil) goto    G5551;
    a = w3;
   G5547:
    popv(5);
    return a;
}

Sex CC_gbEFchkclone(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 5;
    w5 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = Lfloat(a);
    q = a;
    a = mkfxat(5);
    a = times2(a, q);
    w5 = a;
    a = w2;
    a = Lfloat(a);
    q = a;
    a = w5;
    a = Llessp(a, q);
    if(a == nil) goto    G5558;
    a = LL_clone;
    goto    G5563;
   G5558:
    a = w3;
    if(a == nil) goto    G5563;
    w5 = nil;
    q = value(LL_gbEclones);
    a = Lassoc(a, q);
    w5 = a;
    if(a == nil) goto    G5563;
    a = Llength(a);
    q = mkfxat(4);
    a = Llessp(a, q);
    if(a != nil) goto    G5584;
    a = cdr(w5);
    w5 = a;
    a = car(a);
    a = car(a);
    a = Lplusp(a);
    if(a != nil) goto    G5584;
    a = cdr(w5);
    w5 = a;
    a = car(a);
    a = car(a);
    a = Lplusp(a);
    if(a == nil) goto    G5563;
   G5584:
    a = w4;
    a = Lminus(a);
   G5563:
    popv(5);
    return a;
}

Sex CC_gbEFchkselfred(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 12;
    w12 = nil;
    w6 = nil;
    w5 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    q = value(LL_gbEclones);
    a = Lassoc(a, q);
    w5 = a;
    q = value(LL_gbEclones);
    a = w2;
    a = Lassoc(a, q);
    w6 = a;
    a = w5;
    if(a != nil) goto    G5595;
    a = w6;
    if(a == nil) goto    G5587;
   G5595:
    a = w5;
    if(a != nil) goto    G5640;
    a = w6;
    if(a == nil) goto    G5587;
    goto    G5628;
   G5640:
    a = w6;
    if(a == nil) goto    G5615;
    a = cdr(w5);
    w7 = a;
    a = cdr(w6);
    w8 = a;
   G5589:
    a = car(w7);
    w9 = a;
    a = car(w8);
    w10 = a;
    q = car(a);
    a = car(w9);
    a = Lequal(a, q);
    if(a == nil) goto    G5615;
    a = w9;
    a = Lcadddr(a);
    w12 = a;
    a = w10;
    a = Lcadddr(a);
    q = a;
    a = w12;
    a = Lequal(a, q);
    if(a == nil) goto    G5615;
    a = car(w9);
    a = Lplusp(a);
    if(a != nil) goto    G5612;
    a = car(w10);
    a = Lplusp(a);
    if(a == nil) goto    G5611;
   G5612:
    q = cdr(w6);
    a = cdr(w5);
    {
        popv(12);
        return  cons(a, q);
    }
   G5611:
    a = cdr(w7);
    w7 = a;
    a = cdr(w8);
    w8 = a;
    a = w7;
    if(a == nil) goto    G5615;
    a = w8;
    if(a != nil) goto    G5589;
   G5615:
    a = car(cdr(w5));
    w9 = a;
    q = w2;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G5592;
    a = car(cdr(w9));
    w11 = a;
    a = cdr(cdr(w9));
    a = CC_gbErest(a);
    w10 = a;
    a = Lzerop(a);
    if(a != nil) goto    G5592;
    a = w4;
    a = CC_gbEhex(a);
    q = w10;
    a = CC_gbEFchkhex(a, q);
    if(a == nil) goto    G5592;
    q = w10;
    a = w11;
    a = cons(a, q);
    q = w2;
    a = Lxcons(a, q);
    w10 = a;
    a = Lncons(a);
    w12 = a;
    a = w10;
    goto    G5639;
   G5592:
    a = w6;
    if(a == nil) goto    G5587;
   G5628:
    a = car(cdr(w6));
    w10 = a;
    q = w1;
    a = car(a);
    a = Lequal(a, q);
    if(a == nil) goto    G5587;
    a = car(cdr(w10));
    w11 = a;
    a = cdr(cdr(w10));
    a = CC_gbErest(a);
    w9 = a;
    a = Lzerop(a);
    if(a != nil) goto    G5633;
    a = w3;
    a = CC_gbEhex(a);
    q = w9;
    a = CC_gbEFchkhex(a, q);
    if(a != nil) goto    G5632;
   G5633:
    a = nil;
    goto    G5587;
   G5632:
    q = w9;
    a = w11;
    a = cons(a, q);
    q = w1;
    a = Lxcons(a, q);
    w9 = a;
    a = Lncons(a);
    w12 = a;
    a = w9;
   G5639:
    a = Lncons(a);
    q = w12;
    a = Lxcons(a, q);
   G5587:
    popv(12);
    return a;
}

Sex CC_gbEFchkhex(Sex a, Sex q)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 4;
    w1 = a;
    a = cdr(q);
    w3 = a;
    w2 = q;
   G5644:
    a = car(car(w3));
    w4 = a;
    q = a;
    a = w1;
    a = Lequal(a, q);
    if(a == nil) goto    G5646;
    a = true;
    goto    G5643;
   G5646:
    q = w4;
    a = w1;
    a = CC_Slis(a, q);
    if(a == nil) goto    G5648;
    a = nil;
    goto    G5643;
   G5648:
    a = cdr(w3);
    w3 = a;
    if(a != nil) goto    G5644;
   G5643:
    popv(4);
    return a;
}

Sex CC_gbEFsubtrredcer(Sex a, Sex q, Sex m, Sex arg4, Sex arg5, Sex arg6)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 28;
    w28 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w10 = nil;
    w11 = nil;
    w12 = nil;
    w13 = nil;
    w14 = nil;
    w15 = nil;
    w16 = nil;
    w17 = nil;
    w18 = nil;
    w19 = nil;
    w20 = nil;
    w21 = nil;
    w22 = nil;
    w23 = nil;
    w24 = nil;
    w25 = nil;
    w26 = nil;
    w27 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    w5 = arg5;
    w6 = arg6;
    a = Lzerop(a);
    if(a != nil) goto    G5763;
    a = w2;
    a = Lzerop(a);
    if(a != nil) goto    G5763;
    a = car(value(LL_Htemporal));
    w24 = a;
    a = cdr(value(LL_Htemporal));
    w25 = a;
    a = w3;
    a = Lfloat(a);
    q = a;
    a = LITERAL[160];
    a = Lmax2(a, q);
    w3 = a;
    a = w4;
    a = Lfloat(a);
    q = a;
    a = LITERAL[160];
    a = Lmax2(a, q);
    w4 = a;
   G5653:
    a = car(w5);
    w19 = a;
    a = car(w6);
    w20 = a;
    q = car(a);
    a = car(w19);
    a = Lequal(a, q);
    if(a == nil) goto    G5747;
    a = w19;
    a = Lcadddr(a);
    w28 = a;
    a = w20;
    a = Lcadddr(a);
    q = a;
    a = w28;
    a = Lequal(a, q);
    if(a == nil) goto    G5747;
    a = cdr(w19);
    w19 = a;
    a = cdr(w20);
    w20 = a;
    w27 = nil;
    a = car(w19);
    a = Lfloat(a);
    a = Labs(a);
    w28 = a;
    a = car(w20);
    a = Lfloat(a);
    a = Labs(a);
    a = Lminus(a);
    q = a;
    a = w28;
    a = plus2(a, q);
    w23 = a;
    q = mkfxat(0);
    a = Lgreaterp(a, q);
    if(a == nil) goto    G5681;
    a = w20;
    goto    G5682;
   G5681:
    a = w19;
   G5682:
    w18 = a;
    q = cdr(a);
    a = car(a);
    a = CC_gbEnumHdist(a, q);
    w15 = a;
    a = cdr(a);
    w16 = a;
    a = car(car(a));
    w17 = a;
    a = cdr(w1);
    w11 = a;
    a = car(car(a));
    w13 = a;
    a = car(w1);
    a = Lncons(a);
    w9 = a;
    w7 = a;
    a = cdr(w2);
    w12 = a;
    a = car(car(a));
    w14 = a;
    a = car(w2);
    a = Lncons(a);
    w10 = a;
    w8 = a;
#define LL_sttrace LITERAL[383]
    q = LL_sttrace;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a != nil) goto    G5654;
    Lterpri();
    a = LITERAL[384];
    Lprinc(a);
    a = w24;
    Lprin(a);
    a = LITERAL[385];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w1;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    Lterpri();
    a = LITERAL[384];
    Lprinc(a);
    a = w25;
    Lprin(a);
    a = LITERAL[385];
    Lprinc(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w2;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    Lterpri();
    a = LITERAL[386];
    Lprinc(a);
    a = w24;
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = w25;
    Lprin(a);
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w15;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G5654:
    q = w17;
    a = w13;
    a = Lequal(a, q);
    if(a == nil) goto    G5686;
    q = w14;
    a = w17;
    a = Lequal(a, q);
    if(a != nil) goto    G5657;
   G5686:
    q = w17;
    a = w13;
    a = CC_Slis(a, q);
    if(a == nil) goto    G5688;
    a = car(w11);
    a = Lncons(a);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(a);
    w9 = a;
    a = cdr(w11);
    w11 = a;
    if(a == nil) goto    G5694;
    a = car(car(a));
    w13 = a;
    goto    G5654;
   G5694:
    q = w12;
    a = w10;
    goto    G5768;
   G5688:
    q = w17;
    a = w14;
    a = CC_Slis(a, q);
    if(a == nil) goto    G5658;
    a = car(w12);
    a = Lncons(a);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    w10 = a;
    a = cdr(w12);
    w12 = a;
    if(a == nil) goto    G5699;
    a = car(car(a));
    goto    G5765;
   G5699:
    q = w11;
    a = w9;
    goto    G5768;
   G5657:
    a = true;
    w27 = a;
    w26 = a;
    a = cdr(car(w16));
    w18 = a;
    a = Lfloat(a);
    a = Labs(a);
    q = a;
    a = mkfxat(1);
    a = quot2(a, q);
    w23 = a;
    a = w18;
    a = Lminus(a);
    q = a;
    a = cdr(car(w11));
    a = plus2(a, q);
    w19 = a;
    q = w18;
    a = cdr(car(w12));
    a = plus2(a, q);
    w20 = a;
    a = w19;
    a = Lbefloat_value(a);
    w21 = a;
    a = w20;
    a = Lbefloat_value(a);
    w22 = a;
    a = w19;
    a = Lzerop(a);
    if(a != nil) goto    G5705;
    a = w19;
    a = Lbefloat_error(a);
    w28 = a;
    a = w21;
    a = Lfloat(a);
    a = Labs(a);
    q = w23;
    a = times2(a, q);
    q = a;
    a = w28;
    a = times2(a, q);
    q = a;
    a = w21;
    a = Lmkbefloat(a, q);
    q = w13;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w9;
    cdr(a) = q;
    a = cdr(a);
    w9 = a;
   G5705:
    a = w20;
    a = Lzerop(a);
    if(a != nil) goto    G5716;
    a = w20;
    a = Lbefloat_error(a);
    w28 = a;
    a = w22;
    a = Lfloat(a);
    a = Labs(a);
    q = w23;
    a = times2(a, q);
    q = a;
    a = w28;
    a = times2(a, q);
    q = a;
    a = w22;
    a = Lmkbefloat(a, q);
    q = w14;
    a = Lxcons(a, q);
    a = Lncons(a);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    w10 = a;
   G5716:
    a = cdr(w11);
    w11 = a;
    a = cdr(w12);
    w12 = a;
   G5658:
    a = cdr(w16);
    w16 = a;
    if(a != nil) goto    G5773;
    q = w11;
    a = w9;
    cdr(a) = q;
    q = w12;
    a = w10;
    goto    G5768;
   G5773:
    a = car(car(a));
    w17 = a;
    a = w11;
    if(a != nil) goto    G5730;
    q = w12;
    a = w10;
    goto    G5768;
   G5730:
    a = w12;
    if(a == nil) goto    G5772;
    a = car(car(w11));
    w13 = a;
    a = car(car(w12));
   G5765:
    w14 = a;
    goto    G5654;
   G5772:
    q = w11;
    a = w9;
   G5768:
    cdr(a) = q;
    a = w27;
    if(a == nil) goto    G5661;
    a = cdr(w7);
    if(a == nil) goto    G5736;
    a = w7;
    goto    G5769;
   G5736:
    a = mkfxat(0);
   G5769:
    w1 = a;
    a = cdr(w8);
    if(a == nil) goto    G5739;
    a = w8;
    goto    G5770;
   G5739:
    a = mkfxat(0);
   G5770:
    w2 = a;
    a = value(LL_Htracmode);
    if(a == LL_untrace) goto    G5661;
    Lterpri();
    a = LITERAL[387];
    Lprinc(a);
    a = LITERAL[388];
    Lprinc(a);
    a = w24;
    Lprin(a);
    a = LITERAL[93];
    Lprinc(a);
    a = w25;
    Lprin(a);
    a = LITERAL[256];
    Lprinc(a);
    Lterpri();
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w1;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
    arg5 = nil;
    arg4 = nil;
    m = value(LL_gbEorder);
    q = value(LL_gbEvars);
    a = w2;
    CC_gbEprint(a, q, m, arg4, arg5);
    Lterpri();
   G5661:
    a = w1;
    a = Lzerop(a);
    if(a != nil) goto    G5747;
    a = w2;
    a = Lzerop(a);
    if(a != nil) goto    G5747;
    a = cdr(w5);
    w5 = a;
    if(a == nil) goto    G5747;
    a = cdr(w6);
    w6 = a;
    if(a != nil) goto    G5653;
   G5747:
    a = w26;
    if(a != nil) goto    G5750;
   G5763:
    q = LITERAL[160];
    a = LITERAL[160];
    a = cons(a, q);
    goto    G5771;
   G5750:
    a = w1;
    a = Lzerop(a);
    if(a == nil) goto    G5753;
    a = LITERAL[160];
    goto    G5754;
   G5753:
    a = w1;
    a = CC_gbEnorm(a);
    a = Lfloat(a);
    q = a;
    a = w3;
    a = quot2(a, q);
   G5754:
    w19 = a;
    a = w2;
    a = Lzerop(a);
    if(a == nil) goto    G5758;
    a = LITERAL[160];
    goto    G5759;
   G5758:
    a = w2;
    a = CC_gbEnorm(a);
    a = Lfloat(a);
    q = a;
    a = w4;
    a = quot2(a, q);
   G5759:
    w20 = a;
    q = w19;
    a = Lxcons(a, q);
   G5771:
    value(LL_Htemporal) = a;
    q = w2;
    a = w1;
    {
        popv(28);
        return  cons(a, q);
    }
}

Sex CC_gbEFSRupdate(Sex a, Sex q, Sex m, Sex arg4)
{
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w5 = nil;
    w6 = nil;
    w7 = nil;
    w8 = nil;
    w9 = nil;
    w1 = a;
    w2 = q;
    w3 = m;
    w4 = arg4;
    a = car(arg4);
    a = Lzerop(a);
    if(a == nil) goto    G5778;
    a = cdr(w4);
    a = Lzerop(a);
    if(a == nil) goto    G5778;
    a = nil;
    goto    G5776;
   G5778:
    q = mkfxat(-18);
    a = mkfxat(10);
    a = Lexpt(a, q);
    q = value(LL_Hmachineps);
    a = quot2(a, q);
    w9 = a;
    q = value(LL_gbESRlist);
    a = w1;
    a = Lassoc(a, q);
    w5 = a;
    q = value(LL_gbESRlist);
    a = w2;
    a = Lassoc(a, q);
    w7 = a;
    if(a == nil) goto    G5782;
    a = cdr(a);
    goto    G5800;
   G5782:
    a = LITERAL[160];
   G5800:
    w7 = a;
    q = value(LL_gbESRlist);
    a = w3;
    a = Lassoc(a, q);
    w8 = a;
    if(a == nil) goto    G5785;
    a = cdr(a);
    goto    G5801;
   G5785:
    a = LITERAL[160];
   G5801:
    w8 = a;
    q = car(w4);
    a = w7;
    a = times2(a, q);
    w10 = a;
    q = cdr(w4);
    a = w8;
    a = times2(a, q);
    q = a;
    a = w10;
    a = Lmax2(a, q);
    w6 = a;
    q = LL_untrac;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5790;
    Lterpri();
    a = LITERAL[389];
    Lprinc(a);
    a = w1;
    Lprin(a);
    a = LITERAL[55];
    Lprinc(a);
    a = w6;
    Lprint(a);
   G5790:
    q = w9;
    a = w6;
    a = Lgreaterp(a, q);
    if(a == nil) goto    G5792;
    a = LL_PrecShortage;
    goto    G5776;
   G5792:
    a = w5;
    if(a == nil) goto    G5794;
    q = w6;
    {
        popv(10);
        cdr(a) = q;
 return a;
    }
   G5794:
    a = value(LL_gbESRlist);
    a = CC_tail(a);
    w10 = a;
    q = w6;
    a = w1;
    a = cons(a, q);
    w5 = a;
    a = Lncons(a);
    q = a;
    a = w10;
    cdr(a) = q;
    a = cdr(a);
    a = w5;
   G5776:
    popv(10);
    return a;
}

Sex CC_gbEFcalSRIC(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 10;
    w10 = nil;
    w7 = nil;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w8 = nil;
    w9 = nil;
    w2 = a;
    w1 = a;
#define LL_SelfReds LITERAL[390]
    a = LL_SelfReds;
    a = Lncons(a);
    w6 = a;
    w5 = a;
#define LL_IntriCancs LITERAL[391]
    a = LL_IntriCancs;
    a = Lncons(a);
    w7 = a;
#define LL_gbEIClist LITERAL[392]
    value(LL_gbEIClist) = a;
   G5805:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G5806;
    a = cdr(car(a));
    w8 = a;
    a = car(car(a));
    w3 = a;
    a = cdr(car(car(w2)));
    a = Lfloat(a);
    q = a;
    a = LITERAL[160];
    a = Lmax2(a, q);
    w4 = a;
    a = cdr(w8);
    a = CC_gbEepartMax(a);
    a = Lfloat(a);
    w10 = a;
    q = w4;
    a = value(LL_Hmachineps);
    a = times2(a, q);
    q = a;
    a = w10;
    a = quot2(a, q);
    w9 = a;
    q = value(LL_gbESRlist);
    a = w3;
    a = Lassoc(a, q);
    if(a == nil) goto    G5814;
    a = cdr(a);
    goto    G5815;
   G5814:
    a = LITERAL[7];
   G5815:
    w8 = a;
    q = LL_untrace;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5817;
    Lterpri();
    Lterpri();
    a = LITERAL[302];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[393];
    Lprinc(a);
    a = w8;
    Lprin(a);
    a = LITERAL[394];
    Lprinc(a);
    a = w9;
    Lprin(a);
   G5817:
    q = w8;
    a = w3;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    q = w9;
    a = w3;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w7;
    cdr(a) = q;
    a = cdr(a);
    w7 = a;
    goto    G5805;
   G5806:
    q = LL_untrace;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5825;
    Lterpri();
    Lterpri();
   G5825:
    a = w5;
    value(LL_gbESRlist) = a;
    a = value(LL_gbEIClist);
    popv(10);
    return a;
}

Sex CC_gbEFcalMCIC(Sex a)
{
    Sex q;
    Sex *sp = stack;
    stackcheck();
    stack = sp + 9;
    w9 = nil;
    w6 = nil;
    w5 = nil;
    w3 = nil;
    w4 = nil;
    w7 = nil;
    w8 = nil;
    w2 = a;
    w1 = a;
#define LL_MaxCancs LITERAL[395]
    a = LL_MaxCancs;
    a = Lncons(a);
    w5 = a;
#define LL_gbEMClist LITERAL[396]
    value(LL_gbEMClist) = a;
    a = LL_IntriCancs;
    a = Lncons(a);
    w6 = a;
    value(LL_gbEIClist) = a;
   G5829:
    a = cdr(w2);
    w2 = a;
    if(a == nil) goto    G5830;
    a = cdr(car(a));
    w7 = a;
    a = car(car(a));
    w3 = a;
    a = cdr(car(car(w2)));
    a = Lfloat(a);
    q = a;
    a = LITERAL[160];
    a = Lmax2(a, q);
    w4 = a;
    a = cdr(w7);
    a = CC_gbEaccMax(a);
    w9 = a;
    q = w4;
    a = value(LL_Hmachineps);
    a = times2(a, q);
    q = a;
    a = w9;
    a = quot2(a, q);
    w7 = a;
    q = w3;
    a = value(LL_gbEsyzygy);
    a = Lgetv(a, q);
    a = CC_Afmmc(a);
    q = w4;
    a = quot2(a, q);
    w8 = a;
    q = LL_untrace;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5839;
    Lterpri();
    Lterpri();
    a = LITERAL[302];
    Lprinc(a);
    a = w3;
    Lprin(a);
    a = LITERAL[397];
    Lprinc(a);
    a = w7;
    Lprin(a);
    a = LITERAL[394];
    Lprinc(a);
    a = w8;
    Lprin(a);
   G5839:
    q = w7;
    a = w3;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w5;
    cdr(a) = q;
    a = cdr(a);
    w5 = a;
    q = w8;
    a = w3;
    a = cons(a, q);
    a = Lncons(a);
    q = a;
    a = w6;
    cdr(a) = q;
    a = cdr(a);
    w6 = a;
    goto    G5829;
   G5830:
    q = LL_untrace;
    a = value(LL_Htracmode);
    a = Lneq(a, q);
    if(a == nil) goto    G5847;
    Lterpri();
    Lterpri();
   G5847:
    a = value(LL_gbEIClist);
    popv(9);
    return a;
}



/* initialization procedure */
int init_pkggb(void)
{
   long i;

   create_symbols(pkggb_g_setup);
   literal_vectors[number_of_literal_vectors++] =
               LITERAL;
   for(i = 0; pkggb_literal_string[i] != NULL; i++)
           LITERAL[i]
               = make_literal(pkggb_literal_string[i]);
   LITERAL[i] = (Sex)NULL;

    {
        Sex a, q, m, arg4;
        a = LITERAL[398];
        CC_Aenter(a);
        arg4 = mkfxat(2);
#define LL_argchk LITERAL[399]
        m = LL_argchk;
#define LL_AQgroeb LITERAL[400]
        q = LL_AQgroeb;
#define LL_groeb LITERAL[401]
        a = LL_groeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
        q = LL_AQgroeb;
#define LL_qgroeb LITERAL[402]
        a = LL_qgroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
        q = LL_AQgroeb;
#define LL_Qgroeb LITERAL[403]
        a = LL_Qgroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
#define LL_APgroeb LITERAL[404]
        q = LL_APgroeb;
#define LL_pgroeb LITERAL[405]
        a = LL_pgroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
        q = LL_APgroeb;
#define LL_Pgroeb LITERAL[406]
        a = LL_Pgroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
#define LL_AmodGroeb LITERAL[407]
        q = LL_AmodGroeb;
#define LL_modGroeb LITERAL[408]
        a = LL_modGroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(3);
        m = LL_argchk;
#define LL_AappGroeb LITERAL[409]
        q = LL_AappGroeb;
#define LL_appGroeb LITERAL[410]
        a = LL_appGroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
        q = LL_AappGroeb;
#define LL_appGrb LITERAL[411]
        a = LL_appGrb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
#define LL_AmatGroeb LITERAL[412]
        q = LL_AmatGroeb;
#define LL_matGroeb LITERAL[413]
        a = LL_matGroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
        q = LL_AmatGroeb;
#define LL_matGrb LITERAL[414]
        a = LL_matGrb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
#define LL_AhprGroeb LITERAL[415]
        q = LL_AhprGroeb;
#define LL_hprGroeb LITERAL[416]
        a = LL_hprGroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
#define LL_AFgroeb LITERAL[417]
        q = LL_AFgroeb;
#define LL_floGroeb LITERAL[418]
        a = LL_floGroeb;
        CC_defcommand(a, q, m, arg4);
        arg4 = mkfxat(2);
        m = LL_argchk;
        q = LL_AFgroeb;
#define LL_Fgroeb LITERAL[419]
        a = LL_Fgroeb;
        CC_defcommand(a, q, m, arg4);
#define LL_Wid LITERAL[420]
        m = LL_Wid;
        q = LL_gbEorder;
        a = LL_gbEorder;
        CC_defparam(a, q, m);
        m = LL_Wid;
        q = LL_gbEordpar;
        a = LL_gbEordpar;
        CC_defparam(a, q, m);
        m = LL_Wid;
        q = LL_gbEcoftype;
        a = LL_gbEcoftype;
        CC_defparam(a, q, m);
        m = LL_Wid;
        q = LL_gbEredtype;
        a = LL_gbEredtype;
        CC_defparam(a, q, m);
        m = LL_Wid;
        q = LL_gbEhowstop;
        a = LL_gbEhowstop;
        CC_defparam(a, q, m);
        m = LL_Wid;
        q = LL_gbEhowsimp;
        a = LL_gbEhowsimp;
        CC_defparam(a, q, m);
        m = LL_Wid;
        q = LL_gbEsyzygy;
        a = LL_gbEsyzygy;
        CC_defparam(a, q, m);
#define LL_Wbnum LITERAL[421]
        m = LL_Wbnum;
        q = LL_gbEFprec;
        a = LL_gbEFprec;
        CC_defparam(a, q, m);
        m = LL_Wbnum;
        q = LL_gbEaccinit;
        a = LL_gbEaccinit;
        CC_defparam(a, q, m);
#define LL_Wint LITERAL[422]
        m = LL_Wint;
        q = LL_gbEcutvar;
        a = LL_gbEcutvar;
        CC_defparam(a, q, m);
        m = LL_Wint;
        q = LL_gbEcutpar;
        a = LL_gbEcutpar;
        CC_defparam(a, q, m);
        a = LITERAL[423];
        Lglobal(a);
        a = LITERAL[424];
#define LL_Hwordprimes LITERAL[425]
        value(LL_Hwordprimes) = a;
        a = LITERAL[426];
        Lglobal(a);
        a = LITERAL[427];
        Lglobal(a);
        a = LITERAL[428];
        Lglobal(a);
        a = LITERAL[429];
        Lglobal(a);
        a = LITERAL[430];
        a = Lglobal(a);
        return 1;
    }
}
Sex LITERAL[432];

const  char *pkggb_literal_string[432] =
{
/* 0 */
"-1.000000000000000",
/* 1 */
"!<blank!>",
/* 2 */
"!<percent!>",
/* 3 */
"\"package-parameter name = \"",
/* 4 */
"\"PKGPARAM DONE FOR\"",
/* 5 */
"\"SYNTAX ERROR IN PKGPARAM\"",
/* 6 */
"!*random",
/* 7 */
"0.000000000000000",
/* 8 */
"!*chkcoef",
/* 9 */
"fmmc!:bef2float",
/* 10 */
"!*temporal",
/* 11 */
"!*machineps",
/* 12 */
"untrac",
/* 13 */
"!*tracmode",
/* 14 */
"\"   *** deleted: \"",
/* 15 */
"acczerop",
/* 16 */
"\"NOT programmed yet\"",
/* 17 */
"100.0000000000000",
/* 18 */
"! Q",
/* 19 */
"! Z",
/* 20 */
"\"COEFFICIENTS of INPUT are NOT <RATN>\"",
/* 21 */
"ratn",
/* 22 */
"gb!%coftype",
/* 23 */
"times2",
/* 24 */
"gb!%mult",
/* 25 */
"div!:bnumbnum",
/* 26 */
"gb!%quoti",
/* 27 */
"plus2",
/* 28 */
"gb!%add",
/* 29 */
"minus",
/* 30 */
"gb!%neg",
/* 31 */
"gcd!:bnumbnum",
/* 32 */
"gb!%gcd",
/* 33 */
"\"COEFFICIENTS of INPUT are NOT <INT>\"",
/* 34 */
"!*mod",
/* 35 */
"\"DECLARE a prime by declare SENTENCE\"",
/* 36 */
"Zp",
/* 37 */
"modmult",
/* 38 */
"moddiv",
/* 39 */
"modadd",
/* 40 */
"gcd",
/* 41 */
"! F",
/* 42 */
"! C",
/* 43 */
"\"CONVERT INPUT by coef2float COMMAND\"",
/* 44 */
"\"COEFFICIENTS of INPUT are NOT FLOAT\"",
/* 45 */
"float",
/* 46 */
"quotient",
/* 47 */
"end",
/* 48 */
"stop",
/* 49 */
"\"    ****** P\"",
/* 50 */
"\" is REDUCED to a CONSTANT\"",
/* 51 */
"!!set",
/* 52 */
"\"BASIS of A SINGLE ELEMENT\"",
/* 53 */
"\"   POLYNOMIALs in the GROEBNER BASIS :\"",
/* 54 */
"\"       P\"",
/* 55 */
"\" = \"",
/* 56 */
"gb!%order",
/* 57 */
"gb!%vars",
/* 58 */
"gb!%syzygy",
/* 59 */
"!*byproduct",
/* 60 */
"\"SET PARAMETER gb%order BY setparam COMMAND\"",
/* 61 */
"(lex tdeg trev pser)",
/* 62 */
"\"gb%order MUST BE lex, tdeg, trev OR pser\"",
/* 63 */
"! nil",
/* 64 */
"\"PSET MUST BE NIL float COEFFICIENTS\"",
/* 65 */
"gb!%ordpar",
/* 66 */
"\"SET PARAMETER gb%ordpar BY setparam COMMAND\"",
/* 67 */
"\"gb%ordpar MUST BE lex, tdeg, trev OR pser\"",
/* 68 */
"(full head)",
/* 69 */
"gb!%redtype",
/* 70 */
"lex",
/* 71 */
"\"gb%redtype MUST BE full OR head\"",
/* 72 */
"head",
/* 73 */
"P!#s",
/* 74 */
"VAR",
/* 75 */
"\"INPUT BASIS CONTAINS A NUMBER\"",
/* 76 */
"\"GROEBNER\"",
/* 77 */
"lessp",
/* 78 */
"gb!%pars",
/* 79 */
"PAR",
/* 80 */
"\"EVERY VARIABLE IS A PARAMETER\"",
/* 81 */
"\"RESET PARAMETERS, AND TRY AGAIN\"",
/* 82 */
"\"PARAMETER IS HIGHER ORDER THAN VAR\"",
/* 83 */
"\"REORDER THE INPUT, AND TRY AGAIN\"",
/* 84 */
"gb!%syzvar",
/* 85 */
"indxvar",
/* 86 */
"Wset",
/* 87 */
"\"   INITIAL POLYNOMIALs are NAMED as follows : \"",
/* 88 */
"\"   P\"",
/* 89 */
"hpr",
/* 90 */
"yes",
/* 91 */
"\" since GCD(HT,HT) = 1\"",
/* 92 */
"\"            SPOL(P\"",
/* 93 */
"\",P\"",
/* 94 */
"\") ==> 0 \"",
/* 95 */
"\" SINCE A*Pi = B*Pj\"",
/* 96 */
"spol",
/* 97 */
"sttrac",
/* 98 */
"\"       *** SPOL(P\"",
/* 99 */
"\") below is REDUCED a.f.a. POSSIBLE\"",
/* 100 */
"\"     \"",
/* 101 */
"same",
/* 102 */
"\" by REDUCTION\"",
/* 103 */
"gb!%howsimp",
/* 104 */
"\"   NEW POLYNOMIAL is GENERATED from SPOL(P\"",
/* 105 */
"\") ==> \"",
/* 106 */
"\"  RESULT = \"",
/* 107 */
"\"       *** P\"",
/* 108 */
"\" is REDUCED TO 0 and REMOVED\"",
/* 109 */
"\" is REDUCED-NORMALIZED to\"",
/* 110 */
"gb!%tol",
/* 111 */
"\"         ** \"",
/* 112 */
"\"REDUCED to SMALL POL :\"",
/* 113 */
"\"SMALL TERM is DELETED\"",
/* 114 */
"mred",
/* 115 */
"full",
/* 116 */
"\"TERM(S) of SPOL is REDUCED by P\"",
/* 117 */
"\"HEAD(S) of SPOL is REDUCED by P\"",
/* 118 */
"\"            \"",
/* 119 */
"\"TERM(S) of P\"",
/* 120 */
"\"HEAD(S) of P\"",
/* 121 */
"\" is REDUCED by P\"",
/* 122 */
"no",
/* 123 */
"int",
/* 124 */
"!#poly!#",
/* 125 */
"pser",
/* 126 */
"tdeg",
/* 127 */
"trev",
/* 128 */
"gb!%dist!+dist",
/* 129 */
"gb!%se!:dist!+dist",
/* 130 */
"! A",
/* 131 */
"gb!%Fprec",
/* 132 */
"nmlz",
/* 133 */
"gb!%howstop",
/* 134 */
"var",
/* 135 */
"par",
/* 136 */
"\"CONSTANT HAS BEEN GENERATED, IDEAL = (1)\"",
/* 137 */
"gb!%cutvar",
/* 138 */
"\"AN EXPRESSION of DESIRED DEGREE is OBTAINED\"",
/* 139 */
"\"EVERY VARIABLE HAS BEEN ELIMINATED\"",
/* 140 */
"gb!%cutpar",
/* 141 */
"\"VARIABLES and NECESSARY PARAMETERS are ELIMINATED\"",
/* 142 */
"\"   *** \"",
/* 143 */
"\"   *** THE COMPUTATION IS TRUNCATED HERE\"",
/* 144 */
"\"       **** MONOMIAL \"",
/* 145 */
"\"  IS REMOVED FROM P\"",
/* 146 */
"\"-\"",
/* 147 */
"\"+\"",
/* 148 */
"\" \"",
/* 149 */
"\"#\"",
/* 150 */
"\"(\"",
/* 151 */
"\")\"",
/* 152 */
"\"       #\"",
/* 153 */
"\"^\"",
/* 154 */
"gb!%control",
/* 155 */
"gb!%accinit",
/* 156 */
"\"after %ABsortWset\"",
/* 157 */
"\" ==> 0\"",
/* 158 */
"\" by SUBTRATION\"",
/* 159 */
"\" is constructed as follows\"",
/* 160 */
"1.000000000000000",
/* 161 */
"appZERO",
/* 162 */
"\" APPROXimately\"",
/* 163 */
"\" by big InxtCANC\"",
/* 164 */
"\" by PrecShortage\"",
/* 165 */
"\"   NEW POLYNOMIAL is GENERATED from \"",
/* 166 */
"\" ==>  P\"",
/* 167 */
"\" below\"",
/* 168 */
"\"after SPOL CONSTRUCTION\"",
/* 169 */
"\"W by %ABredSsetSmHx\"",
/* 170 */
"\" ==> returned to WSET\"",
/* 171 */
"\" became ACCURATE\"",
/* 172 */
"\"after POL-STORING\"",
/* 173 */
"0.1000000000000000",
/* 174 */
"10.00000000000000",
/* 175 */
"CC",
/* 176 */
"0.5000000000000000",
/* 177 */
"\"@@@ Coef-CANCs of P\"",
/* 178 */
"gb!%canclvl",
/* 179 */
"\"@@@ bigCoef.Cancs\"",
/* 180 */
"\"@@@ sysInxCANC Estimated (Ver.3)\"",
/* 181 */
"\"==> SAVED into %apZeros\"",
/* 182 */
"\" is APPROXimately ZERO \"",
/* 183 */
"AppZERO",
/* 184 */
"\"   ******* RETRY by increasing the PRECISION\"",
/* 185 */
"\"       PRECISION has been LOST in P\"",
/* 186 */
"\" *******\"",
/* 187 */
"\" is FORCED to be 0 and CONTINUE computation ***\"",
/* 188 */
"PrecShort",
/* 189 */
"PbySi",
/* 190 */
"SibyP",
/* 191 */
"STset",
/* 192 */
"STORE",
/* 193 */
"STORE2",
/* 194 */
"\" is REMOVED since ==> 0\"",
/* 195 */
"all",
/* 196 */
"CMatx",
/* 197 */
"row",
/* 198 */
"\"   # of columns\"",
/* 199 */
"\"%ABchkdelZRlftcol\"",
/* 200 */
"\"   %order   = \"",
/* 201 */
"\"   %accinit = \"",
/* 202 */
"\"   %tol     = \"",
/* 203 */
"\"INPUT COEFFICIENTS are NOT NUMBERS\"",
/* 204 */
"\"%accinit is NOT DEFINED or INVALID\"",
/* 205 */
"\"%accinit is TOO BIG, must be <= \"",
/* 206 */
"(! nil ! NIL)",
/* 207 */
"\"2nd ARG must be either NUMBER or NIL\"",
/* 208 */
"\"tolerance is TOO BIG, must be <= \"",
/* 209 */
"0.1500000000000000",
/* 210 */
"\"   %control = \"",
/* 211 */
"!!gid",
/* 212 */
"ApZEROs",
/* 213 */
"gb!%apZeros",
/* 214 */
"AcdInxC",
/* 215 */
"gb!%acdInxC",
/* 216 */
"gb!%histry",
/* 217 */
"app",
/* 218 */
"\"BASIS-REDUCTION ==========\"",
/* 219 */
"\"before REDUCTION\"",
/* 220 */
"\"SPOL-CONSTRUCTION ==========\"",
/* 221 */
"\"before CONSTRUCTION\"",
/* 222 */
"\"FORCED to STOP, because so many SPOLs\"",
/* 223 */
"\"MOVING POLs from STORE ==========\"",
/* 224 */
"\"before POLs-MOVING\"",
/* 225 */
"\"after POLs-MOVING\"",
/* 226 */
"\"   ***** COMPUTATION is STOPPed\"",
/* 227 */
"prec",
/* 228 */
"\"     ****** P\"",
/* 229 */
"\"FINAL-STAGE ==========\"",
/* 230 */
"\"at FINAL-STAGE\"",
/* 231 */
"\"    ***** The following results are\"",
/* 232 */
"\" NOT Groebner Basis, only for REFERENCE\"",
/* 233 */
"\"    ApproxZERO computed (CANCellation = \"",
/* 234 */
"\") : \"",
/* 235 */
"\"   POLYNOMIALs in the APPROXimate GROEBNER BASIS :\"",
/* 236 */
"\"   PrecShortage RESULT (for reference) :\"",
/* 237 */
"ABset",
/* 238 */
"\"   \"",
/* 239 */
"\"big MaxCANC detected\"",
/* 240 */
"\" ==> P\"",
/* 241 */
"\" is stored in STORE\"",
/* 242 */
"\"after REDUCTION\"",
/* 243 */
"redc",
/* 244 */
"\"@@@@@ NOT YET\"",
/* 245 */
"0.6000000000000000",
/* 246 */
"-0.6000000000000000",
/* 247 */
"\"     r = \"",
/* 248 */
"\" ApproxZERO detected (CANCellation = \"",
/* 249 */
"\"    ***\"",
/* 250 */
"\"%appZEROs\"",
/* 251 */
"\" is REDUCED to 0\"",
/* 252 */
"\" in %appZEROs\"",
/* 253 */
"(4 1 1 2)",
/* 254 */
"\"STP\"",
/* 255 */
"\"    *** %canclvl redefined\"",
/* 256 */
"\" ==> \"",
/* 257 */
"\"to reduce POLs in STORE\"",
/* 258 */
"STset2",
/* 259 */
"\" 0 and ELIMINATED\"",
/* 260 */
"\" is REDUCED to\"",
/* 261 */
"\"NOT moved to WSET\"",
/* 262 */
"\" in STORE is \"",
/* 263 */
"\" moved to WSET\"",
/* 264 */
"\" in STORE is\"",
/* 265 */
"\"   Systematic CANCELLATION\"",
/* 266 */
"\" is evaluated by\"",
/* 267 */
"\" Local Matrix\"",
/* 268 */
"\"   Number of rows    = \"",
/* 269 */
"\"   Number of columns = \"",
/* 270 */
"\"   Position of Lterm = \"",
/* 271 */
"\"%ABGaussFelim\"",
/* 272 */
"\"   *** P\"",
/* 273 */
"\" by Matrix-Method\"",
/* 274 */
"\"     multi-row CMATX\"",
/* 275 */
"\"     CMATX contains 0-ROW\"",
/* 276 */
"\"   ==> NORM-reduction evaluated \"",
/* 277 */
"\"by Local M-matrix on P\"",
/* 278 */
"\"ZERO-vector detected\"",
/* 279 */
"\"MATX before Back-Elim\"",
/* 280 */
"\"MATX after Back-Elim\"",
/* 281 */
"\"           Pol#s in  WSET = \"",
/* 282 */
"\"           Pol#s in STORE = \"",
/* 283 */
"\"( )\"",
/* 284 */
"\"|\"",
/* 285 */
"Sset",
/* 286 */
"\"@@@ HxInf4s in \"",
/* 287 */
"\"WSET \"",
/* 288 */
"\"STORE \"",
/* 289 */
"\"STORE2 \"",
/* 290 */
"\" =\"",
/* 291 */
"\"    \"",
/* 292 */
"\" : \"",
/* 293 */
"\"@@@ Hxinf4 of SPOL = \"",
/* 294 */
"\"@@@ Hxinf4 of P\"",
/* 295 */
"\"    ( sysInxCanc = \"",
/* 296 */
"\" ,   abnmlty = \"",
/* 297 */
"\" ,   maxCanc = \"",
/* 298 */
"\" )\"",
/* 299 */
"\"           HEAD(S) of SPOL\"",
/* 300 */
"\"           HEAD(S) of P\"",
/* 301 */
"\" in \"",
/* 302 */
"\"    P\"",
/* 303 */
"\" in STORE is REDUCED-NORMALIZED to\"",
/* 304 */
"\"           P\"",
/* 305 */
"\"           \"",
/* 306 */
"\"SPOL(P\"",
/* 307 */
"\" is REDUCED to 0 APPROXimately\"",
/* 308 */
"0.001000000000000000",
/* 309 */
"\"tolerance is TOO BIG: tol > 0.001\"",
/* 310 */
"\"%accinit is TOO BIG: >= tolerance\"",
/* 311 */
"ClonInfo",
/* 312 */
"gb!%clones",
/* 313 */
"apZeros",
/* 314 */
"\"   %accinit\"",
/* 315 */
"\"       %tol\"",
/* 316 */
"\"   %control\"",
/* 317 */
"mat",
/* 318 */
"P!#s1",
/* 319 */
"MWset2",
/* 320 */
"imprAll",
/* 321 */
"\"   SYZYGY is large ==>\"",
/* 322 */
"\" call %MimprovePols\"",
/* 323 */
"\" ***** PRECision is NOT enough ==>\"",
/* 324 */
"\" PRECision is increased and REPLAY\"",
/* 325 */
"\"   GROEBNER BASIS = { 1 }\"",
/* 326 */
"\"   ===== Now, GAL enters into\"",
/* 327 */
"\" Final Improvement Stage ===== \"",
/* 328 */
"bigC",
/* 329 */
"\" is REDUCED-NORMALIZED to \"",
/* 330 */
"\"     ( accMIN = \"",
/* 331 */
"\" ,     accMAX = \"",
/* 332 */
"Mred",
/* 333 */
"intoMwset2",
/* 334 */
"\" is REDUCED to 0 and REMOVED\"",
/* 335 */
"\" is REDUCED to 0 APPROXimtly\"",
/* 336 */
"\"           SPOL(P\"",
/* 337 */
"untrace",
/* 338 */
"\"big CANCellation detected = \"",
/* 339 */
"\") is REDUCED to a CONSTANT\"",
/* 340 */
"\"big CANCellatn as a whole = \"",
/* 341 */
"Spol",
/* 342 */
"\"maxError/maxCoeff = \"",
/* 343 */
"Syz",
/* 344 */
"\"   accuracy recovered = \"",
/* 345 */
"\"Improved P\"",
/* 346 */
"\" = 0\"",
/* 347 */
"\" is saved into MWSET2\"",
/* 348 */
"\" is returned from MWSET2 to MWSET\"",
/* 349 */
"\"   P# to be improved = \"",
/* 350 */
"\"   POL is the same as Initial POLYnomial\"",
/* 351 */
"\"   POL is well accurate, skip improvement\"",
/* 352 */
"\"   POL to be improved = \"",
/* 353 */
"\"   Power-product set = \"",
/* 354 */
"\"   GAL Improves a Polynomial\"",
/* 355 */
"\" =================\"",
/* 356 */
"\"BUG in %matxMonoset\"",
/* 357 */
"!>lis",
/* 358 */
"\"BUG in %matxHexpos\"",
/* 359 */
"\"%matxGauss2\"",
/* 360 */
"\" # of rows = \"",
/* 361 */
"\" # of clms = \"",
/* 362 */
"MWset",
/* 363 */
"RedSub",
/* 364 */
"gb!%strtgy",
/* 365 */
"selfreds",
/* 366 */
"gb!%SRlist",
/* 367 */
"clones",
/* 368 */
"PrecShortage",
/* 369 */
"\"  { 1 }\"",
/* 370 */
"Syzygy",
/* 371 */
"FWset",
/* 372 */
"AbLate",
/* 373 */
"\"   CONSTANT is GENERATED from SPOL(P\"",
/* 374 */
"\") below is SELF-REDUCTION\"",
/* 375 */
"\" !!! \"",
/* 376 */
"clone",
/* 377 */
"\"       *** SPOL below is A CLONE of P\"",
/* 378 */
"\"  !!!\"",
/* 379 */
"\" is REDUCED to 0 and ELIMINATED\"",
/* 380 */
"\"       *** MRED(P\"",
/* 381 */
"\" below is A CLONE of P\"",
/* 382 */
"\" !!!\"",
/* 383 */
"sttrace",
/* 384 */
"\"     P\"",
/* 385 */
"\" to be SUBTRACTED :\"",
/* 386 */
"\"     REDUCER acts on P\"",
/* 387 */
"\"     After REDUCER SUBTRACTION :  \"",
/* 388 */
"\" P\"",
/* 389 */
"\"       SELF-REDUCTION in P\"",
/* 390 */
"SelfReds",
/* 391 */
"IntriCancs",
/* 392 */
"gb!%IClist",
/* 393 */
"\" :   Self-Red. = \"",
/* 394 */
"\"   Intri-Canc. = \"",
/* 395 */
"MaxCancs",
/* 396 */
"gb!%MClist",
/* 397 */
"\" :   Max-Canc. = \"",
/* 398 */
"(lisp)",
/* 399 */
"argchk",
/* 400 */
"! Qgroeb",
/* 401 */
"groeb",
/* 402 */
"qgroeb",
/* 403 */
"Qgroeb",
/* 404 */
"! Pgroeb",
/* 405 */
"pgroeb",
/* 406 */
"Pgroeb",
/* 407 */
"! modGroeb",
/* 408 */
"modGroeb",
/* 409 */
"! appGroeb",
/* 410 */
"appGroeb",
/* 411 */
"appGrb",
/* 412 */
"! matGroeb",
/* 413 */
"matGroeb",
/* 414 */
"matGrb",
/* 415 */
"! hprGroeb",
/* 416 */
"hprGroeb",
/* 417 */
"! Fgroeb",
/* 418 */
"floGroeb",
/* 419 */
"Fgroeb",
/* 420 */
"!?id",
/* 421 */
"!?bnum",
/* 422 */
"!?int",
/* 423 */
"(!*wordprimes)",
/* 424 */
"(500009 500029 500041 500057 500069 500083 500107 500111 500113 500119 500153 500167 500173 500177 500179 500197 500209 500231 500233 500237 500239 500249 500257 500287 500299 500317 500321 500333 500341 500363 500369 500389 500393 500413 500417 500431 500443 500459 500471 500473 500483 500501 500509 500519 500527 500567 500579 500587 500603 500629 500671 500677 500693 500699)",
/* 425 */
"!*wordprimes",
/* 426 */
"(gb!%vars gb!%pars gb!%syzvar)",
/* 427 */
"(gb!%mult gb!%add gb!%neg gb!%quoti gb!%gcd)",
/* 428 */
"(gb!%histry gb!%apZeros gb!%acdInxC gb!%tol gb!%control gb!%canclvl)",
/* 429 */
"(gb!%clones gb!%mgbase)",
/* 430 */
"(gb!%strtgy gb!%clones gb!%SRlist gb!%IClist gb!%MClist)",
/* 431 */ NULL
};
setup_type const pkggb_g_setup[] =
{
    {"gb%FcalMCIC", (lisp_proc *)CC_gbEFcalMCIC, 1},
    {"gb%FcalSRIC", (lisp_proc *)CC_gbEFcalSRIC, 1},
    {"gb%FSRupdate", (lisp_proc *)CC_gbEFSRupdate, 4},
    {"gb%Fsubtrredcer", (lisp_proc *)CC_gbEFsubtrredcer, 6},
    {"gb%Fchkhex", (lisp_proc *)CC_gbEFchkhex, 2},
    {"gb%Fchkselfred", (lisp_proc *)CC_gbEFchkselfred, 4},
    {"gb%Fchkclone", (lisp_proc *)CC_gbEFchkclone, 4},
    {"gb%Fclonupdate", (lisp_proc *)CC_gbEFclonupdate, 2},
    {"gb%Fdelclone", (lisp_proc *)CC_gbEFdelclone, 1},
    {"gb%Faddclone", (lisp_proc *)CC_gbEFaddclone, 2},
    {"gb%HdelErrTerm", (lisp_proc *)CC_gbEHdelErrTerm, 2},
    {"gb%Hhred", (lisp_proc *)CC_gbEHhred, 7},
    {"gb%Hredpol", (lisp_proc *)CC_gbEHredpol, 4},
    {"gb%Hreduce", (lisp_proc *)CC_gbEHreduce, 3},
    {"gb%Hmkspol", (lisp_proc *)CC_gbEHmkspol, 8},
    {"gb%Hspol", (lisp_proc *)CC_gbEHspol, 3},
    {"gb%Hinswset", (lisp_proc *)CC_gbEHinswset, 2},
    {"gb%preWset2Fwset", (lisp_proc *)CC_gbEpreWset2Fwset, 2},
    {"gb%wset2Fwset", (lisp_proc *)CC_gbEwset2Fwset, 2},
    {"gb%Fmkwprep", (lisp_proc *)CC_gbEFmkwprep, 4},
    {"gb%Hnormalz", (lisp_proc *)CC_gbEHnormalz, 2},
    {"gb%Fnormalz", (lisp_proc *)CC_gbEFnormalz, 3},
    {" hprGroeb", (lisp_proc *)CC_AhprGroeb, 2},
    {"gb%Minswset", (lisp_proc *)CC_gbEMinswset, 2},
    {"gb%wset2Mwset", (lisp_proc *)CC_gbEwset2Mwset, 2},
    {"gb%Mredrest", (lisp_proc *)CC_gbEMredrest, 2},
    {"gb%ABwsRedrest", (lisp_proc *)CC_gbEABwsRedrest, 1},
    {"gb%matxGivens1", (lisp_proc *)CC_gbEmatxGivens1, 2},
    {"gb%matxGivens01", (lisp_proc *)CC_gbEmatxGivens01, 2},
    {"gb%matxGivens0", (lisp_proc *)CC_gbEmatxGivens0, 2},
    {"gb%matxExchCol1", (lisp_proc *)CC_gbEmatxExchCol1, 2},
    {"gb%MmatxPivot", (lisp_proc *)CC_gbEMmatxPivot, 6},
    {"gb%matxGauss2", (lisp_proc *)CC_gbEmatxGauss2, 2},
    {"gb%matxGauss1", (lisp_proc *)CC_gbEmatxGauss1, 2},
    {"gb%matxHexpos", (lisp_proc *)CC_gbEmatxHexpos, 2},
    {"gb%MmatxMkMatx", (lisp_proc *)CC_gbEMmatxMkMatx, 3},
    {"gb%matxMergExs", (lisp_proc *)CC_gbEmatxMergExs, 1},
    {"gb%matxMns1", (lisp_proc *)CC_gbEmatxMns1, 3},
    {"gb%matxMonoset", (lisp_proc *)CC_gbEmatxMonoset, 3},
    {"gb%MimprContSyz", (lisp_proc *)CC_gbEMimprContSyz, 3},
    {"gb%MintlzSyzsIPs", (lisp_proc *)CC_gbEMintlzSyzsIPs, 1},
    {"gb%MimprovePol1", (lisp_proc *)CC_gbEMimprovePol1, 2},
    {"gb%MimprovePols", (lisp_proc *)CC_gbEMimprovePols, 1},
    {"gb%MmoveCancPol", (lisp_proc *)CC_gbEMmoveCancPol, 4},
    {"gb%MimprCancPol", (lisp_proc *)CC_gbEMimprCancPol, 8},
    {"gb%Msamehexp", (lisp_proc *)CC_gbEMsamehexp, 2},
    {"gb%Mmkwprep", (lisp_proc *)CC_gbEMmkwprep, 4},
    {"gb%Mnormalz", (lisp_proc *)CC_gbEMnormalz, 3},
    {"gb%MmonitrSyz", (lisp_proc *)CC_gbEMmonitrSyz, 1},
    {"gb%MdelErrTerm", (lisp_proc *)CC_gbEMdelErrTerm, 2},
    {"gb%Mhred", (lisp_proc *)CC_gbEMhred, 5},
    {"gb%Mredpol", (lisp_proc *)CC_gbEMredpol, 4},
    {"gb%Mmkspol", (lisp_proc *)CC_gbEMmkspol, 6},
    {"gb%Mspol", (lisp_proc *)CC_gbEMspol, 5},
    {"gb%Mreduce", (lisp_proc *)CC_gbEMreduce, 5},
    {" matGroeb", (lisp_proc *)CC_AmatGroeb, 2},
    {"gb%MmatxReduce", (lisp_proc *)CC_gbEMmatxReduce, 2},
    {"gb%ABredpolByGB", (lisp_proc *)CC_gbEABredpolByGB, 2},
    {"gb%priSPOLij", (lisp_proc *)CC_gbEpriSPOLij, 2},
    {"gb%priPmsgmsg", (lisp_proc *)CC_gbEpriPmsgmsg, 3},
    {"gb%ABpriRedPol", (lisp_proc *)CC_gbEABpriRedPol, 4},
    {"gb%priRedPbyQ", (lisp_proc *)CC_gbEpriRedPbyQ, 3},
    {"gb%ABpriavpApB", (lisp_proc *)CC_gbEABpriavpApB, 2},
    {"gb%ABpriHxinf4", (lisp_proc *)CC_gbEABpriHxinf4, 4},
    {"gb%ABpriHxInf4s", (lisp_proc *)CC_gbEABpriHxInf4s, 2},
    {"gb%ABpriElms", (lisp_proc *)CC_gbEABpriElms, 2},
    {"gb%ABchkdelZRlftcol", (lisp_proc *)CC_gbEABchkdelZRlftcol, 2},
    {"gb%ABGaussBelim", (lisp_proc *)CC_gbEABGaussBelim, 3},
    {"gb%ABrowPivot", (lisp_proc *)CC_gbEABrowPivot, 6},
    {"gb%oldABGaussFelim", (lisp_proc *)CC_gbEoldABGaussFelim, 3},
    {"gb%oldABmatxMkMatx", (lisp_proc *)CC_gbEoldABmatxMkMatx, 4},
    {"gb%ABnrmlzIplis", (lisp_proc *)CC_gbEABnrmlzIplis, 1},
    {"gb%ABevalSysInxC", (lisp_proc *)CC_gbEABevalSysInxC, 3},
    {"gb%ABintlzSyzsIPs", (lisp_proc *)CC_gbEABintlzSyzsIPs, 2},
    {"gb%ABmoveCancPol", (lisp_proc *)CC_gbEABmoveCancPol, 3},
    {"gb%oldfindReducer", (lisp_proc *)CC_gbEoldfindReducer, 4},
    {"gb%ABsaveApZero", (lisp_proc *)CC_gbEABsaveApZero, 4},
    {"gb%ABputmarks", (lisp_proc *)CC_gbEABputmarks, 2},
    {"gb%ABhred", (lisp_proc *)CC_gbEABhred, 5},
    {"gb%ABredpol", (lisp_proc *)CC_gbEABredpol, 5},
    {"gb%ABmkspol2", (lisp_proc *)CC_gbEABmkspol2, 6},
    {"gb%ABmkspol", (lisp_proc *)CC_gbEABmkspol, 6},
    {"gb%ABsortWset", (lisp_proc *)CC_gbEABsortWset, 1},
    {"gb%ABreduce", (lisp_proc *)CC_gbEABreduce, 4},
    {"gb%ABbigMaxCp", (lisp_proc *)CC_gbEABbigMaxCp, 3},
    {"gb%ABdelErrTerm", (lisp_proc *)CC_gbEABdelErrTerm, 2},
    {"gb%ABwset2polyset", (lisp_proc *)CC_gbEABwset2polyset, 1},
    {"gb%oldinsSset", (lisp_proc *)CC_gbEoldinsSset, 2},
    {"gb%oldinsWset", (lisp_proc *)CC_gbEoldinsWset, 2},
    {"gb%ABnormalz", (lisp_proc *)CC_gbEABnormalz, 3},
    {"gb%ABwset2wset", (lisp_proc *)CC_gbEABwset2wset, 1},
    {"gb%wset2ABset", (lisp_proc *)CC_gbEwset2ABset, 1},
    {"gb%ABmkwprep", (lisp_proc *)CC_gbEABmkwprep, 4},
    {" appGroeb", (lisp_proc *)CC_AappGroeb, 3},
    {"gb%ABGaussFelim", (lisp_proc *)CC_gbEABGaussFelim, 3},
    {"gb%ABmatxMkMatx", (lisp_proc *)CC_gbEABmatxMkMatx, 4},
    {"gb%BADmkspol", (lisp_proc *)CC_gbEBADmkspol, 6},
    {"gb%ABredSsetSmHx", (lisp_proc *)CC_gbEABredSsetSmHx, 3},
    {"gb%ABinsSset", (lisp_proc *)CC_gbEABinsSset, 2},
    {"gb%ABinsWset", (lisp_proc *)CC_gbEABinsWset, 2},
    {"gb%ABfindReducer", (lisp_proc *)CC_gbEABfindReducer, 4},
    {"gb%ABevalInf4", (lisp_proc *)CC_gbEABevalInf4, 3},
    {"gb%ABinsbigCCs", (lisp_proc *)CC_gbEABinsbigCCs, 3},
    {"gb%ABevalsysIC", (lisp_proc *)CC_gbEABevalsysIC, 1},
    {"gb%ABspol", (lisp_proc *)CC_gbEABspol, 4},
    {"gb%errPolp", (lisp_proc *)CC_gbEerrPolp, 2},
    {"gb%fnorm", (lisp_proc *)CC_gbEfnorm, 1},
    {"gb%primono", (lisp_proc *)CC_gbEprimono, 2},
    {"gb%print", (lisp_proc *)CC_gbEprint, 5},
    {"gb%delSmall", (lisp_proc *)CC_gbEdelSmall, 2},
    {"gb%smallp", (lisp_proc *)CC_gbEsmallp, 2},
    {"gb%cuttrm", (lisp_proc *)CC_gbEcuttrm, 2},
    {"gb%cutterm", (lisp_proc *)CC_gbEcutterm, 2},
    {"gb%flessp", (lisp_proc *)CC_gbEflessp, 2},
    {"gb%epscf", (lisp_proc *)CC_gbEepscf, 2},
    {"gb%epscof", (lisp_proc *)CC_gbEepscof, 2},
    {"gb%mnfctr", (lisp_proc *)CC_gbEmnfctr, 3},
    {"gb%simp", (lisp_proc *)CC_gbEsimp, 2},
    {"gb%stop", (lisp_proc *)CC_gbEstop, 1},
    {"gb%syzy2polyset", (lisp_proc *)CC_gbEsyzy2polyset, 1},
    {"gb%syzysave", (lisp_proc *)CC_gbEsyzysave, 3},
    {"gb%syzyclear", (lisp_proc *)CC_gbEsyzyclear, 1},
    {"gb%syzyupdate", (lisp_proc *)CC_gbEsyzyupdate, 4},
    {"gb%wset2polyset", (lisp_proc *)CC_gbEwset2polyset, 1},
    {"gb%num*dist", (lisp_proc *)CC_gbEnumHdist, 2},
    {"gb%cofmxmn", (lisp_proc *)CC_gbEcofmxmn, 2},
    {"gb%cofmaxmin", (lisp_proc *)CC_gbEcofmaxmin, 1},
    {"gb%Fnormlz0", (lisp_proc *)CC_gbEFnormlz0, 2},
    {"gb%normalz", (lisp_proc *)CC_gbEnormalz, 2},
    {"gb%nrm", (lisp_proc *)CC_gbEnrm, 2},
    {"gb%rnorm", (lisp_proc *)CC_gbErnorm, 1},
    {"gb%norm", (lisp_proc *)CC_gbEnorm, 1},
    {"gb%coeftype", (lisp_proc *)CC_gbEcoeftype, 1},
    {"gb%gcdchk", (lisp_proc *)CC_gbEgcdchk, 4},
    {"gb%redchk0", (lisp_proc *)CC_gbEredchk0, 3},
    {"gb%redchk", (lisp_proc *)CC_gbEredchk, 3},
    {"gb%ord>", (lisp_proc *)CC_gbEordS, 3},
    {"gb%irred", (lisp_proc *)CC_gbEirred, 3},
    {"gb%hex>", (lisp_proc *)CC_gbEhexS, 2},
    {"gb%rest", (lisp_proc *)CC_gbErest, 1},
    {"gb%lc", (lisp_proc *)CC_gbElc, 1},
    {"gb%hc", (lisp_proc *)CC_gbEhc, 1},
    {"gb%hex", (lisp_proc *)CC_gbEhex, 1},
    {"gb%cof*dist", (lisp_proc *)CC_gbEcofHdist, 2},
    {"gb%term*dist", (lisp_proc *)CC_gbEtermHdist, 3},
    {"gb%se:dist+dist", (lisp_proc *)CC_gbEseTdistLdist, 2},
    {"gb%dist*dist", (lisp_proc *)CC_gbEdistHdist, 2},
    {"gb%dist+dist", (lisp_proc *)CC_gbEdistLdist, 2},
    {"gb%mkmono", (lisp_proc *)CC_gbEmkmono, 3},
    {"gb%chgVarorder", (lisp_proc *)CC_gbEchgVarorder, 2},
    {"gb%dist2bpol", (lisp_proc *)CC_gbEdist2bpol, 3},
    {"gb%dist2poly", (lisp_proc *)CC_gbEdist2poly, 3},
    {"gb%lex2tord", (lisp_proc *)CC_gbElex2tord, 2},
    {"gb%bpol2dist", (lisp_proc *)CC_gbEbpol2dist, 5},
    {"gb%poly2dist", (lisp_proc *)CC_gbEpoly2dist, 3},
    {"gb%num2dist", (lisp_proc *)CC_gbEnum2dist, 3},
    {"gb%fred", (lisp_proc *)CC_gbEfred, 3},
    {"gb%hred", (lisp_proc *)CC_gbEhred, 3},
    {"gb%redpol", (lisp_proc *)CC_gbEredpol, 4},
    {"gb%reduce", (lisp_proc *)CC_gbEreduce, 3},
    {"gb%spol", (lisp_proc *)CC_gbEspol, 3},
    {"gb%paircof", (lisp_proc *)CC_gbEpaircof, 2},
    {"gb%inswset", (lisp_proc *)CC_gbEinswset, 2},
    {"gb%delunp#", (lisp_proc *)CC_gbEdelunpC, 2},
    {"gb%insunp#", (lisp_proc *)CC_gbEinsunpC, 2},
    {"gb%initunp#s", (lisp_proc *)CC_gbEinitunpCs, 2},
    {"gb%mkwprep", (lisp_proc *)CC_gbEmkwprep, 3},
    {"gb%initialz", (lisp_proc *)CC_gbEinitialz, 3},
    {"gb%Qgroeb*", (lisp_proc *)CC_gbEQgroebH, 2},
    {" Fgroeb", (lisp_proc *)CC_AFgroeb, 2},
    {" ZpGroeb", (lisp_proc *)CC_AZpGroeb, 2},
    {" Qgroeb", (lisp_proc *)CC_AQgroeb, 2},
    {"gb%accMinMax", (lisp_proc *)CC_gbEaccMinMax, 1},
    {"gb%accMax", (lisp_proc *)CC_gbEaccMax, 1},
    {"gb%accMin", (lisp_proc *)CC_gbEaccMin, 1},
    {"gb%epartMax", (lisp_proc *)CC_gbEepartMax, 1},
    {"gb%vpartMax", (lisp_proc *)CC_gbEvpartMax, 1},
    {"gb%maxcoferr", (lisp_proc *)CC_gbEmaxcoferr, 1},
    {"acczerop", (lisp_proc *)CC_acczerop, 2},
    {"delErTm:bpol", (lisp_proc *)CC_delErTmTbpol, 2},
    {"delErrTerm", (lisp_proc *)CC_delErrTerm, 2},
    {"truncat3dgt", (lisp_proc *)CC_truncat3dgt, 1},
    {"fmmc:bef2float", (lisp_proc *)CC_fmmcTbef2float, 1},
    {" fmmc", (lisp_proc *)CC_Afmmc, 1},
    {" randomD7", (lisp_proc *)CC_ArandomD7, 1},
    {" pkgparam", (lisp_proc *)CC_Apkgparam, 3},
    {"ZEROp", (lisp_proc *)CC_ZEROp, 1},
    {"ONEp", (lisp_proc *)CC_ONEp, 1},
    {NULL, NULL, 0 }
};

