#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 1 "asuka.y"
 

/*
 *    asuka.y           (C) Copyright 1998-2000, 2007 by Fujio Kako, Nara Women's University.
 *      read parser for maple-like syntax
 *      $Header: /Users/kako/asuka/src/RCS/asuka.y,v 2.24 2016/04/08 07:19:55 kako Exp $
 */

static char const rcsid[] =
    "$Id: asuka.y,v 2.24 2016/04/08 07:19:55 kako Exp $";


#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include "config.h"
#include "tags.h"
#include "externs.h"
#include "entries.h"
#include "macros.h"
#include "read.h"
#include "fns.h"

/*
 * #define YYSTYPE Sex
 */

void            yyerror(char *);
static int      stmt_count = 0;

extern Sex     *parse_value_ptr;
extern Sex      proc_frame;
extern Sex      loop_frame;

extern Sex      onbeepre_symbol;
extern Sex      twbeepre_symbol;
extern Sex      thbeepre_symbol;

Sex             symtab;
Sex             methnames,
                methdefs;

static int      label_count = 0;
static int      in_proc = 0;
static int      in_loop = 0;

static void     begin_loop(void);
static void     end_loop(void);
static void     begin_proc(void);
static void     end_proc(void);
void            clear_loop(void);

static Sex	make_try(Sex, Sex, Sex);

static Sex      pickup_globals(Sex);

static          Sex make_statements(Sex l, Sex a);
static          Sex make_statements1(Sex a);

static Sex      make_name1(Sex a, Sex b);
static Sex      make_proc(Sex, Sex, Sex);
static Sex      make_proc_body(Sex);
static Sex      make_func1(Sex, Sex, Sex);
static Sex      make_func2(Sex, Sex, Sex);
static Sex      make_funcall(Sex, Sex);
static Sex      make_if(Sex, Sex, Sex);

static Sex      make_switch(Sex, Sex);
static Sex      make_case(Sex, Sex, Sex);

static Sex      expand_loop(Sex);
static Sex      expand_for(Sex, Sex, Sex);
static Sex      expand_while(Sex, Sex, Sex);
static Sex      expand_repeat(Sex, Sex, Sex);
static Sex      expand_foreach(Sex, Sex, Sex);
static Sex      expand_foreach_expression(Sex, Sex, Sex);
static Sex      expand_for_expression(Sex, Sex, Sex);

static Sex      make_break(Sex);
static Sex      make_continue(Sex);
static Sex      make_return0(void);
static Sex      make_return1(Sex);

static Sex      expand2(Sex);

extern Sex      gdiff2(Sex, Sex);

extern Sex      error(char *s);
extern Sex      Lstrcat(Sex, Sex);
#line 96 "asuka.y"
typedef union {
	long itype;
	int lineno;
	Sex sex;
} YYSTYPE;
#line 108 "asuka.tab.c"
#define QUOTE 257
#define LITERAL 258
#define STOP 259
#define SYMBOL 260
#define STRING 261
#define EOF_TOKEN 262
#define UNKNOWN 263
#define NUOPE 264
#define TWBEEPRE 265
#define THBEEXPRE 266
#define NUMBER 267
#define SHOSSU 268
#define ONEBEEPRE 269
#define OD 270
#define OPTION 271
#define OPTIONS 272
#define PROC 273
#define QUIT 274
#define THEN 275
#define TO 276
#define DOWNTO 277
#define WHILE 278
#define REPEAT 279
#define UNTIL 280
#define BEGIN 281
#define RETURN 282
#define BREAK 283
#define CONTINUE 284
#define ARRAY 285
#define VECTOR 286
#define MATRIX 287
#define BY 288
#define DO 289
#define DONE 290
#define ELIF 291
#define ELSE 292
#define FI 293
#define FOR 294
#define FROM 295
#define IF 296
#define IN 297
#define LOCAL 298
#define END 299
#define GLOBAL 300
#define SETORDER 301
#define ORDER_LEX 302
#define ORDER_TLEX 303
#define ORDER_RLEX 304
#define ORDER_GRADINGS 305
#define FOREACH 306
#define ON 307
#define ENABLE 308
#define DISABLE 309
#define OR 310
#define AND 311
#define NOT 312
#define MOD 313
#define SMOD 314
#define UNION 315
#define NONCOMU 316
#define INTERSECT 317
#define LESSER_EQUAL 318
#define GREATER_EQUAL 319
#define NOT_EQUAL 320
#define COLON_EQUAL 321
#define READ 322
#define IMPORT 323
#define SAVE 324
#define WRITE 325
#define WRITEN 326
#define PRINTF 327
#define LOAD 328
#define CLEAR 329
#define XDEBUG 330
#define XDEBUGN 331
#define ALGEBRAIC 332
#define WITH 333
#define TRY 334
#define THROW 335
#define CATCH 336
#define SWITCH 337
#define HCTIWS 338
#define CASE 339
#define ESAC 340
#define OF 341
#define DEFAULT 342
#define QUOTE_SYMBOL 343
#define SUM 344
#define PRODUCT 345
#define COLLECT 346
#define CONC 347
#define JOIN 348
#define REMAINDER 349
#define ITRSYTH 350
#define ARROWOPE 351
#define SEMICOLON_SEMICOLON 352
#define SET_DIFF 353
#define OMIT 354
#define UNARY 355
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    2,   15,
   15,   50,   50,   50,   24,   25,   26,   26,   26,   26,
   26,   27,   27,   28,   29,   29,   61,   16,   62,   17,
   18,   51,   51,   51,   51,   51,   63,   19,   22,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   20,   52,
   52,   52,   52,   52,   64,   21,   23,   23,   42,   42,
   44,   30,   34,   34,   34,   34,   35,   35,   35,   35,
   36,   36,   36,   36,   36,   36,   37,   37,   38,   39,
   39,   39,   57,   57,   57,   57,   40,   41,   45,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   46,   46,
   31,   31,   32,   32,   32,   33,   33,   60,   48,   48,
   48,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   49,   49,   49,
    3,    3,    3,    3,    3,    3,    3,    4,    4,    4,
    5,    5,    5,    6,    6,    6,    6,    6,    7,    7,
    7,    7,    7,    8,    8,    8,    8,    9,    9,    9,
   11,   10,   12,   12,   13,   14,   53,   53,   54,   54,
   55,   55,   56,   56,   56,   58,   58,   59,
};
short yylen[] = {                                         2,
    2,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    3,    3,    6,
    5,    0,    2,    5,    5,    3,    1,    2,    2,    3,
    2,    5,    7,    4,    1,    2,    0,    6,    0,    5,
    4,    3,    3,    3,    3,    3,    0,    3,    5,    7,
    5,    7,    5,    7,    7,    5,    7,    7,    4,    3,
    3,    3,    3,    3,    0,    3,    3,    3,    1,    1,
    0,    2,    2,    2,    3,    3,    2,    2,    3,    3,
    2,    2,    4,    4,    6,    6,    2,    2,    2,    2,
    4,    4,    3,    3,    3,    3,    2,    2,    1,    3,
    3,    3,    6,    8,   10,    6,    8,   10,    6,    4,
    5,    6,    4,    4,    2,    6,    5,    1,    1,    3,
    0,    2,    2,    3,    2,    2,    3,    3,    1,    2,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    4,    6,    6,    4,    2,    1,    1,    3,    1,    1,
    4,    6,    8,    5,    1,    1,    1,    0,    2,    5,
    5,    7,    9,    6,    8,   10,    2,    7,    8,    2,
    5,    6,    2,    2,    2,    2,    2,    2,    3,    3,
    3,    5,    2,    4,    6,    6,    5,    7,    6,    2,
    1,    4,    2,    1,    1,    1,    3,    0,    1,    2,
    1,    3,    1,    3,    3,    1,    3,    1,
};
short yydefred[] = {                                      0,
    0,    0,  236,  238,    3,    4,    0,  221,   35,   57,
   59,    0,  225,  226,    0,    0,    0,   67,    0,    0,
    0,   85,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  179,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   23,   24,   28,    0,   29,
   30,   31,    5,   19,   20,   17,    0,   18,    0,    6,
    7,    8,   33,   34,    0,    0,   11,   12,   13,   14,
   15,   16,   22,   21,   89,   90,   32,    0,  185,  186,
    0,    0,  177,    0,    0,    0,  233,    0,    0,  187,
    0,    0,    0,    0,    0,  197,    0,  203,    0,  200,
    0,    0,    0,    0,    0,    0,  208,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   93,   94,   97,   98,
    0,    0,    0,  109,    0,  110,  117,    0,    0,    0,
    0,  118,    0,    0,    0,    0,  138,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    2,    1,
    0,    0,    0,  220,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  146,    0,    0,
    0,    0,    0,  178,    0,    0,   37,    0,    0,    0,
    0,    0,    0,   68,    0,    0,    0,    0,    0,    0,
    0,    0,   86,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  151,  148,  147,  144,
  237,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   95,   96,   99,
  100,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  234,  235,    0,    0,  122,  121,    0,    0,    0,  174,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  111,    0,  112,    0,    0,  104,    0,  103,    0,    0,
    0,    0,    0,    0,    0,   55,    0,    0,    0,    0,
    0,    0,    0,   61,   79,  171,    0,    0,    0,    0,
    0,    0,    0,    0,   39,   38,    0,    0,  181,    0,
  191,  201,    0,    0,    0,    0,    0,    0,    0,  184,
    0,    0,  212,    0,    0,    0,    0,  114,  113,  116,
  115,    0,    0,    0,  131,    0,    0,   48,   45,    0,
   49,    0,    0,   52,   56,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   40,    0,
    0,    0,  172,  173,  106,  105,    0,    0,  132,   50,
    0,    0,    0,    0,  194,    0,  202,    0,  219,    0,
    0,    0,    0,    0,    0,    0,    0,  126,    0,    0,
  182,    0,  192,  198,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   53,    0,    0,    0,  229,    0,  218,
    0,    0,    0,  227,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  195,
  199,    0,  230,    0,    0,    0,  127,    0,  183,  193,
    0,    0,    0,    0,    0,    0,   44,  190,    0,    0,
    0,  222,    0,  136,  196,  128,    0,
};
short yydgoto[] = {                                      51,
  207,  208,   53,   54,   55,   56,   57,  285,   58,  429,
   59,   60,   61,   62,   63,   64,   65,   66,  102,   68,
  103,  214,  223,   70,  323,  324,   71,  326,  327,   72,
   73,   74,  377,   75,   76,   77,   78,   79,   80,   81,
   82,   83,   84,   85,   86,   87,  138,  325,  360,  357,
   89,   90,  396,  459,  118,   91,  228,  105,   93,  148,
   98,   99,  112,  126,
};
short yysindex[] = {                                  12484,
    0, -257,    0,    0,    0,    0,  -13,    0,    0,    0,
    0, 2337,    0,    0,  109,  268,  294,    0, 2337,  125,
  -52,    0, -235, -195, 2337,   15,   16, -223,  -29, -223,
 2337, 2337,   54, -223,   69, 2337, 2337,   69, -149, -149,
 2337, 2337,    0,   78, 2337, 2337, 2337, 2337, 2337,  -80,
    0,   -8,  166,  174,  178,    0,    0,    0,  319,    0,
    0,    0,    0,    0,    0,    0,  254,    0,  281,    0,
    0,    0,    0,    0,  179,  183,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4240,    0,    0,
  196,  -76,    0,   11, 2337,  195,    0, 2337,12664,    0,
 2337,  329,  429, 4240,  182,    0,  186,    0,  222,    0,
  244,   69, 3020,  166,  174,  178,    0,  226,  195,  -62,
   69,   69,   69, 2337,  226,   69,    0,    0,    0,    0,
   19, 2337, 2337,    0,  122,    0,    0, 4240,  309,  309,
  -12,    0,  226,  309,  309,  -16,    0,  104,  348, 3042,
 3083,  366,   -7,  -11,    7,    7, 3170,  317,    0,    0,
   69,   69,   69,    0,  334,12664, 2337, 2337, 2337, 2337,
 2337,12664, 2337, 2337, 2337, 2337, 2337, -124, -123, 2337,
 2337, 2337, 2337, 2337, 2337, 2337, 2337, 2337, 2337, 2337,
 2337, 2337, 2337, 2337, 2337, 2337, 2337,    0, 2337,  -21,
 2337, 7792, 2337,    0, 3229, 3325,    0,   -2, 3366, 2337,
 2337, 2337, 2337,    0,  -39,12664,   69, 2337,  226,  226,
  226, 3407,    0,  -10, 3431, 3491,   66,  117, 2337,   41,
  219, 2337,12664, 2337, 2337, 2337,    0,    0,    0,    0,
    0,  323,  344,  349,   26,  -50, 4240, 4240, 4240, 4240,
 4240,    9, 4240, 4240, 4240, 4240, 4240,    0,    0,    0,
    0, 2135,   19,  229,  229, 1132, 1132,  -31,  -31,   27,
  -31,  -31,   27,  -23,  -23,    7,    7,  387,    7, 1132,
    0,    0,  240, 3473,    0,    0, 4423,  -40, 2461,    0,
12664, 2337,12664,12664, 2337, 2498, 2519, 3512, 3556, 2337,
  -54, 2563,  195, 2574,   69, 2337, 2337, 2337, 2337, -232,
    0,  -51,    0, 4240, 2337,    0, 2337,    0, 4412,  -27,
 4240,    0,  394,13091,   95,    0, 1721,   96, 2337, 2337,
 2337,  396,  357,    0,    0,    0,  106,  377,  105,  160,
 2337,  140,   29, 4240,    0,    0, 2563, 2337,    0, 2337,
    0,    0, 2337, 1437, 2337,12664,  169, 2337, 2337,    0,
 2337,  140,    0, 4240, 4240, 3649, 3721,    0,    0,    0,
    0,  388,  395, 2337,    0,  128,  198,    0,    0, 2337,
    0,12664,12664,    0,    0,12664, 2645, 3604, 3791,  184,
  407,  160,  118,  130,   69, 2337, 2708, 2337,    0, 2853,
 2875, 3817, 2337, 2337, 2337, 2337, 3883,   48,    0, 3894,
 4240, 2939,    0,    0,    0,    0,   27,  193,    0,    0,
   48,   18,   50, 2337,    0, 2337,    0,  160,    0,  184,
 2337,  160,  160,   73,  309, 2337,  163,    0, 4423, 2337,
    0, 2337,    0,    0, 3939, 3950, 4018, 2200,12664, 2337,
 2337,  163,12664,    0,12664, 2998, 3961,    0,12574,    0,
  309, 2337, 2337,    0, 4129, 2337, 4251, 4262, 2337, 2337,
 2337, 2337, 2337, 2337,  -54, 2563, 4315,   71, 2337,    0,
    0,   67,    0,  309,  309,  167,    0, 4423,    0,    0,
 4240, 4240, 4240, 4240, 4240, 4240,    0,    0,  167,  428,
 4336,    0, 2337,    0,    0,    0, 4423,
};
short yyrindex[] = {                                     57,
 1580,    0,    0,    0,    0,    0, 1197,    0,    0,    0,
    0,  372,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  786,  786,    0,    0,    0,  786,  786,    0,    0,    0,
    0,    0,    0,  676,  262,    2,    0,    0,    0,    0,
    0,    0, 9420, 9508, 9583,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 9680, 9768,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,11985,    0,    0,
  993, 1514,    0,    0,    0,  472,    0,    0,   72,    0,
    0,    0,    0,12052,  576,    0,    0,    0,    0,    0,
    0,    0,    0, 9843, 9940,10028,    0,10103, 9063, 9248,
    0,    0,    0,    0,10200,    0,    0,    0,    0,    0,
 6413,    0,    0,    0,    0,    0,    0,10288,10363,10460,
    0,    0,10548,10623,10720,    0,    0,    0,10808,    0,
    0, 1087,    0,    0, 4749, 4859,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   93,    0,    0,    0,    0,
    0,   93,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  403,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  803,    0,    0,10883,10980,
11068,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   70,    0,  100,  100,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 7656, 7884, 7977, 8074,
 8223,    0, 8320, 8413, 8514, 8641, 8742,    0,    0,    0,
    0, 6727, 6617, 6821, 6931, 7135, 7245, 5691, 5785, 6209,
 5895, 6099, 6303, 5377, 5581, 5063, 5173, 4655, 5267, 7339,
    0,    0,    0,    0,    0,    0,11672, 2405,    0,    0,
   93,    0,  803,  803,    0,    0,    0,    0,    0,    0,
12982,12396, 9160,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,11166,  403,    0,  403,    0,12157,    0,
12224, 1646,13050,  100,    0,    0,  100,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 4359, 9323,
    0, 1960,    0,12298,    0,    0, 8932,    0,    0,    0,
    0,    0,    0,    0,    0,  803,11240,    0,    0,    0,
    0,    0,    0,  299,  341,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   -5,
    0,   34,   39,    0,    0,   57,    0,    0,    0,    0,
    0, 9323,    0,    0,    0,  786,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,12965,    0,    0,
 8835,    0,    0,    0,    0,    0, 7449,    0,    0,    0,
13067,    0,    0,    0,    0,    0,    0, 7567,    0,    0,
  786, 9323, 9323,    0,11307,    0, 2026,    0,11739,    0,
    0,    0,    0,    0,  350,  359,  411,  533,  803,    0,
    0,    0,   93,    0,  -36,    0,    0,    0,   90,    0,
11426,  786,  786,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,12982, 8932,    0,    0,    0,    0,
    0,    0,    0,11500,11567, 2092,    0,11813,    0,    0,
  553,  559,  613,  653,  658,  723,    0,    0,    0,  220,
    0,    0,    0,    0,    0,    0,11911,
};
short yygindex[] = {                                      0,
   21, -125,  471,  473,  476,    0,    0,    0,    0,   76,
    0,    0,    0,    0,    0,    0,    0,    0,  155,    0,
  201,    0,    0,    0, -290,    0,    0,  170,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   -3,    0,    0,    0,    1,  111,   23,   28,
    0,    0,  144,    0,  -17,   38,    0,  103,  449,  462,
    0,    0,    0,    0,
};
#define YYTABLESIZE 13434
short yytable[] = {                                     201,
   88,  198,   94,  125,  294,  200,  200,   54,  294,  198,
  194,  192,  104,  193,  203,  195,  117,  143,  194,  113,
   52,   54,   91,  195,  127,  131,   95,  368,  218,  200,
  135,  294,  229,  381,  369,  200,  229,    4,   51,  198,
  246,  150,  151,   50,   96,  141,  252,  155,  156,  157,
  160,  198,   51,   51,  132,  133,  294,  119,  119,  198,
  194,  192,  196,  193,  129,  195,  332,  294,  194,  192,
  196,  193,  119,  195,   50,  146,  294,   91,  189,  191,
  190,  316,   50,   50,  315,  238,  189,  294,  190,  420,
  301,   91,   91,  141,  128,  205,  165,   91,  206,   88,
  196,  209,   92,  219,  220,  221,  294,  320,  455,   97,
  147,  310,  196,  239,  152,   91,  217,  107,  109,  111,
  196,   50,  120,   97,  222,  294,  141,  311,   91,  294,
   91,  464,  225,  226,  130,  258,  260,   97,  229,  229,
   97,  139,  140,  141,  201,  394,  144,  145,   91,  215,
  200,   91,  382,  386,   67,  153,  154,  141,  119,  119,
  119,   97,  312,  224,   50,  343,   88,  247,  248,  249,
  250,  251,   88,  253,  254,  255,  256,  257,  313,  158,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  286,  280,
   69,   92,  287,  289,   50,  259,  261,    3,  370,  161,
  296,  297,  298,  299,   97,  371,  302,  162,  304,  334,
   50,  163,  178,   97,   97,   97,  179,  333,   97,  314,
  408,    4,  319,   88,  321,  201,  355,  356,    3,  288,
  200,  200,  375,  230,  202,  281,    3,    3,    4,  121,
  122,  123,  124,   67,  303,   54,  421,  422,  202,  318,
  423,  198,  317,  242,  243,  244,  338,  204,   92,  217,
  194,  192,  210,  193,   92,  195,  211,  292,  335,  376,
  336,  300,  119,  229,  157,    3,  306,  363,  189,  191,
  190,   88,  344,   88,   88,  347,  307,  293,  399,   69,
  354,  293,  282,   54,   92,  141,  364,  365,  366,  367,
  340,  283,  212,  345,  346,   91,  232,  197,   92,   97,
   67,  339,  196,  475,  293,  197,   67,  478,    3,  387,
  388,  389,   51,  482,  213,   92,  186,  187,  188,   91,
  500,  397,  119,  159,  186,  187,  328,   97,  400,  293,
  401,   91,  229,  402,  141,  407,   88,  454,  410,  411,
  293,  412,   91,   50,  106,  502,   69,  197,    3,  293,
   67,   91,   69,  245,  417,  197,   91,  434,   91,  200,
  293,  227,   88,   88,    3,   91,   88,   67,   91,   50,
   91,  234,  233,   92,  438,   92,   92,  391,  439,  293,
  217,  293,  237,  445,  446,  447,  448,   97,   91,   15,
   16,   17,  241,  329,   50,  224,   69,  393,  293,  198,
  217,   91,  293,   91,  456,  372,  457,  373,  415,  224,
  224,  229,  119,   69,  330,  416,  465,  328,  229,  331,
  467,   91,  468,  141,   91,   67,  141,   67,   67,   88,
  476,  477,  378,   88,  390,   88,  392,  395,   92,   88,
  398,  409,  487,  418,  428,  430,  488,  419,  432,  491,
  492,  493,  494,  495,  496,  346,  134,  136,  137,  501,
  433,  453,  142,  466,   92,   92,  504,  503,   92,  137,
  114,   69,  115,   69,   69,  116,  385,   97,  498,  506,
   92,  149,  497,  507,  175,  460,  435,    0,  175,    0,
   67,  175,  175,  175,  175,  175,  175,    0,  175,    0,
    0,    0,    0,  108,    0,    0,    0,    3,    0,  175,
  175,  175,  175,  175,    0,  431,   67,   67,  180,  181,
   67,  461,  166,    0,    0,    0,  186,  187,  188,  110,
    0,   92,    0,    3,    0,   92,   69,   92,    0,    0,
    0,   92,  175,    0,  175,  175,    0,  175,   92,  172,
    0,  458,  484,  485,  164,  462,  463,  197,    3,    0,
    0,    0,   69,   69,    0,    0,   69,   87,    0,  231,
    0,    0,    0,    0,  175,    0,  175,  167,  168,  169,
  170,  171,  483,   67,    0,   92,    0,   67,  233,   67,
    0,    0,  233,   67,    0,  233,  233,  233,  233,  233,
  233,  233,  233,    0,  173,  174,  175,  176,  177,   88,
    0,    0,    0,  233,  233,  233,  233,  233,   69,    0,
    0,  224,   87,   87,   87,   87,   87,   73,    0,   69,
    0,  224,    0,   69,    0,   69,    0,    0,    0,   69,
    0,    0,  224,  224,  224,    0,    0,    0,  233,  233,
  224,  233,  167,  168,  169,  170,  171,    0,  224,    0,
    0,    0,  322,    0,   88,   88,   88,   88,   88,    0,
    0,    0,    0,   69,   69,   69,   69,   69,  233,   76,
  233,    0,   73,   73,   73,   73,   73,    0,  149,  224,
    0,  224,    0,    0,    0,  149,  149,  149,  149,  149,
  149,    0,  149,  224,    0,    0,    0,  175,  175,    0,
    0,  175,  175,  149,  149,  149,  149,  149,  175,    0,
    0,  175,    0,    0,    0,    0,  175,  175,  175,  175,
    0,  175,    0,    0,   76,   76,   76,   76,   76,  175,
  175,    0,  175,  175,  175,  175,  149,  175,  149,  149,
  175,  149,  173,  174,  175,  176,  177,  175,  175,    0,
    0,  175,  175,  175,  175,  175,  175,    0,  175,  175,
  175,  175,    0,    0,    0,    0,    0,    0,  149,    0,
  149,    0,    0,    0,    0,    0,    0,    0,    0,  175,
    0,  175,  175,    0,  175,  175,  175,  175,  175,  175,
  175,   71,    0,  175,  175,    0,    0,    0,    0,  141,
    0,  233,  233,    0,    0,  233,  233,    0,    0,    0,
    0,   70,  233,  141,  141,  233,   91,   74,    0,    0,
  233,  233,  233,  233,    0,  233,    0,    0,    0,    0,
   91,   91,    0,  233,  233,    0,  233,  233,  233,  233,
    0,  233,    0,    0,  233,    0,   71,   71,   71,   71,
   71,  233,  233,    0,    0,  233,  233,  233,  233,  233,
  233,    0,  233,  233,  233,  233,   70,   70,   70,   70,
   70,   77,   74,   74,   74,   74,   74,    0,    0,    0,
    0,    0,    0,  233,    0,  233,  233,    0,  233,  233,
  233,  233,  233,  233,  233,    0,    0,  233,  233,    0,
    0,  149,  149,    0,    0,  149,  149,    0,    0,    0,
    0,   72,  149,    0,    0,  149,   75,    0,    0,    0,
  149,  149,  149,  149,    0,  149,   77,   77,   77,   77,
   77,    0,    0,  149,  149,    0,  149,  149,  149,  149,
    0,  149,    0,    0,  149,    0,    0,    0,    0,    0,
    0,  149,  149,    0,    0,  149,  149,  149,  149,  149,
  149,    0,  149,  149,  149,  149,   72,   72,   72,   72,
   72,   75,   75,   75,   75,   75,    0,    0,    0,    0,
    0,   78,    0,  149,    0,  149,  149,    0,  149,  149,
  149,  149,  149,  149,  149,  176,    0,  149,  149,  176,
    0,    0,    0,  176,  176,  176,  176,  176,    0,  176,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  176,  176,  176,  176,  176,  141,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  141,   78,   78,   78,   78,
   78,    0,   91,    0,    0,    0,  141,  141,  141,    0,
    0,    0,   91,  176,  141,  176,  176,    0,  176,    0,
    0,    0,  141,   91,   91,   91,    0,    0,    0,    0,
    0,   91,    0,    0,    0,    0,    0,    0,    0,   91,
    0,    0,    0,    0,    0,  176,    0,  176,    0,  150,
    0,    0,    0,  141,    0,  141,  150,  150,  150,  150,
  150,  150,    0,  150,    0,    0,    0,  141,    0,    0,
   91,    0,   91,    0,  150,  150,  150,  150,  150,    0,
    0,    0,    0,    0,   91,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  198,    0,    0,    0,    0,    0,
    0,    0,    0,  194,  192,    0,  193,  150,  195,  150,
  150,    0,  150,    0,    0,    0,    0,    0,    0,    0,
    0,  189,  191,  190,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  150,
    0,  150,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  196,    0,    0,    0,  180,
    0,    0,    0,  180,    0,    0,    0,  180,  180,  180,
  180,  180,    0,  180,    0,    0,    0,    0,  176,  176,
    0,    0,  176,  176,  180,  180,  180,  180,  180,  176,
    0,    0,  176,    0,    0,    0,    0,  176,  176,  176,
  176,    0,  176,    0,    0,    0,    0,    0,    0,    0,
  176,  176,    0,  176,  176,  176,  176,  180,  176,  180,
  180,  176,    0,    0,    0,    0,    0,    0,  176,  176,
    0,    0,  176,  176,  176,  176,  176,  176,    0,  176,
  176,  176,  176,    0,    0,    0,    0,    0,    0,  180,
    0,  180,    0,    0,    0,    0,    0,    0,    0,    0,
  176,    0,  176,  176,    0,  176,  176,  176,  176,  176,
  176,  176,  150,  150,  176,  176,  150,  150,    0,    0,
    0,    0,    0,  150,    0,    0,  150,    0,    0,    0,
    0,  150,  150,  150,  150,    0,  150,    0,    0,    0,
    0,    0,    0,    0,  150,  150,    0,  150,  150,  150,
  150,    0,  150,    0,    0,  150,    0,    0,    0,    0,
    0,    0,  150,  150,    0,    0,  150,  150,  150,  150,
  150,  150,    0,  150,  150,  150,  150,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  150,    0,  150,  150,    0,  150,
  150,  150,  150,  150,  150,  150,    0,    0,  150,  150,
    0,  180,  181,    0,  182,  183,    0,    0,    0,  186,
  187,  188,  180,  180,    0,    0,    0,  180,    0,    0,
    0,    0,    0,  180,    0,    0,  180,    0,    0,  198,
    0,  180,  180,  180,  180,    0,  180,    0,  194,  192,
  197,  193,    0,  195,  180,  180,    0,  180,  180,  180,
  180,    0,  180,    0,    0,  180,  189,  191,  190,    0,
    0,    0,  180,  180,    0,    0,  180,  180,  180,  180,
  180,  180,    0,  180,  180,  180,  180,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  196,    0,    0,    0,  180,    0,  180,  180,    0,  180,
  180,  180,  180,  180,  180,  180,  233,    0,  180,  180,
  233,    0,    0,  233,    0,  233,  233,  233,  233,  233,
  233,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  233,  233,  233,  233,  233,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  233,    0,  233,
    0,    0,  187,    0,    0,    0,   36,    0,    0,   36,
    0,  187,   36,   36,   36,    0,  187,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  233,   36,   36,  187,
  187,  187,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   36,    0,    0,  187,    0,   36,    0,    0,  177,    0,
    0,    0,  134,    0,    0,  134,    0,  177,  134,  134,
  134,    0,  177,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   36,  134,  134,  177,  177,  177,    0,    0,
    0,    0,  403,  404,  405,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  406,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  134,    0,    0,  177,
    0,  134,    0,    0,    0,    0,  180,  181,    0,  182,
  183,  184,    0,  185,  186,  187,  188,   44,    0,    0,
   49,    0,    0,   47,    0,   48,    0,    0,  134,  233,
  233,    0,    0,  233,  233,    0,    0,    0,    0,    0,
  233,    0,    0,  233,    0,  197,    0,    0,    0,  199,
    0,    0,    0,  233,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  233,  233,  233,  233,    0,  233,
    0,   45,  233,    0,    0,    0,   50,    0,    0,  233,
  233,    0,    0,  233,  233,  233,  233,  233,  233,    0,
  233,  233,  233,  233,    0,   36,   36,    0,    0,   36,
   36,    0,    0,   46,    0,    0,   36,    0,    0,   36,
    0,  233,    0,  233,    0,    0,  233,    0,    0,   36,
    0,    0,  233,    0,  233,  233,  233,    0,    0,    0,
   36,   36,   36,   36,    0,   36,    0,    0,   36,    0,
    0,    0,    0,    0,    0,   36,   36,    0,    0,  187,
  187,   36,  187,  187,   36,    0,   36,  187,  187,  187,
    0,  134,  134,    0,    0,  134,  134,    0,    0,    0,
    0,    0,  134,    0,    0,  134,    0,   36,    0,   36,
    0,    0,   36,    0,    0,  134,    0,    0,  187,    0,
    0,   36,  187,    0,    0,    0,  134,  134,  134,  134,
    0,  134,    0,    0,  134,    0,    0,    0,    0,    0,
    0,  134,  134,    0,    0,  177,  177,  134,  177,  177,
  134,    0,  134,  177,  177,  177,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  100,    2,    0,    0,
    3,    4,    0,  134,    0,  134,    0,    7,  134,    0,
    0,    0,  181,    0,  177,    0,  181,  134,  177,  181,
    0,  181,  181,  181,  181,    0,  181,    0,    0,    0,
    0,    0,  383,    0,   18,    0,  101,  181,  181,  181,
  181,  181,    0,    0,    0,    0,   22,    0,    0,    0,
    0,    0,   25,    0,    0,   26,    0,   27,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  181,    0,    0,  181,    0,  181,    0,    0,  182,    0,
  384,    0,  182,   43,    0,  182,    0,  182,  182,  182,
  182,    0,  182,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  181,  182,  182,  182,  182,  182,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  182,    0,    0,  182,
    0,  182,    0,    0,  183,    0,    0,    0,  183,    0,
    0,  183,    0,  183,  183,  183,  183,    0,  183,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  182,  183,
  183,  183,  183,  183,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  198,    0,    0,
    0,    0,    0,    0,    0,    0,  194,  192,    0,  193,
    0,  195,  183,    0,    0,  183,    0,  183,    0,    0,
    0,    0,    0,    0,  189,  191,  190,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  183,  181,  181,    0,    0,  181,
  181,    0,    0,    0,    0,    0,  181,    0,  196,  181,
    0,    0,  198,    0,    0,    0,    0,    0,    0,  181,
    0,  194,  192,    0,  193,    0,  195,    0,    0,    0,
  181,  181,  181,  181,    0,  181,    0,    0,  181,  189,
  191,  190,    0,    0,    0,  181,  181,    0,    0,  181,
  181,  181,  181,  181,  181,    0,  181,  181,  181,  181,
    0,  182,  182,    0,    0,  182,  182,    0,    0,    0,
    0,    0,  182,  196,    0,  182,    0,  181,    0,  181,
    0,    0,  181,    0,    0,  182,    0,    0,  181,    0,
    0,  181,  181,    0,    0,    0,  182,  182,  182,  182,
    0,  182,    0,    0,  182,    0,    0,    0,    0,    0,
    0,  182,  182,    0,    0,  182,  182,  182,  182,  182,
  182,    0,  182,  182,  182,  182,    0,  183,  183,    0,
    0,  183,  183,    0,    0,    0,    0,    0,  183,    0,
    0,  183,    0,  182,    0,  182,    0,    0,  182,    0,
    0,  183,    0,   44,  182,    0,   49,  182,  182,   47,
    0,   48,  183,  183,  183,  183,    0,  183,    0,    0,
  183,    0,    0,    0,    0,    0,    0,  183,  183,    0,
    0,  183,  183,  183,  183,  183,  183,    0,  183,  183,
  183,  183,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,    0,  183,
    0,  183,   50,    0,  183,    0,    0,  176,    0,    0,
  183,  176,    0,  183,  183,  181,  176,  176,  176,  176,
    0,  176,  186,  187,  188,    0,    0,    0,    0,   46,
    0,    0,  176,  176,  176,  176,  176,    0,    0,    0,
    0,    0,    0,    0,    0,  472,  473,  474,    0,    0,
    0,    0,    0,  197,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  198,    0,  176,    0,    0,  176,    0,
  176,    0,  194,  192,  341,  193,    0,  195,    0,  180,
  181,    0,  182,  183,  184,    0,  185,  186,  187,  188,
  189,  191,  190,    0,    0,    0,    0,  176,    0,    0,
  198,    0,    0,    0,    0,    0,    0,    0,    0,  194,
  192,  348,  193,    0,  195,    0,    0,    0,  197,    0,
    0,  198,  199,  342,  196,    0,    0,  189,  191,  190,
  194,  192,  350,  193,    0,  195,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  189,  191,
  190,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  349,  196,  100,    2,    0,  198,    3,    4,    0,    0,
    0,    0,    0,    7,  194,  192,  198,  193,    0,  195,
    0,  351,  196,    0,    0,  194,  192,  361,  193,    0,
  195,    0,  189,  191,  190,    0,    0,    0,    0,    0,
   18,    0,  101,  189,  191,  190,    0,    0,    0,    0,
    0,    0,   22,    0,    0,    0,    0,    0,   25,    0,
    0,   26,    0,   27,    0,    0,  196,    0,    0,    0,
  176,  176,    0,    0,  176,  176,  362,  196,    0,    0,
    0,  176,    0,    0,  176,    0,    0,  198,    0,   43,
    0,    0,    0,    0,  176,    0,  194,  192,  424,  193,
    0,  195,    0,    0,    0,  176,  176,  176,  176,    0,
  176,    0,    0,  176,  189,  191,  190,    0,    0,    0,
  176,  176,    0,    0,  176,  176,  176,  176,  176,  176,
    0,  176,  176,  176,  176,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  425,  196,    0,
  198,    0,  176,    0,  176,    0,    0,  176,    0,  194,
  192,  436,  193,  176,  195,    0,  176,  176,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  189,  191,  190,
  180,  181,    0,  182,  183,  184,    0,  185,  186,  187,
  188,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  437,  196,    0,    0,    0,    0,    0,  180,  181,  197,
  182,  183,  184,  199,  185,  186,  187,  188,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  180,  181,
    0,  182,  183,  184,    0,  185,  186,  187,  188,    0,
    0,    0,    0,    0,    0,    0,  197,    0,    0,    0,
  199,    0,    0,  358,  359,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  197,    0,    0,
    0,  199,  180,  181,    0,  182,  183,  184,    0,  185,
  186,  187,  188,  180,  181,  198,  182,  183,  184,    0,
  185,  186,  187,  188,  194,  192,  440,  193,    0,  195,
    0,    0,    0,    0,    0,    0,    0,  198,    0,    0,
    0,  197,  189,  191,  190,  199,  194,  192,  442,  193,
    0,  195,  197,    0,    0,    0,  199,    0,    0,    0,
    0,    0,    0,    0,  189,  191,  190,    0,    0,    0,
    0,    0,    0,    0,    0,  441,  196,    0,    0,    0,
    0,    0,    0,    0,  180,  181,    0,  182,  183,  184,
    0,  185,  186,  187,  188,    0,    0,  443,  196,    0,
    0,  198,    0,    0,    0,    0,    0,    0,    0,    0,
  194,  192,  451,  193,    0,  195,    0,    0,    0,    0,
    0,    0,    0,  197,    0,    0,    0,  199,  189,  191,
  190,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  180,  181,    0,
  182,  183,  184,    0,  185,  186,  187,  188,    0,    0,
  198,  452,  196,    0,    0,    0,    0,    0,    0,  194,
  192,  479,  193,    0,  195,    0,    0,    0,    0,    0,
    0,    0,  198,    0,    0,    0,  197,  189,  191,  190,
  199,  194,  192,    0,  193,    0,  195,    0,    0,    0,
    0,    0,    0,    0,  198,    0,    0,    0,    0,  189,
  191,  190,    0,  194,  192,    0,  193,    0,  195,    0,
  480,  196,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  189,  191,  190,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  196,    0,  198,    0,    0,    0,    0,
    0,    0,    0,    0,  194,  192,    0,  193,    0,  195,
    0,    0,    0,    0,    0,  196,    0,    0,    0,    0,
    0,    0,  189,  191,  190,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  180,  181,    0,  182,  183,  184,    0,  185,
  186,  187,  188,    0,    0,    0,  196,    0,    0,    0,
    0,    0,    0,    0,  180,  181,    0,  182,  183,  184,
    0,  185,  186,  187,  188,    0,    0,    0,    0,    0,
    0,  197,  198,    0,    0,  199,    0,    0,    0,    0,
  240,  194,  192,    0,  193,    0,  195,    0,    0,    0,
    0,    0,    0,  197,    0,    0,    0,  199,    0,  189,
  191,  190,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  180,  181,
    0,  182,  183,  184,    0,  185,  186,  187,  188,    0,
    0,  198,    0,  196,    0,    0,    0,    0,    0,  290,
  194,  192,    0,  193,    0,  195,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  197,  189,  191,
  190,  199,    0,    0,  216,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  180,  181,    0,
  182,  183,  184,    0,  185,  186,  187,  188,    0,    0,
    0,    0,  196,    0,    0,    0,    0,    0,    0,  180,
  181,    0,  182,  183,  184,    0,  185,  186,  187,  188,
    0,    0,    0,    0,    0,    0,  197,    0,    0,    0,
  199,  180,  181,    0,  182,  183,  184,  198,  185,  186,
  187,  188,    0,    0,    0,    0,  194,  192,  197,  193,
    0,  195,  199,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  235,    0,  189,  191,  190,    0,    0,    0,
  197,    0,  180,  181,  199,  182,  183,  184,  198,  185,
  186,  187,  188,    0,    0,    0,    0,  194,  192,    0,
  193,    0,  195,    0,    0,    0,    0,    0,  196,    0,
    0,    0,    0,  236,    0,  189,  191,  190,    0,    0,
    0,  197,    0,    0,    0,  199,    0,    0,    0,  198,
    0,    0,    0,    0,    0,    0,    0,    0,  194,  192,
  305,  193,    0,  195,    0,    0,    0,    0,    0,  196,
    0,    0,    0,  198,    0,    0,  189,  191,  190,    0,
    0,    0,  194,  192,  308,  193,    0,  195,    0,  180,
  181,    0,  182,  183,  184,    0,  185,  186,  187,  188,
  189,  191,  190,    0,    0,    0,    0,    0,    0,    0,
  196,    0,    0,    0,    0,    0,    0,    0,    0,   44,
    0,    0,   49,  337,    0,   47,    0,   48,  197,    0,
    0,    0,  199,  198,  196,    0,    0,    0,    0,    0,
    0,    0,  194,  192,  309,  193,    0,  195,  180,  181,
    0,  182,  183,  184,  198,  185,  186,  187,  188,    0,
  189,  191,  190,  194,  192,    0,  193,    0,  195,    0,
    0,    0,    0,   45,    0,    0,    0,    0,   50,    0,
    0,  189,  191,  190,    0,    0,    0,  197,    0,    0,
    0,  199,    0,    0,  196,    0,    0,    0,  198,    0,
    0,    0,    0,    0,    0,   46,    0,  194,  192,  353,
  193,    0,  195,    0,  352,  196,    0,    0,    0,    0,
    0,    0,    0,  291,    0,  189,  191,  190,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  180,  181,  198,  182,  183,  184,
  295,  185,  186,  187,  188,  194,  192,  426,  193,  196,
  195,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  189,  191,  190,    0,    0,    0,    0,
    0,    0,    0,  197,    0,  180,  181,  199,  182,  183,
  184,  198,  185,  186,  187,  188,    0,    0,    0,  413,
  194,  192,    0,  193,    0,  195,    0,  196,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  189,  191,
  190,    0,    0,    0,  197,    0,  180,  181,  199,  182,
  183,  184,    0,  185,  186,  187,  188,    0,  100,    2,
    0,    0,    3,    4,    0,    0,    0,    0,    0,    7,
  180,  181,  196,  182,  183,  184,    0,  185,  186,  187,
  188,    0,    0,  198,    0,  197,    0,    0,    0,  199,
    0,  414,  194,  192,    0,  193,   18,  195,  101,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   22,  197,
  189,  191,  190,  199,   25,    0,    0,   26,    0,   27,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  180,  181,    0,  182,  183,  184,    0,  185,  186,  187,
  188,    0,    0,    0,  196,   43,    0,    0,    0,    0,
    0,  180,  181,  198,  182,  183,  184,    0,  185,  186,
  187,  188,  194,  192,    0,  193,    0,  195,    0,  197,
    0,    0,    0,  199,    0,    0,    0,    0,    0,  198,
  189,  191,  190,    0,    0,    0,    0,    0,  194,  192,
  197,  193,    0,  195,  199,  180,  181,    0,  182,  183,
  184,    0,  185,  186,  187,  188,  189,  191,  190,    0,
    0,    0,    0,  427,  196,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  197,    0,    0,    0,  199,  444,
  196,    0,    0,  180,  181,  198,  182,  183,  184,    0,
  185,  186,  187,  188,  194,  192,  198,  193,    0,  195,
    0,    0,    0,    0,    0,  194,  192,    0,  193,    0,
  195,    0,  189,  191,  190,    0,    0,    0,    0,    0,
    0,    0,  197,  189,  191,  190,  199,    0,  180,  181,
    0,  182,  183,  184,    0,  185,  186,  187,  188,    0,
    0,  198,    0,    0,    0,    0,  196,    0,    0,    0,
  194,  192,  198,  193,    0,  195,    0,  196,    0,    0,
    0,  194,  192,  198,  193,    0,  195,  197,  189,  191,
  190,  199,  194,  192,    0,  193,    0,  195,    0,  189,
  191,  190,    0,    0,    0,    0,    0,    0,    0,    0,
  189,  191,  190,    0,    0,    0,    0,    0,    0,    0,
  180,  181,  196,  182,  183,  184,    0,  185,  186,  187,
  188,    0,    0,  196,    0,    0,    0,    0,    0,    0,
  198,    0,    0,  481,  196,    0,    0,    0,    0,  194,
  192,    0,  193,    0,  195,    0,    0,    0,    0,  197,
    0,    0,    0,  199,    0,    0,    0,  189,  191,  190,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  180,  181,    0,  182,  183,  184,    0,  185,  186,  187,
  188,  196,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  180,  181,    0,  182,
  183,  184,    0,  185,  186,  187,  188,    0,    0,  197,
    0,    0,    0,  199,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  449,    0,    0,
    0,  198,    0,    0,    0,  197,    0,    0,  450,  199,
  194,  192,    0,  193,    0,  195,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  189,  191,
  190,    0,  180,  181,    0,  182,  183,  184,    0,  185,
  186,  187,  188,  180,  181,    0,  182,  183,  184,    0,
  185,  186,  187,  188,    0,    0,    0,    0,    0,    0,
    0,  486,  196,    0,    0,    0,  469,    0,    0,    0,
    0,  197,    0,    0,    0,  199,    0,  470,    0,    0,
    0,    0,  197,    0,    0,    0,  199,    0,  180,  181,
    0,  182,  183,  184,    0,  185,  186,  187,  188,  180,
  181,    0,  182,  183,  184,    0,  185,  186,  187,  188,
  180,  181,  198,  182,  183,  184,    0,  185,  186,  187,
  188,  194,  192,  198,  193,    0,  195,  197,    0,    0,
    0,  199,  194,  192,  198,  193,    0,  195,  197,  189,
  191,  190,  199,  194,  192,  471,  193,    0,  195,  197,
  189,  191,  190,  199,    0,    0,    0,    0,    0,    0,
    0,  189,  191,  190,    0,    0,    0,  180,  181,    0,
  182,  183,  184,  196,  185,  186,  187,  188,    0,    0,
    0,    0,    0,  489,  196,    0,    0,  198,    0,    0,
    0,    0,    0,    0,  490,  196,  194,  192,    0,  193,
    0,  195,    0,    0,    0,    0,  197,    0,  198,    0,
  199,    0,    0,    0,  189,  191,  190,  194,  192,    0,
  193,    0,  195,    0,    0,    0,    0,    0,    0,    0,
    0,  176,    0,    0,    0,  189,  191,  190,    0,    0,
  176,  176,  231,  176,    0,  176,    0,  499,  196,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  176,  176,
  176,    0,    0,    0,    0,    0,    0,    0,  505,  196,
    0,    0,    0,    0,    0,    0,    0,    0,  180,  181,
    0,  182,  183,  184,  198,  185,  186,  187,  188,    0,
    0,    0,  176,  194,  192,  198,  193,    0,  195,    0,
    0,    0,    0,    0,  194,  192,    0,  193,    0,  195,
    0,  189,  374,  190,    0,    0,    0,  197,    0,    0,
    0,  199,  189,  191,  190,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  196,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  196,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  180,
  181,    0,  182,  183,  184,    0,  185,  186,  187,  188,
  180,  181,    0,  182,  183,  184,    0,  185,  186,  187,
  188,  180,  181,    0,  182,  183,  184,    0,  185,  186,
  187,  188,    0,    0,    0,    0,    0,    0,  197,    0,
    0,    0,  199,    0,    0,    0,    0,    0,    0,  197,
    0,    0,    0,  199,    0,    0,    0,    0,    0,    0,
  197,    0,    0,    0,  199,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  180,  181,    0,  182,  183,  184,
    0,  185,  186,  187,  188,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  180,  181,    0,  182,  183,
  184,    0,  185,  186,  187,  188,    0,    0,    0,    0,
    0,    0,    0,  197,    0,    0,    0,  199,  176,  176,
    0,  176,  176,  176,    0,  176,  176,  176,  176,    0,
    0,    0,    0,    0,  197,    0,    0,    0,  199,    0,
    0,  157,    0,    0,  157,  157,  157,  157,  157,  157,
    0,  157,    0,    0,    0,    0,    0,  176,    0,    0,
    0,  176,  157,  157,  157,  157,  157,    0,    0,    0,
    0,  180,  181,    0,  182,  183,  184,    0,  185,  186,
  187,  188,  180,  181,    0,  182,  183,    0,    0,    0,
  186,  187,  188,    0,    0,  157,    0,  157,  157,    0,
  157,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  197,    0,    0,    0,  199,    0,    0,    0,    0,    0,
    0,  197,    0,    0,    0,  199,    0,  157,    0,  157,
    0,    0,    0,    0,    0,  143,    0,    0,  143,  143,
  143,  143,  143,  143,    0,  143,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  143,  143,  143,  143,
  143,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  143,
    0,  143,    0,    0,  143,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  143,    0,  143,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  142,    0,    0,  142,  142,
  142,  142,  142,  142,    0,  142,    0,    0,    0,    0,
  157,  157,    0,    0,  157,  157,  142,  142,  142,  142,
  142,  157,    0,    0,  157,    0,    0,    0,    0,  157,
  157,  157,  157,    0,  157,    0,    0,    0,    0,    0,
    0,    0,  157,  157,    0,  157,  157,  157,  157,  142,
  157,  142,    0,  157,  142,    0,    0,    0,    0,    0,
  157,  157,    0,    0,  157,  157,  157,  157,  157,  157,
    0,  157,  157,  157,  157,    0,    0,    0,    0,    0,
    0,  142,    0,  142,    0,    0,    0,    0,    0,    0,
    0,    0,  157,    0,  157,  157,    0,  157,  157,  157,
  157,  157,  157,  157,  143,  143,  157,  157,  143,  143,
    0,    0,    0,    0,    0,  143,    0,    0,  143,    0,
    0,    0,    0,  143,  143,  143,  143,    0,  143,    0,
    0,    0,    0,    0,    0,    0,  143,  143,    0,  143,
  143,  143,  143,    0,  143,    0,    0,  143,    0,    0,
    0,    0,    0,    0,  143,  143,    0,    0,  143,  143,
  143,  143,  143,  143,    0,  143,  143,  143,  143,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  143,    0,  143,  143,
    0,  143,  143,  143,  143,  143,  143,  143,    0,  152,
  143,  143,  152,  152,  152,  152,  152,  152,    0,  152,
    0,    0,    0,    0,  142,  142,    0,    0,  142,  142,
  152,  152,  152,  152,  152,  142,    0,    0,  142,    0,
    0,    0,    0,  142,  142,  142,  142,    0,  142,    0,
    0,    0,    0,    0,    0,    0,  142,  142,    0,  142,
  142,  142,  142,  152,  142,  152,    0,  142,  152,    0,
    0,    0,    0,    0,  142,  142,    0,    0,  142,  142,
  142,  142,  142,  142,    0,  142,  142,  142,  142,    0,
    0,    0,    0,    0,    0,  152,    0,  152,    0,    0,
    0,    0,    0,    0,    0,    0,  142,    0,  142,  142,
    0,  142,  142,  142,  142,  142,  142,  142,    0,  153,
  142,  142,  153,  153,  153,  153,  153,  153,    0,  153,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  153,  153,  153,  153,  153,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  153,    0,  153,    0,    0,  153,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  153,    0,  153,    0,    0,
    0,    0,    0,  156,    0,    0,  156,  156,  156,  156,
  156,  156,    0,  156,    0,    0,    0,    0,  152,  152,
    0,    0,  152,  152,  156,  156,  156,  156,  156,  152,
    0,    0,  152,    0,    0,    0,    0,  152,  152,  152,
  152,    0,  152,    0,    0,    0,    0,    0,    0,    0,
  152,  152,    0,  152,  152,  152,  152,  156,  152,  156,
    0,  152,  156,    0,    0,    0,    0,    0,  152,  152,
    0,    0,  152,  152,  152,  152,  152,  152,    0,  152,
  152,  152,  152,    0,    0,    0,    0,    0,    0,  156,
    0,  156,    0,    0,    0,    0,    0,    0,    0,    0,
  152,    0,  152,  152,    0,  152,  152,  152,  152,  152,
  152,  152,    0,  158,  152,  152,  158,  158,    0,  158,
  158,  158,    0,    0,    0,    0,    0,    0,  153,  153,
    0,    0,  153,  153,  158,  158,  158,  158,  158,  153,
    0,    0,  153,    0,    0,    0,    0,  153,  153,  153,
  153,    0,  153,    0,    0,    0,    0,    0,    0,    0,
  153,  153,    0,  153,  153,  153,  153,  158,  153,  158,
    0,  153,  158,    0,    0,    0,    0,    0,  153,  153,
    0,    0,  153,  153,  153,  153,  153,  153,    0,  153,
  153,  153,  153,    0,    0,    0,    0,    0,    0,  158,
    0,  158,    0,    0,    0,    0,    0,    0,    0,    0,
  153,    0,  153,  153,    0,  153,  153,  153,  153,  153,
  153,  153,  156,  156,  153,  153,  156,  156,    0,    0,
    0,    0,    0,  156,    0,    0,  156,    0,    0,    0,
    0,  156,  156,  156,  156,    0,  156,    0,    0,    0,
    0,    0,    0,    0,  156,  156,    0,  156,  156,  156,
  156,    0,  156,    0,    0,  156,    0,    0,    0,    0,
    0,    0,  156,  156,    0,    0,  156,  156,  156,  156,
  156,  156,    0,  156,  156,  156,  156,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  156,    0,  156,  156,    0,  156,
  156,  156,  156,  156,  156,  156,    0,  159,  156,  156,
  159,  159,    0,  159,  159,  159,    0,    0,    0,    0,
    0,    0,  158,  158,    0,    0,  158,  158,  159,  159,
  159,  159,  159,  158,    0,    0,  158,    0,    0,    0,
    0,  158,  158,  158,  158,    0,  158,    0,    0,    0,
    0,    0,    0,    0,  158,  158,    0,  158,  158,  158,
  158,  159,  158,  159,    0,  158,  159,    0,    0,    0,
    0,    0,  158,  158,    0,    0,  158,  158,  158,  158,
  158,  158,    0,  158,  158,  158,  158,    0,    0,    0,
    0,    0,    0,  159,    0,  159,    0,    0,    0,    0,
    0,    0,    0,    0,  158,    0,  158,  158,    0,  158,
  158,  158,  158,  158,  158,    0,    0,  167,  158,  158,
  167,  167,    0,    0,  167,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  167,  167,
  167,  167,  167,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  167,    0,  167,    0,    0,  167,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  167,    0,  167,    0,    0,    0,    0,
    0,  168,    0,    0,  168,  168,    0,    0,  168,    0,
    0,    0,    0,    0,    0,    0,  159,  159,    0,    0,
  159,  159,  168,  168,  168,  168,  168,  159,    0,    0,
  159,    0,    0,    0,    0,  159,  159,  159,  159,    0,
  159,    0,    0,    0,    0,    0,    0,    0,  159,  159,
    0,  159,  159,  159,  159,  168,  159,  168,    0,  159,
  168,    0,    0,    0,    0,    0,  159,  159,    0,    0,
  159,  159,  159,  159,  159,  159,    0,  159,  159,  159,
  159,    0,    0,    0,    0,    0,    0,  168,    0,  168,
    0,    0,    0,    0,    0,    0,    0,    0,  159,    0,
  159,  159,    0,  159,  159,  159,  159,  159,  159,    0,
    0,  165,  159,  159,  165,  165,    0,    0,  165,    0,
    0,    0,    0,    0,    0,    0,  167,  167,    0,    0,
  167,  167,  165,  165,  165,  165,  165,  167,    0,    0,
  167,    0,    0,    0,    0,  167,  167,  167,  167,    0,
  167,    0,    0,    0,    0,    0,    0,    0,  167,  167,
    0,  167,  167,  167,  167,  165,  167,  165,    0,  167,
  165,    0,    0,    0,    0,    0,  167,  167,    0,    0,
  167,  167,  167,  167,  167,  167,    0,  167,  167,  167,
  167,    0,    0,    0,    0,    0,    0,  165,    0,  165,
    0,    0,    0,    0,    0,    0,    0,    0,  167,    0,
  167,  167,    0,  167,  167,  167,  167,  167,  167,    0,
  168,  168,  167,  167,  168,  168,    0,    0,    0,    0,
    0,  168,    0,    0,  168,    0,    0,    0,    0,  168,
  168,  168,  168,    0,  168,    0,    0,    0,    0,    0,
    0,    0,  168,  168,    0,  168,  168,  168,  168,    0,
  168,    0,    0,  168,    0,    0,    0,    0,    0,    0,
  168,  168,    0,    0,  168,  168,  168,  168,  168,  168,
    0,  168,  168,  168,  168,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  168,    0,  168,  168,    0,  168,  168,  168,
  168,  168,  168,    0,    0,  166,  168,  168,  166,  166,
    0,    0,  166,    0,    0,    0,    0,    0,    0,    0,
  165,  165,    0,    0,  165,  165,  166,  166,  166,  166,
  166,  165,    0,    0,  165,    0,    0,    0,    0,  165,
  165,  165,  165,    0,  165,    0,    0,    0,    0,    0,
    0,    0,  165,  165,    0,  165,  165,  165,  165,  166,
  165,  166,    0,  165,  166,    0,    0,    0,    0,    0,
  165,  165,    0,    0,  165,  165,  165,  165,  165,  165,
    0,  165,  165,  165,  165,    0,    0,    0,    0,    0,
    0,  166,    0,  166,    0,    0,    0,    0,    0,    0,
    0,    0,  165,    0,  165,  165,    0,  165,  165,  165,
  165,  165,  165,    0,    0,  161,  165,  165,  161,  161,
    0,    0,  161,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  161,  161,    0,  161,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  161,
    0,  161,    0,    0,  161,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  161,    0,  161,    0,    0,    0,    0,    0,  160,
    0,    0,  160,  160,    0,    0,  160,    0,    0,    0,
    0,    0,    0,    0,  166,  166,    0,    0,  166,  166,
  160,  160,    0,  160,    0,  166,    0,    0,  166,    0,
    0,    0,    0,  166,  166,  166,  166,    0,  166,    0,
    0,    0,    0,    0,    0,    0,  166,  166,    0,  166,
  166,  166,  166,  160,  166,  160,    0,  166,  160,    0,
    0,    0,    0,    0,  166,  166,    0,    0,  166,  166,
  166,  166,  166,  166,    0,  166,  166,  166,  166,    0,
    0,    0,    0,    0,    0,  160,    0,  160,    0,    0,
    0,    0,    0,    0,    0,    0,  166,    0,  166,  166,
    0,  166,  166,  166,  166,  166,  166,    0,    0,  145,
  166,  166,  145,  145,    0,    0,  145,    0,    0,    0,
    0,    0,    0,    0,  161,  161,    0,    0,  161,  161,
  145,  145,    0,    0,    0,  161,    0,    0,  161,    0,
    0,    0,    0,  161,  161,  161,  161,    0,  161,    0,
    0,    0,    0,    0,    0,    0,  161,  161,    0,  161,
  161,  161,  161,  145,  161,  145,    0,  161,  145,    0,
    0,    0,    0,    0,  161,  161,    0,    0,  161,  161,
  161,  161,  161,  161,    0,  161,    0,    0,  161,    0,
    0,    0,    0,    0,    0,  145,    0,  145,    0,    0,
    0,    0,    0,    0,    0,    0,  161,    0,  161,  161,
    0,  161,  161,  161,  161,  161,  161,    0,  160,  160,
  161,  161,  160,  160,    0,    0,    0,    0,    0,  160,
    0,    0,  160,    0,    0,    0,    0,  160,  160,  160,
  160,    0,  160,    0,    0,    0,    0,    0,    0,    0,
  160,  160,    0,  160,  160,  160,  160,    0,  160,    0,
    0,  160,    0,    0,    0,    0,    0,    0,  160,  160,
    0,    0,  160,  160,  160,  160,  160,  160,    0,  160,
    0,    0,  160,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  160,    0,  160,  160,    0,  160,  160,  160,  160,  160,
  160,    0,    0,  169,  160,  160,  169,  169,    0,    0,
  169,    0,    0,    0,    0,    0,    0,    0,  145,  145,
    0,    0,  145,  145,  169,  169,    0,    0,    0,  145,
    0,    0,  145,    0,    0,    0,    0,  145,  145,  145,
  145,    0,  145,    0,    0,    0,    0,    0,    0,    0,
  145,  145,    0,  145,  145,  145,  145,  169,  145,  169,
    0,  145,  169,    0,    0,    0,    0,    0,  145,  145,
    0,    0,  145,  145,  145,  145,  145,  145,    0,  145,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  169,
    0,  169,    0,    0,    0,    0,    0,    0,    0,    0,
  145,    0,  145,  145,    0,  145,  145,  145,  145,  145,
  145,    0,    0,  170,  145,  145,  170,  170,    0,    0,
  170,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  170,  170,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  170,    0,  170,
    0,    0,  170,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  170,
    0,  170,    0,    0,    0,    0,    0,  154,    0,    0,
  154,  154,    0,    0,  154,    0,    0,    0,    0,    0,
    0,    0,  169,  169,    0,    0,  169,  169,  154,  154,
    0,    0,    0,  169,    0,    0,  169,    0,    0,    0,
    0,  169,  169,  169,  169,    0,  169,    0,    0,    0,
    0,    0,    0,    0,  169,  169,    0,  169,  169,  169,
  169,  154,  169,  154,    0,  169,  154,    0,    0,    0,
    0,    0,  169,  169,    0,    0,  169,  169,  169,  169,
  169,  169,    0,  169,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  154,    0,  154,    0,    0,    0,    0,
    0,    0,    0,    0,  169,    0,  169,  169,    0,  169,
  169,  169,  169,  169,  169,    0,    0,  155,  169,  169,
  155,  155,    0,    0,  155,    0,    0,    0,    0,    0,
    0,    0,  170,  170,    0,    0,  170,  170,  155,  155,
    0,    0,    0,  170,    0,    0,  170,    0,    0,    0,
    0,  170,  170,  170,  170,    0,  170,    0,    0,    0,
    0,    0,    0,    0,  170,  170,    0,  170,  170,  170,
  170,  155,  170,  155,    0,  170,  155,    0,    0,    0,
    0,    0,  170,  170,    0,    0,  170,    0,  170,  170,
  170,  170,    0,  170,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  155,    0,  155,    0,    0,    0,    0,
    0,    0,    0,    0,  170,    0,  170,  170,    0,  170,
  170,  170,  170,  170,  170,    0,  154,  154,  170,  170,
  154,  154,    0,    0,    0,    0,    0,  154,    0,    0,
  154,    0,    0,    0,    0,  154,  154,  154,  154,    0,
  154,    0,    0,    0,    0,    0,    0,    0,  154,  154,
    0,  154,  154,  154,  154,    0,  154,    0,    0,  154,
    0,    0,    0,    0,    0,    0,  154,  154,    0,    0,
    0,    0,  154,    0,    0,  154,    0,  154,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  154,    0,
  154,  154,    0,  154,  154,  154,  154,  154,  154,    0,
    0,  162,  154,  154,  162,  162,    0,    0,  162,    0,
    0,    0,    0,    0,    0,    0,  155,  155,    0,    0,
  155,  155,  162,  162,    0,    0,    0,  155,    0,    0,
  155,    0,    0,    0,    0,  155,  155,  155,  155,    0,
  155,    0,    0,    0,    0,    0,    0,    0,  155,  155,
    0,  155,  155,  155,  155,  162,  155,  162,    0,  155,
  162,    0,    0,    0,    0,    0,  155,  155,    0,    0,
    0,    0,  155,    0,    0,  155,    0,  155,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  162,    0,  162,
    0,    0,    0,    0,    0,    0,    0,    0,  155,    0,
  155,  155,    0,  155,  155,  155,  155,  155,  155,    0,
    0,  164,  155,  155,  164,  164,    0,    0,  164,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  164,  164,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  164,    0,  164,    0,    0,
  164,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  164,    0,  164,
    0,    0,    0,    0,    0,  163,    0,    0,  163,  163,
    0,    0,  163,    0,    0,    0,    0,    0,    0,    0,
  162,  162,    0,    0,  162,  162,  163,  163,    0,    0,
    0,  162,    0,    0,  162,    0,    0,    0,    0,  162,
  162,  162,  162,    0,  162,    0,    0,    0,    0,    0,
    0,    0,  162,  162,    0,  162,  162,  162,  162,  163,
  162,  163,    0,  162,  163,    0,    0,    0,    0,    0,
  162,  162,    0,    0,    0,    0,  162,    0,    0,  162,
    0,  162,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  163,    0,  163,    0,    0,    0,    0,    0,    0,
    0,    0,  162,    0,  162,  162,    0,  162,  162,  162,
  162,  162,  162,    0,    0,  129,  162,  162,  129,    0,
    0,    0,  129,    0,    0,    0,    0,    0,    0,    0,
  164,  164,    0,    0,  164,  164,  129,  129,    0,  160,
    0,  164,    0,    0,  164,    0,    0,    0,    0,  164,
  164,  164,  164,    0,  164,    0,    0,    0,    0,    0,
    0,    0,  164,  164,    0,  164,  164,  164,  164,  129,
  164,    0,    0,  164,  129,    0,    0,    0,    0,    0,
  164,  164,    0,    0,    0,    0,  164,    0,    0,  164,
    0,  164,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  129,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  164,    0,  164,  164,    0,  164,  164,  164,
  164,  164,  164,    0,  163,  163,  164,  164,  163,  163,
    0,    0,    0,  228,    0,  163,  228,    0,  163,  228,
    0,  228,    0,  163,  163,  163,  163,    0,  163,    0,
    0,    0,    0,    0,    0,  228,  163,  163,    0,  163,
  163,  163,  163,    0,  163,    0,    0,  163,    0,    0,
    0,    0,    0,    0,  163,  163,    0,    0,    0,    0,
  163,    0,    0,  163,    0,  163,    0,  228,    0,    0,
    0,    0,  228,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  163,    0,  163,  163,
    0,  163,  163,  163,  163,  163,  163,    0,    0,  228,
  163,  163,   62,    0,    0,   62,   62,    0,    0,   62,
    0,    0,    0,    0,  129,  129,    0,    0,  129,  129,
    0,    0,    0,   62,   62,  129,    0,    0,  129,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  129,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  129,
  129,  129,  129,    0,  129,    0,   62,  129,   62,    0,
    0,   62,    0,    0,  129,  129,    0,    0,  160,  160,
  129,  160,  160,  129,    0,  129,    0,    0,  160,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   62,    0,
   62,    0,    0,    0,    0,    0,  129,    0,  129,    0,
    0,  129,    0,    0,    0,    0,    0,    0,    0,    0,
  129,  160,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  228,  228,    0,    0,  228,  228,   44,    0,
    0,  284,    0,  228,   47,    0,   48,    0,    0,  228,
  228,    0,    0,    0,  228,  228,    0,    0,  228,  228,
  228,  228,  228,  228,    0,    0,    0,    0,    0,    0,
  228,    0,  228,    0,    0,  228,  228,  228,    0,    0,
    0,    0,  228,    0,  228,  228,    0,    0,  228,    0,
    0,  228,   45,  228,    0,    0,    0,   50,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,    0,
  228,  228,    0,  228,    0,  228,    0,    0,    0,  228,
    0,   62,   62,    0,   46,   62,   62,    0,  228,    0,
   63,    0,   62,   63,   63,   62,    0,   63,    0,    0,
   62,   62,   62,   62,    0,   62,    0,    0,    0,    0,
    0,   63,   63,   62,   62,    0,   62,   62,   62,   62,
    0,   62,    0,    0,   62,    0,    0,    0,    0,    0,
    0,   62,   62,    0,    0,    0,    0,   62,    0,    0,
    0,    0,    0,    0,   63,    0,   63,    0,    0,   63,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   62,    0,   62,   62,    0,   62,   62,
   62,   62,   62,   62,    0,    0,   63,   62,   63,    0,
    0,    0,    0,   64,    0,    0,   64,   64,    0,    0,
   64,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   64,   64,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  100,    2,    0,
    0,    3,    4,    0,    0,    0,    0,    0,    7,    0,
    0,    0,    0,    0,    0,    0,    0,   64,    0,   64,
    0,    0,   64,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   18,    0,  101,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   22,    0,   64,
    0,   64,    0,   25,    0,    0,   26,    0,   27,    0,
   66,    0,    0,   66,   66,    0,    0,   66,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   66,   66,    0,   43,    0,    0,    0,    0,   63,
   63,    0,    0,   63,   63,    0,    0,    0,    0,    0,
   63,    0,    0,   63,    0,    0,    0,    0,   63,   63,
   63,   63,    0,   63,   66,    0,   66,    0,    0,   66,
    0,   63,   63,    0,   63,   63,   63,   63,    0,   63,
    0,    0,   63,    0,    0,    0,    0,    0,    0,   63,
   63,    0,    0,    0,    0,   63,   66,    0,   66,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   63,    0,   63,   63,    0,   63,   63,   63,   63,
   63,   63,   64,   64,    0,   63,   64,   64,    0,    0,
    0,    0,    0,   64,    0,    0,   64,    0,    0,    0,
    0,   64,   64,   64,   64,    0,   64,    0,    0,   65,
    0,    0,   65,   65,   64,   64,   65,   64,   64,   64,
   64,    0,   64,    0,    0,   64,    0,    0,    0,    0,
   65,   65,   64,   64,    0,    0,    0,    0,   64,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   65,   64,   65,   64,   64,   65,   64,
   64,   64,   64,   64,   64,    0,    0,    0,   64,   66,
   66,    0,    0,   66,   66,    0,    0,    0,    0,    0,
   66,    0,    0,   66,    0,   65,    0,   65,   66,   66,
   66,   66,    0,   66,    0,    0,   80,    0,    0,   80,
   80,   66,   66,   80,   66,   66,   66,   66,    0,   66,
    0,    0,   66,    0,    0,    0,    0,   80,   80,   66,
   66,    0,    0,    0,    0,   66,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   80,   66,   80,   66,   66,   80,   66,   66,   66,   66,
   66,   66,    0,    0,    0,   66,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   80,    0,   80,    0,    0,    0,    0,   81,
    0,    0,   81,   81,    0,    0,   81,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   81,   81,    0,    0,    0,    0,    0,    0,   65,   65,
    0,    0,   65,   65,    0,    0,    0,    0,    0,   65,
    0,    0,   65,    0,    0,    0,    0,   65,   65,   65,
   65,    0,   65,   81,    0,   81,    0,    0,   81,    0,
   65,   65,    0,   65,   65,   65,   65,    0,   65,    0,
    0,   65,    0,    0,    0,    0,    0,    0,   65,   65,
    0,    0,    0,    0,   65,   81,    0,   81,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   82,    0,    0,   82,   82,    0,    0,   82,    0,    0,
   65,    0,   65,   65,    0,   65,   65,   65,   65,   65,
   65,   82,   82,    0,   65,   80,   80,    0,    0,   80,
   80,    0,    0,    0,    0,    0,   80,    0,    0,   80,
    0,    0,    0,    0,   80,   80,   80,   80,    0,   80,
    0,    0,    0,    0,   82,    0,   82,   80,   80,   82,
   80,   80,   80,   80,    0,   80,    0,    0,   80,    0,
    0,    0,    0,    0,    0,   80,   80,    0,    0,    0,
    0,   80,    0,    0,    0,    0,   82,    0,   82,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   80,    0,   80,
   80,    0,   80,   80,   80,   80,   80,   80,   81,   81,
    0,   80,   81,   81,    0,    0,    0,   84,    0,   81,
   84,   84,   81,    0,   84,    0,    0,   81,   81,   81,
   81,    0,   81,    0,    0,    0,    0,    0,   84,   84,
   81,   81,    0,   81,   81,   81,   81,    0,   81,    0,
    0,   81,    0,    0,    0,    0,    0,    0,   81,   81,
    0,    0,    0,    0,   81,    0,    0,    0,    0,    0,
    0,   84,    0,   84,    0,    0,   84,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   81,    0,   81,   81,    0,   81,   81,   81,   81,   81,
   81,    0,    0,   84,   81,   84,    0,    0,    0,   82,
   82,    0,    0,   82,   82,    0,    0,    0,   83,    0,
   82,   83,   83,   82,    0,   83,    0,    0,   82,   82,
   82,   82,    0,   82,    0,    0,    0,    0,    0,   83,
   83,   82,   82,    0,   82,   82,   82,   82,    0,   82,
    0,    0,   82,    0,    0,    0,    0,    0,    0,   82,
   82,    0,    0,    0,    0,   82,    0,    0,    0,    0,
    0,    0,   83,    0,   83,    0,    0,   83,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   82,    0,   82,   82,    0,   82,   82,   82,   82,
   82,   82,    0,    0,   83,   82,   83,    0,    0,    0,
    0,  189,    0,    0,  189,  189,    0,    0,  189,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  189,  189,    0,    0,   84,   84,    0,    0,
   84,   84,    0,    0,    0,    0,    0,   84,    0,    0,
   84,    0,    0,    0,    0,   84,   84,   84,   84,    0,
   84,    0,    0,    0,    0,  189,    0,  189,   84,   84,
  189,   84,   84,   84,   84,    0,   84,    0,    0,   84,
    0,    0,    0,    0,    0,    0,   84,   84,    0,    0,
    0,    0,   84,    0,    0,    0,    0,  189,    0,  189,
    0,    0,    0,    0,    0,    0,    0,    0,  188,    0,
    0,  188,  188,    0,    0,  188,    0,    0,   84,    0,
   84,   84,    0,   84,   84,   84,   84,   84,   84,  188,
  188,    0,   84,    0,    0,    0,    0,   83,   83,    0,
    0,   83,   83,    0,    0,    0,    0,    0,   83,    0,
    0,   83,    0,    0,    0,    0,   83,   83,   83,   83,
    0,   83,  188,    0,  188,    0,    0,  188,    0,   83,
   83,    0,   83,   83,   83,   83,    0,   83,    0,    0,
   83,    0,    0,    0,    0,    0,    0,   83,   83,    0,
    0,    0,    0,   83,  188,    0,  188,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   83,
    0,   83,   83,    0,   83,   83,   83,   83,   83,   83,
  189,  189,    0,   83,  189,  189,    0,    0,    0,  231,
    0,  189,  231,  231,  189,  231,  231,  231,    0,  189,
  189,  189,  189,    0,  189,    0,    0,    0,    0,    0,
  231,  231,  189,  189,    0,  189,  189,  189,  189,    0,
  189,    0,    0,  189,    0,    0,    0,    0,    0,    0,
  189,  189,    0,    0,    0,    0,  189,    0,    0,    0,
    0,    0,    0,  231,    0,    0,    0,    0,  231,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  189,    0,  189,  189,    0,  189,  189,  189,
  189,  189,  189,    0,    0,  231,  189,  188,  188,    0,
    0,  188,  188,    0,    0,    0,  232,    0,  188,  232,
  232,  188,  232,  232,  232,    0,  188,  188,  188,  188,
    0,  188,    0,    0,    0,    0,    0,  232,  232,  188,
  188,    0,    0,    0,  188,  188,    0,  188,    0,    0,
  188,    0,    0,    0,    0,    0,    0,  188,  188,    0,
    0,    0,    0,  188,    0,    0,    0,    0,    0,    0,
  232,    0,    0,    0,    0,  232,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  188,
    0,  188,  188,    0,  188,  188,  188,  188,  188,  188,
    0,    0,  232,  188,  233,    0,    0,  233,    0,    0,
  233,  233,  233,  233,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  233,  233,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  231,  231,
    0,    0,  231,  231,    0,    0,    0,    0,    0,  231,
    0,    0,  231,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  231,  233,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  231,  231,  231,  231,    0,  231,  228,
    0,  231,  228,    0,    0,  228,  228,  228,  231,  231,
  233,    0,    0,    0,  231,    0,    0,  231,    0,  231,
  228,  228,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  231,    0,  231,    0,    0,  231,    0,    0,    0,    0,
    0,    0,    0,  228,  231,  232,  232,    0,  228,  232,
  232,    0,    0,    0,    0,    0,  232,    0,    0,  232,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  232,
    0,    0,    0,    0,    0,  228,    0,    0,    0,    0,
  232,  232,  232,  232,    0,  232,   25,    0,  232,   25,
    0,    0,   25,    0,   25,  232,  232,    0,    0,    0,
    0,  232,    0,    0,  232,    0,  232,   25,   25,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  232,    0,  232,
    0,    0,  232,  233,  233,    0,    0,  233,  233,    0,
   25,  232,    0,    0,  233,   25,    0,  233,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  233,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  233,  233,
  233,  233,   25,  233,   26,    0,  233,   26,    0,    0,
   26,    0,   26,  233,  233,    0,    0,    0,    0,  233,
    0,    0,  233,    0,  233,   26,   26,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  228,  228,
    0,    0,  228,  228,    0,  233,    0,  233,    0,  228,
  233,    0,  228,    0,    0,    0,    0,    0,   26,  233,
    0,    0,  228,   26,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  228,  228,  228,  228,    0,  228,   27,
    0,  228,   27,    0,    0,   27,    0,   27,  228,  228,
   26,    0,    0,    0,  228,    0,    0,  228,    0,  228,
   27,   27,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  228,    0,  228,    0,    0,  228,    0,    0,    0,    0,
    0,    0,    0,   27,  228,   25,   25,    0,   27,   25,
   25,    0,    0,    0,    0,    0,   25,    0,    0,   25,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   25,
    0,    0,    0,    0,    0,   27,    0,    0,    0,    0,
   25,   25,   25,   25,    0,   25,    9,    0,   25,    9,
    0,    0,    9,    0,    9,   25,   25,    0,    0,    0,
    0,   25,    0,    0,   25,    0,   25,    9,    9,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   25,    0,   25,
    0,    0,   25,   26,   26,    0,    0,   26,   26,    0,
    9,   25,    0,    0,   26,    9,    0,   26,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   26,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   26,   26,
   26,   26,    9,   26,   10,    0,   26,   10,    0,    0,
   10,    0,   10,   26,   26,    0,    0,    0,    0,   26,
    0,    0,   26,    0,   26,   10,   10,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   27,   27,
    0,    0,   27,   27,    0,   26,    0,   26,    0,   27,
   26,    0,   27,    0,    0,    0,    0,    0,   10,   26,
    0,    0,   27,   10,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   27,   27,   27,   27,    0,   27,  205,
    0,   27,  205,    0,    0,  205,    0,  205,   27,   27,
   10,    0,    0,    0,   27,    0,    0,   27,    0,   27,
  205,  205,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   27,    0,   27,    0,    0,   27,    0,    0,    0,    0,
    0,    0,    0,  205,   27,    9,    9,    0,  205,    9,
    9,    0,    0,    0,    0,    0,    9,    0,    0,    9,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    9,
    0,    0,    0,    0,    0,  205,    0,    0,    0,    0,
    9,    9,    9,    9,    0,    9,  206,    0,    9,  206,
    0,    0,  206,    0,  206,    9,    9,    0,    0,    0,
    0,    9,    0,    0,    9,    0,    9,  206,  206,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    9,    0,    9,
    0,    0,    9,   10,   10,    0,    0,   10,   10,    0,
  206,    9,    0,    0,   10,  206,    0,   10,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   10,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   10,   10,
   10,   10,  206,   10,  207,    0,   10,  207,    0,    0,
  207,    0,  207,   10,   10,    0,    0,    0,    0,   10,
    0,    0,   10,    0,   10,  207,  207,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  205,  205,
    0,    0,  205,  205,    0,   10,    0,   10,    0,  205,
   10,    0,  205,    0,    0,    0,    0,    0,  207,   10,
    0,    0,  205,  207,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  205,  205,  205,  205,    0,  205,  204,
    0,  205,  204,    0,    0,  204,    0,  204,  205,  205,
  207,    0,    0,    0,  205,    0,    0,  205,    0,  205,
  204,  204,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  205,    0,  205,    0,    0,  205,    0,    0,    0,    0,
    0,    0,    0,  204,  205,  206,  206,    0,  204,  206,
  206,    0,    0,    0,    0,    0,  206,    0,    0,  206,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  206,
    0,    0,    0,    0,    0,  204,    0,    0,    0,    0,
  206,  206,  206,  206,    0,  206,  213,    0,  206,  213,
    0,    0,  213,    0,  213,  206,  206,    0,    0,    0,
    0,  206,    0,    0,  206,    0,  206,  213,  213,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  206,    0,  206,
    0,    0,  206,  207,  207,    0,    0,  207,  207,    0,
  213,  206,    0,    0,  207,  213,    0,  207,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  207,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  207,  207,
  207,  207,  213,  207,  139,    0,  207,  139,  139,    0,
    0,  139,    0,  207,  207,    0,    0,    0,    0,  207,
    0,    0,  207,    0,  207,  139,  139,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  204,  204,
    0,    0,  204,  204,    0,  207,    0,  207,    0,  204,
  207,    0,  204,    0,    0,    0,    0,    0,  139,  207,
  139,    0,  204,  139,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  204,  204,  204,  204,    0,  204,  101,
    0,  204,  101,    0,    0,  101,    0,  101,  204,  204,
  139,    0,  139,    0,  204,    0,    0,  204,    0,  204,
  101,  101,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  204,    0,  204,    0,    0,  204,    0,    0,    0,    0,
    0,    0,    0,  101,  204,  213,  213,    0,  101,  213,
  213,    0,    0,    0,    0,    0,  213,    0,    0,  213,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  213,
    0,    0,    0,    0,    0,  101,    0,    0,    0,    0,
  213,  213,  213,  213,    0,  213,  102,    0,  213,  102,
    0,    0,  102,    0,  102,  213,  213,    0,    0,    0,
    0,  213,    0,    0,  213,    0,  213,  102,  102,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  213,    0,  213,
    0,    0,  213,  139,  139,    0,    0,  139,  139,    0,
  102,  213,    0,    0,  139,  102,    0,  139,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  139,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  139,  139,
  139,  139,  102,  139,   92,    0,  139,   92,    0,    0,
   92,    0,   92,  139,  139,    0,    0,    0,    0,  139,
    0,    0,    0,    0,    0,   92,   92,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  101,  101,
    0,    0,  101,  101,    0,  139,    0,  139,    0,  101,
  139,    0,  101,    0,    0,    0,    0,    0,   92,  139,
    0,    0,  101,   92,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  101,  101,  101,  101,    0,  101,  107,
    0,  101,  107,    0,    0,  107,    0,  107,  101,  101,
   92,    0,    0,    0,  101,    0,    0,  101,    0,  101,
  107,  107,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  101,    0,  101,    0,    0,  101,    0,    0,    0,    0,
    0,    0,    0,  107,  101,  102,  102,    0,  107,  102,
  102,    0,    0,    0,    0,    0,  102,    0,    0,  102,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  102,
    0,    0,    0,    0,    0,  107,    0,    0,    0,    0,
  102,  102,  102,  102,    0,  102,  108,    0,  102,  108,
    0,    0,  108,    0,  108,  102,  102,    0,    0,    0,
    0,  102,    0,    0,  102,    0,  102,  108,  108,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  102,    0,  102,
    0,    0,  102,   92,   92,    0,    0,   92,   92,    0,
  108,  102,    0,    0,   92,  108,    0,   92,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   92,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   92,   92,
   92,   92,  108,   92,  135,    0,   92,  135,    0,    0,
  135,    0,  135,   92,   92,    0,    0,    0,    0,   92,
    0,    0,   92,    0,   92,  135,  135,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  107,  107,
    0,    0,  107,  107,    0,   92,    0,   92,    0,  107,
   92,    0,  107,    0,    0,    0,    0,    0,  135,   92,
    0,    0,  107,  135,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  107,  107,  107,  107,    0,  107,  209,
    0,  107,  209,    0,    0,  209,    0,  209,  107,  107,
  135,    0,    0,    0,  107,    0,    0,  107,    0,  107,
  209,  209,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  107,    0,  107,    0,    0,  107,    0,    0,    0,    0,
    0,    0,    0,  209,  107,  108,  108,    0,  209,  108,
  108,    0,    0,    0,    0,    0,  108,    0,    0,  108,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  108,
    0,    0,    0,    0,    0,  209,    0,    0,    0,    0,
  108,  108,  108,  108,    0,  108,  210,    0,  108,  210,
    0,    0,  210,    0,  210,  108,  108,    0,    0,    0,
    0,  108,    0,    0,  108,    0,  108,  210,  210,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  108,    0,  108,
    0,    0,  108,  135,  135,    0,    0,  135,  135,    0,
  210,  108,    0,    0,  135,  210,    0,  135,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  135,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  135,  135,
  135,  135,  210,  135,  211,    0,  135,  211,    0,    0,
  211,    0,  211,  135,  135,    0,    0,    0,    0,  135,
    0,    0,  135,    0,  135,  211,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  209,  209,
    0,    0,  209,  209,    0,  135,    0,  135,    0,  209,
  135,    0,  209,    0,    0,    0,    0,    0,  211,  135,
    0,    0,  209,  211,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  209,  209,  209,  209,    0,  209,    0,
    0,  209,    0,    0,    0,    0,    0,    0,  209,  209,
  211,    0,    0,    0,  209,    0,    0,  209,    0,  209,
    0,    0,  140,    0,    0,  140,  140,    0,    0,  140,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  209,    0,  209,  140,  140,  209,    0,    0,    0,    0,
    0,    0,    0,    0,  209,  210,  210,    0,    0,  210,
  210,    0,    0,    0,    0,    0,  210,    0,    0,  210,
    0,    0,    0,    0,    0,    0,  140,    0,  140,  210,
    0,  140,    0,    0,    0,    0,    0,    0,    0,    0,
  210,  210,  210,  210,    0,  210,   41,    0,  210,   41,
    0,    0,   41,   41,   41,  210,  210,    0,  140,    0,
  140,  210,    0,    0,  210,    0,  210,   41,   41,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  210,    0,  210,
    0,    0,  210,  211,  211,    0,    0,  211,  211,    0,
   41,  210,    0,    0,  211,   41,    0,  211,    0,    0,
    0,    0,    0,  214,    0,    0,  214,  211,    0,  214,
    0,  214,    0,    0,    0,    0,    0,    0,  211,  211,
  211,  211,   41,  211,  214,  214,  211,    0,    0,    0,
    0,    0,    0,  211,  211,    0,    0,    0,    0,  211,
    0,    0,  211,    0,  211,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  214,    0,    0,
    0,    0,  214,    0,    0,  211,    0,  211,    0,    0,
  211,    0,    0,    0,    0,    0,    0,    0,    0,  211,
    0,  140,  140,    0,    0,  140,  140,    0,    0,  214,
    0,    0,  140,    0,    0,  140,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  140,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  140,  140,  140,  140,
    0,  140,  217,    0,  140,  217,    0,    0,  217,    0,
  217,  140,  140,    0,    0,    0,    0,  140,    0,    0,
    0,    0,    0,  217,  217,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   41,   41,    0,    0,   41,
   41,    0,    0,  140,    0,  140,   41,    0,  140,   41,
    0,    0,    0,    0,    0,    0,  217,  140,    0,   41,
    0,  217,    0,    0,    0,    0,    0,    0,    0,    0,
   41,   41,    0,   41,    0,   41,  216,    0,   41,  216,
    0,    0,  216,    0,  216,   41,   41,    0,  217,    0,
    0,   41,    0,    0,   41,    0,   41,  216,  216,    0,
    0,    0,  214,  214,    0,    0,  214,  214,    0,    0,
    0,    0,    0,  214,    0,    0,  214,   41,    0,   41,
    0,    0,   41,    0,    0,    0,  214,    0,    0,    0,
  216,   41,    0,    0,    0,  216,    0,  214,  214,  214,
  214,    0,  214,  215,    0,  214,  215,    0,    0,  215,
    0,  215,  214,  214,    0,    0,    0,    0,  214,    0,
    0,  214,  216,  214,  215,  215,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  214,    0,  214,    0,    0,  214,
    0,    0,    0,    0,    0,    0,    0,  215,  214,    0,
    0,    0,  215,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  217,  217,    0,    0,  217,  217,    0,    0,  215,
    0,    0,  217,    0,    0,  217,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  217,    0,    0,  120,    0,
    0,  120,    0,    0,    0,  120,  217,  217,  217,  217,
    0,  217,    0,    0,  217,    0,    0,    0,    0,  120,
  120,  217,  217,    0,    0,    0,    0,  217,    0,    0,
  217,    0,  217,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  216,  216,    0,    0,  216,
  216,    0,  120,  217,    0,  217,  216,  120,  217,  216,
    0,    0,    0,    0,    0,  123,    0,  217,  123,  216,
    0,    0,  123,    0,    0,    0,    0,    0,    0,    0,
  216,  216,  216,  216,  120,  216,  123,  123,  216,    0,
    0,    0,    0,    0,    0,  216,  216,    0,    0,    0,
    0,  216,    0,    0,  216,    0,  216,    0,    0,    0,
    0,    0,  215,  215,    0,    0,  215,  215,    0,  123,
    0,    0,    0,  215,  123,    0,  215,  216,    0,  216,
    0,    0,  216,    0,    0,    0,  215,    0,    0,  124,
    0,  216,  124,    0,    0,    0,  124,  215,  215,  215,
  215,  123,  215,    0,    0,  215,    0,    0,    0,    0,
  124,  124,  215,  215,    0,    0,    0,    0,  215,    0,
    0,  215,    0,  215,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  124,  215,    0,  215,    0,  124,  215,
    0,    0,    0,    0,    0,    0,    0,    0,  215,    0,
    0,    0,    0,    0,    0,    0,    0,  120,  120,    0,
    0,  120,  120,    0,    0,  124,    0,    0,  120,    0,
    0,  120,    0,    0,    0,    0,    0,  125,    0,    0,
  125,  120,    0,    0,  125,    0,    0,    0,    0,    0,
    0,    0,  120,  120,  120,  120,    0,  120,  125,  125,
  120,    0,    0,    0,    0,    0,    0,  120,  120,    0,
    0,    0,    0,  120,    0,    0,  120,    0,  120,    0,
    0,    0,    0,    0,  123,  123,    0,    0,  123,  123,
    0,  125,    0,    0,    0,  123,  125,    0,  123,  120,
    0,  120,    0,    0,  120,    0,    0,    0,  123,    0,
    0,  119,    0,  120,  119,    0,    0,    0,  119,  123,
  123,  123,  123,  125,  123,    0,    0,  123,    0,    0,
    0,    0,  119,  119,  123,  123,    0,    0,    0,    0,
  123,    0,    0,  123,    0,  123,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  124,  124,
    0,    0,  124,  124,    0,  119,  123,    0,  123,  124,
  119,  123,  124,    0,    0,    0,    0,    0,  223,    0,
  123,  223,  124,    0,    0,  223,    0,    0,    0,    0,
    0,    0,    0,  124,  124,  124,  124,  119,  124,  223,
  223,  124,    0,    0,    0,    0,    0,    0,  124,  124,
    0,    0,    0,    0,  124,    0,    0,  124,    0,  124,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  223,    0,    0,    0,    0,  223,    0,    0,
  124,    0,  124,    0,    0,  124,    0,    0,    0,    0,
    0,    0,    0,    0,  124,    0,  125,  125,    0,    0,
  125,  125,    0,    0,  223,    0,    0,  125,    0,    0,
  125,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  125,    0,    0,  130,    0,    0,  130,    0,    0,    0,
  130,  125,  125,  125,  125,    0,  125,    0,    0,  125,
    0,    0,    0,    0,  130,  130,  125,  125,    0,    0,
    0,    0,  125,    0,    0,  125,    0,  125,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  119,  119,    0,    0,  119,  119,    0,  130,  125,    0,
  125,  119,  130,  125,  119,    0,    0,    0,    0,    0,
  133,    0,  125,  133,  119,    0,    0,  133,    0,    0,
    0,    0,    0,    0,    0,  119,  119,  119,  119,  130,
  119,  133,  133,  119,    0,    0,    0,    0,    0,    0,
  119,  119,    0,    0,    0,    0,  119,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  223,  223,    0,
    0,  223,  223,    0,  133,    0,    0,    0,  223,  133,
    0,  223,  119,    0,  119,    0,    0,  119,    0,    0,
    0,  223,    0,    0,   60,    0,  119,   60,    0,    0,
    0,   60,  223,  223,  223,  223,  133,  223,    0,    0,
  223,    0,    0,    0,    0,   60,   60,  223,  223,    0,
    0,    0,    0,  223,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   60,  223,
    0,  223,    0,   60,  223,    0,    0,    0,    0,    0,
    0,    0,    0,  223,    0,    0,    0,    0,    0,    0,
    0,    0,  130,  130,    0,    0,  130,  130,    0,    0,
   60,    0,    0,  130,    0,    0,  130,    0,    0,    0,
    0,    0,  119,    0,    0,  119,  130,    0,    0,  119,
    0,    0,    0,    0,    0,    0,    0,  130,  130,  130,
  130,    0,  130,  119,  119,  130,    0,    0,    0,    0,
    0,    0,  130,  130,    0,    0,    0,    0,  130,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  133,
  133,    0,    0,  133,  133,    0,  119,    0,    0,    0,
  133,  119,    0,  133,  130,    0,  130,    0,    0,  130,
    0,    0,    0,  133,    0,    0,    0,    0,  130,    0,
    0,    0,    0,    0,  133,  133,  133,  133,  119,  133,
   44,    0,  133,   49,    0,    0,   47,    0,   48,  133,
  133,    0,    0,    0,    0,  133,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   60,   60,    0,    0,   60,   60,    0,
    0,  133,    0,  133,   60,    0,  133,   60,    0,    0,
    0,    0,    0,    0,   45,  133,    0,   60,    0,   50,
    0,    0,    0,    0,    0,    0,    0,    0,   60,   60,
   60,   60,    0,   60,    0,    0,   60,    0,    0,    0,
    0,    0,    0,   60,   60,    0,   46,    0,    0,   60,
   44,    0,    0,   49,    0,    0,   47,    0,   48,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   60,    0,   60,    0,    0,
   60,    0,    0,    0,    0,    0,    0,    0,    0,   60,
    0,  119,  119,    0,    0,  119,  119,    0,    0,    0,
    0,    0,  119,    0,   45,  119,    0,    0,    0,   50,
    0,    0,    0,    0,    0,  119,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  119,  119,
    0,  119,    0,    0,  119,    0,   46,    0,    0,    0,
   44,  119,  119,   49,    0,    0,   47,  119,   48,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,    0,  119,    0,    0,  119,    1,
    2,    0,    0,    3,    4,    5,    6,  119,    0,    0,
    7,    0,    0,    0,   45,    0,    8,    9,    0,   50,
    0,   10,   11,    0,    0,   12,   13,   14,   15,   16,
   17,    0,    0,    0,    0,    0,    0,   18,    0,   19,
    0,    0,    0,   20,   21,    0,   46,    0,    0,   22,
    0,   23,   24,    0,    0,   25,    0,    0,   26,    0,
   27,    0,    0,    0,    0,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,    0,   39,   40,    0,
   41,    0,   42,    0,    0,    0,   43,    0,    0,    1,
    2,    0,    0,    3,    4,    0,    0,    0,    0,    0,
    7,    0,    0,    0,    0,    0,    8,    9,    0,    0,
    0,   10,   11,    0,    0,   12,   13,   14,   15,   16,
   17,    0,    0,    0,    0,    0,    0,   18,    0,   19,
    0,  395,    0,   20,   21,    0,    0,    0,    0,   22,
    0,   23,   24,    0,    0,   25,    0,    0,   26,    0,
   27,    0,    0,    0,    0,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,    0,   39,   40,    0,
   41,    0,   42,    0,    0,    0,   43,    0,    0,    1,
    2,    0,    0,    3,    4,    0,    0,    0,    0,    0,
    7,    0,    0,    0,    0,    0,    8,    9,    0,    0,
    0,   10,   11,    0,    0,   12,   13,   14,   15,   16,
   17,    0,    0,    0,    0,    0,    0,   18,    0,   19,
    0,    0,    0,   20,   21,    0,    0,    0,    0,   22,
    0,   23,   24,    0,    0,   25,    0,    0,   26,    0,
   27,    0,    0,    0,    0,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,    0,   39,   40,    0,
   41,   43,   42,    0,   43,    0,   43,   43,   43,   43,
    0,    0,    0,    0,    0,    0,    0,    0,   42,    0,
    0,   42,   43,    0,   42,   42,   42,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   42,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   43,    0,    0,    0,    0,
   43,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   42,    0,    0,    0,    0,   42,    0,    0,
    0,    0,    0,    0,    0,    0,   47,   43,    0,   47,
    0,    0,   47,   47,   47,    0,    0,    0,    0,    0,
    0,    0,    0,   46,   42,    0,   46,   47,    0,   46,
   46,   46,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   46,    0,    0,   44,    0,    0,
   49,    0,    0,   47,    0,   48,    0,    0,    0,    0,
   47,    0,    0,    0,    0,   47,    0,    0,    0,  380,
    0,    0,    0,    0,    0,    0,    0,   46,    0,    0,
    0,    0,   46,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   47,    0,    0,    0,    0,    0,    0,    0,
    0,   45,    0,    0,    0,    0,   50,    0,    0,   46,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   46,    0,    0,    0,    0,    0,    0,
   43,   43,    0,    0,   43,   43,    0,    0,    0,    0,
    0,   43,    0,    0,   43,    0,    0,   42,   42,    0,
    0,   42,   42,    0,   43,    0,    0,    0,   42,    0,
    0,   42,    0,    0,    0,   43,   43,   43,   43,    0,
   43,   42,    0,   43,    0,    0,    0,    0,    0,    0,
   43,   43,    0,    0,   42,   42,   43,   42,    0,   43,
   42,   43,    0,    0,    0,    0,    0,   42,   42,    0,
    0,    0,    0,   42,    0,    0,   42,    0,   42,    0,
    0,    0,   43,    0,   43,   47,   47,   43,    0,   47,
   47,    0,    0,    0,    0,    0,   47,    0,    0,   42,
    0,   42,   46,   46,   42,    0,   46,   46,    0,    0,
    0,    0,    0,   46,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   47,    0,   47,  100,    2,    0,    0,
    3,    4,    0,    0,    0,   47,    0,    7,    0,    0,
   46,   47,   46,    0,   47,    0,   47,    0,    0,    0,
    0,    0,   46,    0,    0,    0,    0,    0,   46,    0,
    0,   46,    0,   46,   18,    0,  101,   47,    0,    0,
    0,    0,   47,    0,    0,    0,   22,    0,    0,    0,
    0,    0,   25,    0,   46,   26,    0,   27,    0,   46,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  379,    0,
    0,    0,    0,   43,
};
short yycheck[] = {                                      40,
    0,   33,  260,   21,   59,   46,   46,   44,   59,   33,
   42,   43,   12,   45,   91,   47,   20,   35,   42,   19,
    0,   58,   59,   47,  260,   25,   40,  260,   91,   46,
   60,   59,   44,  324,  267,   46,   44,  261,   44,   33,
  166,   41,   42,   96,    7,   44,  172,   47,   48,   49,
   59,   33,   58,   59,   40,   40,   59,   20,   21,   33,
   42,   43,   94,   45,  260,   47,   41,   59,   42,   43,
   94,   45,   35,   47,   96,   38,   59,   44,   60,   61,
   62,   41,   96,   96,   44,   93,   60,   59,   62,  380,
  216,   58,   59,   40,  330,   95,   59,   59,   98,   99,
   94,  101,    0,  121,  122,  123,   59,  233,   59,    7,
  260,   46,   94,  125,   37,   59,   44,   15,   16,   17,
   94,   96,   20,   21,  124,   59,  125,   62,   59,   59,
   59,   59,  132,  133,  330,  260,  260,   35,   44,   44,
   38,   31,   32,   44,   40,   41,   36,   37,   59,  112,
   46,   59,   58,   58,    0,   45,   46,   58,  121,  122,
  123,   59,   46,  126,   96,  291,  166,  167,  168,  169,
  170,  171,  172,  173,  174,  175,  176,  177,   62,  260,
  180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  202,  199,
    0,   99,  202,  203,   96,  330,  330,  260,  260,   44,
  210,  211,  212,  213,  112,  267,  216,   44,  218,  270,
   96,   44,   44,  121,  122,  123,   44,  245,  126,  229,
  356,  261,  232,  233,  234,   40,  291,  292,  260,  202,
   46,   46,  270,  141,  321,  267,  260,  260,  261,  302,
  303,  304,  305,   99,  217,  292,  382,  383,  321,   41,
  386,   33,   44,  161,  162,  163,  284,  257,  166,   44,
   42,   43,   91,   45,  172,   47,   91,  280,  270,  307,
   41,  321,  245,   44,  284,  260,  297,  305,   60,   61,
   62,  291,  292,  293,  294,  295,  307,  352,  270,   99,
  300,  352,  200,  340,  202,   44,  306,  307,  308,  309,
  351,  201,   91,  293,  294,  352,  333,  349,  216,  217,
  166,  284,   94,  449,  352,  349,  172,  453,  260,  329,
  330,  331,  338,  459,   91,  233,  318,  319,  320,  270,
  270,  341,  305,  352,  318,  319,  236,  245,  348,  352,
  350,  280,   44,  353,   93,  355,  356,  340,  358,  359,
  352,  361,  270,   96,  256,  299,  166,  349,  260,  352,
  216,  338,  172,   40,  374,  349,  307,  395,  340,   46,
  352,  260,  382,  383,  260,  352,  386,  233,  299,   96,
  352,   44,  289,  291,  398,  293,  294,   41,  398,  352,
   44,  352,   37,  403,  404,  405,  406,  305,  352,  285,
  286,  287,   96,   91,   96,   44,  216,   41,  352,   33,
   44,  352,  352,  352,  424,  315,  426,  317,   41,   58,
   59,   44,  395,  233,   91,   41,  436,  327,   44,   91,
  440,  352,  442,   41,  352,  291,   44,  293,  294,  449,
  450,  451,   59,  453,   59,  455,  351,  298,  356,  459,
  321,  293,  466,  336,  281,   59,  466,  270,  351,  469,
  470,  471,  472,  473,  474,  455,   28,   29,   30,  479,
  351,  289,   34,  321,  382,  383,   59,  321,  386,  270,
   20,  291,   20,  293,  294,   20,  327,  395,  476,  503,
  398,   40,  475,  503,   33,  430,  396,   -1,   37,   -1,
  356,   40,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,  256,   -1,   -1,   -1,  260,   -1,   58,
   59,   60,   61,   62,   -1,  392,  382,  383,  310,  311,
  386,  431,  289,   -1,   -1,   -1,  318,  319,  320,  256,
   -1,  449,   -1,  260,   -1,  453,  356,  455,   -1,   -1,
   -1,  459,   91,   -1,   93,   94,   -1,   96,  466,  289,
   -1,  428,  462,  463,  256,  432,  433,  349,  260,   -1,
   -1,   -1,  382,  383,   -1,   -1,  386,  289,   -1,  141,
   -1,   -1,   -1,   -1,  123,   -1,  125,  344,  345,  346,
  347,  348,  459,  449,   -1,  503,   -1,  453,   33,  455,
   -1,   -1,   37,  459,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,  344,  345,  346,  347,  348,  289,
   -1,   -1,   -1,   58,   59,   60,   61,   62,  289,   -1,
   -1,  270,  344,  345,  346,  347,  348,  289,   -1,  449,
   -1,  280,   -1,  453,   -1,  455,   -1,   -1,   -1,  459,
   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   93,   94,
  299,   96,  344,  345,  346,  347,  348,   -1,  307,   -1,
   -1,   -1,  234,   -1,  344,  345,  346,  347,  348,   -1,
   -1,   -1,   -1,  344,  345,  346,  347,  348,  123,  289,
  125,   -1,  344,  345,  346,  347,  348,   -1,   33,  338,
   -1,  340,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   -1,   47,  352,   -1,   -1,   -1,  256,  257,   -1,
   -1,  260,  261,   58,   59,   60,   61,   62,  267,   -1,
   -1,  270,   -1,   -1,   -1,   -1,  275,  276,  277,  278,
   -1,  280,   -1,   -1,  344,  345,  346,  347,  348,  288,
  289,   -1,  291,  292,  293,  294,   91,  296,   93,   94,
  299,   96,  344,  345,  346,  347,  348,  306,  307,   -1,
   -1,  310,  311,  312,  313,  314,  315,   -1,  317,  318,
  319,  320,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,
   -1,  340,  341,   -1,  343,  344,  345,  346,  347,  348,
  349,  289,   -1,  352,  353,   -1,   -1,   -1,   -1,   44,
   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,   -1,
   -1,  289,  267,   58,   59,  270,   44,  289,   -1,   -1,
  275,  276,  277,  278,   -1,  280,   -1,   -1,   -1,   -1,
   58,   59,   -1,  288,  289,   -1,  291,  292,  293,  294,
   -1,  296,   -1,   -1,  299,   -1,  344,  345,  346,  347,
  348,  306,  307,   -1,   -1,  310,  311,  312,  313,  314,
  315,   -1,  317,  318,  319,  320,  344,  345,  346,  347,
  348,  289,  344,  345,  346,  347,  348,   -1,   -1,   -1,
   -1,   -1,   -1,  338,   -1,  340,  341,   -1,  343,  344,
  345,  346,  347,  348,  349,   -1,   -1,  352,  353,   -1,
   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,   -1,
   -1,  289,  267,   -1,   -1,  270,  289,   -1,   -1,   -1,
  275,  276,  277,  278,   -1,  280,  344,  345,  346,  347,
  348,   -1,   -1,  288,  289,   -1,  291,  292,  293,  294,
   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,   -1,
   -1,  306,  307,   -1,   -1,  310,  311,  312,  313,  314,
  315,   -1,  317,  318,  319,  320,  344,  345,  346,  347,
  348,  344,  345,  346,  347,  348,   -1,   -1,   -1,   -1,
   -1,  289,   -1,  338,   -1,  340,  341,   -1,  343,  344,
  345,  346,  347,  348,  349,   33,   -1,  352,  353,   37,
   -1,   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  344,  345,  346,  347,
  348,   -1,  270,   -1,   -1,   -1,  291,  292,  293,   -1,
   -1,   -1,  280,   91,  299,   93,   94,   -1,   96,   -1,
   -1,   -1,  307,  291,  292,  293,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  307,
   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,   -1,   33,
   -1,   -1,   -1,  338,   -1,  340,   40,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,  352,   -1,   -1,
  338,   -1,  340,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,  352,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   42,   43,   -1,   45,   91,   47,   93,
   94,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   37,   -1,   -1,   -1,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   58,   59,   60,   61,   62,  267,
   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,  276,  277,
  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  288,  289,   -1,  291,  292,  293,  294,   91,  296,   93,
   94,  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,  317,
  318,  319,  320,   -1,   -1,   -1,   -1,   -1,   -1,  123,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,  341,   -1,  343,  344,  345,  346,  347,
  348,  349,  256,  257,  352,  353,  260,  261,   -1,   -1,
   -1,   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,
   -1,  275,  276,  277,  278,   -1,  280,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  288,  289,   -1,  291,  292,  293,
  294,   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,
   -1,   -1,  306,  307,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,  317,  318,  319,  320,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  338,   -1,  340,  341,   -1,  343,
  344,  345,  346,  347,  348,  349,   -1,   -1,  352,  353,
   -1,  310,  311,   -1,  313,  314,   -1,   -1,   -1,  318,
  319,  320,  256,  257,   -1,   -1,   -1,  261,   -1,   -1,
   -1,   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   33,
   -1,  275,  276,  277,  278,   -1,  280,   -1,   42,   43,
  349,   45,   -1,   47,  288,  289,   -1,  291,  292,  293,
  294,   -1,  296,   -1,   -1,  299,   60,   61,   62,   -1,
   -1,   -1,  306,  307,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,  317,  318,  319,  320,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,  338,   -1,  340,  341,   -1,  343,
  344,  345,  346,  347,  348,  349,   33,   -1,  352,  353,
   37,   -1,   -1,   40,   -1,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   96,
   -1,   -1,   33,   -1,   -1,   -1,   37,   -1,   -1,   40,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  123,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,   94,   -1,   96,   -1,   -1,   33,   -1,
   -1,   -1,   37,   -1,   -1,   40,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  123,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  276,  277,  278,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  288,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   94,
   -1,   96,   -1,   -1,   -1,   -1,  310,  311,   -1,  313,
  314,  315,   -1,  317,  318,  319,  320,   37,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,  123,  256,
  257,   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,
  267,   -1,   -1,  270,   -1,  349,   -1,   -1,   -1,  353,
   -1,   -1,   -1,  280,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,
   -1,   91,  299,   -1,   -1,   -1,   96,   -1,   -1,  306,
  307,   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,
  317,  318,  319,  320,   -1,  256,  257,   -1,   -1,  260,
  261,   -1,   -1,  123,   -1,   -1,  267,   -1,   -1,  270,
   -1,  338,   -1,  340,   -1,   -1,  343,   -1,   -1,  280,
   -1,   -1,  349,   -1,  351,  352,  353,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   -1,   -1,  299,   -1,
   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,  310,
  311,  312,  313,  314,  315,   -1,  317,  318,  319,  320,
   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,   -1,
   -1,   -1,  267,   -1,   -1,  270,   -1,  338,   -1,  340,
   -1,   -1,  343,   -1,   -1,  280,   -1,   -1,  349,   -1,
   -1,  352,  353,   -1,   -1,   -1,  291,  292,  293,  294,
   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,   -1,
   -1,  306,  307,   -1,   -1,  310,  311,  312,  313,  314,
  315,   -1,  317,  318,  319,  320,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,
  260,  261,   -1,  338,   -1,  340,   -1,  267,  343,   -1,
   -1,   -1,   33,   -1,  349,   -1,   37,  352,  353,   40,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,  292,   -1,  294,   -1,  296,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  306,   -1,   -1,   -1,
   -1,   -1,  312,   -1,   -1,  315,   -1,  317,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,   94,   -1,   96,   -1,   -1,   33,   -1,
  340,   -1,   37,  343,   -1,   40,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  123,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   94,
   -1,   96,   -1,   -1,   33,   -1,   -1,   -1,   37,   -1,
   -1,   40,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   91,   -1,   -1,   94,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  123,  256,  257,   -1,   -1,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   94,  270,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   -1,   -1,  299,   60,
   61,   62,   -1,   -1,   -1,  306,  307,   -1,   -1,  310,
  311,  312,  313,  314,  315,   -1,  317,  318,  319,  320,
   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,   -1,
   -1,   -1,  267,   94,   -1,  270,   -1,  338,   -1,  340,
   -1,   -1,  343,   -1,   -1,  280,   -1,   -1,  349,   -1,
   -1,  352,  353,   -1,   -1,   -1,  291,  292,  293,  294,
   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,   -1,
   -1,  306,  307,   -1,   -1,  310,  311,  312,  313,  314,
  315,   -1,  317,  318,  319,  320,   -1,  256,  257,   -1,
   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,
   -1,  270,   -1,  338,   -1,  340,   -1,   -1,  343,   -1,
   -1,  280,   -1,   37,  349,   -1,   40,  352,  353,   43,
   -1,   45,  291,  292,  293,  294,   -1,  296,   -1,   -1,
  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,
   -1,  310,  311,  312,  313,  314,  315,   -1,  317,  318,
  319,  320,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,  338,
   -1,  340,   96,   -1,  343,   -1,   -1,   33,   -1,   -1,
  349,   37,   -1,  352,  353,  311,   42,   43,   44,   45,
   -1,   47,  318,  319,  320,   -1,   -1,   -1,   -1,  123,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,  278,   -1,   -1,
   -1,   -1,   -1,  349,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   33,   -1,   91,   -1,   -1,   94,   -1,
   96,   -1,   42,   43,   44,   45,   -1,   47,   -1,  310,
  311,   -1,  313,  314,  315,   -1,  317,  318,  319,  320,
   60,   61,   62,   -1,   -1,   -1,   -1,  123,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,  349,   -1,
   -1,   33,  353,   93,   94,   -1,   -1,   60,   61,   62,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   94,  256,  257,   -1,   33,  260,  261,   -1,   -1,
   -1,   -1,   -1,  267,   42,   43,   33,   45,   -1,   47,
   -1,   93,   94,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
  294,   -1,  296,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,  306,   -1,   -1,   -1,   -1,   -1,  312,   -1,
   -1,  315,   -1,  317,   -1,   -1,   94,   -1,   -1,   -1,
  256,  257,   -1,   -1,  260,  261,   93,   94,   -1,   -1,
   -1,  267,   -1,   -1,  270,   -1,   -1,   33,   -1,  343,
   -1,   -1,   -1,   -1,  280,   -1,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,  291,  292,  293,  294,   -1,
  296,   -1,   -1,  299,   60,   61,   62,   -1,   -1,   -1,
  306,  307,   -1,   -1,  310,  311,  312,  313,  314,  315,
   -1,  317,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,   -1,
   33,   -1,  338,   -1,  340,   -1,   -1,  343,   -1,   42,
   43,   44,   45,  349,   47,   -1,  352,  353,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   61,   62,
  310,  311,   -1,  313,  314,  315,   -1,  317,  318,  319,
  320,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,  310,  311,  349,
  313,  314,  315,  353,  317,  318,  319,  320,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,
   -1,  313,  314,  315,   -1,  317,  318,  319,  320,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  349,   -1,   -1,   -1,
  353,   -1,   -1,  291,  292,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  349,   -1,   -1,
   -1,  353,  310,  311,   -1,  313,  314,  315,   -1,  317,
  318,  319,  320,  310,  311,   33,  313,  314,  315,   -1,
  317,  318,  319,  320,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
   -1,  349,   60,   61,   62,  353,   42,   43,   44,   45,
   -1,   47,  349,   -1,   -1,   -1,  353,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  310,  311,   -1,  313,  314,  315,
   -1,  317,  318,  319,  320,   -1,   -1,   93,   94,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  349,   -1,   -1,   -1,  353,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,   -1,
  313,  314,  315,   -1,  317,  318,  319,  320,   -1,   -1,
   33,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,  349,   60,   61,   62,
  353,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   60,
   61,   62,   -1,   42,   43,   -1,   45,   -1,   47,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   33,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  310,  311,   -1,  313,  314,  315,   -1,  317,
  318,  319,  320,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  310,  311,   -1,  313,  314,  315,
   -1,  317,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,
   -1,  349,   33,   -1,   -1,  353,   -1,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,  349,   -1,   -1,   -1,  353,   -1,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,
   -1,  313,  314,  315,   -1,  317,  318,  319,  320,   -1,
   -1,   33,   -1,   94,   -1,   -1,   -1,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  349,   60,   61,
   62,  353,   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,   -1,
  313,  314,  315,   -1,  317,  318,  319,  320,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,  310,
  311,   -1,  313,  314,  315,   -1,  317,  318,  319,  320,
   -1,   -1,   -1,   -1,   -1,   -1,  349,   -1,   -1,   -1,
  353,  310,  311,   -1,  313,  314,  315,   33,  317,  318,
  319,  320,   -1,   -1,   -1,   -1,   42,   43,  349,   45,
   -1,   47,  353,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  341,   -1,   60,   61,   62,   -1,   -1,   -1,
  349,   -1,  310,  311,  353,  313,  314,  315,   33,  317,
  318,  319,  320,   -1,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,  341,   -1,   60,   61,   62,   -1,   -1,
   -1,  349,   -1,   -1,   -1,  353,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   33,   -1,   -1,   60,   61,   62,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,  310,
  311,   -1,  313,  314,  315,   -1,  317,  318,  319,  320,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,
   -1,   -1,   40,   41,   -1,   43,   -1,   45,  349,   -1,
   -1,   -1,  353,   33,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,  310,  311,
   -1,  313,  314,  315,   33,  317,  318,  319,  320,   -1,
   60,   61,   62,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   96,   -1,
   -1,   60,   61,   62,   -1,   -1,   -1,  349,   -1,   -1,
   -1,  353,   -1,   -1,   94,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  289,   -1,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  310,  311,   33,  313,  314,  315,
  275,  317,  318,  319,  320,   42,   43,   44,   45,   94,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  349,   -1,  310,  311,  353,  313,  314,
  315,   33,  317,  318,  319,  320,   -1,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   61,
   62,   -1,   -1,   -1,  349,   -1,  310,  311,  353,  313,
  314,  315,   -1,  317,  318,  319,  320,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,  267,
  310,  311,   94,  313,  314,  315,   -1,  317,  318,  319,
  320,   -1,   -1,   33,   -1,  349,   -1,   -1,   -1,  353,
   -1,   41,   42,   43,   -1,   45,  294,   47,  296,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  306,  349,
   60,   61,   62,  353,  312,   -1,   -1,  315,   -1,  317,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  310,  311,   -1,  313,  314,  315,   -1,  317,  318,  319,
  320,   -1,   -1,   -1,   94,  343,   -1,   -1,   -1,   -1,
   -1,  310,  311,   33,  313,  314,  315,   -1,  317,  318,
  319,  320,   42,   43,   -1,   45,   -1,   47,   -1,  349,
   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,   33,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   42,   43,
  349,   45,   -1,   47,  353,  310,  311,   -1,  313,  314,
  315,   -1,  317,  318,  319,  320,   60,   61,   62,   -1,
   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  349,   -1,   -1,   -1,  353,   93,
   94,   -1,   -1,  310,  311,   33,  313,  314,  315,   -1,
  317,  318,  319,  320,   42,   43,   33,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,
   47,   -1,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  349,   60,   61,   62,  353,   -1,  310,  311,
   -1,  313,  314,  315,   -1,  317,  318,  319,  320,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   42,   43,   33,   45,   -1,   47,   -1,   94,   -1,   -1,
   -1,   42,   43,   33,   45,   -1,   47,  349,   60,   61,
   62,  353,   42,   43,   -1,   45,   -1,   47,   -1,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  310,  311,   94,  313,  314,  315,   -1,  317,  318,  319,
  320,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,  349,
   -1,   -1,   -1,  353,   -1,   -1,   -1,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  310,  311,   -1,  313,  314,  315,   -1,  317,  318,  319,
  320,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,   -1,  313,
  314,  315,   -1,  317,  318,  319,  320,   -1,   -1,  349,
   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  275,   -1,   -1,
   -1,   33,   -1,   -1,   -1,  349,   -1,   -1,  275,  353,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   61,
   62,   -1,  310,  311,   -1,  313,  314,  315,   -1,  317,
  318,  319,  320,  310,  311,   -1,  313,  314,  315,   -1,
  317,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   94,   -1,   -1,   -1,  288,   -1,   -1,   -1,
   -1,  349,   -1,   -1,   -1,  353,   -1,  288,   -1,   -1,
   -1,   -1,  349,   -1,   -1,   -1,  353,   -1,  310,  311,
   -1,  313,  314,  315,   -1,  317,  318,  319,  320,  310,
  311,   -1,  313,  314,  315,   -1,  317,  318,  319,  320,
  310,  311,   33,  313,  314,  315,   -1,  317,  318,  319,
  320,   42,   43,   33,   45,   -1,   47,  349,   -1,   -1,
   -1,  353,   42,   43,   33,   45,   -1,   47,  349,   60,
   61,   62,  353,   42,   43,  288,   45,   -1,   47,  349,
   60,   61,   62,  353,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   60,   61,   62,   -1,   -1,   -1,  310,  311,   -1,
  313,  314,  315,   94,  317,  318,  319,  320,   -1,   -1,
   -1,   -1,   -1,   93,   94,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   94,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,  349,   -1,   33,   -1,
  353,   -1,   -1,   -1,   60,   61,   62,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   33,   -1,   -1,   -1,   60,   61,   62,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   93,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,
   -1,  313,  314,  315,   33,  317,  318,  319,  320,   -1,
   -1,   -1,   94,   42,   43,   33,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,   60,   61,   62,   -1,   -1,   -1,  349,   -1,   -1,
   -1,  353,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,
  311,   -1,  313,  314,  315,   -1,  317,  318,  319,  320,
  310,  311,   -1,  313,  314,  315,   -1,  317,  318,  319,
  320,  310,  311,   -1,  313,  314,  315,   -1,  317,  318,
  319,  320,   -1,   -1,   -1,   -1,   -1,   -1,  349,   -1,
   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,   -1,  349,
   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,   -1,
  349,   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  310,  311,   -1,  313,  314,  315,
   -1,  317,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  310,  311,   -1,  313,  314,
  315,   -1,  317,  318,  319,  320,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  349,   -1,   -1,   -1,  353,  310,  311,
   -1,  313,  314,  315,   -1,  317,  318,  319,  320,   -1,
   -1,   -1,   -1,   -1,  349,   -1,   -1,   -1,  353,   -1,
   -1,   37,   -1,   -1,   40,   41,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,  349,   -1,   -1,
   -1,  353,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  310,  311,   -1,  313,  314,  315,   -1,  317,  318,
  319,  320,  310,  311,   -1,  313,  314,   -1,   -1,   -1,
  318,  319,  320,   -1,   -1,   91,   -1,   93,   94,   -1,
   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  349,   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,
   -1,  349,   -1,   -1,   -1,  353,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   40,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   40,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
  256,  257,   -1,   -1,  260,  261,   58,   59,   60,   61,
   62,  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,
  276,  277,  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  288,  289,   -1,  291,  292,  293,  294,   91,
  296,   93,   -1,  299,   96,   -1,   -1,   -1,   -1,   -1,
  306,  307,   -1,   -1,  310,  311,  312,  313,  314,  315,
   -1,  317,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  338,   -1,  340,  341,   -1,  343,  344,  345,
  346,  347,  348,  349,  256,  257,  352,  353,  260,  261,
   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,   -1,
   -1,   -1,   -1,  275,  276,  277,  278,   -1,  280,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,   -1,  291,
  292,  293,  294,   -1,  296,   -1,   -1,  299,   -1,   -1,
   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,  317,  318,  319,  320,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,  341,
   -1,  343,  344,  345,  346,  347,  348,  349,   -1,   37,
  352,  353,   40,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,  260,  261,
   58,   59,   60,   61,   62,  267,   -1,   -1,  270,   -1,
   -1,   -1,   -1,  275,  276,  277,  278,   -1,  280,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,   -1,  291,
  292,  293,  294,   91,  296,   93,   -1,  299,   96,   -1,
   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,  317,  318,  319,  320,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,  341,
   -1,  343,  344,  345,  346,  347,  348,  349,   -1,   37,
  352,  353,   40,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   96,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   40,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   58,   59,   60,   61,   62,  267,
   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,  276,  277,
  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  288,  289,   -1,  291,  292,  293,  294,   91,  296,   93,
   -1,  299,   96,   -1,   -1,   -1,   -1,   -1,  306,  307,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,  317,
  318,  319,  320,   -1,   -1,   -1,   -1,   -1,   -1,  123,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,  341,   -1,  343,  344,  345,  346,  347,
  348,  349,   -1,   37,  352,  353,   40,   41,   -1,   43,
   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   58,   59,   60,   61,   62,  267,
   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,  276,  277,
  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  288,  289,   -1,  291,  292,  293,  294,   91,  296,   93,
   -1,  299,   96,   -1,   -1,   -1,   -1,   -1,  306,  307,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,  317,
  318,  319,  320,   -1,   -1,   -1,   -1,   -1,   -1,  123,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,  341,   -1,  343,  344,  345,  346,  347,
  348,  349,  256,  257,  352,  353,  260,  261,   -1,   -1,
   -1,   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,
   -1,  275,  276,  277,  278,   -1,  280,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  288,  289,   -1,  291,  292,  293,
  294,   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,
   -1,   -1,  306,  307,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,  317,  318,  319,  320,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  338,   -1,  340,  341,   -1,  343,
  344,  345,  346,  347,  348,  349,   -1,   37,  352,  353,
   40,   41,   -1,   43,   44,   45,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,   -1,   -1,  260,  261,   58,   59,
   60,   61,   62,  267,   -1,   -1,  270,   -1,   -1,   -1,
   -1,  275,  276,  277,  278,   -1,  280,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  288,  289,   -1,  291,  292,  293,
  294,   91,  296,   93,   -1,  299,   96,   -1,   -1,   -1,
   -1,   -1,  306,  307,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,  317,  318,  319,  320,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  338,   -1,  340,  341,   -1,  343,
  344,  345,  346,  347,  348,   -1,   -1,   37,  352,  353,
   40,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   37,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,
  260,  261,   58,   59,   60,   61,   62,  267,   -1,   -1,
  270,   -1,   -1,   -1,   -1,  275,  276,  277,  278,   -1,
  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,
   -1,  291,  292,  293,  294,   91,  296,   93,   -1,  299,
   96,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,
  310,  311,  312,  313,  314,  315,   -1,  317,  318,  319,
  320,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,
  340,  341,   -1,  343,  344,  345,  346,  347,  348,   -1,
   -1,   37,  352,  353,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,
  260,  261,   58,   59,   60,   61,   62,  267,   -1,   -1,
  270,   -1,   -1,   -1,   -1,  275,  276,  277,  278,   -1,
  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,
   -1,  291,  292,  293,  294,   91,  296,   93,   -1,  299,
   96,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,
  310,  311,  312,  313,  314,  315,   -1,  317,  318,  319,
  320,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,
  340,  341,   -1,  343,  344,  345,  346,  347,  348,   -1,
  256,  257,  352,  353,  260,  261,   -1,   -1,   -1,   -1,
   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,
  276,  277,  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  288,  289,   -1,  291,  292,  293,  294,   -1,
  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,
  306,  307,   -1,   -1,  310,  311,  312,  313,  314,  315,
   -1,  317,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  338,   -1,  340,  341,   -1,  343,  344,  345,
  346,  347,  348,   -1,   -1,   37,  352,  353,   40,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,   -1,   -1,  260,  261,   58,   59,   60,   61,
   62,  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,
  276,  277,  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  288,  289,   -1,  291,  292,  293,  294,   91,
  296,   93,   -1,  299,   96,   -1,   -1,   -1,   -1,   -1,
  306,  307,   -1,   -1,  310,  311,  312,  313,  314,  315,
   -1,  317,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  338,   -1,  340,  341,   -1,  343,  344,  345,
  346,  347,  348,   -1,   -1,   37,  352,  353,   40,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,   61,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,   -1,   37,
   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,  260,  261,
   58,   59,   -1,   61,   -1,  267,   -1,   -1,  270,   -1,
   -1,   -1,   -1,  275,  276,  277,  278,   -1,  280,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,   -1,  291,
  292,  293,  294,   91,  296,   93,   -1,  299,   96,   -1,
   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,  317,  318,  319,  320,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,  341,
   -1,  343,  344,  345,  346,  347,  348,   -1,   -1,   37,
  352,  353,   40,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,  260,  261,
   58,   59,   -1,   -1,   -1,  267,   -1,   -1,  270,   -1,
   -1,   -1,   -1,  275,  276,  277,  278,   -1,  280,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,   -1,  291,
  292,  293,  294,   91,  296,   93,   -1,  299,   96,   -1,
   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,  317,   -1,   -1,  320,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,  341,
   -1,  343,  344,  345,  346,  347,  348,   -1,  256,  257,
  352,  353,  260,  261,   -1,   -1,   -1,   -1,   -1,  267,
   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,  276,  277,
  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  288,  289,   -1,  291,  292,  293,  294,   -1,  296,   -1,
   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,  317,
   -1,   -1,  320,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,  341,   -1,  343,  344,  345,  346,  347,
  348,   -1,   -1,   37,  352,  353,   40,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   58,   59,   -1,   -1,   -1,  267,
   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,  276,  277,
  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  288,  289,   -1,  291,  292,  293,  294,   91,  296,   93,
   -1,  299,   96,   -1,   -1,   -1,   -1,   -1,  306,  307,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,  317,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,  341,   -1,  343,  344,  345,  346,  347,
  348,   -1,   -1,   37,  352,  353,   40,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   40,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,   -1,   -1,  260,  261,   58,   59,
   -1,   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,
   -1,  275,  276,  277,  278,   -1,  280,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  288,  289,   -1,  291,  292,  293,
  294,   91,  296,   93,   -1,  299,   96,   -1,   -1,   -1,
   -1,   -1,  306,  307,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  338,   -1,  340,  341,   -1,  343,
  344,  345,  346,  347,  348,   -1,   -1,   37,  352,  353,
   40,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,   -1,   -1,  260,  261,   58,   59,
   -1,   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,
   -1,  275,  276,  277,  278,   -1,  280,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  288,  289,   -1,  291,  292,  293,
  294,   91,  296,   93,   -1,  299,   96,   -1,   -1,   -1,
   -1,   -1,  306,  307,   -1,   -1,  310,   -1,  312,  313,
  314,  315,   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  338,   -1,  340,  341,   -1,  343,
  344,  345,  346,  347,  348,   -1,  256,  257,  352,  353,
  260,  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,
  270,   -1,   -1,   -1,   -1,  275,  276,  277,  278,   -1,
  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,
   -1,  291,  292,  293,  294,   -1,  296,   -1,   -1,  299,
   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,
   -1,   -1,  312,   -1,   -1,  315,   -1,  317,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,
  340,  341,   -1,  343,  344,  345,  346,  347,  348,   -1,
   -1,   37,  352,  353,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,
  260,  261,   58,   59,   -1,   -1,   -1,  267,   -1,   -1,
  270,   -1,   -1,   -1,   -1,  275,  276,  277,  278,   -1,
  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,
   -1,  291,  292,  293,  294,   91,  296,   93,   -1,  299,
   96,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,
   -1,   -1,  312,   -1,   -1,  315,   -1,  317,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,
  340,  341,   -1,  343,  344,  345,  346,  347,  348,   -1,
   -1,   37,  352,  353,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   40,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,   -1,   -1,  260,  261,   58,   59,   -1,   -1,
   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,
  276,  277,  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  288,  289,   -1,  291,  292,  293,  294,   91,
  296,   93,   -1,  299,   96,   -1,   -1,   -1,   -1,   -1,
  306,  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,  315,
   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  338,   -1,  340,  341,   -1,  343,  344,  345,
  346,  347,  348,   -1,   -1,   37,  352,  353,   40,   -1,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,   -1,   -1,  260,  261,   58,   59,   -1,   61,
   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,
  276,  277,  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  288,  289,   -1,  291,  292,  293,  294,   91,
  296,   -1,   -1,  299,   96,   -1,   -1,   -1,   -1,   -1,
  306,  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,  315,
   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  338,   -1,  340,  341,   -1,  343,  344,  345,
  346,  347,  348,   -1,  256,  257,  352,  353,  260,  261,
   -1,   -1,   -1,   37,   -1,  267,   40,   -1,  270,   43,
   -1,   45,   -1,  275,  276,  277,  278,   -1,  280,   -1,
   -1,   -1,   -1,   -1,   -1,   59,  288,  289,   -1,  291,
  292,  293,  294,   -1,  296,   -1,   -1,  299,   -1,   -1,
   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,   -1,   -1,
  312,   -1,   -1,  315,   -1,  317,   -1,   91,   -1,   -1,
   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,  341,
   -1,  343,  344,  345,  346,  347,  348,   -1,   -1,  123,
  352,  353,   37,   -1,   -1,   40,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,  260,  261,
   -1,   -1,   -1,   58,   59,  267,   -1,   -1,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,
  292,  293,  294,   -1,  296,   -1,   91,  299,   93,   -1,
   -1,   96,   -1,   -1,  306,  307,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,  317,   -1,   -1,  320,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,
  125,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  352,  353,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,   -1,   -1,  260,  261,   37,   -1,
   -1,   40,   -1,  267,   43,   -1,   45,   -1,   -1,  273,
  274,   -1,   -1,   -1,  278,  279,   -1,   -1,  282,  283,
  284,  285,  286,  287,   -1,   -1,   -1,   -1,   -1,   -1,
  294,   -1,  296,   -1,   -1,  299,  300,  301,   -1,   -1,
   -1,   -1,  306,   -1,  308,  309,   -1,   -1,  312,   -1,
   -1,  315,   91,  317,   -1,   -1,   -1,   96,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,   -1,
  334,  335,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,  256,  257,   -1,  123,  260,  261,   -1,  352,   -1,
   37,   -1,  267,   40,   41,  270,   -1,   44,   -1,   -1,
  275,  276,  277,  278,   -1,  280,   -1,   -1,   -1,   -1,
   -1,   58,   59,  288,  289,   -1,  291,  292,  293,  294,
   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,   -1,
   -1,  306,  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   96,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  338,   -1,  340,  341,   -1,  343,  344,
  345,  346,  347,  348,   -1,   -1,  123,  352,  125,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   40,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,
   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  294,   -1,  296,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  306,   -1,  123,
   -1,  125,   -1,  312,   -1,   -1,  315,   -1,  317,   -1,
   37,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   -1,  343,   -1,   -1,   -1,   -1,  256,
  257,   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,
  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,  276,
  277,  278,   -1,  280,   91,   -1,   93,   -1,   -1,   96,
   -1,  288,  289,   -1,  291,  292,  293,  294,   -1,  296,
   -1,   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,
  307,   -1,   -1,   -1,   -1,  312,  123,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  338,   -1,  340,  341,   -1,  343,  344,  345,  346,
  347,  348,  256,  257,   -1,  352,  260,  261,   -1,   -1,
   -1,   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,
   -1,  275,  276,  277,  278,   -1,  280,   -1,   -1,   37,
   -1,   -1,   40,   41,  288,  289,   44,  291,  292,  293,
  294,   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,
   58,   59,  306,  307,   -1,   -1,   -1,   -1,  312,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  338,   93,  340,  341,   96,  343,
  344,  345,  346,  347,  348,   -1,   -1,   -1,  352,  256,
  257,   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,
  267,   -1,   -1,  270,   -1,  123,   -1,  125,  275,  276,
  277,  278,   -1,  280,   -1,   -1,   37,   -1,   -1,   40,
   41,  288,  289,   44,  291,  292,  293,  294,   -1,  296,
   -1,   -1,  299,   -1,   -1,   -1,   -1,   58,   59,  306,
  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,  338,   93,  340,  341,   96,  343,  344,  345,  346,
  347,  348,   -1,   -1,   -1,  352,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,   37,
   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,  267,
   -1,   -1,  270,   -1,   -1,   -1,   -1,  275,  276,  277,
  278,   -1,  280,   91,   -1,   93,   -1,   -1,   96,   -1,
  288,  289,   -1,  291,  292,  293,  294,   -1,  296,   -1,
   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,
   -1,   -1,   -1,   -1,  312,  123,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   37,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   -1,
  338,   -1,  340,  341,   -1,  343,  344,  345,  346,  347,
  348,   58,   59,   -1,  352,  256,  257,   -1,   -1,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,  275,  276,  277,  278,   -1,  280,
   -1,   -1,   -1,   -1,   91,   -1,   93,  288,  289,   96,
  291,  292,  293,  294,   -1,  296,   -1,   -1,  299,   -1,
   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,   -1,   -1,  123,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
  341,   -1,  343,  344,  345,  346,  347,  348,  256,  257,
   -1,  352,  260,  261,   -1,   -1,   -1,   37,   -1,  267,
   40,   41,  270,   -1,   44,   -1,   -1,  275,  276,  277,
  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,   58,   59,
  288,  289,   -1,  291,  292,  293,  294,   -1,  296,   -1,
   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,
   -1,   -1,   -1,   -1,  312,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,  341,   -1,  343,  344,  345,  346,  347,
  348,   -1,   -1,  123,  352,  125,   -1,   -1,   -1,  256,
  257,   -1,   -1,  260,  261,   -1,   -1,   -1,   37,   -1,
  267,   40,   41,  270,   -1,   44,   -1,   -1,  275,  276,
  277,  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,   58,
   59,  288,  289,   -1,  291,  292,  293,  294,   -1,  296,
   -1,   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,
  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  338,   -1,  340,  341,   -1,  343,  344,  345,  346,
  347,  348,   -1,   -1,  123,  352,  125,   -1,   -1,   -1,
   -1,   37,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   -1,   -1,  256,  257,   -1,   -1,
  260,  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,
  270,   -1,   -1,   -1,   -1,  275,  276,  277,  278,   -1,
  280,   -1,   -1,   -1,   -1,   91,   -1,   93,  288,  289,
   96,  291,  292,  293,  294,   -1,  296,   -1,   -1,  299,
   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,
   -1,   -1,  312,   -1,   -1,   -1,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,
   -1,   40,   41,   -1,   -1,   44,   -1,   -1,  338,   -1,
  340,  341,   -1,  343,  344,  345,  346,  347,  348,   58,
   59,   -1,  352,   -1,   -1,   -1,   -1,  256,  257,   -1,
   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,
   -1,  270,   -1,   -1,   -1,   -1,  275,  276,  277,  278,
   -1,  280,   91,   -1,   93,   -1,   -1,   96,   -1,  288,
  289,   -1,  291,  292,  293,  294,   -1,  296,   -1,   -1,
  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,
   -1,   -1,   -1,  312,  123,   -1,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,
   -1,  340,  341,   -1,  343,  344,  345,  346,  347,  348,
  256,  257,   -1,  352,  260,  261,   -1,   -1,   -1,   37,
   -1,  267,   40,   41,  270,   43,   44,   45,   -1,  275,
  276,  277,  278,   -1,  280,   -1,   -1,   -1,   -1,   -1,
   58,   59,  288,  289,   -1,  291,  292,  293,  294,   -1,
  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,
  306,  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   96,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  338,   -1,  340,  341,   -1,  343,  344,  345,
  346,  347,  348,   -1,   -1,  123,  352,  256,  257,   -1,
   -1,  260,  261,   -1,   -1,   -1,   37,   -1,  267,   40,
   41,  270,   43,   44,   45,   -1,  275,  276,  277,  278,
   -1,  280,   -1,   -1,   -1,   -1,   -1,   58,   59,  288,
  289,   -1,   -1,   -1,  293,  294,   -1,  296,   -1,   -1,
  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,
   -1,   -1,   -1,  312,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,   -1,   -1,   96,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,
   -1,  340,  341,   -1,  343,  344,  345,  346,  347,  348,
   -1,   -1,  123,  352,   37,   -1,   -1,   40,   -1,   -1,
   43,   44,   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,  267,
   -1,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,   37,
   -1,  299,   40,   -1,   -1,   43,   44,   45,  306,  307,
  123,   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  352,  256,  257,   -1,   96,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   -1,   45,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
   -1,   -1,  343,  256,  257,   -1,   -1,  260,  261,   -1,
   91,  352,   -1,   -1,  267,   96,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,  123,  296,   37,   -1,  299,   40,   -1,   -1,
   43,   -1,   45,  306,  307,   -1,   -1,   -1,   -1,  312,
   -1,   -1,  315,   -1,  317,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,  338,   -1,  340,   -1,  267,
  343,   -1,  270,   -1,   -1,   -1,   -1,   -1,   91,  352,
   -1,   -1,  280,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,   37,
   -1,  299,   40,   -1,   -1,   43,   -1,   45,  306,  307,
  123,   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  352,  256,  257,   -1,   96,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   -1,   45,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
   -1,   -1,  343,  256,  257,   -1,   -1,  260,  261,   -1,
   91,  352,   -1,   -1,  267,   96,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,  123,  296,   37,   -1,  299,   40,   -1,   -1,
   43,   -1,   45,  306,  307,   -1,   -1,   -1,   -1,  312,
   -1,   -1,  315,   -1,  317,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,  338,   -1,  340,   -1,  267,
  343,   -1,  270,   -1,   -1,   -1,   -1,   -1,   91,  352,
   -1,   -1,  280,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,   37,
   -1,  299,   40,   -1,   -1,   43,   -1,   45,  306,  307,
  123,   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  352,  256,  257,   -1,   96,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   -1,   45,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
   -1,   -1,  343,  256,  257,   -1,   -1,  260,  261,   -1,
   91,  352,   -1,   -1,  267,   96,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,  123,  296,   37,   -1,  299,   40,   -1,   -1,
   43,   -1,   45,  306,  307,   -1,   -1,   -1,   -1,  312,
   -1,   -1,  315,   -1,  317,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,  338,   -1,  340,   -1,  267,
  343,   -1,  270,   -1,   -1,   -1,   -1,   -1,   91,  352,
   -1,   -1,  280,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,   37,
   -1,  299,   40,   -1,   -1,   43,   -1,   45,  306,  307,
  123,   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  352,  256,  257,   -1,   96,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   -1,   45,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
   -1,   -1,  343,  256,  257,   -1,   -1,  260,  261,   -1,
   91,  352,   -1,   -1,  267,   96,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,  123,  296,   37,   -1,  299,   40,   41,   -1,
   -1,   44,   -1,  306,  307,   -1,   -1,   -1,   -1,  312,
   -1,   -1,  315,   -1,  317,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,  338,   -1,  340,   -1,  267,
  343,   -1,  270,   -1,   -1,   -1,   -1,   -1,   91,  352,
   93,   -1,  280,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,   37,
   -1,  299,   40,   -1,   -1,   43,   -1,   45,  306,  307,
  123,   -1,  125,   -1,  312,   -1,   -1,  315,   -1,  317,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  352,  256,  257,   -1,   96,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   -1,   45,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
   -1,   -1,  343,  256,  257,   -1,   -1,  260,  261,   -1,
   91,  352,   -1,   -1,  267,   96,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,  123,  296,   37,   -1,  299,   40,   -1,   -1,
   43,   -1,   45,  306,  307,   -1,   -1,   -1,   -1,  312,
   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,  338,   -1,  340,   -1,  267,
  343,   -1,  270,   -1,   -1,   -1,   -1,   -1,   91,  352,
   -1,   -1,  280,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,   37,
   -1,  299,   40,   -1,   -1,   43,   -1,   45,  306,  307,
  123,   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  352,  256,  257,   -1,   96,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   -1,   45,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
   -1,   -1,  343,  256,  257,   -1,   -1,  260,  261,   -1,
   91,  352,   -1,   -1,  267,   96,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,  123,  296,   37,   -1,  299,   40,   -1,   -1,
   43,   -1,   45,  306,  307,   -1,   -1,   -1,   -1,  312,
   -1,   -1,  315,   -1,  317,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,  338,   -1,  340,   -1,  267,
  343,   -1,  270,   -1,   -1,   -1,   -1,   -1,   91,  352,
   -1,   -1,  280,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,   37,
   -1,  299,   40,   -1,   -1,   43,   -1,   45,  306,  307,
  123,   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  352,  256,  257,   -1,   96,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   -1,   45,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
   -1,   -1,  343,  256,  257,   -1,   -1,  260,  261,   -1,
   91,  352,   -1,   -1,  267,   96,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,  123,  296,   37,   -1,  299,   40,   -1,   -1,
   43,   -1,   45,  306,  307,   -1,   -1,   -1,   -1,  312,
   -1,   -1,  315,   -1,  317,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,  338,   -1,  340,   -1,  267,
  343,   -1,  270,   -1,   -1,   -1,   -1,   -1,   91,  352,
   -1,   -1,  280,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,   -1,  296,   -1,
   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,
  123,   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,
   -1,   -1,   37,   -1,   -1,   40,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,   -1,  340,   58,   59,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  352,  256,  257,   -1,   -1,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,  280,
   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   44,   45,  306,  307,   -1,  123,   -1,
  125,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,
   -1,   -1,  343,  256,  257,   -1,   -1,  260,  261,   -1,
   91,  352,   -1,   -1,  267,   96,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   40,  280,   -1,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,  123,  296,   58,   59,  299,   -1,   -1,   -1,
   -1,   -1,   -1,  306,  307,   -1,   -1,   -1,   -1,  312,
   -1,   -1,  315,   -1,  317,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   -1,   -1,   96,   -1,   -1,  338,   -1,  340,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  352,
   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,  123,
   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,  293,  294,
   -1,  296,   37,   -1,  299,   40,   -1,   -1,   43,   -1,
   45,  306,  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,  260,
  261,   -1,   -1,  338,   -1,  340,  267,   -1,  343,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   91,  352,   -1,  280,
   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  291,  292,   -1,  294,   -1,  296,   37,   -1,  299,   40,
   -1,   -1,   43,   -1,   45,  306,  307,   -1,  123,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   58,   59,   -1,
   -1,   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,
   -1,   -1,   -1,  267,   -1,   -1,  270,  338,   -1,  340,
   -1,   -1,  343,   -1,   -1,   -1,  280,   -1,   -1,   -1,
   91,  352,   -1,   -1,   -1,   96,   -1,  291,  292,  293,
  294,   -1,  296,   37,   -1,  299,   40,   -1,   -1,   43,
   -1,   45,  306,  307,   -1,   -1,   -1,   -1,  312,   -1,
   -1,  315,  123,  317,   58,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  338,   -1,  340,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,  352,   -1,
   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,  123,
   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,   37,   -1,
   -1,   40,   -1,   -1,   -1,   44,  291,  292,  293,  294,
   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,   58,
   59,  306,  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,
  315,   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,  260,
  261,   -1,   91,  338,   -1,  340,  267,   96,  343,  270,
   -1,   -1,   -1,   -1,   -1,   37,   -1,  352,   40,  280,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  291,  292,  293,  294,  123,  296,   58,   59,  299,   -1,
   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,   -1,
   -1,  312,   -1,   -1,  315,   -1,  317,   -1,   -1,   -1,
   -1,   -1,  256,  257,   -1,   -1,  260,  261,   -1,   91,
   -1,   -1,   -1,  267,   96,   -1,  270,  338,   -1,  340,
   -1,   -1,  343,   -1,   -1,   -1,  280,   -1,   -1,   37,
   -1,  352,   40,   -1,   -1,   -1,   44,  291,  292,  293,
  294,  123,  296,   -1,   -1,  299,   -1,   -1,   -1,   -1,
   58,   59,  306,  307,   -1,   -1,   -1,   -1,  312,   -1,
   -1,  315,   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,  338,   -1,  340,   -1,   96,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  352,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,
   -1,  260,  261,   -1,   -1,  123,   -1,   -1,  267,   -1,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   40,  280,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  291,  292,  293,  294,   -1,  296,   58,   59,
  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,
   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,   -1,
   -1,   -1,   -1,   -1,  256,  257,   -1,   -1,  260,  261,
   -1,   91,   -1,   -1,   -1,  267,   96,   -1,  270,  338,
   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,  280,   -1,
   -1,   37,   -1,  352,   40,   -1,   -1,   -1,   44,  291,
  292,  293,  294,  123,  296,   -1,   -1,  299,   -1,   -1,
   -1,   -1,   58,   59,  306,  307,   -1,   -1,   -1,   -1,
  312,   -1,   -1,  315,   -1,  317,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
   -1,   -1,  260,  261,   -1,   91,  338,   -1,  340,  267,
   96,  343,  270,   -1,   -1,   -1,   -1,   -1,   37,   -1,
  352,   40,  280,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,  123,  296,   58,
   59,  299,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,
   -1,   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   -1,   -1,   -1,   96,   -1,   -1,
  338,   -1,  340,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  352,   -1,  256,  257,   -1,   -1,
  260,  261,   -1,   -1,  123,   -1,   -1,  267,   -1,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,   -1,   -1,   37,   -1,   -1,   40,   -1,   -1,   -1,
   44,  291,  292,  293,  294,   -1,  296,   -1,   -1,  299,
   -1,   -1,   -1,   -1,   58,   59,  306,  307,   -1,   -1,
   -1,   -1,  312,   -1,   -1,  315,   -1,  317,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,   -1,   -1,  260,  261,   -1,   91,  338,   -1,
  340,  267,   96,  343,  270,   -1,   -1,   -1,   -1,   -1,
   37,   -1,  352,   40,  280,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  291,  292,  293,  294,  123,
  296,   58,   59,  299,   -1,   -1,   -1,   -1,   -1,   -1,
  306,  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,   -1,
   -1,  260,  261,   -1,   91,   -1,   -1,   -1,  267,   96,
   -1,  270,  338,   -1,  340,   -1,   -1,  343,   -1,   -1,
   -1,  280,   -1,   -1,   37,   -1,  352,   40,   -1,   -1,
   -1,   44,  291,  292,  293,  294,  123,  296,   -1,   -1,
  299,   -1,   -1,   -1,   -1,   58,   59,  306,  307,   -1,
   -1,   -1,   -1,  312,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,  338,
   -1,  340,   -1,   96,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  352,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,
  123,   -1,   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,
   -1,   -1,   37,   -1,   -1,   40,  280,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,  293,
  294,   -1,  296,   58,   59,  299,   -1,   -1,   -1,   -1,
   -1,   -1,  306,  307,   -1,   -1,   -1,   -1,  312,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
  257,   -1,   -1,  260,  261,   -1,   91,   -1,   -1,   -1,
  267,   96,   -1,  270,  338,   -1,  340,   -1,   -1,  343,
   -1,   -1,   -1,  280,   -1,   -1,   -1,   -1,  352,   -1,
   -1,   -1,   -1,   -1,  291,  292,  293,  294,  123,  296,
   37,   -1,  299,   40,   -1,   -1,   43,   -1,   45,  306,
  307,   -1,   -1,   -1,   -1,  312,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,  257,   -1,   -1,  260,  261,   -1,
   -1,  338,   -1,  340,  267,   -1,  343,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   91,  352,   -1,  280,   -1,   96,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,  292,
  293,  294,   -1,  296,   -1,   -1,  299,   -1,   -1,   -1,
   -1,   -1,   -1,  306,  307,   -1,  123,   -1,   -1,  312,
   37,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  352,
   -1,  256,  257,   -1,   -1,  260,  261,   -1,   -1,   -1,
   -1,   -1,  267,   -1,   91,  270,   -1,   -1,   -1,   96,
   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  293,  294,
   -1,  296,   -1,   -1,  299,   -1,  123,   -1,   -1,   -1,
   37,  306,  307,   40,   -1,   -1,   43,  312,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  338,   -1,  340,   -1,   -1,  343,  256,
  257,   -1,   -1,  260,  261,  262,  263,  352,   -1,   -1,
  267,   -1,   -1,   -1,   91,   -1,  273,  274,   -1,   96,
   -1,  278,  279,   -1,   -1,  282,  283,  284,  285,  286,
  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,  296,
   -1,   -1,   -1,  300,  301,   -1,  123,   -1,   -1,  306,
   -1,  308,  309,   -1,   -1,  312,   -1,   -1,  315,   -1,
  317,   -1,   -1,   -1,   -1,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,   -1,  334,  335,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,  256,
  257,   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,
  267,   -1,   -1,   -1,   -1,   -1,  273,  274,   -1,   -1,
   -1,  278,  279,   -1,   -1,  282,  283,  284,  285,  286,
  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,  296,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,   -1,  306,
   -1,  308,  309,   -1,   -1,  312,   -1,   -1,  315,   -1,
  317,   -1,   -1,   -1,   -1,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,   -1,  334,  335,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,  256,
  257,   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,
  267,   -1,   -1,   -1,   -1,   -1,  273,  274,   -1,   -1,
   -1,  278,  279,   -1,   -1,  282,  283,  284,  285,  286,
  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,  296,
   -1,   -1,   -1,  300,  301,   -1,   -1,   -1,   -1,  306,
   -1,  308,  309,   -1,   -1,  312,   -1,   -1,  315,   -1,
  317,   -1,   -1,   -1,   -1,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,   -1,  334,  335,   -1,
  337,   37,  339,   -1,   40,   -1,  343,   43,   44,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,
   -1,   40,   58,   -1,   43,   44,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,
   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   -1,   -1,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   37,  123,   -1,   40,
   -1,   -1,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,  123,   -1,   40,   58,   -1,   43,
   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   -1,   -1,   37,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
   91,   -1,   -1,   -1,   -1,   96,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   -1,   -1,   -1,   96,   -1,   -1,  123,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,   -1,   -1,  260,  261,   -1,   -1,   -1,   -1,
   -1,  267,   -1,   -1,  270,   -1,   -1,  256,  257,   -1,
   -1,  260,  261,   -1,  280,   -1,   -1,   -1,  267,   -1,
   -1,  270,   -1,   -1,   -1,  291,  292,  293,  294,   -1,
  296,  280,   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,
  306,  307,   -1,   -1,  293,  294,  312,  296,   -1,  315,
  299,  317,   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,
   -1,   -1,   -1,  312,   -1,   -1,  315,   -1,  317,   -1,
   -1,   -1,  338,   -1,  340,  256,  257,  343,   -1,  260,
  261,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,  338,
   -1,  340,  256,  257,  343,   -1,  260,  261,   -1,   -1,
   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  294,   -1,  296,  256,  257,   -1,   -1,
  260,  261,   -1,   -1,   -1,  306,   -1,  267,   -1,   -1,
  294,  312,  296,   -1,  315,   -1,  317,   -1,   -1,   -1,
   -1,   -1,  306,   -1,   -1,   -1,   -1,   -1,  312,   -1,
   -1,  315,   -1,  317,  294,   -1,  296,  338,   -1,   -1,
   -1,   -1,  343,   -1,   -1,   -1,  306,   -1,   -1,   -1,
   -1,   -1,  312,   -1,  338,  315,   -1,  317,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,
   -1,   -1,   -1,  343,
};
#define YYFINAL 51
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 355
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,"'$'","'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,
0,0,0,0,0,0,0,0,0,"':'","';'","'<'","'='","'>'",0,"'@'",0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,"'`'",0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"QUOTE",
"LITERAL","STOP","SYMBOL","STRING","EOF_TOKEN","UNKNOWN","NUOPE","TWBEEPRE",
"THBEEXPRE","NUMBER","SHOSSU","ONEBEEPRE","OD","OPTION","OPTIONS","PROC","QUIT",
"THEN","TO","DOWNTO","WHILE","REPEAT","UNTIL","BEGIN","RETURN","BREAK",
"CONTINUE","ARRAY","VECTOR","MATRIX","BY","DO","DONE","ELIF","ELSE","FI","FOR",
"FROM","IF","IN","LOCAL","END","GLOBAL","SETORDER","ORDER_LEX","ORDER_TLEX",
"ORDER_RLEX","ORDER_GRADINGS","FOREACH","ON","ENABLE","DISABLE","OR","AND",
"NOT","MOD","SMOD","UNION","NONCOMU","INTERSECT","LESSER_EQUAL","GREATER_EQUAL",
"NOT_EQUAL","COLON_EQUAL","READ","IMPORT","SAVE","WRITE","WRITEN","PRINTF",
"LOAD","CLEAR","XDEBUG","XDEBUGN","ALGEBRAIC","WITH","TRY","THROW","CATCH",
"SWITCH","HCTIWS","CASE","ESAC","OF","DEFAULT","QUOTE_SYMBOL","SUM","PRODUCT",
"COLLECT","CONC","JOIN","REMAINDER","ITRSYTH","ARROWOPE","SEMICOLON_SEMICOLON",
"SET_DIFF","OMIT","UNARY",
};
char *yyrule[] = {
"$accept : program",
"program : statement ';'",
"program : statement SEMICOLON_SEMICOLON",
"program : EOF_TOKEN",
"program : UNKNOWN",
"statement : if_statement",
"statement : switch_statement",
"statement : case_statement",
"statement : clear_statement",
"statement : enable_statement",
"statement : disable_statement",
"statement : write_statement",
"statement : debug_statement",
"statement : read_statement",
"statement : import_statement",
"statement : save_statement",
"statement : load_statement",
"statement : for_statement",
"statement : foreach_statement",
"statement : while_statement",
"statement : repeat_statement",
"statement : assign_statement",
"statement : simple_statement",
"statement : global_declaration",
"statement : setorder_declaration",
"statement : array_declaration",
"statement : matrix_declaration",
"statement : vector_declaration",
"statement : proc_declaration",
"statement : return_statement",
"statement : break_statement",
"statement : continue_statement",
"statement : algebraic_statement",
"statement : try_statement",
"statement : throw_statement",
"statement : QUIT",
"statement : error",
"statements : statement",
"statements : statements ';' statement",
"statements : statements SEMICOLON_SEMICOLON statement",
"if_statement : IF expression THEN statements else_parts FI",
"if_statement : IF expression THEN statements else_parts",
"else_parts :",
"else_parts : ELSE statements",
"else_parts : ELIF expression THEN statements else_parts",
"switch_statement : SWITCH expression OF switch_clauses HCTIWS",
"switch_clause : expression1 ':' statements",
"switch_clauses : switch_clause",
"switch_clauses : switch_clause ';'",
"switch_clauses : switch_clauses switch_clause",
"switch_clauses : switch_clauses ';' switch_clause",
"switch_clauses : switch_clauses ';'",
"case_statement : CASE expression OF case_clauses ESAC",
"case_statement : CASE expression OF case_clauses ELSE statements ESAC",
"case_clause : expression1 ':' statements ';'",
"case_clauses : case_clause",
"case_clauses : case_clauses case_clause",
"$$1 :",
"while_statement : WHILE $$1 expression DO statements OD",
"$$2 :",
"repeat_statement : REPEAT $$2 statements UNTIL expression",
"for_statement : for_head DO statements OD",
"for_expression : for_head SUM expression",
"for_expression : for_head PRODUCT expression",
"for_expression : for_head COLLECT expression",
"for_expression : for_head JOIN expression",
"for_expression : for_head CONC expression",
"$$3 :",
"for_head : FOR $$3 for_list",
"for_list : name COLON_EQUAL expression TO expression",
"for_list : name COLON_EQUAL expression TO expression BY expression",
"for_list : name COLON_EQUAL expression BY expression",
"for_list : name COLON_EQUAL expression BY expression TO expression",
"for_list : name COLON_EQUAL expression DOWNTO expression",
"for_list : name COLON_EQUAL expression DOWNTO expression BY expression",
"for_list : name COLON_EQUAL expression BY expression DOWNTO expression",
"for_list : name COLON_EQUAL expression WHILE expression",
"for_list : name COLON_EQUAL expression WHILE expression BY expression",
"for_list : name COLON_EQUAL expression BY expression WHILE expression",
"foreach_statement : foreach_head DO statements OD",
"foreach_expression : foreach_head SUM expression",
"foreach_expression : foreach_head PRODUCT expression",
"foreach_expression : foreach_head COLLECT expression",
"foreach_expression : foreach_head JOIN expression",
"foreach_expression : foreach_head CONC expression",
"$$4 :",
"foreach_head : FOREACH $$4 foreach_list",
"foreach_list : name IN expression",
"foreach_list : name ON expression",
"simple_statement : empty_statement",
"simple_statement : expression_statement",
"empty_statement :",
"clear_statement : CLEAR nameseq",
"enable_statement : ENABLE SYMBOL",
"enable_statement : ENABLE XDEBUG",
"enable_statement : enable_statement ',' SYMBOL",
"enable_statement : enable_statement ',' XDEBUG",
"disable_statement : DISABLE SYMBOL",
"disable_statement : DISABLE XDEBUG",
"disable_statement : disable_statement ',' SYMBOL",
"disable_statement : disable_statement ',' XDEBUG",
"write_statement : WRITE expression1",
"write_statement : WRITEN expression1",
"write_statement : PRINTF '(' string ')'",
"write_statement : PRINTF '(' identifier ')'",
"write_statement : PRINTF '(' string ',' expression1 ')'",
"write_statement : PRINTF '(' identifier ',' expression1 ')'",
"debug_statement : XDEBUG expression1",
"debug_statement : XDEBUGN expression1",
"read_statement : READ string",
"import_statement : IMPORT string",
"import_statement : IMPORT '<' SYMBOL '>'",
"import_statement : IMPORT '<' filename '>'",
"filename : SYMBOL '.' NUMBER",
"filename : SYMBOL '.' SYMBOL",
"filename : filename '.' NUMBER",
"filename : filename '.' SYMBOL",
"save_statement : SAVE string",
"load_statement : LOAD string",
"expression_statement : expression",
"assign_statement : identifier COLON_EQUAL expression",
"assign_statement : identifier COLON_EQUAL assign_statement",
"assign_statement : identifier COLON_EQUAL func_body",
"assign_statement : identifier '[' expression ']' COLON_EQUAL expression",
"assign_statement : identifier '[' expression ',' expression ']' COLON_EQUAL expression",
"assign_statement : identifier '[' expression ',' expression ',' expression ']' COLON_EQUAL expression",
"assign_statement : identifier '[' expression ']' COLON_EQUAL assign_statement",
"assign_statement : identifier '[' expression ',' expression ']' COLON_EQUAL assign_statement",
"assign_statement : identifier '[' expression ',' expression ',' expression ']' COLON_EQUAL assign_statement",
"algebraic_statement : ALGEBRAIC name WITH expression '=' expression",
"algebraic_statement : ALGEBRAIC name WITH expression",
"try_statement : TRY try_tag DO statements OD",
"try_statement : TRY try_tag DO statements catch_clause OD",
"throw_statement : THROW try_tag ',' expression",
"throw_statement : THROW try_tag ',' string",
"throw_statement : THROW try_tag",
"catch_clause : ON CATCH DO statements OD ';'",
"catch_clause : ON CATCH DO statements OD",
"try_tag : SYMBOL",
"expression1 : expression",
"expression1 : expression1 ',' expression",
"expression1 :",
"expression : '-' expression",
"expression : '+' expression",
"expression : '(' expression ')'",
"expression : NOT expression",
"expression : expression '!'",
"expression : '{' expression1 '}'",
"expression : '[' expression1 ']'",
"expression : '%'",
"expression : '%' '%'",
"expression : '%' '%' '%'",
"expression : expression '*' expression",
"expression : expression '/' expression",
"expression : expression MOD expression",
"expression : expression SMOD expression",
"expression : expression REMAINDER expression",
"expression : expression '^' expression",
"expression : expression '+' expression",
"expression : expression '-' expression",
"expression : expression '=' expression",
"expression : expression NOT_EQUAL expression",
"expression : expression UNION expression",
"expression : expression SET_DIFF expression",
"expression : expression INTERSECT expression",
"expression : expression '<' expression",
"expression : expression '>' expression",
"expression : expression LESSER_EQUAL expression",
"expression : expression GREATER_EQUAL expression",
"expression : expression AND expression",
"expression : expression OR expression",
"expression : name '(' expression1 ')'",
"expression : UNION '(' expression ',' expression ')'",
"expression : INTERSECT '(' expression ',' expression ')'",
"expression : NUMBER '(' expression ')'",
"expression : NUMBER name",
"expression : name",
"expression : string",
"expression : QUOTE SYMBOL QUOTE",
"expression : QUOTE_SYMBOL",
"expression : NUMBER",
"expression : identifier '[' expression ']'",
"expression : identifier '[' expression ',' expression ']'",
"expression : identifier '[' expression ',' expression ',' expression ']'",
"expression : IF expression THEN expression else_expression",
"expression : for_expression",
"expression : foreach_expression",
"expression : error",
"else_expression :",
"else_expression : ELSE expression",
"else_expression : ELIF expression THEN expression else_expression",
"array_declaration : ARRAY identifier '[' expression ']'",
"array_declaration : ARRAY identifier '[' expression ',' expression ']'",
"array_declaration : ARRAY identifier '[' expression ',' expression ',' expression ']'",
"array_declaration : array_declaration ',' identifier '[' expression ']'",
"array_declaration : array_declaration ',' identifier '[' expression ',' expression ']'",
"array_declaration : array_declaration ',' identifier '[' expression ',' expression ',' expression ']'",
"array_declaration : ARRAY error",
"matrix_declaration : MATRIX identifier '[' expression ',' expression ']'",
"matrix_declaration : matrix_declaration ',' identifier '[' expression ',' expression ']'",
"matrix_declaration : MATRIX error",
"vector_declaration : VECTOR identifier '[' expression ']'",
"vector_declaration : vector_declaration ',' identifier '[' expression ']'",
"vector_declaration : VECTOR error",
"global_declaration : GLOBAL nameseq",
"global_declaration : GLOBAL array_declaration",
"global_declaration : GLOBAL matrix_declaration",
"global_declaration : GLOBAL vector_declaration",
"global_declaration : GLOBAL assign_statement",
"setorder_declaration : SETORDER ORDER_LEX nameseq",
"setorder_declaration : SETORDER ORDER_TLEX nameseq",
"setorder_declaration : SETORDER ORDER_RLEX nameseq",
"setorder_declaration : SETORDER ORDER_GRADINGS expression ',' nameseq",
"setorder_declaration : SETORDER nameseq",
"func_body : name ARROWOPE localopt expression1",
"func_body : '(' name ')' ARROWOPE localopt expression1",
"func_body : '(' nameseq ')' ARROWOPE localopt expression1",
"func_body : '(' ')' ARROWOPE localopt expression1",
"proc_declaration : proc_start name '(' nameseq ')' ';' proc_body",
"proc_declaration : proc_start name '(' ')' ';' proc_body",
"proc_declaration : proc_start error",
"proc_start : PROC",
"proc_body : BEGIN localopts statements END",
"return_statement : RETURN expression",
"return_statement : RETURN",
"break_statement : BREAK",
"continue_statement : CONTINUE",
"localopt : LOCAL nameseq ';'",
"localopt :",
"localopts : localopt",
"localopts : localopts localopt",
"nameseq : name",
"nameseq : nameseq ',' name",
"name : identifier",
"name : name '.' NUMBER",
"name : name '.' identifier",
"identifier : SYMBOL",
"identifier : '`' SYMBOL '`'",
"string : STRING",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1082 "asuka.y"

void
yyerror(char *s)
{
    yacc_warnings(s, nil, nil);
}

Sex
make_name1(Sex a, Sex b)
{
    if (is_cons(a)) {
	return Laconc(a, b);
    }
    return Llist3(name_symbol, a, b);
}

Sex
pickup_globals(Sex a)
{
    Sex             c;
#if 0
    lisp_printf("pickup: %p\n", a);
#endif
    push3(a, nil, nil);
#define a stack[-2]
#define b stack[-1]
#define c stack[-0]
    if (is_cons(a)) {
	if (car(a) == progn_symbol) {
	    while (car(a) == progn_symbol) {
		b = caddr(a);
		if (car(b) == setq_symbol)
		    c = cons(cadr(b), c);
		a = cadr(a);
	    }
	}
	if (car(a) == setq_symbol) {
	    c = cons(cadr(a), c);
	}
    }
#undef a
#undef b
#undef c
    c = stack[0];
    popv(3);
    return c;
}




static          Sex
make_funcall(Sex a, Sex b)
{
    proc_vars = Ldeleq(a, proc_vars);
    return cons(a, b);
}

static          Sex
make_func1(b, c, d)
     Sex             b,
                     c,
                     d;
{
    Sex             p;
    stackcheck();
    push3(b, c, d);
    stack[0] = expand2(d);
    b = stack[-2];
    stack[-2] = Lncons(b);
    c = stack[-1];
    if (c != nil) {
	d = stack[0];
	d = Llist3(prog_symbol, c, d);
	stack[0] = d;
    } else
	d = stack[0];
    b = stack[-2];
    p = Llist3(lambda, b, d);
    popv(3);
    return p;
}


static          Sex
make_func2(b, c, d)
     Sex             b,
                     c,
                     d;
{
    Sex             p;
    stackcheck();
    push3(b, c, d);
    stack[0] = expand2(d);
    c = stack[-1];
    if (c != nil) {
	d = stack[0];
	d = Llist3(prog_symbol, c, d);
    } else
	d = stack[0];
    b = stack[-2];
    p = Llist3(lambda, b, d);
    popv(3);
    return p;
}

static          Sex
make_proc(a, b, c)
     Sex             a,
                     b,
                     c;
{
    Sex             d;
    push3(a, b, c);
#if 0
    lisp_printf("proc_vars = %p\n", proc_vars);
    lisp_printf("proc_gvar = %p\n", proc_gvars);
    lisp_printf("proc_args = %p\n", b);
    lisp_printf("proc_frame = %p\n", proc_frame);
#endif
    d = Lsetdiff(proc_vars, proc_frame);
    d = Lsetdiff(d, stack[-1]);
    d = Lsetdiff(d, proc_gvars);
    d = Ldeleq(stack[-2], d);
    d = Ldeleq(asuka_true_symbol, d);
    d = Ldeleq(asuka_false_symbol, d);
    d = Ldeleq(asuka_nil_symbol, d);
    if (d != nil) {
	lisp_printf(" *** Message: global variabls %p used in", d);
	lisp_printf(" procedure %p\n", stack[-2]);
    }
    d = Lintersectionq(proc_gvars, stack[-1]);
    if (d != nil) {
	lisp_printf
	    (" *** Message: variables %p is used as both global and arguments\n",
	     d);
    }
    d = Lintersectionq(proc_gvars, proc_frame);
    if (d != nil) {
	lisp_printf
	    (" *** Message: variables %p is used as both global and local\n",
	     d);
    }

    pop3(c, b, a);
    return Llist4(defproc_symbol, a, b, c);
}

static          Sex
make_proc_body(Sex a)
{
    Sex             b;
    if (!is_cons(a))
	a = cons(prog_symbol, cons(proc_frame, a));
    else if (caar(a) == prog_symbol) {
	proc_frame = Lnconc(proc_frame, cadar(a));
	a = cons(prog_symbol, cons(proc_frame, cddar(a)));
    } else if (caar(a) == progn_symbol) {
	a = cons(prog_symbol, cons(proc_frame, cdar(a)));
    } else {
	a = cons(prog_symbol, cons(proc_frame, a));
    }
    return a;
}


Sex
expand2(Sex a)
{
    if (a == nil)
	return a;
    if (cdr(a) == nil)
	return car(a);
    if (car(a) == prog_symbol)
	return a;
    return cons(progn_symbol, a);
}

/*
 *procedure definition
 */

void
begin_loop(void)
{
    char            buf[128];
    Sex             a;

    in_loop++;

    // lisp_printf("entering loop\n");
    stackcheck();
    push3(nil, nil, nil);	/* label symbol */
    sprintf(buf, "label%d", label_count++);	// start label
    stack[-2] = gensym2(buf);
    sprintf(buf, "label%d", label_count++);	// continue label
    stack[-1] = gensym2(buf);
    sprintf(buf, "label%d", label_count++);	// exit label
    stack[0] = gensym2(buf);
    a = Llist3(stack[0], stack[-1], stack[-2]);
    loop_frame = cons(a, loop_frame);
    popv(3);
}

void
end_loop(void)
{
    if (in_loop <= 0 || !is_cons(loop_frame)) {
	in_loop = 0;
	lisp_printf("over exitting loop\n");
    } else {
	loop_frame = cdr(loop_frame);
	in_loop--;
	// lisp_printf("exitting loop\n");
    }
}

void
clear_loop(void)
{
    while (in_loop > 0) {
	popv(3);
	in_loop--;
	// lisp_printf("cleaning loop\n");
    }
}


Sex
expand_loop(Sex body)
{
    if (!is_cons(body))
	return body;
    if (car(body) == progn_symbol)
	return cdr(body);
    if (car(body) == prog_symbol)
	return cddr(body);
    return body;
}


Sex
expand_while(a, exp, body)
     Sex             a,
                     exp,
                     body;
{
    Sex             q;
    Sex             l;

    if (!is_cons(loop_frame))
	error("invalid while");
    l = car(loop_frame);
    stackcheck();
    push3(a, exp, body);
    push4(nil, nil, nil, l);
#define a stack[-6]
#define exp stack[-5]
#define body stack[-4]
#define gost stack[-3]
#define cond stack[-2]
#define p stack[-1]
#define l stack[-0]
    gost = Llist2(go_symbol, car(l));
    cond = Llist4(if_symbol, exp, nil, gost);
    gost = Llist2(go_symbol, caddr(l));
    // lisp_printf("\n while body=%p\n\n", body);
    if (in_proc) {
	if (!is_cons(body)) {
	    p = Llist3(cadr(l), gost, car(l));
	    p = Lnconc(body, p);
	} else if (caar(body) == prog_symbol) {
	    proc_frame = Lnconc(proc_frame, cadar(body));
	    p = Llist3(cadr(l), gost, car(l));
	    p = Lnconc(cddar(body), p);
	} else if (caar(body) == progn_symbol) {
	    p = Llist3(cadr(l), gost, car(l));
	    p = Lnconc(cdar(body), p);
	} else {
	    p = Llist3(cadr(l), gost, car(l));
	    p = Lnconc(body, p);
	}
    } else {
	p = Llist3(cadr(l), gost, car(l));
	p = Lnconc(body, p);
    }

    p = Lnconc(Llist2(caddr(l), cond), p);
    q = Lnconc(Llist2(prog_symbol, nil), p);
#undef a
#undef exp
#undef body
#undef gost
#undef cond
#undef p
#undef l
    popv(7);
    return q;
}


static          Sex
expand_repeat(a, exp, body)
     Sex             a,
                     exp,
                     body;
{
    Sex             q;
    Sex             l;

    if (!is_cons(loop_frame))
	error("invalid repeat");
    l = car(loop_frame);
    stackcheck();
    push3(a, exp, body);
    push4(nil, nil, nil, l);
#define a stack[-6]
#define exp stack[-5]
#define body stack[-4]
#define gost stack[-3]
#define cond stack[-2]
#define p stack[-1]
#define l stack[-0]
    gost = Llist2(go_symbol, caddr(l));
    cond = Llist4(if_symbol, exp, nil, gost);
    if (in_proc) {
	if (car(body) == prog_symbol) {
	    proc_frame = Lnconc(proc_frame, cadr(body));
	    p = Llist3(cadr(l), cond, car(l));
	    p = Lnconc(cddr(body), p);
	} else if (car(body) == progn_symbol) {
	    p = Llist3(cadr(l), cond, car(l));
	    p = Lnconc(cdr(body), p);
	} else {
	    p = Llist3(cadr(l), cond, car(l));
	    p = Lnconc(body, p);
	}
    } else {
	p = Llist3(cadr(l), cond, car(l));
	p = Lnconc(body, p);
    }
    l = Llist3(prog_symbol, nil, caddr(l));
    q = Lnconc(l, p);
#undef a
#undef exp
#undef body
#undef gost
#undef cond
#undef p
#undef l
    popv(7);
    return q;
}

static          Sex
make_if(cond, t, f)
     Sex             cond,
                     t,
                     f;
{
    Sex             q;
    int             flg = 0;

    if (!in_proc)
	return Llist4(if_symbol, cond, t, f);

    stackcheck();
    push3(cond, t, f);
    push3(nil, nil, nil);

#define cond stack[-5]
#define t stack[-4]
#define f stack[-3]
#define p stack[-2]
#define l stack[-1]
#define gost stack[-0]

    if (is_cons(t) && car(t) == prog_symbol) {
	flg = 1;
	proc_frame = Lnconc(proc_frame, cadr(t));
	t = cons(progn_symbol, cddr(t));
    }
    if (is_cons(f) && car(f) == prog_symbol) {
	flg = 1;
	proc_frame = Lnconc(proc_frame, cadr(f));
	f = cons(progn_symbol, cddr(f));
    }
    if (flg == 0) {
	q = Llist4(if_symbol, cond, t, f);
	popv(6);
	return q;
    }
    begin_loop();
    if (!is_cons(loop_frame)) {
	popv(6);
	error("invalid if");
    }
    l = car(loop_frame);
    if (t == nil) {
	gost = Llist2(go_symbol, car(l));
	cond = Llist4(if_symbol, cond, gost, nil);
	if (car(f) == progn_symbol)
	    f = cdr(f);
	else
	    f = cons(f, nil);
	p = cons(cond, f);
	p = Laconc(p, car(l));
    } else {
	gost = Llist2(go_symbol, car(l));
	cond = Llist4(if_symbol, cond, nil, gost);
	if (car(t) == progn_symbol)
	    t = cdr(t);
	else
	    t = cons(t, nil);
	p = cons(cond, t);
	if (f == nil) {
	    p = Laconc(p, car(l));
	} else {
	    gost = Llist2(go_symbol, cadr(l));
	    p = Laconc(p, gost);
	    p = Laconc(p, car(l));
	    if (car(f) == progn_symbol)
		f = cdr(f);
	    else
		f = cons(f, nil);
	    p = Lnconc(p, f);
	    p = Laconc(p, cadr(l));
	}
    }
    end_loop();
    p = cons(nil, p);
    q = cons(prog_symbol, p);
#undef cond
#undef t
#undef f
#undef p
#undef l
#undef gost
    popv(6);
    return q;
}

static          Sex
make_break(Sex a)
{
    if (!is_cons(loop_frame))
	error("break outside loop");
    return Llist2(go_symbol, car(car(loop_frame)));
}

static          Sex
make_continue(Sex a)
{
    if (!is_cons(loop_frame))
	error("continue outside loop");
    return Llist2(go_symbol, cadr(car(loop_frame)));
}

static          Sex
make_return0(void)
{
    if (!in_proc)
	error("invalid return");
    return cons(return_symbol, nil);
}

static          Sex
make_return1(Sex a)
{
    if (!in_proc)
	error("invalid return");
    a = cons(a, nil);
    return cons(return_symbol, a);
}


static          Sex
expand_for(a, var, body)
     Sex             a,
                     var,
                     body;
{
    Sex             is,
                    ie,
                    ib;
    Sex             q;
    Sex             l;
    long            b;

    b = mkint(car(var));
    var = cdr(var);

    if (!is_cons(loop_frame))
	error("invalid for");

    is = cadr(var);
    ib = cdr(cdr(var));
    ie = car(ib);
    ib = cadr(ib);
    var = car(var);

    l = car(loop_frame);

    stackcheck();
    push3(a, var, body);
    push2(nil, nil);
    push3(is, ie, ib);
    push2(nil, l);
#define a stack[-9]
#define var stack[-8]
#define body stack[-7]
#define gost stack[-6]
#define cond stack[-5]
#define is stack[-4]
#define ie stack[-3]
#define ib stack[-2]
#define p stack[-1]
#define l stack[-0]
    is = Llist3(setq_symbol, var, is);
    gost = Llist2(go_symbol, car(l));
    switch (b) {
    case 0:
	cond = Llist3(gt_symbol, var, ie);
	ib = Llist3(add_symbol, var, ib);
	break;
    case 1:
	cond = Llist3(lt_symbol, var, ie);
	ib = Llist3(sub_symbol, var, ib);
	break;
    default:
	cond = Llist2(not_symbol, ie);
	ib = Llist3(add_symbol, var, ib);
	break;
    }
    cond = Llist4(if_symbol, cond, gost, nil);
    ib = Llist3(setq_symbol, var, ib);
    gost = Llist2(go_symbol, caddr(l));
    // lisp_printf("\n for body=%p\n\n", body);
    if (in_proc) {
	if (caar(body) == prog_symbol) {
	    proc_frame = Lnconc(proc_frame, cadar(body));
	    p = Llist4(cadr(l), ib, gost, car(l));
	    p = Lnconc(cddar(body), p);
	} else if (caar(body) == progn_symbol) {
	    p = Llist4(cadr(l), ib, gost, car(l));
	    p = Lnconc(cdar(body), p);
	} else {
	    p = Llist4(cadr(l), ib, gost, car(l));
	    p = Lnconc(body, p);
	}
    } else {
	p = Llist4(cadr(l), ib, gost, car(l));
	p = Lnconc(body, p);
    }
    // p = Llist7(stack[-2], cond, body, stack[-1], ib, gost, stack[0]);

    if (ie != nil) {
	l = Llist2(caddr(l), cond);
	p = Lnconc(l, p);
    } else {
	p = cons(caddr(l), p);
    }
    p = cons(is, p);
    p = cons(nil, p);
    q = cons(prog_symbol, p);
#undef a
#undef var
#undef body
#undef gost
#undef cond
#undef is
#undef ie
#undef ib
#undef p
#undef l
    popv(10);
    return q;
}

static          Sex
expand_foreach(a, b, body)		/* v, c, body, f */
     Sex             a,
                     b, body;
{
    Sex             q;

    if (!is_cons(loop_frame))
	error("invalid foreach");

    stackcheck();
    push2(a, b);
    push4(nil, body, nil, nil);
    push2(nil, nil);
#define a stack[-7]
#define b stack[-6]
#define p stack[-5]
#define body stack[-4]
#define v stack[-3]
#define gost stack[-2]
#define f stack[-1]
#define l stack[-0]
    l = car(loop_frame);
    v = Lgensym();
    p = Llist3(setq_symbol, v, car(cdr(b)));
    f = Llist3(equal_symbol, v, nil);
    gost = Llist2(go_symbol, car(l));
    gost = Llist4(if_symbol, f, gost, nil);
    f = caddr(b);
    if (f == nil) {
	f = Llist2(car_symbol, v);
	f = Llist3(setq_symbol, car(b), f);
	p = Llist4(p, caddr(l), gost, f);
    } else {
	f = Llist3(setq_symbol, car(b), v);
	p = Llist4(p, caddr(l), gost, f);
    }

    //body = caddr(b);
    // lisp_printf("\n foreach body=%p\n\n", body);
    if (in_proc) {
	if (caar(body) == prog_symbol) {
	    proc_frame = Lnconc(proc_frame, cadar(body));
	    p = Lnconc(p, cddar(body));
	} else if (caar(body) == progn_symbol) {
	    p = Lnconc(p, cdar(body));
	} else {
	    p = Lnconc(p, body);
	}
    } else {
	p = Lnconc(p, body);
    }
    gost = Llist2(go_symbol, caddr(l));
    f = Llist2(cdr_symbol, v);
    body = Llist3(setq_symbol, v, f);
    f = Llist4(cadr(l), body, gost, car(l));
    p = Lnconc(p, f);
    f = Lncons(v);
    f = Llist2(prog_symbol, f);
    q = Lnconc(f, p);
#undef a
#undef b
#undef p
#undef body
#undef v
#undef gost
#undef f
#undef l
    popv(8);
    return q;
}

/**********************************************************************/
/**********************************************************************/


static          Sex
expand_for_expression(a, var, body)
     Sex             a,
                     var,
                     body;
{
    Sex             is,
                    ie,
                    ib;
    Sex             q;
    Sex             l;
    long            b;
    long            c;

    c = mkint(a);
    b = mkint(car(var));
    var = cdr(var);

    if (!is_cons(loop_frame))
	error("invalid for");

    is = cadr(var);
    ib = cdr(cdr(var));
    ie = car(ib);
    ib = cadr(ib);
    var = car(var);

    l = car(loop_frame);

    stackcheck();
    push3(a, var, body);
    push2(nil, nil);
    push3(is, ie, ib);
    push3(nil, l, nil);
#define a stack[-10]
#define var stack[-9]
#define body stack[-8]
#define gost stack[-7]
#define cond stack[-6]
#define is stack[-5]
#define ie stack[-4]
#define ib stack[-3]
#define p stack[-2]
#define l stack[-1]
#define r stack[-0]
    r = Lgensym();
    switch (c) {
    case 1:
	p = Llist3(setq_symbol, r, mkfxat(0));
	break;
    case 2:
	p = Llist3(setq_symbol, r, mkfxat(1));
	break;
    default:
	p = Llist3(setq_symbol, r, nil);
	break;
    }
    is = Llist3(setq_symbol, var, is);
    is = Llist2(p, is);
    gost = Llist2(go_symbol, car(l));
    switch (b) {
    case 0:
	cond = Llist3(gt_symbol, var, ie);
	ib = Llist3(add_symbol, var, ib);
	break;
    case 1:
	cond = Llist3(lt_symbol, var, ie);
	ib = Llist3(sub_symbol, var, ib);
	break;
    default:
	cond = Llist2(not_symbol, ie);
	ib = Llist3(add_symbol, var, ib);
	break;
    }
    cond = Llist4(if_symbol, cond, gost, nil);
    ib = Llist3(setq_symbol, var, ib);
    gost = Llist2(go_symbol, caddr(l));

    p = Llist4(cadr(l), ib, gost, car(l));
    switch (c) {
    case 1:
	q = Llist3(add_symbol, r, body);
	break;
    case 2:
	q = Llist3(times_symbol, r, body);
	break;
    case 3:
	q = Llist3(cons_symbol, body, r);
	break;
    case 4:
	q = Llist3(append_symbol, r, body);
	break;
    default:
	q = Llist3(nconc_symbol, r, body);
	break;
    }
    q = Llist3(setq_symbol, r, q);
    p = cons(q, p);

    if (ie != nil) {
	l = Llist2(caddr(l), cond);
	p = Lnconc(l, p);
    } else {
	p = cons(caddr(l), p);
    }

    if (c == 3) {
	q = Llist2(reversip_symbol, r);
	q = Llist2(return_symbol, q);
    } else {
	q = Llist2(return_symbol, r);
    }
    q = cons(q, nil);
    p = Lnconc(p, q);
    p = Lnconc(is, p);
    q = cons(r, nil);
    p = cons(q, p);
    q = cons(prog_symbol, p);
#undef a
#undef var
#undef body
#undef gost
#undef cond
#undef is
#undef ie
#undef ib
#undef p
#undef l
#undef r
    popv(11);
    return q;
}


static          Sex
expand_foreach_expression(a, b, body)	/* v, c, body, f */
     Sex             a,
                     b, body;
{
    Sex             q;
    long            c;

    c = mkint(a);

    if (!is_cons(loop_frame))
	error("invalid foreach");

    stackcheck();
    push2(a, b);
    push4(nil, body, nil, nil);
    push3(nil, nil, nil);
#define a stack[-8]
#define b stack[-7]
#define p stack[-6]
#define body stack[-5]
#define v stack[-4]
#define gost stack[-3]
#define f stack[-2]
#define l stack[-1]
#define r stack[-0]
    l = car(loop_frame);
    v = Lgensym();
    r = Lgensym();
    switch (c) {
    case 1:
	p = Llist3(setq_symbol, r, mkfxat(0));
	break;
    case 2:
	p = Llist3(setq_symbol, r, mkfxat(1));
	break;
    default:
	p = Llist3(setq_symbol, r, nil);
	break;
    }
    q = Llist3(setq_symbol, v, car(cdr(b)));
    p = Llist2(p, q);
    f = Llist3(equal_symbol, v, nil);
    gost = Llist2(go_symbol, car(l));
    gost = Llist4(if_symbol, f, gost, nil);
    f = caddr(b);
    if (f == nil) {
	f = Llist2(car_symbol, v);
	f = Llist3(setq_symbol, car(b), f);
	f = Llist3(caddr(l), gost, f);
	p = Lnconc(p, f);
    } else {
	f = Llist3(setq_symbol, car(b), v);
	f = Llist3(caddr(l), gost, f);
	p = Lnconc(p, f);
    }

    //body = caddr(b);
    // lisp_printf("\n foreach body=%p\n\n", body);
    switch (c) {
    case 1:
	q = Llist3(add_symbol, r, body);
	break;
    case 2:
	q = Llist3(times_symbol, r, body);
	break;
    case 3:
	q = Llist3(cons_symbol, body, r);
	break;
    case 4:
	q = Llist3(append_symbol, r, body);
	break;
    default:
	q = Llist3(nconc_symbol, r, body);
	break;
    }
    q = Llist3(setq_symbol, r, q);
    q = cons(q, nil);
    p = Lnconc(p, q);
    gost = Llist2(go_symbol, caddr(l));
    f = Llist2(cdr_symbol, v);
    body = Llist3(setq_symbol, v, f);
    f = Llist4(cadr(l), body, gost, car(l));
    p = Lnconc(p, f);
    if (c == 3) {
	q = Llist2(reversip_symbol, r);
	q = Llist2(return_symbol, q);
    } else {
	q = Llist2(return_symbol, r);
    }
    q = cons(q, nil);
    p = Lnconc(p, q);
    f = Llist2(v, r);
    f = Llist2(prog_symbol, f);
    q = Lnconc(f, p);
#undef a
#undef b
#undef p
#undef body
#undef v
#undef gost
#undef f
#undef l
#undef r
    popv(9);
    return q;
}

/**********************************************************************/
/**********************************************************************/

static          Sex
make_statements1(Sex a)
{
    if (a == nil)
	return a;
    if (!in_proc)
	return Lncons(a);
    stackcheck();
    push(a);
#define a stack[0]
    if (is_cons(a) && car(a) == prog_symbol) {
	proc_frame = Lnconc(proc_frame, car(cdr(a)));
	a = cons(nil, cdr(cdr(a)));
	a = cons(prog_symbol, a);
    }
#undef a
    a = stack[0];
    popv(1);
    return Lncons(a);
}


static          Sex
make_statements(Sex l, Sex a)
{
    // lisp_printf("make_statements enters: %p, %p\n", l, a);
    if (a == nil)
	return l;
    if (l == nil)
	return make_statements1(a);
    if (!in_proc)
	return Laconc(l, a);
    stackcheck();
    push4(nil, nil, l, a);
#define c stack[-3]
#define la stack[-2]
#define l stack[-1]
#define a stack[0]
    la = car(l);
    if (car(la) != prog_symbol) {
	if (is_cons(a) && car(a) == prog_symbol) {
	    a = cdr(a);
	    proc_frame = Lnconc(proc_frame, car(a));
	    c = Llist2(prog_symbol, nil);
	    c = Lnconc(c, l);
	    l = Lnconc(c, cdr(a));
	    l = Lncons(l);
	} else {
	    l = Laconc(l, a);
	}
    } else if (is_cons(a) && car(a) == prog_symbol) {
	a = cdr(a);
	proc_frame = Lnconc(proc_frame, car(a));
	l = Lnconc(la, cdr(a));
	l = Lncons(l);
    } else {
	l = Laconc(la, a);
	l = Lncons(l);
    }
#undef c
#undef a
    a = l;
#undef l
#undef la
    popv(4);
    // lisp_printf("make_statements return with : %p\n", a);
    return a;
}

static void
begin_proc(void)
{
    Sex             a;
    in_proc = 1;
    proc_frame = nil;
    proc_vars = nil;
    proc_gvars = nil;
}

static void
end_proc(void)
{
    proc_frame = nil;
    proc_vars = nil;
    proc_gvars = nil;
    in_proc = 0;
}

Sex
make_try(Sex tag, Sex body, Sex catch_body)
{
    Sex             a;
    stackcheck();
    if (body == nil)
	return nil;
    if (catch_body == nil) {
	push(tag);
	body = expand2(body);
	pop(tag);
	a = Llist3(catch_symbol, tag, body);
    } else {
	/*
	 * (if (catch ...) nil catch_body) 
	 */
	push2(catch_body, tag);
	body = expand2(body);
	pop(tag);
	a = Llist3(catch_symbol, tag, body);
	pop(catch_body);
	a = Llist4(if_symbol, a, nil, catch_body);
    }
    return a;
}

Sex
make_switch(Sex tag, Sex cases)
{
    Sex             p;
    /*
     * case = (value, sts) . ... 
     */
    /*
     * tag:=tag, if tag = car 
     */


    // lisp_printf("tag = %p\n", tag);
    // lisp_printf("cases = %p\n", cases);

    p = cons(tag, cases);
    p = cons(switch_symbol, p);
    return p;
}

Sex
make_case(Sex tag, Sex cases, Sex elses)
{
    Sex             p;
    /*
     * case = (value, sts) . ... 
     */
    /*
     * tag:=tag, if tag = car 
     */


    // lisp_printf("tag = %p\n", tag);
    // lisp_printf("cases = %p\n", cases);

    p = Llist3(tag, cases, elses);
    p = cons(case_symbol, p);
    return p;
}
#line 4477 "asuka.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv(const char *);

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 247 "asuka.y"
{*parse_value_ptr = yyvsp[-1].sex; 
		  value_print_flag = 1;
/*		  lisp_printf("stat = %p\n", $1); */
		  YYACCEPT;}
break;
case 2:
#line 252 "asuka.y"
{*parse_value_ptr = yyvsp[-1].sex; 
		  value_print_flag = 0;
/*		  lisp_printf("stat = %p\n", $1); */
		  YYACCEPT;}
break;
case 3:
#line 263 "asuka.y"
{*parse_value_ptr = yyvsp[0].sex;
	/*	  yyerror("end of file;");*/
		  YYACCEPT;}
break;
case 4:
#line 267 "asuka.y"
{*parse_value_ptr = yyvsp[0].sex;
			yyerror("illegal character;");
		YYACCEPT;}
break;
case 35:
#line 306 "asuka.y"
{ yyval.sex = Lncons(yyvsp[0].sex);}
break;
case 36:
#line 308 "asuka.y"
{  yyerror("Malformed statement");
		   YYERROR;}
break;
case 37:
#line 314 "asuka.y"
{yyval.sex = make_statements1(yyvsp[0].sex);}
break;
case 38:
#line 316 "asuka.y"
{ 
/*
		if(in_loop || in_proc) {
			if(car($1) == prog_symbol)
		} else 
			$$ = cons($3, $1);}
*/
			yyval.sex = make_statements(yyvsp[-2].sex, yyvsp[0].sex);
		}
break;
case 39:
#line 326 "asuka.y"
{ yyval.sex = make_statements(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 40:
#line 331 "asuka.y"
{ yyval.sex = make_if(yyvsp[-4].sex, expand2(yyvsp[-2].sex), yyvsp[-1].sex);}
break;
case 41:
#line 333 "asuka.y"
{ yyerror("missing fi");
		yyval.sex = make_if(yyvsp[-3].sex, expand2(yyvsp[-1].sex), yyvsp[0].sex);}
break;
case 42:
#line 339 "asuka.y"
{ yyval.sex = nil;}
break;
case 43:
#line 341 "asuka.y"
{ yyval.sex = expand2(yyvsp[0].sex);}
break;
case 44:
#line 343 "asuka.y"
{ yyval.sex = make_if(yyvsp[-3].sex, expand2(yyvsp[-1].sex), yyvsp[0].sex);}
break;
case 45:
#line 348 "asuka.y"
{ yyval.sex = make_switch(yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 46:
#line 353 "asuka.y"
{ yyval.sex = Llist2(cons(list_symbol, yyvsp[-2].sex), yyvsp[0].sex);}
break;
case 47:
#line 358 "asuka.y"
{yyval.sex = cons(yyvsp[0].sex, nil);}
break;
case 48:
#line 360 "asuka.y"
{yyval.sex = cons(yyvsp[-1].sex, nil);}
break;
case 49:
#line 362 "asuka.y"
{yyval.sex = cons(yyvsp[0].sex, yyvsp[-1].sex);}
break;
case 50:
#line 364 "asuka.y"
{yyval.sex = cons(yyvsp[0].sex, yyvsp[-2].sex);}
break;
case 51:
#line 366 "asuka.y"
{yyval.sex = yyvsp[-1].sex;}
break;
case 52:
#line 372 "asuka.y"
{ yyval.sex = make_case(yyvsp[-3].sex, yyvsp[-1].sex, nil);}
break;
case 53:
#line 374 "asuka.y"
{ yyval.sex = make_case(yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 54:
#line 379 "asuka.y"
{ yyval.sex = Llist2(cons(list_symbol, yyvsp[-3].sex), yyvsp[-1].sex);}
break;
case 55:
#line 384 "asuka.y"
{yyval.sex = cons(yyvsp[0].sex, nil);}
break;
case 56:
#line 386 "asuka.y"
{yyval.sex = cons(yyvsp[0].sex, yyvsp[-1].sex);}
break;
case 57:
#line 407 "asuka.y"
{ begin_loop();}
break;
case 58:
#line 408 "asuka.y"
{ yyval.sex = expand_while(yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[-1].sex); end_loop();}
break;
case 59:
#line 419 "asuka.y"
{begin_loop();}
break;
case 60:
#line 420 "asuka.y"
{ yyval.sex = expand_repeat(yyvsp[-4].sex, yyvsp[0].sex, yyvsp[-2].sex); end_loop();}
break;
case 61:
#line 439 "asuka.y"
{ yyval.sex = expand_for(nil, yyvsp[-3].sex, yyvsp[-1].sex);
		  end_loop();}
break;
case 62:
#line 445 "asuka.y"
{yyval.sex = expand_for_expression(mkfxat(1), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 63:
#line 448 "asuka.y"
{yyval.sex = expand_for_expression(mkfxat(2), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 64:
#line 451 "asuka.y"
{yyval.sex = expand_for_expression(mkfxat(3), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 65:
#line 454 "asuka.y"
{yyval.sex = expand_for_expression(mkfxat(4), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 66:
#line 457 "asuka.y"
{yyval.sex = expand_for_expression(mkfxat(5), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 67:
#line 461 "asuka.y"
{begin_loop();}
break;
case 68:
#line 462 "asuka.y"
{ yyval.sex = yyvsp[0].sex;}
break;
case 69:
#line 474 "asuka.y"
{yyval.sex = Llist5(mkfxat(0), yyvsp[-4].sex, yyvsp[-2].sex, yyvsp[0].sex, mkfxat(1));}
break;
case 70:
#line 476 "asuka.y"
{yyval.sex = Llist5(mkfxat(0), yyvsp[-6].sex, yyvsp[-4].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 71:
#line 478 "asuka.y"
{yyval.sex = Llist5(mkfxat(0), yyvsp[-4].sex, yyvsp[-2].sex, nil, yyvsp[0].sex);}
break;
case 72:
#line 480 "asuka.y"
{yyval.sex = Llist5(mkfxat(0), yyvsp[-6].sex, yyvsp[-4].sex, yyvsp[0].sex, yyvsp[-2].sex);}
break;
case 73:
#line 482 "asuka.y"
{yyval.sex = Llist5(mkfxat(1), yyvsp[-4].sex, yyvsp[-2].sex, yyvsp[0].sex, mkfxat(1));}
break;
case 74:
#line 484 "asuka.y"
{yyval.sex = Llist5(mkfxat(1), yyvsp[-6].sex, yyvsp[-4].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 75:
#line 486 "asuka.y"
{yyval.sex = Llist5(mkfxat(1), yyvsp[-6].sex, yyvsp[-4].sex, yyvsp[0].sex, yyvsp[-2].sex);}
break;
case 76:
#line 488 "asuka.y"
{yyval.sex = Llist5(mkfxat(2),yyvsp[-4].sex, yyvsp[-2].sex, yyvsp[0].sex, mkfxat(1));}
break;
case 77:
#line 490 "asuka.y"
{yyval.sex = Llist5(mkfxat(2),yyvsp[-6].sex, yyvsp[-4].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 78:
#line 492 "asuka.y"
{yyval.sex = Llist5(mkfxat(2),yyvsp[-6].sex, yyvsp[-4].sex, yyvsp[0].sex, yyvsp[-2].sex);}
break;
case 79:
#line 571 "asuka.y"
{ yyval.sex = expand_foreach(nil, yyvsp[-3].sex, yyvsp[-1].sex);
		  end_loop();}
break;
case 80:
#line 577 "asuka.y"
{yyval.sex = expand_foreach_expression(mkfxat(1), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 81:
#line 580 "asuka.y"
{yyval.sex = expand_foreach_expression(mkfxat(2), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 82:
#line 583 "asuka.y"
{yyval.sex = expand_foreach_expression(mkfxat(3), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 83:
#line 586 "asuka.y"
{yyval.sex = expand_foreach_expression(mkfxat(4), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 84:
#line 589 "asuka.y"
{yyval.sex = expand_foreach_expression(mkfxat(5), yyvsp[-2].sex, yyvsp[0].sex);
		 end_loop();}
break;
case 85:
#line 594 "asuka.y"
{begin_loop();}
break;
case 86:
#line 595 "asuka.y"
{yyval.sex = yyvsp[0].sex;}
break;
case 87:
#line 599 "asuka.y"
{yyval.sex = Llist3(yyvsp[-2].sex, yyvsp[0].sex, nil);}
break;
case 88:
#line 601 "asuka.y"
{yyval.sex = Llist3(yyvsp[-2].sex, yyvsp[0].sex, true);}
break;
case 91:
#line 612 "asuka.y"
{yyval.sex = nil;}
break;
case 92:
#line 617 "asuka.y"
{yyval.sex = cons(clear_symbol, yyvsp[0].sex);}
break;
case 93:
#line 628 "asuka.y"
{yyval.sex = Llist2(yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 94:
#line 630 "asuka.y"
{yyval.sex = Llist2(yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 95:
#line 632 "asuka.y"
{yyval.sex = Laconc(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 96:
#line 634 "asuka.y"
{yyval.sex = Laconc(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 97:
#line 638 "asuka.y"
{yyval.sex = Llist2(yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 98:
#line 640 "asuka.y"
{yyval.sex = Llist2(yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 99:
#line 642 "asuka.y"
{yyval.sex = Laconc(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 100:
#line 644 "asuka.y"
{yyval.sex = Laconc(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 101:
#line 654 "asuka.y"
{yyval.sex = Llist2(write_symbol, cons(list_symbol, yyvsp[0].sex));}
break;
case 102:
#line 656 "asuka.y"
{yyval.sex = Llist2(writen_symbol, cons(list_symbol, yyvsp[0].sex));}
break;
case 103:
#line 658 "asuka.y"
{yyval.sex = Llist3(yyvsp[-3].sex, yyvsp[-1].sex, nil);}
break;
case 104:
#line 660 "asuka.y"
{yyval.sex = Llist3(yyvsp[-3].sex, yyvsp[-1].sex, nil);}
break;
case 105:
#line 662 "asuka.y"
{yyval.sex = Llist3(yyvsp[-5].sex, yyvsp[-3].sex, cons(list_symbol, yyvsp[-1].sex));}
break;
case 106:
#line 664 "asuka.y"
{yyval.sex = Llist3(yyvsp[-5].sex, yyvsp[-3].sex, cons(list_symbol, yyvsp[-1].sex));}
break;
case 107:
#line 669 "asuka.y"
{yyval.sex = Llist2(debug_symbol, cons(list_symbol, yyvsp[0].sex));}
break;
case 108:
#line 671 "asuka.y"
{yyval.sex = Llist2(debugn_symbol, cons(list_symbol, yyvsp[0].sex));}
break;
case 109:
#line 677 "asuka.y"
{yyval.sex = Llist2(read_symbol, yyvsp[0].sex);}
break;
case 110:
#line 681 "asuka.y"
{yyval.sex = Llist2(import_symbol, yyvsp[0].sex);}
break;
case 111:
#line 683 "asuka.y"
{yyval.sex = Llist2(import_symbol, Lsymbol_name(yyvsp[-1].sex));}
break;
case 112:
#line 685 "asuka.y"
{yyval.sex = Llist2(import_symbol, yyvsp[-1].sex);}
break;
case 113:
#line 690 "asuka.y"
{ yyval.sex = Lstrcat(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 114:
#line 692 "asuka.y"
{ yyval.sex = Lstrcat(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 115:
#line 694 "asuka.y"
{ yyval.sex = Lstrcat(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 116:
#line 696 "asuka.y"
{ yyval.sex = Lstrcat(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 117:
#line 701 "asuka.y"
{yyval.sex = Llist2(save_symbol, yyvsp[0].sex);}
break;
case 118:
#line 705 "asuka.y"
{yyval.sex = Llist2(load_symbol, yyvsp[0].sex);}
break;
case 120:
#line 714 "asuka.y"
{ yyval.sex = Llist3(setq_symbol, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 121:
#line 716 "asuka.y"
{ yyval.sex = Llist3(setq_symbol, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 122:
#line 718 "asuka.y"
{ yyval.sex = Llist3(setq_symbol, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 123:
#line 720 "asuka.y"
{ yyval.sex = Llist4(setarray1_symbol, yyvsp[-5].sex, yyvsp[0].sex, yyvsp[-3].sex);}
break;
case 124:
#line 722 "asuka.y"
{ yyval.sex = Llist5(setarray2_symbol, yyvsp[-7].sex, yyvsp[0].sex, yyvsp[-5].sex, yyvsp[-3].sex);}
break;
case 125:
#line 725 "asuka.y"
{ yyval.sex = Llist6(setarray3_symbol, yyvsp[-9].sex, yyvsp[0].sex, yyvsp[-7].sex, yyvsp[-5].sex, yyvsp[-3].sex);}
break;
case 126:
#line 727 "asuka.y"
{ yyval.sex = Llist4(setarray1_symbol, yyvsp[-5].sex, yyvsp[0].sex, yyvsp[-3].sex);}
break;
case 127:
#line 729 "asuka.y"
{ yyval.sex = Llist5(setarray2_symbol, yyvsp[-7].sex, yyvsp[0].sex, yyvsp[-5].sex, yyvsp[-3].sex);}
break;
case 128:
#line 732 "asuka.y"
{ yyval.sex = Llist6(setarray3_symbol, yyvsp[-9].sex, yyvsp[0].sex, yyvsp[-7].sex, yyvsp[-5].sex, yyvsp[-3].sex);}
break;
case 129:
#line 737 "asuka.y"
{yyval.sex = Llist3(algebraic_symbol, yyvsp[-4].sex, gdiff2(yyvsp[-2].sex, yyvsp[0].sex));}
break;
case 130:
#line 739 "asuka.y"
{yyval.sex = Llist3(algebraic_symbol, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 131:
#line 744 "asuka.y"
{yyval.sex = make_try(yyvsp[-3].sex, yyvsp[-1].sex, nil);}
break;
case 132:
#line 746 "asuka.y"
{yyval.sex = make_try(yyvsp[-4].sex, yyvsp[-2].sex, yyvsp[-1].sex);}
break;
case 133:
#line 751 "asuka.y"
{yyval.sex = Llist3(throw_symbol, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 134:
#line 753 "asuka.y"
{yyval.sex = Llist3(throw_symbol, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 135:
#line 755 "asuka.y"
{yyval.sex = Llist3(throw_symbol, yyvsp[0].sex, nil);}
break;
case 136:
#line 760 "asuka.y"
{yyval.sex = expand2(yyvsp[-2].sex);}
break;
case 137:
#line 762 "asuka.y"
{yyval.sex = expand2(yyvsp[-1].sex);}
break;
case 138:
#line 768 "asuka.y"
{yyval.sex = yyvsp[0].sex;}
break;
case 139:
#line 786 "asuka.y"
{ yyval.sex = Lncons(yyvsp[0].sex);}
break;
case 140:
#line 788 "asuka.y"
{ yyval.sex = Laconc(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 141:
#line 790 "asuka.y"
{ yyval.sex = nil;}
break;
case 142:
#line 795 "asuka.y"
{ yyval.sex = Llist2(minus_symbol, yyvsp[0].sex);}
break;
case 143:
#line 797 "asuka.y"
{ yyval.sex = yyvsp[0].sex;}
break;
case 144:
#line 799 "asuka.y"
{ yyval.sex = yyvsp[-1].sex;}
break;
case 145:
#line 801 "asuka.y"
{ yyval.sex = Llist2(yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 146:
#line 803 "asuka.y"
{ yyval.sex = Llist2(yyvsp[0].sex, yyvsp[-1].sex);}
break;
case 147:
#line 805 "asuka.y"
{yyval.sex = cons(list_symbol, yyvsp[-1].sex);}
break;
case 148:
#line 807 "asuka.y"
{yyval.sex = cons(set_symbol, yyvsp[-1].sex);}
break;
case 149:
#line 809 "asuka.y"
{yyval.sex = onbeepre_symbol;}
break;
case 150:
#line 811 "asuka.y"
{yyval.sex = twbeepre_symbol;}
break;
case 151:
#line 813 "asuka.y"
{yyval.sex = thbeepre_symbol;}
break;
case 152:
#line 818 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 153:
#line 820 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 154:
#line 822 "asuka.y"
{yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 155:
#line 824 "asuka.y"
{yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 156:
#line 826 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 157:
#line 828 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 158:
#line 830 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 159:
#line 832 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 160:
#line 834 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 161:
#line 836 "asuka.y"
{yyval.sex = Llist2(not_symbol, Llist3(equal_symbol, yyvsp[-2].sex, yyvsp[0].sex));}
break;
case 162:
#line 838 "asuka.y"
{yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 163:
#line 840 "asuka.y"
{yyval.sex = Llist3(set_diff_symbol, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 164:
#line 842 "asuka.y"
{yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 165:
#line 844 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 166:
#line 846 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 167:
#line 848 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 168:
#line 850 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 169:
#line 852 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 170:
#line 854 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-1].sex, yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 171:
#line 856 "asuka.y"
{ yyval.sex = make_funcall(yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 172:
#line 858 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 173:
#line 860 "asuka.y"
{ yyval.sex = Llist3(yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 174:
#line 862 "asuka.y"
{ yyval.sex = Llist3(times_symbol, yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 175:
#line 864 "asuka.y"
{ yyval.sex = Llist3(times_symbol, yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 178:
#line 868 "asuka.y"
{yyval.sex = Llist2(quote_symbol, yyvsp[-1].sex);}
break;
case 179:
#line 870 "asuka.y"
{yyval.sex = Llist2(quote_symbol, yyvsp[0].sex);}
break;
case 181:
#line 873 "asuka.y"
{yyval.sex = Llist3(getarray1_symbol, yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 182:
#line 875 "asuka.y"
{yyval.sex = Llist4(getarray2_symbol, yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 183:
#line 877 "asuka.y"
{yyval.sex = Llist5(getarray3_symbol, yyvsp[-7].sex, yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[-1].sex);}
break;
case 184:
#line 879 "asuka.y"
{yyval.sex = make_if(yyvsp[-3].sex, yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 185:
#line 881 "asuka.y"
{yyval.sex = yyvsp[0].sex;}
break;
case 186:
#line 883 "asuka.y"
{yyval.sex = yyvsp[0].sex;}
break;
case 187:
#line 885 "asuka.y"
{ yyerror("Missing/malformed expression");
		  YYERROR;}
break;
case 188:
#line 892 "asuka.y"
{yyval.sex = nil;}
break;
case 189:
#line 894 "asuka.y"
{ yyval.sex = yyvsp[0].sex;}
break;
case 190:
#line 896 "asuka.y"
{ yyval.sex = make_if(yyvsp[-3].sex, yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 191:
#line 903 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-3].sex, 
				Llist2(mkarray1_symbol, yyvsp[-1].sex));}
break;
case 192:
#line 906 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-5].sex, 
				Llist3(mkarray2_symbol, yyvsp[-3].sex, yyvsp[-1].sex));}
break;
case 193:
#line 909 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-7].sex, 
				Llist4(mkarray3_symbol, yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[-1].sex));}
break;
case 194:
#line 912 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-3].sex, 
				Llist2(mkarray1_symbol, yyvsp[-1].sex));
		 yyval.sex = Llist3(progn_symbol, yyvsp[-5].sex, yyval.sex);}
break;
case 195:
#line 916 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-5].sex, 
				Llist3(mkarray2_symbol, yyvsp[-3].sex, yyvsp[-1].sex));
		 yyval.sex = Llist3(progn_symbol, yyvsp[-7].sex, yyval.sex);}
break;
case 196:
#line 920 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-7].sex, 
				Llist4(mkarray3_symbol, yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[-1].sex));
		 yyval.sex = Llist3(progn_symbol, yyvsp[-9].sex, yyval.sex);}
break;
case 197:
#line 924 "asuka.y"
{ yyerror("syntax error at array declaration");
		  YYERROR;}
break;
case 198:
#line 929 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-5].sex, 
				Llist3(mkmatrix_symbol, yyvsp[-3].sex, yyvsp[-1].sex));}
break;
case 199:
#line 932 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-5].sex, 
				Llist3(mkmatrix_symbol, yyvsp[-3].sex, yyvsp[-1].sex));
		 yyval.sex = Llist3(progn_symbol, yyvsp[-7].sex, yyval.sex);}
break;
case 200:
#line 936 "asuka.y"
{ yyerror("syntax error at matrix declaration");
		  YYERROR;}
break;
case 201:
#line 941 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-3].sex, 
				Llist2(mkvector_symbol, yyvsp[-1].sex));}
break;
case 202:
#line 944 "asuka.y"
{yyval.sex = Llist3(setq_symbol, yyvsp[-3].sex, 
				Llist2(mkvector_symbol, yyvsp[-1].sex));
		 yyval.sex = Llist3(progn_symbol, yyvsp[-5].sex, yyval.sex);}
break;
case 203:
#line 948 "asuka.y"
{ yyerror("syntax error at vector declaration");
		  YYERROR;}
break;
case 204:
#line 953 "asuka.y"
{if(in_proc)
		     proc_gvars = Lnconc(proc_gvars, yyvsp[0].sex);yyval.sex = nil;}
break;
case 205:
#line 956 "asuka.y"
{if(in_proc)
		     proc_gvars = Lnconc(proc_gvars, pickup_globals(yyvsp[0].sex));
		 yyval.sex = yyvsp[0].sex;}
break;
case 206:
#line 960 "asuka.y"
{if(in_proc)
		     proc_gvars = Lnconc(proc_gvars, pickup_globals(yyvsp[0].sex));
		 yyval.sex = yyvsp[0].sex;}
break;
case 207:
#line 964 "asuka.y"
{if(in_proc)
		     proc_gvars = Lnconc(proc_gvars, pickup_globals(yyvsp[0].sex));
		 yyval.sex = yyvsp[0].sex;}
break;
case 208:
#line 968 "asuka.y"
{if(in_proc)
		     proc_gvars = Lnconc(proc_gvars, pickup_globals(yyvsp[0].sex));
		 yyval.sex = yyvsp[0].sex;}
break;
case 209:
#line 975 "asuka.y"
{if(in_proc) proc_gvars = Lnconc(proc_gvars, yyvsp[0].sex);
		 yyval.sex = Llist2(yyvsp[-2].sex, cons(list_symbol, 
			cons(mkfxat(TERM_ORDER_LEX), yyvsp[0].sex)));}
break;
case 210:
#line 979 "asuka.y"
{if(in_proc) proc_gvars = Lnconc(proc_gvars, yyvsp[0].sex);
		 yyval.sex = Llist2(yyvsp[-2].sex, cons(list_symbol, 
			cons(mkfxat(TERM_ORDER_TLEX), yyvsp[0].sex)));}
break;
case 211:
#line 983 "asuka.y"
{if(in_proc) proc_gvars = Lnconc(proc_gvars, yyvsp[0].sex);
		 yyval.sex = Llist2(yyvsp[-2].sex, cons(list_symbol, 
			cons(mkfxat(TERM_ORDER_TREVLEX), yyvsp[0].sex)));}
break;
case 212:
#line 987 "asuka.y"
{if(in_proc) proc_gvars = Lnconc(proc_gvars, yyvsp[-2].sex);
		 yyval.sex = Llist2(yyvsp[-4].sex, cons(list_symbol,
			cons(mkfxat(TERM_ORDER_GRADINGS), cons(yyvsp[-2].sex, yyvsp[0].sex))));}
break;
case 213:
#line 991 "asuka.y"
{if(in_proc) proc_gvars = Lnconc(proc_gvars, yyvsp[0].sex);
		 yyval.sex = Llist2(yyvsp[-1].sex, cons(list_symbol, yyvsp[0].sex));}
break;
case 214:
#line 999 "asuka.y"
{yyval.sex = make_func1(yyvsp[-3].sex, yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 215:
#line 1001 "asuka.y"
{yyval.sex = make_func1(yyvsp[-4].sex, yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 216:
#line 1003 "asuka.y"
{ yyval.sex = make_func2(yyvsp[-4].sex, yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 217:
#line 1005 "asuka.y"
{ yyval.sex = make_func2(nil, yyvsp[-1].sex, yyvsp[0].sex);}
break;
case 218:
#line 1010 "asuka.y"
{
		 yyval.sex = make_proc(yyvsp[-5].sex, yyvsp[-3].sex, yyvsp[0].sex);
		 end_proc();
		 in_proc = 0;}
break;
case 219:
#line 1015 "asuka.y"
{
		 yyval.sex = make_proc(yyvsp[-4].sex, nil, yyvsp[0].sex);
		 end_proc();
		 in_proc = 0;}
break;
case 220:
#line 1020 "asuka.y"
{ end_proc();
		  in_proc = 0; YYERROR; }
break;
case 221:
#line 1024 "asuka.y"
{ begin_proc();
		  in_loop = 0;
		  in_proc = 1;}
break;
case 222:
#line 1030 "asuka.y"
{ yyval.sex = make_proc_body(yyvsp[-1].sex);}
break;
case 223:
#line 1035 "asuka.y"
{yyval.sex = make_return1(yyvsp[0].sex);}
break;
case 224:
#line 1037 "asuka.y"
{yyval.sex = make_return0();}
break;
case 225:
#line 1041 "asuka.y"
{yyval.sex = make_break(yyvsp[0].sex);}
break;
case 226:
#line 1045 "asuka.y"
{yyval.sex = make_continue(yyvsp[0].sex);}
break;
case 227:
#line 1050 "asuka.y"
{proc_frame = Lnconc(proc_frame, yyvsp[-1].sex);
		 yyval.sex = yyvsp[-1].sex;}
break;
case 228:
#line 1052 "asuka.y"
{yyval.sex = nil;}
break;
case 229:
#line 1055 "asuka.y"
{ yyval.sex = yyvsp[0].sex;}
break;
case 230:
#line 1057 "asuka.y"
{ yyval.sex = yyvsp[-1].sex;}
break;
case 231:
#line 1063 "asuka.y"
{yyval.sex = Lncons(yyvsp[0].sex);}
break;
case 232:
#line 1064 "asuka.y"
{yyval.sex = Laconc(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 233:
#line 1067 "asuka.y"
{yyval.sex = yyvsp[0].sex;}
break;
case 234:
#line 1068 "asuka.y"
{ yyval.sex = make_name1(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 235:
#line 1069 "asuka.y"
{ yyval.sex = make_name1(yyvsp[-2].sex, yyvsp[0].sex);}
break;
case 236:
#line 1073 "asuka.y"
{if(in_proc) proc_vars = Lsetaddq(yyvsp[0].sex, proc_vars);yyval.sex = yyvsp[0].sex;}
break;
case 237:
#line 1074 "asuka.y"
{yyval.sex = Lsymbol_name(yyvsp[-1].sex);}
break;
case 238:
#line 1078 "asuka.y"
{yyval.sex = yyvsp[0].sex;}
break;
#line 5505 "asuka.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
